/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ae=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/log/common/log","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","vs/base/common/network","electron","vs/base/common/errors","vs/platform/files/common/files","vs/base/common/buffer","vs/platform/configuration/common/configuration","vs/base/common/resources","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/node/pfs","vs/base/common/arrays","vs/base/common/cancellation","vs/platform/environment/electron-main/environmentMainService","vs/base/common/strings","os","vs/platform/product/common/productService","vs/platform/telemetry/common/telemetry","vs/platform/windows/electron-main/windows","vs/platform/workspace/common/workspace","vs/base/common/map","vs/base/common/uuid","vs/base/common/extpath","vs/platform/state/node/state","vs/base/common/objects","vs/base/common/process","vs/base/parts/ipc/electron-main/ipcMain","vs/platform/environment/common/environment","vs/platform/policy/common/policy","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/json","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/hash","fs","vs/base/common/labels","child_process","vs/platform/update/common/update","vs/base/common/decorators","vs/base/common/errorMessage","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/platform/window/common/window","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/ternarySearchTree","vs/platform/utilityProcess/electron-main/utilityProcess","vs/base/common/lazy","vs/base/common/stream","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/platform/files/common/watcher","vs/base/common/performance","vs/platform/log/electron-main/loggerService","vs/platform/remote/common/remoteHosts","vs/platform/theme/electron-main/themeMainService","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/iterator","vs/base/common/stopwatch","vs/base/common/severity","vs/base/common/codicons","vs/base/common/processes","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindows","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/window/electron-main/window","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/functional","vs/base/common/normalization","crypto","net","vs/base/node/id","vs/base/node/processes","vs/platform/environment/node/environmentService","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/shell/node/shellEnv","vs/platform/sign/common/sign","vs/platform/storage/common/storage","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/base/parts/ipc/node/ipc.net","vs/platform/update/electron-main/abstractUpdateService","vs/base/node/unc","vs/base/common/jsonEdit","vs/base/common/linkedList","vs/base/common/codiconsUtil","vs/base/common/themables","vs/base/node/ports","vs/base/common/glob","vs/base/node/extpath","vs/base/node/powershell","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","path","vs/platform/contextkey/common/contextkey","vs/platform/dialogs/common/dialogs","vs/platform/encryption/common/encryptionService","vs/platform/extensionManagement/common/extensionManagement","vs/platform/files/common/io","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/terminal","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/windows/electron-main/windowsFinder","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/platform/windows/electron-main/windowImpl","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/common/codiconsLibrary","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/electron-main/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/issue/common/issue","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/electron-main/logIpc","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/policy/node/nativePolicyService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/electronRemoteResources","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/telemetryUtils","vs/platform/telemetry/electron-main/telemetryUtils","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/userData/common/fileUserDataProvider","vs/platform/utilityProcess/common/utilityProcessWorkerService","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/electron-main/userDataProfileStorageIpc","vs/platform/userDataProfile/node/userDataProfile","zlib","vs/platform/backup/electron-main/backupMainService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/tunnel/node/tunnelService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/code/electron-main/auth","vs/platform/launch/electron-main/launchMainService","vs/platform/userDataProfile/electron-main/userDataProfilesHandler","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/terminal/electron-main/electronPtyHostStarter","vs/platform/utilityProcess/electron-main/utilityProcessWorkerMainService","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindow","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindowsMainService","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","minimist","assert","graceful-fs","string_decoder","vs/code/electron-main/main"],ce=function(X){for(var e=[],n=0,D=X.length;n<D;n++)e[n]=ae[X[n]];return e};define(ae[136],ce([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rb=e.$qb=e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=void 0;function n(w,p,u){const f=D(w,p);if(f!==-1)return w[f]}e.$fb=n;function D(w,p,u=w.length-1){for(let f=u;f>=0;f--){const h=w[f];if(p(h))return f}return-1}e.$gb=D;function S(w,p){const u=M(w,p);return u===-1?void 0:w[u]}e.$hb=S;function M(w,p,u=0,f=w.length){let h=u,$=f;for(;h<$;){const a=Math.floor((h+$)/2);p(w[a])?h=a+1:$=a}return h-1}e.$ib=M;function C(w,p){const u=P(w,p);return u===w.length?void 0:w[u]}e.$jb=C;function P(w,p,u=0,f=w.length){let h=u,$=f;for(;h<$;){const a=Math.floor((h+$)/2);p(w[a])?$=a:h=a+1}return h}e.$kb=P;function d(w,p,u=0,f=w.length){const h=P(w,p,u,f);return h===w.length?-1:h}e.$lb=d;class c{static{this.assertInvariants=!1}constructor(p){this.e=p,this.c=0}findLastMonotonous(p){if(c.assertInvariants){if(this.d){for(const f of this.e)if(this.d(f)&&!p(f))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=p}const u=M(this.e,p,this.c);return this.c=u+1,u===-1?void 0:this.e[u]}}e.$mb=c;function y(w,p){if(w.length===0)return;let u=w[0];for(let f=1;f<w.length;f++){const h=w[f];p(h,u)>0&&(u=h)}return u}e.$nb=y;function v(w,p){if(w.length===0)return;let u=w[0];for(let f=1;f<w.length;f++){const h=w[f];p(h,u)>=0&&(u=h)}return u}e.$ob=v;function k(w,p){return y(w,(u,f)=>-p(u,f))}e.$pb=k;function g(w,p){if(w.length===0)return-1;let u=0;for(let f=1;f<w.length;f++){const h=w[f];p(h,w[u])>0&&(u=f)}return u}e.$qb=g;function m(w,p){for(const u of w){const f=p(u);if(f!==void 0)return f}}e.$rb=m}),define(ae[137],ce([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N=e.$M=e.$L=e.$K=void 0;function n(C,P){const d=Object.create(null);for(const c of C){const y=P(c);let v=d[y];v||(v=d[y]=[]),v.push(c)}return d}e.$K=n;function D(C,P){const d=[],c=[];for(const y of C)P.has(y)||d.push(y);for(const y of P)C.has(y)||c.push(y);return{removed:d,added:c}}e.$L=D;function S(C,P){const d=[],c=[];for(const[y,v]of C)P.has(y)||d.push(v);for(const[y,v]of P)C.has(y)||c.push(v);return{removed:d,added:c}}e.$M=S;function M(C,P){const d=new Set;for(const c of P)C.has(c)&&d.add(c);return d}e.$N=M}),define(ae[138],ce([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bt=e.$At=e.$zt=e.$yt=void 0;function n(P,d){const c=Math.pow(10,d);return Math.round(P*c)/c}class D{constructor(d,c,y,v=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,d))|0,this.g=Math.min(255,Math.max(0,c))|0,this.b=Math.min(255,Math.max(0,y))|0,this.a=n(Math.max(Math.min(1,v),0),3)}static equals(d,c){return d.r===c.r&&d.g===c.g&&d.b===c.b&&d.a===c.a}}e.$yt=D;class S{constructor(d,c,y,v){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,d),0)|0,this.s=n(Math.max(Math.min(1,c),0),3),this.l=n(Math.max(Math.min(1,y),0),3),this.a=n(Math.max(Math.min(1,v),0),3)}static equals(d,c){return d.h===c.h&&d.s===c.s&&d.l===c.l&&d.a===c.a}static fromRGBA(d){const c=d.r/255,y=d.g/255,v=d.b/255,k=d.a,g=Math.max(c,y,v),m=Math.min(c,y,v);let w=0,p=0;const u=(m+g)/2,f=g-m;if(f>0){switch(p=Math.min(u<=.5?f/(2*u):f/(2-2*u),1),g){case c:w=(y-v)/f+(y<v?6:0);break;case y:w=(v-c)/f+2;break;case v:w=(c-y)/f+4;break}w*=60,w=Math.round(w)}return new S(w,p,u,k)}static i(d,c,y){return y<0&&(y+=1),y>1&&(y-=1),y<1/6?d+(c-d)*6*y:y<1/2?c:y<2/3?d+(c-d)*(2/3-y)*6:d}static toRGBA(d){const c=d.h/360,{s:y,l:v,a:k}=d;let g,m,w;if(y===0)g=m=w=v;else{const p=v<.5?v*(1+y):v+y-v*y,u=2*v-p;g=S.i(u,p,c+1/3),m=S.i(u,p,c),w=S.i(u,p,c-1/3)}return new D(Math.round(g*255),Math.round(m*255),Math.round(w*255),k)}}e.$zt=S;class M{constructor(d,c,y,v){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,d),0)|0,this.s=n(Math.max(Math.min(1,c),0),3),this.v=n(Math.max(Math.min(1,y),0),3),this.a=n(Math.max(Math.min(1,v),0),3)}static equals(d,c){return d.h===c.h&&d.s===c.s&&d.v===c.v&&d.a===c.a}static fromRGBA(d){const c=d.r/255,y=d.g/255,v=d.b/255,k=Math.max(c,y,v),g=Math.min(c,y,v),m=k-g,w=k===0?0:m/k;let p;return m===0?p=0:k===c?p=((y-v)/m%6+6)%6:k===y?p=(v-c)/m+2:p=(c-y)/m+4,new M(Math.round(p*60),w,k,d.a)}static toRGBA(d){const{h:c,s:y,v,a:k}=d,g=v*y,m=g*(1-Math.abs(c/60%2-1)),w=v-g;let[p,u,f]=[0,0,0];return c<60?(p=g,u=m):c<120?(p=m,u=g):c<180?(u=g,f=m):c<240?(u=m,f=g):c<300?(p=m,f=g):c<=360&&(p=g,f=m),p=Math.round((p+w)*255),u=Math.round((u+w)*255),f=Math.round((f+w)*255),new D(p,u,f,k)}}e.$At=M;class C{static fromHex(d){return C.Format.CSS.parseHex(d)||C.red}static equals(d,c){return!d&&!c?!0:!d||!c?!1:d.equals(c)}get hsla(){return this.i?this.i:S.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:M.fromRGBA(this.rgba)}constructor(d){if(d)if(d instanceof D)this.rgba=d;else if(d instanceof S)this.i=d,this.rgba=S.toRGBA(d);else if(d instanceof M)this.j=d,this.rgba=M.toRGBA(d);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(d){return!!d&&D.equals(this.rgba,d.rgba)&&S.equals(this.hsla,d.hsla)&&M.equals(this.hsva,d.hsva)}getRelativeLuminance(){const d=C.k(this.rgba.r),c=C.k(this.rgba.g),y=C.k(this.rgba.b),v=.2126*d+.7152*c+.0722*y;return n(v,4)}static k(d){const c=d/255;return c<=.03928?c/12.92:Math.pow((c+.055)/1.055,2.4)}getContrastRatio(d){const c=this.getRelativeLuminance(),y=d.getRelativeLuminance();return c>y?(c+.05)/(y+.05):(y+.05)/(c+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(d){const c=this.getRelativeLuminance(),y=d.getRelativeLuminance();return c>y}isDarkerThan(d){const c=this.getRelativeLuminance(),y=d.getRelativeLuminance();return c<y}lighten(d){return new C(new S(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*d,this.hsla.a))}darken(d){return new C(new S(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*d,this.hsla.a))}transparent(d){const{r:c,g:y,b:v,a:k}=this.rgba;return new C(new D(c,y,v,k*d))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new C(new D(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(d){const c=d.rgba,y=this.rgba.a,v=c.a,k=y+v*(1-y);if(k<1e-6)return C.transparent;const g=this.rgba.r*y/k+c.r*v*(1-y)/k,m=this.rgba.g*y/k+c.g*v*(1-y)/k,w=this.rgba.b*y/k+c.b*v*(1-y)/k;return new C(new D(g,m,w,k))}makeOpaque(d){if(this.isOpaque()||d.rgba.a!==1)return this;const{r:c,g:y,b:v,a:k}=this.rgba;return new C(new D(d.rgba.r-k*(d.rgba.r-c),d.rgba.g-k*(d.rgba.g-y),d.rgba.b-k*(d.rgba.b-v),1))}flatten(...d){const c=d.reduceRight((y,v)=>C.o(v,y));return C.o(this,c)}static o(d,c){const y=1-d.rgba.a;return new C(new D(y*c.rgba.r+d.rgba.a*d.rgba.r,y*c.rgba.g+d.rgba.a*d.rgba.g,y*c.rgba.b+d.rgba.a*d.rgba.b))}toString(){return this.u||(this.u=C.Format.CSS.format(this)),this.u}static getLighterColor(d,c,y){if(d.isLighterThan(c))return d;y=y||.5;const v=d.getRelativeLuminance(),k=c.getRelativeLuminance();return y=y*(k-v)/k,d.lighten(y)}static getDarkerColor(d,c,y){if(d.isDarkerThan(c))return d;y=y||.5;const v=d.getRelativeLuminance(),k=c.getRelativeLuminance();return y=y*(v-k)/v,d.darken(y)}static{this.white=new C(new D(255,255,255,1))}static{this.black=new C(new D(0,0,0,1))}static{this.red=new C(new D(255,0,0,1))}static{this.blue=new C(new D(0,0,255,1))}static{this.green=new C(new D(0,255,0,1))}static{this.cyan=new C(new D(0,255,255,1))}static{this.lightgrey=new C(new D(211,211,211,1))}static{this.transparent=new C(new D(0,0,0,0))}}e.$Bt=C,function(P){let d;(function(c){let y;(function(v){function k(t){return t.rgba.a===1?`rgb(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b})`:P.Format.CSS.formatRGBA(t)}v.formatRGB=k;function g(t){return`rgba(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b}, ${+t.rgba.a.toFixed(2)})`}v.formatRGBA=g;function m(t){return t.hsla.a===1?`hsl(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%)`:P.Format.CSS.formatHSLA(t)}v.formatHSL=m;function w(t){return`hsla(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%, ${t.hsla.a.toFixed(2)})`}v.formatHSLA=w;function p(t){const o=t.toString(16);return o.length!==2?"0"+o:o}function u(t){return`#${p(t.rgba.r)}${p(t.rgba.g)}${p(t.rgba.b)}`}v.formatHex=u;function f(t,o=!1){return o&&t.rgba.a===1?P.Format.CSS.formatHex(t):`#${p(t.rgba.r)}${p(t.rgba.g)}${p(t.rgba.b)}${p(Math.round(t.rgba.a*255))}`}v.formatHexA=f;function h(t){return t.isOpaque()?P.Format.CSS.formatHex(t):P.Format.CSS.formatRGBA(t)}v.format=h;function $(t){const o=t.length;if(o===0||t.charCodeAt(0)!==35)return null;if(o===7){const r=16*a(t.charCodeAt(1))+a(t.charCodeAt(2)),i=16*a(t.charCodeAt(3))+a(t.charCodeAt(4)),s=16*a(t.charCodeAt(5))+a(t.charCodeAt(6));return new P(new D(r,i,s,1))}if(o===9){const r=16*a(t.charCodeAt(1))+a(t.charCodeAt(2)),i=16*a(t.charCodeAt(3))+a(t.charCodeAt(4)),s=16*a(t.charCodeAt(5))+a(t.charCodeAt(6)),l=16*a(t.charCodeAt(7))+a(t.charCodeAt(8));return new P(new D(r,i,s,l/255))}if(o===4){const r=a(t.charCodeAt(1)),i=a(t.charCodeAt(2)),s=a(t.charCodeAt(3));return new P(new D(16*r+r,16*i+i,16*s+s))}if(o===5){const r=a(t.charCodeAt(1)),i=a(t.charCodeAt(2)),s=a(t.charCodeAt(3)),l=a(t.charCodeAt(4));return new P(new D(16*r+r,16*i+i,16*s+s,(16*l+l)/255))}return null}v.parseHex=$;function a(t){switch(t){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(y=c.CSS||(c.CSS={}))})(d=P.Format||(P.Format={}))}(C||(e.$Bt=C={}))}),define(ae[50],ce([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mh=e.$Lh=e.$Kh=void 0;function n(C){return(P,d,c)=>{let y=null,v=null;if(typeof c.value=="function"?(y="value",v=c.value):typeof c.get=="function"&&(y="get",v=c.get),!v)throw new Error("not supported");c[y]=C(v,d)}}function D(C,P,d){let c=null,y=null;if(typeof d.value=="function"?(c="value",y=d.value,y.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof d.get=="function"&&(c="get",y=d.get),!y)throw new Error("not supported");const v=`$memoize$${P}`;d[c]=function(...k){return this.hasOwnProperty(v)||Object.defineProperty(this,v,{configurable:!1,enumerable:!1,writable:!1,value:y.apply(this,k)}),this[v]}}e.$Kh=D;function S(C,P,d){return n((c,y)=>{const v=`$debounce$${y}`,k=`$debounce$result$${y}`;return function(...g){this[k]||(this[k]=d?d():void 0),clearTimeout(this[v]),P&&(this[k]=P(this[k],...g),g=[this[k]]),this[v]=setTimeout(()=>{c.apply(this,g),this[k]=d?d():void 0},C)}})}e.$Lh=S;function M(C,P,d){return n((c,y)=>{const v=`$throttle$timer$${y}`,k=`$throttle$result$${y}`,g=`$throttle$lastRun$${y}`,m=`$throttle$pending$${y}`;return function(...w){if(this[k]||(this[k]=d?d():void 0),(this[g]===null||this[g]===void 0)&&(this[g]=-Number.MAX_VALUE),P&&(this[k]=P(this[k],...w)),this[m])return;const p=this[g]+C;p<=Date.now()?(this[g]=Date.now(),c.apply(this,[this[k]]),this[k]=d?d():void 0):(this[m]=!0,this[v]=setTimeout(()=>{this[m]=!1,this[g]=Date.now(),c.apply(this,[this[k]]),this[k]=d?d():void 0},p-Date.now()))}})}e.$Mh=M}),define(ae[15],ce([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.setUnexpectedErrorHandler=e.$X=e.$W=void 0;class n{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?h.isErrorNoTelemetry(t)?new h(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(o=>{o(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$W=n,e.$X=new n;function D(a){e.$X.setUnexpectedErrorHandler(a)}e.setUnexpectedErrorHandler=D;function S(a){if(!a||typeof a!="object")return!1;const t=a;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}e.$Z=S;function M(a){c(a)||e.$X.onUnexpectedError(a)}e.$1=M;function C(a){c(a)||e.$X.onUnexpectedExternalError(a)}e.$2=C;function P(a){if(a instanceof Error){const{name:t,message:o}=a,r=a.stacktrace||a.stack;return{$isError:!0,name:t,message:o,stack:r,noTelemetry:h.isErrorNoTelemetry(a)}}return a}e.$3=P;const d="Canceled";function c(a){return a instanceof y?!0:a instanceof Error&&a.name===d&&a.message===d}e.$4=c;class y extends Error{constructor(){super(d),this.name=this.message}}e.$5=y;function v(){const a=new Error(d);return a.name=a.message,a}e.$6=v;function k(a){return a?new Error(`Illegal argument: ${a}`):new Error("Illegal argument")}e.$7=k;function g(a){return a?new Error(`Illegal state: ${a}`):new Error("Illegal state")}e.$8=g;class m extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=m;function w(a){return a?a.message?a.message:a.stack?a.stack.split(`
`)[0]:String(a):"Error"}e.$0=w;class p extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$$=p;class u extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$_=u;class f extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=f;class h extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof h)return t;const o=new h;return o.message=t.message,o.stack=t.stack,o}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$bb=h;class $ extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,$.prototype)}}e.$cb=$}),define(ae[22],ce([0,1,15,136]),function(X,e,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ac=e.$_b=e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=e.CompareResult=e.$6b=e.$5b=e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=e.$Gb=e.top=e.$Eb=e.$Db=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=e.$sb=void 0;function S(z,Q=0){return z[z.length-(1+Q)]}e.$sb=S;function M(z){if(z.length===0)throw new Error("Invalid tail call");return[z.slice(0,z.length-1),z[z.length-1]]}e.$tb=M;function C(z,Q,H=(_,B)=>_===B){if(z===Q)return!0;if(!z||!Q||z.length!==Q.length)return!1;for(let _=0,B=z.length;_<B;_++)if(!H(z[_],Q[_]))return!1;return!0}e.$ub=C;function P(z,Q){const H=z.length-1;Q<H&&(z[Q]=z[H]),z.pop()}e.$vb=P;function d(z,Q,H){return c(z.length,_=>H(z[_],Q))}e.$wb=d;function c(z,Q){let H=0,_=z-1;for(;H<=_;){const B=(H+_)/2|0,te=Q(B);if(te<0)H=B+1;else if(te>0)_=B-1;else return B}return-(H+1)}e.$xb=c;function y(z,Q,H){if(z=z|0,z>=Q.length)throw new TypeError("invalid index");const _=Q[Math.floor(Q.length*Math.random())],B=[],te=[],ie=[];for(const de of Q){const me=H(de,_);me<0?B.push(de):me>0?te.push(de):ie.push(de)}return z<B.length?y(z,B,H):z<B.length+ie.length?ie[0]:y(z-(B.length+ie.length),te,H)}e.$yb=y;function v(z,Q){const H=[];let _;for(const B of z.slice(0).sort(Q))!_||Q(_[0],B)!==0?(_=[B],H.push(_)):_.push(B);return H}e.$zb=v;function*k(z,Q){let H,_;for(const B of z)_!==void 0&&Q(_,B)?H.push(B):(H&&(yield H),H=[B]),_=B;H&&(yield H)}e.$Ab=k;function g(z,Q){for(let H=0;H<=z.length;H++)Q(H===0?void 0:z[H-1],H===z.length?void 0:z[H])}e.$Bb=g;function m(z,Q){for(let H=0;H<z.length;H++)Q(H===0?void 0:z[H-1],z[H],H+1===z.length?void 0:z[H+1])}e.$Cb=m;function w(z,Q,H){const _=[];function B(de,me,ke){if(me===0&&ke.length===0)return;const Se=_[_.length-1];Se&&Se.start+Se.deleteCount===de?(Se.deleteCount+=me,Se.toInsert.push(...ke)):_.push({start:de,deleteCount:me,toInsert:ke})}let te=0,ie=0;for(;;){if(te===z.length){B(te,0,Q.slice(ie));break}if(ie===Q.length){B(te,z.length-te,[]);break}const de=z[te],me=Q[ie],ke=H(de,me);ke===0?(te+=1,ie+=1):ke<0?(B(te,1,[]),te+=1):ke>0&&(B(te,0,[me]),ie+=1)}return _}e.$Db=w;function p(z,Q,H){const _=w(z,Q,H),B=[],te=[];for(const ie of _)B.push(...z.slice(ie.start,ie.start+ie.deleteCount)),te.push(...ie.toInsert);return{removed:B,added:te}}e.$Eb=p;function u(z,Q,H){if(H===0)return[];const _=z.slice(0,H).sort(Q);return h(z,Q,_,H,z.length),_}e.top=u;function f(z,Q,H,_,B){return H===0?Promise.resolve([]):new Promise((te,ie)=>{(async()=>{const de=z.length,me=z.slice(0,H).sort(Q);for(let ke=H,Se=Math.min(H+_,de);ke<de;ke=Se,Se=Math.min(Se+_,de)){if(ke>H&&await new Promise(Me=>setTimeout(Me)),B&&B.isCancellationRequested)throw new n.$5;h(z,Q,me,ke,Se)}return me})().then(te,ie)})}e.$Gb=f;function h(z,Q,H,_,B){for(const te=H.length;_<B;_++){const ie=z[_];if(Q(ie,H[te-1])<0){H.pop();const de=(0,D.$kb)(H,me=>Q(ie,me)<0);H.splice(de,0,ie)}}}function $(z){return z.filter(Q=>!!Q)}e.$Hb=$;function a(z){let Q=0;for(let H=0;H<z.length;H++)z[H]&&(z[Q]=z[H],Q+=1);z.length=Q}e.$Ib=a;function t(z,Q,H){z.splice(H,0,z.splice(Q,1)[0])}e.$Jb=t;function o(z){return!Array.isArray(z)||z.length===0}e.$Kb=o;function r(z){return Array.isArray(z)&&z.length>0}e.$Lb=r;function i(z,Q=H=>H){const H=new Set;return z.filter(_=>{const B=Q(_);return H.has(B)?!1:(H.add(B),!0)})}e.$Mb=i;function s(z){const Q=new Set;return H=>{const _=z(H);return Q.has(_)?!1:(Q.add(_),!0)}}e.$Nb=s;function l(z,Q){return z.length>0?z[0]:Q}e.$Ob=l;function b(z,Q){return z.length>0?z[z.length-1]:Q}e.$Pb=b;function R(z,Q,H=(_,B)=>_===B){let _=0;for(let B=0,te=Math.min(z.length,Q.length);B<te&&H(z[B],Q[B]);B++)_++;return _}e.$Qb=R;function I(z){return[].concat(...z)}e.$Rb=I;function E(z,Q){let H=typeof Q=="number"?z:0;typeof Q=="number"?H=z:(H=0,Q=z);const _=[];if(H<=Q)for(let B=H;B<Q;B++)_.push(B);else for(let B=H;B>Q;B--)_.push(B);return _}e.$Sb=E;function A(z,Q,H){return z.reduce((_,B)=>(_[Q(B)]=H?H(B):B,_),Object.create(null))}e.$Tb=A;function j(z,Q){return z.push(Q),()=>T(z,Q)}e.$Ub=j;function T(z,Q){const H=z.indexOf(Q);if(H>-1)return z.splice(H,1),Q}e.$Vb=T;function W(z,Q,H){const _=z.slice(0,Q),B=z.slice(Q);return _.concat(H,B)}e.$Wb=W;function V(z,Q){let H;if(typeof Q=="number"){let _=Q;H=()=>{const B=Math.sin(_++)*179426549;return B-Math.floor(B)}}else H=Math.random;for(let _=z.length-1;_>0;_-=1){const B=Math.floor(H()*(_+1)),te=z[_];z[_]=z[B],z[B]=te}}e.$Xb=V;function K(z,Q){const H=z.indexOf(Q);H>-1&&(z.splice(H,1),z.unshift(Q))}e.$Yb=K;function le(z,Q){const H=z.indexOf(Q);H>-1&&(z.splice(H,1),z.push(Q))}e.$Zb=le;function re(z,Q){for(const H of Q)z.push(H)}e.$1b=re;function ue(z,Q){return Array.isArray(z)?z.map(Q):Q(z)}e.$2b=ue;function Z(z){return Array.isArray(z)?z:[z]}e.$3b=Z;function Y(z){return z[Math.floor(Math.random()*z.length)]}e.$4b=Y;function U(z,Q,H){const _=N(z,Q),B=z.length,te=H.length;z.length=B+te;for(let ie=B-1;ie>=_;ie--)z[ie+te]=z[ie];for(let ie=0;ie<te;ie++)z[ie+_]=H[ie]}e.$5b=U;function L(z,Q,H,_){const B=N(z,Q);let te=z.splice(B,H);return te===void 0&&(te=[]),U(z,B,_),te}e.$6b=L;function N(z,Q){return Q<0?Math.max(Q+z.length,0):Math.min(Q,z.length)}var G;(function(z){function Q(te){return te<0}z.isLessThan=Q;function H(te){return te<=0}z.isLessThanOrEqual=H;function _(te){return te>0}z.isGreaterThan=_;function B(te){return te===0}z.isNeitherLessOrGreaterThan=B,z.greaterThan=1,z.lessThan=-1,z.neitherLessOrGreaterThan=0})(G||(e.CompareResult=G={}));function q(z,Q){return(H,_)=>Q(z(H),z(_))}e.$7b=q;function oe(...z){return(Q,H)=>{for(const _ of z){const B=_(Q,H);if(!G.isNeitherLessOrGreaterThan(B))return B}return G.neitherLessOrGreaterThan}}e.$8b=oe;const he=(z,Q)=>z-Q;e.$9b=he;const J=(z,Q)=>(0,e.$9b)(z?1:0,Q?1:0);e.$0b=J;function O(z){return(Q,H)=>-z(Q,H)}e.$$b=O;class F{constructor(Q){this.g=Q,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(Q){let H=this.c;for(;H<this.g.length&&Q(this.g[H]);)H++;const _=H===this.c?null:this.g.slice(this.c,H);return this.c=H,_}takeFromEndWhile(Q){let H=this.d;for(;H>=0&&Q(this.g[H]);)H--;const _=H===this.d?null:this.g.slice(H+1,this.d+1);return this.d=H,_}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const Q=this.g[this.c];return this.c++,Q}removeLast(){const Q=this.g[this.d];return this.d--,Q}takeCount(Q){const H=this.g.slice(this.c,this.c+Q);return this.c+=Q,H}}e.$_b=F;class x{static{this.empty=new x(Q=>{})}constructor(Q){this.iterate=Q}forEach(Q){this.iterate(H=>(Q(H),!0))}toArray(){const Q=[];return this.iterate(H=>(Q.push(H),!0)),Q}filter(Q){return new x(H=>this.iterate(_=>Q(_)?H(_):!0))}map(Q){return new x(H=>this.iterate(_=>H(Q(_))))}some(Q){let H=!1;return this.iterate(_=>(H=Q(_),!H)),H}findFirst(Q){let H;return this.iterate(_=>Q(_)?(H=_,!1):!0),H}findLast(Q){let H;return this.iterate(_=>(Q(_)&&(H=_),!0)),H}findLastMaxBy(Q){let H,_=!0;return this.iterate(B=>((_||G.isGreaterThan(Q(B,H)))&&(_=!1,H=B),!0)),H}}e.$ac=x}),define(ae[139],ce([0,1,15]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ad=e.$_c=e.$$c=e.$0c=e.$9c=e.ok=void 0;function D(c,y){if(!c)throw new Error(y?`Assertion failed (${y})`:"Assertion Failed")}e.ok=D;function S(c,y="Unreachable"){throw new Error(y)}e.$9c=S;function M(c){if(!c)throw new n.$cb("Assertion Failed")}e.$0c=M;function C(c){c||(0,n.$1)(new n.$cb("Soft Assertion Failed"))}e.$$c=C;function P(c){if(!c()){debugger;c(),(0,n.$1)(new n.$cb("Assertion Failed"))}}e.$_c=P;function d(c,y){let v=0;for(;v<c.length-1;){const k=c[v],g=c[v+1];if(!y(k,g))return!1;v++}return!0}e.$ad=d}),define(ae[85],ce([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=void 0;function n(D,S){const M=this;let C=!1,P;return function(){if(C)return P;if(C=!0,S)try{P=D.apply(M,arguments)}finally{S()}else P=D.apply(M,arguments);return P}}e.$db=n}),define(ae[71],ce([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var n;(function(D){function S(t){return t&&typeof t=="object"&&typeof t[Symbol.iterator]=="function"}D.is=S;const M=Object.freeze([]);function C(){return M}D.empty=C;function*P(t){yield t}D.single=P;function d(t){return S(t)?t:P(t)}D.wrap=d;function c(t){return t||M}D.from=c;function*y(t){for(let o=t.length-1;o>=0;o--)yield t[o]}D.reverse=y;function v(t){return!t||t[Symbol.iterator]().next().done===!0}D.isEmpty=v;function k(t){return t[Symbol.iterator]().next().value}D.first=k;function g(t,o){for(const r of t)if(o(r))return!0;return!1}D.some=g;function m(t,o){for(const r of t)if(o(r))return r}D.find=m;function*w(t,o){for(const r of t)o(r)&&(yield r)}D.filter=w;function*p(t,o){let r=0;for(const i of t)yield o(i,r++)}D.map=p;function*u(...t){for(const o of t)yield*o}D.concat=u;function f(t,o,r){let i=r;for(const s of t)i=o(i,s);return i}D.reduce=f;function*h(t,o,r=t.length){for(o<0&&(o+=t.length),r<0?r+=t.length:r>t.length&&(r=t.length);o<r;o++)yield t[o]}D.slice=h;function $(t,o=Number.POSITIVE_INFINITY){const r=[];if(o===0)return[r,t];const i=t[Symbol.iterator]();for(let s=0;s<o;s++){const l=i.next();if(l.done)return[r,D.empty()];r.push(l.value)}return[r,{[Symbol.iterator](){return i}}]}D.consume=$;async function a(t){const o=[];for await(const r of t)o.push(r);return Promise.resolve(o)}D.asyncToArray=a})(n||(e.Iterable=n={}))}),define(ae[42],ce([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bn=e.$An=e.$zn=e.$yn=e.$xn=e.$wn=e.$vn=e.$un=e.$tn=e.$sn=e.$rn=e.$qn=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var n;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(n||(e.ScanError=n={}));var D;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(D||(e.SyntaxKind=D={}));var S;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(S||(e.ParseErrorCode=S={}));var M;(function(t){t.DEFAULT={allowTrailingComma:!0}})(M||(e.ParseOptions=M={}));function C(t,o=!1){let r=0;const i=t.length;let s="",l=0,b=16,R=0;function I(K){let le=0,re=0;for(;le<K;){const ue=t.charCodeAt(r);if(ue>=48&&ue<=57)re=re*16+ue-48;else if(ue>=65&&ue<=70)re=re*16+ue-65+10;else if(ue>=97&&ue<=102)re=re*16+ue-97+10;else break;r++,le++}return le<K&&(re=-1),re}function E(K){r=K,s="",l=0,b=16,R=0}function A(){const K=r;if(t.charCodeAt(r)===48)r++;else for(r++;r<t.length&&c(t.charCodeAt(r));)r++;if(r<t.length&&t.charCodeAt(r)===46)if(r++,r<t.length&&c(t.charCodeAt(r)))for(r++;r<t.length&&c(t.charCodeAt(r));)r++;else return R=3,t.substring(K,r);let le=r;if(r<t.length&&(t.charCodeAt(r)===69||t.charCodeAt(r)===101))if(r++,(r<t.length&&t.charCodeAt(r)===43||t.charCodeAt(r)===45)&&r++,r<t.length&&c(t.charCodeAt(r))){for(r++;r<t.length&&c(t.charCodeAt(r));)r++;le=r}else R=3;return t.substring(K,le)}function j(){let K="",le=r;for(;;){if(r>=i){K+=t.substring(le,r),R=2;break}const re=t.charCodeAt(r);if(re===34){K+=t.substring(le,r),r++;break}if(re===92){if(K+=t.substring(le,r),r++,r>=i){R=2;break}switch(t.charCodeAt(r++)){case 34:K+='"';break;case 92:K+="\\";break;case 47:K+="/";break;case 98:K+="\b";break;case 102:K+="\f";break;case 110:K+=`
`;break;case 114:K+="\r";break;case 116:K+="	";break;case 117:{const Z=I(4);Z>=0?K+=String.fromCharCode(Z):R=4;break}default:R=5}le=r;continue}if(re>=0&&re<=31)if(d(re)){K+=t.substring(le,r),R=2;break}else R=6;r++}return K}function T(){if(s="",R=0,l=r,r>=i)return l=i,b=17;let K=t.charCodeAt(r);if(P(K)){do r++,s+=String.fromCharCode(K),K=t.charCodeAt(r);while(P(K));return b=15}if(d(K))return r++,s+=String.fromCharCode(K),K===13&&t.charCodeAt(r)===10&&(r++,s+=`
`),b=14;switch(K){case 123:return r++,b=1;case 125:return r++,b=2;case 91:return r++,b=3;case 93:return r++,b=4;case 58:return r++,b=6;case 44:return r++,b=5;case 34:return r++,s=j(),b=10;case 47:{const le=r-1;if(t.charCodeAt(r+1)===47){for(r+=2;r<i&&!d(t.charCodeAt(r));)r++;return s=t.substring(le,r),b=12}if(t.charCodeAt(r+1)===42){r+=2;const re=i-1;let ue=!1;for(;r<re;){if(t.charCodeAt(r)===42&&t.charCodeAt(r+1)===47){r+=2,ue=!0;break}r++}return ue||(r++,R=1),s=t.substring(le,r),b=13}return s+=String.fromCharCode(K),r++,b=16}case 45:if(s+=String.fromCharCode(K),r++,r===i||!c(t.charCodeAt(r)))return b=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=A(),b=11;default:for(;r<i&&W(K);)r++,K=t.charCodeAt(r);if(l!==r){switch(s=t.substring(l,r),s){case"true":return b=8;case"false":return b=9;case"null":return b=7}return b=16}return s+=String.fromCharCode(K),r++,b=16}}function W(K){if(P(K)||d(K))return!1;switch(K){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function V(){let K;do K=T();while(K>=12&&K<=15);return K}return{setPosition:E,getPosition:()=>r,scan:o?V:T,getToken:()=>b,getTokenValue:()=>s,getTokenOffset:()=>l,getTokenLength:()=>r-l,getTokenError:()=>R}}e.$qn=C;function P(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function d(t){return t===10||t===13||t===8232||t===8233}function c(t){return t>=48&&t<=57}var y;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(y||(y={}));function v(t,o){const r=[],i=new Object;let s;const l={value:{},offset:0,length:0,type:"object",parent:void 0};let b=!1;function R(I,E,A,j){l.value=I,l.offset=E,l.length=A,l.type=j,l.colonOffset=void 0,s=l}try{h(t,{onObjectBegin:(I,E)=>{if(o<=I)throw i;s=void 0,b=o>I,r.push("")},onObjectProperty:(I,E,A)=>{if(o<E||(R(I,E,A,"property"),r[r.length-1]=I,o<=E+A))throw i},onObjectEnd:(I,E)=>{if(o<=I)throw i;s=void 0,r.pop()},onArrayBegin:(I,E)=>{if(o<=I)throw i;s=void 0,r.push(0)},onArrayEnd:(I,E)=>{if(o<=I)throw i;s=void 0,r.pop()},onLiteralValue:(I,E,A)=>{if(o<E||(R(I,E,A,a(I)),o<=E+A))throw i},onSeparator:(I,E,A)=>{if(o<=E)throw i;if(I===":"&&s&&s.type==="property")s.colonOffset=E,b=!1,s=void 0;else if(I===","){const j=r[r.length-1];typeof j=="number"?r[r.length-1]=j+1:(b=!0,r[r.length-1]=""),s=void 0}}})}catch(I){if(I!==i)throw I}return{path:r,previousNode:s,isAtPropertyKey:b,matches:I=>{let E=0;for(let A=0;E<I.length&&A<r.length;A++)if(I[E]===r[A]||I[E]==="*")E++;else if(I[E]!=="**")return!1;return E===I.length}}}e.$rn=v;function k(t,o=[],r=M.DEFAULT){let i=null,s=[];const l=[];function b(I){Array.isArray(s)?s.push(I):i!==null&&(s[i]=I)}return h(t,{onObjectBegin:()=>{const I={};b(I),l.push(s),s=I,i=null},onObjectProperty:I=>{i=I},onObjectEnd:()=>{s=l.pop()},onArrayBegin:()=>{const I=[];b(I),l.push(s),s=I,i=null},onArrayEnd:()=>{s=l.pop()},onLiteralValue:b,onError:(I,E,A)=>{o.push({error:I,offset:E,length:A})}},r),s[0]}e.$sn=k;function g(t,o=[],r=M.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(I){i.type==="property"&&(i.length=I-i.offset,i=i.parent)}function l(I){return i.children.push(I),I}h(t,{onObjectBegin:I=>{i=l({type:"object",offset:I,length:-1,parent:i,children:[]})},onObjectProperty:(I,E,A)=>{i=l({type:"property",offset:E,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:I,offset:E,length:A,parent:i})},onObjectEnd:(I,E)=>{i.length=I+E-i.offset,i=i.parent,s(I+E)},onArrayBegin:(I,E)=>{i=l({type:"array",offset:I,length:-1,parent:i,children:[]})},onArrayEnd:(I,E)=>{i.length=I+E-i.offset,i=i.parent,s(I+E)},onLiteralValue:(I,E,A)=>{l({type:a(I),offset:E,length:A,parent:i,value:I}),s(E+A)},onSeparator:(I,E,A)=>{i.type==="property"&&(I===":"?i.colonOffset=E:I===","&&s(E))},onError:(I,E,A)=>{o.push({error:I,offset:E,length:A})}},r);const R=i.children[0];return R&&delete R.parent,R}e.$tn=g;function m(t,o){if(!t)return;let r=t;for(const i of o)if(typeof i=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let s=!1;for(const l of r.children)if(Array.isArray(l.children)&&l.children[0].value===i){r=l.children[1],s=!0;break}if(!s)return}else{const s=i;if(r.type!=="array"||s<0||!Array.isArray(r.children)||s>=r.children.length)return;r=r.children[s]}return r}e.$un=m;function w(t){if(!t.parent||!t.parent.children)return[];const o=w(t.parent);if(t.parent.type==="property"){const r=t.parent.children[0].value;o.push(r)}else if(t.parent.type==="array"){const r=t.parent.children.indexOf(t);r!==-1&&o.push(r)}return o}e.$vn=w;function p(t){switch(t.type){case"array":return t.children.map(p);case"object":{const o=Object.create(null);for(const r of t.children){const i=r.children[1];i&&(o[r.children[0].value]=p(i))}return o}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.$wn=p;function u(t,o,r=!1){return o>=t.offset&&o<t.offset+t.length||r&&o===t.offset+t.length}e.$xn=u;function f(t,o,r=!1){if(u(t,o,r)){const i=t.children;if(Array.isArray(i))for(let s=0;s<i.length&&i[s].offset<=o;s++){const l=f(i[s],o,r);if(l)return l}return t}}e.$yn=f;function h(t,o,r=M.DEFAULT){const i=C(t,!1);function s(q){return q?()=>q(i.getTokenOffset(),i.getTokenLength()):()=>!0}function l(q){return q?oe=>q(oe,i.getTokenOffset(),i.getTokenLength()):()=>!0}const b=s(o.onObjectBegin),R=l(o.onObjectProperty),I=s(o.onObjectEnd),E=s(o.onArrayBegin),A=s(o.onArrayEnd),j=l(o.onLiteralValue),T=l(o.onSeparator),W=s(o.onComment),V=l(o.onError),K=r&&r.disallowComments,le=r&&r.allowTrailingComma;function re(){for(;;){const q=i.scan();switch(i.getTokenError()){case 4:ue(14);break;case 5:ue(15);break;case 3:ue(13);break;case 1:K||ue(11);break;case 2:ue(12);break;case 6:ue(16);break}switch(q){case 12:case 13:K?ue(10):W();break;case 16:ue(1);break;case 15:case 14:break;default:return q}}}function ue(q,oe=[],he=[]){if(V(q),oe.length+he.length>0){let J=i.getToken();for(;J!==17;){if(oe.indexOf(J)!==-1){re();break}else if(he.indexOf(J)!==-1)break;J=re()}}}function Z(q){const oe=i.getTokenValue();return q?j(oe):R(oe),re(),!0}function Y(){switch(i.getToken()){case 11:{let q=0;try{q=JSON.parse(i.getTokenValue()),typeof q!="number"&&(ue(2),q=0)}catch{ue(2)}j(q);break}case 7:j(null);break;case 8:j(!0);break;case 9:j(!1);break;default:return!1}return re(),!0}function U(){return i.getToken()!==10?(ue(3,[],[2,5]),!1):(Z(!1),i.getToken()===6?(T(":"),re(),G()||ue(4,[],[2,5])):ue(5,[],[2,5]),!0)}function L(){b(),re();let q=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(q||ue(4,[],[]),T(","),re(),i.getToken()===2&&le)break}else q&&ue(6,[],[]);U()||ue(4,[],[2,5]),q=!0}return I(),i.getToken()!==2?ue(7,[2],[]):re(),!0}function N(){E(),re();let q=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(q||ue(4,[],[]),T(","),re(),i.getToken()===4&&le)break}else q&&ue(6,[],[]);G()||ue(4,[],[4,5]),q=!0}return A(),i.getToken()!==4?ue(8,[4],[]):re(),!0}function G(){switch(i.getToken()){case 3:return N();case 1:return L();case 10:return Z(!0);default:return Y()}}return re(),i.getToken()===17?r.allowEmptyContent?!0:(ue(4,[],[]),!1):G()?(i.getToken()!==17&&ue(9,[],[]),!0):(ue(4,[],[]),!1)}e.$zn=h;function $(t,o){const r=C(t),i=[];let s,l=0,b;do switch(b=r.getPosition(),s=r.scan(),s){case 12:case 13:case 17:l!==b&&i.push(t.substring(l,b)),o!==void 0&&i.push(r.getTokenValue().replace(/[^\r\n]/g,o)),l=r.getPosition();break}while(s!==17);return i.join("")}e.$An=$;function a(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.$Bn=a}),define(ae[140],ce([0,1,42]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fn=e.$En=e.$Dn=e.$Cn=void 0;function D(c,y,v){let k,g,m,w,p;if(y){for(w=y.offset,p=w+y.length,m=w;m>0&&!d(c,m-1);)m--;let b=p;for(;b<c.length&&!d(c,b);)b++;g=c.substring(m,b),k=C(g,v)}else g=c,k=0,m=0,w=0,p=c.length;const u=P(v,c);let f=!1,h=0,$;v.insertSpaces?$=M(" ",v.tabSize||4):$="	";const a=(0,n.$qn)(g,!1);let t=!1;function o(){return u+M($,k+h)}function r(){let b=a.scan();for(f=!1;b===15||b===14;)f=f||b===14,b=a.scan();return t=b===16||a.getTokenError()!==0,b}const i=[];function s(b,R,I){!t&&R<p&&I>w&&c.substring(R,I)!==b&&i.push({offset:R,length:I-R,content:b})}let l=r();if(l!==17){const b=a.getTokenOffset()+m,R=M($,k);s(R,m,b)}for(;l!==17;){let b=a.getTokenOffset()+a.getTokenLength()+m,R=r(),I="";for(;!f&&(R===12||R===13);){const A=a.getTokenOffset()+m;s(" ",b,A),b=a.getTokenOffset()+a.getTokenLength()+m,I=R===12?o():"",R=r()}if(R===2)l!==1&&(h--,I=o());else if(R===4)l!==3&&(h--,I=o());else{switch(l){case 3:case 1:h++,I=o();break;case 5:case 12:I=o();break;case 13:f?I=o():I=" ";break;case 6:I=" ";break;case 10:if(R===6){I="";break}case 7:case 8:case 9:case 11:case 2:case 4:R===12||R===13?I=" ":R!==5&&R!==17&&(t=!0);break;case 16:t=!0;break}f&&(R===12||R===13)&&(I=o())}const E=a.getTokenOffset()+m;s(I,b,E),l=R}return i}e.$Cn=D;function S(c,y){const v=JSON.stringify(c,void 0,y.insertSpaces?y.tabSize||4:"	");return y.eol!==void 0?v.replace(/\r\n|\r|\n/g,y.eol):v}e.$Dn=S;function M(c,y){let v="";for(let k=0;k<y;k++)v+=c;return v}function C(c,y){let v=0,k=0;const g=y.tabSize||4;for(;v<c.length;){const m=c.charAt(v);if(m===" ")k++;else if(m==="	")k+=g;else break;v++}return Math.floor(k/g)}function P(c,y){for(let v=0;v<y.length;v++){const k=y.charAt(v);if(k==="\r")return v+1<y.length&&y.charAt(v+1)===`
`?`\r
`:"\r";if(k===`
`)return`
`}return c&&c.eol||`
`}e.$En=P;function d(c,y){return`\r
`.indexOf(c.charAt(y))!==-1}e.$Fn=d}),define(ae[103],ce([0,1,42,140]),function(X,e,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kn=e.$Jn=e.$In=e.$Hn=e.$Gn=void 0;function S(c,y,v){return M(c,y,void 0,v)}e.$Gn=S;function M(c,y,v,k,g){const m=y.slice(),w=[],p=(0,n.$tn)(c,w);let u,f;for(;m.length>0&&(f=m.pop(),u=(0,n.$un)(p,m),u===void 0&&v!==void 0);)typeof f=="string"?v={[f]:v}:v=[v];if(u)if(u.type==="object"&&typeof f=="string"&&Array.isArray(u.children)){const h=(0,n.$un)(u,[f]);if(h!==void 0)if(v===void 0){if(!h.parent)throw new Error("Malformed AST");const $=u.children.indexOf(h.parent);let a,t=h.parent.offset+h.parent.length;if($>0){const o=u.children[$-1];a=o.offset+o.length}else a=u.offset+1,u.children.length>1&&(t=u.children[1].offset);return C(c,{offset:a,length:t-a,content:""},k)}else return C(c,{offset:h.offset,length:h.length,content:JSON.stringify(v)},k);else{if(v===void 0)return[];const $=`${JSON.stringify(f)}: ${JSON.stringify(v)}`,a=g?g(u.children.map(o=>o.children[0].value)):u.children.length;let t;if(a>0){const o=u.children[a-1];t={offset:o.offset+o.length,length:0,content:","+$}}else u.children.length===0?t={offset:u.offset+1,length:0,content:$}:t={offset:u.offset+1,length:0,content:$+","};return C(c,t,k)}}else if(u.type==="array"&&typeof f=="number"&&Array.isArray(u.children))if(v!==void 0){const h=`${JSON.stringify(v)}`;let $;if(u.children.length===0||f===0)$={offset:u.offset+1,length:0,content:u.children.length===0?h:h+","};else{const a=f===-1||f>u.children.length?u.children.length:f,t=u.children[a-1];$={offset:t.offset+t.length,length:0,content:","+h}}return C(c,$,k)}else{const h=f,$=u.children[h];let a;if(u.children.length===1)a={offset:u.offset+1,length:u.length-2,content:""};else if(u.children.length-1===h){const t=u.children[h-1],o=t.offset+t.length,r=u.offset+u.length;a={offset:o,length:r-2-o,content:""}}else a={offset:$.offset,length:u.children[h+1].offset-$.offset,content:""};return C(c,a,k)}else throw new Error(`Can not add ${typeof f!="number"?"index":"property"} to parent of type ${u.type}`);else{if(v===void 0)throw new Error("Can not delete in empty document");return C(c,{offset:p?p.offset:0,length:p?p.length:0,content:JSON.stringify(v)},k)}}e.$Hn=M;function C(c,y,v){let k=P(c,y),g=y.offset,m=y.offset+y.content.length;if(y.length===0||y.content.length===0){for(;g>0&&!(0,D.$Fn)(k,g-1);)g--;for(;m<k.length&&!(0,D.$Fn)(k,m);)m++}const w=(0,D.$Cn)(k,{offset:g,length:m-g},v);for(let u=w.length-1;u>=0;u--){const f=w[u];k=P(k,f),g=Math.min(g,f.offset),m=Math.max(m,f.offset+f.length),m+=f.content.length-f.length}const p=c.length-(k.length-m)-g;return[{offset:g,length:p,content:k.substring(g,m)}]}e.$In=C;function P(c,y){return c.substring(0,y.offset)+y.content+c.substring(y.offset+y.length)}e.$Jn=P;function d(c,y){const v=y.slice(0).sort((g,m)=>{const w=g.offset-m.offset;return w===0?g.length-m.length:w});let k=c.length;for(let g=v.length-1;g>=0;g--){const m=v[g];if(m.offset+m.length<=k)c=P(c,m);else throw new Error("Overlapping edit");k=m.offset}return c}e.$Kn=d}),define(ae[61],ce([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class n{constructor(S){this.d=S,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(S){this.c=S}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=n}),define(ae[104],ce([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=void 0;class n{static{this.Undefined=new n(void 0)}constructor(M){this.element=M,this.next=n.Undefined,this.prev=n.Undefined}}class D{constructor(){this.a=n.Undefined,this.b=n.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===n.Undefined}clear(){let M=this.a;for(;M!==n.Undefined;){const C=M.next;M.prev=n.Undefined,M.next=n.Undefined,M=C}this.a=n.Undefined,this.b=n.Undefined,this.c=0}unshift(M){return this.d(M,!1)}push(M){return this.d(M,!0)}d(M,C){const P=new n(M);if(this.a===n.Undefined)this.a=P,this.b=P;else if(C){const c=this.b;this.b=P,P.prev=c,c.next=P}else{const c=this.a;this.a=P,P.next=c,c.prev=P}this.c+=1;let d=!1;return()=>{d||(d=!0,this.e(P))}}shift(){if(this.a!==n.Undefined){const M=this.a.element;return this.e(this.a),M}}pop(){if(this.b!==n.Undefined){const M=this.b.element;return this.e(this.b),M}}e(M){if(M.prev!==n.Undefined&&M.next!==n.Undefined){const C=M.prev;C.next=M.next,M.next.prev=C}else M.prev===n.Undefined&&M.next===n.Undefined?(this.a=n.Undefined,this.b=n.Undefined):M.next===n.Undefined?(this.b=this.b.prev,this.b.next=n.Undefined):M.prev===n.Undefined&&(this.a=this.a.next,this.a.prev=n.Undefined);this.c-=1}*[Symbol.iterator](){let M=this.a;for(;M!==n.Undefined;)yield M.element,M=M.next}}e.$4c=D}),define(ae[31],ce([0,1]),function(X,e){"use strict";var n,D,S;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.Touch=e.$Bc=e.$Ac=e.$zc=e.$yc=e.$xc=void 0;function M(h,$,a){let t=h.get($);return t===void 0&&(t=a,h.set($,t)),t}e.$xc=M;function C(h){const $=[];return h.forEach((a,t)=>{$.push(`${t} => ${a}`)}),`Map(${h.size}) {${$.join(", ")}}`}e.$yc=C;function P(h){const $=[];return h.forEach(a=>{$.push(a)}),`Set(${h.size}) {${$.join(", ")}}`}e.$zc=P;class d{constructor($,a){this.uri=$,this.value=a}}function c(h){return Array.isArray(h)}class y{static{this.c=$=>$.toString()}constructor($,a){if(this[n]="ResourceMap",$ instanceof y)this.d=new Map($.d),this.e=a??y.c;else if(c($)){this.d=new Map,this.e=a??y.c;for(const[t,o]of $)this.set(t,o)}else this.d=new Map,this.e=$??y.c}set($,a){return this.d.set(this.e($),new d($,a)),this}get($){return this.d.get(this.e($))?.value}has($){return this.d.has(this.e($))}get size(){return this.d.size}clear(){this.d.clear()}delete($){return this.d.delete(this.e($))}forEach($,a){typeof a<"u"&&($=$.bind(a));for(const[t,o]of this.d)$(o.value,o.uri,this)}*values(){for(const $ of this.d.values())yield $.value}*keys(){for(const $ of this.d.values())yield $.uri}*entries(){for(const $ of this.d.values())yield[$.uri,$.value]}*[(n=Symbol.toStringTag,Symbol.iterator)](){for(const[,$]of this.d)yield[$.uri,$.value]}}e.$Ac=y;class v{constructor($,a){this[D]="ResourceSet",!$||typeof $=="function"?this.c=new y($):(this.c=new y(a),$.forEach(this.add,this))}get size(){return this.c.size}add($){return this.c.set($,$),this}clear(){this.c.clear()}delete($){return this.c.delete($)}forEach($,a){this.c.forEach((t,o)=>$.call(a,o,o,this))}has($){return this.c.has($)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Bc=v;var k;(function(h){h[h.None=0]="None",h[h.AsOld=1]="AsOld",h[h.AsNew=2]="AsNew"})(k||(e.Touch=k={}));class g{constructor(){this[S]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has($){return this.c.has($)}get($,a=0){const t=this.c.get($);if(t)return a!==0&&this.l(t,a),t.value}set($,a,t=0){let o=this.c.get($);if(o)o.value=a,t!==0&&this.l(o,t);else{switch(o={key:$,value:a,next:void 0,previous:void 0},t){case 0:this.j(o);break;case 1:this.i(o);break;case 2:this.j(o);break;default:this.j(o);break}this.c.set($,o),this.f++}return this}delete($){return!!this.remove($)}remove($){const a=this.c.get($);if(a)return this.c.delete($),this.k(a),this.f--,a.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const $=this.d;return this.c.delete($.key),this.k($),this.f--,$.value}forEach($,a){const t=this.g;let o=this.d;for(;o;){if(a?$.bind(a)(o.value,o.key,this):$(o.value,o.key,this),this.g!==t)throw new Error("LinkedMap got modified during iteration.");o=o.next}}keys(){const $=this,a=this.g;let t=this.d;const o={[Symbol.iterator](){return o},next(){if($.g!==a)throw new Error("LinkedMap got modified during iteration.");if(t){const r={value:t.key,done:!1};return t=t.next,r}else return{value:void 0,done:!0}}};return o}values(){const $=this,a=this.g;let t=this.d;const o={[Symbol.iterator](){return o},next(){if($.g!==a)throw new Error("LinkedMap got modified during iteration.");if(t){const r={value:t.value,done:!1};return t=t.next,r}else return{value:void 0,done:!0}}};return o}entries(){const $=this,a=this.g;let t=this.d;const o={[Symbol.iterator](){return o},next(){if($.g!==a)throw new Error("LinkedMap got modified during iteration.");if(t){const r={value:[t.key,t.value],done:!1};return t=t.next,r}else return{value:void 0,done:!0}}};return o}[(S=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h($){if($>=this.size)return;if($===0){this.clear();return}let a=this.d,t=this.size;for(;a&&t>$;)this.c.delete(a.key),a=a.next,t--;this.d=a,this.f=t,a&&(a.previous=void 0),this.g++}i($){if(!this.d&&!this.e)this.e=$;else if(this.d)$.next=this.d,this.d.previous=$;else throw new Error("Invalid list");this.d=$,this.g++}j($){if(!this.d&&!this.e)this.d=$;else if(this.e)$.previous=this.e,this.e.next=$;else throw new Error("Invalid list");this.e=$,this.g++}k($){if($===this.d&&$===this.e)this.d=void 0,this.e=void 0;else if($===this.d){if(!$.next)throw new Error("Invalid list");$.next.previous=void 0,this.d=$.next}else if($===this.e){if(!$.previous)throw new Error("Invalid list");$.previous.next=void 0,this.e=$.previous}else{const a=$.next,t=$.previous;if(!a||!t)throw new Error("Invalid list");a.previous=t,t.next=a}$.next=void 0,$.previous=void 0,this.g++}l($,a){if(!this.d||!this.e)throw new Error("Invalid list");if(!(a!==1&&a!==2)){if(a===1){if($===this.d)return;const t=$.next,o=$.previous;$===this.e?(o.next=void 0,this.e=o):(t.previous=o,o.next=t),$.previous=void 0,$.next=this.d,this.d.previous=$,this.d=$,this.g++}else if(a===2){if($===this.e)return;const t=$.next,o=$.previous;$===this.d?(t.previous=void 0,this.d=t):(t.previous=o,o.next=t),$.next=void 0,$.previous=this.e,this.e.next=$,this.e=$,this.g++}}}toJSON(){const $=[];return this.forEach((a,t)=>{$.push([t,a])}),$}fromJSON($){this.clear();for(const[a,t]of $)this.set(a,t)}}e.$Cc=g;class m extends g{constructor($,a=1){super(),this.m=$,this.n=Math.min(Math.max(0,a),1)}get limit(){return this.m}set limit($){this.m=$,this.o()}get ratio(){return this.n}set ratio($){this.n=Math.min(Math.max(0,$),1),this.o()}get($,a=2){return super.get($,a)}peek($){return super.get($,0)}set($,a){return super.set($,a,2),this.o(),this}o(){this.size>this.m&&this.h(Math.round(this.m*this.n))}}e.$Dc=m;class w{constructor(){this.c=new Map}add($){return this.c.set($,(this.c.get($)||0)+1),this}delete($){let a=this.c.get($)||0;return a===0?!1:(a--,a===0?this.c.delete($):this.c.set($,a),!0)}has($){return this.c.has($)}}e.$Ec=w;class p{constructor($){if(this.c=new Map,this.d=new Map,$)for(const[a,t]of $)this.set(a,t)}clear(){this.c.clear(),this.d.clear()}set($,a){this.c.set($,a),this.d.set(a,$)}get($){return this.c.get($)}getKey($){return this.d.get($)}delete($){const a=this.c.get($);return a===void 0?!1:(this.c.delete($),this.d.delete(a),!0)}forEach($,a){this.c.forEach((t,o)=>{$.call(a,t,o,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Fc=p;class u{constructor(){this.c=new Map}add($,a){let t=this.c.get($);t||(t=new Set,this.c.set($,t)),t.add(a)}delete($,a){const t=this.c.get($);t&&(t.delete(a),t.size===0&&this.c.delete($))}forEach($,a){const t=this.c.get($);t&&t.forEach(a)}get($){const a=this.c.get($);return a||new Set}}e.$Gc=u;function f(h,$){if(h===$)return!0;if(h.size!==$.size)return!1;for(const[a,t]of h)if(!$.has(a)||$.get(a)!==t)return!1;for(const[a]of $)if(!h.has(a))return!1;return!0}e.$Hc=f}),define(ae[2],ce([0,1,22,137,31,85,71]),function(X,e,n,D,S,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=void 0;const P=!1;let d=null;class c{constructor(){this.b=new Map}static{this.a=0}c(j){let T=this.b.get(j);return T||(T={parent:null,source:null,isSingleton:!1,value:j,idx:c.a++},this.b.set(j,T)),T}trackDisposable(j){const T=this.c(j);T.source||(T.source=new Error().stack)}setParent(j,T){const W=this.c(j);W.parent=T}markAsDisposed(j){this.b.delete(j)}markAsSingleton(j){this.c(j).isSingleton=!0}f(j,T){const W=T.get(j);if(W)return W;const V=j.parent?this.f(this.c(j.parent),T):j;return T.set(j,V),V}getTrackedDisposables(){const j=new Map;return[...this.b.entries()].filter(([,W])=>W.source!==null&&!this.f(W,j).isSingleton).flatMap(([W])=>W)}computeLeakingDisposables(j=10,T){let W;if(T)W=T;else{const ue=new Map,Z=[...this.b.values()].filter(U=>U.source!==null&&!this.f(U,ue).isSingleton);if(Z.length===0)return;const Y=new Set(Z.map(U=>U.value));if(W=Z.filter(U=>!(U.parent&&Y.has(U.parent))),W.length===0)throw new Error("There are cyclic diposable chains!")}if(!W)return;function V(ue){function Z(U,L){for(;U.length>0&&L.some(N=>typeof N=="string"?N===U[0]:U[0].match(N));)U.shift()}const Y=ue.source.split(`
`).map(U=>U.trim().replace("at ","")).filter(U=>U!=="");return Z(Y,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),Y.reverse()}const K=new S.$Gc;for(const ue of W){const Z=V(ue);for(let Y=0;Y<=Z.length;Y++)K.add(Z.slice(0,Y).join(`
`),ue)}W.sort((0,n.$7b)(ue=>ue.idx,n.$9b));let le="",re=0;for(const ue of W.slice(0,j)){re++;const Z=V(ue),Y=[];for(let U=0;U<Z.length;U++){let L=Z[U];L=`(shared with ${K.get(Z.slice(0,U+1).join(`
`)).size}/${W.length} leaks) at ${L}`;const G=K.get(Z.slice(0,U).join(`
`)),q=(0,D.$K)([...G].map(oe=>V(oe)[U]),oe=>oe);delete q[Z[U]];for(const[oe,he]of Object.entries(q))Y.unshift(`    - stacktraces of ${he.length} other leaks continue with ${oe}`);Y.unshift(L)}le+=`


==================== Leaking disposable ${re}/${W.length}: ${ue.value.constructor.name} ====================
${Y.join(`
`)}
============================================================

`}return W.length>j&&(le+=`


... and ${W.length-j} more leaking disposables

`),{leaks:W,details:le}}}e.$Ic=c;function y(A){d=A}if(e.$Jc=y,P){const A="__is_disposable_tracked__";y(new class{trackDisposable(j){const T=new Error("Potentially leaked disposable").stack;setTimeout(()=>{j[A]||console.log(T)},3e3)}setParent(j,T){if(j&&j!==t.None)try{j[A]=!0}catch{}}markAsDisposed(j){if(j&&j!==t.None)try{j[A]=!0}catch{}}markAsSingleton(j){}})}function v(A){return d?.trackDisposable(A),A}e.$Kc=v;function k(A){d?.markAsDisposed(A)}e.$Lc=k;function g(A,j){d?.setParent(A,j)}function m(A,j){if(d)for(const T of A)d.setParent(T,j)}function w(A){return d?.markAsSingleton(A),A}e.$Mc=w;function p(A){return typeof A.dispose=="function"&&A.dispose.length===0}e.$Nc=p;function u(A){if(C.Iterable.is(A)){const j=[];for(const T of A)if(T)try{T.dispose()}catch(W){j.push(W)}if(j.length===1)throw j[0];if(j.length>1)throw new AggregateError(j,"Encountered errors while disposing of store");return Array.isArray(A)?[]:A}else if(A)return A.dispose(),A}e.$Oc=u;function f(A){for(const j of A)p(j)&&j.dispose();return[]}e.$Pc=f;function h(...A){const j=$(()=>u(A));return m(A,j),j}e.$Qc=h;function $(A){const j=v({dispose:(0,M.$db)(()=>{k(j),A()})});return j}e.$Rc=$;class a{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,v(this)}dispose(){this.g||(k(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{u(this.f)}finally{this.f.clear()}}add(j){if(!j)return j;if(j===this)throw new Error("Cannot register a disposable on itself!");return g(j,this),this.g?a.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(j),j}delete(j){if(j){if(j===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(j),j.dispose()}}deleteAndLeak(j){j&&this.f.has(j)&&(this.f.delete(j),g(j,null))}}e.$Sc=a;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new a,v(this),g(this.q,this)}dispose(){k(this),this.q.dispose()}B(j){if(j===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(j)}}e.$Tc=t;class o{constructor(){this.b=!1,v(this)}get value(){return this.b?void 0:this.a}set value(j){this.b||j===this.a||(this.a?.dispose(),j&&g(j,this),this.a=j)}clear(){this.value=void 0}dispose(){this.b=!0,k(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const j=this.a;return this.a=void 0,j&&g(j,null),j}}e.$Uc=o;class r{constructor(j){this.a=new o,this.b=!1,this.a.value=j}get value(){return this.a.value}set value(j){this.b||j===this.a.value||(this.a.value=j)}dispose(){this.b=!0,this.a.dispose()}}e.$Vc=r;class i{constructor(j){this.b=j,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Wc=i;class s{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,v(this)}set(j){let T=j;return this.unset=()=>T=void 0,this.isset=()=>T!==void 0,this.dispose=()=>{T&&(T(),T=void 0,k(this))},this}}e.$Xc=s;class l{constructor(){this.a=new Map}acquire(j,...T){let W=this.a.get(j);W||(W={counter:0,object:this.b(j,...T)},this.a.set(j,W));const{object:V}=W,K=(0,M.$db)(()=>{--W.counter===0&&(this.c(j,W.object),this.a.delete(j))});return W.counter++,{object:V,dispose:K}}}e.$Yc=l;class b{constructor(j){this.a=j}async acquire(j,...T){const W=this.a.acquire(j,...T);try{return{object:await W.object,dispose:()=>W.dispose()}}catch(V){throw W.dispose(),V}}}e.$Zc=b;class R{constructor(j){this.object=j}dispose(){}}e.$1c=R;function I(A){const j=new a;try{A(j)}finally{j.dispose()}}e.$2c=I;class E{constructor(){this.a=new Map,this.b=!1,v(this)}dispose(){k(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{u(this.a.values())}finally{this.a.clear()}}has(j){return this.a.has(j)}get size(){return this.a.size}get(j){return this.a.get(j)}set(j,T,W=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),W||this.a.get(j)?.dispose(),this.a.set(j,T)}deleteAndDispose(j){this.a.get(j)?.dispose(),this.a.delete(j)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$3c=E}),define(ae[86],ce([0,1,31]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tl=e.$Sl=e.$Rl=void 0;const D=new n.$Dc(1e4);function S(c){return d(c,"NFC",D)}e.$Rl=S;const M=new n.$Dc(1e4);function C(c){return d(c,"NFD",M)}e.$Sl=C;const P=/[^\u0000-\u0080]/;function d(c,y,v){if(!c)return c;const k=v.get(c);if(k)return k;let g;return P.test(c)?g=c.normalize(y):g=c,v.set(c,g),g}e.$Tl=function(){const c=/[\u0300-\u036f]/g;return function(y){return C(y).replace(c,"")}}()}),define(ae[141],ce([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jm=e.$im=e.$hm=e.rot=e.$fm=void 0;function n(P,d,c){return Math.min(Math.max(P,d),c)}e.$fm=n;function D(P,d){return(d+P%d)%d}e.rot=D;class S{constructor(){this.a=0}getNext(){return this.a++}}e.$hm=S;class M{constructor(){this.a=1,this.b=0}update(d){return this.b=this.b+(d-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$im=M;class C{constructor(d){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(d),this.c.fill(0,0,d)}update(d){const c=this.c[this.d];return this.c[this.d]=d,this.d=(this.d+1)%this.c.length,this.e-=c,this.e+=d,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$jm=C}),function(){function X(S){const M=[];typeof S=="number"&&M.push("code/timeOrigin",S);function C(d){M.push(d,Date.now())}function P(){const d=[];for(let c=0;c<M.length;c+=2)d.push({name:M[c],startTime:M[c+1]});return d}return{mark:C,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?X():{mark(S){performance.mark(S)},getMarks(){let S=performance.timeOrigin;typeof S!="number"&&(S=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const M=[{name:"code/timeOrigin",startTime:Math.round(S)}];for(const C of performance.getEntriesByType("mark"))M.push({name:C.name,startTime:Math.round(S+C.startTime)});return M}};if(typeof process=="object"){const S=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return X(S)}else return console.trace("perf-util loaded in UNKNOWN environment"),X()}function n(S){return S.MonacoPerformanceMarks||(S.MonacoPerformanceMarks=e()),S.MonacoPerformanceMarks}var D;typeof global=="object"?D=global:typeof self=="object"?D=self:D={},typeof define=="function"?define("vs/base/common/performance",[],function(){return n(D)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=n(D):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),D.perf=n(D))}(),function(X,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var n=e();for(var D in n)(typeof exports=="object"?exports:X)[D]=n[D]}}(typeof self<"u"?self:this,function(){return function(X){var e={};function n(D){if(e[D])return e[D].exports;var S=e[D]={i:D,l:!1,exports:{}};return X[D].call(S.exports,S,S.exports,n),S.l=!0,S.exports}return n.m=X,n.c=e,n.d=function(D,S,M){n.o(D,S)||Object.defineProperty(D,S,{enumerable:!0,get:M})},n.r=function(D){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(D,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(D,"__esModule",{value:!0})},n.t=function(D,S){if(1&S&&(D=n(D)),8&S||4&S&&typeof D=="object"&&D&&D.__esModule)return D;var M=Object.create(null);if(n.r(M),Object.defineProperty(M,"default",{enumerable:!0,value:D}),2&S&&typeof D!="string")for(var C in D)n.d(M,C,function(P){return D[P]}.bind(null,C));return M},n.n=function(D){var S=D&&D.__esModule?function(){return D.default}:function(){return D};return n.d(S,"a",S),S},n.o=function(D,S){return Object.prototype.hasOwnProperty.call(D,S)},n.p="",n(n.s=0)}([function(X,e,n){(function(D){var S;e=X.exports=he,S=typeof D=="object"&&D.env&&D.env.NODE_DEBUG&&/\bsemver\b/i.test(D.env.NODE_DEBUG)?function(){var ee=Array.prototype.slice.call(arguments,0);ee.unshift("SEMVER"),console.log.apply(console,ee)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var M=256,C=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],d=e.src=[],c=0,y=c++;d[y]="0|[1-9]\\d*";var v=c++;d[v]="[0-9]+";var k=c++;d[k]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var g=c++;d[g]="("+d[y]+")\\.("+d[y]+")\\.("+d[y]+")";var m=c++;d[m]="("+d[v]+")\\.("+d[v]+")\\.("+d[v]+")";var w=c++;d[w]="(?:"+d[y]+"|"+d[k]+")";var p=c++;d[p]="(?:"+d[v]+"|"+d[k]+")";var u=c++;d[u]="(?:-("+d[w]+"(?:\\."+d[w]+")*))";var f=c++;d[f]="(?:-?("+d[p]+"(?:\\."+d[p]+")*))";var h=c++;d[h]="[0-9A-Za-z-]+";var $=c++;d[$]="(?:\\+("+d[h]+"(?:\\."+d[h]+")*))";var a=c++,t="v?"+d[g]+d[u]+"?"+d[$]+"?";d[a]="^"+t+"$";var o="[v=\\s]*"+d[m]+d[f]+"?"+d[$]+"?",r=c++;d[r]="^"+o+"$";var i=c++;d[i]="((?:<|>)?=?)";var s=c++;d[s]=d[v]+"|x|X|\\*";var l=c++;d[l]=d[y]+"|x|X|\\*";var b=c++;d[b]="[v=\\s]*("+d[l]+")(?:\\.("+d[l]+")(?:\\.("+d[l]+")(?:"+d[u]+")?"+d[$]+"?)?)?";var R=c++;d[R]="[v=\\s]*("+d[s]+")(?:\\.("+d[s]+")(?:\\.("+d[s]+")(?:"+d[f]+")?"+d[$]+"?)?)?";var I=c++;d[I]="^"+d[i]+"\\s*"+d[b]+"$";var E=c++;d[E]="^"+d[i]+"\\s*"+d[R]+"$";var A=c++;d[A]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var j=c++;d[j]="(?:~>?)";var T=c++;d[T]="(\\s*)"+d[j]+"\\s+",P[T]=new RegExp(d[T],"g");var W=c++;d[W]="^"+d[j]+d[b]+"$";var V=c++;d[V]="^"+d[j]+d[R]+"$";var K=c++;d[K]="(?:\\^)";var le=c++;d[le]="(\\s*)"+d[K]+"\\s+",P[le]=new RegExp(d[le],"g");var re=c++;d[re]="^"+d[K]+d[b]+"$";var ue=c++;d[ue]="^"+d[K]+d[R]+"$";var Z=c++;d[Z]="^"+d[i]+"\\s*("+o+")$|^$";var Y=c++;d[Y]="^"+d[i]+"\\s*("+t+")$|^$";var U=c++;d[U]="(\\s*)"+d[i]+"\\s*("+o+"|"+d[b]+")",P[U]=new RegExp(d[U],"g");var L=c++;d[L]="^\\s*("+d[b]+")\\s+-\\s+("+d[b]+")\\s*$";var N=c++;d[N]="^\\s*("+d[R]+")\\s+-\\s+("+d[R]+")\\s*$";var G=c++;d[G]="(<|>)?=?\\s*\\*";for(var q=0;q<35;q++)S(q,d[q]),P[q]||(P[q]=new RegExp(d[q]));function oe(ee,fe){if(ee instanceof he)return ee;if(typeof ee!="string"||ee.length>M||!(fe?P[r]:P[a]).test(ee))return null;try{return new he(ee,fe)}catch{return null}}function he(ee,fe){if(ee instanceof he){if(ee.loose===fe)return ee;ee=ee.version}else if(typeof ee!="string")throw new TypeError("Invalid Version: "+ee);if(ee.length>M)throw new TypeError("version is longer than "+M+" characters");if(!(this instanceof he))return new he(ee,fe);S("SemVer",ee,fe),this.loose=fe;var $e=ee.trim().match(fe?P[r]:P[a]);if(!$e)throw new TypeError("Invalid Version: "+ee);if(this.raw=ee,this.major=+$e[1],this.minor=+$e[2],this.patch=+$e[3],this.major>C||this.major<0)throw new TypeError("Invalid major version");if(this.minor>C||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>C||this.patch<0)throw new TypeError("Invalid patch version");$e[4]?this.prerelease=$e[4].split(".").map(function(Pe){if(/^[0-9]+$/.test(Pe)){var De=+Pe;if(De>=0&&De<C)return De}return Pe}):this.prerelease=[],this.build=$e[5]?$e[5].split("."):[],this.format()}e.parse=oe,e.valid=function(ee,fe){var $e=oe(ee,fe);return $e?$e.version:null},e.clean=function(ee,fe){var $e=oe(ee.trim().replace(/^[=v]+/,""),fe);return $e?$e.version:null},e.SemVer=he,he.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},he.prototype.toString=function(){return this.version},he.prototype.compare=function(ee){return S("SemVer.compare",this.version,this.loose,ee),ee instanceof he||(ee=new he(ee,this.loose)),this.compareMain(ee)||this.comparePre(ee)},he.prototype.compareMain=function(ee){return ee instanceof he||(ee=new he(ee,this.loose)),O(this.major,ee.major)||O(this.minor,ee.minor)||O(this.patch,ee.patch)},he.prototype.comparePre=function(ee){if(ee instanceof he||(ee=new he(ee,this.loose)),this.prerelease.length&&!ee.prerelease.length)return-1;if(!this.prerelease.length&&ee.prerelease.length)return 1;if(!this.prerelease.length&&!ee.prerelease.length)return 0;var fe=0;do{var $e=this.prerelease[fe],Pe=ee.prerelease[fe];if(S("prerelease compare",fe,$e,Pe),$e===void 0&&Pe===void 0)return 0;if(Pe===void 0)return 1;if($e===void 0)return-1;if($e!==Pe)return O($e,Pe)}while(++fe)},he.prototype.inc=function(ee,fe){switch(ee){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",fe);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",fe);break;case"prepatch":this.prerelease.length=0,this.inc("patch",fe),this.inc("pre",fe);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",fe),this.inc("pre",fe);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var $e=this.prerelease.length;--$e>=0;)typeof this.prerelease[$e]=="number"&&(this.prerelease[$e]++,$e=-2);$e===-1&&this.prerelease.push(0)}fe&&(this.prerelease[0]===fe?isNaN(this.prerelease[1])&&(this.prerelease=[fe,0]):this.prerelease=[fe,0]);break;default:throw new Error("invalid increment argument: "+ee)}return this.format(),this.raw=this.version,this},e.inc=function(ee,fe,$e,Pe){typeof $e=="string"&&(Pe=$e,$e=void 0);try{return new he(ee,$e).inc(fe,Pe).version}catch{return null}},e.diff=function(ee,fe){if(Q(ee,fe))return null;var $e=oe(ee),Pe=oe(fe);if($e.prerelease.length||Pe.prerelease.length){for(var De in $e)if((De==="major"||De==="minor"||De==="patch")&&$e[De]!==Pe[De])return"pre"+De;return"prerelease"}for(var De in $e)if((De==="major"||De==="minor"||De==="patch")&&$e[De]!==Pe[De])return De},e.compareIdentifiers=O;var J=/^[0-9]+$/;function O(ee,fe){var $e=J.test(ee),Pe=J.test(fe);return $e&&Pe&&(ee=+ee,fe=+fe),$e&&!Pe?-1:Pe&&!$e?1:ee<fe?-1:ee>fe?1:0}function F(ee,fe,$e){return new he(ee,$e).compare(new he(fe,$e))}function x(ee,fe,$e){return F(ee,fe,$e)>0}function z(ee,fe,$e){return F(ee,fe,$e)<0}function Q(ee,fe,$e){return F(ee,fe,$e)===0}function H(ee,fe,$e){return F(ee,fe,$e)!==0}function _(ee,fe,$e){return F(ee,fe,$e)>=0}function B(ee,fe,$e){return F(ee,fe,$e)<=0}function te(ee,fe,$e,Pe){var De;switch(fe){case"===":typeof ee=="object"&&(ee=ee.version),typeof $e=="object"&&($e=$e.version),De=ee===$e;break;case"!==":typeof ee=="object"&&(ee=ee.version),typeof $e=="object"&&($e=$e.version),De=ee!==$e;break;case"":case"=":case"==":De=Q(ee,$e,Pe);break;case"!=":De=H(ee,$e,Pe);break;case">":De=x(ee,$e,Pe);break;case">=":De=_(ee,$e,Pe);break;case"<":De=z(ee,$e,Pe);break;case"<=":De=B(ee,$e,Pe);break;default:throw new TypeError("Invalid operator: "+fe)}return De}function ie(ee,fe){if(ee instanceof ie){if(ee.loose===fe)return ee;ee=ee.value}if(!(this instanceof ie))return new ie(ee,fe);S("comparator",ee,fe),this.loose=fe,this.parse(ee),this.semver===de?this.value="":this.value=this.operator+this.semver.version,S("comp",this)}e.rcompareIdentifiers=function(ee,fe){return O(fe,ee)},e.major=function(ee,fe){return new he(ee,fe).major},e.minor=function(ee,fe){return new he(ee,fe).minor},e.patch=function(ee,fe){return new he(ee,fe).patch},e.compare=F,e.compareLoose=function(ee,fe){return F(ee,fe,!0)},e.rcompare=function(ee,fe,$e){return F(fe,ee,$e)},e.sort=function(ee,fe){return ee.sort(function($e,Pe){return e.compare($e,Pe,fe)})},e.rsort=function(ee,fe){return ee.sort(function($e,Pe){return e.rcompare($e,Pe,fe)})},e.gt=x,e.lt=z,e.eq=Q,e.neq=H,e.gte=_,e.lte=B,e.cmp=te,e.Comparator=ie;var de={};function me(ee,fe){if(ee instanceof me)return ee.loose===fe?ee:new me(ee.raw,fe);if(ee instanceof ie)return new me(ee.value,fe);if(!(this instanceof me))return new me(ee,fe);if(this.loose=fe,this.raw=ee,this.set=ee.split(/\s*\|\|\s*/).map(function($e){return this.parseRange($e.trim())},this).filter(function($e){return $e.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ee);this.format()}function ke(ee){return!ee||ee.toLowerCase()==="x"||ee==="*"}function Se(ee,fe,$e,Pe,De,qe,je,Fe,Ue,Ge,Xe,Te,ne){return((fe=ke($e)?"":ke(Pe)?">="+$e+".0.0":ke(De)?">="+$e+"."+Pe+".0":">="+fe)+" "+(Fe=ke(Ue)?"":ke(Ge)?"<"+(+Ue+1)+".0.0":ke(Xe)?"<"+Ue+"."+(+Ge+1)+".0":Te?"<="+Ue+"."+Ge+"."+Xe+"-"+Te:"<="+Fe)).trim()}function Me(ee,fe){for(var $e=0;$e<ee.length;$e++)if(!ee[$e].test(fe))return!1;if(fe.prerelease.length){for($e=0;$e<ee.length;$e++)if(S(ee[$e].semver),ee[$e].semver!==de&&ee[$e].semver.prerelease.length>0){var Pe=ee[$e].semver;if(Pe.major===fe.major&&Pe.minor===fe.minor&&Pe.patch===fe.patch)return!0}return!1}return!0}function He(ee,fe,$e){try{fe=new me(fe,$e)}catch{return!1}return fe.test(ee)}function ye(ee,fe,$e,Pe){var De,qe,je,Fe,Ue;switch(ee=new he(ee,Pe),fe=new me(fe,Pe),$e){case">":De=x,qe=B,je=z,Fe=">",Ue=">=";break;case"<":De=z,qe=_,je=x,Fe="<",Ue="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(He(ee,fe,Pe))return!1;for(var Ge=0;Ge<fe.set.length;++Ge){var Xe=fe.set[Ge],Te=null,ne=null;if(Xe.forEach(function(ge){ge.semver===de&&(ge=new ie(">=0.0.0")),Te=Te||ge,ne=ne||ge,De(ge.semver,Te.semver,Pe)?Te=ge:je(ge.semver,ne.semver,Pe)&&(ne=ge)}),Te.operator===Fe||Te.operator===Ue||(!ne.operator||ne.operator===Fe)&&qe(ee,ne.semver)||ne.operator===Ue&&je(ee,ne.semver))return!1}return!0}ie.prototype.parse=function(ee){var fe=this.loose?P[Z]:P[Y],$e=ee.match(fe);if(!$e)throw new TypeError("Invalid comparator: "+ee);this.operator=$e[1],this.operator==="="&&(this.operator=""),$e[2]?this.semver=new he($e[2],this.loose):this.semver=de},ie.prototype.toString=function(){return this.value},ie.prototype.test=function(ee){return S("Comparator.test",ee,this.loose),this.semver===de||(typeof ee=="string"&&(ee=new he(ee,this.loose)),te(ee,this.operator,this.semver,this.loose))},ie.prototype.intersects=function(ee,fe){if(!(ee instanceof ie))throw new TypeError("a Comparator is required");var $e;if(this.operator==="")return $e=new me(ee.value,fe),He(this.value,$e,fe);if(ee.operator==="")return $e=new me(this.value,fe),He(ee.semver,$e,fe);var Pe=!(this.operator!==">="&&this.operator!==">"||ee.operator!==">="&&ee.operator!==">"),De=!(this.operator!=="<="&&this.operator!=="<"||ee.operator!=="<="&&ee.operator!=="<"),qe=this.semver.version===ee.semver.version,je=!(this.operator!==">="&&this.operator!=="<="||ee.operator!==">="&&ee.operator!=="<="),Fe=te(this.semver,"<",ee.semver,fe)&&(this.operator===">="||this.operator===">")&&(ee.operator==="<="||ee.operator==="<"),Ue=te(this.semver,">",ee.semver,fe)&&(this.operator==="<="||this.operator==="<")&&(ee.operator===">="||ee.operator===">");return Pe||De||qe&&je||Fe||Ue},e.Range=me,me.prototype.format=function(){return this.range=this.set.map(function(ee){return ee.join(" ").trim()}).join("||").trim(),this.range},me.prototype.toString=function(){return this.range},me.prototype.parseRange=function(ee){var fe=this.loose;ee=ee.trim(),S("range",ee,fe);var $e=fe?P[N]:P[L];ee=ee.replace($e,Se),S("hyphen replace",ee),ee=ee.replace(P[U],"$1$2$3"),S("comparator trim",ee,P[U]),ee=(ee=(ee=ee.replace(P[T],"$1~")).replace(P[le],"$1^")).split(/\s+/).join(" ");var Pe=fe?P[Z]:P[Y],De=ee.split(" ").map(function(qe){return function(je,Fe){return S("comp",je),je=function(Ue,Ge){return Ue.trim().split(/\s+/).map(function(Xe){return function(Te,ne){S("caret",Te,ne);var ge=ne?P[ue]:P[re];return Te.replace(ge,function(be,pe,Ee,Oe,Ne){var Je;return S("caret",Te,be,pe,Ee,Oe,Ne),ke(pe)?Je="":ke(Ee)?Je=">="+pe+".0.0 <"+(+pe+1)+".0.0":ke(Oe)?Je=pe==="0"?">="+pe+"."+Ee+".0 <"+pe+"."+(+Ee+1)+".0":">="+pe+"."+Ee+".0 <"+(+pe+1)+".0.0":Ne?(S("replaceCaret pr",Ne),Ne.charAt(0)!=="-"&&(Ne="-"+Ne),Je=pe==="0"?Ee==="0"?">="+pe+"."+Ee+"."+Oe+Ne+" <"+pe+"."+Ee+"."+(+Oe+1):">="+pe+"."+Ee+"."+Oe+Ne+" <"+pe+"."+(+Ee+1)+".0":">="+pe+"."+Ee+"."+Oe+Ne+" <"+(+pe+1)+".0.0"):(S("no pr"),Je=pe==="0"?Ee==="0"?">="+pe+"."+Ee+"."+Oe+" <"+pe+"."+Ee+"."+(+Oe+1):">="+pe+"."+Ee+"."+Oe+" <"+pe+"."+(+Ee+1)+".0":">="+pe+"."+Ee+"."+Oe+" <"+(+pe+1)+".0.0"),S("caret return",Je),Je})}(Xe,Ge)}).join(" ")}(je,Fe),S("caret",je),je=function(Ue,Ge){return Ue.trim().split(/\s+/).map(function(Xe){return function(Te,ne){var ge=ne?P[V]:P[W];return Te.replace(ge,function(be,pe,Ee,Oe,Ne){var Je;return S("tilde",Te,be,pe,Ee,Oe,Ne),ke(pe)?Je="":ke(Ee)?Je=">="+pe+".0.0 <"+(+pe+1)+".0.0":ke(Oe)?Je=">="+pe+"."+Ee+".0 <"+pe+"."+(+Ee+1)+".0":Ne?(S("replaceTilde pr",Ne),Ne.charAt(0)!=="-"&&(Ne="-"+Ne),Je=">="+pe+"."+Ee+"."+Oe+Ne+" <"+pe+"."+(+Ee+1)+".0"):Je=">="+pe+"."+Ee+"."+Oe+" <"+pe+"."+(+Ee+1)+".0",S("tilde return",Je),Je})}(Xe,Ge)}).join(" ")}(je,Fe),S("tildes",je),je=function(Ue,Ge){return S("replaceXRanges",Ue,Ge),Ue.split(/\s+/).map(function(Xe){return function(Te,ne){Te=Te.trim();var ge=ne?P[E]:P[I];return Te.replace(ge,function(be,pe,Ee,Oe,Ne,Je){S("xRange",Te,be,pe,Ee,Oe,Ne,Je);var xe=ke(Ee),Ze=xe||ke(Oe),Qe=Ze||ke(Ne);return pe==="="&&Qe&&(pe=""),xe?be=pe===">"||pe==="<"?"<0.0.0":"*":pe&&Qe?(Ze&&(Oe=0),Qe&&(Ne=0),pe===">"?(pe=">=",Ze?(Ee=+Ee+1,Oe=0,Ne=0):Qe&&(Oe=+Oe+1,Ne=0)):pe==="<="&&(pe="<",Ze?Ee=+Ee+1:Oe=+Oe+1),be=pe+Ee+"."+Oe+"."+Ne):Ze?be=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":Qe&&(be=">="+Ee+"."+Oe+".0 <"+Ee+"."+(+Oe+1)+".0"),S("xRange return",be),be})}(Xe,Ge)}).join(" ")}(je,Fe),S("xrange",je),je=function(Ue,Ge){return S("replaceStars",Ue,Ge),Ue.trim().replace(P[G],"")}(je,Fe),S("stars",je),je}(qe,fe)}).join(" ").split(/\s+/);return this.loose&&(De=De.filter(function(qe){return!!qe.match(Pe)})),De=De.map(function(qe){return new ie(qe,fe)})},me.prototype.intersects=function(ee,fe){if(!(ee instanceof me))throw new TypeError("a Range is required");return this.set.some(function($e){return $e.every(function(Pe){return ee.set.some(function(De){return De.every(function(qe){return Pe.intersects(qe,fe)})})})})},e.toComparators=function(ee,fe){return new me(ee,fe).set.map(function($e){return $e.map(function(Pe){return Pe.value}).join(" ").trim().split(" ")})},me.prototype.test=function(ee){if(!ee)return!1;typeof ee=="string"&&(ee=new he(ee,this.loose));for(var fe=0;fe<this.set.length;fe++)if(Me(this.set[fe],ee))return!0;return!1},e.satisfies=He,e.maxSatisfying=function(ee,fe,$e){var Pe=null,De=null;try{var qe=new me(fe,$e)}catch{return null}return ee.forEach(function(je){qe.test(je)&&(Pe&&De.compare(je)!==-1||(De=new he(Pe=je,$e)))}),Pe},e.minSatisfying=function(ee,fe,$e){var Pe=null,De=null;try{var qe=new me(fe,$e)}catch{return null}return ee.forEach(function(je){qe.test(je)&&(Pe&&De.compare(je)!==1||(De=new he(Pe=je,$e)))}),Pe},e.validRange=function(ee,fe){try{return new me(ee,fe).range||"*"}catch{return null}},e.ltr=function(ee,fe,$e){return ye(ee,fe,"<",$e)},e.gtr=function(ee,fe,$e){return ye(ee,fe,">",$e)},e.outside=ye,e.prerelease=function(ee,fe){var $e=oe(ee,fe);return $e&&$e.prerelease.length?$e.prerelease:null},e.intersects=function(ee,fe,$e){return ee=new me(ee,$e),fe=new me(fe,$e),ee.intersects(fe)},e.coerce=function(ee){if(ee instanceof he)return ee;if(typeof ee!="string")return null;var fe=ee.match(P[A]);return fe==null?null:oe((fe[1]||"0")+"."+(fe[2]||"0")+"."+(fe[3]||"0"))}}).call(this,n(1))},function(X,e){var n,D,S=X.exports={};function M(){throw new Error("setTimeout has not been defined")}function C(){throw new Error("clearTimeout has not been defined")}function P(p){if(n===setTimeout)return setTimeout(p,0);if((n===M||!n)&&setTimeout)return n=setTimeout,setTimeout(p,0);try{return n(p,0)}catch{try{return n.call(null,p,0)}catch{return n.call(this,p,0)}}}(function(){try{n=typeof setTimeout=="function"?setTimeout:M}catch{n=M}try{D=typeof clearTimeout=="function"?clearTimeout:C}catch{D=C}})();var d,c=[],y=!1,v=-1;function k(){y&&d&&(y=!1,d.length?c=d.concat(c):v=-1,c.length&&g())}function g(){if(!y){var p=P(k);y=!0;for(var u=c.length;u;){for(d=c,c=[];++v<u;)d&&d[v].run();v=-1,u=c.length}d=null,y=!1,function(f){if(D===clearTimeout)return clearTimeout(f);if((D===C||!D)&&clearTimeout)return D=clearTimeout,clearTimeout(f);try{D(f)}catch{try{return D.call(null,f)}catch{return D.call(this,f)}}}(p)}}function m(p,u){this.fun=p,this.array=u}function w(){}S.nextTick=function(p){var u=new Array(arguments.length-1);if(arguments.length>1)for(var f=1;f<arguments.length;f++)u[f-1]=arguments[f];c.push(new m(p,u)),c.length!==1||y||P(g)},m.prototype.run=function(){this.fun.apply(null,this.array)},S.title="browser",S.browser=!0,S.env={},S.argv=[],S.version="",S.versions={},S.on=w,S.addListener=w,S.once=w,S.off=w,S.removeListener=w,S.removeAllListeners=w,S.emit=w,S.prependListener=w,S.prependOnceListener=w,S.listeners=function(p){return[]},S.binding=function(p){throw new Error("process.binding is not supported")},S.cwd=function(){return"/"},S.chdir=function(p){throw new Error("process.chdir is not supported")},S.umask=function(){return 0}}])}),define(ae[142],ce([0,1]),function(X,e){"use strict";var n;Object.defineProperty(e,"__esModule",{value:!0}),e.$ds=void 0;class D{constructor(P,d,c){this.level=P,this.key=d,this.value=c,this.forward=[]}}const S=void 0;class M{constructor(P,d=2**16){this.comparator=P,this[n]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(d)|0),this.e=new D(this.c,S,S)}get size(){return this.f}clear(){this.e=new D(this.c,S,S),this.f=0}has(P){return!!M.g(this,P,this.comparator)}get(P){return M.g(this,P,this.comparator)?.value}set(P,d){return M.h(this,P,d,this.comparator)&&(this.f+=1),this}delete(P){const d=M.k(this,P,this.comparator);return d&&(this.f-=1),d}forEach(P,d){let c=this.e.forward[0];for(;c;)P.call(d,c.value,c.key,this),c=c.forward[0]}[(n=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let P=this.e.forward[0];for(;P;)yield[P.key,P.value],P=P.forward[0]}*keys(){let P=this.e.forward[0];for(;P;)yield P.key,P=P.forward[0]}*values(){let P=this.e.forward[0];for(;P;)yield P.value,P=P.forward[0]}toString(){let P="[SkipList]:",d=this.e.forward[0];for(;d;)P+=`node(${d.key}, ${d.value}, lvl:${d.level})`,d=d.forward[0];return P}static g(P,d,c){let y=P.e;for(let v=P.d-1;v>=0;v--)for(;y.forward[v]&&c(y.forward[v].key,d)<0;)y=y.forward[v];if(y=y.forward[0],y&&c(y.key,d)===0)return y}static h(P,d,c,y){const v=[];let k=P.e;for(let g=P.d-1;g>=0;g--){for(;k.forward[g]&&y(k.forward[g].key,d)<0;)k=k.forward[g];v[g]=k}if(k=k.forward[0],k&&y(k.key,d)===0)return k.value=c,!1;{const g=M.j(P);if(g>P.d){for(let m=P.d;m<g;m++)v[m]=P.e;P.d=g}k=new D(g,d,c);for(let m=0;m<g;m++)k.forward[m]=v[m].forward[m],v[m].forward[m]=k;return!0}}static j(P,d=.5){let c=1;for(;Math.random()<d&&c<P.c;)c+=1;return c}static k(P,d,c){const y=[];let v=P.e;for(let k=P.d-1;k>=0;k--){for(;v.forward[k]&&c(v.forward[k].key,d)<0;)v=v.forward[k];y[k]=v}if(v=v.forward[0],!v||c(v.key,d)!==0)return!1;for(let k=0;k<P.d&&y[k].forward[k]===v;k++)y[k].forward[k]=v.forward[k];for(;P.d>0&&P.e.forward[P.d-1]===S;)P.d-=1;return!0}}e.$ds=M}),define(ae[72],ce([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2d=void 0;const n=globalThis.performance&&typeof globalThis.performance.now=="function";class D{static create(M){return new D(M)}constructor(M){this.c=n&&M===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$2d=D}),define(ae[3],ce([0,1,15,85,2,104,72]),function(X,e,n,D,S,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.Event=void 0;const P=!1,d=!1;var c;(function(I){I.None=()=>S.$Tc.None;function E(B){if(d){const{onDidAddListener:te}=B,ie=m.create();let de=0;B.onDidAddListener=()=>{++de===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ie.print()),te?.()}}}function A(B,te){return Y(B,()=>{},0,void 0,!0,void 0,te)}I.defer=A;function j(B){return(te,ie=null,de)=>{let me=!1,ke;return ke=B(Se=>{if(!me)return ke?ke.dispose():me=!0,te.call(ie,Se)},null,de),me&&ke.dispose(),ke}}I.once=j;function T(B,te,ie){return ue((de,me=null,ke)=>B(Se=>de.call(me,te(Se)),null,ke),ie)}I.map=T;function W(B,te,ie){return ue((de,me=null,ke)=>B(Se=>{te(Se),de.call(me,Se)},null,ke),ie)}I.forEach=W;function V(B,te,ie){return ue((de,me=null,ke)=>B(Se=>te(Se)&&de.call(me,Se),null,ke),ie)}I.filter=V;function K(B){return B}I.signal=K;function le(...B){return(te,ie=null,de)=>{const me=(0,S.$Qc)(...B.map(ke=>ke(Se=>te.call(ie,Se))));return Z(me,de)}}I.any=le;function re(B,te,ie,de){let me=ie;return T(B,ke=>(me=te(me,ke),me),de)}I.reduce=re;function ue(B,te){let ie;const de={onWillAddFirstListener(){ie=B(me.fire,me)},onDidRemoveLastListener(){ie?.dispose()}};te||E(de);const me=new h(de);return te?.add(me),me.event}function Z(B,te){return te instanceof Array?te.push(B):te&&te.add(B),B}function Y(B,te,ie=100,de=!1,me=!1,ke,Se){let Me,He,ye,ee=0,fe;const $e={leakWarningThreshold:ke,onWillAddFirstListener(){Me=B(De=>{ee++,He=te(He,De),de&&!ye&&(Pe.fire(He),He=void 0),fe=()=>{const qe=He;He=void 0,ye=void 0,(!de||ee>1)&&Pe.fire(qe),ee=0},typeof ie=="number"?(clearTimeout(ye),ye=setTimeout(fe,ie)):ye===void 0&&(ye=0,queueMicrotask(fe))})},onWillRemoveListener(){me&&ee>0&&fe?.()},onDidRemoveLastListener(){fe=void 0,Me.dispose()}};Se||E($e);const Pe=new h($e);return Se?.add(Pe),Pe.event}I.debounce=Y;function U(B,te=0,ie){return I.debounce(B,(de,me)=>de?(de.push(me),de):[me],te,void 0,!0,void 0,ie)}I.accumulate=U;function L(B,te=(de,me)=>de===me,ie){let de=!0,me;return V(B,ke=>{const Se=de||!te(ke,me);return de=!1,me=ke,Se},ie)}I.latch=L;function N(B,te,ie){return[I.filter(B,te,ie),I.filter(B,de=>!te(de),ie)]}I.split=N;function G(B,te=!1,ie=[],de){let me=ie.slice(),ke=B(He=>{me?me.push(He):Me.fire(He)});de&&de.add(ke);const Se=()=>{me?.forEach(He=>Me.fire(He)),me=null},Me=new h({onWillAddFirstListener(){ke||(ke=B(He=>Me.fire(He)),de&&de.add(ke))},onDidAddFirstListener(){me&&(te?setTimeout(Se):Se())},onDidRemoveLastListener(){ke&&ke.dispose(),ke=null}});return de&&de.add(Me),Me.event}I.buffer=G;function q(B,te){return(de,me,ke)=>{const Se=te(new he);return B(function(Me){const He=Se.evaluate(Me);He!==oe&&de.call(me,He)},void 0,ke)}}I.chain=q;const oe=Symbol("HaltChainable");class he{constructor(){this.f=[]}map(te){return this.f.push(te),this}forEach(te){return this.f.push(ie=>(te(ie),ie)),this}filter(te){return this.f.push(ie=>te(ie)?ie:oe),this}reduce(te,ie){let de=ie;return this.f.push(me=>(de=te(de,me),de)),this}latch(te=(ie,de)=>ie===de){let ie=!0,de;return this.f.push(me=>{const ke=ie||!te(me,de);return ie=!1,de=me,ke?me:oe}),this}evaluate(te){for(const ie of this.f)if(te=ie(te),te===oe)break;return te}}function J(B,te,ie=de=>de){const de=(...Me)=>Se.fire(ie(...Me)),me=()=>B.on(te,de),ke=()=>B.removeListener(te,de),Se=new h({onWillAddFirstListener:me,onDidRemoveLastListener:ke});return Se.event}I.fromNodeEventEmitter=J;function O(B,te,ie=de=>de){const de=(...Me)=>Se.fire(ie(...Me)),me=()=>B.addEventListener(te,de),ke=()=>B.removeEventListener(te,de),Se=new h({onWillAddFirstListener:me,onDidRemoveLastListener:ke});return Se.event}I.fromDOMEventEmitter=O;function F(B){return new Promise(te=>j(B)(te))}I.toPromise=F;function x(B){const te=new h;return B.then(ie=>{te.fire(ie)},()=>{te.fire(void 0)}).finally(()=>{te.dispose()}),te.event}I.fromPromise=x;function z(B,te,ie){return te(ie),B(de=>te(de))}I.runAndSubscribe=z;class Q{constructor(te,ie){this._observable=te,this.f=0,this.g=!1;const de={onWillAddFirstListener:()=>{te.addObserver(this)},onDidRemoveLastListener:()=>{te.removeObserver(this)}};ie||E(de),this.emitter=new h(de),ie&&ie.add(this.emitter)}beginUpdate(te){this.f++}handlePossibleChange(te){}handleChange(te,ie){this.g=!0}endUpdate(te){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function H(B,te){return new Q(B,te).emitter.event}I.fromObservable=H;function _(B){return(te,ie,de)=>{let me=0,ke=!1;const Se={beginUpdate(){me++},endUpdate(){me--,me===0&&(B.reportChanges(),ke&&(ke=!1,te.call(ie)))},handlePossibleChange(){},handleChange(){ke=!0}};B.addObserver(Se),B.reportChanges();const Me={dispose(){B.removeObserver(Se)}};return de instanceof S.$Sc?de.add(Me):Array.isArray(de)&&de.push(Me),Me}}I.fromObservableLight=_})(c||(e.Event=c={}));class y{static{this.all=new Set}static{this.f=0}constructor(E){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${E}_${y.f++}`,y.all.add(this)}start(E){this.g=new C.$2d,this.listenerCount=E}stop(){if(this.g){const E=this.g.elapsed();this.durations.push(E),this.elapsedOverall+=E,this.invocationCount+=1,this.g=void 0}}}e.$4d=y;let v=-1;function k(I){const E=v;return v=I,{dispose(){v=E}}}e.$5d=k;class g{constructor(E,A=Math.random().toString(18).slice(2,5)){this.threshold=E,this.name=A,this.g=0}dispose(){this.f?.clear()}check(E,A){const j=this.threshold;if(j<=0||A<j)return;this.f||(this.f=new Map);const T=this.f.get(E.value)||0;if(this.f.set(E.value,T+1),this.g-=1,this.g<=0){this.g=j*.5;let W,V=0;for(const[K,le]of this.f)(!W||V<le)&&(W=K,V=le);console.warn(`[${this.name}] potential listener LEAK detected, having ${A} listeners already. MOST frequent listener (${V}):`),console.warn(W)}return()=>{const W=this.f.get(E.value)||0;this.f.set(E.value,W-1)}}}class m{static create(){return new m(new Error().stack??"")}constructor(E){this.value=E}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let w=0;class p{constructor(E){this.value=E,this.id=w++}}const u=2,f=(I,E)=>{if(I instanceof p)E(I);else for(let A=0;A<I.length;A++){const j=I[A];j&&E(j)}};class h{constructor(E){this.w=0,this.f=E,this.g=v>0||this.f?.leakWarningThreshold?new g(this.f?.leakWarningThreshold??v):void 0,this.j=this.f?._profName?new y(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(P){const E=this.t;queueMicrotask(()=>{f(E,A=>A.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(E,A,j)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),S.$Tc.None;if(this.m)return S.$Tc.None;A&&(E=E.bind(A));const T=new p(E);let W,V;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(T.stack=m.create(),W=this.g.check(T.stack,this.w+1)),P&&(T.stack=V??m.create()),this.t?this.t instanceof p?(this.u??=new a,this.t=[this.t,T]):this.t.push(T):(this.f?.onWillAddFirstListener?.(this),this.t=T,this.f?.onDidAddFirstListener?.(this)),this.w++;const K=(0,S.$Rc)(()=>{W?.(),this.x(T)});return j instanceof S.$Sc?j.add(K):Array.isArray(j)&&j.push(K),K},this.q}x(E){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const A=this.t,j=A.indexOf(E);if(j===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,A[j]=void 0;const T=this.u.current===this;if(this.w*u<=A.length){let W=0;for(let V=0;V<A.length;V++)A[V]?A[W++]=A[V]:T&&(this.u.end--,W<this.u.i&&this.u.i--);A.length=W}}y(E,A){if(!E)return;const j=this.f?.onListenerError||n.$1;if(!j){E.value(A);return}try{E.value(A)}catch(T){j(T)}}z(E){const A=E.current.t;for(;E.i<E.end;)this.y(A[E.i++],E.value);E.reset()}fire(E){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof p)this.y(this.t,E);else{const A=this.u;A.enqueue(this,E,this.t.length),this.z(A)}this.j?.stop()}hasListeners(){return this.w>0}}e.$6d=h;const $=()=>new a;e.$7d=$;class a{constructor(){this.i=-1,this.end=0}enqueue(E,A,j){this.i=0,this.end=j,this.current=E,this.value=A}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class t extends h{async fireAsync(E,A,j){if(this.t)for(this.h||(this.h=new M.$4c),f(this.t,T=>this.h.push([T.value,E]));this.h.size>0&&!A.isCancellationRequested;){const[T,W]=this.h.shift(),V=[],K={...W,token:A,waitUntil:le=>{if(Object.isFrozen(V))throw new Error("waitUntil can NOT be called asynchronous");j&&(le=j(le,T)),V.push(le)}};try{T(K)}catch(le){(0,n.$1)(le);continue}Object.freeze(V),await Promise.allSettled(V).then(le=>{for(const re of le)re.status==="rejected"&&(0,n.$1)(re.reason)})}}}e.$8d=t;class o extends h{get isPaused(){return this.h!==0}constructor(E){super(E),this.h=0,this.s=new M.$4c,this.A=E?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const E=Array.from(this.s);this.s.clear(),super.fire(this.A(E))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(E){this.w&&(this.h!==0?this.s.push(E):super.fire(E))}}e.$9d=o;class r extends o{constructor(E){super(E),this.k=E.delay??100}fire(E){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(E)}}e.$0d=r;class i extends h{constructor(E){super(E),this.h=[],this.k=E?.merge}fire(E){this.hasListeners()&&(this.h.push(E),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(A=>super.fire(A)),this.h=[]}))}}e.$$d=i;class s{constructor(){this.g=!1,this.h=[],this.f=new h({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(E){const A={event:E,listener:null};this.h.push(A),this.g&&this.m(A);const j=()=>{this.g&&this.o(A);const T=this.h.indexOf(A);this.h.splice(T,1)};return(0,S.$Rc)((0,D.$db)(j))}j(){this.g=!0,this.h.forEach(E=>this.m(E))}k(){this.g=!1,this.h.forEach(E=>this.o(E))}m(E){E.listener=E.event(A=>this.f.fire(A))}o(E){E.listener?.dispose(),E.listener=null}dispose(){this.f.dispose();for(const E of this.h)E.listener?.dispose();this.h=[]}}e.$_d=s;class l{constructor(E,A,j,T){this.f=new S.$Sc;const W=this.f.add(new s),V=this.f.add(new S.$3c);function K(le){V.set(le,W.add(T(le)))}for(const le of E)K(le);this.f.add(A(le=>{K(le)})),this.f.add(j(le=>{V.deleteAndDispose(le)})),this.event=W.event}dispose(){this.f.dispose()}}e.$ae=l;class b{constructor(){this.f=[]}wrapEvent(E){return(A,j,T)=>E(W=>{const V=this.f[this.f.length-1];V?V.push(()=>A.call(j,W)):A.call(j,W)},void 0,T)}bufferEvents(E){const A=[];this.f.push(A);const j=E();return this.f.pop(),A.forEach(T=>T()),j}}e.$be=b;class R{constructor(){this.f=!1,this.g=c.None,this.h=S.$Tc.None,this.j=new h({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(E){this.g=E,this.f&&(this.h.dispose(),this.h=E(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$ce=R}),define(ae[23],ce([0,1,3]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$de=e.CancellationToken=void 0;const D=Object.freeze(function(P,d){const c=setTimeout(P.bind(d),0);return{dispose(){clearTimeout(c)}}});var S;(function(P){function d(c){return c===P.None||c===P.Cancelled||c instanceof M?!0:!c||typeof c!="object"?!1:typeof c.isCancellationRequested=="boolean"&&typeof c.onCancellationRequested=="function"}P.isCancellationToken=d,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:n.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:D})})(S||(e.CancellationToken=S={}));class M{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?D:(this.b||(this.b=new n.$6d),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class C{constructor(d){this.f=void 0,this.g=void 0,this.g=d&&d.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new M),this.f}cancel(){this.f?this.f instanceof M&&this.f.cancel():this.f=S.Cancelled}dispose(d=!1){d&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof M&&this.f.dispose():this.f=S.None}}e.$de=C}),define(ae[143],ce([0,1,23]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qe=e.$Pe=e.$Oe=void 0;class D{constructor(P){this.b=P,this.a=null}get(){if(this.a)return this.a;const P=new n.$de,d=this.b(P.token);return this.a={promise:d,dispose:()=>{this.a=null,P.cancel(),P.dispose()}},this.a}}e.$Oe=D;class S{constructor(P){this.c=P,this.a=void 0,this.b=void 0}get(P){const d=JSON.stringify(P);return this.b!==d&&(this.b=d,this.a=this.c(P)),this.a}}e.$Pe=S;class M{get cachedValues(){return this.a}constructor(P){this.b=P,this.a=new Map}get(P){if(this.a.has(P))return this.a.get(P);const d=this.b(P);return this.a.set(P,d),d}}e.$Qe=M}),define(ae[62],ce([0,1,15,2]),function(X,e,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=void 0;function S($){const a=$;return a?typeof a.read=="function":!1}e.$ee=S;function M($){const a=$;return a?[a.on,a.pause,a.resume,a.destroy].every(t=>typeof t=="function"):!1}e.$fe=M;function C($){const a=$;return a?M(a.stream)&&Array.isArray(a.buffer)&&typeof a.ended=="boolean":!1}e.$ge=C;function P($,a){return new d($,a)}e.$he=P;class d{constructor(a,t){this.e=a,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(a){if(!this.a.destroyed){if(this.a.flowing)this.g(a);else if(this.b.data.push(a),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(a){this.a.destroyed||(this.a.flowing?this.h(a):this.b.error.push(a))}end(a){this.a.destroyed||(typeof a<"u"&&this.write(a),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(a){this.c.data.slice(0).forEach(t=>t(a))}h(a){this.c.error.length===0?(0,n.$1)(a):this.c.error.slice(0).forEach(t=>t(a))}i(){this.c.end.slice(0).forEach(a=>a())}on(a,t){if(!this.a.destroyed)switch(a){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(a,t){if(this.a.destroyed)return;let o;switch(a){case"data":o=this.c.data;break;case"end":o=this.c.end;break;case"error":o=this.c.error;break}if(o){const r=o.indexOf(t);r>=0&&o.splice(r,1)}}j(){if(this.b.data.length>0){const a=this.e(this.b.data);this.g(a),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(o=>o())}}k(){if(this.c.error.length>0){for(const a of this.b.error)this.h(a);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function c($,a){const t=[];let o;for(;(o=$.read())!==null;)t.push(o);return a(t)}e.$ie=c;function y($,a,t){const o=[];let r;for(;(r=$.read())!==null&&o.length<t;)o.push(r);return r===null&&o.length>0?a(o):{read:()=>{if(o.length>0)return o.shift();if(typeof r<"u"){const i=r;return r=void 0,i}return $.read()}}}e.$je=y;function v($,a){return new Promise((t,o)=>{const r=[];k($,{onData:i=>{a&&r.push(i)},onError:i=>{a?o(i):t(void 0)},onEnd:()=>{t(a?a(r):void 0)}})})}e.$ke=v;function k($,a,t){$.on("error",o=>{t?.isCancellationRequested||a.onError(o)}),$.on("end",()=>{t?.isCancellationRequested||a.onEnd()}),$.on("data",o=>{t?.isCancellationRequested||a.onData(o)})}e.$le=k;function g($,a){return new Promise((t,o)=>{const r=new D.$Sc,i=[],s=R=>{if(i.push(R),i.length>a)return r.dispose(),$.pause(),t({stream:$,buffer:i,ended:!1})},l=R=>(r.dispose(),o(R)),b=()=>(r.dispose(),t({stream:$,buffer:i,ended:!0}));r.add((0,D.$Rc)(()=>$.removeListener("error",l))),$.on("error",l),r.add((0,D.$Rc)(()=>$.removeListener("end",b))),$.on("end",b),r.add((0,D.$Rc)(()=>$.removeListener("data",s))),$.on("data",s)})}e.$me=g;function m($,a){const t=P(a);return t.end($),t}e.$ne=m;function w(){const $=P(()=>{throw new Error("not supported")});return $.end(),$}e.$oe=w;function p($){let a=!1;return{read:()=>a?null:(a=!0,$)}}e.$pe=p;function u($,a,t){const o=P(t);return k($,{onData:r=>o.write(a.data(r)),onError:r=>o.error(a.error?a.error(r):r),onEnd:()=>o.end()}),o}e.$qe=u;function f($,a,t){let o=!1;return{read:()=>{const r=a.read();return o?r:(o=!0,r!==null?t([$,r]):$)}}}e.$re=f;function h($,a,t){let o=!1;const r=P(t);return k(a,{onData:i=>o?r.write(i):(o=!0,r.write(t([$,i]))),onError:i=>r.error(i),onEnd:()=>{o||(o=!0,r.write($)),r.end()}}),r}e.$se=h}),define(ae[17],ce([0,1,61,62]),function(X,e,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=e.$Ee=e.$De=e.$Ce=e.$Be=e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=void 0;const S=typeof Buffer<"u",M=new n.$V(()=>new Uint8Array(256));let C,P;class d{static alloc(A){return S?new d(Buffer.allocUnsafe(A)):new d(new Uint8Array(A))}static wrap(A){return S&&!Buffer.isBuffer(A)&&(A=Buffer.from(A.buffer,A.byteOffset,A.byteLength)),new d(A)}static fromString(A,j){return!(j?.dontUseNodeBuffer||!1)&&S?new d(Buffer.from(A)):(C||(C=new TextEncoder),new d(C.encode(A)))}static fromByteArray(A){const j=d.alloc(A.length);for(let T=0,W=A.length;T<W;T++)j.buffer[T]=A[T];return j}static concat(A,j){if(typeof j>"u"){j=0;for(let V=0,K=A.length;V<K;V++)j+=A[V].byteLength}const T=d.alloc(j);let W=0;for(let V=0,K=A.length;V<K;V++){const le=A[V];T.set(le,W),W+=le.byteLength}return T}constructor(A){this.buffer=A,this.byteLength=this.buffer.byteLength}clone(){const A=d.alloc(this.byteLength);return A.set(this),A}toString(){return S?this.buffer.toString():(P||(P=new TextDecoder),P.decode(this.buffer))}slice(A,j){return new d(this.buffer.subarray(A,j))}set(A,j){if(A instanceof d)this.buffer.set(A.buffer,j);else if(A instanceof Uint8Array)this.buffer.set(A,j);else if(A instanceof ArrayBuffer)this.buffer.set(new Uint8Array(A),j);else if(ArrayBuffer.isView(A))this.buffer.set(new Uint8Array(A.buffer,A.byteOffset,A.byteLength),j);else throw new Error("Unknown argument 'array'")}readUInt32BE(A){return k(this.buffer,A)}writeUInt32BE(A,j){g(this.buffer,A,j)}readUInt32LE(A){return m(this.buffer,A)}writeUInt32LE(A,j){w(this.buffer,A,j)}readUInt8(A){return p(this.buffer,A)}writeUInt8(A,j){u(this.buffer,A,j)}indexOf(A,j=0){return c(this.buffer,A instanceof d?A.buffer:A,j)}}e.$te=d;function c(E,A,j=0){const T=A.byteLength,W=E.byteLength;if(T===0)return 0;if(T===1)return E.indexOf(A[0]);if(T>W-j)return-1;const V=M.value;V.fill(A.length);for(let ue=0;ue<A.length;ue++)V[A[ue]]=A.length-ue-1;let K=j+A.length-1,le=K,re=-1;for(;K<W;)if(E[K]===A[le]){if(le===0){re=K;break}K--,le--}else K+=Math.max(A.length-le,V[E[K]]),le=A.length-1;return re}e.$ue=c;function y(E,A){return E[A+0]<<0>>>0|E[A+1]<<8>>>0}e.$ve=y;function v(E,A,j){E[j+0]=A&255,A=A>>>8,E[j+1]=A&255}e.$we=v;function k(E,A){return E[A]*2**24+E[A+1]*2**16+E[A+2]*2**8+E[A+3]}e.$xe=k;function g(E,A,j){E[j+3]=A,A=A>>>8,E[j+2]=A,A=A>>>8,E[j+1]=A,A=A>>>8,E[j]=A}e.$ye=g;function m(E,A){return E[A+0]<<0>>>0|E[A+1]<<8>>>0|E[A+2]<<16>>>0|E[A+3]<<24>>>0}e.$ze=m;function w(E,A,j){E[j+0]=A&255,A=A>>>8,E[j+1]=A&255,A=A>>>8,E[j+2]=A&255,A=A>>>8,E[j+3]=A&255}e.$Ae=w;function p(E,A){return E[A]}e.$Be=p;function u(E,A,j){E[j]=A}e.$Ce=u;function f(E){return D.$ie(E,A=>d.concat(A))}e.$De=f;function h(E){return D.$pe(E)}e.$Ee=h;function $(E){return D.$ke(E,A=>d.concat(A))}e.$Fe=$;async function a(E){return E.ended?d.concat(E.buffer):d.concat([...E.buffer,await $(E.stream)])}e.$Ge=a;function t(E){return D.$ne(E,A=>d.concat(A))}e.$He=t;function o(E){return D.$qe(E,{data:A=>typeof A=="string"?d.fromString(A):d.wrap(A)},A=>d.concat(A))}e.$Ie=o;function r(E){return D.$he(A=>d.concat(A),E)}e.$Je=r;function i(E,A){return D.$re(E,A,j=>d.concat(j))}e.$Ke=i;function s(E,A){return D.$se(E,A,j=>d.concat(j))}e.$Le=s;function l(E){let A=0,j=0,T=0;const W=new Uint8Array(Math.floor(E.length/4*3)),V=le=>{switch(j){case 3:W[T++]=A|le,j=0;break;case 2:W[T++]=A|le>>>2,A=le<<6,j=3;break;case 1:W[T++]=A|le>>>4,A=le<<4,j=2;break;default:A=le<<2,j=1}};for(let le=0;le<E.length;le++){const re=E.charCodeAt(le);if(re>=65&&re<=90)V(re-65);else if(re>=97&&re<=122)V(re-97+26);else if(re>=48&&re<=57)V(re-48+52);else if(re===43||re===45)V(62);else if(re===47||re===95)V(63);else{if(re===61)break;throw new SyntaxError(`Unexpected base64 character ${E[le]}`)}}const K=T;for(;j>0;)V(0);return d.wrap(W).slice(0,K)}e.$Me=l;const b="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",R="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function I({buffer:E},A=!0,j=!1){const T=j?R:b;let W="";const V=E.byteLength%3;let K=0;for(;K<E.byteLength-V;K+=3){const le=E[K+0],re=E[K+1],ue=E[K+2];W+=T[le>>>2],W+=T[(le<<4|re>>>4)&63],W+=T[(re<<2|ue>>>6)&63],W+=T[ue&63]}if(V===1){const le=E[K+0];W+=T[le>>>2],W+=T[le<<4&63],A&&(W+="==")}else if(V===2){const le=E[K+0],re=E[K+1];W+=T[le>>>2],W+=T[(le<<4|re>>>4)&63],W+=T[re<<2&63],A&&(W+="=")}return W}e.$Ne=I}),define(ae[25],ce([0,1,143,61]),function(X,e,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sf=e.$Rf=e.$Qf=e.$Pf=e.GraphemeBreakType=e.$Of=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.$Df=e.$Cf=e.$Bf=e.$Af=e.$zf=e.$yf=e.$xf=e.$wf=e.$vf=e.$uf=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=e.$hf=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=e.$8e=e.$7e=e.$6e=e.$5e=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=void 0;function S(ne){return!ne||typeof ne!="string"?!0:ne.trim().length===0}e.$Te=S;const M=/{(\d+)}/g;function C(ne,...ge){return ge.length===0?ne:ne.replace(M,function(be,pe){const Ee=parseInt(pe,10);return isNaN(Ee)||Ee<0||Ee>=ge.length?be:ge[Ee]})}e.$Ue=C;const P=/{([^}]+)}/g;function d(ne,ge){return Object.keys(ge).length===0?ne:ne.replace(P,(be,pe)=>ge[pe]??be)}e.$Ve=d;function c(ne){return ne.replace(/[<>"'&]/g,ge=>{switch(ge){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return ge})}e.$We=c;function y(ne){return ne.replace(/[<>&]/g,function(ge){switch(ge){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ge}})}e.$Xe=y;function v(ne){return ne.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$Ye=v;function k(ne,ge){let be=0;const pe=ge.charCodeAt(0);for(let Ee=ne.length-1;Ee>=0;Ee--)ne.charCodeAt(Ee)===pe&&be++;return be}e.$Ze=k;function g(ne,ge,be="\u2026"){return ne.length<=ge?ne:`${ne.substr(0,ge)}${be}`}e.$1e=g;function m(ne,ge,be="\u2026"){if(ne.length<=ge)return ne;const pe=Math.ceil(ge/2)-be.length/2,Ee=Math.floor(ge/2)-be.length/2;return`${ne.substr(0,pe)}${be}${ne.substr(ne.length-Ee)}`}e.$2e=m;function w(ne,ge=" "){const be=p(ne,ge);return u(be,ge)}e.$3e=w;function p(ne,ge){if(!ne||!ge)return ne;const be=ge.length;if(be===0||ne.length===0)return ne;let pe=0;for(;ne.indexOf(ge,pe)===pe;)pe=pe+be;return ne.substring(pe)}e.$4e=p;function u(ne,ge){if(!ne||!ge)return ne;const be=ge.length,pe=ne.length;if(be===0||pe===0)return ne;let Ee=pe,Oe=-1;for(;Oe=ne.lastIndexOf(ge,Ee-1),!(Oe===-1||Oe+be!==Ee);){if(Oe===0)return"";Ee=Oe}return ne.substring(0,Ee)}e.$5e=u;function f(ne){return ne.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$6e=f;function h(ne){return ne.replace(/\*/g,"")}e.$7e=h;function $(ne,ge,be={}){if(!ne)throw new Error("Cannot create regex from empty string");ge||(ne=v(ne)),be.wholeWord&&(/\B/.test(ne.charAt(0))||(ne="\\b"+ne),/\B/.test(ne.charAt(ne.length-1))||(ne=ne+"\\b"));let pe="";return be.global&&(pe+="g"),be.matchCase||(pe+="i"),be.multiline&&(pe+="m"),be.unicode&&(pe+="u"),new RegExp(ne,pe)}e.$8e=$;function a(ne){return ne.source==="^"||ne.source==="^$"||ne.source==="$"||ne.source==="^\\s*$"?!1:!!(ne.exec("")&&ne.lastIndex===0)}e.$9e=a;function t(ne){return ne.split(/\r\n|\r|\n/)}e.$0e=t;function o(ne){const ge=[],be=ne.split(/(\r\n|\r|\n)/);for(let pe=0;pe<Math.ceil(be.length/2);pe++)ge.push(be[2*pe]+(be[2*pe+1]??""));return ge}e.$$e=o;function r(ne){for(let ge=0,be=ne.length;ge<be;ge++){const pe=ne.charCodeAt(ge);if(pe!==32&&pe!==9)return ge}return-1}e.$_e=r;function i(ne,ge=0,be=ne.length){for(let pe=ge;pe<be;pe++){const Ee=ne.charCodeAt(pe);if(Ee!==32&&Ee!==9)return ne.substring(ge,pe)}return ne.substring(ge,be)}e.$af=i;function s(ne,ge=ne.length-1){for(let be=ge;be>=0;be--){const pe=ne.charCodeAt(be);if(pe!==32&&pe!==9)return be}return-1}e.$bf=s;function l(ne,ge,be){const pe=[];let Ee=0;for(const Oe of ne.matchAll(ge)){if(pe.push(ne.slice(Ee,Oe.index)),Oe.index===void 0)throw new Error("match.index should be defined");Ee=Oe.index+Oe[0].length,pe.push(be(Oe[0],...Oe.slice(1),Oe.index,ne,Oe.groups))}return pe.push(ne.slice(Ee)),Promise.all(pe).then(Oe=>Oe.join(""))}e.$cf=l;function b(ne,ge){return ne<ge?-1:ne>ge?1:0}e.$df=b;function R(ne,ge,be=0,pe=ne.length,Ee=0,Oe=ge.length){for(;be<pe&&Ee<Oe;be++,Ee++){const xe=ne.charCodeAt(be),Ze=ge.charCodeAt(Ee);if(xe<Ze)return-1;if(xe>Ze)return 1}const Ne=pe-be,Je=Oe-Ee;return Ne<Je?-1:Ne>Je?1:0}e.$ef=R;function I(ne,ge){return E(ne,ge,0,ne.length,0,ge.length)}e.$ff=I;function E(ne,ge,be=0,pe=ne.length,Ee=0,Oe=ge.length){for(;be<pe&&Ee<Oe;be++,Ee++){let xe=ne.charCodeAt(be),Ze=ge.charCodeAt(Ee);if(xe===Ze)continue;if(xe>=128||Ze>=128)return R(ne.toLowerCase(),ge.toLowerCase(),be,pe,Ee,Oe);j(xe)&&(xe-=32),j(Ze)&&(Ze-=32);const Qe=xe-Ze;if(Qe!==0)return Qe}const Ne=pe-be,Je=Oe-Ee;return Ne<Je?-1:Ne>Je?1:0}e.$gf=E;function A(ne){return ne>=48&&ne<=57}e.$hf=A;function j(ne){return ne>=97&&ne<=122}e.$if=j;function T(ne){return ne>=65&&ne<=90}e.$jf=T;function W(ne,ge){return ne.length===ge.length&&E(ne,ge)===0}e.$kf=W;function V(ne,ge){const be=ge.length;return ge.length>ne.length?!1:E(ne,ge,0,be)===0}e.$lf=V;function K(ne,ge){const be=Math.min(ne.length,ge.length);let pe;for(pe=0;pe<be;pe++)if(ne.charCodeAt(pe)!==ge.charCodeAt(pe))return pe;return be}e.$mf=K;function le(ne,ge){const be=Math.min(ne.length,ge.length);let pe;const Ee=ne.length-1,Oe=ge.length-1;for(pe=0;pe<be;pe++)if(ne.charCodeAt(Ee-pe)!==ge.charCodeAt(Oe-pe))return pe;return be}e.$nf=le;function re(ne){return 55296<=ne&&ne<=56319}e.$of=re;function ue(ne){return 56320<=ne&&ne<=57343}e.$pf=ue;function Z(ne,ge){return(ne-55296<<10)+(ge-56320)+65536}e.$qf=Z;function Y(ne,ge,be){const pe=ne.charCodeAt(be);if(re(pe)&&be+1<ge){const Ee=ne.charCodeAt(be+1);if(ue(Ee))return Z(pe,Ee)}return pe}e.$rf=Y;function U(ne,ge){const be=ne.charCodeAt(ge-1);if(ue(be)&&ge>1){const pe=ne.charCodeAt(ge-2);if(re(pe))return Z(pe,be)}return be}class L{get offset(){return this.e}constructor(ge,be=0){this.c=ge,this.d=ge.length,this.e=be}setOffset(ge){this.e=ge}prevCodePoint(){const ge=U(this.c,this.e);return this.e-=ge>=65536?2:1,ge}nextCodePoint(){const ge=Y(this.c,this.d,this.e);return this.e+=ge>=65536?2:1,ge}eol(){return this.e>=this.d}}e.$sf=L;class N{get offset(){return this.c.offset}constructor(ge,be=0){this.c=new L(ge,be)}nextGraphemeLength(){const ge=De.getInstance(),be=this.c,pe=be.offset;let Ee=ge.getGraphemeBreakType(be.nextCodePoint());for(;!be.eol();){const Oe=be.offset,Ne=ge.getGraphemeBreakType(be.nextCodePoint());if($e(Ee,Ne)){be.setOffset(Oe);break}Ee=Ne}return be.offset-pe}prevGraphemeLength(){const ge=De.getInstance(),be=this.c,pe=be.offset;let Ee=ge.getGraphemeBreakType(be.prevCodePoint());for(;be.offset>0;){const Oe=be.offset,Ne=ge.getGraphemeBreakType(be.prevCodePoint());if($e(Ne,Ee)){be.setOffset(Oe);break}Ee=Ne}return pe-be.offset}eol(){return this.c.eol()}}e.$tf=N;function G(ne,ge){return new N(ne,ge).nextGraphemeLength()}e.$uf=G;function q(ne,ge){return new N(ne,ge).prevGraphemeLength()}e.$vf=q;function oe(ne,ge){ge>0&&ue(ne.charCodeAt(ge))&&ge--;const be=ge+G(ne,ge);return[be-q(ne,be),be]}e.$wf=oe;function he(ne){const ge=new N(ne);let be=0;for(;!ge.eol();)be++,ge.nextGraphemeLength();return be}e.$xf=he;let J;function O(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function F(ne){return J||(J=O()),J.test(ne)}e.$yf=F;const x=/^[\t\n\r\x20-\x7E]*$/;function z(ne){return x.test(ne)}e.$zf=z,e.$Af=/[\u2028\u2029]/;function Q(ne){return e.$Af.test(ne)}e.$Bf=Q;function H(ne){return ne>=11904&&ne<=55215||ne>=63744&&ne<=64255||ne>=65281&&ne<=65374}e.$Cf=H;function _(ne){return ne>=127462&&ne<=127487||ne===8986||ne===8987||ne===9200||ne===9203||ne>=9728&&ne<=10175||ne===11088||ne===11093||ne>=127744&&ne<=128591||ne>=128640&&ne<=128764||ne>=128992&&ne<=129008||ne>=129280&&ne<=129535||ne>=129648&&ne<=129782}e.$Df=_;function B(ne,ge,be=""){const pe=ne.trimStart();if(pe.length<ge)return pe;const Ee=/\b/g;let Oe=0;for(;Ee.test(pe)&&!(pe.length-Ee.lastIndex<ge);)Oe=Ee.lastIndex,Ee.lastIndex+=1;return Oe===0?pe:be+pe.substring(Oe).trimStart()}e.$Ef=B;const te=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,ie=/\x1b\].*?\x07/g;function de(ne){return ne&&(ne=ne.replace(te,"").replace(ie,"")),ne}e.$Ff=de,e.$Gf="\uFEFF";function me(ne){return!!(ne&&ne.length>0&&ne.charCodeAt(0)===65279)}e.$Hf=me;function ke(ne){return me(ne)?ne.substr(1):ne}e.$If=ke;function Se(ne,ge){if(!ne||!ge||ne.length<ge.length)return!1;const be=ge.length,pe=ne.toLowerCase();let Ee=0,Oe=-1;for(;Ee<be;){const Ne=pe.indexOf(ge[Ee],Oe+1);if(Ne<0)return!1;Oe=Ne,Ee++}return!0}e.$Jf=Se;function Me(ne,ge=!1){return ne?(ge&&(ne=ne.replace(/\\./g,"")),ne.toLowerCase()!==ne):!1}e.$Kf=Me;function He(ne){return ne.charAt(0).toUpperCase()+ne.slice(1)}e.$Lf=He;function ye(ne,ge=1){if(ge===0)return"";let be=-1;do be=ne.indexOf(`
`,be+1),ge--;while(ge>0&&be>=0);return be===-1?ne:(ne[be-1]==="\r"&&be--,ne.substr(0,be))}e.$Mf=ye;function ee(ne){return ne=ne%(2*26),ne<26?String.fromCharCode(97+ne):String.fromCharCode(65+ne-26)}e.$Nf=ee;function fe(ne){return De.getInstance().getGraphemeBreakType(ne)}e.$Of=fe;function $e(ne,ge){return ne===0?ge!==5&&ge!==7:ne===2&&ge===3?!1:ne===4||ne===2||ne===3||ge===4||ge===2||ge===3?!0:!(ne===8&&(ge===8||ge===9||ge===11||ge===12)||(ne===11||ne===9)&&(ge===9||ge===10)||(ne===12||ne===10)&&ge===10||ge===5||ge===13||ge===7||ne===1||ne===13&&ge===14||ne===6&&ge===6)}var Pe;(function(ne){ne[ne.Other=0]="Other",ne[ne.Prepend=1]="Prepend",ne[ne.CR=2]="CR",ne[ne.LF=3]="LF",ne[ne.Control=4]="Control",ne[ne.Extend=5]="Extend",ne[ne.Regional_Indicator=6]="Regional_Indicator",ne[ne.SpacingMark=7]="SpacingMark",ne[ne.L=8]="L",ne[ne.V=9]="V",ne[ne.T=10]="T",ne[ne.LV=11]="LV",ne[ne.LVT=12]="LVT",ne[ne.ZWJ=13]="ZWJ",ne[ne.Extended_Pictographic=14]="Extended_Pictographic"})(Pe||(e.GraphemeBreakType=Pe={}));class De{static{this.c=null}static getInstance(){return De.c||(De.c=new De),De.c}constructor(){this.d=qe()}getGraphemeBreakType(ge){if(ge<32)return ge===10?3:ge===13?2:4;if(ge<127)return 0;const be=this.d,pe=be.length/3;let Ee=1;for(;Ee<=pe;)if(ge<be[3*Ee])Ee=2*Ee;else if(ge>be[3*Ee+1])Ee=2*Ee+1;else return be[3*Ee+2];return 0}}function qe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function je(ne,ge){if(ne===0)return 0;const be=Fe(ne,ge);if(be!==void 0)return be;const pe=new L(ge,ne);return pe.prevCodePoint(),pe.offset}e.$Pf=je;function Fe(ne,ge){const be=new L(ge,ne);let pe=be.prevCodePoint();for(;Ue(pe)||pe===65039||pe===8419;){if(be.offset===0)return;pe=be.prevCodePoint()}if(!_(pe))return;let Ee=be.offset;return Ee>0&&be.prevCodePoint()===8205&&(Ee=be.offset),Ee}function Ue(ne){return 127995<=ne&&ne<=127999}var Ge;(function(ne){ne[ne.zwj=8205]="zwj",ne[ne.emojiVariantSelector=65039]="emojiVariantSelector",ne[ne.enclosingKeyCap=8419]="enclosingKeyCap"})(Ge||(Ge={})),e.$Qf="\xA0";class Xe{static{this.c=new D.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new n.$Pe(ge=>{function be(Qe){const st=new Map;for(let tt=0;tt<Qe.length;tt+=2)st.set(Qe[tt],Qe[tt+1]);return st}function pe(Qe,st){const tt=new Map(Qe);for(const[ot,at]of st)tt.set(ot,at);return tt}function Ee(Qe,st){if(!Qe)return st;const tt=new Map;for(const[ot,at]of Qe)st.has(ot)&&tt.set(ot,at);return tt}const Oe=this.c.value;let Ne=ge.filter(Qe=>!Qe.startsWith("_")&&Qe in Oe);Ne.length===0&&(Ne=["_default"]);let Je;for(const Qe of Ne){const st=be(Oe[Qe]);Je=Ee(Je,st)}const xe=be(Oe._common),Ze=pe(xe,Je);return new Xe(Ze)})}static getInstance(ge){return Xe.d.get(Array.from(ge))}static{this.e=new D.$V(()=>Object.keys(Xe.c.value).filter(ge=>!ge.startsWith("_")))}static getLocales(){return Xe.e.value}constructor(ge){this.f=ge}isAmbiguous(ge){return this.f.has(ge)}getPrimaryConfusable(ge){return this.f.get(ge)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$Rf=Xe;class Te{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Te.c())),this.d}static isInvisibleCharacter(ge){return Te.e().has(ge)}static get codePoints(){return Te.e()}}e.$Sf=Te}),define(ae[45],ce([0,1,25]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=e.$7i=void 0;function D(u){return S(u,0)}e.$7i=D;function S(u,f){switch(typeof u){case"object":return u===null?M(349,f):Array.isArray(u)?d(u,f):c(u,f);case"string":return P(u,f);case"boolean":return C(u,f);case"number":return M(u,f);case"undefined":return M(937,f);default:return M(617,f)}}e.$8i=S;function M(u,f){return(f<<5)-f+u|0}e.$9i=M;function C(u,f){return M(u?433:863,f)}function P(u,f){f=M(149417,f);for(let h=0,$=u.length;h<$;h++)f=M(u.charCodeAt(h),f);return f}e.$0i=P;function d(u,f){return f=M(104579,f),u.reduce((h,$)=>S($,h),f)}function c(u,f){return f=M(181387,f),Object.keys(u).sort().reduce((h,$)=>(h=P($,h),S(u[$],h)),f)}class y{constructor(){this.g=0}get value(){return this.g}hash(f){return this.g=S(f,this.g),this.g}}e.$$i=y;var v;(function(u){u[u.BLOCK_SIZE=64]="BLOCK_SIZE",u[u.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(v||(v={}));function k(u,f,h=32){const $=h-f,a=~((1<<$)-1);return(u<<f|(a&u)>>>$)>>>0}function g(u,f=0,h=u.byteLength,$=0){for(let a=0;a<h;a++)u[f+a]=$}function m(u,f,h="0"){for(;u.length<f;)u=h+u;return u}function w(u,f=32){return u instanceof ArrayBuffer?Array.from(new Uint8Array(u)).map(h=>h.toString(16).padStart(2,"0")).join(""):m((u>>>0).toString(16),f/4)}e.$_i=w;class p{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(f){const h=f.length;if(h===0)return;const $=this.p;let a=this.r,t=this.u,o,r;for(t!==0?(o=t,r=-1,t=0):(o=f.charCodeAt(0),r=0);;){let i=o;if(n.$of(o))if(r+1<h){const s=f.charCodeAt(r+1);n.$pf(s)?(r++,i=n.$qf(o,s)):i=65533}else{t=o;break}else n.$pf(o)&&(i=65533);if(a=this.w($,a,i),r++,r<h)o=f.charCodeAt(r);else break}this.r=a,this.u=t}w(f,h,$){return $<128?f[h++]=$:$<2048?(f[h++]=192|($&1984)>>>6,f[h++]=128|($&63)>>>0):$<65536?(f[h++]=224|($&61440)>>>12,f[h++]=128|($&4032)>>>6,f[h++]=128|($&63)>>>0):(f[h++]=240|($&1835008)>>>18,f[h++]=128|($&258048)>>>12,f[h++]=128|($&4032)>>>6,f[h++]=128|($&63)>>>0),h>=64&&(this.y(),h-=64,this.t+=64,f[0]=f[64],f[1]=f[65],f[2]=f[66]),h}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),w(this.h)+w(this.l)+w(this.m)+w(this.n)+w(this.o)}x(){this.p[this.r++]=128,g(this.p,this.r),this.r>56&&(this.y(),g(this.p));const f=8*this.t;this.q.setUint32(56,Math.floor(f/4294967296),!1),this.q.setUint32(60,f%4294967296,!1),this.y()}y(){const f=p.g,h=this.q;for(let b=0;b<64;b+=4)f.setUint32(b,h.getUint32(b,!1),!1);for(let b=64;b<320;b+=4)f.setUint32(b,k(f.getUint32(b-12,!1)^f.getUint32(b-32,!1)^f.getUint32(b-56,!1)^f.getUint32(b-64,!1),1),!1);let $=this.h,a=this.l,t=this.m,o=this.n,r=this.o,i,s,l;for(let b=0;b<80;b++)b<20?(i=a&t|~a&o,s=1518500249):b<40?(i=a^t^o,s=1859775393):b<60?(i=a&t|a&o|t&o,s=2400959708):(i=a^t^o,s=3395469782),l=k($,5)+i+r+s+f.getUint32(b*4,!1)&4294967295,r=o,o=t,t=k(a,30),a=$,$=l;this.h=this.h+$&4294967295,this.l=this.l+a&4294967295,this.m=this.m+t&4294967295,this.n=this.n+o&4294967295,this.o=this.o+r&4294967295}}e.$aj=p}),define(ae[73],ce([0,1,25]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var D;(function(S){S[S.Ignore=0]="Ignore",S[S.Info=1]="Info",S[S.Warning=2]="Warning",S[S.Error=3]="Error"})(D||(D={})),function(S){const M="error",C="warning",P="warn",d="info",c="ignore";function y(k){return k?n.$kf(M,k)?S.Error:n.$kf(C,k)||n.$kf(P,k)?S.Warning:n.$kf(d,k)?S.Info:S.Ignore:S.Ignore}S.fromValue=y;function v(k){switch(k){case S.Error:return M;case S.Warning:return C;case S.Info:return d;default:return c}}S.toString=v}(D||(D={})),e.default=D}),define(ae[144],ce([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3d=void 0,e.$3d=Symbol("MicrotaskDelay")}),define(ae[59],ce([0,1,22,25]),function(X,e,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mi=e.$li=e.$ki=e.$ji=e.$ii=void 0;class S{constructor(){this.b="",this.c=0}reset(g){return this.b=g,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(g){const m=g.charCodeAt(0),w=this.b.charCodeAt(this.c);return m-w}value(){return this.b[this.c]}}e.$ii=S;class M{constructor(g=!0){this.e=g}reset(g){return this.b=g,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let g=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(g)this.c++;else break;else g=!1;return this}cmp(g){return this.e?(0,D.$ef)(g,this.b,0,g.length,this.c,this.d):(0,D.$gf)(g,this.b,0,g.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$ji=M;class C{constructor(g=!0,m=!0){this.f=g,this.g=m}reset(g){this.d=0,this.e=0,this.b=g,this.c=g.length;for(let m=g.length-1;m>=0;m--,this.c--){const w=this.b.charCodeAt(m);if(!(w===47||this.f&&w===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let g=!0;for(;this.e<this.c;this.e++){const m=this.b.charCodeAt(this.e);if(m===47||this.f&&m===92)if(g)this.d++;else break;else g=!1}return this}cmp(g){return this.g?(0,D.$ef)(g,this.b,0,g.length,this.d,this.e):(0,D.$gf)(g,this.b,0,g.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$ki=C;var P;(function(k){k[k.Scheme=1]="Scheme",k[k.Authority=2]="Authority",k[k.Path=3]="Path",k[k.Query=4]="Query",k[k.Fragment=5]="Fragment"})(P||(P={}));class d{constructor(g,m){this.f=g,this.g=m,this.d=[],this.e=0}reset(g){return this.c=g,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new C(!1,!this.f(g)),this.b.reset(g.path),this.b.value()&&this.d.push(3)),this.g(g)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(g){if(this.d[this.e]===1)return(0,D.$ff)(g,this.c.scheme);if(this.d[this.e]===2)return(0,D.$ff)(g,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(g);if(this.d[this.e]===4)return(0,D.$df)(g,this.c.query);if(this.d[this.e]===5)return(0,D.$df)(g,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$li=d;class c{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const g=this.right;return this.right=g.left,g.left=this,this.updateHeight(),g.updateHeight(),g}rotateRight(){const g=this.left;return this.left=g.right,g.right=this,this.updateHeight(),g.updateHeight(),g}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var y;(function(k){k[k.Left=-1]="Left",k[k.Mid=0]="Mid",k[k.Right=1]="Right"})(y||(y={}));class v{static forUris(g=()=>!1,m=()=>!1){return new v(new d(g,m))}static forPaths(g=!1){return new v(new C(void 0,!g))}static forStrings(){return new v(new S)}static forConfigKeys(){return new v(new M)}constructor(g){this.b=g}clear(){this.c=void 0}fill(g,m){if(m){const w=m.slice(0);(0,n.$Xb)(w);for(const p of w)this.set(p,g)}else{const w=g.slice(0);(0,n.$Xb)(w);for(const p of w)this.set(p[0],p[1])}}set(g,m){const w=this.b.reset(g);let p;this.c||(this.c=new c,this.c.segment=w.value());const u=[];for(p=this.c;;){const h=w.cmp(p.segment);if(h>0)p.left||(p.left=new c,p.left.segment=w.value()),u.push([-1,p]),p=p.left;else if(h<0)p.right||(p.right=new c,p.right.segment=w.value()),u.push([1,p]),p=p.right;else if(w.hasNext())w.next(),p.mid||(p.mid=new c,p.mid.segment=w.value()),u.push([0,p]),p=p.mid;else break}const f=p.value;p.value=m,p.key=g;for(let h=u.length-1;h>=0;h--){const $=u[h][1];$.updateHeight();const a=$.balanceFactor();if(a<-1||a>1){const t=u[h][0],o=u[h+1][0];if(t===1&&o===1)u[h][1]=$.rotateLeft();else if(t===-1&&o===-1)u[h][1]=$.rotateRight();else if(t===1&&o===-1)$.right=u[h+1][1]=u[h+1][1].rotateRight(),u[h][1]=$.rotateLeft();else if(t===-1&&o===1)$.left=u[h+1][1]=u[h+1][1].rotateLeft(),u[h][1]=$.rotateRight();else throw new Error;if(h>0)switch(u[h-1][0]){case-1:u[h-1][1].left=u[h][1];break;case 1:u[h-1][1].right=u[h][1];break;case 0:u[h-1][1].mid=u[h][1];break}else this.c=u[0][1]}}return f}get(g){return this.d(g)?.value}d(g){const m=this.b.reset(g);let w=this.c;for(;w;){const p=m.cmp(w.segment);if(p>0)w=w.left;else if(p<0)w=w.right;else if(m.hasNext())m.next(),w=w.mid;else break}return w}has(g){const m=this.d(g);return!(m?.value===void 0&&m?.mid===void 0)}delete(g){return this.e(g,!1)}deleteSuperstr(g){return this.e(g,!0)}e(g,m){const w=this.b.reset(g),p=[];let u=this.c;for(;u;){const f=w.cmp(u.segment);if(f>0)p.push([-1,u]),u=u.left;else if(f<0)p.push([1,u]),u=u.right;else if(w.hasNext())w.next(),p.push([0,u]),u=u.mid;else break}if(u){if(m?(u.left=void 0,u.mid=void 0,u.right=void 0,u.height=1):(u.key=void 0,u.value=void 0),!u.mid&&!u.value)if(u.left&&u.right){const f=this.f(u.right);if(f.key){const{key:h,value:$,segment:a}=f;this.e(f.key,!1),u.key=h,u.value=$,u.segment=a}}else{const f=u.left??u.right;if(p.length>0){const[h,$]=p[p.length-1];switch(h){case-1:$.left=f;break;case 0:$.mid=f;break;case 1:$.right=f;break}}else this.c=f}for(let f=p.length-1;f>=0;f--){const h=p[f][1];h.updateHeight();const $=h.balanceFactor();if($>1?(h.right.balanceFactor()>=0||(h.right=h.right.rotateRight()),p[f][1]=h.rotateLeft()):$<-1&&(h.left.balanceFactor()<=0||(h.left=h.left.rotateLeft()),p[f][1]=h.rotateRight()),f>0)switch(p[f-1][0]){case-1:p[f-1][1].left=p[f][1];break;case 1:p[f-1][1].right=p[f][1];break;case 0:p[f-1][1].mid=p[f][1];break}else this.c=p[0][1]}}}f(g){for(;g.left;)g=g.left;return g}findSubstr(g){const m=this.b.reset(g);let w=this.c,p;for(;w;){const u=m.cmp(w.segment);if(u>0)w=w.left;else if(u<0)w=w.right;else if(m.hasNext())m.next(),p=w.value||p,w=w.mid;else break}return w&&w.value||p}findSuperstr(g){return this.g(g,!1)}g(g,m){const w=this.b.reset(g);let p=this.c;for(;p;){const u=w.cmp(p.segment);if(u>0)p=p.left;else if(u<0)p=p.right;else if(w.hasNext())w.next(),p=p.mid;else return p.mid?this.h(p.mid):m?p.value:void 0}}hasElementOrSubtree(g){return this.g(g,!0)!==void 0}forEach(g){for(const[m,w]of this)g(w,m)}*[Symbol.iterator](){yield*this.h(this.c)}h(g){const m=[];return this.j(g,m),m[Symbol.iterator]()}j(g,m){g&&(g.left&&this.j(g.left,m),g.value&&m.push([g.key,g.value]),g.mid&&this.j(g.mid,m),g.right&&this.j(g.right,m))}_isBalanced(){const g=m=>{if(!m)return!0;const w=m.balanceFactor();return w<-1||w>1?!1:g(m.left)&&g(m.right)};return g(this.c)}}e.$mi=v}),define(ae[12],ce([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=void 0;function n(a){return typeof a=="string"}e.$Tf=n;function D(a){return Array.isArray(a)&&a.every(t=>n(t))}e.$Uf=D;function S(a){return typeof a=="object"&&a!==null&&!Array.isArray(a)&&!(a instanceof RegExp)&&!(a instanceof Date)}e.$Vf=S;function M(a){const t=Object.getPrototypeOf(Uint8Array);return typeof a=="object"&&a instanceof t}e.$Wf=M;function C(a){return typeof a=="number"&&!isNaN(a)}e.$Xf=C;function P(a){return!!a&&typeof a[Symbol.iterator]=="function"}e.$Yf=P;function d(a){return a===!0||a===!1}e.$Zf=d;function c(a){return typeof a>"u"}e.$1f=c;function y(a){return!v(a)}e.$2f=y;function v(a){return c(a)||a===null}e.$3f=v;function k(a,t){if(!a)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.$4f=k;function g(a){if(v(a))throw new Error("Assertion Failed: argument is undefined or null");return a}e.$5f=g;function m(...a){const t=[];for(let o=0;o<a.length;o++){const r=a[o];if(v(r))throw new Error(`Assertion Failed: argument at index ${o} is undefined or null`);t.push(r)}return t}e.$6f=m;const w=Object.prototype.hasOwnProperty;function p(a){if(!S(a))return!1;for(const t in a)if(w.call(a,t))return!1;return!0}e.$7f=p;function u(a){return typeof a=="function"}e.$8f=u;function f(...a){return a.length>0&&a.every(u)}e.$9f=f;function h(a,t){const o=Math.min(a.length,t.length);for(let r=0;r<o;r++)$(a[r],t[r])}e.$0f=h;function $(a,t){if(n(t)){if(typeof a!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(u(t)){try{if(a instanceof t)return}catch{}if(!v(a)&&a.constructor===t||t.length===1&&t.call(void 0,a)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$$f=$}),define(ae[105],ce([0,1,12]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lk=e.$kk=void 0;const D=Object.create(null);function S(C,P){if((0,n.$Tf)(P)){const d=D[P];if(d===void 0)throw new Error(`${C} references an unknown codicon: ${P}`);P=d}return D[C]=P,{id:C}}e.$kk=S;function M(){return D}e.$lk=M}),define(ae[145],ce([0,1,105]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mk=void 0,e.$mk={add:(0,n.$kk)("add",6e4),plus:(0,n.$kk)("plus",6e4),gistNew:(0,n.$kk)("gist-new",6e4),repoCreate:(0,n.$kk)("repo-create",6e4),lightbulb:(0,n.$kk)("lightbulb",60001),lightBulb:(0,n.$kk)("light-bulb",60001),repo:(0,n.$kk)("repo",60002),repoDelete:(0,n.$kk)("repo-delete",60002),gistFork:(0,n.$kk)("gist-fork",60003),repoForked:(0,n.$kk)("repo-forked",60003),gitPullRequest:(0,n.$kk)("git-pull-request",60004),gitPullRequestAbandoned:(0,n.$kk)("git-pull-request-abandoned",60004),recordKeys:(0,n.$kk)("record-keys",60005),keyboard:(0,n.$kk)("keyboard",60005),tag:(0,n.$kk)("tag",60006),tagAdd:(0,n.$kk)("tag-add",60006),tagRemove:(0,n.$kk)("tag-remove",60006),gitPullRequestLabel:(0,n.$kk)("git-pull-request-label",60006),person:(0,n.$kk)("person",60007),personFollow:(0,n.$kk)("person-follow",60007),personOutline:(0,n.$kk)("person-outline",60007),personFilled:(0,n.$kk)("person-filled",60007),gitBranch:(0,n.$kk)("git-branch",60008),gitBranchCreate:(0,n.$kk)("git-branch-create",60008),gitBranchDelete:(0,n.$kk)("git-branch-delete",60008),sourceControl:(0,n.$kk)("source-control",60008),mirror:(0,n.$kk)("mirror",60009),mirrorPublic:(0,n.$kk)("mirror-public",60009),star:(0,n.$kk)("star",60010),starAdd:(0,n.$kk)("star-add",60010),starDelete:(0,n.$kk)("star-delete",60010),starEmpty:(0,n.$kk)("star-empty",60010),comment:(0,n.$kk)("comment",60011),commentAdd:(0,n.$kk)("comment-add",60011),alert:(0,n.$kk)("alert",60012),warning:(0,n.$kk)("warning",60012),search:(0,n.$kk)("search",60013),searchSave:(0,n.$kk)("search-save",60013),logOut:(0,n.$kk)("log-out",60014),signOut:(0,n.$kk)("sign-out",60014),logIn:(0,n.$kk)("log-in",60015),signIn:(0,n.$kk)("sign-in",60015),eye:(0,n.$kk)("eye",60016),eyeUnwatch:(0,n.$kk)("eye-unwatch",60016),eyeWatch:(0,n.$kk)("eye-watch",60016),circleFilled:(0,n.$kk)("circle-filled",60017),primitiveDot:(0,n.$kk)("primitive-dot",60017),closeDirty:(0,n.$kk)("close-dirty",60017),debugBreakpoint:(0,n.$kk)("debug-breakpoint",60017),debugBreakpointDisabled:(0,n.$kk)("debug-breakpoint-disabled",60017),debugBreakpointPending:(0,n.$kk)("debug-breakpoint-pending",60377),debugHint:(0,n.$kk)("debug-hint",60017),primitiveSquare:(0,n.$kk)("primitive-square",60018),edit:(0,n.$kk)("edit",60019),pencil:(0,n.$kk)("pencil",60019),info:(0,n.$kk)("info",60020),issueOpened:(0,n.$kk)("issue-opened",60020),gistPrivate:(0,n.$kk)("gist-private",60021),gitForkPrivate:(0,n.$kk)("git-fork-private",60021),lock:(0,n.$kk)("lock",60021),mirrorPrivate:(0,n.$kk)("mirror-private",60021),close:(0,n.$kk)("close",60022),removeClose:(0,n.$kk)("remove-close",60022),x:(0,n.$kk)("x",60022),repoSync:(0,n.$kk)("repo-sync",60023),sync:(0,n.$kk)("sync",60023),clone:(0,n.$kk)("clone",60024),desktopDownload:(0,n.$kk)("desktop-download",60024),beaker:(0,n.$kk)("beaker",60025),microscope:(0,n.$kk)("microscope",60025),vm:(0,n.$kk)("vm",60026),deviceDesktop:(0,n.$kk)("device-desktop",60026),file:(0,n.$kk)("file",60027),fileText:(0,n.$kk)("file-text",60027),more:(0,n.$kk)("more",60028),ellipsis:(0,n.$kk)("ellipsis",60028),kebabHorizontal:(0,n.$kk)("kebab-horizontal",60028),mailReply:(0,n.$kk)("mail-reply",60029),reply:(0,n.$kk)("reply",60029),organization:(0,n.$kk)("organization",60030),organizationFilled:(0,n.$kk)("organization-filled",60030),organizationOutline:(0,n.$kk)("organization-outline",60030),newFile:(0,n.$kk)("new-file",60031),fileAdd:(0,n.$kk)("file-add",60031),newFolder:(0,n.$kk)("new-folder",60032),fileDirectoryCreate:(0,n.$kk)("file-directory-create",60032),trash:(0,n.$kk)("trash",60033),trashcan:(0,n.$kk)("trashcan",60033),history:(0,n.$kk)("history",60034),clock:(0,n.$kk)("clock",60034),folder:(0,n.$kk)("folder",60035),fileDirectory:(0,n.$kk)("file-directory",60035),symbolFolder:(0,n.$kk)("symbol-folder",60035),logoGithub:(0,n.$kk)("logo-github",60036),markGithub:(0,n.$kk)("mark-github",60036),github:(0,n.$kk)("github",60036),terminal:(0,n.$kk)("terminal",60037),console:(0,n.$kk)("console",60037),repl:(0,n.$kk)("repl",60037),zap:(0,n.$kk)("zap",60038),symbolEvent:(0,n.$kk)("symbol-event",60038),error:(0,n.$kk)("error",60039),stop:(0,n.$kk)("stop",60039),variable:(0,n.$kk)("variable",60040),symbolVariable:(0,n.$kk)("symbol-variable",60040),array:(0,n.$kk)("array",60042),symbolArray:(0,n.$kk)("symbol-array",60042),symbolModule:(0,n.$kk)("symbol-module",60043),symbolPackage:(0,n.$kk)("symbol-package",60043),symbolNamespace:(0,n.$kk)("symbol-namespace",60043),symbolObject:(0,n.$kk)("symbol-object",60043),symbolMethod:(0,n.$kk)("symbol-method",60044),symbolFunction:(0,n.$kk)("symbol-function",60044),symbolConstructor:(0,n.$kk)("symbol-constructor",60044),symbolBoolean:(0,n.$kk)("symbol-boolean",60047),symbolNull:(0,n.$kk)("symbol-null",60047),symbolNumeric:(0,n.$kk)("symbol-numeric",60048),symbolNumber:(0,n.$kk)("symbol-number",60048),symbolStructure:(0,n.$kk)("symbol-structure",60049),symbolStruct:(0,n.$kk)("symbol-struct",60049),symbolParameter:(0,n.$kk)("symbol-parameter",60050),symbolTypeParameter:(0,n.$kk)("symbol-type-parameter",60050),symbolKey:(0,n.$kk)("symbol-key",60051),symbolText:(0,n.$kk)("symbol-text",60051),symbolReference:(0,n.$kk)("symbol-reference",60052),goToFile:(0,n.$kk)("go-to-file",60052),symbolEnum:(0,n.$kk)("symbol-enum",60053),symbolValue:(0,n.$kk)("symbol-value",60053),symbolRuler:(0,n.$kk)("symbol-ruler",60054),symbolUnit:(0,n.$kk)("symbol-unit",60054),activateBreakpoints:(0,n.$kk)("activate-breakpoints",60055),archive:(0,n.$kk)("archive",60056),arrowBoth:(0,n.$kk)("arrow-both",60057),arrowDown:(0,n.$kk)("arrow-down",60058),arrowLeft:(0,n.$kk)("arrow-left",60059),arrowRight:(0,n.$kk)("arrow-right",60060),arrowSmallDown:(0,n.$kk)("arrow-small-down",60061),arrowSmallLeft:(0,n.$kk)("arrow-small-left",60062),arrowSmallRight:(0,n.$kk)("arrow-small-right",60063),arrowSmallUp:(0,n.$kk)("arrow-small-up",60064),arrowUp:(0,n.$kk)("arrow-up",60065),bell:(0,n.$kk)("bell",60066),bold:(0,n.$kk)("bold",60067),book:(0,n.$kk)("book",60068),bookmark:(0,n.$kk)("bookmark",60069),debugBreakpointConditionalUnverified:(0,n.$kk)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,n.$kk)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,n.$kk)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,n.$kk)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,n.$kk)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,n.$kk)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,n.$kk)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,n.$kk)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,n.$kk)("debug-breakpoint-log-disabled",60075),briefcase:(0,n.$kk)("briefcase",60076),broadcast:(0,n.$kk)("broadcast",60077),browser:(0,n.$kk)("browser",60078),bug:(0,n.$kk)("bug",60079),calendar:(0,n.$kk)("calendar",60080),caseSensitive:(0,n.$kk)("case-sensitive",60081),check:(0,n.$kk)("check",60082),checklist:(0,n.$kk)("checklist",60083),chevronDown:(0,n.$kk)("chevron-down",60084),dropDownButton:(0,n.$kk)("drop-down-button",60084),chevronLeft:(0,n.$kk)("chevron-left",60085),chevronRight:(0,n.$kk)("chevron-right",60086),chevronUp:(0,n.$kk)("chevron-up",60087),chromeClose:(0,n.$kk)("chrome-close",60088),chromeMaximize:(0,n.$kk)("chrome-maximize",60089),chromeMinimize:(0,n.$kk)("chrome-minimize",60090),chromeRestore:(0,n.$kk)("chrome-restore",60091),circle:(0,n.$kk)("circle",60092),circleOutline:(0,n.$kk)("circle-outline",60092),debugBreakpointUnverified:(0,n.$kk)("debug-breakpoint-unverified",60092),circleSlash:(0,n.$kk)("circle-slash",60093),circuitBoard:(0,n.$kk)("circuit-board",60094),clearAll:(0,n.$kk)("clear-all",60095),clippy:(0,n.$kk)("clippy",60096),closeAll:(0,n.$kk)("close-all",60097),cloudDownload:(0,n.$kk)("cloud-download",60098),cloudUpload:(0,n.$kk)("cloud-upload",60099),code:(0,n.$kk)("code",60100),collapseAll:(0,n.$kk)("collapse-all",60101),colorMode:(0,n.$kk)("color-mode",60102),commentDiscussion:(0,n.$kk)("comment-discussion",60103),compareChanges:(0,n.$kk)("compare-changes",60157),creditCard:(0,n.$kk)("credit-card",60105),dash:(0,n.$kk)("dash",60108),dashboard:(0,n.$kk)("dashboard",60109),database:(0,n.$kk)("database",60110),debugContinue:(0,n.$kk)("debug-continue",60111),debugDisconnect:(0,n.$kk)("debug-disconnect",60112),debugPause:(0,n.$kk)("debug-pause",60113),debugRestart:(0,n.$kk)("debug-restart",60114),debugStart:(0,n.$kk)("debug-start",60115),debugStepInto:(0,n.$kk)("debug-step-into",60116),debugStepOut:(0,n.$kk)("debug-step-out",60117),debugStepOver:(0,n.$kk)("debug-step-over",60118),debugStop:(0,n.$kk)("debug-stop",60119),debug:(0,n.$kk)("debug",60120),deviceCameraVideo:(0,n.$kk)("device-camera-video",60121),deviceCamera:(0,n.$kk)("device-camera",60122),deviceMobile:(0,n.$kk)("device-mobile",60123),diffAdded:(0,n.$kk)("diff-added",60124),diffIgnored:(0,n.$kk)("diff-ignored",60125),diffModified:(0,n.$kk)("diff-modified",60126),diffRemoved:(0,n.$kk)("diff-removed",60127),diffRenamed:(0,n.$kk)("diff-renamed",60128),diff:(0,n.$kk)("diff",60129),discard:(0,n.$kk)("discard",60130),editorLayout:(0,n.$kk)("editor-layout",60131),emptyWindow:(0,n.$kk)("empty-window",60132),exclude:(0,n.$kk)("exclude",60133),extensions:(0,n.$kk)("extensions",60134),eyeClosed:(0,n.$kk)("eye-closed",60135),fileBinary:(0,n.$kk)("file-binary",60136),fileCode:(0,n.$kk)("file-code",60137),fileMedia:(0,n.$kk)("file-media",60138),filePdf:(0,n.$kk)("file-pdf",60139),fileSubmodule:(0,n.$kk)("file-submodule",60140),fileSymlinkDirectory:(0,n.$kk)("file-symlink-directory",60141),fileSymlinkFile:(0,n.$kk)("file-symlink-file",60142),fileZip:(0,n.$kk)("file-zip",60143),files:(0,n.$kk)("files",60144),filter:(0,n.$kk)("filter",60145),flame:(0,n.$kk)("flame",60146),foldDown:(0,n.$kk)("fold-down",60147),foldUp:(0,n.$kk)("fold-up",60148),fold:(0,n.$kk)("fold",60149),folderActive:(0,n.$kk)("folder-active",60150),folderOpened:(0,n.$kk)("folder-opened",60151),gear:(0,n.$kk)("gear",60152),gift:(0,n.$kk)("gift",60153),gistSecret:(0,n.$kk)("gist-secret",60154),gist:(0,n.$kk)("gist",60155),gitCommit:(0,n.$kk)("git-commit",60156),gitCompare:(0,n.$kk)("git-compare",60157),gitMerge:(0,n.$kk)("git-merge",60158),githubAction:(0,n.$kk)("github-action",60159),githubAlt:(0,n.$kk)("github-alt",60160),globe:(0,n.$kk)("globe",60161),grabber:(0,n.$kk)("grabber",60162),graph:(0,n.$kk)("graph",60163),gripper:(0,n.$kk)("gripper",60164),heart:(0,n.$kk)("heart",60165),home:(0,n.$kk)("home",60166),horizontalRule:(0,n.$kk)("horizontal-rule",60167),hubot:(0,n.$kk)("hubot",60168),inbox:(0,n.$kk)("inbox",60169),issueClosed:(0,n.$kk)("issue-closed",60324),issueReopened:(0,n.$kk)("issue-reopened",60171),issues:(0,n.$kk)("issues",60172),italic:(0,n.$kk)("italic",60173),jersey:(0,n.$kk)("jersey",60174),json:(0,n.$kk)("json",60175),bracket:(0,n.$kk)("bracket",60175),kebabVertical:(0,n.$kk)("kebab-vertical",60176),key:(0,n.$kk)("key",60177),law:(0,n.$kk)("law",60178),lightbulbAutofix:(0,n.$kk)("lightbulb-autofix",60179),linkExternal:(0,n.$kk)("link-external",60180),link:(0,n.$kk)("link",60181),listOrdered:(0,n.$kk)("list-ordered",60182),listUnordered:(0,n.$kk)("list-unordered",60183),liveShare:(0,n.$kk)("live-share",60184),loading:(0,n.$kk)("loading",60185),location:(0,n.$kk)("location",60186),mailRead:(0,n.$kk)("mail-read",60187),mail:(0,n.$kk)("mail",60188),markdown:(0,n.$kk)("markdown",60189),megaphone:(0,n.$kk)("megaphone",60190),mention:(0,n.$kk)("mention",60191),milestone:(0,n.$kk)("milestone",60192),gitPullRequestMilestone:(0,n.$kk)("git-pull-request-milestone",60192),mortarBoard:(0,n.$kk)("mortar-board",60193),move:(0,n.$kk)("move",60194),multipleWindows:(0,n.$kk)("multiple-windows",60195),mute:(0,n.$kk)("mute",60196),noNewline:(0,n.$kk)("no-newline",60197),note:(0,n.$kk)("note",60198),octoface:(0,n.$kk)("octoface",60199),openPreview:(0,n.$kk)("open-preview",60200),package:(0,n.$kk)("package",60201),paintcan:(0,n.$kk)("paintcan",60202),pin:(0,n.$kk)("pin",60203),play:(0,n.$kk)("play",60204),run:(0,n.$kk)("run",60204),plug:(0,n.$kk)("plug",60205),preserveCase:(0,n.$kk)("preserve-case",60206),preview:(0,n.$kk)("preview",60207),project:(0,n.$kk)("project",60208),pulse:(0,n.$kk)("pulse",60209),question:(0,n.$kk)("question",60210),quote:(0,n.$kk)("quote",60211),radioTower:(0,n.$kk)("radio-tower",60212),reactions:(0,n.$kk)("reactions",60213),references:(0,n.$kk)("references",60214),refresh:(0,n.$kk)("refresh",60215),regex:(0,n.$kk)("regex",60216),remoteExplorer:(0,n.$kk)("remote-explorer",60217),remote:(0,n.$kk)("remote",60218),remove:(0,n.$kk)("remove",60219),replaceAll:(0,n.$kk)("replace-all",60220),replace:(0,n.$kk)("replace",60221),repoClone:(0,n.$kk)("repo-clone",60222),repoForcePush:(0,n.$kk)("repo-force-push",60223),repoPull:(0,n.$kk)("repo-pull",60224),repoPush:(0,n.$kk)("repo-push",60225),report:(0,n.$kk)("report",60226),requestChanges:(0,n.$kk)("request-changes",60227),rocket:(0,n.$kk)("rocket",60228),rootFolderOpened:(0,n.$kk)("root-folder-opened",60229),rootFolder:(0,n.$kk)("root-folder",60230),rss:(0,n.$kk)("rss",60231),ruby:(0,n.$kk)("ruby",60232),saveAll:(0,n.$kk)("save-all",60233),saveAs:(0,n.$kk)("save-as",60234),save:(0,n.$kk)("save",60235),screenFull:(0,n.$kk)("screen-full",60236),screenNormal:(0,n.$kk)("screen-normal",60237),searchStop:(0,n.$kk)("search-stop",60238),server:(0,n.$kk)("server",60240),settingsGear:(0,n.$kk)("settings-gear",60241),settings:(0,n.$kk)("settings",60242),shield:(0,n.$kk)("shield",60243),smiley:(0,n.$kk)("smiley",60244),sortPrecedence:(0,n.$kk)("sort-precedence",60245),splitHorizontal:(0,n.$kk)("split-horizontal",60246),splitVertical:(0,n.$kk)("split-vertical",60247),squirrel:(0,n.$kk)("squirrel",60248),starFull:(0,n.$kk)("star-full",60249),starHalf:(0,n.$kk)("star-half",60250),symbolClass:(0,n.$kk)("symbol-class",60251),symbolColor:(0,n.$kk)("symbol-color",60252),symbolCustomColor:(0,n.$kk)("symbol-customcolor",60252),symbolConstant:(0,n.$kk)("symbol-constant",60253),symbolEnumMember:(0,n.$kk)("symbol-enum-member",60254),symbolField:(0,n.$kk)("symbol-field",60255),symbolFile:(0,n.$kk)("symbol-file",60256),symbolInterface:(0,n.$kk)("symbol-interface",60257),symbolKeyword:(0,n.$kk)("symbol-keyword",60258),symbolMisc:(0,n.$kk)("symbol-misc",60259),symbolOperator:(0,n.$kk)("symbol-operator",60260),symbolProperty:(0,n.$kk)("symbol-property",60261),wrench:(0,n.$kk)("wrench",60261),wrenchSubaction:(0,n.$kk)("wrench-subaction",60261),symbolSnippet:(0,n.$kk)("symbol-snippet",60262),tasklist:(0,n.$kk)("tasklist",60263),telescope:(0,n.$kk)("telescope",60264),textSize:(0,n.$kk)("text-size",60265),threeBars:(0,n.$kk)("three-bars",60266),thumbsdown:(0,n.$kk)("thumbsdown",60267),thumbsup:(0,n.$kk)("thumbsup",60268),tools:(0,n.$kk)("tools",60269),triangleDown:(0,n.$kk)("triangle-down",60270),triangleLeft:(0,n.$kk)("triangle-left",60271),triangleRight:(0,n.$kk)("triangle-right",60272),triangleUp:(0,n.$kk)("triangle-up",60273),twitter:(0,n.$kk)("twitter",60274),unfold:(0,n.$kk)("unfold",60275),unlock:(0,n.$kk)("unlock",60276),unmute:(0,n.$kk)("unmute",60277),unverified:(0,n.$kk)("unverified",60278),verified:(0,n.$kk)("verified",60279),versions:(0,n.$kk)("versions",60280),vmActive:(0,n.$kk)("vm-active",60281),vmOutline:(0,n.$kk)("vm-outline",60282),vmRunning:(0,n.$kk)("vm-running",60283),watch:(0,n.$kk)("watch",60284),whitespace:(0,n.$kk)("whitespace",60285),wholeWord:(0,n.$kk)("whole-word",60286),window:(0,n.$kk)("window",60287),wordWrap:(0,n.$kk)("word-wrap",60288),zoomIn:(0,n.$kk)("zoom-in",60289),zoomOut:(0,n.$kk)("zoom-out",60290),listFilter:(0,n.$kk)("list-filter",60291),listFlat:(0,n.$kk)("list-flat",60292),listSelection:(0,n.$kk)("list-selection",60293),selection:(0,n.$kk)("selection",60293),listTree:(0,n.$kk)("list-tree",60294),debugBreakpointFunctionUnverified:(0,n.$kk)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,n.$kk)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,n.$kk)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,n.$kk)("debug-stackframe-active",60297),circleSmallFilled:(0,n.$kk)("circle-small-filled",60298),debugStackframeDot:(0,n.$kk)("debug-stackframe-dot",60298),debugStackframe:(0,n.$kk)("debug-stackframe",60299),debugStackframeFocused:(0,n.$kk)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,n.$kk)("debug-breakpoint-unsupported",60300),symbolString:(0,n.$kk)("symbol-string",60301),debugReverseContinue:(0,n.$kk)("debug-reverse-continue",60302),debugStepBack:(0,n.$kk)("debug-step-back",60303),debugRestartFrame:(0,n.$kk)("debug-restart-frame",60304),callIncoming:(0,n.$kk)("call-incoming",60306),callOutgoing:(0,n.$kk)("call-outgoing",60307),menu:(0,n.$kk)("menu",60308),expandAll:(0,n.$kk)("expand-all",60309),feedback:(0,n.$kk)("feedback",60310),gitPullRequestReviewer:(0,n.$kk)("git-pull-request-reviewer",60310),groupByRefType:(0,n.$kk)("group-by-ref-type",60311),ungroupByRefType:(0,n.$kk)("ungroup-by-ref-type",60312),account:(0,n.$kk)("account",60313),gitPullRequestAssignee:(0,n.$kk)("git-pull-request-assignee",60313),bellDot:(0,n.$kk)("bell-dot",60314),debugConsole:(0,n.$kk)("debug-console",60315),library:(0,n.$kk)("library",60316),output:(0,n.$kk)("output",60317),runAll:(0,n.$kk)("run-all",60318),syncIgnored:(0,n.$kk)("sync-ignored",60319),pinned:(0,n.$kk)("pinned",60320),githubInverted:(0,n.$kk)("github-inverted",60321),debugAlt:(0,n.$kk)("debug-alt",60305),serverProcess:(0,n.$kk)("server-process",60322),serverEnvironment:(0,n.$kk)("server-environment",60323),pass:(0,n.$kk)("pass",60324),stopCircle:(0,n.$kk)("stop-circle",60325),playCircle:(0,n.$kk)("play-circle",60326),record:(0,n.$kk)("record",60327),debugAltSmall:(0,n.$kk)("debug-alt-small",60328),vmConnect:(0,n.$kk)("vm-connect",60329),cloud:(0,n.$kk)("cloud",60330),merge:(0,n.$kk)("merge",60331),exportIcon:(0,n.$kk)("export",60332),graphLeft:(0,n.$kk)("graph-left",60333),magnet:(0,n.$kk)("magnet",60334),notebook:(0,n.$kk)("notebook",60335),redo:(0,n.$kk)("redo",60336),checkAll:(0,n.$kk)("check-all",60337),pinnedDirty:(0,n.$kk)("pinned-dirty",60338),passFilled:(0,n.$kk)("pass-filled",60339),circleLargeFilled:(0,n.$kk)("circle-large-filled",60340),circleLarge:(0,n.$kk)("circle-large",60341),circleLargeOutline:(0,n.$kk)("circle-large-outline",60341),combine:(0,n.$kk)("combine",60342),gather:(0,n.$kk)("gather",60342),table:(0,n.$kk)("table",60343),variableGroup:(0,n.$kk)("variable-group",60344),typeHierarchy:(0,n.$kk)("type-hierarchy",60345),typeHierarchySub:(0,n.$kk)("type-hierarchy-sub",60346),typeHierarchySuper:(0,n.$kk)("type-hierarchy-super",60347),gitPullRequestCreate:(0,n.$kk)("git-pull-request-create",60348),runAbove:(0,n.$kk)("run-above",60349),runBelow:(0,n.$kk)("run-below",60350),notebookTemplate:(0,n.$kk)("notebook-template",60351),debugRerun:(0,n.$kk)("debug-rerun",60352),workspaceTrusted:(0,n.$kk)("workspace-trusted",60353),workspaceUntrusted:(0,n.$kk)("workspace-untrusted",60354),workspaceUnspecified:(0,n.$kk)("workspace-unspecified",60355),terminalCmd:(0,n.$kk)("terminal-cmd",60356),terminalDebian:(0,n.$kk)("terminal-debian",60357),terminalLinux:(0,n.$kk)("terminal-linux",60358),terminalPowershell:(0,n.$kk)("terminal-powershell",60359),terminalTmux:(0,n.$kk)("terminal-tmux",60360),terminalUbuntu:(0,n.$kk)("terminal-ubuntu",60361),terminalBash:(0,n.$kk)("terminal-bash",60362),arrowSwap:(0,n.$kk)("arrow-swap",60363),copy:(0,n.$kk)("copy",60364),personAdd:(0,n.$kk)("person-add",60365),filterFilled:(0,n.$kk)("filter-filled",60366),wand:(0,n.$kk)("wand",60367),debugLineByLine:(0,n.$kk)("debug-line-by-line",60368),inspect:(0,n.$kk)("inspect",60369),layers:(0,n.$kk)("layers",60370),layersDot:(0,n.$kk)("layers-dot",60371),layersActive:(0,n.$kk)("layers-active",60372),compass:(0,n.$kk)("compass",60373),compassDot:(0,n.$kk)("compass-dot",60374),compassActive:(0,n.$kk)("compass-active",60375),azure:(0,n.$kk)("azure",60376),issueDraft:(0,n.$kk)("issue-draft",60377),gitPullRequestClosed:(0,n.$kk)("git-pull-request-closed",60378),gitPullRequestDraft:(0,n.$kk)("git-pull-request-draft",60379),debugAll:(0,n.$kk)("debug-all",60380),debugCoverage:(0,n.$kk)("debug-coverage",60381),runErrors:(0,n.$kk)("run-errors",60382),folderLibrary:(0,n.$kk)("folder-library",60383),debugContinueSmall:(0,n.$kk)("debug-continue-small",60384),beakerStop:(0,n.$kk)("beaker-stop",60385),graphLine:(0,n.$kk)("graph-line",60386),graphScatter:(0,n.$kk)("graph-scatter",60387),pieChart:(0,n.$kk)("pie-chart",60388),bracketDot:(0,n.$kk)("bracket-dot",60389),bracketError:(0,n.$kk)("bracket-error",60390),lockSmall:(0,n.$kk)("lock-small",60391),azureDevops:(0,n.$kk)("azure-devops",60392),verifiedFilled:(0,n.$kk)("verified-filled",60393),newLine:(0,n.$kk)("newline",60394),layout:(0,n.$kk)("layout",60395),layoutActivitybarLeft:(0,n.$kk)("layout-activitybar-left",60396),layoutActivitybarRight:(0,n.$kk)("layout-activitybar-right",60397),layoutPanelLeft:(0,n.$kk)("layout-panel-left",60398),layoutPanelCenter:(0,n.$kk)("layout-panel-center",60399),layoutPanelJustify:(0,n.$kk)("layout-panel-justify",60400),layoutPanelRight:(0,n.$kk)("layout-panel-right",60401),layoutPanel:(0,n.$kk)("layout-panel",60402),layoutSidebarLeft:(0,n.$kk)("layout-sidebar-left",60403),layoutSidebarRight:(0,n.$kk)("layout-sidebar-right",60404),layoutStatusbar:(0,n.$kk)("layout-statusbar",60405),layoutMenubar:(0,n.$kk)("layout-menubar",60406),layoutCentered:(0,n.$kk)("layout-centered",60407),layoutSidebarRightOff:(0,n.$kk)("layout-sidebar-right-off",60416),layoutPanelOff:(0,n.$kk)("layout-panel-off",60417),layoutSidebarLeftOff:(0,n.$kk)("layout-sidebar-left-off",60418),target:(0,n.$kk)("target",60408),indent:(0,n.$kk)("indent",60409),recordSmall:(0,n.$kk)("record-small",60410),errorSmall:(0,n.$kk)("error-small",60411),arrowCircleDown:(0,n.$kk)("arrow-circle-down",60412),arrowCircleLeft:(0,n.$kk)("arrow-circle-left",60413),arrowCircleRight:(0,n.$kk)("arrow-circle-right",60414),arrowCircleUp:(0,n.$kk)("arrow-circle-up",60415),heartFilled:(0,n.$kk)("heart-filled",60420),map:(0,n.$kk)("map",60421),mapFilled:(0,n.$kk)("map-filled",60422),circleSmall:(0,n.$kk)("circle-small",60423),bellSlash:(0,n.$kk)("bell-slash",60424),bellSlashDot:(0,n.$kk)("bell-slash-dot",60425),commentUnresolved:(0,n.$kk)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,n.$kk)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,n.$kk)("git-pull-request-new-changes",60428),searchFuzzy:(0,n.$kk)("search-fuzzy",60429),commentDraft:(0,n.$kk)("comment-draft",60430),send:(0,n.$kk)("send",60431),sparkle:(0,n.$kk)("sparkle",60432),insert:(0,n.$kk)("insert",60433),mic:(0,n.$kk)("mic",60434),thumbsDownFilled:(0,n.$kk)("thumbsdown-filled",60435),thumbsUpFilled:(0,n.$kk)("thumbsup-filled",60436),coffee:(0,n.$kk)("coffee",60437),snake:(0,n.$kk)("snake",60438),game:(0,n.$kk)("game",60439),vr:(0,n.$kk)("vr",60440),chip:(0,n.$kk)("chip",60441),piano:(0,n.$kk)("piano",60442),music:(0,n.$kk)("music",60443),micFilled:(0,n.$kk)("mic-filled",60444),gitFetch:(0,n.$kk)("git-fetch",60445),copilot:(0,n.$kk)("copilot",60446),lightbulbSparkle:(0,n.$kk)("lightbulb-sparkle",60447),lightbulbSparkleAutofix:(0,n.$kk)("lightbulb-sparkle-autofix",60447),robot:(0,n.$kk)("robot",60448),sparkleFilled:(0,n.$kk)("sparkle-filled",60449),diffSingle:(0,n.$kk)("diff-single",60450),diffMultiple:(0,n.$kk)("diff-multiple",60451),surroundWith:(0,n.$kk)("surround-with",60452),gitStash:(0,n.$kk)("git-stash",60454),gitStashApply:(0,n.$kk)("git-stash-apply",60455),gitStashPop:(0,n.$kk)("git-stash-pop",60456),runAllCoverage:(0,n.$kk)("run-all-coverage",60461),runCoverage:(0,n.$kk)("run-all-coverage",60460),coverage:(0,n.$kk)("coverage",60462),githubProject:(0,n.$kk)("github-project",60463)}}),define(ae[74],ce([0,1,105,145]),function(X,e,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pk=e.$ok=e.$nk=void 0;function S(){return Object.values(e.$pk)}e.$nk=S,e.$ok={dialogError:(0,n.$kk)("dialog-error","error"),dialogWarning:(0,n.$kk)("dialog-warning","warning"),dialogInfo:(0,n.$kk)("dialog-info","info"),dialogClose:(0,n.$kk)("dialog-close","close"),treeItemExpanded:(0,n.$kk)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,n.$kk)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,n.$kk)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,n.$kk)("tree-filter-clear","close"),treeItemLoading:(0,n.$kk)("tree-item-loading","loading"),menuSelection:(0,n.$kk)("menu-selection","check"),menuSubmenu:(0,n.$kk)("menu-submenu","chevron-right"),menuBarMore:(0,n.$kk)("menubar-more","more"),scrollbarButtonLeft:(0,n.$kk)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,n.$kk)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,n.$kk)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,n.$kk)("scrollbar-button-down","triangle-down"),toolBarMore:(0,n.$kk)("toolbar-more","more"),quickInputBack:(0,n.$kk)("quick-input-back","arrow-left")},e.$pk={...D.$mk,...e.$ok}}),define(ae[35],ce([0,1,12]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wn=e.$Vn=e.$Un=e.$Tn=e.$Sn=e.$Rn=e.$Qn=e.$Pn=e.$On=e.$Nn=e.$Mn=e.$Ln=void 0;function D(u){if(!u||typeof u!="object"||u instanceof RegExp)return u;const f=Array.isArray(u)?[]:{};return Object.entries(u).forEach(([h,$])=>{f[h]=$&&typeof $=="object"?D($):$}),f}e.$Ln=D;function S(u){if(!u||typeof u!="object")return u;const f=[u];for(;f.length>0;){const h=f.shift();Object.freeze(h);for(const $ in h)if(M.call(h,$)){const a=h[$];typeof a=="object"&&!Object.isFrozen(a)&&!(0,n.$Wf)(a)&&f.push(a)}}return u}e.$Mn=S;const M=Object.prototype.hasOwnProperty;function C(u,f){return P(u,f,new Set)}e.$Nn=C;function P(u,f,h){if((0,n.$3f)(u))return u;const $=f(u);if(typeof $<"u")return $;if(Array.isArray(u)){const a=[];for(const t of u)a.push(P(t,f,h));return a}if((0,n.$Vf)(u)){if(h.has(u))throw new Error("Cannot clone recursive data-structure");h.add(u);const a={};for(const t in u)M.call(u,t)&&(a[t]=P(u[t],f,h));return h.delete(u),a}return u}function d(u,f,h=!0){return(0,n.$Vf)(u)?((0,n.$Vf)(f)&&Object.keys(f).forEach($=>{$ in u?h&&((0,n.$Vf)(u[$])&&(0,n.$Vf)(f[$])?d(u[$],f[$],h):u[$]=f[$]):u[$]=f[$]}),u):f}e.$On=d;function c(u,f){if(u===f)return!0;if(u==null||f===null||f===void 0||typeof u!=typeof f||typeof u!="object"||Array.isArray(u)!==Array.isArray(f))return!1;let h,$;if(Array.isArray(u)){if(u.length!==f.length)return!1;for(h=0;h<u.length;h++)if(!c(u[h],f[h]))return!1}else{const a=[];for($ in u)a.push($);a.sort();const t=[];for($ in f)t.push($);if(t.sort(),!c(a,t))return!1;for(h=0;h<a.length;h++)if(!c(u[a[h]],f[a[h]]))return!1}return!0}e.$Pn=c;function y(u){const f=new Set;return JSON.stringify(u,(h,$)=>{if((0,n.$Vf)($)||Array.isArray($)){if(f.has($))return"[Circular]";f.add($)}return $})}e.$Qn=y;function v(u,f){const h=Object.create(null);return!u||!f||Object.keys(f).forEach(a=>{const t=u[a],o=f[a];c(t,o)||(h[a]=o)}),h}e.$Rn=v;function k(u,f){const h=f.toLowerCase(),$=Object.keys(u).find(a=>a.toLowerCase()===h);return $?u[$]:u[f]}e.$Sn=k;function g(u,f){const h=Object.create(null);for(const[$,a]of Object.entries(u))f($,a)&&(h[$]=a);return h}e.$Tn=g;function m(u){let f=[];for(;Object.prototype!==u;)f=f.concat(Object.getOwnPropertyNames(u)),u=Object.getPrototypeOf(u);return f}e.$Un=m;function w(u){const f=[];for(const h of m(u))typeof u[h]=="function"&&f.push(h);return f}e.$Vn=w;function p(u,f){const h=a=>function(){const t=Array.prototype.slice.call(arguments,0);return f(a,t)},$={};for(const a of u)$[a]=h(a);return $}e.$Wn=p}),define(ae[106],ce([0,1,74]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$qk=e.ThemeColor=void 0;var D;(function(C){function P(d){return d&&typeof d=="object"&&typeof d.id=="string"}C.isThemeColor=P})(D||(e.ThemeColor=D={}));function S(C){return{id:C}}e.$qk=S;var M;(function(C){C.iconNameSegment="[A-Za-z0-9]+",C.iconNameExpression="[A-Za-z0-9-]+",C.iconModifierExpression="~[A-Za-z]+",C.iconNameCharacter="[A-Za-z0-9~-]";const P=new RegExp(`^(${C.iconNameExpression})(${C.iconModifierExpression})?$`);function d(f){const h=P.exec(f.id);if(!h)return d(n.$pk.error);const[,$,a]=h,t=["codicon","codicon-"+$];return a&&t.push("codicon-modifier-"+a.substring(1)),t}C.asClassNameArray=d;function c(f){return d(f).join(" ")}C.asClassName=c;function y(f){return"."+d(f).join(".")}C.asCSSSelector=y;function v(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(typeof f.color>"u"||D.isThemeColor(f.color))}C.isThemeIcon=v;const k=new RegExp(`^\\$\\((${C.iconNameExpression}(?:${C.iconModifierExpression})?)\\)$`);function g(f){const h=k.exec(f);if(!h)return;const[,$]=h;return{id:$}}C.fromString=g;function m(f){return{id:f}}C.fromId=m;function w(f,h){let $=f.id;const a=$.lastIndexOf("~");return a!==-1&&($=$.substring(0,a)),h&&($=`${$}~${h}`),{id:$}}C.modify=w;function p(f){const h=f.id.lastIndexOf("~");if(h!==-1)return f.id.substring(h+1)}C.getModifier=p;function u(f,h){return f.id===h.id&&f.color?.id===h.color?.id}C.isEqual=u})(M||(e.ThemeIcon=M={}))}),define(ae[32],ce([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cg=e.$Bg=void 0;const n=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function D(S){return n.test(S)}e.$Bg=D,e.$Cg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let S;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?S=crypto.getRandomValues.bind(crypto):S=function(P){for(let d=0;d<P.length;d++)P[d]=Math.floor(Math.random()*256);return P};const M=new Uint8Array(16),C=[];for(let P=0;P<256;P++)C.push(P.toString(16).padStart(2,"0"));return function(){S(M),M[6]=M[6]&15|64,M[8]=M[8]&63|128;let d=0,c="";return c+=C[M[d++]],c+=C[M[d++]],c+=C[M[d++]],c+=C[M[d++]],c+="-",c+=C[M[d++]],c+=C[M[d++]],c+="-",c+=C[M[d++]],c+=C[M[d++]],c+="-",c+=C[M[d++]],c+=C[M[d++]],c+="-",c+=C[M[d++]],c+=C[M[d++]],c+=C[M[d++]],c+=C[M[d++]],c+=C[M[d++]],c+=C[M[d++]],c}}()}),define(ae[146],ce([0,1,87,46,85]),function(X,e,n,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MV=void 0;async function M(C,P){if(await new Promise((y,v)=>{const k=D.createReadStream(C),g=n.createHash("sha256");k.pipe(g);const m=(0,S.$db)((w,p)=>{k.removeAllListeners(),g.removeAllListeners(),w?v(w):y(p)});k.once("error",m),k.once("end",m),g.once("error",m),g.once("data",w=>m(void 0,w.toString("hex")))})!==P)throw new Error("Hash mismatch")}e.$MV=M}),define(ae[147],ce([0,1,26]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mn=void 0;const D=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function S(C){const P=C.replace(/\-/g,":").toLowerCase();return!D.has(P)}function M(){const C=(0,n.networkInterfaces)();for(const P in C){const d=C[P];if(d){for(const{mac:c}of d)if(S(c))return c}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.$mn=M}),define(ae[107],ce([0,1,88]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gg=e.$Fg=e.$Eg=void 0;function D(P,d,c,y=1){let v=!1;return new Promise(k=>{const g=setTimeout(()=>{if(!v)return v=!0,k(0)},c);S(P,d,y,m=>{if(!v)return v=!0,clearTimeout(g),k(m)})})}e.$Eg=D;function S(P,d,c,y){if(d===0)return y(0);const v=new n.Socket;v.once("connect",()=>(C(v),S(P+c,d-1,c,y))),v.once("data",()=>{}),v.once("error",k=>(C(v),k.code!=="ECONNREFUSED"?S(P+c,d-1,c,y):y(P))),v.connect(P,"127.0.0.1")}e.$Fg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function M(P,d,c,y="127.0.0.1"){let v=!1,k,g=1;const m=n.createServer({pauseOnConnect:!0});function w(p,u){v||(v=!0,m.removeAllListeners(),m.close(),k&&clearTimeout(k),u(p))}return new Promise(p=>{k=setTimeout(()=>{w(0,p)},c),m.on("listening",()=>{w(P,p)}),m.on("error",u=>{u&&(u.code==="EADDRINUSE"||u.code==="EACCES")&&g<d?(P++,g++,m.listen(P,y)):w(0,p)}),m.on("close",()=>{w(0,p)}),m.listen(P,y)})}e.$Gg=M;function C(P){try{P.removeAllListeners("connect"),P.removeAllListeners("error"),P.end(),P.destroy(),P.unref()}catch(d){console.error(d)}}}),function(){function X(){function e(){return process.uncHostAllowlist}function n(d){const c=new Set;if(Array.isArray(d))for(const y of d)typeof y=="string"&&c.add(y);return Array.from(c)}function D(){const d=e();return d?Array.from(d):[]}function S(d){if(process.platform!=="win32")return;const c=e();if(c)if(typeof d=="string")c.add(d.toLowerCase());else for(const y of n(d))S(y)}function M(d){if(typeof d!="string")return;const c=["\\\\.\\UNC\\","\\\\?\\UNC\\","\\\\"];let y;for(const v of c){if(d.indexOf(v)!==0)continue;const g=d.indexOf("\\",v.length);if(g===-1)continue;const m=d.substring(v.length,g);if(m){y=m;break}}return y}function C(){process.platform==="win32"&&(process.restrictUNCAccess=!1)}function P(){return process.platform!=="win32"?!0:process.restrictUNCAccess===!1}return{getUNCHostAllowlist:D,addUNCHostToAllowlist:S,getUNCHost:M,disableUNCAccessRestrictions:C,isUNCAccessRestrictionsDisabled:P}}typeof define=="function"?define("vs/base/node/unc",[],function(){return X()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=X():console.trace("vs/base/node/unc defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(ae[148],ce([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QV=e.$PV=void 0,e.$PV="vscode:contextmenu",e.$QV="vscode:onCloseContextMenu"}),define(ae[149],ce([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XV=void 0;class n{constructor(S,M){this.a=S,this.onMessage=M}send(S){try{this.a.send("vscode:message",S.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}e.$XV=n}),define(ae[150],ce([11,10]),function(X,e){return X.create("vs/base/common/date",e)}),define(ae[151],ce([0,1,150]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mm=e.$Lm=e.$Km=void 0;const D=60,S=D*60,M=S*24,C=M*7,P=M*30,d=M*365;function c(k,g,m,w){typeof k!="number"&&(k=k.getTime());const p=Math.round((new Date().getTime()-k)/1e3);if(p<-30)return(0,n.localize)(0,null,c(new Date().getTime()+p*1e3,!1));if(!w&&p<30)return(0,n.localize)(1,null);let u;return p<D?(u=p,g?u===1?m?(0,n.localize)(2,null,u):(0,n.localize)(3,null,u):m?(0,n.localize)(4,null,u):(0,n.localize)(5,null,u):u===1?m?(0,n.localize)(6,null,u):(0,n.localize)(7,null,u):m?(0,n.localize)(8,null,u):(0,n.localize)(9,null,u)):p<S?(u=Math.floor(p/D),g?u===1?m?(0,n.localize)(10,null,u):(0,n.localize)(11,null,u):m?(0,n.localize)(12,null,u):(0,n.localize)(13,null,u):u===1?m?(0,n.localize)(14,null,u):(0,n.localize)(15,null,u):m?(0,n.localize)(16,null,u):(0,n.localize)(17,null,u)):p<M?(u=Math.floor(p/S),g?u===1?m?(0,n.localize)(18,null,u):(0,n.localize)(19,null,u):m?(0,n.localize)(20,null,u):(0,n.localize)(21,null,u):u===1?m?(0,n.localize)(22,null,u):(0,n.localize)(23,null,u):m?(0,n.localize)(24,null,u):(0,n.localize)(25,null,u)):p<C?(u=Math.floor(p/M),g?u===1?(0,n.localize)(26,null,u):(0,n.localize)(27,null,u):u===1?(0,n.localize)(28,null,u):(0,n.localize)(29,null,u)):p<P?(u=Math.floor(p/C),g?u===1?m?(0,n.localize)(30,null,u):(0,n.localize)(31,null,u):m?(0,n.localize)(32,null,u):(0,n.localize)(33,null,u):u===1?m?(0,n.localize)(34,null,u):(0,n.localize)(35,null,u):m?(0,n.localize)(36,null,u):(0,n.localize)(37,null,u)):p<d?(u=Math.floor(p/P),g?u===1?m?(0,n.localize)(38,null,u):(0,n.localize)(39,null,u):m?(0,n.localize)(40,null,u):(0,n.localize)(41,null,u):u===1?m?(0,n.localize)(42,null,u):(0,n.localize)(43,null,u):m?(0,n.localize)(44,null,u):(0,n.localize)(45,null,u)):(u=Math.floor(p/d),g?u===1?m?(0,n.localize)(46,null,u):(0,n.localize)(47,null,u):m?(0,n.localize)(48,null,u):(0,n.localize)(49,null,u):u===1?m?(0,n.localize)(50,null,u):(0,n.localize)(51,null,u):m?(0,n.localize)(52,null,u):(0,n.localize)(53,null,u))}e.$Km=c;function y(k,g){const m=Math.abs(k/1e3);return m<1?g?(0,n.localize)(54,null,k):(0,n.localize)(55,null,k):m<D?g?(0,n.localize)(56,null,Math.round(k)/1e3):(0,n.localize)(57,null,Math.round(k)/1e3):m<S?g?(0,n.localize)(58,null,Math.round(k/(1e3*D))):(0,n.localize)(59,null,Math.round(k/(1e3*D))):m<M?g?(0,n.localize)(60,null,Math.round(k/(1e3*S))):(0,n.localize)(61,null,Math.round(k/(1e3*S))):(0,n.localize)(62,null,Math.round(k/(1e3*M)))}e.$Lm=y;function v(k){return k.getFullYear()+"-"+String(k.getMonth()+1).padStart(2,"0")+"-"+String(k.getDate()).padStart(2,"0")+"T"+String(k.getHours()).padStart(2,"0")+":"+String(k.getMinutes()).padStart(2,"0")+":"+String(k.getSeconds()).padStart(2,"0")+"."+(k.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$Mm=v}),define(ae[152],ce([11,10]),function(X,e){return X.create("vs/base/common/errorMessage",e)}),define(ae[51],ce([0,1,22,12,152]),function(X,e,n,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6i=e.$5i=e.$4i=void 0;function M(v,k){return k&&(v.stack||v.stacktrace)?S.localize(0,null,P(v),C(v.stack)||C(v.stacktrace)):P(v)}function C(v){return Array.isArray(v)?v.join(`
`):v}function P(v){return v.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${v.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof v.code=="string"&&typeof v.errno=="number"&&typeof v.syscall=="string"?S.localize(1,null,v.message):v.message||S.localize(2,null)}function d(v=null,k=!1){if(!v)return S.localize(3,null);if(Array.isArray(v)){const g=n.$Hb(v),m=d(g[0],k);return g.length>1?S.localize(4,null,m,g.length):m}if(D.$Tf(v))return v;if(v.detail){const g=v.detail;if(g.error)return M(g.error,k);if(g.exception)return M(g.exception,k)}return v.stack?M(v,k):v.message?v.message:S.localize(5,null)}e.$4i=d;function c(v){const k=v;return k instanceof Error&&Array.isArray(k.actions)}e.$5i=c;function y(v,k){let g;return typeof v=="string"?g=new Error(v):g=v,g.actions=k,g}e.$6i=y}),define(ae[153],ce([11,10]),function(X,e){return X.create("vs/base/common/jsonErrorMessages",e)}),define(ae[154],ce([0,1,153]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aq=void 0;function D(S){switch(S){case 1:return(0,n.localize)(0,null);case 2:return(0,n.localize)(1,null);case 3:return(0,n.localize)(2,null);case 4:return(0,n.localize)(3,null);case 5:return(0,n.localize)(4,null);case 6:return(0,n.localize)(5,null);case 7:return(0,n.localize)(6,null);case 8:return(0,n.localize)(7,null);case 9:return(0,n.localize)(8,null);default:return""}}e.$aq=D}),define(ae[155],ce([11,10]),function(X,e){return X.create("vs/base/common/platform",e)}),define(ae[4],ce([0,1,155]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J=e.$I=e.$H=e.$G=e.$F=e.$E=e.$D=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.Platform=e.$g=void 0,e.$g="en";let D=!1,S=!1,M=!1,C=!1,P=!1,d=!1,c=!1,y=!1,v=!1,k=!1,g,m=e.$g,w=e.$g,p,u;const f=globalThis;let h;typeof f.vscode<"u"&&typeof f.vscode.process<"u"?h=f.vscode.process:typeof process<"u"&&(h=process);const $=typeof h?.versions?.electron=="string",a=$&&h?.type==="renderer";if(typeof h=="object"){D=h.platform==="win32",S=h.platform==="darwin",M=h.platform==="linux",C=M&&!!h.env.SNAP&&!!h.env.SNAP_REVISION,c=$,v=!!h.env.CI||!!h.env.BUILD_ARTIFACTSTAGINGDIRECTORY,g=e.$g,m=e.$g;const E=h.env.VSCODE_NLS_CONFIG;if(E)try{const A=JSON.parse(E),j=A.availableLanguages["*"];g=A.locale,w=A.osLocale,m=j||e.$g,p=A._translationsConfigFile}catch{}P=!0}else typeof navigator=="object"&&!a?(u=navigator.userAgent,D=u.indexOf("Windows")>=0,S=u.indexOf("Macintosh")>=0,y=(u.indexOf("Macintosh")>=0||u.indexOf("iPad")>=0||u.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,M=u.indexOf("Linux")>=0,k=u?.indexOf("Mobi")>=0,d=!0,g=n.getConfiguredDefaultLocale(n.localize(0,null))||e.$g,m=g,w=navigator.language):console.error("Unable to resolve platform.");var t;(function(E){E[E.Web=0]="Web",E[E.Mac=1]="Mac",E[E.Linux=2]="Linux",E[E.Windows=3]="Windows"})(t||(e.Platform=t={}));function o(E){switch(E){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$h=o;let r=0;S?r=1:D?r=3:M&&(r=2),e.$i=D,e.$j=S,e.$k=M,e.$l=C,e.$m=P,e.$n=c,e.$o=d,e.$p=d&&typeof f.importScripts=="function",e.$q=e.$p?f.origin:void 0,e.$r=y,e.$s=k,e.$t=v,e.$u=r,e.$v=u,e.$w=m;var i;(function(E){function A(){return e.$w}E.value=A;function j(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}E.isDefaultVariant=j;function T(){return e.$w==="en"}E.isDefault=T})(i||(e.Language=i={})),e.$x=g,e.$y=w,e.$z=p,e.$A=typeof f.postMessage=="function"&&!f.importScripts,e.$B=(()=>{if(e.$A){const E=[];f.addEventListener("message",j=>{if(j.data&&j.data.vscodeScheduleAsyncWork)for(let T=0,W=E.length;T<W;T++){const V=E[T];if(V.id===j.data.vscodeScheduleAsyncWork){E.splice(T,1),V.callback();return}}});let A=0;return j=>{const T=++A;E.push({id:T,callback:j}),f.postMessage({vscodeScheduleAsyncWork:T},"*")}}return E=>setTimeout(E)})();var s;(function(E){E[E.Windows=1]="Windows",E[E.Macintosh=2]="Macintosh",E[E.Linux=3]="Linux"})(s||(e.OperatingSystem=s={})),e.OS=S||y?2:D?1:3;let l=!0,b=!1;function R(){if(!b){b=!0;const E=new Uint8Array(2);E[0]=1,E[1]=2,l=new Uint16Array(E.buffer)[0]===513}return l}e.$D=R,e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function I(E){return parseFloat(E)>=20}e.$J=I}),define(ae[36],ce([0,1,4]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=e.$dc=e.env=e.cwd=void 0;let D;const S=globalThis.vscode;if(typeof S<"u"&&typeof S.process<"u"){const M=S.process;D={get platform(){return M.platform},get arch(){return M.arch},get env(){return M.env},cwd(){return M.cwd()}}}else typeof process<"u"?D={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:D={get platform(){return n.$i?"win32":n.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=D.cwd,e.env=D.env,e.$dc=D.platform,e.$ec=D.arch}),define(ae[9],ce([0,1,36]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tc=e.sep=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=void 0;const D=65,S=97,M=90,C=122,P=46,d=47,c=92,y=58,v=63;class k extends Error{constructor(o,r,i){let s;typeof r=="string"&&r.indexOf("not ")===0?(s="must not be",r=r.replace(/^not /,"")):s="must be";const l=o.indexOf(".")!==-1?"property":"argument";let b=`The "${o}" ${l} ${s} of type ${r}`;b+=`. Received type ${typeof i}`,super(b),this.code="ERR_INVALID_ARG_TYPE"}}function g(t,o){if(t===null||typeof t!="object")throw new k(o,"Object",t)}function m(t,o){if(typeof t!="string")throw new k(o,"string",t)}const w=n.$dc==="win32";function p(t){return t===d||t===c}function u(t){return t===d}function f(t){return t>=D&&t<=M||t>=S&&t<=C}function h(t,o,r,i){let s="",l=0,b=-1,R=0,I=0;for(let E=0;E<=t.length;++E){if(E<t.length)I=t.charCodeAt(E);else{if(i(I))break;I=d}if(i(I)){if(!(b===E-1||R===1))if(R===2){if(s.length<2||l!==2||s.charCodeAt(s.length-1)!==P||s.charCodeAt(s.length-2)!==P){if(s.length>2){const A=s.lastIndexOf(r);A===-1?(s="",l=0):(s=s.slice(0,A),l=s.length-1-s.lastIndexOf(r)),b=E,R=0;continue}else if(s.length!==0){s="",l=0,b=E,R=0;continue}}o&&(s+=s.length>0?`${r}..`:"..",l=2)}else s.length>0?s+=`${r}${t.slice(b+1,E)}`:s=t.slice(b+1,E),l=E-b-1;b=E,R=0}else I===P&&R!==-1?++R:R=-1}return s}function $(t,o){g(o,"pathObject");const r=o.dir||o.root,i=o.base||`${o.name||""}${o.ext||""}`;return r?r===o.root?`${r}${i}`:`${r}${t}${i}`:i}e.$fc={resolve(...t){let o="",r="",i=!1;for(let s=t.length-1;s>=-1;s--){let l;if(s>=0){if(l=t[s],m(l,"path"),l.length===0)continue}else o.length===0?l=n.cwd():(l=n.env[`=${o}`]||n.cwd(),(l===void 0||l.slice(0,2).toLowerCase()!==o.toLowerCase()&&l.charCodeAt(2)===c)&&(l=`${o}\\`));const b=l.length;let R=0,I="",E=!1;const A=l.charCodeAt(0);if(b===1)p(A)&&(R=1,E=!0);else if(p(A))if(E=!0,p(l.charCodeAt(1))){let j=2,T=j;for(;j<b&&!p(l.charCodeAt(j));)j++;if(j<b&&j!==T){const W=l.slice(T,j);for(T=j;j<b&&p(l.charCodeAt(j));)j++;if(j<b&&j!==T){for(T=j;j<b&&!p(l.charCodeAt(j));)j++;(j===b||j!==T)&&(I=`\\\\${W}\\${l.slice(T,j)}`,R=j)}}}else R=1;else f(A)&&l.charCodeAt(1)===y&&(I=l.slice(0,2),R=2,b>2&&p(l.charCodeAt(2))&&(E=!0,R=3));if(I.length>0)if(o.length>0){if(I.toLowerCase()!==o.toLowerCase())continue}else o=I;if(i){if(o.length>0)break}else if(r=`${l.slice(R)}\\${r}`,i=E,E&&o.length>0)break}return r=h(r,!i,"\\",p),i?`${o}\\${r}`:`${o}${r}`||"."},normalize(t){m(t,"path");const o=t.length;if(o===0)return".";let r=0,i,s=!1;const l=t.charCodeAt(0);if(o===1)return u(l)?"\\":t;if(p(l))if(s=!0,p(t.charCodeAt(1))){let R=2,I=R;for(;R<o&&!p(t.charCodeAt(R));)R++;if(R<o&&R!==I){const E=t.slice(I,R);for(I=R;R<o&&p(t.charCodeAt(R));)R++;if(R<o&&R!==I){for(I=R;R<o&&!p(t.charCodeAt(R));)R++;if(R===o)return`\\\\${E}\\${t.slice(I)}\\`;R!==I&&(i=`\\\\${E}\\${t.slice(I,R)}`,r=R)}}}else r=1;else f(l)&&t.charCodeAt(1)===y&&(i=t.slice(0,2),r=2,o>2&&p(t.charCodeAt(2))&&(s=!0,r=3));let b=r<o?h(t.slice(r),!s,"\\",p):"";return b.length===0&&!s&&(b="."),b.length>0&&p(t.charCodeAt(o-1))&&(b+="\\"),i===void 0?s?`\\${b}`:b:s?`${i}\\${b}`:`${i}${b}`},isAbsolute(t){m(t,"path");const o=t.length;if(o===0)return!1;const r=t.charCodeAt(0);return p(r)||o>2&&f(r)&&t.charCodeAt(1)===y&&p(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let o,r;for(let l=0;l<t.length;++l){const b=t[l];m(b,"path"),b.length>0&&(o===void 0?o=r=b:o+=`\\${b}`)}if(o===void 0)return".";let i=!0,s=0;if(typeof r=="string"&&p(r.charCodeAt(0))){++s;const l=r.length;l>1&&p(r.charCodeAt(1))&&(++s,l>2&&(p(r.charCodeAt(2))?++s:i=!1))}if(i){for(;s<o.length&&p(o.charCodeAt(s));)s++;s>=2&&(o=`\\${o.slice(s)}`)}return e.$fc.normalize(o)},relative(t,o){if(m(t,"from"),m(o,"to"),t===o)return"";const r=e.$fc.resolve(t),i=e.$fc.resolve(o);if(r===i||(t=r.toLowerCase(),o=i.toLowerCase(),t===o))return"";let s=0;for(;s<t.length&&t.charCodeAt(s)===c;)s++;let l=t.length;for(;l-1>s&&t.charCodeAt(l-1)===c;)l--;const b=l-s;let R=0;for(;R<o.length&&o.charCodeAt(R)===c;)R++;let I=o.length;for(;I-1>R&&o.charCodeAt(I-1)===c;)I--;const E=I-R,A=b<E?b:E;let j=-1,T=0;for(;T<A;T++){const V=t.charCodeAt(s+T);if(V!==o.charCodeAt(R+T))break;V===c&&(j=T)}if(T!==A){if(j===-1)return i}else{if(E>A){if(o.charCodeAt(R+T)===c)return i.slice(R+T+1);if(T===2)return i.slice(R+T)}b>A&&(t.charCodeAt(s+T)===c?j=T:T===2&&(j=3)),j===-1&&(j=0)}let W="";for(T=s+j+1;T<=l;++T)(T===l||t.charCodeAt(T)===c)&&(W+=W.length===0?"..":"\\..");return R+=j,W.length>0?`${W}${i.slice(R,I)}`:(i.charCodeAt(R)===c&&++R,i.slice(R,I))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const o=e.$fc.resolve(t);if(o.length<=2)return t;if(o.charCodeAt(0)===c){if(o.charCodeAt(1)===c){const r=o.charCodeAt(2);if(r!==v&&r!==P)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(f(o.charCodeAt(0))&&o.charCodeAt(1)===y&&o.charCodeAt(2)===c)return`\\\\?\\${o}`;return t},dirname(t){m(t,"path");const o=t.length;if(o===0)return".";let r=-1,i=0;const s=t.charCodeAt(0);if(o===1)return p(s)?t:".";if(p(s)){if(r=i=1,p(t.charCodeAt(1))){let R=2,I=R;for(;R<o&&!p(t.charCodeAt(R));)R++;if(R<o&&R!==I){for(I=R;R<o&&p(t.charCodeAt(R));)R++;if(R<o&&R!==I){for(I=R;R<o&&!p(t.charCodeAt(R));)R++;if(R===o)return t;R!==I&&(r=i=R+1)}}}}else f(s)&&t.charCodeAt(1)===y&&(r=o>2&&p(t.charCodeAt(2))?3:2,i=r);let l=-1,b=!0;for(let R=o-1;R>=i;--R)if(p(t.charCodeAt(R))){if(!b){l=R;break}}else b=!1;if(l===-1){if(r===-1)return".";l=r}return t.slice(0,l)},basename(t,o){o!==void 0&&m(o,"ext"),m(t,"path");let r=0,i=-1,s=!0,l;if(t.length>=2&&f(t.charCodeAt(0))&&t.charCodeAt(1)===y&&(r=2),o!==void 0&&o.length>0&&o.length<=t.length){if(o===t)return"";let b=o.length-1,R=-1;for(l=t.length-1;l>=r;--l){const I=t.charCodeAt(l);if(p(I)){if(!s){r=l+1;break}}else R===-1&&(s=!1,R=l+1),b>=0&&(I===o.charCodeAt(b)?--b===-1&&(i=l):(b=-1,i=R))}return r===i?i=R:i===-1&&(i=t.length),t.slice(r,i)}for(l=t.length-1;l>=r;--l)if(p(t.charCodeAt(l))){if(!s){r=l+1;break}}else i===-1&&(s=!1,i=l+1);return i===-1?"":t.slice(r,i)},extname(t){m(t,"path");let o=0,r=-1,i=0,s=-1,l=!0,b=0;t.length>=2&&t.charCodeAt(1)===y&&f(t.charCodeAt(0))&&(o=i=2);for(let R=t.length-1;R>=o;--R){const I=t.charCodeAt(R);if(p(I)){if(!l){i=R+1;break}continue}s===-1&&(l=!1,s=R+1),I===P?r===-1?r=R:b!==1&&(b=1):r!==-1&&(b=-1)}return r===-1||s===-1||b===0||b===1&&r===s-1&&r===i+1?"":t.slice(r,s)},format:$.bind(null,"\\"),parse(t){m(t,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return o;const r=t.length;let i=0,s=t.charCodeAt(0);if(r===1)return p(s)?(o.root=o.dir=t,o):(o.base=o.name=t,o);if(p(s)){if(i=1,p(t.charCodeAt(1))){let j=2,T=j;for(;j<r&&!p(t.charCodeAt(j));)j++;if(j<r&&j!==T){for(T=j;j<r&&p(t.charCodeAt(j));)j++;if(j<r&&j!==T){for(T=j;j<r&&!p(t.charCodeAt(j));)j++;j===r?i=j:j!==T&&(i=j+1)}}}}else if(f(s)&&t.charCodeAt(1)===y){if(r<=2)return o.root=o.dir=t,o;if(i=2,p(t.charCodeAt(2))){if(r===3)return o.root=o.dir=t,o;i=3}}i>0&&(o.root=t.slice(0,i));let l=-1,b=i,R=-1,I=!0,E=t.length-1,A=0;for(;E>=i;--E){if(s=t.charCodeAt(E),p(s)){if(!I){b=E+1;break}continue}R===-1&&(I=!1,R=E+1),s===P?l===-1?l=E:A!==1&&(A=1):l!==-1&&(A=-1)}return R!==-1&&(l===-1||A===0||A===1&&l===R-1&&l===b+1?o.base=o.name=t.slice(b,R):(o.name=t.slice(b,l),o.base=t.slice(b,R),o.ext=t.slice(l,R))),b>0&&b!==i?o.dir=t.slice(0,b-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null};const a=(()=>{if(w){const t=/\\/g;return()=>{const o=n.cwd().replace(t,"/");return o.slice(o.indexOf("/"))}}return()=>n.cwd()})();e.$gc={resolve(...t){let o="",r=!1;for(let i=t.length-1;i>=-1&&!r;i--){const s=i>=0?t[i]:a();m(s,"path"),s.length!==0&&(o=`${s}/${o}`,r=s.charCodeAt(0)===d)}return o=h(o,!r,"/",u),r?`/${o}`:o.length>0?o:"."},normalize(t){if(m(t,"path"),t.length===0)return".";const o=t.charCodeAt(0)===d,r=t.charCodeAt(t.length-1)===d;return t=h(t,!o,"/",u),t.length===0?o?"/":r?"./":".":(r&&(t+="/"),o?`/${t}`:t)},isAbsolute(t){return m(t,"path"),t.length>0&&t.charCodeAt(0)===d},join(...t){if(t.length===0)return".";let o;for(let r=0;r<t.length;++r){const i=t[r];m(i,"path"),i.length>0&&(o===void 0?o=i:o+=`/${i}`)}return o===void 0?".":e.$gc.normalize(o)},relative(t,o){if(m(t,"from"),m(o,"to"),t===o||(t=e.$gc.resolve(t),o=e.$gc.resolve(o),t===o))return"";const r=1,i=t.length,s=i-r,l=1,b=o.length-l,R=s<b?s:b;let I=-1,E=0;for(;E<R;E++){const j=t.charCodeAt(r+E);if(j!==o.charCodeAt(l+E))break;j===d&&(I=E)}if(E===R)if(b>R){if(o.charCodeAt(l+E)===d)return o.slice(l+E+1);if(E===0)return o.slice(l+E)}else s>R&&(t.charCodeAt(r+E)===d?I=E:E===0&&(I=0));let A="";for(E=r+I+1;E<=i;++E)(E===i||t.charCodeAt(E)===d)&&(A+=A.length===0?"..":"/..");return`${A}${o.slice(l+I)}`},toNamespacedPath(t){return t},dirname(t){if(m(t,"path"),t.length===0)return".";const o=t.charCodeAt(0)===d;let r=-1,i=!0;for(let s=t.length-1;s>=1;--s)if(t.charCodeAt(s)===d){if(!i){r=s;break}}else i=!1;return r===-1?o?"/":".":o&&r===1?"//":t.slice(0,r)},basename(t,o){o!==void 0&&m(o,"ext"),m(t,"path");let r=0,i=-1,s=!0,l;if(o!==void 0&&o.length>0&&o.length<=t.length){if(o===t)return"";let b=o.length-1,R=-1;for(l=t.length-1;l>=0;--l){const I=t.charCodeAt(l);if(I===d){if(!s){r=l+1;break}}else R===-1&&(s=!1,R=l+1),b>=0&&(I===o.charCodeAt(b)?--b===-1&&(i=l):(b=-1,i=R))}return r===i?i=R:i===-1&&(i=t.length),t.slice(r,i)}for(l=t.length-1;l>=0;--l)if(t.charCodeAt(l)===d){if(!s){r=l+1;break}}else i===-1&&(s=!1,i=l+1);return i===-1?"":t.slice(r,i)},extname(t){m(t,"path");let o=-1,r=0,i=-1,s=!0,l=0;for(let b=t.length-1;b>=0;--b){const R=t.charCodeAt(b);if(R===d){if(!s){r=b+1;break}continue}i===-1&&(s=!1,i=b+1),R===P?o===-1?o=b:l!==1&&(l=1):o!==-1&&(l=-1)}return o===-1||i===-1||l===0||l===1&&o===i-1&&o===r+1?"":t.slice(o,i)},format:$.bind(null,"/"),parse(t){m(t,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return o;const r=t.charCodeAt(0)===d;let i;r?(o.root="/",i=1):i=0;let s=-1,l=0,b=-1,R=!0,I=t.length-1,E=0;for(;I>=i;--I){const A=t.charCodeAt(I);if(A===d){if(!R){l=I+1;break}continue}b===-1&&(R=!1,b=I+1),A===P?s===-1?s=I:E!==1&&(E=1):s!==-1&&(E=-1)}if(b!==-1){const A=l===0&&r?1:l;s===-1||E===0||E===1&&s===b-1&&s===l+1?o.base=o.name=t.slice(A,b):(o.name=t.slice(A,s),o.base=t.slice(A,b),o.ext=t.slice(s,b))}return l>0?o.dir=t.slice(0,l-1):r&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.$gc.win32=e.$fc.win32=e.$fc,e.$gc.posix=e.$fc.posix=e.$gc,e.$hc=w?e.$fc.normalize:e.$gc.normalize,e.$ic=w?e.$fc.isAbsolute:e.$gc.isAbsolute,e.$jc=w?e.$fc.join:e.$gc.join,e.$kc=w?e.$fc.resolve:e.$gc.resolve,e.$lc=w?e.$fc.relative:e.$gc.relative,e.$mc=w?e.$fc.dirname:e.$gc.dirname,e.$nc=w?e.$fc.basename:e.$gc.basename,e.$oc=w?e.$fc.extname:e.$gc.extname,e.$pc=w?e.$fc.format:e.$gc.format,e.$qc=w?e.$fc.parse:e.$gc.parse,e.$rc=w?e.$fc.toNamespacedPath:e.$gc.toNamespacedPath,e.sep=w?e.$fc.sep:e.$gc.sep,e.$tc=w?e.$fc.delimiter:e.$gc.delimiter}),define(ae[33],ce([0,1,9,4,25,12]),function(X,e,n,D,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=e.$fg=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=void 0;function C(l){return l===47||l===92}e.$_f=C;function P(l){return l.replace(/[\\/]/g,n.$gc.sep)}e.$ag=P;function d(l){return l.indexOf("/")===-1&&(l=P(l)),/^[a-zA-Z]:(\/|$)/.test(l)&&(l="/"+l),l}e.$bg=d;function c(l,b=n.$gc.sep){if(!l)return"";const R=l.length,I=l.charCodeAt(0);if(C(I)){if(C(l.charCodeAt(1))&&!C(l.charCodeAt(2))){let A=3;const j=A;for(;A<R&&!C(l.charCodeAt(A));A++);if(j!==A&&!C(l.charCodeAt(A+1))){for(A+=1;A<R;A++)if(C(l.charCodeAt(A)))return l.slice(0,A+1).replace(/[\\/]/g,b)}}return b}else if(u(I)&&l.charCodeAt(1)===58)return C(l.charCodeAt(2))?l.slice(0,2)+b:l.slice(0,2);let E=l.indexOf("://");if(E!==-1){for(E+=3;E<R;E++)if(C(l.charCodeAt(E)))return l.slice(0,E+1)}return""}e.$cg=c;function y(l){if(!D.$i||!l||l.length<5)return!1;let b=l.charCodeAt(0);if(b!==92||(b=l.charCodeAt(1),b!==92))return!1;let R=2;const I=R;for(;R<l.length&&(b=l.charCodeAt(R),b!==92);R++);return!(I===R||(b=l.charCodeAt(R+1),isNaN(b)||b===92))}e.$dg=y;const v=/[\\/:\*\?"<>\|]/g,k=/[\\/]/g,g=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function m(l,b=D.$i){const R=b?v:k;return!(!l||l.length===0||/^\s+$/.test(l)||(R.lastIndex=0,R.test(l))||b&&g.test(l)||l==="."||l===".."||b&&l[l.length-1]==="."||b&&l.length!==l.trim().length||l.length>255)}e.$eg=m;function w(l,b,R){const I=l===b;return!R||I?I:!l||!b?!1:(0,S.$kf)(l,b)}e.$fg=w;function p(l,b,R,I=n.sep){if(l===b)return!0;if(!l||!b||b.length>l.length)return!1;if(R){if(!(0,S.$lf)(l,b))return!1;if(b.length===l.length)return!0;let A=b.length;return b.charAt(b.length-1)===I&&A--,l.charAt(A)===I}return b.charAt(b.length-1)!==I&&(b+=I),l.indexOf(b)===0}e.$gg=p;function u(l){return l>=65&&l<=90||l>=97&&l<=122}e.$hg=u;function f(l,b){return D.$i&&l.endsWith(":")&&(l+=n.sep),(0,n.$ic)(l)||(l=(0,n.$jc)(b,l)),l=(0,n.$hc)(l),D.$i?(l=(0,S.$5e)(l,n.sep),l.endsWith(":")&&(l+=n.sep)):(l=(0,S.$5e)(l,n.sep),l||(l=n.sep)),l}e.$ig=f;function h(l){const b=(0,n.$hc)(l);return D.$i?l.length>3?!1:$(b)&&(l.length===2||b.charCodeAt(2)===92):b===n.$gc.sep}e.$jg=h;function $(l,b=D.$i){return b?u(l.charCodeAt(0))&&l.charCodeAt(1)===58:!1}e.$kg=$;function a(l,b=D.$i){return $(l,b)?l[0]:void 0}e.$lg=a;function t(l,b,R){return b.length>l.length?-1:l===b?0:(R&&(l=l.toLowerCase(),b=b.toLowerCase()),l.indexOf(b))}e.$mg=t;function o(l){const b=l.split(":");let R,I,E;for(const A of b){const j=Number(A);(0,M.$Xf)(j)?I===void 0?I=j:E===void 0&&(E=j):R=R?[R,A].join(":"):A}if(!R)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:R,line:I!==void 0?I:void 0,column:E!==void 0?E:I!==void 0?1:void 0}}e.$ng=o;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",i="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function s(l,b,R=8){let I="";for(let A=0;A<R;A++){let j;A===0&&D.$i&&!b&&(R===3||R===4)?j=i:j=r,I+=j.charAt(Math.floor(Math.random()*j.length))}let E;return b?E=`${b}-${I}`:E=I,l?(0,n.$jc)(l,E):E}e.$og=s}),define(ae[75],ce([0,1,4]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4l=e.$3l=e.TerminateResponseCode=e.Source=void 0;var D;(function(P){P[P.stdout=0]="stdout",P[P.stderr=1]="stderr"})(D||(e.Source=D={}));var S;(function(P){P[P.Success=0]="Success",P[P.Unknown=1]="Unknown",P[P.AccessDenied=2]="AccessDenied",P[P.ProcessNotFound=3]="ProcessNotFound"})(S||(e.TerminateResponseCode=S={}));function M(P,...d){const c=d.reduce((k,g)=>(k[g]=!0,k),{}),y=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(P).filter(k=>!c[k]).forEach(k=>{for(let g=0;g<y.length;g++)if(k.search(y[g])!==-1){delete P[k];break}})}e.$3l=M;function C(P){P&&(delete P.DEBUG,n.$j&&delete P.DYLD_LIBRARY_PATH,n.$k&&delete P.LD_PRELOAD)}e.$4l=C}),define(ae[7],ce([0,1,9,4]),function(X,e,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wc=e.$vc=e.URI=void 0;const S=/^\w[\w\d+.-]*$/,M=/^\//,C=/^\/\//;function P(i,s){if(!i.scheme&&s)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!S.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!M.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(C.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function d(i,s){return!i&&!s?"file":i}function c(i,s){switch(i){case"https":case"http":case"file":s?s[0]!==v&&(s=v+s):s=v;break}return s}const y="",v="/",k=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class g{static isUri(s){return s instanceof g?!0:s?typeof s.authority=="string"&&typeof s.fragment=="string"&&typeof s.path=="string"&&typeof s.query=="string"&&typeof s.scheme=="string"&&typeof s.fsPath=="string"&&typeof s.with=="function"&&typeof s.toString=="function":!1}constructor(s,l,b,R,I,E=!1){typeof s=="object"?(this.scheme=s.scheme||y,this.authority=s.authority||y,this.path=s.path||y,this.query=s.query||y,this.fragment=s.fragment||y):(this.scheme=d(s,E),this.authority=l||y,this.path=c(this.scheme,b||y),this.query=R||y,this.fragment=I||y,P(this,E))}get fsPath(){return $(this,!1)}with(s){if(!s)return this;let{scheme:l,authority:b,path:R,query:I,fragment:E}=s;return l===void 0?l=this.scheme:l===null&&(l=y),b===void 0?b=this.authority:b===null&&(b=y),R===void 0?R=this.path:R===null&&(R=y),I===void 0?I=this.query:I===null&&(I=y),E===void 0?E=this.fragment:E===null&&(E=y),l===this.scheme&&b===this.authority&&R===this.path&&I===this.query&&E===this.fragment?this:new p(l,b,R,I,E)}static parse(s,l=!1){const b=k.exec(s);return b?new p(b[2]||y,r(b[4]||y),r(b[5]||y),r(b[7]||y),r(b[9]||y),l):new p(y,y,y,y,y)}static file(s){let l=y;if(D.$i&&(s=s.replace(/\\/g,v)),s[0]===v&&s[1]===v){const b=s.indexOf(v,2);b===-1?(l=s.substring(2),s=v):(l=s.substring(2,b),s=s.substring(b)||v)}return new p("file",l,s,y,y)}static from(s,l){return new p(s.scheme,s.authority,s.path,s.query,s.fragment,l)}static joinPath(s,...l){if(!s.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let b;return D.$i&&s.scheme==="file"?b=g.file(n.$fc.join($(s,!0),...l)).path:b=n.$gc.join(s.path,...l),s.with({path:b})}toString(s=!1){return a(this,s)}toJSON(){return this}static revive(s){if(s){if(s instanceof g)return s;{const l=new p(s);return l._formatted=s.external??null,l._fsPath=s._sep===w?s.fsPath??null:null,l}}else return s}}e.URI=g;function m(i){return!i||typeof i!="object"?!1:typeof i.scheme=="string"&&(typeof i.authority=="string"||typeof i.authority>"u")&&(typeof i.path=="string"||typeof i.path>"u")&&(typeof i.query=="string"||typeof i.query>"u")&&(typeof i.fragment=="string"||typeof i.fragment>"u")}e.$vc=m;const w=D.$i?1:void 0;class p extends g{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=$(this,!1)),this._fsPath}toString(s=!1){return s?a(this,!0):(this._formatted||(this._formatted=a(this,!1)),this._formatted)}toJSON(){const s={$mid:1};return this._fsPath&&(s.fsPath=this._fsPath,s._sep=w),this._formatted&&(s.external=this._formatted),this.path&&(s.path=this.path),this.scheme&&(s.scheme=this.scheme),this.authority&&(s.authority=this.authority),this.query&&(s.query=this.query),this.fragment&&(s.fragment=this.fragment),s}}const u={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function f(i,s,l){let b,R=-1;for(let I=0;I<i.length;I++){const E=i.charCodeAt(I);if(E>=97&&E<=122||E>=65&&E<=90||E>=48&&E<=57||E===45||E===46||E===95||E===126||s&&E===47||l&&E===91||l&&E===93||l&&E===58)R!==-1&&(b+=encodeURIComponent(i.substring(R,I)),R=-1),b!==void 0&&(b+=i.charAt(I));else{b===void 0&&(b=i.substr(0,I));const A=u[E];A!==void 0?(R!==-1&&(b+=encodeURIComponent(i.substring(R,I)),R=-1),b+=A):R===-1&&(R=I)}}return R!==-1&&(b+=encodeURIComponent(i.substring(R))),b!==void 0?b:i}function h(i){let s;for(let l=0;l<i.length;l++){const b=i.charCodeAt(l);b===35||b===63?(s===void 0&&(s=i.substr(0,l)),s+=u[b]):s!==void 0&&(s+=i[l])}return s!==void 0?s:i}function $(i,s){let l;return i.authority&&i.path.length>1&&i.scheme==="file"?l=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?s?l=i.path.substr(1):l=i.path[1].toLowerCase()+i.path.substr(2):l=i.path,D.$i&&(l=l.replace(/\//g,"\\")),l}e.$wc=$;function a(i,s){const l=s?h:f;let b="",{scheme:R,authority:I,path:E,query:A,fragment:j}=i;if(R&&(b+=R,b+=":"),(I||R==="file")&&(b+=v,b+=v),I){let T=I.indexOf("@");if(T!==-1){const W=I.substr(0,T);I=I.substr(T+1),T=W.lastIndexOf(":"),T===-1?b+=l(W,!1,!1):(b+=l(W.substr(0,T),!1,!1),b+=":",b+=l(W.substr(T+1),!1,!0)),b+="@"}I=I.toLowerCase(),T=I.lastIndexOf(":"),T===-1?b+=l(I,!1,!0):(b+=l(I.substr(0,T),!1,!0),b+=I.substr(T))}if(E){if(E.length>=3&&E.charCodeAt(0)===47&&E.charCodeAt(2)===58){const T=E.charCodeAt(1);T>=65&&T<=90&&(E=`/${String.fromCharCode(T+32)}:${E.substr(3)}`)}else if(E.length>=2&&E.charCodeAt(1)===58){const T=E.charCodeAt(0);T>=65&&T<=90&&(E=`${String.fromCharCode(T+32)}:${E.substr(2)}`)}b+=l(E,!0,!1)}return A&&(b+="?",b+=l(A,!1,!1)),j&&(b+="#",b+=s?j:f(j,!1,!1)),b}function t(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+t(i.substr(3)):i}}const o=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(i){return i.match(o)?i.replace(o,s=>t(s)):i}}),define(ae[156],ce([0,1,7]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$Dq=e.$Cq=e.$Bq=void 0;function D(c){const y=c;return y&&typeof y.type=="string"&&typeof y.severity=="string"}e.$Bq=D;function S(c){const y=[];let v;try{const k=JSON.parse(c.arguments),g=k[k.length-1];g&&g.__$stack&&(k.pop(),v=g.__$stack),y.push(...k)}catch{y.push("Unable to log remote console arguments",c.arguments)}return{args:y,stack:v}}e.$Cq=S;function M(c){if(typeof c!="string")return M(S(c).stack);const y=c;if(y){const v=C(y),k=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(v||"");if(k&&k.length===4)return{uri:n.URI.file(k[1]),line:Number(k[2]),column:Number(k[3])}}}e.$Dq=M;function C(c){if(!c)return c;const y=c.indexOf(`
`);return y===-1?c:c.substring(0,y)}function P(c,y){const{args:v,stack:k}=S(c),g=typeof v[0]=="string"&&v.length===1;let m=C(k);m&&(m=`(${m.trim()})`);let w=[];if(typeof v[0]=="string"?m&&g?w=[`%c[${y}] %c${v[0]} %c${m}`,d("blue"),d(""),d("grey")]:w=[`%c[${y}] %c${v[0]}`,d("blue"),d(""),...v.slice(1)]:w=[`%c[${y}]%`,d("blue"),...v],m&&!g&&w.push(m),typeof console[c.severity]!="function")throw new Error("Unknown console method");console[c.severity].apply(console,w)}e.log=P;function d(c){return`color: ${c}`}}),define(ae[76],ce([0,1,17,7]),function(X,e,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ph=e.$Oh=e.$Nh=void 0;function S(d){return JSON.stringify(d,C)}e.$Nh=S;function M(d){let c=JSON.parse(d);return c=P(c),c}e.$Oh=M;function C(d,c){return c instanceof RegExp?{$mid:2,source:c.source,flags:c.flags}:c}function P(d,c=0){if(!d||c>200)return d;if(typeof d=="object"){switch(d.$mid){case 1:return D.URI.revive(d);case 2:return new RegExp(d.source,d.flags);case 17:return new Date(d.source)}if(d instanceof n.$te||d instanceof Uint8Array)return d;if(Array.isArray(d))for(let y=0;y<d.length;++y)d[y]=P(d[y],c+1);else for(const y in d)Object.hasOwnProperty.call(d,y)&&(d[y]=P(d[y],c+1))}return d}e.$Ph=P}),define(ae[13],ce([0,1,15,4,25,7,9]),function(X,e,n,D,S,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.Schemas=void 0;var P;(function(m){m.inMemory="inmemory",m.vscode="vscode",m.internal="private",m.walkThrough="walkThrough",m.walkThroughSnippet="walkThroughSnippet",m.http="http",m.https="https",m.file="file",m.mailto="mailto",m.untitled="untitled",m.data="data",m.command="command",m.vscodeRemote="vscode-remote",m.vscodeRemoteResource="vscode-remote-resource",m.vscodeManagedRemoteResource="vscode-managed-remote-resource",m.vscodeUserData="vscode-userdata",m.vscodeCustomEditor="vscode-custom-editor",m.vscodeNotebookCell="vscode-notebook-cell",m.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",m.vscodeNotebookCellOutput="vscode-notebook-cell-output",m.vscodeInteractiveInput="vscode-interactive-input",m.vscodeSettings="vscode-settings",m.vscodeWorkspaceTrust="vscode-workspace-trust",m.vscodeTerminal="vscode-terminal",m.vscodeChatCodeBlock="vscode-chat-code-block",m.vscodeChatSesssion="vscode-chat-editor",m.webviewPanel="webview-panel",m.vscodeWebview="vscode-webview",m.extension="extension",m.vscodeFileResource="vscode-file",m.tmp="tmp",m.vsls="vsls",m.vscodeSourceControl="vscode-scm",m.codeSetting="code-setting"})(P||(e.Schemas=P={}));function d(m,w){return M.URI.isUri(m)?(0,S.$kf)(m.scheme,w):(0,S.$lf)(m,w+":")}e.$pg=d;function c(m,...w){return w.some(p=>d(m,p))}e.$qg=c,e.$rg="vscode-tkn",e.$sg="tkn";class y{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(w){this.d=w}setDelegate(w){this.e=w}setServerRootPath(w,p){this.f=v(w,p)}getServerRootPath(){return this.f}get g(){return C.$gc.join(this.f,P.vscodeRemoteResource)}set(w,p,u){this.a[w]=p,this.b[w]=u}setConnectionToken(w,p){this.c[w]=p}getPreferredWebSchema(){return this.d}rewrite(w){if(this.e)try{return this.e(w)}catch(a){return n.$1(a),w}const p=w.authority;let u=this.a[p];u&&u.indexOf(":")!==-1&&u.indexOf("[")===-1&&(u=`[${u}]`);const f=this.b[p],h=this.c[p];let $=`path=${encodeURIComponent(w.path)}`;return typeof h=="string"&&($+=`&${e.$sg}=${encodeURIComponent(h)}`),M.URI.from({scheme:D.$o?this.d:P.vscodeRemoteResource,authority:`${u}:${f}`,path:this.g,query:$})}}e.$tg=new y;function v(m,w){return C.$gc.join(w??"/",`${m.quality??"oss"}-${m.commit??"dev"}`)}e.$ug=v,e.$vg="vs/../../extensions",e.$wg="vs/../../node_modules",e.$xg="vs/../../node_modules.asar",e.$yg="vs/../../node_modules.asar.unpacked",e.$zg="vscode-app";class k{static{this.a=e.$zg}asBrowserUri(w){const p=this.b(w,X);return this.uriToBrowserUri(p)}uriToBrowserUri(w){return w.scheme===P.vscodeRemote?e.$tg.rewrite(w):w.scheme===P.file&&(D.$m||D.$q===`${P.vscodeFileResource}://${k.a}`)?w.with({scheme:P.vscodeFileResource,authority:w.authority||k.a,query:null,fragment:null}):w}asFileUri(w){const p=this.b(w,X);return this.uriToFileUri(p)}uriToFileUri(w){return w.scheme===P.vscodeFileResource?w.with({scheme:P.file,authority:w.authority!==k.a?w.authority:null,query:null,fragment:null}):w}b(w,p){return M.URI.isUri(w)?w:M.URI.parse(p.toUrl(w))}}e.$Ag=new k;var g;(function(m){const w=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);m.CoopAndCoep=Object.freeze(w.get("3"));const p="vscode-coi";function u(h){let $;typeof h=="string"?$=new URL(h).searchParams:h instanceof URL?$=h.searchParams:M.URI.isUri(h)&&($=new URL(h.toString(!0)).searchParams);const a=$?.get(p);if(a)return w.get(a)}m.getHeadersFromQuery=u;function f(h,$,a){if(!globalThis.crossOriginIsolated)return;const t=$&&a?"3":a?"2":"1";h instanceof URLSearchParams?h.set(p,t):h[p]=t}m.addSearchParam=f})(g||(e.COI=g={}))}),define(ae[19],ce([0,1,33,13,9,4,25,7]),function(X,e,n,D,S,M,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4g=e.DataUri=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=void 0;function d(g){return(0,P.$wc)(g,!0)}e.$Hg=d;class c{constructor(m){this.a=m}compare(m,w,p=!1){return m===w?0:(0,C.$df)(this.getComparisonKey(m,p),this.getComparisonKey(w,p))}isEqual(m,w,p=!1){return m===w?!0:!m||!w?!1:this.getComparisonKey(m,p)===this.getComparisonKey(w,p)}getComparisonKey(m,w=!1){return m.with({path:this.a(m)?m.path.toLowerCase():void 0,fragment:w?null:void 0}).toString()}ignorePathCasing(m){return this.a(m)}isEqualOrParent(m,w,p=!1){if(m.scheme===w.scheme){if(m.scheme===D.Schemas.file)return n.$gg(d(m),d(w),this.a(m))&&m.query===w.query&&(p||m.fragment===w.fragment);if((0,e.$Yg)(m.authority,w.authority))return n.$gg(m.path,w.path,this.a(m),"/")&&m.query===w.query&&(p||m.fragment===w.fragment)}return!1}joinPath(m,...w){return P.URI.joinPath(m,...w)}basenameOrAuthority(m){return(0,e.$Qg)(m)||m.authority}basename(m){return S.$gc.basename(m.path)}extname(m){return S.$gc.extname(m.path)}dirname(m){if(m.path.length===0)return m;let w;return m.scheme===D.Schemas.file?w=P.URI.file(S.$mc(d(m))).path:(w=S.$gc.dirname(m.path),m.authority&&w.length&&w.charCodeAt(0)!==47&&(console.error(`dirname("${m.toString})) resulted in a relative path`),w="/")),m.with({path:w})}normalizePath(m){if(!m.path.length)return m;let w;return m.scheme===D.Schemas.file?w=P.URI.file(S.$hc(d(m))).path:w=S.$gc.normalize(m.path),m.with({path:w})}relativePath(m,w){if(m.scheme!==w.scheme||!(0,e.$Yg)(m.authority,w.authority))return;if(m.scheme===D.Schemas.file){const f=S.$lc(d(m),d(w));return M.$i?n.$ag(f):f}let p=m.path||"/";const u=w.path||"/";if(this.a(m)){let f=0;for(const h=Math.min(p.length,u.length);f<h&&!(p.charCodeAt(f)!==u.charCodeAt(f)&&p.charAt(f).toLowerCase()!==u.charAt(f).toLowerCase());f++);p=u.substr(0,f)+p.substr(f)}return S.$gc.relative(p,u)}resolvePath(m,w){if(m.scheme===D.Schemas.file){const p=P.URI.file(S.$kc(d(m),w));return m.with({authority:p.authority,path:p.path})}return w=n.$bg(w),m.with({path:S.$gc.resolve(m.path,w)})}isAbsolutePath(m){return!!m.path&&m.path[0]==="/"}isEqualAuthority(m,w){return m===w||m!==void 0&&w!==void 0&&(0,C.$kf)(m,w)}hasTrailingPathSeparator(m,w=S.sep){if(m.scheme===D.Schemas.file){const p=d(m);return p.length>n.$cg(p).length&&p[p.length-1]===w}else{const p=m.path;return p.length>1&&p.charCodeAt(p.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(m.fsPath)}}removeTrailingPathSeparator(m,w=S.sep){return(0,e.$Zg)(m,w)?m.with({path:m.path.substr(0,m.path.length-1)}):m}addTrailingPathSeparator(m,w=S.sep){let p=!1;if(m.scheme===D.Schemas.file){const u=d(m);p=u!==void 0&&u.length===n.$cg(u).length&&u[u.length-1]===w}else{w="/";const u=m.path;p=u.length===1&&u.charCodeAt(u.length-1)===47}return!p&&!(0,e.$Zg)(m,w)?m.with({path:m.path+"/"}):m}}e.$Ig=c,e.$Jg=new c(()=>!1),e.$Kg=new c(g=>g.scheme===D.Schemas.file?!M.$k:!0),e.$Lg=new c(g=>!0),e.$Mg=e.$Jg.isEqual.bind(e.$Jg),e.$Ng=e.$Jg.isEqualOrParent.bind(e.$Jg),e.$Og=e.$Jg.getComparisonKey.bind(e.$Jg),e.$Pg=e.$Jg.basenameOrAuthority.bind(e.$Jg),e.$Qg=e.$Jg.basename.bind(e.$Jg),e.$Rg=e.$Jg.extname.bind(e.$Jg),e.$Sg=e.$Jg.dirname.bind(e.$Jg),e.$Tg=e.$Jg.joinPath.bind(e.$Jg),e.$Ug=e.$Jg.normalizePath.bind(e.$Jg),e.$Vg=e.$Jg.relativePath.bind(e.$Jg),e.$Wg=e.$Jg.resolvePath.bind(e.$Jg),e.$Xg=e.$Jg.isAbsolutePath.bind(e.$Jg),e.$Yg=e.$Jg.isEqualAuthority.bind(e.$Jg),e.$Zg=e.$Jg.hasTrailingPathSeparator.bind(e.$Jg),e.$1g=e.$Jg.removeTrailingPathSeparator.bind(e.$Jg),e.$2g=e.$Jg.addTrailingPathSeparator.bind(e.$Jg);function y(g,m){const w=[];for(let p=0;p<g.length;p++){const u=m(g[p]);g.some((f,h)=>h===p?!1:(0,e.$Ng)(u,m(f)))||w.push(g[p])}return w}e.$3g=y;var v;(function(g){g.META_DATA_LABEL="label",g.META_DATA_DESCRIPTION="description",g.META_DATA_SIZE="size",g.META_DATA_MIME="mime";function m(w){const p=new Map;w.path.substring(w.path.indexOf(";")+1,w.path.lastIndexOf(";")).split(";").forEach(h=>{const[$,a]=h.split(":");$&&a&&p.set($,a)});const f=w.path.substring(0,w.path.indexOf(";"));return f&&p.set(g.META_DATA_MIME,f),p}g.parseMetaData=m})(v||(e.DataUri=v={}));function k(g,m,w){if(m){let p=g.path;return p&&p[0]!==S.$gc.sep&&(p=S.$gc.sep+p),g.with({scheme:w,authority:m,path:p})}return g.with({scheme:w})}e.$4g=k}),define(ae[8],ce([0,1,23,15,3,2,19,4,144,61]),function(X,e,n,D,S,M,C,P,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.Promises=e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=void 0;function y(_){return!!_&&typeof _.then=="function"}e.$5g=y;function v(_){const B=new n.$de,te=_(B.token),ie=new Promise((de,me)=>{const ke=B.token.onCancellationRequested(()=>{ke.dispose(),me(new D.$5)});Promise.resolve(te).then(Se=>{ke.dispose(),B.dispose(),de(Se)},Se=>{ke.dispose(),B.dispose(),me(Se)})});return new class{cancel(){B.cancel(),B.dispose()}then(de,me){return ie.then(de,me)}catch(de){return this.then(void 0,de)}finally(de){return ie.finally(de)}}}e.$6g=v;function k(_,B,te){return new Promise((ie,de)=>{const me=B.onCancellationRequested(()=>{me.dispose(),ie(te)});_.then(ie,de).finally(()=>me.dispose())})}e.$7g=k;function g(_,B){return new Promise((te,ie)=>{const de=B.onCancellationRequested(()=>{de.dispose(),ie(new D.$5)});_.then(te,ie).finally(()=>de.dispose())})}e.$8g=g;async function m(_){let B=-1;const te=_.map((ie,de)=>ie.then(me=>(B=de,me)));try{return await Promise.race(te)}finally{_.forEach((ie,de)=>{de!==B&&ie.cancel()})}}e.$9g=m;function w(_,B,te){let ie;const de=setTimeout(()=>{ie?.(void 0),te?.()},B);return Promise.race([_.finally(()=>clearTimeout(de)),new Promise(me=>ie=me)])}e.$0g=w;function p(_){return new Promise((B,te)=>{const ie=_();y(ie)?ie.then(B,te):B(ie)})}e.$$g=p;function u(){let _,B;return{promise:new Promise((ie,de)=>{_=ie,B=de}),resolve:_,reject:B}}e.$_g=u;class f{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(B){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=B,!this.b){const te=()=>{if(this.b=null,this.f)return;const ie=this.queue(this.d);return this.d=null,ie};this.b=new Promise(ie=>{this.a.then(te,te).then(ie)})}return new Promise((te,ie)=>{this.b.then(te,ie)})}return this.a=B(),new Promise((te,ie)=>{this.a.then(de=>{this.a=null,te(de)},de=>{this.a=null,ie(de)})})}dispose(){this.f=!0}}e.$ah=f;class h{constructor(){this.a=Promise.resolve(null)}queue(B){return this.a=this.a.then(()=>B(),()=>B())}}e.$bh=h;class ${constructor(){this.a=new Map}queue(B,te){const de=(this.a.get(B)??Promise.resolve()).catch(()=>{}).then(te).finally(()=>{this.a.get(B)===de&&this.a.delete(B)});return this.a.set(B,de),de}}e.$ch=$;const a=(_,B)=>{let te=!0;const ie=setTimeout(()=>{te=!1,B()},_);return{isTriggered:()=>te,dispose:()=>{clearTimeout(ie),te=!1}}},t=_=>{let B=!0;return queueMicrotask(()=>{B&&(B=!1,_())}),{isTriggered:()=>B,dispose:()=>{B=!1}}};class o{constructor(B){this.defaultDelay=B,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(B,te=this.defaultDelay){this.g=B,this.h(),this.b||(this.b=new Promise((de,me)=>{this.d=de,this.f=me}).then(()=>{if(this.b=null,this.d=null,this.g){const de=this.g;return this.g=null,de()}}));const ie=()=>{this.a=null,this.d?.(null)};return this.a=te===d.$3d?t(ie):a(te,ie),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new D.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$dh=o;class r{constructor(B){this.a=new o(B),this.b=new f}trigger(B,te){return this.a.trigger(()=>this.b.queue(B),te)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$eh=r;class i{constructor(){this.a=!1,this.b=new Promise((B,te)=>{this.d=B})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$fh=i;class s extends i{constructor(B){super(),this.f=setTimeout(()=>this.open(),B)}open(){clearTimeout(this.f),super.open()}}e.$gh=s;function l(_,B){return B?new Promise((te,ie)=>{const de=setTimeout(()=>{me.dispose(),te()},_),me=B.onCancellationRequested(()=>{clearTimeout(de),me.dispose(),ie(new D.$5)})}):v(te=>l(_,te))}e.$hh=l;function b(_,B=0,te){const ie=setTimeout(()=>{_(),te&&de.dispose()},B),de=(0,M.$Rc)(()=>{clearTimeout(ie),te?.deleteAndLeak(de)});return te?.add(de),de}e.$ih=b;function R(_){const B=[];let te=0;const ie=_.length;function de(){return te<ie?_[te++]():null}function me(ke){ke!=null&&B.push(ke);const Se=de();return Se?Se.then(me):Promise.resolve(B)}return Promise.resolve(null).then(me)}e.$jh=R;function I(_,B=ie=>!!ie,te=null){let ie=0;const de=_.length,me=()=>{if(ie>=de)return Promise.resolve(te);const ke=_[ie++];return Promise.resolve(ke()).then(Me=>B(Me)?Promise.resolve(Me):me())};return me()}e.$kh=I;function E(_,B=ie=>!!ie,te=null){if(_.length===0)return Promise.resolve(te);let ie=_.length;const de=()=>{ie=-1;for(const me of _)me.cancel?.()};return new Promise((me,ke)=>{for(const Se of _)Se.then(Me=>{--ie>=0&&B(Me)?(de(),me(Me)):ie===0&&me(te)}).catch(Me=>{--ie>=0&&(de(),ke(Me))})})}e.$lh=E;class A{constructor(B){this.a=0,this.b=!1,this.f=B,this.g=[],this.d=0,this.h=new S.$6d}whenIdle(){return this.size>0?S.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(B){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((te,ie)=>{this.g.push({factory:B,c:te,e:ie}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const B=this.g.shift();this.d++;const te=B.factory();te.then(B.c,B.e),te.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$mh=A;class j extends A{constructor(){super(1)}}e.$nh=j;class T{constructor(){this.a=new N,this.b=0}queue(B){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,B())):this.a.run(this.b++,B())}}e.$oh=T;class W{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const B=new oe;return this.b.add(B),B.p}g(){for(const[,B]of this.a)if(B.size>0)return!1;return!0}queueSize(B,te=C.$Jg){const ie=te.getComparisonKey(B);return this.a.get(ie)?.size??0}queueFor(B,te,ie=C.$Jg){const de=ie.getComparisonKey(B);let me=this.a.get(de);if(!me){me=new j;const ke=this.f++,Se=S.Event.once(me.onDrained)(()=>{me?.dispose(),this.a.delete(de),this.h(),this.d?.deleteAndDispose(ke),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new M.$3c),this.d.set(ke,Se),this.a.set(de,me)}return me.queue(te)}h(){this.g()&&this.j()}j(){for(const B of this.b)B.complete();this.b.clear()}dispose(){for(const[,B]of this.a)B.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$ph=W;class V{constructor(B,te){this.a=-1,typeof B=="function"&&typeof te=="number"&&this.setIfNotSet(B,te)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(B,te){this.cancel(),this.a=setTimeout(()=>{this.a=-1,B()},te)}setIfNotSet(B,te){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,B()},te))}}e.$qh=V;class K{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(B,te,ie=globalThis){this.cancel();const de=ie.setInterval(()=>{B()},te);this.d=(0,M.$Rc)(()=>{ie.clearInterval(de),this.d=void 0})}dispose(){this.cancel()}}e.$rh=K;class le{constructor(B,te){this.b=-1,this.a=B,this.d=te,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(B=this.d){this.cancel(),this.b=setTimeout(this.f,B)}get delay(){return this.d}set delay(B){this.d=B}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$sh=le;class re{constructor(B,te){te%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${te}ms is not a multiple of 1000ms.`),this.a=B,this.b=te,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(B=this.b){B%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${B}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(B/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$th=re;class ue extends le{constructor(B,te){super(B,te),this.j=[]}work(B){this.j.push(B),this.isScheduled()||this.schedule()}h(){const B=this.j;this.j=[],this.a?.(B)}dispose(){this.j=[],super.dispose()}}e.$uh=ue;class Z extends M.$Tc{constructor(B,te){super(),this.g=B,this.h=te,this.a=[],this.b=this.B(new M.$Uc),this.f=!1}get pending(){return this.a.length}work(B){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+B.length>this.g.maxBufferedWork)return!1}else if(this.pending+B.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const te of B)this.a.push(te);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new le(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$vh=Z,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$xh=(_,B)=>{(0,P.$B)(()=>{if(te)return;const ie=Date.now()+15;B(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ie-Date.now())}}))});let te=!1;return{dispose(){te||(te=!0)}}}:e.$xh=(_,B,te)=>{const ie=_.requestIdleCallback(B,typeof te=="number"?{timeout:te}:void 0);let de=!1;return{dispose(){de||(de=!0,_.cancelIdleCallback(ie))}}},e.$wh=_=>(0,e.$xh)(globalThis,_)}();class Y{constructor(B,te){this.g=!1,this.d=()=>{try{this.j=te()}catch(ie){this.l=ie}finally{this.g=!0}},this.f=(0,e.$xh)(B,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$yh=Y;class U extends Y{constructor(B){super(globalThis,B)}}e.$zh=U;async function L(_,B,te){let ie;for(let de=0;de<te;de++)try{return await _()}catch(me){ie=me,await l(B)}throw ie}e.$Ah=L;class N{isRunning(B){return typeof B=="number"?this.a?.taskId===B:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(B,te,ie){return this.a={taskId:B,cancel:()=>ie?.(),promise:te},te.then(()=>this.d(B),()=>this.d(B)),te}d(B){this.a&&B===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const B=this.b;this.b=void 0,B.run().then(B.promiseResolve,B.promiseReject)}}queue(B){if(this.b)this.b.run=B;else{const{promise:te,resolve:ie,reject:de}=u();this.b={run:B,promise:te,promiseResolve:ie,promiseReject:de}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Bh=N;class G{constructor(B,te=()=>Date.now()){this.d=B,this.f=te,this.a=0,this.b=0}increment(){const B=this.f();return B-this.a>this.d&&(this.a=B,this.b=0),this.b++,this.b}}e.$Ch=G;var q;(function(_){_[_.Resolved=0]="Resolved",_[_.Rejected=1]="Rejected"})(q||(q={}));class oe{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((B,te)=>{this.a=B,this.b=te})}complete(B){return new Promise(te=>{this.a(B),this.d={outcome:0,value:B},te()})}error(B){return new Promise(te=>{this.b(B),this.d={outcome:1,value:B},te()})}cancel(){return this.error(new D.$5)}}e.$Dh=oe;var he;(function(_){async function B(ie){let de;const me=await Promise.all(ie.map(ke=>ke.then(Se=>Se,Se=>{de||(de=Se)})));if(typeof de<"u")throw de;return me}_.settled=B;function te(ie){return new Promise(async(de,me)=>{try{await ie(de,me)}catch(ke){me(ke)}})}_.withAsyncBody=te})(he||(e.Promises=he={}));class J{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(B){this.a=void 0,this.b=void 0,this.d=!1,this.promise=B.then(te=>(this.a=te,this.d=!0,te),te=>{throw this.b=te,this.d=!0,te})}requireValue(){if(!this.d)throw new D.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Eh=J;class O{constructor(B){this.b=B,this.a=new c.$V(()=>new J(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Fh=O;var F;(function(_){_[_.Initial=0]="Initial",_[_.DoneOK=1]="DoneOK",_[_.DoneError=2]="DoneError"})(F||(F={}));class x{static fromArray(B){return new x(te=>{te.emitMany(B)})}static fromPromise(B){return new x(async te=>{te.emitMany(await B)})}static fromPromises(B){return new x(async te=>{await Promise.all(B.map(async ie=>te.emitOne(await ie)))})}static merge(B){return new x(async te=>{await Promise.all(B.map(async ie=>{for await(const de of ie)te.emitOne(de)}))})}static{this.EMPTY=x.fromArray([])}constructor(B){this.a=0,this.b=[],this.d=null,this.f=new S.$6d,queueMicrotask(async()=>{const te={emitOne:ie=>this.g(ie),emitMany:ie=>this.h(ie),reject:ie=>this.k(ie)};try{await Promise.resolve(B(te)),this.j()}catch(ie){this.k(ie)}finally{te.emitOne=void 0,te.emitMany=void 0,te.reject=void 0}})}[Symbol.asyncIterator](){let B=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(B<this.b.length)return{done:!1,value:this.b[B++]};if(this.a===1)return{done:!0,value:void 0};await S.Event.toPromise(this.f.event)}while(!0)}}}static map(B,te){return new x(async ie=>{for await(const de of B)ie.emitOne(te(de))})}map(B){return x.map(this,B)}static filter(B,te){return new x(async ie=>{for await(const de of B)te(de)&&ie.emitOne(de)})}filter(B){return x.filter(this,B)}static coalesce(B){return x.filter(B,te=>!!te)}coalesce(){return x.coalesce(this)}static async toPromise(B){const te=[];for await(const ie of B)te.push(ie);return te}toPromise(){return x.toPromise(this)}g(B){this.a===0&&(this.b.push(B),this.f.fire())}h(B){this.a===0&&(this.b=this.b.concat(B),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(B){this.a===0&&(this.a=2,this.d=B,this.f.fire())}}e.$Gh=x;class z extends x{constructor(B,te){super(te),this.l=B}cancel(){this.l.cancel()}}e.$Hh=z;function Q(_){const B=new n.$de,te=_(B.token);return new z(B,async ie=>{const de=B.token.onCancellationRequested(()=>{de.dispose(),B.dispose(),ie.reject(new D.$5)});try{for await(const me of te){if(B.token.isCancellationRequested)return;ie.emitOne(me)}de.dispose(),B.dispose()}catch(me){de.dispose(),B.dispose(),ie.reject(me)}})}e.$Ih=Q;class H{constructor(){this.a=new oe,this.b=new x(ie=>{if(B){ie.reject(B);return}return te&&ie.emitMany(te),this.d=de=>ie.reject(de),this.f=de=>ie.emitOne(de),this.a.p});let B,te;this.f=ie=>{te||(te=[]),te.push(ie)},this.d=ie=>{B||(B=ie)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(B){this.d(B),this.a.complete()}emitOne(B){this.f(B)}}e.$Jh=H}),define(ae[108],ce([0,1,22,8,33,31,9,4,25]),function(X,e,n,D,S,M,C,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4j=e.$3j=e.$2j=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=void 0;function c(){return Object.create(null)}e.$Uj=c,e.$Vj="**",e.$Wj="/";const y="[/\\\\]",v="[^/\\\\]",k=/\//g;function g(Y,U){switch(Y){case 0:return"";case 1:return`${v}*?`;default:return`(?:${y}|${v}+${y}${U?`|${y}${v}+`:""})*?`}}function m(Y,U){if(!Y)return[];const L=[];let N=!1,G=!1,q="";for(const oe of Y){switch(oe){case U:if(!N&&!G){L.push(q),q="";continue}break;case"{":N=!0;break;case"}":N=!1;break;case"[":G=!0;break;case"]":G=!1;break}q+=oe}return q&&L.push(q),L}e.$Xj=m;function w(Y){if(!Y)return"";let U="";const L=m(Y,e.$Wj);if(L.every(N=>N===e.$Vj))U=".*";else{let N=!1;L.forEach((G,q)=>{if(G===e.$Vj){if(N)return;U+=g(2,q===L.length-1)}else{let oe=!1,he="",J=!1,O="";for(const F of G){if(F!=="}"&&oe){he+=F;continue}if(J&&(F!=="]"||!O)){let x;F==="-"?x=F:(F==="^"||F==="!")&&!O?x="^":F===e.$Wj?x="":x=(0,d.$Ye)(F),O+=x;continue}switch(F){case"{":oe=!0;continue;case"[":J=!0;continue;case"}":{const z=`(?:${m(he,",").map(Q=>w(Q)).join("|")})`;U+=z,oe=!1,he="";break}case"]":{U+="["+O+"]",J=!1,O="";break}case"?":U+=v;continue;case"*":U+=g(1);continue;default:U+=(0,d.$Ye)(F)}}q<L.length-1&&(L[q+1]!==e.$Vj||q+2<L.length)&&(U+=y)}N=G===e.$Vj})}return U}const p=/^\*\*\/\*\.[\w\.-]+$/,u=/^\*\*\/([\w\.-]+)\/?$/,f=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,h=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,$=/^\*\*((\/[\w\.-]+)+)\/?$/,a=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new M.$Dc(1e4),o=function(){return!1},r=function(){return null};function i(Y,U){if(!Y)return r;let L;typeof Y!="string"?L=Y.pattern:L=Y,L=L.trim();const N=`${L}_${!!U.trimForExclusions}`;let G=t.get(N);if(G)return s(G,Y);let q;return p.test(L)?G=b(L.substr(4),L):(q=u.exec(l(L,U)))?G=R(q[1],L):(U.trimForExclusions?h:f).test(L)?G=I(L,U):(q=$.exec(l(L,U)))?G=E(q[1].substr(1),L,!0):(q=a.exec(l(L,U)))?G=E(q[1],L,!1):G=A(L),t.set(N,G),s(G,Y)}function s(Y,U){if(typeof U=="string")return Y;const L=function(N,G){return(0,S.$gg)(N,U.base,!P.$k)?Y((0,d.$4e)(N.substr(U.base.length),C.sep),G):null};return L.allBasenames=Y.allBasenames,L.allPaths=Y.allPaths,L.basenames=Y.basenames,L.patterns=Y.patterns,L}function l(Y,U){return U.trimForExclusions&&Y.endsWith("/**")?Y.substr(0,Y.length-2):Y}function b(Y,U){return function(L,N){return typeof L=="string"&&L.endsWith(Y)?U:null}}function R(Y,U){const L=`/${Y}`,N=`\\${Y}`,G=function(oe,he){return typeof oe!="string"?null:he?he===Y?U:null:oe===Y||oe.endsWith(L)||oe.endsWith(N)?U:null},q=[Y];return G.basenames=q,G.patterns=[U],G.allBasenames=q,G}function I(Y,U){const L=ue(Y.slice(1,-1).split(",").map(he=>i(he,U)).filter(he=>he!==r),Y),N=L.length;if(!N)return r;if(N===1)return L[0];const G=function(he,J){for(let O=0,F=L.length;O<F;O++)if(L[O](he,J))return Y;return null},q=L.find(he=>!!he.allBasenames);q&&(G.allBasenames=q.allBasenames);const oe=L.reduce((he,J)=>J.allPaths?he.concat(J.allPaths):he,[]);return oe.length&&(G.allPaths=oe),G}function E(Y,U,L){const N=C.sep===C.$gc.sep,G=N?Y:Y.replace(k,C.sep),q=C.sep+G,oe=C.$gc.sep+Y;let he;return L?he=function(J,O){return typeof J=="string"&&(J===G||J.endsWith(q)||!N&&(J===Y||J.endsWith(oe)))?U:null}:he=function(J,O){return typeof J=="string"&&(J===G||!N&&J===Y)?U:null},he.allPaths=[(L?"*/":"./")+Y],he}function A(Y){try{const U=new RegExp(`^${w(Y)}$`);return function(L){return U.lastIndex=0,typeof L=="string"&&U.test(L)?Y:null}}catch{return r}}function j(Y,U,L){return!Y||typeof U!="string"?!1:T(Y)(U,void 0,L)}e.$Yj=j;function T(Y,U={}){if(!Y)return o;if(typeof Y=="string"||W(Y)){const L=i(Y,U);if(L===r)return o;const N=function(G,q){return!!L(G,q)};return L.allBasenames&&(N.allBasenames=L.allBasenames),L.allPaths&&(N.allPaths=L.allPaths),N}return le(Y,U)}e.$Zj=T;function W(Y){const U=Y;return U?typeof U.base=="string"&&typeof U.pattern=="string":!1}e.$1j=W;function V(Y){return Y.allBasenames||[]}e.$2j=V;function K(Y){return Y.allPaths||[]}e.$3j=K;function le(Y,U){const L=ue(Object.getOwnPropertyNames(Y).map(he=>re(he,Y[he],U)).filter(he=>he!==r)),N=L.length;if(!N)return r;if(!L.some(he=>!!he.requiresSiblings)){if(N===1)return L[0];const he=function(F,x){let z;for(let Q=0,H=L.length;Q<H;Q++){const _=L[Q](F,x);if(typeof _=="string")return _;(0,D.$5g)(_)&&(z||(z=[]),z.push(_))}return z?(async()=>{for(const Q of z){const H=await Q;if(typeof H=="string")return H}return null})():null},J=L.find(F=>!!F.allBasenames);J&&(he.allBasenames=J.allBasenames);const O=L.reduce((F,x)=>x.allPaths?F.concat(x.allPaths):F,[]);return O.length&&(he.allPaths=O),he}const G=function(he,J,O){let F,x;for(let z=0,Q=L.length;z<Q;z++){const H=L[z];H.requiresSiblings&&O&&(J||(J=(0,C.$nc)(he)),F||(F=J.substr(0,J.length-(0,C.$oc)(he).length)));const _=H(he,J,F,O);if(typeof _=="string")return _;(0,D.$5g)(_)&&(x||(x=[]),x.push(_))}return x?(async()=>{for(const z of x){const Q=await z;if(typeof Q=="string")return Q}return null})():null},q=L.find(he=>!!he.allBasenames);q&&(G.allBasenames=q.allBasenames);const oe=L.reduce((he,J)=>J.allPaths?he.concat(J.allPaths):he,[]);return oe.length&&(G.allPaths=oe),G}function re(Y,U,L){if(U===!1)return r;const N=i(Y,L);if(N===r)return r;if(typeof U=="boolean")return N;if(U){const G=U.when;if(typeof G=="string"){const q=(oe,he,J,O)=>{if(!O||!N(oe,he))return null;const F=G.replace("$(basename)",()=>J),x=O(F);return(0,D.$5g)(x)?x.then(z=>z?Y:null):x?Y:null};return q.requiresSiblings=!0,q}}return N}function ue(Y,U){const L=Y.filter(he=>!!he.basenames);if(L.length<2)return Y;const N=L.reduce((he,J)=>{const O=J.basenames;return O?he.concat(O):he},[]);let G;if(U){G=[];for(let he=0,J=N.length;he<J;he++)G.push(U)}else G=L.reduce((he,J)=>{const O=J.patterns;return O?he.concat(O):he},[]);const q=function(he,J){if(typeof he!="string")return null;if(!J){let F;for(F=he.length;F>0;F--){const x=he.charCodeAt(F-1);if(x===47||x===92)break}J=he.substr(F)}const O=N.indexOf(J);return O!==-1?G[O]:null};q.basenames=N,q.patterns=G,q.allBasenames=N;const oe=Y.filter(he=>!he.basenames);return oe.push(q),oe}function Z(Y,U){return(0,n.$ub)(Y,U,(L,N)=>typeof L=="string"&&typeof N=="string"?L===N:typeof L!="string"&&typeof N!="string"?L.base===N.base&&L.pattern===N.pattern:!1)}e.$4j=Z}),define(ae[47],ce([0,1,22,33,9,4,19,25]),function(X,e,n,D,S,M,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iw=e.$hw=e.$gw=e.$fw=e.$ew=e.$dw=e.$cw=e.$bw=e.$aw=e.$_v=void 0;function d(i,s){const{os:l,tildify:b,relative:R}=s;if(R){const A=c(i,R,l);if(typeof A=="string")return A}let I=i.fsPath;if(l===1&&!M.$i?I=I.replace(/\//g,"\\"):l!==1&&M.$i&&(I=I.replace(/\\/g,"/")),l!==1&&b?.userHome){const A=b.userHome.fsPath;let j;i.scheme!==b.userHome.scheme&&i.path[0]===S.$gc.sep&&i.path[1]!==S.$gc.sep?j=b.userHome.with({path:i.path}).fsPath:j=I,I=k(j,A,l)}return(l===1?S.$fc:S.$gc).normalize(y(I,l===1))}e.$_v=d;function c(i,s,l){const b=l===1?S.$fc:S.$gc,R=l===3?C.$Jg:C.$Lg,I=s.getWorkspace(),E=(0,n.$Ob)(I.folders);if(!E)return;i.scheme!==E.uri.scheme&&i.path[0]===S.$gc.sep&&i.path[1]!==S.$gc.sep&&(i=E.uri.with({path:i.path}));const A=s.getWorkspaceFolder(i);if(!A)return;let j;if(R.isEqual(A.uri,i)?j="":j=R.relativePath(A.uri,i)??"",j&&(j=b.normalize(j)),I.folders.length>1&&!s.noPrefix){const T=A.name?A.name:R.basenameOrAuthority(A.uri);j=j?`${T} \u2022 ${j}`:T}return j}function y(i,s=M.$i){return(0,D.$kg)(i,s)?i.charAt(0).toUpperCase()+i.slice(1):i}e.$aw=y;let v=Object.create(null);function k(i,s,l=M.OS){if(l===1||!i||!s)return i;let b=v.original===s?v.normalized:void 0;b||(b=s,M.$i&&(b=(0,D.$ag)(b)),b=`${(0,P.$5e)(b,S.$gc.sep)}${S.$gc.sep}`,v={original:s,normalized:b});let R=i;return M.$i&&(R=(0,D.$ag)(R)),(l===3?R.startsWith(b):(0,P.$lf)(R,b))?`~/${R.substr(b.length)}`:i}e.$bw=k;function g(i,s){return i.replace(/^~($|\/|\\)/,`${s}$1`)}e.$cw=g;const m="\u2026",w="\\\\",p="~";function u(i,s=S.sep){const l=new Array(i.length);let b=!1;for(let R=0;R<i.length;R++){const I=i[R];if(I===""){l[R]=`.${s}`;continue}if(!I){l[R]=I;continue}b=!0;let E="",A=I;A.indexOf(w)===0?(E=A.substr(0,A.indexOf(w)+w.length),A=A.substr(A.indexOf(w)+w.length)):A.indexOf(s)===0?(E=A.substr(0,A.indexOf(s)+s.length),A=A.substr(A.indexOf(s)+s.length)):A.indexOf(p)===0&&(E=A.substr(0,A.indexOf(p)+p.length),A=A.substr(A.indexOf(p)+p.length));const j=A.split(s);for(let T=1;b&&T<=j.length;T++)for(let W=j.length-T;b&&W>=0;W--){b=!1;let V=j.slice(W,W+T).join(s);for(let K=0;!b&&K<i.length;K++)if(K!==R&&i[K]&&i[K].indexOf(V)>-1){const le=W+T===j.length,re=W>0&&i[K].indexOf(s)>-1?s+V:V,ue=i[K].endsWith(re);b=!le||ue}if(!b){let K="";(j[0].endsWith(":")||E!=="")&&(W===1&&(W=0,T++,V=j[0]+s+V),W>0&&(K=j[0]+s),K=E+K),W>0&&(K=K+m+s),K=K+V,W+T<j.length&&(K=K+s+m),l[R]=K}}b&&(l[R]=I)}return l}e.$dw=u;var f;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(f||(f={}));function h(i,s=Object.create(null)){const l=[];let b=!1,R="";for(const I of i)if(I==="$"||b&&I==="{")R&&l.push({value:R,type:f.TEXT}),R="",b=!0;else if(I==="}"&&b){const E=s[R];if(typeof E=="string")E.length&&l.push({value:E,type:f.VARIABLE});else if(E){const A=l[l.length-1];(!A||A.type!==f.SEPARATOR)&&l.push({value:E.label,type:f.SEPARATOR})}R="",b=!1}else R+=I;return R&&!b&&l.push({value:R,type:f.TEXT}),l.filter((I,E)=>{if(I.type===f.SEPARATOR){const A=l[E-1],j=l[E+1];return[A,j].every(T=>T&&(T.type===f.VARIABLE||T.type===f.TEXT)&&T.value.length>0)}return!0}).map(I=>I.value).join("")}e.$ew=h;function $(i,s){return M.$j||s?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,M.$j?"&":"&&"):i.replace(/&&|&/g,l=>l==="&"?"&&":"&")}e.$fw=$;function a(i,s){return M.$j||s?i.replace(/\(&&\w\)|&&/g,""):M.$i?i.replace(/&&|&/g,l=>l==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.$gw=a;function t(i){return i.replace(/&/g,"&&")}e.$hw=t;function o(i){if(i.endsWith("]")){const s=i.lastIndexOf(" [",i.length-2);if(s!==-1){const l=r(i.substring(0,s)),b=i.substring(s);return{name:l.name+b,parentPath:l.parentPath}}}return r(i)}e.$iw=o;function r(i){const s=i.indexOf("/")!==-1?S.$gc:S.$fc,l=s.basename(i),b=s.dirname(i);return l.length?{name:l,parentPath:b}:{name:b,parentPath:""}}}),define(ae[157],ce([0,1,17,7]),function(X,e,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ln=e.$kn=e.$jn=e.$in=e.$hn=void 0;function S(v){return v.toJSON()}class M{constructor(k){this.a=k}transformIncoming(k){const g=this.a.transformIncoming(k);return g===k?k:S(D.URI.from(g))}transformOutgoing(k){const g=this.a.transformOutgoing(k);return g===k?k:S(D.URI.from(g))}transformOutgoingURI(k){const g=this.a.transformOutgoing(k);return g===k?k:D.URI.from(g)}transformOutgoingScheme(k){return this.a.transformOutgoingScheme(k)}}e.$hn=M,e.$in=new class{transformIncoming(v){return v}transformOutgoing(v){return v}transformOutgoingURI(v){return v}transformOutgoingScheme(v){return v}};function C(v,k,g){if(!v||g>200)return null;if(typeof v=="object"){if(v instanceof D.URI)return k.transformOutgoing(v);for(const m in v)if(Object.hasOwnProperty.call(v,m)){const w=C(v[m],k,g+1);w!==null&&(v[m]=w)}}return null}function P(v,k){const g=C(v,k,0);return g===null?v:g}e.$jn=P;function d(v,k,g,m){if(!v||m>200)return null;if(typeof v=="object"){if(v.$mid===1)return g?D.URI.revive(k.transformIncoming(v)):k.transformIncoming(v);if(v instanceof n.$te)return null;for(const w in v)if(Object.hasOwnProperty.call(v,w)){const p=d(v[w],k,g,m+1);p!==null&&(v[w]=p)}}return null}function c(v,k){const g=d(v,k,!1,0);return g===null?v:g}e.$kn=c;function y(v,k){const g=d(v,k,!0,0);return g===null?v:g}e.$ln=y}),define(ae[89],ce([0,1,26,59,32,147,4]),function(X,e,n,D,S,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pn=e.$on=e.$nn=void 0,e.$nn=new class{c(k){return this.a||(this.a=D.$mi.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(k)}value(){if(this.b===void 0){let k=0,g=0;const m=(0,n.networkInterfaces)();for(const w in m){const p=m[w];if(p)for(const{mac:u,internal:f}of p)f||(g+=1,this.c(u.toUpperCase())&&(k+=1))}this.b=g>0?k/g:0}return this.b}};let P;async function d(k){return P||(P=(async()=>await c(k)||S.$Cg())()),P}e.$on=d;async function c(k){try{const g=await new Promise((w,p)=>{X(["crypto"],w,p)}),m=(0,M.$mn)();return g.createHash("sha256").update(m,"utf8").digest("hex")}catch(g){k(g);return}}const y="Software\\Microsoft\\SQMClient";async function v(k){if(C.$i){const g=await new Promise((m,w)=>{X(["@vscode/windows-registry"],m,w)});try{return g.GetStringRegKey("HKEY_LOCAL_MACHINE",y,"MachineId")||""}catch(m){return k(m),""}}return""}e.$pn=v}),define(ae[21],ce([0,1,46,26,158,8,33,86,9,4,19,7]),function(X,e,n,D,S,M,C,P,d,c,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var k;(function(re){re[re.UNLINK=0]="UNLINK",re[re.MOVE=1]="MOVE"})(k||(e.RimRafMode=k={}));async function g(re,ue=k.UNLINK,Z){if((0,C.$jg)(re))throw new Error("rimraf - will refuse to recursively delete root");return ue===k.UNLINK?w(re):m(re,Z)}async function m(re,ue=(0,C.$og)((0,D.tmpdir)())){try{try{await n.promises.rename(re,ue)}catch(Z){return Z.code==="ENOENT"?void 0:w(re)}w(ue).catch(Z=>{})}catch(Z){if(Z.code!=="ENOENT")throw Z}}async function w(re){return(0,S.promisify)(n.rm)(re,{recursive:!0,force:!0,maxRetries:3})}function p(re){if((0,C.$jg)(re))throw new Error("rimraf - will refuse to recursively delete root");n.rmSync(re,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=p;async function u(re,ue){return $(await(ue?f(re):(0,S.promisify)(n.readdir)(re)))}async function f(re){try{return await(0,S.promisify)(n.readdir)(re,{withFileTypes:!0})}catch(Y){console.warn("[node.js fs] readdir with filetypes failed with error: ",Y)}const ue=[],Z=await u(re);for(const Y of Z){let U=!1,L=!1,N=!1;try{const G=await e.Promises.lstat((0,d.$jc)(re,Y));U=G.isFile(),L=G.isDirectory(),N=G.isSymbolicLink()}catch(G){console.warn("[node.js fs] unexpected error from lstat after readdir: ",G)}ue.push({name:Y,isFile:()=>U,isDirectory:()=>L,isSymbolicLink:()=>N})}return ue}function h(re){return $(n.readdirSync(re))}e.readdirSync=h;function $(re){return re.map(ue=>typeof ue=="string"?c.$j?(0,P.$Rl)(ue):ue:(ue.name=c.$j?(0,P.$Rl)(ue.name):ue.name,ue))}async function a(re){const ue=await u(re),Z=[];for(const Y of ue)await o.existsDirectory((0,d.$jc)(re,Y))&&Z.push(Y);return Z}function t(re,ue=1e3){return new Promise(Z=>{let Y=!1;const U=setInterval(()=>{Y||(Y=!0,n.access(re,L=>{Y=!1,L&&(clearInterval(U),Z(void 0))}))},ue)})}e.whenDeleted=t;var o;(function(re){async function ue(U){let L;try{if(L=await e.Promises.lstat(U),!L.isSymbolicLink())return{stat:L}}catch{}try{return{stat:await e.Promises.stat(U),symbolicLink:L?.isSymbolicLink()?{dangling:!1}:void 0}}catch(N){if(N.code==="ENOENT"&&L)return{stat:L,symbolicLink:{dangling:!0}};if(c.$i&&N.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(U)),symbolicLink:{dangling:!1}}}catch(G){if(G.code==="ENOENT"&&L)return{stat:L,symbolicLink:{dangling:!0}};throw G}throw N}}re.stat=ue;async function Z(U){try{const{stat:L,symbolicLink:N}=await re.stat(U);return L.isFile()&&N?.dangling!==!0}catch{}return!1}re.existsFile=Z;async function Y(U){try{const{stat:L,symbolicLink:N}=await re.stat(U);return L.isDirectory()&&N?.dangling!==!0}catch{}return!1}re.existsDirectory=Y})(o||(e.SymlinkSupport=o={}));const r=new M.$ph;function i(re,ue,Z){return r.queueFor(v.URI.file(re),()=>{const Y=I(Z);return new Promise((U,L)=>b(re,ue,Y,N=>N?L(N):U()))},y.$Kg)}let s=!0;function l(re){s=re}e.configureFlushOnWrite=l;function b(re,ue,Z,Y){if(!s)return n.writeFile(re,ue,{mode:Z.mode,flag:Z.flag},Y);n.open(re,Z.flag,Z.mode,(U,L)=>{if(U)return Y(U);n.writeFile(L,ue,N=>{if(N)return n.close(L,()=>Y(N));n.fdatasync(L,G=>(G&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",G),l(!1)),n.close(L,q=>Y(q))))})})}function R(re,ue,Z){const Y=I(Z);if(!s)return n.writeFileSync(re,ue,{mode:Y.mode,flag:Y.flag});const U=n.openSync(re,Y.flag,Y.mode);try{n.writeFileSync(U,ue);try{n.fdatasyncSync(U)}catch(L){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",L),l(!1)}}finally{n.closeSync(U)}}e.writeFileSync=R;function I(re){return re?{mode:typeof re.mode=="number"?re.mode:438,flag:typeof re.flag=="string"?re.flag:"w"}:{mode:438,flag:"w"}}async function E(re,ue,Z=6e4){if(re!==ue)try{c.$i&&typeof Z=="number"?await A(re,ue,Date.now(),Z):await(0,S.promisify)(n.rename)(re,ue)}catch(Y){if(re.toLowerCase()!==ue.toLowerCase()&&Y.code==="EXDEV"||re.endsWith("."))await j(re,ue,{preserveSymlinks:!1}),await g(re,k.MOVE);else throw Y}}async function A(re,ue,Z,Y,U=0){try{return await(0,S.promisify)(n.rename)(re,ue)}catch(L){if(L.code!=="EACCES"&&L.code!=="EPERM"&&L.code!=="EBUSY")throw L;if(Date.now()-Z>=Y)throw console.error(`[node.js fs] rename failed after ${U} retries with error: ${L}`),L;if(U===0){let N=!1;try{const{stat:G}=await o.stat(ue);G.isFile()||(N=!0)}catch{}if(N)throw L}return await(0,M.$hh)(Math.min(100,U*10)),A(re,ue,Z,Y,U+1)}}async function j(re,ue,Z){return W(re,ue,{root:{source:re,target:ue},options:Z,handledSourcePaths:new Set})}const T=511;async function W(re,ue,Z){if(Z.handledSourcePaths.has(re))return;Z.handledSourcePaths.add(re);const{stat:Y,symbolicLink:U}=await o.stat(re);if(U){if(Z.options.preserveSymlinks)try{return await le(re,ue,Z)}catch{}if(U.dangling)return}return Y.isDirectory()?V(re,ue,Y.mode&T,Z):K(re,ue,Y.mode&T)}async function V(re,ue,Z,Y){await e.Promises.mkdir(ue,{recursive:!0,mode:Z});const U=await u(re);for(const L of U)await W((0,d.$jc)(re,L),(0,d.$jc)(ue,L),Y)}async function K(re,ue,Z){await e.Promises.copyFile(re,ue),await e.Promises.chmod(ue,Z)}async function le(re,ue,Z){let Y=await e.Promises.readlink(re);(0,C.$gg)(Y,Z.root.source,!c.$k)&&(Y=(0,d.$jc)(Z.root.target,Y.substr(Z.root.source.length+1))),await e.Promises.symlink(Y,ue)}e.Promises=new class{get access(){return(0,S.promisify)(n.access)}get stat(){return(0,S.promisify)(n.stat)}get lstat(){return(0,S.promisify)(n.lstat)}get utimes(){return(0,S.promisify)(n.utimes)}get read(){return(re,ue,Z,Y,U)=>new Promise((L,N)=>{n.read(re,ue,Z,Y,U,(G,q,oe)=>G?N(G):L({bytesRead:q,buffer:oe}))})}get readFile(){return(0,S.promisify)(n.readFile)}get write(){return(re,ue,Z,Y,U)=>new Promise((L,N)=>{n.write(re,ue,Z,Y,U,(G,q,oe)=>G?N(G):L({bytesWritten:q,buffer:oe}))})}get appendFile(){return(0,S.promisify)(n.appendFile)}get fdatasync(){return(0,S.promisify)(n.fdatasync)}get truncate(){return(0,S.promisify)(n.truncate)}get copyFile(){return(0,S.promisify)(n.copyFile)}get open(){return(0,S.promisify)(n.open)}get close(){return(0,S.promisify)(n.close)}get symlink(){return(0,S.promisify)(n.symlink)}get readlink(){return(0,S.promisify)(n.readlink)}get chmod(){return(0,S.promisify)(n.chmod)}get mkdir(){return(0,S.promisify)(n.mkdir)}get unlink(){return(0,S.promisify)(n.unlink)}get rmdir(){return(0,S.promisify)(n.rmdir)}get realpath(){return(0,S.promisify)(n.realpath)}async exists(re){try{return await e.Promises.access(re),!0}catch{return!1}}get readdir(){return u}get readDirsInDir(){return a}get writeFile(){return i}get rm(){return g}get rename(){return E}get copy(){return j}}}),define(ae[109],ce([0,1,46,9,4,25,21]),function(X,e,n,D,S,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lq=e.$Kq=e.$Jq=e.$Iq=void 0;function P(k){if(S.$k)return k;const g=(0,D.$mc)(k);if(k===g)return k;const m=((0,D.$nc)(k)||k).toLowerCase();try{const p=(0,C.readdirSync)(g).filter(u=>u.toLowerCase()===m);if(p.length===1){const u=P(g);if(u)return(0,D.$jc)(u,p[0])}else if(p.length>1){const u=p.indexOf(m);if(u>=0){const f=P(g);if(f)return(0,D.$jc)(f,p[u])}}}catch{}return null}e.$Iq=P;async function d(k){if(S.$k)return k;const g=(0,D.$mc)(k);if(k===g)return k;const m=((0,D.$nc)(k)||k).toLowerCase();try{const p=(await C.Promises.readdir(g)).filter(u=>u.toLowerCase()===m);if(p.length===1){const u=await d(g);if(u)return(0,D.$jc)(u,p[0])}else if(p.length>1){const u=p.indexOf(m);if(u>=0){const f=await d(g);if(f)return(0,D.$jc)(f,p[u])}}}catch{}return null}e.$Jq=d;async function c(k){try{return await C.Promises.realpath(k)}catch{const m=v(k);return await C.Promises.access(m,n.constants.R_OK),m}}e.$Kq=c;function y(k){try{return n.realpathSync(k)}catch{const m=v(k);return n.accessSync(m,n.constants.R_OK),m}}e.$Lq=y;function v(k){return(0,M.$5e)((0,D.$hc)(k),D.sep)}}),define(ae[110],ce([0,1,26,9,21]),function(X,e,n,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2l=e.$1l=void 0;const M=/^\d+$/,C=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var d;(function($){$[$.x64=0]="x64",$[$.x86=1]="x86",$[$.ARM=2]="ARM"})(d||(d={}));let c;switch(process.arch){case"ia32":c=1;break;case"arm":case"arm64":c=2;break;default:c=0;break}let y;process.env.PROCESSOR_ARCHITEW6432?y=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?y=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?y=1:y=0;class v{constructor(a,t,o){this.exePath=a,this.displayName=t,this.a=o}async exists(){return this.a===void 0&&(this.a=await S.SymlinkSupport.existsFile(this.exePath)),this.a}}function k({useAlternateBitness:$=!1}={}){return $?c===0?process.env["ProgramFiles(x86)"]||null:y===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function g({useAlternateBitness:$=!1,findPreview:a=!1}={}){const t=k({useAlternateBitness:$});if(!t)return null;const o=D.$jc(t,"PowerShell");if(!await S.SymlinkSupport.existsDirectory(o))return null;let r=-1,i=null;for(const b of await S.Promises.readdir(o)){let R=-1;if(a){const E=b.indexOf("-");if(E<0)continue;const A=b.substring(0,E);if(!M.test(A)||b.substring(E+1)!=="preview")continue;R=parseInt(A,10)}else{if(!M.test(b))continue;R=parseInt(b,10)}if(R<=r)continue;const I=D.$jc(o,b,"pwsh.exe");await S.SymlinkSupport.existsFile(I)&&(i=I,r=R)}if(!i)return null;const s=t.includes("x86")?" (x86)":"",l=a?" Preview":"";return new v(i,`PowerShell${l}${s}`,!0)}async function m({findPreview:$}={}){if(!process.env.LOCALAPPDATA)return null;const a=D.$jc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await S.SymlinkSupport.existsDirectory(a))return null;const{pwshMsixDirRegex:t,pwshMsixName:o}=$?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:C,pwshMsixName:"PowerShell (Store)"};for(const r of await S.Promises.readdir(a))if(t.test(r)){const i=D.$jc(a,r,"pwsh.exe");return new v(i,o)}return null}function w(){const $=D.$jc(n.homedir(),".dotnet","tools","pwsh.exe");return new v($,".NET Core PowerShell Global Tool")}function p(){const $=D.$jc(process.env.windir,c===1&&y!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new v($,"Windows PowerShell",!0)}async function*u(){let $=await g();$&&(yield $),$=await g({useAlternateBitness:!0}),$&&(yield $),$=await m(),$&&(yield $),$=w(),$&&(yield $),$=await g({findPreview:!0}),$&&(yield $),$=await m({findPreview:!0}),$&&(yield $),$=await g({useAlternateBitness:!0,findPreview:!0}),$&&(yield $),$=p(),$&&(yield $)}async function*f(){for await(const $ of u())await $.exists()&&(yield $)}e.$1l=f;async function h(){for await(const $ of f())return $;return null}e.$2l=h}),define(ae[90],ce([0,1,9,4,36,75,12,21]),function(X,e,n,D,S,M,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$6l=e.$5l=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return M.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return M.TerminateResponseCode}});function d(v=S.env){return v.comspec||"cmd.exe"}e.$5l=d;function c(v){let k=[],g=!1;const m=function(w){if(g){k.push(w);return}(!v.send(w,u=>{if(u&&console.error(u),g=!1,k.length>0){const f=k.slice(0);k=[],f.forEach(h=>m(h))}})||D.$i)&&(g=!0)};return{send:m}}e.$6l=c;var y;(function(v){async function k(g,m,w){if(n.$ic(g))return g;if(m===void 0&&(m=S.cwd()),n.$mc(g)!=="."||(w===void 0&&C.$Tf(S.env.PATH)&&(w=S.env.PATH.split(n.$tc)),w===void 0||w.length===0))return n.$jc(m,g);async function u(f){if(await P.Promises.exists(f)){let h;try{h=await P.Promises.stat(f)}catch($){$.message.startsWith("EACCES")&&(h=await P.Promises.lstat(f))}return h?!h.isDirectory():!1}return!1}for(const f of w){let h;if(n.$ic(f)?h=n.$jc(f,g):h=n.$jc(m,f,g),await u(h))return h;let $=h+".com";if(await u($)||($=h+".exe",await u($)))return $}return n.$jc(m,g)}v.findExecutable=k})(y||(e.win32=y={}))}),define(ae[111],ce([0,1,48,13]),function(X,e,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hs=void 0;function S(C){return new Promise((P,d)=>{let c;const y=new Map;function v(g,m,w,p,u){const f=y.get(m);if(g===C||f){const h={name:k(w),cmd:w,pid:g,ppid:m,load:p,mem:u};y.set(g,h),g===C&&(c=h),f&&(f.children||(f.children=[]),f.children.push(h),f.children.length>1&&(f.children=f.children.sort(($,a)=>$.pid-a.pid)))}}function k(g){const m=/--utility-sub-type=network/i,w=/--crashes-directory/i,p=/\\pipe\\winpty-control/i,u=/conhost\.exe.+--headless/i,f=/--type=([a-zA-Z-]+)/;if(w.exec(g))return"electron-crash-reporter";if(p.exec(g))return"winpty-agent";if(u.exec(g))return"conpty-agent";let h=f.exec(g);if(h&&h.length===2)return h[1]==="renderer"?"window":h[1]==="utility"?m.exec(g)?"utility-network-service":"utility-process":h[1]==="extensionHost"?"extension-host":h[1];const $=/[a-zA-Z-]+\.js/g;let a="";do h=$.exec(g),h&&(a+=h+" ");while(h);return a&&g.indexOf("node ")<0&&g.indexOf("node.exe")<0?`electron-nodejs (${a})`:g}if(process.platform==="win32"){const g=m=>m.indexOf("\\\\?\\")===0||m.indexOf("\\??\\")===0?m.substring(4):m.indexOf('"\\\\?\\')===0||m.indexOf('"\\??\\')===0?'"'+m.substring(5):m;new Promise((m,w)=>{X(["@vscode/windows-process-tree"],m,w)}).then(m=>{m.getProcessList(C,w=>{if(!w){d(new Error(`Root process ${C} not found`));return}m.getProcessCpuUsage(w,p=>{const u=new Map;p.forEach(f=>{const h=g(f.commandLine||"");u.set(f.pid,{name:k(h),cmd:h,pid:f.pid,ppid:f.ppid,load:f.cpu||0,mem:f.memory||0})}),c=u.get(C),c?(u.forEach(f=>{const h=u.get(f.ppid);h&&(h.children||(h.children=[]),h.children.push(f))}),u.forEach(f=>{f.children&&(f.children=f.children.sort((h,$)=>h.pid-$.pid))}),P(c)):d(new Error(`Root process ${C} not found`))})},m.ProcessDataFlag.CommandLine|m.ProcessDataFlag.Memory)})}else{let g=function(){let m=[c];const w=[];for(;m.length;){const u=m.shift();u&&(w.push(u.pid),u.children&&(m=m.concat(u.children)))}let p=JSON.stringify(D.$Ag.asFileUri("vs/base/node/cpuUsage.sh").fsPath);p+=" "+w.join(" "),(0,n.exec)(p,{},(u,f,h)=>{if(u||h)d(u||new Error(h.toString()));else{const $=f.toString().split(`
`);for(let a=0;a<w.length;a++){const t=y.get(w[a]);t.load=parseFloat($[a])}if(!c){d(new Error(`Root process ${C} not found`));return}P(c)}})};(0,n.exec)("which ps",{},(m,w,p)=>{if(m||p)if(process.platform!=="linux")d(m||new Error(p.toString()));else{const u=JSON.stringify(D.$Ag.asFileUri("vs/base/node/ps.sh").fsPath);(0,n.exec)(u,{},(f,h,$)=>{f||$?d(f||new Error($.toString())):(M(h,v),g())})}else{const u=w.toString().trim();(0,n.exec)(`${u} -ax -o pid=,ppid=,pcpu=,pmem=,command=`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(h,$,a)=>{h||a&&!a.includes("screen size is bogus")?d(h||new Error(a.toString())):(M($,v),process.platform==="linux"?g():c?P(c):d(new Error(`Root process ${C} not found`)))})}})}})}e.$hs=S;function M(C,P){const d=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,c=C.toString().split(`
`);for(const y of c){const v=d.exec(y.trim());v&&v.length===6&&P(parseInt(v[1]),parseInt(v[2]),v[5],parseFloat(v[3]),parseFloat(v[4]))}}}),define(ae[112],ce([0,1,26,4,110,90]),function(X,e,n,D,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7l=void 0;async function C(v,k){return v===1?D.$i?y():M.$5l(k):d(v,k)}e.$7l=C;let P=null;function d(v,k){if(D.$k&&v===2||D.$j&&v===3)return"/bin/bash";if(!P){let g;if(D.$i)g="/bin/bash";else{if(g=k.SHELL,!g)try{g=(0,n.userInfo)().shell}catch{}g||(g="sh"),g==="/bin/false"&&(g="/bin/bash")}P=g}return P}let c=null;async function y(){return c||(c=(await(0,S.$2l)()).exePath),c}});var ve=this&&this.__decorate||function(X,e,n,D){var S=arguments.length,M=S<3?e:D===null?D=Object.getOwnPropertyDescriptor(e,n):D,C;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")M=Reflect.decorate(X,e,n,D);else for(var P=X.length-1;P>=0;P--)(C=X[P])&&(M=(S<3?C(M):S>3?C(e,n,M):C(e,n))||M);return S>3&&M&&Object.defineProperty(e,n,M),M};define(ae[43],ce([0,1,22,8,17,23,50,15,3,2,76,25,12]),function(X,e,n,D,S,M,C,P,d,c,y,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2h=e.ProxyChannel=e.$1h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.RequestInitiator=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=void 0;var g;(function(U){U[U.Promise=100]="Promise",U[U.PromiseCancel=101]="PromiseCancel",U[U.EventListen=102]="EventListen",U[U.EventDispose=103]="EventDispose"})(g||(g={}));function m(U){switch(U){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var w;(function(U){U[U.Initialize=200]="Initialize",U[U.PromiseSuccess=201]="PromiseSuccess",U[U.PromiseError=202]="PromiseError",U[U.PromiseErrorObj=203]="PromiseErrorObj",U[U.EventFire=204]="EventFire"})(w||(w={}));function p(U){switch(U){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var u;(function(U){U[U.Uninitialized=0]="Uninitialized",U[U.Idle=1]="Idle"})(u||(u={}));function f(U){let L=0;for(let N=0;;N+=7){const G=U.read(1);if(L|=(G.buffer[0]&127)<<N,!(G.buffer[0]&128))return L}}const h=r(0);function $(U,L){if(L===0){U.write(h);return}let N=0;for(let q=L;q!==0;q=q>>>7)N++;const G=S.$te.alloc(N);for(let q=0;L!==0;q++)G.buffer[q]=L&127,L=L>>>7,L>0&&(G.buffer[q]|=128);U.write(G)}class a{constructor(L){this.b=L,this.a=0}read(L){const N=this.b.slice(this.a,this.a+L);return this.a+=N.byteLength,N}}e.$Qh=a;class t{constructor(){this.a=[]}get buffer(){return S.$te.concat(this.a)}write(L){this.a.push(L)}}e.$Rh=t;var o;(function(U){U[U.Undefined=0]="Undefined",U[U.String=1]="String",U[U.Buffer=2]="Buffer",U[U.VSBuffer=3]="VSBuffer",U[U.Array=4]="Array",U[U.Object=5]="Object",U[U.Int=6]="Int"})(o||(o={}));function r(U){const L=S.$te.alloc(1);return L.writeUInt8(U,0),L}const i={Undefined:r(o.Undefined),String:r(o.String),Buffer:r(o.Buffer),VSBuffer:r(o.VSBuffer),Array:r(o.Array),Object:r(o.Object),Uint:r(o.Int)},s=typeof Buffer<"u";function l(U,L){if(typeof L>"u")U.write(i.Undefined);else if(typeof L=="string"){const N=S.$te.fromString(L);U.write(i.String),$(U,N.byteLength),U.write(N)}else if(s&&Buffer.isBuffer(L)){const N=S.$te.wrap(L);U.write(i.Buffer),$(U,N.byteLength),U.write(N)}else if(L instanceof S.$te)U.write(i.VSBuffer),$(U,L.byteLength),U.write(L);else if(Array.isArray(L)){U.write(i.Array),$(U,L.length);for(const N of L)l(U,N)}else if(typeof L=="number"&&(L|0)===L)U.write(i.Uint),$(U,L);else{const N=S.$te.fromString(JSON.stringify(L));U.write(i.Object),$(U,N.byteLength),U.write(N)}}e.$Sh=l;function b(U){switch(U.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return U.read(f(U)).toString();case o.Buffer:return U.read(f(U)).buffer;case o.VSBuffer:return U.read(f(U));case o.Array:{const N=f(U),G=[];for(let q=0;q<N;q++)G.push(b(U));return G}case o.Object:return JSON.parse(U.read(f(U)).toString());case o.Int:return f(U)}}e.$Th=b;class R{constructor(L,N,G=null,q=1e3){this.h=L,this.j=N,this.k=G,this.l=q,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(oe=>this.q(oe)),this.m({type:200})}registerChannel(L,N){this.b.set(L,N),setTimeout(()=>this.w(L),0)}m(L){switch(L.type){case 200:{const N=this.o([L.type]);this.k?.logOutgoing(N,0,1,p(L.type));return}case 201:case 202:case 204:case 203:{const N=this.o([L.type,L.id],L.data);this.k?.logOutgoing(N,L.id,1,p(L.type),L.data);return}}}o(L,N=void 0){const G=new t;return l(G,L),l(G,N),this.p(G.buffer)}p(L){try{return this.h.send(L),L.byteLength}catch{return 0}}q(L){const N=new a(L),G=b(N),q=b(N),oe=G[0];switch(oe){case 100:return this.k?.logIncoming(L.byteLength,G[1],1,`${m(oe)}: ${G[2]}.${G[3]}`,q),this.s({type:oe,id:G[1],channelName:G[2],name:G[3],arg:q});case 102:return this.k?.logIncoming(L.byteLength,G[1],1,`${m(oe)}: ${G[2]}.${G[3]}`,q),this.t({type:oe,id:G[1],channelName:G[2],name:G[3],arg:q});case 101:return this.k?.logIncoming(L.byteLength,G[1],1,`${m(oe)}`),this.u({type:oe,id:G[1]});case 103:return this.k?.logIncoming(L.byteLength,G[1],1,`${m(oe)}`),this.u({type:oe,id:G[1]})}}s(L){const N=this.b.get(L.channelName);if(!N){this.v(L);return}const G=new M.$de;let q;try{q=N.call(this.j,L.name,L.arg,G.token)}catch(J){q=Promise.reject(J)}const oe=L.id;q.then(J=>{this.m({id:oe,data:J,type:201})},J=>{J instanceof Error?this.m({id:oe,data:{message:J.message,name:J.name,stack:J.stack?J.stack.split?J.stack.split(`
`):J.stack:void 0},type:202}):this.m({id:oe,data:J,type:203})}).finally(()=>{he.dispose(),this.d.delete(L.id)});const he=(0,c.$Rc)(()=>G.cancel());this.d.set(L.id,he)}t(L){const N=this.b.get(L.channelName);if(!N){this.v(L);return}const G=L.id,oe=N.listen(this.j,L.name,L.arg)(he=>this.m({id:G,data:he,type:204}));this.d.set(L.id,oe)}u(L){const N=this.d.get(L.id);N&&(N.dispose(),this.d.delete(L.id))}v(L){let N=this.g.get(L.channelName);N||(N=[],this.g.set(L.channelName,N));const G=setTimeout(()=>{console.error(`Unknown channel: ${L.channelName}`),L.type===100&&this.m({id:L.id,data:{name:"Unknown channel",message:`Channel name '${L.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);N.push({request:L,timeoutTimer:G})}w(L){const N=this.g.get(L);if(N){for(const G of N)switch(clearTimeout(G.timeoutTimer),G.request.type){case 100:this.s(G.request);break;case 102:this.t(G.request);break}this.g.delete(L)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,c.$Oc)(this.d.values()),this.d.clear()}}e.$Uh=R;var I;(function(U){U[U.LocalSide=0]="LocalSide",U[U.OtherSide=1]="OtherSide"})(I||(e.RequestInitiator=I={}));class E{constructor(L,N=null){this.l=L,this.a=!1,this.b=u.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new d.$6d,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(G=>this.s(G)),this.j=N}getChannel(L){const N=this;return{call(G,q,oe){return N.a?Promise.reject(new P.$5):N.m(L,G,q,oe)},listen(G,q){return N.a?d.Event.None:N.o(L,G,q)}}}m(L,N,G,q=M.CancellationToken.None){const oe=this.g++,J={id:oe,type:100,channelName:L,name:N,arg:G};if(q.isCancellationRequested)return Promise.reject(new P.$5);let O;return new Promise((x,z)=>{if(q.isCancellationRequested)return z(new P.$5);const Q=()=>{const te=ie=>{switch(ie.type){case 201:this.f.delete(oe),x(ie.data);break;case 202:{this.f.delete(oe);const de=new Error(ie.data.message);de.stack=Array.isArray(ie.data.stack)?ie.data.stack.join(`
`):ie.data.stack,de.name=ie.data.name,z(de);break}case 203:this.f.delete(oe),z(ie.data);break}};this.f.set(oe,te),this.p(J)};let H=null;this.b===u.Idle?Q():(H=(0,D.$6g)(te=>this.u()),H.then(()=>{H=null,Q()}));const _=()=>{H?(H.cancel(),H=null):this.p({id:oe,type:101}),z(new P.$5)},B=q.onCancellationRequested(_);O=(0,c.$Qc)((0,c.$Rc)(_),B),this.d.add(O)}).finally(()=>{O.dispose(),this.d.delete(O)})}o(L,N,G){const q=this.g++,he={id:q,type:102,channelName:L,name:N,arg:G};let J=null;const O=new d.$6d({onWillAddFirstListener:()=>{J=(0,D.$6g)(x=>this.u()),J.then(()=>{J=null,this.d.add(O),this.p(he)})},onDidRemoveLastListener:()=>{J?(J.cancel(),J=null):(this.d.delete(O),this.p({id:q,type:103}))}}),F=x=>O.fire(x.data);return this.f.set(q,F),O.event}p(L){switch(L.type){case 100:case 102:{const N=this.q([L.type,L.id,L.channelName,L.name],L.arg);this.j?.logOutgoing(N,L.id,0,`${m(L.type)}: ${L.channelName}.${L.name}`,L.arg);return}case 101:case 103:{const N=this.q([L.type,L.id]);this.j?.logOutgoing(N,L.id,0,m(L.type));return}}}q(L,N=void 0){const G=new t;return l(G,L),l(G,N),this.r(G.buffer)}r(L){try{return this.l.send(L),L.byteLength}catch{return 0}}s(L){const N=new a(L),G=b(N),q=b(N),oe=G[0];switch(oe){case 200:return this.j?.logIncoming(L.byteLength,0,0,p(oe)),this.t({type:G[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(L.byteLength,G[1],0,p(oe),q),this.t({type:G[0],id:G[1],data:q})}}t(L){if(L.type===200){this.b=u.Idle,this.k.fire();return}this.f.get(L.id)?.(L)}get onDidInitializePromise(){return d.Event.toPromise(this.onDidInitialize)}u(){return this.b===u.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,c.$Oc)(this.d.values()),this.d.clear()}}e.$Vh=E,ve([C.$Kh],E.prototype,"onDidInitializePromise",null);class A{get connections(){const L=[];return this.f.forEach(N=>L.push(N)),L}constructor(L){this.a=new Map,this.f=new Set,this.g=new d.$6d,this.onDidAddConnection=this.g.event,this.h=new d.$6d,this.onDidRemoveConnection=this.h.event,this.j=new c.$Sc,this.j.add(L(({protocol:N,onDidClientDisconnect:G})=>{const q=d.Event.once(N.onMessage);this.j.add(q(oe=>{const he=new a(oe),J=b(he),O=new R(N,J),F=new E(N);this.a.forEach((z,Q)=>O.registerChannel(Q,z));const x={channelServer:O,channelClient:F,ctx:J};this.f.add(x),this.g.fire(x),this.j.add(G(()=>{O.dispose(),F.dispose(),this.f.delete(x),this.h.fire(x)}))}))}))}getChannel(L,N){const G=this;return{call(q,oe,he){let J;if((0,k.$8f)(N)){const F=(0,n.$4b)(G.connections.filter(N));J=F?Promise.resolve(F):d.Event.toPromise(d.Event.filter(G.onDidAddConnection,N))}else J=N.routeCall(G,q,oe);const O=J.then(F=>F.channelClient.getChannel(L));return T(O).call(q,oe,he)},listen(q,oe){if((0,k.$8f)(N))return G.k(L,N,q,oe);const he=N.routeEvent(G,q,oe).then(J=>J.channelClient.getChannel(L));return T(he).listen(q,oe)}}}k(L,N,G,q){const oe=this;let he;const J=new d.$6d({onWillAddFirstListener:()=>{he=new c.$Sc;const O=new d.$_d,F=new Map,x=Q=>{const _=Q.channelClient.getChannel(L).listen(G,q),B=O.add(_);F.set(Q,B)},z=Q=>{const H=F.get(Q);H&&(H.dispose(),F.delete(Q))};oe.connections.filter(N).forEach(x),d.Event.filter(oe.onDidAddConnection,N)(x,void 0,he),oe.onDidRemoveConnection(z,void 0,he),O.event(J.fire,J,he),he.add(O)},onDidRemoveLastListener:()=>{he?.dispose(),he=void 0}});return J.event}registerChannel(L,N){this.a.set(L,N);for(const G of this.f)G.channelServer.registerChannel(L,N)}dispose(){this.j.dispose();for(const L of this.f)L.channelClient.dispose(),L.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$Wh=A;class j{constructor(L,N,G=null){const q=new t;l(q,N),L.send(q.buffer),this.a=new E(L,G),this.d=new R(L,N,G)}getChannel(L){return this.a.getChannel(L)}registerChannel(L,N){this.d.registerChannel(L,N)}dispose(){this.a.dispose(),this.d.dispose()}}e.$Xh=j;function T(U){return{call(L,N,G){return U.then(q=>q.call(L,N,G))},listen(L,N){const G=new d.$ce;return U.then(q=>G.input=q.listen(L,N)),G.event}}}e.$Yh=T;function W(U){let L=!1;return{call(N,G,q){return L?U.call(N,G,q):(0,D.$hh)(0).then(()=>L=!0).then(()=>U.call(N,G,q))},listen(N,G){if(L)return U.listen(N,G);const q=new d.$ce;return(0,D.$hh)(0).then(()=>L=!0).then(()=>q.input=U.listen(N,G)),q.event}}}e.$Zh=W;class V{constructor(L){this.a=L}routeCall(L){return this.b(L)}routeEvent(L){return this.b(L)}async b(L){for(const N of L.connections)if(await Promise.resolve(this.a(N.ctx)))return Promise.resolve(N);return await d.Event.toPromise(L.onDidAddConnection),await this.b(L)}}e.$1h=V;var K;(function(U){function L(oe,he,J){const O=oe,F=J&&J.disableMarshalling,x=new Map;for(const z in O)G(z)&&x.set(z,d.Event.buffer(O[z],!0,void 0,he));return new class{listen(z,Q,H){const _=x.get(Q);if(_)return _;const B=O[Q];if(typeof B=="function"){if(q(Q))return B.call(O,H);if(G(Q))return x.set(Q,d.Event.buffer(O[Q],!0,void 0,he)),x.get(Q)}throw new P.$bb(`Event not found: ${Q}`)}call(z,Q,H){const _=O[Q];if(typeof _=="function"){if(!F&&Array.isArray(H))for(let te=0;te<H.length;te++)H[te]=(0,y.$Ph)(H[te]);let B=_.apply(O,H);return B instanceof Promise||(B=Promise.resolve(B)),B}throw new P.$bb(`Method not found: ${Q}`)}}}U.fromService=L;function N(oe,he){const J=he&&he.disableMarshalling;return new Proxy({},{get(O,F){if(typeof F=="string")return he?.properties?.has(F)?he.properties.get(F):q(F)?function(x){return oe.listen(F,x)}:G(F)?oe.listen(F):async function(...x){let z;he&&!(0,k.$3f)(he.context)?z=[he.context,...x]:z=x;const Q=await oe.call(F,z);return J?Q:(0,y.$Ph)(Q)};throw new P.$bb(`Property not found: ${String(F)}`)}})}U.toService=N;function G(oe){return oe[0]==="o"&&oe[1]==="n"&&v.$jf(oe.charCodeAt(2))}function q(oe){return/^onDynamic/.test(oe)&&v.$jf(oe.charCodeAt(9))}})(K||(e.ProxyChannel=K={}));const le=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function re(U){if(Array.isArray(U))return U;if(U&&typeof U=="object"&&typeof U.toString=="function"){const L=U.toString();if(L!=="[object Object]")return L}return U}function ue(U){return Array.isArray(U)?U.map(re):re(U)}function Z(U,L,N,G,q,oe,he){he=ue(he);const J=le[q],O=J[G%J.length];let F=[`%c[${U}]%c[${String(L).padStart(7," ")}]%c[len: ${String(N).padStart(5," ")}]%c${String(G).padStart(5," ")} - ${oe}`,"color: darkgreen","color: grey","color: grey",`color: ${O}`];/\($/.test(oe)?(F=F.concat(he),F.push(")")):F.push(he),console.log.apply(console,F)}class Y{constructor(L,N){this.d=L,this.f=N,this.a=0,this.b=0}logOutgoing(L,N,G,q,oe){this.b+=L,Z(this.d,this.b,L,N,G,q,oe)}logIncoming(L,N,G,q,oe){this.a+=L,Z(this.f,this.a,L,N,G,q,oe)}}e.$2h=Y}),define(ae[159],ce([0,1,17,3,43]),function(X,e,n,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VV=e.$UV=void 0;class M{constructor(d){this.a=d,this.onMessage=D.Event.fromDOMEventEmitter(this.a,"message",c=>c.data?n.$te.wrap(c.data):n.$te.alloc(0)),d.start()}send(d){this.a.postMessage(d.buffer)}disconnect(){this.a.close()}}e.$UV=M;class C extends S.$Xh{constructor(d,c){const y=new M(d);super(y,c),this.b=y}dispose(){this.b.disconnect(),super.dispose()}}e.$VV=C}),define(ae[113],ce([0,1,17,3,2,43]),function(X,e,n,D,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7h=e.$6h=e.$5h=e.$4h=e.ProtocolConstants=e.$3h=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var C;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(C||(e.SocketDiagnosticsEventType=C={}));var P;(function(i){i.enableDiagnostics=!1,i.records=[];const s=new WeakMap;let l=0;function b(I,E){if(!s.has(I)){const A=String(++l);s.set(I,A)}return s.get(I)}function R(I,E,A,j){if(!i.enableDiagnostics)return;const T=b(I,E);if(j instanceof n.$te||j instanceof Uint8Array||j instanceof ArrayBuffer||ArrayBuffer.isView(j)){const W=n.$te.alloc(j.byteLength);W.set(j),i.records.push({timestamp:Date.now(),id:T,label:E,type:A,buff:W})}else i.records.push({timestamp:Date.now(),id:T,label:E,type:A,data:j})}i.traceSocketEvent=R})(P||(e.SocketDiagnostics=P={}));var d;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(d||(e.SocketCloseEventType=d={}));let c=null;function y(){return c||(c=n.$te.alloc(0)),c}class v{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(s){this.a.push(s),this.b+=s.byteLength}read(s){return this.c(s,!0)}peek(s){return this.c(s,!1)}c(s,l){if(s===0)return y();if(s>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===s){const E=this.a[0];return l&&(this.a.shift(),this.b-=s),E}if(this.a[0].byteLength>s){const E=this.a[0].slice(0,s);return l&&(this.a[0]=this.a[0].slice(s),this.b-=s),E}const b=n.$te.alloc(s);let R=0,I=0;for(;s>0;){const E=this.a[I];if(E.byteLength>s){const A=E.slice(0,s);b.set(A,R),R+=s,l&&(this.a[I]=E.slice(s),this.b-=s),s-=s}else b.set(E,R),R+=E.byteLength,l?(this.a.shift(),this.b-=E.byteLength):I++,s-=E.byteLength}return b}}e.$3h=v;var k;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume",i[i.KeepAlive=9]="KeepAlive"})(k||(k={}));function g(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var m;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",i[i.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(m||(e.ProtocolConstants=m={}));class w{constructor(s,l,b,R){this.type=s,this.id=l,this.ack=b,this.data=R,this.writtenTime=0}get size(){return this.data.byteLength}}class p extends S.$Tc{constructor(s){super(),this.f=this.B(new D.$6d),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=s,this.b=!1,this.c=new v,this.B(this.a.onData(l=>this.acceptChunk(l))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(s);this.c.byteLength>=this.g.readLen;){const l=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=l.readUInt32BE(9),this.g.messageType=l.readUInt8(0),this.g.id=l.readUInt32BE(1),this.g.ack=l.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:g(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const b=this.g.messageType,R=this.g.id,I=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",l),this.f.fire(new w(b,R,I,l)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class u{constructor(s){this.k=null,this.a=!1,this.b=!1,this.c=s,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(s){if(this.a)return;s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const l=n.$te.alloc(13);l.writeUInt8(s.type,0),l.writeUInt32BE(s.id,1),l.writeUInt32BE(s.ack,5),l.writeUInt32BE(s.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:g(s.type),id:s.id,ack:s.ack,messageSize:s.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",s.data),this.j(l,s.data)}g(s,l){const b=this.f===0;return this.d.push(s,l),this.f+=s.byteLength+l.byteLength,b}h(){const s=n.$te.concat(this.d,this.f);return this.d.length=0,this.f=0,s}j(s,l){this.g(s,l)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const s=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:s.byteLength}),this.c.write(s)}}class f extends S.$Tc{constructor(s){super(),this.f=new D.$6d,this.onMessage=this.f.event,this.g=new D.$6d,this.onDidDispose=this.g.event,this.a=s,this.b=this.B(new u(this.a)),this.c=this.B(new p(this.a)),this.B(this.c.onMessage(l=>{l.type===1&&this.f.fire(l.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(s){this.b.write(new w(1,0,0,s))}}e.$4h=f;class h extends M.$Xh{static fromSocket(s,l){return new h(new f(s),l)}get onDidDispose(){return this.b.onDidDispose}constructor(s,l,b=null){super(s,l,b),this.b=s}dispose(){super.dispose();const s=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),s.end()}}e.$5h=h;class ${constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new D.$6d({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(s){this.b?this.d.length>0?this.d.push(s):this.a.fire(s):this.d.push(s)}flushBuffer(){this.d=[]}}e.$6h=$;class a{constructor(s){this.data=s,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let s=0,l=this.a;for(;l;)l=l.next,s++;return s}peek(){return this.a?this.a.data:null}toArray(){const s=[];let l=0,b=this.a;for(;b;)s[l++]=b.data,b=b.next;return s}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(s){const l=new a(s);if(!this.a){this.a=l,this.b=l;return}this.b.next=l,this.b=l}}class o{static{this.a=10}static{this.b=null}static getInstance(){return o.b||(o.b=new o),o.b}constructor(){this.c=[];const s=Date.now();for(let l=0;l<o.a;l++)this.c[l]=s-1e3*l;setInterval(()=>{for(let l=o.a;l>=1;l--)this.c[l]=this.c[l-1];this.c[0]=Date.now()},1e3)}d(){const s=Date.now(),l=(1+o.a)*1e3;let b=0;for(let R=0;R<o.a;R++)s-this.c[R]<=l&&b++;return 1-b/o.a}hasHighLoad(){return this.d()>=.5}}class r{get unacknowledgedCount(){return this.c-this.d}constructor(s){this.u=new $,this.onControlMessage=this.u.event,this.v=new $,this.onMessage=this.v.event,this.w=new $,this.onDidDispose=this.w.event,this.x=new $,this.onSocketClose=this.x.event,this.y=new $,this.onSocketTimeout=this.y.event,this.s=s.loadEstimator??o.getInstance(),this.t=s.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new S.$Sc,this.o=s.socket,this.p=this.r.add(new u(this.o)),this.q=this.r.add(new p(this.o)),this.r.add(this.q.onMessage(l=>this.z(l))),this.r.add(this.o.onClose(l=>this.x.fire(l))),s.initialChunk&&this.q.acceptChunk(s.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const s=new w(5,0,0,y());this.p.write(s),this.p.flush()}sendPause(){const s=new w(7,0,0,y());this.p.write(s)}sendResume(){const s=new w(8,0,0,y());this.p.write(s)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(s,l){this.a=!0,this.r.dispose(),this.r=new S.$Sc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=s,this.p=this.r.add(new u(this.o)),this.q=this.r.add(new p(this.o)),this.r.add(this.q.onMessage(b=>this.z(b))),this.r.add(this.o.onClose(b=>this.x.fire(b))),this.q.acceptChunk(l)}endAcceptReconnection(){this.a=!1,this.h=this.g;const s=new w(3,0,this.h,y());this.p.write(s);const l=this.b.toArray();for(let b=0,R=l.length;b<R;b++)this.p.write(l[b]);this.B()}acceptDisconnect(){this.w.fire()}z(s){if(s.ack>this.d){this.d=s.ack;do{const l=this.b.peek();if(l&&l.id<=s.ack)this.b.pop();else break}while(!0)}switch(s.type){case 0:break;case 1:{if(s.id>this.g)if(s.id!==this.g+1){const l=Date.now();l-this.m>1e4&&(this.m=l,this.p.write(new w(6,0,0,y())))}else this.g=s.id,this.j=Date.now(),this.A(),this.v.fire(s.data);break}case 2:{this.u.fire(s.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const l=this.b.toArray();for(let b=0,R=l.length;b<R;b++)this.p.write(l[b]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(s){const l=++this.c;this.h=this.g;const b=new w(1,l,this.h,s);this.b.push(b),this.a||(this.p.write(b),this.B())}sendControl(s){const l=new w(2,0,0,s);this.p.write(l)}A(){if(this.g<=this.h||this.k)return;const s=Date.now()-this.j;if(s>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-s+5)}B(){if(this.c<=this.d||this.f||this.a)return;const s=this.b.peek(),l=Date.now()-s.writtenTime,b=Date.now()-this.q.lastReadTime,R=Date.now()-this.n;if(l>=2e4&&b>=2e4&&R>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:l,timeSinceLastReceivedSomeData:b});return}const I=Math.max(2e4-l,2e4-b,2e4-R,500);this.f=setTimeout(()=>{this.f=null,this.B()},I)}C(){if(this.g<=this.h)return;this.h=this.g;const s=new w(3,0,this.h,y());this.p.write(s)}D(){this.h=this.g;const s=new w(9,0,this.h,y());this.p.write(s)}}e.$7h=r}),define(ae[37],ce([0,1,14,15,13]),function(X,e,n,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RV=void 0;class M{constructor(){this.a=new WeakMap}on(P,d){const c=(y,...v)=>{this.b(P,y)&&d(y,...v)};return this.a.set(d,c),n.ipcMain.on(P,c),this}once(P,d){return n.ipcMain.once(P,(c,...y)=>{this.b(P,c)&&d(c,...y)}),this}handle(P,d){return n.ipcMain.handle(P,(c,...y)=>this.b(P,c)?d(c,...y):Promise.reject(`Invalid channel '${P}' or sender for ipcMain.handle() usage.`)),this}removeHandler(P){return n.ipcMain.removeHandler(P),this}removeListener(P,d){const c=this.a.get(d);return c&&(n.ipcMain.removeListener(P,c),this.a.delete(d)),this}b(P,d){if(!P||!P.startsWith("vscode:"))return(0,D.$1)(`Refused to handle ipcMain event for channel '${P}' because the channel is unknown.`),!1;const c=d.senderFrame,y=c.url;if(!y||y==="about:blank")return!0;let v="unknown";try{v=new URL(y).host}catch{return(0,D.$1)(`Refused to handle ipcMain event for channel '${P}' because of a malformed URL '${y}'.`),!1}return v!==S.$zg?((0,D.$1)(`Refused to handle ipcMain event for channel '${P}' because of a bad origin of '${v}'.`),!1):c.parent!==null?((0,D.$1)(`Refused to handle ipcMain event for channel '${P}' because sender of origin '${v}' is not a main frame.`),!1):!0}}e.$RV=new M}),define(ae[160],ce([0,1,14,37,148]),function(X,e,n,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SV=void 0;function M(){D.$RV.on(S.$PV,(P,d,c,y,v)=>{const k=C(P,y,c);k.popup({x:v?v.x:void 0,y:v?v.y:void 0,positioningItem:v?v.positioningItem:void 0,callback:()=>{k&&P.sender.send(S.$QV,d)}})})}e.$SV=M;function C(P,d,c){const y=new n.Menu;return c.forEach(v=>{let k;v.type==="separator"?k=new n.MenuItem({type:v.type}):Array.isArray(v.submenu)?k=new n.MenuItem({submenu:C(P,d,v.submenu),label:v.label}):k=new n.MenuItem({label:v.label,type:v.type,accelerator:v.accelerator,checked:v.checked,enabled:v.enabled,visible:v.visible,click:(g,m,w)=>P.sender.send(d,v.id,w)}),y.append(k)}),y}}),define(ae[161],ce([0,1,37,17,3,2,43,149]),function(X,e,n,D,S,M,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YV=void 0;function d(y,v){const k=S.Event.fromNodeEventEmitter(n.$RV,v,(m,w)=>({event:m,message:w})),g=S.Event.filter(k,({event:m})=>m.sender.id===y);return S.Event.map(g,({message:m})=>m&&D.$te.wrap(m))}class c extends C.$Wh{static{this.b=new Map}static d(){const v=S.Event.fromNodeEventEmitter(n.$RV,"vscode:hello",({sender:k})=>k);return S.Event.map(v,k=>{const g=k.id;c.b.get(g)?.dispose();const w=new S.$6d;c.b.set(g,(0,M.$Rc)(()=>w.fire()));const p=d(g,"vscode:message"),u=S.Event.any(S.Event.signal(d(g,"vscode:disconnect")),w.event);return{protocol:new P.$XV(k,p),onDidClientDisconnect:u}})}constructor(){super(c.d())}}e.$YV=c}),define(ae[114],ce([0,1,37,3,32,159]),function(X,e,n,D,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1V=e.$ZV=void 0;class C extends M.$VV{constructor(c,y){super({addEventListener:(v,k)=>c.addListener(v,k),removeEventListener:(v,k)=>c.removeListener(v,k),postMessage:v=>c.postMessage(v),start:()=>c.start(),close:()=>c.close()},y)}}e.$ZV=C;async function P(d){if(d.isDestroyed()||d.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const c=(0,S.$Cg)();d.webContents.send("vscode:createMessageChannel",c);const y=D.Event.fromNodeEventEmitter(n.$RV,"vscode:createMessageChannelResult",(k,g)=>({nonce:g,port:k.ports[0]})),{port:v}=await D.Event.toPromise(D.Event.once(D.Event.filter(y,k=>k.nonce===c)));return v}e.$1V=P}),define(ae[162],ce([0,1,48,8,17,23,156,15,3,2,35,90,75,43]),function(X,e,n,D,S,M,C,P,d,c,y,v,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gq=e.$Fq=void 0;class m extends g.$Uh{constructor(u){super({send:f=>{try{process.send?.(f.buffer.toString("base64"))}catch{}},onMessage:d.Event.fromNodeEventEmitter(process,"message",f=>S.$te.wrap(Buffer.from(f,"base64")))},u),process.once("disconnect",()=>this.dispose())}}e.$Fq=m;class w{constructor(u,f){this.i=u,this.j=f,this.c=new Set,this.g=new Map,this.h=new d.$6d,this.onDidProcessExit=this.h.event;const h=f&&f.timeout?f.timeout:6e4;this.b=new D.$dh(h),this.d=null,this.f=null}getChannel(u){const f=this;return{call(h,$,a){return f.k(u,h,$,a)},listen(h,$){return f.l(u,h,$)}}}k(u,f,h,$=M.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if($.isCancellationRequested)return Promise.reject(P.$6());this.b.cancel();const a=this.n(u),t=(0,D.$6g)(i=>a.call(f,h,i)),o=$.onCancellationRequested(()=>t.cancel()),r=(0,c.$Rc)(()=>t.cancel());return this.c.add(r),t.finally(()=>{o.dispose(),this.c.delete(r),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(u,f,h){if(!this.b)return d.Event.None;this.b.cancel();let $;const a=new d.$6d({onWillAddFirstListener:()=>{$=this.n(u).listen(f,h)(a.fire,a),this.c.add($)},onDidRemoveLastListener:()=>{this.c.delete($),$.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return a.event}get m(){if(!this.f){const u=this.j&&this.j.args?this.j.args:[],f=Object.create(null);f.env={...(0,y.$Ln)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(f.env={...f.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(f.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(f.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(f.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),f.execArgv===void 0&&(f.execArgv=process.execArgv.filter(s=>!/^--inspect(-brk)?=/.test(s)).filter(s=>!s.startsWith("--vscode-"))),(0,k.$4l)(f.env),this.d=(0,n.fork)(this.i,u,f);const h=new d.$6d;d.Event.fromNodeEventEmitter(this.d,"message",s=>s)(s=>{if((0,C.$Bq)(s)){(0,C.log)(s,`IPC Library: ${this.j.serverName}`);return}h.fire(S.$te.wrap(Buffer.from(s,"base64")))});const a=this.j.useQueue?(0,v.$6l)(this.d):this.d,t=s=>this.d&&this.d.connected&&a.send(s.buffer.toString("base64")),o=h.event,r={send:t,onMessage:o};this.f=new g.$Vh(r);const i=()=>this.o();process.once("exit",i),this.d.on("error",s=>console.warn('IPC "'+this.j.serverName+'" errored with '+s)),this.d.on("exit",(s,l)=>{process.removeListener("exit",i),this.c.forEach(b=>(0,c.$Oc)(b)),this.c.clear(),s!==0&&l!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+s+" and signal "+l),this.b?.cancel(),this.o(),this.h.fire({code:s,signal:l})})}return this.f}n(u){let f=this.g.get(u);return f||(f=this.m.getChannel(u),this.g.set(u,f)),f}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$Gq=w}),define(ae[115],ce([0,1,8,3,2,76,12]),function(X,e,n,D,S,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gp=e.$Fp=e.StorageState=e.$Ep=e.StorageHint=void 0;var P;(function(k){k[k.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",k[k.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(P||(e.StorageHint=P={}));function d(k){const g=k;return g?.changed instanceof Map||g?.deleted instanceof Set}e.$Ep=d;var c;(function(k){k[k.None=0]="None",k[k.Initialized=1]="Initialized",k[k.Closed=2]="Closed"})(c||(e.StorageState=c={}));class y extends S.$Tc{static{this.a=100}constructor(g,m=Object.create(null)){super(),this.r=g,this.s=m,this.b=this.B(new D.$9d),this.onDidChangeStorage=this.b.event,this.c=c.None,this.f=new Map,this.g=this.B(new n.$eh(y.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(g=>this.u(g)))}u(g){this.b.pause();try{g.changed?.forEach((m,w)=>this.w(w,m)),g.deleted?.forEach(m=>this.w(m,void 0))}finally{this.b.resume()}}w(g,m){if(this.c===c.Closed)return;let w=!1;(0,C.$3f)(m)?w=this.f.delete(g):this.f.get(g)!==m&&(this.f.set(g,m),w=!0),w&&this.b.fire({key:g,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===c.None&&(this.c=c.Initialized,this.s.hint!==P.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(g,m){const w=this.f.get(g);return(0,C.$3f)(w)?m:w}getBoolean(g,m){const w=this.get(g);return(0,C.$3f)(w)?m:w==="true"}getNumber(g,m){const w=this.get(g);return(0,C.$3f)(w)?m:parseInt(w,10)}getObject(g,m){const w=this.get(g);return(0,C.$3f)(w)?m:(0,M.$Oh)(w)}async set(g,m,w=!1){if(this.c===c.Closed)return;if((0,C.$3f)(m))return this.delete(g,w);const p=(0,C.$Vf)(m)||Array.isArray(m)?(0,M.$Nh)(m):String(m);if(this.f.get(g)!==p)return this.f.set(g,p),this.j.set(g,p),this.h.delete(g),this.b.fire({key:g,external:w}),this.D()}async delete(g,m=!1){if(!(this.c===c.Closed||!this.f.delete(g)))return this.h.has(g)||this.h.add(g),this.j.delete(g),this.b.fire({key:g,external:m}),this.D()}async optimize(){if(this.c!==c.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=c.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const g={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(g).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(g){if(this.z)return this.D(g)}async D(g){return this.s.hint===P.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),g)}async whenFlushed(){if(this.z)return new Promise(g=>this.n.push(g))}isInMemory(){return this.s.hint===P.STORAGE_IN_MEMORY}}e.$Fp=y;class v{constructor(){this.onDidChangeItemsExternal=D.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(g){g.insert?.forEach((m,w)=>this.a.set(w,m)),g.delete?.forEach(m=>this.a.delete(m))}async optimize(){}async close(){}}e.$Gp=v}),define(ae[163],ce([0,1,8,3,31,9,21]),function(X,e,n,D,S,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kW=void 0;class P{static{this.IN_MEMORY_PATH=":memory:"}get onDidChangeItemsExternal(){return D.Event.None}static{this.a=2e3}static{this.b=256}constructor(y,v=Object.create(null)){this.g=y,this.h=v,this.c=(0,M.$nc)(this.g),this.d=new d(this.h.logging),this.f=this.n(this.g)}async getItems(){const y=await this.f,v=new Map;return(await this.s(y,"SELECT * FROM ItemTable")).forEach(g=>v.set(g.key,g.value)),this.d.isTracing&&this.d.trace(`[storage ${this.c}] getItems(): ${v.size} rows`),v}async updateItems(y){const v=await this.f;return this.j(v,y)}j(y,v){return this.d.isTracing&&this.d.trace(`[storage ${this.c}] updateItems(): insert(${v.insert?(0,S.$yc)(v.insert):"0"}), delete(${v.delete?(0,S.$zc)(v.delete):"0"})`),this.t(y,()=>{const k=v.insert,g=v.delete;if(k&&k.size>0){const m=[];m.push([]);let w=0;k.forEach((p,u)=>{let f=m[w];f.length>P.b&&(w++,f=[],m.push(f)),f.push(u,p)}),m.forEach(p=>{this.u(y,`INSERT INTO ItemTable VALUES ${new Array(p.length/2).fill("(?,?)").join(",")}`,u=>u.run(p),()=>{const u=[];let f=0;return k.forEach((h,$)=>{u.push($),f+=h.length}),`Keys: ${u.join(", ")} Length: ${f}`})})}if(g&&g.size){const m=[];m.push([]);let w=0;g.forEach(p=>{let u=m[w];u.length>P.b&&(w++,u=[],m.push(u)),u.push(p)}),m.forEach(p=>{this.u(y,`DELETE FROM ItemTable WHERE key IN (${new Array(p.length).fill("?").join(",")})`,u=>u.run(p),()=>{const u=[];return g.forEach(f=>{u.push(f)}),`Keys: ${u.join(", ")}`})})}})}async optimize(){this.d.trace(`[storage ${this.c}] vacuum()`);const y=await this.f;return this.q(y,"VACUUM")}async close(y){this.d.trace(`[storage ${this.c}] close()`);const v=await this.f;return this.k(v,y)}k(y,v){return new Promise((k,g)=>{y.db.close(m=>(m&&this.o(y,`[storage ${this.c}] close(): ${m}`),this.g===P.IN_MEMORY_PATH?k():!y.isErroneous&&!y.isInMemory?this.l().then(k,w=>(this.d.error(`[storage ${this.c}] backup(): ${w}`),k())):typeof v=="function"?C.Promises.unlink(this.g).then(()=>this.p(this.g).then(w=>{const p=()=>this.k(w,void 0);return this.j(w,{insert:v()}).then(()=>p(),u=>(p(),Promise.reject(u)))})).then(k,g):g(m||new Error("Database has errors or is in-memory without recovery option"))))})}l(){const y=this.m(this.g);return C.Promises.copy(this.g,y,{preserveSymlinks:!1})}m(y){return`${y}.backup`}async checkIntegrity(y){this.d.trace(`[storage ${this.c}] checkIntegrity(full: ${y})`);const v=await this.f,k=await this.r(v,y?"PRAGMA integrity_check":"PRAGMA quick_check"),g=y?k.integrity_check:k.quick_check;return v.isErroneous?`${g} (last error: ${v.lastError})`:v.isInMemory?`${g} (in-memory!)`:g}async n(y,v=!0){this.d.trace(`[storage ${this.c}] open(${y}, retryOnBusy: ${v})`);try{return await this.p(y)}catch(k){if(this.d.error(`[storage ${this.c}] open(): Unable to open DB due to ${k}`),k.code==="SQLITE_BUSY"&&v)return await(0,n.$hh)(P.a),this.n(y,!1);try{await C.Promises.unlink(y);try{await C.Promises.rename(this.m(y),y,!1)}catch{}return await this.p(y)}catch(g){return this.d.error(`[storage ${this.c}] open(): Unable to use backup due to ${g}`),this.p(P.IN_MEMORY_PATH)}}}o(y,v){y.isErroneous=!0,y.lastError=v,this.d.error(v)}p(y){return new Promise((v,k)=>{new Promise((g,m)=>{X(["@vscode/sqlite3"],g,m)}).then(g=>{const m={db:new(this.d.isTracing?g.verbose().Database:g.Database)(y,w=>w?m.db&&w.code!=="SQLITE_CANTOPEN"?m.db.close(()=>k(w)):k(w):this.q(m,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>v(m),p=>m.db.close(()=>k(p)))),isInMemory:y===P.IN_MEMORY_PATH};m.db.on("error",w=>this.o(m,`[storage ${this.c}] Error (event): ${w}`)),this.d.isTracing&&m.db.on("trace",w=>this.d.trace(`[storage ${this.c}] Trace (event): ${w}`))},k)})}q(y,v){return new Promise((k,g)=>{y.db.exec(v,m=>m?(this.o(y,`[storage ${this.c}] exec(): ${m}`),g(m)):k())})}r(y,v){return new Promise((k,g)=>{y.db.get(v,(m,w)=>m?(this.o(y,`[storage ${this.c}] get(): ${m}`),g(m)):k(w))})}s(y,v){return new Promise((k,g)=>{y.db.all(v,(m,w)=>m?(this.o(y,`[storage ${this.c}] all(): ${m}`),g(m)):k(w))})}t(y,v){return new Promise((k,g)=>{y.db.serialize(()=>{y.db.run("BEGIN TRANSACTION"),v(),y.db.run("END TRANSACTION",m=>m?(this.o(y,`[storage ${this.c}] transaction(): ${m}`),g(m)):k())})})}u(y,v,k,g){const m=y.db.prepare(v),w=p=>{this.o(y,`[storage ${this.c}] prepare(): ${p} (${v}). Details: ${g()}`)};m.on("error",w),k(m),m.finalize(p=>{p&&w(p),m.removeListener("error",w)})}}e.$kW=P;class d{static{this.a="VSCODE_TRACE_STORAGE"}constructor(y){y&&typeof y.logTrace=="function"&&process.env[d.a]&&(this.b=y.logTrace),y&&typeof y.logError=="function"&&(this.c=y.logError)}get isTracing(){return!!this.b}trace(y){this.b?.(y)}error(y){this.c?.(y)}}}),define(ae[164],ce([11,10]),function(X,e){return X.create("vs/code/electron-main/app",e)}),define(ae[165],ce([11,10]),function(X,e){return X.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ae[166],ce([11,10]),function(X,e){return X.create("vs/platform/contextkey/common/contextkey",e)}),define(ae[167],ce([11,10]),function(X,e){return X.create("vs/platform/contextkey/common/scanner",e)}),define(ae[168],ce([11,10]),function(X,e){return X.create("vs/platform/dialogs/common/dialogs",e)}),define(ae[169],ce([11,10]),function(X,e){return X.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(ae[170],ce([11,10]),function(X,e){return X.create("vs/platform/environment/node/argv",e)}),define(ae[171],ce([11,10]),function(X,e){return X.create("vs/platform/environment/node/argvHelper",e)}),define(ae[172],ce([11,10]),function(X,e){return X.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ae[173],ce([11,10]),function(X,e){return X.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ae[174],ce([11,10]),function(X,e){return X.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ae[175],ce([11,10]),function(X,e){return X.create("vs/platform/extensions/common/extensionValidator",e)}),define(ae[176],ce([11,10]),function(X,e){return X.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ae[177],ce([11,10]),function(X,e){return X.create("vs/platform/files/common/fileService",e)}),define(ae[178],ce([11,10]),function(X,e){return X.create("vs/platform/files/common/files",e)}),define(ae[179],ce([11,10]),function(X,e){return X.create("vs/platform/files/common/io",e)}),define(ae[180],ce([11,10]),function(X,e){return X.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(ae[181],ce([11,10]),function(X,e){return X.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ae[182],ce([11,10]),function(X,e){return X.create("vs/platform/issue/electron-main/issueMainService",e)}),define(ae[183],ce([11,10]),function(X,e){return X.create("vs/platform/menubar/electron-main/menubar",e)}),define(ae[184],ce([11,10]),function(X,e){return X.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(ae[185],ce([11,10]),function(X,e){return X.create("vs/platform/request/common/request",e)}),define(ae[186],ce([11,10]),function(X,e){return X.create("vs/platform/shell/node/shellEnv",e)}),define(ae[187],ce([11,10]),function(X,e){return X.create("vs/platform/telemetry/common/telemetryService",e)}),define(ae[188],ce([11,10]),function(X,e){return X.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(ae[189],ce([11,10]),function(X,e){return X.create("vs/platform/terminal/common/terminalProfiles",e)}),define(ae[190],ce([11,10]),function(X,e){return X.create("vs/platform/update/common/update.config.contribution",e)}),define(ae[191],ce([11,10]),function(X,e){return X.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ae[192],ce([11,10]),function(X,e){return X.create("vs/platform/windows/electron-main/windowImpl",e)}),define(ae[193],ce([11,10]),function(X,e){return X.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(ae[194],ce([11,10]),function(X,e){return X.create("vs/platform/workspace/common/workspace",e)}),define(ae[195],ce([11,10]),function(X,e){return X.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(ae[196],ce([11,10]),function(X,e){return X.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(ae[197],ce([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$keb=e.$jeb=void 0;function n(S){return S&&S.hasOwnProperty("folderUri")}e.$jeb=n;function D(S){return S&&S.hasOwnProperty("workspace")}e.$keb=D}),define(ae[198],ce([0,1,7]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Y$b=e.$X$b=e.$W$b=void 0;function D(C){return typeof C?.backupFolder=="string"}e.$W$b=D;function S(C){let P=[];try{Array.isArray(C.workspaces)&&(P=C.workspaces.map(d=>({workspace:{id:d.id,configPath:n.URI.parse(d.configURIPath)},remoteAuthority:d.remoteAuthority})))}catch{}return P}e.$X$b=S;function M(C){let P=[];try{Array.isArray(C.folders)&&(P=C.folders.map(d=>({folderUri:n.URI.parse(d.folderUri),remoteAuthority:d.remoteAuthority})))}catch{}return P}e.$Y$b=M}),define(ae[199],ce([0,1,15,167]),function(X,e,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bj=e.TokenType=void 0;var S;(function(c){c[c.LParen=0]="LParen",c[c.RParen=1]="RParen",c[c.Neg=2]="Neg",c[c.Eq=3]="Eq",c[c.NotEq=4]="NotEq",c[c.Lt=5]="Lt",c[c.LtEq=6]="LtEq",c[c.Gt=7]="Gt",c[c.GtEq=8]="GtEq",c[c.RegexOp=9]="RegexOp",c[c.RegexStr=10]="RegexStr",c[c.True=11]="True",c[c.False=12]="False",c[c.In=13]="In",c[c.Not=14]="Not",c[c.And=15]="And",c[c.Or=16]="Or",c[c.Str=17]="Str",c[c.QuotedStr=18]="QuotedStr",c[c.Error=19]="Error",c[c.EOF=20]="EOF"})(S||(e.TokenType=S={}));function M(...c){switch(c.length){case 1:return(0,D.localize)(0,null,c[0]);case 2:return(0,D.localize)(1,null,c[0],c[1]);case 3:return(0,D.localize)(2,null,c[0],c[1],c[2]);default:return}}const C=(0,D.localize)(3,null),P=(0,D.localize)(4,null);class d{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(y){switch(y.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return y.isTripleEq?"===":"==";case 4:return y.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return y.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return y.lexeme;case 18:return y.lexeme;case 19:return y.lexeme;case 20:return"EOF";default:throw(0,n.$8)(`unhandled token type: ${JSON.stringify(y)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(y=>y.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(y){return this.c=y,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const v=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:v})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const v=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:v})}else this.h(126)?this.k(9):this.l(M("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(M("&&"));break;case 124:this.h(124)?this.k(16):this.l(M("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(y){return this.r()||this.c.charCodeAt(this.e)!==y?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(y){this.f.push({type:y,offset:this.d})}l(y){const v=this.d,k=this.c.substring(this.d,this.e),g={type:19,offset:this.d,lexeme:k};this.g.push({offset:v,lexeme:k,additionalInfo:y}),this.f.push(g)}n(){this.m.lastIndex=this.d;const y=this.m.exec(this.c);if(y){this.e=this.d+y[0].length;const v=this.c.substring(this.d,this.e),k=d.b.get(v);k?this.k(k):this.f.push({type:17,lexeme:v,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(C);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let y=this.e,v=!1,k=!1;for(;;){if(y>=this.c.length){this.e=y,this.l(P);return}const m=this.c.charCodeAt(y);if(v)v=!1;else if(m===47&&!k){y++;break}else m===91?k=!0:m===92?v=!0:m===93&&(k=!1);y++}for(;y<this.c.length&&d.a.has(this.c.charCodeAt(y));)y++;this.e=y;const g=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:g,offset:this.d})}r(){return this.e>=this.c.length}}e.$bj=d}),define(ae[200],ce([0,1,3,2]),function(X,e,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$so=e.$ro=void 0;class S{constructor(){this.a=new n.$6d,this.b=new n.$6d,this.c=new n.$6d,this.d=new n.$6d}static{this.ChannelName="extensionhostdebugservice"}call(P,d,c){switch(d){case"close":return Promise.resolve(this.a.fire({sessionId:c[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:c[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:c[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:c[0],port:c[1],subId:c[2]}))}throw new Error("Method not implemented.")}listen(P,d,c){switch(d){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}e.$ro=S;class M extends D.$Tc{constructor(P){super(),this.b=P}reload(P){this.b.call("reload",[P])}get onReload(){return this.b.listen("reload")}close(P){this.b.call("close",[P])}get onClose(){return this.b.listen("close")}attachSession(P,d,c){this.b.call("attach",[P,d,c])}get onAttachSession(){return this.b.listen("attach")}terminateSession(P,d){this.b.call("terminate",[P,d])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(P,d){return this.b.call("openExtensionDevelopmentHostWindow",[P,d])}}e.$so=M}),define(ae[201],ce([0,1,151,50,13,9,36,19,7]),function(X,e,n,D,S,M,C,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qm=e.$Pm=e.$Om=e.$Nm=void 0,e.$Nm=/^([^.]+\..+)[:=](.+)$/;class c{get appRoot(){return(0,M.$mc)(S.$Ag.asFileUri("").fsPath)}get userHome(){return d.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return d.URI.file((0,M.$jc)(this.userDataPath,"User"))}get tmpDir(){return d.URI.file(this.b.tmpDir)}get cacheHome(){return d.URI.file(this.userDataPath)}get stateResource(){return(0,P.$Tg)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:S.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,P.$Tg)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const g=(0,n.$Mm)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,M.$jc)(this.userDataPath,"logs",g)}return d.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.$Tg)(d.URI.file((0,M.$jc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,P.$Tg)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,P.$Tg)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,P.$Tg)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const g=C.env.VSCODE_PORTABLE;return g?d.URI.file((0,M.$jc)(g,"argv.json")):(0,P.$Tg)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return d.URI.file((0,M.$jc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const g=this.args["builtin-extensions-dir"];return g?(0,M.$kc)(g):(0,M.$hc)((0,M.$jc)(S.$Ag.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const g=this.args["extensions-download-dir"];return g?d.URI.file((0,M.$kc)(g)):d.URI.file((0,M.$jc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const g=this.args["extensions-dir"];if(g)return(0,M.$kc)(g);const m=C.env.VSCODE_EXTENSIONS;if(m)return m;const w=C.env.VSCODE_PORTABLE;return w?(0,M.$jc)(w,"extensions"):(0,P.$Tg)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const g=this.args.extensionDevelopmentPath;if(Array.isArray(g))return g.map(m=>/^[^:/?#]+?:\/\//.test(m)?d.URI.parse(m):d.URI.file((0,M.$hc)(m)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(g=>g==="ui"||g==="workspace"||g==="web"?g:"workspace")}get extensionTestsLocationURI(){const g=this.args.extensionTestsPath;if(g)return/^[^:/?#]+?:\/\//.test(g)?d.URI.parse(g):d.URI.file((0,M.$hc)(g))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const g=this.args["disable-extension"];if(g){if(typeof g=="string")return[g];if(Array.isArray(g)&&g.length>0)return g}return!1}get debugExtensionHost(){return y(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!C.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(g=>!e.$Nm.test(g))}get extensionLogLevel(){const g=[];for(const m of this.args.log||[]){const w=e.$Nm.exec(m);w&&w[1]&&w[2]&&g.push([w[1],w[2]])}return g.length?g:void 0}get serviceMachineIdResource(){return(0,P.$Tg)(d.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const g=C.env.VSCODE_PORTABLE;return g?d.URI.file((0,M.$jc)(g,"policy.json")):(0,P.$Tg)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(g){this.args.continueOn=g}get args(){return this.a}constructor(g,m,w){this.a=g,this.b=m,this.c=w,this.editSessionId=this.args.editSessionId}}e.$Om=c,ve([D.$Kh],c.prototype,"appRoot",null),ve([D.$Kh],c.prototype,"userHome",null),ve([D.$Kh],c.prototype,"userDataPath",null),ve([D.$Kh],c.prototype,"appSettingsHome",null),ve([D.$Kh],c.prototype,"tmpDir",null),ve([D.$Kh],c.prototype,"cacheHome",null),ve([D.$Kh],c.prototype,"stateResource",null),ve([D.$Kh],c.prototype,"userRoamingDataHome",null),ve([D.$Kh],c.prototype,"userDataSyncHome",null),ve([D.$Kh],c.prototype,"sync",null),ve([D.$Kh],c.prototype,"machineSettingsResource",null),ve([D.$Kh],c.prototype,"workspaceStorageHome",null),ve([D.$Kh],c.prototype,"localHistoryHome",null),ve([D.$Kh],c.prototype,"keyboardLayoutResource",null),ve([D.$Kh],c.prototype,"argvResource",null),ve([D.$Kh],c.prototype,"isExtensionDevelopment",null),ve([D.$Kh],c.prototype,"untitledWorkspacesHome",null),ve([D.$Kh],c.prototype,"builtinExtensionsPath",null),ve([D.$Kh],c.prototype,"extensionsPath",null),ve([D.$Kh],c.prototype,"extensionDevelopmentLocationURI",null),ve([D.$Kh],c.prototype,"extensionDevelopmentKind",null),ve([D.$Kh],c.prototype,"extensionTestsLocationURI",null),ve([D.$Kh],c.prototype,"debugExtensionHost",null),ve([D.$Kh],c.prototype,"logLevel",null),ve([D.$Kh],c.prototype,"extensionLogLevel",null),ve([D.$Kh],c.prototype,"serviceMachineIdResource",null),ve([D.$Kh],c.prototype,"disableTelemetry",null),ve([D.$Kh],c.prototype,"disableWorkspaceTrust",null),ve([D.$Kh],c.prototype,"useInMemorySecretStorage",null),ve([D.$Kh],c.prototype,"policyFile",null);function y(k,g){return v(k["inspect-extensions"],k["inspect-brk-extensions"],5870,g,k.debugId,k.extensionEnvironment)}e.$Pm=y;function v(k,g,m,w,p,u){const h=Number(g||k)||(w?null:m),$=h?!!g:!1;let a;if(u)try{a=JSON.parse(u)}catch{}return{port:h,break:$,debugId:p,env:a}}e.$Qm=v}),define(ae[116],ce([0,1,311,4,170]),function(X,e,n,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$am=e.$_l=e.$$l=e.$0l=e.$9l=e.$8l=void 0;const M={o:(0,S.localize)(0,null),e:(0,S.localize)(1,null),t:(0,S.localize)(2,null)};e.$8l=["tunnel","serve-web"],e.$9l={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,S.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Run a server that displays the editor UI in browsers.",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,S.localize)(4,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,S.localize)(5,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,S.localize)(6,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,S.localize)(7,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,S.localize)(8,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,S.localize)(9,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,S.localize)(10,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,S.localize)(11,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,S.localize)(12,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,S.localize)(13,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,S.localize)(14,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,S.localize)(15,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,S.localize)(16,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,S.localize)(17,null)},"show-versions":{type:"boolean",cat:"e",description:(0,S.localize)(18,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,S.localize)(19,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,S.localize)(20,null)},"pre-release":{type:"boolean",cat:"e",description:(0,S.localize)(21,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,S.localize)(22,null)},"update-extensions":{type:"boolean",cat:"e",description:(0,S.localize)(23,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,S.localize)(24,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,S.localize)(25,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,S.localize)(26,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,S.localize)(27,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,S.localize)(28,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,S.localize)(29,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,S.localize)(30,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,S.localize)(31,null)},sync:{type:"string",cat:"t",description:(0,S.localize)(32,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,S.localize)(33,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,S.localize)(34,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,S.localize)(35,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,S.localize)(36,null)},sandbox:{type:"boolean"},telemetry:{type:"boolean",cat:"t",description:(0,S.localize)(37,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"preserve-env":{type:"boolean"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const C={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function P(w,p,u=C){const f=w.find(l=>l.length>0&&l[0]!=="-"),h={},$=["_"],a=[],t={};let o;for(const l in p){const b=p[l];b.type==="subcommand"?l===f&&(o=b):(b.alias&&(h[l]=b.alias),b.type==="string"||b.type==="string[]"?($.push(l),b.deprecates&&$.push(...b.deprecates)):b.type==="boolean"&&(a.push(l),b.deprecates&&a.push(...b.deprecates)),b.global&&(t[l]=b))}if(o&&f){const l=t;for(const E in o.options)l[E]=o.options[E];const b=w.filter(E=>E!==f),R=u.getSubcommandReporter?u.getSubcommandReporter(f):void 0,I=P(b,l,R);return{[f]:I,_:[]}}const r=n(w,{string:$,boolean:a,alias:h}),i={},s=r;i._=r._.map(l=>String(l)).filter(l=>l.length>0),delete s._;for(const l in p){const b=p[l];if(b.type==="subcommand")continue;b.alias&&delete s[b.alias];let R=s[l];if(b.deprecates)for(const I of b.deprecates)s.hasOwnProperty(I)&&(R||(R=s[I],R&&u.onDeprecatedOption(I,b.deprecationMessage||(0,S.localize)(38,null,l))),delete s[I]);if(typeof R<"u"){if(b.type==="string[]"){if(Array.isArray(R)||(R=[R]),!b.allowEmptyValue){const I=R.filter(E=>E.length>0);I.length!==R.length&&(u.onEmptyValue(l),R=I.length>0?I:void 0)}}else b.type==="string"&&(Array.isArray(R)?(R=R.pop(),u.onMultipleValues(l,R)):!R&&!b.allowEmptyValue&&(u.onEmptyValue(l),R=void 0));i[l]=R,b.deprecationMessage&&u.onDeprecatedOption(l,b.deprecationMessage)}delete s[l]}for(const l in s)u.onUnknownOption(l);return i}e.$0l=P;function d(w,p){let u="";return p.args&&(Array.isArray(p.args)?u=` <${p.args.join("> <")}>`:u=` <${p.args}>`),p.alias?`-${p.alias} --${w}${u}`:`--${w}${u}`}function c(w,p){const u=[];for(const f in w){const h=w[f],$=d(f,h);u.push([$,h.description])}return y(u,p)}e.$$l=c;function y(w,p){const f=w.reduce((a,t)=>Math.max(a,t[0].length),12)+2+1;if(p-f<25)return w.reduce((a,t)=>a.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);const h=p-f-1,$=[];for(const a of w){const t=a[0],o=k(a[1],h),r=v(f-t.length-2);$.push("  "+t+r+o[0]);for(let i=1;i<o.length;i++)$.push(v(f)+o[i])}return $}function v(w){return" ".repeat(w)}function k(w,p){const u=[];for(;w.length;){const f=w.length<p?w.length:w.lastIndexOf(" ",p),h=w.slice(0,f).trim();w=w.slice(f),u.push(h)}return u}function g(w,p,u,f,h){const $=process.stdout.isTTY&&process.stdout.columns||80,a=h?.noInputFiles!==!0?`[${(0,S.localize)(39,null)}...]`:"",t=[`${w} ${u}`];t.push(""),t.push(`${(0,S.localize)(40,null)}: ${p} [${(0,S.localize)(41,null)}]${a}`),t.push(""),h?.noPipe!==!0&&(D.$i?t.push((0,S.localize)(42,null,p)):t.push((0,S.localize)(43,null,p)),t.push(""));const o={},r=[];for(const i in f){const s=f[i];if(s.type==="subcommand")s.description&&r.push({command:i,description:s.description});else if(s.description&&s.cat){let l=o[s.cat];l||(o[s.cat]=l={}),l[i]=s}}for(const i in o){const s=i,l=o[s];l&&(t.push(M[s]),t.push(...c(l,$)),t.push(""))}return r.length&&(t.push((0,S.localize)(44,null)),t.push(...y(r.map(i=>[i.command,i.description]),$)),t.push("")),t.join(`
`)}e.$_l=g;function m(w,p){return`${w||(0,S.localize)(45,null)}
${p||(0,S.localize)(46,null)}
${process.arch}`}e.$am=m}),define(ae[202],ce([0,1,88,200,116]),function(X,e,n,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$y_b=void 0;class M extends D.$ro{constructor(P){super(),this.f=P}call(P,d,c){return d==="openExtensionDevelopmentHostWindow"?this.g(c[0],c[1]):super.call(P,d,c)}async g(P,d){const c=(0,S.$0l)(P,S.$9l);c.debugRenderer=d;const y=c.extensionDevelopmentPath;if(!y)return{success:!1};const[v]=await this.f.openExtensionDevelopmentHostWindow(y,{context:5,cli:c,forceProfile:c.profile,forceTempProfile:c["profile-temp"]});if(!d)return{success:!0};const k=v.win;if(!k)return{success:!0};const g=k.webContents.debugger;let m=g.isAttached()?1/0:0;const w=(0,n.createServer)(p=>{m++===0&&g.attach();let u=!1;const f=a=>{u||p.write(JSON.stringify(a)+"\0")},h=(a,t,o,r)=>f({method:t,params:o,sessionId:r});k.on("close",()=>{g.removeListener("message",h),p.end(),u=!0}),g.addListener("message",h);let $=Buffer.alloc(0);p.on("data",a=>{$=Buffer.concat([$,a]);for(let t=$.indexOf(0);t!==-1;t=$.indexOf(0)){let o;try{const r=$.slice(0,t).toString("utf8");$=$.slice(t+1),o=JSON.parse(r)}catch(r){console.error("error reading cdp line",r)}g.sendCommand(o.method,o.params,o.sessionId).then(r=>f({id:o.id,sessionId:o.sessionId,result:r})).catch(r=>f({id:o.id,sessionId:o.sessionId,error:{code:0,message:r.message}}))}}),p.on("error",a=>{console.error("error on cdp pipe:",a)}),p.on("close",()=>{u=!0,--m===0&&g.detach()})});return await new Promise(p=>w.listen(0,p)),k.on("close",()=>w.close()),{rendererDebugPort:w.address().port,success:!0}}}e.$y_b=M}),define(ae[63],ce([0,1,312,171,116]),function(X,e,n,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$em=e.$dm=e.$cm=e.$bm=void 0;function M(v,k){const g=(h,$)=>{console.warn((0,D.localize)(0,null,h,$))},m=h=>{console.warn((0,D.localize)(1,null,h))},w=(h,$)=>{console.warn((0,D.localize)(2,null,h,$))},p=h=>({onUnknownOption:$=>{S.$8l.includes(h)||console.warn((0,D.localize)(3,null,$,h))},onMultipleValues:g,onEmptyValue:m,onDeprecatedOption:w,getSubcommandReporter:S.$8l.includes(h)?p:void 0}),u={onUnknownOption:h=>{console.warn((0,D.localize)(4,null,h))},onMultipleValues:g,onEmptyValue:m,onDeprecatedOption:w,getSubcommandReporter:p},f=(0,S.$0l)(v,S.$9l,k?u:void 0);return f.goto&&f._.forEach(h=>n(/^(\w:)?[^:]+(:\d*){0,2}:?$/.test(h),(0,D.localize)(5,null))),f}function C(v){const k=v.findIndex(g=>!/^-/.test(g));if(k>-1)return[...v.slice(0,k),...v.slice(k+1)]}function P(v){let[,...k]=v;process.env.VSCODE_DEV&&(k=C(k)||[]);const g=!y(process.env);return M(k,g)}e.$bm=P;function d(v){let[,,...k]=v;return process.env.VSCODE_DEV&&(k=C(k)||[]),M(k,!0)}e.$cm=d;function c(v,...k){const g=v.indexOf("--");return g===-1?v.push(...k):v.splice(g,0,...k),v}e.$dm=c;function y(v){return v.VSCODE_CLI==="1"}e.$em=y}),function(){"use strict";function X(e,n,D){function S(C,P){const d=M(C,P),c=[d];return e.isAbsolute(d)||c.unshift(D),e.resolve(...c)}function M(C,P){process.env.VSCODE_DEV&&(P="code-oss-dev");const d=process.env.VSCODE_PORTABLE;if(d)return e.join(d,"user-data");let c=process.env.VSCODE_APPDATA;if(c)return e.join(c,P);const y=C["user-data-dir"];if(y)return y;switch(process.platform){case"win32":if(c=process.env.APPDATA,!c){const v=process.env.USERPROFILE;if(typeof v!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");c=e.join(v,"AppData","Roaming")}break;case"darwin":c=e.join(n.homedir(),"Library","Application Support");break;case"linux":c=process.env.XDG_CONFIG_HOME||e.join(n.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(c,P)}return{getUserDataPath:S}}if(typeof define=="function")define(ae[203],ce([117,26,36]),function(e,n,D){return X(e,n,D.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),n=require("os");module.exports=X(e,n,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ae[91],ce([0,1,26,201,203]),function(X,e,n,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tm=e.$Sm=e.$Rm=void 0;class M extends D.$Om{constructor(c,y){super(c,{homeDir:(0,n.homedir)(),tmpDir:(0,n.tmpdir)(),userDataDir:(0,S.getUserDataPath)(c,y.nameShort)},y)}}e.$Rm=M;function C(d,c){return(0,D.$Qm)(d["inspect-ptyhost"],d["inspect-brk-ptyhost"],5877,c,d.extensionEnvironment)}e.$Sm=C;function P(d,c){return(0,D.$Qm)(d["inspect-sharedprocess"],d["inspect-brk-sharedprocess"],5879,c,d.extensionEnvironment)}e.$Tm=P}),define(ae[204],ce([0,1,46,26,33]),function(X,e,n,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rac=void 0;function M(C){const P=(0,S.$og)((0,D.tmpdir)());try{return(0,n.writeFileSync)(P,""),C&&console.log(`Marker file for --wait created: ${P}`),P}catch(d){C&&console.error(`Failed to create marker file for --wait: ${d}`);return}}e.$Rac=M}),define(ae[205],ce([0,1,12,173]),function(X,e,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bq=void 0;function S(C,P,d,c){try{M(C,P,d,c)}catch(y){C.error(y?.message??y)}return P}e.$bq=S;function M(C,P,d,c){const y=(v,k,g)=>{const m=v[k];if((0,n.$Tf)(m)){const w=m,p=w.length;if(p>1&&w[0]==="%"&&w[p-1]==="%"){const u=w.substr(1,p-2);let f=d[u];f===void 0&&c&&(f=c[u]);const h=typeof f=="string"?f:f?.message,$=c?.[u],a=typeof $=="string"?$:$?.message;if(!h){a||C.warn(`[${P.name}]: ${(0,D.localize)(0,null,u)}`);return}if(g&&(k==="title"||k==="category")&&a&&a!==h){const t={value:h,original:a};v[k]=t}else v[k]=h}}else if((0,n.$Vf)(m))for(const w in m)m.hasOwnProperty(w)&&(w==="commands"?y(m,w,!0):y(m,w,g));else if(Array.isArray(m))for(let w=0;w<m.length;w++)y(m,w,g)};for(const v in P)P.hasOwnProperty(v)&&y(P,v)}}),define(ae[206],ce([0,1,19,73,175,207]),function(X,e,n,D,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vp=e.$up=e.$tp=e.$sp=e.$rp=e.$qp=e.$pp=void 0;const C=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,P=/^-(\d{4})(\d{2})(\d{2})$/;function d(u){return u=u.trim(),u==="*"||C.test(u)}e.$pp=d;function c(u){if(!d(u))return null;if(u=u.trim(),u==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const f=u.match(C);return f?{hasCaret:f[1]==="^",hasGreaterEquals:f[1]===">=",majorBase:f[2]==="x"?0:parseInt(f[2],10),majorMustEqual:f[2]!=="x",minorBase:f[4]==="x"?0:parseInt(f[4],10),minorMustEqual:f[4]!=="x",patchBase:f[6]==="x"?0:parseInt(f[6],10),patchMustEqual:f[6]!=="x",preRelease:f[8]||null}:null}e.$qp=c;function y(u){if(!u)return null;const f=u.majorBase,h=u.majorMustEqual,$=u.minorBase;let a=u.minorMustEqual;const t=u.patchBase;let o=u.patchMustEqual;u.hasCaret&&(f===0||(a=!1),o=!1);let r=0;if(u.preRelease){const i=P.exec(u.preRelease);if(i){const[,s,l,b]=i;r=Date.UTC(Number(s),Number(l)-1,Number(b))}}return{majorBase:f,majorMustEqual:h,minorBase:$,minorMustEqual:a,patchBase:t,patchMustEqual:o,isMinimum:u.hasGreaterEquals,notBefore:r}}e.$rp=y;function v(u,f,h){let $;typeof u=="string"?$=y(c(u)):$=u;let a;f instanceof Date?a=f.getTime():typeof f=="string"&&(a=new Date(f).getTime());let t;if(typeof h=="string"?t=y(c(h)):t=h,!$||!t)return!1;const o=$.majorBase,r=$.minorBase,i=$.patchBase;let s=t.majorBase,l=t.minorBase,b=t.patchBase;const R=t.notBefore;let I=t.majorMustEqual,E=t.minorMustEqual,A=t.patchMustEqual;return t.isMinimum?o>s?!0:o<s?!1:r>l?!0:r<l||a&&a<R?!1:i>=b:(o===1&&s===0&&(!I||!E||!A)&&(s=1,l=0,b=0,I=!0,E=!1,A=!1),o<s?!1:o>s?!I:r<l?!1:r>l?!E:i<b?!1:i>b?!A:!(a&&a<R))}e.$sp=v;function k(u,f,h,$,a){const t=[];if(typeof $.publisher<"u"&&typeof $.publisher!="string")return t.push([D.default.Error,S.localize(0,null)]),t;if(typeof $.name!="string")return t.push([D.default.Error,S.localize(1,null,"name")]),t;if(typeof $.version!="string")return t.push([D.default.Error,S.localize(2,null,"version")]),t;if(!$.engines)return t.push([D.default.Error,S.localize(3,null,"engines")]),t;if(typeof $.engines.vscode!="string")return t.push([D.default.Error,S.localize(4,null,"engines.vscode")]),t;if(typeof $.extensionDependencies<"u"&&!p($.extensionDependencies))return t.push([D.default.Error,S.localize(5,null,"extensionDependencies")]),t;if(typeof $.activationEvents<"u"){if(!p($.activationEvents))return t.push([D.default.Error,S.localize(6,null,"activationEvents")]),t;if(typeof $.main>"u"&&typeof $.browser>"u")return t.push([D.default.Error,S.localize(7,null,"activationEvents","main","browser")]),t}if(typeof $.extensionKind<"u"&&typeof $.main>"u"&&t.push([D.default.Warning,S.localize(8,null,"extensionKind")]),typeof $.main<"u"){if(typeof $.main!="string")return t.push([D.default.Error,S.localize(9,null,"main")]),t;{const i=(0,n.$Tg)(h,$.main);(0,n.$Ng)(i,h)||t.push([D.default.Warning,S.localize(10,null,i.path,h.path)])}}if(typeof $.browser<"u"){if(typeof $.browser!="string")return t.push([D.default.Error,S.localize(11,null,"browser")]),t;{const i=(0,n.$Tg)(h,$.browser);(0,n.$Ng)(i,h)||t.push([D.default.Warning,S.localize(12,null,i.path,h.path)])}}if(!M.valid($.version))return t.push([D.default.Error,S.localize(13,null)]),t;const o=[];if(!g(u,f,$,a,o))for(const i of o)t.push([D.default.Error,i]);return t}e.$tp=k;function g(u,f,h,$,a){return $||typeof h.main>"u"&&typeof h.browser>"u"?!0:w(u,f,h.engines.vscode,a)}e.$up=g;function m(u,f,h){return u==="*"||w(f,h,u)}e.$vp=m;function w(u,f,h,$=[]){const a=y(c(h));if(!a)return $.push(S.localize(14,null,h)),!1;if(a.majorBase===0){if(!a.majorMustEqual||!a.minorMustEqual)return $.push(S.localize(15,null,h)),!1}else if(!a.majorMustEqual)return $.push(S.localize(16,null,h)),!1;return v(u,f,a)?!0:($.push(S.localize(17,null,u,h)),!1)}function p(u){if(!Array.isArray(u))return!1;for(let f=0,h=u.length;f<h;f++)if(typeof u[f]!="string")return!1;return!0}}),define(ae[208],ce([0,1,17,32]),function(X,e,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pp=void 0;async function S(M,C,P){let d=P&&P.get("storage.serviceMachineId",-1)||null;if(d)return d;try{const y=(await C.readFile(M.serviceMachineIdResource)).value.toString();d=(0,D.$Bg)(y)?y:null}catch{d=null}if(!d){d=(0,D.$Cg)();try{await C.writeFile(M.serviceMachineIdResource,n.$te.fromString(d))}catch{}}return P?.store("storage.serviceMachineId",d,-1,1),d}e.$Pp=S}),define(ae[77],ce([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$di=void 0;class n{constructor(S,M=[],C=!1){this.ctor=S,this.staticArguments=M,this.supportsDelayedInstantiation=C}}e.$di=n}),define(ae[209],ce([0,1,77]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cs=e.$bs=e.InstantiationType=void 0;const D=[];var S;(function(P){P[P.Eager=0]="Eager",P[P.Delayed=1]="Delayed"})(S||(e.InstantiationType=S={}));function M(P,d,c){d instanceof n.$di||(d=new n.$di(d,[],!!c)),D.push([P,d])}e.$bs=M;function C(){return D}e.$cs=C}),define(ae[210],ce([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sq=e.$Rq=void 0;class n{constructor(M,C){this.key=M,this.data=C,this.incoming=new Map,this.outgoing=new Map}}e.$Rq=n;class D{constructor(M){this.b=M,this.a=new Map}roots(){const M=[];for(const C of this.a.values())C.outgoing.size===0&&M.push(C);return M}insertEdge(M,C){const P=this.lookupOrInsertNode(M),d=this.lookupOrInsertNode(C);P.outgoing.set(d.key,d),d.incoming.set(P.key,P)}removeNode(M){const C=this.b(M);this.a.delete(C);for(const P of this.a.values())P.outgoing.delete(C),P.incoming.delete(C)}lookupOrInsertNode(M){const C=this.b(M);let P=this.a.get(C);return P||(P=new n(C,M),this.a.set(C,P)),P}lookup(M){return this.a.get(this.b(M))}isEmpty(){return this.a.size===0}toString(){const M=[];for(const[C,P]of this.a)M.push(`${C}
	(-> incoming)[${[...P.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...P.outgoing.keys()].join(",")}]
`);return M.join(`
`)}findCycleSlow(){for(const[M,C]of this.a){const P=new Set([M]),d=this.c(C,P);if(d)return d}}c(M,C){for(const[P,d]of M.outgoing){if(C.has(P))return[...C,P].join(" -> ");C.add(P);const c=this.c(d,C);if(c)return c;C.delete(P)}}}e.$Sq=D}),define(ae[6],ce([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hi=e.$gi=e.$fi=e._util=void 0;var n;(function(C){C.serviceIds=new Map,C.DI_TARGET="$di$target",C.DI_DEPENDENCIES="$di$dependencies";function P(d){return d[C.DI_DEPENDENCIES]||[]}C.getServiceDependencies=P})(n||(e._util=n={})),e.$fi=S("instantiationService");function D(C,P,d){P[n.DI_TARGET]===P?P[n.DI_DEPENDENCIES].push({id:C,index:d}):(P[n.DI_DEPENDENCIES]=[{id:C,index:d}],P[n.DI_TARGET]=P)}function S(C){if(n.serviceIds.has(C))return n.serviceIds.get(C);const P=function(d,c,y){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");D(P,d,y)};return P.toString=()=>C,n.serviceIds.set(C,P),P}e.$gi=S;function M(C){return C}e.$hi=M}),define(ae[78],ce([0,1,6]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Q_b=void 0,e.$Q_b=(0,n.$gi)("auxiliaryWindowsMainService")}),define(ae[64],ce([0,1,6]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Z$b=void 0,e.$Z$b=(0,n.$gi)("backupMainService")}),define(ae[18],ce([0,1,12,7,6]),function(X,e,n,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.ConfigurationTarget=e.$Oi=e.$Ni=e.$Mi=void 0,e.$Mi=(0,S.$gi)("configurationService");function M(u){return u&&typeof u=="object"&&(!u.overrideIdentifier||typeof u.overrideIdentifier=="string")&&(!u.resource||u.resource instanceof D.URI)}e.$Ni=M;function C(u){return u&&typeof u=="object"&&(!u.overrideIdentifiers||Array.isArray(u.overrideIdentifiers))&&!u.overrideIdentifier&&(!u.resource||u.resource instanceof D.URI)}e.$Oi=C;var P;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.USER=2]="USER",u[u.USER_LOCAL=3]="USER_LOCAL",u[u.USER_REMOTE=4]="USER_REMOTE",u[u.WORKSPACE=5]="WORKSPACE",u[u.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",u[u.DEFAULT=7]="DEFAULT",u[u.MEMORY=8]="MEMORY"})(P||(e.ConfigurationTarget=P={}));function d(u){switch(u){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$Pi=d;function c(u){return u.applicationValue!==void 0||u.userValue!==void 0||u.userLocalValue!==void 0||u.userRemoteValue!==void 0||u.workspaceValue!==void 0||u.workspaceFolderValue!==void 0}e.$Qi=c;function y(u,f){const h=Object.create(null);for(const $ in u)v(h,$,u[$],f);return h}e.$Ri=y;function v(u,f,h,$){const a=f.split("."),t=a.pop();let o=u;for(let r=0;r<a.length;r++){const i=a[r];let s=o[i];switch(typeof s){case"undefined":s=o[i]=Object.create(null);break;case"object":break;default:$(`Ignoring ${f} as ${a.slice(0,r+1).join(".")} is ${JSON.stringify(s)}`);return}o=s}if(typeof o=="object"&&o!==null)try{o[t]=h}catch{$(`Ignoring ${f} as ${a.join(".")} is ${JSON.stringify(o)}`)}else $(`Ignoring ${f} as ${a.join(".")} is ${JSON.stringify(o)}`)}e.$Si=v;function k(u,f){const h=f.split(".");g(u,h)}e.$Ti=k;function g(u,f){const h=f.shift();if(f.length===0){delete u[h];return}if(Object.keys(u).indexOf(h)!==-1){const $=u[h];typeof $=="object"&&!Array.isArray($)&&(g($,f),Object.keys($).length===0&&delete u[h])}}function m(u,f,h){function $(o,r){let i=o;for(const s of r){if(typeof i!="object"||i===null)return;i=i[s]}return i}const a=f.split("."),t=$(u,a);return typeof t>"u"?h:t}e.$Ui=m;function w(u,f,h){Object.keys(f).forEach($=>{$!=="__proto__"&&($ in u?n.$Vf(u[$])&&n.$Vf(f[$])?w(u[$],f[$],h):h&&(u[$]=f[$]):u[$]=f[$])})}e.$Vi=w;function p(u){return u.replace(/[\[\]]/g,"")}e.$Wi=p}),define(ae[118],ce([0,1,4,25,199,6,166,15]),function(X,e,n,D,S,M,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.ContextKeyExprType=e.$cj=void 0;const d=new Map;d.set("false",!1),d.set("true",!0),d.set("isMac",n.$j),d.set("isLinux",n.$k),d.set("isWindows",n.$i),d.set("isWeb",n.$o),d.set("isMacNative",n.$j&&!n.$o),d.set("isEdge",n.$H),d.set("isFirefox",n.$F),d.set("isChrome",n.$E),d.set("isSafari",n.$G);function c(J,O){if(d.get(J)!==void 0)throw(0,P.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");d.set(J,O)}e.$cj=c;const y=Object.prototype.hasOwnProperty;var v;(function(J){J[J.False=0]="False",J[J.True=1]="True",J[J.Defined=2]="Defined",J[J.Not=3]="Not",J[J.Equals=4]="Equals",J[J.NotEquals=5]="NotEquals",J[J.And=6]="And",J[J.Regex=7]="Regex",J[J.NotRegex=8]="NotRegex",J[J.Or=9]="Or",J[J.In=10]="In",J[J.NotIn=11]="NotIn",J[J.Greater=12]="Greater",J[J.GreaterEquals=13]="GreaterEquals",J[J.Smaller=14]="Smaller",J[J.SmallerEquals=15]="SmallerEquals"})(v||(e.ContextKeyExprType=v={}));const k={regexParsingWithErrorRecovery:!0},g=(0,C.localize)(0,null),m=(0,C.localize)(1,null),w=(0,C.localize)(2,null),p=(0,C.localize)(3,null),u=(0,C.localize)(4,null),f=(0,C.localize)(5,null),h=(0,C.localize)(6,null),$=(0,C.localize)(7,null);class a{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(O=k){this.k=O,this.d=new S.$bj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(O){if(O===""){this.h.push({message:g,offset:0,lexeme:"",additionalInfo:m});return}this.f=this.d.reset(O).scan(),this.g=0,this.h=[];try{const F=this.l();if(!this.E()){const x=this.D(),z=x.type===17?f:void 0;throw this.h.push({message:u,offset:x.offset,lexeme:S.$bj.getLexeme(x),additionalInfo:z}),a.c}return F}catch(F){if(F!==a.c)throw F;return}}l(){return this.m()}m(){const O=[this.o()];for(;this.y(16);){const F=this.o();O.push(F)}return O.length===1?O[0]:t.or(...O)}o(){const O=[this.s()];for(;this.y(15);){const F=this.s();O.push(F)}return O.length===1?O[0]:t.and(...O)}s(){if(this.y(2)){const O=this.D();switch(O.type){case 11:return this.z(),s.INSTANCE;case 12:return this.z(),l.INSTANCE;case 0:{this.z();const F=this.l();return this.A(1,p),F?.negate()}case 17:return this.z(),j.create(O.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",O)}}return this.t()}t(){const O=this.D();switch(O.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const F=this.l();return this.A(1,p),F}case 17:{const F=O.lexeme;if(this.z(),this.y(9)){const z=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),z.type!==10)throw this.B("REGEX",z);const Q=z.lexeme,H=Q.lastIndexOf("/"),_=H===Q.length-1?void 0:this.w(Q.substring(H+1));let B;try{B=new RegExp(Q.substring(1,H),_)}catch{throw this.B("REGEX",z)}return re.create(F,B)}switch(z.type){case 10:case 19:{const Q=[z.lexeme];this.z();let H=this.D(),_=0;for(let me=0;me<z.lexeme.length;me++)z.lexeme.charCodeAt(me)===40?_++:z.lexeme.charCodeAt(me)===41&&_--;for(;!this.E()&&H.type!==15&&H.type!==16;){switch(H.type){case 0:_++;break;case 1:_--;break;case 10:case 18:for(let me=0;me<H.lexeme.length;me++)H.lexeme.charCodeAt(me)===40?_++:z.lexeme.charCodeAt(me)===41&&_--}if(_<0)break;Q.push(S.$bj.getLexeme(H)),this.z(),H=this.D()}const B=Q.join(""),te=B.lastIndexOf("/"),ie=te===B.length-1?void 0:this.w(B.substring(te+1));let de;try{de=new RegExp(B.substring(1,te),ie)}catch{throw this.B("REGEX",z)}return t.regex(F,de)}case 18:{const Q=z.lexeme;this.z();let H=null;if(!(0,D.$Te)(Q)){const _=Q.indexOf("/"),B=Q.lastIndexOf("/");if(_!==B&&_>=0){const te=Q.slice(_+1,B),ie=Q[B+1]==="i"?"i":"";try{H=new RegExp(te,ie)}catch{throw this.B("REGEX",z)}}}if(H===null)throw this.B("REGEX",z);return re.create(F,H)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,w);const z=this.u();return t.notIn(F,z)}switch(this.D().type){case 3:{this.z();const z=this.u();if(this.x().type===18)return t.equals(F,z);switch(z){case"true":return t.has(F);case"false":return t.not(F);default:return t.equals(F,z)}}case 4:{this.z();const z=this.u();if(this.x().type===18)return t.notEquals(F,z);switch(z){case"true":return t.not(F);case"false":return t.has(F);default:return t.notEquals(F,z)}}case 5:return this.z(),K.create(F,this.u());case 6:return this.z(),le.create(F,this.u());case 7:return this.z(),W.create(F,this.u());case 8:return this.z(),V.create(F,this.u());case 13:return this.z(),t.in(F,this.u());default:return t.has(F)}}case 20:throw this.h.push({message:h,offset:O.offset,lexeme:"",additionalInfo:$}),a.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const O=this.D();switch(O.type){case 17:case 18:return this.z(),O.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(O){return O.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(O){return this.C(O)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(O,F){if(this.C(O))return this.z();throw this.B(F,this.D())}B(O,F,x){const z=(0,C.localize)(8,null,O,S.$bj.getLexeme(F)),Q=F.offset,H=S.$bj.getLexeme(F);return this.h.push({message:z,offset:Q,lexeme:H,additionalInfo:x}),a.c}C(O){return this.D().type===O}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$dj=a;class t{static false(){return s.INSTANCE}static true(){return l.INSTANCE}static has(O){return b.create(O)}static equals(O,F){return R.create(O,F)}static notEquals(O,F){return A.create(O,F)}static regex(O,F){return re.create(O,F)}static in(O,F){return I.create(O,F)}static notIn(O,F){return E.create(O,F)}static not(O){return j.create(O)}static and(...O){return Y.create(O,null,!0)}static or(...O){return U.create(O,null,!0)}static greater(O,F){return W.create(O,F)}static greaterEquals(O,F){return V.create(O,F)}static smaller(O,F){return K.create(O,F)}static smallerEquals(O,F){return le.create(O,F)}static{this.c=new a({regexParsingWithErrorRecovery:!1})}static deserialize(O){return O==null?void 0:this.c.parse(O)}}e.$ej=t;function o(J){const O=new a({regexParsingWithErrorRecovery:!1});return J.map(F=>(O.parse(F),O.lexingErrors.length>0?O.lexingErrors.map(x=>({errorMessage:x.additionalInfo?(0,C.localize)(9,null,x.additionalInfo):(0,C.localize)(10,null),offset:x.offset,length:x.lexeme.length})):O.parsingErrors.length>0?O.parsingErrors.map(x=>({errorMessage:x.additionalInfo?`${x.message}. ${x.additionalInfo}`:x.message,offset:x.offset,length:x.lexeme.length})):[]))}e.$fj=o;function r(J,O){const F=J?J.substituteConstants():void 0,x=O?O.substituteConstants():void 0;return!F&&!x?!0:!F||!x?!1:F.equals(x)}e.$gj=r;function i(J,O){return J.cmp(O)}class s{static{this.INSTANCE=new s}constructor(){this.type=0}cmp(O){return this.type-O.type}equals(O){return O.type===this.type}substituteConstants(){return this}evaluate(O){return!1}serialize(){return"false"}keys(){return[]}map(O){return this}negate(){return l.INSTANCE}}e.$hj=s;class l{static{this.INSTANCE=new l}constructor(){this.type=1}cmp(O){return this.type-O.type}equals(O){return O.type===this.type}substituteConstants(){return this}evaluate(O){return!0}serialize(){return"true"}keys(){return[]}map(O){return this}negate(){return s.INSTANCE}}e.$ij=l;class b{static create(O,F=null){const x=d.get(O);return typeof x=="boolean"?x?l.INSTANCE:s.INSTANCE:new b(O,F)}constructor(O,F){this.key=O,this.c=F,this.type=2}cmp(O){return O.type!==this.type?this.type-O.type:N(this.key,O.key)}equals(O){return O.type===this.type?this.key===O.key:!1}substituteConstants(){const O=d.get(this.key);return typeof O=="boolean"?O?l.INSTANCE:s.INSTANCE:this}evaluate(O){return!!O.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(O){return O.mapDefined(this.key)}negate(){return this.c||(this.c=j.create(this.key,this)),this.c}}e.$jj=b;class R{static create(O,F,x=null){if(typeof F=="boolean")return F?b.create(O,x):j.create(O,x);const z=d.get(O);return typeof z=="boolean"?F===(z?"true":"false")?l.INSTANCE:s.INSTANCE:new R(O,F,x)}constructor(O,F,x){this.c=O,this.d=F,this.f=x,this.type=4}cmp(O){return O.type!==this.type?this.type-O.type:G(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){const O=d.get(this.c);if(typeof O=="boolean"){const F=O?"true":"false";return this.d===F?l.INSTANCE:s.INSTANCE}return this}evaluate(O){return O.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(O){return O.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=A.create(this.c,this.d,this)),this.f}}e.$kj=R;class I{static create(O,F){return new I(O,F)}constructor(O,F){this.d=O,this.f=F,this.type=10,this.c=null}cmp(O){return O.type!==this.type?this.type-O.type:G(this.d,this.f,O.d,O.f)}equals(O){return O.type===this.type?this.d===O.d&&this.f===O.f:!1}substituteConstants(){return this}evaluate(O){const F=O.getValue(this.f),x=O.getValue(this.d);return Array.isArray(F)?F.includes(x):typeof x=="string"&&typeof F=="object"&&F!==null?y.call(F,x):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(O){return O.mapIn(this.d,this.f)}negate(){return this.c||(this.c=E.create(this.d,this.f)),this.c}}e.$lj=I;class E{static create(O,F){return new E(O,F)}constructor(O,F){this.d=O,this.f=F,this.type=11,this.c=I.create(O,F)}cmp(O){return O.type!==this.type?this.type-O.type:this.c.cmp(O.c)}equals(O){return O.type===this.type?this.c.equals(O.c):!1}substituteConstants(){return this}evaluate(O){return!this.c.evaluate(O)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(O){return O.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$mj=E;class A{static create(O,F,x=null){if(typeof F=="boolean")return F?j.create(O,x):b.create(O,x);const z=d.get(O);return typeof z=="boolean"?F===(z?"true":"false")?s.INSTANCE:l.INSTANCE:new A(O,F,x)}constructor(O,F,x){this.c=O,this.d=F,this.f=x,this.type=5}cmp(O){return O.type!==this.type?this.type-O.type:G(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){const O=d.get(this.c);if(typeof O=="boolean"){const F=O?"true":"false";return this.d===F?s.INSTANCE:l.INSTANCE}return this}evaluate(O){return O.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(O){return O.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=R.create(this.c,this.d,this)),this.f}}e.$nj=A;class j{static create(O,F=null){const x=d.get(O);return typeof x=="boolean"?x?s.INSTANCE:l.INSTANCE:new j(O,F)}constructor(O,F){this.c=O,this.d=F,this.type=3}cmp(O){return O.type!==this.type?this.type-O.type:N(this.c,O.c)}equals(O){return O.type===this.type?this.c===O.c:!1}substituteConstants(){const O=d.get(this.c);return typeof O=="boolean"?O?s.INSTANCE:l.INSTANCE:this}evaluate(O){return!O.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(O){return O.mapNot(this.c)}negate(){return this.d||(this.d=b.create(this.c,this)),this.d}}e.$oj=j;function T(J,O){if(typeof J=="string"){const F=parseFloat(J);isNaN(F)||(J=F)}return typeof J=="string"||typeof J=="number"?O(J):s.INSTANCE}class W{static create(O,F,x=null){return T(F,z=>new W(O,z,x))}constructor(O,F,x){this.c=O,this.d=F,this.f=x,this.type=12}cmp(O){return O.type!==this.type?this.type-O.type:G(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(O){return O.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=le.create(this.c,this.d,this)),this.f}}e.$pj=W;class V{static create(O,F,x=null){return T(F,z=>new V(O,z,x))}constructor(O,F,x){this.c=O,this.d=F,this.f=x,this.type=13}cmp(O){return O.type!==this.type?this.type-O.type:G(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(O){return O.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=K.create(this.c,this.d,this)),this.f}}e.$qj=V;class K{static create(O,F,x=null){return T(F,z=>new K(O,z,x))}constructor(O,F,x){this.c=O,this.d=F,this.f=x,this.type=14}cmp(O){return O.type!==this.type?this.type-O.type:G(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(O){return O.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=V.create(this.c,this.d,this)),this.f}}e.$rj=K;class le{static create(O,F,x=null){return T(F,z=>new le(O,z,x))}constructor(O,F,x){this.c=O,this.d=F,this.f=x,this.type=15}cmp(O){return O.type!==this.type?this.type-O.type:G(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(O){return O.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=W.create(this.c,this.d,this)),this.f}}e.$sj=le;class re{static create(O,F){return new re(O,F)}constructor(O,F){this.d=O,this.f=F,this.type=7,this.c=null}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.d<O.d)return-1;if(this.d>O.d)return 1;const F=this.f?this.f.source:"",x=O.f?O.f.source:"";return F<x?-1:F>x?1:0}equals(O){if(O.type===this.type){const F=this.f?this.f.source:"",x=O.f?O.f.source:"";return this.d===O.d&&F===x}return!1}substituteConstants(){return this}evaluate(O){const F=O.getValue(this.d);return this.f?this.f.test(F):!1}serialize(){const O=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${O}`}keys(){return[this.d]}map(O){return O.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=ue.create(this)),this.c}}e.$tj=re;class ue{static create(O){return new ue(O)}constructor(O){this.c=O,this.type=8}cmp(O){return O.type!==this.type?this.type-O.type:this.c.cmp(O.c)}equals(O){return O.type===this.type?this.c.equals(O.c):!1}substituteConstants(){return this}evaluate(O){return!this.c.evaluate(O)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(O){return new ue(this.c.map(O))}negate(){return this.c}}e.$uj=ue;function Z(J){let O=null;for(let F=0,x=J.length;F<x;F++){const z=J[F].substituteConstants();if(J[F]!==z&&O===null){O=[];for(let Q=0;Q<F;Q++)O[Q]=J[Q]}O!==null&&(O[F]=z)}return O===null?J:O}class Y{static create(O,F,x){return Y.d(O,F,x)}constructor(O,F){this.expr=O,this.c=F,this.type=6}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.expr.length<O.expr.length)return-1;if(this.expr.length>O.expr.length)return 1;for(let F=0,x=this.expr.length;F<x;F++){const z=i(this.expr[F],O.expr[F]);if(z!==0)return z}return 0}equals(O){if(O.type===this.type){if(this.expr.length!==O.expr.length)return!1;for(let F=0,x=this.expr.length;F<x;F++)if(!this.expr[F].equals(O.expr[F]))return!1;return!0}return!1}substituteConstants(){const O=Z(this.expr);return O===this.expr?this:Y.create(O,this.c,!1)}evaluate(O){for(let F=0,x=this.expr.length;F<x;F++)if(!this.expr[F].evaluate(O))return!1;return!0}static d(O,F,x){const z=[];let Q=!1;for(const H of O)if(H){if(H.type===1){Q=!0;continue}if(H.type===0)return s.INSTANCE;if(H.type===6){z.push(...H.expr);continue}z.push(H)}if(z.length===0&&Q)return l.INSTANCE;if(z.length!==0){if(z.length===1)return z[0];z.sort(i);for(let H=1;H<z.length;H++)z[H-1].equals(z[H])&&(z.splice(H,1),H--);if(z.length===1)return z[0];for(;z.length>1;){const H=z[z.length-1];if(H.type!==9)break;z.pop();const _=z.pop(),B=z.length===0,te=U.create(H.expr.map(ie=>Y.create([ie,_],null,x)),null,B);te&&(z.push(te),z.sort(i))}if(z.length===1)return z[0];if(x){for(let H=0;H<z.length;H++)for(let _=H+1;_<z.length;_++)if(z[H].negate().equals(z[_]))return s.INSTANCE;if(z.length===1)return z[0]}return new Y(z,F)}}serialize(){return this.expr.map(O=>O.serialize()).join(" && ")}keys(){const O=[];for(const F of this.expr)O.push(...F.keys());return O}map(O){return new Y(this.expr.map(F=>F.map(O)),null)}negate(){if(!this.c){const O=[];for(const F of this.expr)O.push(F.negate());this.c=U.create(O,this,!0)}return this.c}}e.$vj=Y;class U{static create(O,F,x){return U.d(O,F,x)}constructor(O,F){this.expr=O,this.c=F,this.type=9}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.expr.length<O.expr.length)return-1;if(this.expr.length>O.expr.length)return 1;for(let F=0,x=this.expr.length;F<x;F++){const z=i(this.expr[F],O.expr[F]);if(z!==0)return z}return 0}equals(O){if(O.type===this.type){if(this.expr.length!==O.expr.length)return!1;for(let F=0,x=this.expr.length;F<x;F++)if(!this.expr[F].equals(O.expr[F]))return!1;return!0}return!1}substituteConstants(){const O=Z(this.expr);return O===this.expr?this:U.create(O,this.c,!1)}evaluate(O){for(let F=0,x=this.expr.length;F<x;F++)if(this.expr[F].evaluate(O))return!0;return!1}static d(O,F,x){let z=[],Q=!1;if(O){for(let H=0,_=O.length;H<_;H++){const B=O[H];if(B){if(B.type===0){Q=!0;continue}if(B.type===1)return l.INSTANCE;if(B.type===9){z=z.concat(B.expr);continue}z.push(B)}}if(z.length===0&&Q)return s.INSTANCE;z.sort(i)}if(z.length!==0){if(z.length===1)return z[0];for(let H=1;H<z.length;H++)z[H-1].equals(z[H])&&(z.splice(H,1),H--);if(z.length===1)return z[0];if(x){for(let H=0;H<z.length;H++)for(let _=H+1;_<z.length;_++)if(z[H].negate().equals(z[_]))return l.INSTANCE;if(z.length===1)return z[0]}return new U(z,F)}}serialize(){return this.expr.map(O=>O.serialize()).join(" || ")}keys(){const O=[];for(const F of this.expr)O.push(...F.keys());return O}map(O){return new U(this.expr.map(F=>F.map(O)),null)}negate(){if(!this.c){const O=[];for(const F of this.expr)O.push(F.negate());for(;O.length>1;){const F=O.shift(),x=O.shift(),z=[];for(const Q of he(F))for(const H of he(x))z.push(Y.create([Q,H],null,!1));O.unshift(U.create(z,null,!1))}this.c=U.create(O,this,!0)}return this.c}}e.$wj=U;class L extends b{static{this.d=[]}static all(){return L.d.values()}constructor(O,F,x){super(O,null),this.f=F,typeof x=="object"?L.d.push({...x,key:O}):x!==!0&&L.d.push({key:O,description:x,type:F!=null?typeof F:void 0})}bindTo(O){return O.createKey(this.key,this.f)}getValue(O){return O.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(O){return R.create(this.key,O)}notEqualsTo(O){return A.create(this.key,O)}}e.$xj=L,e.$yj=(0,M.$gi)("contextKeyService");function N(J,O){return J<O?-1:J>O?1:0}function G(J,O,F,x){return J<F?-1:J>F?1:O<x?-1:O>x?1:0}function q(J,O){if(J.type===0||O.type===1)return!0;if(J.type===9)return O.type===9?oe(J.expr,O.expr):!1;if(O.type===9){for(const F of O.expr)if(q(J,F))return!0;return!1}if(J.type===6){if(O.type===6)return oe(O.expr,J.expr);for(const F of J.expr)if(q(F,O))return!0;return!1}return J.equals(O)}e.$zj=q;function oe(J,O){let F=0,x=0;for(;F<J.length&&x<O.length;){const z=J[F].cmp(O[x]);if(z<0)return!1;z===0&&F++,x++}return F===J.length}function he(J){return J.type===9?J.expr:[J]}}),define(ae[92],ce([0,1,6]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1m=e.$Zm=e.$Ym=e.ID=void 0,e.ID="diagnosticsService",e.$Ym=(0,n.$gi)(e.ID);function D(M){return!!M.hostName&&!!M.errorMessage}e.$Zm=D;class S{async getPerformanceInfo(C,P){return{}}async getSystemInfo(C,P){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(C,P){return""}async getWorkspaceFileExtensions(C){return{extensions:[]}}async reportWorkspaceStats(C){}}e.$1m=S}),define(ae[119],ce([0,1,19,73,168,6,47,4,35]),function(X,e,n,D,S,M,C,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nw=e.$mw=e.ConfirmResult=e.$lw=e.$kw=e.$jw=void 0,e.$jw=(0,M.$gi)("dialogService");var c;(function(w){w[w.Confirmation=1]="Confirmation",w[w.Prompt=2]="Prompt",w[w.Input=3]="Input"})(c||(c={}));class y{a(p){return this.d(p,c.Confirmation)}b(p){return this.d(p,c.Prompt)}c(p){return this.d(p,c.Input)}d(p,u){const f=[];switch(u){case c.Confirmation:{const h=p;h.primaryButton?f.push(h.primaryButton):f.push((0,S.localize)(0,null)),h.cancelButton?f.push(h.cancelButton):f.push((0,S.localize)(1,null));break}case c.Prompt:{const h=p;Array.isArray(h.buttons)&&h.buttons.length>0&&f.push(...h.buttons.map($=>$.label)),h.cancelButton&&(h.cancelButton===!0?f.push((0,S.localize)(2,null)):typeof h.cancelButton=="string"?f.push(h.cancelButton):h.cancelButton.label?f.push(h.cancelButton.label):f.push((0,S.localize)(3,null))),f.length===0&&f.push((0,S.localize)(4,null));break}case c.Input:{const h=p;h.primaryButton?f.push(h.primaryButton):f.push((0,S.localize)(5,null)),h.cancelButton?f.push(h.cancelButton):f.push((0,S.localize)(6,null));break}}return f}e(p){if(typeof p=="string")return p;if(typeof p=="number")return p===D.default.Info?"info":p===D.default.Error?"error":p===D.default.Warning?"warning":"none"}f(p,u,f){const h=[...p.buttons??[]];p.cancelButton&&typeof p.cancelButton!="string"&&typeof p.cancelButton!="boolean"&&h.push(p.cancelButton);let $=h[u]?.run({checkboxChecked:f});return $ instanceof Promise||($=Promise.resolve($)),{result:$,checkboxChecked:f}}}e.$kw=y,e.$lw=(0,M.$gi)("fileDialogService");var v;(function(w){w[w.SAVE=0]="SAVE",w[w.DONT_SAVE=1]="DONT_SAVE",w[w.CANCEL=2]="CANCEL"})(v||(e.ConfirmResult=v={}));const k=10;function g(w){const p=[];return p.push(...w.slice(0,k).map(u=>typeof u=="string"?u:(0,n.$Qg)(u))),w.length>k&&(w.length-k===1?p.push((0,S.localize)(7,null)):p.push((0,S.localize)(8,null,w.length-k))),p.push(""),p.join(`
`)}e.$mw=g;function m(w,p){const u=(0,d.$Ln)(w);let f=(u.buttons??[]).map(t=>(0,C.$gw)(t)),h=(w.buttons||[]).map((t,o)=>o),$=0,a=u.cancelId??f.length-1;if(f.length>1){const t=typeof a=="number"?f[a]:void 0;if(P.$k||P.$j){if(typeof t=="string"&&f.length>1&&a!==1){f.splice(a,1),f.splice(1,0,t);const o=h[a];h.splice(a,1),h.splice(1,0,o),a=1}P.$k&&f.length>1&&(f=f.reverse(),h=h.reverse(),$=f.length-1,typeof t=="string"&&(a=$-1))}else if(P.$i&&typeof t=="string"&&f.length>1&&a!==f.length-1){f.splice(a,1),f.push(t);const o=h[a];h.splice(a,1),h.push(o),a=f.length-1}}return u.buttons=f,u.defaultId=$,u.cancelId=a,u.noLink=!0,u.title=u.title||p.nameLong,{options:u,buttonIndeces:h}}e.$nw=m}),define(ae[120],ce([0,1,6]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CW=e.$BW=e.KnownStorageProvider=e.PasswordStoreCLIOption=e.$AW=e.$zW=void 0,e.$zW=(0,n.$gi)("encryptionService"),e.$AW=(0,n.$gi)("encryptionMainService");var D;(function(P){P.kwallet="kwallet",P.kwallet5="kwallet5",P.gnomeLibsecret="gnome-libsecret",P.basic="basic"})(D||(e.PasswordStoreCLIOption=D={}));var S;(function(P){P.unknown="unknown",P.basicText="basic_text",P.gnomeAny="gnome_any",P.gnomeLibsecret="gnome_libsecret",P.gnomeKeyring="gnome_keyring",P.kwallet="kwallet",P.kwallet5="kwallet5",P.kwallet6="kwallet6",P.dplib="dpapi",P.keychainAccess="keychain_access"})(S||(e.KnownStorageProvider=S={}));function M(P){return P==="kwallet"||P==="kwallet5"||P==="kwallet6"}e.$BW=M;function C(P){return P==="gnome_any"||P==="gnome_libsecret"||P==="gnome_keyring"}e.$CW=C}),define(ae[38],ce([0,1,6]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oi=e.$ni=void 0,e.$ni=(0,n.$gi)("environmentService"),e.$oi=(0,n.$hi)(e.$ni)}),define(ae[121],ce([0,1,172,6]),function(X,e,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=e.$So=e.$Ro=e.$Qo=e.ExtensionGalleryErrorCode=e.$Po=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Oo=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$No=e.$Mo=e.$Lo=e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=void 0,e.$Co="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Do=new RegExp(e.$Co),e.$Eo="__web_extension",e.$Fo="skipWalkthrough",e.$Go="extensionsSync",e.$Ho="dependecyOrPackExtensionInstall";function S(h){switch(h){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$Io=S;function M(h){switch(h){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$Jo=M;function C(h,$){switch(h){case 3:return $==="x64"?"win32-x64":$==="arm64"?"win32-arm64":"unknown";case 2:return $==="x64"?"linux-x64":$==="arm64"?"linux-arm64":$==="arm"?"linux-armhf":"unknown";case"alpine":return $==="x64"?"alpine-x64":$==="arm64"?"alpine-arm64":"unknown";case 1:return $==="x64"?"darwin-x64":$==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$Ko=C;function P(h,$){return $==="web"&&!h.includes("web")}e.$Lo=P;function d(h,$,a){return P($,a)?!1:h==="undefined"||h==="universal"?!0:h==="unknown"?!1:h===a}e.$Mo=d;function c(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(!h.uuid||typeof h.uuid=="string")}e.$No=c;var y;(function(h){h[h.NoneOrRelevance=0]="NoneOrRelevance",h[h.LastUpdatedDate=1]="LastUpdatedDate",h[h.Title=2]="Title",h[h.PublisherName=3]="PublisherName",h[h.InstallCount=4]="InstallCount",h[h.PublishedDate=10]="PublishedDate",h[h.AverageRating=6]="AverageRating",h[h.WeightedRating=12]="WeightedRating"})(y||(e.SortBy=y={}));var v;(function(h){h[h.Default=0]="Default",h[h.Ascending=1]="Ascending",h[h.Descending=2]="Descending"})(v||(e.SortOrder=v={}));var k;(function(h){h.Install="install",h.Uninstall="uninstall"})(k||(e.StatisticType=k={}));var g;(function(h){h[h.None=1]="None",h[h.Install=2]="Install",h[h.Update=3]="Update",h[h.Migrate=4]="Migrate"})(g||(e.InstallOperation=g={})),e.$Oo=(0,D.$gi)("extensionGalleryService");var m;(function(h){h.Unsupported="Unsupported",h.Deprecated="Deprecated",h.Malicious="Malicious",h.Incompatible="Incompatible",h.IncompatibleTargetPlatform="IncompatibleTargetPlatform",h.ReleaseVersionNotFound="ReleaseVersionNotFound",h.Invalid="Invalid",h.Download="Download",h.DownloadSignature="DownloadSignature",h.UpdateMetadata="UpdateMetadata",h.Extract="Extract",h.Scanning="Scanning",h.Delete="Delete",h.Rename="Rename",h.CorruptZip="CorruptZip",h.IncompleteZip="IncompleteZip",h.Signature="Signature",h.NotAllowed="NotAllowed",h.Gallery="Gallery",h.Unknown="Unknown",h.Internal="Internal"})(m||(e.ExtensionManagementErrorCode=m={}));var w;(function(h){h.UnknownError="UnknownError",h.PackageIsInvalidZip="PackageIsInvalidZip",h.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(w||(e.ExtensionSignaturetErrorCode=w={}));class p extends Error{constructor($,a){super($),this.code=a,this.name=a}}e.$Po=p;var u;(function(h){h.Timeout="Timeout",h.Cancelled="Cancelled",h.Failed="Failed"})(u||(e.ExtensionGalleryErrorCode=u={}));class f extends Error{constructor($,a){super($),this.code=a,this.name=a}}e.$Qo=f,e.$Ro=(0,D.$gi)("extensionManagementService"),e.$So="extensionsIdentifiers/disabled",e.$To="extensionsIdentifiers/enabled",e.$Uo=(0,D.$gi)("IGlobalExtensionEnablementService"),e.$Vo=(0,D.$gi)("IExtensionTipsService"),e.$Wo=(0,n.localize2)(0,"Extensions"),e.$Xo=(0,n.localize2)(1,"Preferences")}),define(ae[211],ce([0,1,6]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$G_b=e.$F_b=void 0,e.$F_b=(0,n.$gi)("extensionHostStarter"),e.$G_b="extensionHostStarter"}),define(ae[212],ce([0,1,6]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K4b=e.$J4b=void 0,e.$J4b=(0,n.$gi)("externalTerminal"),e.$K4b="Terminal.app"}),define(ae[213],ce([0,1,6]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I_b=void 0,e.$I_b=(0,n.$gi)("externalTerminal")}),define(ae[214],ce([0,1,48,50,13,9,4,75,21,90,176,212]),function(X,e,n,D,S,M,C,P,d,c,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L_b=e.$K_b=e.$J_b=void 0;const k=y.localize(0,null);class g{async getDefaultTerminalForPlatforms(){return{windows:m.getDefaultTerminalWindows(),linux:await p.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class m extends g{static{this.b="cmd.exe"}openTerminal(a,t){return this.spawnTerminal(n,a,c.$5l(),t)}spawnTerminal(a,t,o,r){const i=t.windowsExec||m.getDefaultTerminalWindows();r&&r[1]===":"&&(r=r[0].toUpperCase()+r.substr(1));const s=M.$nc(i,".exe").toLowerCase();if(s==="cmder")return a.spawn(i,r?[r]:void 0),Promise.resolve(void 0);const l=["/c","start","/wait"];return i.indexOf(" ")>=0&&l.push('""'),l.push(i),s==="wt"&&l.push("-d ."),new Promise((b,R)=>{const I=u(process),E=a.spawn(o,l,{cwd:r,env:I,detached:!0});E.on("error",R),E.on("exit",()=>b())})}async runInTerminal(a,t,o,r,i){const s="windowsExec"in i&&i.windowsExec?i.windowsExec:m.getDefaultTerminalWindows(),l=await m.f();return new Promise((b,R)=>{const I=`"${t} - ${k}"`,E=`"${o.join('" "')}" & pause`,A=Object.assign({},u(process),r);Object.keys(A).filter(K=>A[K]===null).forEach(K=>delete A[K]);const j={cwd:t,env:A,windowsVerbatimArguments:!0};let T,W;M.$nc(s,".exe")==="wt"?(T=s,W=["-d",".",m.b,"/c",E]):l?(T=l,W=["-d",".",s,"/c",E]):(T=m.b,W=["/c","start",I,"/wait",s,"/c",`"${E}"`]),n.spawn(T,W,j).on("error",K=>{R(f(K))}),b(void 0)})}static getDefaultTerminalWindows(){if(!m.d){const a=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");m.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${a?"Sysnative":"System32"}\\cmd.exe`}return m.d}static async f(){try{const a=await c.win32.findExecutable("wt");return await d.Promises.exists(a)?a:void 0}catch{return}}}e.$J_b=m,ve([D.$Kh],m,"f",null);class w extends g{static{this.b="/usr/bin/osascript"}openTerminal(a,t){return this.spawnTerminal(n,a,t)}runInTerminal(a,t,o,r,i){const s=i.osxExec||v.$K4b;return new Promise((l,b)=>{if(s===v.$K4b||s==="iTerm.app"){const R=s===v.$K4b?"TerminalHelper":"iTermHelper",E=[S.$Ag.asFileUri(`vs/workbench/contrib/externalTerminal/node/${R}.scpt`).fsPath,"-t",a||k,"-w",t];for(const T of o)E.push("-a"),E.push(T);if(r){const T=Object.assign({},u(process),r);for(const W in T){const V=T[W];V===null?(E.push("-u"),E.push(W)):(E.push("-e"),E.push(`${W}=${V}`))}}let A="";const j=n.spawn(w.b,E);j.on("error",T=>{b(f(T))}),j.stderr.on("data",T=>{A+=T.toString()}),j.on("exit",T=>{if(T===0)l(void 0);else if(A){const W=A.split(`
`,1);b(new Error(W[0]))}else b(new Error(y.localize(1,null,R,T)))})}else b(new Error(y.localize(2,null,s)))})}spawnTerminal(a,t,o){const r=t.osxExec||v.$K4b;return new Promise((i,s)=>{const l=["-a",r];o&&l.push(o);const b=u(process),R=a.spawn("/usr/bin/open",l,{cwd:o,env:b});R.on("error",s),R.on("exit",()=>i())})}}e.$K_b=w;class p extends g{static{this.b=y.localize(3,null)}openTerminal(a,t){return this.spawnTerminal(n,a,t)}runInTerminal(a,t,o,r,i){const s=i.linuxExec?Promise.resolve(i.linuxExec):p.getDefaultTerminalLinuxReady();return new Promise((l,b)=>{const R=[];s.then(I=>{I.indexOf("gnome-terminal")>=0?R.push("-x"):R.push("-e"),R.push("bash"),R.push("-c");const E=`${h(o)}; echo; read -p "${p.b}" -n1;`;R.push(`''${E}''`);const A=Object.assign({},u(process),r);Object.keys(A).filter(V=>A[V]===null).forEach(V=>delete A[V]);const j={cwd:t,env:A};let T="";const W=n.spawn(I,R,j);W.on("error",V=>{b(f(V))}),W.stderr.on("data",V=>{T+=V.toString()}),W.on("exit",V=>{if(V===0)l(void 0);else if(T){const K=T.split(`
`,1);b(new Error(K[0]))}else b(new Error(y.localize(4,null,I,V)))})})})}static async getDefaultTerminalLinuxReady(){if(!p.d)if(!C.$k)p.d=Promise.resolve("xterm");else{const a=await d.Promises.exists("/etc/debian_version");p.d=new Promise(t=>{a?t("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?t("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?t("konsole"):process.env.COLORTERM?t(process.env.COLORTERM):process.env.TERM?t(process.env.TERM):t("xterm")})}return p.d}spawnTerminal(a,t,o){const r=t.linuxExec?Promise.resolve(t.linuxExec):p.getDefaultTerminalLinuxReady();return new Promise((i,s)=>{r.then(l=>{const b=u(process),R=a.spawn(l,[],{cwd:o,env:b});R.on("error",s),R.on("exit",()=>i())})})}}e.$L_b=p;function u($){const a={...$.env};return(0,P.$3l)(a),a}function f($){return"errno"in $&&$.errno==="ENOENT"&&"path"in $&&typeof $.path=="string"?new Error(y.localize(5,null,$.path)):$}function h($){let a="";for(const t of $)t.indexOf(" ")>=0?a+='"'+t+'"':a+=t,a+=" ";return a}}),define(ae[16],ce([0,1,59,9,25,12,7,178,6,4,13,61]),function(X,e,n,D,S,M,C,P,d,c,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dl=e.$cl=e.$bl=e.$al=e.$_k=e.FileKind=e.$$k=e.$0k=e.$9k=e.$8k=e.$7k=e.$6k=e.$5k=e.FileOperationResult=e.$4k=e.$3k=e.$2k=e.$1k=e.$Zk=e.FileChangeType=e.$Yk=e.FileOperation=e.$Xk=e.$Wk=e.$Vk=e.$Uk=e.$Tk=e.$Sk=e.FileSystemProviderErrorCode=e.$Rk=e.$Qk=e.$Pk=e.$Ok=e.$Nk=e.$Mk=e.$Lk=e.$Kk=e.$Jk=e.FileSystemProviderCapabilities=e.$Ik=e.FilePermission=e.FileType=e.$Hk=e.$Gk=void 0,e.$Gk=(0,d.$gi)("fileService");function k(q){return q.create===!0}e.$Hk=k;var g;(function(q){q[q.Unknown=0]="Unknown",q[q.File=1]="File",q[q.Directory=2]="Directory",q[q.SymbolicLink=64]="SymbolicLink"})(g||(e.FileType=g={}));var m;(function(q){q[q.Readonly=1]="Readonly",q[q.Locked=2]="Locked"})(m||(e.FilePermission=m={}));function w(q){const oe=q;return!!oe&&typeof oe.onDidChange=="function"}e.$Ik=w;var p;(function(q){q[q.None=0]="None",q[q.FileReadWrite=2]="FileReadWrite",q[q.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",q[q.FileReadStream=16]="FileReadStream",q[q.FileFolderCopy=8]="FileFolderCopy",q[q.PathCaseSensitive=1024]="PathCaseSensitive",q[q.Readonly=2048]="Readonly",q[q.Trash=4096]="Trash",q[q.FileWriteUnlock=8192]="FileWriteUnlock",q[q.FileAtomicRead=16384]="FileAtomicRead",q[q.FileAtomicWrite=32768]="FileAtomicWrite",q[q.FileAtomicDelete=65536]="FileAtomicDelete",q[q.FileClone=131072]="FileClone"})(p||(e.FileSystemProviderCapabilities=p={}));function u(q){return!!(q.capabilities&2)}e.$Jk=u;function f(q){return!!(q.capabilities&8)}e.$Kk=f;function h(q){return!!(q.capabilities&131072)}e.$Lk=h;function $(q){return!!(q.capabilities&4)}e.$Mk=$;function a(q){return!!(q.capabilities&16)}e.$Nk=a;function t(q){return u(q)?!!(q.capabilities&16384):!1}e.$Ok=t;function o(q){return u(q)?!!(q.capabilities&32768):!1}e.$Pk=o;function r(q){return!!(q.capabilities&65536)}e.$Qk=r;function i(q){return!!(q.capabilities&2048)}e.$Rk=i;var s;(function(q){q.FileExists="EntryExists",q.FileNotFound="EntryNotFound",q.FileNotADirectory="EntryNotADirectory",q.FileIsADirectory="EntryIsADirectory",q.FileExceedsStorageQuota="EntryExceedsStorageQuota",q.FileTooLarge="EntryTooLarge",q.FileWriteLocked="EntryWriteLocked",q.NoPermissions="NoPermissions",q.Unavailable="Unavailable",q.Unknown="Unknown"})(s||(e.FileSystemProviderErrorCode=s={}));class l extends Error{static create(oe,he){const J=new l(oe.toString(),he);return I(J,he),J}constructor(oe,he){super(oe),this.code=he}}e.$Sk=l;function b(q,oe){return l.create(q,oe)}e.$Tk=b;function R(q){return q||b((0,P.localize)(0,null),s.Unknown)}e.$Uk=R;function I(q,oe){return q.name=oe?`${oe} (FileSystemError)`:"FileSystemError",q}e.$Vk=I;function E(q){if(!q)return s.Unknown;if(q instanceof l)return q.code;const oe=/^(.+) \(FileSystemError\)$/.exec(q.name);if(!oe)return s.Unknown;switch(oe[1]){case s.FileExists:return s.FileExists;case s.FileIsADirectory:return s.FileIsADirectory;case s.FileNotADirectory:return s.FileNotADirectory;case s.FileNotFound:return s.FileNotFound;case s.FileTooLarge:return s.FileTooLarge;case s.FileWriteLocked:return s.FileWriteLocked;case s.NoPermissions:return s.NoPermissions;case s.Unavailable:return s.Unavailable}return s.Unknown}e.$Wk=E;function A(q){if(q instanceof le)return q.fileOperationResult;switch(E(q)){case s.FileNotFound:return 1;case s.FileIsADirectory:return 0;case s.FileNotADirectory:return 9;case s.FileWriteLocked:return 5;case s.NoPermissions:return 6;case s.FileExists:return 4;case s.FileTooLarge:return 7;default:return 10}}e.$Xk=A;var j;(function(q){q[q.CREATE=0]="CREATE",q[q.DELETE=1]="DELETE",q[q.MOVE=2]="MOVE",q[q.COPY=3]="COPY",q[q.WRITE=4]="WRITE"})(j||(e.FileOperation=j={}));class T{constructor(oe,he,J){this.resource=oe,this.operation=he,this.target=J}isOperation(oe){return this.operation===oe}}e.$Yk=T;var W;(function(q){q[q.UPDATED=0]="UPDATED",q[q.ADDED=1]="ADDED",q[q.DELETED=2]="DELETED"})(W||(e.FileChangeType=W={}));class V{static{this.a=null}constructor(oe,he){this.c=he,this.b=void 0,this.d=new v.$V(()=>{const J=n.$mi.forUris(()=>this.c);return J.fill(this.rawAdded.map(O=>[O,!0])),J}),this.f=new v.$V(()=>{const J=n.$mi.forUris(()=>this.c);return J.fill(this.rawUpdated.map(O=>[O,!0])),J}),this.g=new v.$V(()=>{const J=n.$mi.forUris(()=>this.c);return J.fill(this.rawDeleted.map(O=>[O,!0])),J}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const J of oe){switch(J.type){case 1:this.rawAdded.push(J.resource);break;case 0:this.rawUpdated.push(J.resource);break;case 2:this.rawDeleted.push(J.resource);break}this.b!==V.a&&(typeof J.cId=="number"?this.b===void 0?this.b=J.cId:this.b!==J.cId&&(this.b=V.a):this.b!==void 0&&(this.b=V.a))}}contains(oe,...he){return this.h(oe,{includeChildren:!1},...he)}affects(oe,...he){return this.h(oe,{includeChildren:!0},...he)}h(oe,he,...J){if(!oe)return!1;const O=J.length>0;return!!((!O||J.includes(1))&&(this.d.value.get(oe)||he.includeChildren&&this.d.value.findSuperstr(oe))||(!O||J.includes(0))&&(this.f.value.get(oe)||he.includeChildren&&this.f.value.findSuperstr(oe))||(!O||J.includes(2))&&(this.g.value.findSubstr(oe)||he.includeChildren&&this.g.value.findSuperstr(oe)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(oe){return this.b===oe}hasCorrelation(){return typeof this.b=="number"}}e.$Zk=V;function K(q,oe,he){return!q||!oe||q===oe||oe.length>q.length?!1:(oe.charAt(oe.length-1)!==D.sep&&(oe+=D.sep),he?(0,S.$lf)(q,oe):q.indexOf(oe)===0)}e.$1k=K;class le extends Error{constructor(oe,he,J){super(oe),this.fileOperationResult=he,this.options=J}}e.$2k=le;class re extends le{constructor(oe,he,J,O){super(oe,he,O),this.fileOperationResult=he,this.size=J}}e.$3k=re;class ue extends le{constructor(oe,he,J){super(oe,2,J),this.stat=he}}e.$4k=ue;var Z;(function(q){q[q.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",q[q.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",q[q.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",q[q.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",q[q.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",q[q.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",q[q.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",q[q.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",q[q.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",q[q.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",q[q.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(Z||(e.FileOperationResult=Z={})),e.$5k={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$6k={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$7k="files.associations",e.$8k="files.exclude",e.$9k="files.readonlyInclude",e.$0k="files.readonlyExclude",e.$$k="files.readonlyFromPermissions";var Y;(function(q){q[q.FILE=0]="FILE",q[q.FOLDER=1]="FOLDER",q[q.ROOT_FOLDER=2]="ROOT_FOLDER"})(Y||(e.FileKind=Y={})),e.$_k="";function U(q){if(!(typeof q.size!="number"||typeof q.mtime!="number"))return q.mtime.toString(29)+q.size.toString(31)}e.$al=U;async function L(q,oe){if(!oe.hasProvider(C.URI.from({scheme:q.scheme})))return new Promise(he=>{const J=oe.onDidChangeFileSystemProviderRegistrations(O=>{O.scheme===q.scheme&&O.added&&(J.dispose(),he())})})}e.$bl=L;class N{static{this.KB=1024}static{this.MB=N.KB*N.KB}static{this.GB=N.MB*N.KB}static{this.TB=N.GB*N.KB}static formatSize(oe){return(0,M.$Xf)(oe)||(oe=0),oe<N.KB?(0,P.localize)(1,null,oe.toFixed(0)):oe<N.MB?(0,P.localize)(2,null,(oe/N.KB).toFixed(2)):oe<N.GB?(0,P.localize)(3,null,(oe/N.MB).toFixed(2)):oe<N.TB?(0,P.localize)(4,null,(oe/N.GB).toFixed(2)):(0,P.localize)(5,null,(oe/N.TB).toFixed(2))}}e.$cl=N;function G(q){const oe=typeof q=="string"||q?.scheme===y.Schemas.vscodeRemote;return typeof q!="string"&&q?.scheme===y.Schemas.file?1024*N.MB:oe?10*N.MB:c.$o?50*N.MB:1024*N.MB}e.$dl=G}),define(ae[122],ce([0,1,17,15,179,16]),function(X,e,n,D,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qq=void 0;async function C(y,v,k,g,m,w){let p;try{await P(y,v,k,g,m,w)}catch(u){p=u}finally{p&&m.errorTransformer&&(p=m.errorTransformer(p)),typeof p<"u"&&k.error(p),k.end()}}e.$qq=C;async function P(y,v,k,g,m,w){d(w);const p=await y.open(v,{create:!1});try{d(w);let u=0,f=0,h=m&&typeof m.length=="number"?m.length:void 0,$=n.$te.alloc(Math.min(m.bufferSize,typeof h=="number"?h:m.bufferSize)),a=m&&typeof m.position=="number"?m.position:0,t=0;do f=await y.read(p,a,$.buffer,t,$.byteLength-t),a+=f,t+=f,u+=f,typeof h=="number"&&(h-=f),t===$.byteLength&&(await k.write(g($)),$=n.$te.alloc(Math.min(m.bufferSize,typeof h=="number"?h:m.bufferSize)),t=0);while(f>0&&(typeof h!="number"||h>0)&&d(w)&&c(u,m));if(t>0){let o=t;typeof h=="number"&&(o=Math.min(t,h)),k.write(g($.slice(0,o)))}}catch(u){throw(0,M.$Uk)(u)}finally{await y.close(p)}}function d(y){if(y.isCancellationRequested)throw(0,D.$6)();return!0}function c(y,v){if(typeof v?.limits?.size=="number"&&y>v.limits.size)throw(0,M.$Tk)((0,S.localize)(0,null),M.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ae[65],ce([0,1,108,2,9,4,7,16]),function(X,e,n,D,S,M,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zq=e.$yq=e.$xq=e.$wq=e.$vq=e.$uq=e.$tq=e.$sq=void 0;function d(u){return u.recursive===!0}e.$sq=d;class c extends D.$Tc{static{this.a=5}constructor(f,h,$,a){super(),this.h=f,this.j=h,this.m=$,this.n=a,this.c=this.B(new D.$Uc),this.f=void 0,this.g=0}s(){const f=new D.$Sc;this.c.value=f,this.b=this.r(f),this.b.setVerboseLogging(this.m),f.add(this.b.onDidChangeFile(h=>this.h(h))),f.add(this.b.onDidLogMessage(h=>this.j(h))),f.add(this.b.onDidError(h=>this.t(h)))}t(f){this.n.restartOnError?this.g<c.a&&this.f?(this.w(`restarting watcher after error: ${f}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${f}`):this.w(f)}u(f){this.g++,this.s(),this.watch(f)}async watch(f){this.f=f,await this.b?.watch(f)}async setVerboseLogging(f){this.m=f,await this.b?.setVerboseLogging(f)}w(f){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${f}`})}y(f){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${f}`})}dispose(){return this.b=void 0,super.dispose()}}e.$tq=c;class y extends c{constructor(f,h,$){super(f,h,$,{type:"node.js",restartOnError:!1})}}e.$uq=y;class v extends c{constructor(f,h,$){super(f,h,$,{type:"universal",restartOnError:!0})}}e.$vq=v;function k(u){return u.map(f=>({type:f.type,resource:C.URI.revive(f.resource),cId:f.cId}))}e.$wq=k;function g(u){const f=new p;for(const h of u)f.processEvent(h);return f.coalesce()}e.$xq=g;function m(u,f){return typeof f=="string"&&!f.startsWith(n.$Vj)&&!(0,S.$ic)(f)?{base:u,pattern:f}:f}e.$yq=m;function w(u,f){const h=[];for(const $ of f)h.push((0,n.$Zj)(m(u,$)));return h}e.$zq=w;class p{constructor(){this.a=new Set,this.b=new Map}c(f){return M.$k?f.resource.fsPath:f.resource.fsPath.toLowerCase()}processEvent(f){const h=this.b.get(this.c(f));let $=!1;if(h){const a=h.type,t=f.type;h.resource.fsPath!==f.resource.fsPath&&(f.type===2||f.type===1)?$=!0:a===1&&t===2?(this.b.delete(this.c(f)),this.a.delete(h)):a===2&&t===1?h.type=0:a===1&&t===0||(h.type=t)}else $=!0;$&&(this.a.add(f),this.b.set(this.c(f),f))}coalesce(){const f=[],h=[];return Array.from(this.a).filter($=>$.type!==2?(f.push($),!1):!0).sort(($,a)=>$.resource.fsPath.length-a.resource.fsPath.length).filter($=>h.some(a=>(0,P.$1k)($.resource.fsPath,a,!M.$k))?!1:(h.push($.resource.fsPath),!0)).concat(f)}}}),define(ae[215],ce([0,1,17,51,15,3,2,62,32,16,65]),function(X,e,n,D,S,M,C,P,d,c,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yP=e.$xP=void 0,e.$xP="localFilesystem";class v extends C.$Tc{constructor(g,m){super(),this.a=g,this.b=m,this.onDidChangeCapabilities=M.Event.None,this.f=this.B(new M.$6d),this.onDidChangeFile=this.f.event,this.g=this.B(new M.$6d),this.onDidWatchError=this.g.event,this.h=(0,d.$Cg)(),this.j()}get capabilities(){return this.c||(this.c=253982,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(g){return this.a.call("stat",[g])}readdir(g){return this.a.call("readdir",[g])}async readFile(g,m){const{buffer:w}=await this.a.call("readFile",[g,m]);return w}readFileStream(g,m,w){const p=(0,P.$he)(f=>n.$te.concat(f.map(h=>n.$te.wrap(h))).buffer),u=new C.$Sc;return u.add(this.a.listen("readFileStream",[g,m])(f=>{if(f instanceof n.$te)p.write(f.buffer);else{if(f==="end")p.end();else{let h;if(f instanceof Error)h=f;else{const $=f;h=(0,c.$Tk)($.message??(0,D.$4i)($),$.code??c.FileSystemProviderErrorCode.Unknown)}p.error(h),p.end()}u.dispose()}})),u.add(w.onCancellationRequested(()=>{p.error((0,S.$6)()),p.end(),u.dispose()})),p}writeFile(g,m,w){return this.a.call("writeFile",[g,n.$te.wrap(m),w])}open(g,m){return this.a.call("open",[g,m])}close(g){return this.a.call("close",[g])}async read(g,m,w,p,u){const[f,h]=await this.a.call("read",[g,m,u]);return w.set(f.buffer.slice(0,h),p),h}write(g,m,w,p,u){return this.a.call("write",[g,m,n.$te.wrap(w),p,u])}mkdir(g){return this.a.call("mkdir",[g])}delete(g,m){return this.a.call("delete",[g,m])}rename(g,m,w){return this.a.call("rename",[g,m,w])}copy(g,m,w){return this.a.call("copy",[g,m,w])}cloneFile(g,m){return this.a.call("cloneFile",[g,m])}j(){this.B(this.a.listen("fileChange",[this.h])(g=>{if(Array.isArray(g)){const m=g;this.f.fire((0,y.$wq)(m))}else{const m=g;this.g.fire(m)}}))}watch(g,m){const w=(0,d.$Cg)();return this.a.call("watch",[this.h,w,g,m]),(0,C.$Rc)(()=>this.a.call("unwatch",[this.h,w]))}}e.$yP=v}),define(ae[216],ce([0,1,46,8,23,33,2,86,9,4,19,7,109,21,65]),function(X,e,n,D,S,M,C,P,d,c,y,v,k,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nq=e.$Mq=void 0;class w extends C.$Tc{static{this.a=100}static{this.b=75}constructor(f,h,$,a){super(),this.m=f,this.n=h,this.r=$,this.s=a,this.c=this.B(new D.$vh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},t=>this.n(t))),this.f=this.B(new D.$uh(t=>this.z(t),w.b)),this.g=(0,m.$zq)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,m.$zq)(this.m.path,this.m.includes):void 0,this.j=new S.$de,this.ready=this.t()}async t(){try{const f=await this.u(this.m);if(this.j.token.isCancellationRequested)return;const h=await g.Promises.stat(f);this.B(await this.w(f,h.isDirectory()))}catch(f){f.code!=="ENOENT"?this.D(f):this.G(f)}}async u(f){let h=f.path;try{h=await g.Promises.realpath(f.path),f.path===h&&(h=await(0,k.$Jq)(f.path)??f.path),f.path!==h&&this.G(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${f.path}, real: ${h})`)}catch{}return h}async w(f,h){if(c.$j&&(0,M.$gg)(f,"/Volumes/",!0))return this.D(`Refusing to watch ${f} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),C.$Tc.None;const $=new S.$de(this.j.token),a=new C.$Sc;try{const t=v.URI.file(this.m.path),o=(0,d.$nc)(f),r=(0,n.watch)(f);a.add((0,C.$Rc)(()=>{r.removeAllListeners(),r.close()})),this.G(`Started watching: '${f}'`);const i=new Set;if(h)try{for(const l of await g.Promises.readdir(f))i.add(l)}catch(l){this.D(l)}const s=new Map;a.add((0,C.$Rc)(()=>{for(const[,l]of s)l.dispose();s.clear()})),r.on("error",(l,b)=>{this.D(`Failed to watch ${f} for changes using fs.watch() (${l}, ${b})`),this.dispose()}),r.on("change",(l,b)=>{if($.token.isCancellationRequested)return;this.G(`[raw] ["${l}"] ${b}`);let R="";if(b&&(R=b.toString(),c.$j&&(R=(0,P.$Rl)(R))),!(!R||l!=="change"&&l!=="rename"))if(h)if(l==="rename"){s.get(R)?.dispose();const I=setTimeout(async()=>{if(s.delete(R),R===o&&!await g.Promises.exists(f)){this.F("Watcher shutdown because watched path got deleted"),this.dispose();return}const E=await this.C((0,d.$jc)(f,R));if($.token.isCancellationRequested)return;let A;E?i.has(R)?A=0:(A=1,i.add(R)):(i.delete(R),A=2),this.y({resource:(0,y.$Tg)(t,R),type:A,cId:this.m.correlationId})},w.a);s.set(R,(0,C.$Rc)(()=>clearTimeout(I)))}else{let I;i.has(R)?I=0:(I=1,i.add(R)),this.y({resource:(0,y.$Tg)(t,R),type:I,cId:this.m.correlationId})}else if(l==="rename"||R!==o){const I=setTimeout(async()=>{const E=await g.Promises.exists(f);$.token.isCancellationRequested||(E?(this.y({resource:t,type:0,cId:this.m.correlationId},!0),a.add(await this.w(f,!1))):(this.y({resource:t,type:2,cId:this.m.correlationId},!0),this.f.flush(),this.dispose()))},w.a);a.clear(),a.add((0,C.$Rc)(()=>clearTimeout(I)))}else this.y({resource:t,type:0,cId:this.m.correlationId},!0)})}catch(t){await g.Promises.exists(f)&&!$.token.isCancellationRequested&&this.D(`Failed to watch ${f} for changes using fs.watch() (${t.toString()})`)}return(0,C.$Rc)(()=>{$.dispose(!0),a.dispose()})}y(f,h=!1){this.j.token.isCancellationRequested||(this.s&&this.G(`${f.type===1?"[ADDED]":f.type===2?"[DELETED]":"[CHANGED]"} ${f.resource.fsPath}`),!h&&this.g.some($=>$(f.resource.fsPath))?this.s&&this.G(` >> ignored (excluded) ${f.resource.fsPath}`):!h&&this.h&&this.h.length>0&&!this.h.some($=>$(f.resource.fsPath))?this.s&&this.G(` >> ignored (not included) ${f.resource.fsPath}`):this.f.work(f))}z(f){const h=(0,m.$xq)(f);if(h.length>0){if(this.s)for(const a of h)this.G(` >> normalized ${a.type===1?"[ADDED]":a.type===2?"[DELETED]":"[CHANGED]"} ${a.resource.fsPath}`);this.c.work(h)?this.c.pending>0&&this.G(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${h[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.F(`started ignoring events due to too many file change events at once (incoming: ${h.length}, most recent change: ${h[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async C(f){if(c.$k)return g.Promises.exists(f);try{const h=(0,d.$nc)(f);return(await g.Promises.readdir((0,d.$mc)(f))).some(a=>a===h)}catch(h){return this.G(h),!1}}setVerboseLogging(f){this.s=f}D(f){this.j.token.isCancellationRequested||this.r?.({type:"error",message:`[File Watcher (node.js)] ${f}`})}F(f){this.j.token.isCancellationRequested||this.r?.({type:"warn",message:`[File Watcher (node.js)] ${f}`})}G(f){!this.j.token.isCancellationRequested&&this.s&&this.r?.({type:"trace",message:`[File Watcher (node.js)] ${f}`})}dispose(){this.G(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$Mq=w;async function p(u,f,h,$,a=512){const t=await g.Promises.open(u,"r"),o=Buffer.allocUnsafe(a),r=new S.$de($);let i,s=!1;const l={path:u,excludes:[],recursive:!1},b=new w(l,R=>{(async()=>{for(const{type:I}of R)if(I===0){if(s)return;s=!0;try{for(;!r.token.isCancellationRequested;){const{bytesRead:E}=await g.Promises.read(t,o,0,a,null);if(!E||r.token.isCancellationRequested)break;f(o.slice(0,E))}}catch(E){i=new Error(E),r.dispose(!0)}finally{s=!1}}})()});return await b.ready,h(),new Promise((R,I)=>{r.token.onCancellationRequested(async()=>{b.dispose();try{await g.Promises.close(t)}catch(E){i=new Error(E)}i?I(i):R()})})}e.$Nq=p}),define(ae[217],ce([0,1,3,108,2,4,216]),function(X,e,n,D,S,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oq=void 0;class P extends S.$Tc{constructor(){super(...arguments),this.a=this.B(new n.$6d),this.onDidChangeFile=this.a.event,this.b=this.B(new n.$6d),this.onDidLogMessage=this.b.event,this.onDidError=n.Event.None,this.c=new Map,this.f=!1}async watch(c){const y=this.j(c),v=y.filter(g=>{const m=this.c.get(g.path);return m?!(0,D.$4j)(m.request.excludes,g.excludes)||!(0,D.$4j)(m.request.includes,g.includes):!0}),k=Array.from(this.c.values()).filter(({request:g})=>!y.find(m=>m.path===g.path&&(0,D.$4j)(m.excludes,g.excludes)&&(0,D.$4j)(m.includes,g.includes))).map(({request:g})=>g.path);v.length&&this.m(`Request to start watching: ${v.map(g=>`${g.path} (excludes: ${g.excludes.length>0?g.excludes:"<none>"}, includes: ${g.includes&&g.includes.length>0?JSON.stringify(g.includes):"<all>"}, correlationId: ${typeof g.correlationId=="number"?g.correlationId:"<none>"})`).join(",")}`),k.length&&this.m(`Request to stop watching: ${k.join(",")}`);for(const g of k)this.h(g);for(const g of v)this.g(g)}g(c){const y=new C.$Mq(c,k=>this.a.fire(k),k=>this.b.fire(k),this.f),v={request:c,instance:y};this.c.set(c.path,v)}async stop(){for(const[c]of this.c)this.h(c);this.c.clear()}h(c){const y=this.c.get(c);y&&(this.c.delete(c),y.instance.dispose())}j(c){const y=new Map;for(const v of c){const k=M.$k?v.path:v.path.toLowerCase();let g=y.get(v.correlationId);g||(g=new Map,y.set(v.correlationId,g)),g.set(k,v)}return Array.from(y.values()).map(v=>Array.from(v.values())).flat()}async setVerboseLogging(c){this.f=c;for(const[,y]of this.c)y.instance.setVerboseLogging(c)}m(c){this.f&&this.b.fire({type:"trace",message:this.n(c)})}n(c,y){return y?`[File Watcher (node.js)] ${c} (path: ${y.request.path})`:`[File Watcher (node.js)] ${c}`}}e.$Oq=P}),define(ae[218],ce([0,1,65,217]),function(X,e,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pq=void 0;class S extends n.$uq{constructor(C,P,d){super(C,P,d),this.s()}r(C){return C.add(new D.$Oq)}}e.$Pq=S}),define(ae[219],ce([0,1,13,43,162,65]),function(X,e,n,D,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hq=void 0;class C extends M.$vq{constructor(d,c,y){super(d,c,y),this.s()}r(d){const c=d.add(new S.$Gq(n.$Ag.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return d.add(c.onDidProcessExit(({code:y,signal:v})=>this.t(`terminated by itself with code ${y}, signal: ${v}`))),D.ProxyChannel.toService((0,D.$Zh)(c.getChannel("watcher")))}}e.$Hq=C}),define(ae[93],ce([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ei=void 0;class n{constructor(...S){this.a=new Map;for(const[M,C]of S)this.set(M,C)}set(S,M){const C=this.a.get(S);return this.a.set(S,M),C}has(S){return this.a.has(S)}get(S){return this.a.get(S)}}e.$ei=n}),define(ae[220],ce([0,1,8,15,2,77,210,6,93,104]),function(X,e,n,D,S,M,C,P,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uq=e.$Tq=void 0;const y=!1;class v extends Error{constructor(p){super("cyclic dependency between services"),this.message=p.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${p.toString()}`}}class k{constructor(p=new d.$ei,u=!1,f,h=y){this.f=p,this.g=u,this.h=f,this.i=h,this.o=new Set,this.f.set(P.$fi,this),this._globalGraph=h?f?._globalGraph??new C.$Sq($=>$):void 0}createChild(p){return new k(p,this.g,this,this.i)}invokeFunction(p,...u){const f=m.traceInvocation(this.i,p);let h=!1;try{return p({get:a=>{if(h)throw(0,D.$8)("service accessor is only valid during the invocation of its target method");const t=this.m(a,f);if(!t)throw new Error(`[invokeFunction] unknown service '${a}'`);return t}},...u)}finally{h=!0,f.stop()}}createInstance(p,...u){let f,h;return p instanceof M.$di?(f=m.traceCreation(this.i,p.ctor),h=this.j(p.ctor,p.staticArguments.concat(u),f)):(f=m.traceCreation(this.i,p),h=this.j(p,u,f)),f.stop(),h}j(p,u=[],f){const h=P._util.getServiceDependencies(p).sort((t,o)=>t.index-o.index),$=[];for(const t of h){const o=this.m(t.id,f);o||this.u(`[createInstance] ${p.name} depends on UNKNOWN service ${t.id}.`,!1),$.push(o)}const a=h.length>0?h[0].index:u.length;if(u.length!==a){console.trace(`[createInstance] First service dependency of ${p.name} at position ${a+1} conflicts with ${u.length} static arguments`);const t=a-u.length;t>0?u=u.concat(new Array(t)):u=u.slice(0,a)}return Reflect.construct(p,u.concat($))}k(p,u){if(this.f.get(p)instanceof M.$di)this.f.set(p,u);else if(this.h)this.h.k(p,u);else throw new Error("illegalState - setting UNKNOWN service instance")}l(p){const u=this.f.get(p);return!u&&this.h?this.h.l(p):u}m(p,u){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(p));const f=this.l(p);return f instanceof M.$di?this.q(p,f,u.branch(p,!0)):(u.branch(p,!1),f)}q(p,u,f){if(this.o.has(p))throw new Error(`illegal state - RECURSIVELY instantiating service '${p}'`);this.o.add(p);try{return this.r(p,u,f)}finally{this.o.delete(p)}}r(p,u,f){const h=new C.$Sq(t=>t.id.toString());let $=0;const a=[{id:p,desc:u,_trace:f}];for(;a.length;){const t=a.pop();if(h.lookupOrInsertNode(t),$++>1e3)throw new v(h);for(const o of P._util.getServiceDependencies(t.desc.ctor)){const r=this.l(o.id);if(r||this.u(`[createInstance] ${p} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(o.id)),r instanceof M.$di){const i={id:o.id,desc:r,_trace:t._trace.branch(o.id,!0)};h.insertEdge(t,i),a.push(i)}}}for(;;){const t=h.roots();if(t.length===0){if(!h.isEmpty())throw new v(h);break}for(const{data:o}of t){if(this.l(o.id)instanceof M.$di){const i=this.s(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this.k(o.id,i)}h.removeNode(o)}}return this.l(p)}s(p,u,f=[],h,$){if(this.f.get(p)instanceof M.$di)return this.t(p,u,f,h,$);if(this.h)return this.h.s(p,u,f,h,$);throw new Error(`illegalState - creating UNKNOWN service instance ${u.name}`)}t(p,u,f=[],h,$){if(h){const a=new k(void 0,this.g,this,this.i);a.c=String(p);const t=new Map,o=new n.$zh(()=>{const r=a.j(u,f,$);for(const[i,s]of t){const l=r[i];if(typeof l=="function")for(const b of s)b.disposable=l.apply(r,b.listener)}return t.clear(),r});return new Proxy(Object.create(null),{get(r,i){if(!o.isInitialized&&typeof i=="string"&&(i.startsWith("onDid")||i.startsWith("onWill"))){let b=t.get(i);return b||(b=new c.$4c,t.set(i,b)),(I,E,A)=>{if(o.isInitialized)return o.value[i](I,E,A);{const j={listener:[I,E,A],disposable:void 0},T=b.push(j);return(0,S.$Rc)(()=>{T(),j.disposable?.dispose()})}}}if(i in r)return r[i];const s=o.value;let l=s[i];return typeof l!="function"||(l=l.bind(s),r[i]=l),l},set(r,i,s){return o.value[i]=s,!0},getPrototypeOf(r){return u.prototype}})}else return this.j(u,f,$)}u(p,u){if(u&&console.warn(p),this.g)throw new Error(p)}}e.$Tq=k;var g;(function(w){w[w.None=0]="None",w[w.Creation=1]="Creation",w[w.Invocation=2]="Invocation",w[w.Branch=3]="Branch"})(g||(g={}));class m{static{this.all=new Set}static{this.c=new class extends m{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(p,u){return p?new m(2,u.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):m.c}static traceCreation(p,u){return p?new m(1,u.name):m.c}static{this.f=0}constructor(p,u){this.type=p,this.name=u,this.g=Date.now(),this.h=[]}branch(p,u){const f=new m(3,p.toString());return this.h.push([p,u,f]),f}stop(){const p=Date.now()-this.g;m.f+=p;let u=!1;function f($,a){const t=[],o=new Array($+1).join("	");for(const[r,i,s]of a.h)if(i&&s){u=!0,t.push(`${o}CREATES -> ${r}`);const l=f($+1,s);l&&t.push(l)}else t.push(`${o}uses -> ${r}`);return t.join(`
`)}const h=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${f(1,this)}`,`DONE, took ${p.toFixed(2)}ms (grand total ${m.f.toFixed(2)}ms)`];(p>2||u)&&m.all.add(h.join(`
`))}}e.$Uq=m}),define(ae[221],ce([0,1,6]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JBb=e.IssueType=void 0;var D;(function(S){S[S.Bug=0]="Bug",S[S.PerformanceIssue=1]="PerformanceIssue",S[S.FeatureRequest=2]="FeatureRequest"})(D||(e.IssueType=D={})),e.$JBb=(0,n.$gi)("issueService")}),define(ae[5],ce([0,1,51,3,45,2,31,4,19,12,7,118,6]),function(X,e,n,D,S,M,C,P,d,c,y,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.log=e.$Dj=e.LogLevel=e.$Cj=e.$Bj=e.$Aj=void 0,e.$Aj=(0,k.$gi)("logService"),e.$Bj=(0,k.$gi)("loggerService");function g(){return new Date().toISOString()}function m(I){return(0,c.$Xf)(I)}e.$Cj=m;var w;(function(I){I[I.Off=0]="Off",I[I.Trace=1]="Trace",I[I.Debug=2]="Debug",I[I.Info=3]="Info",I[I.Warning=4]="Warning",I[I.Error=5]="Error"})(w||(e.LogLevel=w={})),e.$Dj=w.Info;function p(I,E,A){switch(E){case w.Trace:I.trace(A);break;case w.Debug:I.debug(A);break;case w.Info:I.info(A);break;case w.Warning:I.warn(A);break;case w.Error:I.error(A);break;case w.Off:break;default:throw new Error(`Invalid log level ${E}`)}}e.log=p;function u(I,E=!1){let A="";for(let j=0;j<I.length;j++){let T=I[j];if(T instanceof Error&&(T=(0,n.$4i)(T,E)),typeof T=="object")try{T=JSON.stringify(T)}catch{}A+=(j>0?" ":"")+T}return A}class f extends M.$Tc{constructor(){super(...arguments),this.b=e.$Dj,this.c=this.B(new D.$6d),this.onDidChangeLogLevel=this.c.event}setLevel(E){this.b!==E&&(this.b=E,this.c.fire(this.b))}getLevel(){return this.b}f(E){return this.b!==w.Off&&this.b<=E}}e.$Fj=f;class h extends f{constructor(E){super(),this.h=E}f(E){return this.h||super.f(E)}trace(E,...A){this.f(w.Trace)&&this.g(w.Trace,u([E,...A],!0))}debug(E,...A){this.f(w.Debug)&&this.g(w.Debug,u([E,...A]))}info(E,...A){this.f(w.Info)&&this.g(w.Info,u([E,...A]))}warn(E,...A){this.f(w.Warning)&&this.g(w.Warning,u([E,...A]))}error(E,...A){if(this.f(w.Error))if(E instanceof Error){const j=Array.prototype.slice.call(arguments);j[0]=E.stack,this.g(w.Error,u(j))}else this.g(w.Error,u([E,...A]))}flush(){}}e.$Gj=h;class $ extends f{constructor(E=e.$Dj){super(),this.setLevel(E),this.g=!P.$i}trace(E,...A){this.f(w.Trace)&&(this.g?console.log(`\x1B[90m[main ${g()}]\x1B[0m`,E,...A):console.log(`[main ${g()}]`,E,...A))}debug(E,...A){this.f(w.Debug)&&(this.g?console.log(`\x1B[90m[main ${g()}]\x1B[0m`,E,...A):console.log(`[main ${g()}]`,E,...A))}info(E,...A){this.f(w.Info)&&(this.g?console.log(`\x1B[90m[main ${g()}]\x1B[0m`,E,...A):console.log(`[main ${g()}]`,E,...A))}warn(E,...A){this.f(w.Warning)&&(this.g?console.warn(`\x1B[93m[main ${g()}]\x1B[0m`,E,...A):console.warn(`[main ${g()}]`,E,...A))}error(E,...A){this.f(w.Error)&&(this.g?console.error(`\x1B[91m[main ${g()}]\x1B[0m`,E,...A):console.error(`[main ${g()}]`,E,...A))}flush(){}}e.$Hj=$;class a extends f{constructor(E=e.$Dj,A=!0){super(),this.g=A,this.setLevel(E)}trace(E,...A){this.f(w.Trace)&&(this.g?console.log("%cTRACE","color: #888",E,...A):console.log(E,...A))}debug(E,...A){this.f(w.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",E,...A):console.log(E,...A))}info(E,...A){this.f(w.Info)&&(this.g?console.log("%c INFO","color: #33f",E,...A):console.log(E,...A))}warn(E,...A){this.f(w.Warning)&&(this.g?console.log("%c WARN","color: #993",E,...A):console.log(E,...A))}error(E,...A){this.f(w.Error)&&(this.g?console.log("%c  ERR","color: #f33",E,...A):console.error(E,...A))}flush(){}}e.$Ij=a;class t extends f{constructor(E,A=e.$Dj){super(),this.g=E,this.setLevel(A)}trace(E,...A){this.f(w.Trace)&&this.g.log(w.Trace,[this.h(E),...A])}debug(E,...A){this.f(w.Debug)&&this.g.log(w.Debug,[this.h(E),...A])}info(E,...A){this.f(w.Info)&&this.g.log(w.Info,[this.h(E),...A])}warn(E,...A){this.f(w.Warning)&&this.g.log(w.Warning,[this.h(E),...A])}error(E,...A){this.f(w.Error)&&this.g.log(w.Error,[this.h(E),...A])}h(E){return typeof E=="string"?E:(0,n.$4i)(E,this.f(w.Trace))}flush(){}}e.$Jj=t;class o extends f{constructor(E){super(),this.g=E,E.length&&this.setLevel(E[0].getLevel())}setLevel(E){for(const A of this.g)A.setLevel(E);super.setLevel(E)}trace(E,...A){for(const j of this.g)j.trace(E,...A)}debug(E,...A){for(const j of this.g)j.debug(E,...A)}info(E,...A){for(const j of this.g)j.info(E,...A)}warn(E,...A){for(const j of this.g)j.warn(E,...A)}error(E,...A){for(const j of this.g)j.error(E,...A)}flush(){for(const E of this.g)E.flush()}dispose(){for(const E of this.g)E.dispose();super.dispose()}}e.$Kj=o;class r extends M.$Tc{constructor(E,A,j){if(super(),this.h=E,this.j=A,this.b=new C.$Ac,this.c=this.B(new D.$6d),this.onDidChangeLoggers=this.c.event,this.f=this.B(new D.$6d),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new D.$6d),this.onDidChangeVisibility=this.g.event,j)for(const T of j)this.b.set(T.resource,{logger:void 0,info:T})}m(E){return(0,c.$Tf)(E)?[...this.b.values()].find(A=>A.info.id===E):this.b.get(E)}getLogger(E){return this.m(E)?.logger}createLogger(E,A){const j=this.n(E),T=(0,c.$Tf)(E)?E:A?.id??(0,S.$7i)(j.toString()).toString(16);let W=this.b.get(j)?.logger;const V=A?.logLevel==="always"?w.Trace:A?.logLevel;W||(W=this.s(j,V??this.getLogLevel(j)??this.h,{...A,id:T}));const K={logger:W,info:{resource:j,id:T,logLevel:V,name:A?.name,hidden:A?.hidden,extensionId:A?.extensionId,when:A?.when}};return this.registerLogger(K.info),this.b.set(j,K),W}n(E){return(0,c.$Tf)(E)?(0,d.$Tg)(this.j,`${E}.log`):E}setLogLevel(E,A){if(y.URI.isUri(E)){const j=E,T=A,W=this.b.get(j);W&&T!==W.info.logLevel&&(W.info.logLevel=T===this.h?void 0:T,W.logger?.setLevel(T),this.b.set(W.info.resource,W),this.f.fire([j,T]))}else{this.h=E;for(const[j,T]of this.b.entries())this.b.get(j)?.info.logLevel===void 0&&T.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(E,A){const j=this.m(E);j&&A!==!j.info.hidden&&(j.info.hidden=!A,this.b.set(j.info.resource,j),this.g.fire([j.info.resource,A]))}getLogLevel(E){let A;return E&&(A=this.b.get(E)?.info.logLevel),A??this.h}registerLogger(E){const A=this.b.get(E.resource);A?A.info.hidden!==E.hidden&&this.setVisibility(E.resource,!E.hidden):(this.b.set(E.resource,{info:E,logger:void 0}),this.c.fire({added:[E],removed:[]}))}deregisterLogger(E){const A=this.b.get(E);A&&(A.logger&&A.logger.dispose(),this.b.delete(E),this.c.fire({added:[],removed:[A.info]}))}*getRegisteredLoggers(){for(const E of this.b.values())yield E.info}getRegisteredLogger(E){return this.b.get(E)?.info}dispose(){this.b.forEach(E=>E.logger?.dispose()),this.b.clear(),super.dispose()}}e.$Lj=r;class i{constructor(){this.onDidChangeLogLevel=new D.$6d().event}setLevel(E){}getLevel(){return w.Info}trace(E,...A){}debug(E,...A){}info(E,...A){}warn(E,...A){}error(E,...A){}critical(E,...A){}dispose(){}flush(){}}e.$Mj=i;class s extends i{}e.$Nj=s;function l(I){if(I.verbose)return w.Trace;if(typeof I.logLevel=="string"){const E=R(I.logLevel.toLowerCase());if(E!==void 0)return E}return e.$Dj}e.$Oj=l;function b(I){switch(I){case w.Trace:return"trace";case w.Debug:return"debug";case w.Info:return"info";case w.Warning:return"warn";case w.Error:return"error";case w.Off:return"off"}}e.$Pj=b;function R(I){switch(I){case"trace":return w.Trace;case"debug":return w.Debug;case"info":return w.Info;case"warn":return w.Warning;case"error":return w.Error;case"critical":return w.Error;case"off":return w.Off}}e.$Qj=R,e.$Rj=new v.$xj("logLevel",b(w.Info))});var se=this&&this.__param||function(X,e){return function(n,D){e(n,D,X)}};define(ae[222],ce([0,1,14,4,5]),function(X,e,n,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E_b=void 0;const M=n.safeStorage;let C=class{constructor(d){this.a=d,n.app.commandLine.getSwitchValue("password-store")==="basic"&&M.setUsePlainTextEncryption?.(!0)}async encrypt(d){this.a.trace("[EncryptionMainService] Encrypting value.");try{const c=JSON.stringify(M.encryptString(d));return this.a.trace("[EncryptionMainService] Encrypted value."),c}catch(c){throw this.a.error(c),c}}async decrypt(d){let c;try{if(c=JSON.parse(d),!c.data)throw new Error(`[EncryptionMainService] Invalid encrypted value: ${d}`);const y=Buffer.from(c.data);this.a.trace("[EncryptionMainService] Decrypting value.");const v=M.decryptString(y);return this.a.trace("[EncryptionMainService] Decrypted value."),v}catch(y){throw this.a.error(y),y}}isEncryptionAvailable(){return Promise.resolve(M.isEncryptionAvailable())}getKeyStorageProvider(){if(D.$i)return Promise.resolve("dpapi");if(D.$j)return Promise.resolve("keychain_access");if(M.getSelectedStorageBackend)try{const d=M.getSelectedStorageBackend();return Promise.resolve(d)}catch(d){this.a.error(d)}return Promise.resolve("unknown")}async setUsePlainTextEncryption(){if(D.$i)throw new Error("Setting plain text encryption is not supported on Windows.");if(D.$j)throw new Error("Setting plain text encryption is not supported on macOS.");if(!M.setUsePlainTextEncryption)throw new Error("Setting plain text encryption is not supported.");M.setUsePlainTextEncryption(!0)}};e.$E_b=C,e.$E_b=C=ve([se(0,S.$Aj)],C)}),define(ae[223],ce([0,1,22,8,15,3,2,9,65,5]),function(X,e,n,D,S,M,C,P,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aq=void 0;class y extends C.$Tc{constructor(k,g){super(),this.a=k,this.b=g,this.c=this.B(new M.$6d),this.onDidChangeFile=this.c.event,this.g=this.B(new M.$6d),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new D.$eh(0)),this.w=[],this.y=this.B(new D.$eh(0))}watch(k,g){return g.recursive||this.b?.watcher?.forceUniversal?this.n(k,g):this.z(k,g)}n(k,g){const m={path:this.H(k),excludes:g.excludes,includes:g.includes,recursive:g.recursive,correlationId:g.correlationId},w=(0,n.$Ub)(this.j,m);return this.r(),(0,C.$Rc)(()=>{w(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(k=>(0,S.$1)(k))}s(){this.h||(this.h=this.B(this.t(g=>this.c.fire((0,d.$wq)(g)),g=>this.G(g),this.a.getLevel()===c.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===c.LogLevel.Trace)})));const k=this.b?.watcher?.recursive?.usePolling;if(k===!0)for(const g of this.j)(0,d.$sq)(g)&&(g.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(k))for(const g of this.j)(0,d.$sq)(g)&&k.includes(g.path)&&(g.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(k,g){const m={path:this.H(k),excludes:g.excludes,includes:g.includes,recursive:!1,correlationId:g.correlationId},w=(0,n.$Ub)(this.w,m);return this.C(),(0,C.$Rc)(()=>{w(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(k=>(0,S.$1)(k))}D(){return this.u||(this.u=this.B(this.F(k=>this.c.fire((0,d.$wq)(k)),k=>this.G(k),this.a.getLevel()===c.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===c.LogLevel.Trace)}))),this.u.watch(this.w)}G(k){k.type==="error"&&this.g.fire(k.message),this.a[k.type](k.message)}H(k){return(0,P.$hc)(k.fsPath)}}e.$Aq=y}),define(ae[224],ce([0,1,22,8,17,23,3,45,71,2,59,13,66,19,62,177,16,122,5,15]),function(X,e,n,D,S,M,C,P,d,c,y,v,k,g,m,w,p,u,f,h){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$rq=void 0;let a=class extends c.$Tc{static{$=this}constructor(o){super(),this.b=o,this.a=256*1024,this.c=this.B(new C.$6d),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new C.$6d),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new C.$6d),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new C.$6d),this.onDidRunOperation=this.r.event,this.X=this.B(new C.$6d),this.Y=this.B(new C.$6d),this.onDidFilesChange=this.Y.event,this.Z=this.B(new C.$6d),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new D.$ph)}registerProvider(o,r){if(this.h.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,k.mark)(`code/registerFilesystem/${o}`);const i=new c.$Sc;return this.h.set(o,r),this.c.fire({added:!0,scheme:o,provider:r}),i.add(r.onDidChangeFile(s=>{const l=new p.$Zk(s,!this.S(r));this.X.fire(l),l.hasCorrelation()||this.Y.fire(l)})),typeof r.onDidWatchError=="function"&&i.add(r.onDidWatchError(s=>this.Z.fire(new Error(s)))),i.add(r.onDidChangeCapabilities(()=>this.g.fire({provider:r,scheme:o}))),(0,c.$Rc)(()=>{this.c.fire({added:!1,scheme:o,provider:r}),this.h.delete(o),(0,c.$Oc)(i)})}getProvider(o){return this.h.get(o)}async activateProvider(o){const r=[];this.f.fire({scheme:o,join(i){r.push(i)}}),!this.h.has(o)&&await D.Promises.settled(r)}async canHandleResource(o){return await this.activateProvider(o.scheme),this.hasProvider(o)}hasProvider(o){return this.h.has(o.scheme)}hasCapability(o,r){const i=this.h.get(o.scheme);return!!(i&&i.capabilities&r)}listCapabilities(){return d.Iterable.map(this.h,([o,r])=>({scheme:o,capabilities:r.capabilities}))}async j(o){if(!(0,g.$Xg)(o))throw new p.$2k((0,w.localize)(0,null,this.sb(o)),8);await this.activateProvider(o.scheme);const r=this.h.get(o.scheme);if(!r){const i=new h.$bb;throw i.message=(0,w.localize)(1,null,o.toString()),i}return r}async m(o){const r=await this.j(o);if((0,p.$Mk)(r)||(0,p.$Jk)(r)||(0,p.$Nk)(r))return r;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(o){const r=await this.j(o);if((0,p.$Mk)(r)||(0,p.$Jk)(r))return r;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,r){try{return await this.s(o,r)}catch(i){throw(0,p.$Wk)(i)===p.FileSystemProviderErrorCode.FileNotFound?new p.$2k((0,w.localize)(2,null,this.sb(o)),1):(0,p.$Uk)(i)}}async s(o,r){const i=await this.j(o),s=this.S(i),l=r?.resolveTo,b=r?.resolveSingleChildDescendants,R=r?.resolveMetadata,I=await i.stat(o);let E;return this.t(i,o,I,void 0,!!R,(A,j)=>(E||(E=y.$mi.forUris(()=>!s),E.set(o,!0),l&&E.fill(!0,l)),E.get(A.resource)||E.findSuperstr(A.resource.with({query:null,fragment:null}))?!0:A.isDirectory&&b?j===1:!1))}async t(o,r,i,s,l,b){const{providerExtUri:R}=this.R(o),I={resource:r,name:R.basename(r),isFile:(i.type&p.FileType.File)!==0,isDirectory:(i.type&p.FileType.Directory)!==0,isSymbolicLink:(i.type&p.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:!!((i.permissions??0)&p.FilePermission.Readonly)||!!(o.capabilities&2048),locked:!!((i.permissions??0)&p.FilePermission.Locked),etag:(0,p.$al)({mtime:i.mtime,size:i.size}),children:void 0};if(I.isDirectory&&b(I,s)){try{const E=await o.readdir(r),A=await D.Promises.settled(E.map(async([j,T])=>{try{const W=R.joinPath(r,j),V=l?await o.stat(W):{type:T};return await this.t(o,W,V,E.length,l,b)}catch(W){return this.b.trace(W),null}}));I.children=(0,n.$Hb)(A)}catch(E){this.b.trace(E),I.children=[]}return I}return I}async resolveAll(o){return D.Promises.settled(o.map(async r=>{try{return{stat:await this.s(r.resource,r.options),success:!0}}catch(i){return this.b.trace(i),{stat:void 0,success:!1}}}))}async stat(o){const r=await this.j(o),i=await r.stat(o);return this.t(r,o,i,void 0,!0,()=>!1)}async exists(o){const r=await this.j(o);try{return!!await r.stat(o)}catch{return!1}}async canCreateFile(o,r){try{await this.u(o,r)}catch(i){return i}return!0}async u(o,r){if(!r?.overwrite&&await this.exists(o))throw new p.$2k((0,w.localize)(3,null,this.sb(o)),3,r)}async createFile(o,r=S.$te.fromString(""),i){await this.u(o,i);const s=await this.writeFile(o,r);return this.r.fire(new p.$Yk(o,0,s)),s}async writeFile(o,r,i){const s=this.qb(await this.n(o),o),{providerExtUri:l}=this.R(s);let b=i;if((0,p.$Pk)(s)&&!b?.atomic){const R=s.enforceAtomicWriteFile?.(o);R&&(b={...i,atomic:R})}try{await this.w(s,o,b)||await this.U(s,l.dirname(o));let I;if((0,p.$Jk)(s)&&!(r instanceof S.$te))if((0,m.$fe)(r)){const E=await(0,m.$me)(r,3);E.ended?I=S.$te.concat(E.buffer):I=E}else I=(0,m.$je)(r,E=>S.$te.concat(E),3);else I=r;!(0,p.$Mk)(s)||(0,p.$Jk)(s)&&I instanceof S.$te||(0,p.$Jk)(s)&&(0,p.$Pk)(s)&&b?.atomic?await this.hb(s,o,b,I):await this.db(s,o,b,I instanceof S.$te?(0,S.$Ee)(I):I),this.r.fire(new p.$Yk(o,4))}catch(R){throw new p.$2k((0,w.localize)(4,null,this.sb(o),(0,p.$Uk)(R).toString()),(0,p.$Xk)(R),b)}return this.resolve(o,{resolveMetadata:!0})}async w(o,r,i){const s=!!i?.unlock;if(s&&!(o.capabilities&8192))throw new Error((0,w.localize)(5,null,this.sb(r)));if(!!i?.atomic){if(!(o.capabilities&32768))throw new Error((0,w.localize)(6,null,this.sb(r)));if(!(o.capabilities&2))throw new Error((0,w.localize)(7,null,this.sb(r)));if(s)throw new Error((0,w.localize)(8,null,this.sb(r)))}let b;try{b=await o.stat(r)}catch{return}if(b.type&p.FileType.Directory)throw new p.$2k((0,w.localize)(9,null,this.sb(r)),0,i);if(this.rb(r,b),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==p.$_k&&typeof b.mtime=="number"&&typeof b.size=="number"&&i.mtime<b.mtime&&i.etag!==(0,p.$al)({mtime:i.mtime,size:b.size}))throw new p.$2k((0,w.localize)(10,null),3,i);return b}async readFile(o,r,i){const s=await this.m(o);return r?.atomic?this.z(s,o,r,i):this.C(s,o,r,i)}async z(o,r,i,s){return new Promise((l,b)=>{this.cb.queueFor(r,async()=>{try{const R=await this.C(o,r,i,s);l(R)}catch(R){b(R)}},this.R(o).providerExtUri)})}async C(o,r,i,s){const l=await this.D(o,r,{...i,preferUnbuffered:!0},s);return{...l,value:await(0,S.$Fe)(l.value)}}async readFileStream(o,r,i){const s=await this.m(o);return this.D(s,o,r,i)}async D(o,r,i,s){const l=new M.$de(s);let b=i;(0,p.$Ok)(o)&&o.enforceAtomicReadFile?.(r)&&(b={...i,atomic:!0});const R=this.J(r,b).then(E=>E,E=>{throw l.dispose(!0),E});let I;try{return typeof b?.etag=="string"&&b.etag!==p.$_k&&await R,b?.atomic&&(0,p.$Ok)(o)||!((0,p.$Mk)(o)||(0,p.$Nk)(o))||(0,p.$Jk)(o)&&b?.preferUnbuffered?I=this.I(o,r,b):(0,p.$Nk)(o)?I=this.G(o,r,l.token,b):I=this.H(o,r,l.token,b),I.on("end",()=>l.dispose()),I.on("error",()=>l.dispose()),{...await R,value:I}}catch(E){throw I&&await(0,m.$ke)(I),this.F(E,r,b)}}F(o,r,i){const s=(0,w.localize)(11,null,this.sb(r),(0,p.$Uk)(o).toString());return o instanceof p.$4k?new p.$4k(s,o.stat,i):o instanceof p.$3k?new p.$3k(s,o.fileOperationResult,o.size,o.options):new p.$2k(s,(0,p.$Xk)(o),i)}G(o,r,i,s=Object.create(null)){const l=o.readFileStream(r,s,i);return(0,m.$qe)(l,{data:b=>b instanceof S.$te?b:S.$te.wrap(b),error:b=>this.F(b,r,s)},b=>S.$te.concat(b))}H(o,r,i,s=Object.create(null)){const l=(0,S.$Je)();return(0,u.$qq)(o,r,l,b=>b,{...s,bufferSize:this.a,errorTransformer:b=>this.F(b,r,s)},i),l}I(o,r,i){const s=(0,m.$he)(l=>S.$te.concat(l));return(async()=>{try{let l;i?.atomic&&(0,p.$Ok)(o)?l=await o.readFile(r,{atomic:!0}):l=await o.readFile(r),typeof i?.position=="number"&&(l=l.slice(i.position)),typeof i?.length=="number"&&(l=l.slice(0,i.length)),this.L(r,l.byteLength,i),s.end(S.$te.wrap(l))}catch(l){s.error(l),s.end()}})(),s}async J(o,r){const i=await this.resolve(o,{resolveMetadata:!0});if(i.isDirectory)throw new p.$2k((0,w.localize)(12,null,this.sb(o)),0,r);if(typeof r?.etag=="string"&&r.etag!==p.$_k&&r.etag===i.etag)throw new p.$4k((0,w.localize)(13,null),i,r);return this.L(o,i.size,r),i}L(o,r,i){if(typeof i?.limits?.size=="number"&&r>i.limits.size)throw new p.$3k((0,w.localize)(14,null,this.sb(o)),7,r,i)}async canMove(o,r,i){return this.M(o,r,"move",i)}async canCopy(o,r,i){return this.M(o,r,"copy",i)}async M(o,r,i,s){if(o.toString()!==r.toString())try{const l=i==="move"?this.qb(await this.n(o),o):await this.m(o),b=this.qb(await this.n(r),r);await this.Q(l,o,b,r,i,s)}catch(l){return l}return!0}async move(o,r,i){const s=this.qb(await this.n(o),o),l=this.qb(await this.n(r),r),b=await this.N(s,o,l,r,"move",!!i),R=await this.resolve(r,{resolveMetadata:!0});return this.r.fire(new p.$Yk(o,b==="move"?2:3,R)),R}async copy(o,r,i){const s=await this.m(o),l=this.qb(await this.n(r),r),b=await this.N(s,o,l,r,"copy",!!i),R=await this.resolve(r,{resolveMetadata:!0});return this.r.fire(new p.$Yk(o,b==="copy"?3:2,R)),R}async N(o,r,i,s,l,b){if(r.toString()===s.toString())return l;const{exists:R,isSameResourceWithDifferentPathCase:I}=await this.Q(o,r,i,s,l,b);if(R&&!I&&b&&await this.del(s,{recursive:!0}),await this.U(i,this.R(i).providerExtUri.dirname(s)),l==="copy"){if(o===i&&(0,p.$Kk)(o))await o.copy(r,s,{overwrite:b});else{const E=await this.resolve(r);E.isDirectory?await this.P(o,E,i,s):await this.O(o,r,i,s)}return l}else return o===i?(await o.rename(r,s,{overwrite:b}),l):(await this.N(o,r,i,s,"copy",b),await this.del(r,{recursive:!0}),"copy")}async O(o,r,i,s){if((0,p.$Mk)(o)&&(0,p.$Mk)(i))return this.jb(o,r,i,s);if((0,p.$Mk)(o)&&(0,p.$Jk)(i))return this.pb(o,r,i,s);if((0,p.$Jk)(o)&&(0,p.$Mk)(i))return this.nb(o,r,i,s);if((0,p.$Jk)(o)&&(0,p.$Jk)(i))return this.lb(o,r,i,s)}async P(o,r,i,s){await i.mkdir(s),Array.isArray(r.children)&&await D.Promises.settled(r.children.map(async l=>{const b=this.R(i).providerExtUri.joinPath(s,l.name);return l.isDirectory?this.P(o,await this.resolve(l.resource),i,b):this.O(o,l.resource,i,b)}))}async Q(o,r,i,s,l,b){let R=!1;if(o===i){const{providerExtUri:E,isPathCaseSensitive:A}=this.R(o);if(A||(R=E.isEqual(r,s)),R&&l==="copy")throw new Error((0,w.localize)(15,null,this.sb(r),this.sb(s)));if(!R&&E.isEqualOrParent(s,r))throw new Error((0,w.localize)(16,null,this.sb(r),this.sb(s)))}const I=await this.exists(s);if(I&&!R){if(!b)throw new p.$2k((0,w.localize)(17,null,this.sb(r),this.sb(s)),4);if(o===i){const{providerExtUri:E}=this.R(o);if(E.isEqualOrParent(r,s))throw new Error((0,w.localize)(18,null,this.sb(r),this.sb(s)))}}return{exists:I,isSameResourceWithDifferentPathCase:R}}R(o){const r=this.S(o);return{providerExtUri:r?g.$Jg:g.$Lg,isPathCaseSensitive:r}}S(o){return!!(o.capabilities&1024)}async createFolder(o){const r=this.qb(await this.j(o),o);await this.U(r,o);const i=await this.resolve(o,{resolveMetadata:!0});return this.r.fire(new p.$Yk(o,0,i)),i}async U(o,r){const i=[],{providerExtUri:s}=this.R(o);for(;!s.isEqual(r,s.dirname(r));)try{if(!((await o.stat(r)).type&p.FileType.Directory))throw new Error((0,w.localize)(19,null,this.sb(r)));break}catch(l){if((0,p.$Wk)(l)!==p.FileSystemProviderErrorCode.FileNotFound)throw l;i.push(s.basename(r)),r=s.dirname(r)}for(let l=i.length-1;l>=0;l--){r=s.joinPath(r,i[l]);try{await o.mkdir(r)}catch(b){if((0,p.$Wk)(b)!==p.FileSystemProviderErrorCode.FileExists)throw b}}}async canDelete(o,r){try{await this.W(o,r)}catch(i){return i}return!0}async W(o,r){const i=this.qb(await this.j(o),o),s=!!r?.useTrash;if(s&&!(i.capabilities&4096))throw new Error((0,w.localize)(20,null,this.sb(o)));const l=r?.atomic;if(l&&!(i.capabilities&65536))throw new Error((0,w.localize)(21,null,this.sb(o)));if(s&&l)throw new Error((0,w.localize)(22,null,this.sb(o)));let b;try{b=await i.stat(o)}catch{}if(b)this.rb(o,b);else throw new p.$2k((0,w.localize)(23,null,this.sb(o)),1);if(!!!r?.recursive){const I=await this.resolve(o);if(I.isDirectory&&Array.isArray(I.children)&&I.children.length>0)throw new Error((0,w.localize)(24,null,this.sb(o)))}return i}async del(o,r){const i=await this.W(o,r);let s=r;if((0,p.$Qk)(i)&&!s?.atomic){const I=i.enforceAtomicDelete?.(o);I&&(s={...r,atomic:I})}const l=!!s?.useTrash,b=!!s?.recursive,R=s?.atomic??!1;await i.delete(o,{recursive:b,useTrash:l,atomic:R}),this.r.fire(new p.$Yk(o,1))}async cloneFile(o,r){const i=await this.j(o),s=this.qb(await this.n(r),r);if(!(i===s&&this.R(i).providerExtUri.isEqual(o,r)))return i===s&&(0,p.$Lk)(i)?i.cloneFile(o,r):(await this.U(s,this.R(s).providerExtUri.dirname(r)),i===s&&(0,p.$Kk)(i)?this.cb.queueFor(o,()=>i.copy(o,r,{overwrite:!0}),this.R(i).providerExtUri):this.cb.queueFor(o,()=>this.O(i,o,s,r),this.R(i).providerExtUri))}static{this.ab=0}createWatcher(o,r){return this.watch(o,{...r,correlationId:$.ab++})}watch(o,r={recursive:!1,excludes:[]}){const i=new c.$Sc;let s=!1,l=()=>{s=!0};i.add((0,c.$Rc)(()=>l())),(async()=>{try{const R=await this.bb(o,r);s?(0,c.$Oc)(R):l=()=>(0,c.$Oc)(R)}catch(R){this.b.error(R)}})();const b=r.correlationId;if(typeof b=="number"){const R=i.add(new C.$6d);return i.add(this.X.event(E=>{E.correlates(b)&&R.fire(E)})),{onDidChange:R.event,dispose:()=>i.dispose()}}return i}async bb(o,r){const i=await this.j(o),s=(0,P.$7i)([this.R(i).providerExtUri.getComparisonKey(o),r]);let l=this.$.get(s);return l||(l={count:0,disposable:i.watch(o,r)},this.$.set(s,l)),l.count+=1,(0,c.$Rc)(()=>{l&&(l.count--,l.count===0&&((0,c.$Oc)(l.disposable),this.$.delete(s)))})}dispose(){super.dispose();for(const[,o]of this.$)(0,c.$Oc)(o.disposable);this.$.clear()}async db(o,r,i,s){return this.cb.queueFor(r,async()=>{const l=await o.open(r,{create:!0,unlock:i?.unlock??!1});try{(0,m.$fe)(s)||(0,m.$ge)(s)?await this.eb(o,l,s):await this.fb(o,l,s)}catch(b){throw(0,p.$Uk)(b)}finally{await o.close(l)}},this.R(o).providerExtUri)}async eb(o,r,i){let s=0,l;if((0,m.$ge)(i)){if(i.buffer.length>0){const b=S.$te.concat(i.buffer);await this.gb(o,r,b,b.byteLength,s,0),s+=b.byteLength}if(i.ended)return;l=i.stream}else l=i;return new Promise((b,R)=>{(0,m.$le)(l,{onData:async I=>{l.pause();try{await this.gb(o,r,I,I.byteLength,s,0)}catch(E){return R(E)}s+=I.byteLength,setTimeout(()=>l.resume())},onError:I=>R(I),onEnd:()=>b()})})}async fb(o,r,i){let s=0,l;for(;(l=i.read())!==null;)await this.gb(o,r,l,l.byteLength,s,0),s+=l.byteLength}async gb(o,r,i,s,l,b){let R=0;for(;R<s;){const I=await o.write(r,l+R,i.buffer,b+R,s-R);R+=I}}async hb(o,r,i,s){return this.cb.queueFor(r,()=>this.ib(o,r,i,s),this.R(o).providerExtUri)}async ib(o,r,i,s){let l;s instanceof S.$te?l=s:(0,m.$fe)(s)?l=await(0,S.$Fe)(s):(0,m.$ge)(s)?l=await(0,S.$Ge)(s):l=(0,S.$De)(s),await o.writeFile(r,l.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1,atomic:i?.atomic??!1})}async jb(o,r,i,s){return this.cb.queueFor(s,()=>this.kb(o,r,i,s),this.R(i).providerExtUri)}async kb(o,r,i,s){let l,b;try{l=await o.open(r,{create:!1}),b=await i.open(s,{create:!0,unlock:!1});const R=S.$te.alloc(this.a);let I=0,E=0,A=0;do A=await o.read(l,I,R.buffer,E,R.byteLength-E),await this.gb(i,b,R,A,I,E),I+=A,E+=A,E===R.byteLength&&(E=0);while(A>0)}catch(R){throw(0,p.$Uk)(R)}finally{await D.Promises.settled([typeof l=="number"?o.close(l):Promise.resolve(),typeof b=="number"?i.close(b):Promise.resolve()])}}async lb(o,r,i,s){return this.cb.queueFor(s,()=>this.mb(o,r,i,s),this.R(i).providerExtUri)}async mb(o,r,i,s){return i.writeFile(s,await o.readFile(r),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(o,r,i,s){return this.cb.queueFor(s,()=>this.ob(o,r,i,s),this.R(i).providerExtUri)}async ob(o,r,i,s){const l=await i.open(s,{create:!0,unlock:!1});try{const b=await o.readFile(r);await this.gb(i,l,S.$te.wrap(b),b.byteLength,0,0)}catch(b){throw(0,p.$Uk)(b)}finally{await i.close(l)}}async pb(o,r,i,s){const l=await(0,S.$Fe)(this.H(o,r,M.CancellationToken.None));await this.hb(i,s,void 0,l)}qb(o,r){if(o.capabilities&2048)throw new p.$2k((0,w.localize)(25,null,this.sb(r)),6);return o}rb(o,r){if((r.permissions??0)&p.FilePermission.Readonly)throw new p.$2k((0,w.localize)(26,null,this.sb(o)),6)}sb(o){return o.scheme===v.Schemas.file?o.fsPath:o.toString(!0)}};e.$rq=a,e.$rq=a=$=ve([se(0,f.$Aj)],a)}),define(ae[94],ce([0,1,46,313,8,31,17,3,33,2,9,4,19,62,21,181,16,122,223,51,219,218]),function(X,e,n,D,S,M,C,P,d,c,y,v,k,g,m,w,p,u,f,h,$,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qq=void 0,(()=>{try{(0,D.gracefulify)(n)}catch(o){console.error(`Error enabling graceful-fs: ${(0,h.$4i)(o)}`)}})();class t extends f.$Aq{static{this.I=!1}constructor(r,i){super(r,i),this.onDidChangeCapabilities=P.Event.None,this.N=new M.$Ac(s=>k.$Kg.getComparisonKey(s)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,v.$k&&(this.J|=1024)),this.J}async stat(r){try{const{stat:i,symbolicLink:s}=await m.SymlinkSupport.stat(this.H(r));return{type:this.M(i,s),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:p.FilePermission.Locked}}catch(i){throw this.fb(i)}}async L(r){try{return await this.stat(r)}catch{return}}async readdir(r){try{const i=await m.Promises.readdir(this.H(r),{withFileTypes:!0}),s=[];return await Promise.all(i.map(async l=>{try{let b;l.isSymbolicLink()?b=(await this.stat((0,k.$Tg)(r,l.name))).type:b=this.M(l),s.push([l.name,b])}catch(b){this.a.trace(b)}})),s}catch(i){throw this.fb(i)}}M(r,i){let s;return i?.dangling?s=p.FileType.Unknown:r.isFile()?s=p.FileType.File:r.isDirectory()?s=p.FileType.Directory:s=p.FileType.Unknown,i&&(s|=p.FileType.SymbolicLink),s}async O(r){const i=this.H(r);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let s;for(;s=this.N.get(r);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await s.wait();const l=new S.$fh;return this.N.set(r,l),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,c.$Rc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.N.get(r)===l&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.N.delete(r)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),l.open()})}async readFile(r,i){let s;try{i?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(r)})`),s=await this.O(r));const l=this.H(r);return await m.Promises.readFile(l)}catch(l){throw this.fb(l)}finally{s?.dispose()}}P(r){t.I&&this.a.trace(r)}readFileStream(r,i,s){const l=(0,g.$he)(b=>C.$te.concat(b.map(R=>C.$te.wrap(R))).buffer);return(0,u.$qq)(this,r,l,b=>b.buffer,{...i,bufferSize:256*1024},s),l}async writeFile(r,i,s){return s?.atomic!==!1&&s?.atomic?.postfix&&await this.Q(r)?this.R(r,(0,k.$Tg)((0,k.$Sg)(r),`${(0,k.$Qg)(r)}${s.atomic.postfix}`),i,s):this.S(r,i,s)}async Q(r){try{const i=this.H(r),{symbolicLink:s}=await m.SymlinkSupport.stat(i);if(s)return!1}catch{}return!0}async R(r,i,s,l){const b=new c.$Sc;try{b.add(await this.O(r)),b.add(await this.O(i)),await this.S(i,s,l,!0);try{await this.rename(i,r,{overwrite:!0})}catch(R){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw R}}finally{b.dispose()}}async S(r,i,s,l){let b;try{const R=this.H(r);if(!s.create||!s.overwrite){if(await m.Promises.exists(R)){if(!s.overwrite)throw(0,p.$Tk)((0,w.localize)(0,null),p.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,p.$Tk)((0,w.localize)(1,null),p.FileSystemProviderErrorCode.FileNotFound)}b=await this.open(r,{create:!0,unlock:s.unlock},l),await this.write(b,0,i,0,i.byteLength)}catch(R){throw await this.gb(r,R)}finally{typeof b=="number"&&await this.close(b)}}static{this.Y=!0}static configureFlushOnWrite(r){t.Y=r}async open(r,i,s){const l=this.H(r);let b;(0,p.$Hk)(i)&&!s&&(b=await this.O(r));let R;try{if((0,p.$Hk)(i)&&i.unlock)try{const{stat:E}=await m.SymlinkSupport.stat(l);E.mode&128||await m.Promises.chmod(l,E.mode|128)}catch(E){E.code!=="ENOENT"&&this.a.trace(E)}let I;if((0,p.$Hk)(i)){if(v.$i)try{await m.Promises.truncate(l,0),I="r+"}catch(E){E.code!=="ENOENT"&&this.a.trace(E)}I||(I="w")}else I="r";R=await m.Promises.open(l,I)}catch(I){throw b?.dispose(),(0,p.$Hk)(i)?await this.gb(r,I):this.fb(I)}if(this.U.set(R,0),(0,p.$Hk)(i)&&this.X.set(R,r),b){const I=this.W.get(R);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${R} (${l})`),this.W.set(R,b),I&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${R} (${l})`),I.dispose())}return R}async close(r){const i=this.W.get(r);try{if(this.U.delete(r),this.X.delete(r)&&t.Y)try{await m.Promises.fdatasync(r)}catch(s){t.configureFlushOnWrite(!1),this.a.error(s)}return await m.Promises.close(r)}catch(s){throw this.fb(s)}finally{i&&(this.W.get(r)===i&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${r}`),this.W.delete(r)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${r}`),i.dispose())}}async read(r,i,s,l,b){const R=this.Z(r,i);let I=null;try{I=(await m.Promises.read(r,s,l,b,R)).bytesRead}catch(E){throw this.fb(E)}finally{this.$(r,R,I)}return I}Z(r,i){return i===this.U.get(r)?null:i}$(r,i,s){const l=this.U.get(r);typeof l=="number"&&(typeof i=="number"||(typeof s=="number"?this.U.set(r,l+s):this.U.delete(r)))}async write(r,i,s,l,b){return(0,S.$Ah)(()=>this.ab(r,i,s,l,b),100,3)}async ab(r,i,s,l,b){const R=this.Z(r,i);let I=null;try{I=(await m.Promises.write(r,s,l,b,R)).bytesWritten}catch(E){throw await this.gb(this.X.get(r),E)}finally{this.$(r,R,I)}return I}async mkdir(r){try{await m.Promises.mkdir(this.H(r))}catch(i){throw this.fb(i)}}async delete(r,i){try{const s=this.H(r);if(i.recursive){let l;i?.atomic!==!1&&i.atomic.postfix&&(l=(0,y.$jc)((0,y.$mc)(s),`${(0,y.$nc)(s)}${i.atomic.postfix}`)),await m.Promises.rm(s,m.RimRafMode.MOVE,l)}else try{await m.Promises.unlink(s)}catch(l){if(l.code==="EPERM"||l.code==="EISDIR"){let b=!1;try{const{stat:R,symbolicLink:I}=await m.SymlinkSupport.stat(s);b=R.isDirectory()&&!I}catch{}if(b)await m.Promises.rmdir(s);else throw l}else throw l}}catch(s){throw this.fb(s)}}async rename(r,i,s){const l=this.H(r),b=this.H(i);if(l!==b)try{await this.bb(r,i,"move",s.overwrite),await m.Promises.rename(l,b)}catch(R){throw(R.code==="EINVAL"||R.code==="EBUSY"||R.code==="ENAMETOOLONG")&&(R=new Error((0,w.localize)(2,null,(0,y.$nc)(l),(0,y.$nc)((0,y.$mc)(b)),R.toString()))),this.fb(R)}}async copy(r,i,s){const l=this.H(r),b=this.H(i);if(l!==b)try{await this.bb(r,i,"copy",s.overwrite),await m.Promises.copy(l,b,{preserveSymlinks:!0})}catch(R){throw(R.code==="EINVAL"||R.code==="EBUSY"||R.code==="ENAMETOOLONG")&&(R=new Error((0,w.localize)(3,null,(0,y.$nc)(l),(0,y.$nc)((0,y.$mc)(b)),R.toString()))),this.fb(R)}}async bb(r,i,s,l){const b=this.H(r),R=this.H(i);let I=!1;if(!!(this.capabilities&1024)||(I=(0,d.$fg)(b,R,!0)),I){if(s==="copy")throw(0,p.$Tk)((0,w.localize)(4,null),p.FileSystemProviderErrorCode.FileExists);if(s==="move")return}const A=await this.L(r);if(!A)throw(0,p.$Tk)((0,w.localize)(5,null),p.FileSystemProviderErrorCode.FileNotFound);const j=await this.L(i);if(j){if(!l)throw(0,p.$Tk)((0,w.localize)(6,null),p.FileSystemProviderErrorCode.FileExists);A.type&p.FileType.File&&j.type&p.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(r,i){return this.cb(r,i,!1)}async cb(r,i,s){const l=this.H(r),b=this.H(i),R=!!(this.capabilities&1024);if((0,d.$fg)(l,b,!R))return;const I=new c.$Sc;try{I.add(await this.O(r)),I.add(await this.O(i)),s&&await m.Promises.mkdir((0,y.$mc)(b),{recursive:!0}),await m.Promises.copyFile(l,b)}catch(E){if(E.code==="ENOENT"&&!s)return this.cb(r,i,!0);throw this.fb(E)}finally{I.dispose()}}t(r,i,s){return new $.$Hq(l=>r(l),l=>i(l),s)}F(r,i,s){return new a.$Pq(l=>r(l),l=>i(l),s)}fb(r){if(r instanceof p.$Sk)return r;let i=r,s;switch(r.code){case"ENOENT":s=p.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":s=p.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":s=p.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":s=p.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":s=p.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${r.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,s=p.FileSystemProviderErrorCode.Unknown;break;default:s=p.FileSystemProviderErrorCode.Unknown}return(0,p.$Tk)(i,s)}async gb(r,i){let s=this.fb(i);if(r&&s.code===p.FileSystemProviderErrorCode.NoPermissions)try{const{stat:l}=await m.SymlinkSupport.stat(this.H(r));l.mode&128||(s=(0,p.$Tk)(i,p.FileSystemProviderErrorCode.FileWriteLocked))}catch(l){this.a.trace(l)}return s}}e.$Qq=t}),define(ae[225],ce([0,1,3,94,2,17,62,23]),function(X,e,n,D,S,M,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$os=e.$ns=void 0;class d extends S.$Tc{constructor(v,k){super(),this.a=v,this.b=k,this.F=new Map,this.G=new Map}call(v,k,g){const m=this.c(v);switch(k){case"stat":return this.g(m,g[0]);case"readdir":return this.h(m,g[0]);case"open":return this.r(m,g[0],g[1]);case"close":return this.s(g[0]);case"read":return this.t(g[0],g[1],g[2]);case"readFile":return this.j(m,g[0],g[1]);case"write":return this.u(g[0],g[1],g[2],g[3],g[4]);case"writeFile":return this.n(m,g[0],g[1],g[2]);case"rename":return this.z(m,g[0],g[1],g[2]);case"copy":return this.C(m,g[0],g[1],g[2]);case"cloneFile":return this.D(m,g[0],g[1]);case"mkdir":return this.w(m,g[0]);case"delete":return this.y(m,g[0],g[1]);case"watch":return this.I(m,g[0],g[1],g[2],g[3]);case"unwatch":return this.J(g[0],g[1])}throw new Error(`IPC Command ${k} not found`)}listen(v,k,g){const m=this.c(v);switch(k){case"fileChange":return this.H(m,g[0]);case"readFileStream":return this.m(m,g[0],g[1])}throw new Error(`Unknown event ${k}`)}g(v,k){const g=this.f(v,k,!0);return this.a.stat(g)}h(v,k){const g=this.f(v,k);return this.a.readdir(g)}async j(v,k,g){const m=this.f(v,k,!0),w=await this.a.readFile(m,g);return M.$te.wrap(w)}m(v,k,g){const m=this.f(v,k,!0),w=new P.$de,p=new n.$6d({onDidRemoveLastListener:()=>{w.cancel()}}),u=this.a.readFileStream(m,g,w.token);return(0,C.$le)(u,{onData:f=>p.fire(M.$te.wrap(f)),onError:f=>p.fire(f),onEnd:()=>{p.fire("end"),p.dispose(),w.dispose()}}),p.event}n(v,k,g,m){const w=this.f(v,k);return this.a.writeFile(w,g.buffer,m)}r(v,k,g){const m=this.f(v,k,!0);return this.a.open(m,g)}s(v){return this.a.close(v)}async t(v,k,g){const m=M.$te.alloc(g),p=await this.a.read(v,k,m.buffer,0,g);return[m,p]}u(v,k,g,m,w){return this.a.write(v,k,g.buffer,m,w)}w(v,k){const g=this.f(v,k);return this.a.mkdir(g)}y(v,k,g){const m=this.f(v,k);return this.a.delete(m,g)}z(v,k,g,m){const w=this.f(v,k),p=this.f(v,g);return this.a.rename(w,p,m)}C(v,k,g,m){const w=this.f(v,k),p=this.f(v,g);return this.a.copy(w,p,m)}D(v,k,g){const m=this.f(v,k),w=this.f(v,g);return this.a.cloneFile(m,w)}H(v,k){const g=new n.$6d({onWillAddFirstListener:()=>{this.F.set(k,this.L(v,g))},onDidRemoveLastListener:()=>{(0,S.$Oc)(this.F.get(k)),this.F.delete(k)}});return g.event}async I(v,k,g,m,w){const p=this.F.get(k);if(p){const u=this.f(v,m),f=p.watch(g,u,w);this.G.set(k+g,f)}}async J(v,k){const g=v+k,m=this.G.get(g);m&&((0,S.$Oc)(m),this.G.delete(g))}dispose(){super.dispose();for(const[,v]of this.G)v.dispose();this.G.clear();for(const[,v]of this.F)v.dispose();this.F.clear()}}e.$ns=d;class c extends S.$Tc{constructor(v,k,g,m){super(),this.c=v,this.f=g,this.g=m,this.a=new Map,this.b=this.B(new D.$Qq(this.f,{watcher:{recursive:this.j(this.g)}})),this.h(k)}h(v){const k=this.B(new n.$6d);this.B(k.event(g=>{v.fire(g.map(m=>({resource:this.c.transformOutgoingURI(m.resource),type:m.type,cId:m.cId})))})),this.B(this.b.onDidChangeFile(g=>k.fire(g))),this.B(this.b.onDidWatchError(g=>v.fire(g)))}j(v){}m(v){}watch(v,k,g){const m=this.m(this.g);return Array.isArray(m)&&(g.excludes=[...g.excludes,...m]),this.a.set(v,this.b.watch(k,g)),(0,S.$Rc)(()=>{(0,S.$Oc)(this.a.get(v)),this.a.delete(v)})}dispose(){for(const[,v]of this.a)v.dispose();this.a.clear(),super.dispose()}}e.$os=c}),define(ae[226],ce([0,1,14,180,4,7,16,9,225,157]),function(X,e,n,D,S,M,C,P,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M_b=void 0;class y extends d.$ns{constructor(g,m,w){super(g,m),this.M=w}c(g){return c.$in}f(g,m){return M.URI.revive(m)}async y(g,m,w){if(!w.useTrash)return super.y(g,m,w);const p=this.f(g,m),u=(0,P.$hc)(p.fsPath);try{await n.shell.trashItem(u)}catch{throw(0,C.$Tk)(S.$i?(0,D.localize)(0,null,(0,P.$nc)(u)):(0,D.localize)(1,null,(0,P.$nc)(u)),C.FileSystemProviderErrorCode.Unknown)}}L(g,m){return new v(g,m,this.b,this.M)}}e.$M_b=y;class v extends d.$os{watch(g,m,w){if(w.recursive)throw(0,C.$Tk)("Recursive file watching is not supported from main process for performance reasons.",C.FileSystemProviderErrorCode.Unavailable);return super.watch(g,m,w)}}}),define(ae[227],ce([0,1,5]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$C9b=void 0;class D extends n.$Gj{constructor(M=n.$Dj){super(),this.m=[],this.n=void 0,this.setLevel(M),this.B(this.onDidChangeLogLevel(C=>{this.n?.setLevel(C)}))}set logger(M){this.n=M;for(const{level:C,message:P}of this.m)(0,n.log)(M,C,P);this.m=[]}g(M,C){this.n?(0,n.log)(this.n,M,C):this.getLevel()<=M&&this.m.push({level:M,message:C})}dispose(){this.n?.dispose(),super.dispose()}flush(){this.n?.flush()}}e.$C9b=D}),define(ae[228],ce([0,1,7,3,5,2]),function(X,e,n,D,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rr=e.$Qr=e.$Pr=void 0;class C extends S.$Lj{constructor(v,k,g,m,w){super(k,g,m),this.r=v,this.t=w,this.B(w.listen("onDidChangeLogLevel",v)(p=>{(0,S.$Cj)(p)?super.setLogLevel(p):super.setLogLevel(n.URI.revive(p[0]),p[1])})),this.B(w.listen("onDidChangeVisibility",v)(([p,u])=>super.setVisibility(n.URI.revive(p),u))),this.B(w.listen("onDidChangeLoggers",v)(({added:p,removed:u})=>{for(const f of p)super.registerLogger({...f,resource:n.URI.revive(f.resource)});for(const f of u)super.deregisterLogger(f.resource)}))}createConsoleMainLogger(){return new S.$Jj({log:(v,k)=>{this.t.call("consoleLog",[v,k])}})}registerLogger(v){super.registerLogger(v),this.t.call("registerLogger",[v,this.r])}deregisterLogger(v){super.deregisterLogger(v),this.t.call("deregisterLogger",[v,this.r])}setLogLevel(v,k){super.setLogLevel(v,k),this.t.call("setLogLevel",[v,k])}setVisibility(v,k){super.setVisibility(v,k),this.t.call("setVisibility",[this.n(v),k])}s(v,k,g){return new P(this.t,v,k,g,this.r)}static setLogLevel(v,k,g){return v.call("setLogLevel",[k,g])}}e.$Pr=C;class P extends S.$Gj{constructor(v,k,g,m,w){super(m?.logLevel==="always"),this.r=v,this.s=k,this.m=!1,this.n=[],this.setLevel(g),this.r.call("createLogger",[k,m,w]).then(()=>{this.u(this.n),this.m=!0})}g(v,k){const g=[[v,k]];this.m?this.u(g):this.n.push(...g)}u(v){this.r.call("log",[this.s,v])}}class d{constructor(v,k){this.a=v,this.b=k}listen(v,k){const g=this.b(v);switch(k){case"onDidChangeLoggers":return D.Event.map(this.a.onDidChangeLoggers,m=>({added:[...m.added].map(w=>this.c(w,g)),removed:[...m.removed].map(w=>this.c(w,g))}));case"onDidChangeVisibility":return D.Event.map(this.a.onDidChangeVisibility,m=>[g.transformOutgoingURI(m[0]),m[1]]);case"onDidChangeLogLevel":return D.Event.map(this.a.onDidChangeLogLevel,m=>(0,S.$Cj)(m)?m:[g.transformOutgoingURI(m[0]),m[1]])}throw new Error(`Event not found: ${k}`)}async call(v,k,g){const m=this.b(v);switch(k){case"setLogLevel":return(0,S.$Cj)(g[0])?this.a.setLogLevel(g[0]):this.a.setLogLevel(n.URI.revive(m.transformIncoming(g[0][0])),g[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(w=>this.c(w,m)))}throw new Error(`Call not found: ${k}`)}c(v,k){return{...v,resource:k.transformOutgoingURI(v.resource)}}}e.$Qr=d;class c extends M.$Tc{constructor(v,k){super(),k.call("setLogLevel",[v.getLogLevel()]),this.B(v.onDidChangeLogLevel(g=>k.call("setLogLevel",[g]))),k.call("getRegisteredLoggers").then(g=>{for(const m of g)v.registerLogger({...m,resource:n.URI.revive(m.resource)})}),this.B(k.listen("onDidChangeVisibility")(([g,m])=>v.setVisibility(n.URI.revive(g),m))),this.B(k.listen("onDidChangeLoggers")(({added:g,removed:m})=>{for(const w of g)v.registerLogger({...w,resource:n.URI.revive(w.resource)});for(const w of m)v.deregisterLogger(w.resource)}))}}e.$Rr=c}),define(ae[229],ce([0,1,2,5]),function(X,e,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PP=void 0;class S extends n.$Tc{constructor(C,P=[]){super(),this.a=new D.$Kj([C,...P]),this.B(C.onDidChangeLogLevel(d=>this.setLevel(d)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(C){this.a.setLevel(C)}getLevel(){return this.a.getLevel()}trace(C,...P){this.a.trace(C,...P)}debug(C,...P){this.a.debug(C,...P)}info(C,...P){this.a.info(C,...P)}warn(C,...P){this.a.warn(C,...P)}error(C,...P){this.a.error(C,...P)}flush(){this.a.flush()}}e.$PP=S}),define(ae[230],ce([0,1,31,7,5]),function(X,e,n,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hac=void 0;class M{constructor(P){this.b=P,this.a=new n.$Ac}listen(P,d,c){switch(d){case"onDidChangeLoggers":return c?this.b.getOnDidChangeLoggersEvent(c):this.b.onDidChangeLoggers;case"onDidChangeLogLevel":return c?this.b.getOnDidChangeLogLevelEvent(c):this.b.onDidChangeLogLevel;case"onDidChangeVisibility":return c?this.b.getOnDidChangeVisibilityEvent(c):this.b.onDidChangeVisibility}throw new Error(`Event not found: ${d}`)}async call(P,d,c){switch(d){case"createLogger":this.c(D.URI.revive(c[0]),c[1],c[2]);return;case"log":return this.e(D.URI.revive(c[0]),c[1]);case"consoleLog":return this.d(c[0],c[1]);case"setLogLevel":return(0,S.$Cj)(c[0])?this.b.setLogLevel(c[0]):this.b.setLogLevel(D.URI.revive(c[0]),c[1]);case"setVisibility":return this.b.setVisibility(D.URI.revive(c[0]),c[1]);case"registerLogger":return this.b.registerLogger({...c[0],resource:D.URI.revive(c[0].resource)},c[1]);case"deregisterLogger":return this.b.deregisterLogger(D.URI.revive(c[0]))}throw new Error(`Call not found: ${d}`)}c(P,d,c){this.a.set(P,this.b.createLogger(P,d,c))}d(P,d){let c=console.log;switch(P){case S.LogLevel.Error:c=console.error;break;case S.LogLevel.Warning:c=console.warn;break;case S.LogLevel.Info:c=console.info;break}c.call(console,...d)}e(P,d){const c=this.a.get(P);if(!c)throw new Error("Create the logger before logging");for(const[y,v]of d)(0,S.log)(c,y,v)}}e.$Hac=M}),define(ae[231],ce([0,1,16,5]),function(X,e,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EP=void 0;var S;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(S||(S={}));async function M(c,y,v,k,g){try{const m=await new Promise((p,u)=>{X(["@vscode/spdlog"],p,u)});m.setFlushOn(S.Trace);const w=await m.createAsyncRotatingLogger(c,y,v,k);return g?w.clearFormatters():w.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),w}catch(m){console.error(m)}return null}function C(c,y,v){switch(y){case D.LogLevel.Trace:c.trace(v);break;case D.LogLevel.Debug:c.debug(v);break;case D.LogLevel.Info:c.info(v);break;case D.LogLevel.Warning:c.warn(v);break;case D.LogLevel.Error:c.error(v);break;case D.LogLevel.Off:break;default:throw new Error(`Invalid log level ${y}`)}}function P(c,y){switch(y){case D.LogLevel.Trace:c.setLevel(S.Trace);break;case D.LogLevel.Debug:c.setLevel(S.Debug);break;case D.LogLevel.Info:c.setLevel(S.Info);break;case D.LogLevel.Warning:c.setLevel(S.Warning);break;case D.LogLevel.Error:c.setLevel(S.Error);break;case D.LogLevel.Off:c.setLevel(S.Off);break;default:throw new Error(`Invalid log level ${y}`)}}class d extends D.$Gj{constructor(y,v,k,g,m){super(),this.m=[],this.setLevel(m),this.n=this.s(y,v,k,g),this.B(this.onDidChangeLogLevel(w=>{this.r&&P(this.r,w)}))}async s(y,v,k,g){const m=k?6:1,w=30/m*n.$cl.MB,p=await M(y,v,w,m,g);if(p){this.r=p,P(this.r,this.getLevel());for(const{level:u,message:f}of this.m)C(this.r,u,f);this.m=[]}}g(y,v){this.r?C(this.r,y,v):this.getLevel()<=y&&this.m.push({level:y,message:v})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$EP=d}),define(ae[232],ce([0,1,32,5,231]),function(X,e,n,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FP=void 0;class M extends D.$Lj{s(P,d,c){return new S.$EP((0,n.$Cg)(),P.fsPath,!c?.donotRotate,!!c?.donotUseFormatters,d)}}e.$FP=M}),define(ae[67],ce([0,1,31,3,6,5,232]),function(X,e,n,D,S,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$i_b=e.$h_b=void 0,e.$h_b=(0,S.$hi)(M.$Bj);class P extends C.$FP{constructor(){super(...arguments),this.u=new n.$Ac}createLogger(c,y,v){v!==void 0&&this.u.set(this.n(c),v);try{return super.createLogger(c,y)}catch(k){throw this.u.delete(this.n(c)),k}}registerLogger(c,y){y!==void 0&&this.u.set(c.resource,y),super.registerLogger(c)}deregisterLogger(c){this.u.delete(c),super.deregisterLogger(c)}getRegisteredLoggers(c){const y=[];for(const v of super.getRegisteredLoggers())c===this.u.get(v.resource)&&y.push(v);return y}getOnDidChangeLogLevelEvent(c){return D.Event.filter(this.onDidChangeLogLevel,y=>(0,M.$Cj)(y)||this.w(y[0],c))}getOnDidChangeVisibilityEvent(c){return D.Event.filter(this.onDidChangeVisibility,([y])=>this.w(y,c))}getOnDidChangeLoggersEvent(c){return D.Event.filter(D.Event.map(this.onDidChangeLoggers,y=>({added:[...y.added].filter(k=>this.w(k.resource,c)),removed:[...y.removed].filter(k=>this.w(k.resource,c))})),y=>y.added.length>0||y.removed.length>0)}deregisterLoggers(c){for(const[y,v]of this.u)v===c&&this.deregisterLogger(y)}w(c,y){const v=this.u.get(c);return v===void 0||v===y}dispose(){super.dispose(),this.u.clear()}}e.$i_b=P}),define(ae[233],ce([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3_b=e.$2_b=e.$1_b=e.$Z_b=void 0;function n(C){return C.submenu!==void 0}e.$Z_b=n;function D(C){return C.id==="vscode.menubar.separator"}e.$1_b=D;function S(C){return C.uri!==void 0}e.$2_b=S;function M(C){return!n(C)&&!D(C)&&!S(C)}e.$3_b=M}),define(ae[39],ce([0,1,3,71,2,6]),function(X,e,n,D,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2n=e.$1n=e.$Zn=void 0,e.$Zn=(0,M.$gi)("policy");class C extends S.$Tc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new n.$6d),this.onDidChange=this.h.event}async updatePolicyDefinitions(c){const y=Object.keys(this.f).length;return this.f={...c,...this.f},y!==Object.keys(this.f).length&&await this.j(c),D.Iterable.reduce(this.g.entries(),(v,[k,g])=>({...v,[k]:g}),{})}getPolicyValue(c){return this.g.get(c)}serialize(){return D.Iterable.reduce(Object.entries(this.f),(c,[y,v])=>({...c,[y]:{definition:v,value:this.g.get(y)}}),{})}}e.$1n=C;class P{constructor(){this.onDidChange=n.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$2n=P}),define(ae[234],ce([0,1,8,3,71,12,16,5,39]),function(X,e,n,D,S,M,C,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1ac=void 0;function c(v,k){const g=[];for(const m of new Set(S.Iterable.concat(v.keys(),k.keys())))v.get(m)!==k.get(m)&&g.push(m);return g}let y=class extends d.$1n{constructor(k,g,m){super(),this.m=k,this.n=g,this.s=m,this.c=this.B(new n.$eh(500));const w=D.Event.filter(g.onDidFilesChange,p=>p.affects(k));this.B(g.watch(k)),this.B(w(()=>this.c.trigger(()=>this.w())))}async j(){await this.w()}async u(){const k=new Map;try{const g=await this.n.readFile(this.m),m=JSON.parse(g.value.toString());if(!(0,M.$Vf)(m))throw new Error("Policy file isn't a JSON object");for(const w of Object.keys(m))this.f[w]&&k.set(w,m[w])}catch(g){g.fileOperationResult!==1&&this.s.error("[FilePolicyService] Failed to read policies",g)}return k}async w(){const k=await this.u(),g=c(this.g,k);this.g=k,g.length>0&&this.h.fire(g)}};e.$1ac=y,e.$1ac=y=ve([se(1,C.$Gk),se(2,P.$Aj)],y)}),define(ae[235],ce([0,1,3,2,39]),function(X,e,n,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zac=e.$yac=void 0;class M{constructor(d){this.b=d,this.a=new D.$Sc}listen(d,c){switch(c){case"onDidChange":return n.Event.map(this.b.onDidChange,y=>y.reduce((v,k)=>({...v,[k]:this.b.getPolicyValue(k)??null}),{}),this.a)}throw new Error(`Event not found: ${c}`)}call(d,c,y){switch(c){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(y)}throw new Error(`Call not found: ${c}`)}dispose(){this.a.dispose()}}e.$yac=M;class C extends S.$1n{constructor(d,c){super(),this.a=c;for(const y in d){const{definition:v,value:k}=d[y];this.f[y]=v,k!==void 0&&this.g.set(y,k)}this.a.listen("onDidChange")(y=>{for(const v in y){const k=y[v];k===null?this.g.delete(v):this.g.set(v,k)}this.h.fire(Object.keys(y))})}async j(d){const c=await this.a.call("updatePolicyDefinitions",d);for(const y in c)this.g.set(y,c[y])}}e.$zac=C}),define(ae[236],ce([0,1,39,8,2,5]),function(X,e,n,D,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zac=void 0;let C=class extends n.$1n{constructor(d,c){super(),this.m=d,this.n=c,this.a=new D.$ah,this.b=this.B(new S.$Uc)}async j(d){this.m.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(d).length} policy definitions`);const{createWatcher:c}=await new Promise((y,v)=>{X(["@vscode/policy-watcher"],y,v)});await this.a.queue(()=>new Promise((y,v)=>{try{this.b.value=c(this.n,d,k=>{this.t(k),y()})}catch(k){this.m.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",k),v(k)}}))}t(d){this.m.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(d)}`);for(const c in d){const y=d[c];y===void 0?this.g.delete(c):this.g.set(c,y)}this.h.fire(Object.keys(d))}};e.$Zac=C,e.$Zac=C=ve([se(0,M.$Aj)],C)}),define(ae[79],ce([0,1,36]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let D;const S=globalThis.vscode;if(typeof S<"u"&&typeof S.context<"u"){const M=S.context.configuration();if(M)D=M.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(D=globalThis._VSCODE_PRODUCT_JSON,n.env.VSCODE_DEV&&Object.assign(D,{nameShort:`${D.nameShort} Dev`,nameLong:`${D.nameLong} Dev`,dataFolderName:`${D.dataFolderName}-dev`,serverDataFolderName:D.serverDataFolderName?`${D.serverDataFolderName}-dev`:void 0}),!D.version){const M=globalThis._VSCODE_PACKAGE_JSON;Object.assign(D,{version:M.version})}}else D={},Object.keys(D).length===0&&Object.assign(D,{version:"1.87.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=D}),define(ae[27],ce([0,1,6]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tj=e.$Sj=void 0,e.$Sj=(0,n.$gi)("productService"),e.$Tj="vscode://schemas/vscode-product"}),define(ae[237],ce([0,1,8,5]),function(X,e,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$P_b=void 0;let S=class{constructor(C,P,d){this.a=C,this.b=P,this.c=d}async inspect(C){await this.d();const P=this.a.webContents.debugger;await P.sendCommand("Profiler.start"),this.c.warn("[perf] profiling STARTED",this.b),await(0,n.$hh)(C);const d=await P.sendCommand("Profiler.stop");return this.c.warn("[perf] profiling DONE",this.b),await this.e(),d.profile}async d(){const C=this.a.webContents.debugger;C.attach(),await C.sendCommand("Profiler.enable")}async e(){const C=this.a.webContents.debugger;await C.sendCommand("Profiler.disable"),C.detach()}};e.$P_b=S,e.$P_b=S=ve([se(2,D.$Aj)],S)}),define(ae[80],ce([0,1,6]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3$b=void 0,e.$3$b=(0,n.$gi)("protocolMainService")}),define(ae[44],ce([0,1,139,12]),function(X,e,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xn=void 0;class S{constructor(){this.a=new Map}add(C,P){n.ok(D.$Tf(C)),n.ok(D.$Vf(P)),n.ok(!this.a.has(C),"There is already an extension with this id"),this.a.set(C,P)}knows(C){return this.a.has(C)}as(C){return this.a.get(C)||null}}e.$Xn=new S}),define(ae[238],ce([0,1,3,44]),function(X,e,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yn=void 0,e.$Yn={JSONContribution:"base.contributions.json"};function S(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class M{constructor(){this.b=new n.$6d,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(d,c){this.a[S(d)]=c,this.b.fire(d)}notifySchemaChanged(d){this.b.fire(d)}getSchemaContributions(){return{schemas:this.a}}}const C=new M;D.$Xn.add(e.$Yn.JSONContribution,C)}),define(ae[52],ce([0,1,22,3,12,165,18,238,44]),function(X,e,n,D,S,M,C,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fo=e.$eo=e.$do=e.$co=e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.ConfigurationScope=e.$3n=e.EditPresentationTypes=void 0;var c;(function(a){a.Multiline="multilineText",a.Singleline="singlelineText"})(c||(e.EditPresentationTypes=c={})),e.$3n={Configuration:"base.contributions.configuration"};var y;(function(a){a[a.APPLICATION=1]="APPLICATION",a[a.MACHINE=2]="MACHINE",a[a.WINDOW=3]="WINDOW",a[a.RESOURCE=4]="RESOURCE",a[a.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",a[a.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(y||(e.ConfigurationScope=y={})),e.$4n={properties:{},patternProperties:{}},e.$5n={properties:{},patternProperties:{}},e.$6n={properties:{},patternProperties:{}},e.$7n={properties:{},patternProperties:{}},e.$8n={properties:{},patternProperties:{}},e.$9n={properties:{},patternProperties:{}},e.$0n="vscode://schemas/settings/resourceLanguage",e.$$n="vscode://schemas/settings/configurationDefaults";const v=d.$Xn.as(P.$Yn.JSONContribution);class k{constructor(){this.h=new Set,this.i=new D.$6d,this.onDidSchemaChange=this.i.event,this.j=new D.$6d,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:M.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},v.registerSchema(e.$0n,this.g),this.v()}registerConfiguration(t,o=!0){this.registerConfigurations([t],o)}registerConfigurations(t,o=!0){const r=new Set;this.n(t,o,r),v.registerSchema(e.$0n,this.g),this.i.fire(),this.j.fire({properties:r})}deregisterConfigurations(t){const o=new Set;this.o(t,o),v.registerSchema(e.$0n,this.g),this.i.fire(),this.j.fire({properties:o})}updateConfigurations({add:t,remove:o}){const r=new Set;this.o(o,r),this.n(t,!1,r),v.registerSchema(e.$0n,this.g),this.i.fire(),this.j.fire({properties:r})}registerDefaultConfigurations(t){const o=new Set;this.k(t,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}k(t,o){const r=[];for(const{overrides:i,source:s}of t)for(const l in i)if(o.add(l),e.$ao.test(l)){const b=this.a.get(l),R=b?.valuesSources??new Map;if(s)for(const j of Object.keys(i[l]))R.set(j,s);const I={...b?.value||{},...i[l]};this.a.set(l,{source:s,value:I,valuesSources:R});const E=(0,C.$Wi)(l),A={type:"object",default:I,description:M.localize(1,null,E),$ref:e.$0n,defaultDefaultValue:I,source:S.$Tf(s)?void 0:s,defaultValueSource:s};r.push(...w(l)),this.d[l]=A,this.b.properties[l]=A}else{this.a.set(l,{value:i[l],source:s});const b=this.d[l];b&&(this.w(l,b),this.r(l,b))}this.m(r)}deregisterDefaultConfigurations(t){const o=new Set;this.l(t,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}l(t,o){for(const{overrides:r,source:i}of t)for(const s in r){const l=this.a.get(s),b=S.$Tf(i)?i:i?.id,R=S.$Tf(l?.source)?l?.source:l?.source?.id;if(b===R)if(o.add(s),this.a.delete(s),e.$ao.test(s))delete this.d[s],delete this.b.properties[s];else{const I=this.d[s];I&&(this.w(s,I),this.r(s,I))}}this.u()}deltaConfiguration(t){let o=!1;const r=new Set;t.removedDefaults&&(this.l(t.removedDefaults,r),o=!0),t.addedDefaults&&(this.k(t.addedDefaults,r),o=!0),t.removedConfigurations&&this.o(t.removedConfigurations,r),t.addedConfigurations&&this.n(t.addedConfigurations,!1,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:o})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const o of t)this.h.add(o);this.u()}n(t,o,r){t.forEach(i=>{this.p(i,o,i.extensionInfo,i.restrictedProperties,void 0,r),this.c.push(i),this.q(i)})}o(t,o){const r=i=>{if(i.properties)for(const s in i.properties){o.add(s);const l=this.d[s];l?.policy?.name&&this.e.delete(l.policy.name),delete this.d[s],this.s(s,i.properties[s])}i.allOf?.forEach(s=>r(s))};for(const i of t){r(i);const s=this.c.indexOf(i);s!==-1&&this.c.splice(s,1)}}p(t,o=!0,r,i,s=3,l){s=S.$3f(t.scope)?s:t.scope;const b=t.properties;if(b)for(const I in b){const E=b[I];if(o&&h(I,E)){delete b[I];continue}if(E.source=r,E.defaultDefaultValue=b[I].default,this.w(I,E),e.$ao.test(I)?E.scope=void 0:(E.scope=S.$3f(E.scope)?s:E.scope,E.restricted=S.$3f(E.restricted)?!!i?.includes(I):E.restricted),b[I].hasOwnProperty("included")&&!b[I].included){this.f[I]=b[I],delete b[I];continue}else this.d[I]=b[I],b[I].policy?.name&&this.e.set(b[I].policy.name,I);!b[I].deprecationMessage&&b[I].markdownDeprecationMessage&&(b[I].deprecationMessage=b[I].markdownDeprecationMessage),l.add(I)}const R=t.allOf;if(R)for(const I of R)this.p(I,o,r,i,s,l)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const o=r=>{const i=r.properties;if(i)for(const l in i)this.r(l,i[l]);r.allOf?.forEach(o)};o(t)}r(t,o){switch(e.$4n.properties[t]=o,o.scope){case 1:e.$5n.properties[t]=o;break;case 2:e.$6n.properties[t]=o;break;case 6:e.$7n.properties[t]=o;break;case 3:e.$8n.properties[t]=o;break;case 4:e.$9n.properties[t]=o;break;case 5:e.$9n.properties[t]=o,this.g.properties[t]=o;break}}s(t,o){switch(delete e.$4n.properties[t],o.scope){case 1:delete e.$5n.properties[t];break;case 2:delete e.$6n.properties[t];break;case 6:delete e.$7n.properties[t];break;case 3:delete e.$8n.properties[t];break;case 4:case 5:delete e.$9n.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const o=`[${t}]`,r={type:"object",description:M.localize(2,null),errorMessage:M.localize(3,null),$ref:e.$0n};this.w(o,r),e.$4n.properties[o]=r,e.$5n.properties[o]=r,e.$6n.properties[o]=r,e.$7n.properties[o]=r,e.$8n.properties[o]=r,e.$9n.properties[o]=r}}v(){const t={type:"object",description:M.localize(4,null),errorMessage:M.localize(5,null),$ref:e.$0n};e.$4n.patternProperties[e.$_n]=t,e.$5n.patternProperties[e.$_n]=t,e.$6n.patternProperties[e.$_n]=t,e.$7n.patternProperties[e.$_n]=t,e.$8n.patternProperties[e.$_n]=t,e.$9n.patternProperties[e.$_n]=t,this.i.fire()}w(t,o){const r=this.a.get(t);let i=r?.value,s=r?.source;S.$1f(i)&&(i=o.defaultDefaultValue,s=void 0),S.$1f(i)&&(i=u(o.type)),o.default=i,o.defaultValueSource=s}}const g="\\[([^\\]]+)\\]",m=new RegExp(g,"g");e.$_n=`^(${g})+$`,e.$ao=new RegExp(e.$_n);function w(a){const t=[];if(e.$ao.test(a)){let o=m.exec(a);for(;o?.length;){const r=o[1].trim();r&&t.push(r),o=m.exec(a)}}return(0,n.$Mb)(t)}e.$bo=w;function p(a){return a.reduce((t,o)=>`${t}[${o}]`,"")}e.$co=p;function u(a){switch(Array.isArray(a)?a[0]:a){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$do=u;const f=new k;d.$Xn.add(e.$3n.Configuration,f);function h(a,t){return a.trim()?e.$ao.test(a)?M.localize(7,null,a):f.getConfigurationProperties()[a]!==void 0?M.localize(8,null,a):t.policy?.name&&f.getPolicyConfigurations().get(t.policy?.name)!==void 0?M.localize(9,null,a,t.policy?.name,f.getPolicyConfigurations().get(t.policy?.name)):null:M.localize(6,null)}e.$eo=h;function $(){const a=[],t=f.getConfigurationProperties();for(const o of Object.keys(t))a.push([o,t[o].scope]);return a.push(["launch",4]),a.push(["task",4]),a}e.$fo=$}),define(ae[123],ce([0,1,22,3,42,2,31,35,12,7,18,52,44]),function(X,e,n,D,S,M,C,P,d,c,y,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=void 0;function g(o){return Object.isFrozen(o)?o:P.$Mn(o)}class m{constructor(r={},i=[],s=[],l){this.b=r,this.c=i,this.d=s,this.raw=l,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const r=this.raw.map(i=>{if(i instanceof m)return i;const s=new w("");return s.parseRaw(i),s.configurationModel});this.f=r.reduce((i,s)=>s===i?s:i.merge(s),r[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(r){return r?(0,y.$Ui)(this.contents,r):this.contents}inspect(r,i){const s=this;return{get value(){return g(s.rawConfiguration.getValue(r))},get override(){return i?g(s.rawConfiguration.getOverrideValue(r,i)):void 0},get merged(){return g(i?s.rawConfiguration.override(i).getValue(r):s.rawConfiguration.getValue(r))},get overrides(){const l=[];for(const{contents:b,identifiers:R,keys:I}of s.rawConfiguration.overrides){const E=new m(b,I).getValue(r);E!==void 0&&l.push({identifiers:R,value:E})}return l.length?g(l):void 0}}}getOverrideValue(r,i){const s=this.i(i);return s?r?(0,y.$Ui)(s,r):s:void 0}getKeysForOverrideIdentifier(r){const i=[];for(const s of this.overrides)s.identifiers.includes(r)&&i.push(...s.keys);return n.$Mb(i)}getAllOverrideIdentifiers(){const r=[];for(const i of this.overrides)r.push(...i.identifiers);return n.$Mb(r)}override(r){let i=this.a.get(r);return i||(i=this.g(r),this.a.set(r,i)),i}merge(...r){const i=P.$Ln(this.contents),s=P.$Ln(this.overrides),l=[...this.keys],b=this.raw?.length?[...this.raw]:[this];for(const R of r)if(b.push(...R.raw?.length?R.raw:[R]),!R.isEmpty()){this.h(i,R.contents);for(const I of R.overrides){const[E]=s.filter(A=>n.$ub(A.identifiers,I.identifiers));E?(this.h(E.contents,I.contents),E.keys.push(...I.keys),E.keys=n.$Mb(E.keys)):s.push(P.$Ln(I))}for(const I of R.keys)l.indexOf(I)===-1&&l.push(I)}return new m(i,l,s,b.every(R=>R instanceof m)?void 0:b)}g(r){const i=this.i(r);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const s={};for(const l of n.$Mb([...Object.keys(this.contents),...Object.keys(i)])){let b=this.contents[l];const R=i[l];R&&(typeof b=="object"&&typeof R=="object"?(b=P.$Ln(b),this.h(b,R)):b=R),s[l]=b}return new m(s,this.keys,this.overrides)}h(r,i){for(const s of Object.keys(i)){if(s in r&&d.$Vf(r[s])&&d.$Vf(i[s])){this.h(r[s],i[s]);continue}r[s]=P.$Ln(i[s])}}i(r){let i=null,s=null;const l=b=>{b&&(s?this.h(s,b):s=P.$Ln(b))};for(const b of this.overrides)b.identifiers.length===1&&b.identifiers[0]===r?i=b.contents:b.identifiers.includes(r)&&l(b.contents);return l(i),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(r,i){this.j(r,i,!0)}setValue(r,i){this.j(r,i,!1)}removeValue(r){const i=this.keys.indexOf(r);i!==-1&&(this.keys.splice(i,1),(0,y.$Ti)(this.contents,r),v.$ao.test(r)&&this.overrides.splice(this.overrides.findIndex(s=>n.$ub(s.identifiers,(0,v.$bo)(r))),1))}j(r,i,s){(0,y.$Si)(this.contents,r,i,l=>console.error(l)),s=s||this.keys.indexOf(r)===-1,s&&this.keys.push(r),v.$ao.test(r)&&this.overrides.push({identifiers:(0,v.$bo)(r),keys:Object.keys(this.contents[r]),contents:(0,y.$Ri)(this.contents[r],l=>console.error(l))})}}e.$go=m;class w{constructor(r){this.f=r,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new m}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(r,i){if(!d.$3f(r)){const s=this.g(r);this.parseRaw(s,i)}}reparse(r){this.a&&this.parseRaw(this.a,r)}parseRaw(r,i){this.a=r;const{contents:s,keys:l,overrides:b,restricted:R,hasExcludedProperties:I}=this.h(r,i);this.b=new m(s,l,b,I?[r]:void 0),this.c=R||[]}g(r){let i={},s=null,l=[];const b=[],R=[];function I(A){Array.isArray(l)?l.push(A):s!==null&&(l[s]=A)}const E={onObjectBegin:()=>{const A={};I(A),b.push(l),l=A,s=null},onObjectProperty:A=>{s=A},onObjectEnd:()=>{l=b.pop()},onArrayBegin:()=>{const A=[];I(A),b.push(l),l=A,s=null},onArrayEnd:()=>{l=b.pop()},onLiteralValue:I,onError:(A,j,T)=>{R.push({error:A,offset:j,length:T})}};if(r)try{S.$zn(r,E),i=l[0]||{}}catch(A){console.error(`Error while parsing settings file ${this.f}: ${A}`),this.d=[A]}return i}h(r,i){const s=k.$Xn.as(v.$3n.Configuration).getConfigurationProperties(),l=this.i(r,s,!0,i);r=l.raw;const b=(0,y.$Ri)(r,E=>console.error(`Conflict in settings file ${this.f}: ${E}`)),R=Object.keys(r),I=this.j(r,E=>console.error(`Conflict in settings file ${this.f}: ${E}`));return{contents:b,keys:R,overrides:I,restricted:l.restricted,hasExcludedProperties:l.hasExcludedProperties}}i(r,i,s,l){let b=!1;if(!l?.scopes&&!l?.skipRestricted&&!l?.exclude?.length)return{raw:r,restricted:[],hasExcludedProperties:b};const R={},I=[];for(const E in r)if(v.$ao.test(E)&&s){const A=this.i(r[E],i,!1,l);R[E]=A.raw,b=b||A.hasExcludedProperties,I.push(...A.restricted)}else{const A=i[E],j=A?typeof A.scope<"u"?A.scope:3:void 0;A?.restricted&&I.push(E),!l.exclude?.includes(E)&&(l.include?.includes(E)||(j===void 0||l.scopes===void 0||l.scopes.includes(j))&&!(l.skipRestricted&&A?.restricted))?R[E]=r[E]:b=!0}return{raw:R,restricted:I,hasExcludedProperties:b}}j(r,i){const s=[];for(const l of Object.keys(r))if(v.$ao.test(l)){const b={};for(const R in r[l])b[R]=r[l][R];s.push({identifiers:(0,v.$bo)(l),keys:Object.keys(b),contents:(0,y.$Ri)(b,i)})}return s}}e.$ho=w;class p extends M.$Tc{constructor(r,i,s,l){super(),this.c=r,this.f=i,this.g=l,this.b=this.B(new D.$6d),this.onDidChange=this.b.event,this.a=new w(this.c.toString()),this.B(this.g.watch(s.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(D.Event.any(D.Event.filter(this.g.onDidFilesChange,b=>b.contains(this.c)),D.Event.filter(this.g.onDidRunOperation,b=>(b.isOperation(0)||b.isOperation(3)||b.isOperation(1)||b.isOperation(4))&&s.isEqual(b.resource,r)))(()=>this.b.fire()))}async loadConfiguration(){try{const r=await this.g.readFile(this.c);return this.a.parse(r.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new m}}reparse(r){return r&&(this.f=r),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$io=p;class u{constructor(r,i,s,l,b,R,I,E,A,j,T,W,V){this.a=r,this.b=i,this.c=s,this.overrideIdentifiers=l,this.d=b,this.f=R,this.g=I,this.h=E,this.i=A,this.j=j,this.k=T,this.l=W,this.m=V}get value(){return g(this.c)}n(r){return r?.value!==void 0||r?.override!==void 0||r?.overrides!==void 0?r:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class f{constructor(r,i,s,l,b=new m,R=new m,I=new C.$Ac,E=new m,A=new C.$Ac){this.c=r,this.d=i,this.f=s,this.g=l,this.h=b,this.i=R,this.j=I,this.l=E,this.m=A,this.a=null,this.b=new C.$Ac,this.n=null}getValue(r,i,s){return this.p(r,i,s).getValue(r)}updateValue(r,i,s={}){let l;s.resource?(l=this.m.get(s.resource),l||(l=new m,this.m.set(s.resource,l))):l=this.l,i===void 0?l.removeValue(r):l.setValue(r,i),s.resource||(this.a=null)}inspect(r,i,s){const l=this.p(r,i,s),b=this.t(i.resource,s),R=i.resource?this.m.get(i.resource)||this.l:this.l,I=new Set;for(const E of l.overrides)for(const A of E.identifiers)l.getOverrideValue(r,A)!==void 0&&I.add(A);return new u(r,i,l.getValue(r),I.size?[...I]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,s?this.i:void 0,b||void 0,R)}keys(r){const i=this.t(void 0,r);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(r){this.c=r,this.a=null,this.b.clear()}updatePolicyConfiguration(r){this.d=r}updateApplicationConfiguration(r){this.f=r,this.a=null,this.b.clear()}updateLocalUserConfiguration(r){this.g=r,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(r){this.h=r,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(r){this.i=r,this.a=null,this.b.clear()}updateFolderConfiguration(r,i){this.j.set(r,i),this.b.delete(r)}deleteFolderConfiguration(r){this.folderConfigurations.delete(r),this.b.delete(r)}compareAndUpdateDefaultConfiguration(r,i){const s=[];if(!i){const{added:l,updated:b,removed:R}=a(this.c,r);i=[...l,...b,...R]}for(const l of i)for(const b of(0,v.$bo)(l)){const R=this.c.getKeysForOverrideIdentifier(b),I=r.getKeysForOverrideIdentifier(b),E=[...I.filter(A=>R.indexOf(A)===-1),...R.filter(A=>I.indexOf(A)===-1),...R.filter(A=>!P.$Pn(this.c.override(b).getValue(A),r.override(b).getValue(A)))];s.push([b,E])}return this.updateDefaultConfiguration(r),{keys:i,overrides:s}}compareAndUpdatePolicyConfiguration(r){const{added:i,updated:s,removed:l}=a(this.d,r),b=[...i,...s,...l];return b.length&&this.updatePolicyConfiguration(r),{keys:b,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:i,updated:s,removed:l,overrides:b}=a(this.applicationConfiguration,r),R=[...i,...s,...l];return R.length&&this.updateApplicationConfiguration(r),{keys:R,overrides:b}}compareAndUpdateLocalUserConfiguration(r){const{added:i,updated:s,removed:l,overrides:b}=a(this.localUserConfiguration,r),R=[...i,...s,...l];return R.length&&this.updateLocalUserConfiguration(r),{keys:R,overrides:b}}compareAndUpdateRemoteUserConfiguration(r){const{added:i,updated:s,removed:l,overrides:b}=a(this.remoteUserConfiguration,r),R=[...i,...s,...l];return R.length&&this.updateRemoteUserConfiguration(r),{keys:R,overrides:b}}compareAndUpdateWorkspaceConfiguration(r){const{added:i,updated:s,removed:l,overrides:b}=a(this.workspaceConfiguration,r),R=[...i,...s,...l];return R.length&&this.updateWorkspaceConfiguration(r),{keys:R,overrides:b}}compareAndUpdateFolderConfiguration(r,i){const s=this.folderConfigurations.get(r),{added:l,updated:b,removed:R,overrides:I}=a(s,i),E=[...l,...b,...R];return(E.length||!s)&&this.updateFolderConfiguration(r,i),{keys:E,overrides:I}}compareAndDeleteFolderConfiguration(r){const i=this.folderConfigurations.get(r);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:s,updated:l,removed:b,overrides:R}=a(i,void 0);return{keys:[...s,...l,...b],overrides:R}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(r,i,s){let l=this.q(i,s);return i.overrideIdentifier&&(l=l.override(i.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(r)!==void 0&&(l=l.merge(this.d)),l}q({resource:r},i){let s=this.r();if(i&&r){const l=i.getFolder(r);l&&(s=this.s(l.uri)||s);const b=this.m.get(r);b&&(s=s.merge(b))}return s}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(r){let i=this.b.get(r);if(!i){const s=this.r(),l=this.j.get(r);l?(i=s.merge(l),this.b.set(r,i)):i=s}return i}t(r,i){if(i&&r){const s=i.getFolder(r);if(s)return this.j.get(s.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((r,i)=>{const{contents:s,overrides:l,keys:b}=this.j.get(i);return r.push([i,{contents:s,overrides:l,keys:b}]),r},[])}}allKeys(){const r=new Set;return this.c.keys.forEach(i=>r.add(i)),this.userConfiguration.keys.forEach(i=>r.add(i)),this.i.keys.forEach(i=>r.add(i)),this.j.forEach(i=>i.keys.forEach(s=>r.add(s))),[...r.values()]}u(){const r=new Set;return this.c.getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.i.getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.j.forEach(i=>i.getAllOverrideIdentifiers().forEach(s=>r.add(s))),[...r.values()]}v(r){const i=new Set;return this.c.getKeysForOverrideIdentifier(r).forEach(s=>i.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(s=>i.add(s)),this.i.getKeysForOverrideIdentifier(r).forEach(s=>i.add(s)),this.j.forEach(s=>s.getKeysForOverrideIdentifier(r).forEach(l=>i.add(l))),[...i.values()]}static parse(r){const i=this.w(r.defaults),s=this.w(r.policy),l=this.w(r.application),b=this.w(r.user),R=this.w(r.workspace),I=r.folders.reduce((E,A)=>(E.set(c.URI.revive(A[0]),this.w(A[1])),E),new C.$Ac);return new f(i,s,l,b,new m,R,I,new m,new C.$Ac)}static w(r){return new m(r.contents,r.keys,r.overrides)}}e.$jo=f;function h(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const r=new Set,i=new Map;for(const l of o)l.keys.forEach(b=>r.add(b)),l.overrides.forEach(([b,R])=>{const I=(0,C.$xc)(i,b,new Set);R.forEach(E=>I.add(E))});const s=[];return i.forEach((l,b)=>s.push([b,[...l.values()]])),{keys:[...r.values()],overrides:s}}e.$ko=h;class ${constructor(r,i,s,l){this.change=r,this.f=i,this.g=s,this.h=l,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.i=void 0;for(const b of r.keys)this.affectedKeys.add(b);for(const[,b]of r.overrides)for(const R of b)this.affectedKeys.add(R);this.d=this.a;for(const b of this.affectedKeys)this.d+=b+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=f.parse(this.f.data)),this.i}affectsConfiguration(r,i){const s=this.a+r,l=this.d.indexOf(s);if(l<0)return!1;const b=l+s.length;if(b>=this.d.length)return!1;const R=this.d.charCodeAt(b);if(R!==this.b&&R!==this.c)return!1;if(i){const I=this.previousConfiguration?this.previousConfiguration.getValue(r,i,this.f?.workspace):void 0,E=this.g.getValue(r,i,this.h);return!P.$Pn(I,E)}return!0}}e.$lo=$;function a(o,r){const{added:i,removed:s,updated:l}=t(r?.rawConfiguration,o?.rawConfiguration),b=[],R=o?.getAllOverrideIdentifiers()||[],I=r?.getAllOverrideIdentifiers()||[];if(r){const E=I.filter(A=>!R.includes(A));for(const A of E)b.push([A,r.getKeysForOverrideIdentifier(A)])}if(o){const E=R.filter(A=>!I.includes(A));for(const A of E)b.push([A,o.getKeysForOverrideIdentifier(A)])}if(r&&o){for(const E of R)if(I.includes(E)){const A=t({contents:o.getOverrideValue(void 0,E)||{},keys:o.getKeysForOverrideIdentifier(E)},{contents:r.getOverrideValue(void 0,E)||{},keys:r.getKeysForOverrideIdentifier(E)});b.push([E,[...A.added,...A.removed,...A.updated]])}}return{added:i,removed:s,updated:l,overrides:b}}function t(o,r){const i=o?r?o.keys.filter(b=>r.keys.indexOf(b)===-1):[...o.keys]:[],s=r?o?r.keys.filter(b=>o.keys.indexOf(b)===-1):[...r.keys]:[],l=[];if(o&&r){for(const b of r.keys)if(o.keys.indexOf(b)!==-1){const R=(0,y.$Ui)(r.contents,b),I=(0,y.$Ui)(o.contents,b);P.$Pn(R,I)||l.push(b)}}return{added:i,removed:s,updated:l}}}),define(ae[239],ce([0,1,22,3,2,35,12,123,52,5,39,44]),function(X,e,n,D,S,M,C,P,d,c,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oo=e.$no=e.$mo=void 0;class k extends S.$Tc{constructor(){super(...arguments),this.a=this.B(new D.$6d),this.onDidChangeConfiguration=this.a.event,this.b=new P.$go}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(v.$Xn.as(d.$3n.Configuration).onDidUpdateConfiguration(({properties:p,defaultsOverrides:u})=>this.c(Array.from(p),u))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(p,u){this.h(p,v.$Xn.as(d.$3n.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:p})}f(){return{}}g(){this.b=new P.$go;const p=v.$Xn.as(d.$3n.Configuration).getConfigurationProperties();this.h(Object.keys(p),p)}h(p,u){const f=this.f();for(const h of p){const $=f[h],a=u[h];$!==void 0?this.b.addValue(h,$):a?this.b.addValue(h,a.default):this.b.removeValue(h)}}}e.$mo=k;class g{constructor(){this.onDidChangeConfiguration=D.Event.None,this.configurationModel=new P.$go}async initialize(){return this.configurationModel}}e.$no=g;let m=class extends S.$Tc{get configurationModel(){return this.b}constructor(p,u,f){super(),this.c=p,this.f=u,this.g=f,this.a=this.B(new D.$6d),this.onDidChangeConfiguration=this.a.event,this.b=new P.$go}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(p=>this.j(p))),this.B(this.c.onDidChangeConfiguration(async({properties:p})=>this.m(await this.h(p),!0))),this.b}async h(p){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",p);const u={},f=[],h=v.$Xn.as(d.$3n.Configuration).getConfigurationProperties();for(const $ of p){const a=h[$];if(!a){f.push($);continue}if(a.policy){if(a.type!=="string"&&a.type!=="number"){this.g.warn(`Policy ${a.policy.name} has unsupported type ${a.type}`);continue}f.push($),u[a.policy.name]={type:a.type}}}return(0,C.$7f)(u)||await this.f.updatePolicyDefinitions(u),f}j(p){this.g.trace("PolicyConfiguration#onDidChangePolicies",p);const u=v.$Xn.as(d.$3n.Configuration).getPolicyConfigurations(),f=(0,n.$Hb)(p.map(h=>u.get(h)));this.m(f,!0)}m(p,u){this.g.trace("PolicyConfiguration#update",p);const f=v.$Xn.as(d.$3n.Configuration).getConfigurationProperties(),h=[],$=this.b.isEmpty();for(const a of p){const t=f[a]?.policy?.name;if(t){const o=this.f.getPolicyValue(t);($?o!==void 0:!(0,M.$Pn)(this.b.getValue(a),o))&&h.push([a,o])}else this.b.getValue(a)!==void 0&&h.push([a,void 0])}if(h.length){this.g.trace("PolicyConfiguration#changed",h);const a=this.b;this.b=new P.$go;for(const t of a.keys)this.b.setValue(t,a.getValue(t));for(const[t,o]of h)o===void 0?this.b.removeValue(t):this.b.setValue(t,o);u&&this.a.fire(this.b)}}};e.$oo=m,e.$oo=m=ve([se(1,y.$Zn),se(2,c.$Aj)],m)}),define(ae[240],ce([0,1,22,8,17,3,42,103,2,35,4,19,18,123,52,239,39]),function(X,e,n,D,S,M,C,P,d,c,y,v,k,g,m,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$po=void 0;class u extends d.$Tc{constructor($,a,t,o){super(),this.m=$,this.h=this.B(new M.$6d),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new w.$mo),this.c=t instanceof p.$2n?new w.$no:this.B(new w.$oo(this.b,t,o)),this.f=this.B(new g.$io(this.m,{},v.$Kg,a)),this.a=new g.$jo(this.b.configurationModel,this.c.configurationModel,new g.$go,new g.$go),this.j=new f($,a,this),this.g=this.B(new D.$sh(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:r,properties:i})=>this.r(r,i))),this.B(this.c.onDidChangeConfiguration(r=>this.s(r))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[$,a,t]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new g.$jo($,a,new g.$go,t)}getConfigurationData(){return this.a.toData()}getValue($,a){const t=typeof $=="string"?$:void 0,o=(0,k.$Ni)($)?$:(0,k.$Ni)(a)?a:{};return this.a.getValue(t,o,void 0)}async updateValue($,a,t,o,r){const i=(0,k.$Oi)(t)?t:(0,k.$Ni)(t)?{resource:t.resource,overrideIdentifiers:t.overrideIdentifier?[t.overrideIdentifier]:void 0}:void 0,s=i?o:t;if(s!==void 0&&s!==3&&s!==2)throw new Error(`Unable to write ${$} to target ${s}.`);i?.overrideIdentifiers&&(i.overrideIdentifiers=(0,n.$Mb)(i.overrideIdentifiers),i.overrideIdentifiers=i.overrideIdentifiers.length?i.overrideIdentifiers:void 0);const l=this.inspect($,{resource:i?.resource,overrideIdentifier:i?.overrideIdentifiers?i.overrideIdentifiers[0]:void 0});if(l.policyValue!==void 0)throw new Error(`Unable to write ${$} because it is configured in system policy.`);if((0,c.$Pn)(a,l.defaultValue)&&(a=void 0),i?.overrideIdentifiers?.length&&i.overrideIdentifiers.length>1){const R=i.overrideIdentifiers.sort(),I=this.a.localUserConfiguration.overrides.find(E=>(0,n.$ub)([...E.identifiers].sort(),R));I&&(i.overrideIdentifiers=I.identifiers)}const b=i?.overrideIdentifiers?.length?[(0,m.$co)(i.overrideIdentifiers),$]:[$];await this.j.write(b,a),await this.reloadConfiguration()}inspect($,a={}){return this.a.inspect($,a,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const $=await this.f.loadConfiguration();this.n($)}n($){const a=this.a.toData(),t=this.a.compareAndUpdateLocalUserConfiguration($);this.t(t,a,2)}r($,a){const t=this.a.toData(),o=this.a.compareAndUpdateDefaultConfiguration($,a);this.t(o,t,7)}s($){const a=this.a.toData(),t=this.a.compareAndUpdatePolicyConfiguration($);this.t(t,a,7)}t($,a,t){const o=new g.$lo($,{data:a},this.a);o.source=t,this.h.fire(o)}}e.$po=u;class f{constructor($,a,t){this.b=$,this.c=a,this.d=t,this.a=new D.$nh}write($,a){return this.a.queue(()=>this.e($,a))}async e($,a){let t;try{t=(await this.c.readFile(this.b)).value.toString()}catch(i){if(i.fileOperationResult===1)t="{}";else throw i}const o=[];if((0,C.$sn)(t,o,{allowTrailingComma:!0,allowEmptyContent:!0}),o.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const r=this.f(t,$,a);t=(0,P.$Kn)(t,r),await this.c.writeFile(this.b,S.$te.fromString(t))}f($,a,t){const{tabSize:o,insertSpaces:r,eol:i}=this.h;if(!a.length){const s=JSON.stringify(t,null,r?" ".repeat(o):"	");return[{content:s,length:s.length,offset:0}]}return(0,P.$Hn)($,a,t,{tabSize:o,insertSpaces:r,eol:i})}get h(){if(!this.g){let $=y.OS===3||y.OS===2?`
`:`\r
`;const a=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});a&&typeof a=="string"&&a!=="auto"&&($=a),this.g={eol:$,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(ae[241],ce([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oac=e.$Nac=e.$Mac=void 0,e.$Mac="request",e.$Nac="remoteResourceHandler";class n{async routeCall(S,M,C){if(M!==e.$Mac)throw new Error(`Call not found: ${M}`);const P=C[0];if(P?.authority){const d=S.connections.find(c=>c.ctx===P.authority);if(d)return d}throw new Error("Caller not found")}routeEvent(S,M){throw new Error(`Event not found: ${M}`)}}e.$Oac=n}),define(ae[242],ce([0,1,15,6]),function(X,e,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pl=e.$ol=e.RemoteAuthorityResolverErrorCode=e.$nl=e.$ml=e.RemoteConnectionType=e.$ll=void 0,e.$ll=(0,D.$gi)("remoteAuthorityResolverService");var S;(function(y){y[y.WebSocket=0]="WebSocket",y[y.Managed=1]="Managed"})(S||(e.RemoteConnectionType=S={}));class M{constructor(v){this.id=v,this.type=1}toString(){return`Managed(${this.id})`}}e.$ml=M;class C{constructor(v,k){this.host=v,this.port=k,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$nl=C;var P;(function(y){y.Unknown="Unknown",y.NotAvailable="NotAvailable",y.TemporarilyNotAvailable="TemporarilyNotAvailable",y.NoResolverFound="NoResolverFound",y.InvalidAuthority="InvalidAuthority"})(P||(e.RemoteAuthorityResolverErrorCode=P={}));class d extends n.$bb{static isNotAvailable(v){return v instanceof d&&v._code===P.NotAvailable}static isTemporarilyNotAvailable(v){return v instanceof d&&v._code===P.TemporarilyNotAvailable}static isNoResolverFound(v){return v instanceof d&&v._code===P.NoResolverFound}static isInvalidAuthority(v){return v instanceof d&&v._code===P.InvalidAuthority}static isHandled(v){return v instanceof d&&v.isHandled}constructor(v,k=P.Unknown,g){super(v),this._message=v,this._code=k,this._detail=g,this.isHandled=k===P.NotAvailable&&g===!0,Object.setPrototypeOf(this,d.prototype)}}e.$ol=d;function c(y){const v=y.indexOf("+");return v===-1?y:y.substring(0,v)}e.$pl=c}),define(ae[243],ce([0,1,8,17,23,15,3,2,13,66,72,32,113,242]),function(X,e,n,D,S,M,C,P,d,c,y,v,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$El=e.$Dl=e.$Cl=e.$Bl=e.$Al=e.$zl=e.$yl=e.$xl=e.PersistentConnectionEventType=e.$wl=e.$vl=e.$ul=e.ConnectionType=void 0;const m=30*1e3;var w;(function(J){J[J.Management=1]="Management",J[J.ExtensionHost=2]="ExtensionHost",J[J.Tunnel=3]="Tunnel"})(w||(e.ConnectionType=w={}));function p(J){switch(J){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function u(J){const O=new S.$de;return setTimeout(()=>O.cancel(),J),O.token}function f(J,O){if(J.isCancellationRequested||O.isCancellationRequested)return S.CancellationToken.Cancelled;const F=new S.$de;return J.onCancellationRequested(()=>F.cancel()),O.onCancellationRequested(()=>F.cancel()),F.token}class h{get didTimeout(){return this.c==="timedout"}constructor(O){this.c="pending",this.d=new P.$Sc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,n.$_g)(),O.isCancellationRequested?this.h():this.d.add(O.onCancellationRequested(()=>this.h()))}registerDisposable(O){this.c==="pending"?this.d.add(O):O.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const O=new Error("Time limit reached");return O.code="ETIMEDOUT",O.syscall="connect",O}resolve(O){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(O))}reject(O){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(O))}}function $(J,O){const F=new h(O);return F.registerDisposable(J.onControlMessage(x=>{const z=JSON.parse(x.toString()),Q=L(z);Q?F.reject(Q):F.resolve(z)})),F.promise}function a(J,O,F,x,z,Q,H,_){const B=new h(_),te=y.$2d.create(!1);return J.info(`Creating a socket (${H})...`),c.mark(`code/willCreateSocket/${Q}`),O.connect(F,x,z,H).then(ie=>{B.didTimeout?(c.mark(`code/didCreateSocketError/${Q}`),J.info(`Creating a socket (${H}) finished after ${te.elapsed()} ms, but this is too late and has timed out already.`),ie?.dispose()):(c.mark(`code/didCreateSocketOK/${Q}`),J.info(`Creating a socket (${H}) was successful after ${te.elapsed()} ms.`),B.resolve(ie))},ie=>{c.mark(`code/didCreateSocketError/${Q}`),J.info(`Creating a socket (${H}) returned an error after ${te.elapsed()} ms.`),J.error(ie),B.reject(ie)}),B.promise}function t(J,O){const F=new h(O);return J.then(x=>{F.didTimeout||F.resolve(x)},x=>{F.didTimeout||F.reject(x)}),F.promise}async function o(J,O,F,x){const z=oe(J,O);J.logService.trace(`${z} 1/6. invoking socketFactory.connect().`);let Q;try{Q=await a(J.logService,J.remoteSocketFactoryService,J.connectTo,d.$tg.getServerRootPath(),`reconnectionToken=${J.reconnectionToken}&reconnection=${J.reconnectionProtocol?"true":"false"}`,p(O),`renderer-${p(O)}-${J.reconnectionToken}`,x)}catch(ie){throw J.logService.error(`${z} socketFactory.connect() failed or timed out. Error:`),J.logService.error(ie),ie}J.logService.trace(`${z} 2/6. socketFactory.connect() was successful.`);let H,_;J.reconnectionProtocol?(J.reconnectionProtocol.beginAcceptReconnection(Q,null),H=J.reconnectionProtocol,_=!1):(H=new k.$7h({socket:Q}),_=!0),J.logService.trace(`${z} 3/6. sending AuthRequest control message.`);const B=await t(J.signService.createNewMessage((0,v.$Cg)()),x),te={type:"auth",auth:J.connectionToken||"00000000000000000000",data:B.data};H.sendControl(D.$te.fromString(JSON.stringify(te)));try{const ie=await $(H,f(x,u(1e4)));if(ie.type!=="sign"||typeof ie.data!="string"){const Se=new Error("Unexpected handshake message");throw Se.code="VSCODE_CONNECTION_ERROR",Se}if(J.logService.trace(`${z} 4/6. received SignRequest control message.`),!await t(J.signService.validate(B,ie.signedData),x)){const Se=new Error("Refused to connect to unsupported server");throw Se.code="VSCODE_CONNECTION_ERROR",Se}const me=await t(J.signService.sign(ie.data),x),ke={type:"connectionType",commit:J.commit,signedData:me,desiredConnectionType:O};return F&&(ke.args=F),J.logService.trace(`${z} 5/6. sending ConnectionTypeRequest control message.`),H.sendControl(D.$te.fromString(JSON.stringify(ke))),{protocol:H,ownsProtocol:_}}catch(ie){throw ie&&ie.code==="ETIMEDOUT"&&(J.logService.error(`${z} the handshake timed out. Error:`),J.logService.error(ie)),ie&&ie.code==="VSCODE_CONNECTION_ERROR"&&(J.logService.error(`${z} received error control message when negotiating connection. Error:`),J.logService.error(ie)),_&&U(H),ie}}async function r(J,O,F,x){const z=Date.now(),Q=oe(J,O),{protocol:H,ownsProtocol:_}=await o(J,O,F,x),B=new h(x);return B.registerDisposable(H.onControlMessage(te=>{const ie=JSON.parse(te.toString()),de=L(ie);de?(J.logService.error(`${Q} received error control message when negotiating connection. Error:`),J.logService.error(de),_&&U(H),B.reject(de)):(J.reconnectionProtocol?.endAcceptReconnection(),J.logService.trace(`${Q} 6/6. handshake finished, connection is up and running after ${he(z)}!`),B.resolve({protocol:H,firstMessage:ie}))})),B.promise}async function i(J,O){const{protocol:F}=await r(J,1,void 0,O);return{protocol:F}}async function s(J,O,F){const{protocol:x,firstMessage:z}=await r(J,2,O,F),Q=z&&z.debugPort;return{protocol:x,debugPort:Q}}async function l(J,O,F){const x=Date.now(),z=oe(J,3),{protocol:Q}=await o(J,3,O,F);return J.logService.trace(`${z} 6/6. handshake finished, connection is up and running after ${he(x)}!`),Q}async function b(J,O,F){const{connectTo:x,connectionToken:z}=await J.addressProvider.getAddress();return{commit:J.commit,quality:J.quality,connectTo:x,connectionToken:z,reconnectionToken:O,reconnectionProtocol:F,remoteSocketFactoryService:J.remoteSocketFactoryService,signService:J.signService,logService:J.logService}}async function R(J,O,F){return E(J,async x=>{const{protocol:z}=await i(x,S.CancellationToken.None);return new Z(J,O,F,x.reconnectionToken,z)})}e.$ul=R;async function I(J,O){return E(J,async F=>{const{protocol:x,debugPort:z}=await s(F,O,S.CancellationToken.None);return new Y(J,O,F.reconnectionToken,x,z)})}e.$vl=I;async function E(J,O){for(let x=1;;x++)try{const z=(0,v.$Cg)(),Q=await b(J,z,null);return await O(Q)}catch(z){if(x<5)J.logService.error(`[remote-connection][attempt ${x}] An error occurred in initial connection! Will retry... Error:`),J.logService.error(z);else throw J.logService.error(`[remote-connection][attempt ${x}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),J.logService.error(z),ue.triggerPermanentFailure(0,0,g.$ol.isHandled(z)),z}}async function A(J,O,F){const x=await b(J,(0,v.$Cg)(),null);return await l(x,{host:O,port:F},S.CancellationToken.None)}e.$wl=A;function j(J){return(0,n.$6g)(O=>new Promise((F,x)=>{const z=setTimeout(F,J*1e3);O.onCancellationRequested(()=>{clearTimeout(z),F()})}))}var T;(function(J){J[J.ConnectionLost=0]="ConnectionLost",J[J.ReconnectionWait=1]="ReconnectionWait",J[J.ReconnectionRunning=2]="ReconnectionRunning",J[J.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",J[J.ConnectionGain=4]="ConnectionGain"})(T||(e.PersistentConnectionEventType=T={}));class W{constructor(O,F){this.reconnectionToken=O,this.millisSinceLastIncomingData=F,this.type=0}}e.$xl=W;class V{constructor(O,F,x,z){this.reconnectionToken=O,this.millisSinceLastIncomingData=F,this.durationSeconds=x,this.c=z,this.type=1}skipWait(){this.c.cancel()}}e.$yl=V;class K{constructor(O,F,x){this.reconnectionToken=O,this.millisSinceLastIncomingData=F,this.attempt=x,this.type=2}}e.$zl=K;class le{constructor(O,F,x){this.reconnectionToken=O,this.millisSinceLastIncomingData=F,this.attempt=x,this.type=4}}e.$Al=le;class re{constructor(O,F,x,z){this.reconnectionToken=O,this.millisSinceLastIncomingData=F,this.attempt=x,this.handled=z,this.type=3}}e.$Bl=re;class ue extends P.$Tc{static triggerPermanentFailure(O,F,x){this._permanentFailure=!0,this.f=O,this.g=F,this.h=x,this.j.forEach(z=>z.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(O=>O.y())}static debugPauseSocketWriting(){this.j.forEach(O=>O.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||ue._permanentFailure}constructor(O,F,x,z,Q){super(),this.t=O,this.u=F,this.reconnectionToken=x,this.protocol=z,this.w=Q,this.m=this.B(new C.$6d),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new le(this.reconnectionToken,0,0)),this.B(z.onSocketClose(H=>{const _=q(this.t,this.reconnectionToken,!0);H?H.type===0?(this.u.logService.info(`${_} received socket close event (hadError: ${H.hadError}).`),H.error&&this.u.logService.error(H.error)):(this.u.logService.info(`${_} received socket close event (wasClean: ${H.wasClean}, code: ${H.code}, reason: ${H.reason}).`),H.event&&this.u.logService.error(H.event)):this.u.logService.info(`${_} received socket close event.`),this.y()})),this.B(z.onSocketTimeout(H=>{const _=q(this.t,this.reconnectionToken,!0);this.u.logService.info(`${_} received socket timeout event (unacknowledgedMsgCount: ${H.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${H.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${H.timeSinceLastReceivedSomeData}).`),this.y()})),ue.j.push(this),this.B((0,P.$Rc)(()=>{const H=ue.j.indexOf(this);H>=0&&ue.j.splice(H,1)})),this.n&&this.D(ue.f,ue.g,ue.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const O=q(this.t,this.reconnectionToken,!0);this.u.logService.info(`${O} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new W(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const F=[0,5,5,10,10,10,10,10,30];let x=-1;do{x++;const z=x<F.length?F[x]:F[F.length-1];try{if(z>0){const H=j(z);this.m.fire(new V(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),z,H)),this.u.logService.info(`${O} waiting for ${z} seconds before reconnecting...`);try{await H}catch{}}if(this.n){this.u.logService.error(`${O} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new K(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),x+1)),this.u.logService.info(`${O} resolving connection...`);const Q=await b(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${O} connecting to ${Q.connectTo}...`),await this.G(Q,u(m)),this.u.logService.info(`${O} reconnected!`),this.m.fire(new le(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),x+1));break}catch(Q){if(Q.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${O} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(Q),this.C(this.protocol.getMillisSinceLastIncomingData(),x+1,!1);break}if(x>360){this.u.logService.error(`${O} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(Q),this.C(this.protocol.getMillisSinceLastIncomingData(),x+1,!1);break}if(g.$ol.isTemporarilyNotAvailable(Q)){this.u.logService.info(`${O} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(Q);continue}if((Q.code==="ETIMEDOUT"||Q.code==="ENETUNREACH"||Q.code==="ECONNREFUSED"||Q.code==="ECONNRESET")&&Q.syscall==="connect"){this.u.logService.info(`${O} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(Q);continue}if((0,M.$4)(Q)){this.u.logService.info(`${O} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(Q);continue}if(Q instanceof g.$ol){this.u.logService.error(`${O} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(Q),this.C(this.protocol.getMillisSinceLastIncomingData(),x+1,g.$ol.isHandled(Q));break}this.u.logService.error(`${O} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(Q),this.C(this.protocol.getMillisSinceLastIncomingData(),x+1,!1);break}}while(!this.n&&!this.s)}C(O,F,x){this.w?ue.triggerPermanentFailure(O,F,x):this.D(O,F,x)}D(O,F,x){this.m.fire(new re(this.reconnectionToken,O,F,x)),U(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$Cl=ue;class Z extends ue{constructor(O,F,x,z,Q){super(1,O,z,Q,!0),this.client=this.B(new k.$5h(Q,{remoteAuthority:F,clientId:x},O.ipcLogger))}async G(O,F){await i(O,F)}}e.$Dl=Z;class Y extends ue{constructor(O,F,x,z,Q){super(2,O,x,z,!1),this.H=F,this.debugPort=Q}async G(O,F){await s(O,this.H,F)}}e.$El=Y;function U(J){try{J.acceptDisconnect();const O=J.getSocket();J.dispose(),O.dispose()}catch(O){(0,M.$1)(O)}}function L(J){if(J&&J.type==="error"){const O=new Error(`Connection error: ${J.reason}`);return O.code="VSCODE_CONNECTION_ERROR",O}return null}function N(J,O){for(;J.length<O;)J+=" ";return J}function G(J,O){return`[remote-connection][${N(p(J),13)}][${O.substr(0,5)}\u2026]`}function q(J,O,F){return`${G(J,O)}[${F?"reconnect":"initial"}]`}function oe(J,O){return`${q(O,J.reconnectionToken,!!J.reconnectionProtocol)}[${J.connectTo}]`}function he(J){return`${Date.now()-J} ms`}}),define(ae[68],ce([0,1,13]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tm=e.$sm=e.$rm=e.$qm=void 0;function D(d){return d.scheme===n.Schemas.vscodeRemote?d.authority:void 0}e.$qm=D;function S(d){if(!d)return;const c=d.indexOf("+");return c<0?d:d.substr(0,c)}e.$rm=S;function M(d){const{host:c,port:y}=P(d);if(typeof y>"u")throw new Error(`Invalid remote authority: ${d}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:c,port:y}}e.$sm=M;function C(d,c){let{host:y,port:v}=P(d);return typeof v>"u"&&(v=c),{host:y,port:v}}e.$tm=C;function P(d){const c=d.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(c)return{host:c[1],port:parseInt(c[2],10)};const y=d.match(/^(\[[0-9a-z:]+\])$/);if(y)return{host:y[1],port:void 0};const v=d.match(/(.*):(\d+)$/);return v?{host:v[1],port:parseInt(v[2],10)}:{host:d,port:void 0}}}),define(ae[124],ce([0,1,25,6,68]),function(X,e,n,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hm=e.$Gm=e.$Fm=e.$Em=e.$Dm=e.$Cm=e.$Bm=e.$Am=e.TargetPlatform=e.ExtensionType=e.$zm=e.$ym=e.$xm=e.$wm=e.$vm=e.$um=void 0,e.$um="extensions.user.cache",e.$vm="extensions.builtin.cache",e.$wm="undefined_publisher",e.$xm=["ui","workspace","web"];function M(w){if(typeof w=="object"&&w!==null&&w.supported!==!0)return w.description}e.$ym=M,e.$zm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var C;(function(w){w[w.System=0]="System",w[w.User=1]="User"})(C||(e.ExtensionType=C={}));var P;(function(w){w.WIN32_X64="win32-x64",w.WIN32_ARM64="win32-arm64",w.LINUX_X64="linux-x64",w.LINUX_ARM64="linux-arm64",w.LINUX_ARMHF="linux-armhf",w.ALPINE_X64="alpine-x64",w.ALPINE_ARM64="alpine-arm64",w.DARWIN_X64="darwin-x64",w.DARWIN_ARM64="darwin-arm64",w.WEB="web",w.UNIVERSAL="universal",w.UNKNOWN="unknown",w.UNDEFINED="undefined"})(P||(e.TargetPlatform=P={}));class d{constructor(p){this.value=p,this._lower=p.toLowerCase()}static equals(p,u){if(typeof p>"u"||p===null)return typeof u>"u"||u===null;if(typeof u>"u"||u===null)return!1;if(typeof p=="string"||typeof u=="string"){const f=typeof p=="string"?p:p.value,h=typeof u=="string"?u:u.value;return n.$kf(f,h)}return p._lower===u._lower}static toKey(p){return typeof p=="string"?p.toLowerCase():p._lower}}e.$Am=d;class c{get size(){return this.c.size}constructor(p){if(this.c=new Set,p)for(const u of p)this.add(u)}add(p){this.c.add(d.toKey(p))}delete(p){return this.c.delete(d.toKey(p))}has(p){return this.c.has(d.toKey(p))}}e.$Bm=c;class y{constructor(){this.c=new Map}clear(){this.c.clear()}delete(p){this.c.delete(d.toKey(p))}get(p){return this.c.get(d.toKey(p))}has(p){return this.c.has(d.toKey(p))}set(p,u){this.c.set(d.toKey(p),u)}values(){return this.c.values()}forEach(p){this.c.forEach(p)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Cm=y;function v(w){return k(w)}e.$Dm=v;function k(w){return w.contributes&&w.contributes.localizations?w.contributes.localizations.length>0:!1}e.$Em=k;function g(w){return w.contributes&&w.contributes.authentication?w.contributes.authentication.length>0:!1}e.$Fm=g;function m(w,p){if(p){const u=`onResolveRemoteAuthority:${(0,S.$rm)(p)}`;return!!w.activationEvents?.includes(u)}return!1}e.$Gm=m,e.$Hm=(0,D.$gi)("IBuiltinExtensionsScannerService")}),define(ae[244],ce([0,1,2,6]),function(X,e,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rl=e.$ql=void 0,e.$ql=(0,D.$gi)("remoteSocketFactoryService");class S{constructor(){this.a={}}register(C,P){return this.a[C]??=[],this.a[C].push(P),(0,n.$Rc)(()=>{const d=this.a[C]?.indexOf(P);typeof d=="number"&&d>=0&&this.a[C]?.splice(d,1)})}b(C){return(this.a[C.type]||[]).find(d=>d.supports(C))}connect(C,P,d,c){const y=this.b(C);if(!y)throw new Error(`No socket factory found for ${C}`);return y.connect(C,P,d,c)}}e.$rl=S}),define(ae[245],ce([0,1,26,48,21,117]),function(X,e,n,D,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$O_b=void 0;let C;async function P(g=!1){return(C===void 0||g)&&(C=d()),C}e.$O_b=P;async function d(){const g=c();if(g===void 0)return!1;if(g>=22e3){const m=v();if(m)return new Promise(w=>{D.execFile(m,["--status"],p=>w(!p))})}else{const m=k();if(m)try{if((await S.Promises.stat(m)).isFile())return!0}catch{}}return!1}function c(){const g=/(\d+)\.(\d+)\.(\d+)/g.exec(n.release());if(g)return parseInt(g[3])}function y(g){const m=process.env.SystemRoot;if(m){const w=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return M.join(m,w?"Sysnative":"System32",g)}}function v(){return y("wsl.exe")}function k(){return y("lxss\\LxssManager.dll")}}),define(ae[53],ce([0,1,17,15,2,185,52,6,5,44]),function(X,e,n,D,S,M,C,P,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dp=e.$Cp=e.$Bp=e.$Ap=e.$zp=e.$yp=e.$xp=e.$wp=void 0,e.$wp=(0,P.$gi)("requestService");class y{constructor(a){this.b=a}toJSON(){if(!this.a){const a=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?a[t]="*****":a[t]=this.b[t];this.a=a}return this.a}}class v extends S.$Tc{constructor(a){super(),this.b=0,this.a=a.createLogger("network",{name:(0,M.localize)(0,null),when:d.$Rj.isEqualTo((0,d.$Pj)(d.LogLevel.Trace)).serialize()})}async c(a,t,o){const r=`${a} #${++this.b}: ${t.url}`;this.a.trace(`${r} - begin`,t.type,new y(t.headers??{}));try{const i=await o();return this.a.trace(`${r} - end`,t.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.a.error(`${r} - error`,t.type,(0,D.$0)(i)),i}}}e.$xp=v;function k($){return $.res.statusCode&&$.res.statusCode>=200&&$.res.statusCode<300||$.res.statusCode===1223}e.$yp=k;function g($){return $.res.statusCode===204}e.$zp=g;async function m($){return g($)?null:(await(0,n.$Fe)($.stream)).toString()}e.$Ap=m;async function w($){if(!k($))throw new Error("Server returned "+$.res.statusCode);return m($)}e.$Bp=w;async function p($){if(!k($))throw new Error("Server returned "+$.res.statusCode);if(g($))return null;const t=(await(0,n.$Fe)($.stream)).toString();try{return JSON.parse(t)}catch(o){throw o.message+=`:
`+t,o}}e.$Cp=p;function u($){h($)}e.$Dp=u;let f;function h($){const a=c.$Xn.as(C.$3n.Configuration),t=f;f={id:"http",order:15,title:(0,M.localize)(1,null),type:"object",scope:$,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,M.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,M.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,M.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,M.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,M.localize)(6,null),(0,M.localize)(7,null),(0,M.localize)(8,null),(0,M.localize)(9,null)],default:"override",description:(0,M.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,M.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,M.localize)(12,null),restricted:!0}}},a.updateConfigurations({add:[f],remove:t?[t]:[]})}h(1)}),define(ae[246],ce([0,1,17,23]),function(X,e,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ar=e.$zr=void 0;class S{constructor(P){this.a=P}listen(P,d){throw new Error("Invalid listen")}call(P,d,c,y=D.CancellationToken.None){switch(d){case"request":return this.a.request(c[0],y).then(async({res:v,stream:k})=>{const g=await(0,n.$Fe)(k);return[{statusCode:v.statusCode,headers:v.headers},g]});case"resolveProxy":return this.a.resolveProxy(c[0]);case"loadCertificates":return this.a.loadCertificates()}throw new Error("Invalid call")}}e.$zr=S;class M{constructor(P){this.a=P}async request(P,d){const[c,y]=await this.a.call("request",[P],d);return{res:c,stream:(0,n.$He)(y)}}async resolveProxy(P){return this.a.call("resolveProxy",[P])}async loadCertificates(){return this.a.call("loadCertificates")}}e.$Ar=M}),define(ae[247],ce([0,1,248,12]),function(X,e,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Br=void 0;function S(C,P){return C.protocol==="http:"?P.HTTP_PROXY||P.http_proxy||null:C.protocol==="https:"&&(P.HTTPS_PROXY||P.https_proxy||P.HTTP_PROXY||P.http_proxy)||null}async function M(C,P,d={}){const c=(0,n.parse)(C),y=d.proxyUrl||S(c,P);if(!y)return null;const v=(0,n.parse)(y);if(!/^https?:$/.test(v.protocol||""))return null;const k={host:v.hostname||"",port:(v.port?+v.port:0)||(v.protocol==="https"?443:80),auth:v.auth,rejectUnauthorized:(0,D.$Zf)(d.strictSSL)?d.strictSSL:!0};return c.protocol==="http:"?new(await new Promise((g,m)=>{X(["http-proxy-agent"],g,m)})).HttpProxyAgent(y,k):new(await new Promise((g,m)=>{X(["https-proxy-agent"],g,m)})).HttpsProxyAgent(y,k)}e.$Br=M}),define(ae[249],ce([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$_b=e.$0_b=e.$9_b=void 0,e.$9_b={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.$0_b={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.$$_b={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(ae[95],ce([0,1,48,9,186,23,51,15,4,32,112,63,8,141]),function(X,e,n,D,S,M,C,P,d,c,y,v,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$km=void 0;let m;async function w(u,f,h,$){return h["force-disable-user-env"]?(f.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):d.$i?(f.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,v.$em)($)&&!h["force-user-env"]?(f.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,v.$em)($)?f.trace("resolveShellEnv(): running (--force-user-env)"):f.trace("resolveShellEnv(): running (macOS/Linux)"),m||(m=k.Promises.withAsyncBody(async(a,t)=>{const o=new M.$de;let r=1e4;const i=u.getValue("application.shellEnvironmentResolutionTimeout");typeof i=="number"&&(r=(0,g.$fm)(i,1,120)*1e3);const s=setTimeout(()=>{o.dispose(!0),t(new Error((0,S.localize)(0,null)))},r);try{a(await p(f,o.token))}catch(l){!(0,P.$4)(l)&&!o.token.isCancellationRequested?t(new Error((0,S.localize)(1,null,(0,C.$4i)(l)))):a({})}finally{clearTimeout(s),o.dispose()}})),m)}e.$km=w;async function p(u,f){const h=process.env.ELECTRON_RUN_AS_NODE;u.trace("getUnixShellEnvironment#runAsNode",h);const $=process.env.ELECTRON_NO_ATTACH_CONSOLE;u.trace("getUnixShellEnvironment#noAttach",$);const a=(0,c.$Cg)().replace(/-/g,"").substr(0,12),t=new RegExp(a+"({.*})"+a),o={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};u.trace("getUnixShellEnvironment#env",o);const r=await(0,y.$7l)(d.OS,o);return u.trace("getUnixShellEnvironment#shell",r),new Promise((i,s)=>{if(f.isCancellationRequested)return s(new P.$5);const l=(0,D.$nc)(r);let b,R;const I="";/^pwsh(-preview)?$/.test(l)?(b=`& '${process.execPath}' ${I} -p '''${a}'' + JSON.stringify(process.env) + ''${a}'''`,R=["-Login","-Command"]):l==="nu"?(b=`^'${process.execPath}' ${I} -p '"${a}" + JSON.stringify(process.env) + "${a}"'`,R=["-i","-l","-c"]):l==="xonsh"?(b=`import os, json; print("${a}", json.dumps(dict(os.environ)), "${a}")`,R=["-i","-l","-c"]):(b=`'${process.execPath}' ${I} -p '"${a}" + JSON.stringify(process.env) + "${a}"'`,l==="tcsh"||l==="csh"?R=["-ic"]:R=["-i","-l","-c"]),u.trace("getUnixShellEnvironment#spawn",JSON.stringify(R),b);const E=(0,n.spawn)(r,[...R,b],{detached:!0,stdio:["ignore","pipe","pipe"],env:o});f.onCancellationRequested(()=>(E.kill(),s(new P.$5))),E.on("error",T=>{u.error("getUnixShellEnvironment#errorChildProcess",(0,C.$4i)(T)),s(T)});const A=[];E.stdout.on("data",T=>A.push(T));const j=[];E.stderr.on("data",T=>j.push(T)),E.on("close",(T,W)=>{const V=Buffer.concat(A).toString("utf8");u.trace("getUnixShellEnvironment#raw",V);const K=Buffer.concat(j).toString("utf8");if(K.trim()&&u.trace("getUnixShellEnvironment#stderr",K),T||W)return s(new Error((0,S.localize)(2,null,T,W)));const le=t.exec(V),re=le?le[1]:"{}";try{const ue=JSON.parse(re);h?ue.ELECTRON_RUN_AS_NODE=h:delete ue.ELECTRON_RUN_AS_NODE,$?ue.ELECTRON_NO_ATTACH_CONSOLE=$:delete ue.ELECTRON_NO_ATTACH_CONSOLE,delete ue.VSCODE_RESOLVING_ENVIRONMENT,delete ue.XDG_RUNTIME_DIR,u.trace("getUnixShellEnvironment#result",ue),i(ue)}catch(ue){u.error("getUnixShellEnvironment#errorCaught",(0,C.$4i)(ue)),s(ue)}})})}}),define(ae[250],ce([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$58b=void 0;class n{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(S){try{const M=await this.c();if(M){const C=String(n.a++);return this.b.set(C,M),{id:C,data:M.createNewMessage(S)}}}catch{}return{id:"",data:S}}async validate(S,M){if(!S.id)return!0;const C=this.b.get(S.id);if(!C)return!1;this.b.delete(S.id);try{return C.validate(M)==="ok"}catch{return!1}finally{C.dispose?.()}}async sign(S){try{return await this.d(S)}catch{}return S}}e.$58b=n}),define(ae[96],ce([0,1,6]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tl=e.$sl=void 0,e.$sl="signService",e.$tl=(0,n.$gi)(e.$sl)}),define(ae[251],ce([0,1,250]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yac=void 0;class D extends n.$58b{c(){return this.h().then(M=>new M.validator)}d(M){return this.h().then(C=>new C.signer().sign(M))}h(){return new Promise((M,C)=>X(["vsda"],M,C))}}e.$Yac=D}),define(ae[34],ce([0,1,6]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HP=e.$GP=void 0,e.$GP=(0,n.$gi)("stateReadService"),e.$HP=(0,n.$gi)("stateService")}),define(ae[125],ce([0,1,8,17,2,12,38,16,5]),function(X,e,n,D,S,M,C,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KP=e.$JP=e.$IP=e.SaveStrategy=void 0;var c;(function(g){g[g.IMMEDIATE=0]="IMMEDIATE",g[g.DELAYED=1]="DELAYED"})(c||(e.SaveStrategy=c={}));class y extends S.$Tc{constructor(m,w,p,u){super(),this.h=m,this.j=w,this.m=p,this.n=u,this.a=Object.create(null),this.b="",this.c=this.B(new n.$eh(this.j===0?0:100)),this.f=void 0,this.g=void 0}init(){return this.f||(this.f=this.r()),this.f}async r(){try{this.b=(await this.n.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(m){m.fileOperationResult!==1&&this.m.error(m)}}getItem(m,w){const p=this.a[m];return(0,M.$3f)(p)?w:p}setItem(m,w){this.setItems([{key:m,data:w}])}setItems(m){let w=!1;for(const{key:p,data:u}of m)this.a[p]!==u&&((0,M.$3f)(u)?(0,M.$1f)(this.a[p])||(this.a[p]=void 0,w=!0):(this.a[p]=u,w=!0));w&&this.s()}removeItem(m){(0,M.$1f)(this.a[m])||(this.a[m]=void 0,this.s())}async s(){if(!this.g)return this.c.trigger(()=>this.t())}async t(){if(!this.f)return;await this.f;const m=JSON.stringify(this.a,null,4);if(m!==this.b)try{await this.n.writeFile(this.h,D.$te.fromString(m),{atomic:{postfix:".vsctmp"}}),this.b=m}catch(w){this.m.error(w)}}async close(){return this.g||(this.g=this.c.trigger(()=>this.t(),0)),this.g}}e.$IP=y;let v=class extends S.$Tc{constructor(m,w,p,u){super(),this.a=this.B(new y(w.stateResource,m,p,u))}async init(){await this.a.init()}getItem(m,w){return this.a.getItem(m,w)}};e.$JP=v,e.$JP=v=ve([se(1,C.$ni),se(2,d.$Aj),se(3,P.$Gk)],v);class k extends v{setItem(m,w){this.a.setItem(m,w)}setItems(m){this.a.setItems(m)}removeItem(m){this.a.removeItem(m)}close(){return this.a.close()}}e.$KP=k}),define(ae[126],ce([0,1,4,36,32]),function(X,e,n,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zo=e.$Yo=void 0;function M(d){if(n.$u===2&&/^penguin(\.|$)/i.test(d))return"chromebook"}function C(d,c,y,v,k,g,m,w,p){const u=Object.create(null);u["common.machineId"]=g,u["common.sqmId"]=m,u.sessionID=(0,S.$Cg)()+Date.now(),u.commitHash=v,u.version=k,u["common.platformVersion"]=(d||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),u["common.platform"]=(0,n.$h)(n.$u),u["common.nodePlatform"]=D.$dc,u["common.nodeArch"]=y,u["common.product"]=p||"desktop",w&&(u["common.msftInternal"]=w);let f=0;const h=Date.now();Object.defineProperties(u,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-h,enumerable:!0},"common.sequence":{get:()=>f++,enumerable:!0}}),n.$l&&(u["common.snap"]="true");const $=M(c);return $&&(u["common.platformDetail"]=$),u}e.$Yo=C;function P(d){const c=D.env.USERDNSDOMAIN;if(!c)return!1;const y=c.toLowerCase();return d.some(v=>y===v)}e.$Zo=P}),define(ae[28],ce([0,1,6]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$Pl=e.$Ol=e.$Nl=e.$Ml=e.$Ll=e.$Kl=e.$Jl=e.$Il=e.$Hl=e.$Gl=e.$Fl=void 0,e.$Fl=(0,n.$gi)("telemetryService"),e.$Gl=(0,n.$gi)("customEndpointTelemetryService"),e.$Hl="telemetry.currentSessionDate",e.$Il="telemetry.firstSessionDate",e.$Jl="telemetry.lastSessionDate",e.$Kl="telemetry.machineId",e.$Ll="telemetry.sqmId",e.$Ml="telemetry",e.$Nl="telemetry.telemetryLevel",e.$Ol="telemetry.enableCrashReporter",e.$Pl="telemetry.enableTelemetry";var D;(function(M){M[M.NONE=0]="NONE",M[M.CRASH=1]="CRASH",M[M.ERROR=2]="ERROR",M[M.USAGE=3]="USAGE"})(D||(e.TelemetryLevel=D={}));var S;(function(M){M.OFF="off",M.CRASH="crash",M.ERROR="error",M.ON="all"})(S||(e.TelemetryConfiguration=S={}))}),define(ae[252],ce([0,1,26,8,42,13,9,4,7,89,21,111,92,16,27,28]),function(X,e,n,D,S,M,C,P,d,c,y,v,k,g,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ls=e.$ks=e.$js=e.$is=void 0;const p=new Map;async function u(t,o){const r=`${t}::${o.join(":")}`,i=p.get(r);if(i)return i;const s=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],l=new Map,b=new Map,R=2e4;function I(A,j,T,W){const V=j.substring(A.length+1);return D.Promises.withAsyncBody(async K=>{let le;try{le=await y.Promises.readdir(j,{withFileTypes:!0})}catch{K();return}if(W.count>=R){W.count+=le.length,W.maxReached=!0,K();return}let re=le.length;if(re===0){K();return}let ue=le;W.count+le.length>R&&(W.maxReached=!0,re=R-W.count,ue=le.slice(0,re)),W.count+=le.length;for(const Z of ue)if(Z.isDirectory()){if(T.includes(Z.name)||await I(A,(0,C.$jc)(j,Z.name),T,W),--re===0){K();return}}else{const Y=Z.name.lastIndexOf(".");if(Y>=0){const U=Z.name.substring(Y+1);U&&l.set(U,(l.get(U)??0)+1)}for(const U of s)U.relativePathPattern?.test(V)!==!1&&U.filePattern.test(Z.name)&&b.set(U.tag,(b.get(U.tag)??0)+1);if(--re===0){K();return}}})}const E=D.Promises.withAsyncBody(async A=>{const j={count:0,maxReached:!1};await I(t,t,o,j);const T=await $(t);A({configFiles:f(b),fileTypes:f(l),fileCount:j.count,maxFilesReached:j.maxReached,launchConfigFiles:T})});return p.set(r,E),E}e.$is=u;function f(t){return Array.from(t.entries(),([o,r])=>({name:o,count:r})).sort((o,r)=>r.count-o.count)}function h(){const t={os:`${n.type()} ${n.arch()} ${n.release()}`,memory:`${(n.totalmem()/g.$cl.GB).toFixed(2)}GB (${(n.freemem()/g.$cl.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(c.$nn.value()*100)}%`},o=n.cpus();return o&&o.length>0&&(t.cpus=`${o[0].model} (${o.length} x ${o[0].speed})`),t}e.$js=h;async function $(t){try{const o=new Map,r=(0,C.$jc)(t,".vscode","launch.json"),i=await y.Promises.readFile(r),s=[],l=(0,S.$sn)(i.toString(),s);if(s.length)return console.log(`Unable to parse ${r}`),[];if((0,S.$Bn)(l)==="object"&&l.configurations)for(const b of l.configurations){const R=b.type;R&&(o.has(R)?o.set(R,o.get(R)+1):o.set(R,1))}return f(o)}catch{return[]}}e.$ks=$;let a=class{constructor(o,r){this.c=o,this.d=r}f(o){const r=[];return r.push(`OS Version:       ${o.os}`),r.push(`CPUs:             ${o.cpus}`),r.push(`Memory (System):  ${o.memory}`),r.push(`VM:               ${o.vmHint}`),r.join(`
`)}g(o){const r=[];r.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),r.push(`OS Version:       ${n.type()} ${n.arch()} ${n.release()}`);const i=n.cpus();return i&&i.length>0&&r.push(`CPUs:             ${i[0].model} (${i.length} x ${i[0].speed})`),r.push(`Memory (System):  ${(n.totalmem()/g.$cl.GB).toFixed(2)}GB (${(n.freemem()/g.$cl.GB).toFixed(2)}GB free)`),P.$i||r.push(`Load (avg):       ${n.loadavg().map(s=>Math.round(s)).join(", ")}`),r.push(`VM:               ${Math.round(c.$nn.value()*100)}%`),r.push(`Screen Reader:    ${o.screenReader?"yes":"no"}`),r.push(`Process Argv:     ${o.mainArguments.join(" ")}`),r.push(`GPU Status:       ${this.j(o.gpuFeatureStatus)}`),r.join(`
`)}async getPerformanceInfo(o,r){return Promise.all([(0,v.$hs)(o.mainPID),this.k(o)]).then(async i=>{let[s,l]=i,b=this.m(o,s);return r.forEach(R=>{if((0,k.$Zm)(R))b+=`
${R.errorMessage}`,l+=`
${R.errorMessage}`;else if(b+=`

Remote: ${R.hostName}`,R.processes&&(b+=`
${this.m(o,R.processes)}`),R.workspaceMetadata){l+=`
|  Remote: ${R.hostName}`;for(const I of Object.keys(R.workspaceMetadata)){const E=R.workspaceMetadata[I];let A=`${E.fileCount} files`;E.maxFilesReached&&(A=`more than ${A}`),l+=`|    Folder (${I}): ${A}`,l+=this.h(E)}}}),{processInfo:b,workspaceInfo:l}})}async getSystemInfo(o,r){const{memory:i,vmHint:s,os:l,cpus:b}=h(),R={os:l,memory:i,cpus:b,vmHint:s,processArgs:`${o.mainArguments.join(" ")}`,gpuStatus:o.gpuFeatureStatus,screenReader:`${o.screenReader?"yes":"no"}`,remoteData:r};return P.$i||(R.load=`${n.loadavg().map(I=>Math.round(I)).join(", ")}`),P.$k&&(R.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(R)}async getDiagnostics(o,r){const i=[];return(0,v.$hs)(o.mainPID).then(async s=>(i.push(""),i.push(this.g(o)),i.push(""),i.push(this.m(o,s)),o.windows.some(l=>l.folderURIs&&l.folderURIs.length>0&&!l.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.k(o))),r.forEach(l=>{if((0,k.$Zm)(l))i.push(`
${l.errorMessage}`);else if(i.push(`

`),i.push(`Remote:           ${l.hostName}`),i.push(this.f(l.machineInfo)),l.processes&&i.push(this.m(o,l.processes)),l.workspaceMetadata)for(const b of Object.keys(l.workspaceMetadata)){const R=l.workspaceMetadata[b];let I=`${R.fileCount} files`;R.maxFilesReached&&(I=`more than ${I}`),i.push(`Folder (${b}): ${I}`),i.push(this.h(R))}}),i.push(""),i.push(""),i.join(`
`)))}h(o){const r=[];let s=0;const l=(E,A)=>{const j=` ${E}(${A})`;s+j.length>60?(r.push(b),b="|                 ",s=b.length):s+=j.length,b+=j};let b="|      File types:";const R=10,I=o.fileTypes.length>R?R:o.fileTypes.length;for(let E=0;E<I;E++){const A=o.fileTypes[E];l(A.name,A.count)}if(r.push(b),o.configFiles.length>=0&&(b="|      Conf files:",s=0,o.configFiles.forEach(E=>{l(E.name,E.count)}),r.push(b)),o.launchConfigFiles.length>0){let E="|      Launch Configs:";o.launchConfigFiles.forEach(A=>{const j=A.count>1?` ${A.name}(${A.count})`:` ${A.name}`;E+=j}),r.push(E)}return r.join(`
`)}j(o){const r=Math.max(...Object.keys(o).map(i=>i.length));return Object.keys(o).map(i=>`${i}:  ${" ".repeat(r-i.length)}  ${o[i]}`).join(`
                  `)}k(o){const r=[],i=[];return o.windows.forEach(s=>{s.folderURIs.length===0||s.remoteAuthority||(r.push(`|  Window (${s.title})`),s.folderURIs.forEach(l=>{const b=d.URI.revive(l);if(b.scheme===M.Schemas.file){const R=b.fsPath;i.push(u(R,["node_modules",".git"]).then(I=>{let E=`${I.fileCount} files`;I.maxFilesReached&&(E=`more than ${E}`),r.push(`|    Folder (${(0,C.$nc)(R)}): ${E}`),r.push(this.h(I))}).catch(I=>{r.push(`|      Error: Unable to collect workspace stats for folder ${R} (${I.toString()})`)}))}else r.push(`|    Folder (${b.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(s=>r.join(`
`)).catch(s=>`Unable to collect workspace stats: ${s}`)}m(o,r){const i=new Map;o.windows.forEach(l=>i.set(l.pid,`window [${l.id}] (${l.title})`)),o.pidToNames.forEach(({pid:l,name:b})=>i.set(l,b));const s=[];return s.push("CPU %	Mem MB	   PID	Process"),r&&this.n(o.mainPID,i,s,r,0),s.join(`
`)}n(o,r,i,s,l){const b=l===0;let R;b?R=s.pid===o?`${this.d.applicationName} main`:"remote agent":r.has(s.pid)?R=r.get(s.pid):R=`${"  ".repeat(l)} ${s.name}`;const I=process.platform==="win32"?s.mem:n.totalmem()*(s.mem/100);i.push(`${s.load.toFixed(0).padStart(5," ")}	${(I/g.$cl.MB).toFixed(0).padStart(6," ")}	${s.pid.toFixed(0).padStart(6," ")}	${R}`),Array.isArray(s.children)&&s.children.forEach(E=>this.n(o,r,i,E,l+1))}async getWorkspaceFileExtensions(o){const r=new Set;for(const{uri:i}of o.folders){const s=d.URI.revive(i);if(s.scheme!==M.Schemas.file)continue;const l=s.fsPath;try{(await u(l,["node_modules",".git"])).fileTypes.forEach(R=>r.add(R.name))}catch{}}return{extensions:[...r]}}async reportWorkspaceStats(o){for(const{uri:r}of o.folders){const i=d.URI.revive(r);if(i.scheme!==M.Schemas.file)continue;const s=i.fsPath;try{const l=await u(s,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":o.telemetryId,rendererSessionId:o.rendererSessionId}),l.fileTypes.forEach(b=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:o.rendererSessionId,type:b.name,count:b.count})}),l.launchConfigFiles.forEach(b=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:o.rendererSessionId,type:b.name,count:b.count})}),l.configFiles.forEach(b=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:o.rendererSessionId,type:b.name,count:b.count})})}catch{}}}};e.$ls=a,e.$ls=a=ve([se(0,w.$Fl),se(1,m.$Sj)],a)}),define(ae[253],ce([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cac=e.$bac=void 0;class n{constructor(M){this.b=M}listen(M,C){throw new Error(`Event not found: ${C}`)}call(M,C,{eventName:P,data:d}){return this.b.forEach(c=>c.log(P,d)),Promise.resolve(null)}}e.$bac=n;class D{constructor(M){this.b=M}log(M,C){return this.b.call("log",{eventName:M,data:C}).then(void 0,P=>`Failed to log telemetry: ${console.warn(P)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$cac=D}),define(ae[54],ce([0,1,35,12,68,126,28]),function(X,e,n,D,S,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cp=e.$bp=e.$ap=e.$_o=e.$$o=e.$0o=e.$9o=e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=e.$3o=e.$2o=e.$1o=void 0;class P{constructor(o){this.value=o,this.isTrustedTelemetryValue=!0}}e.$1o=P;class d{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$2o=d,e.$3o=new d;class c{async publicLog(o,r,i){}async publicLogError(o,r,i){}}e.$4o=c,e.$5o="telemetry",e.$6o="extensionTelemetryLog",e.$7o={log:()=>null,flush:()=>Promise.resolve(null)};function y(t,o){return!o.isBuilt&&!o.disableTelemetry?!0:!(o.disableTelemetry||!t.enableTelemetry)}e.$8o=y;function v(t,o){return o.extensionTestsLocationURI?!0:!(o.isBuilt||o.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}e.$9o=v;function k(t){const o=t.getValue(C.$Nl),r=t.getValue(C.$Ol);if(t.getValue(C.$Pl)===!1||r===!1)return 0;switch(o??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$0o=k;function g(t){const o={},r={},i={};p(t,i);for(let s in i){s=s.length>150?s.substr(s.length-149):s;const l=i[s];typeof l=="number"?r[s]=l:typeof l=="boolean"?r[s]=l?1:0:typeof l=="string"?(l.length>8192&&console.warn(`Telemetry property: ${s} has been trimmed to 8192, the original length is ${l.length}`),o[s]=l.substring(0,8191)):typeof l<"u"&&l!==null&&(o[s]=l)}return{properties:o,measurements:r}}e.$$o=g;const m=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function w(t){if(!t)return"none";const o=(0,S.$rm)(t);return m.has(o)?o:"other"}e.$_o=w;function p(t,o,r=0,i){if(t)for(const s of Object.getOwnPropertyNames(t)){const l=t[s],b=i?i+s:s;Array.isArray(l)?o[b]=(0,n.$Qn)(l):l instanceof Date?o[b]=l.toISOString():(0,D.$Vf)(l)?r<2?p(l,o,r+1,b+"."):o[b]=(0,n.$Qn)(l):o[b]=l}}function u(t,o){const r=t.msftInternalDomains||[],i=o.getValue("telemetry.internalTesting");return(0,M.$Zo)(r)||i}e.$ap=u;function f(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}e.$bp=f;function h(t,o){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let r=t;const i=[];for(const R of o)for(;;){const I=R.exec(t);if(!I)break;i.push([I.index,R.lastIndex])}const s=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,l=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let b=0;for(r="";;){const R=l.exec(t);if(!R)break;const I=i.some(([E,A])=>R.index<A&&E<l.lastIndex);!s.test(R[0])&&!I&&(r+=t.substring(b,R.index)+"<REDACTED: user-file-path>",b=l.lastIndex)}return b<t.length&&(r+=t.substr(b)),r}function $(t){if(!t)return t;const o=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const r of o)if(r.regex.test(t))return`<REDACTED: ${r.label}>`;return t}function a(t,o){return(0,n.$Nn)(t,r=>{if(r instanceof P||Object.hasOwnProperty.call(r,"isTrustedTelemetryValue"))return r.value;if(typeof r=="string"){let i=r.replaceAll("%20"," ");i=h(i,o);for(const s of o)i=i.replace(s,"");return i=$(i),i}})}e.$cp=a}),define(ae[127],ce([0,1,25,121,124,4,7,15,36,54]),function(X,e,n,D,S,M,C,P,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$op=e.$np=e.$mp=e.$lp=e.$kp=e.$jp=e.$ip=e.$hp=e.$gp=e.$fp=e.$ep=e.$dp=void 0;function y(r,i){return r.uuid&&i.uuid?r.uuid===i.uuid:r.id===i.id?!0:(0,n.$ff)(r.id,i.id)===0}e.$dp=y;const v=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class k{static create(i){const s=i.manifest?i.manifest.version:i.version,l=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new k(i.identifier,s,l)}static parse(i){const s=v.exec(i);return s&&s[1]&&s[2]?new k({id:s[1]},s[2],s[4]||void 0):null}constructor(i,s,l="undefined"){this.version=s,this.targetPlatform=l,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof k?y(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.$ep=k;const g=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function m(r){const i=g.exec(r);return i&&i[1]?[p(i[1]),i[2]]:[p(r),void 0]}e.$fp=m;function w(r,i){return`${r}.${i}`}e.$gp=w;function p(r){return r.toLowerCase()}e.$hp=p;function u(r,i){return p(w(r??S.$wm,i))}e.$ip=u;function f(r,i){const s=[],l=b=>{for(const R of s)if(R.some(I=>y(i(I),i(b))))return R;return null};for(const b of r){const R=l(b);R?R.push(b):s.push([b])}return s}e.$jp=f;function h(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}e.$kp=h;function $(r){return{id:new c.$1o(r.identifier.id),name:new c.$1o(r.name),galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}e.$lp=$,e.$mp=new S.$Am("pprice.better-merge");function a(r,i){const s=[],l=i.manifest.extensionDependencies?.slice(0)??[];for(;l.length;){const b=l.shift();if(b&&s.every(R=>!y(R.identifier,{id:b}))){const R=r.filter(I=>y(I.identifier,{id:b}));R.length===1&&(s.push(R[0]),l.push(...R[0].manifest.extensionDependencies?.slice(0)??[]))}}return s}e.$np=a;async function t(r,i){if(!M.$k)return!1;let s;try{s=(await r.readFile(C.URI.file("/etc/os-release"))).value.toString()}catch{try{s=(await r.readFile(C.URI.file("/usr/lib/os-release"))).value.toString()}catch(b){i.debug("Error while getting the os-release file.",(0,P.$0)(b))}}return!!s&&(s.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function o(r,i){const s=await t(r,i),l=(0,D.$Ko)(s?"alpine":M.$u,d.$ec);return i.debug("ComputeTargetPlatform:",l),l}e.$op=o}),define(ae[254],ce([0,1,208,54]),function(X,e,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qp=void 0;async function S(M,C,P,d,c,y,v){const k={"X-Market-Client-Id":`VSCode ${M}`,"User-Agent":`VSCode ${M} (${C.nameShort})`};if((0,D.$8o)(C,P)&&(0,D.$0o)(d)===3){const g=await(0,n.$Pp)(P,c,y);k["X-Market-User-Id"]=g,k["VSCode-SessionId"]=v.machineId||g}return k}e.$Qp=S}),define(ae[255],ce([0,1,2,35,4,25,187,18,52,79,27,44,28,54]),function(X,e,n,D,S,M,C,P,d,c,y,v,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Er=void 0;let m=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(u,f,h){this.k=f,this.l=h,this.d={},this.i=new n.$Sc,this.j=[],this.b=u.appenders,this.c=u.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=u.piiPaths||[],this.g=3,this.h=!!u.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const $ of this.f)this.j.push(new RegExp((0,M.$Ye)($),"gi")),$.indexOf("\\")>=0&&this.j.push(new RegExp((0,M.$Ye)($.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration($=>{($.affectsConfiguration(k.$Nl)||$.affectsConfiguration(k.$Pl)||$.affectsConfiguration(k.$Ol))&&this.m()}))}setExperimentProperty(u,f){this.d[u]=f}m(){let u=(0,g.$0o)(this.k);const f=this.l.enabledTelemetryLevels;if(f){this.h=this.sendErrorTelemetry?f.error:!1;const h=f.usage?3:f.error?2:0;u=Math.min(u,h)}this.g=u}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(u,f,h){this.g<f||(h=(0,D.$On)(h,this.d),h=(0,g.$cp)(h,this.j),h=(0,D.$On)(h,this.c),this.b.forEach($=>$.log(u,h)))}publicLog(u,f){this.n(u,3,f)}publicLog2(u,f){this.publicLog(u,f)}publicLogError(u,f){this.h&&this.n(u,2,f)}publicLogError2(u,f){this.publicLogError(u,f)}};e.$Er=m,e.$Er=m=ve([se(1,P.$Mi),se(2,y.$Sj)],m);function w(){const p=(0,C.localize)(0,null,c.default.nameLong),u=c.default.privacyStatementUrl?(0,C.localize)(2,null,"https://aka.ms/vscode-telemetry",c.default.privacyStatementUrl):(0,C.localize)(1,null,"https://aka.ms/vscode-telemetry"),f=S.$o?"":(0,C.localize)(3,null),h=(0,C.localize)(4,null),$=(0,C.localize)(5,null),a=(0,C.localize)(6,null),t=(0,C.localize)(7,null),o=`
|       | ${h} | ${$} | ${a} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,r=(0,C.localize)(8,null);return`
${p} ${u} ${f}

&nbsp;

${t}
${o}

&nbsp;

${r}
`}v.$Xn.as(d.$3n.Configuration).registerConfiguration({id:k.$Ml,order:1,type:"object",title:(0,C.localize)(9,null),properties:{[k.$Nl]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,C.localize)(10,null),(0,C.localize)(11,null),(0,C.localize)(12,null),(0,C.localize)(13,null)],markdownDescription:w(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),v.$Xn.as(d.$3n.Configuration).registerConfiguration({id:k.$Ml,order:110,type:"object",title:(0,C.localize)(14,null),properties:{[k.$Pl]:{type:"boolean",markdownDescription:c.default.privacyStatementUrl?(0,C.localize)(16,null,c.default.nameLong,c.default.privacyStatementUrl):(0,C.localize)(15,null,c.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,C.localize)(17,null,`\`#${k.$Nl}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ae[256],ce([0,1,4,89,28]),function(X,e,n,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eac=e.$Dac=void 0;async function M(P,d){let c=P.getItem(S.$Kl);return(typeof c!="string"||n.$j&&c==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(c=await(0,D.$on)(d.error.bind(d))),c}e.$Dac=M;async function C(P,d){let c=P.getItem(S.$Ll);return typeof c!="string"&&(c=await(0,D.$pn)(d.error.bind(d))),c}e.$Eac=C}),define(ae[257],ce([0,1,28,256]),function(X,e,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gac=e.$Fac=void 0;async function S(C,P){const d=await(0,D.$Dac)(C,P);return C.setItem(n.$Kl,d),d}e.$Fac=S;async function M(C,P){const d=await(0,D.$Eac)(C,P);return C.setItem(n.$Ll,d),d}e.$Gac=M}),define(ae[128],ce([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var n;(function(D){D[D.Replace=1]="Replace",D[D.Append=2]="Append",D[D.Prepend=3]="Prepend"})(n||(e.EnvironmentVariableMutatorType=n={}))}),define(ae[258],ce([0,1,4,128]),function(X,e,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8r=void 0;const S=new Map([[D.EnvironmentVariableMutatorType.Append,"APPEND"],[D.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[D.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class M{constructor(y){this.collections=y,this.a=new Map,this.b=new Map,y.forEach((v,k)=>{this.d(v,k);const g=v.map.entries();let m=g.next();for(;!m.done;){const w=m.value[1],p=m.value[0];let u=this.a.get(p);if(u||(u=[],this.a.set(p,u)),u.length>0&&u[0].type===D.EnvironmentVariableMutatorType.Replace){m=g.next();continue}const f={extensionIdentifier:k,value:w.value,type:w.type,scope:w.scope,variable:w.variable,options:w.options};f.scope||delete f.scope,u.unshift(f),m=g.next()}})}async applyToProcessEnvironment(y,v,k){let g;n.$i&&(g={},Object.keys(y).forEach(m=>g[m.toLowerCase()]=m));for(const[m,w]of this.getVariableMap(v)){const p=n.$i&&g[m.toLowerCase()]||m;for(const u of w){const f=k?await k(u.value):u.value;if(u.options?.applyAtProcessCreation??!0)switch(u.type){case D.EnvironmentVariableMutatorType.Append:y[p]=(y[p]||"")+f;break;case D.EnvironmentVariableMutatorType.Prepend:y[p]=f+(y[p]||"");break;case D.EnvironmentVariableMutatorType.Replace:y[p]=f;break}if(u.options?.applyAtShellIntegration??!1){const h=`VSCODE_ENV_${S.get(u.type)}`;y[h]=(y[h]?y[h]+":":"")+m+"="+this.c(f)}}}}c(y){return y.replaceAll(":","\\x3a")}diff(y,v){const k=new Map,g=new Map,m=new Map;if(y.getVariableMap(v).forEach((w,p)=>{const u=this.getVariableMap(v).get(p),f=P(w,u);f&&k.set(p,f)}),this.getVariableMap(v).forEach((w,p)=>{const u=y.getVariableMap(v).get(p),f=P(w,u);f&&m.set(p,f)}),this.getVariableMap(v).forEach((w,p)=>{const u=y.getVariableMap(v).get(p),f=d(w,u);f&&g.set(p,f)}),!(k.size===0&&g.size===0&&m.size===0))return{added:k,changed:g,removed:m}}getVariableMap(y){const v=new Map;for(const k of this.a.values()){const g=k.filter(m=>C(m,y));g.length>0&&v.set(g[0].variable,g)}return v}getDescriptionMap(y){const v=new Map;for(const k of this.b.values()){const g=k.filter(m=>C(m,y,!0));for(const m of g)v.set(m.extensionIdentifier,m.description)}return v}d(y,v){if(!y.descriptionMap)return;const k=y.descriptionMap.entries();let g=k.next();for(;!g.done;){const m=g.value[1],w=g.value[0];let p=this.b.get(w);p||(p=[],this.b.set(w,p));const u={extensionIdentifier:v,scope:m.scope,description:m.description};u.scope||delete u.scope,p.push(u),g=k.next()}}}e.$8r=M;function C(c,y,v=!1){return c.scope?!!(c.scope.workspaceFolder&&y?.workspaceFolder&&c.scope.workspaceFolder.index===y.workspaceFolder.index):v?y===c.scope:!0}function P(c,y){if(!y)return c;const v=new Set;y.forEach(g=>v.add(g.extensionIdentifier));const k=[];return c.forEach(g=>{v.has(g.extensionIdentifier)||k.push(g)}),k.length===0?void 0:k}function d(c,y){if(!y)return;const v=new Map;y.forEach(g=>v.set(g.extensionIdentifier,g));const k=[];return c.forEach(g=>{const m=v.get(g.extensionIdentifier);m&&(g.type!==m.type||g.value!==m.value||g.scope?.workspaceFolder?.index!==m.scope?.workspaceFolder?.index)&&k.push(m)}),k.length===0?void 0:k}}),define(ae[259],ce([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7r=e.$6r=e.$5r=e.$4r=e.$3r=e.$2r=void 0;function n(d){return[...d.entries()]}e.$2r=n;function D(d){return d?[...d.entries()]:[]}e.$3r=D;function S(d){return new Map(d)}e.$4r=S;function M(d){return new Map(d??[])}e.$5r=M;function C(d){return Array.from(d.entries()).map(c=>[c[0],n(c[1].map),D(c[1].descriptionMap)])}e.$6r=C;function P(d){return new Map(d.map(c=>[c[0],{map:S(c[1]),descriptionMap:M(c[2])}]))}e.$7r=P}),define(ae[260],ce([0,1,8,23,3,2,5]),function(X,e,n,D,S,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sr=void 0;let P=class extends M.$Tc{constructor(c,y){super(),this.h=y,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new S.$6d),this.onCreateRequest=this.g.event,this.b=c===void 0?15e3:c,this.B((0,M.$Rc)(()=>{for(const v of this.f.values())(0,M.$Oc)(v)}))}createRequest(c){return new Promise((y,v)=>{const k=++this.a;this.c.set(k,y),this.g.fire({requestId:k,...c});const g=new D.$de;(0,n.$hh)(this.b,g.token).then(()=>v(`Request ${k} timed out (${this.b}ms)`)),this.f.set(k,[(0,M.$Rc)(()=>g.cancel())])})}acceptReply(c,y){const v=this.c.get(c);v?(this.c.delete(c),(0,M.$Oc)(this.f.get(c)||[]),this.f.delete(c),v(y)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${c}`)}};e.$Sr=P,e.$Sr=P=ve([se(1,C.$Aj)],P)}),define(ae[129],ce([0,1,6,118,44]),function(X,e,n,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Or=e.$Nr=e.$Mr=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$Lr=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$Kr=void 0,e.$Kr=new D.$xj("terminalTabFocusMode",!1,!0);var M;(function(a){a.AutomationProfile="terminal.integrated.automationProfile.",a.DefaultProfile="terminal.integrated.defaultProfile.",a.Profiles="terminal.integrated.profiles."})(M||(e.TerminalSettingPrefix=M={}));var C;(function(a){a.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",a.AutomationProfileLinux="terminal.integrated.automationProfile.linux",a.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",a.AutomationProfileWindows="terminal.integrated.automationProfile.windows",a.ProfilesWindows="terminal.integrated.profiles.windows",a.ProfilesMacOs="terminal.integrated.profiles.osx",a.ProfilesLinux="terminal.integrated.profiles.linux",a.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",a.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",a.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",a.UseWslProfiles="terminal.integrated.useWslProfiles",a.TabsDefaultColor="terminal.integrated.tabs.defaultColor",a.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",a.TabsEnabled="terminal.integrated.tabs.enabled",a.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",a.TabsHideCondition="terminal.integrated.tabs.hideCondition",a.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",a.TabsShowActions="terminal.integrated.tabs.showActions",a.TabsLocation="terminal.integrated.tabs.location",a.TabsFocusMode="terminal.integrated.tabs.focusMode",a.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",a.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",a.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",a.CopyOnSelection="terminal.integrated.copyOnSelection",a.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",a.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",a.FontFamily="terminal.integrated.fontFamily",a.FontSize="terminal.integrated.fontSize",a.LetterSpacing="terminal.integrated.letterSpacing",a.LineHeight="terminal.integrated.lineHeight",a.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",a.TabStopWidth="terminal.integrated.tabStopWidth",a.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",a.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",a.BellDuration="terminal.integrated.bellDuration",a.FontWeight="terminal.integrated.fontWeight",a.FontWeightBold="terminal.integrated.fontWeightBold",a.CursorBlinking="terminal.integrated.cursorBlinking",a.CursorStyle="terminal.integrated.cursorStyle",a.CursorStyleInactive="terminal.integrated.cursorStyleInactive",a.CursorWidth="terminal.integrated.cursorWidth",a.Scrollback="terminal.integrated.scrollback",a.DetectLocale="terminal.integrated.detectLocale",a.DefaultLocation="terminal.integrated.defaultLocation",a.GpuAcceleration="terminal.integrated.gpuAcceleration",a.TerminalTitleSeparator="terminal.integrated.tabs.separator",a.TerminalTitle="terminal.integrated.tabs.title",a.TerminalDescription="terminal.integrated.tabs.description",a.RightClickBehavior="terminal.integrated.rightClickBehavior",a.Cwd="terminal.integrated.cwd",a.ConfirmOnExit="terminal.integrated.confirmOnExit",a.ConfirmOnKill="terminal.integrated.confirmOnKill",a.EnableBell="terminal.integrated.enableBell",a.EnableVisualBell="terminal.integrated.enableVisualBell",a.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",a.AllowChords="terminal.integrated.allowChords",a.AllowMnemonics="terminal.integrated.allowMnemonics",a.TabFocusMode="terminal.integrated.tabFocusMode",a.EnvMacOs="terminal.integrated.env.osx",a.EnvLinux="terminal.integrated.env.linux",a.EnvWindows="terminal.integrated.env.windows",a.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",a.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",a.ShowExitAlert="terminal.integrated.showExitAlert",a.SplitCwd="terminal.integrated.splitCwd",a.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",a.WordSeparators="terminal.integrated.wordSeparators",a.EnableFileLinks="terminal.integrated.enableFileLinks",a.UnicodeVersion="terminal.integrated.unicodeVersion",a.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",a.LocalEchoEnabled="terminal.integrated.localEchoEnabled",a.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",a.LocalEchoStyle="terminal.integrated.localEchoStyle",a.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",a.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",a.HideOnStartup="terminal.integrated.hideOnStartup",a.CustomGlyphs="terminal.integrated.customGlyphs",a.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",a.InheritEnv="terminal.integrated.inheritEnv",a.ShowLinkHover="terminal.integrated.showLinkHover",a.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",a.AutoReplies="terminal.integrated.autoReplies",a.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",a.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",a.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",a.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",a.ShellIntegrationSuggestEnabled="terminal.integrated.shellIntegration.suggestEnabled",a.EnableImages="terminal.integrated.enableImages",a.SmoothScrolling="terminal.integrated.smoothScrolling",a.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",a.FocusAfterRun="terminal.integrated.focusAfterRun",a.AccessibleViewPreserveCursorPosition="terminal.integrated.accessibleViewPreserveCursorPosition",a.AccessibleViewFocusOnCommandExecution="terminal.integrated.accessibleViewFocusOnCommandExecution",a.StickyScrollEnabled="terminal.integrated.stickyScroll.enabled",a.StickyScrollMaxLineCount="terminal.integrated.stickyScroll.maxLineCount",a.MouseWheelZoom="terminal.integrated.mouseWheelZoom",a.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",a.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",a.DevMode="terminal.integrated.developer.devMode"})(C||(e.TerminalSettingId=C={}));var P;(function(a){a.PowerShell="pwsh",a.Bash="bash",a.Fish="fish",a.Sh="sh",a.Csh="csh",a.Ksh="ksh",a.Zsh="zsh",a.Python="python"})(P||(e.PosixShellType=P={}));var d;(function(a){a.CommandPrompt="cmd",a.PowerShell="pwsh",a.Wsl="wsl",a.GitBash="gitbash",a.Python="python"})(d||(e.WindowsShellType=d={}));var c;(function(a){a[a.Api=0]="Api",a[a.Process=1]="Process",a[a.Sequence=2]="Sequence",a[a.Config=3]="Config"})(c||(e.TitleEventSource=c={}));var y;(function(a){a.LocalPty="localPty",a.PtyHost="ptyHost",a.PtyHostWindow="ptyHostWindow",a.Logger="logger",a.Heartbeat="heartbeat"})(y||(e.TerminalIpcChannels=y={}));var v;(function(a){a.Cwd="cwd",a.InitialCwd="initialCwd",a.FixedDimensions="fixedDimensions",a.Title="title",a.ShellType="shellType",a.HasChildProcesses="hasChildProcesses",a.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",a.OverrideDimensions="overrideDimensions",a.FailedShellIntegrationActivation="failedShellIntegrationActivation",a.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(v||(e.ProcessPropertyType=v={})),e.$Lr=(0,n.$gi)("ptyService");var k;(function(a){a[a.BeatInterval=5e3]="BeatInterval",a[a.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",a[a.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",a[a.SecondWaitMultiplier=1]="SecondWaitMultiplier",a[a.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(k||(e.HeartbeatConstants=k={}));var g;(function(a){a[a.Panel=1]="Panel",a[a.Editor=2]="Editor"})(g||(e.TerminalLocation=g={}));var m;(function(a){a.TerminalView="view",a.Editor="editor"})(m||(e.TerminalLocationString=m={}));var w;(function(a){a[a.GraceTime=6e4]="GraceTime",a[a.ShortGraceTime=6e3]="ShortGraceTime"})(w||(e.LocalReconnectConstants=w={}));var p;(function(a){a[a.HighWatermarkChars=1e5]="HighWatermarkChars",a[a.LowWatermarkChars=5e3]="LowWatermarkChars",a[a.CharCountAckSize=5e3]="CharCountAckSize"})(p||(e.FlowControlConstants=p={}));var u;(function(a){a.GitBash="Git Bash",a.Pwsh="PowerShell"})(u||(e.ProfileSource=u={}));var f;(function(a){a[a.Off=0]="Off",a[a.FinalTerm=1]="FinalTerm",a[a.VSCode=2]="VSCode"})(f||(e.ShellIntegrationStatus=f={}));var h;(function(a){a[a.Unknown=0]="Unknown",a[a.Shutdown=1]="Shutdown",a[a.Process=2]="Process",a[a.User=3]="User",a[a.Extension=4]="Extension"})(h||(e.TerminalExitReason=h={})),e.$Mr={Backend:"workbench.contributions.terminal.processBackend"};class ${constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(t){const o=this.b(t.remoteAuthority);if(this.a.has(o))throw new Error(`A terminal backend with remote authority '${o}' was already registered.`);this.a.set(o,t)}getTerminalBackend(t){return this.a.get(this.b(t))}b(t){return t?.toLowerCase()??""}}S.$Xn.add(e.$Mr.Backend,new $),e.$Nr=(0,n.$gi)("localPtyService"),e.$Or=(0,n.$gi)("terminalLogService")}),define(ae[261],ce([0,1,74,7,189,106]),function(X,e,n,D,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wr=e.$Vr=e.$Ur=e.$Tr=void 0;function C(k,g){const m=[{name:null,description:(0,S.localize)(0,null)}];return m.push(...k.map(w=>({name:w.profileName,description:P(w)}))),g&&m.push(...g.map(w=>({name:w.title,description:d(w)}))),{values:m.map(w=>w.name),markdownDescriptions:m.map(w=>w.description)}}e.$Tr=C;function P(k){let g=`$(${M.ThemeIcon.isThemeIcon(k.icon)?k.icon.id:k.icon?k.icon:n.$pk.terminal.id}) ${k.profileName}
- path: ${k.path}`;return k.args&&(typeof k.args=="string"?g+=`
- args: "${k.args}"`:g+=`
- args: [${k.args.length===0?"":`'${k.args.join("','")}'`}]`),k.overrideName!==void 0&&(g+=`
- overrideName: ${k.overrideName}`),k.color&&(g+=`
- color: ${k.color}`),k.env&&(g+=`
- env: ${JSON.stringify(k.env)}`),g}function d(k){return`$(${M.ThemeIcon.isThemeIcon(k.icon)?k.icon.id:k.icon?k.icon:n.$pk.terminal.id}) ${k.title}
- extensionIdentifier: ${k.extensionIdentifier}`}function c(k,g){if(!k&&!g)return!0;if(typeof k=="string"&&typeof g=="string")return k===g;if(Array.isArray(k)&&Array.isArray(g)){if(k.length!==g.length)return!1;for(let m=0;m<k.length;m++)if(k[m]!==g[m])return!1;return!0}return!1}e.$Ur=c;function y(k,g){if(!k&&!g)return!0;if(!k||!g)return!1;if(M.ThemeIcon.isThemeIcon(k)&&M.ThemeIcon.isThemeIcon(g))return k.id===g.id&&k.color===g.color;if(typeof k=="object"&&"light"in k&&"dark"in k&&typeof g=="object"&&"light"in g&&"dark"in g){const m=k,w=g;if((D.URI.isUri(m.light)||v(m.light))&&(D.URI.isUri(m.dark)||v(m.dark))&&(D.URI.isUri(w.light)||v(w.light))&&(D.URI.isUri(w.dark)||v(w.dark)))return m.light.path===w.light.path&&m.dark.path===w.dark.path}if(D.URI.isUri(k)&&D.URI.isUri(g)||v(k)||v(g)){const m=k,w=g;return m.path===w.path&&m.scheme===w.scheme}return!1}e.$Vr=y;function v(k){return k?typeof k.path=="string"&&typeof k.scheme=="string":!1}e.$Wr=v}),define(ae[262],ce([0,1,74,4,188,52,44,261]),function(X,e,n,D,S,M,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1r=e.$Zr=e.$Yr=e.$Xr=void 0,e.$Xr={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.$Yr={type:"string",enum:Array.from((0,n.$nk)(),p=>p.id),markdownEnumDescriptions:Array.from((0,n.$nk)(),p=>`$(${p.id})`)};const d={args:{description:(0,S.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,S.localize)(1,null),type:"boolean"},icon:{description:(0,S.localize)(2,null),...e.$Yr},color:{description:(0,S.localize)(3,null),...e.$Xr},env:{markdownDescription:(0,S.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},c={type:"object",required:["path"],properties:{path:{description:(0,S.localize)(5,null),type:["string","array"],items:{type:"string"}},...d}},y={type:"object",required:["path"],properties:{path:{description:(0,S.localize)(6,null),type:["string"],items:{type:"string"}},...d}};function v(p){const u=p===2?"linux":p===1?"osx":"windows";return(0,S.localize)(7,null,(0,D.$h)(p),'```json\n"terminal.integrated.profile.'+u+'": {\n  "bash": null\n}\n```',"[","](https://code.visualstudio.com/docs/terminal/profiles)")}const k={id:"terminal",order:100,title:(0,S.localize)(8,null),type:"object",properties:{"terminal.integrated.automationProfile.linux":{restricted:!0,markdownDescription:(0,S.localize)(9,null),type:["object","null"],default:null,anyOf:[{type:"null"},y],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},"terminal.integrated.automationProfile.osx":{restricted:!0,markdownDescription:(0,S.localize)(10,null),type:["object","null"],default:null,anyOf:[{type:"null"},y],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},"terminal.integrated.automationProfile.windows":{restricted:!0,markdownDescription:(0,S.localize)(11,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},y],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},"terminal.integrated.profiles.windows":{restricted:!0,markdownDescription:v(3),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,S.localize)(12,null),enum:["PowerShell","Git Bash"]},...d}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,S.localize)(13,null),type:"string"},id:{description:(0,S.localize)(14,null),type:"string"},title:{description:(0,S.localize)(15,null),type:"string"},...d}},{type:"null"},c]}},"terminal.integrated.profiles.osx":{restricted:!0,markdownDescription:v(1),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,S.localize)(16,null),type:"string"},id:{description:(0,S.localize)(17,null),type:"string"},title:{description:(0,S.localize)(18,null),type:"string"},...d}},{type:"null"},c]}},"terminal.integrated.profiles.linux":{restricted:!0,markdownDescription:v(2),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,S.localize)(19,null),type:"string"},id:{description:(0,S.localize)(20,null),type:"string"},title:{description:(0,S.localize)(21,null),type:"string"},...d}},{type:"null"},c]}},"terminal.integrated.useWslProfiles":{description:(0,S.localize)(22,null),type:"boolean",default:!0},"terminal.integrated.inheritEnv":{scope:1,description:(0,S.localize)(23,null),type:"boolean",default:!0},"terminal.integrated.persistentSessionScrollback":{scope:1,markdownDescription:(0,S.localize)(24,null),type:"number",default:100},"terminal.integrated.showLinkHover":{scope:1,description:(0,S.localize)(25,null),type:"boolean",default:!0},"terminal.integrated.ignoreProcessNames":{markdownDescription:(0,S.localize)(26,null,"`#terminal.integrated.confirmOnKill#`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function g(){C.$Xn.as(M.$3n.Configuration).registerConfiguration(k),w()}e.$Zr=g;let m;function w(p,u){const f=C.$Xn.as(M.$3n.Configuration);let h;p&&(h=(0,P.$Tr)(p?.profiles,u));const $=m;m={id:"terminal",order:100,title:(0,S.localize)(27,null),type:"object",properties:{"terminal.integrated.defaultProfile.linux":{restricted:!0,markdownDescription:(0,S.localize)(28,null),type:["string","null"],default:null,enum:p?.os===3?h?.values:void 0,markdownEnumDescriptions:p?.os===3?h?.markdownDescriptions:void 0},"terminal.integrated.defaultProfile.osx":{restricted:!0,markdownDescription:(0,S.localize)(29,null),type:["string","null"],default:null,enum:p?.os===2?h?.values:void 0,markdownEnumDescriptions:p?.os===2?h?.markdownDescriptions:void 0},"terminal.integrated.defaultProfile.windows":{restricted:!0,markdownDescription:(0,S.localize)(30,null),type:["string","null"],default:null,enum:p?.os===1?h?.values:void 0,markdownEnumDescriptions:p?.os===1?h?.markdownDescriptions:void 0}}},f.updateConfigurations({add:[m],remove:$?[$]:[]})}e.$1r=w}),define(ae[263],ce([0,1,26,13,35,9,4,36,25,12,21,128,259,258]),function(X,e,n,D,S,M,C,P,d,c,y,v,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$r=e.$0r=e.$9r=void 0;function m(){const i=/(\d+)\.(\d+)\.(\d+)/g.exec(n.release());let s=0;return i&&i.length===4&&(s=parseInt(i[3])),s}e.$9r=m;async function w(i,s,l,b=P.env,R=y.Promises.exists){if(M.$ic(i))return await R(i)?i:void 0;if(s===void 0&&(s=P.cwd()),M.$mc(i)!=="."){const j=M.$jc(s,i);return await R(j)?j:void 0}const E=(0,S.$Sn)(b,"PATH");if(l===void 0&&(0,c.$Tf)(E)&&(l=E.split(M.$tc)),l===void 0||l.length===0){const j=M.$jc(s,i);return await R(j)?j:void 0}for(const j of l){let T;if(M.$ic(j)?T=M.$jc(j,i):T=M.$jc(s,j,i),await R(T))return T;if(C.$i){let W=T+".com";if(await R(W)||(W=T+".exe",await R(W)))return W}}const A=M.$jc(s,i);return await R(A)?A:void 0}e.$0r=w;function p(i,s,l,b,R){const I=C.$i&&(!s.windowsEnableConpty||m()<18309);if(!s.shellIntegration.enabled||!i.executable||i.isFeatureTerminal&&!i.forceShellIntegration||i.hideFromUser||i.ignoreShellIntegration||I)return;const E=i.args,A=P.$dc==="win32"?M.$nc(i.executable).toLowerCase():M.$nc(i.executable),j=M.$mc(D.$Ag.asFileUri("").fsPath);let T;const W={VSCODE_INJECTION:"1"};if(s.shellIntegration.nonce&&(W.VSCODE_NONCE=s.shellIntegration.nonce),C.$i){if(A==="pwsh.exe"||A==="powershell.exe")return!E||o(E)?T=h.get(f.WindowsPwsh):t(E)&&(T=h.get(f.WindowsPwshLogin)),T?(T=[...T],T[T.length-1]=(0,d.$Ue)(T[T.length-1],j,""),s.shellIntegration.suggestEnabled&&(W.VSCODE_SUGGEST="1"),{newArgs:T,envMixin:W}):void 0;b.warn(`Shell integration cannot be enabled for executable "${i.executable}" and args`,i.args);return}switch(A){case"bash":return!E||E.length===0?T=h.get(f.Bash):r(E)&&(W.VSCODE_SHELL_LOGIN="1",u(s,W),T=h.get(f.Bash)),T?(T=[...T],T[T.length-1]=(0,d.$Ue)(T[T.length-1],j),{newArgs:T,envMixin:W}):void 0;case"fish":{const V=l?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",K=M.$jc(j,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return W.XDG_DATA_DIRS=`${V}:${K}`,u(s,W),{newArgs:void 0,envMixin:W}}case"pwsh":return!E||o(E)?T=h.get(f.Pwsh):t(E)&&(T=h.get(f.PwshLogin)),T?(s.shellIntegration.suggestEnabled&&(W.VSCODE_SUGGEST="1"),T=[...T],T[T.length-1]=(0,d.$Ue)(T[T.length-1],j,""),{newArgs:T,envMixin:W}):void 0;case"zsh":{if(!E||E.length===0?T=h.get(f.Zsh):r(E)?(T=h.get(f.ZshLogin),u(s,W)):(E===h.get(f.Zsh)||E===h.get(f.ZshLogin))&&(T=E),!T)return;T=[...T],T[T.length-1]=(0,d.$Ue)(T[T.length-1],j);let V;try{V=n.userInfo().username}catch{V="unknown"}const K=M.$jc(n.tmpdir(),`${V}-${R.applicationName}-zsh`);W.ZDOTDIR=K;const le=l?.ZDOTDIR??n.homedir()??"~";W.USER_ZDOTDIR=le;const re=[];return re.push({source:M.$jc(j,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:M.$jc(K,".zshrc")}),re.push({source:M.$jc(j,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:M.$jc(K,".zprofile")}),re.push({source:M.$jc(j,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:M.$jc(K,".zshenv")}),re.push({source:M.$jc(j,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:M.$jc(K,".zlogin")}),{newArgs:T,envMixin:W,filesToCopy:re}}}b.warn(`Shell integration cannot be enabled for executable "${i.executable}" and args`,i.args)}e.$$r=p;function u(i,s){if(C.$j&&i.environmentVariableCollections){const l=(0,k.$7r)(i.environmentVariableCollections),R=new g.$8r(l).getVariableMap({workspaceFolder:i.workspaceFolder}).get("PATH"),I=[];if(R)for(const E of R)E.type===v.EnvironmentVariableMutatorType.Prepend&&I.push(E.value);I.length>0&&(s.VSCODE_PATH_PREFIX=I.join(""))}}var f;(function(i){i.WindowsPwsh="windows-pwsh",i.WindowsPwshLogin="windows-pwsh-login",i.Pwsh="pwsh",i.PwshLogin="pwsh-login",i.Zsh="zsh",i.ZshLogin="zsh-login",i.Bash="bash"})(f||(f={}));const h=new Map;h.set(f.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),h.set(f.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),h.set(f.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),h.set(f.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),h.set(f.Zsh,["-i"]),h.set(f.ZshLogin,["-il"]),h.set(f.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const $=["-login","-l"],a=["-nol","-nologo"];function t(i){return typeof i=="string"?$.includes(i.toLowerCase()):i.length===1&&$.includes(i[0].toLowerCase())||i.length===2&&($.includes(i[0].toLowerCase())||$.includes(i[1].toLowerCase()))&&(a.includes(i[0].toLowerCase())||a.includes(i[1].toLowerCase()))}function o(i){return typeof i=="string"?a.includes(i.toLowerCase()):i.length===0||i?.length===1&&a.includes(i[0].toLowerCase())}function r(i){return i==="string"&&$.includes(i.toLowerCase())||typeof i!="string"&&i.length===1&&$.includes(i[0].toLowerCase())}}),define(ae[264],ce([0,1,48,74,9,4,12,21,110,263,117]),function(X,e,n,D,S,M,C,P,d,c,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_r=void 0;var v;(function(l){l.UnixShellsPath="/etc/shells"})(v||(v={}));let k,g=!0;function m(l,b,R,I,E=process.env,A,j,T,W){return A=A||{existsFile:P.SymlinkSupport.existsFile,readFile:P.Promises.readFile},M.$i?w(R,A,E,j,I.getValue("terminal.integrated.useWslProfiles")!==!1,l&&typeof l=="object"?{...l}:I.getValue("terminal.integrated.profiles.windows"),typeof b=="string"?b:I.getValue("terminal.integrated.defaultProfile.windows"),W,T):r(A,j,R,l&&typeof l=="object"?{...l}:I.getValue(M.$k?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof b=="string"?b:I.getValue(M.$k?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),W,T,E)}e.$_r=m;async function w(l,b,R,I,E,A,j,T,W){const V=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),K=`${process.env.windir}\\${V?"Sysnative":"System32"}`;let le=!1;(0,c.$9r)()>=16299&&(le=!0),await h(T);const re=new Map;if(l){re.set("PowerShell",{source:"PowerShell",icon:D.$pk.terminalPowershell,isAutoDetected:!0}),re.set("Windows PowerShell",{path:`${K}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:D.$pk.terminalPowershell,isAutoDetected:!0}),re.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),re.set("Command Prompt",{path:`${K}\\cmd.exe`,icon:D.$pk.terminalCmd,isAutoDetected:!0}),re.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),re.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],env:{CHERE_INVOKING:"1"},icon:D.$pk.terminalBash,isAutoDetected:!0});const Z=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;re.set("Cmder",{path:`${K}\\cmd.exe`,args:["/K",Z],requiresPath:process.env.CMDER_ROOT?Z:{path:Z,isUnsafe:!0},isAutoDetected:!0})}i(A,re);const ue=await p(re.entries(),j,b,R,I,W);if(l&&E)try{const Z=await t(`${K}\\${le?"wsl":"bash"}.exe`,j);for(const Y of Z)(!A||!(Y.profileName in A))&&ue.push(Y)}catch{g&&(I?.trace("WSL is not installed, so could not detect WSL profiles"),g=!1)}return ue}async function p(l,b,R,I=process.env,E,A){const j=[];for(const[T,W]of l)j.push(u(T,W,b,R,I,E,A));return(await Promise.all(j)).filter(T=>!!T)}async function u(l,b,R,I,E=process.env,A,j){if(b===null)return;let T,W,V;if("source"in b&&!("path"in b)){const ue=k?.get(b.source);if(!ue)return;T=ue.paths,W=b.args||ue.args,b.icon?V=f(b.icon):ue.icon&&(V=ue.icon)}else T=Array.isArray(b.path)?b.path:[b.path],W=M.$i||Array.isArray(b.args)?b.args:void 0,V=f(b.icon);let K;if(j){const ue=T.map(Y=>typeof Y=="string"?Y:Y.path),Z=await j(ue);K=new Array(T.length);for(let Y=0;Y<T.length;Y++)typeof T[Y]=="string"?K[Y]=Z[Y]:K[Y]={path:Z[Y],isUnsafe:!0}}else K=T.slice();let le;if(b.requiresPath){let ue;if((0,C.$Tf)(b.requiresPath)?ue=b.requiresPath:(ue=b.requiresPath.path,b.requiresPath.isUnsafe&&(le=ue)),!await I.existsFile(ue))return}const re=await s(l,R,K,I,E,W,b.env,b.overrideName,b.isAutoDetected,le);if(!re){A?.debug("Terminal profile not validated",l,T);return}return re.isAutoDetected=b.isAutoDetected,re.icon=V,re.color=b.color,re}function f(l){return typeof l=="string"?{id:l}:l}async function h(l){if(k&&!l)return;const[b,R]=await Promise.all([$(),l||a()]);k=new Map,k.set("Git Bash",{profileName:"Git Bash",paths:b,args:["--login","-i"]}),k.set("PowerShell",{profileName:"PowerShell",paths:R,icon:D.$pk.terminalPowershell})}async function $(){const l=new Set,b=await(0,c.$0r)("git.exe");if(b){const E=(0,y.dirname)(b);l.add((0,y.resolve)(E,"../.."))}function R(E,A){A&&E.add(A)}R(l,process.env.ProgramW6432),R(l,process.env.ProgramFiles),R(l,process.env["ProgramFiles(X86)"]),R(l,`${process.env.LocalAppData}\\Program`);const I=[];for(const E of l)I.push(`${E}\\Git\\bin\\bash.exe`,`${E}\\Git\\usr\\bin\\bash.exe`,`${E}\\usr\\bin\\bash.exe`);return I.push(`${process.env.UserProfile}\\scoop\\apps\\git\\current\\bin\\bash.exe`),I.push(`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`),I}async function a(){const l=[];for await(const b of(0,d.$1l)())l.push(b.exePath);return l}async function t(l,b){const R=[],I=await new Promise((j,T)=>{n.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(W,V)=>{if(W)return T("Problem occurred when getting wsl distros");j(V)})});if(!I)return[];const E=new RegExp(/[\r?\n]/),A=I.split(E).filter(j=>j.trim().length>0&&j!=="");for(const j of A){if(j===""||j.startsWith("docker-desktop"))continue;const T=`${j} (WSL)`,W={profileName:T,path:l,args:["-d",`${j}`],isDefault:T===b,icon:o(j),isAutoDetected:!1};R.push(W)}return R}function o(l){return l.includes("Ubuntu")?D.$pk.terminalUbuntu:l.includes("Debian")?D.$pk.terminalDebian:D.$pk.terminalLinux}async function r(l,b,R,I,E,A,j,T){const W=new Map;if(R&&await l.existsFile("/etc/shells")){const V=(await l.readFile("/etc/shells")).toString(),K=(A||V.split(`
`)).map(re=>{const ue=re.indexOf("#");return ue===-1?re:re.substring(0,ue)}).filter(re=>re.trim().length>0),le=new Map;for(const re of K){let ue=(0,S.$nc)(re),Z=le.get(ue)||0;Z++,Z>1&&(ue=`${ue} (${Z})`),le.set(ue,Z),W.set(ue,{path:re,isAutoDetected:!0})}}return i(I,W),await p(W.entries(),E,l,T,b,j)}function i(l,b){if(l)for(const[R,I]of Object.entries(l))I===null||typeof I!="object"||!("path"in I)&&!("source"in I)?b.delete(R):(I.icon=I.icon||b.get(R)?.icon,b.set(R,I))}async function s(l,b,R,I,E,A,j,T,W,V){if(R.length===0)return Promise.resolve(void 0);const K=R.shift();if(K==="")return s(l,b,R,I,E,A,j,T,W);const le=typeof K!="string"&&K.isUnsafe,re=typeof K=="string"?K:K.path,ue={profileName:l,path:re,args:A,env:j,overrideName:T,isAutoDetected:W,isDefault:l===b,isUnsafePath:le,requiresUnsafePath:V};if((0,S.$nc)(re)===re){const Y=E.PATH?E.PATH.split(S.$tc):void 0,U=await(0,c.$0r)(re,void 0,Y,void 0,I.existsFile);return U?(ue.path=U,ue.isFromPath=!0,ue):s(l,b,R,I,E,A)}return await I.existsFile((0,S.$hc)(re))?ue:s(l,b,R,I,E,A,j,T,W)}}),define(ae[265],ce([0,1,3,2,4,43,18,5,228,95,260,129,262,264,112,72]),function(X,e,n,D,S,M,C,P,d,c,y,v,k,g,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$as=void 0;var p;(function(f){f[f.MaxRestarts=5]="MaxRestarts"})(p||(p={}));let u=class extends D.$Tc{get c(){return this.h(),this.a}get f(){return this.h(),this.b}get g(){return this.b}h(){this.a||this.U()}constructor(h,$,a,t){super(),this.M=h,this.N=$,this.O=a,this.P=t,this.m=!1,this.n=0,this.r=!0,this.u=this.B(new n.$6d),this.onPtyHostExit=this.u.event,this.w=this.B(new n.$6d),this.onPtyHostStart=this.w.event,this.y=this.B(new n.$6d),this.onPtyHostUnresponsive=this.y.event,this.z=this.B(new n.$6d),this.onPtyHostResponsive=this.z.event,this.C=this.B(new n.$6d),this.onPtyHostRequestResolveVariables=this.C.event,this.D=this.B(new n.$6d),this.onProcessData=this.D.event,this.F=this.B(new n.$6d),this.onProcessReady=this.F.event,this.G=this.B(new n.$6d),this.onProcessReplay=this.G.event,this.H=this.B(new n.$6d),this.onProcessOrphanQuestion=this.H.event,this.I=this.B(new n.$6d),this.onDidRequestDetach=this.I.event,this.J=this.B(new n.$6d),this.onDidChangeProperty=this.J.event,this.L=this.B(new n.$6d),this.onProcessExit=this.L.event,(0,k.$Zr)(),this.B(this.M),this.B((0,D.$Rc)(()=>this.W())),this.j=this.B(new y.$Sr(void 0,this.O)),this.j.onCreateRequest(this.C.fire,this.C),this.M.onRequestConnection&&n.Event.once(this.M.onRequestConnection)(()=>this.h()),this.M.onWillShutdown?.(()=>this.m=!0)}get Q(){return this.N.getValue("terminal.integrated.ignoreProcessNames")}async R(){return this.g?.refreshIgnoreProcessNames?.(this.Q)}async S(){if(S.$i)return process.env;try{return await(0,c.$km)(this.N,this.O,{_:[]},process.env)}catch(h){return this.O.error("ptyHost was unable to resolve shell environment",h),{}}}U(){const h=this.M.start(),$=h.client;this.O.getLevel()===P.LogLevel.Trace&&this.O.trace("PtyHostService#_startPtyHost",new Error().stack?.replace(/^Error/,"")),M.ProxyChannel.toService($.getChannel(v.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.X()),this.X(!0),this.B(h.onDidProcessExit(o=>{this.u.fire(o.code),!this.m&&!this.q.isDisposed&&(this.n<=p.MaxRestarts?(this.O.error(`ptyHost terminated unexpectedly with code ${o.code}`),this.n++,this.restartPtyHost()):this.O.error(`ptyHost terminated unexpectedly with code ${o.code}, giving up`))}));const t=M.ProxyChannel.toService($.getChannel(v.TerminalIpcChannels.PtyHost));return this.B(t.onProcessData(o=>this.D.fire(o))),this.B(t.onProcessReady(o=>this.F.fire(o))),this.B(t.onProcessExit(o=>this.L.fire(o))),this.B(t.onDidChangeProperty(o=>this.J.fire(o))),this.B(t.onProcessReplay(o=>this.G.fire(o))),this.B(t.onProcessOrphanQuestion(o=>this.H.fire(o))),this.B(t.onDidRequestDetach(o=>this.I.fire(o))),this.B(new d.$Rr(this.P,$.getChannel(v.TerminalIpcChannels.Logger))),this.a=h,this.b=t,this.w.fire(),this.B(this.N.onDidChangeConfiguration(async o=>{o.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this.R()})),this.R(),[h,t]}async createProcess(h,$,a,t,o,r,i,s,l,b,R){const I=setTimeout(()=>this.$(),v.HeartbeatConstants.CreateProcessTimeout),E=await this.f.createProcess(h,$,a,t,o,r,i,s,l,b,R);return clearTimeout(I),E}updateTitle(h,$,a){return this.f.updateTitle(h,$,a)}updateIcon(h,$,a,t){return this.f.updateIcon(h,$,a,t)}attachToProcess(h){return this.f.attachToProcess(h)}detachFromProcess(h,$){return this.f.detachFromProcess(h,$)}shutdownAll(){return this.f.shutdownAll()}listProcesses(){return this.f.listProcesses()}async getPerformanceMarks(){return this.g?.getPerformanceMarks()??[]}async reduceConnectionGraceTime(){return this.g?.reduceConnectionGraceTime()}start(h){return this.f.start(h)}shutdown(h,$){return this.f.shutdown(h,$)}input(h,$){return this.f.input(h,$)}processBinary(h,$){return this.f.processBinary(h,$)}resize(h,$,a){return this.f.resize(h,$,a)}clearBuffer(h){return this.f.clearBuffer(h)}acknowledgeDataEvent(h,$){return this.f.acknowledgeDataEvent(h,$)}setUnicodeVersion(h,$){return this.f.setUnicodeVersion(h,$)}getInitialCwd(h){return this.f.getInitialCwd(h)}getCwd(h){return this.f.getCwd(h)}async getLatency(){const h=new w.$2d,$=await this.f.getLatency();return h.stop(),[{label:"ptyhostservice<->ptyhost",latency:h.elapsed()},...$]}orphanQuestionReply(h){return this.f.orphanQuestionReply(h)}installAutoReply(h,$){return this.f.installAutoReply(h,$)}uninstallAllAutoReplies(){return this.f.uninstallAllAutoReplies()}uninstallAutoReply(h){return this.f.uninstallAutoReply(h)}getDefaultSystemShell(h){return this.g?.getDefaultSystemShell(h)??(0,m.$7l)(h??S.OS,process.env)}async getProfiles(h,$,a,t=!1){const o=await this.S();return(0,g.$_r)($,a,t,this.N,o,void 0,this.O,this.bb.bind(this,h))}async getEnvironment(){return this.b?this.f.getEnvironment():{...process.env}}getWslPath(h,$){return this.f.getWslPath(h,$)}getRevivedPtyNewId(h,$){return this.f.getRevivedPtyNewId(h,$)}setTerminalLayoutInfo(h){return this.f.setTerminalLayoutInfo(h)}async getTerminalLayoutInfo(h){return this.g?.getTerminalLayoutInfo(h)}async requestDetachInstance(h,$){return this.f.requestDetachInstance(h,$)}async acceptDetachInstanceReply(h,$){return this.f.acceptDetachInstanceReply(h,$)}async freePortKillProcess(h){if(!this.f.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.f.freePortKillProcess(h)}async serializeTerminalState(h){return this.f.serializeTerminalState(h)}async reviveTerminalProcesses(h,$,a){return this.f.reviveTerminalProcesses(h,$,a)}async refreshProperty(h,$){return this.f.refreshProperty(h,$)}async updateProperty(h,$,a){return this.f.updateProperty(h,$,a)}async restartPtyHost(){this.W(),this.r=!0,this.U()}W(){this.f.shutdownAll(),this.c.store.dispose()}X(h){this.ab(),this.s=setTimeout(()=>this.Y(),h?v.HeartbeatConstants.ConnectingBeatInterval:v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.FirstWaitMultiplier),this.r||(this.r=!0,this.z.fire())}Y(){this.O.warn(`No ptyHost heartbeat after ${v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.s=void 0,this.t=setTimeout(()=>this.Z(),v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.SecondWaitMultiplier)}Z(){this.O.error(`No ptyHost heartbeat after ${(v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.FirstWaitMultiplier+v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.t=void 0,this.r&&(this.r=!1,this.y.fire())}$(){this.ab(),this.O.error(`No ptyHost response to createProcess after ${v.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.r&&(this.r=!1,this.y.fire())}ab(){this.s&&(clearTimeout(this.s),this.s=void 0),this.t&&(clearTimeout(this.t),this.t=void 0)}bb(h,$){return this.j.createRequest({workspaceId:h,originalText:$})}async acceptPtyHostResolvedVariables(h,$){this.j.acceptReply(h,$)}};e.$as=u,e.$as=u=ve([se(1,C.$Mi),se(2,P.$Aj),se(3,P.$Bj)],u)}),define(ae[69],ce([0,1,14,3,2,4,18,6,34]),function(X,e,n,D,S,M,C,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5$b=e.$4$b=void 0;const c="#FFFFFF",y="#1E1E1E",v="#000000",k="#FFFFFF",g="theme",m="themeBackground",w="windowSplash";e.$4$b=(0,P.$gi)("themeMainService");let p=class extends S.$Tc{constructor(f,h){super(),this.b=f,this.c=h,this.a=this.B(new D.$6d),this.onDidChangeColorScheme=this.a.event,this.B(this.c.onDidChangeConfiguration($=>{$.affectsConfiguration("window.systemColorTheme")&&this.f()})),this.f(),this.B(D.Event.fromNodeEventEmitter(n.nativeTheme,"updated")(()=>this.a.fire(this.getColorScheme())))}f(){switch(this.c.getValue("window.systemColorTheme")){case"dark":n.nativeTheme.themeSource="dark";break;case"light":n.nativeTheme.themeSource="light";break;case"auto":switch(this.g()){case"vs":n.nativeTheme.themeSource="light";break;case"vs-dark":n.nativeTheme.themeSource="dark";break;default:n.nativeTheme.themeSource="system"}break;default:n.nativeTheme.themeSource="system";break}}getColorScheme(){if(M.$i){if(n.nativeTheme.shouldUseHighContrastColors)return{dark:n.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(M.$j){if(n.nativeTheme.shouldUseInvertedColorScheme||n.nativeTheme.shouldUseHighContrastColors)return{dark:n.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(M.$k&&n.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:n.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const f=this.getColorScheme();if(f.highContrast&&this.c.getValue("window.autoDetectHighContrast"))return f.dark?v:k;let h=this.b.getItem(m,null);if(!h)switch(this.g()){case"vs":h=c;break;case"hc-black":h=v;break;case"hc-light":h=k;break;default:h=y}return M.$j&&h.toUpperCase()===y&&(h="#171717"),h}g(){switch(this.b.getItem(g,"vs-dark").split(" ")[0]){case"vs":return"vs";case"hc-black":return"hc-black";case"hc-light":return"hc-light";default:return"vs-dark"}}saveWindowSplash(f,h){this.b.setItems([{key:g,data:h.baseTheme},{key:m,data:h.colorInfo.background},{key:w,data:h}]),typeof f=="number"&&this.h(f,h),this.f()}h(f,h){for(const $ of n.BrowserWindow.getAllWindows())if($.id===f){$.setBackgroundColor(h.colorInfo.background);break}}getWindowSplash(){return this.b.getItem(w)}};e.$5$b=p,e.$5$b=p=ve([se(0,d.$HP),se(1,C.$Mi)],p)}),define(ae[130],ce([0,1,3,18,6,5]),function(X,e,n,D,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1v=e.$Zv=e.$Yv=e.$Xv=e.$Wv=e.$Vv=e.$Uv=e.$Tv=e.ProvidedOnAutoForward=e.$Sv=e.TunnelPrivacyId=e.TunnelProtocol=e.$Rv=e.$Qv=void 0,e.$Qv=(0,S.$gi)("tunnelService"),e.$Rv=(0,S.$gi)("sharedTunnelsService");var C;(function(p){p.Http="http",p.Https="https"})(C||(e.TunnelProtocol=C={}));var P;(function(p){p.ConstantPrivate="constantPrivate",p.Private="private",p.Public="public"})(P||(e.TunnelPrivacyId=P={}));function d(p){return!!p.forwardPort}e.$Sv=d;var c;(function(p){p[p.Notify=1]="Notify",p[p.OpenBrowser=2]="OpenBrowser",p[p.OpenPreview=3]="OpenPreview",p[p.Silent=4]="Silent",p[p.Ignore=5]="Ignore",p[p.OpenBrowserOnce=6]="OpenBrowserOnce"})(c||(e.ProvidedOnAutoForward=c={}));function y(p){if(p.scheme!=="http"&&p.scheme!=="https")return;const u=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(p.authority);if(u)return{address:u[1],port:+u[2]}}e.$Tv=y,e.$Uv=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function v(p){return e.$Uv.indexOf(p)>=0}e.$Vv=v,e.$Wv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function k(p){return e.$Wv.indexOf(p)>=0}e.$Xv=k;function g(p,u,f,h){if(f===1)return!1;if(f===2&&k(u)){const $=/(\d+)\.(\d+)\.(\d+)/g.exec(h);if($?.length===4&&parseInt($[1])>=18)return!1}return p<1024}e.$Yv=g;class m{constructor(u,f,h){this.remoteAddress=u,this.localAddress=f,this.b=h,this.a=new n.$6d,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Zv=m;let w=class{constructor(u,f){this.k=u,this.l=f,this.a=new n.$6d,this.onTunnelOpened=this.a.event,this.b=new n.$6d,this.onTunnelClosed=this.b.event,this.c=new n.$6d,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const u=this.l.getValue("remote.localPortHost");return!u||u==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(u){return this.f=u,u?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(u){this.g=u.elevation,this.i=u.privacyOptions,this.h=u.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const u=[],f=Array.from(this.e.values());for(const h of f){const $=Array.from(h.values());for(const a of $){const t=await a.value;t&&typeof t!="string"&&u.push(t)}}return u}async dispose(){for(const u of this.e.values()){for(const{value:f}of u.values())await f.then(h=>typeof h!="string"?h?.dispose():void 0);u.clear()}this.e.clear()}setEnvironmentTunnel(u,f,h,$,a){this.q(u,f,Promise.resolve({tunnelRemoteHost:u,tunnelRemotePort:f,localAddress:h,privacy:$,protocol:a,dispose:()=>Promise.resolve()}))}async getExistingTunnel(u,f){(k(u)||v(u))&&(u=e.$Uv[0]);const h=this.s(u,f);if(h)return++h.refcount,h.value}openTunnel(u,f,h,$,a,t=!1,o,r){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${f}:${h} on local port ${a}.`);const i=this.f??u;if(!i)return;if(f||(f="localhost"),$||($=this.m),this.f&&this.j.has(h)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const s=this.t(i,f,h,$,a,t,o,r);return s?s.then(l=>{if(l){if(typeof l=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(f,h),l}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(f,h);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const b=this.o(l);return(l.tunnelRemoteHost!==f||l.tunnelRemotePort!==h)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),o&&l.privacy!==o&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(b),b}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),s)}o(u){return{tunnelRemotePort:u.tunnelRemotePort,tunnelRemoteHost:u.tunnelRemoteHost,tunnelLocalPort:u.tunnelLocalPort,localAddress:u.localAddress,privacy:u.privacy,protocol:u.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${u.tunnelRemoteHost}:${u.tunnelRemotePort} `);const f=this.e.get(u.tunnelRemoteHost);if(f){const h=f.get(u.tunnelRemotePort);h&&(h.refcount--,await this.p(u.tunnelRemoteHost,u.tunnelRemotePort,h))}}}}async p(u,f,h){if(h.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${u}:${f}.`);const $=h.value.then(async a=>{a&&typeof a!="string"&&(await a.dispose(!0),this.b.fire({host:a.tunnelRemoteHost,port:a.tunnelRemotePort}))});return this.e.has(u)&&this.e.get(u).delete(f),$}}async closeTunnel(u,f){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${u}:${f} `);const h=this.e.get(u);if(h&&h.has(f)){const $=h.get(f);$.refcount=0,await this.p(u,f,$)}}q(u,f,h){this.e.has(u)||this.e.set(u,new Map),this.e.get(u).set(f,{refcount:1,value:h})}async r(u,f){const h=this.e.get(u);if(h){const $=h.get(f),a=$?await $.value:void 0;(!a||typeof a=="string")&&h.delete(f),h.size===0&&this.e.delete(u)}}s(u,f){const h=[u];v(u)?(h.push(...e.$Uv),h.push(...e.$Wv)):k(u)&&h.push(...e.$Wv);const $=h.map(a=>this.e.get(a));for(const a of $){const t=a?.get(f);if(t)return t}}canTunnel(u){return!!y(u)}u(u,f,h,$,a,t,o){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${f}:${h} on local port ${$}.`);const r=h;this.j.add(r);const i=$===void 0?h:$,s={elevationRequired:a?this.isPortPrivileged(i):!1},l={remoteAddress:{host:f,port:h},localAddressPort:$,privacy:t,public:t?t!==P.Private:void 0,protocol:o},b=u.forwardPort(l,s);return b?(this.q(f,h,b),b.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(r)})):this.j.delete(r),b}};e.$1v=w,e.$1v=w=ve([se(0,M.$Aj),se(1,D.$Mi)],w)}),define(ae[49],ce([0,1,6]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QW=e.$PW=e.DisablementReason=e.UpdateType=e.StateType=void 0;var D;(function(C){C.Uninitialized="uninitialized",C.Idle="idle",C.Disabled="disabled",C.CheckingForUpdates="checking for updates",C.AvailableForDownload="available for download",C.Downloading="downloading",C.Downloaded="downloaded",C.Updating="updating",C.Ready="ready"})(D||(e.StateType=D={}));var S;(function(C){C[C.Setup=0]="Setup",C[C.Archive=1]="Archive",C[C.Snap=2]="Snap"})(S||(e.UpdateType=S={}));var M;(function(C){C[C.NotBuilt=0]="NotBuilt",C[C.DisabledByEnvironment=1]="DisabledByEnvironment",C[C.ManuallyDisabled=2]="ManuallyDisabled",C[C.MissingConfiguration=3]="MissingConfiguration",C[C.InvalidConfiguration=4]="InvalidConfiguration",C[C.RunningAsAdmin=5]="RunningAsAdmin"})(M||(e.DisablementReason=M={})),e.$PW={Uninitialized:{type:"uninitialized"},Disabled:C=>({type:"disabled",reason:C}),Idle:(C,P)=>({type:"idle",updateType:C,error:P}),CheckingForUpdates:C=>({type:"checking for updates",explicit:C}),AvailableForDownload:C=>({type:"available for download",update:C}),Downloading:C=>({type:"downloading",update:C}),Downloaded:C=>({type:"downloaded",update:C}),Updating:C=>({type:"updating",update:C}),Ready:C=>({type:"ready",update:C})},e.$QW=(0,n.$gi)("updateService")}),define(ae[266],ce([0,1,4,190,52,44]),function(X,e,n,D,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),M.$Xn.as(S.$3n.Configuration).registerConfiguration({id:"update",order:15,title:(0,D.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,D.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,D.localize)(2,null),(0,D.localize)(3,null),(0,D.localize)(4,null),(0,D.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:1,description:(0,D.localize)(6,null),deprecationMessage:(0,D.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,D.localize)(8,null),description:(0,D.localize)(9,null),included:n.$i&&!n.$o},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,D.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(ae[267],ce([0,1,3,49]),function(X,e,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eac=e.$dac=void 0;class S{constructor(P){this.a=P}listen(P,d){switch(d){case"onStateChange":return this.a.onStateChange}throw new Error(`Event not found: ${d}`)}call(P,d,c){switch(d){case"checkForUpdates":return this.a.checkForUpdates(c);case"downloadUpdate":return this.a.downloadUpdate();case"applyUpdate":return this.a.applyUpdate();case"quitAndInstall":return this.a.quitAndInstall();case"_getInitialState":return Promise.resolve(this.a.state);case"isLatestVersion":return this.a.isLatestVersion();case"_applySpecificUpdate":return this.a._applySpecificUpdate(c)}throw new Error(`Call not found: ${d}`)}}e.$dac=S;class M{get state(){return this.b}set state(P){this.b=P,this.a.fire(P)}constructor(P){this.c=P,this.a=new n.$6d,this.onStateChange=this.a.event,this.b=D.$PW.Uninitialized,this.c.listen("onStateChange")(d=>this.state=d),this.c.call("_getInitialState").then(d=>this.state=d)}checkForUpdates(P){return this.c.call("checkForUpdates",P)}downloadUpdate(){return this.c.call("downloadUpdate")}applyUpdate(){return this.c.call("applyUpdate")}quitAndInstall(){return this.c.call("quitAndInstall")}isLatestVersion(){return this.c.call("isLatestVersion")}_applySpecificUpdate(P){return this.c.call("_applySpecificUpdate",P)}}e.$eac=M}),define(ae[40],ce([0,1,6]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$el=void 0,e.$el=(0,n.$gi)("IUriIdentityService")}),define(ae[268],ce([0,1,40,209,16,19,142,3,2]),function(X,e,n,D,S,M,C,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$es=void 0;class c{static{this._clock=0}constructor(k){this.uri=k,this.time=c._clock++}touch(){return this.time=c._clock++,this}}let y=class{constructor(k){this.g=k,this.c=new d.$Sc,this.f=2**16;const g=new Map,m=w=>{let p=g.get(w.scheme);return p===void 0&&(p=k.hasProvider(w)&&!this.g.hasCapability(w,1024),g.set(w.scheme,p)),p};this.c.add(P.Event.any(k.onDidChangeFileSystemProviderRegistrations,k.onDidChangeFileSystemProviderCapabilities)(w=>{g.delete(w.scheme)})),this.extUri=new M.$Ig(m),this.d=new C.$ds((w,p)=>this.extUri.compare(w,p,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(k){this.g.hasProvider(k)&&(k=(0,M.$Ug)(k));const g=this.d.get(k);return g?g.touch().uri.with({fragment:k.fragment}):(this.d.set(k,new c(k)),this.h(),k)}h(){if(this.d.size<this.f)return;const k=[...this.d.entries()].sort((m,w)=>m[1].time<w[1].time?1:m[1].time>w[1].time?-1:0);c._clock=0,this.d.clear();const g=this.f*.5;for(let m=0;m<g;m++)this.d.set(k[m][0],k[m][1].touch())}};e.$es=y,e.$es=y=ve([se(0,S.$Gk)],y),(0,D.$bs)(n.$el,y,1)}),define(ae[131],ce([0,1,6]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GW=void 0,e.$GW=(0,n.$gi)("urlService")}),define(ae[269],ce([0,1,7]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nac=e.$mac=e.$lac=void 0;class D{constructor(P){this.a=P}listen(P,d){throw new Error(`Event not found: ${d}`)}call(P,d,c){switch(d){case"handleURL":return this.a.handleURL(n.URI.revive(c[0]),c[1])}throw new Error(`Call not found: ${d}`)}}e.$lac=D;class S{constructor(P){this.a=P}handleURL(P,d){return this.a.call("handleURL",[P.toJSON(),d])}}e.$mac=S;class M{constructor(P,d){this.a=P,this.b=d}async routeCall(P,d,c,y){if(d!=="handleURL")throw new Error(`Call not found: ${d}`);if(Array.isArray(c)&&c.length>0){const v=n.URI.revive(c[0]);if(this.b.trace("URLHandlerRouter#routeCall() with URI argument",v.toString(!0)),v.query){const k=/\bwindowId=(\d+)/.exec(v.query);if(k){const g=k[1];this.b.trace(`URLHandlerRouter#routeCall(): found windowId query parameter with value "${g}"`,v.toString(!0));const m=new RegExp(`window:${g}`),w=P.connections.find(p=>(this.b.trace("URLHandlerRouter#routeCall(): testing connection",p.ctx),m.test(p.ctx)));if(w)return this.b.trace("URLHandlerRouter#routeCall(): found a connection to route",v.toString(!0)),w;this.b.trace("URLHandlerRouter#routeCall(): did not find a connection to route",v.toString(!0))}else this.b.trace("URLHandlerRouter#routeCall(): did not find windowId query parameter",v.toString(!0))}}else this.b.trace("URLHandlerRouter#routeCall() without URI argument");return this.a.routeCall(P,d,c,y)}routeEvent(P,d){throw new Error(`Event not found: ${d}`)}}e.$nac=M}),define(ae[270],ce([0,1,8,2,7,27]),function(X,e,n,D,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IW=e.$HW=void 0;class C extends D.$Tc{constructor(){super(...arguments),this.a=new Set}open(c,y){const v=[...this.a.values()];return(0,n.$kh)(v.map(k=>()=>k.handleURL(c,y)),void 0,!1).then(k=>k||!1)}registerHandler(c){return this.a.add(c),(0,D.$Rc)(()=>this.a.delete(c))}}e.$HW=C;let P=class extends C{constructor(c){super(),this.b=c}create(c){let{authority:y,path:v,query:k,fragment:g}=c||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return y&&v&&v.indexOf("/")!==0&&(v=`/${v}`),S.URI.from({scheme:this.b.urlProtocol,authority:y,path:v,query:k,fragment:g})}};e.$IW=P,e.$IW=P=ve([se(0,M.$Sj)],P)}),define(ae[271],ce([0,1,14,8,3,2,4,7]),function(X,e,n,D,S,M,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oac=void 0;class d extends M.$Tc{constructor(y,v,k,g,m,w){if(super(),this.c=v,this.f=w,this.a=[],this.b=0,y&&(w.trace("ElectronURLListener initialUrisToHandle:",y.map(f=>f.originalUrl)),this.a=y),C.$i){const f=g.isBuilt?[]:[`"${g.appRoot}"`];f.push("--open-url","--"),n.app.setAsDefaultProtocolClient(m.urlProtocol,process.execPath,f)}const p=S.Event.map(S.Event.fromNodeEventEmitter(n.app,"open-url",(f,h)=>({event:f,url:h})),({event:f,url:h})=>(f.preventDefault(),h));this.B(p(f=>{const h=this.g(f);h&&this.c.open(h,{originalUrl:f})})),k.getWindows().filter(f=>f.isReady).length>0?(w.trace("ElectronURLListener: window is ready to handle URLs"),this.h()):(w.trace("ElectronURLListener: waiting for window to be ready to handle URLs..."),this.B(S.Event.once(k.onDidSignalReadyWindow)(()=>this.h())))}g(y){try{return P.URI.parse(y)}catch{return}}async h(){if(this.b++>10){this.f.trace("ElectronURLListener#flush(): giving up after 10 retries");return}this.f.trace("ElectronURLListener#flush(): flushing URLs");const y=[];for(const v of this.a)await this.c.open(v.uri,{originalUrl:v.originalUrl})?this.f.trace("ElectronURLListener#flush(): URL was handled",v.originalUrl):(this.f.trace("ElectronURLListener#flush(): URL was not yet handled",v.originalUrl),y.push(v));y.length!==0&&(this.a=y,(0,D.$ih)(()=>this.h(),500,this.q))}}e.$oac=d}),define(ae[272],ce([0,1,3,2,16,59,31]),function(X,e,n,D,S,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2ac=void 0;class P extends D.$Tc{constructor(c,y,v,k,g,m){super(),this.f=c,this.g=y,this.h=v,this.j=k,this.m=g,this.n=m,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new n.$6d),this.onDidChangeFile=this.a.event,this.b=M.$mi.forUris(()=>!(this.capabilities&1024)),this.c=new C.$Bc(w=>this.m.extUri.getComparisonKey(this.t(w))),this.r(),this.B(k.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(w=>this.s(w)))}r(){this.c.clear();for(const c of this.j.profiles)this.c.add(c.settingsResource),this.c.add(c.keybindingsResource),this.c.add(c.tasksResource),this.c.add(c.extensionsResource)}open(c,y){return this.g.open(this.t(c),y)}close(c){return this.g.close(c)}read(c,y,v,k,g){return this.g.read(c,y,v,k,g)}write(c,y,v,k,g){return this.g.write(c,y,v,k,g)}watch(c,y){this.b.set(c,c);const v=this.g.watch(this.t(c),y);return(0,D.$Rc)(()=>{this.b.delete(c),v.dispose()})}stat(c){return this.g.stat(this.t(c))}mkdir(c){return this.g.mkdir(this.t(c))}rename(c,y,v){return this.g.rename(this.t(c),this.t(y),v)}readFile(c,y){return this.g.readFile(this.t(c),y)}readFileStream(c,y,v){return this.g.readFileStream(this.t(c),y,v)}readdir(c){return this.g.readdir(this.t(c))}enforceAtomicReadFile(c){return this.c.has(c)}writeFile(c,y,v){return this.g.writeFile(this.t(c),y,v)}enforceAtomicWriteFile(c){return this.c.has(c)?{postfix:".vsctmp"}:!1}delete(c,y){return this.g.delete(this.t(c),y)}copy(c,y,v){if((0,S.$Kk)(this.g))return this.g.copy(this.t(c),this.t(y),v);throw new Error("copy not supported")}cloneFile(c,y){if((0,S.$Lk)(this.g))return this.g.cloneFile(this.t(c),this.t(y));throw new Error("clone not supported")}s(c){const y=[];for(const v of c){if(v.resource.scheme!==this.f)continue;const k=this.u(v.resource);this.b.findSubstr(k)&&y.push({resource:k,type:v.type,cId:v.cId})}y.length&&(this.n.debug("User data changed"),this.a.fire(y))}t(c){return c.with({scheme:this.f})}u(c){return c.with({scheme:this.h})}}e.$2ac=P}),define(ae[273],ce([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iac=void 0,e.$Iac="utilityProcessWorker"}),define(ae[274],ce([0,1,6]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pac=void 0,e.$pac=(0,n.$gi)("webviewManagerService")}),define(ae[275],ce([0,1,14,2,13,7]),function(X,e,n,D,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qac=void 0;class C extends D.$Tc{static{this.a=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}constructor(){super();const d=this.b.bind(this);n.protocol.registerFileProtocol(S.Schemas.vscodeWebview,d)}b(d,c){try{const y=M.URI.parse(d.url),v=C.a.get(y.path);if(typeof v=="string"){const k=`vs/workbench/contrib/webview/browser/pre/${v}`,g=S.$Ag.asFileUri(k);return c({path:g.fsPath,headers:{...S.COI.getHeadersFromQuery(d.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return c({error:-10})}catch{}return c({error:-2})}}e.$qac=C}),define(ae[55],ce([0,1,4]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cD=e.$bD=e.$aD=e.$_C=e.$$C=e.$0C=e.CustomTitleBarVisibility=e.TitlebarStyle=e.TitleBarSetting=e.$9C=e.$8C=e.$7C=e.$6C=e.$5C=e.$4C=void 0,e.$4C={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function D(u){return typeof u.parentId=="number"}e.$5C=D;function S(u){return!!u.workspaceUri}e.$6C=S;function M(u){return!!u.folderUri}e.$7C=M;function C(u){return!!u.fileUri}e.$8C=C;function P(u){const f=k(u),h=u.getValue("window.menuBarVisibility");return h==="default"||f&&h==="compact"||n.$j&&n.$m?"classic":h}e.$9C=P;var d;(function(u){u.TITLE_BAR_STYLE="window.titleBarStyle",u.CUSTOM_TITLE_BAR_VISIBILITY="window.customTitleBarVisibility"})(d||(e.TitleBarSetting=d={}));var c;(function(u){u.NATIVE="native",u.CUSTOM="custom"})(c||(e.TitlebarStyle=c={}));var y;(function(u){u.AUTO="auto",u.WINDOWED="windowed",u.NEVER="never"})(y||(e.CustomTitleBarVisibility=y={}));function v(u,f){return!0}e.$0C=v;function k(u,f){return f||(f=g(u)),f==="native"}e.$$C=k;function g(u){if(n.$o)return"custom";const f=u.getValue("window");if(f){if(n.$j&&f.nativeTabs===!0||n.$j&&f.nativeFullScreen===!1)return"native";const a=f.titleBarStyle;if(a==="native"||a==="custom")return a}return n.$k?"native":"custom"}e.$_C=g;function m(u){return!(!n.$i||n.$o||k(u))}e.$aD=m;function w(u){const f=u.getValue("window");return!f||typeof f.nativeFullScreen!="boolean"||f.nativeTabs?!0:f.nativeFullScreen!==!1}e.$bD=w;function p(u=0){return Math.pow(1.2,u)}e.$cD=p}),define(ae[81],ce([0,1,14]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.$T$b=e.$S$b=e.UnloadReason=e.LoadReason=void 0;var D;(function(c){c[c.INITIAL=1]="INITIAL",c[c.LOAD=2]="LOAD",c[c.RELOAD=3]="RELOAD"})(D||(e.LoadReason=D={}));var S;(function(c){c[c.CLOSE=1]="CLOSE",c[c.QUIT=2]="QUIT",c[c.RELOAD=3]="RELOAD",c[c.LOAD=4]="LOAD"})(S||(e.UnloadReason=S={}));const M=function(c=1){return{width:1024,height:768,mode:c}};e.$S$b=M;const C=function(){const v=n.screen.getPrimaryDisplay().workArea,k=Math.max(v.x+v.width/2-800/2,0),g=Math.max(v.y+v.height/2-600/2,0);return{x:k,y:g,width:800,height:600,mode:1}};e.$T$b=C;var P;(function(c){c[c.Maximized=0]="Maximized",c[c.Normal=1]="Normal",c[c.Minimized=2]="Minimized",c[c.Fullscreen=3]="Fullscreen"})(P||(e.WindowMode=P={}));var d;(function(c){c[c.UNRESPONSIVE=1]="UNRESPONSIVE",c[c.PROCESS_GONE=2]="PROCESS_GONE",c[c.LOAD=3]="LOAD"})(d||(e.WindowError=d={}))}),define(ae[276],ce([0,1,8,3,2]),function(X,e,n,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wac=void 0;class M extends S.$Tc{constructor({onDidOpenMainWindow:P,onDidFocusMainWindow:d,getActiveWindowId:c}){super(),this.a=this.B(new S.$Sc),D.Event.latch(D.Event.any(P,d))(this.f,this,this.a),this.b=(0,n.$6g)(()=>c()),(async()=>{try{const v=await this.b;this.c=typeof this.c=="number"?this.c:v}catch{}finally{this.b=void 0}})()}f(P){this.b&&(this.b.cancel(),this.b=void 0),this.c=P}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$wac=M}),define(ae[30],ce([0,1,194,9,59,19,7,6,13]),function(X,e,n,D,S,M,C,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Li=e.$Ki=e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.$Di=e.$Ci=e.$Bi=e.$Ai=e.$zi=e.$yi=e.$xi=e.WorkbenchState=e.$wi=e.$vi=e.$ui=e.$ti=e.$si=e.$ri=e.$qi=e.$pi=void 0,e.$pi=(0,P.$gi)("contextService");function c(i){const s=i;return typeof s?.id=="string"&&C.URI.isUri(s.uri)}e.$qi=c;function y(i){return typeof i?.id=="string"&&!c(i)&&!k(i)}e.$ri=y,e.$si={id:"ext-dev"},e.$ti={id:"empty-window"};function v(i,s){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,D.$nc)(i)}:s?e.$si:e.$ti;const l=i;return l.configuration?{id:l.id,configPath:l.configuration}:l.folders.length===1?{id:l.id,uri:l.folders[0].uri}:{id:l.id}}e.$ui=v;function k(i){const s=i;return typeof s?.id=="string"&&C.URI.isUri(s.configPath)}e.$vi=k;function g(i){const s=i;if(s?.uri)return{id:s.id,uri:C.URI.revive(s.uri)};const l=i;if(l?.configPath)return{id:l.id,configPath:C.URI.revive(l.configPath)};if(i?.id)return{id:i.id}}e.$wi=g;var m;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(m||(e.WorkbenchState=m={}));function w(i){const s=i;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&Array.isArray(s.folders))}e.$xi=w;function p(i){const s=i;return!!(s&&typeof s=="object"&&C.URI.isUri(s.uri)&&typeof s.name=="string"&&typeof s.toResource=="function")}e.$yi=p;class u{constructor(s,l,b,R,I){this.h=s,this.j=b,this.k=R,this.l=I,this.c=S.$mi.forUris(this.l,()=>!0),this.folders=l}update(s){this.h=s.id,this.k=s.configuration,this.j=s.transient,this.l=s.l,this.folders=s.folders}get folders(){return this.g}set folders(s){this.g=s,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(s){this.k=s}getFolder(s){return s&&this.c.findSubstr(s)||null}n(){this.c=S.$mi.forUris(this.l,()=>!0);for(const s of this.folders)this.c.set(s.uri,s)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$zi=u;class f{constructor(s,l){this.raw=l,this.uri=s.uri,this.index=s.index,this.name=s.name}toResource(s){return(0,M.$Tg)(this.uri,s)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Ai=f;function h(i){return new f({uri:i,index:0,name:(0,M.$Pg)(i)},{uri:i.toString()})}e.$Bi=h,e.$Ci="code-workspace",e.$Di=`.${e.$Ci}`,e.$Ei=[{name:(0,n.localize)(0,null),extensions:[e.$Ci]}],e.$Fi="workspace.json";function $(i,s){return M.$Kg.isEqualOrParent(i,s.untitledWorkspacesHome)}e.$Gi=$;function a(i){let s;return C.URI.isUri(i)?s=i:s=i.configuration,s?.scheme===d.Schemas.tmp}e.$Hi=a,e.$Ii="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(i){return i.id===e.$Ii}e.$Ji=t;function o(i,s){return!$(i,s)&&!a(i)}e.$Ki=o;function r(i){return(typeof i=="string"?(0,D.$oc)(i):(0,M.$Rg)(i))===e.$Di}e.$Li=r}),define(ae[56],ce([0,1,14,8,45,47,2,86,4,21,169,119,6,5,27,30]),function(X,e,n,D,S,M,C,P,d,c,y,v,k,g,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2$b=e.$1$b=void 0,e.$1$b=(0,k.$gi)("dialogMainService");let p=class{constructor(f,h){this.d=f,this.e=h,this.a=new Map,this.b=new Map,this.c=new D.$nh}pickFileFolder(f,h){return this.f({...f,pickFolders:!0,pickFiles:!0,title:(0,y.localize)(0,null)},h)}pickFolder(f,h){return this.f({...f,pickFolders:!0,title:(0,y.localize)(1,null)},h)}pickFile(f,h){return this.f({...f,pickFiles:!0,title:(0,y.localize)(2,null)},h)}pickWorkspace(f,h){const $=(0,y.localize)(3,null),a=(0,M.$gw)((0,y.localize)(4,null)),t=w.$Ei;return this.f({...f,pickFiles:!0,title:$,filters:t,buttonLabel:a},h)}async f(f,h){const $={title:f.title,buttonLabel:f.buttonLabel,filters:f.filters,defaultPath:f.defaultPath};(typeof f.pickFiles=="boolean"||typeof f.pickFolders=="boolean")&&($.properties=void 0,f.pickFiles&&f.pickFolders&&($.properties=["multiSelections","openDirectory","openFile","createDirectory"])),$.properties||($.properties=["multiSelections",f.pickFolders?"openDirectory":"openFile","createDirectory"]),d.$j&&$.properties.push("treatPackageAsDirectory");const a=await this.showOpenDialog($,(h||n.BrowserWindow.getFocusedWindow())??void 0);if(a&&a.filePaths&&a.filePaths.length>0)return a.filePaths}g(f){if(f){let h=this.b.get(f.id);return h||(h=new D.$nh,this.b.set(f.id,h)),h}else return this.c}showMessageBox(f,h){return this.g(h).queue(async()=>{const{options:$,buttonIndeces:a}=(0,v.$nw)(f,this.e);let t;return h?t=await n.dialog.showMessageBox(h,$):t=await n.dialog.showMessageBox($),{response:a[t.response],checkboxChecked:t.checkboxChecked}})}async showSaveDialog(f,h){const $=this.j(f,h);if(!$)return this.d.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.g(h).queue(async()=>{let a;return h?a=await n.dialog.showSaveDialog(h,f):a=await n.dialog.showSaveDialog(f),a.filePath=this.h(a.filePath),a})}finally{(0,C.$Oc)($)}}h(f){return f&&d.$j&&(f=(0,P.$Rl)(f)),f}i(f){return f.map(h=>this.h(h))}async showOpenDialog(f,h){f.defaultPath&&(await c.Promises.exists(f.defaultPath)||(f.defaultPath=void 0));const $=this.j(f,h);if(!$)return this.d.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.g(h).queue(async()=>{let a;return h?a=await n.dialog.showOpenDialog(h,f):a=await n.dialog.showOpenDialog(f),a.filePaths=this.i(a.filePaths),a})}finally{(0,C.$Oc)($)}}j(f,h){if(!h)return C.$Tc.None;this.d.trace("[DialogMainService]: request to acquire file dialog lock",f);let $=this.a.get(h.id);$||($=new Set,this.a.set(h.id,$));const a=(0,S.$7i)(f);if(!$.has(a))return this.d.trace("[DialogMainService]: new file dialog lock created",f),$.add(a),(0,C.$Rc)(()=>{this.d.trace("[DialogMainService]: file dialog lock disposed",f),$?.delete(a),$?.size===0&&this.a.delete(h.id)})}};e.$2$b=p,e.$2$b=p=ve([se(0,g.$Aj),se(1,m.$Sj)],p)}),define(ae[277],ce([0,1,3,2,76,30]),function(X,e,n,D,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aac=void 0;class C extends D.$Tc{static{this.a=100}constructor(d,c){super(),this.f=d,this.g=c,this.b=this.B(new n.$6d),this.c=new Map,this.h(c.applicationStorage,this.b)}h(d,c){this.B(n.Event.debounce(d.onDidChangeStorage,(y,v)=>(y?y.push(v):y=[v],y),C.a)(y=>{y.length&&c.fire(this.j(y,d))}))}j(d,c){const y=new Map,v=new Set;return d.forEach(k=>{const g=c.get(k.key);typeof g=="string"?y.set(k.key,g):v.add(k.key)}),{changed:Array.from(y.entries()),deleted:Array.from(v.values())}}listen(d,c,y){switch(c){case"onDidChangeStorage":{const v=y.profile?(0,S.$Ph)(y.profile):void 0;if(!v)return this.b.event;let k=this.c.get(v.id);return k||(k=this.B(new n.$6d),this.h(this.g.profileStorage(v),k),this.c.set(v.id,k)),k.event}}throw new Error(`Event not found: ${c}`)}async call(d,c,y){const v=y.profile?(0,S.$Ph)(y.profile):void 0,k=(0,M.$wi)(y.workspace),g=await this.m(v,k);switch(c){case"getItems":return Array.from(g.items.entries());case"updateItems":{const m=y;if(m.insert)for(const[w,p]of m.insert)g.set(w,p);m.delete?.forEach(w=>g.delete(w));break}case"optimize":return g.optimize();case"isUsed":{const m=y.payload;if(typeof m=="string")return this.g.isUsed(m)}default:throw new Error(`Call not found: ${c}`)}}async m(d,c){let y;c?y=this.g.workspaceStorage(c):d?y=this.g.profileStorage(d):y=this.g.applicationStorage;try{await y.init()}catch(v){this.f.error(`StorageIPC#init: Unable to init ${c?"workspace":d?"profile":"application"} storage due to ${v}`)}return y}}e.$aac=C}),define(ae[41],ce([0,1,45,3,2,19,7,191,38,16,6,5,30,31,40,8,32,25,12]),function(X,e,n,D,S,M,C,P,d,c,y,v,k,g,m,w,p,u,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kl=e.$jl=e.$il=e.$hl=e.$gl=e.$fl=e.ProfileResourceType=void 0;var h;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState"})(h||(e.ProfileResourceType=h={}));function $(i){const s=i;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&typeof s.isDefault=="boolean"&&typeof s.name=="string"&&C.URI.isUri(s.location)&&C.URI.isUri(s.globalStorageHome)&&C.URI.isUri(s.settingsResource)&&C.URI.isUri(s.keybindingsResource)&&C.URI.isUri(s.tasksResource)&&C.URI.isUri(s.snippetsHome)&&C.URI.isUri(s.extensionsResource))}e.$fl=$,e.$gl=(0,y.$gi)("IUserDataProfilesService");function a(i,s){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,icon:i.icon,location:C.URI.revive(i.location).with({scheme:s}),globalStorageHome:C.URI.revive(i.globalStorageHome).with({scheme:s}),settingsResource:C.URI.revive(i.settingsResource).with({scheme:s}),keybindingsResource:C.URI.revive(i.keybindingsResource).with({scheme:s}),tasksResource:C.URI.revive(i.tasksResource).with({scheme:s}),snippetsHome:C.URI.revive(i.snippetsHome).with({scheme:s}),extensionsResource:C.URI.revive(i.extensionsResource).with({scheme:s}),cacheHome:C.URI.revive(i.cacheHome).with({scheme:s}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}e.$hl=a;function t(i,s,l,b,R,I){return{id:i,name:s,location:l,isDefault:!1,shortName:R?.shortName,icon:R?.icon,globalStorageHome:I&&R?.useDefaultFlags?.globalState?I.globalStorageHome:(0,M.$Tg)(l,"globalStorage"),settingsResource:I&&R?.useDefaultFlags?.settings?I.settingsResource:(0,M.$Tg)(l,"settings.json"),keybindingsResource:I&&R?.useDefaultFlags?.keybindings?I.keybindingsResource:(0,M.$Tg)(l,"keybindings.json"),tasksResource:I&&R?.useDefaultFlags?.tasks?I.tasksResource:(0,M.$Tg)(l,"tasks.json"),snippetsHome:I&&R?.useDefaultFlags?.snippets?I.snippetsHome:(0,M.$Tg)(l,"snippets"),extensionsResource:I&&R?.useDefaultFlags?.extensions?I.extensionsResource:(0,M.$Tg)(l,"extensions.json"),cacheHome:(0,M.$Tg)(b,i),useDefaultFlags:R?.useDefaultFlags,isTransient:R?.transient}}e.$il=t;let o=class extends S.$Tc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(s,l,b,R){super(),this.t=s,this.u=l,this.w=b,this.y=R,this.f=!0,this.h=this.B(new D.$6d),this.onDidChangeProfiles=this.h.event,this.j=this.B(new D.$6d),this.onWillCreateProfile=this.j.event,this.m=this.B(new D.$6d),this.onWillRemoveProfile=this.m.event,this.n=this.B(new D.$6d),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new g.$Ac,emptyWindows:new Map},this.profilesHome=(0,M.$Tg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,M.$Tg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(s){this.f!==s&&(this.z=void 0,this.f=s)}isEnabled(){return this.f}get C(){if(!this.z){const s=this.D(),l=[s];if(this.f)try{for(const I of this.O()){if(!I.name||!(0,f.$Tf)(I.name)||!I.location){this.y.warn("Skipping the invalid stored profile",I.location||I.name);continue}l.push(t((0,M.$Qg)(I.location),I.name,I.location,this.g,{shortName:I.shortName,icon:I.icon,useDefaultFlags:I.useDefaultFlags},s))}}catch(I){this.y.error(I)}const b=new g.$Ac,R=new Map;if(l.length)try{const I=this.Q();if(I.workspaces)for(const[E,A]of Object.entries(I.workspaces)){const j=C.URI.parse(E),T=l.find(W=>W.id===A);T&&b.set(j,T)}if(I.emptyWindows)for(const[E,A]of Object.entries(I.emptyWindows)){const j=l.find(T=>T.id===A);j&&R.set(E,j)}}catch(I){this.y.error(I)}this.z={profiles:l,workspaces:b,emptyWindows:R}}return this.z}D(){const s=t("__default__profile__",(0,P.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...s,extensionsResource:this.S()??s.extensionsResource,isDefault:!0}}async createTransientProfile(s){const l="Temp",b=new RegExp(`${(0,u.$Ye)(l)}\\s(\\d+)`);let R=0;for(const E of this.profiles){const A=b.exec(E.name),j=A?parseInt(A[1]):0;R=j>R?j:R}const I=`${l} ${R+1}`;return this.createProfile((0,n.$7i)((0,p.$Cg)()).toString(16),I,{transient:!0},s)}async createNamedProfile(s,l,b){return this.createProfile((0,n.$7i)((0,p.$Cg)()).toString(16),s,l,b)}async createProfile(s,l,b,R){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const I=await this.F(s,l,b);return R&&await this.setProfileForWorkspace(R,I),I}async F(s,l,b){if(!(0,f.$Tf)(l)||!l)throw new Error("Name of the profile is mandatory and must be of type `string`");let R=this.r.get(l);return R||(R=(async()=>{try{const I=this.profiles.find(j=>j.name===l||j.id===s);if(I)return I;const E=t(s,l,(0,M.$Tg)(this.profilesHome,s),this.g,b,this.defaultProfile);await this.u.createFolder(E.location);const A=[];return this.j.fire({profile:E,join(j){A.push(j)}}),await w.Promises.settled(A),this.I([E],[],[]),E}finally{this.r.delete(l)}})(),this.r.set(l,R)),R}async updateProfile(s,l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let b=this.profiles.find(R=>R.id===s.id);if(!b)throw new Error(`Profile '${s.name}' does not exist`);return b=t(b.id,l.name??b.name,b.location,this.g,{shortName:l.shortName??b.shortName,icon:l.icon===null?void 0:l.icon??b.icon,transient:l.transient??b.isTransient,useDefaultFlags:l.useDefaultFlags??b.useDefaultFlags},this.defaultProfile),this.I([],[],[b]),b}async removeProfile(s){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(s.isDefault)throw new Error("Cannot remove default profile");const l=this.profiles.find(R=>R.id===s.id);if(!l)throw new Error(`Profile '${s.name}' does not exist`);const b=[];this.m.fire({profile:l,join(R){b.push(R)}});try{await Promise.allSettled(b)}catch(R){this.y.error(R)}for(const R of[...this.C.emptyWindows.keys()])l.id===this.C.emptyWindows.get(R)?.id&&this.C.emptyWindows.delete(R);for(const R of[...this.C.workspaces.keys()])l.id===this.C.workspaces.get(R)?.id&&this.C.workspaces.delete(R);this.M(),this.I([],[l],[]);try{await this.u.del(l.cacheHome,{recursive:!0})}catch(R){(0,c.$Xk)(R)!==1&&this.y.error(R)}}async setProfileForWorkspace(s,l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const b=this.profiles.find(R=>R.id===l.id);if(!b)throw new Error(`Profile '${l.name}' does not exist`);this.L(s,b)}unsetWorkspace(s,l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(s,void 0,l)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const s=await this.u.resolve(this.profilesHome);await Promise.all((s.children||[]).filter(l=>l.isDirectory&&this.profiles.every(b=>!this.w.extUri.isEqual(b.location,l.resource))).map(l=>this.u.del(l.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const s=this.s.profiles.filter(l=>!this.H(l));await Promise.allSettled(s.map(l=>this.removeProfile(l)))}getProfileForWorkspace(s){const l=this.G(s);return C.URI.isUri(l)?this.s.workspaces.get(l)??this.C.workspaces.get(l):this.s.emptyWindows.get(l)??this.C.emptyWindows.get(l)}G(s){return(0,k.$qi)(s)?s.uri:(0,k.$vi)(s)?s.configPath:s.id}H(s){return!!([...this.s.emptyWindows.values()].some(l=>this.w.extUri.isEqual(l.location,s.location))||[...this.s.workspaces.values()].some(l=>this.w.extUri.isEqual(l.location,s.location))||[...this.C.emptyWindows.values()].some(l=>this.w.extUri.isEqual(l.location,s.location))||[...this.C.workspaces.values()].some(l=>this.w.extUri.isEqual(l.location,s.location)))}I(s,l,b){const R=[...this.profiles,...s],I=[];this.s.profiles=[];for(let E of R)E.isDefault||l.some(A=>E.id===A.id)||(E=b.find(A=>E.id===A.id)??E,E.isTransient?this.s.profiles.push(E):I.push({location:E.location,name:E.name,shortName:E.shortName,icon:E.icon,useDefaultFlags:E.useDefaultFlags}));this.P(I),this.z=void 0,this.J(s,l,b)}J(s,l,b){this.h.fire({added:s,removed:l,updated:b,all:this.profiles})}L(s,l,b){b=l?.isTransient?!0:b,b||this.L(s,void 0,!0);const R=this.G(s),I=b?this.s:this.C;C.URI.isUri(R)?(I.workspaces.delete(R),l&&I.workspaces.set(R,l)):(I.emptyWindows.delete(R),l&&I.emptyWindows.set(R,l)),b||this.M()}M(){const s={};for(const[b,R]of this.C.workspaces.entries())s[b.toString()]=R.id;const l={};for(const[b,R]of this.C.emptyWindows.entries())l[b.toString()]=R.id;this.R({workspaces:s,emptyWindows:l}),this.z=void 0}N(s){const l={},b=this.D();if(s.workspaces)for(const[I,E]of Object.entries(s.workspaces)){const A=C.URI.parse(E);l[I]=this.w.extUri.isEqual(A,b.location)?b.id:this.w.extUri.basename(A)}const R={};if(s.emptyWindows)for(const[I,E]of Object.entries(s.emptyWindows)){const A=C.URI.parse(E);R[I]=this.w.extUri.isEqual(A,b.location)?b.id:this.w.extUri.basename(A)}return{workspaces:l,emptyWindows:R}}O(){return[]}P(s){throw new Error("not implemented")}Q(){return{}}R(s){throw new Error("not implemented")}S(){}};e.$jl=o,e.$jl=o=ve([se(0,d.$ni),se(1,c.$Gk),se(2,m.$el),se(3,v.$Aj)],o);class r extends o{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(s){this.a=s}Q(){return this.X}R(s){this.X=s}}e.$kl=r}),define(ae[82],ce([0,1,8,17,2,3,31,7,121,127,16,6,5,41,40,12,15,28]),function(X,e,n,D,S,M,C,P,d,c,y,v,k,g,m,w,p,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_p=e.$$p=e.$0p=e.ExtensionsProfileScanningErrorCode=void 0;var f;(function(o){o.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",o.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(f||(e.ExtensionsProfileScanningErrorCode=f={}));class h extends Error{constructor(r,i){super(r),this.code=i}}e.$0p=h,e.$$p=(0,v.$gi)("IExtensionsProfileScannerService");let $=class extends S.$Tc{constructor(r,i,s,l,b,R){super(),this.j=r,this.m=i,this.n=s,this.r=l,this.s=b,this.t=R,this.b=this.B(new M.$6d),this.onAddExtensions=this.b.event,this.c=this.B(new M.$6d),this.onDidAddExtensions=this.c.event,this.f=this.B(new M.$6d),this.onRemoveExtensions=this.f.event,this.g=this.B(new M.$6d),this.onDidRemoveExtensions=this.g.event,this.h=new C.$Ac}scanProfileExtensions(r,i){return this.u(r,void 0,i)}async addExtensionsToProfile(r,i){const s=[],l=[];try{return await this.u(i,b=>{const R=[];for(const I of b)r.some(([E])=>(0,c.$dp)(E.identifier,I.identifier)&&E.manifest.version!==I.version)?s.push(I):R.push(I);for(const[I,E]of r){const A=R.findIndex(T=>(0,c.$dp)(T.identifier,I.identifier)&&T.version===I.manifest.version),j={identifier:I.identifier,version:I.manifest.version,location:I.location,metadata:E};A===-1?(l.push(j),R.push(j)):R.splice(A,1,j)}return l.length&&this.b.fire({extensions:l,profileLocation:i}),s.length&&this.f.fire({extensions:s,profileLocation:i}),R}),l.length&&this.c.fire({extensions:l,profileLocation:i}),s.length&&this.g.fire({extensions:s,profileLocation:i}),l}catch(b){throw l.length&&this.c.fire({extensions:l,error:b,profileLocation:i}),s.length&&this.g.fire({extensions:s,error:b,profileLocation:i}),b}}async updateMetadata(r,i){const s=[];return await this.u(i,l=>{const b=[];for(const R of l){const I=r.find(([E])=>(0,c.$dp)(E.identifier,R.identifier)&&E.manifest.version===R.version);I&&(R.metadata={...R.metadata,...I[1]},s.push(R)),b.push(R)}return b}),s}async removeExtensionFromProfile(r,i){const s=[];try{await this.u(i,l=>{const b=[];for(const R of l)(0,c.$dp)(R.identifier,r.identifier)?s.push(R):b.push(R);return s.length&&this.f.fire({extensions:s,profileLocation:i}),b}),s.length&&this.g.fire({extensions:s,profileLocation:i})}catch(l){throw s.length&&this.g.fire({extensions:s,error:l,profileLocation:i}),l}}async u(r,i,s){return this.F(r).queue(async()=>{let l=[],b;try{const R=await this.m.readFile(r);b=JSON.parse(R.value.toString().trim()||"[]")}catch(R){if((0,y.$Xk)(R)!==1)throw R;if(this.r.extUri.isEqual(r,this.n.defaultProfile.extensionsResource)&&(b=await this.D()),!b&&s?.bailOutWhenFileNotFound)throw new h((0,p.$0)(R),"ERROR_PROFILE_NOT_FOUND")}if(b){Array.isArray(b)||this.w(r);let R=!1;for(const I of b){a(I)||this.w(r);let E;if((0,w.$Tf)(I.relativeLocation)&&I.relativeLocation)E=this.z(I.relativeLocation);else if((0,w.$Tf)(I.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${I.location}`);continue}else{E=P.URI.revive(I.location);const A=this.y(E);A&&(R=!0,I.relativeLocation=A)}(0,w.$1f)(I.metadata?.hasPreReleaseVersion)&&I.metadata?.preRelease&&(R=!0,I.metadata.hasPreReleaseVersion=!0),l.push({identifier:I.identifier,location:E,version:I.version,metadata:I.metadata})}R&&await this.m.writeFile(r,D.$te.fromString(JSON.stringify(b)))}if(i){l=i(l);const R=l.map(I=>({identifier:I.identifier,version:I.version,location:I.location.toJSON(),relativeLocation:this.y(I.location),metadata:I.metadata}));await this.m.writeFile(r,D.$te.fromString(JSON.stringify(R)))}return l})}w(r){const i=new h(`Invalid extensions content in ${r.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}y(r){return this.r.extUri.isEqual(this.r.extUri.dirname(r),this.j)?this.r.extUri.basename(r):void 0}z(r){return this.r.extUri.joinPath(this.j,r)}async D(){return this.C||(this.C=(async()=>{const r=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),i=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let s;try{s=(await this.m.readFile(r)).value.toString()}catch(b){if((0,y.$Xk)(b)===1)return;throw b}this.t.info("Migrating extensions from old default profile location",r.toString());let l;try{const b=JSON.parse(s);Array.isArray(b)&&b.every(R=>a(R))?l=b:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",b)}catch(b){this.t.error(b)}if(l)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,D.$te.fromString(JSON.stringify(l)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",r.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(b){if((0,y.$Xk)(b)===3)this.t.info("Migration from old default profile location to new location is done by another window",r.toString(),this.n.defaultProfile.extensionsResource.toString());else throw b}try{await this.m.del(r)}catch(b){(0,y.$Xk)(b)!==1&&this.t.error(b)}try{await this.m.del(i)}catch(b){(0,y.$Xk)(b)!==1&&this.t.error(b)}return l})()),this.C}F(r){let i=this.h.get(r);return i||(i=new n.$nh,this.h.set(r,i)),i}};e.$_p=$,e.$_p=$=ve([se(1,y.$Gk),se(2,g.$gl),se(3,m.$el),se(4,u.$Fl),se(5,k.$Aj)],$);function a(o){return(0,w.$Vf)(o)&&(0,d.$No)(o.identifier)&&(t(o.location)||(0,w.$Tf)(o.location)&&o.location)&&((0,w.$1f)(o.relativeLocation)||(0,w.$Tf)(o.relativeLocation))&&o.version&&(0,w.$Tf)(o.version)}function t(o){return o?(0,w.$Tf)(o.path)&&(0,w.$Tf)(o.scheme):!1}}),define(ae[132],ce([0,1,22,8,35,17,15,42,154,2,13,9,4,19,207,73,12,7,174,38,127,124,206,16,6,5,27,3,76,82,41,40,205]),function(X,e,n,D,S,M,C,P,d,c,y,v,k,g,m,w,p,u,f,h,$,a,t,o,r,i,s,l,b,R,I,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gq=e.$fq=e.$eq=e.$dq=e.$cq=e.Translations=void 0;var j;(function(ue){function Z(Y,U){if(Y===U)return!0;const L=Object.keys(Y),N=new Set;for(const G of Object.keys(U))N.add(G);if(L.length!==N.size)return!1;for(const G of L){if(Y[G]!==U[G])return!1;N.delete(G)}return N.size===0}ue.equals=Z})(j||(e.Translations=j={})),e.$cq=(0,r.$gi)("IExtensionsScannerService");let T=class extends c.$Tc{constructor(Z,Y,U,L,N,G,q,oe,he,J,O,F){super(),this.systemExtensionsLocation=Z,this.userExtensionsLocation=Y,this.r=U,this.s=L,this.t=N,this.u=G,this.w=q,this.y=oe,this.z=he,this.C=J,this.D=O,this.F=F,this.g=this.B(new l.$6d),this.onDidChangeCache=this.g.event,this.h=(0,g.$Tg)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(K,this.s,this.h)),this.m=this.B(this.F.createInstance(K,this.s,this.h)),this.n=this.B(this.F.createInstance(V,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,$.$op)(this.w,this.y)),this.G}async scanAllExtensions(Z,Y,U){const[L,N]=await Promise.all([this.scanSystemExtensions(Z),this.scanUserExtensions(Y)]),G=U?await this.scanExtensionsUnderDevelopment(Z,[...L,...N]):[];return this.L(L,N,G,await this.getTargetPlatform(),!0)}async scanSystemExtensions(Z){const Y=[];Y.push(this.M(!!Z.useCache,Z.language)),Y.push(this.N(Z.language,!!Z.checkControlFile));const[U,L]=await Promise.all(Y);return this.J([...U,...L],0,Z,!1)}async scanUserExtensions(Z){const Y=Z.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",Y);const U=this.D.extUri.isEqual(Z.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,L=await this.P(Y,!!Z.profileLocation,1,!Z.includeUninstalled,Z.language,!0,U),N=Z.useCache&&!L.devMode&&L.excludeObsolete?this.m:this.n;let G;try{G=await N.scanExtensions(L)}catch(q){if(q instanceof R.$0p&&q.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),G=await N.scanExtensions(L);else throw q}return G=await this.J(G,1,Z,!0),this.y.trace("Scanned user extensions:",G.length),G}async scanExtensionsUnderDevelopment(Z,Y){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const U=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(L=>L.scheme===y.Schemas.file).map(async L=>{const N=await this.P(L,!1,1,!0,Z.language,!1,void 0);return(await this.n.scanOneOrMultipleExtensions(N)).map(q=>(q.type=Y.find(oe=>(0,$.$dp)(oe.identifier,q.identifier))?.type??q.type,this.n.validate(q,N)))}))).flat();return this.J(U,"development",Z,!0)}return[]}async scanExistingExtension(Z,Y,U){const L=await this.P(Z,!1,Y,!0,U.language,!0,void 0),N=await this.n.scanExtension(L);return!N||!U.includeInvalid&&!N.isValid?null:N}async scanOneOrMultipleExtensions(Z,Y,U){const L=await this.P(Z,!1,Y,!0,U.language,!0,void 0),N=await this.n.scanOneOrMultipleExtensions(L);return this.J(N,Y,U,!0)}async scanMetadata(Z){const Y=(0,g.$Tg)(Z,"package.json"),U=(await this.w.readFile(Y)).value.toString();return JSON.parse(U).__metadata}async updateMetadata(Z,Y){const U=(0,g.$Tg)(Z,"package.json"),L=(await this.w.readFile(U)).value.toString(),N=JSON.parse(L);Y.isMachineScoped===!1&&delete Y.isMachineScoped,Y.isBuiltin===!1&&delete Y.isBuiltin,N.__metadata={...N.__metadata,...Y},await this.w.writeFile((0,g.$Tg)(Z,"package.json"),M.$te.fromString(JSON.stringify(N,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(Z){if(Z instanceof R.$0p&&Z.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw Z}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const Z=await this.scanUserExtensions({includeInvalid:!0});if(Z.length)await this.u.addExtensionsToProfile(Z.map(Y=>[Y,Y.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,M.$te.fromString(JSON.stringify([])))}catch(Y){(0,o.$Xk)(Y)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,C.$0)(Y))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(Z){this.y.error(Z)}finally{this.H=void 0}})()),this.H}async J(Z,Y,U,L){return U.includeAllVersions||(Z=this.L(Y===0?Z:void 0,Y===1?Z:void 0,Y==="development"?Z:void 0,await this.getTargetPlatform(),L)),U.includeInvalid||(Z=Z.filter(N=>N.isValid)),Z.sort((N,G)=>{const q=v.$nc(N.location.fsPath),oe=v.$nc(G.location.fsPath);return q<oe?-1:q>oe?1:0})}L(Z,Y,U,L,N){const G=(oe,he,J)=>{if(oe.isValid&&!he.isValid)return!1;if(oe.isValid===he.isValid){if(N&&m.gt(oe.manifest.version,he.manifest.version))return this.y.debug(`Skipping extension ${he.location.path} with lower version ${he.manifest.version} in favour of ${oe.location.path} with version ${oe.manifest.version}`),!1;if(m.eq(oe.manifest.version,he.manifest.version)){if(oe.type===0)return this.y.debug(`Skipping extension ${he.location.path} in favour of system extension ${oe.location.path} with same version`),!1;if(oe.targetPlatform===L)return this.y.debug(`Skipping extension ${he.location.path} from different target platform ${he.targetPlatform}`),!1}}return J?this.y.warn(`Overwriting user extension ${oe.location.path} with ${he.location.path}.`):this.y.debug(`Overwriting user extension ${oe.location.path} with ${he.location.path}.`),!0},q=new a.$Cm;return Z?.forEach(oe=>{const he=q.get(oe.identifier.id);(!he||G(he,oe,!1))&&q.set(oe.identifier.id,oe)}),Y?.forEach(oe=>{const he=q.get(oe.identifier.id);if(!he&&Z&&oe.type===0){this.y.debug(`Skipping obsolete system extension ${oe.location.path}.`);return}(!he||G(he,oe,!1))&&q.set(oe.identifier.id,oe)}),U?.forEach(oe=>{const he=q.get(oe.identifier.id);(!he||G(he,oe,!0))&&q.set(oe.identifier.id,oe),q.set(oe.identifier.id,oe)}),[...q.values()]}async M(Z,Y){this.y.trace("Started scanning system extensions");const U=await this.P(this.systemExtensionsLocation,!1,0,!0,Y,!0,void 0),N=await(Z&&!U.devMode?this.j:this.n).scanExtensions(U);return this.y.trace("Scanned system extensions:",N.length),N}async N(Z,Y){const U=this.z.isBuilt?[]:this.C.builtInExtensions;if(!U?.length)return[];this.y.trace("Started scanning dev system extensions");const L=Y?await this.O():{},N=[],G=u.URI.file(v.$hc(v.$jc(y.$Ag.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const oe of U){const he=L[oe.name]||"marketplace";switch(he){case"disabled":break;case"marketplace":N.push((0,g.$Tg)(G,oe.name));break;default:N.push(u.URI.file(he));break}}const q=await Promise.all(N.map(async oe=>this.n.scanExtension(await this.P(oe,!1,0,!0,Z,!0,void 0))));return this.y.trace("Scanned dev system extensions:",q.length),(0,n.$Hb)(q)}async O(){try{const Z=await this.w.readFile(this.r);return JSON.parse(Z.value.toString())}catch{return{}}}async P(Z,Y,U,L,N,G,q){const oe=await this.f(N??k.$w),he=await this.Q(Z),J=Y&&!this.D.extUri.isEqual(Z,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,O=J?await this.Q(J):void 0;return new W(Z,he,J,O,Y,q,U,L,G,this.C.version,this.C.date,this.C.commit,!this.z.isBuilt,N,oe)}async Q(Z){try{const Y=await this.w.stat(Z);if(typeof Y.mtime=="number")return Y.mtime}catch{}}};e.$dq=T,e.$dq=T=ve([se(4,I.$gl),se(5,R.$$p),se(6,o.$Gk),se(7,i.$Aj),se(8,h.$ni),se(9,s.$Sj),se(10,E.$el),se(11,r.$fi)],T);class W{constructor(Z,Y,U,L,N,G,q,oe,he,J,O,F,x,z,Q){this.location=Z,this.mtime=Y,this.applicationExtensionslocation=U,this.applicationExtensionslocationMtime=L,this.profile=N,this.profileScanOptions=G,this.type=q,this.excludeObsolete=oe,this.validate=he,this.productVersion=J,this.productDate=O,this.productCommit=F,this.devMode=x,this.language=z,this.translations=Q}static createNlsConfiguration(Z){return{language:Z.language,pseudo:Z.language==="pseudo",devMode:Z.devMode,translations:Z.translations}}static equals(Z,Y){return(0,g.$Mg)(Z.location,Y.location)&&Z.mtime===Y.mtime&&(0,g.$Mg)(Z.applicationExtensionslocation,Y.applicationExtensionslocation)&&Z.applicationExtensionslocationMtime===Y.applicationExtensionslocationMtime&&Z.profile===Y.profile&&S.$Pn(Z.profileScanOptions,Y.profileScanOptions)&&Z.type===Y.type&&Z.excludeObsolete===Y.excludeObsolete&&Z.validate===Y.validate&&Z.productVersion===Y.productVersion&&Z.productDate===Y.productDate&&Z.productCommit===Y.productCommit&&Z.devMode===Y.devMode&&Z.language===Y.language&&j.equals(Z.translations,Y.translations)}}e.$eq=W;let V=class extends c.$Tc{constructor(Z,Y,U,L,N){super(),this.f=Z,this.g=Y,this.h=U,this.j=L,this.m=N}async scanExtensions(Z){const Y=Z.profile?await this.r(Z):await this.n(Z);let U={};if(Z.excludeObsolete&&Z.type===1)try{const L=(await this.j.readFile(this.f)).value.toString();U=JSON.parse(L)}catch{}return(0,p.$7f)(U)?Y:Y.filter(L=>!U[$.$ep.create(L).toString()])}async n(Z){const Y=await this.j.resolve(Z.location);if(!Y.children?.length)return[];const U=await Promise.all(Y.children.map(async L=>{if(!L.isDirectory||Z.type===1&&(0,g.$Qg)(L.resource).indexOf(".")===0)return null;const N=new W(L.resource,Z.mtime,Z.applicationExtensionslocation,Z.applicationExtensionslocationMtime,Z.profile,Z.profileScanOptions,Z.type,Z.excludeObsolete,Z.validate,Z.productVersion,Z.productDate,Z.productCommit,Z.devMode,Z.language,Z.translations);return this.scanExtension(N)}));return(0,n.$Hb)(U).sort((L,N)=>L.location.path<N.location.path?-1:1)}async r(Z){let Y=await this.s(Z.location,()=>!0,Z);if(Z.applicationExtensionslocation&&!this.h.extUri.isEqual(Z.location,Z.applicationExtensionslocation)){Y=Y.filter(L=>!L.metadata?.isApplicationScoped);const U=await this.s(Z.applicationExtensionslocation,L=>!!L.metadata?.isBuiltin||!!L.metadata?.isApplicationScoped,Z);Y.push(...U)}return Y}async s(Z,Y,U){const L=await this.g.scanProfileExtensions(Z,U.profileScanOptions);if(!L.length)return[];const N=await Promise.all(L.map(async G=>{if(Y(G)){const q=new W(G.location,U.mtime,U.applicationExtensionslocation,U.applicationExtensionslocationMtime,U.profile,U.profileScanOptions,U.type,U.excludeObsolete,U.validate,U.productVersion,U.productDate,U.productCommit,U.devMode,U.language,U.translations);return this.scanExtension(q,G.metadata)}return null}));return(0,n.$Hb)(N)}async scanOneOrMultipleExtensions(Z){try{if(await this.j.exists((0,g.$Tg)(Z.location,"package.json"))){const Y=await this.scanExtension(Z);return Y?[Y]:[]}else return await this.scanExtensions(Z)}catch(Y){return this.m.error(`Error scanning extensions at ${Z.location.path}:`,(0,C.$0)(Y)),[]}}async scanExtension(Z,Y){try{let U=await this.scanExtensionManifest(Z.location);if(U){U.publisher||(U.publisher=a.$wm),Y=Y??U.__metadata,delete U.__metadata;const L=(0,$.$ip)(U.publisher,U.name),N=Y?.id?{id:L,uuid:Y.id}:{id:L},G=Y?.isSystem?0:Z.type,q=G===0||!!Y?.isBuiltin;U=await this.t(Z.location,U,W.createNlsConfiguration(Z));const oe={type:G,identifier:N,manifest:U,location:Z.location,isBuiltin:q,targetPlatform:Y?.targetPlatform??"undefined",metadata:Y,isValid:!0,validations:[]};return Z.validate?this.validate(oe,Z):oe}}catch(U){Z.type!==0&&this.m.error(U)}return null}validate(Z,Y){let U=!0;const L=(0,t.$tp)(Y.productVersion,Y.productDate,Y.location,Z.manifest,Z.isBuiltin);for(const[N,G]of L)N===w.default.Error&&(U=!1,this.m.error(this.z(Y.location,G)));return Z.isValid=U,Z.validations=L,Z}async scanExtensionManifest(Z){const Y=(0,g.$Tg)(Z,"package.json");let U;try{U=(await this.j.readFile(Y)).value.toString()}catch(N){return(0,o.$Xk)(N)!==1&&this.m.error(this.z(Z,(0,f.localize)(0,null,Y.path,N.message))),null}let L;try{L=JSON.parse(U)}catch{const G=[];(0,P.$sn)(U,G);for(const q of G)this.m.error(this.z(Z,(0,f.localize)(1,null,Y.path,q.offset,q.length,(0,d.$aq)(q.error))));return null}return(0,P.$Bn)(L)!=="object"?(this.m.error(this.z(Z,(0,f.localize)(2,null,Y.path))),null):L}async t(Z,Y,U){const L=await this.u(Z,Y,U);if(L)try{const N=[],G=await this.w(L.default,N);if(N.length>0)return N.forEach(oe=>{this.m.error(this.z(Z,(0,f.localize)(3,null,L.default?.path,(0,d.$aq)(oe.error))))}),Y;if((0,P.$Bn)(L)!=="object")return this.m.error(this.z(Z,(0,f.localize)(4,null,L.default?.path))),Y;const q=L.values||Object.create(null);return(0,A.$bq)(this.m,Y,q,G)}catch{}return Y}async u(Z,Y,U){const L=(0,g.$Tg)(Z,"package.nls.json"),N=(he,J)=>{J.forEach(O=>{this.m.error(this.z(Z,(0,f.localize)(5,null,he?.path,(0,d.$aq)(O.error))))})},G=he=>{this.m.error(this.z(Z,(0,f.localize)(6,null,he?.path)))},q=`${Y.publisher}.${Y.name}`,oe=U.translations[q];if(oe)try{const he=u.URI.file(oe),J=(await this.j.readFile(he)).value.toString(),O=[],F=(0,P.$sn)(J,O);return O.length>0?(N(he,O),{values:void 0,default:L}):(0,P.$Bn)(F)!=="object"?(G(he),{values:void 0,default:L}):{values:F.contents?F.contents.package:void 0,default:L}}catch{return{values:void 0,default:L}}else{if(!await this.j.exists(L))return;let J;try{J=await this.y(Z,U)}catch{return}if(!J.localized)return{values:void 0,default:J.original};try{const O=(await this.j.readFile(J.localized)).value.toString(),F=[],x=(0,P.$sn)(O,F);return F.length>0?(N(J.localized,F),{values:void 0,default:J.original}):(0,P.$Bn)(x)!=="object"?(G(J.localized),{values:void 0,default:J.original}):{values:x,default:J.original}}catch{return{values:void 0,default:J.original}}}}async w(Z,Y){if(Z)try{const U=(await this.j.readFile(Z)).value.toString();return(0,P.$sn)(U,Y)}catch{}}y(Z,Y){return new Promise((U,L)=>{const N=G=>{const q=(0,g.$Tg)(Z,`package.nls.${G}.json`);this.j.exists(q).then(oe=>{oe&&U({localized:q,original:(0,g.$Tg)(Z,"package.nls.json")});const he=G.lastIndexOf("-");he===-1?U({localized:(0,g.$Tg)(Z,"package.nls.json"),original:null}):(G=G.substring(0,he),N(G))})};if(Y.devMode||Y.pseudo||!Y.language)return U({localized:(0,g.$Tg)(Z,"package.nls.json"),original:null});N(Y.language)})}z(Z,Y){return`[${Z.path}]: ${Y}`}};V=ve([se(1,R.$$p),se(2,E.$el),se(3,o.$Gk),se(4,i.$Aj)],V);let K=class extends V{constructor(Z,Y,U,L,N,G,q){super(Y,L,N,G,q),this.G=Z,this.H=U,this.D=this.B(new D.$eh(3e3)),this.F=this.B(new l.$6d),this.onDidChangeCache=this.F.event}async scanExtensions(Z){const Y=this.M(Z),U=await this.I(Y);if(this.C=Z,U&&U.input&&W.equals(U.input,this.C))return this.m.debug("Using cached extensions scan result",Z.location.toString()),this.D.trigger(()=>this.L()),U.result.map(N=>(N.location=u.URI.revive(N.location),N));const L=await super.scanExtensions(Z);return await this.J(Y,{input:Z,result:L}),L}async I(Z){try{const Y=await this.j.readFile(Z),U=JSON.parse(Y.value.toString());return{result:U.result,input:(0,b.$Ph)(U.input)}}catch(Y){this.m.debug("Error while reading the extension cache file:",Z.path,(0,C.$0)(Y))}return null}async J(Z,Y){try{await this.j.writeFile(Z,M.$te.fromString(JSON.stringify(Y)))}catch(U){this.m.debug("Error while writing the extension cache file:",Z.path,(0,C.$0)(U))}}async L(){if(!this.C)return;const Z=this.M(this.C),Y=await this.I(Z);if(!Y)return;const U=Y.result,L=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!S.$Pn(L,U))try{this.m.info("Invalidating Cache",U,L),await this.j.del(Z),this.F.fire()}catch(N){this.m.error(N)}}M(Z){const Y=this.N(Z);return this.h.extUri.joinPath(Y.cacheHome,Z.type===0?a.$vm:a.$um)}N(Z){return Z.type===0?this.H.defaultProfile:Z.profile?this.h.extUri.isEqual(Z.location,this.G.extensionsResource)?this.G:this.H.profiles.find(Y=>this.h.extUri.isEqual(Z.location,Y.extensionsResource))??this.G:this.H.defaultProfile}};K=ve([se(2,I.$gl),se(3,R.$$p),se(4,E.$el),se(5,o.$Gk),se(6,i.$Aj)],K);function le(ue,Z){const Y=(0,$.$gp)(ue.manifest.publisher,ue.manifest.name);return{id:Y,identifier:new a.$Am(Y),isBuiltin:ue.type===0,isUserBuiltin:ue.type===1&&ue.isBuiltin,isUnderDevelopment:Z,extensionLocation:ue.location,uuid:ue.identifier.uuid,targetPlatform:ue.targetPlatform,...ue.manifest}}e.$fq=le;class re extends T{constructor(Z,Y,U,L,N,G,q,oe,he,J,O,F){super(Z,Y,(0,g.$Tg)(U,".vscode-oss-dev","extensions","control.json"),L,N,G,q,oe,he,J,O,F),this.R=(async()=>{if(k.$z)try{const x=await this.w.readFile(u.URI.file(k.$z));return JSON.parse(x.value.toString())}catch{}return Object.create(null)})()}f(Z){return this.R}}e.$gq=re}),define(ae[278],ce([0,1,5,41,40,28,82,16,38,7]),function(X,e,n,D,S,M,C,P,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OP=void 0;let y=class extends C.$_p{constructor(k,g,m,w,p,u){super(c.URI.file(k.extensionsPath),g,m,w,p,u)}};e.$OP=y,e.$OP=y=ve([se(0,d.$oi),se(1,P.$Gk),se(2,D.$gl),se(3,S.$el),se(4,M.$Fl),se(5,n.$Aj)],y)}),define(ae[279],ce([0,1,7,38,82,132,16,6,5,27,40,41]),function(X,e,n,D,S,M,C,P,d,c,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aac=void 0;let k=class extends M.$gq{constructor(m,w,p,u,f,h,$,a){super(n.URI.file(f.builtinExtensionsPath),n.URI.file(f.extensionsPath),f.userHome,m.defaultProfile,m,w,p,u,f,h,$,a)}};e.$Aac=k,e.$Aac=k=ve([se(0,v.$gl),se(1,S.$$p),se(2,C.$Gk),se(3,d.$Aj),se(4,D.$oi),se(5,c.$Sj),se(6,y.$el),se(7,P.$fi)],k)}),define(ae[280],ce([0,1,14,2,13,9,4,59,7,32,37,38,5,41]),function(X,e,n,D,S,M,C,P,d,c,y,v,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sac=void 0;let m=class extends D.$Tc{constructor(p,u,f){super(),this.c=p,this.f=f,this.a=P.$mi.forPaths(!C.$k),this.b=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp"]),this.addValidFileRoot(p.appRoot),this.addValidFileRoot(p.extensionsPath),this.addValidFileRoot(u.defaultProfile.globalStorageHome.with({scheme:S.Schemas.file}).fsPath),this.addValidFileRoot(p.workspaceStorageHome.with({scheme:S.Schemas.file}).fsPath),this.g()}g(){const{defaultSession:p}=n.session;p.protocol.registerFileProtocol(S.Schemas.vscodeFileResource,(u,f)=>this.j(u,f)),p.protocol.interceptFileProtocol(S.Schemas.file,(u,f)=>this.h(u,f)),this.B((0,D.$Rc)(()=>{p.protocol.unregisterProtocol(S.Schemas.vscodeFileResource),p.protocol.uninterceptProtocol(S.Schemas.file)}))}addValidFileRoot(p){const u=(0,M.$hc)(p);return this.a.get(u)?D.$Tc.None:(this.a.set(u,!0),(0,D.$Rc)(()=>this.a.delete(u)))}h(p,u){const f=d.URI.parse(p.url);return this.f.error(`Refused to load resource ${f.fsPath} from ${S.Schemas.file}: protocol (original URL: ${p.url})`),u({error:-3})}j(p,u){const f=this.m(p);let h;return this.c.crossOriginIsolated&&((0,M.$nc)(f)==="workbench.html"||(0,M.$nc)(f)==="workbench-dev.html"?h=S.COI.CoopAndCoep:h=S.COI.getHeadersFromQuery(p.url)),this.a.findSubstr(f)?u({path:f,headers:h}):this.b.has((0,M.$oc)(f).toLowerCase())?u({path:f}):(this.f.error(`${S.Schemas.vscodeFileResource}: Refused to load resource ${f} from ${S.Schemas.vscodeFileResource}: protocol (original URL: ${p.url})`),u({error:-3}))}m(p){const u=d.URI.parse(p.url),f=S.$Ag.uriToFileUri(u);return(0,M.$hc)(f.fsPath)}createIPCObjectUrl(){let p;const u=d.URI.from({scheme:"vscode",path:(0,c.$Cg)()}),f=u.toString(),h=async()=>p;return y.$RV.handle(f,h),this.f.trace(`IPC Object URL: Registered new channel ${f}.`),{resource:u,update:$=>p=$,dispose:()=>{this.f.trace(`IPC Object URL: Removed channel ${f}.`),y.$RV.removeHandler(f)}}}};e.$Sac=m,e.$Sac=m=ve([se(0,v.$oi),se(1,g.$gl),se(2,k.$Aj)],m)}),define(ae[97],ce([0,1,8,3,2,66,12,115,6,41]),function(X,e,n,D,S,M,C,P,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Op=e.$Np=e.$Mp=e.$Lp=e.$Kp=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$Jp=e.$Ip=e.$Hp=void 0,e.$Hp="__$__isNewStorageMarker",e.$Ip="__$__targetStorageMarker",e.$Jp=(0,d.$gi)("storageService");var y;(function(f){f[f.NONE=0]="NONE",f[f.SHUTDOWN=1]="SHUTDOWN"})(y||(e.WillSaveStateReason=y={}));var v;(function(f){f[f.APPLICATION=-1]="APPLICATION",f[f.PROFILE=0]="PROFILE",f[f.WORKSPACE=1]="WORKSPACE"})(v||(e.StorageScope=v={}));var k;(function(f){f[f.USER=0]="USER",f[f.MACHINE=1]="MACHINE"})(k||(e.StorageTarget=k={}));function g(f){const h=f.get(e.$Ip);if(h)try{return JSON.parse(h)}catch{}return Object.create(null)}e.$Kp=g;class m extends S.$Tc{static{this.a=60*1e3}constructor(h={flushInterval:m.a}){super(),this.m=h,this.b=this.B(new D.$9d),this.c=this.B(new D.$9d),this.onDidChangeTarget=this.c.event,this.f=this.B(new D.$6d),this.onWillSaveState=this.f.event,this.h=this.B(new n.$sh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new S.$Uc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(h,$,a){return D.Event.filter(this.b.event,t=>t.scope===h&&($===void 0||t.key===$),a)}n(){this.j.value=(0,n.$wh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,S.$Oc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,M.mark)("code/willInitStorage");try{await this.O()}finally{(0,M.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(h,$){const{key:a,external:t}=$;if(a===e.$Ip){switch(h){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:h})}else this.b.fire({scope:h,key:a,target:this.J(h)[a],external:t})}w(h){this.f.fire({reason:h})}get(h,$,a){return this.P($)?.get(h,a)}getBoolean(h,$,a){return this.P($)?.getBoolean(h,a)}getNumber(h,$,a){return this.P($)?.getNumber(h,a)}getObject(h,$,a){return this.P($)?.getObject(h,a)}storeAll(h,$){this.y(()=>{for(const a of h)this.store(a.key,a.value,a.scope,a.target,$)})}store(h,$,a,t,o=!1){if((0,C.$3f)($)){this.remove(h,a,o);return}this.y(()=>{this.z(h,a,t),this.P(a)?.set(h,$,o)})}remove(h,$,a=!1){this.y(()=>{this.z(h,$,void 0),this.P($)?.delete(h,a)})}y(h){this.b.pause(),this.c.pause();try{h()}finally{this.b.resume(),this.c.resume()}}keys(h,$){const a=[],t=this.J(h);for(const o of Object.keys(t))t[o]===$&&a.push(o);return a}z(h,$,a,t=!1){const o=this.J($);typeof a=="number"?o[h]!==a&&(o[h]=a,this.P($)?.set(e.$Ip,JSON.stringify(o),t)):typeof o[h]=="number"&&(delete o[h],this.P($)?.set(e.$Ip,JSON.stringify(o),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(h){switch(h){case-1:return this.I;case 0:return this.G;default:return this.D}}L(h){const $=this.P(h);return $?g($):Object.create(null)}isNew(h){return this.getBoolean(e.$Hp,h)===!0}async flush(h=y.NONE){this.f.fire({reason:h});const $=this.P(-1),a=this.P(0),t=this.P(1);switch(h){case y.NONE:await n.Promises.settled([$?.whenFlushed()??Promise.resolve(),a?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case y.SHUTDOWN:await n.Promises.settled([$?.flush(0)??Promise.resolve(),a?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const h=this.P(-1)?.items??new Map,$=this.P(0)?.items??new Map,a=this.P(1)?.items??new Map;return u(h,$,a,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(h){return await this.flush(),this.P(h)?.optimize()}async switch(h,$){return this.w(y.NONE),(0,c.$fl)(h)?this.R(h,$):this.S(h,$)}M(h,$){return!(h.id===$.id||w($)&&w(h))}N(h,$,a){this.y(()=>{const t=new Set;for(const[o,r]of h)t.add(o),$.get(o)!==r&&this.u(a,{key:o,external:!0});for(const[o]of $.items)t.has(o)||this.u(a,{key:o,external:!0})})}}e.$Lp=m;function w(f){return f.isDefault||!!f.useDefaultFlags?.globalState}e.$Mp=w;class p extends m{constructor(){super(),this.U=this.B(new P.$Fp(new P.$Gp,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new P.$Fp(new P.$Gp,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new P.$Fp(new P.$Gp,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(h=>this.u(1,h))),this.B(this.W.onDidChangeStorage(h=>this.u(0,h))),this.B(this.U.onDidChangeStorage(h=>this.u(-1,h)))}P(h){switch(h){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(h){switch(h){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(h){return!1}}e.$Np=p;async function u(f,h,$,a,t,o){const r=j=>{try{return JSON.parse(j)}catch{return j}},i=new Map,s=new Map;f.forEach((j,T)=>{i.set(T,j),s.set(T,r(j))});const l=new Map,b=new Map;h.forEach((j,T)=>{l.set(T,j),b.set(T,r(j))});const R=new Map,I=new Map;$.forEach((j,T)=>{R.set(T,j),I.set(T,r(j))}),console.group(a!==t?`Storage: Application (path: ${a})`:`Storage: Application & Profile (path: ${a}, default profile)`);const E=[];if(i.forEach((j,T)=>{E.push({key:T,value:j})}),console.table(E),console.groupEnd(),console.log(s),a!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const j=[];l.forEach((T,W)=>{j.push({key:W,value:T})}),console.table(j),console.groupEnd(),console.log(b)}console.group(`Storage: Workspace (path: ${o})`);const A=[];R.forEach((j,T)=>{A.push({key:T,value:j})}),console.table(A),console.groupEnd(),console.log(I)}e.$Op=u}),define(ae[281],ce([0,1,22,8,3,2,9,72,7,21,115,163,5,97,28,30,13]),function(X,e,n,D,S,M,C,P,d,c,y,v,k,g,m,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$r_b=e.$q_b=e.$p_b=e.$o_b=void 0;class u extends M.$Tc{static{this.a=2e3}get storage(){return this.f}constructor(r,i){super(),this.m=r,this.n=i,this.b=this.B(new S.$6d),this.onDidChangeStorage=this.b.event,this.c=this.B(new S.$6d),this.onDidCloseStorage=this.c.event,this.f=this.B(new y.$Fp(new y.$Gp,{hint:y.StorageHint.STORAGE_IN_MEMORY})),this.g=void 0,this.h=new D.$Dh,this.whenInit=this.h.p,this.j=y.StorageState.None}isInMemory(){return this.f.isInMemory()}init(){return this.g||(this.g=(async()=>{if(this.j===y.StorageState.None)try{const r=this.B(await this.t());this.f.dispose(),this.f=r,this.B(r.onDidChangeStorage(s=>this.b.fire(s))),await this.s(r);const i=r.getBoolean(g.$Hp);i===void 0?r.set(g.$Hp,!0):i&&r.set(g.$Hp,!1)}catch(r){this.m.error(`[storage main] initialize(): Unable to init storage due to ${r}`)}finally{this.j=y.StorageState.Initialized,this.h.complete()}})()),this.g}r(){return{logTrace:this.m.getLevel()===k.LogLevel.Trace?r=>this.m.trace(r):void 0,logError:r=>this.m.error(r)}}s(r){return r.init()}get items(){return this.f.items}get(r,i){return this.f.get(r,i)}set(r,i){return this.f.set(r,i)}delete(r){return this.f.delete(r)}optimize(){return this.f.optimize()}async close(){const r=new P.$2d(!1);await this.w(),r.stop(),r.elapsed()>u.a&&await this.u(r),this.c.fire()}async u(r){if(this.path)try{const i=(0,n.top)(Array.from(this.f.items.entries()).map(([l,b])=>({key:l,length:b.length})),(l,b)=>b.length-l.length,5).map(l=>`${l.key}:${l.length}`).join(", "),s=(await this.n.stat(d.URI.file(this.path))).size;this.m.warn(`[storage main] detected slow close() operation: Time: ${r.elapsed()}ms, DB size: ${s}b, Large Keys: ${i}`)}catch(i){this.m.error("[storage main] figuring out stats for slow DB on close() resulted in an error",i)}}async w(){this.g&&await this.g,this.j=y.StorageState.Closed,await this.f.close()}}class f extends u{static{this.y="state.vscdb"}get path(){if(!this.C.useInMemoryStorage)return(0,C.$jc)(this.z.globalStorageHome.with({scheme:p.Schemas.file}).fsPath,f.y)}constructor(r,i,s,l){super(s,l),this.z=r,this.C=i}async t(){return new y.$Fp(new v.$kW(this.path??v.$kW.IN_MEMORY_PATH,{logging:this.r()}),this.path?void 0:{hint:y.StorageHint.STORAGE_IN_MEMORY})}}class h extends f{constructor(r,i,s,l){super(r,i,s,l)}}e.$o_b=h;class $ extends f{constructor(r,i,s,l){super(i.defaultProfile,r,s,l)}async s(r){await super.s(r),this.G(r)}G(r){r.get(m.$Il,void 0)===void 0&&r.set(m.$Il,new Date().toUTCString());const s=r.get(m.$Hl,void 0),l=new Date().toUTCString();r.set(m.$Jl,typeof s>"u"?null:s),r.set(m.$Hl,l)}}e.$p_b=$;class a extends u{static{this.y="state.vscdb"}static{this.z="workspace.json"}get path(){if(!this.D.useInMemoryStorage)return(0,C.$jc)(this.F.workspaceStorageHome.with({scheme:p.Schemas.file}).fsPath,this.C.id,a.y)}constructor(r,i,s,l,b){super(s,b),this.C=r,this.D=i,this.F=l}async t(){const{storageFilePath:r,wasCreated:i}=await this.H();return new y.$Fp(new v.$kW(r,{logging:this.r()}),{hint:this.D.useInMemoryStorage?y.StorageHint.STORAGE_IN_MEMORY:i?y.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async H(){if(this.D.useInMemoryStorage)return{storageFilePath:v.$kW.IN_MEMORY_PATH,wasCreated:!0};const r=(0,C.$jc)(this.F.workspaceStorageHome.with({scheme:p.Schemas.file}).fsPath,this.C.id),i=(0,C.$jc)(r,a.y);return await c.Promises.exists(r)?{storageFilePath:i,wasCreated:!1}:(await c.Promises.mkdir(r,{recursive:!0}),this.I(r),{storageFilePath:i,wasCreated:!0})}async I(r){let i;if((0,w.$qi)(this.C)?i={folder:this.C.uri.toString()}:(0,w.$vi)(this.C)&&(i={workspace:this.C.configPath.toString()}),i)try{const s=(0,C.$jc)(r,a.z);await c.Promises.exists(s)||await c.Promises.writeFile(s,JSON.stringify(i,void 0,2))}catch(s){this.m.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${s}`)}}}e.$q_b=a;class t extends u{get path(){}async t(){return new y.$Fp(new y.$Gp,{hint:y.StorageHint.STORAGE_IN_MEMORY})}}e.$r_b=t}),define(ae[282],ce([0,1,3,2,97]),function(X,e,n,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cac=void 0;class M extends D.$Tc{constructor(P,d,c){super(),this.b=P,this.c=d,this.f=c;const y=this.B(new D.$Uc);this.a=this.B(new n.$6d({onWillAddFirstListener:()=>y.value=this.g(),onDidRemoveLastListener:()=>y.value=void 0}))}g(){this.f.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const P=new D.$Sc;return P.add(n.Event.debounce(this.b.applicationStorage.onDidChangeStorage,(d,c)=>(d?d.push(c.key):d=[c.key],d),100)(d=>this.h(d))),P.add(n.Event.debounce(this.b.onDidChangeProfileStorage,(d,c)=>{d||(d=new Map);let y=d.get(c.profile.id);return y||d.set(c.profile.id,y={profile:c.profile,keys:[],storage:c.storage}),y.keys.push(c.key),d},100)(d=>this.j(d))),P}h(P){const d=P.includes(S.$Ip)?[this.c.defaultProfile]:[],c=[];if(P=P.filter(y=>y!==S.$Ip),P.length){const y=(0,S.$Kp)(this.b.applicationStorage.storage);c.push({profile:this.c.defaultProfile,changes:P.map(v=>({key:v,scope:0,target:y[v]}))})}this.m(d,c)}j(P){const d=[],c=new Map;for(const[y,v]of P.entries()){v.keys.includes(S.$Ip)&&d.push(v.profile);const k=v.keys.filter(g=>g!==S.$Ip);if(k.length){const g=(0,S.$Kp)(v.storage.storage);c.set(y,{profile:v.profile,changes:k.map(m=>({key:m,scope:0,target:g[m]}))})}}this.m(d,[...c.values()])}m(P,d){(P.length||d.length)&&this.a.fire({valueChanges:d,targetChanges:P})}listen(P,d,c){switch(d){case"onDidChange":return this.a.event}throw new Error(`[ProfileStorageChangesListenerChannel] Event not found: ${d}`)}async call(P,d){throw new Error(`Call not found: ${d}`)}}e.$Cac=M}),define(ae[283],ce([0,1,7,38,16,5,34,40,41,12,125]),function(X,e,n,D,S,M,C,P,d,c,y){"use strict";var v,k;Object.defineProperty(e,"__esModule",{value:!0}),e.$NP=e.$MP=e.$LP=void 0;let g=class extends d.$jl{static{v=this}static{this.a="profileAssociationsMigration"}constructor(u,f,h,$,a){super(h,$,f,a),this.U=u,this.W=h}O(){return this.U.getItem(v.b,[]).map(f=>({...f,location:(0,c.$Tf)(f.location)?this.w.extUri.joinPath(this.profilesHome,f.location):n.URI.revive(f.location)}))}Q(){const u=this.U.getItem(v.c,{});return this.U.getItem(v.a,!1)?u:this.N(u)}S(){return this.w.extUri.joinPath(n.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$LP=g,e.$LP=g=v=ve([se(0,C.$GP),se(1,P.$el),se(2,D.$oi),se(3,S.$Gk),se(4,M.$Aj)],g);let m=k=class extends g{constructor(u,f,h,$,a){super(u,f,h,$,a),this.$=u}P(u){u.length?this.$.setItem(k.b,u.map(f=>({...f,location:this.w.extUri.basename(f.location)}))):this.$.removeItem(k.b)}O(){const u=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P(u),this.$.setItem("userDataProfilesMigration",!0)),u}R(u){u.emptyWindows||u.workspaces?this.$.setItem(k.c,u):this.$.removeItem(k.c)}Q(){const u="workspaceAndProfileInfo",f=this.$.getItem(u,void 0);if(f){this.$.removeItem(u);const $=f.reduce((a,{workspace:t,profile:o})=>(a[n.URI.revive(t).toString()]=n.URI.revive(o).toString(),a),{});this.$.setItem(k.c,{workspaces:$})}const h=super.Q();return this.$.getItem(k.a,!1)||(this.R(h),this.$.setItem(k.a,!0)),h}};e.$MP=m,e.$MP=m=k=ve([se(0,C.$HP),se(1,P.$el),se(2,D.$oi),se(3,S.$Gk),se(4,M.$Aj)],m);let w=class extends m{constructor(u,f,h,$){super(new y.$KP(0,f,$,h),u,f,h,$)}async init(){return await this.$.init(),super.init()}};e.$NP=w,e.$NP=w=ve([se(0,P.$el),se(1,D.$oi),se(2,S.$Gk),se(3,M.$Aj)],w)}),define(ae[57],ce([0,1,38,16,6,5,40,41,283,34]),function(X,e,n,D,S,M,C,P,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0$b=e.$9$b=void 0,e.$9$b=(0,S.$hi)(P.$gl);let y=class extends d.$MP{constructor(k,g,m,w,p){super(k,g,m,w,p)}getAssociatedEmptyWindows(){const k=[];for(const g of this.C.emptyWindows.keys())k.push({id:g});return k}};e.$0$b=y,e.$0$b=y=ve([se(0,c.$HP),se(1,C.$el),se(2,n.$oi),se(3,D.$Gk),se(4,M.$Aj)],y)}),define(ae[133],ce([0,1,19,7,30]),function(X,e,n,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$a_b=e.$_$b=e.$$$b=void 0;async function M(d,c,y){for(const k of d){const g=k.openedWorkspace;if((0,S.$vi)(g)){const m=await y(g);if(m){if(m.folders.some(w=>n.$Kg.isEqualOrParent(c,w.uri)))return k}else if(n.$Kg.isEqualOrParent(c,g.configPath))return k}}const v=d.filter(k=>(0,S.$qi)(k.openedWorkspace)&&n.$Kg.isEqualOrParent(c,k.openedWorkspace.uri));if(v.length)return v.sort((k,g)=>-(k.openedWorkspace.uri.path.length-g.openedWorkspace.uri.path.length))[0]}e.$$$b=M;function C(d,c){for(const y of d)if((0,S.$vi)(y.openedWorkspace)&&n.$Kg.isEqual(y.openedWorkspace.configPath,c)||(0,S.$qi)(y.openedWorkspace)&&n.$Kg.isEqual(y.openedWorkspace.uri,c))return y}e.$_$b=C;function P(d,c){const y=v=>c.some(k=>n.$Kg.isEqual(D.URI.file(k),D.URI.file(v)));for(const v of d)if(v.config?.extensionDevelopmentPath?.some(k=>y(k)))return v}e.$a_b=P}),define(ae[98],ce([0,1,33,42,103,47,13,9,4,19,7,6,68,30]),function(X,e,n,D,S,M,C,P,d,c,y,v,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ueb=e.$teb=e.$seb=e.$reb=e.$qeb=e.$peb=e.$oeb=e.$neb=e.$meb=e.$leb=void 0,e.$leb=(0,v.$gi)("workspacesService");function m(I){return I.hasOwnProperty("workspace")}e.$meb=m;function w(I){return I.hasOwnProperty("folderUri")}e.$neb=w;function p(I){return I.hasOwnProperty("fileUri")}e.$oeb=p;function u(I){return f(I)||h(I)}e.$peb=u;function f(I){const E=I;return typeof E?.path=="string"&&(!E.name||typeof E.name=="string")}function h(I){const E=I;return typeof E?.uri=="string"&&(!E.name||typeof E.name=="string")}function $(I,E,A,j,T){if(I.scheme!==j.scheme)return{name:A,uri:I.toString(!0)};let W=E?void 0:T.relativePath(j,I);if(W!==void 0)W.length===0?W=".":d.$i&&(W=a(W));else if(I.scheme===C.Schemas.file)W=I.fsPath,d.$i&&(W=a(W));else if(T.isEqualAuthority(I.authority,j.authority))W=I.path;else return{name:A,uri:I.toString(!0)};return{name:A,path:W}}e.$qeb=$;function a(I){return I=(0,M.$aw)(I),(0,n.$dg)(I)||(I=(0,n.$ag)(I)),I}function t(I,E,A){const j=[],T=new Set,W=A.dirname(E);for(const V of I){let K;if(f(V))V.path&&(K=A.resolvePath(W,V.path));else if(h(V))try{K=y.URI.parse(V.uri),K.path[0]!==P.$gc.sep&&(K=K.with({path:P.$gc.sep+K.path}))}catch(le){console.warn(le)}if(K){const le=A.getComparisonKey(K);if(!T.has(le)){T.add(le);const re=V.name||A.basenameOrAuthority(K);j.push(new g.$Ai({uri:K,name:re,index:j.length},V))}}}return j}e.$reb=t;function o(I,E,A,j,T){const W=r(E,I),V=T.dirname(E),K=T.dirname(j),le=[];for(const Y of W.folders){const U=f(Y)?T.resolvePath(V,Y.path):y.URI.parse(Y.uri);let L;A?L=!1:L=!f(Y)||(0,P.$ic)(Y.path),le.push($(U,L,Y.name,K,T))}const re={insertSpaces:!1,tabSize:4,eol:d.$k||d.$j?`
`:`\r
`},ue=S.$Hn(I,["folders"],le,re);let Z=S.$Kn(I,ue);return(0,c.$Yg)(W.remoteAuthority,(0,k.$qm)(j))&&(Z=S.$Kn(Z,S.$Gn(Z,["remoteAuthority"],re))),Z}e.$seb=o;function r(I,E){const A=D.$sn(E);if(A&&Array.isArray(A.folders))A.folders=A.folders.filter(j=>u(j));else throw new Error(`${I} looks like an invalid workspace file.`);return A}function i(I){return I.workspace&&typeof I.workspace=="object"&&typeof I.workspace.id=="string"&&typeof I.workspace.configPath=="string"}function s(I){return typeof I.folderUri=="string"}function l(I){return typeof I.fileUri=="string"}function b(I,E){const A={workspaces:[],files:[]};if(I){const j=function(W,V){for(let K=0;K<W.length;K++)try{V(W[K],K)}catch(le){E.warn(`Error restoring recent entry ${JSON.stringify(W[K])}: ${le.toString()}. Skip entry.`)}},T=I;Array.isArray(T.entries)&&j(T.entries,W=>{const V=W.label,K=W.remoteAuthority;i(W)?A.workspaces.push({label:V,remoteAuthority:K,workspace:{id:W.workspace.id,configPath:y.URI.parse(W.workspace.configPath)}}):s(W)?A.workspaces.push({label:V,remoteAuthority:K,folderUri:y.URI.parse(W.folderUri)}):l(W)&&A.files.push({label:V,remoteAuthority:K,fileUri:y.URI.parse(W.fileUri)})})}return A}e.$teb=b;function R(I){const E={entries:[]};for(const A of I.workspaces)w(A)?E.entries.push({folderUri:A.folderUri.toString(),label:A.label,remoteAuthority:A.remoteAuthority}):E.entries.push({workspace:{id:A.workspace.id,configPath:A.workspace.configPath.toString()},label:A.label,remoteAuthority:A.remoteAuthority});for(const A of I.files)E.entries.push({fileUri:A.fileUri.toString(),label:A.label,remoteAuthority:A.remoteAuthority});return E}e.$ueb=R}),define(ae[99],ce([0,1,87,13,4,19]),function(X,e,n,D,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$e_b=e.$d_b=e.$c_b=e.$b_b=void 0,e.$b_b=128/4;function C(c){function y(){let v=c.scheme===D.Schemas.file?(0,M.$Hg)(c):c.toString();return S.$k||(v=v.toLowerCase()),(0,n.createHash)("md5").update(v).digest("hex")}return{id:y(),configPath:c}}e.$c_b=C;function P(c,y){function v(){if(c.scheme!==D.Schemas.file)return(0,n.createHash)("md5").update(c.toString()).digest("hex");if(!y)return;let g;return S.$k?g=y.ino:S.$j?g=y.birthtime.getTime():S.$i&&(typeof y.birthtimeMs=="number"?g=Math.floor(y.birthtimeMs):g=y.birthtime.getTime()),(0,n.createHash)("md5").update(c.fsPath).update(g?String(g):"").digest("hex")}const k=v();if(typeof k=="string")return{id:k,uri:c}}e.$d_b=P;function d(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.$e_b=d}),define(ae[100],ce([0,1,87,88,26,284,17,15,3,2,9,4,32,43,113]),function(X,e,n,D,S,M,C,P,d,c,y,v,k,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=e.$0h=e.$9h=e.$8h=void 0;class w{traceSocketEvent(E,A){m.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,E,A)}constructor(E,A=""){this.f=!0,this.debugLabel=A,this.socket=E,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=j=>{if(this.traceSocketEvent("error",{code:j?.code,message:j?.message}),j){if(j.code==="EPIPE")return;(0,P.$1)(j)}},this.socket.on("error",this.a),this.b=j=>{this.traceSocketEvent("close",{hadError:j}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(E){const A=j=>{this.traceSocketEvent("read",j),E(C.$te.wrap(j))};return this.socket.on("data",A),{dispose:()=>this.socket.off("data",A)}}onClose(E){const A=j=>{E({type:0,hadError:j,error:void 0})};return this.socket.on("close",A),{dispose:()=>this.socket.off("close",A)}}onEnd(E){const A=()=>{E()};return this.socket.on("end",A),{dispose:()=>this.socket.off("end",A)}}write(E){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",E),this.socket.write(E.buffer,A=>{if(A){if(A.code==="EPIPE")return;(0,P.$1)(A)}})}catch(A){if(A.code==="EPIPE")return;(0,P.$1)(A)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((E,A)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),E();return}const j=()=>{this.socket.off("close",j),this.socket.off("end",j),this.socket.off("error",j),this.socket.off("timeout",j),this.socket.off("drain",j),this.traceSocketEvent("nodeDrainEnd"),E()};this.socket.on("close",j),this.socket.on("end",j),this.socket.on("error",j),this.socket.on("timeout",j),this.socket.on("drain",j)})}}e.$8h=w;var p;(function(I){I[I.MinHeaderByteSize=2]="MinHeaderByteSize",I[I.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(p||(p={}));var u;(function(I){I[I.PeekHeader=1]="PeekHeader",I[I.ReadHeader=2]="ReadHeader",I[I.ReadBody=3]="ReadBody",I[I.Fin=4]="Fin"})(u||(u={}));class f extends c.$Tc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(E,A){this.socket.traceSocketEvent(E,A)}constructor(E,A,j,T){super(),this.f=this.B(new d.$6d),this.g=this.B(new d.$6d),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=E,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:A,inflateBytesLength:j?.byteLength||0,recordInflateBytes:T}),this.a=this.B(new h(this,A,j,T,this.f,(W,V)=>this.m(W,V))),this.B(this.a.onError(W=>{console.error(W),(0,P.$1)(W),this.g.fire({type:0,hadError:!0,error:W})})),this.b=new m.$3h,this.B(this.socket.onData(W=>this.n(W))),this.B(this.socket.onClose(async W=>{this.a.isProcessingReadQueue()&&await d.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(W)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(E){return this.f.event(E)}onClose(E){return this.g.event(E)}onEnd(E){return this.socket.onEnd(E)}write(E){let A=0;for(;A<E.byteLength;)this.a.writeMessage(E.slice(A,Math.min(A+262144,E.byteLength)),{compressed:!0,opcode:2}),A+=262144}m(E,{compressed:A,opcode:j}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",E);let T=2;E.byteLength<126?T+=0:E.byteLength<2**16?T+=2:T+=8;const W=C.$te.alloc(T),V=A?64:0,K=j&15;if(W.writeUInt8(128|V|K,0),E.byteLength<126)W.writeUInt8(E.byteLength,1);else if(E.byteLength<2**16){W.writeUInt8(126,1);let le=1;W.writeUInt8(E.byteLength>>>8&255,++le),W.writeUInt8(E.byteLength>>>0&255,++le)}else{W.writeUInt8(127,1);let le=1;W.writeUInt8(0,++le),W.writeUInt8(0,++le),W.writeUInt8(0,++le),W.writeUInt8(0,++le),W.writeUInt8(E.byteLength>>>24&255,++le),W.writeUInt8(E.byteLength>>>16&255,++le),W.writeUInt8(E.byteLength>>>8&255,++le),W.writeUInt8(E.byteLength>>>0&255,++le)}this.socket.write(C.$te.concat([W,E]))}end(){this.h=!0,this.socket.end()}n(E){if(E.byteLength!==0){for(this.b.acceptChunk(E);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const A=this.b.peek(this.j.readLen),j=A.readUInt8(0),T=(j&128)>>>7,W=(j&64)>>>6,V=j&15,K=A.readUInt8(1),le=(K&128)>>>7,re=K&127;this.j.state=2,this.j.readLen=2+(le?4:0)+(re===126?2:0)+(re===127?8:0),this.j.fin=T,this.j.firstFrameOfMessage&&(this.j.compressed=!!W),this.j.firstFrameOfMessage=!!T,this.j.mask=0,this.j.opcode=V,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const A=this.b.read(this.j.readLen),j=A.readUInt8(1),T=(j&128)>>>7;let W=j&127,V=1;W===126?W=A.readUInt8(++V)*2**8+A.readUInt8(++V):W===127&&(W=A.readUInt8(++V)*0+A.readUInt8(++V)*0+A.readUInt8(++V)*0+A.readUInt8(++V)*0+A.readUInt8(++V)*2**24+A.readUInt8(++V)*2**16+A.readUInt8(++V)*2**8+A.readUInt8(++V));let K=0;T&&(K=A.readUInt8(++V)*2**24+A.readUInt8(++V)*2**16+A.readUInt8(++V)*2**8+A.readUInt8(++V)),this.j.state=3,this.j.readLen=W,this.j.mask=K,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const A=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",A),t(A,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",A),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(A,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(A,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await d.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$9h=f;class h extends c.$Tc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:C.$te.alloc(0)}constructor(E,A,j,T,W,V){super(),this.n=E,this.r=W,this.s=V,this.a=this.B(new d.$6d),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new d.$6d),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new d.$6d),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,A?(this.b=this.B(new $(this.n,T,j,{windowBits:15})),this.f=this.B(new a(this.n,{windowBits:15})),this.B(this.b.onError(K=>this.a.fire(K))),this.B(this.f.onError(K=>this.a.fire(K)))):(this.b=null,this.f=null)}writeMessage(E,A){this.g.push({data:E,options:A}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:E,options:A}=this.g.shift();if(this.f&&A.compressed){const j=await this.w(this.f,E);this.s(j,A)}else this.s(E,{...A,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(E,A){return new Promise((j,T)=>{E.write(A),E.flush(W=>j(W))})}acceptFrame(E,A,j){this.h.push({data:E,isCompressed:A,isLastFrameOfMessage:j}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const E=this.h.shift();if(this.b&&E.isCompressed){const A=await this.C(this.b,E.data,E.isLastFrameOfMessage);this.r.fire(A)}else this.r.fire(E.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(E,A,j){return new Promise((T,W)=>{E.write(A),j&&E.write(C.$te.fromByteArray([0,0,255,255])),E.flush(V=>T(V))})}}class $ extends c.$Tc{get recordedInflateBytes(){return this.j?C.$te.concat(this.f):C.$te.alloc(0)}constructor(E,A,j,T){super(),this.h=E,this.j=A,this.a=this.B(new d.$6d),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,M.createInflateRaw)(T),this.b.on("error",W=>{this.h.traceSocketEvent("zlibInflateError",{message:W?.message,code:W?.code}),this.a.fire(W)}),this.b.on("data",W=>{this.h.traceSocketEvent("zlibInflateData",W),this.g.push(C.$te.wrap(W))}),j&&(this.h.traceSocketEvent("zlibInflateInitialWrite",j.buffer),this.b.write(j.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(E){this.j&&this.f.push(E.clone()),this.h.traceSocketEvent("zlibInflateWrite",E),this.b.write(E.buffer)}flush(E){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const A=C.$te.concat(this.g);this.g.length=0,E(A)})}}class a extends c.$Tc{constructor(E,A){super(),this.g=E,this.a=this.B(new d.$6d),this.onError=this.a.event,this.f=[],this.b=(0,M.createDeflateRaw)({windowBits:15}),this.b.on("error",j=>{this.g.traceSocketEvent("zlibDeflateError",{message:j?.message,code:j?.code}),this.a.fire(j)}),this.b.on("data",j=>{this.g.traceSocketEvent("zlibDeflateData",j),this.f.push(C.$te.wrap(j))})}write(E){this.g.traceSocketEvent("zlibDeflateWrite",E.buffer),this.b.write(E.buffer)}flush(E){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let A=C.$te.concat(this.f);this.f.length=0,A=A.slice(0,A.byteLength-4),E(A)})}}function t(I,E){if(E===0)return;const A=I.byteLength>>>2;for(let le=0;le<A;le++){const re=I.readUInt32BE(le*4);I.writeUInt32BE(re^E,le*4)}const j=A*4,T=I.byteLength-j,W=E>>>24&255,V=E>>>16&255,K=E>>>8&255;T>=1&&I.writeUInt8(I.readUInt8(j)^W,j),T>=2&&I.writeUInt8(I.readUInt8(j+1)^V,j+1),T>=3&&I.writeUInt8(I.readUInt8(j+2)^K,j+2)}e.$0h=process.env.XDG_RUNTIME_DIR;const o={2:107,1:103};function r(){const I=(0,k.$Cg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${I}-sock`;const E=process.platform!=="darwin"&&e.$0h?e.$0h:(0,S.tmpdir)(),A=(0,y.$jc)(E,`vscode-ipc-${I}.sock`);return s(A),A}e.$$h=r;function i(I,E,A){const T=(0,n.createHash)("sha256").update(I).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${T}-${A}-${E}-sock`;const W=A.substr(0,4),V=E.substr(0,6);let K;return process.platform!=="darwin"&&e.$0h&&!process.env.VSCODE_PORTABLE?K=(0,y.$jc)(e.$0h,`vscode-${T}-${W}-${V}.sock`):K=(0,y.$jc)(I,`${W}-${V}.sock`),s(K),K}e.$_h=i;function s(I){const E=o[v.$u];typeof E=="number"&&I.length>=E&&console.warn(`WARNING: IPC handle "${I}" is longer than ${E} chars, try a shorter --user-data-dir`)}class l extends g.$Wh{static b(E){const A=d.Event.fromNodeEventEmitter(E,"connection");return d.Event.map(A,j=>({protocol:new m.$4h(new w(j,"ipc-server-connection")),onDidClientDisconnect:d.Event.once(d.Event.fromNodeEventEmitter(j,"close"))}))}constructor(E){super(l.b(E)),this.d=E}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$ai=l;function b(I){return new Promise((E,A)=>{const j=(0,D.createServer)();j.on("error",A),j.listen(I,()=>{j.removeListener("error",A),E(new l(j))})})}e.$bi=b;function R(I,E){return new Promise((A,j)=>{const T=(0,D.createConnection)(I,()=>{T.removeListener("error",j),A(m.$5h.fromSocket(new w(T,`ipc-client${E}`),E))});T.once("error",j)})}e.$ci=R}),define(ae[24],ce([0,1,50,9,4,100,38,91,6]),function(X,e,n,D,S,M,C,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V$b=e.$U$b=void 0,e.$U$b=(0,d.$hi)(C.$ni);class c extends P.$Rm{constructor(){super(...arguments),this.d={}}get cachedLanguagesPath(){return(0,D.$jc)(this.userDataPath,"clp")}get backupHome(){return(0,D.$jc)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,M.$_h)(this.userDataPath,"main",this.c.version)}get mainLockfile(){return(0,D.$jc)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}unsetSnapExportedVariables(){if(S.$k){for(const v in process.env)if(v.endsWith("_VSCODE_SNAP_ORIG")){const k=v.slice(0,-17);if(this.d[k])continue;process.env[k]&&(this.d[k]=process.env[k]),process.env[v]?process.env[k]=process.env[v]:delete process.env[k]}}}restoreSnapExportedVariables(){if(S.$k)for(const v in this.d)process.env[v]=this.d[v],delete this.d[v]}}e.$V$b=c,ve([n.$Kh],c.prototype,"cachedLanguagesPath",null),ve([n.$Kh],c.prototype,"backupHome",null),ve([n.$Kh],c.prototype,"mainIPCHandle",null),ve([n.$Kh],c.prototype,"mainLockfile",null),ve([n.$Kh],c.prototype,"disableUpdates",null),ve([n.$Kh],c.prototype,"crossOriginIsolated",null),ve([n.$Kh],c.prototype,"codeCachePath",null),ve([n.$Kh],c.prototype,"useCodeCache",null)}),define(ae[285],ce([0,1,87,33,13,9,4,19,21,198,18,24,34,16,5,197,30,99]),function(X,e,n,D,S,M,C,P,d,c,y,v,k,g,m,w,p,u){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.$x_b=void 0;let h=class{static{f=this}static{this.a="backupWorkspaces"}constructor(a,t,o,r){this.j=a,this.k=t,this.l=o,this.m=r,this.c=this.j.backupHome,this.d=[],this.e=[],this.g=[],this.h=P.$Kg,this.i={isEqual:(i,s)=>(0,D.$fg)(i,s,!C.$k)}}async initialize(){const a=this.m.getItem(f.a)??{workspaces:[],folders:[],emptyWindows:[]};this.g=await this.w(a.emptyWindows),this.d=await this.u((0,c.$X$b)(a)),this.e=await this.v((0,c.$Y$b)(a)),this.C()}n(){return this.q()?[]:this.d.slice(0)}o(){return this.q()?[]:this.e.slice(0)}isHotExitEnabled(){return this.s()!==g.$6k.OFF}q(){return this.s()===g.$6k.ON_EXIT_AND_WINDOW_CLOSE}s(){return this.k.getValue()?.files?.hotExit||g.$6k.ON_EXIT}getEmptyWindowBackups(){return this.g.slice(0)}registerWorkspaceBackup(a,t){this.d.some(r=>a.workspace.id===r.workspace.id)||(this.d.push(a),this.C());const o=(0,M.$jc)(this.c,a.workspace.id);return t?this.t(o,t).then(()=>o):o}async t(a,t){if(await d.Promises.exists(a)&&await this.z(a),await d.Promises.exists(t))try{await d.Promises.rename(t,a,!1)}catch(o){this.l.error(`Backup: Could not move backup folder to new location: ${o.toString()}`)}}registerFolderBackup(a){return this.e.some(t=>this.h.isEqual(a.folderUri,t.folderUri))||(this.e.push(a),this.C()),(0,M.$jc)(this.c,this.D(a))}registerEmptyWindowBackup(a){return this.g.some(t=>!!t.backupFolder&&this.i.isEqual(t.backupFolder,a.backupFolder))||(this.g.push(a),this.C()),(0,M.$jc)(this.c,a.backupFolder)}async u(a){if(!Array.isArray(a))return[];const t=new Set,o=[];for(const r of a){const i=r.workspace;if(!(0,p.$vi)(i))return[];if(!t.has(i.id)){t.add(i.id);const s=(0,M.$jc)(this.c,i.id);await this.B(s)?i.configPath.scheme!==S.Schemas.file||await d.Promises.exists(i.configPath.fsPath)?o.push(r):await this.z(s):await this.x(s)}}return o}async v(a){if(!Array.isArray(a))return[];const t=[],o=new Set;for(const r of a){const i=r.folderUri,s=this.h.getComparisonKey(i);if(!o.has(s)){o.add(s);const l=(0,M.$jc)(this.c,this.D(r));await this.B(l)?i.scheme!==S.Schemas.file||await d.Promises.exists(i.fsPath)?t.push(r):await this.z(l):await this.x(l)}}return t}async w(a){if(!Array.isArray(a))return[];const t=[],o=new Set;for(const r of a){const i=r.backupFolder;if(typeof i!="string")return[];if(!o.has(i)){o.add(i);const s=(0,M.$jc)(this.c,i);await this.B(s)?t.push(r):await this.x(s)}}return t}async x(a){try{await d.Promises.rm(a,d.RimRafMode.MOVE)}catch(t){this.l.error(`Backup: Could not delete stale backup: ${t.toString()}`)}}y(){let a=(0,u.$e_b)();for(;this.g.some(t=>!!t.backupFolder&&this.i.isEqual(t.backupFolder,a.id));)a=(0,u.$e_b)();return{backupFolder:a.id}}async z(a){const t=this.y(),o=(0,M.$jc)(this.c,t.backupFolder);try{await d.Promises.rename(a,o,!1)}catch(r){return this.l.error(`Backup: Could not rename backup folder: ${r.toString()}`),!1}return this.g.push(t),!0}async getDirtyWorkspaces(){const a=[];for(const t of this.d)await this.A(t)&&a.push(t);for(const t of this.e)await this.A(t)&&a.push(t);return a}A(a){let t;return(0,c.$W$b)(a)?t=(0,M.$jc)(this.c,a.backupFolder):(0,w.$jeb)(a)?t=(0,M.$jc)(this.c,this.D(a)):t=(0,M.$jc)(this.c,a.workspace.id),this.B(t)}async B(a){try{const t=await d.Promises.readdir(a);for(const o of t)try{if((await d.Promises.readdir((0,M.$jc)(a,o))).length>0)return!0}catch{}}catch{}return!1}C(){const a={workspaces:this.d.map(({workspace:t,remoteAuthority:o})=>{const r={id:t.id,configURIPath:t.configPath.toString()};return o&&(r.remoteAuthority=o),r}),folders:this.e.map(({folderUri:t,remoteAuthority:o})=>{const r={folderUri:t.toString()};return o&&(r.remoteAuthority=o),r}),emptyWindows:this.g.map(({backupFolder:t,remoteAuthority:o})=>{const r={backupFolder:t};return o&&(r.remoteAuthority=o),r})};this.m.setItem(f.a,a)}D(a){const t=a.folderUri;let o;return t.scheme===S.Schemas.file?o=C.$k?t.fsPath:t.fsPath.toLowerCase():o=t.toString().toLowerCase(),(0,n.createHash)("md5").update(o).digest("hex")}};e.$x_b=h,e.$x_b=h=f=ve([se(0,v.$U$b),se(1,y.$Mi),se(2,m.$Aj),se(3,k.$HP)],h)}),define(ae[20],ce([0,1,14,37,8,3,2,4,36,12,6,5,34,24]),function(X,e,n,D,S,M,C,P,d,c,y,v,k,g){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$n_b=e.LifecycleMainPhase=e.ShutdownReason=e.$m_b=void 0,e.$m_b=(0,y.$gi)("lifecycleMainService");var w;(function(f){f[f.QUIT=1]="QUIT",f[f.KILL=2]="KILL"})(w||(e.ShutdownReason=w={}));var p;(function(f){f[f.Starting=1]="Starting",f[f.Ready=2]="Ready",f[f.AfterWindowOpen=3]="AfterWindowOpen",f[f.Eventually=4]="Eventually"})(p||(e.LifecycleMainPhase=p={}));let u=class extends C.$Tc{static{m=this}static{this.b="lifecycle.quitAndRestart"}get quitRequested(){return this.j}get wasRestarted(){return this.m}get phase(){return this.n}constructor(h,$,a){super(),this.F=h,this.G=$,this.H=a,this.c=this.B(new M.$6d),this.onBeforeShutdown=this.c.event,this.f=this.B(new M.$6d),this.onWillShutdown=this.f.event,this.g=this.B(new M.$6d),this.onWillLoadWindow=this.g.event,this.h=this.B(new M.$6d),this.onBeforeCloseWindow=this.h.event,this.j=!1,this.m=!1,this.n=1,this.r=new Set,this.s=0,this.t=0,this.u=void 0,this.w=void 0,this.y=void 0,this.z=new Map,this.C=new Map,this.D=void 0,this.I(),this.when(2).then(()=>this.J())}I(){this.m=!!this.G.getItem(m.b),this.m&&this.G.removeItem(m.b)}J(){const h=()=>{this.j||(this.S("Lifecycle#app.on(before-quit)"),this.j=!0,this.S("Lifecycle#onBeforeShutdown.fire()"),this.c.fire(),P.$j&&this.t===0&&this.L(1))};n.app.addListener("before-quit",h);const $=()=>{this.S("Lifecycle#app.on(window-all-closed)"),(this.j||!P.$j)&&n.app.quit()};n.app.addListener("window-all-closed",$),n.app.once("will-quit",a=>{this.S("Lifecycle#app.on(will-quit) - begin"),a.preventDefault(),this.L(1).finally(()=>{this.S("Lifecycle#app.on(will-quit) - after fireOnWillShutdown"),this.O(!1),n.app.removeListener("before-quit",h),n.app.removeListener("window-all-closed",$),this.S("Lifecycle#app.on(will-quit) - calling app.quit()"),n.app.quit()})})}L(h){if(this.y)return this.y;const $=this.F;this.S("Lifecycle#onWillShutdown.fire()");const a=[];return this.f.fire({reason:h,join(t,o){$.trace(`Lifecycle#onWillShutdown - begin '${t}'`),a.push(o.finally(()=>{$.trace(`Lifecycle#onWillShutdown - end '${t}'`)}))}}),this.y=(async()=>{try{await S.Promises.settled(a)}catch(t){this.F.error(t)}try{await this.G.close()}catch(t){this.F.error(t)}})(),this.y}set phase(h){if(h<this.phase)throw new Error("Lifecycle cannot go backwards");if(this.n===h)return;this.S(`lifecycle (main): phase changed (value: ${h})`),this.n=h;const $=this.C.get(this.n);$&&($.open(),this.C.delete(this.n))}async when(h){if(h<=this.n)return;let $=this.C.get(h);$||($=new S.$fh,this.C.set(h,$)),await $.wait()}registerWindow(h){const $=new C.$Sc;this.t++,$.add(h.onWillLoad(t=>this.g.fire({window:h,workspace:t.workspace,reason:t.reason})));const a=(0,c.$5f)(h.win);a.on("close",t=>{const o=h.id;if(this.r.has(o)){this.r.delete(o);return}this.S(`Lifecycle#window.on('close') - window ID ${h.id}`),t.preventDefault(),this.unload(h,1).then(r=>{if(r){this.r.delete(o);return}this.r.add(o),this.S(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${o}`),this.h.fire(h),h.close()})}),a.on("closed",()=>{this.S(`Lifecycle#window.on('closed') - window ID ${h.id}`),this.t--,$.dispose(),this.t===0&&(!P.$j||this.j)&&this.L(1)})}registerAuxWindow(h){const $=(0,c.$5f)(h.win);$.on("close",a=>{this.S(`Lifecycle#auxWindow.on('close') - window ID ${h.id}`),this.j&&(this.S("Lifecycle#auxWindow.on('close') - preventDefault() because quit requested"),a.preventDefault())}),$.on("closed",()=>{this.S(`Lifecycle#auxWindow.on('closed') - window ID ${h.id}`)})}async reload(h,$){await this.unload(h,3)||h.reload($)}unload(h,$){const a=this.z.get(h.id);if(a)return a;const t=this.M(h,$).finally(()=>{this.z.delete(h.id)});return this.z.set(h.id,t),t}async M(h,$){if(!h.isReady)return!1;this.S(`Lifecycle#unload() - window ID ${h.id}`);const a=this.j?2:$,t=await this.P(h,a);return t?(this.S(`Lifecycle#unload() - veto in renderer (window ID ${h.id})`),this.N(t)):(await this.Q(h,a),!1)}N(h){return h?(this.O(!0),this.j=!1,!0):!1}O(h){this.w&&(this.w(h),this.w=void 0,this.u=void 0)}P(h,$){return new Promise(a=>{const t=this.s++,o=`vscode:ok${t}`,r=`vscode:cancel${t}`;D.$RV.once(o,()=>{a(!1)}),D.$RV.once(r,()=>{a(!0)}),h.send("vscode:onBeforeUnload",{okChannel:o,cancelChannel:r,reason:$})})}Q(h,$){return new Promise(a=>{const o=`vscode:reply${this.s++}`;D.$RV.once(o,()=>a()),h.send("vscode:onWillUnload",{replyChannel:o,reason:$})})}quit(h){return this.R(h).then($=>{if(!$&&h)try{if(P.$i){const a=(0,d.cwd)();a!==process.cwd()&&process.chdir(a)}}catch(a){this.F.error(a)}return $})}R(h){return this.S(`Lifecycle#quit() - begin (willRestart: ${h})`),this.u?(this.S("Lifecycle#quit() - returning pending quit promise"),this.u):(h&&this.G.setItem(m.b,!0),this.u=new Promise($=>{this.w=$,this.S("Lifecycle#quit() - calling app.quit()"),n.app.quit()}),this.u)}S(h){this.H.args["enable-smoke-test-driver"]?this.F.info(h):this.F.trace(h)}setRelaunchHandler(h){this.D=h}async relaunch(h){this.S("Lifecycle#relaunch()");const $=process.argv.slice(1);if(h?.addArgs&&$.push(...h.addArgs),h?.removeArgs)for(const o of h.removeArgs){const r=$.indexOf(o);r>=0&&$.splice(r,1)}const a=()=>{this.D?.handleRelaunch(h)||(this.S("Lifecycle#relaunch() - calling app.relaunch()"),n.app.relaunch({args:$}))};n.app.once("quit",a),await this.quit(!0)&&n.app.removeListener("quit",a)}async kill(h){this.S("Lifecycle#kill()"),await this.L(2),await Promise.race([(0,S.$hh)(1e3),(async()=>{for(const $ of n.BrowserWindow.getAllWindows())if($&&!$.isDestroyed()){let a;$.webContents&&!$.webContents.isDestroyed()?a=new Promise(t=>$.once("closed",t)):a=Promise.resolve(),$.destroy(),await a}})()]),n.app.exit(h)}};e.$n_b=u,e.$n_b=u=m=ve([se(0,v.$Aj),se(1,k.$HP),se(2,g.$U$b)],u)}),define(ae[286],ce([0,1,4,3,2,6,20]),function(X,e,n,D,S,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V_b=e.$U_b=void 0,e.$U_b=(0,M.$gi)("keyboardLayoutMainService");let P=class extends S.$Tc{constructor(y){super(),this.a=this.B(new D.$6d),this.onDidChangeKeyboardLayout=this.a.event,this.b=null,this.c=null,y.when(3).then(()=>this.f())}f(){return this.b||(this.b=this.g()),this.b}async g(){const y=await new Promise((v,k)=>{X(["native-keymap"],v,k)});this.c=d(y),n.$t||y.onDidChangeKeyboardLayout(()=>{this.c=d(y),this.a.fire(this.c)})}async getKeyboardLayoutData(){return await this.f(),this.c}};e.$V_b=P,e.$V_b=P=ve([se(0,C.$m_b)],P);function d(c){const y=c.getKeyMap(),v=c.getCurrentKeyboardLayout();return{keyboardMapping:y,keyboardLayoutInfo:v}}}),define(ae[287],ce([0,1,248,8,17,15,12,18,38,95,5,53,247,284]),function(X,e,n,D,S,M,C,P,d,c,y,v,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dr=e.$Cr=void 0;let m=class extends v.$xp{constructor(f,h,$,a){super(a),this.m=f,this.n=h,this.r=$,this.s(),this.B(f.onDidChangeConfiguration(t=>{t.affectsConfiguration("http")&&this.s()}))}s(){const f=this.m.getValue("http");this.f=f?.proxy,this.g=!!f?.proxyStrictSSL,this.h=f?.proxyAuthorization}async request(f,h){const{f:$,g:a}=this;let t;try{t=await(0,c.$km)(this.m,this.r,this.n.args,process.env)}catch(i){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,M.$0)(i)))}const o={...process.env,...t},r=f.agent?f.agent:await(0,k.$Br)(f.url||"",o,{proxyUrl:$,strictSSL:a});return f.agent=r,f.strictSSL=a,this.h&&(f.headers={...f.headers||{},"Proxy-Authorization":this.h}),this.c(f.isChromiumNetwork?"electron":"node",f,()=>p(f,h))}async resolveProxy(f){}async loadCertificates(){return(await new Promise((h,$)=>{X(["@vscode/proxy-agent"],h,$)})).loadSystemCertificates({log:this.r})}};e.$Cr=m,e.$Cr=m=ve([se(0,P.$Mi),se(1,d.$oi),se(2,y.$Aj),se(3,y.$Bj)],m);async function w(u){return((0,n.parse)(u.url).protocol==="https:"?await new Promise(($,a)=>{X(["https"],$,a)}):await new Promise(($,a)=>{X(["http"],$,a)})).request}async function p(u,f){return D.Promises.withAsyncBody(async(h,$)=>{const a=(0,n.parse)(u.url),t=u.getRawRequest?u.getRawRequest(u):await w(u),o={hostname:a.hostname,port:a.port?parseInt(a.port):a.protocol==="https:"?443:80,protocol:a.protocol,path:a.path,method:u.type||"GET",headers:u.headers,agent:u.agent,rejectUnauthorized:(0,C.$Zf)(u.strictSSL)?u.strictSSL:!0};u.user&&u.password&&(o.auth=u.user+":"+u.password);const r=t(o,i=>{const s=(0,C.$Xf)(u.followRedirects)?u.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&s>0&&i.headers.location)p({...u,url:i.headers.location,followRedirects:s-1},f).then(h,$);else{let l=i;!u.isChromiumNetwork&&i.headers["content-encoding"]==="gzip"&&(l=i.pipe((0,g.createGunzip)())),h({res:i,stream:(0,S.$Ie)(l)})}});r.on("error",$),u.timeout&&r.setTimeout(u.timeout),u.isChromiumNetwork&&r.removeHeader("Content-Length"),u.data&&typeof u.data=="string"&&r.write(u.data),r.end(),f.onCancellationRequested(()=>{r.abort(),$(new M.$5)})})}e.$Dr=p}),define(ae[288],ce([0,1,14,287]),function(X,e,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xac=void 0;function S(C){return n.net.request}class M extends D.$Cr{request(P,d){return super.request({...P||{},getRawRequest:S,isChromiumNetwork:!0},d)}}e.$Xac=M}),define(ae[83],ce([0,1,7,3,2,38,16,6,20,5,97,281,41,57,40,13]),function(X,e,n,D,S,M,C,P,d,c,y,v,k,g,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$v_b=e.$u_b=e.$t_b=e.$s_b=void 0,e.$s_b=(0,P.$gi)("storageMainService");let p=class extends S.$Tc{constructor(h,$,a,t,o,r){super(),this.c=h,this.f=$,this.g=a,this.h=t,this.j=o,this.m=r,this.a=void 0,this.b=this.B(new D.$6d),this.onDidChangeProfileStorage=this.b.event,this.applicationStorage=this.B(this.s()),this.t=new Map,this.w=new Map,this.r()}n(){return{useInMemoryStorage:!!this.f.extensionTestsLocationURI}}r(){(async()=>(await this.h.when(3),this.applicationStorage.init()))(),this.B(this.h.onWillLoadWindow(h=>{h.window.profile&&this.profileStorage(h.window.profile).init(),h.workspace&&this.workspaceStorage(h.workspace).init()})),this.B(this.h.onWillShutdown(h=>{this.c.trace("storageMainService#onWillShutdown()"),this.a=h.reason,h.join("applicationStorage",this.applicationStorage.close());for(const[,$]of this.t)h.join("profileStorage",$.close());for(const[,$]of this.w)h.join("workspaceStorage",$.close())})),this.B(this.g.onWillCreateProfile(h=>{h.join((async()=>{await this.j.exists(h.profile.globalStorageHome)||await this.j.createFolder(h.profile.globalStorageHome)})())})),this.B(this.g.onWillRemoveProfile(h=>{const $=this.t.get(h.profile.id);$&&h.join($.close())}))}s(){this.c.trace("StorageMainService: creating application storage");const h=new v.$p_b(this.n(),this.g,this.c,this.j);return this.B(D.Event.once(h.onDidCloseStorage)(()=>{this.c.trace("StorageMainService: closed application storage")})),h}profileStorage(h){if((0,y.$Mp)(h))return this.applicationStorage;let $=this.t.get(h.id);if(!$){this.c.trace(`StorageMainService: creating profile storage (${h.name})`),$=this.B(this.u(h)),this.t.set(h.id,$);const a=this.B($.onDidChangeStorage(t=>this.b.fire({...t,storage:$,profile:h})));this.B(D.Event.once($.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed profile storage (${h.name})`),this.t.delete(h.id),a.dispose()}))}return $}u(h){return this.a===2?new v.$r_b(this.c,this.j):new v.$o_b(h,this.n(),this.c,this.j)}workspaceStorage(h){let $=this.w.get(h.id);return $||(this.c.trace(`StorageMainService: creating workspace storage (${h.id})`),$=this.B(this.y(h)),this.w.set(h.id,$),this.B(D.Event.once($.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed workspace storage (${h.id})`),this.w.delete(h.id)}))),$}y(h){return this.a===2?new v.$r_b(this.c,this.j):new v.$q_b(h,this.n(),this.c,this.f,this.j)}isUsed(h){const $=n.URI.file(h);for(const a of[this.applicationStorage,...this.t.values(),...this.w.values()])if(a.path&&this.m.extUri.isEqualOrParent(n.URI.file(a.path),$))return!0;return!1}};e.$t_b=p,e.$t_b=p=ve([se(0,c.$Aj),se(1,M.$ni),se(2,g.$9$b),se(3,d.$m_b),se(4,C.$Gk),se(5,m.$el)],p),e.$u_b=(0,P.$gi)("applicationStorageMainService");let u=class extends y.$Lp{constructor(h,$){super(),this.s=h,this.U=$,this.whenReady=this.U.applicationStorage.whenInit}O(){return this.U.applicationStorage.whenInit}P(h){if(h===-1)return this.U.applicationStorage.storage}Q(h){if(h===-1)return this.s.defaultProfile.globalStorageHome.with({scheme:w.Schemas.file}).fsPath}r(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}R(){throw new Error("Switching storage profile is unsupported from main process")}S(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};e.$v_b=u,e.$v_b=u=ve([se(0,k.$gl),se(1,e.$s_b)],u)}),define(ae[289],ce([0,1,88,26,107,100,8,2,4,18,5,27,243,244,96,130,17]),function(X,e,n,D,S,M,C,P,d,c,y,v,k,g,m,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wac=e.$Vac=e.$Uac=e.$Tac=void 0;async function u(t,o,r,i,s){let l;for(let b=3;b&&(l?.dispose(),l=await new f(t,o,r,i,s).waitForReady(),!(s&&S.$Fg[s]||!S.$Fg[l.tunnelLocalPort]));b--);return l}class f extends P.$Tc{constructor(o,r,i,s,l){super(),this.m=r,this.n=l,this.privacy=w.TunnelPrivacyId.Private,this.j=new Map,this.a=o,this.b=n.createServer(),this.c=new C.$fh,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=b=>this.r(b),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=s,this.tunnelRemoteHost=i}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(r=>{r()})}async waitForReady(){const o=this.n??this.tunnelRemotePort,r=(0,w.$Xv)(this.m)?"0.0.0.0":"127.0.0.1";let i=await(0,S.$Gg)(o,2,1e3,r),s=null;return this.b.listen(i,this.m),await this.c.wait(),s=this.b.address(),s||(i=0,this.b.listen(i,this.m),await this.c.wait(),s=this.b.address()),this.tunnelLocalPort=s.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${s.port}`,this}async r(o){o.pause();const r=(0,w.$Vv)(this.tunnelRemoteHost)||(0,w.$Xv)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,i=await(0,k.$wl)(this.a,r,this.tunnelRemotePort),s=i.getSocket(),l=i.readEntireBuffer();i.dispose(),l.byteLength>0&&o.write(l.buffer),o.on("end",()=>{o.localAddress&&this.j.delete(o.localAddress),s.end()}),o.on("close",()=>s.end()),o.on("error",()=>{o.localAddress&&this.j.delete(o.localAddress),s instanceof M.$8h?s.socket.destroy():s.end()}),s instanceof M.$8h?this.t(o,s):this.s(o,s),o.localAddress&&this.j.set(o.localAddress,()=>{o.end(),s.end()})}s(o,r){r.onClose(()=>o.destroy()),r.onEnd(()=>o.end()),r.onData(i=>o.write(i.buffer)),o.on("data",i=>r.write(p.$te.wrap(i))),o.resume()}t(o,r){const i=r.socket;i.on("end",()=>o.end()),i.on("close",()=>o.end()),i.on("error",()=>{o.destroy()}),i.pipe(o),o.pipe(i)}}e.$Tac=f;let h=class extends w.$1v{constructor(o,r,i,s,l){super(r,l),this.v=o,this.w=i,this.y=s}isPortPrivileged(o){return(0,w.$Yv)(o,this.m,d.OS,D.release())}t(o,r,i,s,l,b,R,I){const E=this.s(r,i);if(E)return++E.refcount,E.value;if((0,w.$Sv)(o))return this.u(o,r,i,l,b,R,I);{this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${r}:${i} on local port ${l}.`);const A={commit:this.y.commit,quality:this.y.quality,addressProvider:o,remoteSocketFactoryService:this.v,signService:this.w,logService:this.k,ipcLogger:null},j=u(A,s,r,i,l);return this.k.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.q(r,i,j),j}}};e.$Uac=h,e.$Uac=h=ve([se(0,g.$ql),se(1,y.$Aj),se(2,m.$tl),se(3,v.$Sj),se(4,c.$Mi)],h);let $=class extends h{constructor(o,r,i,s,l){super(o,r,i,s,l)}};e.$Vac=$,e.$Vac=$=ve([se(0,g.$ql),se(1,y.$Aj),se(2,m.$tl),se(3,v.$Sj),se(4,c.$Mi)],$);let a=class extends P.$Tc{constructor(o,r,i,s,l){super(),this.b=o,this.c=r,this.f=i,this.g=s,this.h=l,this.a=new Map}async openTunnel(o,r,i,s,l,b,R,I,E){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${i}:${s} on local port ${b}.`),!this.a.has(o)){const A=new $(this.b,this.c,this.g,this.f,this.h);this.B(A),this.a.set(o,A),A.onTunnelClosed(async()=>{(await A.tunnels).length===0&&(A.dispose(),this.a.delete(o))})}return this.a.get(o).openTunnel(r,i,s,l,b,R,I,E)}};e.$Wac=a,e.$Wac=a=ve([se(0,g.$ql),se(1,y.$Aj),se(2,v.$Sj),se(3,m.$tl),se(4,c.$Mi)],a)}),define(ae[101],ce([0,1,8,23,3,18,24,20,5,27,53,49]),function(X,e,n,D,S,M,C,P,d,c,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gac=e.$fac=void 0;function k(m,w,p){return`${p.updateUrl}/api/update/${m}/${w}/${p.commit}`}e.$fac=k;let g=class{get state(){return this.b}d(w){this.j.info("update#setState",w.type),this.b=w,this.c.fire(w)}constructor(w,p,u,f,h,$){this.f=w,this.g=p,this.h=u,this.i=f,this.j=h,this.k=$,this.b=v.$PW.Uninitialized,this.c=new S.$6d,this.onStateChange=this.c.event,w.when(3).finally(()=>this.l())}async l(){if(!this.h.isBuilt){this.d(v.$PW.Disabled(0));return}if(this.h.disableUpdates){this.d(v.$PW.Disabled(1)),this.j.info("update#ctor - updates are disabled by the environment");return}if(!this.k.updateUrl||!this.k.commit){this.d(v.$PW.Disabled(3)),this.j.info("update#ctor - updates are disabled as there is no update URL");return}const w=this.g.getValue("update.mode"),p=this.m(w);if(!p){this.d(v.$PW.Disabled(2)),this.j.info("update#ctor - updates are disabled by user preference");return}if(this.a=this.s(p),!this.a){this.d(v.$PW.Disabled(4)),this.j.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.g.getValue("_update.prss")){const u=new URL(this.a);u.searchParams.set("prss","true"),this.a=u.toString()}if(this.d(v.$PW.Idle(this.q())),w==="manual"){this.j.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}w==="start"?(this.j.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.n(30*1e3).then(void 0,u=>this.j.error(u))}m(w){return w==="none"?void 0:this.k.quality}n(w=60*60*1e3){return(0,n.$hh)(w).then(()=>this.checkForUpdates(!1)).then(()=>this.n(60*60*1e3))}async checkForUpdates(w){this.j.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.t(w)}async downloadUpdate(){this.j.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.o(this.state)}async o(w){}async applyUpdate(){this.j.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.p()}async p(){}quitAndInstall(){return this.j.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.j.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(w=>{this.j.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${w}`),!w&&(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.r())})),Promise.resolve(void 0)}async isLatestVersion(){if(!this.a)return;if(this.g.getValue("update.mode")==="none")return!1;try{return(await this.i.request({url:this.a},D.CancellationToken.None)).res.statusCode===204}catch(p){this.j.error("update#isLatestVersion(): failed to check for updates"),this.j.error(p);return}}async _applySpecificUpdate(w){}q(){return 1}r(){}};e.$gac=g,e.$gac=g=ve([se(0,P.$m_b),se(1,M.$Mi),se(2,C.$U$b),se(3,y.$wp),se(4,d.$Aj),se(5,c.$Sj)],g)}),define(ae[290],ce([0,1,14,50,3,45,2,18,24,20,5,27,53,28,49,101]),function(X,e,n,D,S,M,C,P,d,c,y,v,k,g,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hac=void 0;let p=class extends w.$gac{get v(){return S.Event.fromNodeEventEmitter(n.autoUpdater,"error",(f,h)=>h)}get w(){return S.Event.fromNodeEventEmitter(n.autoUpdater,"update-not-available")}get x(){return S.Event.fromNodeEventEmitter(n.autoUpdater,"update-available",(f,h,$)=>({url:h,version:$,productVersion:$}))}get y(){return S.Event.fromNodeEventEmitter(n.autoUpdater,"update-downloaded",(f,h,$,a)=>({releaseNotes:h,version:$,productVersion:$,date:a}))}constructor(f,h,$,a,t,o,r){super(f,h,a,t,o,r),this.z=$,this.u=new C.$Sc,f.setRelaunchHandler(this)}handleRelaunch(f){return f?.addArgs||f?.removeArgs||this.state.type!=="ready"?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){await super.l(),this.v(this.B,this,this.u),this.x(this.E,this,this.u),this.y(this.F,this,this.u),this.w(this.G,this,this.u)}B(f){this.z.publicLog2("update:error",{messageHash:String((0,M.$7i)(String(f)))}),this.j.error("UpdateService error:",f);const h=this.state.type==="checking for updates"&&this.state.explicit?f:void 0;this.d(m.$PW.Idle(1,h))}s(f){let h;this.k.darwinUniversalAssetId?h=this.k.darwinUniversalAssetId:h=process.arch==="x64"?"darwin":"darwin-arm64";const $=(0,w.$fac)(h,f,this.k);try{n.autoUpdater.setFeedURL({url:$})}catch(a){this.j.error("Failed to set update feed URL",a);return}return $}t(f){this.d(m.$PW.CheckingForUpdates(f)),n.autoUpdater.checkForUpdates()}E(f){this.state.type==="checking for updates"&&this.d(m.$PW.Downloading(f))}F(f){this.state.type==="downloading"&&(this.z.publicLog2("update:downloaded",{version:f.version}),this.d(m.$PW.Ready(f)))}G(){this.state.type==="checking for updates"&&(this.z.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.d(m.$PW.Idle(1)))}r(){this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),n.autoUpdater.quitAndInstall()}dispose(){this.u.dispose()}};e.$hac=p,ve([D.$Kh],p.prototype,"v",null),ve([D.$Kh],p.prototype,"w",null),ve([D.$Kh],p.prototype,"x",null),ve([D.$Kh],p.prototype,"y",null),e.$hac=p=ve([se(0,c.$m_b),se(1,P.$Mi),se(2,g.$Fl),se(3,d.$U$b),se(4,k.$wp),se(5,y.$Aj),se(6,v.$Sj)],p)}),define(ae[291],ce([0,1,48,46,8,3,9,24,20,5,28,49]),function(X,e,n,D,S,M,C,P,d,c,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jac=void 0;let k=class{get state(){return this.a}d(w){this.g.info("update#setState",w.type),this.a=w,this.b.fire(w)}constructor(w,p,u){if(this.f=w,this.g=u,this.a=v.$PW.Uninitialized,this.b=new M.$6d,this.onStateChange=this.b.event,p.disableUpdates){this.g.info("update#ctor - updates are disabled");return}this.d(v.$PW.Idle(this.k())),this.h(30*1e3).then(void 0,f=>this.g.error(f))}h(w=60*60*1e3){return(0,S.$hh)(w).then(()=>this.checkForUpdates(!1)).then(()=>this.h(60*60*1e3))}async checkForUpdates(w){this.g.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.m(w)}async downloadUpdate(){this.g.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.i(this.state)}i(w){return Promise.resolve(void 0)}async applyUpdate(){this.g.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.j()}j(){return Promise.resolve(void 0)}quitAndInstall(){return this.g.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.g.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(w=>{this.g.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${w}`),!w&&(this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.l())})),Promise.resolve(void 0)}k(){return 2}l(){}async _applySpecificUpdate(w){}};k=ve([se(0,d.$m_b),se(1,P.$U$b),se(2,c.$Aj)],k);let g=class extends k{constructor(w,p,u,f,h,$){super(u,f,h),this.o=w,this.p=p,this.q=$;const a=(0,D.watch)(C.$mc(this.o)),t=M.Event.fromNodeEventEmitter(a,"change",(s,l)=>l),o=M.Event.filter(t,s=>s==="current"),i=M.Event.debounce(o,(s,l)=>l,2e3)(()=>this.checkForUpdates(!1));u.onWillShutdown(()=>{i.dispose(),a.close()})}m(){this.d(v.$PW.CheckingForUpdates(!1)),this.u().then(w=>{w?this.d(v.$PW.Ready({version:"something",productVersion:"something"})):(this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(v.$PW.Idle(2)))},w=>{this.g.error(w),this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(v.$PW.Idle(2,w.message||w))})}l(){this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,n.spawn)("sleep 3 && "+C.$nc(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async u(){const w=await new Promise((u,f)=>(0,D.realpath)(`${C.$mc(this.o)}/current`,(h,$)=>h?f(h):u($))),p=C.$nc(w);return this.p!==p}isLatestVersion(){return this.u().then(void 0,w=>{this.g.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};e.$jac=g,e.$jac=g=ve([se(2,d.$m_b),se(3,P.$U$b),se(4,c.$Aj),se(5,y.$Fl)],g)}),define(ae[29],ce([0,1,14,4,6,81,55,69,27,18,24,9,138]),function(X,e,n,D,S,M,C,P,d,c,y,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowStateValidator=e.$8$b=e.$7$b=e.OpenContext=e.$6$b=void 0,e.$6$b=(0,S.$gi)("windowsMainService");var g;(function(u){u[u.CLI=0]="CLI",u[u.DOCK=1]="DOCK",u[u.MENU=2]="MENU",u[u.DIALOG=3]="DIALOG",u[u.DESKTOP=4]="DESKTOP",u[u.API=5]="API"})(g||(e.OpenContext=g={}));function m(u,f,h){const $=u.get(P.$4$b),a=u.get(d.$Sj),t=u.get(c.$Mi),o=u.get(y.$U$b),r=t.getValue("window"),i={backgroundColor:$.getBackgroundColor(),minWidth:C.$4C.WIDTH,minHeight:C.$4C.HEIGHT,title:a.nameLong,...h,x:f.x,y:f.y,width:f.width,height:f.height,webPreferences:{enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,C.$cD)(f.zoomLevel??r?.zoomLevel),autoplayPolicy:"user-gesture-required",enableBlinkFeatures:"HighlightAPI",...h?.webPreferences,sandbox:!0},experimentalDarkMode:!0};if(D.$k?i.icon=(0,v.$jc)(o.appRoot,"resources/linux/code.png"):D.$i&&!o.isBuilt&&(i.icon=(0,v.$jc)(o.appRoot,"resources/win32/code_150x150.png")),D.$j&&(i.acceptFirstMouse=!0,r?.clickThroughInactive===!1&&(i.acceptFirstMouse=!1)),D.$j&&!(0,C.$bD)(t)&&(i.fullscreenable=!1),D.$j&&r?.nativeTabs===!0&&(i.tabbingIdentifier=a.nameShort),!(0,C.$$C)(t)&&(i.titleBarStyle="hidden",D.$j||(i.frame=!1),(0,C.$aD)(t))){const b=$.getWindowSplash()?.colorInfo.titleBarBackground??$.getBackgroundColor(),R=k.$Bt.fromHex(b).isDarker()?"#FFFFFF":"#000000";i.titleBarOverlay={height:29,color:b,symbolColor:R}}return i}e.$7$b=m;function w(u){let f,h=Number.MIN_VALUE;for(const $ of u)$.lastFocusTime>h&&(h=$.lastFocusTime,f=$);return f}e.$8$b=w;var p;(function(u){function f($,a,t=n.screen.getAllDisplays()){if($.trace(`window#validateWindowState: validating window state on ${t.length} display(s)`,a),typeof a.x!="number"||typeof a.y!="number"||typeof a.width!="number"||typeof a.height!="number"){$.trace("window#validateWindowState: unexpected type of state values");return}if(a.width<=0||a.height<=0){$.trace("window#validateWindowState: unexpected negative values");return}if(t.length===1){const i=h(t[0]);if($.trace("window#validateWindowState: single monitor working area",i),i){let s=function(){!a||typeof a.x!="number"||typeof a.y!="number"||!i||(a.x<i.x&&(a.x=i.x),a.y<i.y&&(a.y=i.y))};s(),a.width>i.width&&(a.width=i.width),a.height>i.height&&(a.height=i.height),a.x>i.x+i.width-128&&(a.x=i.x+i.width-a.width),a.y>i.y+i.height-128&&(a.y=i.y+i.height-a.height),s()}return a}if(a.display&&a.mode===3){const i=t.find(s=>s.id===a.display);if(i&&typeof i.bounds?.x=="number"&&typeof i.bounds?.y=="number"){$.trace("window#validateWindowState: restoring fullscreen to previous display");const s=(0,M.$S$b)(3);return s.x=i.bounds.x,s.y=i.bounds.y,s}}let o,r;try{o=n.screen.getDisplayMatching({x:a.x,y:a.y,width:a.width,height:a.height}),r=h(o),$.trace("window#validateWindowState: multi-monitor working area",r)}catch(i){$.error("window#validateWindowState: error finding display for window state",i)}if(o&&r&&a.x+a.width>r.x&&a.y+a.height>r.y&&a.x<r.x+r.width&&a.y<r.y+r.height)return a;$.trace("window#validateWindowState: state is outside of the multi-monitor working area")}u.validateWindowState=f;function h($){if($.workArea.width>0&&$.workArea.height>0)return $.workArea;if($.bounds.width>0&&$.bounds.height>0)return $.bounds}})(p||(e.WindowStateValidator=p={}))}),define(ae[292],ce([0,1,14,23,3,45,2,32,120,5,83,29]),function(X,e,n,D,S,M,C,P,d,c,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$w_b=void 0;var k;(function(m){m[m.Initial=1]="Initial",m[m.StoredCredentialsUsed=2]="StoredCredentialsUsed",m[m.LoginDialogShown=3]="LoginDialogShown"})(k||(k={}));let g=class extends C.$Tc{constructor(w,p,u,f){super(),this.g=w,this.h=p,this.j=u,this.m=f,this.a="proxy-credentials://",this.b=void 0,this.c=k.Initial,this.f=void 0,this.n()}n(){const w=S.Event.fromNodeEventEmitter(n.app,"login",(p,u,f,h,$)=>({event:p,webContents:u,req:f,authInfo:h,callback:$}));this.B(w(this.r,this))}async r({event:w,authInfo:p,req:u,callback:f}){if(!p.isProxy)return;if(!this.b&&this.c===k.LoginDialogShown&&u.firstAuthAttempt){this.g.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}w.preventDefault();let h;if(this.b)this.g.trace("auth#onLogin (proxy) - pending proxy handling found"),h=await this.b;else{this.g.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.b=this.s(p);try{h=await this.b}finally{this.b=void 0}}f(h?.username,h?.password)}async s(w){this.g.trace("auth#resolveProxyCredentials (proxy) - enter");try{const p=await this.t(w);if(p)return this.g.trace("auth#resolveProxyCredentials (proxy) - got credentials"),p;this.g.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.g.trace("auth#resolveProxyCredentials (proxy) - exit")}}async t(w){this.g.trace("auth#doResolveProxyCredentials - enter",w);const p=String((0,M.$7i)({scheme:w.scheme,host:w.host,port:w.port}));let u,f;try{const t=this.m.get(this.a+p,-1);if(t){const o=JSON.parse(await this.j.decrypt(t));u=o.username,f=o.password}}catch(t){this.g.error(t)}if(this.c!==k.StoredCredentialsUsed&&typeof u=="string"&&typeof f=="string")return this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.c=k.StoredCredentialsUsed,{username:u,password:f};const h=this.h.getFocusedWindow()||this.h.getLastActiveWindow();if(!h){this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.g.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${h.id} to handle proxy login`);const $={authInfo:w,username:this.f?.username??u,password:this.f?.password??f,replyChannel:`vscode:proxyAuthResponse:${(0,P.$Cg)()}`};h.sendWhenReady("vscode:openProxyAuthenticationDialog",D.CancellationToken.None,$),this.c=k.LoginDialogShown;const a=await new Promise(t=>{const o=async(r,i,s)=>{if(i===$.replyChannel)if(this.g.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${h.id}`),h.win?.webContents.off("ipc-message",o),s){const l={username:s.username,password:s.password};try{if(s.remember){const b=await this.j.encrypt(JSON.stringify(l));this.m.store(this.a+p,b,-1,1)}else this.m.remove(this.a+p,-1)}catch(b){this.g.error(b)}t({username:l.username,password:l.password})}else t(void 0)};h.win?.webContents.on("ipc-message",o)});return this.f=a,a}};e.$w_b=g,e.$w_b=g=ve([se(0,c.$Aj),se(1,v.$6$b),se(2,d.$AW),se(3,y.$u_b)],g)}),define(ae[293],ce([0,1,14,22,4,7,21,18,63,6,5,131,29]),function(X,e,n,D,S,M,C,P,d,c,y,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Y_b=e.$X_b=e.ID=void 0,e.ID="launchMainService",e.$X_b=(0,c.$gi)(e.ID);let g=class{constructor(w,p,u,f){this.a=w,this.b=p,this.c=u,this.d=f}async start(w,p){this.a.trace("Received data from other instance: ",w,p),S.$j&&n.app.focus({steal:!0});const u=this.e(w);if(u.length){let f=Promise.resolve();if(this.b.getWindowCount()===0){const h=(0,D.$Ob)(await this.b.openEmptyWindow({context:4}));h&&(f=h.ready())}f.then(()=>{for(const{uri:h,originalUrl:$}of u)this.c.open(h,{originalUrl:$})})}else return this.f(w,p)}e(w){return w["open-url"]&&w._urls&&w._urls.length>0?(0,D.$Hb)(w._urls.map(p=>{try{return{uri:M.URI.parse(p),originalUrl:p}}catch{return null}})):[]}async f(w,p){const u=(0,d.$em)(p)?0:4;let f=[];const h=w.wait&&w.waitMarkerFilePath?M.URI.file(w.waitMarkerFilePath):void 0,$=w.remote||void 0,a={context:u,cli:w,userEnv:w["preserve-env"]||u===0?p:void 0,waitMarkerFileURI:h,remoteAuthority:$,forceProfile:w.profile,forceTempProfile:w["profile-temp"]};if(w.extensionDevelopmentPath)await this.b.openExtensionDevelopmentHostWindow(w.extensionDevelopmentPath,a);else if(!w._.length&&!w["folder-uri"]&&!w["file-uri"]){let t=!1;if(w["new-window"]||w["unity-launch"]||a.forceProfile||a.forceTempProfile)t=!0;else if(w["reuse-window"])t=!1;else switch(this.d.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":t=!0;break;case"off":t=!1;break;default:t=!S.$j}if(t)f=await this.b.open({...a,forceNewWindow:!0,forceEmpty:!0});else{const o=this.b.getLastActiveWindow();o?(this.b.openExistingWindow(o,a),f=[o]):f=await this.b.open({...a,forceEmpty:!0})}}else f=await this.b.open({...a,forceNewWindow:w["new-window"],preferNewWindow:!w["reuse-window"]&&!w.wait,forceReuseWindow:w["reuse-window"],diffMode:w.diff,mergeMode:w.merge,addMode:w.add,noRecentEntry:!!w["skip-add-to-recently-opened"],gotoLineMode:w.goto});if(h&&f.length===1&&f[0])return Promise.race([f[0].whenClosedOrLoaded,(0,C.whenDeleted)(h.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.a.trace("Received request for process ID from other instance."),process.pid}};e.$Y_b=g,e.$Y_b=g=ve([se(0,y.$Aj),se(1,k.$6$b),se(2,v.$GW),se(3,P.$Mi)],g)}),define(ae[294],ce([0,1,2,20,57,30,8,29]),function(X,e,n,D,S,M,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bac=void 0;let d=class extends n.$Tc{constructor(y,v,k){super(),this.a=v,this.b=k,this.B(y.onWillLoadWindow(g=>{g.reason===2&&this.c(g.window)})),this.B(y.onBeforeCloseWindow(g=>this.c(g))),this.B(new C.$sh(()=>this.g(),30*1e3)).schedule()}async c(y){const v=this.f(y),k=this.a.getProfileForWorkspace(v);k?.isTransient&&(this.a.unsetWorkspace(v,k.isTransient),k.isTransient&&await this.a.cleanUpTransientProfiles())}f(y){return y.openedWorkspace??(0,M.$ui)(y.backupPath,y.isExtensionDevelopmentHost)}g(){const y=this.a.getAssociatedEmptyWindows();if(y.length===0)return;const v=this.b.getWindows().map(k=>this.f(k));for(const k of y)v.some(g=>g.id===k.id)||this.a.unsetWorkspace(k,!1)}};e.$Bac=d,e.$Bac=d=ve([se(0,D.$m_b),se(1,S.$9$b),se(2,P.$6$b)],d)}),define(ae[60],ce([0,1,14,2,3,5,314,8,13,29,73,28,20,75,35,4,102]),function(X,e,n,D,S,M,C,P,d,c,y,v,k,g,m,w,p){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$A_b=e.$z_b=void 0;function f(a){return typeof a.responseWindowId=="number"}let h=class extends D.$Tc{static{u=this}static{this.a=0}static{this.b=new Map}static getAll(){return Array.from(u.b.values())}constructor(t,o,r){super(),this.u=t,this.w=o,this.y=r,this.c=String(++u.a),this.f=this.B(new S.$6d),this.onStdout=this.f.event,this.g=this.B(new S.$6d),this.onStderr=this.g.event,this.h=this.B(new S.$6d),this.onMessage=this.h.event,this.j=this.B(new S.$6d),this.onSpawn=this.j.event,this.m=this.B(new S.$6d),this.onExit=this.m.event,this.n=this.B(new S.$6d),this.onCrash=this.n.event,this.r=void 0,this.s=void 0,this.t=void 0}z(t,o){let r;switch(this.t?.correlationId?r=`[UtilityProcess id: ${this.t?.correlationId}, type: ${this.t?.type}, pid: ${this.s??"<none>"}]: ${t}`:r=`[UtilityProcess type: ${this.t?.type}, pid: ${this.s??"<none>"}]: ${t}`,o){case y.default.Error:this.u.error(r);break;case y.default.Warning:this.u.warn(r);break;case y.default.Info:this.u.trace(r);break}}C(){return this.r?(this.z("Cannot start utility process because it is already running...",y.default.Error),!1):!0}start(t){const o=this.D(t);return o&&t.payload&&this.postMessage(t.payload)&&this.z("payload sent via postMessage()",y.default.Info),o}D(t){if(!this.C())return!1;this.t=t;const o=`${this.t.type}-${this.c}`,r=d.$Ag.asFileUri("bootstrap-fork.js").fsPath,i=this.t.args??[],s=this.t.execArgv??[],l=this.t.allowLoadingUnsignedLibraries,b=this.t.forceAllocationsToV8Sandbox,R="pipe",I=this.F(t);return this.z("creating new...",y.default.Info),this.r=n.utilityProcess.fork(r,i,{serviceName:o,env:I,execArgv:s,allowLoadingUnsignedLibraries:l,forceAllocationsToV8Sandbox:b,stdio:R}),this.G(this.r,this.t,o),!0}F(t){const o=t.env?{...t.env}:{...(0,m.$Ln)(process.env)};o.VSCODE_AMD_ENTRYPOINT=t.entryPoint,typeof t.parentLifecycleBound=="number"&&(o.VSCODE_PARENT_PID=String(t.parentLifecycleBound)),o.VSCODE_CRASH_REPORTER_PROCESS_TYPE=t.type,w.$i&&((0,p.isUNCAccessRestrictionsDisabled)()?o.NODE_DISABLE_UNC_ACCESS_CHECKS="1":o.NODE_UNC_HOST_ALLOWLIST=(0,p.getUNCHostAllowlist)().join("\\")),(0,g.$4l)(o);for(const r of Object.keys(o))o[r]=String(o[r]);return o}G(t,o,r){if(t.stdout){const i=new C.StringDecoder("utf-8");this.B(S.Event.fromNodeEventEmitter(t.stdout,"data")(s=>this.f.fire(typeof s=="string"?s:i.write(s))))}if(t.stderr){const i=new C.StringDecoder("utf-8");this.B(S.Event.fromNodeEventEmitter(t.stderr,"data")(s=>this.g.fire(typeof s=="string"?s:i.write(s))))}this.B(S.Event.fromNodeEventEmitter(t,"message")(i=>this.h.fire(i))),this.B(S.Event.fromNodeEventEmitter(t,"spawn")(()=>{this.s=t.pid,typeof t.pid=="number"&&u.b.set(t.pid,{pid:t.pid,name:f(o)?`${o.type} [${o.responseWindowId}]`:o.type}),this.z("successfully created",y.default.Info),this.j.fire(t.pid)})),this.B(S.Event.fromNodeEventEmitter(t,"exit")(i=>{this.z(`received exit event with code ${i}`,y.default.Info),this.m.fire({pid:this.s,code:i,signal:"unknown"}),this.H()})),this.B(S.Event.fromNodeEventEmitter(n.app,"child-process-gone",(i,s)=>({event:i,details:s}))(({details:i})=>{i.type==="Utility"&&i.name===r&&(this.z(`crashed with code ${i.exitCode} and reason '${i.reason}'`,y.default.Error),this.w.publicLog2("utilityprocesscrash",{type:o.type,reason:i.reason,code:i.exitCode}),this.n.fire({pid:this.s,code:i.exitCode,reason:i.reason}),this.H())}))}once(t,o){const r=this.B(this.h.event(i=>{i===t&&(r.dispose(),o())}))}postMessage(t,o){return this.r?(this.r.postMessage(t,o),!0):!1}connect(t){const{port1:o,port2:r}=new n.MessageChannelMain;return this.postMessage(t,[r]),o}enableInspectPort(){if(!this.r||typeof this.s!="number")return!1;this.z("enabling inspect port",y.default.Info);const t=process;return typeof t._debugProcess=="function"?(t._debugProcess(this.s),!0):!1}kill(){if(!this.r)return;this.z("attempting to kill the process...",y.default.Info),this.r.kill()?(this.z("successfully killed the process",y.default.Info),this.H()):this.z("unable to kill the process",y.default.Warning)}H(){typeof this.s=="number"&&u.b.delete(this.s),this.r=void 0}async waitForExit(t){this.r&&(this.z("waiting to exit...",y.default.Info),await Promise.race([S.Event.toPromise(this.onExit),(0,P.$hh)(t)]),this.r&&(this.z(`did not exit within ${t}ms, will kill it now...`,y.default.Info),this.kill()))}};e.$z_b=h,e.$z_b=h=u=ve([se(0,M.$Aj),se(1,v.$Fl),se(2,k.$m_b)],h);let $=class extends h{constructor(t,o,r,i){super(t,r,i),this.I=o}start(t){const o=this.I.getWindowById(t.responseWindowId);if(!o?.win||o.win.isDestroyed()||o.win.webContents.isDestroyed())return this.z("Refusing to start utility process because requesting window cannot be found or is destroyed...",y.default.Error),!0;if(!super.D(t))return!1;this.J(o.win,t);const i=this.connect(t.payload);return o.win.webContents.postMessage(t.responseChannel,t.responseNonce,[i]),!0}J(t,o){o.windowLifecycleBound&&(this.B(S.Event.filter(this.y.onWillLoadWindow,r=>r.window.win===t)(()=>this.kill())),this.B(S.Event.fromNodeEventEmitter(t,"closed")(()=>this.kill())))}};e.$A_b=$,e.$A_b=$=ve([se(0,M.$Aj),se(1,c.$6$b),se(2,v.$Fl),se(3,k.$m_b)],$)}),define(ae[295],ce([0,1,15,3,5,20,8,60,29,28]),function(X,e,n,D,S,M,C,P,d,c){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.$H_b=void 0;let v=class{static{y=this}static{this.a=0}constructor(g,m,w,p){this.d=g,this.f=m,this.g=w,this.h=p,this.b=new Map,this.c=!1,this.f.onWillShutdown(u=>{this.c=!0,u.join("extHostStarter",this._waitForAllExit(6e3))})}dispose(){}i(g){const m=this.b.get(g);if(!m)throw new Error("Unknown extension host!");return m}onDynamicStdout(g){return this.i(g).onStdout}onDynamicStderr(g){return this.i(g).onStderr}onDynamicMessage(g){return this.i(g).onMessage}onDynamicExit(g){return this.i(g).onExit}async createExtensionHost(){if(this.c)throw(0,n.$6)();const g=String(++y.a),m=new P.$A_b(this.d,this.g,this.h,this.f);return this.b.set(g,m),m.onExit(({pid:w,code:p,signal:u})=>{this.d.info(`Extension host with pid ${w} exited with code: ${p}, signal: ${u}.`),setTimeout(()=>{m.dispose(),this.b.delete(g)}),setTimeout(()=>{try{process.kill(w,0),this.d.error(`Extension host with pid ${w} still exists, forcefully killing it...`),process.kill(w)}catch{}},1e3)}),{id:g}}async start(g,m){if(this.c)throw(0,n.$6)();const w=this.i(g);return w.start({...m,type:"extensionHost",entryPoint:"vs/workbench/api/node/extensionHostProcess",args:["--skipWorkspaceStorageLock"],execArgv:m.execArgv,allowLoadingUnsignedLibraries:!0,forceAllocationsToV8Sandbox:!0,correlationId:g}),{pid:await D.Event.toPromise(w.onSpawn)}}async enableInspectPort(g){if(this.c)throw(0,n.$6)();const m=this.b.get(g);return m?m.enableInspectPort():!1}async kill(g){if(this.c)throw(0,n.$6)();const m=this.b.get(g);m&&m.kill()}async _killAllNow(){for(const[,g]of this.b)g.kill()}async _waitForAllExit(g){const m=[];for(const[,w]of this.b)m.push(w.waitForExit(g));return C.Promises.settled(m).then(()=>{})}};e.$H_b=v,e.$H_b=v=y=ve([se(0,S.$Aj),se(1,M.$m_b),se(2,d.$6$b),se(3,c.$Fl)],v)}),define(ae[296],ce([0,1,37,8,2,24,20,5,41,39,67,60,54,91,12,249]),function(X,e,n,D,S,M,C,P,d,c,y,v,k,g,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$__b=void 0;let p=class extends S.$Tc{constructor(f,h,$,a,t,o,r,i){super(),this.f=f,this.g=h,this.h=$,this.j=a,this.m=t,this.n=o,this.r=r,this.s=i,this.a=new D.$fh,this.b=void 0,this.c=void 0,this.y=void 0,this.z=void 0,this.t()}t(){n.$RV.on(w.$0_b.request,(f,h)=>this.u(f,h,w.$0_b.response)),n.$RV.on(w.$$_b.request,(f,h)=>this.u(f,h,w.$$_b.response)),this.B(this.m.onWillShutdown(()=>this.w()))}async u(f,h,$){this.n.trace(`[SharedProcess] onWindowConnection for: ${$}`),this.a.isOpen()||this.a.open(),await this.whenReady();const a=await this.connect($);if(f.sender.isDestroyed())return a.close();f.sender.postMessage($,h,[a])}w(){this.n.trace("[SharedProcess] onWillShutdown"),this.b?.postMessage(w.$9_b.exit),this.b=void 0}whenReady(){return this.y||(this.y=(async()=>{await this.C;const f=new D.$Dh;this.b?.once(w.$9_b.initDone,()=>f.complete()),await f.p,this.c?.dispose(),this.n.trace("[SharedProcess] Overall ready")})()),this.y}get C(){return this.z||(this.z=(async()=>{await this.a.wait(),this.D();const f=new D.$Dh;this.b?.once(w.$9_b.ipcReady,()=>f.complete()),await f.p,this.n.trace("[SharedProcess] IPC ready")})()),this.z}D(){this.b=this.B(new v.$z_b(this.n,k.$3o,this.m)),this.c=this.b.onMessage($=>{typeof $.warning=="string"?this.n.warn($.warning):typeof $.error=="string"&&this.n.error($.error)});const f=(0,g.$Tm)(this.h.args,this.h.isBuilt);let h;f.port&&(h=["--nolazy"],f.break?h.push(`--inspect-brk=${f.port}`):h.push(`--inspect=${f.port}`)),this.b.start({type:"shared-process",entryPoint:"vs/code/node/sharedProcess/sharedProcessMain",payload:this.F(),execArgv:h})}F(){return{machineId:this.f,sqmId:this.g,codeCachePath:this.h.codeCachePath,profiles:{home:this.j.profilesHome,all:this.j.profiles},args:this.h.args,logLevel:this.r.getLogLevel(),loggers:this.r.getRegisteredLoggers(),policiesData:this.s.serialize()}}async connect(f){return await this.C,(0,m.$5f)(this.b).connect(f)}};e.$__b=p,e.$__b=p=ve([se(2,M.$U$b),se(3,d.$gl),se(4,C.$m_b),se(5,P.$Aj),se(6,y.$h_b),se(7,c.$Zn)],p)}),define(ae[297],ce([0,1,24,91,20,5,54,60,114,37,2,3,35,18,13]),function(X,e,n,D,S,M,C,P,d,c,y,v,k,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lac=void 0;let w=class extends y.$Tc{constructor(u,f,h,$,a){super(),this.f=u,this.g=f,this.h=h,this.j=$,this.m=a,this.a=void 0,this.b=new v.$6d,this.onRequestConnection=this.b.event,this.c=new v.$6d,this.onWillShutdown=this.c.event,this.j.onWillShutdown(()=>this.c.fire()),c.$RV.on("vscode:createPtyHostMessageChannel",(t,o)=>this.r(t,o)),this.B((0,y.$Rc)(()=>{c.$RV.removeHandler("vscode:createPtyHostMessageChannel")}))}start(){this.a=new P.$z_b(this.m,C.$3o,this.j);const u=(0,D.$Sm)(this.h.args,this.h.isBuilt),f=u.port?["--nolazy",`--inspect${u.break?"-brk":""}=${u.port}`]:void 0;this.a.start({type:"ptyHost",entryPoint:"vs/platform/terminal/node/ptyHostMain",execArgv:f,args:["--logsPath",this.h.logsHome.with({scheme:m.Schemas.file}).fsPath],env:this.n()});const h=this.a.connect(),$=new d.$ZV(h,"ptyHost"),a=new y.$Sc;return a.add($),a.add((0,y.$Rc)(()=>{this.a?.kill(),this.a?.dispose(),this.a=void 0})),{client:$,store:a,onDidProcessExit:this.a.onExit}}n(){this.h.unsetSnapExportedVariables();const u={...(0,k.$Ln)(process.env),VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:String(this.f.graceTime),VSCODE_RECONNECT_SHORT_GRACE_TIME:String(this.f.shortGraceTime),VSCODE_RECONNECT_SCROLLBACK:String(this.f.scrollback)},f=this.g.getValue("terminal.integrated.developer.ptyHost.latency");f&&typeof f=="number"&&(u.VSCODE_LATENCY=String(f));const h=this.g.getValue("terminal.integrated.developer.ptyHost.startupDelay");return h&&typeof h=="number"&&(u.VSCODE_STARTUP_DELAY=String(h)),this.h.restoreSnapExportedVariables(),u}r(u,f){this.b.fire();const h=this.a.connect();if(u.sender.isDestroyed()){h.close();return}u.sender.postMessage("vscode:createPtyHostMessageChannelResult",f,[h])}};e.$Lac=w,e.$Lac=w=ve([se(1,g.$Mi),se(2,n.$U$b),se(3,S.$m_b),se(4,M.$Aj)],w)}),define(ae[298],ce([0,1,2,6,5,29,60,28,45,3,8,20]),function(X,e,n,D,S,M,C,P,d,c,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kac=e.$Jac=void 0,e.$Jac=(0,D.$gi)("utilityProcessWorker");let k=class extends n.$Tc{constructor(w,p,u,f){super(),this.b=w,this.c=p,this.f=u,this.g=f,this.a=new Map}async createWorker(w){const p=`window: ${w.reply.windowId}, moduleId: ${w.process.moduleId}`;this.b.trace(`[UtilityProcessWorker]: createWorker(${p})`);const u=this.h(w);this.a.has(u)&&(this.b.warn(`[UtilityProcessWorker]: createWorker() found an existing worker that will be terminated (${p})`),this.disposeWorker(w));const f=new g(this.b,this.c,this.f,this.g,w);if(!f.spawn())return{reason:{code:1,signal:"EINVALID"}};this.a.set(u,f);const h=new y.$Dh;return c.Event.once(f.onDidTerminate)($=>{$.code===0?this.b.trace(`[UtilityProcessWorker]: terminated normally with code ${$.code}, signal: ${$.signal}`):this.b.error(`[UtilityProcessWorker]: terminated unexpectedly with code ${$.code}, signal: ${$.signal}`),this.a.delete(u),h.complete({reason:$})}),h.p}h(w){return(0,d.$7i)({moduleId:w.process.moduleId,windowId:w.reply.windowId})}async disposeWorker(w){const p=this.h(w),u=this.a.get(p);u&&(this.b.trace(`[UtilityProcessWorker]: disposeWorker(window: ${w.reply.windowId}, moduleId: ${w.process.moduleId})`),u.kill(),this.a.delete(p))}};e.$Kac=k,e.$Kac=k=ve([se(0,S.$Aj),se(1,M.$6$b),se(2,P.$Fl),se(3,v.$m_b)],k);let g=class extends n.$Tc{constructor(w,p,u,f,h){super(),this.c=w,this.f=p,this.g=u,this.h=f,this.j=h,this.a=this.B(new c.$6d),this.onDidTerminate=this.a.event,this.b=new C.$A_b(this.c,this.f,this.g,this.h),this.m()}m(){this.B(this.b.onExit(w=>this.a.fire({code:w.code,signal:w.signal}))),this.B(this.b.onCrash(w=>this.a.fire({code:w.code,signal:"ECRASH"})))}spawn(){const p=this.f.getWindowById(this.j.reply.windowId)?.win?.webContents.getOSProcessId();return this.b.start({type:this.j.process.type,entryPoint:this.j.process.moduleId,parentLifecycleBound:p,windowLifecycleBound:!0,correlationId:`${this.j.reply.windowId}`,responseWindowId:this.j.reply.windowId,responseChannel:this.j.reply.channel,responseNonce:this.j.reply.nonce})}kill(){this.b.kill()}};g=ve([se(0,S.$Aj),se(1,M.$6$b),se(2,P.$Fl),se(3,v.$m_b)],g)}),define(ae[299],ce([0,1,14,3,2,275,29]),function(X,e,n,D,S,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rac=void 0;let P=class extends S.$Tc{constructor(c){super(),this.b=c,this.a=this.B(new D.$6d),this.onFoundInFrame=this.a.event,this.B(new M.$qac)}async setIgnoreMenuShortcuts(c,y){let v;if(typeof c.windowId=="number"){const{windowId:k}=c,g=this.b.getWindowById(k);if(!g?.win)throw new Error(`Invalid windowId: ${k}`);v=g.win.webContents}else{const{webContentsId:k}=c;if(v=n.webContents.fromId(k),!v)throw new Error(`Invalid webContentsId: ${k}`)}v.isDestroyed()||v.setIgnoreMenuShortcuts(y)}async findInFrame(c,y,v,k){const m=this.c(c,y);if(typeof m.findInFrame=="function"){m.findInFrame(v,{findNext:k.findNext,forward:k.forward});const w=(p,u)=>{u.finalUpdate&&(this.a.fire(u),m.removeListener("found-in-frame",w))};m.on("found-in-frame",w)}}async stopFindInFrame(c,y,v){const g=this.c(c,y);typeof g.stopFindInFrame=="function"&&g.stopFindInFrame(v.keepSelection?"keepSelection":"clearSelection")}c(c,y){const v=this.b.getWindowById(c.windowId);if(!v?.win)throw new Error(`Invalid windowId: ${c}`);const k=v.win.webContents.mainFrame.framesInSubtree.find(g=>g.name===y);if(!k)throw new Error(`Unknown frame: ${y}`);return k}};e.$rac=P,e.$rac=P=ve([se(0,C.$6$b)],P)}),define(ae[300],ce([0,1,14,2,4,19,7,18,20,5,34,29,81,30]),function(X,e,n,D,S,M,C,P,d,c,y,v,k,g){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$uac=e.$tac=e.$sac=void 0;let w=class extends D.$Tc{static{m=this}static{this.a="windowsState"}get state(){return this.b}constructor(a,t,o,r,i){super(),this.g=a,this.h=t,this.j=o,this.m=r,this.n=i,this.b=p(this.h.getItem(m.a)),this.c=void 0,this.f=!1,this.r()}r(){n.app.on("browser-window-blur",()=>{this.f||this.t()}),this.j.onBeforeCloseWindow(a=>this.u(a)),this.j.onBeforeShutdown(()=>this.s()),this.g.onDidChangeWindowsCount(a=>{a.newCount-a.oldCount>0&&(this.c=void 0)}),this.g.onDidDestroyWindow(a=>this.u(a))}s(){this.f=!0,this.t()}t(){const a=new Set,t={openedWindows:[],lastPluginDevelopmentHostWindow:this.b.lastPluginDevelopmentHostWindow,lastActiveWindow:this.c};if(!t.lastActiveWindow){let i=this.g.getLastActiveWindow();(!i||i.isExtensionDevelopmentHost)&&(i=this.g.getWindows().find(s=>!s.isExtensionDevelopmentHost)),i&&(t.lastActiveWindow=this.w(i),t.lastActiveWindow.uiState.mode===3&&a.add(t.lastActiveWindow.uiState.display))}const o=this.g.getWindows().find(i=>i.isExtensionDevelopmentHost&&!i.isExtensionTestHost);o&&(t.lastPluginDevelopmentHostWindow=this.w(o),t.lastPluginDevelopmentHostWindow.uiState.mode===3&&(a.has(t.lastPluginDevelopmentHostWindow.uiState.display)?S.$j&&!o.win?.isSimpleFullScreen()&&(t.lastPluginDevelopmentHostWindow.uiState.mode=1):a.add(t.lastPluginDevelopmentHostWindow.uiState.display))),this.g.getWindowCount()>1&&(t.openedWindows=this.g.getWindows().filter(i=>!i.isExtensionDevelopmentHost).map(i=>{const s=this.w(i);return s.uiState.mode===3&&(a.has(s.uiState.display)?S.$j&&s.windowId!==t.lastActiveWindow?.windowId&&!i.win?.isSimpleFullScreen()&&(s.uiState.mode=1):a.add(s.uiState.display)),s}));const r=f(t);this.h.setItem(m.a,r),this.f&&this.m.trace("[WindowsStateHandler] onBeforeShutdown",r)}u(a){if(this.j.quitRequested)return;const t=this.w(a);a.isExtensionDevelopmentHost&&!a.isExtensionTestHost?this.b.lastPluginDevelopmentHostWindow=t:!a.isExtensionDevelopmentHost&&a.openedWorkspace&&this.b.openedWindows.forEach(o=>{const r=(0,g.$vi)(a.openedWorkspace)&&o.workspace?.id===a.openedWorkspace.id,i=(0,g.$qi)(a.openedWorkspace)&&o.folderUri&&M.$Kg.isEqual(o.folderUri,a.openedWorkspace.uri);(r||i)&&(o.uiState=t.uiState)}),this.g.getWindowCount()===1&&(this.c=t)}w(a){return{windowId:a.id,workspace:(0,g.$vi)(a.openedWorkspace)?a.openedWorkspace:void 0,folderUri:(0,g.$qi)(a.openedWorkspace)?a.openedWorkspace.uri:void 0,backupPath:a.backupPath,remoteAuthority:a.remoteAuthority,uiState:a.serializeWindowState()}}getNewWindowState(a){const t=this.z(a),o=this.n.getValue("window");if(t.mode===3){let r;t.hasDefaultState?r=!!(o?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(o.newWindowDimensions)>=0):r=!!(this.j.wasRestarted||o?.restoreFullscreen),r||(t.mode=1)}return t}z(a){const t=this.g.getLastActiveWindow();if(!a.extensionTestsPath){if(a.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const b=a.workspace;if((0,g.$vi)(b)){const I=this.state.openedWindows.filter(E=>E.workspace&&E.workspace.id===b.id).map(E=>E.uiState);if(I.length)return I[0]}if((0,g.$qi)(b)){const I=this.state.openedWindows.filter(E=>E.folderUri&&M.$Kg.isEqual(E.folderUri,b.uri)).map(E=>E.uiState);if(I.length)return I[0]}else if(a.backupPath){const I=this.state.openedWindows.filter(E=>E.backupPath===a.backupPath).map(E=>E.uiState);if(I.length)return I[0]}const R=this.c||this.state.lastActiveWindow;if(!t&&R)return R.uiState}let o;const r=n.screen.getAllDisplays();if(r.length===1)o=r[0];else{if(S.$j){const b=n.screen.getCursorScreenPoint();o=n.screen.getDisplayNearestPoint(b)}!o&&t&&(o=n.screen.getDisplayMatching(t.getBounds())),o||(o=n.screen.getPrimaryDisplay()||r[0])}let i=(0,k.$S$b)();i.x=Math.round(o.bounds.x+o.bounds.width/2-i.width/2),i.y=Math.round(o.bounds.y+o.bounds.height/2-i.height/2);const s=this.n.getValue("window");let l=!0;if(s?.newWindowDimensions){if(s.newWindowDimensions==="maximized")i.mode=0,l=!1;else if(s.newWindowDimensions==="fullscreen")i.mode=3,l=!1;else if((s.newWindowDimensions==="inherit"||s.newWindowDimensions==="offset")&&t){const b=t.serializeWindowState();b.mode===3?i.mode=3:i={...b,zoomLevel:void 0},l=i.mode!==3&&s.newWindowDimensions==="offset"}}return l&&(i=this.C(i)),i.hasDefaultState=!0,i}C(a){if(this.g.getWindows().length===0)return a;a.x=typeof a.x=="number"?a.x:0,a.y=typeof a.y=="number"?a.y:0;const t=this.g.getWindows().map(o=>o.getBounds());for(;t.some(o=>o.x===a.x||o.y===a.y);)a.x+=30,a.y+=30;return a}};e.$sac=w,e.$sac=w=m=ve([se(0,v.$6$b),se(1,y.$HP),se(2,d.$m_b),se(3,c.$Aj),se(4,P.$Mi)],w);function p($){const a={openedWindows:[]},t=$||{openedWindows:[]};return t.lastActiveWindow&&(a.lastActiveWindow=u(t.lastActiveWindow)),t.lastPluginDevelopmentHostWindow&&(a.lastPluginDevelopmentHostWindow=u(t.lastPluginDevelopmentHostWindow)),Array.isArray(t.openedWindows)&&(a.openedWindows=t.openedWindows.map(o=>u(o))),a}e.$tac=p;function u($){const a={uiState:$.uiState};return $.backupPath&&(a.backupPath=$.backupPath),$.remoteAuthority&&(a.remoteAuthority=$.remoteAuthority),$.folder&&(a.folderUri=C.URI.parse($.folder)),$.workspaceIdentifier&&(a.workspace={id:$.workspaceIdentifier.id,configPath:C.URI.parse($.workspaceIdentifier.configURIPath)}),a}function f($){return{lastActiveWindow:$.lastActiveWindow&&h($.lastActiveWindow),lastPluginDevelopmentHostWindow:$.lastPluginDevelopmentHostWindow&&h($.lastPluginDevelopmentHostWindow),openedWindows:$.openedWindows.map(a=>h(a))}}e.$uac=f;function h($){return{workspaceIdentifier:$.workspace&&{id:$.workspace.id,configURIPath:$.workspace.configPath.toString()},folder:$.folderUri&&$.folderUri.toString(),backupPath:$.backupPath,remoteAuthority:$.remoteAuthority,uiState:$.uiState}}}),define(ae[58],ce([0,1,14,3,42,2,13,9,19,21,196,64,56,24,6,5,57,133,30,98,99]),function(X,e,n,D,S,M,C,P,d,c,y,v,k,g,m,w,p,u,f,h,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$g_b=e.$f_b=void 0,e.$f_b=(0,m.$gi)("workspacesManagementMainService");let a=class extends M.$Tc{constructor(o,r,i,s,l){super(),this.g=o,this.h=r,this.j=i,this.m=s,this.n=l,this.a=this.B(new D.$6d),this.onDidDeleteUntitledWorkspace=this.a.event,this.b=this.B(new D.$6d),this.onDidEnterWorkspace=this.b.event,this.c=this.g.untitledWorkspacesHome,this.f=[]}async initialize(){this.f=[];try{const o=(await c.Promises.readdir(this.c.with({scheme:C.Schemas.file}).fsPath)).map(r=>(0,d.$Tg)(this.c,r,f.$Fi));for(const r of o){const i=(0,$.$c_b)(r),s=await this.resolveLocalWorkspace(r);s?this.f.push({workspace:i,remoteAuthority:s.remoteAuthority}):await this.deleteUntitledWorkspace(i)}}catch(o){o.code!=="ENOENT"&&this.h.warn(`Unable to read folders in ${this.c} (${o}).`)}}resolveLocalWorkspace(o){return this.r(o,r=>c.Promises.readFile(r,"utf8"))}r(o,r){if(this.s(o)&&o.scheme===C.Schemas.file)try{const i=r(o.fsPath);return i instanceof Promise?i.then(s=>this.t(o,s),s=>{}):this.t(o,i)}catch{return}}s(o){return(0,f.$Gi)(o,this.g)||(0,f.$Li)(o)}t(o,r){try{const i=this.u(o,r),s=(0,$.$c_b)(o);return{id:s.id,configPath:s.configPath,folders:(0,h.$reb)(i.folders,s.configPath,d.$Kg),remoteAuthority:i.remoteAuthority,transient:i.transient}}catch(i){this.h.warn(i.toString())}}u(o,r){const i=(0,S.$sn)(r);if(i&&Array.isArray(i.folders))i.folders=i.folders.filter(s=>(0,h.$peb)(s));else throw new Error(`${o.toString(!0)} looks like an invalid workspace file.`);return i}async createUntitledWorkspace(o,r){const{workspace:i,storedWorkspace:s}=this.w(o,r),l=i.configPath.fsPath;return await c.Promises.mkdir((0,P.$mc)(l),{recursive:!0}),await c.Promises.writeFile(l,JSON.stringify(s,null,"	")),this.f.push({workspace:i,remoteAuthority:r}),i}w(o=[],r){const i=(Date.now()+Math.round(Math.random()*1e3)).toString(),s=(0,d.$Tg)(this.c,i),l=(0,d.$Tg)(s,f.$Fi),b=[];for(const R of o)b.push((0,h.$qeb)(R.uri,!0,R.name,s,d.$Kg));return{workspace:(0,$.$c_b)(l),storedWorkspace:{folders:b,remoteAuthority:r}}}async getWorkspaceIdentifier(o){return(0,$.$c_b)(o)}isUntitledWorkspace(o){return(0,f.$Gi)(o.configPath,this.g)}async deleteUntitledWorkspace(o){this.isUntitledWorkspace(o)&&(await this.y(o),this.j.isEnabled()&&this.j.unsetWorkspace(o),this.a.fire(o))}async y(o){const r=(0,d.$Hg)(o.configPath);try{await c.Promises.rm((0,P.$mc)(r));const i=(0,P.$jc)(this.g.workspaceStorageHome.with({scheme:C.Schemas.file}).fsPath,o.id);await c.Promises.exists(i)&&await c.Promises.writeFile((0,P.$jc)(i,"obsolete"),""),this.f=this.f.filter(s=>s.workspace.id!==o.id)}catch(i){this.h.warn(`Unable to delete untitled workspace ${r} (${i}).`)}}getUntitledWorkspaces(){return this.f}async enterWorkspace(o,r,i){if(!o||!o.win||!o.isReady||!await this.z(o,r,i))return;const l=await this.C(o,(0,$.$c_b)(i));if(l)return this.b.fire({window:o,workspace:l.workspace}),l}async z(o,r,i){return i?(0,f.$vi)(o.openedWorkspace)&&d.$Kg.isEqual(o.openedWorkspace.configPath,i)?!1:(0,u.$_$b)(r,i)?(await this.n.showMessageBox({type:"info",buttons:[(0,y.localize)(0,null)],message:(0,y.localize)(1,null,(0,d.$Qg)(i)),detail:(0,y.localize)(2,null)},n.BrowserWindow.getFocusedWindow()??void 0),!1):!0:!0}async C(o,r){if(!o.config)return;o.focus();let i;return o.config.extensionDevelopmentPath||(o.config.backupPath?i=await this.m.registerWorkspaceBackup({workspace:r,remoteAuthority:o.remoteAuthority},o.config.backupPath):i=this.m.registerWorkspaceBackup({workspace:r,remoteAuthority:o.remoteAuthority})),(0,f.$vi)(o.openedWorkspace)&&this.isUntitledWorkspace(o.openedWorkspace)&&await this.deleteUntitledWorkspace(o.openedWorkspace),o.config.workspace=r,o.config.backupPath=i,{workspace:r,backupPath:i}}};e.$g_b=a,e.$g_b=a=ve([se(0,g.$U$b),se(1,w.$Aj),se(2,p.$9$b),se(3,v.$Z$b),se(4,k.$1$b)],a)}),define(ae[134],ce([0,1,14,37,23,6,29,30,58,12,5,60]),function(X,e,n,D,S,M,C,P,d,c,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$D_b=e.$C_b=e.ID=void 0,e.ID="diagnosticsMainService",e.$C_b=(0,M.$gi)(e.ID);let k=class{constructor(m,w,p){this.a=m,this.b=w,this.c=p}async getRemoteDiagnostics(m){const w=this.a.getWindows();return(await Promise.all(w.map(async u=>{const f=u.remoteAuthority;if(!f)return;const h=`vscode:getDiagnosticInfoResponse${u.id}`,$={includeProcesses:m.includeProcesses,folders:m.includeWorkspaceMetadata?await this.f(u):void 0};return new Promise(a=>{u.sendWhenReady("vscode:getDiagnosticInfo",S.CancellationToken.None,{replyChannel:h,args:$}),D.$RV.once(h,(t,o)=>{o||a({hostName:f,errorMessage:`Unable to resolve connection to '${f}'.`}),a(o)}),setTimeout(()=>{a({hostName:f,errorMessage:`Connection to '${f}' could not be established`})},5e3)})}))).filter(u=>!!u)}async getMainDiagnostics(){this.c.trace("Received request for main process info from other instance.");const m=[];for(const p of n.BrowserWindow.getAllWindows()){const u=this.a.getWindowById(p.id);u?m.push(await this.d(u)):m.push(this.e(p))}const w=[];for(const{pid:p,name:u}of v.$z_b.getAll())w.push({pid:p,name:u});return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:m,pidToNames:w,screenReader:!!n.app.accessibilitySupportEnabled,gpuFeatureStatus:n.app.getGPUFeatureStatus()}}async d(m){const w=await this.f(m),p=(0,c.$5f)(m.win);return this.e(p,w,m.remoteAuthority)}e(m,w=[],p){return{id:m.id,pid:m.webContents.getOSProcessId(),title:m.getTitle(),folderURIs:w,remoteAuthority:p}}async f(m){const w=[],p=m.openedWorkspace;if((0,P.$qi)(p))w.push(p.uri);else if((0,P.$vi)(p)){const u=await this.b.resolveLocalWorkspace(p.configPath);u&&u.folders.forEach(h=>{w.push(h.uri)})}return w}};e.$D_b=k,e.$D_b=k=ve([se(0,C.$6$b),se(1,d.$f_b),se(2,y.$Aj)],k)}),define(ae[70],ce([0,1,48,14,26,158,50,3,2,13,9,4,7,109,89,21,107,184,56,24,6,20,5,27,69,29,30,58,17,245,237,78,15]),function(X,e,n,D,S,M,C,P,d,c,y,v,k,g,m,w,p,u,f,h,$,a,t,o,r,i,s,l,b,R,I,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S_b=e.$R_b=void 0,e.$R_b=(0,$.$gi)("nativeHostMainService");let j=class extends d.$Tc{constructor(W,V,K,le,re,ue,Z,Y,U){super(),this.a=W,this.b=V,this.c=K,this.f=le,this.g=re,this.h=ue,this.j=Z,this.m=Y,this.n=U,this.onDidOpenMainWindow=P.Event.map(this.a.onDidOpenWindow,L=>L.id),this.onDidTriggerWindowSystemContextMenu=P.Event.any(P.Event.filter(P.Event.map(this.a.onDidTriggerSystemContextMenu,({window:L,x:N,y:G})=>({windowId:L.id,x:N,y:G})),({windowId:L})=>!!this.a.getWindowById(L)),P.Event.filter(P.Event.map(this.b.onDidTriggerSystemContextMenu,({window:L,x:N,y:G})=>({windowId:L.id,x:N,y:G})),({windowId:L})=>!!this.b.getWindowById(L))),this.onDidMaximizeWindow=P.Event.any(P.Event.filter(P.Event.map(this.a.onDidMaximizeWindow,L=>L.id),L=>!!this.a.getWindowById(L)),P.Event.filter(P.Event.map(this.b.onDidMaximizeWindow,L=>L.id),L=>!!this.b.getWindowById(L))),this.onDidUnmaximizeWindow=P.Event.any(P.Event.filter(P.Event.map(this.a.onDidUnmaximizeWindow,L=>L.id),L=>!!this.a.getWindowById(L)),P.Event.filter(P.Event.map(this.b.onDidUnmaximizeWindow,L=>L.id),L=>!!this.b.getWindowById(L))),this.onDidChangeWindowFullScreen=P.Event.any(P.Event.map(this.a.onDidChangeFullScreen,L=>({windowId:L.window.id,fullscreen:L.fullscreen})),P.Event.map(this.b.onDidChangeFullScreen,L=>({windowId:L.window.id,fullscreen:L.fullscreen}))),this.onDidBlurMainWindow=P.Event.filter(P.Event.fromNodeEventEmitter(D.app,"browser-window-blur",(L,N)=>N.id),L=>!!this.a.getWindowById(L)),this.onDidFocusMainWindow=P.Event.any(P.Event.map(P.Event.filter(P.Event.map(this.a.onDidChangeWindowsCount,()=>this.a.getLastActiveWindow()),L=>!!L),L=>L.id),P.Event.filter(P.Event.fromNodeEventEmitter(D.app,"browser-window-focus",(L,N)=>N.id),L=>!!this.a.getWindowById(L))),this.onDidBlurMainOrAuxiliaryWindow=P.Event.any(this.onDidBlurMainWindow,P.Event.filter(P.Event.fromNodeEventEmitter(D.app,"browser-window-blur",(L,N)=>N.id),L=>!!this.b.getWindowById(L))),this.onDidFocusMainOrAuxiliaryWindow=P.Event.any(this.onDidFocusMainWindow,P.Event.filter(P.Event.fromNodeEventEmitter(D.app,"browser-window-focus",(L,N)=>N.id),L=>!!this.b.getWindowById(L))),this.onDidResumeOS=P.Event.fromNodeEventEmitter(D.powerMonitor,"resume"),this.onDidChangeColorScheme=this.m.onDidChangeColorScheme,this.r=this.B(new P.$6d),this.onDidChangePassword=this.r.event,this.onDidChangeDisplay=P.Event.debounce(P.Event.any(P.Event.filter(P.Event.fromNodeEventEmitter(D.screen,"display-metrics-changed",(L,N,G)=>G),L=>!(Array.isArray(L)&&L.length===1&&L[0]==="workArea")),P.Event.fromNodeEventEmitter(D.screen,"display-added"),P.Event.fromNodeEventEmitter(D.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(W,V){const K=this.a.getWindows().map(re=>({id:re.id,workspace:re.openedWorkspace??(0,s.$ui)(re.backupPath,re.isExtensionDevelopmentHost),title:re.win?.getTitle()??"",filename:re.getRepresentedFilename(),dirty:re.isDocumentEdited()})),le=[];return V.includeAuxiliaryWindows&&le.push(...this.b.getWindows().map(re=>({id:re.id,parentId:re.parentId,title:re.win?.getTitle()??"",filename:re.getRepresentedFilename()}))),[...K,...le]}async getWindowCount(W){return this.a.getWindowCount()}async getActiveWindowId(W){const V=this.a.getFocusedWindow()||this.a.getLastActiveWindow();if(V)return V.id}openWindow(W,V,K){return Array.isArray(V)?this.s(W,V,K):this.t(W,V)}async s(W,V,K=Object.create(null)){V.length>0&&await this.a.open({context:5,contextWindowId:W,urisToOpen:V,cli:this.g.args,forceNewWindow:K.forceNewWindow,forceReuseWindow:K.forceReuseWindow,preferNewWindow:K.preferNewWindow,diffMode:K.diffMode,mergeMode:K.mergeMode,addMode:K.addMode,gotoLineMode:K.gotoLineMode,noRecentEntry:K.noRecentEntry,waitMarkerFileURI:K.waitMarkerFileURI,remoteAuthority:K.remoteAuthority||void 0,forceProfile:K.forceProfile,forceTempProfile:K.forceTempProfile})}async t(W,V){await this.a.openEmptyWindow({context:5,contextWindowId:W},V)}async toggleFullScreen(W,V){this.C(V?.targetWindowId,W)?.toggleFullScreen()}async handleTitleDoubleClick(W,V){this.C(V?.targetWindowId,W)?.handleTitleDoubleClick()}async getCursorScreenPoint(W){const V=D.screen.getCursorScreenPoint(),K=D.screen.getDisplayNearestPoint(V);return{point:V,display:K.bounds}}async isMaximized(W,V){return this.C(V?.targetWindowId,W)?.win?.isMaximized()??!1}async maximizeWindow(W,V){this.C(V?.targetWindowId,W)?.win?.maximize()}async unmaximizeWindow(W,V){this.C(V?.targetWindowId,W)?.win?.unmaximize()}async minimizeWindow(W,V){this.C(V?.targetWindowId,W)?.win?.minimize()}async moveWindowTop(W,V){this.C(V?.targetWindowId,W)?.win?.moveTop()}async positionWindow(W,V,K){const le=this.C(K?.targetWindowId,W);if(le?.win){if(le.win.isFullScreen()){const re=P.Event.toPromise(P.Event.once(P.Event.fromNodeEventEmitter(le.win,"leave-full-screen")));le.win.setFullScreen(!1),await re}le.win.setBounds(V)}}async updateWindowControls(W,V){this.C(V?.targetWindowId,W)?.updateWindowControls(V)}async focusWindow(W,V){this.C(V?.targetWindowId,W)?.focus({force:V?.force??!1})}async setMinimumSize(W,V,K){const le=this.D(W);if(le?.win){const[re,ue]=le.win.getSize(),[Z,Y]=le.win.getMinimumSize(),[U,L]=[V??Z,K??Y],[N,G]=[Math.max(re,U),Math.max(ue,L)];(Z!==U||Y!==L)&&le.win.setMinimumSize(U,L),(re!==N||ue!==G)&&le.win.setSize(N,G)}}async saveWindowSplash(W,V){this.m.saveWindowSplash(W,V)}async installShellCommand(W){const{source:V,target:K}=await this.u();try{const{symbolicLink:le}=await w.SymlinkSupport.stat(V);if(le&&!le.dangling){const re=await(0,g.$Kq)(V);if(K===re)return}await w.Promises.unlink(V)}catch(le){if(le.code!=="ENOENT")throw le}try{await w.Promises.symlink(K,V)}catch(le){if(le.code!=="EACCES"&&le.code!=="ENOENT")throw le;const{response:re}=await this.showMessageBox(W,{type:"info",message:(0,u.localize)(0,null,this.j.nameShort),buttons:[(0,u.localize)(1,null),(0,u.localize)(2,null)]});if(re===1)throw new A.$5;try{const ue=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${K}' '${V}'\\" with administrator privileges"`;await(0,M.promisify)(n.exec)(ue)}catch{throw new Error((0,u.localize)(3,null,V))}}}async uninstallShellCommand(W){const{source:V}=await this.u();try{await w.Promises.unlink(V)}catch(K){switch(K.code){case"EACCES":{const{response:le}=await this.showMessageBox(W,{type:"info",message:(0,u.localize)(4,null,this.j.nameShort),buttons:[(0,u.localize)(5,null),(0,u.localize)(6,null)]});if(le===1)throw new A.$5;try{const re=`osascript -e "do shell script \\"rm '${V}'\\" with administrator privileges"`;await(0,M.promisify)(n.exec)(re)}catch{throw new Error((0,u.localize)(7,null,V))}break}case"ENOENT":break;default:throw K}}}async u(){const W=(0,y.$kc)(this.g.appRoot,"bin","code"),V=`/usr/local/bin/${this.j.applicationName}`;if(!await w.Promises.exists(W))throw new Error((0,u.localize)(8,null,W));return{source:V,target:W}}async showMessageBox(W,V){const K=this.C(V?.targetWindowId,W);return this.c.showMessageBox(V,K?.win??void 0)}async showSaveDialog(W,V){const K=this.C(V?.targetWindowId,W);return this.c.showSaveDialog(V,K?.win??void 0)}async showOpenDialog(W,V){const K=this.C(V?.targetWindowId,W);return this.c.showOpenDialog(V,K?.win??void 0)}async pickFileFolderAndOpen(W,V){const K=await this.c.pickFileFolder(V);K&&await this.w(await Promise.all(K.map(async le=>await w.SymlinkSupport.existsDirectory(le)?{folderUri:k.URI.file(le)}:{fileUri:k.URI.file(le)})),V,W)}async pickFolderAndOpen(W,V){const K=await this.c.pickFolder(V);K&&await this.w(K.map(le=>({folderUri:k.URI.file(le)})),V,W)}async pickFileAndOpen(W,V){const K=await this.c.pickFile(V);K&&await this.w(K.map(le=>({fileUri:k.URI.file(le)})),V,W)}async pickWorkspaceAndOpen(W,V){const K=await this.c.pickWorkspace(V);K&&await this.w(K.map(le=>({workspaceUri:k.URI.file(le)})),V,W)}async w(W,V,K){await this.a.open({context:3,contextWindowId:K,cli:this.g.args,urisToOpen:W,forceNewWindow:V.forceNewWindow})}async showItemInFolder(W,V){D.shell.showItemInFolder(V)}async setRepresentedFilename(W,V,K){this.C(K?.targetWindowId,W)?.setRepresentedFilename(V)}async setDocumentEdited(W,V,K){this.C(K?.targetWindowId,W)?.setDocumentEdited(V)}async openExternal(W,V){return this.g.unsetSnapExportedVariables(),D.shell.openExternal(V),this.g.restoreSnapExportedVariables(),!0}moveItemToTrash(W,V){return D.shell.trashItem(V)}async isAdmin(){let W;return v.$i?W=(await new Promise((V,K)=>{X(["native-is-elevated"],V,K)}))():W=process.getuid?.()===0,W}async writeElevated(W,V,K,le){const re=await new Promise((ue,Z)=>{X(["@vscode/sudo-prompt"],ue,Z)});return new Promise((ue,Z)=>{const Y=[`"${this.z}"`];le?.unlock&&Y.push("--file-chmod"),Y.push("--file-write",`"${V.fsPath}"`,`"${K.fsPath}"`);const U={name:this.j.nameLong.replace("-",""),icns:v.$j&&this.g.isBuilt?(0,y.$jc)((0,y.$mc)(this.g.appRoot),`${this.j.nameShort}.icns`):void 0};re.exec(Y.join(" "),U,(L,N,G)=>{N&&this.h.trace(`[sudo-prompt] received stdout: ${N}`),G&&this.h.trace(`[sudo-prompt] received stderr: ${G}`),L?Z(L):ue(void 0)})})}async isRunningUnderARM64Translation(){return v.$k||v.$i?!1:D.app.runningUnderARM64Translation}get z(){return v.$i?this.g.isBuilt?(0,y.$jc)((0,y.$mc)(process.execPath),"bin",`${this.j.applicationName}.cmd`):(0,y.$jc)(this.g.appRoot,"scripts","code-cli.bat"):v.$k?this.g.isBuilt?(0,y.$jc)((0,y.$mc)(process.execPath),"bin",`${this.j.applicationName}`):(0,y.$jc)(this.g.appRoot,"scripts","code-cli.sh"):this.g.isBuilt?(0,y.$jc)(this.g.appRoot,"bin","code"):(0,y.$jc)(this.g.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,S.totalmem)(),freemem:(0,S.freemem)(),loadavg:(0,S.loadavg)()}}async getOSProperties(){return{arch:(0,S.arch)(),platform:(0,S.platform)(),release:(0,S.release)(),type:(0,S.type)(),cpus:(0,S.cpus)()}}async getOSVirtualMachineHint(){return m.$nn.value()}async getOSColorScheme(){return this.m.getColorScheme()}async hasWSLFeatureInstalled(){return v.$i&&(0,R.$O_b)()}async killProcess(W,V,K){process.kill(V,K)}async readClipboardText(W,V){return D.clipboard.readText(V)}async writeClipboardText(W,V,K){return D.clipboard.writeText(V,K)}async readClipboardFindText(W){return D.clipboard.readFindText()}async writeClipboardFindText(W,V){return D.clipboard.writeFindText(V)}async writeClipboardBuffer(W,V,K,le){return D.clipboard.writeBuffer(V,Buffer.from(K.buffer),le)}async readClipboardBuffer(W,V){return b.$te.wrap(D.clipboard.readBuffer(V))}async hasClipboard(W,V,K){return D.clipboard.has(V,K)}async newWindowTab(){await this.a.open({context:5,cli:this.g.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.g.args.remote||void 0})}async showPreviousWindowTab(){D.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){D.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){D.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){D.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){D.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(W,V){this.D(W)?.updateTouchBar(V)}async notifyReady(W){this.D(W)?.setReady()}async relaunch(W,V){return this.f.relaunch(V)}async reload(W,V){const K=this.D(W);if(K){if((0,s.$vi)(K.openedWorkspace)){const le=K.openedWorkspace.configPath;if(le.scheme===c.Schemas.file&&(await this.n.resolveLocalWorkspace(le))?.transient)return this.openWindow(K.id,{forceReuseWindow:!0})}return this.f.reload(K,V?.disableExtensions!==void 0?{_:[],"disable-extensions":V.disableExtensions}:void 0)}}async closeWindow(W,V){return this.C(V?.targetWindowId,W)?.win?.close()}async quit(W){const V=this.a.getLastActiveWindow();V?.isExtensionDevelopmentHost&&this.a.getWindowCount()>1&&V.win?V.win.close():this.f.quit()}async exit(W,V){await this.f.kill(V)}async resolveProxy(W,V){return this.D(W)?.win?.webContents?.session?.resolveProxy(V)}async loadCertificates(W){return(await new Promise((K,le)=>{X(["@vscode/proxy-agent"],K,le)})).loadSystemCertificates({log:this.h})}findFreePort(W,V,K,le,re=1){return(0,p.$Eg)(V,K,le,re)}async openDevTools(W,V){this.C(V?.targetWindowId,W)?.win?.webContents.openDevTools(V?.mode?{mode:V.mode,activate:V.activate}:void 0)}async toggleDevTools(W,V){this.C(V?.targetWindowId,W)?.win?.webContents.toggleDevTools()}async profileRenderer(W,V,K){const le=this.D(W);if(!le||!le.win)throw new Error;return await new I.$P_b(le.win,V,this.h).inspect(K)}async windowsGetStringRegKey(W,V,K,le){if(!v.$i)return;const re=await new Promise((ue,Z)=>{X(["@vscode/windows-registry"],ue,Z)});try{return re.GetStringRegKey(V,K,le)}catch{return}}C(W,V){return this.D(W)??this.F(W)??this.D(V)}D(W){if(typeof W=="number")return this.a.getWindowById(W)}F(W){if(typeof W=="number")return this.b.getWindowById(W)}};e.$S_b=j,ve([C.$Kh],j.prototype,"z",null),e.$S_b=j=ve([se(0,i.$6$b),se(1,E.$Q_b),se(2,f.$1$b),se(3,a.$m_b),se(4,h.$U$b),se(5,t.$Aj),se(6,o.$Sj),se(7,r.$4$b),se(8,l.$f_b)],j)}),define(ae[301],ce([0,1,14,26,8,23,33,2,13,4,7,111,37,182,92,134,56,24,5,70,79,27,80,34,60,55,29]),function(X,e,n,D,S,M,C,P,d,c,y,v,k,g,m,w,p,u,f,h,$,a,t,o,r,i,s){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$T_b=void 0;const b="issue.processExplorerWindowState";let R=class{static{l=this}static{this.a="#1E1E1E"}constructor(A,j,T,W,V,K,le,re,ue,Z,Y){this.g=A,this.h=j,this.i=T,this.j=W,this.k=V,this.l=K,this.m=le,this.n=re,this.o=ue,this.p=Z,this.q=Y,this.b=null,this.c=null,this.d=null,this.f=null,this.r()}r(){k.$RV.on("vscode:listProcesses",async A=>{const j=[];try{j.push({name:(0,g.localize)(0,null),rootProcess:await(0,v.$hs)(process.pid)}),(await this.k.getRemoteDiagnostics({includeProcesses:!0})).forEach(W=>{(0,m.$Zm)(W)?j.push({name:W.hostName,rootProcess:W}):W.processes&&j.push({name:W.hostName,rootProcess:W.processes})})}catch(T){this.i.error(`Listing processes failed: ${T}`)}this.t(A,"vscode:listProcessesResponse",j)}),k.$RV.on("vscode:workbenchCommand",(A,j)=>{const{id:T,from:W,args:V}=j;let K;switch(W){case"processExplorer":K=this.f;break;default:throw new Error(`Unexpected command source: ${W}`)}K?.webContents.send("vscode:runAction",{id:T,from:W,args:V})}),k.$RV.on("vscode:closeProcessExplorer",A=>{this.d?.close()}),k.$RV.on("vscode:pidToNameRequest",async A=>{const j=await this.k.getMainDiagnostics(),T=[];for(const W of j.windows)T.push([W.pid,`window [${W.id}] (${W.title})`]);for(const{pid:W,name:V}of r.$z_b.getAll())T.push([W,V]);this.t(A,"vscode:pidToNameResponse",T)})}async openReporter(A){if(this.b)this.b&&this.s(this.b);else if(this.c=n.BrowserWindow.getFocusedWindow(),this.c){const j=new P.$Sc,T=j.add(this.n.createIPCObjectUrl()),W=this.v(this.c,700,800);this.b=this.u(W,T,{backgroundColor:A.styles.backgroundColor,title:(0,g.localize)(1,null),zoomLevel:A.zoomLevel,alwaysOnTop:!1},"issue-reporter"),T.update({appRoot:this.h.appRoot,windowId:this.b.id,userEnv:this.g,data:A,disableExtensions:!!this.h.disableExtensions,os:{type:(0,D.type)(),arch:(0,D.arch)(),release:(0,D.release)()},product:$.default}),this.b.loadURL(d.$Ag.asBrowserUri(`vs/code/electron-sandbox/issue/issueReporter${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.b.on("close",()=>{this.b=null,j.dispose()}),this.c.on("closed",()=>{this.b&&(this.b.close(),this.b=null,j.dispose())})}}async openProcessExplorer(A){if(!this.d&&(this.f=n.BrowserWindow.getFocusedWindow(),this.f)){const j=new P.$Sc,T=j.add(this.n.createIPCObjectUrl()),W=this.p.getItem(b,void 0),V=I(W)?W:this.v(this.f,800,500);this.d=this.u(V,T,{backgroundColor:A.styles.backgroundColor,title:(0,g.localize)(2,null),zoomLevel:A.zoomLevel,alwaysOnTop:!0},"process-explorer"),T.update({appRoot:this.h.appRoot,windowId:this.d.id,userEnv:this.g,data:A,product:$.default}),this.d.loadURL(d.$Ag.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.d.on("close",()=>{this.d=null,j.dispose()}),this.f.on("close",()=>{this.d&&(this.d.close(),this.d=null,j.dispose())});const K=()=>{if(!this.d)return;const le=this.d.getSize(),re=this.d.getPosition();if(!le||!re)return;const ue={width:le[0],height:le[1],x:re[0],y:re[1]};this.p.setItem(b,ue)};this.d.on("moved",K),this.d.on("resized",K)}this.d&&this.s(this.d)}async stopTracing(){if(!this.h.args.trace)return;const A=await n.contentTracing.stopRecording(`${(0,C.$og)(this.h.userHome.fsPath,this.o.applicationName)}.trace.txt`);await this.l.showMessageBox({type:"info",message:(0,g.localize)(3,null),detail:(0,g.localize)(4,null,A),buttons:[(0,g.localize)(5,null)]},n.BrowserWindow.getFocusedWindow()??void 0),this.m.showItemInFolder(void 0,A)}async getSystemStatus(){const[A,j]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.j.getDiagnostics(A,j)}async $getSystemInfo(){const[A,j]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return await this.j.getSystemInfo(A,j)}async $getPerformanceInfo(){try{const[A,j]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.j.getPerformanceInfo(A,j)}catch(A){throw this.i.warn("issueService#getPerformanceInfo ",A.message),A}}async $reloadWithExtensionsDisabled(){if(this.c)try{await this.m.reload(this.c.id,{disableExtensions:!0})}catch(A){this.i.error(A)}}async $showConfirmCloseDialog(){if(this.b){const{response:A}=await this.l.showMessageBox({type:"warning",message:(0,g.localize)(6,null),buttons:[(0,g.localize)(7,null),(0,g.localize)(8,null)]},this.b);A===0&&this.b&&(this.b.destroy(),this.b=null)}}async $showClipboardDialog(){if(this.b){const{response:A}=await this.l.showMessageBox({type:"warning",message:(0,g.localize)(9,null),buttons:[(0,g.localize)(10,null),(0,g.localize)(11,null)]},this.b);return A===0}return!1}issueReporterWindowCheck(){if(!this.c)throw new Error("Issue reporter window not available");const A=this.q.getWindowById(this.c.id);if(!A)throw new Error("Window not found");return A}async $getIssueReporterUri(A){const j=this.issueReporterWindowCheck(),T=`vscode:triggerIssueUriRequestHandlerResponse${j.id}`;return S.Promises.withAsyncBody(async(W,V)=>{const K=new M.$de;j.sendWhenReady("vscode:triggerIssueUriRequestHandler",K.token,{replyChannel:T,extensionId:A}),k.$RV.once(T,(le,re)=>{W(y.URI.parse(re))});try{await(0,S.$hh)(5e3),K.cancel(),V(new Error("Timed out waiting for issue reporter URI"))}finally{k.$RV.removeHandler(T)}})}async $getIssueReporterData(A){const j=this.issueReporterWindowCheck(),T=`vscode:triggerIssueDataProviderResponse${j.id}`;return S.Promises.withAsyncBody(async W=>{const V=new M.$de;j.sendWhenReady("vscode:triggerIssueDataProvider",V.token,{replyChannel:T,extensionId:A}),k.$RV.once(T,(K,le)=>{W(le)});try{await(0,S.$hh)(5e3),V.cancel(),W("Error: Extension timed out waiting for issue reporter data")}finally{k.$RV.removeHandler(T)}})}async $getIssueReporterTemplate(A){const j=this.issueReporterWindowCheck(),T=`vscode:triggerIssueDataTemplateResponse${j.id}`;return S.Promises.withAsyncBody(async W=>{const V=new M.$de;j.sendWhenReady("vscode:triggerIssueDataTemplate",V.token,{replyChannel:T,extensionId:A}),k.$RV.once(T,(K,le)=>{W(le)});try{await(0,S.$hh)(5e3),V.cancel(),W("Error: Extension timed out waiting for issue reporter template")}finally{k.$RV.removeHandler(T)}})}async $getReporterStatus(A,j){const T=[!1,!1],W=this.issueReporterWindowCheck(),V="vscode:triggerReporterStatus",K=new M.$de;return W.sendWhenReady(V,K.token,{replyChannel:V,extensionId:A,extensionName:j}),await(0,S.$0g)(new Promise(re=>k.$RV.once("vscode:triggerReporterStatusResponse",(ue,Z)=>re(Z))),2e3,()=>{this.i.error("Error: Extension timed out waiting for reporter status"),K.cancel()})??T}async $sendReporterMenu(A,j){const T=this.issueReporterWindowCheck(),W="vscode:triggerReporterMenu",V=new M.$de;return T.sendWhenReady(W,V.token,{replyChannel:W,extensionId:A,extensionName:j}),await(0,S.$0g)(new Promise(le=>k.$RV.once(`vscode:triggerReporterMenuResponse:${A}`,(re,ue)=>le(ue))),5e3,()=>{this.i.error(`Error: Extension ${A} timed out waiting for menu response`),V.cancel()})}async $closeReporter(){this.b?.close()}async closeProcessExplorer(){this.d?.close()}s(A){A.isMinimized()&&A.restore(),A.focus()}t(A,j,...T){A.sender.isDestroyed()||A.sender.send(j,...T)}u(A,j,T,W){const V=new n.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:A.width,height:A.height,minWidth:300,minHeight:200,x:A.x,y:A.y,title:T.title,backgroundColor:T.backgroundColor||l.a,webPreferences:{preload:d.$Ag.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${j.resource.toString()}`],v8CacheOptions:this.h.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,i.$cD)(T.zoomLevel),sandbox:!0},alwaysOnTop:T.alwaysOnTop,experimentalDarkMode:!0});return V.setMenuBarVisibility(!1),V}v(A,j,T){let W;const V=n.screen.getAllDisplays();if(V.length===1)W=V[0];else{if(c.$j){const re=n.screen.getCursorScreenPoint();W=n.screen.getDisplayNearestPoint(re)}!W&&A&&(W=n.screen.getDisplayMatching(A.getBounds())),W||(W=n.screen.getPrimaryDisplay()||V[0])}const K=W.bounds,le={width:j,height:T,x:K.x+K.width/2-j/2,y:K.y+K.height/2-T/2};return K.width>0&&K.height>0&&(le.x<K.x&&(le.x=K.x),le.y<K.y&&(le.y=K.y),le.x>K.x+K.width&&(le.x=K.x),le.y>K.y+K.height&&(le.y=K.y),le.width>K.width&&(le.width=K.width),le.height>K.height&&(le.height=K.height)),le}};e.$T_b=R,e.$T_b=R=l=ve([se(1,u.$U$b),se(2,f.$Aj),se(3,m.$Ym),se(4,w.$C_b),se(5,p.$1$b),se(6,h.$R_b),se(7,t.$3$b),se(8,a.$Sj),se(9,o.$HP),se(10,s.$6$b)],R);function I(E){return typeof E!="object"||E===null?!1:"x"in E&&"y"in E&&"width"in E&&"height"in E}}),define(ae[302],ce([0,1,23,18,24,20,5,70,27,53,28,49,101]),function(X,e,n,D,S,M,C,P,d,c,y,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iac=void 0;let g=class extends k.$gac{constructor(w,p,u,f,h,$,a,t){super(w,p,f,h,$,t),this.e=u,this.u=a}s(w){return(0,k.$fac)(`linux-${process.arch}`,w,this.k)}t(w){this.a&&(this.d(v.$PW.CheckingForUpdates(w)),this.i.request({url:this.a},n.CancellationToken.None).then(c.$Cp).then(p=>{!p||!p.url||!p.version||!p.productVersion?(this.e.publicLog2("update:notAvailable",{explicit:!!w}),this.d(v.$PW.Idle(1))):this.d(v.$PW.AvailableForDownload(p))}).then(void 0,p=>{this.j.error(p);const u=w?p.message||p:void 0;this.d(v.$PW.Idle(1,u))}))}async o(w){this.k.downloadUrl&&this.k.downloadUrl.length>0?this.u.openExternal(void 0,this.k.downloadUrl):w.update.url&&this.u.openExternal(void 0,w.update.url),this.d(v.$PW.Idle(1))}};e.$iac=g,e.$iac=g=ve([se(0,M.$m_b),se(1,D.$Mi),se(2,y.$Fl),se(3,S.$U$b),se(4,c.$wp),se(5,C.$Aj),se(6,P.$R_b),se(7,d.$Sj)],g)}),define(ae[303],ce([0,1,48,46,26,8,23,50,45,9,7,146,21,18,24,16,20,5,70,27,53,28,49,101]),function(X,e,n,D,S,M,C,P,d,c,y,v,k,g,m,w,p,u,f,h,$,a,t,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kac=void 0;async function r(b,R=1e3){for(;!b();)await(0,M.$hh)(R)}let i;function s(){return typeof i>"u"&&(i=D.existsSync(c.$jc(c.$mc(process.execPath),"unins000.exe"))?0:1),i}let l=class extends o.$gac{get cachePath(){const R=c.$jc((0,S.tmpdir)(),`vscode-${this.k.quality}-${this.k.target}-${process.arch}`);return k.Promises.mkdir(R,{recursive:!0}).then(()=>R)}constructor(R,I,E,A,j,T,W,V,K){super(R,I,A,j,T,K),this.u=E,this.v=W,this.w=V,R.setRelaunchHandler(this)}handleRelaunch(R){return R?.addArgs||R?.removeArgs||this.state.type!=="ready"||!this.e?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){if(this.k.target==="user"&&await this.w.isAdmin(void 0)){this.d(t.$PW.Disabled(5)),this.j.info("update#ctor - updates are disabled due to running as Admin in user setup");return}await super.l()}s(R){let I=`win32-${process.arch}`;return s()===1?I+="-archive":this.k.target==="user"&&(I+="-user"),(0,o.$fac)(I,R,this.k)}t(R){this.a&&(this.d(t.$PW.CheckingForUpdates(R)),this.i.request({url:this.a},C.CancellationToken.None).then($.$Cp).then(I=>{const E=s();return!I||!I.url||!I.version||!I.productVersion?(this.u.publicLog2("update:notAvailable",{explicit:!!R}),this.d(t.$PW.Idle(E)),Promise.resolve(null)):E===1?(this.d(t.$PW.AvailableForDownload(I)),Promise.resolve(null)):(this.d(t.$PW.Downloading(I)),this.C(I.version).then(()=>this.B(I.version).then(A=>k.Promises.exists(A).then(j=>{if(j)return Promise.resolve(A);const T=`${A}.tmp`;return this.i.request({url:I.url},C.CancellationToken.None).then(W=>this.v.writeFile(y.URI.file(T),W.stream)).then(I.sha256hash?()=>(0,v.$MV)(T,I.sha256hash):()=>{}).then(()=>k.Promises.rename(T,A,!1)).then(()=>A)})).then(A=>{const j=this.g.getValue("update.enableWindowsBackgroundUpdates");this.e={packagePath:A},j?this.k.target==="user"?this.p():this.d(t.$PW.Downloaded(I)):this.d(t.$PW.Ready(I))})))}).then(void 0,I=>{this.u.publicLog2("update:error",{messageHash:String((0,d.$7i)(String(I)))}),this.j.error(I);const E=R?I.message||I:void 0;this.d(t.$PW.Idle(s(),E))}))}async o(R){R.update.url&&this.w.openExternal(void 0,R.update.url),this.d(t.$PW.Idle(s()))}async B(R){const I=await this.cachePath;return c.$jc(I,`CodeSetup-${this.k.quality}-${R}.exe`)}async C(R=null){const I=R?T=>!new RegExp(`${this.k.quality}-${R}\\.exe$`).test(T):()=>!0,E=await this.cachePath,j=(await k.Promises.readdir(E)).filter(I).map(async T=>{try{await k.Promises.unlink(c.$jc(E,T))}catch{}});await Promise.all(j)}async p(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.e)return Promise.resolve(void 0);const R=this.state.update;this.d(t.$PW.Updating(R));const I=await this.cachePath;this.e.updateFilePath=c.$jc(I,`CodeSetup-${this.k.quality}-${R.version}.flag`),await k.Promises.writeFile(this.e.updateFilePath,"flag"),(0,n.spawn)(this.e.packagePath,["/verysilent","/log",`/update="${this.e.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.e=void 0,this.d(t.$PW.Idle(s()))});const A=`${this.k.win32MutexName}-ready`,j=await new Promise((T,W)=>{X(["@vscode/windows-mutex"],T,W)});r(()=>j.isActive(A)).then(()=>this.d(t.$PW.Ready(R)))}r(){this.state.type!=="ready"||!this.e||(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.e.updateFilePath?D.unlinkSync(this.e.updateFilePath):(0,n.spawn)(this.e.packagePath,["/silent","/log","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}q(){return s()}async _applySpecificUpdate(R){if(this.state.type!=="idle")return;const I=this.g.getValue("update.enableWindowsBackgroundUpdates"),E={version:"unknown",productVersion:"unknown"};this.d(t.$PW.Downloading(E)),this.e={packagePath:R},I?this.k.target==="user"?this.p():this.d(t.$PW.Downloaded(E)):this.d(t.$PW.Ready(E))}};e.$kac=l,ve([P.$Kh],l.prototype,"cachePath",null),e.$kac=l=ve([se(0,p.$m_b),se(1,g.$Mi),se(2,a.$Fl),se(3,m.$U$b),se(4,$.$wp),se(5,u.$Aj),se(6,w.$Gk),se(7,f.$R_b),se(8,h.$Sj)],l)}),define(ae[135],ce([0,1,14,8,23,51,3,2,13,66,4,7,192,26,64,18,56,24,63,16,20,5,27,80,254,83,28,106,69,55,29,30,58,81,39,34,57,67,22,6]),function(X,e,n,D,S,M,C,P,d,c,y,v,k,g,m,w,p,u,f,h,$,a,t,o,r,i,s,l,b,R,I,E,A,j,T,W,V,K,le,re){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$k_b=e.$j_b=void 0;var ue;(function(U){U[U.NONE=0]="NONE",U[U.NAVIGATING=1]="NAVIGATING",U[U.READY=2]="READY"})(ue||(ue={}));class Z extends P.$Tc{get lastFocusTime(){return this.j}get win(){return this.m}n(L){this.m=L,this.B(C.Event.fromNodeEventEmitter(L,"maximize")(()=>this.b.fire())),this.B(C.Event.fromNodeEventEmitter(L,"unmaximize")(()=>this.c.fire())),this.B(C.Event.fromNodeEventEmitter(L,"closed")(()=>{this.a.fire(),this.dispose()})),this.B(C.Event.fromNodeEventEmitter(L,"focus")(()=>{this.j=Date.now()})),this.B(C.Event.fromNodeEventEmitter(this.m,"enter-full-screen")(()=>this.g.fire())),this.B(C.Event.fromNodeEventEmitter(this.m,"leave-full-screen")(()=>this.h.fire()));const N=!(0,R.$$C)(this.r);if(y.$j&&N&&L.setSheetOffset((0,y.$J)((0,g.release)())?28:22),N&&(y.$i&&(0,R.$aD)(this.r)||y.$j)){const G=this.s.getItem(Z.C);G&&this.updateWindowControls({height:G})}y.$i&&N&&L.hookWindowMessage(278,()=>{const[q,oe]=L.getPosition(),he=n.screen.getCursorScreenPoint(),J=he.x-q,O=he.y-oe;return!(J>30&&O>=0&&O<=Math.max(L.getBounds().height*.15,35))||(L.setEnabled(!1),L.setEnabled(!0),this.f.fire({x:J,y:O})),0}),this.t.args["open-devtools"]===!0&&L.webContents.openDevTools(),y.$j&&(this.B(this.onDidEnterFullScreen(()=>{this.G?.complete(!0)})),this.B(this.onDidLeaveFullScreen(()=>{this.G?.complete(!0)})))}constructor(L,N,G,q){super(),this.r=L,this.s=N,this.t=G,this.u=q,this.a=this.B(new C.$6d),this.onDidClose=this.a.event,this.b=this.B(new C.$6d),this.onDidMaximize=this.b.event,this.c=this.B(new C.$6d),this.onDidUnmaximize=this.c.event,this.f=this.B(new C.$6d),this.onDidTriggerSystemContextMenu=this.f.event,this.g=this.B(new C.$6d),this.onDidEnterFullScreen=this.g.event,this.h=this.B(new C.$6d),this.onDidLeaveFullScreen=this.h.event,this.j=Date.now(),this.m=null,this.D=(0,R.$aD)(this.r),this.F=void 0,this.G=void 0}setRepresentedFilename(L){y.$j?this.win?.setRepresentedFilename(L):this.w=L}getRepresentedFilename(){return y.$j?this.win?.getRepresentedFilename():this.w}setDocumentEdited(L){y.$j&&this.win?.setDocumentEdited(L),this.z=L}isDocumentEdited(){return y.$j?!!this.win?.isDocumentEdited():!!this.z}focus(L){y.$j&&L?.force&&n.app.focus({steal:!0});const N=this.win;N&&(N.isMinimized()&&N.restore(),N.focus())}handleTitleDoubleClick(){const L=this.win;if(L)if(y.$j)switch(n.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":L.minimize();break;case"None":break;case"Maximize":default:L.isMaximized()?L.unmaximize():L.maximize()}else L.isMaximized()?L.unmaximize():L.maximize()}static{this.C="windowControlHeight"}updateWindowControls(L){const N=this.win;if(N){if(L.height&&this.s.setItem(Y.C,L.height),y.$i&&this.D)N.setTitleBarOverlay({color:L.backgroundColor?.trim()===""?void 0:L.backgroundColor,symbolColor:L.foregroundColor?.trim()===""?void 0:L.foregroundColor,height:L.height?L.height-1:void 0});else if(y.$j&&L.height!==void 0){const G=(L.height-15)/2;G?N.setWindowButtonPosition({x:G,y:G}):N.setWindowButtonPosition(null)}}}toggleFullScreen(){this.H(!this.isFullScreen,!1)}H(L,N){(0,R.$bD)(this.r)?this.I(L,N):this.L(L)}get isFullScreen(){if(y.$j&&typeof this.F=="boolean")return this.F;const L=this.win,N=L?.isFullScreen(),G=L?.isSimpleFullScreen();return!!(N||G)}I(L,N){const G=this.win;G?.isSimpleFullScreen()&&G?.setSimpleFullScreen(!1),this.J(L,N)}J(L,N){if(y.$j){this.F=L;const q=this.G=new D.$Dh;(async()=>{const oe=await Promise.race([q.p,(0,D.$hh)(1e4).then(()=>!1)]);this.G===q&&(this.F=void 0,this.G=void 0,!oe&&L&&N&&this.win&&!this.win.isFullScreen()&&(this.u.warn("window: native macOS fullscreen transition did not happen within 10s from restoring"),this.h.fire()))})()}this.win?.setFullScreen(L)}L(L){const N=this.win;N?.isFullScreen()&&this.J(!1,!1),N?.setSimpleFullScreen(L),N?.webContents.focus()}dispose(){super.dispose(),this.m=null}}e.$j_b=Z;let Y=class extends Z{get id(){return this.P}get backupPath(){return this.R?.backupPath}get openedWorkspace(){return this.R?.workspace}get profile(){if(!this.config)return;const L=this.gb.profiles.find(N=>N.id===this.config?.profiles.profile.id);return this.isExtensionDevelopmentHost&&L?L:this.gb.getProfileForWorkspace(this.config.workspace??(0,E.$ui)(this.backupPath,this.isExtensionDevelopmentHost))??this.gb.defaultProfile}get remoteAuthority(){return this.R?.remoteAuthority}get config(){return this.R}get isExtensionDevelopmentHost(){return!!this.R?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.R?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.R?.debugId}constructor(L,N,G,q,oe,he,J,O,F,x,z,Q,H,_,B,te,ie,de,me,ke,Se){super(x,ke,q,N),this.eb=G,this.fb=oe,this.gb=he,this.hb=J,this.ib=O,this.jb=F,this.kb=z,this.lb=Q,this.mb=H,this.nb=_,this.ob=B,this.pb=te,this.qb=ie,this.rb=de,this.sb=me,this.M=this.B(new C.$6d),this.onWillLoad=this.M.event,this.N=this.B(new C.$6d),this.onDidSignalReady=this.N.event,this.O=this.B(new C.$6d),this.onDidDestroy=this.O.event,this.W=[],this.X=[],this.Y=void 0,this.Z=void 0,this.$=void 0,this.ab=this.B(this.rb.createIPCObjectUrl()),this.db=!1,this.tb=0;{const[Me,He]=this.Db(L.state);this.S=Me,this.u.trace("window#ctor: using window state",Me);const ye=this.S.mode===0||this.S.mode===3,ee=Se.invokeFunction(I.$7$b,this.S,{show:!ye,webPreferences:{preload:d.$Ag.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${this.ab.resource.toString()}`],v8CacheOptions:this.t.useCodeCache?"bypassHeatCheck":"none"}});(0,c.mark)("code/willCreateCodeBrowserWindow"),this.m=new n.BrowserWindow(ee),(0,c.mark)("code/didCreateCodeBrowserWindow"),this.P=this.m.id,this.n(this.m);const fe=this.r.getValue("window"),$e=y.$j&&fe?.nativeTabs===!0;(y.$j||y.$i)&&He&&(!$e||n.BrowserWindow.getAllWindows().length===1)&&[this.S.width,this.S.height,this.S.x,this.S.y].every(Pe=>typeof Pe=="number")&&this.m.setBounds({width:this.S.width,height:this.S.height,x:this.S.x,y:this.S.y}),ye&&((0,c.mark)("code/willMaximizeCodeWindow"),this.m.maximize(),this.S.mode===3&&this.H(!0,!0),this.m.show(),(0,c.mark)("code/didMaximizeCodeWindow")),this.j=Date.now()}this.Ab(),this.Jb(),this.ub()}setReady(){for(this.u.trace(`window#load: window reported ready (id: ${this.P})`),this.tb=2;this.W.length;)this.W.pop()(this);this.N.fire()}ready(){return new Promise(L=>{if(this.isReady)return L(this);this.W.push(L)})}get isReady(){return this.tb===2}get whenClosedOrLoaded(){return new Promise(L=>{function N(){G.dispose(),q.dispose(),L()}const G=this.onDidClose(()=>N()),q=this.onWillLoad(()=>N())})}ub(){this.m.on("unresponsive",()=>this.xb(1)),this.m.webContents.on("render-process-gone",(N,G)=>this.xb(2,{...G})),this.m.webContents.on("did-fail-load",(N,G,q)=>this.xb(3,{reason:q,exitCode:G})),this.m.webContents.on("will-prevent-unload",N=>{N.preventDefault()}),this.m.webContents.on("did-finish-load",()=>{this.bb&&(this.R=this.bb,this.bb=void 0)}),this.B(this.onDidMaximize(()=>{this.R&&(this.R.maximized=!0)})),this.B(this.onDidUnmaximize(()=>{this.R&&(this.R.maximized=!1)})),this.B(this.onDidEnterFullScreen(()=>{this.sendWhenReady("vscode:enterFullScreen",S.CancellationToken.None)})),this.B(this.onDidLeaveFullScreen(()=>{this.sendWhenReady("vscode:leaveFullScreen",S.CancellationToken.None)})),this.B(this.r.onDidChangeConfiguration(N=>this.Ab(N))),this.B(this.lb.onDidDeleteUntitledWorkspace(N=>this.zb(N)));const L=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this.m.webContents.session.webRequest.onBeforeSendHeaders({urls:L},async(N,G)=>{const q=await this.wb();G({cancel:!1,requestHeaders:Object.assign(N.requestHeaders,q)})})}wb(){return this.vb||(this.vb=(0,r.$Qp)(this.qb.version,this.qb,this.t,this.r,this.hb,this.ib,this.nb)),this.vb}async xb(L,N){switch(L){case 2:this.u.error(`CodeWindow: renderer process gone (reason: ${N?.reason||"<unknown>"}, code: ${N?.exitCode||"<unknown>"})`);break;case 1:this.u.error("CodeWindow: detected unresponsive");break;case 3:this.u.error(`CodeWindow: failed to load (reason: ${N?.reason||"<unknown>"}, code: ${N?.exitCode||"<unknown>"})`);break}switch(this.nb.publicLog2("windowerror",{type:L,reason:N?.reason,code:N?.exitCode}),L){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.pb.kill(1);return}if(this.t.args["enable-smoke-test-driver"]){await this.yb(!1,!1),this.pb.quit();return}if(L===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this.m&&this.m.webContents&&this.m.webContents.isDevToolsOpened())return;const{response:G,checkboxChecked:q}=await this.ob.showMessageBox({type:"warning",buttons:[(0,k.localize)(0,null),(0,k.localize)(1,null),(0,k.localize)(2,null)],message:(0,k.localize)(3,null),detail:(0,k.localize)(4,null),checkboxLabel:this.R?.workspace?(0,k.localize)(5,null):void 0},this.m);if(G!==2){const oe=G===0;await this.yb(oe,q)}}else if(L===2){let G;N?G=(0,k.localize)(7,null,N.reason,N.exitCode??"<unknown>"):G=(0,k.localize)(6,null);const{response:q,checkboxChecked:oe}=await this.ob.showMessageBox({type:"warning",buttons:[this.R?.workspace?(0,k.localize)(8,null):(0,k.localize)(9,null),(0,k.localize)(10,null)],message:G,detail:this.R?.workspace?(0,k.localize)(11,null):(0,k.localize)(12,null),checkboxLabel:this.R?.workspace?(0,k.localize)(13,null):void 0},this.m),he=q===0;await this.yb(he,oe)}break}}async yb(L,N){const G=this.R?.workspace;if(N&&G)try{const q=this.jb.workspaceStorage(G);await q.init(),q.delete("memento/workbench.parts.editor"),await q.close()}catch(q){this.u.error(q)}this.O.fire();try{if(L&&this.R){let q,oe;(0,E.$qi)(G)?q={folderUri:G.uri}:(0,E.$vi)(G)?q={workspaceUri:G.configPath}:oe=!0,(0,le.$Ob)(await this.sb.open({context:5,userEnv:this.R.userEnv,cli:{...this.t.args,_:[]},urisToOpen:q?[q]:void 0,forceEmpty:oe,forceNewWindow:!0,remoteAuthority:this.remoteAuthority}))?.focus()}}finally{this.m?.destroy()}}zb(L){this.R?.workspace?.id===L.id&&(this.R.workspace=void 0)}Ab(L){if(!L||L.affectsConfiguration("window.menuBarVisibility")){const N=this.Fb();N!==this.U&&(this.U=N,this.Gb(N))}if(!L||L.affectsConfiguration("http.proxy")){let N=(this.r.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;N?.endsWith("/")&&(N=N.substr(0,N.length-1));const G=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((N||"").indexOf("@")===-1&&(N!==this.Y||G!==this.Z)){this.Y=N,this.Z=G;const q=N||"",oe=G?`${G},<local>`:"<local>";this.u.trace(`Setting proxy to '${q}', bypassing '${oe}'`),this.m.webContents.session.setProxy({proxyRules:q,proxyBypassRules:oe,pacScript:""}),typeof n.app.setProxy=="function"&&n.app.setProxy({proxyRules:q,proxyBypassRules:oe,pacScript:""})}}}addTabbedWindow(L){y.$j&&L.win&&this.m.addTabbedWindow(L.win)}load(L,N=Object.create(null)){this.u.trace(`window#load: attempt to load window (id: ${this.P})`),this.isDocumentEdited()&&(!N.isReload||!this.mb.isHotExitEnabled())&&this.setDocumentEdited(!1),N.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this.m.setTitle(this.qb.nameLong)),this.Bb(L,N),this.tb===0?this.R=L:this.bb=L,this.tb=1,this.m.loadURL(d.$Ag.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.t.isBuilt?"":"-dev"}.html`).toString(!0));const G=this.db;this.db=!0,!this.t.isBuilt&&!this.t.extensionTestsLocationURI&&this.B(new D.$sh(()=>{this.m&&!this.m.isVisible()&&!this.m.isMinimized()&&(this.m.show(),this.focus({force:!0}),this.m.webContents.openDevTools())},1e4)).schedule(),this.M.fire({workspace:L.workspace,reason:N.isReload?3:G?2:1})}Bb(L,N){const G=(this.R??this.bb)?.userEnv;if(G){const q=(0,f.$em)(G)&&!(0,f.$em)(L.userEnv),oe=this.isExtensionDevelopmentHost;(q||oe)&&(L.userEnv={...G,...L.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(L.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),N.disableExtensions!==void 0&&(L["disable-extensions"]=N.disableExtensions),L.fullscreen=this.isFullScreen,L.maximized=this.m.isMaximized(),L.partsSplash=this.kb.getWindowSplash(),L.zoomLevel=this.Ib(),L.isCustomZoomLevel=typeof this.$=="number",L.isCustomZoomLevel&&L.partsSplash&&(L.partsSplash.zoomLevel=L.zoomLevel),(0,c.mark)("code/willOpenNewWindow"),L.perfMarks=(0,c.getMarks)(),this.ab.update(L)}async reload(L){const N=Object.assign({},this.R);N.workspace=await this.Cb(N),delete N.filesToOpenOrCreate,delete N.filesToDiff,delete N.filesToMerge,delete N.filesToWait,this.isExtensionDevelopmentHost&&L&&(N.verbose=L.verbose,N.debugId=L.debugId,N.extensionEnvironment=L.extensionEnvironment,N["inspect-extensions"]=L["inspect-extensions"],N["inspect-brk-extensions"]=L["inspect-brk-extensions"],N["extensions-dir"]=L["extensions-dir"]),N.accessibilitySupport=n.app.isAccessibilitySupportEnabled(),N.isInitialStartup=!1,N.policiesData=this.fb.serialize(),N.continueOn=this.t.continueOn,N.profiles={all:this.gb.profiles,profile:this.profile||this.gb.defaultProfile,home:this.gb.profilesHome},N.logLevel=this.eb.getLogLevel(),N.loggers={window:this.eb.getRegisteredLoggers(this.id),global:this.eb.getRegisteredLoggers()},this.load(N,{isReload:!0,disableExtensions:L?.["disable-extensions"]})}async Cb(L){if((0,E.$vi)(L.workspace)){const N=L.workspace.configPath;if(N.scheme===d.Schemas.file&&!await this.hb.exists(N))return}else if((0,E.$qi)(L.workspace)){const N=L.workspace.uri;if(N.scheme===d.Schemas.file&&!await this.hb.exists(N))return}return L.workspace}serializeWindowState(){if(!this.m)return(0,j.$S$b)();if(this.isFullScreen){let G;try{G=n.screen.getDisplayMatching(this.getBounds())}catch{}const q=(0,j.$S$b)();return{mode:3,display:G?G.id:void 0,width:this.S.width||q.width,height:this.S.height||q.height,x:this.S.x||0,y:this.S.y||0,zoomLevel:this.$}}const L=Object.create(null);let N;if(!y.$j&&this.m.isMaximized()?N=0:N=1,N===0?L.mode=0:L.mode=1,N===1||N===0){let G;N===1?G=this.getBounds():G=this.m.getNormalBounds(),L.x=G.x,L.y=G.y,L.width=G.width,L.height=G.height}return L.zoomLevel=this.$,L}Db(L){(0,c.mark)("code/willRestoreCodeWindowState");let N=!1;if(L){this.$=L.zoomLevel;try{const G=n.screen.getAllDisplays();N=G.length>1,L=I.WindowStateValidator.validateWindowState(this.u,L,G)}catch(G){this.u.warn(`Unexpected error validating window state: ${G}
${G.stack}`)}}return(0,c.mark)("code/didRestoreCodeWindowState"),[L||(0,j.$S$b)(),N]}getBounds(){const[L,N]=this.m.getPosition(),[G,q]=this.m.getSize();return{x:L,y:N,width:G,height:q}}H(L,N){super.H(L,N),this.sendWhenReady(L?"vscode:enterFullScreen":"vscode:leaveFullScreen",S.CancellationToken.None),this.U&&this.Gb(this.U,!1)}Fb(){let L=(0,R.$9C)(this.r);return["visible","toggle","hidden"].indexOf(L)<0&&(L="classic"),L}Gb(L,N=!0){y.$j||(L==="toggle"&&N&&this.send("vscode:showInfoMessage",(0,k.localize)(14,null)),L==="hidden"?setTimeout(()=>{this.Hb(L)}):this.Hb(L))}Hb(L){const N=this.isFullScreen;switch(L){case"classic":this.m.setMenuBarVisibility(!N),this.m.autoHideMenuBar=N;break;case"visible":this.m.setMenuBarVisibility(!0),this.m.autoHideMenuBar=!1;break;case"toggle":this.m.setMenuBarVisibility(!1),this.m.autoHideMenuBar=!0;break;case"hidden":this.m.setMenuBarVisibility(!1),this.m.autoHideMenuBar=!1;break}}notifyZoomLevel(L){this.$=L}Ib(){return typeof this.$=="number"?this.$:this.r.getValue("window")?.zoomLevel}close(){this.m?.close()}sendWhenReady(L,N,...G){this.isReady?this.send(L,...G):this.ready().then(()=>{N.isCancellationRequested||this.send(L,...G)})}send(L,...N){if(this.m){if(this.m.isDestroyed()||this.m.webContents.isDestroyed()){this.u.warn(`Sending IPC message to channel '${L}' for window that is destroyed`);return}try{this.m.webContents.send(L,...N)}catch(G){this.u.warn(`Error sending IPC message to channel '${L}' of window ${this.P}: ${(0,M.$4i)(G)}`)}}}updateTouchBar(L){y.$j&&this.X.forEach((N,G)=>{const q=L[G];N.segments=this.Lb(q)})}Jb(){if(y.$j){for(let L=0;L<10;L++){const N=this.Kb();this.X.push(N)}this.m.setTouchBar(new n.TouchBar({items:this.X}))}}Kb(L=[]){const N=this.Lb(L),G=new n.TouchBar.TouchBarSegmentedControl({segments:N,mode:"buttons",segmentStyle:"automatic",change:q=>{this.sendWhenReady("vscode:runAction",S.CancellationToken.None,{id:G.segments[q].id,from:"touchbar"})}});return G}Lb(L=[]){return L.map(G=>{let q;G.icon&&!l.ThemeIcon.isThemeIcon(G.icon)&&G.icon?.dark?.scheme===d.Schemas.file&&(q=n.nativeImage.createFromPath(v.URI.revive(G.icon.dark).fsPath),q.isEmpty()&&(q=void 0));let oe;return typeof G.title=="string"?oe=G.title:oe=G.title.value,{id:G.id,label:q?void 0:oe,icon:q}})}dispose(){super.dispose(),this.eb.deregisterLoggers(this.id)}};e.$k_b=Y,e.$k_b=Y=ve([se(1,a.$Aj),se(2,K.$h_b),se(3,u.$U$b),se(4,T.$Zn),se(5,V.$9$b),se(6,h.$Gk),se(7,i.$u_b),se(8,i.$s_b),se(9,w.$Mi),se(10,b.$4$b),se(11,A.$f_b),se(12,m.$Z$b),se(13,s.$Fl),se(14,p.$1$b),se(15,$.$m_b),se(16,t.$Sj),se(17,o.$3$b),se(18,I.$6$b),se(19,W.$HP),se(20,re.$fi)],Y)}),define(ae[304],ce([0,1,14,4,18,24,20,5,34,55,135]),function(X,e,n,D,S,M,C,P,d,c,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$l_b=void 0;let v=class extends y.$j_b{get win(){return super.win||this.tryClaimWindow(),super.win}constructor(g,m,w,p,u,f){super(p,u,m,w),this.M=g,this.N=f,this.id=this.M.id,this.parentId=-1,this.tryClaimWindow()}tryClaimWindow(){if(this.m||this.q.isDisposed||this.M.isDestroyed())return;const g=n.BrowserWindow.fromWebContents(this.M);g&&(this.u.trace("[aux window] Claimed browser window instance"),this.n(g),g.setMenu(null),(D.$i||D.$k)&&(0,c.$$C)(this.r)&&g.setAutoHideMenuBar(!0),this.N.registerAuxWindow(this))}};e.$l_b=v,e.$l_b=v=ve([se(1,M.$U$b),se(2,P.$Aj),se(3,S.$Mi),se(4,d.$HP),se(5,C.$m_b)],v)}),define(ae[305],ce([0,1,14,3,2,13,37,304,6,5,81,29]),function(X,e,n,D,S,M,C,P,d,c,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pac=void 0;let k=class extends S.$Tc{constructor(m,w){super(),this.h=m,this.j=w,this.a=this.B(new D.$6d),this.onDidMaximizeWindow=this.a.event,this.b=this.B(new D.$6d),this.onDidUnmaximizeWindow=this.b.event,this.c=this.B(new D.$6d),this.onDidChangeFullScreen=this.c.event,this.f=this.B(new D.$6d),this.onDidTriggerSystemContextMenu=this.f.event,this.g=new Map,this.m()}m(){n.app.on("browser-window-created",(m,w)=>{const p=this.getWindowById(w.id);p&&(this.j.trace('[aux window] app.on("browser-window-created"): Trying to claim auxiliary window'),p.tryClaimWindow())}),C.$RV.handle("vscode:registerAuxiliaryWindow",async(m,w)=>{const p=this.getWindowById(m.sender.id);return p&&(this.j.trace("[aux window] vscode:registerAuxiliaryWindow: Registering auxiliary window to main window"),p.parentId=w),m.sender.id})}createWindow(m){return this.h.invokeFunction(v.$7$b,this.n(m),{webPreferences:{preload:M.$Ag.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload-aux.js").fsPath}})}n(m){const w={},p=m.features.split(",");for(const f of p){const[h,$]=f.split("=");switch(h){case"width":w.width=parseInt($,10);break;case"height":w.height=parseInt($,10);break;case"left":w.x=parseInt($,10);break;case"top":w.y=parseInt($,10);break}}const u=v.WindowStateValidator.validateWindowState(this.j,w)??(0,y.$T$b)();return this.j.trace("[aux window] using window state",u),u}registerWindow(m){const w=new S.$Sc,p=this.h.createInstance(P.$l_b,m);this.g.set(p.id,p),w.add((0,S.$Rc)(()=>this.g.delete(p.id))),w.add(p.onDidMaximize(()=>this.a.fire(p))),w.add(p.onDidUnmaximize(()=>this.b.fire(p))),w.add(p.onDidEnterFullScreen(()=>this.c.fire({window:p,fullscreen:!0}))),w.add(p.onDidLeaveFullScreen(()=>this.c.fire({window:p,fullscreen:!1}))),w.add(p.onDidTriggerSystemContextMenu(({x:u,y:f})=>this.f.fire({window:p,x:u,y:f}))),D.Event.once(p.onDidClose)(()=>w.dispose())}getWindowById(m){return this.g.get(m)}getFocusedWindow(){const m=n.BrowserWindow.getFocusedWindow();if(m)return this.getWindowById(m.id)}getLastActiveWindow(){return(0,v.$8$b)(Array.from(this.g.values()))}getWindows(){return Array.from(this.g.values())}};e.$Pac=k,e.$Pac=k=ve([se(0,d.$fi),se(1,c.$Aj)],k)}),define(ae[84],ce([0,1,14,22,8,3,47,2,13,4,19,7,21,195,6,20,5,83,98,30,58,31,56]),function(X,e,n,D,S,M,C,P,d,c,y,v,k,g,m,w,p,u,f,h,$,a,t){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$5_b=e.$4_b=void 0,e.$4_b=(0,m.$gi)("workspacesHistoryMainService");let r=class extends P.$Tc{static{o=this}static{this.a=500}static{this.b="history.recentlyOpenedPathsList"}constructor(s,l,b,R,I){super(),this.f=s,this.g=l,this.h=b,this.j=R,this.m=I,this.c=this.B(new M.$6d),this.onDidChangeRecentlyOpened=this.c.event,this.H=this.B(new S.$eh(800)),this.n()}n(){this.h.when(4).then(()=>this.I()),this.B(this.g.onDidEnterWorkspace(s=>this.addRecentlyOpened([{workspace:s.workspace,remoteAuthority:s.window.remoteAuthority}])))}async addRecentlyOpened(s){let l=[],b=[];for(const I of s)if((0,f.$meb)(I))!this.g.isUntitledWorkspace(I.workspace)&&!this.w(l,I.workspace)&&l.push(I);else if((0,f.$neb)(I))this.y(l,I.folderUri)||l.push(I);else{const E=this.z(b,I.fileUri),A=I.fileUri.scheme===d.Schemas.file&&o.G.indexOf((0,y.$Qg)(I.fileUri))>=0;!E&&!A&&(b.push(I),c.$i&&I.fileUri.scheme===d.Schemas.file&&n.app.addRecentDocument(I.fileUri.fsPath))}const R=await this.r({workspaces:l,files:b});l=R.workspaces,b=R.files,l.length>o.a&&(l.length=o.a),b.length>o.a&&(b.length=o.a),await this.t({workspaces:l,files:b}),this.c.fire(),c.$j&&this.H.trigger(()=>this.N())}async removeRecentlyOpened(s){const l=E=>{const A=this.u(E);for(const j of s)if(y.$Kg.isEqual(j,A))return!1;return!0},b=await this.getRecentlyOpened(),R=b.workspaces.filter(l),I=b.files.filter(l);(R.length!==b.workspaces.length||I.length!==b.files.length)&&(await this.t({files:I,workspaces:R}),this.c.fire(),c.$j&&this.H.trigger(()=>this.N()))}async clearRecentlyOpened(s){if(s?.confirm){const{response:l}=await this.m.showMessageBox({type:"warning",buttons:[(0,g.localize)(0,null),(0,g.localize)(1,null)],message:(0,g.localize)(2,null),detail:(0,g.localize)(3,null),cancelId:1});if(l!==0)return}await this.t({workspaces:[],files:[]}),n.app.clearRecentDocuments(),this.c.fire()}async getRecentlyOpened(){return this.r()}async r(s){const l=new a.$Ac(I=>y.$Kg.getComparisonKey(I));if(s?.workspaces)for(const I of s.workspaces)l.set(this.u(I),I);const b=new a.$Ac(I=>y.$Kg.getComparisonKey(I));if(s?.files)for(const I of s.files)b.set(this.u(I),I);const R=await this.s();for(const I of R.workspaces){const E=l.get(this.u(I));E?E.label=E.label??I.label:l.set(this.u(I),I)}for(const I of R.files){const E=b.get(this.u(I));E?E.label=E.label??I.label:b.set(this.u(I),I)}return{workspaces:[...l.values()],files:[...b.values()]}}async s(){await this.j.whenReady;let s;const l=this.j.get(o.b,-1);if(typeof l=="string")try{s=JSON.parse(l)}catch(b){this.f.error("Unexpected error parsing opened paths list",b)}return(0,f.$teb)(s,this.f)}async t(s){await this.j.whenReady,this.j.store(o.b,JSON.stringify((0,f.$ueb)(s)),-1,1)}u(s){return(0,f.$neb)(s)?s.folderUri:(0,f.$oeb)(s)?s.fileUri:s.workspace.configPath}w(s,l){return!!s.find(b=>(0,f.$meb)(b)&&b.workspace.id===l.id)}y(s,l){return!!s.find(b=>(0,f.$neb)(b)&&y.$Kg.isEqual(b.folderUri,l))}z(s,l){return!!s.find(b=>y.$Kg.isEqual(b.fileUri,l))}static{this.C=7}static{this.D=10}static{this.F=7}static{this.G=["COMMIT_EDITMSG","MERGE_MSG"]}async I(){c.$i&&(await this.J(),this.B(this.onDidChangeRecentlyOpened(()=>this.J())))}async J(){if(!c.$i)return;const s=[];if(s.push({type:"tasks",items:[{type:"task",title:(0,g.localize)(4,null),description:(0,g.localize)(5,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const l=[];for(const I of n.app.getJumpListSettings().removedItems){const E=I.args;if(E){const A=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(E);A&&l.push(v.URI.parse(A[2]))}}await this.removeRecentlyOpened(l);let b=!1;const R=(0,D.$Hb)((await this.getRecentlyOpened()).workspaces.slice(0,o.F).map(I=>{const E=(0,f.$meb)(I)?I.workspace:I.folderUri,{title:A,description:j}=this.L(E,I.label);let T;return v.URI.isUri(E)?T=`--folder-uri "${E.toString()}"`:(b=!0,T=`--file-uri "${E.configPath.toString()}"`),{type:"task",title:A.substr(0,255),description:j.substr(0,255),program:process.execPath,args:T,iconPath:"explorer.exe",iconIndex:0}}));R.length>0&&s.push({type:"custom",name:b?(0,g.localize)(6,null):(0,g.localize)(7,null),items:R})}s.push({type:"recent"});try{const l=n.app.setJumpList(s);l&&l!=="ok"&&this.f.warn(`updateWindowsJumpList#setJumpList unexpected result: ${l}`)}catch(l){this.f.warn("updateWindowsJumpList#setJumpList",l)}}L(s,l){if(l)return{title:(0,C.$iw)(l).name,description:l};if(v.URI.isUri(s))return{title:(0,y.$Qg)(s),description:this.M(s)};if(this.g.isUntitledWorkspace(s))return{title:(0,g.localize)(8,null),description:""};let b=(0,y.$Qg)(s.configPath);return b.endsWith(h.$Ci)&&(b=b.substr(0,b.length-h.$Ci.length-1)),{title:(0,g.localize)(9,null,b),description:this.M(s.configPath)}}M(s){return s.scheme==="file"?(0,C.$aw)(s.fsPath):s.toString()}async N(){if(!c.$j)return;n.app.clearRecentDocuments();const s=await this.getRecentlyOpened(),l=[];let b=0;for(let I=0;I<s.workspaces.length&&b<o.C;I++){const E=this.u(s.workspaces[I]);if(E.scheme===d.Schemas.file){const A=(0,y.$Hg)(E);await k.Promises.exists(A)&&(l.push(A),b++)}}const R=[];for(let I=0;I<s.files.length&&b<o.D;I++){const E=this.u(s.files[I]);if(E.scheme===d.Schemas.file){const A=(0,y.$Hg)(E);if(o.G.includes((0,y.$Qg)(E))||l.includes(A))continue;await k.Promises.exists(A)&&(R.push(A),b++)}}R.reverse().forEach(I=>n.app.addRecentDocument(I)),l.reverse().forEach(I=>n.app.addRecentDocument(I))}};e.$5_b=r,e.$5_b=r=o=ve([se(0,p.$Aj),se(1,$.$f_b),se(2,w.$m_b),se(3,u.$u_b),se(4,t.$1$b)],r)}),define(ae[306],ce([0,1,14,8,23,47,4,7,183,78,18,24,20,5,233,70,27,34,28,49,55,29,84]),function(X,e,n,D,S,M,C,P,d,c,y,v,k,g,m,w,p,u,f,h,$,a,t){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$6_b=void 0;const r="menu";let i=class{static{o=this}static{this.a="lastKnownMenubarData"}constructor(b,R,I,E,A,j,T,W,V,K,le,re){this.n=b,this.o=R,this.p=I,this.q=E,this.r=A,this.s=j,this.t=T,this.u=W,this.v=V,this.w=K,this.x=le,this.y=re,this.m=Object.create(null),this.g=new D.$sh(()=>this.F(),0),this.h=new D.$sh(()=>{this.j=[]},1e4),this.k=Object.create(null),this.l=Object.create(null),(C.$j||(0,$.$$C)(R))&&this.z(),this.A(),this.d=!1,this.f=!1,this.j=[],this.I(),this.B()}z(){const b=this.t.getItem(o.a);b&&(b.menus&&(this.k=b.menus),b.keybindings&&(this.l=b.keybindings))}A(){this.m["workbench.action.files.newUntitledFile"]=(j,T,W)=>{this.Y({type:"commandId",commandId:"workbench.action.files.newUntitledFile"})||this.p.openEmptyWindow({context:2,contextWindowId:T?.id})},this.m["workbench.action.newWindow"]=(j,T,W)=>this.p.openEmptyWindow({context:2,contextWindowId:T?.id}),this.m["workbench.action.files.openFileFolder"]=(j,T,W)=>this.w.pickFileFolderAndOpen(void 0,{forceNewWindow:this.R(W),telemetryExtraData:{from:r}}),this.m["workbench.action.files.openFolder"]=(j,T,W)=>this.w.pickFolderAndOpen(void 0,{forceNewWindow:this.R(W),telemetryExtraData:{from:r}}),this.m["workbench.action.openWorkspace"]=(j,T,W)=>this.w.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.R(W),telemetryExtraData:{from:r}}),this.m["workbench.action.clearRecentFiles"]=()=>this.s.clearRecentlyOpened({confirm:!0});const b=this.x.youTubeUrl;b&&(this.m["workbench.action.openYouTubeUrl"]=()=>this.ab(b,"openYouTubeUrl"));const R=this.x.requestFeatureUrl;R&&(this.m["workbench.action.openRequestFeatureUrl"]=()=>this.ab(R,"openUserVoiceUrl"));const I=this.x.reportIssueUrl;I&&(this.m["workbench.action.openIssueReporter"]=()=>this.ab(I,"openReportIssues"));const E=this.x.licenseUrl;E&&(this.m["workbench.action.openLicenseUrl"]=()=>{if(C.$w){const j=E.indexOf("?")>0?"&":"?";this.ab(`${E}${j}lang=${C.$w}`,"openLicenseUrl")}else this.ab(E,"openLicenseUrl")});const A=this.x.privacyStatementUrl;A&&E&&(this.m["workbench.action.openPrivacyStatementUrl"]=()=>{this.ab(A,"openPrivacyStatement")})}B(){this.u.onWillShutdown(()=>this.b=!0),this.p.onDidChangeWindowsCount(b=>this.G(b)),this.w.onDidBlurMainWindow(()=>this.H()),this.w.onDidFocusMainWindow(()=>this.H())}get C(){const b=this.o.getValue("window.enableMenuBarMnemonics");return typeof b!="boolean"?!0:b}get D(){if(!C.$j)return!1;const b=this.o.getValue("window.nativeTabs");return typeof b!="boolean"?!1:b}updateMenu(b,R){this.k=b.menus,this.l=b.keybindings,this.t.setItem(o.a,b),this.E()}E(){this.g.schedule()}F(){this.b||setTimeout(()=>{this.b||this.I()},10)}G(b){C.$j&&(b.oldCount===0&&b.newCount>0||b.oldCount>0&&b.newCount===0)&&(this.d=b.newCount===0,this.E())}H(){if(!C.$j)return;const b=n.BrowserWindow.getFocusedWindow();this.f=!b||!!this.y.getWindowById(b.id),this.E()}I(){const b=n.Menu.getApplicationMenu();if(b&&this.j.push(b),Object.keys(this.k).length===0){this.J(C.$j?new n.Menu:null);return}const R=new n.Menu;let I;if(C.$j){const A=new n.Menu;I=new n.MenuItem({label:this.x.nameShort,submenu:A}),this.K(A),R.append(I)}if(C.$j&&!this.c){this.c=!0;const A=new n.Menu;A.append(new n.MenuItem({label:this.cb(d.localize(0,null)),click:()=>this.p.openEmptyWindow({context:1})})),n.app.dock.setMenu(A)}if(this.M("File")){const A=new n.Menu,j=new n.MenuItem({label:this.cb(d.localize(1,null)),submenu:A});this.O(A,"File"),R.append(j)}if(this.M("Edit")){const A=new n.Menu,j=new n.MenuItem({label:this.cb(d.localize(2,null)),submenu:A});this.O(A,"Edit"),R.append(j)}if(this.M("Selection")){const A=new n.Menu,j=new n.MenuItem({label:this.cb(d.localize(3,null)),submenu:A});this.O(A,"Selection"),R.append(j)}if(this.M("View")){const A=new n.Menu,j=new n.MenuItem({label:this.cb(d.localize(4,null)),submenu:A});this.O(A,"View"),R.append(j)}if(this.M("Go")){const A=new n.Menu,j=new n.MenuItem({label:this.cb(d.localize(5,null)),submenu:A});this.O(A,"Go"),R.append(j)}if(this.M("Run")){const A=new n.Menu,j=new n.MenuItem({label:this.cb(d.localize(6,null)),submenu:A});this.O(A,"Run"),R.append(j)}if(this.M("Terminal")){const A=new n.Menu,j=new n.MenuItem({label:this.cb(d.localize(7,null)),submenu:A});this.O(A,"Terminal"),R.append(j)}let E;if(this.M("Window")){const A=new n.Menu;E=new n.MenuItem({label:this.cb(d.localize(8,null)),submenu:A,role:"window"}),this.U(A)}if(E&&R.append(E),this.M("Help")){const A=new n.Menu,j=new n.MenuItem({label:this.cb(d.localize(9,null)),submenu:A,role:"help"});this.O(A,"Help"),R.append(j)}R.items&&R.items.length>0?this.J(R):this.J(null),this.h.schedule()}J(b){if(n.Menu.setApplicationMenu(b),b)for(const R of this.y.getWindows())R.win?.setMenu(null)}K(b){const R=this.W(d.localize(10,null,this.x.nameLong),"workbench.action.showAboutDialog"),I=this.V();let E;if(this.M("Preferences")){const re=new n.Menu;this.O(re,"Preferences"),E=new n.MenuItem({label:this.cb(d.localize(11,null)),submenu:re})}const A=new n.Menu,j=new n.MenuItem({label:d.localize(12,null),role:"services",submenu:A}),T=new n.MenuItem({label:d.localize(13,null,this.x.nameLong),role:"hide",accelerator:"Command+H"}),W=new n.MenuItem({label:d.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),V=new n.MenuItem({label:d.localize(15,null),role:"unhide"}),K=new n.MenuItem(this.$("workbench.action.quit",{label:d.localize(16,null,this.x.nameLong),click:async(re,ue,Z)=>{const Y=this.p.getLastActiveWindow();(this.p.getWindowCount()===0||n.BrowserWindow.getFocusedWindow()||Y?.win?.isMinimized())&&await this.L(Z)&&this.w.quit(void 0)}})),le=[R];le.push(...I),E&&le.push(s(),E),le.push(s(),j,s(),T,W,V,s(),K),le.forEach(re=>b.append(re))}async L(b){if(this.p.getWindowCount()===0)return!0;const R=this.o.getValue("window.confirmBeforeClose");if(R==="always"||R==="keyboardOnly"&&this.S(b)){const{response:I}=await this.w.showMessageBox(this.p.getFocusedWindow()?.id,{type:"question",buttons:[d.localize(17,null),d.localize(18,null)],message:d.localize(19,null)});return I===0}return!0}M(b){if(!C.$j&&!(0,$.$$C)(this.o))return!1;switch(b){case"File":case"Help":if(C.$j)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k&&!!this.k[b];case"Window":if(C.$j)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k;default:return this.p.getWindowCount()>0&&!!this.k&&!!this.k[b]}}N(b,R){R.forEach(I=>{if((0,m.$1_b)(I))b.append(s());else if((0,m.$Z_b)(I)){const E=new n.Menu,A=new n.MenuItem({label:this.cb(I.label),submenu:E});this.N(E,I.submenu.items),b.append(A)}else(0,m.$2_b)(I)?b.append(this.Q(I)):(0,m.$3_b)(I)&&(I.id==="workbench.action.showAboutDialog"&&this.P(b),C.$j?this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f?this.m[I.id]?b.append(new n.MenuItem(this.$(I.id,{label:this.cb(I.label),click:this.m[I.id]}))):b.append(this.W(I.label,I.id,!1,I.checked)):b.append(this.W(I.label,I.id,I.enabled!==!1,!!I.checked)):b.append(this.W(I.label,I.id,I.enabled!==!1,!!I.checked)))})}O(b,R){this.k&&this.k[R]&&this.N(b,this.k[R].items)}P(b){const R=this.V();R.length&&(R.forEach(I=>b.append(I)),b.append(s()))}Q(b){const R=P.URI.revive(b.uri),I=b.id,E=I==="openRecentFile"?{fileUri:R}:I==="openRecentWorkspace"?{workspaceUri:R}:{folderUri:R};return new n.MenuItem(this.$(I,{label:b.label,click:async(A,j,T)=>{const W=this.R(T);(await this.p.open({context:2,cli:this.q.args,urisToOpen:[E],forceNewWindow:W,gotoLineMode:!1,remoteAuthority:b.remoteAuthority})).length>0||await this.s.removeRecentlyOpened([R])}},!1))}R(b){return!!(b&&(!C.$j&&(b.ctrlKey||b.shiftKey)||C.$j&&(b.metaKey||b.altKey)))}S(b){return!!(b.triggeredByAccelerator||b.altKey||b.ctrlKey||b.metaKey||b.shiftKey)}T(b,R,I){const E={label:this.cb(b),role:I,enabled:!0};return new n.MenuItem(this.Z(R,E))}U(b){const R=new n.MenuItem({label:d.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.p.getWindowCount()>0}),I=new n.MenuItem({label:d.localize(21,null),role:"zoom",enabled:this.p.getWindowCount()>0}),E=new n.MenuItem({label:d.localize(22,null),role:"front",enabled:this.p.getWindowCount()>0}),A=this.W(d.localize(23,null),"workbench.action.switchWindow"),j=[];this.D&&(j.push(s()),j.push(this.W(d.localize(24,null),"workbench.action.newWindowTab")),j.push(this.T(d.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),j.push(this.T(d.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),j.push(this.T(d.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),j.push(this.T(d.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[R,I,s(),A,...j,s(),E].forEach(T=>b.append(T))}V(){switch(this.n.state.type){case"idle":return[new n.MenuItem({label:this.cb(d.localize(29,null)),click:()=>setTimeout(()=>{this.bb("CheckForUpdate"),this.n.checkForUpdates(!0)},0)})];case"checking for updates":return[new n.MenuItem({label:d.localize(30,null),enabled:!1})];case"available for download":return[new n.MenuItem({label:this.cb(d.localize(31,null)),click:()=>{this.n.downloadUpdate()}})];case"downloading":return[new n.MenuItem({label:d.localize(32,null),enabled:!1})];case"downloaded":return[new n.MenuItem({label:this.cb(d.localize(33,null)),click:()=>{this.bb("InstallUpdate"),this.n.applyUpdate()}})];case"updating":return[new n.MenuItem({label:d.localize(34,null),enabled:!1})];case"ready":return[new n.MenuItem({label:this.cb(d.localize(35,null)),click:()=>{this.bb("RestartToUpdate"),this.n.quitAndInstall()}})];default:return[]}}W(b,R,I,E){const A=this.cb(b),j=typeof R=="function"?R:(le,re,ue)=>{const Z=le?le.userSettingsLabel:null;let Y=R;Array.isArray(R)&&(Y=this.R(ue)?R[1]:R[0]),Z&&ue.triggeredByAccelerator?this.Y({type:"keybinding",userSettingsLabel:Z}):this.Y({type:"commandId",commandId:Y})},T=typeof I=="boolean"?I:this.p.getWindowCount()>0,W=typeof E=="boolean"?E:!1,V={label:A,click:j,enabled:T};W&&(V.type="checkbox",V.checked=W);let K;return typeof R=="string"?K=R:Array.isArray(R)&&(K=R[0]),C.$j&&(K==="editor.action.clipboardCutAction"?V.role="cut":K==="editor.action.clipboardCopyAction"?V.role="copy":K==="editor.action.clipboardPasteAction"&&(V.role="paste"),K==="undo"?V.click=this.X(j,{inDevTools:le=>le.undo(),inNoWindow:()=>n.Menu.sendActionToFirstResponder("undo:")}):K==="redo"?V.click=this.X(j,{inDevTools:le=>le.redo(),inNoWindow:()=>n.Menu.sendActionToFirstResponder("redo:")}):K==="editor.action.selectAll"&&(V.click=this.X(j,{inDevTools:le=>le.selectAll(),inNoWindow:()=>n.Menu.sendActionToFirstResponder("selectAll:")}))),new n.MenuItem(this.Z(K,V))}X(b,R){return(I,E,A)=>{const j=n.BrowserWindow.getFocusedWindow();if(!j)return R.inNoWindow();if(j.webContents.isDevToolsFocused()&&j.webContents.devToolsWebContents)return R.inDevTools(j.webContents.devToolsWebContents);b(I,E||j,A)}}Y(b){let R=n.BrowserWindow.getFocusedWindow();if(R){const E=this.y.getWindowById(R.id);E&&(R=this.p.getWindowById(E.parentId)?.win??null)}if(!R){const E=this.p.getLastActiveWindow();E?.win?.isMinimized()&&(R=E.win)}const I=R?this.p.getWindowById(R.id):void 0;if(I){if(this.v.trace("menubar#runActionInRenderer",b),C.$j&&!this.q.isBuilt&&!I.isReady&&(b.type==="commandId"&&b.commandId==="workbench.action.toggleDevTools"||b.type!=="commandId"&&b.userSettingsLabel==="alt+cmd+i"))return!1;if(b.type==="commandId"){const E={id:b.commandId,from:"menu"};I.sendWhenReady("vscode:runAction",S.CancellationToken.None,E)}else{const E={userSettingsLabel:b.userSettingsLabel};I.sendWhenReady("vscode:runKeybinding",S.CancellationToken.None,E)}return!0}else return this.v.trace("menubar#runActionInRenderer: no active window found",b),!1}Z(b,R){const I=typeof b=="string"?this.l[b]:void 0;if(I?.label){if(I.isNative!==!1)R.accelerator=I.label,R.userSettingsLabel=I.userSettingsLabel;else if(typeof R.label=="string"){const E=R.label.indexOf("[");E>=0?R.label=`${R.label.substr(0,E)} [${I.label}]`:R.label=`${R.label} [${I.label}]`}}else R.accelerator=void 0;return R}$(b,R,I=!R.accelerator){I&&(R=this.Z(b,R));const E=R.click;return R.click=(A,j,T)=>{this.bb(b),E?.(A,j,T)},R}ab(b,R){this.w.openExternal(void 0,b),this.bb(R)}bb(b){this.r.publicLog2("workbenchActionExecuted",{id:b,from:r})}cb(b){return(0,M.$fw)(b,!this.C)}};e.$6_b=i,e.$6_b=i=o=ve([se(0,h.$QW),se(1,y.$Mi),se(2,a.$6$b),se(3,v.$U$b),se(4,f.$Fl),se(5,t.$4_b),se(6,u.$HP),se(7,k.$m_b),se(8,g.$Aj),se(9,w.$R_b),se(10,p.$Sj),se(11,c.$Q_b)],i);function s(){return new n.MenuItem({type:"separator"})}}),define(ae[307],ce([0,1,6,20,5,306]),function(X,e,n,D,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8_b=e.$7_b=void 0,e.$7_b=(0,n.$gi)("menubarMainService");let C=class{constructor(d,c,y){this.b=d,this.c=c,this.d=y,this.a=this.e()}async e(){return await this.c.when(3),this.b.createInstance(M.$6_b)}async updateMenubar(d,c){this.d.trace("menubarService#updateMenubar",d),(await this.a).updateMenu(c,d)}};e.$8_b=C,e.$8_b=C=ve([se(0,n.$fi),se(1,D.$m_b),se(2,S.$Aj)],C)}),define(ae[308],ce([0,1,14,21,102,26,22,23,3,33,47,2,13,9,66,4,36,19,12,7,193,64,18,56,24,16,6,20,5,79,80,68,34,55,135,29,133,300,30,99,84,58,69,39,57,67,78]),function(X,e,n,D,S,M,C,P,d,c,y,v,k,g,m,w,p,u,f,h,$,a,t,o,r,i,s,l,b,R,I,E,A,j,T,W,V,K,le,re,ue,Z,Y,U,L,N,G){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vac=void 0;function q(J){return(0,le.$vi)(J?.workspace)}function oe(J){return(0,le.$qi)(J?.workspace)}let he=class extends v.$Tc{constructor(O,F,x,z,Q,H,_,B,te,ie,de,me,ke,Se,Me,He,ye,ee,fe,$e){super(),this.s=O,this.t=F,this.u=x,this.w=z,this.z=Q,this.C=H,this.D=_,this.F=B,this.G=te,this.H=ie,this.I=de,this.J=me,this.L=ke,this.M=Se,this.N=Me,this.O=He,this.P=ye,this.Q=ee,this.R=fe,this.S=$e,this.a=this.B(new d.$6d),this.onDidOpenWindow=this.a.event,this.b=this.B(new d.$6d),this.onDidSignalReadyWindow=this.b.event,this.c=this.B(new d.$6d),this.onDidDestroyWindow=this.c.event,this.f=this.B(new d.$6d),this.onDidChangeWindowsCount=this.f.event,this.g=this.B(new d.$6d),this.onDidMaximizeWindow=this.g.event,this.h=this.B(new d.$6d),this.onDidUnmaximizeWindow=this.h.event,this.j=this.B(new d.$6d),this.onDidChangeFullScreen=this.j.event,this.m=this.B(new d.$6d),this.onDidTriggerSystemContextMenu=this.m.event,this.n=new Map,this.r=this.B(new K.$sac(this,this.C,this.H,this.w,this.J)),this.U()}U(){this.B(this.M.onDidEnterWorkspace(O=>this.b.fire(O.window))),this.B(this.onDidSignalReadyWindow(O=>{if(O.config?.extensionDevelopmentPath||O.config?.extensionTestsPath){const F=new v.$Sc;if(F.add(d.Event.any(O.onDidClose,O.onDidDestroy)(()=>F.dispose())),O.config.extensionDevelopmentPath)for(const x of O.config.extensionDevelopmentPath)F.add(this.Q.addValidFileRoot(x));O.config.extensionTestsPath&&F.add(this.Q.addValidFileRoot(O.config.extensionTestsPath))}}))}openEmptyWindow(O,F){const x=this.F.args,z=F?.remoteAuthority||void 0,Q=!0,H=F?.forceReuseWindow,_=!H;return this.open({...O,cli:x,forceEmpty:Q,forceNewWindow:_,forceReuseWindow:H,remoteAuthority:z})}openExistingWindow(O,F){O.focus(),this.W(F,[O])}async open(O){this.w.trace("windowsManager#open"),O.addMode&&(O.initialStartup||!this.getLastActiveWindow())&&(O.addMode=!1);const F=[],x=[],z=[],Q=[],H=[];let _,B=0;const te=await this.cb(O);this.w.trace("windowsManager#open pathsToOpen",te);for(const Se of te)oe(Se)?O.addMode?F.push(Se):x.push(Se):q(Se)?z.push(Se):Se.fileUri?(_||(_={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:Se.remoteAuthority}),_.filesToOpenOrCreate.push(Se)):Se.backupPath?H.push({backupFolder:(0,g.$nc)(Se.backupPath),remoteAuthority:Se.remoteAuthority}):B++;O.diffMode&&_&&_.filesToOpenOrCreate.length>=2&&(_.filesToDiff=_.filesToOpenOrCreate.slice(0,2),_.filesToOpenOrCreate=[]),O.mergeMode&&_&&_.filesToOpenOrCreate.length===4&&(_.filesToMerge=_.filesToOpenOrCreate.slice(0,4),_.filesToOpenOrCreate=[],_.filesToDiff=[]),_&&O.waitMarkerFileURI&&(_.filesToWait={paths:(0,C.$Hb)([..._.filesToDiff,_.filesToMerge[3],..._.filesToOpenOrCreate]),waitMarkerFileUri:O.waitMarkerFileURI}),O.initialStartup?(Q.push(...this.M.getUntitledWorkspaces()),z.push(...Q),H.push(...this.I.getEmptyWindowBackups())):H.length=0;const{windows:ie,filesOpenedInWindow:de}=await this.X(O,z,x,H,B,_,F);if(this.w.trace(`windowsManager#open used window count ${ie.length} (workspacesToOpen: ${z.length}, foldersToOpen: ${x.length}, emptyToRestore: ${H.length}, emptyToOpen: ${B})`),ie.length>1)if(de)de.focus();else{const Se=this.r.state.lastActiveWindow&&!O.forceEmpty&&!O.cli._.length&&!O.cli["file-uri"]&&!O.cli["folder-uri"]&&!(O.urisToOpen&&O.urisToOpen.length);let Me=!0,He=!0;if(Se){const ye=ie.filter(ee=>this.r.state.lastActiveWindow&&ee.backupPath===this.r.state.lastActiveWindow.backupPath);ye.length&&(ye[0].focus(),Me=!1,He=!1)}if(Me)for(let ye=ie.length-1;ye>=0;ye--){const ee=ie[ye];if(!(ee.openedWorkspace&&Q.some(fe=>ee.openedWorkspace&&fe.workspace.id===ee.openedWorkspace.id)||ee.backupPath&&H.some(fe=>ee.backupPath&&fe.backupFolder===(0,g.$nc)(ee.backupPath)))){ee.focus(),He=!1;break}}He&&ie[ie.length-1].focus()}const me=_&&_.filesToDiff.length>0,ke=_&&_.filesToMerge.length>0;if(!ie.some(Se=>Se.isExtensionDevelopmentHost)&&!me&&!ke&&!O.noRecentEntry){const Se=[];for(const Me of te)q(Me)&&!Me.transient?Se.push({label:Me.label,workspace:Me.workspace,remoteAuthority:Me.remoteAuthority}):oe(Me)?Se.push({label:Me.label,folderUri:Me.workspace.uri,remoteAuthority:Me.remoteAuthority}):Me.fileUri&&Se.push({label:Me.label,fileUri:Me.fileUri,remoteAuthority:Me.remoteAuthority});this.L.addRecentlyOpened(Se)}return this.W(O,ie),ie}W(O,F){const x=O.waitMarkerFileURI;O.context===0&&x&&F.length===1&&F[0]&&(async()=>{await F[0].whenClosedOrLoaded;try{await this.P.del(x)}catch{}})()}async X(O,F,x,z,Q,H,_){const B=[];let te;function ie(ye,ee){B.push(ye),ee&&(te=ye,H=void 0)}let{openFolderInNewWindow:de,openFilesInNewWindow:me}=this.ob(O);if(!O.initialStartup&&_.length>0){const ye=_[0].remoteAuthority,ee=this.ub(ye);ee&&ie(this.$(ee,_.map(fe=>fe.workspace.uri)))}const ke=x.length+F.length+z.length;if(H&&ke===0){const ye=H.filesToOpenOrCreate[0]||H.filesToDiff[0]||H.filesToMerge[3],ee=this.getWindows().filter($e=>H&&(0,u.$Yg)($e.remoteAuthority,H.remoteAuthority));let fe;ye?.fileUri&&!me&&((O.context===4||O.context===0||O.context===1)&&(fe=await(0,V.$$$b)(ee,ye.fileUri,async $e=>$e.configPath.scheme===k.Schemas.file?this.M.resolveLocalWorkspace($e.configPath):void 0)),fe||(fe=this.vb(ee))),fe?(0,le.$vi)(fe.openedWorkspace)?F.push({workspace:fe.openedWorkspace,remoteAuthority:fe.remoteAuthority}):(0,le.$qi)(fe.openedWorkspace)?x.push({workspace:fe.openedWorkspace,remoteAuthority:fe.remoteAuthority}):ie(this.Y(O,fe,H),!0):ie(await this.pb({userEnv:O.userEnv,cli:O.cli,initialStartup:O.initialStartup,filesToOpen:H,forceNewWindow:!0,remoteAuthority:H.remoteAuthority,forceNewTabbedWindow:O.forceNewTabbedWindow,forceProfile:O.forceProfile,forceTempProfile:O.forceTempProfile}),!0)}const Se=(0,C.$Mb)(F,ye=>ye.workspace.id);if(Se.length>0){const ye=(0,C.$Hb)(Se.map(ee=>(0,V.$_$b)(this.getWindows(),ee.workspace.configPath)));if(ye.length>0){const ee=ye[0],fe=(0,u.$Yg)(H?.remoteAuthority,ee.remoteAuthority)?H:void 0;ie(this.Y(O,ee,fe),!!fe),de=!0}for(const ee of Se){if(ye.some(Pe=>Pe.openedWorkspace&&Pe.openedWorkspace.id===ee.workspace.id))continue;const fe=ee.remoteAuthority,$e=(0,u.$Yg)(H?.remoteAuthority,fe)?H:void 0;ie(await this.bb(O,ee,de,$e),!!$e),de=!0}}const Me=(0,C.$Mb)(x,ye=>u.$Kg.getComparisonKey(ye.workspace.uri));if(Me.length>0){const ye=(0,C.$Hb)(Me.map(ee=>(0,V.$_$b)(this.getWindows(),ee.workspace.uri)));if(ye.length>0){const ee=ye[0],fe=(0,u.$Yg)(H?.remoteAuthority,ee.remoteAuthority)?H:void 0;ie(this.Y(O,ee,fe),!!fe),de=!0}for(const ee of Me){if(ye.some(Pe=>(0,le.$qi)(Pe.openedWorkspace)&&u.$Kg.isEqual(Pe.openedWorkspace.uri,ee.workspace.uri)))continue;const fe=ee.remoteAuthority,$e=(0,u.$Yg)(H?.remoteAuthority,fe)?H:void 0;ie(await this.bb(O,ee,de,$e),!!$e),de=!0}}const He=(0,C.$Mb)(z,ye=>ye.backupFolder);if(He.length>0)for(const ye of He){const ee=ye.remoteAuthority,fe=(0,u.$Yg)(H?.remoteAuthority,ee)?H:void 0;ie(await this.ab(O,!0,ee,fe,ye),!!fe),de=!0}if(B.length===0||H){H&&!Q&&Q++;const ye=H?H.remoteAuthority:O.remoteAuthority;for(let ee=0;ee<Q;ee++)ie(await this.ab(O,de,ye,H),!!H),de=!0}return{windows:(0,C.$Mb)(B),filesOpenedInWindow:te}}Y(O,F,x){this.w.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:x}),this.Z(F);const z={filesToOpenOrCreate:x?.filesToOpenOrCreate,filesToDiff:x?.filesToDiff,filesToMerge:x?.filesToMerge,filesToWait:x?.filesToWait,termProgram:O?.userEnv?.TERM_PROGRAM};return F.sendWhenReady("vscode:openFiles",P.CancellationToken.None,z),F}Z(O){let F=O;const x=n.BrowserWindow.getFocusedWindow();if(x&&x.id!==O.id){const z=this.S.getWindowById(x.id);z&&z.parentId===O.id&&(F=z)}F.focus()}$(O,F){this.w.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:F}),O.focus();const x={foldersToAdd:F};return O.sendWhenReady("vscode:addFolders",P.CancellationToken.None,x),O}ab(O,F,x,z,Q){this.w.trace("windowsManager#doOpenEmpty",{restore:!!Q,remoteAuthority:x,filesToOpen:z,forceNewWindow:F});let H;return!F&&typeof O.contextWindowId=="number"&&(H=this.getWindowById(O.contextWindowId)),this.pb({userEnv:O.userEnv,cli:O.cli,initialStartup:O.initialStartup,remoteAuthority:x,forceNewWindow:F,forceNewTabbedWindow:O.forceNewTabbedWindow,filesToOpen:z,windowToUse:H,emptyWindowBackupInfo:Q,forceProfile:O.forceProfile,forceTempProfile:O.forceTempProfile})}bb(O,F,x,z,Q){return this.w.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:F,filesToOpen:z}),!x&&!Q&&typeof O.contextWindowId=="number"&&(Q=this.getWindowById(O.contextWindowId)),this.pb({workspace:F.workspace,userEnv:O.userEnv,cli:O.cli,initialStartup:O.initialStartup,remoteAuthority:F.remoteAuthority,forceNewWindow:x,forceNewTabbedWindow:O.forceNewTabbedWindow,filesToOpen:z,windowToUse:Q,forceProfile:O.forceProfile,forceTempProfile:O.forceTempProfile})}async cb(O){let F,x=!1,z=!1;if(O.urisToOpen&&O.urisToOpen.length>0?(F=await this.db(O),x=!0):O.forceEmpty?F=[Object.create(null)]:O.cli._.length||O.cli["folder-uri"]||O.cli["file-uri"]?(F=await this.eb(O.cli),F.length===0&&F.push(Object.create(null)),x=!0):(F=await this.gb(),F.length===0&&F.push(Object.create(null)),z=!0),!O.addMode&&x){const Q=F.filter(H=>oe(H));if(Q.length>1){const H=Q[0].remoteAuthority;if(Q.every(_=>(0,u.$Yg)(_.remoteAuthority,H))){const _=await this.M.createUntitledWorkspace(Q.map(B=>({uri:B.workspace.uri})));F.push({workspace:_,remoteAuthority:H}),F=F.filter(B=>!oe(B))}}}if(O.initialStartup&&!z&&this.J.getValue("window")?.restoreWindows==="preserve"){const Q=await this.gb();F.unshift(...Q.filter(H=>q(H)||oe(H)||H.backupPath))}return F}async db(O){const F={gotoLineMode:O.gotoLineMode,remoteAuthority:O.remoteAuthority},x=await Promise.all((0,C.$Hb)(O.urisToOpen||[]).map(async z=>{const Q=await this.ib(z,F);if(Q)return Q.label=z.label,Q;const H=this.kb(z);this.O.showMessageBox({type:"info",buttons:[(0,$.localize)(0,null)],message:H.scheme===k.Schemas.file?(0,$.localize)(1,null):(0,$.localize)(2,null),detail:H.scheme===k.Schemas.file?(0,$.localize)(3,null,(0,y.$_v)(H,{os:w.OS,tildify:this.F})):(0,$.localize)(4,null,H.toString(!0))},n.BrowserWindow.getFocusedWindow()??void 0)}));return(0,C.$Hb)(x)}async eb(O){const F=[],x={ignoreFileNotFound:!0,gotoLineMode:O.goto,remoteAuthority:O.remote||void 0,forceOpenWorkspaceAsFile:O.diff&&O._.length===2||O.merge&&O._.length===4},z=O["folder-uri"];if(z){const _=await Promise.all(z.map(B=>{const te=this.fb(B);if(te)return this.ib({folderUri:te},x)}));F.push(...(0,C.$Hb)(_))}const Q=O["file-uri"];if(Q){const _=await Promise.all(Q.map(B=>{const te=this.fb(B);if(te)return this.ib((0,le.$Li)(B)?{workspaceUri:te}:{fileUri:te},x)}));F.push(...(0,C.$Hb)(_))}const H=await Promise.all(O._.map(_=>x.remoteAuthority?this.nb(_,x):this.lb(_,x)));return F.push(...(0,C.$Hb)(H)),F}fb(O){try{const F=h.URI.parse(O);if(!F.scheme){this.w.error(`Invalid URI input string, scheme missing: ${O}`);return}return F.path?F:F.with({path:"/"})}catch(F){this.w.error(`Invalid URI input string: ${O}, ${F.message}`)}}async gb(){const O=this.hb();switch(O){case"none":return[];case"one":case"all":case"preserve":case"folders":{const F=[];O!=="one"&&F.push(...this.r.state.openedWindows),this.r.state.lastActiveWindow&&F.push(this.r.state.lastActiveWindow);const x=await Promise.all(F.map(async z=>{if(z.workspace){const Q=await this.ib({workspaceUri:z.workspace.configPath},{remoteAuthority:z.remoteAuthority,rejectTransientWorkspaces:!0});if(q(Q))return Q}else if(z.folderUri){const Q=await this.ib({folderUri:z.folderUri},{remoteAuthority:z.remoteAuthority});if(oe(Q))return Q}else if(O!=="folders"&&z.backupPath)return{backupPath:z.backupPath,remoteAuthority:z.remoteAuthority}}));return(0,C.$Hb)(x)}}}hb(){let O;return this.H.wasRestarted?O="all":(O=this.J.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(O)||(O="all")),O}async ib(O,F=Object.create(null)){const x=this.kb(O);return x.scheme===k.Schemas.file?((0,j.$8C)(O)&&(F={...F,forceOpenWorkspaceAsFile:!0}),this.lb(x.fsPath,F)):this.jb(O,F)}jb(O,F){let x=this.kb(O);const z=(0,E.$qm)(x)||F.remoteAuthority;if(x=(0,u.$1g)((0,u.$Ug)(x)),(0,j.$8C)(O)){if(F.gotoLineMode){const{path:Q,line:H,column:_}=(0,c.$ng)(x.path);return{fileUri:x.with({path:Q}),options:{selection:H?{startLineNumber:H,startColumn:_||1}:void 0},remoteAuthority:z}}return{fileUri:x,remoteAuthority:z}}else if((0,j.$6C)(O))return{workspace:(0,re.$c_b)(x),remoteAuthority:z};return{workspace:(0,re.$d_b)(x),remoteAuthority:z}}kb(O){return(0,j.$6C)(O)?O.workspaceUri:(0,j.$7C)(O)?O.folderUri:O.fileUri}async lb(O,F,x){let z,Q;F.gotoLineMode&&({path:O,line:z,column:Q}=(0,c.$ng)(O)),O=(0,c.$ig)((0,g.$hc)(O),(0,p.cwd)());try{const H=await D.Promises.stat(O);if(H.isFile()){if(!F.forceOpenWorkspaceAsFile){const _=await this.M.resolveLocalWorkspace(h.URI.file(O));if(_)return _.transient&&F.rejectTransientWorkspaces?void 0:{workspace:{id:_.id,configPath:_.configPath},type:i.FileType.File,exists:!0,remoteAuthority:_.remoteAuthority,transient:_.transient}}return{fileUri:h.URI.file(O),type:i.FileType.File,exists:!0,options:{selection:z?{startLineNumber:z,startColumn:Q||1}:void 0}}}else{if(H.isDirectory())return{workspace:(0,re.$d_b)(h.URI.file(O),H),type:i.FileType.Directory,exists:!0};if(!w.$i&&O==="/dev/null")return{fileUri:h.URI.file(O),type:i.FileType.File,exists:!0}}}catch(H){if(H.code==="ERR_UNC_HOST_NOT_ALLOWED"&&!x)return this.mb(O,F);const _=h.URI.file(O);if(this.L.removeRecentlyOpened([_]),F.ignoreFileNotFound)return{fileUri:_,type:i.FileType.File,exists:!1}}}async mb(O,F){const x=h.URI.file(O),{response:z,checkboxChecked:Q}=await this.O.showMessageBox({type:"warning",buttons:[(0,$.localize)(5,null),(0,$.localize)(6,null),(0,$.localize)(7,null)],message:(0,$.localize)(8,null,x.authority),detail:(0,$.localize)(9,null,(0,y.$_v)(x,{os:w.OS,tildify:this.F})),checkboxLabel:(0,$.localize)(10,null,x.authority),cancelId:1});if(z===0){if((0,S.addUNCHostToAllowlist)(x.authority),Q){const H={channel:"vscode:configureAllowedUNCHost",args:x.authority};this.sendToFocused(H.channel,H.args),this.sendToOpeningWindow(H.channel,H.args)}return this.lb(O,F,!0)}if(z===2)return n.shell.openExternal("https://aka.ms/vscode-windows-unc"),this.mb(O,F)}nb(O,F){const x=O.charCodeAt(0),z=F.remoteAuthority;let Q,H;F.gotoLineMode&&({path:O,line:Q,column:H}=(0,c.$ng)(O)),x!==47&&((0,c.$hg)(x)&&O.charCodeAt(O.charCodeAt(1))===58&&(O=(0,c.$ag)(O)),O=`/${O}`);const _=h.URI.from({scheme:k.Schemas.vscodeRemote,authority:z,path:O});if(O.charCodeAt(O.length-1)!==47){if((0,le.$Li)(O))return F.forceOpenWorkspaceAsFile?{fileUri:_,options:{selection:Q?{startLineNumber:Q,startColumn:H||1}:void 0},remoteAuthority:F.remoteAuthority}:{workspace:(0,re.$c_b)(_),remoteAuthority:z};if(F.gotoLineMode||g.$gc.basename(O).indexOf(".")!==-1)return{fileUri:_,options:{selection:Q?{startLineNumber:Q,startColumn:H||1}:void 0},remoteAuthority:z}}return{workspace:(0,re.$d_b)(_),remoteAuthority:z}}ob(O){const F=this.J.getValue("window"),x=F?.openFoldersInNewWindow||"default",z=F?.openFilesInNewWindow||"off";let Q=(O.preferNewWindow||O.forceNewWindow)&&!O.forceReuseWindow;!O.forceNewWindow&&!O.forceReuseWindow&&(x==="on"||x==="off")&&(Q=x==="on");let H=!1;return O.forceNewWindow||O.forceReuseWindow?H=!!O.forceNewWindow&&!O.forceReuseWindow:(w.$j?O.context===1&&(H=!0):O.context!==3&&O.context!==2&&!(O.userEnv&&O.userEnv.TERM_PROGRAM==="vscode")&&(H=!0),!O.cli.extensionDevelopmentPath&&(z==="on"||z==="off")&&(H=z==="on")),{openFolderInNewWindow:!!Q,openFilesInNewWindow:H}}async openExtensionDevelopmentHostWindow(O,F){const x=(0,V.$a_b)(this.getWindows(),O);if(x)return this.H.reload(x,F.cli),x.focus(),[x];let z=F.cli["folder-uri"]||[],Q=F.cli["file-uri"]||[],H=F.cli._;if(!H.length&&!z.length&&!Q.length&&!F.cli.extensionTestsPath){const te=this.r.state.lastPluginDevelopmentHostWindow,ie=te?.workspace??te?.folderUri;ie&&(h.URI.isUri(ie)?ie.scheme===k.Schemas.file?H=[ie.fsPath]:z=[ie.toString()]:ie.configPath.scheme===k.Schemas.file?H=[(0,u.$Hg)(ie.configPath)]:Q=[ie.configPath.toString()])}let _=F.remoteAuthority;for(const te of O)if(te.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const ie=h.URI.parse(te),de=(0,E.$qm)(ie);de&&(_?(0,u.$Yg)(de,_)||this.w.error("more than one extension development path authority"):_=de)}H=H.filter(te=>{const ie=h.URI.file(te);return(0,V.$_$b)(this.getWindows(),ie)?!1:(0,u.$Yg)((0,E.$qm)(ie),_)}),z=z.filter(te=>{const ie=this.fb(te);return ie&&(0,V.$_$b)(this.getWindows(),ie)?!1:ie?(0,u.$Yg)((0,E.$qm)(ie),_):!1}),Q=Q.filter(te=>{const ie=this.fb(te);return ie&&(0,V.$_$b)(this.getWindows(),ie)?!1:ie?(0,u.$Yg)((0,E.$qm)(ie),_):!1}),F.cli._=H,F.cli["folder-uri"]=z,F.cli["file-uri"]=Q;const B={context:F.context,cli:F.cli,forceNewWindow:!0,forceEmpty:!H.length&&!z.length&&!Q.length,userEnv:F.userEnv,noRecentEntry:!0,waitMarkerFileURI:F.waitMarkerFileURI,remoteAuthority:_,forceProfile:F.forceProfile,forceTempProfile:F.forceTempProfile};return this.open(B)}async pb(O){const F=this.J.getValue("window"),x=this.getLastActiveWindow(),z=x?.profile??this.G.defaultProfile;let Q;!O.forceNewWindow&&!O.forceNewTabbedWindow&&(Q=O.windowToUse||x,Q&&Q.focus());const H={...this.F.args,...O.cli,machineId:this.s,sqmId:this.t,windowId:-1,mainPid:process.pid,appRoot:this.F.appRoot,execPath:process.execPath,codeCachePath:this.F.codeCachePath,backupPath:O.emptyWindowBackupInfo?(0,g.$jc)(this.F.backupHome,O.emptyWindowBackupInfo.backupFolder):void 0,profiles:{home:this.G.profilesHome,all:this.G.profiles,profile:z},homeDir:this.F.userHome.with({scheme:k.Schemas.file}).fsPath,tmpDir:this.F.tmpDir.with({scheme:k.Schemas.file}).fsPath,userDataDir:this.F.userDataPath,remoteAuthority:O.remoteAuthority,workspace:O.workspace,userEnv:{...this.u,...O.userEnv},filesToOpenOrCreate:O.filesToOpen?.filesToOpenOrCreate,filesToDiff:O.filesToOpen?.filesToDiff,filesToMerge:O.filesToOpen?.filesToMerge,filesToWait:O.filesToOpen?.filesToWait,logLevel:this.z.getLogLevel(),loggers:{window:[],global:this.z.getRegisteredLoggers()},logsPath:this.F.logsHome.with({scheme:k.Schemas.file}).fsPath,product:R.default,isInitialStartup:O.initialStartup,perfMarks:(0,m.getMarks)(),os:{release:(0,M.release)(),hostname:(0,M.hostname)(),arch:(0,M.arch)()},autoDetectHighContrast:F?.autoDetectHighContrast??!0,autoDetectColorScheme:F?.autoDetectColorScheme??!1,accessibilitySupport:n.app.accessibilitySupportEnabled,colorScheme:this.R.getColorScheme(),policiesData:this.D.serialize(),continueOn:this.F.continueOn};if(Q){const _=Q.config;!H.extensionDevelopmentPath&&_?.extensionDevelopmentPath&&(H.extensionDevelopmentPath=_.extensionDevelopmentPath,H.extensionDevelopmentKind=_.extensionDevelopmentKind,H["enable-proposed-api"]=_["enable-proposed-api"],H.verbose=_.verbose,H["inspect-extensions"]=_["inspect-extensions"],H["inspect-brk-extensions"]=_["inspect-brk-extensions"],H.debugId=_.debugId,H.extensionEnvironment=_.extensionEnvironment,H["extensions-dir"]=_["extensions-dir"],H["disable-extensions"]=_["disable-extensions"]),H.loggers={global:H.loggers.global,window:_?.loggers.window??H.loggers.window}}else{const _=this.r.getNewWindowState(H);(0,m.mark)("code/willCreateCodeWindow");const B=Q=this.N.createInstance(T.$k_b,{state:_,extensionDevelopmentPath:H.extensionDevelopmentPath,isExtensionTestHost:!!H.extensionTestsPath});(0,m.mark)("code/didCreateCodeWindow"),O.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(B),this.n.set(B.id,B),this.a.fire(B),this.f.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()});const te=new v.$Sc;te.add(B.onDidSignalReady(()=>this.b.fire(B))),te.add(d.Event.once(B.onDidClose)(()=>this.sb(B,te))),te.add(d.Event.once(B.onDidDestroy)(()=>this.tb(B))),te.add(B.onDidMaximize(()=>this.g.fire(B))),te.add(B.onDidUnmaximize(()=>this.h.fire(B))),te.add(B.onDidEnterFullScreen(()=>this.j.fire({window:B,fullscreen:!0}))),te.add(B.onDidLeaveFullScreen(()=>this.j.fire({window:B,fullscreen:!1}))),te.add(B.onDidTriggerSystemContextMenu(({x:de,y:me})=>this.m.fire({window:B,x:de,y:me})));const ie=(0,f.$5f)(B.win?.webContents);ie.removeAllListeners("devtools-reload-page"),ie.on("devtools-reload-page",()=>this.H.reload(B)),this.H.registerWindow(B)}return H.windowId=Q.id,Q.isReady?this.H.unload(Q,4).then(async _=>{_||await this.qb(Q,H,O,z)}):await this.qb(Q,H,O,z),Q}async qb(O,F,x,z){if(F.extensionDevelopmentPath||((0,le.$vi)(F.workspace)?F.backupPath=this.I.registerWorkspaceBackup({workspace:F.workspace,remoteAuthority:F.remoteAuthority}):(0,le.$qi)(F.workspace)?F.backupPath=this.I.registerFolderBackup({folderUri:F.workspace.uri,remoteAuthority:F.remoteAuthority}):F.backupPath=this.I.registerEmptyWindowBackup({backupFolder:x.emptyWindowBackupInfo?.backupFolder??(0,re.$e_b)().id,remoteAuthority:F.remoteAuthority})),this.G.isEnabled()){const Q=F.workspace??(0,le.$ui)(F.backupPath,!1),H=this.rb(x,Q,z),_=H instanceof Promise?await H:H;F.profiles.profile=_,F.extensionDevelopmentPath||await this.G.setProfileForWorkspace(Q,_)}O.load(F)}rb(O,F,x){return O.forceProfile?this.G.profiles.find(z=>z.name===O.forceProfile)??this.G.createNamedProfile(O.forceProfile):O.forceTempProfile?this.G.createTransientProfile():this.G.getProfileForWorkspace(F)??x}sb(O,F){this.n.delete(O.id),this.f.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()}),F.dispose()}tb(O){this.n.delete(O.id),this.c.fire(O)}getFocusedWindow(){const O=n.BrowserWindow.getFocusedWindow();if(O)return this.getWindowById(O.id)}getLastActiveWindow(){return this.vb(this.getWindows())}ub(O){return this.vb(this.getWindows().filter(F=>(0,u.$Yg)(F.remoteAuthority,O)))}vb(O){return(0,W.$8$b)(O)}sendToFocused(O,...F){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(O,P.CancellationToken.None,...F)}sendToOpeningWindow(O,...F){this.B(d.Event.once(this.onDidSignalReadyWindow)(x=>{x.sendWhenReady(O,P.CancellationToken.None,...F)}))}sendToAll(O,F,x){for(const z of this.getWindows())x&&x.indexOf(z.id)>=0||z.sendWhenReady(O,P.CancellationToken.None,F)}getWindows(){return Array.from(this.n.values())}getWindowCount(){return this.n.size}getWindowById(O){return this.n.get(O)}getWindowByWebContents(O){const F=n.BrowserWindow.fromWebContents(O);if(F)return this.getWindowById(F.id)}};e.$vac=he,e.$vac=he=ve([se(3,b.$Aj),se(4,N.$h_b),se(5,A.$HP),se(6,U.$Zn),se(7,r.$U$b),se(8,L.$9$b),se(9,l.$m_b),se(10,a.$Z$b),se(11,t.$Mi),se(12,ue.$4_b),se(13,Z.$f_b),se(14,s.$fi),se(15,o.$1$b),se(16,i.$Gk),se(17,I.$3$b),se(18,Y.$4$b),se(19,G.$Q_b)],he)}),define(ae[309],ce([0,1,64,29,84,58]),function(X,e,n,D,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xac=void 0;let C=class{constructor(d,c,y,v){this.a=d,this.b=c,this.c=y,this.d=v,this.onDidChangeRecentlyOpened=this.c.onDidChangeRecentlyOpened}async enterWorkspace(d,c){const y=this.b.getWindowById(d);if(y)return this.a.enterWorkspace(y,this.b.getWindows(),c)}createUntitledWorkspace(d,c,y){return this.a.createUntitledWorkspace(c,y)}deleteUntitledWorkspace(d,c){return this.a.deleteUntitledWorkspace(c)}getWorkspaceIdentifier(d,c){return this.a.getWorkspaceIdentifier(c)}getRecentlyOpened(d){return this.c.getRecentlyOpened()}addRecentlyOpened(d,c){return this.c.addRecentlyOpened(c)}removeRecentlyOpened(d,c){return this.c.removeRecentlyOpened(c)}clearRecentlyOpened(d){return this.c.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.d.getDirtyWorkspaces()}};e.$xac=C,e.$xac=C=ve([se(0,M.$f_b),se(1,D.$6$b),se(2,S.$4_b),se(3,n.$Z$b)],C)}),define(ae[310],ce([0,1,14,102,37,26,17,51,15,33,3,42,47,2,13,9,4,12,7,32,160,43,161,114,292,164,64,285,18,202,92,134,56,120,222,24,63,95,211,295,213,214,215,16,226,94,77,6,93,221,301,286,293,20,5,307,70,27,68,296,96,34,277,83,126,28,253,255,54,49,267,290,302,291,303,131,269,270,271,274,299,55,29,308,276,30,98,84,309,58,39,235,57,246,53,82,132,279,294,282,8,257,278,230,67,298,273,22,129,297,265,241,61,78,305]),function(X,e,n,D,S,M,C,P,d,c,y,v,k,g,m,w,p,u,f,h,$,a,t,o,r,i,s,l,b,R,I,E,A,j,T,W,V,K,le,re,ue,Z,Y,U,L,N,G,q,oe,he,J,O,F,x,z,Q,H,_,B,te,ie,de,me,ke,Se,Me,He,ye,ee,fe,$e,Pe,De,qe,je,Fe,Ue,Ge,Xe,Te,ne,ge,be,pe,Ee,Oe,Ne,Je,xe,Ze,Qe,st,tt,ot,at,yt,vt,kt,Et,Pt,ct,gt,St,It,At,lt,Ct,$t,ut,Rt,Dt,ht,Ot,mt,Mt){"use strict";var ft;Object.defineProperty(e,"__esModule",{value:!0}),e.$Qac=void 0;let dt=class extends g.$Tc{static{ft=this}static{this.a={[m.Schemas.file]:"security.promptForLocalFileProtocolHandling",[m.Schemas.vscodeRemote]:"security.promptForRemoteFileProtocolHandling"}}constructor(Ie,Ae,Re,we,Ce,ze,Be,Ke,Le,We,Ve,Ye){super(),this.g=Ie,this.h=Ae,this.j=Re,this.m=we,this.n=Ce,this.s=ze,this.t=Be,this.u=Ke,this.w=Le,this.y=We,this.z=Ve,this.C=Ye,this.D(),this.F()}D(){const Ie=Le=>Le?.startsWith(`${m.Schemas.vscodeWebview}://`),Ae=new Set(["clipboard-read","clipboard-sanitized-write"]);n.session.defaultSession.setPermissionRequestHandler((Le,We,Ve,Ye)=>Ie(Ye.requestingUrl)?Ve(Ae.has(We)):Ve(!1)),n.session.defaultSession.setPermissionCheckHandler((Le,We,Ve,Ye)=>Ie(Ye.requestingUrl)?Ae.has(We):!1);const Re=new Set([m.Schemas.file,m.Schemas.vscodeFileResource,m.Schemas.vscodeRemoteResource,m.Schemas.vscodeManagedRemoteResource,"devtools"]),we=Le=>{for(let We=Le;We;We=We.parent)if(We.url.startsWith(`${m.Schemas.vscodeWebview}://`))return!0;return!1},Ce=Le=>Le.resourceType==="xhr"||we(Le.frame),ze=Le=>{const We=Le.frame;if(!We||!this.b)return!1;const Ve=n.BrowserWindow.getAllWindows();for(const Ye of Ve)if(We.processId===Ye.webContents.mainFrame.processId)return!0;return!1},Be=(Le,We)=>{if(Le.path!=="/index.html")return!0;const Ve=We.frame;if(!Ve||!this.b)return!1;for(const Ye of this.b.getWindows())if(Ye.win&&Ve.processId===Ye.win.webContents.mainFrame.processId)return!0;return!1};n.session.defaultSession.webRequest.onBeforeRequest((Le,We)=>{const Ve=f.URI.parse(Le.url);return Ve.scheme===m.Schemas.vscodeWebview&&!Be(Ve,Le)?(this.m.error("Blocked vscode-webview request",Le.url),We({cancel:!0})):Ve.scheme===m.Schemas.vscodeFileResource&&!ze(Le)?(this.m.error("Blocked vscode-file request",Le.url),We({cancel:!0})):Ve.path.endsWith(".svg")&&!Re.has(Ve.scheme)?We({cancel:!Ce(Le)}):We({cancel:!1})}),n.session.defaultSession.webRequest.onHeadersReceived((Le,We)=>{const Ve=Le.responseHeaders,Ye=Ve["content-type"]||Ve["Content-Type"];if(Ye&&Array.isArray(Ye)){const _e=f.URI.parse(Le.url);if(_e.path.endsWith(".svg")&&Re.has(_e.scheme))return Ve["Content-Type"]=["image/svg+xml"],We({cancel:!1,responseHeaders:Ve});if(!_e.path.endsWith(m.Schemas.vscodeRemoteResource)&&Ye.some(it=>it.toLowerCase().includes("image/svg")))return We({cancel:!Ce(Le)})}return We({cancel:!1})}),n.session.defaultSession.webRequest.onHeadersReceived((Le,We)=>{if(Le.url.startsWith("https://vscode.download.prss.microsoft.com/")){const Ve=Le.responseHeaders??Object.create(null);if(Ve["Access-Control-Allow-Origin"]===void 0)return Ve["Access-Control-Allow-Origin"]=["*"],We({cancel:!1,responseHeaders:Ve})}return We({cancel:!1})});const Ke=n.session.defaultSession;typeof Ke.setCodeCachePath=="function"&&this.s.codeCachePath&&Ke.setCodeCachePath((0,w.$jc)(this.s.codeCachePath,"chrome")),p.$i&&(this.u.getValue("security.restrictUNCAccess")===!1?(0,D.disableUNCAccessRestrictions)():(0,D.addUNCHostToAllowlist)(this.u.getValue("security.allowedUNCHosts")))}F(){(0,d.setUnexpectedErrorHandler)(Re=>this.H(Re)),process.on("uncaughtException",Re=>{(0,d.$Z)(Re)||(0,d.$1)(Re)}),process.on("unhandledRejection",Re=>(0,d.$1)(Re)),this.t.onWillShutdown(()=>this.dispose()),(0,$.$SV)(),n.app.on("accessibility-support-changed",(Re,we)=>{this.b?.sendToAll("vscode:accessibilitySupportChanged",we)}),n.app.on("activate",async(Re,we)=>{this.m.trace("app#activate"),we||await this.b?.openEmptyWindow({context:1})}),n.app.on("web-contents-created",(Re,we)=>{we?.opener?.url.startsWith(`${m.Schemas.vscodeFileResource}://${m.$zg}/`)&&(this.m.trace('[aux window]  app.on("web-contents-created"): Registering auxiliary window'),this.c?.registerWindow(we)),we.on("will-navigate",Ce=>{this.m.error("webContents#will-navigate: Prevented webcontent navigation"),Ce.preventDefault()}),we.setWindowOpenHandler(Ce=>Ce.url==="about:blank"?(this.m.trace("[aux window] webContents#setWindowOpenHandler: Allowing auxiliary window to open on about:blank"),{action:"allow",overrideBrowserWindowOptions:this.c?.createWindow(Ce)}):(this.m.trace(`webContents#setWindowOpenHandler: Prevented opening window with URL ${Ce.url}}`),this.f?.openExternal(void 0,Ce.url),{action:"deny"}))});let Ie=[],Ae;n.app.on("open-file",(Re,we)=>{this.m.trace("app#open-file: ",we),Re.preventDefault(),Ie.push((0,Oe.$Li)(we)?{workspaceUri:f.URI.file(we)}:{fileUri:f.URI.file(we)}),Ae!==void 0&&(clearTimeout(Ae),Ae=void 0),Ae=setTimeout(async()=>{await this.b?.open({context:1,cli:this.s.args,urisToOpen:Ie,gotoLineMode:!1,preferNewWindow:!0}),Ie=[],Ae=void 0},100)}),n.app.on("new-window-for-tab",async()=>{await this.b?.openEmptyWindow({context:4})}),S.$RV.handle("vscode:fetchShellEnv",Re=>{const we=this.b?.getWindowByWebContents(Re.sender);let Ce,ze;return we?.config?(Ce=we.config,ze={...process.env,...we.config.userEnv}):(Ce=this.s.args,ze=process.env),this.X(Ce,ze,!1)}),S.$RV.handle("vscode:writeNlsFile",(Re,we,Ce)=>{const ze=this.G([we]);if(!ze||typeof Ce!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.y.writeFile(ze,C.$te.fromString(Ce))}),S.$RV.handle("vscode:readNlsFile",async(Re,...we)=>{const Ce=this.G(we);if(!Ce)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.y.readFile(Ce)).value.toString()}),S.$RV.on("vscode:toggleDevTools",Re=>Re.sender.toggleDevTools()),S.$RV.on("vscode:openDevTools",Re=>Re.sender.openDevTools()),S.$RV.on("vscode:reloadWindow",Re=>Re.sender.reload()),S.$RV.handle("vscode:notifyZoomLevel",async(Re,we)=>{const Ce=this.b?.getWindowById(Re.sender.id);Ce&&Ce.notifyZoomLevel(we)})}G(Ie){let Ae;for(const Re of Ie)typeof Re=="string"&&(typeof Ae!="string"?Ae=Re:Ae=(0,w.$jc)(Ae,Re));if(!(typeof Ae!="string"||!(0,w.$ic)(Ae)||!(0,c.$gg)(Ae,this.s.cachedLanguagesPath,!p.$k)))return f.URI.file(Ae)}H(Ie){if(Ie){const Ae={message:`[uncaught exception in main]: ${Ie.message}`,stack:Ie.stack};this.b?.sendToFocused("vscode:reportError",JSON.stringify(Ae))}this.m.error(`[uncaught exception in main]: ${Ie}`),Ie.stack&&this.m.error(Ie.stack)}async startup(){this.m.debug("Starting VS Code"),this.m.debug(`from: ${this.s.appRoot}`),this.m.debug("args:",this.s.args);const Ie=this.z.win32AppUserModelId;p.$i&&Ie&&n.app.setAppUserModelId(Ie);try{p.$j&&this.u.getValue("window.nativeTabs")===!0&&!n.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&n.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(We){this.m.error(We)}const Ae=new t.$YV;this.t.onWillShutdown(We=>{We.reason===2&&Ae.dispose()}),this.m.trace("Resolving machine identifier...");const[Re,we]=await Promise.all([(0,gt.$Fac)(this.w,this.m),(0,gt.$Gac)(this.w,this.m)]);this.m.trace(`Resolved machine identifier: ${Re}`);const{sharedProcessReady:Ce,sharedProcessClient:ze}=this.P(Re,we),Be=await this.Q(Re,we,Ce);this.B(Be.createInstance(r.$w_b)),this.B(Be.createInstance(Et.$Bac)),Be.invokeFunction(We=>this.R(We,Ae,ze));const Ke=await Be.invokeFunction(We=>this.I(We,Ae));this.J(Ae),this.t.phase=2,await Be.invokeFunction(We=>this.S(We,Ke)),this.t.phase=3,this.U(),this.B(new ct.$sh(()=>{this.B((0,ct.$wh)(()=>this.t.phase=4,2500))},2500)).schedule()}async I(Ie,Ae){const Re=this.b=Ie.get(be.$6$b),we=Ie.get(Fe.$GW),Ce=this.f=Ie.get(H.$R_b),ze=Ie.get(A.$1$b),Be=this;we.registerHandler({async handleURL(_e,it){return Be.O(Re,ze,we,_e,it)}});const Ke=this.B(new Ee.$wac({onDidOpenMainWindow:Ce.onDidOpenMainWindow,onDidFocusMainWindow:Ce.onDidFocusMainWindow,getActiveWindowId:()=>Ce.getActiveWindowId(-1)})),Le=new a.$1h(_e=>Ke.getActiveClientId().then(it=>_e===it)),We=new Ue.$nac(Le,this.m),Ve=Ae.getChannel("urlHandler",We);we.registerHandler(new Ue.$mac(Ve));const Ye=await this.L(Re,ze);return this.B(new Xe.$oac(Ye?.urls,we,Re,this.s,this.z,this.m)),Ye}J(Ie){const Ae=()=>({statusCode:404,data:"Not found"}),Re=new Ot.$V(()=>Ie.getChannel(ht.$Nac,new ht.$Oac));n.protocol.registerBufferProtocol(m.Schemas.vscodeManagedRemoteResource,(we,Ce)=>{const ze=f.URI.parse(we.url);if(!ze.authority.startsWith("window:"))return Ce(Ae());Re.value.call(ht.$Mac,[ze]).then(Be=>Ce({...Be,data:Buffer.from(Be.body,"base64")}),Be=>{this.m.warn("error dispatching remote resource call",Be),Ce({statusCode:500,data:String(Be)})})})}async L(Ie,Ae){const Re=this.s.args["open-url"]?this.s.args._urls||[]:[];Re.length>0&&this.m.trace("app#resolveInitialProtocolUrls() protocol urls from command line:",Re);const we=global.getOpenUrls()||[];if(we.length>0&&this.m.trace("app#resolveInitialProtocolUrls() protocol urls from macOS 'open-url' event:",we),Re.length+we.length===0)return;const Ce=[...Re,...we].map(Ke=>{try{return{uri:f.URI.parse(Ke),originalUrl:Ke}}catch{this.m.trace("app#resolveInitialProtocolUrls() protocol url failed to parse:",Ke);return}}),ze=[],Be=[];for(const Ke of Ce){if(!Ke)continue;const Le=this.N(Ke.uri);if(Le)if(await this.M(Le,Ie,Ae)){this.m.trace("app#resolveInitialProtocolUrls() protocol url was blocked:",Ke.uri.toString(!0));continue}else this.m.trace("app#resolveInitialProtocolUrls() protocol url will be handled as window to open:",Ke.uri.toString(!0),Le),ze.push(Le);else this.m.trace("app#resolveInitialProtocolUrls() protocol url will be passed to active window for handling:",Ke.uri.toString(!0)),Be.push(Ke)}return{urls:Be,openables:ze}}async M(Ie,Ae,Re){let we,Ce;if((0,ge.$6C)(Ie)?(we=Ie.workspaceUri,Ce=(0,i.localize)(0,null,we.scheme===m.Schemas.file?(0,k.$_v)(we,{os:p.OS,tildify:this.s}):we.toString(!0),this.z.nameShort)):(0,ge.$7C)(Ie)?(we=Ie.folderUri,Ce=(0,i.localize)(1,null,we.scheme===m.Schemas.file?(0,k.$_v)(we,{os:p.OS,tildify:this.s}):we.toString(!0),this.z.nameShort)):(we=Ie.fileUri,Ce=(0,i.localize)(2,null,we.scheme===m.Schemas.file?(0,k.$_v)(we,{os:p.OS,tildify:this.s}):we.toString(!0),this.z.nameShort)),we.scheme!==m.Schemas.file&&we.scheme!==m.Schemas.vscodeRemote||this.u.getValue(ft.a[we.scheme])===!1)return!1;const{response:Be,checkboxChecked:Ke}=await Re.showMessageBox({type:"warning",buttons:[(0,i.localize)(3,null),(0,i.localize)(4,null)],message:Ce,detail:(0,i.localize)(5,null),checkboxLabel:we.scheme===m.Schemas.file?(0,i.localize)(6,null):(0,i.localize)(7,null),cancelId:1});if(Be!==0)return!0;if(Ke){const Le={channel:"vscode:disablePromptForProtocolHandling",args:we.scheme===m.Schemas.file?"local":"remote"};Ae.sendToFocused(Le.channel,Le.args),Ae.sendToOpeningWindow(Le.channel,Le.args)}return!1}N(Ie){if(Ie.path){if(Ie.authority===m.Schemas.file){const Ae=f.URI.file(Ie.fsPath);return(0,Oe.$Li)(Ae)?{workspaceUri:Ae}:{fileUri:Ae}}else if(Ie.authority===m.Schemas.vscodeRemote){const Ae=Ie.path.indexOf(w.$gc.sep,1);if(Ae!==-1){const Re=Ie.path.substring(1,Ae),we=Ie.path.substring(Ae);let Ce=Ie.query;const ze=new URLSearchParams(Ie.query);ze.get("windowId")==="_blank"&&(ze.delete("windowId"),Ce=ze.toString());const Be=f.URI.from({scheme:m.Schemas.vscodeRemote,authority:Re,path:we,query:Ce,fragment:Ie.fragment});return(0,Oe.$Li)(we)?{workspaceUri:Be}:/:[\d]+$/.test(we)?{fileUri:Be}:{folderUri:Be}}}}}async O(Ie,Ae,Re,we,Ce){this.m.trace("app#handleProtocolUrl():",we.toString(!0),Ce),we.scheme===this.z.urlProtocol&&we.path==="workspace"&&(we=we.with({authority:"file",path:f.URI.parse(we.query).path,query:""}));let ze=!1;const Be=new URLSearchParams(we.query);Be.get("windowId")==="_blank"?(this.m.trace("app#handleProtocolUrl() found 'windowId=_blank' as parameter, setting shouldOpenInNewWindow=true:",we.toString(!0)),Be.delete("windowId"),we=we.with({query:Be.toString()}),ze=!0):p.$j&&Ie.getWindowCount()===0&&(this.m.trace("app#handleProtocolUrl() running on macOS with no window open, setting shouldOpenInNewWindow=true:",we.toString(!0)),ze=!0);const Ke=Be.get("continueOn");Ke!==null&&(this.m.trace("app#handleProtocolUrl() found 'continueOn' as parameter:",we.toString(!0)),Be.delete("continueOn"),we=we.with({query:Be.toString()}),this.s.continueOn=Ke??void 0);const Le=this.N(we);return Le?await this.M(Le,Ie,Ae)?(this.m.trace("app#handleProtocolUrl() protocol url was blocked:",we.toString(!0)),!0):(this.m.trace("app#handleProtocolUrl() opening protocol url as window:",Le,we.toString(!0)),(0,$t.$Ob)(await Ie.open({context:5,cli:{...this.s.args},urisToOpen:[Le],forceNewWindow:ze,gotoLineMode:!0}))?.focus(),!0):ze?(this.m.trace("app#handleProtocolUrl() opening empty window and passing in protocol url:",we.toString(!0)),await(0,$t.$Ob)(await Ie.open({context:5,cli:{...this.s.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,B.$qm)(we)}))?.ready(),Re.open(we,Ce)):(this.m.trace("app#handleProtocolUrl(): not handled",we.toString(!0),Ce),!1)}P(Ie,Ae){const Re=this.B(this.j.createInstance(te.$__b,Ie,Ae)),we=(async()=>{this.m.trace("Main->SharedProcess#connect");const ze=await Re.connect();return this.m.trace("Main->SharedProcess#connect: connection established"),new o.$ZV(ze,"main")})();return{sharedProcessReady:(async()=>(await Re.whenReady(),we))(),sharedProcessClient:we}}async Q(Ie,Ae,Re){const we=new oe.$ei;switch(process.platform){case"win32":we.set(fe.$QW,new G.$di(je.$kac));break;case"linux":p.$l?we.set(fe.$QW,new G.$di(qe.$jac,[process.env.SNAP,process.env.SNAP_REVISION])):we.set(fe.$QW,new G.$di(De.$iac));break;case"darwin":we.set(fe.$QW,new G.$di(Pe.$hac));break}we.set(be.$6$b,new G.$di(pe.$vac,[Ie,Ae,this.h],!1)),we.set(mt.$Q_b,new G.$di(Mt.$Pac,void 0,!1));const Ce=new A.$2$b(this.m,this.z);we.set(A.$1$b,Ce),we.set(F.$X_b,new G.$di(F.$Y_b,void 0,!1)),we.set(E.$C_b,new G.$di(E.$D_b,void 0,!1)),we.set(I.$Ym,a.ProxyChannel.toService((0,a.$Yh)(Re.then(We=>We.getChannel("diagnostics"))))),we.set(he.$JBb,new G.$di(J.$T_b,[this.h])),we.set(j.$AW,new G.$di(T.$E_b)),we.set(O.$U_b,new G.$di(O.$V_b)),we.set(H.$R_b,new G.$di(H.$S_b,void 0,!1)),we.set(Te.$pac,new G.$di(ne.$rac)),we.set(Q.$7_b,new G.$di(Q.$8_b)),we.set(le.$F_b,new G.$di(re.$H_b)),we.set(ke.$s_b,new G.$di(ke.$t_b)),we.set(ke.$u_b,new G.$di(ke.$v_b));const ze=new Rt.$Lac({graceTime:6e4,shortGraceTime:6e3,scrollback:this.u.getValue("terminal.integrated.persistentSessionScrollback")??100},this.u,this.s,this.t,this.m),Be=new Dt.$as(ze,this.u,this.m,this.n);we.set(ut.$Nr,Be),p.$i?we.set(ue.$I_b,new G.$di(Z.$J_b)):p.$j?we.set(ue.$I_b,new G.$di(Z.$K_b)):p.$k&&we.set(ue.$I_b,new G.$di(Z.$L_b));const Ke=new l.$x_b(this.s,this.u,this.m,this.w);we.set(s.$Z$b,Ke);const Le=new Ze.$g_b(this.s,this.m,this.C,Ke,Ce);if(we.set(Ze.$f_b,Le),we.set(Ne.$leb,new G.$di(xe.$xac,void 0,!1)),we.set(Je.$4_b,new G.$di(Je.$5_b,void 0,!1)),we.set(Fe.$GW,new G.$di(Ge.$IW,void 0,!1)),(0,ee.$8o)(this.z,this.s)){const We=(0,ee.$ap)(this.z,this.u),Ve=(0,a.$Yh)(Re.then(rt=>rt.getChannel("telemetryAppender"))),Ye=new He.$cac(Ve),_e=(0,Se.$Yo)((0,M.release)(),(0,M.hostname)(),process.arch,this.z.commit,this.z.version,Ie,Ae,We),it=(0,ee.$bp)(this.s),nt={appenders:[Ye],commonProperties:_e,piiPaths:it,sendErrorTelemetry:!0};we.set(Me.$Fl,new G.$di(ye.$Er,[nt],!1))}else we.set(Me.$Fl,ee.$3o);return we.set(yt.$$p,new G.$di(St.$OP,void 0,!0)),we.set(vt.$cq,new G.$di(kt.$Aac,void 0,!0)),we.set(lt.$Jac,new G.$di(lt.$Kac,void 0,!0)),await ct.Promises.settled([Ke.initialize(),Le.initialize()]),this.j.createChild(we)}R(Ie,Ae,Re){const we=this.B(new g.$Sc),Ce=a.ProxyChannel.fromService(Ie.get(F.$X_b),we,{disableMarshalling:!0});this.g.registerChannel("launch",Ce);const ze=a.ProxyChannel.fromService(Ie.get(E.$C_b),we,{disableMarshalling:!0});this.g.registerChannel("diagnostics",ze);const Be=new st.$yac(Ie.get(Qe.$Zn));Ae.registerChannel("policy",Be),Re.then(et=>et.registerChannel("policy",Be));const Ke=this.y.getProvider(m.Schemas.file);(0,u.$4f)(Ke instanceof N.$Qq);const Le=new L.$M_b(Ke,this.m,this.s);Ae.registerChannel(Y.$xP,Le),Re.then(et=>et.registerChannel(Y.$xP,Le));const We=a.ProxyChannel.fromService(Ie.get(tt.$9$b),we);Ae.registerChannel("userDataProfiles",We),Re.then(et=>et.registerChannel("userDataProfiles",We));const Ve=new ot.$zr(Ie.get(at.$wp));Re.then(et=>et.registerChannel("request",Ve));const Ye=new $e.$dac(Ie.get(fe.$QW));Ae.registerChannel("update",Ye);const _e=a.ProxyChannel.fromService(Ie.get(he.$JBb),we);Ae.registerChannel("issue",_e);const it=a.ProxyChannel.fromService(Ie.get(j.$AW),we);Ae.registerChannel("encryption",it);const nt=a.ProxyChannel.fromService(Ie.get(ie.$tl),we);Ae.registerChannel("sign",nt);const rt=a.ProxyChannel.fromService(Ie.get(O.$U_b),we);Ae.registerChannel("keyboardLayout",rt),this.f=Ie.get(H.$R_b);const wt=a.ProxyChannel.fromService(this.f,we);Ae.registerChannel("nativeHost",wt),Re.then(et=>et.registerChannel("nativeHost",wt));const jt=a.ProxyChannel.fromService(Ie.get(Ne.$leb),we);Ae.registerChannel("workspaces",jt);const Lt=a.ProxyChannel.fromService(Ie.get(Q.$7_b),we);Ae.registerChannel("menubar",Lt);const Ft=a.ProxyChannel.fromService(Ie.get(Fe.$GW),we);Ae.registerChannel("url",Ft);const Wt=a.ProxyChannel.fromService(Ie.get(Te.$pac),we);Ae.registerChannel("webview",Wt);const bt=this.B(new me.$aac(this.m,Ie.get(ke.$s_b)));Ae.registerChannel("storage",bt),Re.then(et=>et.registerChannel("storage",bt));const Tt=this.B(new Pt.$Cac(Ie.get(ke.$s_b),Ie.get(tt.$9$b),this.m));Re.then(et=>et.registerChannel("profileStorageListener",Tt));const Nt=a.ProxyChannel.fromService(Ie.get(ut.$Nr),we);Ae.registerChannel(ut.TerminalIpcChannels.LocalPty,Nt);const zt=a.ProxyChannel.fromService(Ie.get(ue.$I_b),we);Ae.registerChannel("externalTerminal",zt);const pt=new It.$Hac(Ie.get(At.$h_b));Ae.registerChannel("logger",pt),Re.then(et=>et.registerChannel("logger",pt));const Bt=new R.$y_b(Ie.get(be.$6$b));Ae.registerChannel("extensionhostdebugservice",Bt);const qt=a.ProxyChannel.fromService(Ie.get(le.$F_b),we);Ae.registerChannel(le.$G_b,qt);const Ut=a.ProxyChannel.fromService(Ie.get(lt.$Jac),we);Ae.registerChannel(Ct.$Iac,Ut)}async S(Ie,Ae){const Re=this.b=Ie.get(be.$6$b);this.c=Ie.get(mt.$Q_b);const we=(0,V.$em)(process.env)?0:4,Ce=this.s.args;if(Ae){if(Ae.openables.length>0)return Re.open({context:we,cli:Ce,urisToOpen:Ae.openables,gotoLineMode:!0,initialStartup:!0});if(Ae.urls.length>0)for(const nt of Ae.urls){const rt=new URLSearchParams(nt.uri.query);if(rt.get("windowId")==="_blank")return rt.delete("windowId"),nt.originalUrl=nt.uri.toString(!0),nt.uri=nt.uri.with({query:rt.toString()}),Re.open({context:we,cli:Ce,forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,initialStartup:!0})}}const ze=global.macOpenFiles,Be=Ce._.length,Ke=!!Ce["folder-uri"],Le=!!Ce["file-uri"],We=Ce["skip-add-to-recently-opened"]===!0,Ve=Ce.wait&&Ce.waitMarkerFilePath?f.URI.file(Ce.waitMarkerFilePath):void 0,Ye=Ce.remote||void 0,_e=Ce.profile,it=Ce["profile-temp"];if(!Be&&!Ke&&!Le){if(Ce["new-window"]||_e||it)return Re.open({context:we,cli:Ce,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:We,waitMarkerFileURI:Ve,initialStartup:!0,remoteAuthority:Ye,forceProfile:_e,forceTempProfile:it});if(ze.length)return Re.open({context:1,cli:Ce,urisToOpen:ze.map(nt=>(0,Oe.$Li)(nt)?{workspaceUri:f.URI.file(nt)}:{fileUri:f.URI.file(nt)}),noRecentEntry:We,waitMarkerFileURI:Ve,initialStartup:!0})}return Re.open({context:we,cli:Ce,forceNewWindow:Ce["new-window"]||!Be&&Ce["unity-launch"],diffMode:Ce.diff,mergeMode:Ce.merge,noRecentEntry:We,waitMarkerFileURI:Ve,gotoLineMode:Ce.goto,initialStartup:!0,remoteAuthority:Ye,forceProfile:_e,forceTempProfile:it})}U(){this.W(),n.protocol.registerHttpProtocol(m.Schemas.vscodeRemoteResource,(Ie,Ae)=>{Ae({url:Ie.url.replace(/^vscode-remote-resource:/,"http:"),method:Ie.method})}),this.X(this.s.args,process.env,!0),this.Y(),p.$j&&n.app.runningUnderARM64Translation&&this.b?.sendToFocused("vscode:showTranslatedBuildWarning")}async W(){const Ie=this.z.win32MutexName;if(p.$i&&Ie)try{const Ae=await new Promise((we,Ce)=>{X(["@vscode/windows-mutex"],we,Ce)}),Re=new Ae.Mutex(Ie);y.Event.once(this.t.onWillShutdown)(()=>Re.release())}catch(Ae){this.m.error(Ae)}}async X(Ie,Ae,Re){try{return await(0,K.$km)(this.u,this.m,Ie,Ae)}catch(we){const Ce=(0,P.$4i)(we);Re?this.b?.sendToFocused("vscode:showResolveShellEnvError",Ce):this.m.error(Ce)}return{}}async Y(){try{const Ae=(await this.y.readFile(this.s.argvResource)).value.toString(),Re=JSON.parse((0,v.$An)(Ae)),Ce=(0,ee.$0o)(this.u)>=1;if(Re["enable-crash-reporter"]===void 0){const ze=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Ce},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,h.$Cg)()}"`,"}"],Be=Ae.substring(0,Ae.length-2).concat(`,
`,ze.join(`
`));await this.y.writeFile(this.s.argvResource,C.$te.fromString(Be))}else{const ze=Ae.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${Ce},`);ze!==Ae&&await this.y.writeFile(this.s.argvResource,C.$te.fromString(ze))}}catch(Ie){this.m.error(Ie)}}};e.$Qac=dt,e.$Qac=dt=ft=ve([se(2,q.$fi),se(3,z.$Aj),se(4,z.$Bj),se(5,W.$U$b),se(6,x.$m_b),se(7,b.$Mi),se(8,de.$HP),se(9,U.$Gk),se(10,_.$Sj),se(11,tt.$9$b)],dt)}),define(ae[315],ce([0,1,14,46,7,22,8,51,15,33,3,47,13,9,66,4,36,25,21,43,100,310,10,18,240,252,24,63,204,16,224,94,77,220,93,20,227,5,79,27,80,280,130,289,53,288,96,251,34,54,69,57,39,236,234,2,40,268,67,229,119,125,272,102,266]),function(X,e,n,D,S,M,C,P,d,c,y,v,k,g,m,w,p,u,f,h,$,a,t,o,r,i,s,l,b,R,I,E,A,j,T,W,V,K,le,re,ue,Z,Y,U,L,N,G,q,oe,he,J,O,F,x,z,Q,H,_,B,te,ie,de,me,ke){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class Se{main(){try{this.a()}catch(ye){console.error(ye.message),n.app.exit(1)}}async a(){(0,d.setUnexpectedErrorHandler)(Fe=>console.error(Fe));const[ye,ee,fe,$e,Pe,De,qe,je]=this.b();try{try{await this.d(fe,je,$e,Pe,qe)}catch(Fe){throw this.g(fe,qe,Fe),Fe}await ye.invokeFunction(async Fe=>{const Ue=Fe.get(K.$Aj),Ge=Fe.get(W.$m_b),Xe=Fe.get(R.$Gk),Te=Fe.get(K.$Bj),ne=await this.f(Ue,fe,Ge,ye,qe,!0);return f.Promises.writeFile(fe.mainLockfile,String(process.pid)).catch(ge=>{Ue.warn(`app#startup(): Error writing main lockfile: ${ge.stack}`)}),De.logger=Te.createLogger("main",{name:(0,t.localize)(0,null)}),y.Event.once(Ge.onWillShutdown)(ge=>{Xe.dispose(),$e.dispose(),ge.join("instanceLockfile",f.Promises.unlink(fe.mainLockfile).catch(()=>{}))}),ye.createInstance(a.$Qac,ne,ee).startup()})}catch(Fe){ye.invokeFunction(this.j,Fe)}}b(){const ye=new T.$ei,ee=new Q.$Sc;process.once("exit",()=>ee.dispose());const fe={_serviceBrand:void 0,...le.default};ye.set(re.$Sj,fe);const $e=new s.$V$b(this.k(),fe),Pe=this.c($e);ye.set(s.$U$b,$e);const De=new B.$i_b((0,K.$Oj)($e),$e.logsHome);ye.set(B.$h_b,De);const qe=new V.$C9b(De.getLogLevel()),je=ee.add(new te.$PP(qe,[new K.$Hj(De.getLogLevel())]));ye.set(K.$Aj,je);const Fe=new I.$rq(je);ye.set(R.$Gk,Fe);const Ue=new E.$Qq(je);Fe.registerProvider(k.Schemas.file,Ue);const Ge=new _.$es(Fe);ye.set(H.$el,Ge);const Xe=new de.$KP(1,$e,je,Fe);ye.set(oe.$GP,Xe),ye.set(oe.$HP,Xe);const Te=new O.$0$b(Xe,Ge,$e,Fe,je);ye.set(O.$9$b,Te),Fe.registerProvider(k.Schemas.vscodeUserData,new me.$2ac(k.Schemas.file,Ue,k.Schemas.vscodeUserData,Te,Ge,je));const ne=w.$i&&fe.win32RegValueName?ee.add(new x.$Zac(je,fe.win32RegValueName)):$e.policyFile?ee.add(new z.$1ac($e.policyFile,Fe,je)):new F.$2n;ye.set(F.$Zn,ne);const ge=new r.$po(Te.defaultProfile.settingsResource,Fe,ne,je);return ye.set(o.$Mi,ge),ye.set(W.$m_b,new A.$di(W.$n_b,void 0,!1)),ye.set(L.$wp,new A.$di(N.$Xac,void 0,!0)),ye.set(J.$4$b,new A.$di(J.$5$b)),ye.set(G.$tl,new A.$di(q.$Yac,void 0,!1)),ye.set(Y.$Qv,new A.$di(U.$Vac)),ye.set(ue.$3$b,new Z.$Sac($e,Te,je)),[new j.$Tq(ye,!0),Pe,$e,ge,Xe,qe,fe,Te]}c(ye){const ee={VSCODE_IPC_HOOK:ye.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(fe=>{const $e=process.env[fe];typeof $e=="string"&&(ee[fe]=$e)}),Object.assign(process.env,ee),ee}async d(ye,ee,fe,$e,Pe){await C.Promises.settled([Promise.all([this.e(ye.extensionsPath),ye.codeCachePath,ye.logsHome.with({scheme:k.Schemas.file}).fsPath,ee.defaultProfile.globalStorageHome.with({scheme:k.Schemas.file}).fsPath,ye.workspaceStorageHome.with({scheme:k.Schemas.file}).fsPath,ye.localHistoryHome.with({scheme:k.Schemas.file}).fsPath,ye.backupHome].map(De=>De?f.Promises.mkdir(De,{recursive:!0}):void 0)),$e.init(),fe.initialize()]),ee.init()}e(ye){if(w.$i){const ee=(0,ke.getUNCHost)(ye);ee&&(0,ke.addUNCHostToAllowlist)(ee)}return ye}async f(ye,ee,fe,$e,Pe,De){let qe;try{(0,m.mark)("code/willStartMainServer"),qe=await(0,$.$bi)(ee.mainIPCHandle),(0,m.mark)("code/didStartMainServer"),y.Event.once(fe.onWillShutdown)(()=>qe.dispose())}catch(je){if(je.code!=="EADDRINUSE")throw this.g(ee,Pe,je),je;let Fe;try{Fe=await(0,$.$ci)(ee.mainIPCHandle,"main")}catch(Te){if(!De||w.$i||Te.code!=="ECONNREFUSED")throw Te.code==="EPERM"&&this.h((0,t.localize)(1,null,Pe.nameShort),(0,t.localize)(2,null),Pe),Te;try{(0,D.unlinkSync)(ee.mainIPCHandle)}catch(ne){throw ye.warn("Could not delete obsolete instance handle",ne),ne}return this.f(ye,ee,fe,$e,Pe,!1)}if(ee.extensionTestsLocationURI&&!ee.debugExtensionHost.break){const Te=`Running extension tests from the command line is currently only supported if no other instance of ${Pe.nameShort} is running.`;throw ye.error(Te),Fe.dispose(),new Error(Te)}let Ue;!ee.args.wait&&!ee.args.status&&(Ue=setTimeout(()=>{this.h((0,t.localize)(3,null,Pe.nameShort),(0,t.localize)(4,null),Pe)},1e4));const Ge=h.ProxyChannel.toService(Fe.getChannel("launch"),{disableMarshalling:!0}),Xe=h.ProxyChannel.toService(Fe.getChannel("diagnostics"),{disableMarshalling:!0});if(ee.args.status)return $e.invokeFunction(async()=>{const Te=new i.$ls(he.$3o,Pe),ne=await Xe.getMainDiagnostics(),ge=await Xe.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),be=await Te.getDiagnostics(ne,ge);throw console.log(be),new d.$ab});throw w.$i&&await this.i(Ge,ye),ye.trace("Sending env to running instance..."),await Ge.start(ee.args,process.env),Fe.dispose(),Ue&&clearTimeout(Ue),new d.$ab("Sent env to running instance. Terminating...")}if(ee.args.status)throw console.log((0,t.localize)(5,null,Pe.nameShort)),new d.$ab("Terminating...");return process.env.VSCODE_PID=String(process.pid),qe}g(ye,ee,fe){if(fe.code==="EACCES"||fe.code==="EPERM"){const $e=(0,M.$Hb)([ye.userDataPath,ye.extensionsPath,$.$0h]).map(Pe=>(0,v.$_v)(S.URI.file(Pe),{os:w.OS,tildify:ye}));this.h((0,t.localize)(6,null),(0,t.localize)(7,null,(0,P.$4i)(fe),$e.join(`
`)),ee)}}h(ye,ee,fe){n.dialog.showMessageBoxSync((0,ie.$nw)({type:"warning",buttons:[(0,t.localize)(8,null)],message:ye,detail:ee},fe).options)}async i(ye,ee){if(w.$i){const fe=await ye.getMainProcessId();ee.trace("Sending some foreground love to the running instance:",fe);try{(await new Promise(($e,Pe)=>{X(["windows-foreground-love"],$e,Pe)})).allowSetForegroundWindow(fe)}catch($e){ee.error($e)}}}j(ye,ee){const fe=ye.get(K.$Aj),$e=ye.get(W.$m_b);let Pe=0;ee&&(ee.isExpected?ee.message&&fe.trace(ee.message):(Pe=1,ee.stack?fe.error(ee.stack):fe.error(`Startup error: ${ee.toString()}`))),$e.kill(Pe)}k(){const ye=this.l((0,l.$bm)(process.argv));if(ye.wait&&!ye.waitMarkerFilePath){const ee=(0,b.$Rac)(ye.verbose);ee&&((0,l.$dm)(process.argv,"--waitMarkerFilePath",ee),ye.waitMarkerFilePath=ee)}return ye}l(ye){if(ye["open-url"]&&(ye._urls=ye._,ye._=[]),!ye.remote){const ee=this.m(ye._,ye.goto);ye._=ee}return ye}m(ye,ee){const fe=(0,p.cwd)(),$e=ye.map(qe=>{let je=String(qe),Fe;ee&&(Fe=(0,c.$ng)(je),je=Fe.path),je&&(je=this.n(fe,je));const Ue=(0,c.$ig)(je,fe),Ge=(0,g.$nc)(Ue);return Ge&&!(0,c.$eg)(Ge)?null:ee&&Fe?(Fe.path=Ue,this.o(Fe)):Ue}),Pe=w.$i||w.$j,De=(0,M.$Mb)($e,qe=>qe&&Pe?qe.toLowerCase():qe||"");return(0,M.$Hb)(De)}n(ye,ee){return w.$i&&(ee=(0,u.$5e)(ee,'"')),ee=(0,u.$3e)((0,u.$3e)(ee," "),"	"),w.$i&&(ee=(0,g.$kc)(ye,ee),ee=(0,u.$5e)(ee,".")),ee}o(ye){const ee=[ye.path];return typeof ye.line=="number"&&ee.push(String(ye.line)),typeof ye.column=="number"&&ee.push(String(ye.column)),ee.join(":")}}new Se().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/d73fa8b14a6c873958d00a7d7ad13fcb540a052c/core/vs/code/electron-main/main.js.map
