/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ie=["require","exports","vs/base/common/lifecycle","vs/base/common/types","vs/platform/log/common/log","vs/nls!vs/code/node/cliProcessMain","vs/base/common/event","vs/base/common/errors","vs/nls","vs/base/common/async","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/platform","vs/platform/files/common/files","vs/base/common/buffer","vs/base/common/network","vs/base/common/path","vs/base/common/resources","vs/platform/environment/common/environment","vs/base/common/arrays","vs/base/common/cancellation","vs/platform/extensionManagement/common/extensionManagement","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/node/pfs","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/objects","vs/base/common/uuid","vs/platform/configuration/common/configuration","vs/base/common/strings","vs/base/common/map","vs/platform/product/common/productService","os","vs/base/common/errorMessage","vs/base/common/process","vs/platform/registry/common/platform","vs/platform/extensions/common/extensions","vs/base/common/json","vs/platform/policy/common/policy","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/hash","vs/base/common/semver/semver","vs/platform/request/common/request","vs/base/common/stream","vs/base/common/marshalling","vs/base/common/ternarySearchTree","vs/base/node/zip","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/decorators","vs/base/common/severity","vs/base/common/processes","vs/base/node/processes","vs/base/parts/ipc/common/ipc","child_process","vs/platform/download/common/download","vs/platform/files/common/io","vs/platform/files/common/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/base/common/amd","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/numbers","vs/base/common/skipList","vs/base/node/macAddress","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/base/common/console","vs/amdX","vs/base/node/id","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/zip","fs","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/contextkey/common/contextkey","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/policy/common/filePolicyService","vs/platform/policy/node/nativePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/state","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetry","vs/platform/telemetry/node/telemetryUtils","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/storage/common/storage","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/platform/request/node/requestService","vs/base/common/lazy","path","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/linkedList","graceful-fs","vs/base/common/extpath","vs/platform/environment/node/argvHelper","crypto","https","vs/base/common/stopwatch","zlib","vs/code/node/cliProcessMain","vs/base/node/unc"],ne=function(J){for(var e=[],N=0,D=J.length;N<D;N++)e[N]=ie[J[N]];return e};define(ie[70],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class N{static get(){const R=new Map,L=new Map,A=new Map,P=new Map;function u(m,w){m.has(w.detail)||m.set(w.detail,-w.timestamp)}function a(m,w){const k=m.get(w.detail);k&&(k>=0||m.set(w.detail,k+w.timestamp))}let y=[];typeof J=="function"&&typeof J.getStats=="function"&&(y=J.getStats().slice(0).sort((m,w)=>m.timestamp-w.timestamp));for(const m of y)switch(m.type){case 10:u(R,m);break;case 11:case 12:a(R,m);break;case 21:u(L,m);break;case 22:a(L,m);break;case 33:u(A,m);break;case 34:a(A,m);break;case 31:u(P,m);break;case 32:a(P,m);break}let E=0;A.forEach(m=>E+=m);function d(m){const w=[];return m.forEach((k,b)=>w.push([b,k])),w}return{amdLoad:d(R),amdInvoke:d(L),nodeRequire:d(A),nodeEval:d(P),nodeRequireTotal:E}}static toMarkdownTable(R,L){let A="";const P=[];return R.forEach((u,a)=>{P[a]=u.length}),L.forEach(u=>{u.forEach((a,y)=>{typeof a>"u"&&(a=u[y]="-");const E=a.toString().length;P[y]=Math.max(E,P[y])})}),R.forEach((u,a)=>{A+=`| ${u+" ".repeat(P[a]-u.toString().length)} `}),A+=`|
`,R.forEach((u,a)=>{A+=`| ${"-".repeat(P[a])} `}),A+=`|
`,L.forEach(u=>{u.forEach((a,y)=>{typeof a<"u"&&(A+=`| ${a+" ".repeat(P[y]-a.toString().length)} `)}),A+=`|
`}),A}}e.$U=N}),define(ie[53],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mh=e.$Lh=e.$Kh=void 0;function N(A){return(P,u,a)=>{let y=null,E=null;if(typeof a.value=="function"?(y="value",E=a.value):typeof a.get=="function"&&(y="get",E=a.get),!E)throw new Error("not supported");a[y]=A(E,u)}}function D(A,P,u){let a=null,y=null;if(typeof u.value=="function"?(a="value",y=u.value,y.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof u.get=="function"&&(a="get",y=u.get),!y)throw new Error("not supported");const E=`$memoize$${P}`;u[a]=function(...d){return this.hasOwnProperty(E)||Object.defineProperty(this,E,{configurable:!1,enumerable:!1,writable:!1,value:y.apply(this,d)}),this[E]}}e.$Kh=D;function R(A,P,u){return N((a,y)=>{const E=`$debounce$${y}`,d=`$debounce$result$${y}`;return function(...m){this[d]||(this[d]=u?u():void 0),clearTimeout(this[E]),P&&(this[d]=P(this[d],...m),m=[this[d]]),this[E]=setTimeout(()=>{a.apply(this,m),this[d]=u?u():void 0},A)}})}e.$Lh=R;function L(A,P,u){return N((a,y)=>{const E=`$throttle$timer$${y}`,d=`$throttle$result$${y}`,m=`$throttle$lastRun$${y}`,w=`$throttle$pending$${y}`;return function(...k){if(this[d]||(this[d]=u?u():void 0),(this[m]===null||this[m]===void 0)&&(this[m]=-Number.MAX_VALUE),P&&(this[d]=P(this[d],...k)),this[w])return;const b=this[m]+A;b<=Date.now()?(this[m]=Date.now(),a.apply(this,[this[d]]),this[d]=u?u():void 0):(this[w]=!0,this[E]=setTimeout(()=>{this[w]=!1,this[m]=Date.now(),a.apply(this,[this[d]]),this[d]=u?u():void 0},b-Date.now()))}})}e.$Mh=L}),define(ie[71],ne([0,1,7]),function(J,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ad=e.$_c=e.$$c=e.$0c=e.$9c=e.ok=void 0;function D(a,y){if(!a)throw new Error(y?`Assertion failed (${y})`:"Assertion Failed")}e.ok=D;function R(a,y="Unreachable"){throw new Error(y)}e.$9c=R;function L(a){if(!a)throw new N.$cb("Assertion Failed")}e.$0c=L;function A(a){a||(0,N.$1)(new N.$cb("Soft Assertion Failed"))}e.$$c=A;function P(a){if(!a()){debugger;a(),(0,N.$1)(new N.$cb("Assertion Failed"))}}e.$_c=P;function u(a,y){let E=0;for(;E<a.length-1;){const d=a[E],m=a[E+1];if(!y(d,m))return!1;E++}return!0}e.$ad=u}),define(ie[38],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bn=e.$An=e.$zn=e.$yn=e.$xn=e.$wn=e.$vn=e.$un=e.$tn=e.$sn=e.$rn=e.$qn=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var N;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(N||(e.ScanError=N={}));var D;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(D||(e.SyntaxKind=D={}));var R;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(R||(e.ParseErrorCode=R={}));var L;(function(i){i.DEFAULT={allowTrailingComma:!0}})(L||(e.ParseOptions=L={}));function A(i,r=!1){let t=0;const n=i.length;let s="",o=0,l=16,O=0;function I(re){let ue=0,fe=0;for(;ue<re;){const ae=i.charCodeAt(t);if(ae>=48&&ae<=57)fe=fe*16+ae-48;else if(ae>=65&&ae<=70)fe=fe*16+ae-65+10;else if(ae>=97&&ae<=102)fe=fe*16+ae-97+10;else break;t++,ue++}return ue<re&&(fe=-1),fe}function v(re){t=re,s="",o=0,l=16,O=0}function j(){const re=t;if(i.charCodeAt(t)===48)t++;else for(t++;t<i.length&&a(i.charCodeAt(t));)t++;if(t<i.length&&i.charCodeAt(t)===46)if(t++,t<i.length&&a(i.charCodeAt(t)))for(t++;t<i.length&&a(i.charCodeAt(t));)t++;else return O=3,i.substring(re,t);let ue=t;if(t<i.length&&(i.charCodeAt(t)===69||i.charCodeAt(t)===101))if(t++,(t<i.length&&i.charCodeAt(t)===43||i.charCodeAt(t)===45)&&t++,t<i.length&&a(i.charCodeAt(t))){for(t++;t<i.length&&a(i.charCodeAt(t));)t++;ue=t}else O=3;return i.substring(re,ue)}function q(){let re="",ue=t;for(;;){if(t>=n){re+=i.substring(ue,t),O=2;break}const fe=i.charCodeAt(t);if(fe===34){re+=i.substring(ue,t),t++;break}if(fe===92){if(re+=i.substring(ue,t),t++,t>=n){O=2;break}switch(i.charCodeAt(t++)){case 34:re+='"';break;case 92:re+="\\";break;case 47:re+="/";break;case 98:re+="\b";break;case 102:re+="\f";break;case 110:re+=`
`;break;case 114:re+="\r";break;case 116:re+="	";break;case 117:{const B=I(4);B>=0?re+=String.fromCharCode(B):O=4;break}default:O=5}ue=t;continue}if(fe>=0&&fe<=31)if(u(fe)){re+=i.substring(ue,t),O=2;break}else O=6;t++}return re}function Y(){if(s="",O=0,o=t,t>=n)return o=n,l=17;let re=i.charCodeAt(t);if(P(re)){do t++,s+=String.fromCharCode(re),re=i.charCodeAt(t);while(P(re));return l=15}if(u(re))return t++,s+=String.fromCharCode(re),re===13&&i.charCodeAt(t)===10&&(t++,s+=`
`),l=14;switch(re){case 123:return t++,l=1;case 125:return t++,l=2;case 91:return t++,l=3;case 93:return t++,l=4;case 58:return t++,l=6;case 44:return t++,l=5;case 34:return t++,s=q(),l=10;case 47:{const ue=t-1;if(i.charCodeAt(t+1)===47){for(t+=2;t<n&&!u(i.charCodeAt(t));)t++;return s=i.substring(ue,t),l=12}if(i.charCodeAt(t+1)===42){t+=2;const fe=n-1;let ae=!1;for(;t<fe;){if(i.charCodeAt(t)===42&&i.charCodeAt(t+1)===47){t+=2,ae=!0;break}t++}return ae||(t++,O=1),s=i.substring(ue,t),l=13}return s+=String.fromCharCode(re),t++,l=16}case 45:if(s+=String.fromCharCode(re),t++,t===n||!a(i.charCodeAt(t)))return l=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=j(),l=11;default:for(;t<n&&Z(re);)t++,re=i.charCodeAt(t);if(o!==t){switch(s=i.substring(o,t),s){case"true":return l=8;case"false":return l=9;case"null":return l=7}return l=16}return s+=String.fromCharCode(re),t++,l=16}}function Z(re){if(P(re)||u(re))return!1;switch(re){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function oe(){let re;do re=Y();while(re>=12&&re<=15);return re}return{setPosition:v,getPosition:()=>t,scan:r?oe:Y,getToken:()=>l,getTokenValue:()=>s,getTokenOffset:()=>o,getTokenLength:()=>t-o,getTokenError:()=>O}}e.$qn=A;function P(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function u(i){return i===10||i===13||i===8232||i===8233}function a(i){return i>=48&&i<=57}var y;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(y||(y={}));function E(i,r){const t=[],n=new Object;let s;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let l=!1;function O(I,v,j,q){o.value=I,o.offset=v,o.length=j,o.type=q,o.colonOffset=void 0,s=o}try{$(i,{onObjectBegin:(I,v)=>{if(r<=I)throw n;s=void 0,l=r>I,t.push("")},onObjectProperty:(I,v,j)=>{if(r<v||(O(I,v,j,"property"),t[t.length-1]=I,r<=v+j))throw n},onObjectEnd:(I,v)=>{if(r<=I)throw n;s=void 0,t.pop()},onArrayBegin:(I,v)=>{if(r<=I)throw n;s=void 0,t.push(0)},onArrayEnd:(I,v)=>{if(r<=I)throw n;s=void 0,t.pop()},onLiteralValue:(I,v,j)=>{if(r<v||(O(I,v,j,g(I)),r<=v+j))throw n},onSeparator:(I,v,j)=>{if(r<=v)throw n;if(I===":"&&s&&s.type==="property")s.colonOffset=v,l=!1,s=void 0;else if(I===","){const q=t[t.length-1];typeof q=="number"?t[t.length-1]=q+1:(l=!0,t[t.length-1]=""),s=void 0}}})}catch(I){if(I!==n)throw I}return{path:t,previousNode:s,isAtPropertyKey:l,matches:I=>{let v=0;for(let j=0;v<I.length&&j<t.length;j++)if(I[v]===t[j]||I[v]==="*")v++;else if(I[v]!=="**")return!1;return v===I.length}}}e.$rn=E;function d(i,r=[],t=L.DEFAULT){let n=null,s=[];const o=[];function l(I){Array.isArray(s)?s.push(I):n!==null&&(s[n]=I)}return $(i,{onObjectBegin:()=>{const I={};l(I),o.push(s),s=I,n=null},onObjectProperty:I=>{n=I},onObjectEnd:()=>{s=o.pop()},onArrayBegin:()=>{const I=[];l(I),o.push(s),s=I,n=null},onArrayEnd:()=>{s=o.pop()},onLiteralValue:l,onError:(I,v,j)=>{r.push({error:I,offset:v,length:j})}},t),s[0]}e.$sn=d;function m(i,r=[],t=L.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(I){n.type==="property"&&(n.length=I-n.offset,n=n.parent)}function o(I){return n.children.push(I),I}$(i,{onObjectBegin:I=>{n=o({type:"object",offset:I,length:-1,parent:n,children:[]})},onObjectProperty:(I,v,j)=>{n=o({type:"property",offset:v,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:I,offset:v,length:j,parent:n})},onObjectEnd:(I,v)=>{n.length=I+v-n.offset,n=n.parent,s(I+v)},onArrayBegin:(I,v)=>{n=o({type:"array",offset:I,length:-1,parent:n,children:[]})},onArrayEnd:(I,v)=>{n.length=I+v-n.offset,n=n.parent,s(I+v)},onLiteralValue:(I,v,j)=>{o({type:g(I),offset:v,length:j,parent:n,value:I}),s(v+j)},onSeparator:(I,v,j)=>{n.type==="property"&&(I===":"?n.colonOffset=v:I===","&&s(v))},onError:(I,v,j)=>{r.push({error:I,offset:v,length:j})}},t);const O=n.children[0];return O&&delete O.parent,O}e.$tn=m;function w(i,r){if(!i)return;let t=i;for(const n of r)if(typeof n=="string"){if(t.type!=="object"||!Array.isArray(t.children))return;let s=!1;for(const o of t.children)if(Array.isArray(o.children)&&o.children[0].value===n){t=o.children[1],s=!0;break}if(!s)return}else{const s=n;if(t.type!=="array"||s<0||!Array.isArray(t.children)||s>=t.children.length)return;t=t.children[s]}return t}e.$un=w;function k(i){if(!i.parent||!i.parent.children)return[];const r=k(i.parent);if(i.parent.type==="property"){const t=i.parent.children[0].value;r.push(t)}else if(i.parent.type==="array"){const t=i.parent.children.indexOf(i);t!==-1&&r.push(t)}return r}e.$vn=k;function b(i){switch(i.type){case"array":return i.children.map(b);case"object":{const r=Object.create(null);for(const t of i.children){const n=t.children[1];n&&(r[t.children[0].value]=b(n))}return r}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.$wn=b;function c(i,r,t=!1){return r>=i.offset&&r<i.offset+i.length||t&&r===i.offset+i.length}e.$xn=c;function p(i,r,t=!1){if(c(i,r,t)){const n=i.children;if(Array.isArray(n))for(let s=0;s<n.length&&n[s].offset<=r;s++){const o=p(n[s],r,t);if(o)return o}return i}}e.$yn=p;function $(i,r,t=L.DEFAULT){const n=A(i,!1);function s(Q){return Q?()=>Q(n.getTokenOffset(),n.getTokenLength()):()=>!0}function o(Q){return Q?ee=>Q(ee,n.getTokenOffset(),n.getTokenLength()):()=>!0}const l=s(r.onObjectBegin),O=o(r.onObjectProperty),I=s(r.onObjectEnd),v=s(r.onArrayBegin),j=s(r.onArrayEnd),q=o(r.onLiteralValue),Y=o(r.onSeparator),Z=s(r.onComment),oe=o(r.onError),re=t&&t.disallowComments,ue=t&&t.allowTrailingComma;function fe(){for(;;){const Q=n.scan();switch(n.getTokenError()){case 4:ae(14);break;case 5:ae(15);break;case 3:ae(13);break;case 1:re||ae(11);break;case 2:ae(12);break;case 6:ae(16);break}switch(Q){case 12:case 13:re?ae(10):Z();break;case 16:ae(1);break;case 15:case 14:break;default:return Q}}}function ae(Q,ee=[],C=[]){if(oe(Q),ee.length+C.length>0){let z=n.getToken();for(;z!==17;){if(ee.indexOf(z)!==-1){fe();break}else if(C.indexOf(z)!==-1)break;z=fe()}}}function B(Q){const ee=n.getTokenValue();return Q?q(ee):O(ee),fe(),!0}function X(){switch(n.getToken()){case 11:{let Q=0;try{Q=JSON.parse(n.getTokenValue()),typeof Q!="number"&&(ae(2),Q=0)}catch{ae(2)}q(Q);break}case 7:q(null);break;case 8:q(!0);break;case 9:q(!1);break;default:return!1}return fe(),!0}function U(){return n.getToken()!==10?(ae(3,[],[2,5]),!1):(B(!1),n.getToken()===6?(Y(":"),fe(),K()||ae(4,[],[2,5])):ae(5,[],[2,5]),!0)}function M(){l(),fe();let Q=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(Q||ae(4,[],[]),Y(","),fe(),n.getToken()===2&&ue)break}else Q&&ae(6,[],[]);U()||ae(4,[],[2,5]),Q=!0}return I(),n.getToken()!==2?ae(7,[2],[]):fe(),!0}function H(){v(),fe();let Q=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(Q||ae(4,[],[]),Y(","),fe(),n.getToken()===4&&ue)break}else Q&&ae(6,[],[]);K()||ae(4,[],[4,5]),Q=!0}return j(),n.getToken()!==4?ae(8,[4],[]):fe(),!0}function K(){switch(n.getToken()){case 3:return H();case 1:return M();case 10:return B(!0);default:return X()}}return fe(),n.getToken()===17?t.allowEmptyContent?!0:(ae(4,[],[]),!1):K()?(n.getToken()!==17&&ae(9,[],[]),!0):(ae(4,[],[]),!1)}e.$zn=$;function h(i,r){const t=A(i),n=[];let s,o=0,l;do switch(l=t.getPosition(),s=t.scan(),s){case 12:case 13:case 17:o!==l&&n.push(i.substring(o,l)),r!==void 0&&n.push(t.getTokenValue().replace(/[^\r\n]/g,r)),o=t.getPosition();break}while(s!==17);return n.join("")}e.$An=h;function g(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.$Bn=g}),define(ie[72],ne([0,1,38]),function(J,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fn=e.$En=e.$Dn=e.$Cn=void 0;function D(a,y,E){let d,m,w,k,b;if(y){for(k=y.offset,b=k+y.length,w=k;w>0&&!u(a,w-1);)w--;let l=b;for(;l<a.length&&!u(a,l);)l++;m=a.substring(w,l),d=A(m,E)}else m=a,d=0,w=0,k=0,b=a.length;const c=P(E,a);let p=!1,$=0,h;E.insertSpaces?h=L(" ",E.tabSize||4):h="	";const g=(0,N.$qn)(m,!1);let i=!1;function r(){return c+L(h,d+$)}function t(){let l=g.scan();for(p=!1;l===15||l===14;)p=p||l===14,l=g.scan();return i=l===16||g.getTokenError()!==0,l}const n=[];function s(l,O,I){!i&&O<b&&I>k&&a.substring(O,I)!==l&&n.push({offset:O,length:I-O,content:l})}let o=t();if(o!==17){const l=g.getTokenOffset()+w,O=L(h,d);s(O,w,l)}for(;o!==17;){let l=g.getTokenOffset()+g.getTokenLength()+w,O=t(),I="";for(;!p&&(O===12||O===13);){const j=g.getTokenOffset()+w;s(" ",l,j),l=g.getTokenOffset()+g.getTokenLength()+w,I=O===12?r():"",O=t()}if(O===2)o!==1&&($--,I=r());else if(O===4)o!==3&&($--,I=r());else{switch(o){case 3:case 1:$++,I=r();break;case 5:case 12:I=r();break;case 13:p?I=r():I=" ";break;case 6:I=" ";break;case 10:if(O===6){I="";break}case 7:case 8:case 9:case 11:case 2:case 4:O===12||O===13?I=" ":O!==5&&O!==17&&(i=!0);break;case 16:i=!0;break}p&&(O===12||O===13)&&(I=r())}const v=g.getTokenOffset()+w;s(I,l,v),o=O}return n}e.$Cn=D;function R(a,y){const E=JSON.stringify(a,void 0,y.insertSpaces?y.tabSize||4:"	");return y.eol!==void 0?E.replace(/\r\n|\r|\n/g,y.eol):E}e.$Dn=R;function L(a,y){let E="";for(let d=0;d<y;d++)E+=a;return E}function A(a,y){let E=0,d=0;const m=y.tabSize||4;for(;E<a.length;){const w=a.charAt(E);if(w===" ")d++;else if(w==="	")d+=m;else break;E++}return Math.floor(d/m)}function P(a,y){for(let E=0;E<y.length;E++){const d=y.charAt(E);if(d==="\r")return E+1<y.length&&y.charAt(E+1)===`
`?`\r
`:"\r";if(d===`
`)return`
`}return a&&a.eol||`
`}e.$En=P;function u(a,y){return`\r
`.indexOf(a.charAt(y))!==-1}e.$Fn=u}),define(ie[73],ne([0,1,38,72]),function(J,e,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kn=e.$Jn=e.$In=e.$Hn=e.$Gn=void 0;function R(a,y,E){return L(a,y,void 0,E)}e.$Gn=R;function L(a,y,E,d,m){const w=y.slice(),k=[],b=(0,N.$tn)(a,k);let c,p;for(;w.length>0&&(p=w.pop(),c=(0,N.$un)(b,w),c===void 0&&E!==void 0);)typeof p=="string"?E={[p]:E}:E=[E];if(c)if(c.type==="object"&&typeof p=="string"&&Array.isArray(c.children)){const $=(0,N.$un)(c,[p]);if($!==void 0)if(E===void 0){if(!$.parent)throw new Error("Malformed AST");const h=c.children.indexOf($.parent);let g,i=$.parent.offset+$.parent.length;if(h>0){const r=c.children[h-1];g=r.offset+r.length}else g=c.offset+1,c.children.length>1&&(i=c.children[1].offset);return A(a,{offset:g,length:i-g,content:""},d)}else return A(a,{offset:$.offset,length:$.length,content:JSON.stringify(E)},d);else{if(E===void 0)return[];const h=`${JSON.stringify(p)}: ${JSON.stringify(E)}`,g=m?m(c.children.map(r=>r.children[0].value)):c.children.length;let i;if(g>0){const r=c.children[g-1];i={offset:r.offset+r.length,length:0,content:","+h}}else c.children.length===0?i={offset:c.offset+1,length:0,content:h}:i={offset:c.offset+1,length:0,content:h+","};return A(a,i,d)}}else if(c.type==="array"&&typeof p=="number"&&Array.isArray(c.children))if(E!==void 0){const $=`${JSON.stringify(E)}`;let h;if(c.children.length===0||p===0)h={offset:c.offset+1,length:0,content:c.children.length===0?$:$+","};else{const g=p===-1||p>c.children.length?c.children.length:p,i=c.children[g-1];h={offset:i.offset+i.length,length:0,content:","+$}}return A(a,h,d)}else{const $=p,h=c.children[$];let g;if(c.children.length===1)g={offset:c.offset+1,length:c.length-2,content:""};else if(c.children.length-1===$){const i=c.children[$-1],r=i.offset+i.length,t=c.offset+c.length;g={offset:r,length:t-2-r,content:""}}else g={offset:h.offset,length:c.children[$+1].offset-h.offset,content:""};return A(a,g,d)}else throw new Error(`Can not add ${typeof p!="number"?"index":"property"} to parent of type ${c.type}`);else{if(E===void 0)throw new Error("Can not delete in empty document");return A(a,{offset:b?b.offset:0,length:b?b.length:0,content:JSON.stringify(E)},d)}}e.$Hn=L;function A(a,y,E){let d=P(a,y),m=y.offset,w=y.offset+y.content.length;if(y.length===0||y.content.length===0){for(;m>0&&!(0,D.$Fn)(d,m-1);)m--;for(;w<d.length&&!(0,D.$Fn)(d,w);)w++}const k=(0,D.$Cn)(d,{offset:m,length:w-m},E);for(let c=k.length-1;c>=0;c--){const p=k[c];d=P(d,p),m=Math.min(m,p.offset),w=Math.max(w,p.offset+p.length),w+=p.content.length-p.length}const b=a.length-(d.length-w)-m;return[{offset:m,length:b,content:d.substring(m,w)}]}e.$In=A;function P(a,y){return a.substring(0,y.offset)+y.content+a.substring(y.offset+y.length)}e.$Jn=P;function u(a,y){const E=y.slice(0).sort((m,w)=>{const k=m.offset-w.offset;return k===0?m.length-w.length:k});let d=a.length;for(let m=E.length-1;m>=0;m--){const w=E[m];if(w.offset+w.length<=d)a=P(a,w);else throw new Error("Overlapping edit");d=w.offset}return a}e.$Kn=u}),define(ie[74],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jm=e.$im=e.$hm=e.rot=e.$fm=void 0;function N(P,u,a){return Math.min(Math.max(P,u),a)}e.$fm=N;function D(P,u){return(u+P%u)%u}e.rot=D;class R{constructor(){this.a=0}getNext(){return this.a++}}e.$hm=R;class L{constructor(){this.a=1,this.b=0}update(u){return this.b=this.b+(u-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$im=L;class A{constructor(u){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(u),this.c.fill(0,0,u)}update(u){const a=this.c[this.d];return this.c[this.d]=u,this.d=(this.d+1)%this.c.length,this.e-=a,this.e+=u,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$jm=A}),function(){function J(R){const L=[];typeof R=="number"&&L.push("code/timeOrigin",R);function A(u){L.push(u,Date.now())}function P(){const u=[];for(let a=0;a<L.length;a+=2)u.push({name:L[a],startTime:L[a+1]});return u}return{mark:A,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?J():{mark(R){performance.mark(R)},getMarks(){let R=performance.timeOrigin;typeof R!="number"&&(R=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(R)}];for(const A of performance.getEntriesByType("mark"))L.push({name:A.name,startTime:Math.round(R+A.startTime)});return L}};if(typeof process=="object"){const R=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return J(R)}else return console.trace("perf-util loaded in UNKNOWN environment"),J()}function N(R){return R.MonacoPerformanceMarks||(R.MonacoPerformanceMarks=e()),R.MonacoPerformanceMarks}var D;typeof global=="object"?D=global:typeof self=="object"?D=self:D={},typeof define=="function"?define("vs/base/common/performance",[],function(){return N(D)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=N(D):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),D.perf=N(D))}(),function(J,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var N=e();for(var D in N)(typeof exports=="object"?exports:J)[D]=N[D]}}(typeof self<"u"?self:this,function(){return function(J){var e={};function N(D){if(e[D])return e[D].exports;var R=e[D]={i:D,l:!1,exports:{}};return J[D].call(R.exports,R,R.exports,N),R.l=!0,R.exports}return N.m=J,N.c=e,N.d=function(D,R,L){N.o(D,R)||Object.defineProperty(D,R,{enumerable:!0,get:L})},N.r=function(D){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(D,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(D,"__esModule",{value:!0})},N.t=function(D,R){if(1&R&&(D=N(D)),8&R||4&R&&typeof D=="object"&&D&&D.__esModule)return D;var L=Object.create(null);if(N.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:D}),2&R&&typeof D!="string")for(var A in D)N.d(L,A,function(P){return D[P]}.bind(null,A));return L},N.n=function(D){var R=D&&D.__esModule?function(){return D.default}:function(){return D};return N.d(R,"a",R),R},N.o=function(D,R){return Object.prototype.hasOwnProperty.call(D,R)},N.p="",N(N.s=0)}([function(J,e,N){(function(D){var R;e=J.exports=C,R=typeof D=="object"&&D.env&&D.env.NODE_DEBUG&&/\bsemver\b/i.test(D.env.NODE_DEBUG)?function(){var V=Array.prototype.slice.call(arguments,0);V.unshift("SEMVER"),console.log.apply(console,V)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var L=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],u=e.src=[],a=0,y=a++;u[y]="0|[1-9]\\d*";var E=a++;u[E]="[0-9]+";var d=a++;u[d]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var m=a++;u[m]="("+u[y]+")\\.("+u[y]+")\\.("+u[y]+")";var w=a++;u[w]="("+u[E]+")\\.("+u[E]+")\\.("+u[E]+")";var k=a++;u[k]="(?:"+u[y]+"|"+u[d]+")";var b=a++;u[b]="(?:"+u[E]+"|"+u[d]+")";var c=a++;u[c]="(?:-("+u[k]+"(?:\\."+u[k]+")*))";var p=a++;u[p]="(?:-?("+u[b]+"(?:\\."+u[b]+")*))";var $=a++;u[$]="[0-9A-Za-z-]+";var h=a++;u[h]="(?:\\+("+u[$]+"(?:\\."+u[$]+")*))";var g=a++,i="v?"+u[m]+u[c]+"?"+u[h]+"?";u[g]="^"+i+"$";var r="[v=\\s]*"+u[w]+u[p]+"?"+u[h]+"?",t=a++;u[t]="^"+r+"$";var n=a++;u[n]="((?:<|>)?=?)";var s=a++;u[s]=u[E]+"|x|X|\\*";var o=a++;u[o]=u[y]+"|x|X|\\*";var l=a++;u[l]="[v=\\s]*("+u[o]+")(?:\\.("+u[o]+")(?:\\.("+u[o]+")(?:"+u[c]+")?"+u[h]+"?)?)?";var O=a++;u[O]="[v=\\s]*("+u[s]+")(?:\\.("+u[s]+")(?:\\.("+u[s]+")(?:"+u[p]+")?"+u[h]+"?)?)?";var I=a++;u[I]="^"+u[n]+"\\s*"+u[l]+"$";var v=a++;u[v]="^"+u[n]+"\\s*"+u[O]+"$";var j=a++;u[j]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var q=a++;u[q]="(?:~>?)";var Y=a++;u[Y]="(\\s*)"+u[q]+"\\s+",P[Y]=new RegExp(u[Y],"g");var Z=a++;u[Z]="^"+u[q]+u[l]+"$";var oe=a++;u[oe]="^"+u[q]+u[O]+"$";var re=a++;u[re]="(?:\\^)";var ue=a++;u[ue]="(\\s*)"+u[re]+"\\s+",P[ue]=new RegExp(u[ue],"g");var fe=a++;u[fe]="^"+u[re]+u[l]+"$";var ae=a++;u[ae]="^"+u[re]+u[O]+"$";var B=a++;u[B]="^"+u[n]+"\\s*("+r+")$|^$";var X=a++;u[X]="^"+u[n]+"\\s*("+i+")$|^$";var U=a++;u[U]="(\\s*)"+u[n]+"\\s*("+r+"|"+u[l]+")",P[U]=new RegExp(u[U],"g");var M=a++;u[M]="^\\s*("+u[l]+")\\s+-\\s+("+u[l]+")\\s*$";var H=a++;u[H]="^\\s*("+u[O]+")\\s+-\\s+("+u[O]+")\\s*$";var K=a++;u[K]="(<|>)?=?\\s*\\*";for(var Q=0;Q<35;Q++)R(Q,u[Q]),P[Q]||(P[Q]=new RegExp(u[Q]));function ee(V,x){if(V instanceof C)return V;if(typeof V!="string"||V.length>L||!(x?P[t]:P[g]).test(V))return null;try{return new C(V,x)}catch{return null}}function C(V,x){if(V instanceof C){if(V.loose===x)return V;V=V.version}else if(typeof V!="string")throw new TypeError("Invalid Version: "+V);if(V.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof C))return new C(V,x);R("SemVer",V,x),this.loose=x;var _=V.trim().match(x?P[t]:P[g]);if(!_)throw new TypeError("Invalid Version: "+V);if(this.raw=V,this.major=+_[1],this.minor=+_[2],this.patch=+_[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");_[4]?this.prerelease=_[4].split(".").map(function(ge){if(/^[0-9]+$/.test(ge)){var ve=+ge;if(ve>=0&&ve<A)return ve}return ge}):this.prerelease=[],this.build=_[5]?_[5].split("."):[],this.format()}e.parse=ee,e.valid=function(V,x){var _=ee(V,x);return _?_.version:null},e.clean=function(V,x){var _=ee(V.trim().replace(/^[=v]+/,""),x);return _?_.version:null},e.SemVer=C,C.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},C.prototype.toString=function(){return this.version},C.prototype.compare=function(V){return R("SemVer.compare",this.version,this.loose,V),V instanceof C||(V=new C(V,this.loose)),this.compareMain(V)||this.comparePre(V)},C.prototype.compareMain=function(V){return V instanceof C||(V=new C(V,this.loose)),f(this.major,V.major)||f(this.minor,V.minor)||f(this.patch,V.patch)},C.prototype.comparePre=function(V){if(V instanceof C||(V=new C(V,this.loose)),this.prerelease.length&&!V.prerelease.length)return-1;if(!this.prerelease.length&&V.prerelease.length)return 1;if(!this.prerelease.length&&!V.prerelease.length)return 0;var x=0;do{var _=this.prerelease[x],ge=V.prerelease[x];if(R("prerelease compare",x,_,ge),_===void 0&&ge===void 0)return 0;if(ge===void 0)return 1;if(_===void 0)return-1;if(_!==ge)return f(_,ge)}while(++x)},C.prototype.inc=function(V,x){switch(V){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",x);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",x);break;case"prepatch":this.prerelease.length=0,this.inc("patch",x),this.inc("pre",x);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",x),this.inc("pre",x);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var _=this.prerelease.length;--_>=0;)typeof this.prerelease[_]=="number"&&(this.prerelease[_]++,_=-2);_===-1&&this.prerelease.push(0)}x&&(this.prerelease[0]===x?isNaN(this.prerelease[1])&&(this.prerelease=[x,0]):this.prerelease=[x,0]);break;default:throw new Error("invalid increment argument: "+V)}return this.format(),this.raw=this.version,this},e.inc=function(V,x,_,ge){typeof _=="string"&&(ge=_,_=void 0);try{return new C(V,_).inc(x,ge).version}catch{return null}},e.diff=function(V,x){if(W(V,x))return null;var _=ee(V),ge=ee(x);if(_.prerelease.length||ge.prerelease.length){for(var ve in _)if((ve==="major"||ve==="minor"||ve==="patch")&&_[ve]!==ge[ve])return"pre"+ve;return"prerelease"}for(var ve in _)if((ve==="major"||ve==="minor"||ve==="patch")&&_[ve]!==ge[ve])return ve},e.compareIdentifiers=f;var z=/^[0-9]+$/;function f(V,x){var _=z.test(V),ge=z.test(x);return _&&ge&&(V=+V,x=+x),_&&!ge?-1:ge&&!_?1:V<x?-1:V>x?1:0}function S(V,x,_){return new C(V,_).compare(new C(x,_))}function T(V,x,_){return S(V,x,_)>0}function F(V,x,_){return S(V,x,_)<0}function W(V,x,_){return S(V,x,_)===0}function G(V,x,_){return S(V,x,_)!==0}function te(V,x,_){return S(V,x,_)>=0}function ce(V,x,_){return S(V,x,_)<=0}function le(V,x,_,ge){var ve;switch(x){case"===":typeof V=="object"&&(V=V.version),typeof _=="object"&&(_=_.version),ve=V===_;break;case"!==":typeof V=="object"&&(V=V.version),typeof _=="object"&&(_=_.version),ve=V!==_;break;case"":case"=":case"==":ve=W(V,_,ge);break;case"!=":ve=G(V,_,ge);break;case">":ve=T(V,_,ge);break;case">=":ve=te(V,_,ge);break;case"<":ve=F(V,_,ge);break;case"<=":ve=ce(V,_,ge);break;default:throw new TypeError("Invalid operator: "+x)}return ve}function $e(V,x){if(V instanceof $e){if(V.loose===x)return V;V=V.value}if(!(this instanceof $e))return new $e(V,x);R("comparator",V,x),this.loose=x,this.parse(V),this.semver===ye?this.value="":this.value=this.operator+this.semver.version,R("comp",this)}e.rcompareIdentifiers=function(V,x){return f(x,V)},e.major=function(V,x){return new C(V,x).major},e.minor=function(V,x){return new C(V,x).minor},e.patch=function(V,x){return new C(V,x).patch},e.compare=S,e.compareLoose=function(V,x){return S(V,x,!0)},e.rcompare=function(V,x,_){return S(x,V,_)},e.sort=function(V,x){return V.sort(function(_,ge){return e.compare(_,ge,x)})},e.rsort=function(V,x){return V.sort(function(_,ge){return e.rcompare(_,ge,x)})},e.gt=T,e.lt=F,e.eq=W,e.neq=G,e.gte=te,e.lte=ce,e.cmp=le,e.Comparator=$e;var ye={};function he(V,x){if(V instanceof he)return V.loose===x?V:new he(V.raw,x);if(V instanceof $e)return new he(V.value,x);if(!(this instanceof he))return new he(V,x);if(this.loose=x,this.raw=V,this.set=V.split(/\s*\|\|\s*/).map(function(_){return this.parseRange(_.trim())},this).filter(function(_){return _.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+V);this.format()}function me(V){return!V||V.toLowerCase()==="x"||V==="*"}function de(V,x,_,ge,ve,De,Se,Le,Oe,Ae,Fe,je,Ne){return((x=me(_)?"":me(ge)?">="+_+".0.0":me(ve)?">="+_+"."+ge+".0":">="+x)+" "+(Le=me(Oe)?"":me(Ae)?"<"+(+Oe+1)+".0.0":me(Fe)?"<"+Oe+"."+(+Ae+1)+".0":je?"<="+Oe+"."+Ae+"."+Fe+"-"+je:"<="+Le)).trim()}function we(V,x){for(var _=0;_<V.length;_++)if(!V[_].test(x))return!1;if(x.prerelease.length){for(_=0;_<V.length;_++)if(R(V[_].semver),V[_].semver!==ye&&V[_].semver.prerelease.length>0){var ge=V[_].semver;if(ge.major===x.major&&ge.minor===x.minor&&ge.patch===x.patch)return!0}return!1}return!0}function Ee(V,x,_){try{x=new he(x,_)}catch{return!1}return x.test(V)}function ke(V,x,_,ge){var ve,De,Se,Le,Oe;switch(V=new C(V,ge),x=new he(x,ge),_){case">":ve=T,De=ce,Se=F,Le=">",Oe=">=";break;case"<":ve=F,De=te,Se=T,Le="<",Oe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ee(V,x,ge))return!1;for(var Ae=0;Ae<x.set.length;++Ae){var Fe=x.set[Ae],je=null,Ne=null;if(Fe.forEach(function(Te){Te.semver===ye&&(Te=new $e(">=0.0.0")),je=je||Te,Ne=Ne||Te,ve(Te.semver,je.semver,ge)?je=Te:Se(Te.semver,Ne.semver,ge)&&(Ne=Te)}),je.operator===Le||je.operator===Oe||(!Ne.operator||Ne.operator===Le)&&De(V,Ne.semver)||Ne.operator===Oe&&Se(V,Ne.semver))return!1}return!0}$e.prototype.parse=function(V){var x=this.loose?P[B]:P[X],_=V.match(x);if(!_)throw new TypeError("Invalid comparator: "+V);this.operator=_[1],this.operator==="="&&(this.operator=""),_[2]?this.semver=new C(_[2],this.loose):this.semver=ye},$e.prototype.toString=function(){return this.value},$e.prototype.test=function(V){return R("Comparator.test",V,this.loose),this.semver===ye||(typeof V=="string"&&(V=new C(V,this.loose)),le(V,this.operator,this.semver,this.loose))},$e.prototype.intersects=function(V,x){if(!(V instanceof $e))throw new TypeError("a Comparator is required");var _;if(this.operator==="")return _=new he(V.value,x),Ee(this.value,_,x);if(V.operator==="")return _=new he(this.value,x),Ee(V.semver,_,x);var ge=!(this.operator!==">="&&this.operator!==">"||V.operator!==">="&&V.operator!==">"),ve=!(this.operator!=="<="&&this.operator!=="<"||V.operator!=="<="&&V.operator!=="<"),De=this.semver.version===V.semver.version,Se=!(this.operator!==">="&&this.operator!=="<="||V.operator!==">="&&V.operator!=="<="),Le=le(this.semver,"<",V.semver,x)&&(this.operator===">="||this.operator===">")&&(V.operator==="<="||V.operator==="<"),Oe=le(this.semver,">",V.semver,x)&&(this.operator==="<="||this.operator==="<")&&(V.operator===">="||V.operator===">");return ge||ve||De&&Se||Le||Oe},e.Range=he,he.prototype.format=function(){return this.range=this.set.map(function(V){return V.join(" ").trim()}).join("||").trim(),this.range},he.prototype.toString=function(){return this.range},he.prototype.parseRange=function(V){var x=this.loose;V=V.trim(),R("range",V,x);var _=x?P[H]:P[M];V=V.replace(_,de),R("hyphen replace",V),V=V.replace(P[U],"$1$2$3"),R("comparator trim",V,P[U]),V=(V=(V=V.replace(P[Y],"$1~")).replace(P[ue],"$1^")).split(/\s+/).join(" ");var ge=x?P[B]:P[X],ve=V.split(" ").map(function(De){return function(Se,Le){return R("comp",Se),Se=function(Oe,Ae){return Oe.trim().split(/\s+/).map(function(Fe){return function(je,Ne){R("caret",je,Ne);var Te=Ne?P[ae]:P[fe];return je.replace(Te,function(Ce,be,Pe,Ie,Re){var ze;return R("caret",je,Ce,be,Pe,Ie,Re),me(be)?ze="":me(Pe)?ze=">="+be+".0.0 <"+(+be+1)+".0.0":me(Ie)?ze=be==="0"?">="+be+"."+Pe+".0 <"+be+"."+(+Pe+1)+".0":">="+be+"."+Pe+".0 <"+(+be+1)+".0.0":Re?(R("replaceCaret pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),ze=be==="0"?Pe==="0"?">="+be+"."+Pe+"."+Ie+Re+" <"+be+"."+Pe+"."+(+Ie+1):">="+be+"."+Pe+"."+Ie+Re+" <"+be+"."+(+Pe+1)+".0":">="+be+"."+Pe+"."+Ie+Re+" <"+(+be+1)+".0.0"):(R("no pr"),ze=be==="0"?Pe==="0"?">="+be+"."+Pe+"."+Ie+" <"+be+"."+Pe+"."+(+Ie+1):">="+be+"."+Pe+"."+Ie+" <"+be+"."+(+Pe+1)+".0":">="+be+"."+Pe+"."+Ie+" <"+(+be+1)+".0.0"),R("caret return",ze),ze})}(Fe,Ae)}).join(" ")}(Se,Le),R("caret",Se),Se=function(Oe,Ae){return Oe.trim().split(/\s+/).map(function(Fe){return function(je,Ne){var Te=Ne?P[oe]:P[Z];return je.replace(Te,function(Ce,be,Pe,Ie,Re){var ze;return R("tilde",je,Ce,be,Pe,Ie,Re),me(be)?ze="":me(Pe)?ze=">="+be+".0.0 <"+(+be+1)+".0.0":me(Ie)?ze=">="+be+"."+Pe+".0 <"+be+"."+(+Pe+1)+".0":Re?(R("replaceTilde pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),ze=">="+be+"."+Pe+"."+Ie+Re+" <"+be+"."+(+Pe+1)+".0"):ze=">="+be+"."+Pe+"."+Ie+" <"+be+"."+(+Pe+1)+".0",R("tilde return",ze),ze})}(Fe,Ae)}).join(" ")}(Se,Le),R("tildes",Se),Se=function(Oe,Ae){return R("replaceXRanges",Oe,Ae),Oe.split(/\s+/).map(function(Fe){return function(je,Ne){je=je.trim();var Te=Ne?P[v]:P[I];return je.replace(Te,function(Ce,be,Pe,Ie,Re,ze){R("xRange",je,Ce,be,Pe,Ie,Re,ze);var qe=me(Pe),Me=qe||me(Ie),Ue=Me||me(Re);return be==="="&&Ue&&(be=""),qe?Ce=be===">"||be==="<"?"<0.0.0":"*":be&&Ue?(Me&&(Ie=0),Ue&&(Re=0),be===">"?(be=">=",Me?(Pe=+Pe+1,Ie=0,Re=0):Ue&&(Ie=+Ie+1,Re=0)):be==="<="&&(be="<",Me?Pe=+Pe+1:Ie=+Ie+1),Ce=be+Pe+"."+Ie+"."+Re):Me?Ce=">="+Pe+".0.0 <"+(+Pe+1)+".0.0":Ue&&(Ce=">="+Pe+"."+Ie+".0 <"+Pe+"."+(+Ie+1)+".0"),R("xRange return",Ce),Ce})}(Fe,Ae)}).join(" ")}(Se,Le),R("xrange",Se),Se=function(Oe,Ae){return R("replaceStars",Oe,Ae),Oe.trim().replace(P[K],"")}(Se,Le),R("stars",Se),Se}(De,x)}).join(" ").split(/\s+/);return this.loose&&(ve=ve.filter(function(De){return!!De.match(ge)})),ve=ve.map(function(De){return new $e(De,x)})},he.prototype.intersects=function(V,x){if(!(V instanceof he))throw new TypeError("a Range is required");return this.set.some(function(_){return _.every(function(ge){return V.set.some(function(ve){return ve.every(function(De){return ge.intersects(De,x)})})})})},e.toComparators=function(V,x){return new he(V,x).set.map(function(_){return _.map(function(ge){return ge.value}).join(" ").trim().split(" ")})},he.prototype.test=function(V){if(!V)return!1;typeof V=="string"&&(V=new C(V,this.loose));for(var x=0;x<this.set.length;x++)if(we(this.set[x],V))return!0;return!1},e.satisfies=Ee,e.maxSatisfying=function(V,x,_){var ge=null,ve=null;try{var De=new he(x,_)}catch{return null}return V.forEach(function(Se){De.test(Se)&&(ge&&ve.compare(Se)!==-1||(ve=new C(ge=Se,_)))}),ge},e.minSatisfying=function(V,x,_){var ge=null,ve=null;try{var De=new he(x,_)}catch{return null}return V.forEach(function(Se){De.test(Se)&&(ge&&ve.compare(Se)!==1||(ve=new C(ge=Se,_)))}),ge},e.validRange=function(V,x){try{return new he(V,x).range||"*"}catch{return null}},e.ltr=function(V,x,_){return ke(V,x,"<",_)},e.gtr=function(V,x,_){return ke(V,x,">",_)},e.outside=ke,e.prerelease=function(V,x){var _=ee(V,x);return _&&_.prerelease.length?_.prerelease:null},e.intersects=function(V,x,_){return V=new he(V,_),x=new he(x,_),V.intersects(x)},e.coerce=function(V){if(V instanceof C)return V;if(typeof V!="string")return null;var x=V.match(P[j]);return x==null?null:ee((x[1]||"0")+"."+(x[2]||"0")+"."+(x[3]||"0"))}}).call(this,N(1))},function(J,e){var N,D,R=J.exports={};function L(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function P(b){if(N===setTimeout)return setTimeout(b,0);if((N===L||!N)&&setTimeout)return N=setTimeout,setTimeout(b,0);try{return N(b,0)}catch{try{return N.call(null,b,0)}catch{return N.call(this,b,0)}}}(function(){try{N=typeof setTimeout=="function"?setTimeout:L}catch{N=L}try{D=typeof clearTimeout=="function"?clearTimeout:A}catch{D=A}})();var u,a=[],y=!1,E=-1;function d(){y&&u&&(y=!1,u.length?a=u.concat(a):E=-1,a.length&&m())}function m(){if(!y){var b=P(d);y=!0;for(var c=a.length;c;){for(u=a,a=[];++E<c;)u&&u[E].run();E=-1,c=a.length}u=null,y=!1,function(p){if(D===clearTimeout)return clearTimeout(p);if((D===A||!D)&&clearTimeout)return D=clearTimeout,clearTimeout(p);try{D(p)}catch{try{return D.call(null,p)}catch{return D.call(this,p)}}}(b)}}function w(b,c){this.fun=b,this.array=c}function k(){}R.nextTick=function(b){var c=new Array(arguments.length-1);if(arguments.length>1)for(var p=1;p<arguments.length;p++)c[p-1]=arguments[p];a.push(new w(b,c)),a.length!==1||y||P(m)},w.prototype.run=function(){this.fun.apply(null,this.array)},R.title="browser",R.browser=!0,R.env={},R.argv=[],R.version="",R.versions={},R.on=k,R.addListener=k,R.once=k,R.off=k,R.removeListener=k,R.removeAllListeners=k,R.emit=k,R.prependListener=k,R.prependOnceListener=k,R.listeners=function(b){return[]},R.binding=function(b){throw new Error("process.binding is not supported")},R.cwd=function(){return"/"},R.chdir=function(b){throw new Error("process.chdir is not supported")},R.umask=function(){return 0}}])}),define(ie[75],ne([0,1]),function(J,e){"use strict";var N;Object.defineProperty(e,"__esModule",{value:!0}),e.$ds=void 0;class D{constructor(P,u,a){this.level=P,this.key=u,this.value=a,this.forward=[]}}const R=void 0;class L{constructor(P,u=2**16){this.comparator=P,this[N]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(u)|0),this.e=new D(this.c,R,R)}get size(){return this.f}clear(){this.e=new D(this.c,R,R),this.f=0}has(P){return!!L.g(this,P,this.comparator)}get(P){return L.g(this,P,this.comparator)?.value}set(P,u){return L.h(this,P,u,this.comparator)&&(this.f+=1),this}delete(P){const u=L.k(this,P,this.comparator);return u&&(this.f-=1),u}forEach(P,u){let a=this.e.forward[0];for(;a;)P.call(u,a.value,a.key,this),a=a.forward[0]}[(N=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let P=this.e.forward[0];for(;P;)yield[P.key,P.value],P=P.forward[0]}*keys(){let P=this.e.forward[0];for(;P;)yield P.key,P=P.forward[0]}*values(){let P=this.e.forward[0];for(;P;)yield P.value,P=P.forward[0]}toString(){let P="[SkipList]:",u=this.e.forward[0];for(;u;)P+=`node(${u.key}, ${u.value}, lvl:${u.level})`,u=u.forward[0];return P}static g(P,u,a){let y=P.e;for(let E=P.d-1;E>=0;E--)for(;y.forward[E]&&a(y.forward[E].key,u)<0;)y=y.forward[E];if(y=y.forward[0],y&&a(y.key,u)===0)return y}static h(P,u,a,y){const E=[];let d=P.e;for(let m=P.d-1;m>=0;m--){for(;d.forward[m]&&y(d.forward[m].key,u)<0;)d=d.forward[m];E[m]=d}if(d=d.forward[0],d&&y(d.key,u)===0)return d.value=a,!1;{const m=L.j(P);if(m>P.d){for(let w=P.d;w<m;w++)E[w]=P.e;P.d=m}d=new D(m,u,a);for(let w=0;w<m;w++)d.forward[w]=E[w].forward[w],E[w].forward[w]=d;return!0}}static j(P,u=.5){let a=1;for(;Math.random()<u&&a<P.c;)a+=1;return a}static k(P,u,a){const y=[];let E=P.e;for(let d=P.d-1;d>=0;d--){for(;E.forward[d]&&a(E.forward[d].key,u)<0;)E=E.forward[d];y[d]=E}if(E=E.forward[0],!E||a(E.key,u)!==0)return!1;for(let d=0;d<P.d&&y[d].forward[d]===E;d++)y[d].forward[d]=E.forward[d];for(;P.d>0&&P.e.forward[P.d-1]===R;)P.d-=1;return!0}}e.$ds=L}),define(ie[46],ne([0,1,7,2]),function(J,e,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=void 0;function R(h){const g=h;return g?typeof g.read=="function":!1}e.$ee=R;function L(h){const g=h;return g?[g.on,g.pause,g.resume,g.destroy].every(i=>typeof i=="function"):!1}e.$fe=L;function A(h){const g=h;return g?L(g.stream)&&Array.isArray(g.buffer)&&typeof g.ended=="boolean":!1}e.$ge=A;function P(h,g){return new u(h,g)}e.$he=P;class u{constructor(g,i){this.e=g,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(g){if(!this.a.destroyed){if(this.a.flowing)this.g(g);else if(this.b.data.push(g),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(g){this.a.destroyed||(this.a.flowing?this.h(g):this.b.error.push(g))}end(g){this.a.destroyed||(typeof g<"u"&&this.write(g),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(g){this.c.data.slice(0).forEach(i=>i(g))}h(g){this.c.error.length===0?(0,N.$1)(g):this.c.error.slice(0).forEach(i=>i(g))}i(){this.c.end.slice(0).forEach(g=>g())}on(g,i){if(!this.a.destroyed)switch(g){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(g,i){if(this.a.destroyed)return;let r;switch(g){case"data":r=this.c.data;break;case"end":r=this.c.end;break;case"error":r=this.c.error;break}if(r){const t=r.indexOf(i);t>=0&&r.splice(t,1)}}j(){if(this.b.data.length>0){const g=this.e(this.b.data);this.g(g),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(r=>r())}}k(){if(this.c.error.length>0){for(const g of this.b.error)this.h(g);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function a(h,g){const i=[];let r;for(;(r=h.read())!==null;)i.push(r);return g(i)}e.$ie=a;function y(h,g,i){const r=[];let t;for(;(t=h.read())!==null&&r.length<i;)r.push(t);return t===null&&r.length>0?g(r):{read:()=>{if(r.length>0)return r.shift();if(typeof t<"u"){const n=t;return t=void 0,n}return h.read()}}}e.$je=y;function E(h,g){return new Promise((i,r)=>{const t=[];d(h,{onData:n=>{g&&t.push(n)},onError:n=>{g?r(n):i(void 0)},onEnd:()=>{i(g?g(t):void 0)}})})}e.$ke=E;function d(h,g,i){h.on("error",r=>{i?.isCancellationRequested||g.onError(r)}),h.on("end",()=>{i?.isCancellationRequested||g.onEnd()}),h.on("data",r=>{i?.isCancellationRequested||g.onData(r)})}e.$le=d;function m(h,g){return new Promise((i,r)=>{const t=new D.$Sc,n=[],s=O=>{if(n.push(O),n.length>g)return t.dispose(),h.pause(),i({stream:h,buffer:n,ended:!1})},o=O=>(t.dispose(),r(O)),l=()=>(t.dispose(),i({stream:h,buffer:n,ended:!0}));t.add((0,D.$Rc)(()=>h.removeListener("error",o))),h.on("error",o),t.add((0,D.$Rc)(()=>h.removeListener("end",l))),h.on("end",l),t.add((0,D.$Rc)(()=>h.removeListener("data",s))),h.on("data",s)})}e.$me=m;function w(h,g){const i=P(g);return i.end(h),i}e.$ne=w;function k(){const h=P(()=>{throw new Error("not supported")});return h.end(),h}e.$oe=k;function b(h){let g=!1;return{read:()=>g?null:(g=!0,h)}}e.$pe=b;function c(h,g,i){const r=P(i);return d(h,{onData:t=>r.write(g.data(t)),onError:t=>r.error(g.error?g.error(t):t),onEnd:()=>r.end()}),r}e.$qe=c;function p(h,g,i){let r=!1;return{read:()=>{const t=g.read();return r?t:(r=!0,t!==null?i([h,t]):h)}}}e.$re=p;function $(h,g,i){let r=!1;const t=P(i);return d(g,{onData:n=>r?t.write(n):(r=!0,t.write(i([h,n]))),onError:n=>t.error(n),onEnd:()=>{r||(r=!0,t.write(h)),t.end()}}),t}e.$se=$}),define(ie[14],ne([0,1,166,46]),function(J,e,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=e.$Ee=e.$De=e.$Ce=e.$Be=e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=void 0;const R=typeof Buffer<"u",L=new N.$V(()=>new Uint8Array(256));let A,P;class u{static alloc(j){return R?new u(Buffer.allocUnsafe(j)):new u(new Uint8Array(j))}static wrap(j){return R&&!Buffer.isBuffer(j)&&(j=Buffer.from(j.buffer,j.byteOffset,j.byteLength)),new u(j)}static fromString(j,q){return!(q?.dontUseNodeBuffer||!1)&&R?new u(Buffer.from(j)):(A||(A=new TextEncoder),new u(A.encode(j)))}static fromByteArray(j){const q=u.alloc(j.length);for(let Y=0,Z=j.length;Y<Z;Y++)q.buffer[Y]=j[Y];return q}static concat(j,q){if(typeof q>"u"){q=0;for(let oe=0,re=j.length;oe<re;oe++)q+=j[oe].byteLength}const Y=u.alloc(q);let Z=0;for(let oe=0,re=j.length;oe<re;oe++){const ue=j[oe];Y.set(ue,Z),Z+=ue.byteLength}return Y}constructor(j){this.buffer=j,this.byteLength=this.buffer.byteLength}clone(){const j=u.alloc(this.byteLength);return j.set(this),j}toString(){return R?this.buffer.toString():(P||(P=new TextDecoder),P.decode(this.buffer))}slice(j,q){return new u(this.buffer.subarray(j,q))}set(j,q){if(j instanceof u)this.buffer.set(j.buffer,q);else if(j instanceof Uint8Array)this.buffer.set(j,q);else if(j instanceof ArrayBuffer)this.buffer.set(new Uint8Array(j),q);else if(ArrayBuffer.isView(j))this.buffer.set(new Uint8Array(j.buffer,j.byteOffset,j.byteLength),q);else throw new Error("Unknown argument 'array'")}readUInt32BE(j){return d(this.buffer,j)}writeUInt32BE(j,q){m(this.buffer,j,q)}readUInt32LE(j){return w(this.buffer,j)}writeUInt32LE(j,q){k(this.buffer,j,q)}readUInt8(j){return b(this.buffer,j)}writeUInt8(j,q){c(this.buffer,j,q)}indexOf(j,q=0){return a(this.buffer,j instanceof u?j.buffer:j,q)}}e.$te=u;function a(v,j,q=0){const Y=j.byteLength,Z=v.byteLength;if(Y===0)return 0;if(Y===1)return v.indexOf(j[0]);if(Y>Z-q)return-1;const oe=L.value;oe.fill(j.length);for(let ae=0;ae<j.length;ae++)oe[j[ae]]=j.length-ae-1;let re=q+j.length-1,ue=re,fe=-1;for(;re<Z;)if(v[re]===j[ue]){if(ue===0){fe=re;break}re--,ue--}else re+=Math.max(j.length-ue,oe[v[re]]),ue=j.length-1;return fe}e.$ue=a;function y(v,j){return v[j+0]<<0>>>0|v[j+1]<<8>>>0}e.$ve=y;function E(v,j,q){v[q+0]=j&255,j=j>>>8,v[q+1]=j&255}e.$we=E;function d(v,j){return v[j]*2**24+v[j+1]*2**16+v[j+2]*2**8+v[j+3]}e.$xe=d;function m(v,j,q){v[q+3]=j,j=j>>>8,v[q+2]=j,j=j>>>8,v[q+1]=j,j=j>>>8,v[q]=j}e.$ye=m;function w(v,j){return v[j+0]<<0>>>0|v[j+1]<<8>>>0|v[j+2]<<16>>>0|v[j+3]<<24>>>0}e.$ze=w;function k(v,j,q){v[q+0]=j&255,j=j>>>8,v[q+1]=j&255,j=j>>>8,v[q+2]=j&255,j=j>>>8,v[q+3]=j&255}e.$Ae=k;function b(v,j){return v[j]}e.$Be=b;function c(v,j,q){v[q]=j}e.$Ce=c;function p(v){return D.$ie(v,j=>u.concat(j))}e.$De=p;function $(v){return D.$pe(v)}e.$Ee=$;function h(v){return D.$ke(v,j=>u.concat(j))}e.$Fe=h;async function g(v){return v.ended?u.concat(v.buffer):u.concat([...v.buffer,await h(v.stream)])}e.$Ge=g;function i(v){return D.$ne(v,j=>u.concat(j))}e.$He=i;function r(v){return D.$qe(v,{data:j=>typeof j=="string"?u.fromString(j):u.wrap(j)},j=>u.concat(j))}e.$Ie=r;function t(v){return D.$he(j=>u.concat(j),v)}e.$Je=t;function n(v,j){return D.$re(v,j,q=>u.concat(q))}e.$Ke=n;function s(v,j){return D.$se(v,j,q=>u.concat(q))}e.$Le=s;function o(v){let j=0,q=0,Y=0;const Z=new Uint8Array(Math.floor(v.length/4*3)),oe=ue=>{switch(q){case 3:Z[Y++]=j|ue,q=0;break;case 2:Z[Y++]=j|ue>>>2,j=ue<<6,q=3;break;case 1:Z[Y++]=j|ue>>>4,j=ue<<4,q=2;break;default:j=ue<<2,q=1}};for(let ue=0;ue<v.length;ue++){const fe=v.charCodeAt(ue);if(fe>=65&&fe<=90)oe(fe-65);else if(fe>=97&&fe<=122)oe(fe-97+26);else if(fe>=48&&fe<=57)oe(fe-48+52);else if(fe===43||fe===45)oe(62);else if(fe===47||fe===95)oe(63);else{if(fe===61)break;throw new SyntaxError(`Unexpected base64 character ${v[ue]}`)}}const re=Y;for(;q>0;)oe(0);return u.wrap(Z).slice(0,re)}e.$Me=o;const l="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",O="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function I({buffer:v},j=!0,q=!1){const Y=q?O:l;let Z="";const oe=v.byteLength%3;let re=0;for(;re<v.byteLength-oe;re+=3){const ue=v[re+0],fe=v[re+1],ae=v[re+2];Z+=Y[ue>>>2],Z+=Y[(ue<<4|fe>>>4)&63],Z+=Y[(fe<<2|ae>>>6)&63],Z+=Y[ae&63]}if(oe===1){const ue=v[re+0];Z+=Y[ue>>>2],Z+=Y[ue<<4&63],j&&(Z+="==")}else if(oe===2){const ue=v[re+0],fe=v[re+1];Z+=Y[ue>>>2],Z+=Y[(ue<<4|fe>>>4)&63],Z+=Y[fe<<2&63],j&&(Z+="=")}return Z}e.$Ne=I}),define(ie[43],ne([0,1,30]),function(J,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=e.$7i=void 0;function D(c){return R(c,0)}e.$7i=D;function R(c,p){switch(typeof c){case"object":return c===null?L(349,p):Array.isArray(c)?u(c,p):a(c,p);case"string":return P(c,p);case"boolean":return A(c,p);case"number":return L(c,p);case"undefined":return L(937,p);default:return L(617,p)}}e.$8i=R;function L(c,p){return(p<<5)-p+c|0}e.$9i=L;function A(c,p){return L(c?433:863,p)}function P(c,p){p=L(149417,p);for(let $=0,h=c.length;$<h;$++)p=L(c.charCodeAt($),p);return p}e.$0i=P;function u(c,p){return p=L(104579,p),c.reduce(($,h)=>R(h,$),p)}function a(c,p){return p=L(181387,p),Object.keys(c).sort().reduce(($,h)=>($=P(h,$),R(c[h],$)),p)}class y{constructor(){this.g=0}get value(){return this.g}hash(p){return this.g=R(p,this.g),this.g}}e.$$i=y;var E;(function(c){c[c.BLOCK_SIZE=64]="BLOCK_SIZE",c[c.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(E||(E={}));function d(c,p,$=32){const h=$-p,g=~((1<<h)-1);return(c<<p|(g&c)>>>h)>>>0}function m(c,p=0,$=c.byteLength,h=0){for(let g=0;g<$;g++)c[p+g]=h}function w(c,p,$="0"){for(;c.length<p;)c=$+c;return c}function k(c,p=32){return c instanceof ArrayBuffer?Array.from(new Uint8Array(c)).map($=>$.toString(16).padStart(2,"0")).join(""):w((c>>>0).toString(16),p/4)}e.$_i=k;class b{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(p){const $=p.length;if($===0)return;const h=this.p;let g=this.r,i=this.u,r,t;for(i!==0?(r=i,t=-1,i=0):(r=p.charCodeAt(0),t=0);;){let n=r;if(N.$of(r))if(t+1<$){const s=p.charCodeAt(t+1);N.$pf(s)?(t++,n=N.$qf(r,s)):n=65533}else{i=r;break}else N.$pf(r)&&(n=65533);if(g=this.w(h,g,n),t++,t<$)r=p.charCodeAt(t);else break}this.r=g,this.u=i}w(p,$,h){return h<128?p[$++]=h:h<2048?(p[$++]=192|(h&1984)>>>6,p[$++]=128|(h&63)>>>0):h<65536?(p[$++]=224|(h&61440)>>>12,p[$++]=128|(h&4032)>>>6,p[$++]=128|(h&63)>>>0):(p[$++]=240|(h&1835008)>>>18,p[$++]=128|(h&258048)>>>12,p[$++]=128|(h&4032)>>>6,p[$++]=128|(h&63)>>>0),$>=64&&(this.y(),$-=64,this.t+=64,p[0]=p[64],p[1]=p[65],p[2]=p[66]),$}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),k(this.h)+k(this.l)+k(this.m)+k(this.n)+k(this.o)}x(){this.p[this.r++]=128,m(this.p,this.r),this.r>56&&(this.y(),m(this.p));const p=8*this.t;this.q.setUint32(56,Math.floor(p/4294967296),!1),this.q.setUint32(60,p%4294967296,!1),this.y()}y(){const p=b.g,$=this.q;for(let l=0;l<64;l+=4)p.setUint32(l,$.getUint32(l,!1),!1);for(let l=64;l<320;l+=4)p.setUint32(l,d(p.getUint32(l-12,!1)^p.getUint32(l-32,!1)^p.getUint32(l-56,!1)^p.getUint32(l-64,!1),1),!1);let h=this.h,g=this.l,i=this.m,r=this.n,t=this.o,n,s,o;for(let l=0;l<80;l++)l<20?(n=g&i|~g&r,s=1518500249):l<40?(n=g^i^r,s=1859775393):l<60?(n=g&i|g&r|i&r,s=2400959708):(n=g^i^r,s=3395469782),o=d(h,5)+n+t+s+p.getUint32(l*4,!1)&4294967295,t=r,r=i,i=d(g,30),g=h,h=o;this.h=this.h+h&4294967295,this.l=this.l+g&4294967295,this.m=this.m+i&4294967295,this.n=this.n+r&4294967295,this.o=this.o+t&4294967295}}e.$aj=b}),define(ie[54],ne([0,1,30]),function(J,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var D;(function(R){R[R.Ignore=0]="Ignore",R[R.Info=1]="Info",R[R.Warning=2]="Warning",R[R.Error=3]="Error"})(D||(D={})),function(R){const L="error",A="warning",P="warn",u="info",a="ignore";function y(d){return d?N.$kf(L,d)?R.Error:N.$kf(A,d)||N.$kf(P,d)?R.Warning:N.$kf(u,d)?R.Info:R.Ignore:R.Ignore}R.fromValue=y;function E(d){switch(d){case R.Error:return L;case R.Warning:return A;case R.Info:return u;default:return a}}R.toString=E}(D||(D={})),e.default=D}),define(ie[27],ne([0,1,3]),function(J,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wn=e.$Vn=e.$Un=e.$Tn=e.$Sn=e.$Rn=e.$Qn=e.$Pn=e.$On=e.$Nn=e.$Mn=e.$Ln=void 0;function D(c){if(!c||typeof c!="object"||c instanceof RegExp)return c;const p=Array.isArray(c)?[]:{};return Object.entries(c).forEach(([$,h])=>{p[$]=h&&typeof h=="object"?D(h):h}),p}e.$Ln=D;function R(c){if(!c||typeof c!="object")return c;const p=[c];for(;p.length>0;){const $=p.shift();Object.freeze($);for(const h in $)if(L.call($,h)){const g=$[h];typeof g=="object"&&!Object.isFrozen(g)&&!(0,N.$Wf)(g)&&p.push(g)}}return c}e.$Mn=R;const L=Object.prototype.hasOwnProperty;function A(c,p){return P(c,p,new Set)}e.$Nn=A;function P(c,p,$){if((0,N.$3f)(c))return c;const h=p(c);if(typeof h<"u")return h;if(Array.isArray(c)){const g=[];for(const i of c)g.push(P(i,p,$));return g}if((0,N.$Vf)(c)){if($.has(c))throw new Error("Cannot clone recursive data-structure");$.add(c);const g={};for(const i in c)L.call(c,i)&&(g[i]=P(c[i],p,$));return $.delete(c),g}return c}function u(c,p,$=!0){return(0,N.$Vf)(c)?((0,N.$Vf)(p)&&Object.keys(p).forEach(h=>{h in c?$&&((0,N.$Vf)(c[h])&&(0,N.$Vf)(p[h])?u(c[h],p[h],$):c[h]=p[h]):c[h]=p[h]}),c):p}e.$On=u;function a(c,p){if(c===p)return!0;if(c==null||p===null||p===void 0||typeof c!=typeof p||typeof c!="object"||Array.isArray(c)!==Array.isArray(p))return!1;let $,h;if(Array.isArray(c)){if(c.length!==p.length)return!1;for($=0;$<c.length;$++)if(!a(c[$],p[$]))return!1}else{const g=[];for(h in c)g.push(h);g.sort();const i=[];for(h in p)i.push(h);if(i.sort(),!a(g,i))return!1;for($=0;$<g.length;$++)if(!a(c[g[$]],p[g[$]]))return!1}return!0}e.$Pn=a;function y(c){const p=new Set;return JSON.stringify(c,($,h)=>{if((0,N.$Vf)(h)||Array.isArray(h)){if(p.has(h))return"[Circular]";p.add(h)}return h})}e.$Qn=y;function E(c,p){const $=Object.create(null);return!c||!p||Object.keys(p).forEach(g=>{const i=c[g],r=p[g];a(i,r)||($[g]=r)}),$}e.$Rn=E;function d(c,p){const $=p.toLowerCase(),h=Object.keys(c).find(g=>g.toLowerCase()===$);return h?c[h]:c[p]}e.$Sn=d;function m(c,p){const $=Object.create(null);for(const[h,g]of Object.entries(c))p(h,g)&&($[h]=g);return $}e.$Tn=m;function w(c){let p=[];for(;Object.prototype!==c;)p=p.concat(Object.getOwnPropertyNames(c)),c=Object.getPrototypeOf(c);return p}e.$Un=w;function k(c){const p=[];for(const $ of w(c))typeof c[$]=="function"&&p.push($);return p}e.$Vn=k;function b(c,p){const $=g=>function(){const i=Array.prototype.slice.call(arguments,0);return p(g,i)},h={};for(const g of c)h[g]=$(g);return h}e.$Wn=b}),define(ie[28],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cg=e.$Bg=void 0;const N=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function D(R){return N.test(R)}e.$Bg=D,e.$Cg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let R;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?R=crypto.getRandomValues.bind(crypto):R=function(P){for(let u=0;u<P.length;u++)P[u]=Math.floor(Math.random()*256);return P};const L=new Uint8Array(16),A=[];for(let P=0;P<256;P++)A.push(P.toString(16).padStart(2,"0"));return function(){R(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let u=0,a="";return a+=A[L[u++]],a+=A[L[u++]],a+=A[L[u++]],a+=A[L[u++]],a+="-",a+=A[L[u++]],a+=A[L[u++]],a+="-",a+=A[L[u++]],a+=A[L[u++]],a+="-",a+=A[L[u++]],a+=A[L[u++]],a+="-",a+=A[L[u++]],a+=A[L[u++]],a+=A[L[u++]],a+=A[L[u++]],a+=A[L[u++]],a+=A[L[u++]],a}}()}),define(ie[76],ne([0,1,33]),function(J,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mn=void 0;const D=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function R(A){const P=A.replace(/\-/g,":").toLowerCase();return!D.has(P)}function L(){const A=(0,N.networkInterfaces)();for(const P in A){const u=A[P];if(u){for(const{mac:a}of u)if(R(a))return a}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.$mn=L}),define(ie[77],ne([8,5]),function(J,e){return J.create("vs/base/common/date",e)}),define(ie[78],ne([0,1,77]),function(J,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mm=e.$Lm=e.$Km=void 0;const D=60,R=D*60,L=R*24,A=L*7,P=L*30,u=L*365;function a(d,m,w,k){typeof d!="number"&&(d=d.getTime());const b=Math.round((new Date().getTime()-d)/1e3);if(b<-30)return(0,N.localize)(0,null,a(new Date().getTime()+b*1e3,!1));if(!k&&b<30)return(0,N.localize)(1,null);let c;return b<D?(c=b,m?c===1?w?(0,N.localize)(2,null,c):(0,N.localize)(3,null,c):w?(0,N.localize)(4,null,c):(0,N.localize)(5,null,c):c===1?w?(0,N.localize)(6,null,c):(0,N.localize)(7,null,c):w?(0,N.localize)(8,null,c):(0,N.localize)(9,null,c)):b<R?(c=Math.floor(b/D),m?c===1?w?(0,N.localize)(10,null,c):(0,N.localize)(11,null,c):w?(0,N.localize)(12,null,c):(0,N.localize)(13,null,c):c===1?w?(0,N.localize)(14,null,c):(0,N.localize)(15,null,c):w?(0,N.localize)(16,null,c):(0,N.localize)(17,null,c)):b<L?(c=Math.floor(b/R),m?c===1?w?(0,N.localize)(18,null,c):(0,N.localize)(19,null,c):w?(0,N.localize)(20,null,c):(0,N.localize)(21,null,c):c===1?w?(0,N.localize)(22,null,c):(0,N.localize)(23,null,c):w?(0,N.localize)(24,null,c):(0,N.localize)(25,null,c)):b<A?(c=Math.floor(b/L),m?c===1?(0,N.localize)(26,null,c):(0,N.localize)(27,null,c):c===1?(0,N.localize)(28,null,c):(0,N.localize)(29,null,c)):b<P?(c=Math.floor(b/A),m?c===1?w?(0,N.localize)(30,null,c):(0,N.localize)(31,null,c):w?(0,N.localize)(32,null,c):(0,N.localize)(33,null,c):c===1?w?(0,N.localize)(34,null,c):(0,N.localize)(35,null,c):w?(0,N.localize)(36,null,c):(0,N.localize)(37,null,c)):b<u?(c=Math.floor(b/P),m?c===1?w?(0,N.localize)(38,null,c):(0,N.localize)(39,null,c):w?(0,N.localize)(40,null,c):(0,N.localize)(41,null,c):c===1?w?(0,N.localize)(42,null,c):(0,N.localize)(43,null,c):w?(0,N.localize)(44,null,c):(0,N.localize)(45,null,c)):(c=Math.floor(b/u),m?c===1?w?(0,N.localize)(46,null,c):(0,N.localize)(47,null,c):w?(0,N.localize)(48,null,c):(0,N.localize)(49,null,c):c===1?w?(0,N.localize)(50,null,c):(0,N.localize)(51,null,c):w?(0,N.localize)(52,null,c):(0,N.localize)(53,null,c))}e.$Km=a;function y(d,m){const w=Math.abs(d/1e3);return w<1?m?(0,N.localize)(54,null,d):(0,N.localize)(55,null,d):w<D?m?(0,N.localize)(56,null,Math.round(d)/1e3):(0,N.localize)(57,null,Math.round(d)/1e3):w<R?m?(0,N.localize)(58,null,Math.round(d/(1e3*D))):(0,N.localize)(59,null,Math.round(d/(1e3*D))):w<L?m?(0,N.localize)(60,null,Math.round(d/(1e3*R))):(0,N.localize)(61,null,Math.round(d/(1e3*R))):(0,N.localize)(62,null,Math.round(d/(1e3*L)))}e.$Lm=y;function E(d){return d.getFullYear()+"-"+String(d.getMonth()+1).padStart(2,"0")+"-"+String(d.getDate()).padStart(2,"0")+"T"+String(d.getHours()).padStart(2,"0")+":"+String(d.getMinutes()).padStart(2,"0")+":"+String(d.getSeconds()).padStart(2,"0")+"."+(d.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$Mm=E}),define(ie[79],ne([8,5]),function(J,e){return J.create("vs/base/common/errorMessage",e)}),define(ie[34],ne([0,1,19,3,79]),function(J,e,N,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6i=e.$5i=e.$4i=void 0;function L(E,d){return d&&(E.stack||E.stacktrace)?R.localize(0,null,P(E),A(E.stack)||A(E.stacktrace)):P(E)}function A(E){return Array.isArray(E)?E.join(`
`):E}function P(E){return E.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${E.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof E.code=="string"&&typeof E.errno=="number"&&typeof E.syscall=="string"?R.localize(1,null,E.message):E.message||R.localize(2,null)}function u(E=null,d=!1){if(!E)return R.localize(3,null);if(Array.isArray(E)){const m=N.$Hb(E),w=u(m[0],d);return m.length>1?R.localize(4,null,w,m.length):w}if(D.$Tf(E))return E;if(E.detail){const m=E.detail;if(m.error)return L(m.error,d);if(m.exception)return L(m.exception,d)}return E.stack?L(E,d):E.message?E.message:R.localize(5,null)}e.$4i=u;function a(E){const d=E;return d instanceof Error&&Array.isArray(d.actions)}e.$5i=a;function y(E,d){let m;return typeof E=="string"?m=new Error(E):m=E,m.actions=d,m}e.$6i=y}),define(ie[80],ne([8,5]),function(J,e){return J.create("vs/base/common/jsonErrorMessages",e)}),define(ie[81],ne([0,1,80]),function(J,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aq=void 0;function D(R){switch(R){case 1:return(0,N.localize)(0,null);case 2:return(0,N.localize)(1,null);case 3:return(0,N.localize)(2,null);case 4:return(0,N.localize)(3,null);case 5:return(0,N.localize)(4,null);case 6:return(0,N.localize)(5,null);case 7:return(0,N.localize)(6,null);case 8:return(0,N.localize)(7,null);case 9:return(0,N.localize)(8,null);default:return""}}e.$aq=D}),define(ie[55],ne([0,1,12]),function(J,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4l=e.$3l=e.TerminateResponseCode=e.Source=void 0;var D;(function(P){P[P.stdout=0]="stdout",P[P.stderr=1]="stderr"})(D||(e.Source=D={}));var R;(function(P){P[P.Success=0]="Success",P[P.Unknown=1]="Unknown",P[P.AccessDenied=2]="AccessDenied",P[P.ProcessNotFound=3]="ProcessNotFound"})(R||(e.TerminateResponseCode=R={}));function L(P,...u){const a=u.reduce((d,m)=>(d[m]=!0,d),{}),y=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(P).filter(d=>!a[d]).forEach(d=>{for(let m=0;m<y.length;m++)if(d.search(y[m])!==-1){delete P[d];break}})}e.$3l=L;function A(P){P&&(delete P.DEBUG,N.$j&&delete P.DYLD_LIBRARY_PATH,N.$k&&delete P.LD_PRELOAD)}e.$4l=A}),define(ie[82],ne([0,1,11]),function(J,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$Dq=e.$Cq=e.$Bq=void 0;function D(a){const y=a;return y&&typeof y.type=="string"&&typeof y.severity=="string"}e.$Bq=D;function R(a){const y=[];let E;try{const d=JSON.parse(a.arguments),m=d[d.length-1];m&&m.__$stack&&(d.pop(),E=m.__$stack),y.push(...d)}catch{y.push("Unable to log remote console arguments",a.arguments)}return{args:y,stack:E}}e.$Cq=R;function L(a){if(typeof a!="string")return L(R(a).stack);const y=a;if(y){const E=A(y),d=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(E||"");if(d&&d.length===4)return{uri:N.URI.file(d[1]),line:Number(d[2]),column:Number(d[3])}}}e.$Dq=L;function A(a){if(!a)return a;const y=a.indexOf(`
`);return y===-1?a:a.substring(0,y)}function P(a,y){const{args:E,stack:d}=R(a),m=typeof E[0]=="string"&&E.length===1;let w=A(d);w&&(w=`(${w.trim()})`);let k=[];if(typeof E[0]=="string"?w&&m?k=[`%c[${y}] %c${E[0]} %c${w}`,u("blue"),u(""),u("grey")]:k=[`%c[${y}] %c${E[0]}`,u("blue"),u(""),...E.slice(1)]:k=[`%c[${y}]%`,u("blue"),...E],w&&!m&&k.push(w),typeof console[a.severity]!="function")throw new Error("Unknown console method");console[a.severity].apply(console,k)}e.log=P;function u(a){return`color: ${a}`}}),define(ie[47],ne([0,1,14,11]),function(J,e,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ph=e.$Oh=e.$Nh=void 0;function R(u){return JSON.stringify(u,A)}e.$Nh=R;function L(u){let a=JSON.parse(u);return a=P(a),a}e.$Oh=L;function A(u,a){return a instanceof RegExp?{$mid:2,source:a.source,flags:a.flags}:a}function P(u,a=0){if(!u||a>200)return u;if(typeof u=="object"){switch(u.$mid){case 1:return D.URI.revive(u);case 2:return new RegExp(u.source,u.flags);case 17:return new Date(u.source)}if(u instanceof N.$te||u instanceof Uint8Array)return u;if(Array.isArray(u))for(let y=0;y<u.length;++y)u[y]=P(u[y],a+1);else for(const y in u)Object.hasOwnProperty.call(u,y)&&(u[y]=P(u[y],a+1))}return u}e.$Ph=P}),define(ie[83],ne([0,1,70,15,12,11]),function(J,e,N,D,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xD=void 0;class A{constructor(d,m,w){this.id=d,this.dependencies=m,this.callback=w}}class P{static{this.INSTANCE=new P}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(d,m,w)=>{typeof d!="string"&&(w=m,m=d,d=null),(typeof m!="object"||!Array.isArray(m))&&(w=m,m=null),this.c.push(new A(d,m,w))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(d){if(d.startsWith(window.location.origin)||d.startsWith("vscode-file://vscode-app"))return d;throw new Error(`[trusted_script_src] Invalid script url: ${d}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(d){return d}})))}async load(d){this.g();const m=await(this.a?this.i(d):this.b?this.h(d):this.j(d));if(!m)throw new Error(`Did not receive a define call from script ${d}`);if(Array.isArray(m.dependencies)&&m.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${d}. The dependencies are: ${m.dependencies.join(", ")}`);return typeof m.callback=="function"?m.callback([]):m.callback}h(d){return new Promise((m,w)=>{const k=document.createElement("script");k.setAttribute("async","async"),k.setAttribute("type","text/javascript");const b=()=>{k.removeEventListener("load",c),k.removeEventListener("error",p)},c=$=>{b(),m(this.c.pop())},p=$=>{b(),w($)};k.addEventListener("load",c),k.addEventListener("error",p),this.f&&(d=this.f.createScriptURL(d)),k.setAttribute("src",d),window.document.getElementsByTagName("head")[0].appendChild(k)})}i(d){return new Promise((m,w)=>{try{this.f&&(d=this.f.createScriptURL(d)),importScripts(d),m(this.c.pop())}catch(k){w(k)}})}async j(d){try{const m=globalThis._VSCODE_NODE_MODULES.fs,w=globalThis._VSCODE_NODE_MODULES.vm,k=globalThis._VSCODE_NODE_MODULES.module,b=L.URI.parse(d).fsPath,c=m.readFileSync(b).toString(),p=k.wrap(c.replace(/^#!.*/,""));return new w.Script(p).runInThisContext().apply(),this.c.pop()}catch(m){throw m}}}const u=new Map;let a={};typeof globalThis.require=="object"&&(a=globalThis.require.paths??{});async function y(E,d,m){if(N.$T){m===void 0&&(m=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),a[E]&&(E=a[E]);const w=`${E}/${d}`;if(u.has(w))return u.get(w);let k;if(/^\w[\w\d+.-]*:\/\//.test(w))k=w;else{const $=`${m&&!R.$o?D.$xg:D.$wg}/${w}`;k=D.$Ag.asBrowserUri($).toString(!0)}const b=P.INSTANCE.load(k);return u.set(w,b),b}else return await new Promise((w,k)=>{J([E],w,k)})}e.$xD=y}),define(ie[84],ne([0,1,33,48,28,76,12]),function(J,e,N,D,R,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pn=e.$on=e.$nn=void 0,e.$nn=new class{c(d){return this.a||(this.a=D.$mi.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(d)}value(){if(this.b===void 0){let d=0,m=0;const w=(0,N.networkInterfaces)();for(const k in w){const b=w[k];if(b)for(const{mac:c,internal:p}of b)p||(m+=1,this.c(c.toUpperCase())&&(d+=1))}this.b=m>0?d/m:0}return this.b}};let P;async function u(d){return P||(P=(async()=>await a(d)||R.$Cg())()),P}e.$on=u;async function a(d){try{const m=await new Promise((k,b)=>{J(["crypto"],k,b)}),w=(0,L.$mn)();return m.createHash("sha256").update(w,"utf8").digest("hex")}catch(m){d(m);return}}const y="Software\\Microsoft\\SQMClient";async function E(d){if(A.$i){const m=await new Promise((w,k)=>{J(["@vscode/windows-registry"],w,k)});try{return m.GetStringRegKey("HKEY_LOCAL_MACHINE",y,"MachineId")||""}catch(w){return d(w),""}}return""}e.$pn=E}),define(ie[85],ne([0,1,33,16,24]),function(J,e,N,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2l=e.$1l=void 0;const L=/^\d+$/,A=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var u;(function(h){h[h.x64=0]="x64",h[h.x86=1]="x86",h[h.ARM=2]="ARM"})(u||(u={}));let a;switch(process.arch){case"ia32":a=1;break;case"arm":case"arm64":a=2;break;default:a=0;break}let y;process.env.PROCESSOR_ARCHITEW6432?y=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?y=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?y=1:y=0;class E{constructor(g,i,r){this.exePath=g,this.displayName=i,this.a=r}async exists(){return this.a===void 0&&(this.a=await R.SymlinkSupport.existsFile(this.exePath)),this.a}}function d({useAlternateBitness:h=!1}={}){return h?a===0?process.env["ProgramFiles(x86)"]||null:y===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function m({useAlternateBitness:h=!1,findPreview:g=!1}={}){const i=d({useAlternateBitness:h});if(!i)return null;const r=D.$jc(i,"PowerShell");if(!await R.SymlinkSupport.existsDirectory(r))return null;let t=-1,n=null;for(const l of await R.Promises.readdir(r)){let O=-1;if(g){const v=l.indexOf("-");if(v<0)continue;const j=l.substring(0,v);if(!L.test(j)||l.substring(v+1)!=="preview")continue;O=parseInt(j,10)}else{if(!L.test(l))continue;O=parseInt(l,10)}if(O<=t)continue;const I=D.$jc(r,l,"pwsh.exe");await R.SymlinkSupport.existsFile(I)&&(n=I,t=O)}if(!n)return null;const s=i.includes("x86")?" (x86)":"",o=g?" Preview":"";return new E(n,`PowerShell${o}${s}`,!0)}async function w({findPreview:h}={}){if(!process.env.LOCALAPPDATA)return null;const g=D.$jc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await R.SymlinkSupport.existsDirectory(g))return null;const{pwshMsixDirRegex:i,pwshMsixName:r}=h?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:A,pwshMsixName:"PowerShell (Store)"};for(const t of await R.Promises.readdir(g))if(i.test(t)){const n=D.$jc(g,t,"pwsh.exe");return new E(n,r)}return null}function k(){const h=D.$jc(N.homedir(),".dotnet","tools","pwsh.exe");return new E(h,".NET Core PowerShell Global Tool")}function b(){const h=D.$jc(process.env.windir,a===1&&y!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new E(h,"Windows PowerShell",!0)}async function*c(){let h=await m();h&&(yield h),h=await m({useAlternateBitness:!0}),h&&(yield h),h=await w(),h&&(yield h),h=k(),h&&(yield h),h=await m({findPreview:!0}),h&&(yield h),h=await w({findPreview:!0}),h&&(yield h),h=await m({useAlternateBitness:!0,findPreview:!0}),h&&(yield h),h=b(),h&&(yield h)}async function*p(){for await(const h of c())await h.exists()&&(yield h)}e.$1l=p;async function $(){for await(const h of p())return h;return null}e.$2l=$}),define(ie[56],ne([0,1,16,12,35,55,3,24]),function(J,e,N,D,R,L,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$6l=e.$5l=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return L.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return L.TerminateResponseCode}});function u(E=R.env){return E.comspec||"cmd.exe"}e.$5l=u;function a(E){let d=[],m=!1;const w=function(k){if(m){d.push(k);return}(!E.send(k,c=>{if(c&&console.error(c),m=!1,d.length>0){const p=d.slice(0);d=[],p.forEach($=>w($))}})||D.$i)&&(m=!0)};return{send:w}}e.$6l=a;var y;(function(E){async function d(m,w,k){if(N.$ic(m))return m;if(w===void 0&&(w=R.cwd()),N.$mc(m)!=="."||(k===void 0&&A.$Tf(R.env.PATH)&&(k=R.env.PATH.split(N.$tc)),k===void 0||k.length===0))return N.$jc(w,m);async function c(p){if(await P.Promises.exists(p)){let $;try{$=await P.Promises.stat(p)}catch(h){h.message.startsWith("EACCES")&&($=await P.Promises.lstat(p))}return $?!$.isDirectory():!1}return!1}for(const p of k){let $;if(N.$ic(p)?$=N.$jc(p,m):$=N.$jc(w,p,m),await c($))return $;let h=$+".com";if(await c(h)||(h=$+".exe",await c(h)))return h}return N.$jc(w,m)}E.findExecutable=d})(y||(e.win32=y={}))}),define(ie[86],ne([0,1,33,12,85,56]),function(J,e,N,D,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7l=void 0;async function A(E,d){return E===1?D.$i?y():L.$5l(d):u(E,d)}e.$7l=A;let P=null;function u(E,d){if(D.$k&&E===2||D.$j&&E===3)return"/bin/bash";if(!P){let m;if(D.$i)m="/bin/bash";else{if(m=d.SHELL,!m)try{m=(0,N.userInfo)().shell}catch{}m||(m="sh"),m==="/bin/false"&&(m="/bin/bash")}P=m}return P}let a=null;async function y(){return a||(a=(await(0,R.$2l)()).exePath),a}});var pe=this&&this.__decorate||function(J,e,N,D){var R=arguments.length,L=R<3?e:D===null?D=Object.getOwnPropertyDescriptor(e,N):D,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate(J,e,N,D);else for(var P=J.length-1;P>=0;P--)(A=J[P])&&(L=(R<3?A(L):R>3?A(e,N,L):A(e,N))||L);return R>3&&L&&Object.defineProperty(e,N,L),L};define(ie[57],ne([0,1,19,9,14,20,53,7,6,2,47,30,3]),function(J,e,N,D,R,L,A,P,u,a,y,E,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2h=e.ProxyChannel=e.$1h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.RequestInitiator=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=void 0;var m;(function(U){U[U.Promise=100]="Promise",U[U.PromiseCancel=101]="PromiseCancel",U[U.EventListen=102]="EventListen",U[U.EventDispose=103]="EventDispose"})(m||(m={}));function w(U){switch(U){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var k;(function(U){U[U.Initialize=200]="Initialize",U[U.PromiseSuccess=201]="PromiseSuccess",U[U.PromiseError=202]="PromiseError",U[U.PromiseErrorObj=203]="PromiseErrorObj",U[U.EventFire=204]="EventFire"})(k||(k={}));function b(U){switch(U){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var c;(function(U){U[U.Uninitialized=0]="Uninitialized",U[U.Idle=1]="Idle"})(c||(c={}));function p(U){let M=0;for(let H=0;;H+=7){const K=U.read(1);if(M|=(K.buffer[0]&127)<<H,!(K.buffer[0]&128))return M}}const $=t(0);function h(U,M){if(M===0){U.write($);return}let H=0;for(let Q=M;Q!==0;Q=Q>>>7)H++;const K=R.$te.alloc(H);for(let Q=0;M!==0;Q++)K.buffer[Q]=M&127,M=M>>>7,M>0&&(K.buffer[Q]|=128);U.write(K)}class g{constructor(M){this.b=M,this.a=0}read(M){const H=this.b.slice(this.a,this.a+M);return this.a+=H.byteLength,H}}e.$Qh=g;class i{constructor(){this.a=[]}get buffer(){return R.$te.concat(this.a)}write(M){this.a.push(M)}}e.$Rh=i;var r;(function(U){U[U.Undefined=0]="Undefined",U[U.String=1]="String",U[U.Buffer=2]="Buffer",U[U.VSBuffer=3]="VSBuffer",U[U.Array=4]="Array",U[U.Object=5]="Object",U[U.Int=6]="Int"})(r||(r={}));function t(U){const M=R.$te.alloc(1);return M.writeUInt8(U,0),M}const n={Undefined:t(r.Undefined),String:t(r.String),Buffer:t(r.Buffer),VSBuffer:t(r.VSBuffer),Array:t(r.Array),Object:t(r.Object),Uint:t(r.Int)},s=typeof Buffer<"u";function o(U,M){if(typeof M>"u")U.write(n.Undefined);else if(typeof M=="string"){const H=R.$te.fromString(M);U.write(n.String),h(U,H.byteLength),U.write(H)}else if(s&&Buffer.isBuffer(M)){const H=R.$te.wrap(M);U.write(n.Buffer),h(U,H.byteLength),U.write(H)}else if(M instanceof R.$te)U.write(n.VSBuffer),h(U,M.byteLength),U.write(M);else if(Array.isArray(M)){U.write(n.Array),h(U,M.length);for(const H of M)o(U,H)}else if(typeof M=="number"&&(M|0)===M)U.write(n.Uint),h(U,M);else{const H=R.$te.fromString(JSON.stringify(M));U.write(n.Object),h(U,H.byteLength),U.write(H)}}e.$Sh=o;function l(U){switch(U.read(1).readUInt8(0)){case r.Undefined:return;case r.String:return U.read(p(U)).toString();case r.Buffer:return U.read(p(U)).buffer;case r.VSBuffer:return U.read(p(U));case r.Array:{const H=p(U),K=[];for(let Q=0;Q<H;Q++)K.push(l(U));return K}case r.Object:return JSON.parse(U.read(p(U)).toString());case r.Int:return p(U)}}e.$Th=l;class O{constructor(M,H,K=null,Q=1e3){this.h=M,this.j=H,this.k=K,this.l=Q,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ee=>this.q(ee)),this.m({type:200})}registerChannel(M,H){this.b.set(M,H),setTimeout(()=>this.w(M),0)}m(M){switch(M.type){case 200:{const H=this.o([M.type]);this.k?.logOutgoing(H,0,1,b(M.type));return}case 201:case 202:case 204:case 203:{const H=this.o([M.type,M.id],M.data);this.k?.logOutgoing(H,M.id,1,b(M.type),M.data);return}}}o(M,H=void 0){const K=new i;return o(K,M),o(K,H),this.p(K.buffer)}p(M){try{return this.h.send(M),M.byteLength}catch{return 0}}q(M){const H=new g(M),K=l(H),Q=l(H),ee=K[0];switch(ee){case 100:return this.k?.logIncoming(M.byteLength,K[1],1,`${w(ee)}: ${K[2]}.${K[3]}`,Q),this.s({type:ee,id:K[1],channelName:K[2],name:K[3],arg:Q});case 102:return this.k?.logIncoming(M.byteLength,K[1],1,`${w(ee)}: ${K[2]}.${K[3]}`,Q),this.t({type:ee,id:K[1],channelName:K[2],name:K[3],arg:Q});case 101:return this.k?.logIncoming(M.byteLength,K[1],1,`${w(ee)}`),this.u({type:ee,id:K[1]});case 103:return this.k?.logIncoming(M.byteLength,K[1],1,`${w(ee)}`),this.u({type:ee,id:K[1]})}}s(M){const H=this.b.get(M.channelName);if(!H){this.v(M);return}const K=new L.$de;let Q;try{Q=H.call(this.j,M.name,M.arg,K.token)}catch(z){Q=Promise.reject(z)}const ee=M.id;Q.then(z=>{this.m({id:ee,data:z,type:201})},z=>{z instanceof Error?this.m({id:ee,data:{message:z.message,name:z.name,stack:z.stack?z.stack.split?z.stack.split(`
`):z.stack:void 0},type:202}):this.m({id:ee,data:z,type:203})}).finally(()=>{C.dispose(),this.d.delete(M.id)});const C=(0,a.$Rc)(()=>K.cancel());this.d.set(M.id,C)}t(M){const H=this.b.get(M.channelName);if(!H){this.v(M);return}const K=M.id,ee=H.listen(this.j,M.name,M.arg)(C=>this.m({id:K,data:C,type:204}));this.d.set(M.id,ee)}u(M){const H=this.d.get(M.id);H&&(H.dispose(),this.d.delete(M.id))}v(M){let H=this.g.get(M.channelName);H||(H=[],this.g.set(M.channelName,H));const K=setTimeout(()=>{console.error(`Unknown channel: ${M.channelName}`),M.type===100&&this.m({id:M.id,data:{name:"Unknown channel",message:`Channel name '${M.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);H.push({request:M,timeoutTimer:K})}w(M){const H=this.g.get(M);if(H){for(const K of H)switch(clearTimeout(K.timeoutTimer),K.request.type){case 100:this.s(K.request);break;case 102:this.t(K.request);break}this.g.delete(M)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,a.$Oc)(this.d.values()),this.d.clear()}}e.$Uh=O;var I;(function(U){U[U.LocalSide=0]="LocalSide",U[U.OtherSide=1]="OtherSide"})(I||(e.RequestInitiator=I={}));class v{constructor(M,H=null){this.l=M,this.a=!1,this.b=c.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new u.$6d,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(K=>this.s(K)),this.j=H}getChannel(M){const H=this;return{call(K,Q,ee){return H.a?Promise.reject(new P.$5):H.m(M,K,Q,ee)},listen(K,Q){return H.a?u.Event.None:H.o(M,K,Q)}}}m(M,H,K,Q=L.CancellationToken.None){const ee=this.g++,z={id:ee,type:100,channelName:M,name:H,arg:K};if(Q.isCancellationRequested)return Promise.reject(new P.$5);let f;return new Promise((T,F)=>{if(Q.isCancellationRequested)return F(new P.$5);const W=()=>{const le=$e=>{switch($e.type){case 201:this.f.delete(ee),T($e.data);break;case 202:{this.f.delete(ee);const ye=new Error($e.data.message);ye.stack=Array.isArray($e.data.stack)?$e.data.stack.join(`
`):$e.data.stack,ye.name=$e.data.name,F(ye);break}case 203:this.f.delete(ee),F($e.data);break}};this.f.set(ee,le),this.p(z)};let G=null;this.b===c.Idle?W():(G=(0,D.$6g)(le=>this.u()),G.then(()=>{G=null,W()}));const te=()=>{G?(G.cancel(),G=null):this.p({id:ee,type:101}),F(new P.$5)},ce=Q.onCancellationRequested(te);f=(0,a.$Qc)((0,a.$Rc)(te),ce),this.d.add(f)}).finally(()=>{f.dispose(),this.d.delete(f)})}o(M,H,K){const Q=this.g++,C={id:Q,type:102,channelName:M,name:H,arg:K};let z=null;const f=new u.$6d({onWillAddFirstListener:()=>{z=(0,D.$6g)(T=>this.u()),z.then(()=>{z=null,this.d.add(f),this.p(C)})},onDidRemoveLastListener:()=>{z?(z.cancel(),z=null):(this.d.delete(f),this.p({id:Q,type:103}))}}),S=T=>f.fire(T.data);return this.f.set(Q,S),f.event}p(M){switch(M.type){case 100:case 102:{const H=this.q([M.type,M.id,M.channelName,M.name],M.arg);this.j?.logOutgoing(H,M.id,0,`${w(M.type)}: ${M.channelName}.${M.name}`,M.arg);return}case 101:case 103:{const H=this.q([M.type,M.id]);this.j?.logOutgoing(H,M.id,0,w(M.type));return}}}q(M,H=void 0){const K=new i;return o(K,M),o(K,H),this.r(K.buffer)}r(M){try{return this.l.send(M),M.byteLength}catch{return 0}}s(M){const H=new g(M),K=l(H),Q=l(H),ee=K[0];switch(ee){case 200:return this.j?.logIncoming(M.byteLength,0,0,b(ee)),this.t({type:K[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(M.byteLength,K[1],0,b(ee),Q),this.t({type:K[0],id:K[1],data:Q})}}t(M){if(M.type===200){this.b=c.Idle,this.k.fire();return}this.f.get(M.id)?.(M)}get onDidInitializePromise(){return u.Event.toPromise(this.onDidInitialize)}u(){return this.b===c.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,a.$Oc)(this.d.values()),this.d.clear()}}e.$Vh=v,pe([A.$Kh],v.prototype,"onDidInitializePromise",null);class j{get connections(){const M=[];return this.f.forEach(H=>M.push(H)),M}constructor(M){this.a=new Map,this.f=new Set,this.g=new u.$6d,this.onDidAddConnection=this.g.event,this.h=new u.$6d,this.onDidRemoveConnection=this.h.event,this.j=new a.$Sc,this.j.add(M(({protocol:H,onDidClientDisconnect:K})=>{const Q=u.Event.once(H.onMessage);this.j.add(Q(ee=>{const C=new g(ee),z=l(C),f=new O(H,z),S=new v(H);this.a.forEach((F,W)=>f.registerChannel(W,F));const T={channelServer:f,channelClient:S,ctx:z};this.f.add(T),this.g.fire(T),this.j.add(K(()=>{f.dispose(),S.dispose(),this.f.delete(T),this.h.fire(T)}))}))}))}getChannel(M,H){const K=this;return{call(Q,ee,C){let z;if((0,d.$8f)(H)){const S=(0,N.$4b)(K.connections.filter(H));z=S?Promise.resolve(S):u.Event.toPromise(u.Event.filter(K.onDidAddConnection,H))}else z=H.routeCall(K,Q,ee);const f=z.then(S=>S.channelClient.getChannel(M));return Y(f).call(Q,ee,C)},listen(Q,ee){if((0,d.$8f)(H))return K.k(M,H,Q,ee);const C=H.routeEvent(K,Q,ee).then(z=>z.channelClient.getChannel(M));return Y(C).listen(Q,ee)}}}k(M,H,K,Q){const ee=this;let C;const z=new u.$6d({onWillAddFirstListener:()=>{C=new a.$Sc;const f=new u.$_d,S=new Map,T=W=>{const te=W.channelClient.getChannel(M).listen(K,Q),ce=f.add(te);S.set(W,ce)},F=W=>{const G=S.get(W);G&&(G.dispose(),S.delete(W))};ee.connections.filter(H).forEach(T),u.Event.filter(ee.onDidAddConnection,H)(T,void 0,C),ee.onDidRemoveConnection(F,void 0,C),f.event(z.fire,z,C),C.add(f)},onDidRemoveLastListener:()=>{C?.dispose(),C=void 0}});return z.event}registerChannel(M,H){this.a.set(M,H);for(const K of this.f)K.channelServer.registerChannel(M,H)}dispose(){this.j.dispose();for(const M of this.f)M.channelClient.dispose(),M.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$Wh=j;class q{constructor(M,H,K=null){const Q=new i;o(Q,H),M.send(Q.buffer),this.a=new v(M,K),this.d=new O(M,H,K)}getChannel(M){return this.a.getChannel(M)}registerChannel(M,H){this.d.registerChannel(M,H)}dispose(){this.a.dispose(),this.d.dispose()}}e.$Xh=q;function Y(U){return{call(M,H,K){return U.then(Q=>Q.call(M,H,K))},listen(M,H){const K=new u.$ce;return U.then(Q=>K.input=Q.listen(M,H)),K.event}}}e.$Yh=Y;function Z(U){let M=!1;return{call(H,K,Q){return M?U.call(H,K,Q):(0,D.$hh)(0).then(()=>M=!0).then(()=>U.call(H,K,Q))},listen(H,K){if(M)return U.listen(H,K);const Q=new u.$ce;return(0,D.$hh)(0).then(()=>M=!0).then(()=>Q.input=U.listen(H,K)),Q.event}}}e.$Zh=Z;class oe{constructor(M){this.a=M}routeCall(M){return this.b(M)}routeEvent(M){return this.b(M)}async b(M){for(const H of M.connections)if(await Promise.resolve(this.a(H.ctx)))return Promise.resolve(H);return await u.Event.toPromise(M.onDidAddConnection),await this.b(M)}}e.$1h=oe;var re;(function(U){function M(ee,C,z){const f=ee,S=z&&z.disableMarshalling,T=new Map;for(const F in f)K(F)&&T.set(F,u.Event.buffer(f[F],!0,void 0,C));return new class{listen(F,W,G){const te=T.get(W);if(te)return te;const ce=f[W];if(typeof ce=="function"){if(Q(W))return ce.call(f,G);if(K(W))return T.set(W,u.Event.buffer(f[W],!0,void 0,C)),T.get(W)}throw new P.$bb(`Event not found: ${W}`)}call(F,W,G){const te=f[W];if(typeof te=="function"){if(!S&&Array.isArray(G))for(let le=0;le<G.length;le++)G[le]=(0,y.$Ph)(G[le]);let ce=te.apply(f,G);return ce instanceof Promise||(ce=Promise.resolve(ce)),ce}throw new P.$bb(`Method not found: ${W}`)}}}U.fromService=M;function H(ee,C){const z=C&&C.disableMarshalling;return new Proxy({},{get(f,S){if(typeof S=="string")return C?.properties?.has(S)?C.properties.get(S):Q(S)?function(T){return ee.listen(S,T)}:K(S)?ee.listen(S):async function(...T){let F;C&&!(0,d.$3f)(C.context)?F=[C.context,...T]:F=T;const W=await ee.call(S,F);return z?W:(0,y.$Ph)(W)};throw new P.$bb(`Property not found: ${String(S)}`)}})}U.toService=H;function K(ee){return ee[0]==="o"&&ee[1]==="n"&&E.$jf(ee.charCodeAt(2))}function Q(ee){return/^onDynamic/.test(ee)&&E.$jf(ee.charCodeAt(9))}})(re||(e.ProxyChannel=re={}));const ue=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function fe(U){if(Array.isArray(U))return U;if(U&&typeof U=="object"&&typeof U.toString=="function"){const M=U.toString();if(M!=="[object Object]")return M}return U}function ae(U){return Array.isArray(U)?U.map(fe):fe(U)}function B(U,M,H,K,Q,ee,C){C=ae(C);const z=ue[Q],f=z[K%z.length];let S=[`%c[${U}]%c[${String(M).padStart(7," ")}]%c[len: ${String(H).padStart(5," ")}]%c${String(K).padStart(5," ")} - ${ee}`,"color: darkgreen","color: grey","color: grey",`color: ${f}`];/\($/.test(ee)?(S=S.concat(C),S.push(")")):S.push(C),console.log.apply(console,S)}class X{constructor(M,H){this.d=M,this.f=H,this.a=0,this.b=0}logOutgoing(M,H,K,Q,ee){this.b+=M,B(this.d,this.b,M,H,K,Q,ee)}logIncoming(M,H,K,Q,ee){this.a+=M,B(this.f,this.a,M,H,K,Q,ee)}}e.$2h=X}),define(ie[87],ne([0,1,58,9,14,20,82,7,6,2,27,56,55,57]),function(J,e,N,D,R,L,A,P,u,a,y,E,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gq=e.$Fq=void 0;class w extends m.$Uh{constructor(c){super({send:p=>{try{process.send?.(p.buffer.toString("base64"))}catch{}},onMessage:u.Event.fromNodeEventEmitter(process,"message",p=>R.$te.wrap(Buffer.from(p,"base64")))},c),process.once("disconnect",()=>this.dispose())}}e.$Fq=w;class k{constructor(c,p){this.i=c,this.j=p,this.c=new Set,this.g=new Map,this.h=new u.$6d,this.onDidProcessExit=this.h.event;const $=p&&p.timeout?p.timeout:6e4;this.b=new D.$dh($),this.d=null,this.f=null}getChannel(c){const p=this;return{call($,h,g){return p.k(c,$,h,g)},listen($,h){return p.l(c,$,h)}}}k(c,p,$,h=L.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(h.isCancellationRequested)return Promise.reject(P.$6());this.b.cancel();const g=this.n(c),i=(0,D.$6g)(n=>g.call(p,$,n)),r=h.onCancellationRequested(()=>i.cancel()),t=(0,a.$Rc)(()=>i.cancel());return this.c.add(t),i.finally(()=>{r.dispose(),this.c.delete(t),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),i}l(c,p,$){if(!this.b)return u.Event.None;this.b.cancel();let h;const g=new u.$6d({onWillAddFirstListener:()=>{h=this.n(c).listen(p,$)(g.fire,g),this.c.add(h)},onDidRemoveLastListener:()=>{this.c.delete(h),h.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return g.event}get m(){if(!this.f){const c=this.j&&this.j.args?this.j.args:[],p=Object.create(null);p.env={...(0,y.$Ln)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(p.env={...p.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(p.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(p.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(p.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),p.execArgv===void 0&&(p.execArgv=process.execArgv.filter(s=>!/^--inspect(-brk)?=/.test(s)).filter(s=>!s.startsWith("--vscode-"))),(0,d.$4l)(p.env),this.d=(0,N.fork)(this.i,c,p);const $=new u.$6d;u.Event.fromNodeEventEmitter(this.d,"message",s=>s)(s=>{if((0,A.$Bq)(s)){(0,A.log)(s,`IPC Library: ${this.j.serverName}`);return}$.fire(R.$te.wrap(Buffer.from(s,"base64")))});const g=this.j.useQueue?(0,E.$6l)(this.d):this.d,i=s=>this.d&&this.d.connected&&g.send(s.buffer.toString("base64")),r=$.event,t={send:i,onMessage:r};this.f=new m.$Vh(t);const n=()=>this.o();process.once("exit",n),this.d.on("error",s=>console.warn('IPC "'+this.j.serverName+'" errored with '+s)),this.d.on("exit",(s,o)=>{process.removeListener("exit",n),this.c.forEach(l=>(0,a.$Oc)(l)),this.c.clear(),s!==0&&o!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+s+" and signal "+o),this.b?.cancel(),this.o(),this.h.fire({code:s,signal:o})})}return this.f}n(c){let p=this.g.get(c);return p||(p=this.m.getChannel(c),this.g.set(c,p)),p}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$Gq=k}),define(ie[88],ne([0,1,9,6,2,47,3]),function(J,e,N,D,R,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gp=e.$Fp=e.StorageState=e.$Ep=e.StorageHint=void 0;var P;(function(d){d[d.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",d[d.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(P||(e.StorageHint=P={}));function u(d){const m=d;return m?.changed instanceof Map||m?.deleted instanceof Set}e.$Ep=u;var a;(function(d){d[d.None=0]="None",d[d.Initialized=1]="Initialized",d[d.Closed=2]="Closed"})(a||(e.StorageState=a={}));class y extends R.$Tc{static{this.a=100}constructor(m,w=Object.create(null)){super(),this.r=m,this.s=w,this.b=this.B(new D.$9d),this.onDidChangeStorage=this.b.event,this.c=a.None,this.f=new Map,this.g=this.B(new N.$eh(y.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(m=>this.u(m)))}u(m){this.b.pause();try{m.changed?.forEach((w,k)=>this.w(k,w)),m.deleted?.forEach(w=>this.w(w,void 0))}finally{this.b.resume()}}w(m,w){if(this.c===a.Closed)return;let k=!1;(0,A.$3f)(w)?k=this.f.delete(m):this.f.get(m)!==w&&(this.f.set(m,w),k=!0),k&&this.b.fire({key:m,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===a.None&&(this.c=a.Initialized,this.s.hint!==P.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(m,w){const k=this.f.get(m);return(0,A.$3f)(k)?w:k}getBoolean(m,w){const k=this.get(m);return(0,A.$3f)(k)?w:k==="true"}getNumber(m,w){const k=this.get(m);return(0,A.$3f)(k)?w:parseInt(k,10)}getObject(m,w){const k=this.get(m);return(0,A.$3f)(k)?w:(0,L.$Oh)(k)}async set(m,w,k=!1){if(this.c===a.Closed)return;if((0,A.$3f)(w))return this.delete(m,k);const b=(0,A.$Vf)(w)||Array.isArray(w)?(0,L.$Nh)(w):String(w);if(this.f.get(m)!==b)return this.f.set(m,b),this.j.set(m,b),this.h.delete(m),this.b.fire({key:m,external:k}),this.D()}async delete(m,w=!1){if(!(this.c===a.Closed||!this.f.delete(m)))return this.h.has(m)||this.h.add(m),this.j.delete(m),this.b.fire({key:m,external:w}),this.D()}async optimize(){if(this.c!==a.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=a.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const m={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(m).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(m){if(this.z)return this.D(m)}async D(m){return this.s.hint===P.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),m)}async whenFlushed(){if(this.z)return new Promise(m=>this.n.push(m))}isInMemory(){return this.s.hint===P.STORAGE_IN_MEMORY}}e.$Fp=y;class E{constructor(){this.onDidChangeItemsExternal=D.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(m){m.insert?.forEach((w,k)=>this.a.set(k,w)),m.delete?.forEach(w=>this.a.delete(w))}async optimize(){}async close(){}}e.$Gp=E}),define(ie[89],ne([8,5]),function(J,e){return J.create("vs/base/node/zip",e)}),define(ie[49],ne([0,1,90,9,16,3,24,89]),function(J,e,N,D,R,L,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5p=e.$4p=e.zip=e.$2p=e.$1p=void 0,e.$1p="end of central directory record signature not found";const u=new RegExp(e.$1p);class a extends Error{constructor(g,i){let r=i.message;switch(g){case"CorruptZip":r=`Corrupt ZIP: ${r}`;break}super(r),this.type=g,this.cause=i}}e.$2p=a;function y(h){const g=h.externalFileAttributes>>16||33188;return[448,56,7].map(i=>g&i).reduce((i,r)=>i+r,g&61440)}function E(h){if(h instanceof a)return h;let g;return u.test(h.message)&&(g="CorruptZip"),new a(g,h)}function d(h,g,i,r,t,n){const s=R.$mc(g),o=R.$jc(r,s);if(!o.startsWith(r))return Promise.reject(new Error(P.localize(0,null,g)));const l=R.$jc(r,g);let O;return n.onCancellationRequested(()=>{O?.destroy()}),Promise.resolve(A.Promises.mkdir(o,{recursive:!0})).then(()=>new Promise((I,v)=>{if(!n.isCancellationRequested)try{O=(0,N.createWriteStream)(l,{mode:i}),O.once("close",()=>I()),O.once("error",v),h.once("error",v),h.pipe(O)}catch(j){v(j)}}))}function m(h,g,i,r){let t=(0,D.$6g)(()=>Promise.resolve()),n=0;const s=r.onCancellationRequested(()=>{t.cancel(),h.close()});return new Promise((o,l)=>{const O=new D.$bh,I=v=>{v.isCancellationRequested||(n++,h.readEntry())};h.once("error",l),h.once("close",()=>t.then(()=>{r.isCancellationRequested||h.entryCount===n?o():l(new a("Incomplete",new Error(P.localize(1,null,n,h.entryCount))))},l)),h.readEntry(),h.on("entry",v=>{if(r.isCancellationRequested)return;if(!i.sourcePathRegex.test(v.fileName)){I(r);return}const j=v.fileName.replace(i.sourcePathRegex,"");if(/\/$/.test(j)){const Z=R.$jc(g,j);t=(0,D.$6g)(oe=>A.Promises.mkdir(Z,{recursive:!0}).then(()=>I(oe)).then(void 0,l));return}const q=k(h,v),Y=y(v);t=(0,D.$6g)(Z=>O.queue(()=>q.then(oe=>d(oe,j,Y,g,i,Z).then(()=>I(Z)))).then(null,l))})}).finally(()=>s.dispose())}async function w(h,g=!1){const{open:i}=await new Promise((r,t)=>{J(["yauzl"],r,t)});return new Promise((r,t)=>{i(h,g?{lazyEntries:!0}:void 0,(n,s)=>{n?t(E(n)):r((0,L.$5f)(s))})})}function k(h,g){return new Promise((i,r)=>{h.openReadStream(g,(t,n)=>{t?r(E(t)):i((0,L.$5f)(n))})})}async function b(h,g){const{ZipFile:i}=await new Promise((r,t)=>{J(["yazl"],r,t)});return new Promise((r,t)=>{const n=new i;g.forEach(o=>{o.contents?n.addBuffer(typeof o.contents=="string"?Buffer.from(o.contents,"utf8"):o.contents,o.path):o.localPath&&n.addFile(o.localPath,o.path)}),n.end();const s=(0,N.createWriteStream)(h);n.outputStream.pipe(s),n.outputStream.once("error",t),s.once("error",t),s.once("finish",()=>r(h))})}e.zip=b;function c(h,g,i={},r){const t=new RegExp(i.sourcePath?`^${i.sourcePath}`:"");let n=w(h,!0);return i.overwrite&&(n=n.then(s=>A.Promises.rm(g).then(()=>s))),n.then(s=>m(s,g,{sourcePathRegex:t},r))}e.$4p=c;function p(h,g){return w(h).then(i=>new Promise((r,t)=>{i.on("entry",n=>{n.fileName===g&&k(i,n).then(s=>r(s),s=>t(s))}),i.once("close",()=>t(new Error(P.localize(2,null,g))))}))}function $(h,g){return p(h,g).then(i=>new Promise((r,t)=>{const n=[];i.once("error",t),i.on("data",s=>n.push(s)),i.on("end",()=>r(Buffer.concat(n)))}))}e.$5p=$}),define(ie[91],ne([8,5]),function(J,e){return J.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ie[92],ne([8,5]),function(J,e){return J.create("vs/platform/contextkey/common/contextkey",e)}),define(ie[93],ne([8,5]),function(J,e){return J.create("vs/platform/contextkey/common/scanner",e)}),define(ie[94],ne([8,5]),function(J,e){return J.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(ie[95],ne([8,5]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ie[96],ne([8,5]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(ie[97],ne([8,5]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ie[98],ne([8,5]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ie[99],ne([8,5]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(ie[100],ne([8,5]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(ie[101],ne([8,5]),function(J,e){return J.create("vs/platform/extensions/common/extensionValidator",e)}),define(ie[102],ne([8,5]),function(J,e){return J.create("vs/platform/files/common/fileService",e)}),define(ie[103],ne([8,5]),function(J,e){return J.create("vs/platform/files/common/io",e)}),define(ie[104],ne([8,5]),function(J,e){return J.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ie[105],ne([8,5]),function(J,e){return J.create("vs/platform/languagePacks/common/languagePacks",e)}),define(ie[106],ne([8,5]),function(J,e){return J.create("vs/platform/request/common/request",e)}),define(ie[107],ne([8,5]),function(J,e){return J.create("vs/platform/shell/node/shellEnv",e)}),define(ie[108],ne([8,5]),function(J,e){return J.create("vs/platform/telemetry/common/telemetryService",e)}),define(ie[109],ne([8,5]),function(J,e){return J.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ie[110],ne([8,5]),function(J,e){return J.create("vs/platform/workspace/common/workspace",e)}),define(ie[111],ne([0,1,7,93]),function(J,e,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bj=e.TokenType=void 0;var R;(function(a){a[a.LParen=0]="LParen",a[a.RParen=1]="RParen",a[a.Neg=2]="Neg",a[a.Eq=3]="Eq",a[a.NotEq=4]="NotEq",a[a.Lt=5]="Lt",a[a.LtEq=6]="LtEq",a[a.Gt=7]="Gt",a[a.GtEq=8]="GtEq",a[a.RegexOp=9]="RegexOp",a[a.RegexStr=10]="RegexStr",a[a.True=11]="True",a[a.False=12]="False",a[a.In=13]="In",a[a.Not=14]="Not",a[a.And=15]="And",a[a.Or=16]="Or",a[a.Str=17]="Str",a[a.QuotedStr=18]="QuotedStr",a[a.Error=19]="Error",a[a.EOF=20]="EOF"})(R||(e.TokenType=R={}));function L(...a){switch(a.length){case 1:return(0,D.localize)(0,null,a[0]);case 2:return(0,D.localize)(1,null,a[0],a[1]);case 3:return(0,D.localize)(2,null,a[0],a[1],a[2]);default:return}}const A=(0,D.localize)(3,null),P=(0,D.localize)(4,null);class u{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(y){switch(y.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return y.isTripleEq?"===":"==";case 4:return y.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return y.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return y.lexeme;case 18:return y.lexeme;case 19:return y.lexeme;case 20:return"EOF";default:throw(0,N.$8)(`unhandled token type: ${JSON.stringify(y)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(y=>y.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(y){return this.c=y,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const E=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:E})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const E=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:E})}else this.h(126)?this.k(9):this.l(L("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(L("&&"));break;case 124:this.h(124)?this.k(16):this.l(L("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(y){return this.r()||this.c.charCodeAt(this.e)!==y?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(y){this.f.push({type:y,offset:this.d})}l(y){const E=this.d,d=this.c.substring(this.d,this.e),m={type:19,offset:this.d,lexeme:d};this.g.push({offset:E,lexeme:d,additionalInfo:y}),this.f.push(m)}n(){this.m.lastIndex=this.d;const y=this.m.exec(this.c);if(y){this.e=this.d+y[0].length;const E=this.c.substring(this.d,this.e),d=u.b.get(E);d?this.k(d):this.f.push({type:17,lexeme:E,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(A);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let y=this.e,E=!1,d=!1;for(;;){if(y>=this.c.length){this.e=y,this.l(P);return}const w=this.c.charCodeAt(y);if(E)E=!1;else if(w===47&&!d){y++;break}else w===91?d=!0:w===92?E=!0:w===93&&(d=!1);y++}for(;y<this.c.length&&u.a.has(this.c.charCodeAt(y));)y++;this.e=y;const m=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:m,offset:this.d})}r(){return this.e>=this.c.length}}e.$bj=u}),define(ie[112],ne([0,1,78,53,15,16,35,17,11]),function(J,e,N,D,R,L,A,P,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qm=e.$Pm=e.$Om=e.$Nm=void 0,e.$Nm=/^([^.]+\..+)[:=](.+)$/;class a{get appRoot(){return(0,L.$mc)(R.$Ag.asFileUri("").fsPath)}get userHome(){return u.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return u.URI.file((0,L.$jc)(this.userDataPath,"User"))}get tmpDir(){return u.URI.file(this.b.tmpDir)}get cacheHome(){return u.URI.file(this.userDataPath)}get stateResource(){return(0,P.$Tg)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:R.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,P.$Tg)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const m=(0,N.$Mm)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,L.$jc)(this.userDataPath,"logs",m)}return u.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.$Tg)(u.URI.file((0,L.$jc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,P.$Tg)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,P.$Tg)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,P.$Tg)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const m=A.env.VSCODE_PORTABLE;return m?u.URI.file((0,L.$jc)(m,"argv.json")):(0,P.$Tg)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return u.URI.file((0,L.$jc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const m=this.args["builtin-extensions-dir"];return m?(0,L.$kc)(m):(0,L.$hc)((0,L.$jc)(R.$Ag.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const m=this.args["extensions-download-dir"];return m?u.URI.file((0,L.$kc)(m)):u.URI.file((0,L.$jc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const m=this.args["extensions-dir"];if(m)return(0,L.$kc)(m);const w=A.env.VSCODE_EXTENSIONS;if(w)return w;const k=A.env.VSCODE_PORTABLE;return k?(0,L.$jc)(k,"extensions"):(0,P.$Tg)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const m=this.args.extensionDevelopmentPath;if(Array.isArray(m))return m.map(w=>/^[^:/?#]+?:\/\//.test(w)?u.URI.parse(w):u.URI.file((0,L.$hc)(w)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(m=>m==="ui"||m==="workspace"||m==="web"?m:"workspace")}get extensionTestsLocationURI(){const m=this.args.extensionTestsPath;if(m)return/^[^:/?#]+?:\/\//.test(m)?u.URI.parse(m):u.URI.file((0,L.$hc)(m))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const m=this.args["disable-extension"];if(m){if(typeof m=="string")return[m];if(Array.isArray(m)&&m.length>0)return m}return!1}get debugExtensionHost(){return y(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!A.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(m=>!e.$Nm.test(m))}get extensionLogLevel(){const m=[];for(const w of this.args.log||[]){const k=e.$Nm.exec(w);k&&k[1]&&k[2]&&m.push([k[1],k[2]])}return m.length?m:void 0}get serviceMachineIdResource(){return(0,P.$Tg)(u.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const m=A.env.VSCODE_PORTABLE;return m?u.URI.file((0,L.$jc)(m,"policy.json")):(0,P.$Tg)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(m){this.args.continueOn=m}get args(){return this.a}constructor(m,w,k){this.a=m,this.b=w,this.c=k,this.editSessionId=this.args.editSessionId}}e.$Om=a,pe([D.$Kh],a.prototype,"appRoot",null),pe([D.$Kh],a.prototype,"userHome",null),pe([D.$Kh],a.prototype,"userDataPath",null),pe([D.$Kh],a.prototype,"appSettingsHome",null),pe([D.$Kh],a.prototype,"tmpDir",null),pe([D.$Kh],a.prototype,"cacheHome",null),pe([D.$Kh],a.prototype,"stateResource",null),pe([D.$Kh],a.prototype,"userRoamingDataHome",null),pe([D.$Kh],a.prototype,"userDataSyncHome",null),pe([D.$Kh],a.prototype,"sync",null),pe([D.$Kh],a.prototype,"machineSettingsResource",null),pe([D.$Kh],a.prototype,"workspaceStorageHome",null),pe([D.$Kh],a.prototype,"localHistoryHome",null),pe([D.$Kh],a.prototype,"keyboardLayoutResource",null),pe([D.$Kh],a.prototype,"argvResource",null),pe([D.$Kh],a.prototype,"isExtensionDevelopment",null),pe([D.$Kh],a.prototype,"untitledWorkspacesHome",null),pe([D.$Kh],a.prototype,"builtinExtensionsPath",null),pe([D.$Kh],a.prototype,"extensionsPath",null),pe([D.$Kh],a.prototype,"extensionDevelopmentLocationURI",null),pe([D.$Kh],a.prototype,"extensionDevelopmentKind",null),pe([D.$Kh],a.prototype,"extensionTestsLocationURI",null),pe([D.$Kh],a.prototype,"debugExtensionHost",null),pe([D.$Kh],a.prototype,"logLevel",null),pe([D.$Kh],a.prototype,"extensionLogLevel",null),pe([D.$Kh],a.prototype,"serviceMachineIdResource",null),pe([D.$Kh],a.prototype,"disableTelemetry",null),pe([D.$Kh],a.prototype,"disableWorkspaceTrust",null),pe([D.$Kh],a.prototype,"useInMemorySecretStorage",null),pe([D.$Kh],a.prototype,"policyFile",null);function y(d,m){return E(d["inspect-extensions"],d["inspect-brk-extensions"],5870,m,d.debugId,d.extensionEnvironment)}e.$Pm=y;function E(d,m,w,k,b,c){const $=Number(m||d)||(k?null:w),h=$?!!m:!1;let g;if(c)try{g=JSON.parse(c)}catch{}return{port:$,break:h,debugId:b,env:g}}e.$Qm=E}),function(){"use strict";function J(e,N,D){function R(A,P){const u=L(A,P),a=[u];return e.isAbsolute(u)||a.unshift(D),e.resolve(...a)}function L(A,P){process.env.VSCODE_DEV&&(P="code-oss-dev");const u=process.env.VSCODE_PORTABLE;if(u)return e.join(u,"user-data");let a=process.env.VSCODE_APPDATA;if(a)return e.join(a,P);const y=A["user-data-dir"];if(y)return y;switch(process.platform){case"win32":if(a=process.env.APPDATA,!a){const E=process.env.USERPROFILE;if(typeof E!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");a=e.join(E,"AppData","Roaming")}break;case"darwin":a=e.join(N.homedir(),"Library","Application Support");break;case"linux":a=process.env.XDG_CONFIG_HOME||e.join(N.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(a,P)}return{getUserDataPath:R}}if(typeof define=="function")define(ie[113],ne([167,33,35]),function(e,N,D){return J(e,N,D.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),N=require("os");module.exports=J(e,N,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ie[114],ne([0,1,33,112,113]),function(J,e,N,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tm=e.$Sm=e.$Rm=void 0;class L extends D.$Om{constructor(a,y){super(a,{homeDir:(0,N.homedir)(),tmpDir:(0,N.tmpdir)(),userDataDir:(0,R.getUserDataPath)(a,y.nameShort)},y)}}e.$Rm=L;function A(u,a){return(0,D.$Qm)(u["inspect-ptyhost"],u["inspect-brk-ptyhost"],5877,a,u.extensionEnvironment)}e.$Sm=A;function P(u,a){return(0,D.$Qm)(u["inspect-sharedprocess"],u["inspect-brk-sharedprocess"],5879,a,u.extensionEnvironment)}e.$Tm=P}),define(ie[115],ne([0,1,3,97]),function(J,e,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bq=void 0;function R(A,P,u,a){try{L(A,P,u,a)}catch(y){A.error(y?.message??y)}return P}e.$bq=R;function L(A,P,u,a){const y=(E,d,m)=>{const w=E[d];if((0,N.$Tf)(w)){const k=w,b=k.length;if(b>1&&k[0]==="%"&&k[b-1]==="%"){const c=k.substr(1,b-2);let p=u[c];p===void 0&&a&&(p=a[c]);const $=typeof p=="string"?p:p?.message,h=a?.[c],g=typeof h=="string"?h:h?.message;if(!$){g||A.warn(`[${P.name}]: ${(0,D.localize)(0,null,c)}`);return}if(m&&(d==="title"||d==="category")&&g&&g!==$){const i={value:$,original:g};E[d]=i}else E[d]=$}}else if((0,N.$Vf)(w))for(const k in w)w.hasOwnProperty(k)&&(k==="commands"?y(w,k,!0):y(w,k,m));else if(Array.isArray(w))for(let k=0;k<w.length;k++)y(w,k,m)};for(const E in P)P.hasOwnProperty(E)&&y(P,E)}}),define(ie[116],ne([0,1,49,100]),function(J,e,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jq=void 0;function R(L){return(0,N.$5p)(L,"extension/package.json").then(A=>{try{return JSON.parse(A.toString("utf8"))}catch{throw new Error((0,D.localize)(0,null))}})}e.$jq=R}),define(ie[50],ne([0,1,17,54,101,44]),function(J,e,N,D,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vp=e.$up=e.$tp=e.$sp=e.$rp=e.$qp=e.$pp=void 0;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,P=/^-(\d{4})(\d{2})(\d{2})$/;function u(c){return c=c.trim(),c==="*"||A.test(c)}e.$pp=u;function a(c){if(!u(c))return null;if(c=c.trim(),c==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const p=c.match(A);return p?{hasCaret:p[1]==="^",hasGreaterEquals:p[1]===">=",majorBase:p[2]==="x"?0:parseInt(p[2],10),majorMustEqual:p[2]!=="x",minorBase:p[4]==="x"?0:parseInt(p[4],10),minorMustEqual:p[4]!=="x",patchBase:p[6]==="x"?0:parseInt(p[6],10),patchMustEqual:p[6]!=="x",preRelease:p[8]||null}:null}e.$qp=a;function y(c){if(!c)return null;const p=c.majorBase,$=c.majorMustEqual,h=c.minorBase;let g=c.minorMustEqual;const i=c.patchBase;let r=c.patchMustEqual;c.hasCaret&&(p===0||(g=!1),r=!1);let t=0;if(c.preRelease){const n=P.exec(c.preRelease);if(n){const[,s,o,l]=n;t=Date.UTC(Number(s),Number(o)-1,Number(l))}}return{majorBase:p,majorMustEqual:$,minorBase:h,minorMustEqual:g,patchBase:i,patchMustEqual:r,isMinimum:c.hasGreaterEquals,notBefore:t}}e.$rp=y;function E(c,p,$){let h;typeof c=="string"?h=y(a(c)):h=c;let g;p instanceof Date?g=p.getTime():typeof p=="string"&&(g=new Date(p).getTime());let i;if(typeof $=="string"?i=y(a($)):i=$,!h||!i)return!1;const r=h.majorBase,t=h.minorBase,n=h.patchBase;let s=i.majorBase,o=i.minorBase,l=i.patchBase;const O=i.notBefore;let I=i.majorMustEqual,v=i.minorMustEqual,j=i.patchMustEqual;return i.isMinimum?r>s?!0:r<s?!1:t>o?!0:t<o||g&&g<O?!1:n>=l:(r===1&&s===0&&(!I||!v||!j)&&(s=1,o=0,l=0,I=!0,v=!1,j=!1),r<s?!1:r>s?!I:t<o?!1:t>o?!v:n<l?!1:n>l?!j:!(g&&g<O))}e.$sp=E;function d(c,p,$,h,g){const i=[];if(typeof h.publisher<"u"&&typeof h.publisher!="string")return i.push([D.default.Error,R.localize(0,null)]),i;if(typeof h.name!="string")return i.push([D.default.Error,R.localize(1,null,"name")]),i;if(typeof h.version!="string")return i.push([D.default.Error,R.localize(2,null,"version")]),i;if(!h.engines)return i.push([D.default.Error,R.localize(3,null,"engines")]),i;if(typeof h.engines.vscode!="string")return i.push([D.default.Error,R.localize(4,null,"engines.vscode")]),i;if(typeof h.extensionDependencies<"u"&&!b(h.extensionDependencies))return i.push([D.default.Error,R.localize(5,null,"extensionDependencies")]),i;if(typeof h.activationEvents<"u"){if(!b(h.activationEvents))return i.push([D.default.Error,R.localize(6,null,"activationEvents")]),i;if(typeof h.main>"u"&&typeof h.browser>"u")return i.push([D.default.Error,R.localize(7,null,"activationEvents","main","browser")]),i}if(typeof h.extensionKind<"u"&&typeof h.main>"u"&&i.push([D.default.Warning,R.localize(8,null,"extensionKind")]),typeof h.main<"u"){if(typeof h.main!="string")return i.push([D.default.Error,R.localize(9,null,"main")]),i;{const n=(0,N.$Tg)($,h.main);(0,N.$Ng)(n,$)||i.push([D.default.Warning,R.localize(10,null,n.path,$.path)])}}if(typeof h.browser<"u"){if(typeof h.browser!="string")return i.push([D.default.Error,R.localize(11,null,"browser")]),i;{const n=(0,N.$Tg)($,h.browser);(0,N.$Ng)(n,$)||i.push([D.default.Warning,R.localize(12,null,n.path,$.path)])}}if(!L.valid(h.version))return i.push([D.default.Error,R.localize(13,null)]),i;const r=[];if(!m(c,p,h,g,r))for(const n of r)i.push([D.default.Error,n]);return i}e.$tp=d;function m(c,p,$,h,g){return h||typeof $.main>"u"&&typeof $.browser>"u"?!0:k(c,p,$.engines.vscode,g)}e.$up=m;function w(c,p,$){return c==="*"||k(p,$,c)}e.$vp=w;function k(c,p,$,h=[]){const g=y(a($));if(!g)return h.push(R.localize(14,null,$)),!1;if(g.majorBase===0){if(!g.majorMustEqual||!g.minorMustEqual)return h.push(R.localize(15,null,$)),!1}else if(!g.majorMustEqual)return h.push(R.localize(16,null,$)),!1;return E(c,p,g)?!0:(h.push(R.localize(17,null,c,$)),!1)}function b(c){if(!Array.isArray(c))return!1;for(let p=0,$=c.length;p<$;p++)if(typeof c[p]!="string")return!1;return!0}}),define(ie[117],ne([0,1,14,28]),function(J,e,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pp=void 0;async function R(L,A,P){let u=P&&P.get("storage.serviceMachineId",-1)||null;if(u)return u;try{const y=(await A.readFile(L.serviceMachineIdResource)).value.toString();u=(0,D.$Bg)(y)?y:null}catch{u=null}if(!u){u=(0,D.$Cg)();try{await A.writeFile(L.serviceMachineIdResource,N.$te.fromString(u))}catch{}}return P?.store("storage.serviceMachineId",u,-1,1),u}e.$Pp=R}),define(ie[51],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$di=void 0;class N{constructor(R,L=[],A=!1){this.ctor=R,this.staticArguments=L,this.supportsDelayedInstantiation=A}}e.$di=N}),define(ie[118],ne([0,1,51]),function(J,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cs=e.$bs=e.InstantiationType=void 0;const D=[];var R;(function(P){P[P.Eager=0]="Eager",P[P.Delayed=1]="Delayed"})(R||(e.InstantiationType=R={}));function L(P,u,a){u instanceof N.$di||(u=new N.$di(u,[],!!a)),D.push([P,u])}e.$bs=L;function A(){return D}e.$cs=A}),define(ie[119],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sq=e.$Rq=void 0;class N{constructor(L,A){this.key=L,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.$Rq=N;class D{constructor(L){this.b=L,this.a=new Map}roots(){const L=[];for(const A of this.a.values())A.outgoing.size===0&&L.push(A);return L}insertEdge(L,A){const P=this.lookupOrInsertNode(L),u=this.lookupOrInsertNode(A);P.outgoing.set(u.key,u),u.incoming.set(P.key,P)}removeNode(L){const A=this.b(L);this.a.delete(A);for(const P of this.a.values())P.outgoing.delete(A),P.incoming.delete(A)}lookupOrInsertNode(L){const A=this.b(L);let P=this.a.get(A);return P||(P=new N(A,L),this.a.set(A,P)),P}lookup(L){return this.a.get(this.b(L))}isEmpty(){return this.a.size===0}toString(){const L=[];for(const[A,P]of this.a)L.push(`${A}
	(-> incoming)[${[...P.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...P.outgoing.keys()].join(",")}]
`);return L.join(`
`)}findCycleSlow(){for(const[L,A]of this.a){const P=new Set([L]),u=this.c(A,P);if(u)return u}}c(L,A){for(const[P,u]of L.outgoing){if(A.has(P))return[...A,P].join(" -> ");A.add(P);const a=this.c(u,A);if(a)return a;A.delete(P)}}}e.$Sq=D}),define(ie[29],ne([0,1,3,11,10]),function(J,e,N,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.ConfigurationTarget=e.$Oi=e.$Ni=e.$Mi=void 0,e.$Mi=(0,R.$gi)("configurationService");function L(c){return c&&typeof c=="object"&&(!c.overrideIdentifier||typeof c.overrideIdentifier=="string")&&(!c.resource||c.resource instanceof D.URI)}e.$Ni=L;function A(c){return c&&typeof c=="object"&&(!c.overrideIdentifiers||Array.isArray(c.overrideIdentifiers))&&!c.overrideIdentifier&&(!c.resource||c.resource instanceof D.URI)}e.$Oi=A;var P;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.USER=2]="USER",c[c.USER_LOCAL=3]="USER_LOCAL",c[c.USER_REMOTE=4]="USER_REMOTE",c[c.WORKSPACE=5]="WORKSPACE",c[c.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",c[c.DEFAULT=7]="DEFAULT",c[c.MEMORY=8]="MEMORY"})(P||(e.ConfigurationTarget=P={}));function u(c){switch(c){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$Pi=u;function a(c){return c.applicationValue!==void 0||c.userValue!==void 0||c.userLocalValue!==void 0||c.userRemoteValue!==void 0||c.workspaceValue!==void 0||c.workspaceFolderValue!==void 0}e.$Qi=a;function y(c,p){const $=Object.create(null);for(const h in c)E($,h,c[h],p);return $}e.$Ri=y;function E(c,p,$,h){const g=p.split("."),i=g.pop();let r=c;for(let t=0;t<g.length;t++){const n=g[t];let s=r[n];switch(typeof s){case"undefined":s=r[n]=Object.create(null);break;case"object":break;default:h(`Ignoring ${p} as ${g.slice(0,t+1).join(".")} is ${JSON.stringify(s)}`);return}r=s}if(typeof r=="object"&&r!==null)try{r[i]=$}catch{h(`Ignoring ${p} as ${g.join(".")} is ${JSON.stringify(r)}`)}else h(`Ignoring ${p} as ${g.join(".")} is ${JSON.stringify(r)}`)}e.$Si=E;function d(c,p){const $=p.split(".");m(c,$)}e.$Ti=d;function m(c,p){const $=p.shift();if(p.length===0){delete c[$];return}if(Object.keys(c).indexOf($)!==-1){const h=c[$];typeof h=="object"&&!Array.isArray(h)&&(m(h,p),Object.keys(h).length===0&&delete c[$])}}function w(c,p,$){function h(r,t){let n=r;for(const s of t){if(typeof n!="object"||n===null)return;n=n[s]}return n}const g=p.split("."),i=h(c,g);return typeof i>"u"?$:i}e.$Ui=w;function k(c,p,$){Object.keys(p).forEach(h=>{h!=="__proto__"&&(h in c?N.$Vf(c[h])&&N.$Vf(p[h])?k(c[h],p[h],$):$&&(c[h]=p[h]):c[h]=p[h])})}e.$Vi=k;function b(c){return c.replace(/[\[\]]/g,"")}e.$Wi=b}),define(ie[120],ne([0,1,12,30,111,10,92,7]),function(J,e,N,D,R,L,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.ContextKeyExprType=e.$cj=void 0;const u=new Map;u.set("false",!1),u.set("true",!0),u.set("isMac",N.$j),u.set("isLinux",N.$k),u.set("isWindows",N.$i),u.set("isWeb",N.$o),u.set("isMacNative",N.$j&&!N.$o),u.set("isEdge",N.$H),u.set("isFirefox",N.$F),u.set("isChrome",N.$E),u.set("isSafari",N.$G);function a(z,f){if(u.get(z)!==void 0)throw(0,P.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");u.set(z,f)}e.$cj=a;const y=Object.prototype.hasOwnProperty;var E;(function(z){z[z.False=0]="False",z[z.True=1]="True",z[z.Defined=2]="Defined",z[z.Not=3]="Not",z[z.Equals=4]="Equals",z[z.NotEquals=5]="NotEquals",z[z.And=6]="And",z[z.Regex=7]="Regex",z[z.NotRegex=8]="NotRegex",z[z.Or=9]="Or",z[z.In=10]="In",z[z.NotIn=11]="NotIn",z[z.Greater=12]="Greater",z[z.GreaterEquals=13]="GreaterEquals",z[z.Smaller=14]="Smaller",z[z.SmallerEquals=15]="SmallerEquals"})(E||(e.ContextKeyExprType=E={}));const d={regexParsingWithErrorRecovery:!0},m=(0,A.localize)(0,null),w=(0,A.localize)(1,null),k=(0,A.localize)(2,null),b=(0,A.localize)(3,null),c=(0,A.localize)(4,null),p=(0,A.localize)(5,null),$=(0,A.localize)(6,null),h=(0,A.localize)(7,null);class g{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(f=d){this.k=f,this.d=new R.$bj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(f){if(f===""){this.h.push({message:m,offset:0,lexeme:"",additionalInfo:w});return}this.f=this.d.reset(f).scan(),this.g=0,this.h=[];try{const S=this.l();if(!this.E()){const T=this.D(),F=T.type===17?p:void 0;throw this.h.push({message:c,offset:T.offset,lexeme:R.$bj.getLexeme(T),additionalInfo:F}),g.c}return S}catch(S){if(S!==g.c)throw S;return}}l(){return this.m()}m(){const f=[this.o()];for(;this.y(16);){const S=this.o();f.push(S)}return f.length===1?f[0]:i.or(...f)}o(){const f=[this.s()];for(;this.y(15);){const S=this.s();f.push(S)}return f.length===1?f[0]:i.and(...f)}s(){if(this.y(2)){const f=this.D();switch(f.type){case 11:return this.z(),s.INSTANCE;case 12:return this.z(),o.INSTANCE;case 0:{this.z();const S=this.l();return this.A(1,b),S?.negate()}case 17:return this.z(),q.create(f.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",f)}}return this.t()}t(){const f=this.D();switch(f.type){case 11:return this.z(),i.true();case 12:return this.z(),i.false();case 0:{this.z();const S=this.l();return this.A(1,b),S}case 17:{const S=f.lexeme;if(this.z(),this.y(9)){const F=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),F.type!==10)throw this.B("REGEX",F);const W=F.lexeme,G=W.lastIndexOf("/"),te=G===W.length-1?void 0:this.w(W.substring(G+1));let ce;try{ce=new RegExp(W.substring(1,G),te)}catch{throw this.B("REGEX",F)}return fe.create(S,ce)}switch(F.type){case 10:case 19:{const W=[F.lexeme];this.z();let G=this.D(),te=0;for(let he=0;he<F.lexeme.length;he++)F.lexeme.charCodeAt(he)===40?te++:F.lexeme.charCodeAt(he)===41&&te--;for(;!this.E()&&G.type!==15&&G.type!==16;){switch(G.type){case 0:te++;break;case 1:te--;break;case 10:case 18:for(let he=0;he<G.lexeme.length;he++)G.lexeme.charCodeAt(he)===40?te++:F.lexeme.charCodeAt(he)===41&&te--}if(te<0)break;W.push(R.$bj.getLexeme(G)),this.z(),G=this.D()}const ce=W.join(""),le=ce.lastIndexOf("/"),$e=le===ce.length-1?void 0:this.w(ce.substring(le+1));let ye;try{ye=new RegExp(ce.substring(1,le),$e)}catch{throw this.B("REGEX",F)}return i.regex(S,ye)}case 18:{const W=F.lexeme;this.z();let G=null;if(!(0,D.$Te)(W)){const te=W.indexOf("/"),ce=W.lastIndexOf("/");if(te!==ce&&te>=0){const le=W.slice(te+1,ce),$e=W[ce+1]==="i"?"i":"";try{G=new RegExp(le,$e)}catch{throw this.B("REGEX",F)}}}if(G===null)throw this.B("REGEX",F);return fe.create(S,G)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,k);const F=this.u();return i.notIn(S,F)}switch(this.D().type){case 3:{this.z();const F=this.u();if(this.x().type===18)return i.equals(S,F);switch(F){case"true":return i.has(S);case"false":return i.not(S);default:return i.equals(S,F)}}case 4:{this.z();const F=this.u();if(this.x().type===18)return i.notEquals(S,F);switch(F){case"true":return i.not(S);case"false":return i.has(S);default:return i.notEquals(S,F)}}case 5:return this.z(),re.create(S,this.u());case 6:return this.z(),ue.create(S,this.u());case 7:return this.z(),Z.create(S,this.u());case 8:return this.z(),oe.create(S,this.u());case 13:return this.z(),i.in(S,this.u());default:return i.has(S)}}case 20:throw this.h.push({message:$,offset:f.offset,lexeme:"",additionalInfo:h}),g.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const f=this.D();switch(f.type){case 17:case 18:return this.z(),f.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(f){return f.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(f){return this.C(f)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(f,S){if(this.C(f))return this.z();throw this.B(S,this.D())}B(f,S,T){const F=(0,A.localize)(8,null,f,R.$bj.getLexeme(S)),W=S.offset,G=R.$bj.getLexeme(S);return this.h.push({message:F,offset:W,lexeme:G,additionalInfo:T}),g.c}C(f){return this.D().type===f}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$dj=g;class i{static false(){return s.INSTANCE}static true(){return o.INSTANCE}static has(f){return l.create(f)}static equals(f,S){return O.create(f,S)}static notEquals(f,S){return j.create(f,S)}static regex(f,S){return fe.create(f,S)}static in(f,S){return I.create(f,S)}static notIn(f,S){return v.create(f,S)}static not(f){return q.create(f)}static and(...f){return X.create(f,null,!0)}static or(...f){return U.create(f,null,!0)}static greater(f,S){return Z.create(f,S)}static greaterEquals(f,S){return oe.create(f,S)}static smaller(f,S){return re.create(f,S)}static smallerEquals(f,S){return ue.create(f,S)}static{this.c=new g({regexParsingWithErrorRecovery:!1})}static deserialize(f){return f==null?void 0:this.c.parse(f)}}e.$ej=i;function r(z){const f=new g({regexParsingWithErrorRecovery:!1});return z.map(S=>(f.parse(S),f.lexingErrors.length>0?f.lexingErrors.map(T=>({errorMessage:T.additionalInfo?(0,A.localize)(9,null,T.additionalInfo):(0,A.localize)(10,null),offset:T.offset,length:T.lexeme.length})):f.parsingErrors.length>0?f.parsingErrors.map(T=>({errorMessage:T.additionalInfo?`${T.message}. ${T.additionalInfo}`:T.message,offset:T.offset,length:T.lexeme.length})):[]))}e.$fj=r;function t(z,f){const S=z?z.substituteConstants():void 0,T=f?f.substituteConstants():void 0;return!S&&!T?!0:!S||!T?!1:S.equals(T)}e.$gj=t;function n(z,f){return z.cmp(f)}class s{static{this.INSTANCE=new s}constructor(){this.type=0}cmp(f){return this.type-f.type}equals(f){return f.type===this.type}substituteConstants(){return this}evaluate(f){return!1}serialize(){return"false"}keys(){return[]}map(f){return this}negate(){return o.INSTANCE}}e.$hj=s;class o{static{this.INSTANCE=new o}constructor(){this.type=1}cmp(f){return this.type-f.type}equals(f){return f.type===this.type}substituteConstants(){return this}evaluate(f){return!0}serialize(){return"true"}keys(){return[]}map(f){return this}negate(){return s.INSTANCE}}e.$ij=o;class l{static create(f,S=null){const T=u.get(f);return typeof T=="boolean"?T?o.INSTANCE:s.INSTANCE:new l(f,S)}constructor(f,S){this.key=f,this.c=S,this.type=2}cmp(f){return f.type!==this.type?this.type-f.type:H(this.key,f.key)}equals(f){return f.type===this.type?this.key===f.key:!1}substituteConstants(){const f=u.get(this.key);return typeof f=="boolean"?f?o.INSTANCE:s.INSTANCE:this}evaluate(f){return!!f.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(f){return f.mapDefined(this.key)}negate(){return this.c||(this.c=q.create(this.key,this)),this.c}}e.$jj=l;class O{static create(f,S,T=null){if(typeof S=="boolean")return S?l.create(f,T):q.create(f,T);const F=u.get(f);return typeof F=="boolean"?S===(F?"true":"false")?o.INSTANCE:s.INSTANCE:new O(f,S,T)}constructor(f,S,T){this.c=f,this.d=S,this.f=T,this.type=4}cmp(f){return f.type!==this.type?this.type-f.type:K(this.c,this.d,f.c,f.d)}equals(f){return f.type===this.type?this.c===f.c&&this.d===f.d:!1}substituteConstants(){const f=u.get(this.c);if(typeof f=="boolean"){const S=f?"true":"false";return this.d===S?o.INSTANCE:s.INSTANCE}return this}evaluate(f){return f.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(f){return f.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.$kj=O;class I{static create(f,S){return new I(f,S)}constructor(f,S){this.d=f,this.f=S,this.type=10,this.c=null}cmp(f){return f.type!==this.type?this.type-f.type:K(this.d,this.f,f.d,f.f)}equals(f){return f.type===this.type?this.d===f.d&&this.f===f.f:!1}substituteConstants(){return this}evaluate(f){const S=f.getValue(this.f),T=f.getValue(this.d);return Array.isArray(S)?S.includes(T):typeof T=="string"&&typeof S=="object"&&S!==null?y.call(S,T):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(f){return f.mapIn(this.d,this.f)}negate(){return this.c||(this.c=v.create(this.d,this.f)),this.c}}e.$lj=I;class v{static create(f,S){return new v(f,S)}constructor(f,S){this.d=f,this.f=S,this.type=11,this.c=I.create(f,S)}cmp(f){return f.type!==this.type?this.type-f.type:this.c.cmp(f.c)}equals(f){return f.type===this.type?this.c.equals(f.c):!1}substituteConstants(){return this}evaluate(f){return!this.c.evaluate(f)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(f){return f.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$mj=v;class j{static create(f,S,T=null){if(typeof S=="boolean")return S?q.create(f,T):l.create(f,T);const F=u.get(f);return typeof F=="boolean"?S===(F?"true":"false")?s.INSTANCE:o.INSTANCE:new j(f,S,T)}constructor(f,S,T){this.c=f,this.d=S,this.f=T,this.type=5}cmp(f){return f.type!==this.type?this.type-f.type:K(this.c,this.d,f.c,f.d)}equals(f){return f.type===this.type?this.c===f.c&&this.d===f.d:!1}substituteConstants(){const f=u.get(this.c);if(typeof f=="boolean"){const S=f?"true":"false";return this.d===S?s.INSTANCE:o.INSTANCE}return this}evaluate(f){return f.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(f){return f.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=O.create(this.c,this.d,this)),this.f}}e.$nj=j;class q{static create(f,S=null){const T=u.get(f);return typeof T=="boolean"?T?s.INSTANCE:o.INSTANCE:new q(f,S)}constructor(f,S){this.c=f,this.d=S,this.type=3}cmp(f){return f.type!==this.type?this.type-f.type:H(this.c,f.c)}equals(f){return f.type===this.type?this.c===f.c:!1}substituteConstants(){const f=u.get(this.c);return typeof f=="boolean"?f?s.INSTANCE:o.INSTANCE:this}evaluate(f){return!f.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(f){return f.mapNot(this.c)}negate(){return this.d||(this.d=l.create(this.c,this)),this.d}}e.$oj=q;function Y(z,f){if(typeof z=="string"){const S=parseFloat(z);isNaN(S)||(z=S)}return typeof z=="string"||typeof z=="number"?f(z):s.INSTANCE}class Z{static create(f,S,T=null){return Y(S,F=>new Z(f,F,T))}constructor(f,S,T){this.c=f,this.d=S,this.f=T,this.type=12}cmp(f){return f.type!==this.type?this.type-f.type:K(this.c,this.d,f.c,f.d)}equals(f){return f.type===this.type?this.c===f.c&&this.d===f.d:!1}substituteConstants(){return this}evaluate(f){return typeof this.d=="string"?!1:parseFloat(f.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(f){return f.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=ue.create(this.c,this.d,this)),this.f}}e.$pj=Z;class oe{static create(f,S,T=null){return Y(S,F=>new oe(f,F,T))}constructor(f,S,T){this.c=f,this.d=S,this.f=T,this.type=13}cmp(f){return f.type!==this.type?this.type-f.type:K(this.c,this.d,f.c,f.d)}equals(f){return f.type===this.type?this.c===f.c&&this.d===f.d:!1}substituteConstants(){return this}evaluate(f){return typeof this.d=="string"?!1:parseFloat(f.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(f){return f.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=re.create(this.c,this.d,this)),this.f}}e.$qj=oe;class re{static create(f,S,T=null){return Y(S,F=>new re(f,F,T))}constructor(f,S,T){this.c=f,this.d=S,this.f=T,this.type=14}cmp(f){return f.type!==this.type?this.type-f.type:K(this.c,this.d,f.c,f.d)}equals(f){return f.type===this.type?this.c===f.c&&this.d===f.d:!1}substituteConstants(){return this}evaluate(f){return typeof this.d=="string"?!1:parseFloat(f.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(f){return f.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=oe.create(this.c,this.d,this)),this.f}}e.$rj=re;class ue{static create(f,S,T=null){return Y(S,F=>new ue(f,F,T))}constructor(f,S,T){this.c=f,this.d=S,this.f=T,this.type=15}cmp(f){return f.type!==this.type?this.type-f.type:K(this.c,this.d,f.c,f.d)}equals(f){return f.type===this.type?this.c===f.c&&this.d===f.d:!1}substituteConstants(){return this}evaluate(f){return typeof this.d=="string"?!1:parseFloat(f.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(f){return f.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=Z.create(this.c,this.d,this)),this.f}}e.$sj=ue;class fe{static create(f,S){return new fe(f,S)}constructor(f,S){this.d=f,this.f=S,this.type=7,this.c=null}cmp(f){if(f.type!==this.type)return this.type-f.type;if(this.d<f.d)return-1;if(this.d>f.d)return 1;const S=this.f?this.f.source:"",T=f.f?f.f.source:"";return S<T?-1:S>T?1:0}equals(f){if(f.type===this.type){const S=this.f?this.f.source:"",T=f.f?f.f.source:"";return this.d===f.d&&S===T}return!1}substituteConstants(){return this}evaluate(f){const S=f.getValue(this.d);return this.f?this.f.test(S):!1}serialize(){const f=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${f}`}keys(){return[this.d]}map(f){return f.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=ae.create(this)),this.c}}e.$tj=fe;class ae{static create(f){return new ae(f)}constructor(f){this.c=f,this.type=8}cmp(f){return f.type!==this.type?this.type-f.type:this.c.cmp(f.c)}equals(f){return f.type===this.type?this.c.equals(f.c):!1}substituteConstants(){return this}evaluate(f){return!this.c.evaluate(f)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(f){return new ae(this.c.map(f))}negate(){return this.c}}e.$uj=ae;function B(z){let f=null;for(let S=0,T=z.length;S<T;S++){const F=z[S].substituteConstants();if(z[S]!==F&&f===null){f=[];for(let W=0;W<S;W++)f[W]=z[W]}f!==null&&(f[S]=F)}return f===null?z:f}class X{static create(f,S,T){return X.d(f,S,T)}constructor(f,S){this.expr=f,this.c=S,this.type=6}cmp(f){if(f.type!==this.type)return this.type-f.type;if(this.expr.length<f.expr.length)return-1;if(this.expr.length>f.expr.length)return 1;for(let S=0,T=this.expr.length;S<T;S++){const F=n(this.expr[S],f.expr[S]);if(F!==0)return F}return 0}equals(f){if(f.type===this.type){if(this.expr.length!==f.expr.length)return!1;for(let S=0,T=this.expr.length;S<T;S++)if(!this.expr[S].equals(f.expr[S]))return!1;return!0}return!1}substituteConstants(){const f=B(this.expr);return f===this.expr?this:X.create(f,this.c,!1)}evaluate(f){for(let S=0,T=this.expr.length;S<T;S++)if(!this.expr[S].evaluate(f))return!1;return!0}static d(f,S,T){const F=[];let W=!1;for(const G of f)if(G){if(G.type===1){W=!0;continue}if(G.type===0)return s.INSTANCE;if(G.type===6){F.push(...G.expr);continue}F.push(G)}if(F.length===0&&W)return o.INSTANCE;if(F.length!==0){if(F.length===1)return F[0];F.sort(n);for(let G=1;G<F.length;G++)F[G-1].equals(F[G])&&(F.splice(G,1),G--);if(F.length===1)return F[0];for(;F.length>1;){const G=F[F.length-1];if(G.type!==9)break;F.pop();const te=F.pop(),ce=F.length===0,le=U.create(G.expr.map($e=>X.create([$e,te],null,T)),null,ce);le&&(F.push(le),F.sort(n))}if(F.length===1)return F[0];if(T){for(let G=0;G<F.length;G++)for(let te=G+1;te<F.length;te++)if(F[G].negate().equals(F[te]))return s.INSTANCE;if(F.length===1)return F[0]}return new X(F,S)}}serialize(){return this.expr.map(f=>f.serialize()).join(" && ")}keys(){const f=[];for(const S of this.expr)f.push(...S.keys());return f}map(f){return new X(this.expr.map(S=>S.map(f)),null)}negate(){if(!this.c){const f=[];for(const S of this.expr)f.push(S.negate());this.c=U.create(f,this,!0)}return this.c}}e.$vj=X;class U{static create(f,S,T){return U.d(f,S,T)}constructor(f,S){this.expr=f,this.c=S,this.type=9}cmp(f){if(f.type!==this.type)return this.type-f.type;if(this.expr.length<f.expr.length)return-1;if(this.expr.length>f.expr.length)return 1;for(let S=0,T=this.expr.length;S<T;S++){const F=n(this.expr[S],f.expr[S]);if(F!==0)return F}return 0}equals(f){if(f.type===this.type){if(this.expr.length!==f.expr.length)return!1;for(let S=0,T=this.expr.length;S<T;S++)if(!this.expr[S].equals(f.expr[S]))return!1;return!0}return!1}substituteConstants(){const f=B(this.expr);return f===this.expr?this:U.create(f,this.c,!1)}evaluate(f){for(let S=0,T=this.expr.length;S<T;S++)if(this.expr[S].evaluate(f))return!0;return!1}static d(f,S,T){let F=[],W=!1;if(f){for(let G=0,te=f.length;G<te;G++){const ce=f[G];if(ce){if(ce.type===0){W=!0;continue}if(ce.type===1)return o.INSTANCE;if(ce.type===9){F=F.concat(ce.expr);continue}F.push(ce)}}if(F.length===0&&W)return s.INSTANCE;F.sort(n)}if(F.length!==0){if(F.length===1)return F[0];for(let G=1;G<F.length;G++)F[G-1].equals(F[G])&&(F.splice(G,1),G--);if(F.length===1)return F[0];if(T){for(let G=0;G<F.length;G++)for(let te=G+1;te<F.length;te++)if(F[G].negate().equals(F[te]))return o.INSTANCE;if(F.length===1)return F[0]}return new U(F,S)}}serialize(){return this.expr.map(f=>f.serialize()).join(" || ")}keys(){const f=[];for(const S of this.expr)f.push(...S.keys());return f}map(f){return new U(this.expr.map(S=>S.map(f)),null)}negate(){if(!this.c){const f=[];for(const S of this.expr)f.push(S.negate());for(;f.length>1;){const S=f.shift(),T=f.shift(),F=[];for(const W of C(S))for(const G of C(T))F.push(X.create([W,G],null,!1));f.unshift(U.create(F,null,!1))}this.c=U.create(f,this,!0)}return this.c}}e.$wj=U;class M extends l{static{this.d=[]}static all(){return M.d.values()}constructor(f,S,T){super(f,null),this.f=S,typeof T=="object"?M.d.push({...T,key:f}):T!==!0&&M.d.push({key:f,description:T,type:S!=null?typeof S:void 0})}bindTo(f){return f.createKey(this.key,this.f)}getValue(f){return f.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(f){return O.create(this.key,f)}notEqualsTo(f){return j.create(this.key,f)}}e.$xj=M,e.$yj=(0,L.$gi)("contextKeyService");function H(z,f){return z<f?-1:z>f?1:0}function K(z,f,S,T){return z<S?-1:z>S?1:f<T?-1:f>T?1:0}function Q(z,f){if(z.type===0||f.type===1)return!0;if(z.type===9)return f.type===9?ee(z.expr,f.expr):!1;if(f.type===9){for(const S of f.expr)if(Q(z,S))return!0;return!1}if(z.type===6){if(f.type===6)return ee(f.expr,z.expr);for(const S of z.expr)if(Q(S,f))return!0;return!1}return z.equals(f)}e.$zj=Q;function ee(z,f){let S=0,T=0;for(;S<z.length&&T<f.length;){const F=z[S].cmp(f[T]);if(F<0)return!1;F===0&&S++,T++}return S===z.length}function C(z){return z.type===9?z.expr:[z]}}),define(ie[59],ne([0,1,10]),function(J,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$to=void 0,e.$to=(0,N.$gi)("downloadService")}),define(ie[18],ne([0,1,10]),function(J,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oi=e.$ni=void 0,e.$ni=(0,N.$gi)("environmentService"),e.$oi=(0,N.$hi)(e.$ni)}),define(ie[21],ne([0,1,95,10]),function(J,e,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=e.$So=e.$Ro=e.$Qo=e.ExtensionGalleryErrorCode=e.$Po=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Oo=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$No=e.$Mo=e.$Lo=e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=void 0,e.$Co="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Do=new RegExp(e.$Co),e.$Eo="__web_extension",e.$Fo="skipWalkthrough",e.$Go="extensionsSync",e.$Ho="dependecyOrPackExtensionInstall";function R($){switch($){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$Io=R;function L($){switch($){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$Jo=L;function A($,h){switch($){case 3:return h==="x64"?"win32-x64":h==="arm64"?"win32-arm64":"unknown";case 2:return h==="x64"?"linux-x64":h==="arm64"?"linux-arm64":h==="arm"?"linux-armhf":"unknown";case"alpine":return h==="x64"?"alpine-x64":h==="arm64"?"alpine-arm64":"unknown";case 1:return h==="x64"?"darwin-x64":h==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$Ko=A;function P($,h){return h==="web"&&!$.includes("web")}e.$Lo=P;function u($,h,g){return P(h,g)?!1:$==="undefined"||$==="universal"?!0:$==="unknown"?!1:$===g}e.$Mo=u;function a($){return $&&typeof $=="object"&&typeof $.id=="string"&&(!$.uuid||typeof $.uuid=="string")}e.$No=a;var y;(function($){$[$.NoneOrRelevance=0]="NoneOrRelevance",$[$.LastUpdatedDate=1]="LastUpdatedDate",$[$.Title=2]="Title",$[$.PublisherName=3]="PublisherName",$[$.InstallCount=4]="InstallCount",$[$.PublishedDate=10]="PublishedDate",$[$.AverageRating=6]="AverageRating",$[$.WeightedRating=12]="WeightedRating"})(y||(e.SortBy=y={}));var E;(function($){$[$.Default=0]="Default",$[$.Ascending=1]="Ascending",$[$.Descending=2]="Descending"})(E||(e.SortOrder=E={}));var d;(function($){$.Install="install",$.Uninstall="uninstall"})(d||(e.StatisticType=d={}));var m;(function($){$[$.None=1]="None",$[$.Install=2]="Install",$[$.Update=3]="Update",$[$.Migrate=4]="Migrate"})(m||(e.InstallOperation=m={})),e.$Oo=(0,D.$gi)("extensionGalleryService");var w;(function($){$.Unsupported="Unsupported",$.Deprecated="Deprecated",$.Malicious="Malicious",$.Incompatible="Incompatible",$.IncompatibleTargetPlatform="IncompatibleTargetPlatform",$.ReleaseVersionNotFound="ReleaseVersionNotFound",$.Invalid="Invalid",$.Download="Download",$.DownloadSignature="DownloadSignature",$.UpdateMetadata="UpdateMetadata",$.Extract="Extract",$.Scanning="Scanning",$.Delete="Delete",$.Rename="Rename",$.CorruptZip="CorruptZip",$.IncompleteZip="IncompleteZip",$.Signature="Signature",$.NotAllowed="NotAllowed",$.Gallery="Gallery",$.Unknown="Unknown",$.Internal="Internal"})(w||(e.ExtensionManagementErrorCode=w={}));var k;(function($){$.UnknownError="UnknownError",$.PackageIsInvalidZip="PackageIsInvalidZip",$.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(k||(e.ExtensionSignaturetErrorCode=k={}));class b extends Error{constructor(h,g){super(h),this.code=g,this.name=g}}e.$Po=b;var c;(function($){$.Timeout="Timeout",$.Cancelled="Cancelled",$.Failed="Failed"})(c||(e.ExtensionGalleryErrorCode=c={}));class p extends Error{constructor(h,g){super(h),this.code=g,this.name=g}}e.$Qo=p,e.$Ro=(0,D.$gi)("extensionManagementService"),e.$So="extensionsIdentifiers/disabled",e.$To="extensionsIdentifiers/enabled",e.$Uo=(0,D.$gi)("IGlobalExtensionEnablementService"),e.$Vo=(0,D.$gi)("IExtensionTipsService"),e.$Wo=(0,N.localize2)(0,"Extensions"),e.$Xo=(0,N.localize2)(1,"Preferences")}),define(ie[60],ne([0,1,14,7,103,13]),function(J,e,N,D,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qq=void 0;async function A(y,E,d,m,w,k){let b;try{await P(y,E,d,m,w,k)}catch(c){b=c}finally{b&&w.errorTransformer&&(b=w.errorTransformer(b)),typeof b<"u"&&d.error(b),d.end()}}e.$qq=A;async function P(y,E,d,m,w,k){u(k);const b=await y.open(E,{create:!1});try{u(k);let c=0,p=0,$=w&&typeof w.length=="number"?w.length:void 0,h=N.$te.alloc(Math.min(w.bufferSize,typeof $=="number"?$:w.bufferSize)),g=w&&typeof w.position=="number"?w.position:0,i=0;do p=await y.read(b,g,h.buffer,i,h.byteLength-i),g+=p,i+=p,c+=p,typeof $=="number"&&($-=p),i===h.byteLength&&(await d.write(m(h)),h=N.$te.alloc(Math.min(w.bufferSize,typeof $=="number"?$:w.bufferSize)),i=0);while(p>0&&(typeof $!="number"||$>0)&&u(k)&&a(c,w));if(i>0){let r=i;typeof $=="number"&&(r=Math.min(i,$)),d.write(m(h.slice(0,r)))}}catch(c){throw(0,L.$Uk)(c)}finally{await y.close(b)}}function u(y){if(y.isCancellationRequested)throw(0,D.$6)();return!0}function a(y,E){if(typeof E?.limits?.size=="number"&&y>E.limits.size)throw(0,L.$Tk)((0,R.localize)(0,null),L.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ie[121],ne([0,1,6,168,2,12,169]),function(J,e,N,D,R,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oq=void 0;class P extends R.$Tc{constructor(){super(...arguments),this.a=this.B(new N.$6d),this.onDidChangeFile=this.a.event,this.b=this.B(new N.$6d),this.onDidLogMessage=this.b.event,this.onDidError=N.Event.None,this.c=new Map,this.f=!1}async watch(a){const y=this.j(a),E=y.filter(m=>{const w=this.c.get(m.path);return w?!(0,D.$4j)(w.request.excludes,m.excludes)||!(0,D.$4j)(w.request.includes,m.includes):!0}),d=Array.from(this.c.values()).filter(({request:m})=>!y.find(w=>w.path===m.path&&(0,D.$4j)(w.excludes,m.excludes)&&(0,D.$4j)(w.includes,m.includes))).map(({request:m})=>m.path);E.length&&this.m(`Request to start watching: ${E.map(m=>`${m.path} (excludes: ${m.excludes.length>0?m.excludes:"<none>"}, includes: ${m.includes&&m.includes.length>0?JSON.stringify(m.includes):"<all>"}, correlationId: ${typeof m.correlationId=="number"?m.correlationId:"<none>"})`).join(",")}`),d.length&&this.m(`Request to stop watching: ${d.join(",")}`);for(const m of d)this.h(m);for(const m of E)this.g(m)}g(a){const y=new A.$Mq(a,d=>this.a.fire(d),d=>this.b.fire(d),this.f),E={request:a,instance:y};this.c.set(a.path,E)}async stop(){for(const[a]of this.c)this.h(a);this.c.clear()}h(a){const y=this.c.get(a);y&&(this.c.delete(a),y.instance.dispose())}j(a){const y=new Map;for(const E of a){const d=L.$k?E.path:E.path.toLowerCase();let m=y.get(E.correlationId);m||(m=new Map,y.set(E.correlationId,m)),m.set(d,E)}return Array.from(y.values()).map(E=>Array.from(E.values())).flat()}async setVerboseLogging(a){this.f=a;for(const[,y]of this.c)y.instance.setVerboseLogging(a)}m(a){this.f&&this.b.fire({type:"trace",message:this.n(a)})}n(a,y){return y?`[File Watcher (node.js)] ${a} (path: ${y.request.path})`:`[File Watcher (node.js)] ${a}`}}e.$Oq=P}),define(ie[122],ne([0,1,61,121]),function(J,e,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pq=void 0;class R extends N.$uq{constructor(A,P,u){super(A,P,u),this.s()}r(A){return A.add(new D.$Oq)}}e.$Pq=R}),define(ie[123],ne([0,1,15,57,87,61]),function(J,e,N,D,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hq=void 0;class A extends L.$vq{constructor(u,a,y){super(u,a,y),this.s()}r(u){const a=u.add(new R.$Gq(N.$Ag.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return u.add(a.onDidProcessExit(({code:y,signal:E})=>this.t(`terminated by itself with code ${y}, signal: ${E}`))),D.ProxyChannel.toService((0,D.$Zh)(a.getChannel("watcher")))}}e.$Hq=A}),define(ie[62],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ei=void 0;class N{constructor(...R){this.a=new Map;for(const[L,A]of R)this.set(L,A)}set(R,L){const A=this.a.get(R);return this.a.set(R,L),A}has(R){return this.a.has(R)}get(R){return this.a.get(R)}}e.$ei=N}),define(ie[124],ne([0,1,9,7,2,51,119,10,62,170]),function(J,e,N,D,R,L,A,P,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uq=e.$Tq=void 0;const y=!1;class E extends Error{constructor(b){super("cyclic dependency between services"),this.message=b.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${b.toString()}`}}class d{constructor(b=new u.$ei,c=!1,p,$=y){this.f=b,this.g=c,this.h=p,this.i=$,this.o=new Set,this.f.set(P.$fi,this),this._globalGraph=$?p?._globalGraph??new A.$Sq(h=>h):void 0}createChild(b){return new d(b,this.g,this,this.i)}invokeFunction(b,...c){const p=w.traceInvocation(this.i,b);let $=!1;try{return b({get:g=>{if($)throw(0,D.$8)("service accessor is only valid during the invocation of its target method");const i=this.m(g,p);if(!i)throw new Error(`[invokeFunction] unknown service '${g}'`);return i}},...c)}finally{$=!0,p.stop()}}createInstance(b,...c){let p,$;return b instanceof L.$di?(p=w.traceCreation(this.i,b.ctor),$=this.j(b.ctor,b.staticArguments.concat(c),p)):(p=w.traceCreation(this.i,b),$=this.j(b,c,p)),p.stop(),$}j(b,c=[],p){const $=P._util.getServiceDependencies(b).sort((i,r)=>i.index-r.index),h=[];for(const i of $){const r=this.m(i.id,p);r||this.u(`[createInstance] ${b.name} depends on UNKNOWN service ${i.id}.`,!1),h.push(r)}const g=$.length>0?$[0].index:c.length;if(c.length!==g){console.trace(`[createInstance] First service dependency of ${b.name} at position ${g+1} conflicts with ${c.length} static arguments`);const i=g-c.length;i>0?c=c.concat(new Array(i)):c=c.slice(0,g)}return Reflect.construct(b,c.concat(h))}k(b,c){if(this.f.get(b)instanceof L.$di)this.f.set(b,c);else if(this.h)this.h.k(b,c);else throw new Error("illegalState - setting UNKNOWN service instance")}l(b){const c=this.f.get(b);return!c&&this.h?this.h.l(b):c}m(b,c){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(b));const p=this.l(b);return p instanceof L.$di?this.q(b,p,c.branch(b,!0)):(c.branch(b,!1),p)}q(b,c,p){if(this.o.has(b))throw new Error(`illegal state - RECURSIVELY instantiating service '${b}'`);this.o.add(b);try{return this.r(b,c,p)}finally{this.o.delete(b)}}r(b,c,p){const $=new A.$Sq(i=>i.id.toString());let h=0;const g=[{id:b,desc:c,_trace:p}];for(;g.length;){const i=g.pop();if($.lookupOrInsertNode(i),h++>1e3)throw new E($);for(const r of P._util.getServiceDependencies(i.desc.ctor)){const t=this.l(r.id);if(t||this.u(`[createInstance] ${b} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(r.id)),t instanceof L.$di){const n={id:r.id,desc:t,_trace:i._trace.branch(r.id,!0)};$.insertEdge(i,n),g.push(n)}}}for(;;){const i=$.roots();if(i.length===0){if(!$.isEmpty())throw new E($);break}for(const{data:r}of i){if(this.l(r.id)instanceof L.$di){const n=this.s(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this.k(r.id,n)}$.removeNode(r)}}return this.l(b)}s(b,c,p=[],$,h){if(this.f.get(b)instanceof L.$di)return this.t(b,c,p,$,h);if(this.h)return this.h.s(b,c,p,$,h);throw new Error(`illegalState - creating UNKNOWN service instance ${c.name}`)}t(b,c,p=[],$,h){if($){const g=new d(void 0,this.g,this,this.i);g.c=String(b);const i=new Map,r=new N.$zh(()=>{const t=g.j(c,p,h);for(const[n,s]of i){const o=t[n];if(typeof o=="function")for(const l of s)l.disposable=o.apply(t,l.listener)}return i.clear(),t});return new Proxy(Object.create(null),{get(t,n){if(!r.isInitialized&&typeof n=="string"&&(n.startsWith("onDid")||n.startsWith("onWill"))){let l=i.get(n);return l||(l=new a.$4c,i.set(n,l)),(I,v,j)=>{if(r.isInitialized)return r.value[n](I,v,j);{const q={listener:[I,v,j],disposable:void 0},Y=l.push(q);return(0,R.$Rc)(()=>{Y(),q.disposable?.dispose()})}}}if(n in t)return t[n];const s=r.value;let o=s[n];return typeof o!="function"||(o=o.bind(s),t[n]=o),o},set(t,n,s){return r.value[n]=s,!0},getPrototypeOf(t){return c.prototype}})}else return this.j(c,p,h)}u(b,c){if(c&&console.warn(b),this.g)throw new Error(b)}}e.$Tq=d;var m;(function(k){k[k.None=0]="None",k[k.Creation=1]="Creation",k[k.Invocation=2]="Invocation",k[k.Branch=3]="Branch"})(m||(m={}));class w{static{this.all=new Set}static{this.c=new class extends w{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(b,c){return b?new w(2,c.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):w.c}static traceCreation(b,c){return b?new w(1,c.name):w.c}static{this.f=0}constructor(b,c){this.type=b,this.name=c,this.g=Date.now(),this.h=[]}branch(b,c){const p=new w(3,b.toString());return this.h.push([b,c,p]),p}stop(){const b=Date.now()-this.g;w.f+=b;let c=!1;function p(h,g){const i=[],r=new Array(h+1).join("	");for(const[t,n,s]of g.h)if(n&&s){c=!0,i.push(`${r}CREATES -> ${t}`);const o=p(h+1,s);o&&i.push(o)}else i.push(`${r}uses -> ${t}`);return i.join(`
`)}const $=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${p(1,this)}`,`DONE, took ${b.toFixed(2)}ms (grand total ${w.f.toFixed(2)}ms)`];(b>2||c)&&w.all.add($.join(`
`))}}e.$Uq=w});var se=this&&this.__param||function(J,e){return function(N,D){e(N,D,J)}};define(ie[63],ne([0,1,20,2,12,105,21,10]),function(J,e,N,D,R,L,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xr=e.$wr=e.$vr=void 0;function u(y){return y.tags.find(E=>E.startsWith("lp-"))?.split("lp-")[1]}e.$vr=u,e.$wr=(0,P.$gi)("languagePackService");let a=class extends D.$Tc{constructor(E){super(),this.c=E}async getAvailableLanguages(){const E=new N.$de;setTimeout(()=>E.cancel(),1e3);let d;try{d=await this.c.query({text:'category:"language packs"',pageSize:20},E.token)}catch{return[]}const w=d.firstPage.filter(k=>k.properties.localizedLanguages?.length&&k.tags.some(b=>b.startsWith("lp-"))).map(k=>{const b=k.properties.localizedLanguages?.[0],c=u(k);return{...this.f(c,b,k),extensionId:k.identifier.id,galleryExtension:k}});return w.push(this.f("en","English")),w}f(E,d,m){const w=d??E;let k;if(w!==E&&(k=`(${E})`),E.toLowerCase()===R.$w.toLowerCase()&&(k??="",k+=(0,L.localize)(0,null)),m?.installCount){k??="";const b=m.installCount;let c;b>1e6?c=`${Math.floor(b/1e5)/10}M`:b>1e3?c=`${Math.floor(b/1e3)}K`:c=String(b),k+=` $(cloud-download) ${c}`}return{id:E,label:w,description:k}}};e.$xr=a,e.$xr=a=pe([se(0,A.$Oo)],a)}),define(ie[4],ne([0,1,34,6,43,2,31,12,17,3,11,120,10]),function(J,e,N,D,R,L,A,P,u,a,y,E,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.log=e.$Dj=e.LogLevel=e.$Cj=e.$Bj=e.$Aj=void 0,e.$Aj=(0,d.$gi)("logService"),e.$Bj=(0,d.$gi)("loggerService");function m(){return new Date().toISOString()}function w(I){return(0,a.$Xf)(I)}e.$Cj=w;var k;(function(I){I[I.Off=0]="Off",I[I.Trace=1]="Trace",I[I.Debug=2]="Debug",I[I.Info=3]="Info",I[I.Warning=4]="Warning",I[I.Error=5]="Error"})(k||(e.LogLevel=k={})),e.$Dj=k.Info;function b(I,v,j){switch(v){case k.Trace:I.trace(j);break;case k.Debug:I.debug(j);break;case k.Info:I.info(j);break;case k.Warning:I.warn(j);break;case k.Error:I.error(j);break;case k.Off:break;default:throw new Error(`Invalid log level ${v}`)}}e.log=b;function c(I,v=!1){let j="";for(let q=0;q<I.length;q++){let Y=I[q];if(Y instanceof Error&&(Y=(0,N.$4i)(Y,v)),typeof Y=="object")try{Y=JSON.stringify(Y)}catch{}j+=(q>0?" ":"")+Y}return j}class p extends L.$Tc{constructor(){super(...arguments),this.b=e.$Dj,this.c=this.B(new D.$6d),this.onDidChangeLogLevel=this.c.event}setLevel(v){this.b!==v&&(this.b=v,this.c.fire(this.b))}getLevel(){return this.b}f(v){return this.b!==k.Off&&this.b<=v}}e.$Fj=p;class $ extends p{constructor(v){super(),this.h=v}f(v){return this.h||super.f(v)}trace(v,...j){this.f(k.Trace)&&this.g(k.Trace,c([v,...j],!0))}debug(v,...j){this.f(k.Debug)&&this.g(k.Debug,c([v,...j]))}info(v,...j){this.f(k.Info)&&this.g(k.Info,c([v,...j]))}warn(v,...j){this.f(k.Warning)&&this.g(k.Warning,c([v,...j]))}error(v,...j){if(this.f(k.Error))if(v instanceof Error){const q=Array.prototype.slice.call(arguments);q[0]=v.stack,this.g(k.Error,c(q))}else this.g(k.Error,c([v,...j]))}flush(){}}e.$Gj=$;class h extends p{constructor(v=e.$Dj){super(),this.setLevel(v),this.g=!P.$i}trace(v,...j){this.f(k.Trace)&&(this.g?console.log(`\x1B[90m[main ${m()}]\x1B[0m`,v,...j):console.log(`[main ${m()}]`,v,...j))}debug(v,...j){this.f(k.Debug)&&(this.g?console.log(`\x1B[90m[main ${m()}]\x1B[0m`,v,...j):console.log(`[main ${m()}]`,v,...j))}info(v,...j){this.f(k.Info)&&(this.g?console.log(`\x1B[90m[main ${m()}]\x1B[0m`,v,...j):console.log(`[main ${m()}]`,v,...j))}warn(v,...j){this.f(k.Warning)&&(this.g?console.warn(`\x1B[93m[main ${m()}]\x1B[0m`,v,...j):console.warn(`[main ${m()}]`,v,...j))}error(v,...j){this.f(k.Error)&&(this.g?console.error(`\x1B[91m[main ${m()}]\x1B[0m`,v,...j):console.error(`[main ${m()}]`,v,...j))}flush(){}}e.$Hj=h;class g extends p{constructor(v=e.$Dj,j=!0){super(),this.g=j,this.setLevel(v)}trace(v,...j){this.f(k.Trace)&&(this.g?console.log("%cTRACE","color: #888",v,...j):console.log(v,...j))}debug(v,...j){this.f(k.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",v,...j):console.log(v,...j))}info(v,...j){this.f(k.Info)&&(this.g?console.log("%c INFO","color: #33f",v,...j):console.log(v,...j))}warn(v,...j){this.f(k.Warning)&&(this.g?console.log("%c WARN","color: #993",v,...j):console.log(v,...j))}error(v,...j){this.f(k.Error)&&(this.g?console.log("%c  ERR","color: #f33",v,...j):console.error(v,...j))}flush(){}}e.$Ij=g;class i extends p{constructor(v,j=e.$Dj){super(),this.g=v,this.setLevel(j)}trace(v,...j){this.f(k.Trace)&&this.g.log(k.Trace,[this.h(v),...j])}debug(v,...j){this.f(k.Debug)&&this.g.log(k.Debug,[this.h(v),...j])}info(v,...j){this.f(k.Info)&&this.g.log(k.Info,[this.h(v),...j])}warn(v,...j){this.f(k.Warning)&&this.g.log(k.Warning,[this.h(v),...j])}error(v,...j){this.f(k.Error)&&this.g.log(k.Error,[this.h(v),...j])}h(v){return typeof v=="string"?v:(0,N.$4i)(v,this.f(k.Trace))}flush(){}}e.$Jj=i;class r extends p{constructor(v){super(),this.g=v,v.length&&this.setLevel(v[0].getLevel())}setLevel(v){for(const j of this.g)j.setLevel(v);super.setLevel(v)}trace(v,...j){for(const q of this.g)q.trace(v,...j)}debug(v,...j){for(const q of this.g)q.debug(v,...j)}info(v,...j){for(const q of this.g)q.info(v,...j)}warn(v,...j){for(const q of this.g)q.warn(v,...j)}error(v,...j){for(const q of this.g)q.error(v,...j)}flush(){for(const v of this.g)v.flush()}dispose(){for(const v of this.g)v.dispose();super.dispose()}}e.$Kj=r;class t extends L.$Tc{constructor(v,j,q){if(super(),this.h=v,this.j=j,this.b=new A.$Ac,this.c=this.B(new D.$6d),this.onDidChangeLoggers=this.c.event,this.f=this.B(new D.$6d),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new D.$6d),this.onDidChangeVisibility=this.g.event,q)for(const Y of q)this.b.set(Y.resource,{logger:void 0,info:Y})}m(v){return(0,a.$Tf)(v)?[...this.b.values()].find(j=>j.info.id===v):this.b.get(v)}getLogger(v){return this.m(v)?.logger}createLogger(v,j){const q=this.n(v),Y=(0,a.$Tf)(v)?v:j?.id??(0,R.$7i)(q.toString()).toString(16);let Z=this.b.get(q)?.logger;const oe=j?.logLevel==="always"?k.Trace:j?.logLevel;Z||(Z=this.s(q,oe??this.getLogLevel(q)??this.h,{...j,id:Y}));const re={logger:Z,info:{resource:q,id:Y,logLevel:oe,name:j?.name,hidden:j?.hidden,extensionId:j?.extensionId,when:j?.when}};return this.registerLogger(re.info),this.b.set(q,re),Z}n(v){return(0,a.$Tf)(v)?(0,u.$Tg)(this.j,`${v}.log`):v}setLogLevel(v,j){if(y.URI.isUri(v)){const q=v,Y=j,Z=this.b.get(q);Z&&Y!==Z.info.logLevel&&(Z.info.logLevel=Y===this.h?void 0:Y,Z.logger?.setLevel(Y),this.b.set(Z.info.resource,Z),this.f.fire([q,Y]))}else{this.h=v;for(const[q,Y]of this.b.entries())this.b.get(q)?.info.logLevel===void 0&&Y.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(v,j){const q=this.m(v);q&&j!==!q.info.hidden&&(q.info.hidden=!j,this.b.set(q.info.resource,q),this.g.fire([q.info.resource,j]))}getLogLevel(v){let j;return v&&(j=this.b.get(v)?.info.logLevel),j??this.h}registerLogger(v){const j=this.b.get(v.resource);j?j.info.hidden!==v.hidden&&this.setVisibility(v.resource,!v.hidden):(this.b.set(v.resource,{info:v,logger:void 0}),this.c.fire({added:[v],removed:[]}))}deregisterLogger(v){const j=this.b.get(v);j&&(j.logger&&j.logger.dispose(),this.b.delete(v),this.c.fire({added:[],removed:[j.info]}))}*getRegisteredLoggers(){for(const v of this.b.values())yield v.info}getRegisteredLogger(v){return this.b.get(v)?.info}dispose(){this.b.forEach(v=>v.logger?.dispose()),this.b.clear(),super.dispose()}}e.$Lj=t;class n{constructor(){this.onDidChangeLogLevel=new D.$6d().event}setLevel(v){}getLevel(){return k.Info}trace(v,...j){}debug(v,...j){}info(v,...j){}warn(v,...j){}error(v,...j){}critical(v,...j){}dispose(){}flush(){}}e.$Mj=n;class s extends n{}e.$Nj=s;function o(I){if(I.verbose)return k.Trace;if(typeof I.logLevel=="string"){const v=O(I.logLevel.toLowerCase());if(v!==void 0)return v}return e.$Dj}e.$Oj=o;function l(I){switch(I){case k.Trace:return"trace";case k.Debug:return"debug";case k.Info:return"info";case k.Warning:return"warn";case k.Error:return"error";case k.Off:return"off"}}e.$Pj=l;function O(I){switch(I){case"trace":return k.Trace;case"debug":return k.Debug;case"info":return k.Info;case"warn":return k.Warning;case"error":return k.Error;case"critical":return k.Error;case"off":return k.Off}}e.$Qj=O,e.$Rj=new E.$xj("logLevel",l(k.Info))}),define(ie[64],ne([0,1,7,10,4]),function(J,e,N,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vp=e.$Up=void 0,e.$Up=(0,D.$gi)("IExtensionSignatureVerificationService");let L=class{constructor(P){this.b=P}c(){return this.a||(this.a=new Promise((P,u)=>J(["@vscode/vsce-sign"],async a=>P(a),u))),this.a}async verify(P,u,a){let y;try{y=await this.c()}catch(E){return this.b.error("Could not load vsce-sign module",(0,N.$0)(E)),!1}return y.verify(P,u,a)}};e.$Vp=L,e.$Vp=L=pe([se(0,R.$Aj)],L)}),define(ie[125],ne([0,1,19,9,7,6,2,16,61,4]),function(J,e,N,D,R,L,A,P,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aq=void 0;class y extends A.$Tc{constructor(d,m){super(),this.a=d,this.b=m,this.c=this.B(new L.$6d),this.onDidChangeFile=this.c.event,this.g=this.B(new L.$6d),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new D.$eh(0)),this.w=[],this.y=this.B(new D.$eh(0))}watch(d,m){return m.recursive||this.b?.watcher?.forceUniversal?this.n(d,m):this.z(d,m)}n(d,m){const w={path:this.H(d),excludes:m.excludes,includes:m.includes,recursive:m.recursive,correlationId:m.correlationId},k=(0,N.$Ub)(this.j,w);return this.r(),(0,A.$Rc)(()=>{k(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(d=>(0,R.$1)(d))}s(){this.h||(this.h=this.B(this.t(m=>this.c.fire((0,u.$wq)(m)),m=>this.G(m),this.a.getLevel()===a.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===a.LogLevel.Trace)})));const d=this.b?.watcher?.recursive?.usePolling;if(d===!0)for(const m of this.j)(0,u.$sq)(m)&&(m.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(d))for(const m of this.j)(0,u.$sq)(m)&&d.includes(m.path)&&(m.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(d,m){const w={path:this.H(d),excludes:m.excludes,includes:m.includes,recursive:!1,correlationId:m.correlationId},k=(0,N.$Ub)(this.w,w);return this.C(),(0,A.$Rc)(()=>{k(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(d=>(0,R.$1)(d))}D(){return this.u||(this.u=this.B(this.F(d=>this.c.fire((0,u.$wq)(d)),d=>this.G(d),this.a.getLevel()===a.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===a.LogLevel.Trace)}))),this.u.watch(this.w)}G(d){d.type==="error"&&this.g.fire(d.message),this.a[d.type](d.message)}H(d){return(0,P.$hc)(d.fsPath)}}e.$Aq=y}),define(ie[126],ne([0,1,19,9,14,20,6,43,65,2,48,15,127,17,46,102,13,60,4,7]),function(J,e,N,D,R,L,A,P,u,a,y,E,d,m,w,k,b,c,p,$){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.$rq=void 0;let g=class extends a.$Tc{static{h=this}constructor(r){super(),this.b=r,this.a=256*1024,this.c=this.B(new A.$6d),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new A.$6d),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new A.$6d),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new A.$6d),this.onDidRunOperation=this.r.event,this.X=this.B(new A.$6d),this.Y=this.B(new A.$6d),this.onDidFilesChange=this.Y.event,this.Z=this.B(new A.$6d),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new D.$ph)}registerProvider(r,t){if(this.h.has(r))throw new Error(`A filesystem provider for the scheme '${r}' is already registered.`);(0,d.mark)(`code/registerFilesystem/${r}`);const n=new a.$Sc;return this.h.set(r,t),this.c.fire({added:!0,scheme:r,provider:t}),n.add(t.onDidChangeFile(s=>{const o=new b.$Zk(s,!this.S(t));this.X.fire(o),o.hasCorrelation()||this.Y.fire(o)})),typeof t.onDidWatchError=="function"&&n.add(t.onDidWatchError(s=>this.Z.fire(new Error(s)))),n.add(t.onDidChangeCapabilities(()=>this.g.fire({provider:t,scheme:r}))),(0,a.$Rc)(()=>{this.c.fire({added:!1,scheme:r,provider:t}),this.h.delete(r),(0,a.$Oc)(n)})}getProvider(r){return this.h.get(r)}async activateProvider(r){const t=[];this.f.fire({scheme:r,join(n){t.push(n)}}),!this.h.has(r)&&await D.Promises.settled(t)}async canHandleResource(r){return await this.activateProvider(r.scheme),this.hasProvider(r)}hasProvider(r){return this.h.has(r.scheme)}hasCapability(r,t){const n=this.h.get(r.scheme);return!!(n&&n.capabilities&t)}listCapabilities(){return u.Iterable.map(this.h,([r,t])=>({scheme:r,capabilities:t.capabilities}))}async j(r){if(!(0,m.$Xg)(r))throw new b.$2k((0,k.localize)(0,null,this.sb(r)),8);await this.activateProvider(r.scheme);const t=this.h.get(r.scheme);if(!t){const n=new $.$bb;throw n.message=(0,k.localize)(1,null,r.toString()),n}return t}async m(r){const t=await this.j(r);if((0,b.$Mk)(t)||(0,b.$Jk)(t)||(0,b.$Nk)(t))return t;throw new Error(`Filesystem provider for scheme '${r.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(r){const t=await this.j(r);if((0,b.$Mk)(t)||(0,b.$Jk)(t))return t;throw new Error(`Filesystem provider for scheme '${r.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(r,t){try{return await this.s(r,t)}catch(n){throw(0,b.$Wk)(n)===b.FileSystemProviderErrorCode.FileNotFound?new b.$2k((0,k.localize)(2,null,this.sb(r)),1):(0,b.$Uk)(n)}}async s(r,t){const n=await this.j(r),s=this.S(n),o=t?.resolveTo,l=t?.resolveSingleChildDescendants,O=t?.resolveMetadata,I=await n.stat(r);let v;return this.t(n,r,I,void 0,!!O,(j,q)=>(v||(v=y.$mi.forUris(()=>!s),v.set(r,!0),o&&v.fill(!0,o)),v.get(j.resource)||v.findSuperstr(j.resource.with({query:null,fragment:null}))?!0:j.isDirectory&&l?q===1:!1))}async t(r,t,n,s,o,l){const{providerExtUri:O}=this.R(r),I={resource:t,name:O.basename(t),isFile:(n.type&b.FileType.File)!==0,isDirectory:(n.type&b.FileType.Directory)!==0,isSymbolicLink:(n.type&b.FileType.SymbolicLink)!==0,mtime:n.mtime,ctime:n.ctime,size:n.size,readonly:!!((n.permissions??0)&b.FilePermission.Readonly)||!!(r.capabilities&2048),locked:!!((n.permissions??0)&b.FilePermission.Locked),etag:(0,b.$al)({mtime:n.mtime,size:n.size}),children:void 0};if(I.isDirectory&&l(I,s)){try{const v=await r.readdir(t),j=await D.Promises.settled(v.map(async([q,Y])=>{try{const Z=O.joinPath(t,q),oe=o?await r.stat(Z):{type:Y};return await this.t(r,Z,oe,v.length,o,l)}catch(Z){return this.b.trace(Z),null}}));I.children=(0,N.$Hb)(j)}catch(v){this.b.trace(v),I.children=[]}return I}return I}async resolveAll(r){return D.Promises.settled(r.map(async t=>{try{return{stat:await this.s(t.resource,t.options),success:!0}}catch(n){return this.b.trace(n),{stat:void 0,success:!1}}}))}async stat(r){const t=await this.j(r),n=await t.stat(r);return this.t(t,r,n,void 0,!0,()=>!1)}async exists(r){const t=await this.j(r);try{return!!await t.stat(r)}catch{return!1}}async canCreateFile(r,t){try{await this.u(r,t)}catch(n){return n}return!0}async u(r,t){if(!t?.overwrite&&await this.exists(r))throw new b.$2k((0,k.localize)(3,null,this.sb(r)),3,t)}async createFile(r,t=R.$te.fromString(""),n){await this.u(r,n);const s=await this.writeFile(r,t);return this.r.fire(new b.$Yk(r,0,s)),s}async writeFile(r,t,n){const s=this.qb(await this.n(r),r),{providerExtUri:o}=this.R(s);let l=n;if((0,b.$Pk)(s)&&!l?.atomic){const O=s.enforceAtomicWriteFile?.(r);O&&(l={...n,atomic:O})}try{await this.w(s,r,l)||await this.U(s,o.dirname(r));let I;if((0,b.$Jk)(s)&&!(t instanceof R.$te))if((0,w.$fe)(t)){const v=await(0,w.$me)(t,3);v.ended?I=R.$te.concat(v.buffer):I=v}else I=(0,w.$je)(t,v=>R.$te.concat(v),3);else I=t;!(0,b.$Mk)(s)||(0,b.$Jk)(s)&&I instanceof R.$te||(0,b.$Jk)(s)&&(0,b.$Pk)(s)&&l?.atomic?await this.hb(s,r,l,I):await this.db(s,r,l,I instanceof R.$te?(0,R.$Ee)(I):I),this.r.fire(new b.$Yk(r,4))}catch(O){throw new b.$2k((0,k.localize)(4,null,this.sb(r),(0,b.$Uk)(O).toString()),(0,b.$Xk)(O),l)}return this.resolve(r,{resolveMetadata:!0})}async w(r,t,n){const s=!!n?.unlock;if(s&&!(r.capabilities&8192))throw new Error((0,k.localize)(5,null,this.sb(t)));if(!!n?.atomic){if(!(r.capabilities&32768))throw new Error((0,k.localize)(6,null,this.sb(t)));if(!(r.capabilities&2))throw new Error((0,k.localize)(7,null,this.sb(t)));if(s)throw new Error((0,k.localize)(8,null,this.sb(t)))}let l;try{l=await r.stat(t)}catch{return}if(l.type&b.FileType.Directory)throw new b.$2k((0,k.localize)(9,null,this.sb(t)),0,n);if(this.rb(t,l),typeof n?.mtime=="number"&&typeof n.etag=="string"&&n.etag!==b.$_k&&typeof l.mtime=="number"&&typeof l.size=="number"&&n.mtime<l.mtime&&n.etag!==(0,b.$al)({mtime:n.mtime,size:l.size}))throw new b.$2k((0,k.localize)(10,null),3,n);return l}async readFile(r,t,n){const s=await this.m(r);return t?.atomic?this.z(s,r,t,n):this.C(s,r,t,n)}async z(r,t,n,s){return new Promise((o,l)=>{this.cb.queueFor(t,async()=>{try{const O=await this.C(r,t,n,s);o(O)}catch(O){l(O)}},this.R(r).providerExtUri)})}async C(r,t,n,s){const o=await this.D(r,t,{...n,preferUnbuffered:!0},s);return{...o,value:await(0,R.$Fe)(o.value)}}async readFileStream(r,t,n){const s=await this.m(r);return this.D(s,r,t,n)}async D(r,t,n,s){const o=new L.$de(s);let l=n;(0,b.$Ok)(r)&&r.enforceAtomicReadFile?.(t)&&(l={...n,atomic:!0});const O=this.J(t,l).then(v=>v,v=>{throw o.dispose(!0),v});let I;try{return typeof l?.etag=="string"&&l.etag!==b.$_k&&await O,l?.atomic&&(0,b.$Ok)(r)||!((0,b.$Mk)(r)||(0,b.$Nk)(r))||(0,b.$Jk)(r)&&l?.preferUnbuffered?I=this.I(r,t,l):(0,b.$Nk)(r)?I=this.G(r,t,o.token,l):I=this.H(r,t,o.token,l),I.on("end",()=>o.dispose()),I.on("error",()=>o.dispose()),{...await O,value:I}}catch(v){throw I&&await(0,w.$ke)(I),this.F(v,t,l)}}F(r,t,n){const s=(0,k.localize)(11,null,this.sb(t),(0,b.$Uk)(r).toString());return r instanceof b.$4k?new b.$4k(s,r.stat,n):r instanceof b.$3k?new b.$3k(s,r.fileOperationResult,r.size,r.options):new b.$2k(s,(0,b.$Xk)(r),n)}G(r,t,n,s=Object.create(null)){const o=r.readFileStream(t,s,n);return(0,w.$qe)(o,{data:l=>l instanceof R.$te?l:R.$te.wrap(l),error:l=>this.F(l,t,s)},l=>R.$te.concat(l))}H(r,t,n,s=Object.create(null)){const o=(0,R.$Je)();return(0,c.$qq)(r,t,o,l=>l,{...s,bufferSize:this.a,errorTransformer:l=>this.F(l,t,s)},n),o}I(r,t,n){const s=(0,w.$he)(o=>R.$te.concat(o));return(async()=>{try{let o;n?.atomic&&(0,b.$Ok)(r)?o=await r.readFile(t,{atomic:!0}):o=await r.readFile(t),typeof n?.position=="number"&&(o=o.slice(n.position)),typeof n?.length=="number"&&(o=o.slice(0,n.length)),this.L(t,o.byteLength,n),s.end(R.$te.wrap(o))}catch(o){s.error(o),s.end()}})(),s}async J(r,t){const n=await this.resolve(r,{resolveMetadata:!0});if(n.isDirectory)throw new b.$2k((0,k.localize)(12,null,this.sb(r)),0,t);if(typeof t?.etag=="string"&&t.etag!==b.$_k&&t.etag===n.etag)throw new b.$4k((0,k.localize)(13,null),n,t);return this.L(r,n.size,t),n}L(r,t,n){if(typeof n?.limits?.size=="number"&&t>n.limits.size)throw new b.$3k((0,k.localize)(14,null,this.sb(r)),7,t,n)}async canMove(r,t,n){return this.M(r,t,"move",n)}async canCopy(r,t,n){return this.M(r,t,"copy",n)}async M(r,t,n,s){if(r.toString()!==t.toString())try{const o=n==="move"?this.qb(await this.n(r),r):await this.m(r),l=this.qb(await this.n(t),t);await this.Q(o,r,l,t,n,s)}catch(o){return o}return!0}async move(r,t,n){const s=this.qb(await this.n(r),r),o=this.qb(await this.n(t),t),l=await this.N(s,r,o,t,"move",!!n),O=await this.resolve(t,{resolveMetadata:!0});return this.r.fire(new b.$Yk(r,l==="move"?2:3,O)),O}async copy(r,t,n){const s=await this.m(r),o=this.qb(await this.n(t),t),l=await this.N(s,r,o,t,"copy",!!n),O=await this.resolve(t,{resolveMetadata:!0});return this.r.fire(new b.$Yk(r,l==="copy"?3:2,O)),O}async N(r,t,n,s,o,l){if(t.toString()===s.toString())return o;const{exists:O,isSameResourceWithDifferentPathCase:I}=await this.Q(r,t,n,s,o,l);if(O&&!I&&l&&await this.del(s,{recursive:!0}),await this.U(n,this.R(n).providerExtUri.dirname(s)),o==="copy"){if(r===n&&(0,b.$Kk)(r))await r.copy(t,s,{overwrite:l});else{const v=await this.resolve(t);v.isDirectory?await this.P(r,v,n,s):await this.O(r,t,n,s)}return o}else return r===n?(await r.rename(t,s,{overwrite:l}),o):(await this.N(r,t,n,s,"copy",l),await this.del(t,{recursive:!0}),"copy")}async O(r,t,n,s){if((0,b.$Mk)(r)&&(0,b.$Mk)(n))return this.jb(r,t,n,s);if((0,b.$Mk)(r)&&(0,b.$Jk)(n))return this.pb(r,t,n,s);if((0,b.$Jk)(r)&&(0,b.$Mk)(n))return this.nb(r,t,n,s);if((0,b.$Jk)(r)&&(0,b.$Jk)(n))return this.lb(r,t,n,s)}async P(r,t,n,s){await n.mkdir(s),Array.isArray(t.children)&&await D.Promises.settled(t.children.map(async o=>{const l=this.R(n).providerExtUri.joinPath(s,o.name);return o.isDirectory?this.P(r,await this.resolve(o.resource),n,l):this.O(r,o.resource,n,l)}))}async Q(r,t,n,s,o,l){let O=!1;if(r===n){const{providerExtUri:v,isPathCaseSensitive:j}=this.R(r);if(j||(O=v.isEqual(t,s)),O&&o==="copy")throw new Error((0,k.localize)(15,null,this.sb(t),this.sb(s)));if(!O&&v.isEqualOrParent(s,t))throw new Error((0,k.localize)(16,null,this.sb(t),this.sb(s)))}const I=await this.exists(s);if(I&&!O){if(!l)throw new b.$2k((0,k.localize)(17,null,this.sb(t),this.sb(s)),4);if(r===n){const{providerExtUri:v}=this.R(r);if(v.isEqualOrParent(t,s))throw new Error((0,k.localize)(18,null,this.sb(t),this.sb(s)))}}return{exists:I,isSameResourceWithDifferentPathCase:O}}R(r){const t=this.S(r);return{providerExtUri:t?m.$Jg:m.$Lg,isPathCaseSensitive:t}}S(r){return!!(r.capabilities&1024)}async createFolder(r){const t=this.qb(await this.j(r),r);await this.U(t,r);const n=await this.resolve(r,{resolveMetadata:!0});return this.r.fire(new b.$Yk(r,0,n)),n}async U(r,t){const n=[],{providerExtUri:s}=this.R(r);for(;!s.isEqual(t,s.dirname(t));)try{if(!((await r.stat(t)).type&b.FileType.Directory))throw new Error((0,k.localize)(19,null,this.sb(t)));break}catch(o){if((0,b.$Wk)(o)!==b.FileSystemProviderErrorCode.FileNotFound)throw o;n.push(s.basename(t)),t=s.dirname(t)}for(let o=n.length-1;o>=0;o--){t=s.joinPath(t,n[o]);try{await r.mkdir(t)}catch(l){if((0,b.$Wk)(l)!==b.FileSystemProviderErrorCode.FileExists)throw l}}}async canDelete(r,t){try{await this.W(r,t)}catch(n){return n}return!0}async W(r,t){const n=this.qb(await this.j(r),r),s=!!t?.useTrash;if(s&&!(n.capabilities&4096))throw new Error((0,k.localize)(20,null,this.sb(r)));const o=t?.atomic;if(o&&!(n.capabilities&65536))throw new Error((0,k.localize)(21,null,this.sb(r)));if(s&&o)throw new Error((0,k.localize)(22,null,this.sb(r)));let l;try{l=await n.stat(r)}catch{}if(l)this.rb(r,l);else throw new b.$2k((0,k.localize)(23,null,this.sb(r)),1);if(!!!t?.recursive){const I=await this.resolve(r);if(I.isDirectory&&Array.isArray(I.children)&&I.children.length>0)throw new Error((0,k.localize)(24,null,this.sb(r)))}return n}async del(r,t){const n=await this.W(r,t);let s=t;if((0,b.$Qk)(n)&&!s?.atomic){const I=n.enforceAtomicDelete?.(r);I&&(s={...t,atomic:I})}const o=!!s?.useTrash,l=!!s?.recursive,O=s?.atomic??!1;await n.delete(r,{recursive:l,useTrash:o,atomic:O}),this.r.fire(new b.$Yk(r,1))}async cloneFile(r,t){const n=await this.j(r),s=this.qb(await this.n(t),t);if(!(n===s&&this.R(n).providerExtUri.isEqual(r,t)))return n===s&&(0,b.$Lk)(n)?n.cloneFile(r,t):(await this.U(s,this.R(s).providerExtUri.dirname(t)),n===s&&(0,b.$Kk)(n)?this.cb.queueFor(r,()=>n.copy(r,t,{overwrite:!0}),this.R(n).providerExtUri):this.cb.queueFor(r,()=>this.O(n,r,s,t),this.R(n).providerExtUri))}static{this.ab=0}createWatcher(r,t){return this.watch(r,{...t,correlationId:h.ab++})}watch(r,t={recursive:!1,excludes:[]}){const n=new a.$Sc;let s=!1,o=()=>{s=!0};n.add((0,a.$Rc)(()=>o())),(async()=>{try{const O=await this.bb(r,t);s?(0,a.$Oc)(O):o=()=>(0,a.$Oc)(O)}catch(O){this.b.error(O)}})();const l=t.correlationId;if(typeof l=="number"){const O=n.add(new A.$6d);return n.add(this.X.event(v=>{v.correlates(l)&&O.fire(v)})),{onDidChange:O.event,dispose:()=>n.dispose()}}return n}async bb(r,t){const n=await this.j(r),s=(0,P.$7i)([this.R(n).providerExtUri.getComparisonKey(r),t]);let o=this.$.get(s);return o||(o={count:0,disposable:n.watch(r,t)},this.$.set(s,o)),o.count+=1,(0,a.$Rc)(()=>{o&&(o.count--,o.count===0&&((0,a.$Oc)(o.disposable),this.$.delete(s)))})}dispose(){super.dispose();for(const[,r]of this.$)(0,a.$Oc)(r.disposable);this.$.clear()}async db(r,t,n,s){return this.cb.queueFor(t,async()=>{const o=await r.open(t,{create:!0,unlock:n?.unlock??!1});try{(0,w.$fe)(s)||(0,w.$ge)(s)?await this.eb(r,o,s):await this.fb(r,o,s)}catch(l){throw(0,b.$Uk)(l)}finally{await r.close(o)}},this.R(r).providerExtUri)}async eb(r,t,n){let s=0,o;if((0,w.$ge)(n)){if(n.buffer.length>0){const l=R.$te.concat(n.buffer);await this.gb(r,t,l,l.byteLength,s,0),s+=l.byteLength}if(n.ended)return;o=n.stream}else o=n;return new Promise((l,O)=>{(0,w.$le)(o,{onData:async I=>{o.pause();try{await this.gb(r,t,I,I.byteLength,s,0)}catch(v){return O(v)}s+=I.byteLength,setTimeout(()=>o.resume())},onError:I=>O(I),onEnd:()=>l()})})}async fb(r,t,n){let s=0,o;for(;(o=n.read())!==null;)await this.gb(r,t,o,o.byteLength,s,0),s+=o.byteLength}async gb(r,t,n,s,o,l){let O=0;for(;O<s;){const I=await r.write(t,o+O,n.buffer,l+O,s-O);O+=I}}async hb(r,t,n,s){return this.cb.queueFor(t,()=>this.ib(r,t,n,s),this.R(r).providerExtUri)}async ib(r,t,n,s){let o;s instanceof R.$te?o=s:(0,w.$fe)(s)?o=await(0,R.$Fe)(s):(0,w.$ge)(s)?o=await(0,R.$Ge)(s):o=(0,R.$De)(s),await r.writeFile(t,o.buffer,{create:!0,overwrite:!0,unlock:n?.unlock??!1,atomic:n?.atomic??!1})}async jb(r,t,n,s){return this.cb.queueFor(s,()=>this.kb(r,t,n,s),this.R(n).providerExtUri)}async kb(r,t,n,s){let o,l;try{o=await r.open(t,{create:!1}),l=await n.open(s,{create:!0,unlock:!1});const O=R.$te.alloc(this.a);let I=0,v=0,j=0;do j=await r.read(o,I,O.buffer,v,O.byteLength-v),await this.gb(n,l,O,j,I,v),I+=j,v+=j,v===O.byteLength&&(v=0);while(j>0)}catch(O){throw(0,b.$Uk)(O)}finally{await D.Promises.settled([typeof o=="number"?r.close(o):Promise.resolve(),typeof l=="number"?n.close(l):Promise.resolve()])}}async lb(r,t,n,s){return this.cb.queueFor(s,()=>this.mb(r,t,n,s),this.R(n).providerExtUri)}async mb(r,t,n,s){return n.writeFile(s,await r.readFile(t),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(r,t,n,s){return this.cb.queueFor(s,()=>this.ob(r,t,n,s),this.R(n).providerExtUri)}async ob(r,t,n,s){const o=await n.open(s,{create:!0,unlock:!1});try{const l=await r.readFile(t);await this.gb(n,o,R.$te.wrap(l),l.byteLength,0,0)}catch(l){throw(0,b.$Uk)(l)}finally{await n.close(o)}}async pb(r,t,n,s){const o=await(0,R.$Fe)(this.H(r,t,L.CancellationToken.None));await this.hb(n,s,void 0,o)}qb(r,t){if(r.capabilities&2048)throw new b.$2k((0,k.localize)(25,null,this.sb(t)),6);return r}rb(r,t){if((t.permissions??0)&b.FilePermission.Readonly)throw new b.$2k((0,k.localize)(26,null,this.sb(r)),6)}sb(r){return r.scheme===E.Schemas.file?r.fsPath:r.toString(!0)}};e.$rq=g,e.$rq=g=h=pe([se(0,p.$Aj)],g)}),define(ie[128],ne([0,1,90,171,9,31,14,6,172,2,16,12,17,46,24,104,13,60,125,34,123,122]),function(J,e,N,D,R,L,A,P,u,a,y,E,d,m,w,k,b,c,p,$,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qq=void 0,(()=>{try{(0,D.gracefulify)(N)}catch(r){console.error(`Error enabling graceful-fs: ${(0,$.$4i)(r)}`)}})();class i extends p.$Aq{static{this.I=!1}constructor(t,n){super(t,n),this.onDidChangeCapabilities=P.Event.None,this.N=new L.$Ac(s=>d.$Kg.getComparisonKey(s)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,E.$k&&(this.J|=1024)),this.J}async stat(t){try{const{stat:n,symbolicLink:s}=await w.SymlinkSupport.stat(this.H(t));return{type:this.M(n,s),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size,permissions:n.mode&128?void 0:b.FilePermission.Locked}}catch(n){throw this.fb(n)}}async L(t){try{return await this.stat(t)}catch{return}}async readdir(t){try{const n=await w.Promises.readdir(this.H(t),{withFileTypes:!0}),s=[];return await Promise.all(n.map(async o=>{try{let l;o.isSymbolicLink()?l=(await this.stat((0,d.$Tg)(t,o.name))).type:l=this.M(o),s.push([o.name,l])}catch(l){this.a.trace(l)}})),s}catch(n){throw this.fb(n)}}M(t,n){let s;return n?.dangling?s=b.FileType.Unknown:t.isFile()?s=b.FileType.File:t.isDirectory()?s=b.FileType.Directory:s=b.FileType.Unknown,n&&(s|=b.FileType.SymbolicLink),s}async O(t){const n=this.H(t);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let s;for(;s=this.N.get(t);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await s.wait();const o=new R.$fh;return this.N.set(t,o),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,a.$Rc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.N.get(t)===o&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.N.delete(t)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),o.open()})}async readFile(t,n){let s;try{n?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(t)})`),s=await this.O(t));const o=this.H(t);return await w.Promises.readFile(o)}catch(o){throw this.fb(o)}finally{s?.dispose()}}P(t){i.I&&this.a.trace(t)}readFileStream(t,n,s){const o=(0,m.$he)(l=>A.$te.concat(l.map(O=>A.$te.wrap(O))).buffer);return(0,c.$qq)(this,t,o,l=>l.buffer,{...n,bufferSize:256*1024},s),o}async writeFile(t,n,s){return s?.atomic!==!1&&s?.atomic?.postfix&&await this.Q(t)?this.R(t,(0,d.$Tg)((0,d.$Sg)(t),`${(0,d.$Qg)(t)}${s.atomic.postfix}`),n,s):this.S(t,n,s)}async Q(t){try{const n=this.H(t),{symbolicLink:s}=await w.SymlinkSupport.stat(n);if(s)return!1}catch{}return!0}async R(t,n,s,o){const l=new a.$Sc;try{l.add(await this.O(t)),l.add(await this.O(n)),await this.S(n,s,o,!0);try{await this.rename(n,t,{overwrite:!0})}catch(O){try{await this.delete(n,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw O}}finally{l.dispose()}}async S(t,n,s,o){let l;try{const O=this.H(t);if(!s.create||!s.overwrite){if(await w.Promises.exists(O)){if(!s.overwrite)throw(0,b.$Tk)((0,k.localize)(0,null),b.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,b.$Tk)((0,k.localize)(1,null),b.FileSystemProviderErrorCode.FileNotFound)}l=await this.open(t,{create:!0,unlock:s.unlock},o),await this.write(l,0,n,0,n.byteLength)}catch(O){throw await this.gb(t,O)}finally{typeof l=="number"&&await this.close(l)}}static{this.Y=!0}static configureFlushOnWrite(t){i.Y=t}async open(t,n,s){const o=this.H(t);let l;(0,b.$Hk)(n)&&!s&&(l=await this.O(t));let O;try{if((0,b.$Hk)(n)&&n.unlock)try{const{stat:v}=await w.SymlinkSupport.stat(o);v.mode&128||await w.Promises.chmod(o,v.mode|128)}catch(v){v.code!=="ENOENT"&&this.a.trace(v)}let I;if((0,b.$Hk)(n)){if(E.$i)try{await w.Promises.truncate(o,0),I="r+"}catch(v){v.code!=="ENOENT"&&this.a.trace(v)}I||(I="w")}else I="r";O=await w.Promises.open(o,I)}catch(I){throw l?.dispose(),(0,b.$Hk)(n)?await this.gb(t,I):this.fb(I)}if(this.U.set(O,0),(0,b.$Hk)(n)&&this.X.set(O,t),l){const I=this.W.get(O);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${O} (${o})`),this.W.set(O,l),I&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${O} (${o})`),I.dispose())}return O}async close(t){const n=this.W.get(t);try{if(this.U.delete(t),this.X.delete(t)&&i.Y)try{await w.Promises.fdatasync(t)}catch(s){i.configureFlushOnWrite(!1),this.a.error(s)}return await w.Promises.close(t)}catch(s){throw this.fb(s)}finally{n&&(this.W.get(t)===n&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${t}`),this.W.delete(t)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${t}`),n.dispose())}}async read(t,n,s,o,l){const O=this.Z(t,n);let I=null;try{I=(await w.Promises.read(t,s,o,l,O)).bytesRead}catch(v){throw this.fb(v)}finally{this.$(t,O,I)}return I}Z(t,n){return n===this.U.get(t)?null:n}$(t,n,s){const o=this.U.get(t);typeof o=="number"&&(typeof n=="number"||(typeof s=="number"?this.U.set(t,o+s):this.U.delete(t)))}async write(t,n,s,o,l){return(0,R.$Ah)(()=>this.ab(t,n,s,o,l),100,3)}async ab(t,n,s,o,l){const O=this.Z(t,n);let I=null;try{I=(await w.Promises.write(t,s,o,l,O)).bytesWritten}catch(v){throw await this.gb(this.X.get(t),v)}finally{this.$(t,O,I)}return I}async mkdir(t){try{await w.Promises.mkdir(this.H(t))}catch(n){throw this.fb(n)}}async delete(t,n){try{const s=this.H(t);if(n.recursive){let o;n?.atomic!==!1&&n.atomic.postfix&&(o=(0,y.$jc)((0,y.$mc)(s),`${(0,y.$nc)(s)}${n.atomic.postfix}`)),await w.Promises.rm(s,w.RimRafMode.MOVE,o)}else try{await w.Promises.unlink(s)}catch(o){if(o.code==="EPERM"||o.code==="EISDIR"){let l=!1;try{const{stat:O,symbolicLink:I}=await w.SymlinkSupport.stat(s);l=O.isDirectory()&&!I}catch{}if(l)await w.Promises.rmdir(s);else throw o}else throw o}}catch(s){throw this.fb(s)}}async rename(t,n,s){const o=this.H(t),l=this.H(n);if(o!==l)try{await this.bb(t,n,"move",s.overwrite),await w.Promises.rename(o,l)}catch(O){throw(O.code==="EINVAL"||O.code==="EBUSY"||O.code==="ENAMETOOLONG")&&(O=new Error((0,k.localize)(2,null,(0,y.$nc)(o),(0,y.$nc)((0,y.$mc)(l)),O.toString()))),this.fb(O)}}async copy(t,n,s){const o=this.H(t),l=this.H(n);if(o!==l)try{await this.bb(t,n,"copy",s.overwrite),await w.Promises.copy(o,l,{preserveSymlinks:!0})}catch(O){throw(O.code==="EINVAL"||O.code==="EBUSY"||O.code==="ENAMETOOLONG")&&(O=new Error((0,k.localize)(3,null,(0,y.$nc)(o),(0,y.$nc)((0,y.$mc)(l)),O.toString()))),this.fb(O)}}async bb(t,n,s,o){const l=this.H(t),O=this.H(n);let I=!1;if(!!(this.capabilities&1024)||(I=(0,u.$fg)(l,O,!0)),I){if(s==="copy")throw(0,b.$Tk)((0,k.localize)(4,null),b.FileSystemProviderErrorCode.FileExists);if(s==="move")return}const j=await this.L(t);if(!j)throw(0,b.$Tk)((0,k.localize)(5,null),b.FileSystemProviderErrorCode.FileNotFound);const q=await this.L(n);if(q){if(!o)throw(0,b.$Tk)((0,k.localize)(6,null),b.FileSystemProviderErrorCode.FileExists);j.type&b.FileType.File&&q.type&b.FileType.File||await this.delete(n,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(t,n){return this.cb(t,n,!1)}async cb(t,n,s){const o=this.H(t),l=this.H(n),O=!!(this.capabilities&1024);if((0,u.$fg)(o,l,!O))return;const I=new a.$Sc;try{I.add(await this.O(t)),I.add(await this.O(n)),s&&await w.Promises.mkdir((0,y.$mc)(l),{recursive:!0}),await w.Promises.copyFile(o,l)}catch(v){if(v.code==="ENOENT"&&!s)return this.cb(t,n,!0);throw this.fb(v)}finally{I.dispose()}}t(t,n,s){return new h.$Hq(o=>t(o),o=>n(o),s)}F(t,n,s){return new g.$Pq(o=>t(o),o=>n(o),s)}fb(t){if(t instanceof b.$Sk)return t;let n=t,s;switch(t.code){case"ENOENT":s=b.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":s=b.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":s=b.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":s=b.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":s=b.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":n=`${t.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,s=b.FileSystemProviderErrorCode.Unknown;break;default:s=b.FileSystemProviderErrorCode.Unknown}return(0,b.$Tk)(n,s)}async gb(t,n){let s=this.fb(n);if(t&&s.code===b.FileSystemProviderErrorCode.NoPermissions)try{const{stat:o}=await w.SymlinkSupport.stat(this.H(t));o.mode&128||(s=(0,b.$Tk)(n,b.FileSystemProviderErrorCode.FileWriteLocked))}catch(o){this.a.trace(o)}return s}}e.$Qq=i}),define(ie[129],ne([0,1,2,4]),function(J,e,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PP=void 0;class R extends N.$Tc{constructor(A,P=[]){super(),this.a=new D.$Kj([A,...P]),this.B(A.onDidChangeLogLevel(u=>this.setLevel(u)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(A){this.a.setLevel(A)}getLevel(){return this.a.getLevel()}trace(A,...P){this.a.trace(A,...P)}debug(A,...P){this.a.debug(A,...P)}info(A,...P){this.a.info(A,...P)}warn(A,...P){this.a.warn(A,...P)}error(A,...P){this.a.error(A,...P)}flush(){this.a.flush()}}e.$PP=R}),define(ie[130],ne([0,1,13,4]),function(J,e,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EP=void 0;var R;(function(a){a[a.Trace=0]="Trace",a[a.Debug=1]="Debug",a[a.Info=2]="Info",a[a.Warning=3]="Warning",a[a.Error=4]="Error",a[a.Critical=5]="Critical",a[a.Off=6]="Off"})(R||(R={}));async function L(a,y,E,d,m){try{const w=await new Promise((b,c)=>{J(["@vscode/spdlog"],b,c)});w.setFlushOn(R.Trace);const k=await w.createAsyncRotatingLogger(a,y,E,d);return m?k.clearFormatters():k.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),k}catch(w){console.error(w)}return null}function A(a,y,E){switch(y){case D.LogLevel.Trace:a.trace(E);break;case D.LogLevel.Debug:a.debug(E);break;case D.LogLevel.Info:a.info(E);break;case D.LogLevel.Warning:a.warn(E);break;case D.LogLevel.Error:a.error(E);break;case D.LogLevel.Off:break;default:throw new Error(`Invalid log level ${y}`)}}function P(a,y){switch(y){case D.LogLevel.Trace:a.setLevel(R.Trace);break;case D.LogLevel.Debug:a.setLevel(R.Debug);break;case D.LogLevel.Info:a.setLevel(R.Info);break;case D.LogLevel.Warning:a.setLevel(R.Warning);break;case D.LogLevel.Error:a.setLevel(R.Error);break;case D.LogLevel.Off:a.setLevel(R.Off);break;default:throw new Error(`Invalid log level ${y}`)}}class u extends D.$Gj{constructor(y,E,d,m,w){super(),this.m=[],this.setLevel(w),this.n=this.s(y,E,d,m),this.B(this.onDidChangeLogLevel(k=>{this.r&&P(this.r,k)}))}async s(y,E,d,m){const w=d?6:1,k=30/w*N.$cl.MB,b=await L(y,E,k,w,m);if(b){this.r=b,P(this.r,this.getLevel());for(const{level:c,message:p}of this.m)A(this.r,c,p);this.m=[]}}g(y,E){this.r?A(this.r,y,E):this.getLevel()<=y&&this.m.push({level:y,message:E})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$EP=u}),define(ie[131],ne([0,1,28,4,130]),function(J,e,N,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FP=void 0;class L extends D.$Lj{s(P,u,a){return new R.$EP((0,N.$Cg)(),P.fsPath,!a?.donotRotate,!!a?.donotUseFormatters,u)}}e.$FP=L}),define(ie[39],ne([0,1,6,65,2,10]),function(J,e,N,D,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2n=e.$1n=e.$Zn=void 0,e.$Zn=(0,L.$gi)("policy");class A extends R.$Tc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new N.$6d),this.onDidChange=this.h.event}async updatePolicyDefinitions(a){const y=Object.keys(this.f).length;return this.f={...a,...this.f},y!==Object.keys(this.f).length&&await this.j(a),D.Iterable.reduce(this.g.entries(),(E,[d,m])=>({...E,[d]:m}),{})}getPolicyValue(a){return this.g.get(a)}serialize(){return D.Iterable.reduce(Object.entries(this.f),(a,[y,E])=>({...a,[y]:{definition:E,value:this.g.get(y)}}),{})}}e.$1n=A;class P{constructor(){this.onDidChange=N.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$2n=P}),define(ie[132],ne([0,1,9,6,65,3,13,4,39]),function(J,e,N,D,R,L,A,P,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1ac=void 0;function a(E,d){const m=[];for(const w of new Set(R.Iterable.concat(E.keys(),d.keys())))E.get(w)!==d.get(w)&&m.push(w);return m}let y=class extends u.$1n{constructor(d,m,w){super(),this.m=d,this.n=m,this.s=w,this.c=this.B(new N.$eh(500));const k=D.Event.filter(m.onDidFilesChange,b=>b.affects(d));this.B(m.watch(d)),this.B(k(()=>this.c.trigger(()=>this.w())))}async j(){await this.w()}async u(){const d=new Map;try{const m=await this.n.readFile(this.m),w=JSON.parse(m.value.toString());if(!(0,L.$Vf)(w))throw new Error("Policy file isn't a JSON object");for(const k of Object.keys(w))this.f[k]&&d.set(k,w[k])}catch(m){m.fileOperationResult!==1&&this.s.error("[FilePolicyService] Failed to read policies",m)}return d}async w(){const d=await this.u(),m=a(this.g,d);this.g=d,m.length>0&&this.h.fire(m)}};e.$1ac=y,e.$1ac=y=pe([se(1,A.$Gk),se(2,P.$Aj)],y)}),define(ie[133],ne([0,1,39,9,2,4]),function(J,e,N,D,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zac=void 0;let A=class extends N.$1n{constructor(u,a){super(),this.m=u,this.n=a,this.a=new D.$ah,this.b=this.B(new R.$Uc)}async j(u){this.m.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(u).length} policy definitions`);const{createWatcher:a}=await new Promise((y,E)=>{J(["@vscode/policy-watcher"],y,E)});await this.a.queue(()=>new Promise((y,E)=>{try{this.b.value=a(this.n,u,d=>{this.t(d),y()})}catch(d){this.m.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",d),E(d)}}))}t(u){this.m.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(u)}`);for(const a in u){const y=u[a];y===void 0?this.g.delete(a):this.g.set(a,y)}this.h.fire(Object.keys(u))}};e.$Zac=A,e.$Zac=A=pe([se(0,L.$Aj)],A)}),define(ie[32],ne([0,1,10]),function(J,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tj=e.$Sj=void 0,e.$Sj=(0,N.$gi)("productService"),e.$Tj="vscode://schemas/vscode-product"}),define(ie[36],ne([0,1,71,3]),function(J,e,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xn=void 0;class R{constructor(){this.a=new Map}add(A,P){N.ok(D.$Tf(A)),N.ok(D.$Vf(P)),N.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,P)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}e.$Xn=new R}),define(ie[134],ne([0,1,6,36]),function(J,e,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yn=void 0,e.$Yn={JSONContribution:"base.contributions.json"};function R(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class L{constructor(){this.b=new N.$6d,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(u,a){this.a[R(u)]=a,this.b.fire(u)}notifySchemaChanged(u){this.b.fire(u)}getSchemaContributions(){return{schemas:this.a}}}const A=new L;D.$Xn.add(e.$Yn.JSONContribution,A)}),define(ie[40],ne([0,1,19,6,3,91,29,134,36]),function(J,e,N,D,R,L,A,P,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fo=e.$eo=e.$do=e.$co=e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.ConfigurationScope=e.$3n=e.EditPresentationTypes=void 0;var a;(function(g){g.Multiline="multilineText",g.Singleline="singlelineText"})(a||(e.EditPresentationTypes=a={})),e.$3n={Configuration:"base.contributions.configuration"};var y;(function(g){g[g.APPLICATION=1]="APPLICATION",g[g.MACHINE=2]="MACHINE",g[g.WINDOW=3]="WINDOW",g[g.RESOURCE=4]="RESOURCE",g[g.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",g[g.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(y||(e.ConfigurationScope=y={})),e.$4n={properties:{},patternProperties:{}},e.$5n={properties:{},patternProperties:{}},e.$6n={properties:{},patternProperties:{}},e.$7n={properties:{},patternProperties:{}},e.$8n={properties:{},patternProperties:{}},e.$9n={properties:{},patternProperties:{}},e.$0n="vscode://schemas/settings/resourceLanguage",e.$$n="vscode://schemas/settings/configurationDefaults";const E=u.$Xn.as(P.$Yn.JSONContribution);class d{constructor(){this.h=new Set,this.i=new D.$6d,this.onDidSchemaChange=this.i.event,this.j=new D.$6d,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:L.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},E.registerSchema(e.$0n,this.g),this.v()}registerConfiguration(i,r=!0){this.registerConfigurations([i],r)}registerConfigurations(i,r=!0){const t=new Set;this.n(i,r,t),E.registerSchema(e.$0n,this.g),this.i.fire(),this.j.fire({properties:t})}deregisterConfigurations(i){const r=new Set;this.o(i,r),E.registerSchema(e.$0n,this.g),this.i.fire(),this.j.fire({properties:r})}updateConfigurations({add:i,remove:r}){const t=new Set;this.o(r,t),this.n(i,!1,t),E.registerSchema(e.$0n,this.g),this.i.fire(),this.j.fire({properties:t})}registerDefaultConfigurations(i){const r=new Set;this.k(i,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}k(i,r){const t=[];for(const{overrides:n,source:s}of i)for(const o in n)if(r.add(o),e.$ao.test(o)){const l=this.a.get(o),O=l?.valuesSources??new Map;if(s)for(const q of Object.keys(n[o]))O.set(q,s);const I={...l?.value||{},...n[o]};this.a.set(o,{source:s,value:I,valuesSources:O});const v=(0,A.$Wi)(o),j={type:"object",default:I,description:L.localize(1,null,v),$ref:e.$0n,defaultDefaultValue:I,source:R.$Tf(s)?void 0:s,defaultValueSource:s};t.push(...k(o)),this.d[o]=j,this.b.properties[o]=j}else{this.a.set(o,{value:n[o],source:s});const l=this.d[o];l&&(this.w(o,l),this.r(o,l))}this.m(t)}deregisterDefaultConfigurations(i){const r=new Set;this.l(i,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}l(i,r){for(const{overrides:t,source:n}of i)for(const s in t){const o=this.a.get(s),l=R.$Tf(n)?n:n?.id,O=R.$Tf(o?.source)?o?.source:o?.source?.id;if(l===O)if(r.add(s),this.a.delete(s),e.$ao.test(s))delete this.d[s],delete this.b.properties[s];else{const I=this.d[s];I&&(this.w(s,I),this.r(s,I))}}this.u()}deltaConfiguration(i){let r=!1;const t=new Set;i.removedDefaults&&(this.l(i.removedDefaults,t),r=!0),i.addedDefaults&&(this.k(i.addedDefaults,t),r=!0),i.removedConfigurations&&this.o(i.removedConfigurations,t),i.addedConfigurations&&this.n(i.addedConfigurations,!1,t),this.i.fire(),this.j.fire({properties:t,defaultsOverrides:r})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){this.m(i),this.i.fire()}m(i){for(const r of i)this.h.add(r);this.u()}n(i,r,t){i.forEach(n=>{this.p(n,r,n.extensionInfo,n.restrictedProperties,void 0,t),this.c.push(n),this.q(n)})}o(i,r){const t=n=>{if(n.properties)for(const s in n.properties){r.add(s);const o=this.d[s];o?.policy?.name&&this.e.delete(o.policy.name),delete this.d[s],this.s(s,n.properties[s])}n.allOf?.forEach(s=>t(s))};for(const n of i){t(n);const s=this.c.indexOf(n);s!==-1&&this.c.splice(s,1)}}p(i,r=!0,t,n,s=3,o){s=R.$3f(i.scope)?s:i.scope;const l=i.properties;if(l)for(const I in l){const v=l[I];if(r&&$(I,v)){delete l[I];continue}if(v.source=t,v.defaultDefaultValue=l[I].default,this.w(I,v),e.$ao.test(I)?v.scope=void 0:(v.scope=R.$3f(v.scope)?s:v.scope,v.restricted=R.$3f(v.restricted)?!!n?.includes(I):v.restricted),l[I].hasOwnProperty("included")&&!l[I].included){this.f[I]=l[I],delete l[I];continue}else this.d[I]=l[I],l[I].policy?.name&&this.e.set(l[I].policy.name,I);!l[I].deprecationMessage&&l[I].markdownDeprecationMessage&&(l[I].deprecationMessage=l[I].markdownDeprecationMessage),o.add(I)}const O=i.allOf;if(O)for(const I of O)this.p(I,r,t,n,s,o)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(i){const r=t=>{const n=t.properties;if(n)for(const o in n)this.r(o,n[o]);t.allOf?.forEach(r)};r(i)}r(i,r){switch(e.$4n.properties[i]=r,r.scope){case 1:e.$5n.properties[i]=r;break;case 2:e.$6n.properties[i]=r;break;case 6:e.$7n.properties[i]=r;break;case 3:e.$8n.properties[i]=r;break;case 4:e.$9n.properties[i]=r;break;case 5:e.$9n.properties[i]=r,this.g.properties[i]=r;break}}s(i,r){switch(delete e.$4n.properties[i],r.scope){case 1:delete e.$5n.properties[i];break;case 2:delete e.$6n.properties[i];break;case 6:delete e.$7n.properties[i];break;case 3:delete e.$8n.properties[i];break;case 4:case 5:delete e.$9n.properties[i],delete this.g.properties[i];break}}u(){for(const i of this.h.values()){const r=`[${i}]`,t={type:"object",description:L.localize(2,null),errorMessage:L.localize(3,null),$ref:e.$0n};this.w(r,t),e.$4n.properties[r]=t,e.$5n.properties[r]=t,e.$6n.properties[r]=t,e.$7n.properties[r]=t,e.$8n.properties[r]=t,e.$9n.properties[r]=t}}v(){const i={type:"object",description:L.localize(4,null),errorMessage:L.localize(5,null),$ref:e.$0n};e.$4n.patternProperties[e.$_n]=i,e.$5n.patternProperties[e.$_n]=i,e.$6n.patternProperties[e.$_n]=i,e.$7n.patternProperties[e.$_n]=i,e.$8n.patternProperties[e.$_n]=i,e.$9n.patternProperties[e.$_n]=i,this.i.fire()}w(i,r){const t=this.a.get(i);let n=t?.value,s=t?.source;R.$1f(n)&&(n=r.defaultDefaultValue,s=void 0),R.$1f(n)&&(n=c(r.type)),r.default=n,r.defaultValueSource=s}}const m="\\[([^\\]]+)\\]",w=new RegExp(m,"g");e.$_n=`^(${m})+$`,e.$ao=new RegExp(e.$_n);function k(g){const i=[];if(e.$ao.test(g)){let r=w.exec(g);for(;r?.length;){const t=r[1].trim();t&&i.push(t),r=w.exec(g)}}return(0,N.$Mb)(i)}e.$bo=k;function b(g){return g.reduce((i,r)=>`${i}[${r}]`,"")}e.$co=b;function c(g){switch(Array.isArray(g)?g[0]:g){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$do=c;const p=new d;u.$Xn.add(e.$3n.Configuration,p);function $(g,i){return g.trim()?e.$ao.test(g)?L.localize(7,null,g):p.getConfigurationProperties()[g]!==void 0?L.localize(8,null,g):i.policy?.name&&p.getPolicyConfigurations().get(i.policy?.name)!==void 0?L.localize(9,null,g,i.policy?.name,p.getPolicyConfigurations().get(i.policy?.name)):null:L.localize(6,null)}e.$eo=$;function h(){const g=[],i=p.getConfigurationProperties();for(const r of Object.keys(i))g.push([r,i[r].scope]);return g.push(["launch",4]),g.push(["task",4]),g}e.$fo=h}),define(ie[66],ne([0,1,19,6,38,2,31,27,3,11,29,40,36]),function(J,e,N,D,R,L,A,P,u,a,y,E,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=void 0;function m(r){return Object.isFrozen(r)?r:P.$Mn(r)}class w{constructor(t={},n=[],s=[],o){this.b=t,this.c=n,this.d=s,this.raw=o,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const t=this.raw.map(n=>{if(n instanceof w)return n;const s=new k("");return s.parseRaw(n),s.configurationModel});this.f=t.reduce((n,s)=>s===n?s:n.merge(s),t[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(t){return t?(0,y.$Ui)(this.contents,t):this.contents}inspect(t,n){const s=this;return{get value(){return m(s.rawConfiguration.getValue(t))},get override(){return n?m(s.rawConfiguration.getOverrideValue(t,n)):void 0},get merged(){return m(n?s.rawConfiguration.override(n).getValue(t):s.rawConfiguration.getValue(t))},get overrides(){const o=[];for(const{contents:l,identifiers:O,keys:I}of s.rawConfiguration.overrides){const v=new w(l,I).getValue(t);v!==void 0&&o.push({identifiers:O,value:v})}return o.length?m(o):void 0}}}getOverrideValue(t,n){const s=this.i(n);return s?t?(0,y.$Ui)(s,t):s:void 0}getKeysForOverrideIdentifier(t){const n=[];for(const s of this.overrides)s.identifiers.includes(t)&&n.push(...s.keys);return N.$Mb(n)}getAllOverrideIdentifiers(){const t=[];for(const n of this.overrides)t.push(...n.identifiers);return N.$Mb(t)}override(t){let n=this.a.get(t);return n||(n=this.g(t),this.a.set(t,n)),n}merge(...t){const n=P.$Ln(this.contents),s=P.$Ln(this.overrides),o=[...this.keys],l=this.raw?.length?[...this.raw]:[this];for(const O of t)if(l.push(...O.raw?.length?O.raw:[O]),!O.isEmpty()){this.h(n,O.contents);for(const I of O.overrides){const[v]=s.filter(j=>N.$ub(j.identifiers,I.identifiers));v?(this.h(v.contents,I.contents),v.keys.push(...I.keys),v.keys=N.$Mb(v.keys)):s.push(P.$Ln(I))}for(const I of O.keys)o.indexOf(I)===-1&&o.push(I)}return new w(n,o,s,l.every(O=>O instanceof w)?void 0:l)}g(t){const n=this.i(t);if(!n||typeof n!="object"||!Object.keys(n).length)return this;const s={};for(const o of N.$Mb([...Object.keys(this.contents),...Object.keys(n)])){let l=this.contents[o];const O=n[o];O&&(typeof l=="object"&&typeof O=="object"?(l=P.$Ln(l),this.h(l,O)):l=O),s[o]=l}return new w(s,this.keys,this.overrides)}h(t,n){for(const s of Object.keys(n)){if(s in t&&u.$Vf(t[s])&&u.$Vf(n[s])){this.h(t[s],n[s]);continue}t[s]=P.$Ln(n[s])}}i(t){let n=null,s=null;const o=l=>{l&&(s?this.h(s,l):s=P.$Ln(l))};for(const l of this.overrides)l.identifiers.length===1&&l.identifiers[0]===t?n=l.contents:l.identifiers.includes(t)&&o(l.contents);return o(n),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(t,n){this.j(t,n,!0)}setValue(t,n){this.j(t,n,!1)}removeValue(t){const n=this.keys.indexOf(t);n!==-1&&(this.keys.splice(n,1),(0,y.$Ti)(this.contents,t),E.$ao.test(t)&&this.overrides.splice(this.overrides.findIndex(s=>N.$ub(s.identifiers,(0,E.$bo)(t))),1))}j(t,n,s){(0,y.$Si)(this.contents,t,n,o=>console.error(o)),s=s||this.keys.indexOf(t)===-1,s&&this.keys.push(t),E.$ao.test(t)&&this.overrides.push({identifiers:(0,E.$bo)(t),keys:Object.keys(this.contents[t]),contents:(0,y.$Ri)(this.contents[t],o=>console.error(o))})}}e.$go=w;class k{constructor(t){this.f=t,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new w}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(t,n){if(!u.$3f(t)){const s=this.g(t);this.parseRaw(s,n)}}reparse(t){this.a&&this.parseRaw(this.a,t)}parseRaw(t,n){this.a=t;const{contents:s,keys:o,overrides:l,restricted:O,hasExcludedProperties:I}=this.h(t,n);this.b=new w(s,o,l,I?[t]:void 0),this.c=O||[]}g(t){let n={},s=null,o=[];const l=[],O=[];function I(j){Array.isArray(o)?o.push(j):s!==null&&(o[s]=j)}const v={onObjectBegin:()=>{const j={};I(j),l.push(o),o=j,s=null},onObjectProperty:j=>{s=j},onObjectEnd:()=>{o=l.pop()},onArrayBegin:()=>{const j=[];I(j),l.push(o),o=j,s=null},onArrayEnd:()=>{o=l.pop()},onLiteralValue:I,onError:(j,q,Y)=>{O.push({error:j,offset:q,length:Y})}};if(t)try{R.$zn(t,v),n=o[0]||{}}catch(j){console.error(`Error while parsing settings file ${this.f}: ${j}`),this.d=[j]}return n}h(t,n){const s=d.$Xn.as(E.$3n.Configuration).getConfigurationProperties(),o=this.i(t,s,!0,n);t=o.raw;const l=(0,y.$Ri)(t,v=>console.error(`Conflict in settings file ${this.f}: ${v}`)),O=Object.keys(t),I=this.j(t,v=>console.error(`Conflict in settings file ${this.f}: ${v}`));return{contents:l,keys:O,overrides:I,restricted:o.restricted,hasExcludedProperties:o.hasExcludedProperties}}i(t,n,s,o){let l=!1;if(!o?.scopes&&!o?.skipRestricted&&!o?.exclude?.length)return{raw:t,restricted:[],hasExcludedProperties:l};const O={},I=[];for(const v in t)if(E.$ao.test(v)&&s){const j=this.i(t[v],n,!1,o);O[v]=j.raw,l=l||j.hasExcludedProperties,I.push(...j.restricted)}else{const j=n[v],q=j?typeof j.scope<"u"?j.scope:3:void 0;j?.restricted&&I.push(v),!o.exclude?.includes(v)&&(o.include?.includes(v)||(q===void 0||o.scopes===void 0||o.scopes.includes(q))&&!(o.skipRestricted&&j?.restricted))?O[v]=t[v]:l=!0}return{raw:O,restricted:I,hasExcludedProperties:l}}j(t,n){const s=[];for(const o of Object.keys(t))if(E.$ao.test(o)){const l={};for(const O in t[o])l[O]=t[o][O];s.push({identifiers:(0,E.$bo)(o),keys:Object.keys(l),contents:(0,y.$Ri)(l,n)})}return s}}e.$ho=k;class b extends L.$Tc{constructor(t,n,s,o){super(),this.c=t,this.f=n,this.g=o,this.b=this.B(new D.$6d),this.onDidChange=this.b.event,this.a=new k(this.c.toString()),this.B(this.g.watch(s.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(D.Event.any(D.Event.filter(this.g.onDidFilesChange,l=>l.contains(this.c)),D.Event.filter(this.g.onDidRunOperation,l=>(l.isOperation(0)||l.isOperation(3)||l.isOperation(1)||l.isOperation(4))&&s.isEqual(l.resource,t)))(()=>this.b.fire()))}async loadConfiguration(){try{const t=await this.g.readFile(this.c);return this.a.parse(t.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new w}}reparse(t){return t&&(this.f=t),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$io=b;class c{constructor(t,n,s,o,l,O,I,v,j,q,Y,Z,oe){this.a=t,this.b=n,this.c=s,this.overrideIdentifiers=o,this.d=l,this.f=O,this.g=I,this.h=v,this.i=j,this.j=q,this.k=Y,this.l=Z,this.m=oe}get value(){return m(this.c)}n(t){return t?.value!==void 0||t?.override!==void 0||t?.overrides!==void 0?t:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class p{constructor(t,n,s,o,l=new w,O=new w,I=new A.$Ac,v=new w,j=new A.$Ac){this.c=t,this.d=n,this.f=s,this.g=o,this.h=l,this.i=O,this.j=I,this.l=v,this.m=j,this.a=null,this.b=new A.$Ac,this.n=null}getValue(t,n,s){return this.p(t,n,s).getValue(t)}updateValue(t,n,s={}){let o;s.resource?(o=this.m.get(s.resource),o||(o=new w,this.m.set(s.resource,o))):o=this.l,n===void 0?o.removeValue(t):o.setValue(t,n),s.resource||(this.a=null)}inspect(t,n,s){const o=this.p(t,n,s),l=this.t(n.resource,s),O=n.resource?this.m.get(n.resource)||this.l:this.l,I=new Set;for(const v of o.overrides)for(const j of v.identifiers)o.getOverrideValue(t,j)!==void 0&&I.add(j);return new c(t,n,o.getValue(t),I.size?[...I]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,s?this.i:void 0,l||void 0,O)}keys(t){const n=this.t(void 0,t);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:n?n.keys.slice(0):[]}}updateDefaultConfiguration(t){this.c=t,this.a=null,this.b.clear()}updatePolicyConfiguration(t){this.d=t}updateApplicationConfiguration(t){this.f=t,this.a=null,this.b.clear()}updateLocalUserConfiguration(t){this.g=t,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(t){this.h=t,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(t){this.i=t,this.a=null,this.b.clear()}updateFolderConfiguration(t,n){this.j.set(t,n),this.b.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this.b.delete(t)}compareAndUpdateDefaultConfiguration(t,n){const s=[];if(!n){const{added:o,updated:l,removed:O}=g(this.c,t);n=[...o,...l,...O]}for(const o of n)for(const l of(0,E.$bo)(o)){const O=this.c.getKeysForOverrideIdentifier(l),I=t.getKeysForOverrideIdentifier(l),v=[...I.filter(j=>O.indexOf(j)===-1),...O.filter(j=>I.indexOf(j)===-1),...O.filter(j=>!P.$Pn(this.c.override(l).getValue(j),t.override(l).getValue(j)))];s.push([l,v])}return this.updateDefaultConfiguration(t),{keys:n,overrides:s}}compareAndUpdatePolicyConfiguration(t){const{added:n,updated:s,removed:o}=g(this.d,t),l=[...n,...s,...o];return l.length&&this.updatePolicyConfiguration(t),{keys:l,overrides:[]}}compareAndUpdateApplicationConfiguration(t){const{added:n,updated:s,removed:o,overrides:l}=g(this.applicationConfiguration,t),O=[...n,...s,...o];return O.length&&this.updateApplicationConfiguration(t),{keys:O,overrides:l}}compareAndUpdateLocalUserConfiguration(t){const{added:n,updated:s,removed:o,overrides:l}=g(this.localUserConfiguration,t),O=[...n,...s,...o];return O.length&&this.updateLocalUserConfiguration(t),{keys:O,overrides:l}}compareAndUpdateRemoteUserConfiguration(t){const{added:n,updated:s,removed:o,overrides:l}=g(this.remoteUserConfiguration,t),O=[...n,...s,...o];return O.length&&this.updateRemoteUserConfiguration(t),{keys:O,overrides:l}}compareAndUpdateWorkspaceConfiguration(t){const{added:n,updated:s,removed:o,overrides:l}=g(this.workspaceConfiguration,t),O=[...n,...s,...o];return O.length&&this.updateWorkspaceConfiguration(t),{keys:O,overrides:l}}compareAndUpdateFolderConfiguration(t,n){const s=this.folderConfigurations.get(t),{added:o,updated:l,removed:O,overrides:I}=g(s,n),v=[...o,...l,...O];return(v.length||!s)&&this.updateFolderConfiguration(t,n),{keys:v,overrides:I}}compareAndDeleteFolderConfiguration(t){const n=this.folderConfigurations.get(t);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:s,updated:o,removed:l,overrides:O}=g(n,void 0);return{keys:[...s,...o,...l],overrides:O}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(t,n,s){let o=this.q(n,s);return n.overrideIdentifier&&(o=o.override(n.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(t)!==void 0&&(o=o.merge(this.d)),o}q({resource:t},n){let s=this.r();if(n&&t){const o=n.getFolder(t);o&&(s=this.s(o.uri)||s);const l=this.m.get(t);l&&(s=s.merge(l))}return s}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(t){let n=this.b.get(t);if(!n){const s=this.r(),o=this.j.get(t);o?(n=s.merge(o),this.b.set(t,n)):n=s}return n}t(t,n){if(n&&t){const s=n.getFolder(t);if(s)return this.j.get(s.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((t,n)=>{const{contents:s,overrides:o,keys:l}=this.j.get(n);return t.push([n,{contents:s,overrides:o,keys:l}]),t},[])}}allKeys(){const t=new Set;return this.c.keys.forEach(n=>t.add(n)),this.userConfiguration.keys.forEach(n=>t.add(n)),this.i.keys.forEach(n=>t.add(n)),this.j.forEach(n=>n.keys.forEach(s=>t.add(s))),[...t.values()]}u(){const t=new Set;return this.c.getAllOverrideIdentifiers().forEach(n=>t.add(n)),this.userConfiguration.getAllOverrideIdentifiers().forEach(n=>t.add(n)),this.i.getAllOverrideIdentifiers().forEach(n=>t.add(n)),this.j.forEach(n=>n.getAllOverrideIdentifiers().forEach(s=>t.add(s))),[...t.values()]}v(t){const n=new Set;return this.c.getKeysForOverrideIdentifier(t).forEach(s=>n.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>n.add(s)),this.i.getKeysForOverrideIdentifier(t).forEach(s=>n.add(s)),this.j.forEach(s=>s.getKeysForOverrideIdentifier(t).forEach(o=>n.add(o))),[...n.values()]}static parse(t){const n=this.w(t.defaults),s=this.w(t.policy),o=this.w(t.application),l=this.w(t.user),O=this.w(t.workspace),I=t.folders.reduce((v,j)=>(v.set(a.URI.revive(j[0]),this.w(j[1])),v),new A.$Ac);return new p(n,s,o,l,new w,O,I,new w,new A.$Ac)}static w(t){return new w(t.contents,t.keys,t.overrides)}}e.$jo=p;function $(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const t=new Set,n=new Map;for(const o of r)o.keys.forEach(l=>t.add(l)),o.overrides.forEach(([l,O])=>{const I=(0,A.$xc)(n,l,new Set);O.forEach(v=>I.add(v))});const s=[];return n.forEach((o,l)=>s.push([l,[...o.values()]])),{keys:[...t.values()],overrides:s}}e.$ko=$;class h{constructor(t,n,s,o){this.change=t,this.f=n,this.g=s,this.h=o,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.i=void 0;for(const l of t.keys)this.affectedKeys.add(l);for(const[,l]of t.overrides)for(const O of l)this.affectedKeys.add(O);this.d=this.a;for(const l of this.affectedKeys)this.d+=l+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=p.parse(this.f.data)),this.i}affectsConfiguration(t,n){const s=this.a+t,o=this.d.indexOf(s);if(o<0)return!1;const l=o+s.length;if(l>=this.d.length)return!1;const O=this.d.charCodeAt(l);if(O!==this.b&&O!==this.c)return!1;if(n){const I=this.previousConfiguration?this.previousConfiguration.getValue(t,n,this.f?.workspace):void 0,v=this.g.getValue(t,n,this.h);return!P.$Pn(I,v)}return!0}}e.$lo=h;function g(r,t){const{added:n,removed:s,updated:o}=i(t?.rawConfiguration,r?.rawConfiguration),l=[],O=r?.getAllOverrideIdentifiers()||[],I=t?.getAllOverrideIdentifiers()||[];if(t){const v=I.filter(j=>!O.includes(j));for(const j of v)l.push([j,t.getKeysForOverrideIdentifier(j)])}if(r){const v=O.filter(j=>!I.includes(j));for(const j of v)l.push([j,r.getKeysForOverrideIdentifier(j)])}if(t&&r){for(const v of O)if(I.includes(v)){const j=i({contents:r.getOverrideValue(void 0,v)||{},keys:r.getKeysForOverrideIdentifier(v)},{contents:t.getOverrideValue(void 0,v)||{},keys:t.getKeysForOverrideIdentifier(v)});l.push([v,[...j.added,...j.removed,...j.updated]])}}return{added:n,removed:s,updated:o,overrides:l}}function i(r,t){const n=r?t?r.keys.filter(l=>t.keys.indexOf(l)===-1):[...r.keys]:[],s=t?r?t.keys.filter(l=>r.keys.indexOf(l)===-1):[...t.keys]:[],o=[];if(r&&t){for(const l of t.keys)if(r.keys.indexOf(l)!==-1){const O=(0,y.$Ui)(t.contents,l),I=(0,y.$Ui)(r.contents,l);P.$Pn(O,I)||o.push(l)}}return{added:n,removed:s,updated:o}}}),define(ie[135],ne([0,1,19,6,2,27,3,66,40,4,39,36]),function(J,e,N,D,R,L,A,P,u,a,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oo=e.$no=e.$mo=void 0;class d extends R.$Tc{constructor(){super(...arguments),this.a=this.B(new D.$6d),this.onDidChangeConfiguration=this.a.event,this.b=new P.$go}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(E.$Xn.as(u.$3n.Configuration).onDidUpdateConfiguration(({properties:b,defaultsOverrides:c})=>this.c(Array.from(b),c))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(b,c){this.h(b,E.$Xn.as(u.$3n.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:b})}f(){return{}}g(){this.b=new P.$go;const b=E.$Xn.as(u.$3n.Configuration).getConfigurationProperties();this.h(Object.keys(b),b)}h(b,c){const p=this.f();for(const $ of b){const h=p[$],g=c[$];h!==void 0?this.b.addValue($,h):g?this.b.addValue($,g.default):this.b.removeValue($)}}}e.$mo=d;class m{constructor(){this.onDidChangeConfiguration=D.Event.None,this.configurationModel=new P.$go}async initialize(){return this.configurationModel}}e.$no=m;let w=class extends R.$Tc{get configurationModel(){return this.b}constructor(b,c,p){super(),this.c=b,this.f=c,this.g=p,this.a=this.B(new D.$6d),this.onDidChangeConfiguration=this.a.event,this.b=new P.$go}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(b=>this.j(b))),this.B(this.c.onDidChangeConfiguration(async({properties:b})=>this.m(await this.h(b),!0))),this.b}async h(b){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",b);const c={},p=[],$=E.$Xn.as(u.$3n.Configuration).getConfigurationProperties();for(const h of b){const g=$[h];if(!g){p.push(h);continue}if(g.policy){if(g.type!=="string"&&g.type!=="number"){this.g.warn(`Policy ${g.policy.name} has unsupported type ${g.type}`);continue}p.push(h),c[g.policy.name]={type:g.type}}}return(0,A.$7f)(c)||await this.f.updatePolicyDefinitions(c),p}j(b){this.g.trace("PolicyConfiguration#onDidChangePolicies",b);const c=E.$Xn.as(u.$3n.Configuration).getPolicyConfigurations(),p=(0,N.$Hb)(b.map($=>c.get($)));this.m(p,!0)}m(b,c){this.g.trace("PolicyConfiguration#update",b);const p=E.$Xn.as(u.$3n.Configuration).getConfigurationProperties(),$=[],h=this.b.isEmpty();for(const g of b){const i=p[g]?.policy?.name;if(i){const r=this.f.getPolicyValue(i);(h?r!==void 0:!(0,L.$Pn)(this.b.getValue(g),r))&&$.push([g,r])}else this.b.getValue(g)!==void 0&&$.push([g,void 0])}if($.length){this.g.trace("PolicyConfiguration#changed",$);const g=this.b;this.b=new P.$go;for(const i of g.keys)this.b.setValue(i,g.getValue(i));for(const[i,r]of $)r===void 0?this.b.removeValue(i):this.b.setValue(i,r);c&&this.a.fire(this.b)}}};e.$oo=w,e.$oo=w=pe([se(1,y.$Zn),se(2,a.$Aj)],w)}),define(ie[136],ne([0,1,19,9,14,6,38,73,2,27,12,17,29,66,40,135,39]),function(J,e,N,D,R,L,A,P,u,a,y,E,d,m,w,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$po=void 0;class c extends u.$Tc{constructor(h,g,i,r){super(),this.m=h,this.h=this.B(new L.$6d),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new k.$mo),this.c=i instanceof b.$2n?new k.$no:this.B(new k.$oo(this.b,i,r)),this.f=this.B(new m.$io(this.m,{},E.$Kg,g)),this.a=new m.$jo(this.b.configurationModel,this.c.configurationModel,new m.$go,new m.$go),this.j=new p(h,g,this),this.g=this.B(new D.$sh(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:t,properties:n})=>this.r(t,n))),this.B(this.c.onDidChangeConfiguration(t=>this.s(t))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[h,g,i]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new m.$jo(h,g,new m.$go,i)}getConfigurationData(){return this.a.toData()}getValue(h,g){const i=typeof h=="string"?h:void 0,r=(0,d.$Ni)(h)?h:(0,d.$Ni)(g)?g:{};return this.a.getValue(i,r,void 0)}async updateValue(h,g,i,r,t){const n=(0,d.$Oi)(i)?i:(0,d.$Ni)(i)?{resource:i.resource,overrideIdentifiers:i.overrideIdentifier?[i.overrideIdentifier]:void 0}:void 0,s=n?r:i;if(s!==void 0&&s!==3&&s!==2)throw new Error(`Unable to write ${h} to target ${s}.`);n?.overrideIdentifiers&&(n.overrideIdentifiers=(0,N.$Mb)(n.overrideIdentifiers),n.overrideIdentifiers=n.overrideIdentifiers.length?n.overrideIdentifiers:void 0);const o=this.inspect(h,{resource:n?.resource,overrideIdentifier:n?.overrideIdentifiers?n.overrideIdentifiers[0]:void 0});if(o.policyValue!==void 0)throw new Error(`Unable to write ${h} because it is configured in system policy.`);if((0,a.$Pn)(g,o.defaultValue)&&(g=void 0),n?.overrideIdentifiers?.length&&n.overrideIdentifiers.length>1){const O=n.overrideIdentifiers.sort(),I=this.a.localUserConfiguration.overrides.find(v=>(0,N.$ub)([...v.identifiers].sort(),O));I&&(n.overrideIdentifiers=I.identifiers)}const l=n?.overrideIdentifiers?.length?[(0,w.$co)(n.overrideIdentifiers),h]:[h];await this.j.write(l,g),await this.reloadConfiguration()}inspect(h,g={}){return this.a.inspect(h,g,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const h=await this.f.loadConfiguration();this.n(h)}n(h){const g=this.a.toData(),i=this.a.compareAndUpdateLocalUserConfiguration(h);this.t(i,g,2)}r(h,g){const i=this.a.toData(),r=this.a.compareAndUpdateDefaultConfiguration(h,g);this.t(r,i,7)}s(h){const g=this.a.toData(),i=this.a.compareAndUpdatePolicyConfiguration(h);this.t(i,g,7)}t(h,g,i){const r=new m.$lo(h,{data:g},this.a);r.source=i,this.h.fire(r)}}e.$po=c;class p{constructor(h,g,i){this.b=h,this.c=g,this.d=i,this.a=new D.$nh}write(h,g){return this.a.queue(()=>this.e(h,g))}async e(h,g){let i;try{i=(await this.c.readFile(this.b)).value.toString()}catch(n){if(n.fileOperationResult===1)i="{}";else throw n}const r=[];if((0,A.$sn)(i,r,{allowTrailingComma:!0,allowEmptyContent:!0}),r.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const t=this.f(i,h,g);i=(0,P.$Kn)(i,t),await this.c.writeFile(this.b,R.$te.fromString(i))}f(h,g,i){const{tabSize:r,insertSpaces:t,eol:n}=this.h;if(!g.length){const s=JSON.stringify(i,null,t?" ".repeat(r):"	");return[{content:s,length:s.length,offset:0}]}return(0,P.$Hn)(h,g,i,{tabSize:r,insertSpaces:t,eol:n})}get h(){if(!this.g){let h=y.OS===3||y.OS===2?`
`:`\r
`;const g=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});g&&typeof g=="string"&&g!=="auto"&&(h=g),this.g={eol:h,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(ie[67],ne([0,1,15]),function(J,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tm=e.$sm=e.$rm=e.$qm=void 0;function D(u){return u.scheme===N.Schemas.vscodeRemote?u.authority:void 0}e.$qm=D;function R(u){if(!u)return;const a=u.indexOf("+");return a<0?u:u.substr(0,a)}e.$rm=R;function L(u){const{host:a,port:y}=P(u);if(typeof y>"u")throw new Error(`Invalid remote authority: ${u}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:a,port:y}}e.$sm=L;function A(u,a){let{host:y,port:E}=P(u);return typeof E>"u"&&(E=a),{host:y,port:E}}e.$tm=A;function P(u){const a=u.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(a)return{host:a[1],port:parseInt(a[2],10)};const y=u.match(/^(\[[0-9a-z:]+\])$/);if(y)return{host:y[1],port:void 0};const E=u.match(/(.*):(\d+)$/);return E?{host:E[1],port:parseInt(E[2],10)}:{host:u,port:void 0}}}),define(ie[37],ne([0,1,30,10,67]),function(J,e,N,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hm=e.$Gm=e.$Fm=e.$Em=e.$Dm=e.$Cm=e.$Bm=e.$Am=e.TargetPlatform=e.ExtensionType=e.$zm=e.$ym=e.$xm=e.$wm=e.$vm=e.$um=void 0,e.$um="extensions.user.cache",e.$vm="extensions.builtin.cache",e.$wm="undefined_publisher",e.$xm=["ui","workspace","web"];function L(k){if(typeof k=="object"&&k!==null&&k.supported!==!0)return k.description}e.$ym=L,e.$zm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var A;(function(k){k[k.System=0]="System",k[k.User=1]="User"})(A||(e.ExtensionType=A={}));var P;(function(k){k.WIN32_X64="win32-x64",k.WIN32_ARM64="win32-arm64",k.LINUX_X64="linux-x64",k.LINUX_ARM64="linux-arm64",k.LINUX_ARMHF="linux-armhf",k.ALPINE_X64="alpine-x64",k.ALPINE_ARM64="alpine-arm64",k.DARWIN_X64="darwin-x64",k.DARWIN_ARM64="darwin-arm64",k.WEB="web",k.UNIVERSAL="universal",k.UNKNOWN="unknown",k.UNDEFINED="undefined"})(P||(e.TargetPlatform=P={}));class u{constructor(b){this.value=b,this._lower=b.toLowerCase()}static equals(b,c){if(typeof b>"u"||b===null)return typeof c>"u"||c===null;if(typeof c>"u"||c===null)return!1;if(typeof b=="string"||typeof c=="string"){const p=typeof b=="string"?b:b.value,$=typeof c=="string"?c:c.value;return N.$kf(p,$)}return b._lower===c._lower}static toKey(b){return typeof b=="string"?b.toLowerCase():b._lower}}e.$Am=u;class a{get size(){return this.c.size}constructor(b){if(this.c=new Set,b)for(const c of b)this.add(c)}add(b){this.c.add(u.toKey(b))}delete(b){return this.c.delete(u.toKey(b))}has(b){return this.c.has(u.toKey(b))}}e.$Bm=a;class y{constructor(){this.c=new Map}clear(){this.c.clear()}delete(b){this.c.delete(u.toKey(b))}get(b){return this.c.get(u.toKey(b))}has(b){return this.c.has(u.toKey(b))}set(b,c){this.c.set(u.toKey(b),c)}values(){return this.c.values()}forEach(b){this.c.forEach(b)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Cm=y;function E(k){return d(k)}e.$Dm=E;function d(k){return k.contributes&&k.contributes.localizations?k.contributes.localizations.length>0:!1}e.$Em=d;function m(k){return k.contributes&&k.contributes.authentication?k.contributes.authentication.length>0:!1}e.$Fm=m;function w(k,b){if(b){const c=`onResolveRemoteAuthority:${(0,R.$rm)(b)}`;return!!k.activationEvents?.includes(c)}return!1}e.$Gm=w,e.$Hm=(0,D.$gi)("IBuiltinExtensionsScannerService")}),define(ie[137],ne([0,1,2,37,13]),function(J,e,N,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kq=void 0;class L extends N.$Tc{constructor(P,u,a,y,E){super(),this.a=P,this.b=u,this.c=a,this.f=E,this.B(y.onDidInstallExtensions(d=>this.g(d))),this.B(y.onDidUninstallExtension(d=>this.h(d)))}g(P){for(const u of P)u.local&&this.invalidate(u.profileLocation)}h(P){P.error||this.invalidate(P.profileLocation)}async invalidate(P){if(P)for(const u of this.a.profiles)this.c.extUri.isEqual(u.extensionsResource,P)&&await this.j(u);else await this.j(this.a.defaultProfile)}async j(P){try{await this.b.del(this.c.extUri.joinPath(P.cacheHome,D.$um))}catch(u){(0,R.$Xk)(u)!==1&&this.f.error(u)}}}e.$kq=L}),define(ie[45],ne([0,1,14,7,2,106,40,10,4,36]),function(J,e,N,D,R,L,A,P,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dp=e.$Cp=e.$Bp=e.$Ap=e.$zp=e.$yp=e.$xp=e.$wp=void 0,e.$wp=(0,P.$gi)("requestService");class y{constructor(g){this.b=g}toJSON(){if(!this.a){const g=Object.create(null);for(const i in this.b)i.toLowerCase()==="authorization"||i.toLowerCase()==="proxy-authorization"?g[i]="*****":g[i]=this.b[i];this.a=g}return this.a}}class E extends R.$Tc{constructor(g){super(),this.b=0,this.a=g.createLogger("network",{name:(0,L.localize)(0,null),when:u.$Rj.isEqualTo((0,u.$Pj)(u.LogLevel.Trace)).serialize()})}async c(g,i,r){const t=`${g} #${++this.b}: ${i.url}`;this.a.trace(`${t} - begin`,i.type,new y(i.headers??{}));try{const n=await r();return this.a.trace(`${t} - end`,i.type,n.res.statusCode,n.res.headers),n}catch(n){throw this.a.error(`${t} - error`,i.type,(0,D.$0)(n)),n}}}e.$xp=E;function d(h){return h.res.statusCode&&h.res.statusCode>=200&&h.res.statusCode<300||h.res.statusCode===1223}e.$yp=d;function m(h){return h.res.statusCode===204}e.$zp=m;async function w(h){return m(h)?null:(await(0,N.$Fe)(h.stream)).toString()}e.$Ap=w;async function k(h){if(!d(h))throw new Error("Server returned "+h.res.statusCode);return w(h)}e.$Bp=k;async function b(h){if(!d(h))throw new Error("Server returned "+h.res.statusCode);if(m(h))return null;const i=(await(0,N.$Fe)(h.stream)).toString();try{return JSON.parse(i)}catch(r){throw r.message+=`:
`+i,r}}e.$Cp=b;function c(h){$(h)}e.$Dp=c;let p;function $(h){const g=a.$Xn.as(A.$3n.Configuration),i=p;p={id:"http",order:15,title:(0,L.localize)(1,null),type:"object",scope:h,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,L.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,L.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,L.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,L.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,L.localize)(6,null),(0,L.localize)(7,null),(0,L.localize)(8,null),(0,L.localize)(9,null)],default:"override",description:(0,L.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,L.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,L.localize)(12,null),restricted:!0}}},g.updateConfigurations({add:[p],remove:i?[i]:[]})}$(1)}),define(ie[138],ne([0,1,20,15,13,45]),function(J,e,N,D,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5P=void 0;let A=class{constructor(u,a){this.a=u,this.b=a}async download(u,a,y=N.CancellationToken.None){if(u.scheme===D.Schemas.file||u.scheme===D.Schemas.vscodeRemote){await this.b.copy(u,a);return}const E={type:"GET",url:u.toString(!0)},d=await this.a.request(E,y);if(d.res.statusCode===200)await this.b.writeFile(a,d.stream);else{const m=await(0,L.$Bp)(d);throw new Error(`Expected 200, got back ${d.res.statusCode} instead.

${m}`)}}};e.$5P=A,e.$5P=A=pe([se(0,L.$wp),se(1,R.$Gk)],A)}),define(ie[139],ne([0,1,140,3]),function(J,e,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Br=void 0;function R(A,P){return A.protocol==="http:"?P.HTTP_PROXY||P.http_proxy||null:A.protocol==="https:"&&(P.HTTPS_PROXY||P.https_proxy||P.HTTP_PROXY||P.http_proxy)||null}async function L(A,P,u={}){const a=(0,N.parse)(A),y=u.proxyUrl||R(a,P);if(!y)return null;const E=(0,N.parse)(y);if(!/^https?:$/.test(E.protocol||""))return null;const d={host:E.hostname||"",port:(E.port?+E.port:0)||(E.protocol==="https"?443:80),auth:E.auth,rejectUnauthorized:(0,D.$Zf)(u.strictSSL)?u.strictSSL:!0};return a.protocol==="http:"?new(await new Promise((m,w)=>{J(["http-proxy-agent"],m,w)})).HttpProxyAgent(y,d):new(await new Promise((m,w)=>{J(["https-proxy-agent"],m,w)})).HttpsProxyAgent(y,d)}e.$Br=L}),define(ie[141],ne([0,1,58,16,107,20,34,7,12,28,86,173,9,74]),function(J,e,N,D,R,L,A,P,u,a,y,E,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$km=void 0;let w;async function k(c,p,$,h){return $["force-disable-user-env"]?(p.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):u.$i?(p.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,E.$em)(h)&&!$["force-user-env"]?(p.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,E.$em)(h)?p.trace("resolveShellEnv(): running (--force-user-env)"):p.trace("resolveShellEnv(): running (macOS/Linux)"),w||(w=d.Promises.withAsyncBody(async(g,i)=>{const r=new L.$de;let t=1e4;const n=c.getValue("application.shellEnvironmentResolutionTimeout");typeof n=="number"&&(t=(0,m.$fm)(n,1,120)*1e3);const s=setTimeout(()=>{r.dispose(!0),i(new Error((0,R.localize)(0,null)))},t);try{g(await b(p,r.token))}catch(o){!(0,P.$4)(o)&&!r.token.isCancellationRequested?i(new Error((0,R.localize)(1,null,(0,A.$4i)(o)))):g({})}finally{clearTimeout(s),r.dispose()}})),w)}e.$km=k;async function b(c,p){const $=process.env.ELECTRON_RUN_AS_NODE;c.trace("getUnixShellEnvironment#runAsNode",$);const h=process.env.ELECTRON_NO_ATTACH_CONSOLE;c.trace("getUnixShellEnvironment#noAttach",h);const g=(0,a.$Cg)().replace(/-/g,"").substr(0,12),i=new RegExp(g+"({.*})"+g),r={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};c.trace("getUnixShellEnvironment#env",r);const t=await(0,y.$7l)(u.OS,r);return c.trace("getUnixShellEnvironment#shell",t),new Promise((n,s)=>{if(p.isCancellationRequested)return s(new P.$5);const o=(0,D.$nc)(t);let l,O;const I="";/^pwsh(-preview)?$/.test(o)?(l=`& '${process.execPath}' ${I} -p '''${g}'' + JSON.stringify(process.env) + ''${g}'''`,O=["-Login","-Command"]):o==="nu"?(l=`^'${process.execPath}' ${I} -p '"${g}" + JSON.stringify(process.env) + "${g}"'`,O=["-i","-l","-c"]):o==="xonsh"?(l=`import os, json; print("${g}", json.dumps(dict(os.environ)), "${g}")`,O=["-i","-l","-c"]):(l=`'${process.execPath}' ${I} -p '"${g}" + JSON.stringify(process.env) + "${g}"'`,o==="tcsh"||o==="csh"?O=["-ic"]:O=["-i","-l","-c"]),c.trace("getUnixShellEnvironment#spawn",JSON.stringify(O),l);const v=(0,N.spawn)(t,[...O,l],{detached:!0,stdio:["ignore","pipe","pipe"],env:r});p.onCancellationRequested(()=>(v.kill(),s(new P.$5))),v.on("error",Y=>{c.error("getUnixShellEnvironment#errorChildProcess",(0,A.$4i)(Y)),s(Y)});const j=[];v.stdout.on("data",Y=>j.push(Y));const q=[];v.stderr.on("data",Y=>q.push(Y)),v.on("close",(Y,Z)=>{const oe=Buffer.concat(j).toString("utf8");c.trace("getUnixShellEnvironment#raw",oe);const re=Buffer.concat(q).toString("utf8");if(re.trim()&&c.trace("getUnixShellEnvironment#stderr",re),Y||Z)return s(new Error((0,R.localize)(2,null,Y,Z)));const ue=i.exec(oe),fe=ue?ue[1]:"{}";try{const ae=JSON.parse(fe);$?ae.ELECTRON_RUN_AS_NODE=$:delete ae.ELECTRON_RUN_AS_NODE,h?ae.ELECTRON_NO_ATTACH_CONSOLE=h:delete ae.ELECTRON_NO_ATTACH_CONSOLE,delete ae.VSCODE_RESOLVING_ENVIRONMENT,delete ae.XDG_RUNTIME_DIR,c.trace("getUnixShellEnvironment#result",ae),n(ae)}catch(ae){c.error("getUnixShellEnvironment#errorCaught",(0,A.$4i)(ae)),s(ae)}})})}}),define(ie[142],ne([0,1,10]),function(J,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HP=e.$GP=void 0,e.$GP=(0,N.$gi)("stateReadService"),e.$HP=(0,N.$gi)("stateService")}),define(ie[68],ne([0,1,9,14,2,3,18,13,4]),function(J,e,N,D,R,L,A,P,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KP=e.$JP=e.$IP=e.SaveStrategy=void 0;var a;(function(m){m[m.IMMEDIATE=0]="IMMEDIATE",m[m.DELAYED=1]="DELAYED"})(a||(e.SaveStrategy=a={}));class y extends R.$Tc{constructor(w,k,b,c){super(),this.h=w,this.j=k,this.m=b,this.n=c,this.a=Object.create(null),this.b="",this.c=this.B(new N.$eh(this.j===0?0:100)),this.f=void 0,this.g=void 0}init(){return this.f||(this.f=this.r()),this.f}async r(){try{this.b=(await this.n.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(w){w.fileOperationResult!==1&&this.m.error(w)}}getItem(w,k){const b=this.a[w];return(0,L.$3f)(b)?k:b}setItem(w,k){this.setItems([{key:w,data:k}])}setItems(w){let k=!1;for(const{key:b,data:c}of w)this.a[b]!==c&&((0,L.$3f)(c)?(0,L.$1f)(this.a[b])||(this.a[b]=void 0,k=!0):(this.a[b]=c,k=!0));k&&this.s()}removeItem(w){(0,L.$1f)(this.a[w])||(this.a[w]=void 0,this.s())}async s(){if(!this.g)return this.c.trigger(()=>this.t())}async t(){if(!this.f)return;await this.f;const w=JSON.stringify(this.a,null,4);if(w!==this.b)try{await this.n.writeFile(this.h,D.$te.fromString(w),{atomic:{postfix:".vsctmp"}}),this.b=w}catch(k){this.m.error(k)}}async close(){return this.g||(this.g=this.c.trigger(()=>this.t(),0)),this.g}}e.$IP=y;let E=class extends R.$Tc{constructor(w,k,b,c){super(),this.a=this.B(new y(k.stateResource,w,b,c))}async init(){await this.a.init()}getItem(w,k){return this.a.getItem(w,k)}};e.$JP=E,e.$JP=E=pe([se(1,A.$ni),se(2,u.$Aj),se(3,P.$Gk)],E);class d extends E{setItem(w,k){this.a.setItem(w,k)}setItems(w){this.a.setItems(w)}removeItem(w){this.a.removeItem(w)}close(){return this.a.close()}}e.$KP=d}),define(ie[69],ne([0,1,12,35,28]),function(J,e,N,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zo=e.$Yo=void 0;function L(u){if(N.$u===2&&/^penguin(\.|$)/i.test(u))return"chromebook"}function A(u,a,y,E,d,m,w,k,b){const c=Object.create(null);c["common.machineId"]=m,c["common.sqmId"]=w,c.sessionID=(0,R.$Cg)()+Date.now(),c.commitHash=E,c.version=d,c["common.platformVersion"]=(u||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),c["common.platform"]=(0,N.$h)(N.$u),c["common.nodePlatform"]=D.$dc,c["common.nodeArch"]=y,c["common.product"]=b||"desktop",k&&(c["common.msftInternal"]=k);let p=0;const $=Date.now();Object.defineProperties(c,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-$,enumerable:!0},"common.sequence":{get:()=>p++,enumerable:!0}}),N.$l&&(c["common.snap"]="true");const h=L(a);return h&&(c["common.platformDetail"]=h),c}e.$Yo=A;function P(u){const a=D.env.USERDNSDOMAIN;if(!a)return!1;const y=a.toLowerCase();return u.some(E=>y===E)}e.$Zo=P}),define(ie[25],ne([0,1,10]),function(J,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$Pl=e.$Ol=e.$Nl=e.$Ml=e.$Ll=e.$Kl=e.$Jl=e.$Il=e.$Hl=e.$Gl=e.$Fl=void 0,e.$Fl=(0,N.$gi)("telemetryService"),e.$Gl=(0,N.$gi)("customEndpointTelemetryService"),e.$Hl="telemetry.currentSessionDate",e.$Il="telemetry.firstSessionDate",e.$Jl="telemetry.lastSessionDate",e.$Kl="telemetry.machineId",e.$Ll="telemetry.sqmId",e.$Ml="telemetry",e.$Nl="telemetry.telemetryLevel",e.$Ol="telemetry.enableCrashReporter",e.$Pl="telemetry.enableTelemetry";var D;(function(L){L[L.NONE=0]="NONE",L[L.CRASH=1]="CRASH",L[L.ERROR=2]="ERROR",L[L.USAGE=3]="USAGE"})(D||(e.TelemetryLevel=D={}));var R;(function(L){L.OFF="off",L.CRASH="crash",L.ERROR="error",L.ON="all"})(R||(e.TelemetryConfiguration=R={}))}),define(ie[41],ne([0,1,27,3,67,69,25]),function(J,e,N,D,R,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cp=e.$bp=e.$ap=e.$_o=e.$$o=e.$0o=e.$9o=e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=e.$3o=e.$2o=e.$1o=void 0;class P{constructor(r){this.value=r,this.isTrustedTelemetryValue=!0}}e.$1o=P;class u{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$2o=u,e.$3o=new u;class a{async publicLog(r,t,n){}async publicLogError(r,t,n){}}e.$4o=a,e.$5o="telemetry",e.$6o="extensionTelemetryLog",e.$7o={log:()=>null,flush:()=>Promise.resolve(null)};function y(i,r){return!r.isBuilt&&!r.disableTelemetry?!0:!(r.disableTelemetry||!i.enableTelemetry)}e.$8o=y;function E(i,r){return r.extensionTestsLocationURI?!0:!(r.isBuilt||r.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}e.$9o=E;function d(i){const r=i.getValue(A.$Nl),t=i.getValue(A.$Ol);if(i.getValue(A.$Pl)===!1||t===!1)return 0;switch(r??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$0o=d;function m(i){const r={},t={},n={};b(i,n);for(let s in n){s=s.length>150?s.substr(s.length-149):s;const o=n[s];typeof o=="number"?t[s]=o:typeof o=="boolean"?t[s]=o?1:0:typeof o=="string"?(o.length>8192&&console.warn(`Telemetry property: ${s} has been trimmed to 8192, the original length is ${o.length}`),r[s]=o.substring(0,8191)):typeof o<"u"&&o!==null&&(r[s]=o)}return{properties:r,measurements:t}}e.$$o=m;const w=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function k(i){if(!i)return"none";const r=(0,R.$rm)(i);return w.has(r)?r:"other"}e.$_o=k;function b(i,r,t=0,n){if(i)for(const s of Object.getOwnPropertyNames(i)){const o=i[s],l=n?n+s:s;Array.isArray(o)?r[l]=(0,N.$Qn)(o):o instanceof Date?r[l]=o.toISOString():(0,D.$Vf)(o)?t<2?b(o,r,t+1,l+"."):r[l]=(0,N.$Qn)(o):r[l]=o}}function c(i,r){const t=i.msftInternalDomains||[],n=r.getValue("telemetry.internalTesting");return(0,L.$Zo)(t)||n}e.$ap=c;function p(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.$bp=p;function $(i,r){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let t=i;const n=[];for(const O of r)for(;;){const I=O.exec(i);if(!I)break;n.push([I.index,O.lastIndex])}const s=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,o=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let l=0;for(t="";;){const O=o.exec(i);if(!O)break;const I=n.some(([v,j])=>O.index<j&&v<o.lastIndex);!s.test(O[0])&&!I&&(t+=i.substring(l,O.index)+"<REDACTED: user-file-path>",l=o.lastIndex)}return l<i.length&&(t+=i.substr(l)),t}function h(i){if(!i)return i;const r=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const t of r)if(t.regex.test(i))return`<REDACTED: ${t.label}>`;return i}function g(i,r){return(0,N.$Nn)(i,t=>{if(t instanceof P||Object.hasOwnProperty.call(t,"isTrustedTelemetryValue"))return t.value;if(typeof t=="string"){let n=t.replaceAll("%20"," ");n=$(n,r);for(const s of r)n=n.replace(s,"");return n=h(n),n}})}e.$cp=g}),define(ie[26],ne([0,1,30,21,37,12,11,7,35,41]),function(J,e,N,D,R,L,A,P,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$op=e.$np=e.$mp=e.$lp=e.$kp=e.$jp=e.$ip=e.$hp=e.$gp=e.$fp=e.$ep=e.$dp=void 0;function y(t,n){return t.uuid&&n.uuid?t.uuid===n.uuid:t.id===n.id?!0:(0,N.$ff)(t.id,n.id)===0}e.$dp=y;const E=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class d{static create(n){const s=n.manifest?n.manifest.version:n.version,o=n.manifest?n.targetPlatform:n.properties.targetPlatform;return new d(n.identifier,s,o)}static parse(n){const s=E.exec(n);return s&&s[1]&&s[2]?new d({id:s[1]},s[2],s[4]||void 0):null}constructor(n,s,o="undefined"){this.version=s,this.targetPlatform=o,this.id=n.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(n){return n instanceof d?y(this,n)&&this.version===n.version&&this.targetPlatform===n.targetPlatform:!1}}e.$ep=d;const m=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function w(t){const n=m.exec(t);return n&&n[1]?[b(n[1]),n[2]]:[b(t),void 0]}e.$fp=w;function k(t,n){return`${t}.${n}`}e.$gp=k;function b(t){return t.toLowerCase()}e.$hp=b;function c(t,n){return b(k(t??R.$wm,n))}e.$ip=c;function p(t,n){const s=[],o=l=>{for(const O of s)if(O.some(I=>y(n(I),n(l))))return O;return null};for(const l of t){const O=o(l);O?O.push(l):s.push([l])}return s}e.$jp=p;function $(t){return{id:t.identifier.id,name:t.manifest.name,galleryId:null,publisherId:t.publisherId,publisherName:t.manifest.publisher,publisherDisplayName:t.publisherDisplayName,dependencies:t.manifest.extensionDependencies&&t.manifest.extensionDependencies.length>0}}e.$kp=$;function h(t){return{id:new a.$1o(t.identifier.id),name:new a.$1o(t.name),galleryId:t.identifier.uuid,publisherId:t.publisherId,publisherName:t.publisher,publisherDisplayName:t.publisherDisplayName,isPreReleaseVersion:t.properties.isPreReleaseVersion,dependencies:!!(t.properties.dependencies&&t.properties.dependencies.length>0),isSigned:t.isSigned,...t.telemetryData}}e.$lp=h,e.$mp=new R.$Am("pprice.better-merge");function g(t,n){const s=[],o=n.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const l=o.shift();if(l&&s.every(O=>!y(O.identifier,{id:l}))){const O=t.filter(I=>y(I.identifier,{id:l}));O.length===1&&(s.push(O[0]),o.push(...O[0].manifest.extensionDependencies?.slice(0)??[]))}}return s}e.$np=g;async function i(t,n){if(!L.$k)return!1;let s;try{s=(await t.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{s=(await t.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(l){n.debug("Error while getting the os-release file.",(0,P.$0)(l))}}return!!s&&(s.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function r(t,n){const s=await i(t,n),o=(0,D.$Ko)(s?"alpine":L.$u,u.$ec);return n.debug("ComputeTargetPlatform:",o),o}e.$op=r}),define(ie[143],ne([0,1,20,7,15,17,44,11,96,21,26,37]),function(J,e,N,D,R,L,A,P,u,a,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wp=void 0;const d=k=>(0,u.localize)(0,null,k),m=(0,u.localize)(1,null,"ms-dotnettools.csharp");let w=class{constructor(b,c,p){this.a=b,this.b=c,this.d=p}get f(){}async listExtensions(b,c,p){let $=await this.b.getInstalled(1,p);const h=E.$zm.map(i=>i.toLowerCase());if(c&&c!==""){if(h.indexOf(c.toLowerCase())<0){this.a.info("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}$=$.filter(i=>i.manifest.categories?i.manifest.categories.map(t=>t.toLowerCase()).indexOf(c.toLowerCase())>-1:!1)}else if(c===""){this.a.info("Possible Categories: "),h.forEach(i=>{this.a.info(i)});return}this.f&&this.a.info((0,u.localize)(2,null,this.f)),$=$.sort((i,r)=>i.identifier.id.localeCompare(r.identifier.id));let g;for(const i of $)g!==i.identifier.id&&(g=i.identifier.id,this.a.info(b?`${g}@${i.manifest.version}`:g))}async installExtensions(b,c,p,$){const h=[];try{b.length&&this.a.info(this.f?(0,u.localize)(3,null,this.f):(0,u.localize)(4,null));const g=[],i=[],r=(n,s,o)=>{i.push({id:n,version:s!=="prerelease"?s:void 0,installOptions:{...p,isBuiltin:o,installPreReleaseVersion:s==="prerelease"||p.installPreReleaseVersion}})};for(const n of b)if(n instanceof P.URI)g.push({vsix:n,installOptions:p});else{const[s,o]=(0,y.$fp)(n);r(s,o,!1)}for(const n of c)if(n instanceof P.URI)g.push({vsix:n,installOptions:{...p,isBuiltin:!0,donotIncludePackAndDependencies:!0}});else{const[s,o]=(0,y.$fp)(n);r(s,o,!0)}const t=await this.b.getInstalled(1,p.profileLocation);if(g.length&&await Promise.all(g.map(async({vsix:n,installOptions:s})=>{try{await this.h(n,s,$,t)}catch(o){this.a.error(o),h.push(n.toString())}})),i.length){const n=await this.g(i,t,$);h.push(...n)}}catch(g){throw this.a.error((0,u.localize)(5,null,(0,D.$0)(g))),g}if(h.length)throw new Error((0,u.localize)(6,null,h.join(", ")))}async updateExtensions(b){const c=await this.b.getInstalled(1,b),p=[];for(const i of c)i.identifier.uuid&&p.push({...i.identifier,preRelease:i.preRelease});this.a.trace((0,u.localize)(7,null,p.length));const $=await this.d.getExtensions(p,{compatible:!0},N.CancellationToken.None),h=[];for(const i of $)for(const r of c)(0,y.$dp)(r.identifier,i.identifier)&&(0,A.gt)(i.version,r.manifest.version)&&h.push({extension:i,options:{operation:3,installPreReleaseVersion:r.isPreReleaseVersion}});if(!h.length){this.a.info((0,u.localize)(8,null));return}this.a.info((0,u.localize)(9,null,h.map(i=>i.extension.identifier.id).join(", ")));const g=await this.b.installGalleryExtensions(h);for(const i of g)i.error?this.a.error((0,u.localize)(10,null,i.identifier.id,(0,D.$0)(i.error))):this.a.info((0,u.localize)(11,null,i.identifier.id,i.local?.manifest.version))}async g(b,c,p){if(b=b.filter(({id:i,version:r})=>{const t=c.find(n=>(0,y.$dp)(n.identifier,{id:i}));if(t){if(!p&&(!r||r==="prerelease"&&t.preRelease))return this.a.info((0,u.localize)(12,null,i,t.manifest.version,i)),!1;if(r&&t.manifest.version===r)return this.a.info((0,u.localize)(13,null,`${i}@${r}`)),!1}return!0}),!b.length)return[];const $=[],h=[],g=await this.j(b);if(await Promise.all(b.map(async({id:i,version:r,installOptions:t})=>{const n=g.get(i.toLowerCase());if(!n){this.a.error(`${d(r?`${i}@${r}`:i)}
${m}`),$.push(i);return}try{const o=await this.d.getManifest(n,N.CancellationToken.None);if(o&&!this.k(o))return}catch(o){this.a.error(o.message||o.stack||o),$.push(i);return}const s=c.find(o=>(0,y.$dp)(o.identifier,n.identifier));if(s){if(n.version===s.manifest.version){this.a.info((0,u.localize)(14,null,r?`${i}@${r}`:i));return}this.a.info((0,u.localize)(15,null,i,n.version))}t.isBuiltin?this.a.info(r?(0,u.localize)(16,null,i,r):(0,u.localize)(17,null,i)):this.a.info(r?(0,u.localize)(18,null,i,r):(0,u.localize)(19,null,i)),h.push({extension:n,options:{...t,installGivenVersion:!!r}})})),h.length){const i=await this.b.installGalleryExtensions(h);for(const r of i)r.error?(this.a.error((0,u.localize)(20,null,r.identifier.id,(0,D.$0)(r.error))),$.push(r.identifier.id)):this.a.info((0,u.localize)(21,null,r.identifier.id,r.local?.manifest.version))}return $}async h(b,c,p,$){const h=await this.b.getManifest(b);if(!h)throw new Error("Invalid vsix");if(await this.l(h,p,c.profileLocation,$))try{await this.b.install(b,c),this.a.info((0,u.localize)(22,null,(0,L.$Qg)(b)))}catch(i){if((0,D.$4)(i))this.a.info((0,u.localize)(23,null,(0,L.$Qg)(b)));else throw i}}async j(b){const c=new Map,p=b.some(g=>g.installOptions.installPreReleaseVersion),$=await this.b.getTargetPlatform(),h=[];for(const g of b)a.$Do.test(g.id)&&h.push({...g,preRelease:p});if(h.length){const g=await this.d.getExtensions(h,{targetPlatform:$},N.CancellationToken.None);for(const i of g)c.set(i.identifier.id.toLowerCase(),i)}return c}k(b){return!0}async l(b,c,p,$){if(!c){const h={id:(0,y.$ip)(b.publisher,b.name)},g=$.find(i=>(0,y.$dp)(h,i.identifier)&&(0,A.gt)(i.manifest.version,b.version));if(g)return this.a.info((0,u.localize)(24,null,g.identifier.id,g.manifest.version,b.version)),!1}return this.k(b)}async uninstallExtensions(b,c,p){const $=async g=>{if(g instanceof P.URI){const i=await this.b.getManifest(g);return(0,y.$gp)(i.publisher,i.name)}return g},h=[];for(const g of b){const i=await $(g),t=(await this.b.getInstalled(void 0,p)).filter(n=>(0,y.$dp)(n.identifier,{id:i}));if(!t.length)throw new Error(`${this.m(i)}
${m}`);if(t.some(n=>n.type===0)){this.a.info((0,u.localize)(25,null,i));return}if(!c&&t.some(n=>n.isBuiltin)){this.a.info((0,u.localize)(26,null,i));return}this.a.info((0,u.localize)(27,null,i));for(const n of t)await this.b.uninstall(n,{profileLocation:p}),h.push(n);this.f?this.a.info((0,u.localize)(28,null,i,this.f)):this.a.info((0,u.localize)(29,null,i))}}async locateExtension(b){const c=await this.b.getInstalled();b.forEach(p=>{c.forEach($=>{if($.identifier.id===p&&$.location.scheme===R.Schemas.file){this.a.info($.location.fsPath);return}})})}m(b){return this.f?(0,u.localize)(30,null,b,this.f):(0,u.localize)(31,null,b)}};e.$Wp=w,e.$Wp=w=pe([se(1,a.$Ro),se(2,a.$Oo)],w)}),define(ie[144],ne([0,1,9,7,2,15,17,44,3,28,24,49,29,18,21,26,64,13,4]),function(J,e,N,D,R,L,A,P,u,a,y,E,d,m,w,k,b,c,p){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$hq=void 0;let h=class extends R.$Tc{static{$=this}static{this.c=".sigzip"}constructor(i,r,t,n,s,o){super(),this.h=r,this.j=t,this.m=n,this.n=s,this.r=o,this.extensionsDownloadDir=i.extensionsDownloadLocation,this.f=20,this.g=this.y()}async download(i,r,t){await this.g;const n=(0,A.$Tg)(this.extensionsDownloadDir,this.z(i));try{await this.w(i,n,o=>this.j.download(i,o,r))}catch(o){throw new w.$Po(o.message,w.ExtensionManagementErrorCode.Download)}let s=!1;if(t&&this.t(i)){const o=await this.u(i);try{s=await this.n.verify(n.fsPath,o.fsPath,this.r.getLevel()===p.LogLevel.Trace)}catch(l){const O=l;if(s=O.code,O.output&&this.r.trace(`Extension signature verification details for ${i.identifier.id} ${i.version}:
${O.output}`),s===w.ExtensionSignaturetErrorCode.PackageIsInvalidZip||s===w.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip){try{await this.delete(n)}catch(I){this.r.error(I)}throw new w.$Po(E.$1p,w.ExtensionManagementErrorCode.CorruptZip)}}finally{try{await this.delete(o)}catch(l){this.r.error(l)}}}return s===!0?this.r.info(`Extension signature is verified: ${i.identifier.id}`):s===!1?this.r.info(`Extension signature verification is not done: ${i.identifier.id}`):this.r.warn(`Extension signature verification failed with error '${s}': ${i.identifier.id}`),{location:n,verificationStatus:s}}t(i){if(!i.isSigned)return this.r.info(`Extension is not signed: ${i.identifier.id}`),!1;const r=this.m.getValue("extensions.verifySignature");return(0,u.$Zf)(r)?r:!0}async u(i){await this.g;const r=(0,A.$Tg)(this.extensionsDownloadDir,`${this.z(i)}${$.c}`);try{await this.w(i,r,t=>this.j.downloadSignatureArchive(i,t))}catch(t){throw new w.$Po(t.message,w.ExtensionManagementErrorCode.DownloadSignature)}return r}async w(i,r,t){if(await this.h.exists(r))return;if(r.scheme!==L.Schemas.file){await t(r);return}const n=(0,A.$Tg)(this.extensionsDownloadDir,`.${(0,a.$Cg)()}`);await this.h.exists(n)||await t(n);try{await y.Promises.rename(n.fsPath,r.fsPath,2*60*1e3)}catch(s){try{await this.h.del(n)}catch{}if(s.code==="ENOTEMPTY")this.r.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",i.identifier.id,r.path);else throw this.r.info(`Rename failed because of ${(0,D.$0)(s)}. Deleted the file from downloaded location`,n.path),s}}async delete(i){await this.g,await this.h.del(i)}async y(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.r.trace("Extension VSIX downloads cache dir does not exist");return}const i=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(i.children){const r=[],t=[],n=[];for(const l of i.children)if(l.name.endsWith($.c))n.push(l.resource);else{const O=k.$ep.parse(l.name);O&&t.push([O,l])}const s=(0,k.$jp)(t,([l])=>l),o=[];for(const l of s)l.sort((O,I)=>P.rcompare(O[0].version,I[0].version)),r.push(...l.slice(1).map(O=>O[1].resource)),o.push(l[0][1]);o.sort((l,O)=>l.mtime-O.mtime),r.push(...o.slice(0,Math.max(0,o.length-this.f)).map(l=>l.resource)),r.push(...n),await N.Promises.settled(r.map(l=>(this.r.trace("Deleting from cache",l.path),this.h.del(l))))}}catch(i){this.r.error(i)}}z(i){return this.f?k.$ep.create(i).toString().toLowerCase():(0,a.$Cg)()}};e.$hq=h,e.$hq=h=$=pe([se(0,m.$oi),se(1,c.$Gk),se(2,w.$Oo),se(3,d.$Mi),se(4,b.$Up),se(5,p.$Aj)],h)}),define(ie[145],ne([0,1,6,2,31,26,37]),function(J,e,N,D,R,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lq=void 0;class P extends D.$Tc{constructor(a,y,E,d,m,w,k){super(),this.f=a,this.g=y,this.h=E,this.j=d,this.m=m,this.n=w,this.r=k,this.a=this.B(new N.$6d),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new D.$3c),this.s().then(null,b=>k.error(b))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(a=>this.u(a.added))),this.B(this.j.onAddExtensions(a=>this.w(a))),this.B(this.j.onDidAddExtensions(a=>this.y(a))),this.B(this.j.onRemoveExtensions(a=>this.z(a))),this.B(this.j.onDidRemoveExtensions(a=>this.C(a))),this.B(this.n.onDidFilesChange(a=>this.D(a)))}async u(a){try{a.length&&await Promise.all(a.map(y=>(this.c.set(y.id,(0,D.$Qc)(this.n.watch(this.m.extUri.dirname(y.extensionsResource)),this.n.watch(y.extensionsResource))),this.G(y.extensionsResource))))}catch(y){throw this.r.error(y),y}}async w(a){for(const y of a.extensions)this.I(this.L(y.identifier,y.version),a.profileLocation)}async y(a){for(const y of a.extensions){const E=this.L(y.identifier,y.version);a.error?this.J(E,a.profileLocation):this.I(E,a.profileLocation)}}async z(a){for(const y of a.extensions)this.J(this.L(y.identifier,y.version),a.profileLocation)}async C(a){const y=[],E=[];for(const d of a.extensions){const m=this.L(d.identifier,d.version);a.error?this.I(m,a.profileLocation):(this.J(m,a.profileLocation),this.b.has(m)||(this.r.debug("Extension is removed from all profiles",d.identifier.id,d.version),E.push(this.f.scanInstalledExtensionAtLocation(d.location).then(w=>{w?y.push(w):this.r.info("Extension not found at the location",d.location.toString())},w=>this.r.error(w)))))}try{await Promise.all(E),y.length&&await this.H(y)}catch(d){this.r.error(d)}}D(a){for(const y of this.h.profiles)a.contains(y.extensionsResource,0,1)&&this.F(y.extensionsResource)}async F(a){const y=[],E=[],d=await this.j.scanProfileExtensions(a),m=new Set,w=new Set;for(const[k,b]of this.b)b.has(a)&&w.add(k);for(const k of d){const b=this.L(k.identifier,k.version);m.add(b),w.has(b)||(y.push(k.identifier),this.I(b,a))}for(const k of w)if(!m.has(k)){const b=this.M(k);b&&(E.push(b.identifier),this.J(k,a))}(y.length||E.length)&&this.a.fire({added:y.length?{extensions:y,profileLocation:a}:void 0,removed:E.length?{extensions:E,profileLocation:a}:void 0})}async G(a){const y=await this.j.scanProfileExtensions(a);for(const E of y)this.I(this.L(E.identifier,E.version),a)}async H(a){a||(a=(await this.f.scanAllUserInstalledExtensions()).filter(E=>!this.b.has(this.L(E.identifier,E.manifest.version)))),a.length&&await this.f.markAsUninstalled(...a)}I(a,y){let E=this.b.get(a);E||this.b.set(a,E=new R.$Bc(d=>this.m.extUri.getComparisonKey(d))),E.add(y)}J(a,y){const E=this.b.get(a);E&&E.delete(y),E?.size||this.b.delete(a)}L(a,y){return`${A.$Am.toKey(a.id)}@${y}`}M(a){const[y,E]=(0,L.$fp)(a);return E?{identifier:{id:y},version:E}:void 0}}e.$lq=P}),define(ie[146],ne([0,1,117,41]),function(J,e,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qp=void 0;async function R(L,A,P,u,a,y,E){const d={"X-Market-Client-Id":`VSCode ${L}`,"User-Agent":`VSCode ${L} (${A.nameShort})`};if((0,D.$8o)(A,P)&&(0,D.$0o)(u)===3){const m=await(0,N.$Pp)(P,a,y);d["X-Market-User-Id"]=m,d["VSCode-SessionId"]=E.machineId||m}return d}e.$Qp=R}),define(ie[147],ne([0,1,174,19,9,2,15,16,24,18,21,26,4,63,11]),function(J,e,N,D,R,L,A,P,u,a,y,E,d,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yr=void 0;let k=class extends m.$xr{constructor($,h,g,i){super(g),this.h=$,this.j=i,this.g=this.B(new b(h,i)),this.h.registerParticipant({postInstall:async r=>this.m(r),postUninstall:async r=>this.n(r)})}async getBuiltInExtensionTranslationsUri($,h){const i=(await this.g.getLanguagePacks())[h];if(!i){this.j.warn(`No language pack found for ${h}`);return}const r=i.translations[$];return r?w.URI.file(r):void 0}async getInstalledLanguages(){const $=await this.g.getLanguagePacks(),h=Object.keys($).map(g=>{const i=$[g];return{...this.f(g,i.label),extensionId:i.extensions[0].extensionIdentifier.id}});return h.push(this.f("en","English")),h.sort((g,i)=>g.label.localeCompare(i.label)),h}async m($){$&&$.manifest&&$.manifest.contributes&&$.manifest.contributes.localizations&&$.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",$.identifier.id),await this.update())}async n($){const h=await this.g.getLanguagePacks();Object.keys(h).some(g=>h[g]&&h[g].extensions.some(i=>(0,E.$dp)(i.extensionIdentifier,$.identifier)))&&(this.j.info("Removing language packs from the extension",$.identifier.id),await this.update())}async update(){const[$,h]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),g=await this.g.update(h);return!(0,D.$ub)(Object.keys($),Object.keys(g))}};e.$yr=k,e.$yr=k=pe([se(0,y.$Ro),se(1,a.$oi),se(2,y.$Oo),se(3,d.$Aj)],k);let b=class extends L.$Tc{constructor($,h){super(),this.j=h,this.c={},this.f=(0,P.$jc)($.userDataPath,"languagepacks.json"),this.g=new R.$nh}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update($){return this.s(h=>{Object.keys(h).forEach(g=>delete h[g]),this.m(h,...$)}).then(()=>this.c)}m($,...h){for(const g of h)g&&g.manifest&&g.manifest.contributes&&g.manifest.contributes.localizations&&g.manifest.contributes.localizations.length&&this.n($,g);Object.keys($).forEach(g=>this.r($[g]))}n($,h){const g=h.identifier,i=h.manifest.contributes&&h.manifest.contributes.localizations?h.manifest.contributes.localizations:[];for(const r of i)if(h.location.scheme===A.Schemas.file&&c(r)){let t=$[r.languageId];t||(t={hash:"",extensions:[],translations:{},label:r.localizedLanguageName??r.languageName},$[r.languageId]=t);const n=t.extensions.filter(s=>(0,E.$dp)(s.extensionIdentifier,g))[0];n?n.version=h.manifest.version:t.extensions.push({extensionIdentifier:g,version:h.manifest.version});for(const s of r.translations)t.translations[s.id]=(0,P.$jc)(h.location.fsPath,s.path)}}r($){if($){const h=(0,N.createHash)("md5");for(const g of $.extensions)h.update(g.extensionIdentifier.uuid||g.extensionIdentifier.id).update(g.version);$.hash=h.digest("hex")}}s($=()=>null){return this.g.queue(()=>{let h=null;return u.Promises.readFile(this.f,"utf8").then(void 0,g=>g.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(g)).then(g=>{try{return JSON.parse(g)}catch{return{}}}).then(g=>(h=$(g),g)).then(g=>{for(const r of Object.keys(g))g[r]||delete g[r];this.c=g,this.h=!0;const i=JSON.stringify(this.c);return this.j.debug("Writing language packs",i),u.Promises.writeFile(this.f,i)}).then(()=>h,g=>this.j.error(g))})}};b=pe([se(0,a.$oi),se(1,d.$Aj)],b);function c(p){if(typeof p.languageId!="string"||!Array.isArray(p.translations)||p.translations.length===0)return!1;for(const $ of p.translations)if(typeof $.id!="string"||typeof $.path!="string")return!1;return!(p.languageName&&typeof p.languageName!="string"||p.localizedLanguageName&&typeof p.localizedLanguageName!="string")}}),define(ie[148],ne([0,1,83,7,27,41]),function(J,e,N,D,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CP=void 0;const A="https://mobile.events.data.microsoft.com/OneCollector/1.0",P="https://mobile.events.data.microsoft.com/ping";async function u(y,E,d){const m=await(0,N.$xD)("@microsoft/1ds-core-js","dist/ms.core.js"),w=await(0,N.$xD)("@microsoft/1ds-post-js","dist/ms.post.js"),k=new m.AppInsightsCore,b=new w.PostChannel,c={instrumentationKey:y,endpointUrl:A,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[b]]};if(d){c.extensionConfig={};const p={alwaysUseXhrOverride:!0,ignoreMc1Ms0CookieProcessing:!0,httpXHROverride:d};c.extensionConfig[b.identifier]=p}return k.initialize(c,[]),k.addTelemetryInitializer(p=>{p.ext=p.ext??{},p.ext.web=p.ext.web??{},p.ext.web.consentDetails='{"GPC_DataSharingOptIn":false}',E&&(p.ext.utc=p.ext.utc??{},p.ext.utc.flags=8462029)}),k}class a{constructor(E,d,m,w,k){this.e=E,this.f=d,this.g=m,this.h=k,this.c=A,this.d=P,this.g||(this.g={}),typeof w=="function"?this.a=w():this.a=w,this.b=null}i(E){if(this.a){if(typeof this.a!="string"){E(this.a);return}this.b||(this.b=u(this.a,this.e,this.h)),this.b.then(d=>{E(d)},d=>{(0,D.$1)(d),console.error(d)})}}log(E,d){if(!this.a)return;d=(0,R.$On)(d,this.g),d=(0,L.$$o)(d);const m=this.f+"/"+E;try{this.i(w=>{w.pluginVersionString=d?.properties.version??"Unknown",w.track({name:m,baseData:{name:m,properties:d?.properties,measurements:d?.measurements}})})}catch{}}flush(){return this.a?new Promise(E=>{this.i(d=>{d.unload(!0,()=>{this.a=void 0,E(void 0)})})}):Promise.resolve(void 0)}}e.$CP=a}),define(ie[149],ne([0,1,2,27,12,30,108,29,40,150,32,36,25,41]),function(J,e,N,D,R,L,A,P,u,a,y,E,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Er=void 0;let w=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(c,p,$){this.k=p,this.l=$,this.d={},this.i=new N.$Sc,this.j=[],this.b=c.appenders,this.c=c.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=c.piiPaths||[],this.g=3,this.h=!!c.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const h of this.f)this.j.push(new RegExp((0,L.$Ye)(h),"gi")),h.indexOf("\\")>=0&&this.j.push(new RegExp((0,L.$Ye)(h.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(h=>{(h.affectsConfiguration(d.$Nl)||h.affectsConfiguration(d.$Pl)||h.affectsConfiguration(d.$Ol))&&this.m()}))}setExperimentProperty(c,p){this.d[c]=p}m(){let c=(0,m.$0o)(this.k);const p=this.l.enabledTelemetryLevels;if(p){this.h=this.sendErrorTelemetry?p.error:!1;const $=p.usage?3:p.error?2:0;c=Math.min(c,$)}this.g=c}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(c,p,$){this.g<p||($=(0,D.$On)($,this.d),$=(0,m.$cp)($,this.j),$=(0,D.$On)($,this.c),this.b.forEach(h=>h.log(c,$)))}publicLog(c,p){this.n(c,3,p)}publicLog2(c,p){this.publicLog(c,p)}publicLogError(c,p){this.h&&this.n(c,2,p)}publicLogError2(c,p){this.publicLogError(c,p)}};e.$Er=w,e.$Er=w=pe([se(1,P.$Mi),se(2,y.$Sj)],w);function k(){const b=(0,A.localize)(0,null,a.default.nameLong),c=a.default.privacyStatementUrl?(0,A.localize)(2,null,"https://aka.ms/vscode-telemetry",a.default.privacyStatementUrl):(0,A.localize)(1,null,"https://aka.ms/vscode-telemetry"),p=R.$o?"":(0,A.localize)(3,null),$=(0,A.localize)(4,null),h=(0,A.localize)(5,null),g=(0,A.localize)(6,null),i=(0,A.localize)(7,null),r=`
|       | ${$} | ${h} | ${g} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,t=(0,A.localize)(8,null);return`
${b} ${c} ${p}

&nbsp;

${i}
${r}

&nbsp;

${t}
`}E.$Xn.as(u.$3n.Configuration).registerConfiguration({id:d.$Ml,order:1,type:"object",title:(0,A.localize)(9,null),properties:{[d.$Nl]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,A.localize)(10,null),(0,A.localize)(11,null),(0,A.localize)(12,null),(0,A.localize)(13,null)],markdownDescription:k(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),E.$Xn.as(u.$3n.Configuration).registerConfiguration({id:d.$Ml,order:110,type:"object",title:(0,A.localize)(14,null),properties:{[d.$Pl]:{type:"boolean",markdownDescription:a.default.privacyStatementUrl?(0,A.localize)(16,null,a.default.nameLong,a.default.privacyStatementUrl):(0,A.localize)(15,null,a.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,A.localize)(17,null,`\`#${d.$Nl}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ie[151],ne([0,1,14,20,175,148]),function(J,e,N,D,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DP=void 0;async function A(y,E){const d=await E.request(y,D.CancellationToken.None),m=(await(0,N.$Fe)(d.stream)).toString(),w=d.res.statusCode??200;return{headers:d.res.headers,statusCode:w,responseData:m}}async function P(y){const E={method:y.type,headers:y.headers};return new Promise((m,w)=>{const k=R.request(y.url??"",E,b=>{b.on("data",function(c){m({headers:b.headers,statusCode:b.statusCode??200,responseData:c.toString()})}),b.on("error",function(c){w(c)})});k.write(y.data,b=>{b&&w(b)}),k.end()})}async function u(y,E,d){const m=typeof E.data=="string"?E.data:new TextDecoder().decode(E.data),w={type:"POST",headers:{...E.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(E.data).toString()},url:E.urlString,data:m};try{const k=y?await A(w,y):await P(w);d(k.statusCode,k.headers,k.responseData)}catch{d(0,{})}}class a extends L.$CP{constructor(E,d,m,w,k){const b={sendPOST:(c,p)=>{u(E,c,p)}};super(d,m,w,k,b)}}e.$DP=a}),define(ie[152],ne([0,1,16,24]),function(J,e,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nbc=void 0;async function R(L,A){const P=Object.create(null),u=(y,E)=>{const d=JSON.parse(y);P[E]=d};if(A){const y=[],E=await D.Promises.readdir(A);for(const m of E)try{(await D.Promises.stat((0,N.$jc)(A,m))).isDirectory()&&y.push(m)}catch{}const d=[];for(const m of y)(await D.Promises.readdir((0,N.$jc)(A,m))).filter(k=>k==="telemetry.json").length===1&&d.push(m);for(const m of d){const w=(await D.Promises.readFile((0,N.$jc)(A,m,"telemetry.json"))).toString();u(w,m)}}let a=(await D.Promises.readFile((0,N.$jc)(L,"telemetry-core.json"))).toString();return u(a,"vscode-core"),a=(await D.Promises.readFile((0,N.$jc)(L,"telemetry-extensions.json"))).toString(),u(a,"vscode-extensions"),JSON.stringify(P,null,4)}e.$nbc=R}),define(ie[153],ne([0,1,12,84,25]),function(J,e,N,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eac=e.$Dac=void 0;async function L(P,u){let a=P.getItem(R.$Kl);return(typeof a!="string"||N.$j&&a==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(a=await(0,D.$on)(u.error.bind(u))),a}e.$Dac=L;async function A(P,u){let a=P.getItem(R.$Ll);return typeof a!="string"&&(a=await(0,D.$pn)(u.error.bind(u))),a}e.$Eac=A}),define(ie[22],ne([0,1,10]),function(J,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$el=void 0,e.$el=(0,N.$gi)("IUriIdentityService")}),define(ie[154],ne([0,1,22,118,13,17,75,6,2]),function(J,e,N,D,R,L,A,P,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$es=void 0;class a{static{this._clock=0}constructor(d){this.uri=d,this.time=a._clock++}touch(){return this.time=a._clock++,this}}let y=class{constructor(d){this.g=d,this.c=new u.$Sc,this.f=2**16;const m=new Map,w=k=>{let b=m.get(k.scheme);return b===void 0&&(b=d.hasProvider(k)&&!this.g.hasCapability(k,1024),m.set(k.scheme,b)),b};this.c.add(P.Event.any(d.onDidChangeFileSystemProviderRegistrations,d.onDidChangeFileSystemProviderCapabilities)(k=>{m.delete(k.scheme)})),this.extUri=new L.$Ig(w),this.d=new A.$ds((k,b)=>this.extUri.compare(k,b,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(d){this.g.hasProvider(d)&&(d=(0,L.$Ug)(d));const m=this.d.get(d);return m?m.touch().uri.with({fragment:d.fragment}):(this.d.set(d,new a(d)),this.h(),d)}h(){if(this.d.size<this.f)return;const d=[...this.d.entries()].sort((w,k)=>w[1].time<k[1].time?1:w[1].time>k[1].time?-1:0);a._clock=0,this.d.clear();const m=this.f*.5;for(let w=0;w<m;w++)this.d.set(d[w][0],d[w][1].touch())}};e.$es=y,e.$es=y=pe([se(0,R.$Gk)],y),(0,D.$bs)(N.$el,y,1)}),define(ie[155],ne([0,1,6,2,13,48,31]),function(J,e,N,D,R,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2ac=void 0;class P extends D.$Tc{constructor(a,y,E,d,m,w){super(),this.f=a,this.g=y,this.h=E,this.j=d,this.m=m,this.n=w,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new N.$6d),this.onDidChangeFile=this.a.event,this.b=L.$mi.forUris(()=>!(this.capabilities&1024)),this.c=new A.$Bc(k=>this.m.extUri.getComparisonKey(this.t(k))),this.r(),this.B(d.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(k=>this.s(k)))}r(){this.c.clear();for(const a of this.j.profiles)this.c.add(a.settingsResource),this.c.add(a.keybindingsResource),this.c.add(a.tasksResource),this.c.add(a.extensionsResource)}open(a,y){return this.g.open(this.t(a),y)}close(a){return this.g.close(a)}read(a,y,E,d,m){return this.g.read(a,y,E,d,m)}write(a,y,E,d,m){return this.g.write(a,y,E,d,m)}watch(a,y){this.b.set(a,a);const E=this.g.watch(this.t(a),y);return(0,D.$Rc)(()=>{this.b.delete(a),E.dispose()})}stat(a){return this.g.stat(this.t(a))}mkdir(a){return this.g.mkdir(this.t(a))}rename(a,y,E){return this.g.rename(this.t(a),this.t(y),E)}readFile(a,y){return this.g.readFile(this.t(a),y)}readFileStream(a,y,E){return this.g.readFileStream(this.t(a),y,E)}readdir(a){return this.g.readdir(this.t(a))}enforceAtomicReadFile(a){return this.c.has(a)}writeFile(a,y,E){return this.g.writeFile(this.t(a),y,E)}enforceAtomicWriteFile(a){return this.c.has(a)?{postfix:".vsctmp"}:!1}delete(a,y){return this.g.delete(this.t(a),y)}copy(a,y,E){if((0,R.$Kk)(this.g))return this.g.copy(this.t(a),this.t(y),E);throw new Error("copy not supported")}cloneFile(a,y){if((0,R.$Lk)(this.g))return this.g.cloneFile(this.t(a),this.t(y));throw new Error("clone not supported")}s(a){const y=[];for(const E of a){if(E.resource.scheme!==this.f)continue;const d=this.u(E.resource);this.b.findSubstr(d)&&y.push({resource:d,type:E.type,cId:E.cId})}y.length&&(this.n.debug("User data changed"),this.a.fire(y))}t(a){return a.with({scheme:this.f})}u(a){return a.with({scheme:this.h})}}e.$2ac=P}),define(ie[156],ne([0,1,110,16,48,17,11,10,15]),function(J,e,N,D,R,L,A,P,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Li=e.$Ki=e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.$Di=e.$Ci=e.$Bi=e.$Ai=e.$zi=e.$yi=e.$xi=e.WorkbenchState=e.$wi=e.$vi=e.$ui=e.$ti=e.$si=e.$ri=e.$qi=e.$pi=void 0,e.$pi=(0,P.$gi)("contextService");function a(n){const s=n;return typeof s?.id=="string"&&A.URI.isUri(s.uri)}e.$qi=a;function y(n){return typeof n?.id=="string"&&!a(n)&&!d(n)}e.$ri=y,e.$si={id:"ext-dev"},e.$ti={id:"empty-window"};function E(n,s){if(typeof n=="string"||typeof n>"u")return typeof n=="string"?{id:(0,D.$nc)(n)}:s?e.$si:e.$ti;const o=n;return o.configuration?{id:o.id,configPath:o.configuration}:o.folders.length===1?{id:o.id,uri:o.folders[0].uri}:{id:o.id}}e.$ui=E;function d(n){const s=n;return typeof s?.id=="string"&&A.URI.isUri(s.configPath)}e.$vi=d;function m(n){const s=n;if(s?.uri)return{id:s.id,uri:A.URI.revive(s.uri)};const o=n;if(o?.configPath)return{id:o.id,configPath:A.URI.revive(o.configPath)};if(n?.id)return{id:n.id}}e.$wi=m;var w;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(w||(e.WorkbenchState=w={}));function k(n){const s=n;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&Array.isArray(s.folders))}e.$xi=k;function b(n){const s=n;return!!(s&&typeof s=="object"&&A.URI.isUri(s.uri)&&typeof s.name=="string"&&typeof s.toResource=="function")}e.$yi=b;class c{constructor(s,o,l,O,I){this.h=s,this.j=l,this.k=O,this.l=I,this.c=R.$mi.forUris(this.l,()=>!0),this.folders=o}update(s){this.h=s.id,this.k=s.configuration,this.j=s.transient,this.l=s.l,this.folders=s.folders}get folders(){return this.g}set folders(s){this.g=s,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(s){this.k=s}getFolder(s){return s&&this.c.findSubstr(s)||null}n(){this.c=R.$mi.forUris(this.l,()=>!0);for(const s of this.folders)this.c.set(s.uri,s)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$zi=c;class p{constructor(s,o){this.raw=o,this.uri=s.uri,this.index=s.index,this.name=s.name}toResource(s){return(0,L.$Tg)(this.uri,s)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Ai=p;function $(n){return new p({uri:n,index:0,name:(0,L.$Pg)(n)},{uri:n.toString()})}e.$Bi=$,e.$Ci="code-workspace",e.$Di=`.${e.$Ci}`,e.$Ei=[{name:(0,N.localize)(0,null),extensions:[e.$Ci]}],e.$Fi="workspace.json";function h(n,s){return L.$Kg.isEqualOrParent(n,s.untitledWorkspacesHome)}e.$Gi=h;function g(n){let s;return A.URI.isUri(n)?s=n:s=n.configuration,s?.scheme===u.Schemas.tmp}e.$Hi=g,e.$Ii="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function i(n){return n.id===e.$Ii}e.$Ji=i;function r(n,s){return!h(n,s)&&!g(n)}e.$Ki=r;function t(n){return(typeof n=="string"?(0,D.$oc)(n):(0,L.$Rg)(n))===e.$Di}e.$Li=t}),define(ie[23],ne([0,1,43,6,2,17,11,109,18,13,10,4,156,31,22,9,28,30,3]),function(J,e,N,D,R,L,A,P,u,a,y,E,d,m,w,k,b,c,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kl=e.$jl=e.$il=e.$hl=e.$gl=e.$fl=e.ProfileResourceType=void 0;var $;(function(n){n.Settings="settings",n.Keybindings="keybindings",n.Snippets="snippets",n.Tasks="tasks",n.Extensions="extensions",n.GlobalState="globalState"})($||(e.ProfileResourceType=$={}));function h(n){const s=n;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&typeof s.isDefault=="boolean"&&typeof s.name=="string"&&A.URI.isUri(s.location)&&A.URI.isUri(s.globalStorageHome)&&A.URI.isUri(s.settingsResource)&&A.URI.isUri(s.keybindingsResource)&&A.URI.isUri(s.tasksResource)&&A.URI.isUri(s.snippetsHome)&&A.URI.isUri(s.extensionsResource))}e.$fl=h,e.$gl=(0,y.$gi)("IUserDataProfilesService");function g(n,s){return{id:n.id,isDefault:n.isDefault,name:n.name,shortName:n.shortName,icon:n.icon,location:A.URI.revive(n.location).with({scheme:s}),globalStorageHome:A.URI.revive(n.globalStorageHome).with({scheme:s}),settingsResource:A.URI.revive(n.settingsResource).with({scheme:s}),keybindingsResource:A.URI.revive(n.keybindingsResource).with({scheme:s}),tasksResource:A.URI.revive(n.tasksResource).with({scheme:s}),snippetsHome:A.URI.revive(n.snippetsHome).with({scheme:s}),extensionsResource:A.URI.revive(n.extensionsResource).with({scheme:s}),cacheHome:A.URI.revive(n.cacheHome).with({scheme:s}),useDefaultFlags:n.useDefaultFlags,isTransient:n.isTransient}}e.$hl=g;function i(n,s,o,l,O,I){return{id:n,name:s,location:o,isDefault:!1,shortName:O?.shortName,icon:O?.icon,globalStorageHome:I&&O?.useDefaultFlags?.globalState?I.globalStorageHome:(0,L.$Tg)(o,"globalStorage"),settingsResource:I&&O?.useDefaultFlags?.settings?I.settingsResource:(0,L.$Tg)(o,"settings.json"),keybindingsResource:I&&O?.useDefaultFlags?.keybindings?I.keybindingsResource:(0,L.$Tg)(o,"keybindings.json"),tasksResource:I&&O?.useDefaultFlags?.tasks?I.tasksResource:(0,L.$Tg)(o,"tasks.json"),snippetsHome:I&&O?.useDefaultFlags?.snippets?I.snippetsHome:(0,L.$Tg)(o,"snippets"),extensionsResource:I&&O?.useDefaultFlags?.extensions?I.extensionsResource:(0,L.$Tg)(o,"extensions.json"),cacheHome:(0,L.$Tg)(l,n),useDefaultFlags:O?.useDefaultFlags,isTransient:O?.transient}}e.$il=i;let r=class extends R.$Tc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(s,o,l,O){super(),this.t=s,this.u=o,this.w=l,this.y=O,this.f=!0,this.h=this.B(new D.$6d),this.onDidChangeProfiles=this.h.event,this.j=this.B(new D.$6d),this.onWillCreateProfile=this.j.event,this.m=this.B(new D.$6d),this.onWillRemoveProfile=this.m.event,this.n=this.B(new D.$6d),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new m.$Ac,emptyWindows:new Map},this.profilesHome=(0,L.$Tg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,L.$Tg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(s){this.f!==s&&(this.z=void 0,this.f=s)}isEnabled(){return this.f}get C(){if(!this.z){const s=this.D(),o=[s];if(this.f)try{for(const I of this.O()){if(!I.name||!(0,p.$Tf)(I.name)||!I.location){this.y.warn("Skipping the invalid stored profile",I.location||I.name);continue}o.push(i((0,L.$Qg)(I.location),I.name,I.location,this.g,{shortName:I.shortName,icon:I.icon,useDefaultFlags:I.useDefaultFlags},s))}}catch(I){this.y.error(I)}const l=new m.$Ac,O=new Map;if(o.length)try{const I=this.Q();if(I.workspaces)for(const[v,j]of Object.entries(I.workspaces)){const q=A.URI.parse(v),Y=o.find(Z=>Z.id===j);Y&&l.set(q,Y)}if(I.emptyWindows)for(const[v,j]of Object.entries(I.emptyWindows)){const q=o.find(Y=>Y.id===j);q&&O.set(v,q)}}catch(I){this.y.error(I)}this.z={profiles:o,workspaces:l,emptyWindows:O}}return this.z}D(){const s=i("__default__profile__",(0,P.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...s,extensionsResource:this.S()??s.extensionsResource,isDefault:!0}}async createTransientProfile(s){const o="Temp",l=new RegExp(`${(0,c.$Ye)(o)}\\s(\\d+)`);let O=0;for(const v of this.profiles){const j=l.exec(v.name),q=j?parseInt(j[1]):0;O=q>O?q:O}const I=`${o} ${O+1}`;return this.createProfile((0,N.$7i)((0,b.$Cg)()).toString(16),I,{transient:!0},s)}async createNamedProfile(s,o,l){return this.createProfile((0,N.$7i)((0,b.$Cg)()).toString(16),s,o,l)}async createProfile(s,o,l,O){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const I=await this.F(s,o,l);return O&&await this.setProfileForWorkspace(O,I),I}async F(s,o,l){if(!(0,p.$Tf)(o)||!o)throw new Error("Name of the profile is mandatory and must be of type `string`");let O=this.r.get(o);return O||(O=(async()=>{try{const I=this.profiles.find(q=>q.name===o||q.id===s);if(I)return I;const v=i(s,o,(0,L.$Tg)(this.profilesHome,s),this.g,l,this.defaultProfile);await this.u.createFolder(v.location);const j=[];return this.j.fire({profile:v,join(q){j.push(q)}}),await k.Promises.settled(j),this.I([v],[],[]),v}finally{this.r.delete(o)}})(),this.r.set(o,O)),O}async updateProfile(s,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let l=this.profiles.find(O=>O.id===s.id);if(!l)throw new Error(`Profile '${s.name}' does not exist`);return l=i(l.id,o.name??l.name,l.location,this.g,{shortName:o.shortName??l.shortName,icon:o.icon===null?void 0:o.icon??l.icon,transient:o.transient??l.isTransient,useDefaultFlags:o.useDefaultFlags??l.useDefaultFlags},this.defaultProfile),this.I([],[],[l]),l}async removeProfile(s){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(s.isDefault)throw new Error("Cannot remove default profile");const o=this.profiles.find(O=>O.id===s.id);if(!o)throw new Error(`Profile '${s.name}' does not exist`);const l=[];this.m.fire({profile:o,join(O){l.push(O)}});try{await Promise.allSettled(l)}catch(O){this.y.error(O)}for(const O of[...this.C.emptyWindows.keys()])o.id===this.C.emptyWindows.get(O)?.id&&this.C.emptyWindows.delete(O);for(const O of[...this.C.workspaces.keys()])o.id===this.C.workspaces.get(O)?.id&&this.C.workspaces.delete(O);this.M(),this.I([],[o],[]);try{await this.u.del(o.cacheHome,{recursive:!0})}catch(O){(0,a.$Xk)(O)!==1&&this.y.error(O)}}async setProfileForWorkspace(s,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const l=this.profiles.find(O=>O.id===o.id);if(!l)throw new Error(`Profile '${o.name}' does not exist`);this.L(s,l)}unsetWorkspace(s,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(s,void 0,o)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const s=await this.u.resolve(this.profilesHome);await Promise.all((s.children||[]).filter(o=>o.isDirectory&&this.profiles.every(l=>!this.w.extUri.isEqual(l.location,o.resource))).map(o=>this.u.del(o.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const s=this.s.profiles.filter(o=>!this.H(o));await Promise.allSettled(s.map(o=>this.removeProfile(o)))}getProfileForWorkspace(s){const o=this.G(s);return A.URI.isUri(o)?this.s.workspaces.get(o)??this.C.workspaces.get(o):this.s.emptyWindows.get(o)??this.C.emptyWindows.get(o)}G(s){return(0,d.$qi)(s)?s.uri:(0,d.$vi)(s)?s.configPath:s.id}H(s){return!!([...this.s.emptyWindows.values()].some(o=>this.w.extUri.isEqual(o.location,s.location))||[...this.s.workspaces.values()].some(o=>this.w.extUri.isEqual(o.location,s.location))||[...this.C.emptyWindows.values()].some(o=>this.w.extUri.isEqual(o.location,s.location))||[...this.C.workspaces.values()].some(o=>this.w.extUri.isEqual(o.location,s.location)))}I(s,o,l){const O=[...this.profiles,...s],I=[];this.s.profiles=[];for(let v of O)v.isDefault||o.some(j=>v.id===j.id)||(v=l.find(j=>v.id===j.id)??v,v.isTransient?this.s.profiles.push(v):I.push({location:v.location,name:v.name,shortName:v.shortName,icon:v.icon,useDefaultFlags:v.useDefaultFlags}));this.P(I),this.z=void 0,this.J(s,o,l)}J(s,o,l){this.h.fire({added:s,removed:o,updated:l,all:this.profiles})}L(s,o,l){l=o?.isTransient?!0:l,l||this.L(s,void 0,!0);const O=this.G(s),I=l?this.s:this.C;A.URI.isUri(O)?(I.workspaces.delete(O),o&&I.workspaces.set(O,o)):(I.emptyWindows.delete(O),o&&I.emptyWindows.set(O,o)),l||this.M()}M(){const s={};for(const[l,O]of this.C.workspaces.entries())s[l.toString()]=O.id;const o={};for(const[l,O]of this.C.emptyWindows.entries())o[l.toString()]=O.id;this.R({workspaces:s,emptyWindows:o}),this.z=void 0}N(s){const o={},l=this.D();if(s.workspaces)for(const[I,v]of Object.entries(s.workspaces)){const j=A.URI.parse(v);o[I]=this.w.extUri.isEqual(j,l.location)?l.id:this.w.extUri.basename(j)}const O={};if(s.emptyWindows)for(const[I,v]of Object.entries(s.emptyWindows)){const j=A.URI.parse(v);O[I]=this.w.extUri.isEqual(j,l.location)?l.id:this.w.extUri.basename(j)}return{workspaces:o,emptyWindows:O}}O(){return[]}P(s){throw new Error("not implemented")}Q(){return{}}R(s){throw new Error("not implemented")}S(){}};e.$jl=r,e.$jl=r=pe([se(0,u.$ni),se(1,a.$Gk),se(2,w.$el),se(3,E.$Aj)],r);class t extends r{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(s){this.a=s}Q(){return this.X}R(s){this.X=s}}e.$kl=t}),define(ie[157],ne([0,1,19,9,20,7,6,2,12,3,11,94,21,26,37,4,32,25,22,23]),function(J,e,N,D,R,L,A,P,u,a,y,E,d,m,w,k,b,c,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9p=e.$8p=e.$7p=e.$6p=void 0;let h=class extends P.$Tc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(s,o,l,O,I,v){super(),this.z=s,this.C=o,this.D=l,this.F=O,this.G=I,this.H=v,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new A.$6d),this.s=this.B(new A.$6d),this.t=this.B(new A.$6d),this.u=this.B(new A.$6d),this.w=this.B(new A.$6d),this.y=[],this.B((0,P.$Rc)(()=>{this.j.forEach(({task:j})=>j.cancel()),this.m.forEach(j=>j.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(s){const o=await this.getTargetPlatform();return s.allTargetPlatforms.some(l=>(0,d.$Mo)(l,s.allTargetPlatforms,o))}async installFromGallery(s,o={}){try{const O=(await this.installGalleryExtensions([{extension:s,options:o}])).find(({identifier:I})=>(0,m.$dp)(I,s.identifier));if(O?.local)return O?.local;throw O?.error?O.error:new d.$Po(`Unknown error while installing extension ${s.identifier.id}`,d.ExtensionManagementErrorCode.Unknown)}catch(l){throw i(l)}}async installGalleryExtensions(s){if(!this.z.isEnabled())throw new d.$Po(E.localize(0,null),d.ExtensionManagementErrorCode.NotAllowed);const o=[],l=[];await Promise.allSettled(s.map(async({extension:O,options:I})=>{try{const v=await this.N(O,!!I?.installGivenVersion,!!I?.installPreReleaseVersion);l.push({...v,options:I})}catch(v){o.push({identifier:O.identifier,operation:2,source:O,error:v})}})),l.length&&o.push(...await this.I(l));for(const O of o)O.error&&(this.F.error("Failed to install extension.",O.identifier.id),this.F.error(O.error),O.source&&!y.URI.isUri(O.source)&&r(this.C,"extensionGallery:install",{extensionData:(0,m.$lp)(O.source),error:O.error}));return o}async uninstall(s,o={}){return this.F.trace("ExtensionManagementService#uninstall",s.identifier.id),this.P(s,o)}async toggleAppliationScope(s,o){if((0,w.$Dm)(s.manifest)||s.isBuiltin)return s;if(s.isApplicationScoped){let l=await this.updateMetadata(s,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(o,this.H.defaultProfile.extensionsResource)||(l=await this.$(s,this.H.defaultProfile.extensionsResource,o));for(const O of this.H.profiles){const I=(await this.getInstalled(1,O.extensionsResource)).find(v=>(0,m.$dp)(v.identifier,s.identifier));I?this.w.fire(I):this.u.fire({identifier:s.identifier,profileLocation:O.extensionsResource})}return l}else{const l=this.D.extUri.isEqual(o,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(s,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.$(s,o,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:l.identifier,operation:2,local:l,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),l}}getExtensionsControlManifest(){const s=new Date().getTime();return(!this.g||s-this.h>1e3*60*5)&&(this.g=this.W(),this.h=s),this.g}registerParticipant(s){this.y.push(s)}async I(s){const o=[],l=new Map,O=[],I=[],v=(q,Y)=>`${m.$ep.create(q).toString()}-${Y.toString()}`,j=(q,Y,Z)=>{const oe=this.Y(q,Y,Z),re=y.URI.isUri(Y)?Y.path:`${Y.identifier.id.toLowerCase()}-${Z.profileLocation.toString()}`;l.set(re,{task:oe,manifest:q}),this.n.fire({identifier:oe.identifier,source:Y,profileLocation:Z.profileLocation}),this.F.info("Installing extension:",oe.identifier.id),y.URI.isUri(Y)||this.j.set(v(Y,Z.profileLocation),{task:oe,waitingTasks:[]})};try{for(const{manifest:q,extension:Y,options:Z}of s){const oe=Z.isApplicationScoped||Z.isBuiltin||(0,w.$Dm)(q),re={...Z,installOnlyNewlyAddedFromExtensionPack:Z.installOnlyNewlyAddedFromExtensionPack??!y.URI.isUri(Y),isApplicationScoped:oe,profileLocation:oe?this.H.defaultProfile.extensionsResource:Z.profileLocation??this.X()},ue=y.URI.isUri(Y)?void 0:this.j.get(v(Y,re.profileLocation));ue?(this.F.info("Extension is already requested to install",ue.task.identifier.id),O.push(ue.task.waitUntilTaskIsFinished())):j(q,Y,re)}await Promise.all([...l.values()].map(async({task:q,manifest:Y})=>{if(q.options.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",q.identifier.id);else try{const Z=await this.M(q.identifier,Y,!!q.options.installOnlyNewlyAddedFromExtensionPack,!!q.options.installPreReleaseVersion,q.options.profileLocation),oe=await this.getInstalled(void 0,q.options.profileLocation),re={...q.options,donotIncludePackAndDependencies:!0,context:{...q.options.context,[d.$Ho]:!0}};for(const{gallery:ue,manifest:fe}of(0,N.$Mb)(Z,({gallery:ae})=>ae.identifier.id)){if(l.has(`${ue.identifier.id.toLowerCase()}-${re.profileLocation.toString()}`))continue;const ae=this.j.get(v(ue,re.profileLocation));if(ae){if(this.J(q,ae.task)){const B=ae.task.identifier;this.F.info("Waiting for already requested installing extension",B.id,q.identifier.id),ae.waitingTasks.push(q),O.push(A.Event.toPromise(A.Event.filter(this.onDidInstallExtensions,X=>X.some(U=>(0,m.$dp)(U.identifier,B)))).then(X=>{if(this.F.info("Finished waiting for already requested installing extension",B.id,q.identifier.id),!X.find(M=>(0,m.$dp)(M.identifier,B))?.local)throw new Error(`Extension ${B.id} is not installed`)}))}}else oe.some(({identifier:B})=>(0,m.$dp)(B,ue.identifier))||j(fe,ue,re)}}catch(Z){if(y.URI.isUri(q.source))(0,N.$Lb)(Y.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",q.identifier.id,Z.message),(0,N.$Lb)(Y.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",q.identifier.id,Z.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",q.identifier.id),Z}})),await this.L([...l.values()].map(async({task:q})=>{const Y=new Date().getTime();try{const Z=await q.run();if(await this.L(this.y.map(oe=>oe.postInstall(Z,q.source,q.options,R.CancellationToken.None))),!y.URI.isUri(q.source)){const oe=q.operation===3,re=oe?void 0:(new Date().getTime()-q.source.lastUpdated)/1e3;if(r(this.C,oe?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,m.$lp)(q.source),verificationStatus:q.verificationStatus,duration:new Date().getTime()-Y,durationSinceUpdate:re}),u.$o&&q.operation!==3)try{await this.z.reportStatistic(Z.manifest.publisher,Z.manifest.name,Z.manifest.version,"install")}catch{}}I.push({local:Z,identifier:q.identifier,operation:q.operation,source:q.source,context:q.options.context,profileLocation:q.profileLocation,applicationScoped:Z.isApplicationScoped})}catch(Z){throw this.F.error("Error while installing the extension",q.identifier.id,(0,L.$0)(Z)),Z}})),O.length&&await this.L(O);for(const q of I)this.F.info("Extension installed successfully:",q.identifier.id),o.push(q);return o}catch(q){I.length&&await Promise.allSettled(I.map(async({local:Y,profileLocation:Z})=>{try{await this.Z(Y,{versionOnly:!0,profileLocation:Z}).run(),this.F.info("Rollback: Uninstalled extension",Y.identifier.id)}catch(oe){this.F.warn("Rollback: Error while uninstalling extension",Y.identifier.id,(0,L.$0)(oe))}}));for(const{task:Y}of l.values())Y.cancel(),o.push({identifier:Y.identifier,operation:2,source:Y.source,context:Y.options.context,profileLocation:Y.profileLocation,error:q});throw q}finally{for(const{task:q}of l.values())q.source&&!y.URI.isUri(q.source)&&this.j.delete(v(q.source,q.profileLocation));o.length&&this.s.fire(o)}}J(s,o){for(const[,{task:l,waitingTasks:O}]of this.j.entries())if(l===s&&(O.includes(o)||O.some(I=>this.J(I,o)))||l===o&&O[0]&&!this.J(s,O[0]))return!1;return!0}async L(s){const o=[],l=[],O=await Promise.allSettled(s);for(const I of O)I.status==="fulfilled"?o.push(I.value):l.push(I.reason);if(l.length)throw g(l);return o}async M(s,o,l,O,I){if(!this.z.isEnabled())return[];const v=await this.getInstalled(void 0,I),j=[],q=[],Y=async(Z,oe)=>{j.push(Z);const re=oe.extensionDependencies||[],ue=[...re];if(oe.extensionPack){const fe=l?v.find(ae=>(0,m.$dp)(ae.identifier,Z)):void 0;for(const ae of oe.extensionPack)fe&&fe.manifest.extensionPack&&fe.manifest.extensionPack.some(B=>(0,m.$dp)({id:B},{id:ae}))||ue.every(B=>!(0,m.$dp)({id:B},{id:ae}))&&ue.push(ae)}if(ue.length){const fe=ue.filter(ae=>j.every(B=>!(0,m.$dp)(B,{id:ae})));if(fe.length){const ae=await this.z.getExtensions(fe.map(B=>({id:B,preRelease:O})),R.CancellationToken.None);for(const B of ae){if(j.find(M=>(0,m.$dp)(M,B.identifier)))continue;const X=re.some(M=>(0,m.$dp)({id:M},B.identifier));let U;try{U=await this.N(B,!1,O)}catch(M){if(X)throw M;this.F.info("Skipping the packed extension as it cannot be installed",B.identifier.id,(0,L.$0)(M));continue}q.push({gallery:U.extension,manifest:U.manifest}),await Y(U.extension.identifier,U.manifest)}}}};return await Y(s,o),q}async N(s,o,l){let O;const I=await this.getExtensionsControlManifest();if(I.malicious.some(q=>(0,m.$dp)(s.identifier,q)))throw new d.$Po(E.localize(1,null,s.identifier.id),d.ExtensionManagementErrorCode.Malicious);const v=I.deprecated[s.identifier.id.toLowerCase()];if(v?.extension?.autoMigrate){if(this.F.info(`The '${s.identifier.id}' extension is deprecated, fetching the compatible '${v.extension.id}' extension instead.`),O=(await this.z.getExtensions([{id:v.extension.id,preRelease:v.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0},R.CancellationToken.None))[0],!O)throw new d.$Po(E.localize(2,null,s.identifier.id,v.extension.id),d.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(s)){const q=await this.getTargetPlatform();throw new d.$Po(E.localize(3,null,s.identifier.id,this.G.nameLong,(0,d.$Io)(q)),d.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(O=await this.O(s,o,l),!O)throw!l&&s.properties.isPreReleaseVersion&&(await this.z.getExtensions([s.identifier],R.CancellationToken.None))[0]?new d.$Po(E.localize(4,null,s.displayName??s.identifier.id),d.ExtensionManagementErrorCode.ReleaseVersionNotFound):new d.$Po(E.localize(5,null,s.identifier.id,this.G.nameLong,this.G.version),d.ExtensionManagementErrorCode.Incompatible)}this.F.info("Getting Manifest...",O.identifier.id);const j=await this.z.getManifest(O,R.CancellationToken.None);if(j===null)throw new d.$Po(`Missing manifest for extension ${O.identifier.id}`,d.ExtensionManagementErrorCode.Invalid);if(j.version!==O.version)throw new d.$Po(`Cannot install '${O.identifier.id}' extension because of version mismatch in Marketplace`,d.ExtensionManagementErrorCode.Invalid);return{extension:O,manifest:j}}async O(s,o,l){const O=await this.getTargetPlatform();let I=null;return!o&&s.hasPreReleaseVersion&&s.properties.isPreReleaseVersion!==l&&(I=(await this.z.getExtensions([{...s.identifier,preRelease:l}],{targetPlatform:O,compatible:!0},R.CancellationToken.None))[0]||null),!I&&await this.z.isExtensionCompatible(s,l,O)&&(I=s),I||(o?I=(await this.z.getExtensions([{...s.identifier,version:s.version}],{targetPlatform:O,compatible:!0},R.CancellationToken.None))[0]||null:I=await this.z.getCompatibleExtension(s,l,O)),I}async P(s,o){const l={...o,profileLocation:s.isApplicationScoped?this.H.defaultProfile.extensionsResource:o.profileLocation??this.X()},O=Z=>`${Z.id.toLowerCase()}${l.versionOnly?`-${s.manifest.version}`:""}${l.profileLocation?`@${l.profileLocation.toString()}`:""}`,I=this.m.get(O(s.identifier));if(I)return this.F.info("Extensions is already requested to uninstall",s.identifier.id),I.waitUntilTaskIsFinished();const v=Z=>{const oe=this.Z(Z,l);return this.m.set(O(oe.extension.identifier),oe),l.profileLocation?this.F.info("Uninstalling extension from the profile:",`${Z.identifier.id}@${Z.manifest.version}`,l.profileLocation.toString()):this.F.info("Uninstalling extension:",`${Z.identifier.id}@${Z.manifest.version}`),this.t.fire({identifier:Z.identifier,profileLocation:l.profileLocation,applicationScoped:Z.isApplicationScoped}),oe},j=(Z,oe)=>{oe?l.profileLocation?this.F.error("Failed to uninstall extension from the profile:",`${Z.identifier.id}@${Z.manifest.version}`,l.profileLocation.toString(),oe.message):this.F.error("Failed to uninstall extension:",`${Z.identifier.id}@${Z.manifest.version}`,oe.message):l.profileLocation?this.F.info("Successfully uninstalled extension from the profile",`${Z.identifier.id}@${Z.manifest.version}`,l.profileLocation.toString()):this.F.info("Successfully uninstalled extension:",`${Z.identifier.id}@${Z.manifest.version}`),r(this.C,"extensionGallery:uninstall",{extensionData:(0,m.$kp)(Z),error:oe}),this.u.fire({identifier:Z.identifier,error:oe?.code,profileLocation:l.profileLocation,applicationScoped:Z.isApplicationScoped})},q=[],Y=[];try{q.push(v(s));const Z=await this.getInstalled(1,l.profileLocation);if(l.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${s.identifier.id}@${s.manifest.version}`);else{const oe=this.S(s,Z);for(const re of oe)this.m.has(O(re.identifier))?this.F.info("Extensions is already requested to uninstall",re.identifier.id):q.push(v(re))}l.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${s.identifier.id}@${s.manifest.version}`):this.Q(q.map(oe=>oe.extension),Z,s),await this.L(q.map(async oe=>{try{if(await oe.run(),await this.L(this.y.map(re=>re.postUninstall(oe.extension,l,R.CancellationToken.None))),oe.extension.identifier.uuid)try{await this.z.reportStatistic(oe.extension.manifest.publisher,oe.extension.manifest.name,oe.extension.manifest.version,"uninstall")}catch{}j(oe.extension)}catch(re){const ue=re instanceof d.$Po?re:new d.$Po((0,L.$0)(re),d.ExtensionManagementErrorCode.Internal);throw j(oe.extension,ue),ue}finally{Y.push(oe)}}))}catch(Z){const oe=Z instanceof d.$Po?Z:new d.$Po((0,L.$0)(Z),d.ExtensionManagementErrorCode.Internal);for(const re of q){try{re.cancel()}catch{}Y.includes(re)||j(re.extension,oe)}throw oe}finally{for(const Z of q)this.m.delete(O(Z.extension.identifier))||this.F.warn("Uninstallation task is not found in the cache",Z.extension.identifier.id)}}Q(s,o,l){for(const O of s){const I=this.U(O,o);if(I.length){const v=I.filter(j=>!s.some(q=>(0,m.$dp)(q.identifier,j.identifier)));if(v.length)throw new Error(this.R(O,v,l))}}}R(s,o,l){return l===s?o.length===1?E.localize(6,null,l.manifest.displayName||l.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?E.localize(7,null,l.manifest.displayName||l.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):E.localize(8,null,l.manifest.displayName||l.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):o.length===1?E.localize(9,null,l.manifest.displayName||l.manifest.name,s.manifest.displayName||s.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?E.localize(10,null,l.manifest.displayName||l.manifest.name,s.manifest.displayName||s.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):E.localize(11,null,l.manifest.displayName||l.manifest.name,s.manifest.displayName||s.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name)}S(s,o,l=[]){if(l.indexOf(s)!==-1)return[];l.push(s);const O=s.manifest.extensionPack?s.manifest.extensionPack:[];if(O.length){const I=o.filter(j=>!j.isBuiltin&&O.some(q=>(0,m.$dp)({id:q},j.identifier))),v=[];for(const j of I)v.push(...this.S(j,o,l));return[...I,...v]}return[]}U(s,o){return o.filter(l=>l.manifest.extensionDependencies&&l.manifest.extensionDependencies.some(O=>(0,m.$dp)({id:O},s.identifier)))}async W(){try{return this.F.trace("ExtensionManagementService.updateControlCache"),await this.z.getExtensionsControlManifest()}catch(s){return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest",(0,L.$0)(s)),{malicious:[],deprecated:{},search:[]}}}};e.$6p=h,e.$6p=h=pe([se(0,d.$Oo),se(1,c.$Fl),se(2,p.$el),se(3,k.$Aj),se(4,b.$Sj),se(5,$.$gl)],h);function g(n){const s=Array.isArray(n)?n:[n];return s.length===1?s[0]instanceof Error?s[0]:new Error(s[0]):s.reduce((o,l)=>new Error(`${o.message}${o.message?",":""}${l instanceof Error?l.message:l}`),new Error(""))}e.$7p=g;function i(n){if(n instanceof d.$Po)return n;if(n instanceof d.$Qo){const o=new d.$Po(n.message,d.ExtensionManagementErrorCode.Gallery);return o.stack=n.stack,o}const s=new d.$Po(n.message,d.ExtensionManagementErrorCode.Internal);return s.stack=n.stack,s}e.$8p=i;function r(n,s,{extensionData:o,verificationStatus:l,duration:O,error:I,durationSinceUpdate:v}){let j,q;(0,a.$2f)(l)&&(l===!0?l="Verified":(l===!1||(j=d.ExtensionManagementErrorCode.Signature,q=l),l="Unverified")),I&&(I instanceof d.$Po||I instanceof d.$Qo?(j=I.code,I.code===d.ExtensionManagementErrorCode.Signature&&(q=I.message)):j=d.ExtensionManagementErrorCode.Internal),n.publicLog(s,{...o,verificationStatus:l,success:!I,duration:O,errorcode:j,errorcodeDetail:q,durationSinceUpdate:v})}class t{constructor(){this.d=new D.$fh}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,D.$6g)(s=>this.h(s))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,D.$6g)(s=>new Promise((o,l)=>{const O=s.onCancellationRequested(()=>{O.dispose(),l(new L.$5)})})),this.d.open()),this.g.cancel()}}e.$9p=t}),define(ie[42],ne([0,1,9,14,2,6,31,11,21,26,13,10,4,23,22,3,7,25]),function(J,e,N,D,R,L,A,P,u,a,y,E,d,m,w,k,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_p=e.$$p=e.$0p=e.ExtensionsProfileScanningErrorCode=void 0;var p;(function(r){r.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",r.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(p||(e.ExtensionsProfileScanningErrorCode=p={}));class $ extends Error{constructor(t,n){super(t),this.code=n}}e.$0p=$,e.$$p=(0,E.$gi)("IExtensionsProfileScannerService");let h=class extends R.$Tc{constructor(t,n,s,o,l,O){super(),this.j=t,this.m=n,this.n=s,this.r=o,this.s=l,this.t=O,this.b=this.B(new L.$6d),this.onAddExtensions=this.b.event,this.c=this.B(new L.$6d),this.onDidAddExtensions=this.c.event,this.f=this.B(new L.$6d),this.onRemoveExtensions=this.f.event,this.g=this.B(new L.$6d),this.onDidRemoveExtensions=this.g.event,this.h=new A.$Ac}scanProfileExtensions(t,n){return this.u(t,void 0,n)}async addExtensionsToProfile(t,n){const s=[],o=[];try{return await this.u(n,l=>{const O=[];for(const I of l)t.some(([v])=>(0,a.$dp)(v.identifier,I.identifier)&&v.manifest.version!==I.version)?s.push(I):O.push(I);for(const[I,v]of t){const j=O.findIndex(Y=>(0,a.$dp)(Y.identifier,I.identifier)&&Y.version===I.manifest.version),q={identifier:I.identifier,version:I.manifest.version,location:I.location,metadata:v};j===-1?(o.push(q),O.push(q)):O.splice(j,1,q)}return o.length&&this.b.fire({extensions:o,profileLocation:n}),s.length&&this.f.fire({extensions:s,profileLocation:n}),O}),o.length&&this.c.fire({extensions:o,profileLocation:n}),s.length&&this.g.fire({extensions:s,profileLocation:n}),o}catch(l){throw o.length&&this.c.fire({extensions:o,error:l,profileLocation:n}),s.length&&this.g.fire({extensions:s,error:l,profileLocation:n}),l}}async updateMetadata(t,n){const s=[];return await this.u(n,o=>{const l=[];for(const O of o){const I=t.find(([v])=>(0,a.$dp)(v.identifier,O.identifier)&&v.manifest.version===O.version);I&&(O.metadata={...O.metadata,...I[1]},s.push(O)),l.push(O)}return l}),s}async removeExtensionFromProfile(t,n){const s=[];try{await this.u(n,o=>{const l=[];for(const O of o)(0,a.$dp)(O.identifier,t.identifier)?s.push(O):l.push(O);return s.length&&this.f.fire({extensions:s,profileLocation:n}),l}),s.length&&this.g.fire({extensions:s,profileLocation:n})}catch(o){throw s.length&&this.g.fire({extensions:s,error:o,profileLocation:n}),o}}async u(t,n,s){return this.F(t).queue(async()=>{let o=[],l;try{const O=await this.m.readFile(t);l=JSON.parse(O.value.toString().trim()||"[]")}catch(O){if((0,y.$Xk)(O)!==1)throw O;if(this.r.extUri.isEqual(t,this.n.defaultProfile.extensionsResource)&&(l=await this.D()),!l&&s?.bailOutWhenFileNotFound)throw new $((0,b.$0)(O),"ERROR_PROFILE_NOT_FOUND")}if(l){Array.isArray(l)||this.w(t);let O=!1;for(const I of l){g(I)||this.w(t);let v;if((0,k.$Tf)(I.relativeLocation)&&I.relativeLocation)v=this.z(I.relativeLocation);else if((0,k.$Tf)(I.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${I.location}`);continue}else{v=P.URI.revive(I.location);const j=this.y(v);j&&(O=!0,I.relativeLocation=j)}(0,k.$1f)(I.metadata?.hasPreReleaseVersion)&&I.metadata?.preRelease&&(O=!0,I.metadata.hasPreReleaseVersion=!0),o.push({identifier:I.identifier,location:v,version:I.version,metadata:I.metadata})}O&&await this.m.writeFile(t,D.$te.fromString(JSON.stringify(l)))}if(n){o=n(o);const O=o.map(I=>({identifier:I.identifier,version:I.version,location:I.location.toJSON(),relativeLocation:this.y(I.location),metadata:I.metadata}));await this.m.writeFile(t,D.$te.fromString(JSON.stringify(O)))}return o})}w(t){const n=new $(`Invalid extensions content in ${t.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:n.code}),n}y(t){return this.r.extUri.isEqual(this.r.extUri.dirname(t),this.j)?this.r.extUri.basename(t):void 0}z(t){return this.r.extUri.joinPath(this.j,t)}async D(){return this.C||(this.C=(async()=>{const t=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),n=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let s;try{s=(await this.m.readFile(t)).value.toString()}catch(l){if((0,y.$Xk)(l)===1)return;throw l}this.t.info("Migrating extensions from old default profile location",t.toString());let o;try{const l=JSON.parse(s);Array.isArray(l)&&l.every(O=>g(O))?o=l:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",l)}catch(l){this.t.error(l)}if(o)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,D.$te.fromString(JSON.stringify(o)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",t.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(l){if((0,y.$Xk)(l)===3)this.t.info("Migration from old default profile location to new location is done by another window",t.toString(),this.n.defaultProfile.extensionsResource.toString());else throw l}try{await this.m.del(t)}catch(l){(0,y.$Xk)(l)!==1&&this.t.error(l)}try{await this.m.del(n)}catch(l){(0,y.$Xk)(l)!==1&&this.t.error(l)}return o})()),this.C}F(t){let n=this.h.get(t);return n||(n=new N.$nh,this.h.set(t,n)),n}};e.$_p=h,e.$_p=h=pe([se(1,y.$Gk),se(2,m.$gl),se(3,w.$el),se(4,c.$Fl),se(5,d.$Aj)],h);function g(r){return(0,k.$Vf)(r)&&(0,u.$No)(r.identifier)&&(i(r.location)||(0,k.$Tf)(r.location)&&r.location)&&((0,k.$1f)(r.relativeLocation)||(0,k.$Tf)(r.relativeLocation))&&r.version&&(0,k.$Tf)(r.version)}function i(r){return r?(0,k.$Tf)(r.path)&&(0,k.$Tf)(r.scheme):!1}}),define(ie[52],ne([0,1,19,9,27,14,7,38,81,2,15,16,12,17,44,54,3,11,98,18,26,37,50,13,10,4,32,6,47,42,23,22,115]),function(J,e,N,D,R,L,A,P,u,a,y,E,d,m,w,k,b,c,p,$,h,g,i,r,t,n,s,o,l,O,I,v,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gq=e.$fq=e.$eq=e.$dq=e.$cq=e.Translations=void 0;var q;(function(ae){function B(X,U){if(X===U)return!0;const M=Object.keys(X),H=new Set;for(const K of Object.keys(U))H.add(K);if(M.length!==H.size)return!1;for(const K of M){if(X[K]!==U[K])return!1;H.delete(K)}return H.size===0}ae.equals=B})(q||(e.Translations=q={})),e.$cq=(0,t.$gi)("IExtensionsScannerService");let Y=class extends a.$Tc{constructor(B,X,U,M,H,K,Q,ee,C,z,f,S){super(),this.systemExtensionsLocation=B,this.userExtensionsLocation=X,this.r=U,this.s=M,this.t=H,this.u=K,this.w=Q,this.y=ee,this.z=C,this.C=z,this.D=f,this.F=S,this.g=this.B(new o.$6d),this.onDidChangeCache=this.g.event,this.h=(0,m.$Tg)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(re,this.s,this.h)),this.m=this.B(this.F.createInstance(re,this.s,this.h)),this.n=this.B(this.F.createInstance(oe,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,h.$op)(this.w,this.y)),this.G}async scanAllExtensions(B,X,U){const[M,H]=await Promise.all([this.scanSystemExtensions(B),this.scanUserExtensions(X)]),K=U?await this.scanExtensionsUnderDevelopment(B,[...M,...H]):[];return this.L(M,H,K,await this.getTargetPlatform(),!0)}async scanSystemExtensions(B){const X=[];X.push(this.M(!!B.useCache,B.language)),X.push(this.N(B.language,!!B.checkControlFile));const[U,M]=await Promise.all(X);return this.J([...U,...M],0,B,!1)}async scanUserExtensions(B){const X=B.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",X);const U=this.D.extUri.isEqual(B.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,M=await this.P(X,!!B.profileLocation,1,!B.includeUninstalled,B.language,!0,U),H=B.useCache&&!M.devMode&&M.excludeObsolete?this.m:this.n;let K;try{K=await H.scanExtensions(M)}catch(Q){if(Q instanceof O.$0p&&Q.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),K=await H.scanExtensions(M);else throw Q}return K=await this.J(K,1,B,!0),this.y.trace("Scanned user extensions:",K.length),K}async scanExtensionsUnderDevelopment(B,X){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const U=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(M=>M.scheme===y.Schemas.file).map(async M=>{const H=await this.P(M,!1,1,!0,B.language,!1,void 0);return(await this.n.scanOneOrMultipleExtensions(H)).map(Q=>(Q.type=X.find(ee=>(0,h.$dp)(ee.identifier,Q.identifier))?.type??Q.type,this.n.validate(Q,H)))}))).flat();return this.J(U,"development",B,!0)}return[]}async scanExistingExtension(B,X,U){const M=await this.P(B,!1,X,!0,U.language,!0,void 0),H=await this.n.scanExtension(M);return!H||!U.includeInvalid&&!H.isValid?null:H}async scanOneOrMultipleExtensions(B,X,U){const M=await this.P(B,!1,X,!0,U.language,!0,void 0),H=await this.n.scanOneOrMultipleExtensions(M);return this.J(H,X,U,!0)}async scanMetadata(B){const X=(0,m.$Tg)(B,"package.json"),U=(await this.w.readFile(X)).value.toString();return JSON.parse(U).__metadata}async updateMetadata(B,X){const U=(0,m.$Tg)(B,"package.json"),M=(await this.w.readFile(U)).value.toString(),H=JSON.parse(M);X.isMachineScoped===!1&&delete X.isMachineScoped,X.isBuiltin===!1&&delete X.isBuiltin,H.__metadata={...H.__metadata,...X},await this.w.writeFile((0,m.$Tg)(B,"package.json"),L.$te.fromString(JSON.stringify(H,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(B){if(B instanceof O.$0p&&B.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw B}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const B=await this.scanUserExtensions({includeInvalid:!0});if(B.length)await this.u.addExtensionsToProfile(B.map(X=>[X,X.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,L.$te.fromString(JSON.stringify([])))}catch(X){(0,r.$Xk)(X)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,A.$0)(X))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(B){this.y.error(B)}finally{this.H=void 0}})()),this.H}async J(B,X,U,M){return U.includeAllVersions||(B=this.L(X===0?B:void 0,X===1?B:void 0,X==="development"?B:void 0,await this.getTargetPlatform(),M)),U.includeInvalid||(B=B.filter(H=>H.isValid)),B.sort((H,K)=>{const Q=E.$nc(H.location.fsPath),ee=E.$nc(K.location.fsPath);return Q<ee?-1:Q>ee?1:0})}L(B,X,U,M,H){const K=(ee,C,z)=>{if(ee.isValid&&!C.isValid)return!1;if(ee.isValid===C.isValid){if(H&&w.gt(ee.manifest.version,C.manifest.version))return this.y.debug(`Skipping extension ${C.location.path} with lower version ${C.manifest.version} in favour of ${ee.location.path} with version ${ee.manifest.version}`),!1;if(w.eq(ee.manifest.version,C.manifest.version)){if(ee.type===0)return this.y.debug(`Skipping extension ${C.location.path} in favour of system extension ${ee.location.path} with same version`),!1;if(ee.targetPlatform===M)return this.y.debug(`Skipping extension ${C.location.path} from different target platform ${C.targetPlatform}`),!1}}return z?this.y.warn(`Overwriting user extension ${ee.location.path} with ${C.location.path}.`):this.y.debug(`Overwriting user extension ${ee.location.path} with ${C.location.path}.`),!0},Q=new g.$Cm;return B?.forEach(ee=>{const C=Q.get(ee.identifier.id);(!C||K(C,ee,!1))&&Q.set(ee.identifier.id,ee)}),X?.forEach(ee=>{const C=Q.get(ee.identifier.id);if(!C&&B&&ee.type===0){this.y.debug(`Skipping obsolete system extension ${ee.location.path}.`);return}(!C||K(C,ee,!1))&&Q.set(ee.identifier.id,ee)}),U?.forEach(ee=>{const C=Q.get(ee.identifier.id);(!C||K(C,ee,!0))&&Q.set(ee.identifier.id,ee),Q.set(ee.identifier.id,ee)}),[...Q.values()]}async M(B,X){this.y.trace("Started scanning system extensions");const U=await this.P(this.systemExtensionsLocation,!1,0,!0,X,!0,void 0),H=await(B&&!U.devMode?this.j:this.n).scanExtensions(U);return this.y.trace("Scanned system extensions:",H.length),H}async N(B,X){const U=this.z.isBuilt?[]:this.C.builtInExtensions;if(!U?.length)return[];this.y.trace("Started scanning dev system extensions");const M=X?await this.O():{},H=[],K=c.URI.file(E.$hc(E.$jc(y.$Ag.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const ee of U){const C=M[ee.name]||"marketplace";switch(C){case"disabled":break;case"marketplace":H.push((0,m.$Tg)(K,ee.name));break;default:H.push(c.URI.file(C));break}}const Q=await Promise.all(H.map(async ee=>this.n.scanExtension(await this.P(ee,!1,0,!0,B,!0,void 0))));return this.y.trace("Scanned dev system extensions:",Q.length),(0,N.$Hb)(Q)}async O(){try{const B=await this.w.readFile(this.r);return JSON.parse(B.value.toString())}catch{return{}}}async P(B,X,U,M,H,K,Q){const ee=await this.f(H??d.$w),C=await this.Q(B),z=X&&!this.D.extUri.isEqual(B,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,f=z?await this.Q(z):void 0;return new Z(B,C,z,f,X,Q,U,M,K,this.C.version,this.C.date,this.C.commit,!this.z.isBuilt,H,ee)}async Q(B){try{const X=await this.w.stat(B);if(typeof X.mtime=="number")return X.mtime}catch{}}};e.$dq=Y,e.$dq=Y=pe([se(4,I.$gl),se(5,O.$$p),se(6,r.$Gk),se(7,n.$Aj),se(8,$.$ni),se(9,s.$Sj),se(10,v.$el),se(11,t.$fi)],Y);class Z{constructor(B,X,U,M,H,K,Q,ee,C,z,f,S,T,F,W){this.location=B,this.mtime=X,this.applicationExtensionslocation=U,this.applicationExtensionslocationMtime=M,this.profile=H,this.profileScanOptions=K,this.type=Q,this.excludeObsolete=ee,this.validate=C,this.productVersion=z,this.productDate=f,this.productCommit=S,this.devMode=T,this.language=F,this.translations=W}static createNlsConfiguration(B){return{language:B.language,pseudo:B.language==="pseudo",devMode:B.devMode,translations:B.translations}}static equals(B,X){return(0,m.$Mg)(B.location,X.location)&&B.mtime===X.mtime&&(0,m.$Mg)(B.applicationExtensionslocation,X.applicationExtensionslocation)&&B.applicationExtensionslocationMtime===X.applicationExtensionslocationMtime&&B.profile===X.profile&&R.$Pn(B.profileScanOptions,X.profileScanOptions)&&B.type===X.type&&B.excludeObsolete===X.excludeObsolete&&B.validate===X.validate&&B.productVersion===X.productVersion&&B.productDate===X.productDate&&B.productCommit===X.productCommit&&B.devMode===X.devMode&&B.language===X.language&&q.equals(B.translations,X.translations)}}e.$eq=Z;let oe=class extends a.$Tc{constructor(B,X,U,M,H){super(),this.f=B,this.g=X,this.h=U,this.j=M,this.m=H}async scanExtensions(B){const X=B.profile?await this.r(B):await this.n(B);let U={};if(B.excludeObsolete&&B.type===1)try{const M=(await this.j.readFile(this.f)).value.toString();U=JSON.parse(M)}catch{}return(0,b.$7f)(U)?X:X.filter(M=>!U[h.$ep.create(M).toString()])}async n(B){const X=await this.j.resolve(B.location);if(!X.children?.length)return[];const U=await Promise.all(X.children.map(async M=>{if(!M.isDirectory||B.type===1&&(0,m.$Qg)(M.resource).indexOf(".")===0)return null;const H=new Z(M.resource,B.mtime,B.applicationExtensionslocation,B.applicationExtensionslocationMtime,B.profile,B.profileScanOptions,B.type,B.excludeObsolete,B.validate,B.productVersion,B.productDate,B.productCommit,B.devMode,B.language,B.translations);return this.scanExtension(H)}));return(0,N.$Hb)(U).sort((M,H)=>M.location.path<H.location.path?-1:1)}async r(B){let X=await this.s(B.location,()=>!0,B);if(B.applicationExtensionslocation&&!this.h.extUri.isEqual(B.location,B.applicationExtensionslocation)){X=X.filter(M=>!M.metadata?.isApplicationScoped);const U=await this.s(B.applicationExtensionslocation,M=>!!M.metadata?.isBuiltin||!!M.metadata?.isApplicationScoped,B);X.push(...U)}return X}async s(B,X,U){const M=await this.g.scanProfileExtensions(B,U.profileScanOptions);if(!M.length)return[];const H=await Promise.all(M.map(async K=>{if(X(K)){const Q=new Z(K.location,U.mtime,U.applicationExtensionslocation,U.applicationExtensionslocationMtime,U.profile,U.profileScanOptions,U.type,U.excludeObsolete,U.validate,U.productVersion,U.productDate,U.productCommit,U.devMode,U.language,U.translations);return this.scanExtension(Q,K.metadata)}return null}));return(0,N.$Hb)(H)}async scanOneOrMultipleExtensions(B){try{if(await this.j.exists((0,m.$Tg)(B.location,"package.json"))){const X=await this.scanExtension(B);return X?[X]:[]}else return await this.scanExtensions(B)}catch(X){return this.m.error(`Error scanning extensions at ${B.location.path}:`,(0,A.$0)(X)),[]}}async scanExtension(B,X){try{let U=await this.scanExtensionManifest(B.location);if(U){U.publisher||(U.publisher=g.$wm),X=X??U.__metadata,delete U.__metadata;const M=(0,h.$ip)(U.publisher,U.name),H=X?.id?{id:M,uuid:X.id}:{id:M},K=X?.isSystem?0:B.type,Q=K===0||!!X?.isBuiltin;U=await this.t(B.location,U,Z.createNlsConfiguration(B));const ee={type:K,identifier:H,manifest:U,location:B.location,isBuiltin:Q,targetPlatform:X?.targetPlatform??"undefined",metadata:X,isValid:!0,validations:[]};return B.validate?this.validate(ee,B):ee}}catch(U){B.type!==0&&this.m.error(U)}return null}validate(B,X){let U=!0;const M=(0,i.$tp)(X.productVersion,X.productDate,X.location,B.manifest,B.isBuiltin);for(const[H,K]of M)H===k.default.Error&&(U=!1,this.m.error(this.z(X.location,K)));return B.isValid=U,B.validations=M,B}async scanExtensionManifest(B){const X=(0,m.$Tg)(B,"package.json");let U;try{U=(await this.j.readFile(X)).value.toString()}catch(H){return(0,r.$Xk)(H)!==1&&this.m.error(this.z(B,(0,p.localize)(0,null,X.path,H.message))),null}let M;try{M=JSON.parse(U)}catch{const K=[];(0,P.$sn)(U,K);for(const Q of K)this.m.error(this.z(B,(0,p.localize)(1,null,X.path,Q.offset,Q.length,(0,u.$aq)(Q.error))));return null}return(0,P.$Bn)(M)!=="object"?(this.m.error(this.z(B,(0,p.localize)(2,null,X.path))),null):M}async t(B,X,U){const M=await this.u(B,X,U);if(M)try{const H=[],K=await this.w(M.default,H);if(H.length>0)return H.forEach(ee=>{this.m.error(this.z(B,(0,p.localize)(3,null,M.default?.path,(0,u.$aq)(ee.error))))}),X;if((0,P.$Bn)(M)!=="object")return this.m.error(this.z(B,(0,p.localize)(4,null,M.default?.path))),X;const Q=M.values||Object.create(null);return(0,j.$bq)(this.m,X,Q,K)}catch{}return X}async u(B,X,U){const M=(0,m.$Tg)(B,"package.nls.json"),H=(C,z)=>{z.forEach(f=>{this.m.error(this.z(B,(0,p.localize)(5,null,C?.path,(0,u.$aq)(f.error))))})},K=C=>{this.m.error(this.z(B,(0,p.localize)(6,null,C?.path)))},Q=`${X.publisher}.${X.name}`,ee=U.translations[Q];if(ee)try{const C=c.URI.file(ee),z=(await this.j.readFile(C)).value.toString(),f=[],S=(0,P.$sn)(z,f);return f.length>0?(H(C,f),{values:void 0,default:M}):(0,P.$Bn)(S)!=="object"?(K(C),{values:void 0,default:M}):{values:S.contents?S.contents.package:void 0,default:M}}catch{return{values:void 0,default:M}}else{if(!await this.j.exists(M))return;let z;try{z=await this.y(B,U)}catch{return}if(!z.localized)return{values:void 0,default:z.original};try{const f=(await this.j.readFile(z.localized)).value.toString(),S=[],T=(0,P.$sn)(f,S);return S.length>0?(H(z.localized,S),{values:void 0,default:z.original}):(0,P.$Bn)(T)!=="object"?(K(z.localized),{values:void 0,default:z.original}):{values:T,default:z.original}}catch{return{values:void 0,default:z.original}}}}async w(B,X){if(B)try{const U=(await this.j.readFile(B)).value.toString();return(0,P.$sn)(U,X)}catch{}}y(B,X){return new Promise((U,M)=>{const H=K=>{const Q=(0,m.$Tg)(B,`package.nls.${K}.json`);this.j.exists(Q).then(ee=>{ee&&U({localized:Q,original:(0,m.$Tg)(B,"package.nls.json")});const C=K.lastIndexOf("-");C===-1?U({localized:(0,m.$Tg)(B,"package.nls.json"),original:null}):(K=K.substring(0,C),H(K))})};if(X.devMode||X.pseudo||!X.language)return U({localized:(0,m.$Tg)(B,"package.nls.json"),original:null});H(X.language)})}z(B,X){return`[${B.path}]: ${X}`}};oe=pe([se(1,O.$$p),se(2,v.$el),se(3,r.$Gk),se(4,n.$Aj)],oe);let re=class extends oe{constructor(B,X,U,M,H,K,Q){super(X,M,H,K,Q),this.G=B,this.H=U,this.D=this.B(new D.$eh(3e3)),this.F=this.B(new o.$6d),this.onDidChangeCache=this.F.event}async scanExtensions(B){const X=this.M(B),U=await this.I(X);if(this.C=B,U&&U.input&&Z.equals(U.input,this.C))return this.m.debug("Using cached extensions scan result",B.location.toString()),this.D.trigger(()=>this.L()),U.result.map(H=>(H.location=c.URI.revive(H.location),H));const M=await super.scanExtensions(B);return await this.J(X,{input:B,result:M}),M}async I(B){try{const X=await this.j.readFile(B),U=JSON.parse(X.value.toString());return{result:U.result,input:(0,l.$Ph)(U.input)}}catch(X){this.m.debug("Error while reading the extension cache file:",B.path,(0,A.$0)(X))}return null}async J(B,X){try{await this.j.writeFile(B,L.$te.fromString(JSON.stringify(X)))}catch(U){this.m.debug("Error while writing the extension cache file:",B.path,(0,A.$0)(U))}}async L(){if(!this.C)return;const B=this.M(this.C),X=await this.I(B);if(!X)return;const U=X.result,M=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!R.$Pn(M,U))try{this.m.info("Invalidating Cache",U,M),await this.j.del(B),this.F.fire()}catch(H){this.m.error(H)}}M(B){const X=this.N(B);return this.h.extUri.joinPath(X.cacheHome,B.type===0?g.$vm:g.$um)}N(B){return B.type===0?this.H.defaultProfile:B.profile?this.h.extUri.isEqual(B.location,this.G.extensionsResource)?this.G:this.H.profiles.find(X=>this.h.extUri.isEqual(B.location,X.extensionsResource))??this.G:this.H.defaultProfile}};re=pe([se(2,I.$gl),se(3,O.$$p),se(4,v.$el),se(5,r.$Gk),se(6,n.$Aj)],re);function ue(ae,B){const X=(0,h.$gp)(ae.manifest.publisher,ae.manifest.name);return{id:X,identifier:new g.$Am(X),isBuiltin:ae.type===0,isUserBuiltin:ae.type===1&&ae.isBuiltin,isUnderDevelopment:B,extensionLocation:ae.location,uuid:ae.identifier.uuid,targetPlatform:ae.targetPlatform,...ae.manifest}}e.$fq=ue;class fe extends Y{constructor(B,X,U,M,H,K,Q,ee,C,z,f,S){super(B,X,(0,m.$Tg)(U,".vscode-oss-dev","extensions","control.json"),M,H,K,Q,ee,C,z,f,S),this.R=(async()=>{if(d.$z)try{const T=await this.w.readFile(c.URI.file(d.$z));return JSON.parse(T.value.toString())}catch{}return Object.create(null)})()}f(B){return this.R}}e.$gq=fe}),define(ie[158],ne([0,1,58,9,34,6,2,15,16,24,4,23]),function(J,e,N,D,R,L,A,P,u,a,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iq=void 0;let d=class extends A.$Tc{constructor(w,k){super(),this.b=w,this.f=k,this.a=new D.$mh(5)}async postUninstall(w){const k=this.g(w,"uninstall");k&&(this.f.info(w.identifier.id,w.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(k.script,"uninstall",k.args,!0,w),this.f.info("Finished running post uninstall script",w.identifier.id,w.manifest.version)}catch(b){this.f.error("Failed to run post uninstall script",w.identifier.id,w.manifest.version),this.f.error(b)}}));try{await a.Promises.rm(this.m(w))}catch(b){this.f.error("Error while removing extension storage path",w.identifier.id),this.f.error(b)}}g(w,k){const b=`vscode:${k}`;if(w.location.scheme===P.Schemas.file&&w.manifest&&w.manifest.scripts&&typeof w.manifest.scripts[b]=="string"){const c=w.manifest.scripts[b].split(" ");return c.length<2||c[0]!=="node"||!c[1]?(this.f.warn(w.identifier.id,w.manifest.version,`${b} should be a node script`),null):{script:(0,u.$jc)(w.location.fsPath,c[1]),args:c.slice(2)||[]}}return null}h(w,k,b,c,p){return new Promise(($,h)=>{const g=this.j(w,k,b,p);let i;const r=t=>{i&&(clearTimeout(i),i=null),t?h(t):$(void 0)};g.on("error",t=>{r((0,R.$4i)(t)||"Unknown")}),g.on("exit",(t,n)=>{r(t?`post-${k} process exited with code ${t}`:void 0)}),c&&(i=setTimeout(()=>{i=null,g.kill(),h("timed out")},5e3))})}j(w,k,b,c){const p={silent:!0,execArgv:void 0},$=(0,N.fork)(w,[`--type=extension-post-${k}`,...b],p);$.stdout.setEncoding("utf8"),$.stderr.setEncoding("utf8");const h=L.Event.fromNodeEventEmitter($.stdout,"data"),g=L.Event.fromNodeEventEmitter($.stderr,"data");h(t=>this.f.info(c.identifier.id,c.manifest.version,`post-${k}`,t)),g(t=>this.f.error(c.identifier.id,c.manifest.version,`post-${k}`,t));const i=L.Event.any(L.Event.map(h,t=>({data:`%c${t}`,format:[""]})),L.Event.map(g,t=>({data:`%c${t}`,format:["color: red"]})));return L.Event.debounce(i,(t,n)=>t?{data:t.data+n.data,format:[...t.format,...n.format]}:{data:n.data,format:n.format},100)(t=>{console.group(c.identifier.id),console.log(t.data,...t.format),console.groupEnd()}),$}m(w){return(0,u.$jc)(this.b.defaultProfile.globalStorageHome.fsPath,w.identifier.id.toLowerCase())}};e.$iq=d,e.$iq=d=pe([se(0,E.$gl),se(1,y.$Aj)],d)}),define(ie[159],ne([0,1,9,14,20,34,7,6,43,2,31,15,16,17,44,3,11,28,24,49,99,59,18,157,21,26,42,52,144,158,116,137,145,50,13,10,4,32,25,22,23]),function(J,e,N,D,R,L,A,P,u,a,y,E,d,m,w,k,b,c,p,$,h,g,i,r,t,n,s,o,l,O,I,v,j,q,Y,Z,oe,re,ue,fe,ae){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pq=e.$oq=e.$nq=e.$mq=void 0,e.$mq=(0,Z.$hi)(t.$Ro);const B=".vsctmp";let X=class extends r.$6p{constructor(C,z,f,S,T,F,W,G,te,ce,le,$e){super(C,z,le,f,ce,$e),this.eb=T,this.fb=F,this.gb=W,this.hb=te,this.db=new Map,this.qb=new y.$Bc;const ye=this.B(G.createInstance(O.$iq));this.ab=this.B(G.createInstance(U,me=>ye.postUninstall(me))),this.bb=this.B(new v.$kq($e,te,le,this,this.F)),this.cb=this.B(G.createInstance(l.$hq));const he=this.B(new j.$lq(this,this.eb,$e,F,le,te,f));this.B(he.onDidChangeExtensionsByAnotherSource(me=>this.pb(me))),this.rb()}getTargetPlatform(){return this.ib||(this.ib=(0,n.$op)(this.hb,this.F)),this.ib}async zip(C){this.F.trace("ExtensionManagementService#zip",C.identifier.id);const z=await this.ob(C),f=await(0,$.zip)((0,m.$Tg)(this.cb.extensionsDownloadDir,(0,c.$Cg)()).fsPath,z);return b.URI.file(f)}async unzip(C){return this.F.trace("ExtensionManagementService#unzip",C.toString()),(await this.install(C)).identifier}async getManifest(C){const{location:z,cleanup:f}=await this.kb(C),S=d.$kc(z.fsPath);try{return await(0,I.$jq)(S)}finally{await f()}}getInstalled(C,z=this.H.defaultProfile.extensionsResource){return this.ab.scanExtensions(C??null,z)}scanAllUserInstalledExtensions(){return this.ab.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(C){return this.ab.scanUserExtensionAtLocation(C)}async install(C,z={}){this.F.trace("ExtensionManagementService#install",C.toString());const{location:f,cleanup:S}=await this.kb(C);try{const T=await(0,I.$jq)(d.$kc(f.fsPath)),F=(0,n.$ip)(T.publisher,T.name);if(T.engines&&T.engines.vscode&&!(0,q.$vp)(T.engines.vscode,this.G.version,this.G.date))throw new Error(h.localize(0,null,F,this.G.version));const G=(await this.I([{manifest:T,extension:f,options:z}])).find(({identifier:te})=>(0,n.$dp)(te,{id:F}));if(G?.local)return G.local;throw G?.error?G.error:(0,r.$8p)(new Error(`Unknown error while installing extension ${F}`))}finally{await S()}}async installFromLocation(C,z){this.F.trace("ExtensionManagementService#installFromLocation",C.toString());const f=await this.ab.scanUserExtensionAtLocation(C);if(!f||!f.manifest.name||!f.manifest.version)throw new Error(`Cannot find a valid extension from the location ${C.toString()}`);return await this.tb([[f,void 0]],z),this.F.info("Successfully installed extension",f.identifier.id,z.toString()),f}async installExtensionsFromProfile(C,z,f){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",C,z.toString(),f.toString());const S=(await this.ab.scanExtensions(1,z)).filter(T=>C.some(F=>(0,n.$dp)(F,T.identifier)));if(S.length){const T=await Promise.all(S.map(F=>this.ab.scanMetadata(F,z)));await this.tb(S.map((F,W)=>[F,T[W]]),f),this.F.info("Successfully installed extensions",S.map(F=>F.identifier.id),f.toString())}return S}async updateMetadata(C,z,f=this.H.defaultProfile.extensionsResource){return this.F.trace("ExtensionManagementService#updateMetadata",C.identifier.id),z.isPreReleaseVersion&&(z.preRelease=!0,z.hasPreReleaseVersion=!0),z.isMachineScoped===!1&&(z.isMachineScoped=void 0),z.isBuiltin===!1&&(z.isBuiltin=void 0),z.pinned===!1&&(z.pinned=void 0),C=await this.ab.updateMetadata(C,z,f),this.bb.invalidate(f),this.w.fire(C),C}async reinstallFromGallery(C){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",C.identifier.id),!this.z.isEnabled())throw new Error(h.localize(1,null));const z=await this.getTargetPlatform(),[f]=await this.z.getExtensions([{...C.identifier,preRelease:C.preRelease}],{targetPlatform:z,compatible:!0},R.CancellationToken.None);if(!f)throw new Error(h.localize(2,null));await this.ab.setUninstalled(C);try{await this.ab.removeUninstalledExtension(C)}catch(S){throw new Error(h.localize(3,null,(0,L.$4i)(S)))}return this.installFromGallery(f)}$(C,z,f,S){return this.ab.copyExtension(C,z,f,S)}copyExtensions(C,z){return this.ab.copyExtensions(C,z)}markAsUninstalled(...C){return this.ab.setUninstalled(...C)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.ab.cleanUp()}catch(C){this.F.error(C)}}async download(C,z,f){const{location:S}=await this.cb.download(C,z,!f);return S}async kb(C){if(C.scheme===E.Schemas.file)return{location:C,async cleanup(){}};this.F.trace("Downloading extension from",C.toString());const z=(0,m.$Tg)(this.cb.extensionsDownloadDir,(0,c.$Cg)());return await this.gb.download(C,z),this.F.info("Downloaded extension to",z.toString()),{location:z,cleanup:async()=>{try{await this.hb.del(z)}catch(S){this.F.error(S)}}}}X(){return this.H.defaultProfile.extensionsResource}Y(C,z,f){if(b.URI.isUri(z))return new K(C,z,f,this.z,this.ab,this.D,this.H,this.eb,this.fb,this.F);const S=n.$ep.create(z).toString();let T=this.db.get(S);return T||(this.db.set(S,T=new H(C,z,f,this.cb,this.ab,this.D,this.H,this.eb,this.fb,this.F)),T.waitUntilTaskIsFinished().finally(()=>this.db.delete(S))),T}Z(C,z){return new Q(C,z.profileLocation,this.fb)}async ob(C){const z=async S=>{let T=await p.Promises.readdir(S);T=T.map(G=>d.$jc(S,G));const F=await Promise.all(T.map(G=>p.Promises.stat(G)));let W=Promise.resolve([]);return F.forEach((G,te)=>{const ce=T[te];G.isFile()&&(W=W.then(le=>[...le,ce])),G.isDirectory()&&(W=W.then(le=>z(ce).then($e=>[...le,...$e])))}),W};return(await z(C.location.fsPath)).map(S=>({path:`extension/${d.$lc(C.location.fsPath,S)}`,localPath:S}))}async pb({added:C,removed:z}){if(z){const f=C&&this.D.extUri.isEqual(z.profileLocation,C.profileLocation)?z.extensions.filter(S=>C.extensions.every(T=>!(0,n.$dp)(T,S))):z.extensions;for(const S of f)this.F.info("Extensions removed from another source",S.id,z.profileLocation.toString()),this.u.fire({identifier:S,profileLocation:z.profileLocation})}if(C){const S=(await this.ab.scanExtensions(1,C.profileLocation)).filter(T=>C.extensions.some(F=>(0,n.$dp)(F,T.identifier)));this.s.fire(S.map(T=>(this.F.info("Extensions added from another source",T.identifier.id,C.profileLocation.toString()),{identifier:T.identifier,local:T,profileLocation:C.profileLocation,operation:1})))}}async rb(){this.B(this.ab.onExtract(z=>this.qb.add(z)));const C=await this.hb.resolve(this.eb.userExtensionsLocation);for(const z of C.children??[])z.isDirectory&&this.qb.add(z.resource);this.B(this.hb.watch(this.eb.userExtensionsLocation)),this.B(this.hb.onDidFilesChange(z=>this.sb(z)))}async sb(C){if(!C.affects(this.eb.userExtensionsLocation,1))return;const z=[];for(const f of C.rawAdded){if(this.qb.has(f)||!this.D.extUri.isEqual(this.D.extUri.dirname(f),this.eb.userExtensionsLocation)||this.D.extUri.isEqual(f,this.D.extUri.joinPath(this.eb.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(f).startsWith(".")||!(await this.hb.stat(f)).isDirectory)continue;const S=await this.ab.scanUserExtensionAtLocation(f);S&&S.installedTimestamp===void 0&&(this.qb.add(f),z.push(S))}z.length&&(await this.tb(z.map(f=>[f,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",z.map(f=>f.identifier.id)))}async tb(C,z){const f=C.map(S=>S[0]);await this.ub(f),await this.fb.addExtensionsToProfile(C,z),this.s.fire(f.map(S=>({local:S,identifier:S.identifier,operation:1,profileLocation:z})))}async ub(C){const z=await this.ab.getUninstalledExtensions();for(const f of C){const S=n.$ep.create(f);z[S.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",S.id),await this.ab.setInstalled(S),this.F.info("Removed the extension from uninstalled list:",S.id))}}};e.$nq=X,e.$nq=X=pe([se(0,t.$Oo),se(1,ue.$Fl),se(2,oe.$Aj),se(3,i.$oi),se(4,o.$cq),se(5,s.$$p),se(6,g.$to),se(7,Z.$fi),se(8,Y.$Gk),se(9,re.$Sj),se(10,fe.$el),se(11,ae.$gl)],X);let U=class extends a.$Tc{constructor(C,z,f,S,T,F){super(),this.j=C,this.m=z,this.n=f,this.s=S,this.t=T,this.u=F,this.h=this.B(new P.$6d),this.onExtract=this.h.event,this.c=(0,m.$Tg)(this.n.userExtensionsLocation,".obsolete"),this.g=new N.$nh}async cleanUp(){await this.H(),await this.G()}async scanExtensions(C,z){const f={includeInvalid:!0,profileLocation:z};let S=[];return C===null||C===0?S.push(...await this.n.scanAllExtensions({includeInvalid:!0},f,!1)):C===1&&S.push(...await this.n.scanUserExtensions(f)),S=C!==null?S.filter(T=>T.type===C):S,Promise.all(S.map(T=>this.F(T)))}async scanAllUserExtensions(C){const z=await this.n.scanUserExtensions({includeAllVersions:!C,includeInvalid:!0});return Promise.all(z.map(f=>this.F(f)))}async scanUserExtensionAtLocation(C){try{const z=await this.n.scanExistingExtension(C,1,{includeInvalid:!0});if(z)return await this.F(z)}catch(z){this.u.error(z)}return null}async extractUserExtension(C,z,f,S,T){const F=C.toString(),W=b.URI.file(d.$jc(this.n.userExtensionsLocation.fsPath,`.${(0,c.$Cg)()}`)),G=b.URI.file(d.$jc(this.n.userExtensionsLocation.fsPath,F));let te=await this.m.exists(G);if(te&&S){try{await this.y(C.id,G,"removeExisting")}catch{throw new t.$Po(h.localize(4,null,G.fsPath,C.id),t.ExtensionManagementErrorCode.Delete)}te=!1}if(te)await this.n.updateMetadata(G,f);else try{try{this.u.trace(`Started extracting the extension from ${z} to ${G.fsPath}`),await(0,$.$4p)(z,W.fsPath,{sourcePath:"extension",overwrite:!0},T),this.u.info(`Extracted extension to ${G}:`,C.id)}catch(ce){let le=t.ExtensionManagementErrorCode.Extract;throw ce instanceof $.$2p&&(ce.type==="CorruptZip"?le=t.ExtensionManagementErrorCode.CorruptZip:ce.type==="Incomplete"&&(le=t.ExtensionManagementErrorCode.IncompleteZip)),new t.$Po(ce.message,le)}await this.n.updateMetadata(W,f);try{this.u.trace(`Started renaming the extension from ${W.fsPath} to ${G.fsPath}`),await this.C(W.fsPath,G.fsPath),this.u.info("Renamed to",G.fsPath)}catch(ce){if(ce.code==="ENOTEMPTY")this.u.info("Rename failed because extension was installed by another source. So ignoring renaming.",C.id);else throw this.u.info(`Rename failed because of ${(0,A.$0)(ce)}. Deleted from extracted location`,W),ce}this.h.fire(G)}catch(ce){try{await this.m.del(W,{recursive:!0})}catch{}throw ce}return this.D(G,1)}async scanMetadata(C,z){return z?(await this.w(C,z))?.metadata:this.n.scanMetadata(C.location)}async w(C,z){return(await this.s.scanProfileExtensions(z)).find(S=>(0,n.$dp)(S.identifier,C.identifier))}async updateMetadata(C,z,f){return f?await this.s.updateMetadata([[C,z]],f):await this.n.updateMetadata(C.location,z),this.D(C.location,C.type,f)}getUninstalledExtensions(){return this.z()}async setUninstalled(...C){const z=C.map(f=>n.$ep.create(f));await this.z(f=>z.forEach(S=>{f[S.toString()]=!0,this.u.info("Marked extension as uninstalled",S.toString())}))}async setInstalled(C){await this.z(z=>delete z[C.toString()])}async removeExtension(C,z){if(this.t.extUri.isEqualOrParent(C.location,this.n.userExtensionsLocation))return this.y(C.identifier.id,C.location,z)}async removeUninstalledExtension(C){await this.removeExtension(C,"uninstalled"),await this.z(z=>delete z[n.$ep.create(C).toString()])}async copyExtension(C,z,f,S){const T=await this.w(C,z),F=await this.w(C,f);if(S={...T?.metadata,...S},F)if(this.t.extUri.isEqual(F.location,C.location))await this.s.updateMetadata([[C,{...F.metadata,...S}]],f);else{const W=await this.D(F.location,C.type,f);await this.s.removeExtensionFromProfile(W,f),await this.s.addExtensionsToProfile([[C,{...F.metadata,...S}]],f)}else await this.s.addExtensionsToProfile([[C,S]],f);return this.D(C.location,C.type,f)}async copyExtensions(C,z){const f=await this.scanExtensions(1,C),S=await Promise.all(f.filter(T=>!T.isApplicationScoped).map(async T=>[T,await this.scanMetadata(T,C)]));await this.s.addExtensionsToProfile(S,z)}async y(C,z,f){this.u.trace(`Deleting ${f} extension from disk`,C,z.fsPath);const S=this.t.extUri.joinPath(this.t.extUri.dirname(z),`${this.t.extUri.basename(z)}.${(0,u.$7i)((0,c.$Cg)()).toString(16)}${B}`);await this.C(z.fsPath,S.fsPath),await this.m.del(S,{recursive:!0}),this.u.info(`Deleted ${f} extension from disk`,C,z.fsPath)}async z(C){return this.g.queue(async()=>{let z;try{z=(await this.m.readFile(this.c,"utf8")).value.toString()}catch(S){if((0,Y.$Xk)(S)!==1)throw S}let f={};if(z)try{f=JSON.parse(z)}catch{}return C&&(C(f),Object.keys(f).length?await this.m.writeFile(this.c,D.$te.fromString(JSON.stringify(f))):await this.m.del(this.c)),f})}async C(C,z){try{await p.Promises.rename(C,z,2*60*1e3)}catch(f){throw new t.$Po(f.message||h.localize(5,null,C,z),f.code||t.ExtensionManagementErrorCode.Rename)}}async D(C,z,f){if(f){const T=(await this.n.scanUserExtensions({profileLocation:f})).find(F=>this.t.extUri.isEqual(F.location,C));if(T)return this.F(T)}else{const S=await this.n.scanExistingExtension(C,z,{includeInvalid:!0});if(S)return this.F(S)}throw new Error(h.localize(6,null,C.path))}async F(C){const z=await this.m.resolve(C.location);let f,S;return z.children&&(f=z.children.find(({name:T})=>/^readme(\.txt|\.md|)$/i.test(T))?.resource,S=z.children.find(({name:T})=>/^changelog(\.txt|\.md|)$/i.test(T))?.resource),{identifier:C.identifier,type:C.type,isBuiltin:C.isBuiltin||!!C.metadata?.isBuiltin,location:C.location,manifest:C.manifest,targetPlatform:C.targetPlatform,validations:C.validations,isValid:C.isValid,readmeUrl:f,changelogUrl:S,publisherDisplayName:C.metadata?.publisherDisplayName||null,publisherId:C.metadata?.publisherId||null,isApplicationScoped:!!C.metadata?.isApplicationScoped,isMachineScoped:!!C.metadata?.isMachineScoped,isPreReleaseVersion:!!C.metadata?.isPreReleaseVersion,hasPreReleaseVersion:!!C.metadata?.hasPreReleaseVersion,preRelease:!!C.metadata?.preRelease,installedTimestamp:C.metadata?.installedTimestamp,updated:!!C.metadata?.updated,pinned:!!C.metadata?.pinned}}async G(){const C=await this.getUninstalledExtensions();if(Object.keys(C).length===0){this.u.debug("No uninstalled extensions found.");return}this.u.debug("Removing uninstalled extensions:",Object.keys(C));const z=await this.n.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),f=new Set;for(const T of z)C[n.$ep.create(T).toString()]||f.add(T.identifier.id.toLowerCase());try{const T=(0,n.$jp)(z,F=>F.identifier);await N.Promises.settled(T.map(async F=>{const W=F.sort((G,te)=>w.rcompare(G.manifest.version,te.manifest.version))[0];f.has(W.identifier.id.toLowerCase())||await this.j(await this.F(W))}))}catch(T){this.u.error(T)}const S=z.filter(T=>T.metadata&&C[n.$ep.create(T).toString()]);await Promise.allSettled(S.map(T=>this.removeUninstalledExtension(T)))}async H(){this.u.trace("ExtensionManagementService#removeTempDeleteFolders");let C;try{C=await this.m.resolve(this.n.userExtensionsLocation)}catch(z){(0,Y.$Xk)(z)!==1&&this.u.error(z);return}if(C?.children)try{await Promise.allSettled(C.children.map(async z=>{if(!(!z.isDirectory||!z.name.endsWith(B))){this.u.trace("Deleting the temporarily deleted folder",z.resource.toString());try{await this.m.del(z.resource,{recursive:!0}),this.u.trace("Deleted the temporarily deleted folder",z.resource.toString())}catch(f){(0,Y.$Xk)(f)!==1&&this.u.error(f)}}}))}catch{}}};e.$oq=U,e.$oq=U=pe([se(1,Y.$Gk),se(2,o.$cq),se(3,s.$$p),se(4,fe.$el),se(5,oe.$Aj)],U);class M extends r.$9p{get profileLocation(){return this.j}get verificationStatus(){return this.k}get operation(){return(0,k.$1f)(this.options.operation)?this.l:this.options.operation}constructor(C,z,f,S,T,F,W,G,te){super(),this.identifier=C,this.source=z,this.options=f,this.m=S,this.n=T,this.o=F,this.p=W,this.q=G,this.s=te,this.j=this.options.profileLocation,this.k=!1,this.l=2}async h(C){const[z,f]=await this.x(C);return this.j=z.isBuiltin||z.isApplicationScoped?this.o.defaultProfile.extensionsResource:this.options.profileLocation,this.n.extUri.isEqual(this.o.defaultProfile.extensionsResource,this.j)&&await this.p.initializeDefaultProfileExtensions(),await this.q.addExtensionsToProfile([[z,f]],this.j),z}async u({zipPath:C,key:z,metadata:f},S,T){let F=await this.v(z);return F?F=await this.m.updateMetadata(F,f):(this.s.trace("Extracting extension...",z.id),F=await this.m.extractUserExtension(z,C,f,S,T),this.s.info("Extracting extension completed.",z.id)),F}async v(C){return await this.w(C)?(this.s.trace("Removing the extension from uninstalled list:",C.id),await this.m.setInstalled(C),this.s.info("Removed the extension from uninstalled list:",C.id),(await this.m.scanAllUserExtensions(!0)).find(S=>n.$ep.create(S).equals(C))):void 0}async w(C){return!!(await this.m.getUninstalledExtensions())[C.toString()]}}class H extends M{constructor(C,z,f,S,T,F,W,G,te,ce){super(z.identifier,z,f,T,F,W,G,te,ce),this.y=z,this.z=S}async x(C){let z;try{z=await this.m.scanExtensions(null,this.options.profileLocation)}catch(W){throw new t.$Po(W,t.ExtensionManagementErrorCode.Scanning)}const f=z.find(W=>(0,n.$dp)(W.identifier,this.y.identifier));f&&(this.l=3);const S={id:this.y.identifier.uuid,publisherId:this.y.publisherId,publisherDisplayName:this.y.publisherDisplayName,targetPlatform:this.y.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||f?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||f?.isMachineScoped,isBuiltin:this.options.isBuiltin||f?.isBuiltin,isSystem:f?.type===0?!0:void 0,updated:!!f,isPreReleaseVersion:this.y.properties.isPreReleaseVersion,hasPreReleaseVersion:f?.hasPreReleaseVersion||this.y.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??f?.pinned,preRelease:(0,k.$Zf)(this.options.preRelease)?this.options.preRelease:this.options.installPreReleaseVersion||this.y.properties.isPreReleaseVersion||f?.preRelease};if(f?.manifest.version===this.y.version)try{return[await this.m.updateMetadata(f,S),S]}catch(W){throw new t.$Po((0,A.$0)(W),t.ExtensionManagementErrorCode.UpdateMetadata)}const{location:T,verificationStatus:F}=await this.z.download(this.y,this.l,!this.options.donotVerifySignature);try{return this.k=F,this.B(T.fsPath),[await this.u({zipPath:T.fsPath,key:n.$ep.create(this.y),metadata:S},!1,C),S]}catch(W){try{await this.z.delete(T)}catch(G){this.s.warn("Error while deleting the downloaded file",T.toString(),(0,A.$0)(G))}throw W}}async B(C){try{await(0,I.$jq)(C)}catch(z){throw new t.$Po((0,r.$7p)(z).message,t.ExtensionManagementErrorCode.Invalid)}}}e.$pq=H;class K extends M{constructor(C,z,f,S,T,F,W,G,te,ce){super({id:(0,n.$ip)(C.publisher,C.name)},z,f,T,F,W,G,te,ce),this.y=C,this.z=z,this.A=S}async h(C){const z=await super.h(C);return this.D(z,C),z}async x(C){const z=new n.$ep(this.identifier,this.y.version),S=(await this.m.scanExtensions(1,this.options.profileLocation)).find(W=>(0,n.$dp)(this.identifier,W.identifier)),T={isApplicationScoped:this.options.isApplicationScoped||S?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||S?.isMachineScoped,isBuiltin:this.options.isBuiltin||S?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??S?.pinned};if(S)if(this.l=3,z.equals(new n.$ep(S.identifier,S.manifest.version)))try{await this.m.removeExtension(S,"existing")}catch{throw new Error(h.localize(7,null,this.y.displayName||this.y.name))}else!this.options.profileLocation&&w.gt(S.manifest.version,this.y.version)&&await this.m.setUninstalled(S);else{const W=await this.v(z);if(W)try{await this.m.removeExtension(W,"existing")}catch{throw new Error(h.localize(8,null,this.y.displayName||this.y.name))}}return[await this.u({zipPath:d.$kc(this.z.fsPath),key:z,metadata:T},!0,C),T]}async D(C,z){try{let[f]=await this.A.getExtensions([{id:C.identifier.id,version:C.manifest.version}],z);if(f||([f]=await this.A.getExtensions([{id:C.identifier.id}],z)),f){const S={id:f.identifier.uuid,publisherDisplayName:f.publisherDisplayName,publisherId:f.publisherId,isPreReleaseVersion:f.properties.isPreReleaseVersion,hasPreReleaseVersion:C.hasPreReleaseVersion||f.properties.isPreReleaseVersion,preRelease:f.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.m.updateMetadata(C,S,this.options.profileLocation)}}catch{}}}class Q extends r.$9p{constructor(C,z,f){super(),this.extension=C,this.j=z,this.k=f}async h(C){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(ie[160],ne([0,1,4,23,22,25,42,13,18,11]),function(J,e,N,D,R,L,A,P,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OP=void 0;let y=class extends A.$_p{constructor(d,m,w,k,b,c){super(a.URI.file(d.extensionsPath),m,w,k,b,c)}};e.$OP=y,e.$OP=y=pe([se(0,u.$oi),se(1,P.$Gk),se(2,D.$gl),se(3,R.$el),se(4,L.$Fl),se(5,N.$Aj)],y)}),define(ie[161],ne([0,1,11,18,42,52,13,10,4,32,22,23]),function(J,e,N,D,R,L,A,P,u,a,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aac=void 0;let d=class extends L.$gq{constructor(w,k,b,c,p,$,h,g){super(N.URI.file(p.builtinExtensionsPath),N.URI.file(p.extensionsPath),p.userHome,w.defaultProfile,w,k,b,c,p,$,h,g)}};e.$Aac=d,e.$Aac=d=pe([se(0,E.$gl),se(1,R.$$p),se(2,A.$Gk),se(3,u.$Aj),se(4,D.$oi),se(5,a.$Sj),se(6,y.$el),se(7,P.$fi)],d)}),define(ie[162],ne([0,1,9,6,2,127,3,88,10,23]),function(J,e,N,D,R,L,A,P,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Op=e.$Np=e.$Mp=e.$Lp=e.$Kp=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$Jp=e.$Ip=e.$Hp=void 0,e.$Hp="__$__isNewStorageMarker",e.$Ip="__$__targetStorageMarker",e.$Jp=(0,u.$gi)("storageService");var y;(function(p){p[p.NONE=0]="NONE",p[p.SHUTDOWN=1]="SHUTDOWN"})(y||(e.WillSaveStateReason=y={}));var E;(function(p){p[p.APPLICATION=-1]="APPLICATION",p[p.PROFILE=0]="PROFILE",p[p.WORKSPACE=1]="WORKSPACE"})(E||(e.StorageScope=E={}));var d;(function(p){p[p.USER=0]="USER",p[p.MACHINE=1]="MACHINE"})(d||(e.StorageTarget=d={}));function m(p){const $=p.get(e.$Ip);if($)try{return JSON.parse($)}catch{}return Object.create(null)}e.$Kp=m;class w extends R.$Tc{static{this.a=60*1e3}constructor($={flushInterval:w.a}){super(),this.m=$,this.b=this.B(new D.$9d),this.c=this.B(new D.$9d),this.onDidChangeTarget=this.c.event,this.f=this.B(new D.$6d),this.onWillSaveState=this.f.event,this.h=this.B(new N.$sh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new R.$Uc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue($,h,g){return D.Event.filter(this.b.event,i=>i.scope===$&&(h===void 0||i.key===h),g)}n(){this.j.value=(0,N.$wh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,R.$Oc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,L.mark)("code/willInitStorage");try{await this.O()}finally{(0,L.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u($,h){const{key:g,external:i}=h;if(g===e.$Ip){switch($){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:$})}else this.b.fire({scope:$,key:g,target:this.J($)[g],external:i})}w($){this.f.fire({reason:$})}get($,h,g){return this.P(h)?.get($,g)}getBoolean($,h,g){return this.P(h)?.getBoolean($,g)}getNumber($,h,g){return this.P(h)?.getNumber($,g)}getObject($,h,g){return this.P(h)?.getObject($,g)}storeAll($,h){this.y(()=>{for(const g of $)this.store(g.key,g.value,g.scope,g.target,h)})}store($,h,g,i,r=!1){if((0,A.$3f)(h)){this.remove($,g,r);return}this.y(()=>{this.z($,g,i),this.P(g)?.set($,h,r)})}remove($,h,g=!1){this.y(()=>{this.z($,h,void 0),this.P(h)?.delete($,g)})}y($){this.b.pause(),this.c.pause();try{$()}finally{this.b.resume(),this.c.resume()}}keys($,h){const g=[],i=this.J($);for(const r of Object.keys(i))i[r]===h&&g.push(r);return g}z($,h,g,i=!1){const r=this.J(h);typeof g=="number"?r[$]!==g&&(r[$]=g,this.P(h)?.set(e.$Ip,JSON.stringify(r),i)):typeof r[$]=="number"&&(delete r[$],this.P(h)?.set(e.$Ip,JSON.stringify(r),i))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J($){switch($){case-1:return this.I;case 0:return this.G;default:return this.D}}L($){const h=this.P($);return h?m(h):Object.create(null)}isNew($){return this.getBoolean(e.$Hp,$)===!0}async flush($=y.NONE){this.f.fire({reason:$});const h=this.P(-1),g=this.P(0),i=this.P(1);switch($){case y.NONE:await N.Promises.settled([h?.whenFlushed()??Promise.resolve(),g?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve()]);break;case y.SHUTDOWN:await N.Promises.settled([h?.flush(0)??Promise.resolve(),g?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve()]);break}}async log(){const $=this.P(-1)?.items??new Map,h=this.P(0)?.items??new Map,g=this.P(1)?.items??new Map;return c($,h,g,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize($){return await this.flush(),this.P($)?.optimize()}async switch($,h){return this.w(y.NONE),(0,a.$fl)($)?this.R($,h):this.S($,h)}M($,h){return!($.id===h.id||k(h)&&k($))}N($,h,g){this.y(()=>{const i=new Set;for(const[r,t]of $)i.add(r),h.get(r)!==t&&this.u(g,{key:r,external:!0});for(const[r]of h.items)i.has(r)||this.u(g,{key:r,external:!0})})}}e.$Lp=w;function k(p){return p.isDefault||!!p.useDefaultFlags?.globalState}e.$Mp=k;class b extends w{constructor(){super(),this.U=this.B(new P.$Fp(new P.$Gp,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new P.$Fp(new P.$Gp,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new P.$Fp(new P.$Gp,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage($=>this.u(1,$))),this.B(this.W.onDidChangeStorage($=>this.u(0,$))),this.B(this.U.onDidChangeStorage($=>this.u(-1,$)))}P($){switch($){case-1:return this.U;case 0:return this.W;default:return this.X}}Q($){switch($){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope($){return!1}}e.$Np=b;async function c(p,$,h,g,i,r){const t=q=>{try{return JSON.parse(q)}catch{return q}},n=new Map,s=new Map;p.forEach((q,Y)=>{n.set(Y,q),s.set(Y,t(q))});const o=new Map,l=new Map;$.forEach((q,Y)=>{o.set(Y,q),l.set(Y,t(q))});const O=new Map,I=new Map;h.forEach((q,Y)=>{O.set(Y,q),I.set(Y,t(q))}),console.group(g!==i?`Storage: Application (path: ${g})`:`Storage: Application & Profile (path: ${g}, default profile)`);const v=[];if(n.forEach((q,Y)=>{v.push({key:Y,value:q})}),console.table(v),console.groupEnd(),console.log(s),g!==i){console.group(`Storage: Profile (path: ${i}, profile specific)`);const q=[];o.forEach((Y,Z)=>{q.push({key:Z,value:Y})}),console.table(q),console.groupEnd(),console.log(l)}console.group(`Storage: Workspace (path: ${r})`);const j=[];O.forEach((q,Y)=>{j.push({key:Y,value:q})}),console.table(j),console.groupEnd(),console.log(I)}e.$Op=c}),define(ie[163],ne([0,1,19,20,7,12,35,3,11,29,18,21,26,50,13,4,32,45,146,162,25,176]),function(J,e,N,D,R,L,A,P,u,a,y,E,d,m,w,k,b,c,p,$,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tp=e.$Sp=e.$Rp=void 0;const i=L.$o?"web":(0,E.$Ko)(L.$u,A.$ec),r="X-Market-Search-Activity-Id";var t;(function(S){S[S.None=0]="None",S[S.IncludeVersions=1]="IncludeVersions",S[S.IncludeFiles=2]="IncludeFiles",S[S.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",S[S.IncludeSharedAccounts=8]="IncludeSharedAccounts",S[S.IncludeVersionProperties=16]="IncludeVersionProperties",S[S.ExcludeNonValidated=32]="ExcludeNonValidated",S[S.IncludeInstallationTargets=64]="IncludeInstallationTargets",S[S.IncludeAssetUri=128]="IncludeAssetUri",S[S.IncludeStatistics=256]="IncludeStatistics",S[S.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",S[S.Unpublished=4096]="Unpublished",S[S.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(t||(t={}));function n(...S){return String(S.reduce((T,F)=>T|F,0))}var s;(function(S){S[S.Tag=1]="Tag",S[S.ExtensionId=4]="ExtensionId",S[S.Category=5]="Category",S[S.ExtensionName=7]="ExtensionName",S[S.Target=8]="Target",S[S.Featured=9]="Featured",S[S.SearchText=10]="SearchText",S[S.ExcludeWithFlags=12]="ExcludeWithFlags"})(s||(s={}));const o={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},l={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink",SupportLink:"Microsoft.VisualStudio.Services.Links.Support"},I={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:t.None,criteria:[],assetTypes:[]};class v{constructor(T=I){this.d=T}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(T,F=this.d.pageSize){return new v({...this.d,pageNumber:T,pageSize:F})}withFilter(T,...F){const W=[...this.d.criteria,...F.length?F.map(G=>({filterType:T,value:G})):[{filterType:T}]];return new v({...this.d,criteria:W})}withSortBy(T){return new v({...this.d,sortBy:T})}withSortOrder(T){return new v({...this.d,sortOrder:T})}withFlags(...T){return new v({...this.d,flags:T.reduce((F,W)=>F|W,0)})}withAssetTypes(...T){return new v({...this.d,assetTypes:T})}withSource(T){return new v({...this.d,source:T})}get raw(){const{criteria:T,pageNumber:F,pageSize:W,sortBy:G,sortOrder:te,flags:ce,assetTypes:le}=this.d;return{filters:[{criteria:T,pageNumber:F,pageSize:W,sortBy:G,sortOrder:te}],assetTypes:le,flags:ce}}get searchText(){const T=this.d.criteria.filter(F=>F.filterType===s.SearchText)[0];return T&&T.value?T.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(T=>String(T.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function j(S,T){const F=(S||[]).filter(W=>W.statisticName===T)[0];return F?F.value:0}function q(S){const T="Microsoft.VisualStudio.Code.Translation.";return S.files.filter(W=>W.assetType.indexOf(T)===0).reduce((W,G)=>{const te=oe(S,G.assetType);return te&&W.push([G.assetType.substring(T.length),te]),W},[])}function Y(S){if(S.properties){const T=S.properties.filter(G=>G.key===o.Repository),F=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),W=T.filter(G=>F.test(G.value))[0];return W?{uri:W.value,fallbackUri:W.value}:null}return oe(S,o.Repository)}function Z(S){return{uri:`${S.fallbackAssetUri}/${o.VSIX}?redirect=true${S.targetPlatform?`&targetPlatform=${S.targetPlatform}`:""}`,fallbackUri:`${S.fallbackAssetUri}/${o.VSIX}${S.targetPlatform?`?targetPlatform=${S.targetPlatform}`:""}`}}function oe(S,T){return S.files.filter(W=>W.assetType===T)[0]?{uri:`${S.assetUri}/${T}${S.targetPlatform?`?targetPlatform=${S.targetPlatform}`:""}`,fallbackUri:`${S.fallbackAssetUri}/${T}${S.targetPlatform?`?targetPlatform=${S.targetPlatform}`:""}`}:null}function re(S,T){const F=S.properties?S.properties.filter(G=>G.key===T):[],W=F.length>0&&F[0].value;return W?W.split(",").map(G=>(0,d.$hp)(G)):[]}function ue(S){const T=S.properties?S.properties.filter(F=>F.key===l.Engine):[];return T.length>0&&T[0].value||""}function fe(S){const T=S.properties?S.properties.filter(F=>F.key===l.PreRelease):[];return T.length>0&&T[0].value==="true"}function ae(S){const T=S.properties?S.properties.filter(W=>W.key===l.LocalizedLanguages):[],F=T.length>0&&T[0].value||"";return F?F.split(","):[]}function B(S){return S.properties?.find(T=>T.key===l.SponsorLink)?.value}function X(S){return S.properties?.find(T=>T.key===l.SupportLink)?.value}function U(S){return S.indexOf("preview")!==-1}function M(S){return S.targetPlatform?(0,E.$Jo)(S.targetPlatform):"undefined"}function H(S){const T=(0,N.$Mb)(S.versions.map(M)),F=!!S.tags?.includes(E.$Eo),W=T.indexOf("web");return F?W===-1&&T.push("web"):W!==-1&&T.splice(W,1),T}function K(S,T){for(let F=0;F<S.length;F++){const W=S[F];if(W.version===S[F-1]?.version){let G=F;if(M(W)===T)for(;G>0&&S[G-1].version===W.version;)G--;G!==F&&(S.splice(F,1),S.splice(G,0,W))}}return S}e.$Rp=K;function Q(S,T,F){S.telemetryData={index:T,querySource:F,queryActivityId:S.queryContext?.[r]}}function ee(S,T,F,W){const G=S.versions[0],te={manifest:oe(T,o.Manifest),readme:oe(T,o.Details),changelog:oe(T,o.Changelog),license:oe(T,o.License),repository:Y(T),download:Z(T),icon:oe(T,o.Icon),signature:oe(T,o.Signature),coreTranslations:q(T)};return{identifier:{id:(0,d.$ip)(S.publisher.publisherName,S.extensionName),uuid:S.extensionId},name:S.extensionName,version:T.version,displayName:S.displayName,publisherId:S.publisher.publisherId,publisher:S.publisher.publisherName,publisherDisplayName:S.publisher.displayName,publisherDomain:S.publisher.domain?{link:S.publisher.domain,verified:!!S.publisher.isDomainVerified}:void 0,publisherSponsorLink:B(G),description:S.shortDescription??"",installCount:j(S.statistics,"install"),rating:j(S.statistics,"averagerating"),ratingCount:j(S.statistics,"ratingcount"),categories:S.categories||[],tags:S.tags||[],releaseDate:Date.parse(S.releaseDate),lastUpdated:Date.parse(S.lastUpdated),allTargetPlatforms:F,assets:te,properties:{dependencies:re(T,l.Dependency),extensionPack:re(T,l.ExtensionPack),engine:ue(T),localizedLanguages:ae(T),targetPlatform:M(T),isPreReleaseVersion:fe(T)},hasPreReleaseVersion:fe(G),hasReleaseVersion:!0,preview:U(S.flags),isSigned:!!te.signature,queryContext:W,supportLink:X(G)}}let C=class{constructor(T,F,W,G,te,ce,le,$e){this.k=F,this.l=W,this.n=G,this.o=te,this.q=ce,this.u=le,this.w=$e;const ye=le.extensionsGallery,he=ye?.servicePPEUrl&&$e.getValue("_extensionsGallery.enablePPE");this.d=he?ye.servicePPEUrl:ye?.serviceUrl,this.g=he?void 0:ye?.searchUrl,this.h=ye?.controlUrl,this.j=(0,p.$Qp)(le.version,le,this.n,this.w,this.q,T,this.o)}x(T=""){return`${this.d}${T}`}isEnabled(){return!!this.d}async getExtensions(T,F,W){const G=D.CancellationToken.isCancellationToken(F)?{}:F,te=D.CancellationToken.isCancellationToken(F)?F:W,ce=[],le=[],$e=[],ye=[];let he=!0;for(const we of T){we.uuid?le.push(we.uuid):ce.push(we.id);const Ee=!!(we.version||we.preRelease);$e.push({id:we.id,uuid:we.uuid,includePreRelease:Ee}),we.version&&ye.push({id:we.id,uuid:we.uuid,version:we.version}),he=he&&!!we.hasPreRelease&&!Ee}if(!le.length&&!ce.length)return[];let me=new v().withPage(1,T.length);le.length&&(me=me.withFilter(s.ExtensionId,...le)),ce.length&&(me=me.withFilter(s.ExtensionName,...ce)),(G.queryAllVersions||he)&&(me=me.withFlags(me.flags,t.IncludeVersions)),G.source&&(me=me.withSource(G.source));const{extensions:de}=await this.z(me,{targetPlatform:G.targetPlatform??i,includePreRelease:$e,versions:ye,compatible:!!G.compatible},te);return G.source&&de.forEach((we,Ee)=>Q(we,Ee,G.source)),de}async getCompatibleExtension(T,F,W){if((0,E.$Lo)(T.allTargetPlatforms,W))return null;if(await this.isExtensionCompatible(T,F,W))return T;const G=new v().withFlags(t.IncludeVersions).withPage(1,1).withFilter(s.ExtensionId,T.identifier.uuid),{extensions:te}=await this.z(G,{targetPlatform:W,compatible:!0,includePreRelease:F},D.CancellationToken.None);return te[0]||null}async isExtensionCompatible(T,F,W){if(!(0,E.$Mo)(T.properties.targetPlatform,T.allTargetPlatforms,W)||!F&&T.properties.isPreReleaseVersion)return!1;let G=T.properties.engine;if(!G){const te=await this.getManifest(T,D.CancellationToken.None);if(!te)throw new Error("Manifest was not found");G=te.engines.vscode}return(0,m.$vp)(G,this.u.version,this.u.date)}async y(T,F,W,G,te){if(!(0,E.$Mo)(M(T),G,te)||F!=="any"&&fe(T)!==(F==="prerelease"))return!1;if(W)try{const ce=await this.E(T);if(!(0,m.$vp)(ce,this.u.version,this.u.date))return!1}catch(ce){return this.l.error(`Error while getting the engine for the version ${T.version}.`,(0,R.$0)(ce)),!1}return!0}async query(T,F){let W=T.text||"";const G=T.pageSize??50;let te=new v().withPage(1,G);W?(W=W.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(he,me,de)=>(te=te.withFilter(s.Category,de||me),"")),W=W.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(he,me,de)=>(te=te.withFilter(s.Tag,de||me),"")),W=W.replace(/\bfeatured(\s+|\b|$)/g,()=>(te=te.withFilter(s.Featured),"")),W=W.trim(),W&&(W=W.length<200?W:W.substring(0,200),te=te.withFilter(s.SearchText,W)),te=te.withSortBy(0)):T.ids?te=te.withFilter(s.ExtensionId,...T.ids):T.names?te=te.withFilter(s.ExtensionName,...T.names):te=te.withSortBy(4),typeof T.sortBy=="number"&&(te=te.withSortBy(T.sortBy)),typeof T.sortOrder=="number"&&(te=te.withSortOrder(T.sortOrder)),T.source&&(te=te.withSource(T.source));const ce=async(he,me)=>{const{extensions:de,total:we}=await this.z(he,{targetPlatform:i,compatible:!1,includePreRelease:!!T.includePreRelease},me);return de.forEach((Ee,ke)=>Q(Ee,(he.pageNumber-1)*he.pageSize+ke,T.source)),{extensions:de,total:we}},{extensions:le,total:$e}=await ce(te,F),ye=async(he,me)=>{if(me.isCancellationRequested)throw new R.$5;const{extensions:de}=await ce(te.withPage(he+1),me);return de};return{firstPage:le,total:$e,pageSize:te.pageSize,getPage:ye}}async z(T,F,W){const G=T.flags;T.flags&t.IncludeLatestVersionOnly&&T.flags&t.IncludeVersions&&(T=T.withFlags(T.flags&~t.IncludeVersions,t.IncludeLatestVersionOnly)),!(T.flags&t.IncludeLatestVersionOnly)&&!(T.flags&t.IncludeVersions)&&(T=T.withFlags(T.flags,t.IncludeLatestVersionOnly)),F.versions?.length&&(T=T.withFlags(T.flags&~t.IncludeLatestVersionOnly,t.IncludeVersions)),T=T.withFlags(T.flags,t.IncludeAssetUri,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeStatistics,t.IncludeVersionProperties);const{galleryExtensions:te,total:ce,context:le}=await this.B(T,W);if(!(T.flags&t.IncludeLatestVersionOnly)){const me=[];for(const de of te){const we=await this.A(de,F,le);we&&me.push(we)}return{extensions:me,total:ce}}const ye=[],he=new Map;for(let me=0;me<te.length;me++){const de=te[me],we={id:(0,d.$ip)(de.publisher.publisherName,de.extensionName),uuid:de.extensionId},Ee=(0,P.$Zf)(F.includePreRelease)?F.includePreRelease:!!F.includePreRelease.find(V=>(0,d.$dp)(V,we))?.includePreRelease;if(F.compatible&&(0,E.$Lo)(H(de),F.targetPlatform))continue;const ke=await this.A(de,F,le);!ke||ke.properties.isPreReleaseVersion&&(!Ee||!ke.hasReleaseVersion)||!ke.properties.isPreReleaseVersion&&ke.properties.targetPlatform!==F.targetPlatform&&ke.hasPreReleaseVersion?he.set(de.extensionId,me):ye.push([me,ke])}if(he.size){const me=new g.$2d,de=new v().withFlags(G&~t.IncludeLatestVersionOnly,t.IncludeVersions).withPage(1,he.size).withFilter(s.ExtensionId,...he.keys()),{extensions:we}=await this.z(de,F,W);this.o.publicLog2("galleryService:additionalQuery",{duration:me.elapsed(),count:he.size});for(const Ee of we){const ke=he.get(Ee.identifier.uuid);ye.push([ke,Ee])}}return{extensions:ye.sort((me,de)=>me[0]-de[0]).map(([,me])=>me),total:ce}}async A(T,F,W){const G={id:(0,d.$ip)(T.publisher.publisherName,T.extensionName),uuid:T.extensionId},te=F.versions?.find(ye=>(0,d.$dp)(ye,G))?.version,ce=(0,P.$Zf)(F.includePreRelease)?F.includePreRelease:!!F.includePreRelease.find(ye=>(0,d.$dp)(ye,G))?.includePreRelease,le=H(T),$e=K(T.versions,F.targetPlatform);if(F.compatible&&(0,E.$Lo)(le,F.targetPlatform))return null;for(let ye=0;ye<$e.length;ye++){const he=$e[ye];if(!(te&&he.version!==te)){if(await this.y(he,ce?"any":"release",F.compatible,le,F.targetPlatform))return ee(T,he,le,W);if(te&&he.version===te)return null}}return te||F.compatible?null:ee(T,T.versions[0],le)}async B(T,F){if(!this.isEnabled())throw new Error("No extension gallery service configured.");T=T.withFlags(T.flags,t.ExcludeNonValidated).withFilter(s.Target,"Microsoft.VisualStudio.Code").withFilter(s.ExcludeWithFlags,n(t.Unpublished));const W=await this.j,G=JSON.stringify(T.raw),te={...W,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(G.length)},ce=new g.$2d;let le,$e,ye=0;try{if(le=await this.k.request({type:"POST",url:this.g&&T.criteria.some(me=>me.filterType===s.SearchText)?this.g:this.x("/extensionquery"),data:G,headers:te},F),le.res.statusCode&&le.res.statusCode>=400&&le.res.statusCode<500)return{galleryExtensions:[],total:ye};const he=await(0,c.$Cp)(le);if(he){const me=he.results[0],de=me.extensions,we=me.resultMetadata&&me.resultMetadata.filter(Ee=>Ee.metadataType==="ResultCount")[0];return ye=we&&we.metadataItems.filter(Ee=>Ee.name==="TotalCount")[0].count||0,{galleryExtensions:de,total:ye,context:{[r]:le.res.headers.activityid}}}return{galleryExtensions:[],total:ye}}catch(he){const me=(0,R.$4)(he)?E.ExtensionGalleryErrorCode.Cancelled:(0,R.$0)(he).startsWith("XHR timeout")?E.ExtensionGalleryErrorCode.Timeout:E.ExtensionGalleryErrorCode.Failed;throw $e=new E.$Qo((0,R.$0)(he),me),$e}finally{this.o.publicLog2("galleryService:query",{...T.telemetryData,requestBodySize:String(G.length),duration:ce.elapsed(),success:!!le&&(0,c.$yp)(le),responseBodySize:le?.res.headers["Content-Length"],statusCode:le?String(le.res.statusCode):void 0,errorCode:$e?.code,count:String(ye)})}}async reportStatistic(T,F,W,G){if(!this.isEnabled())return;const te=L.$o?this.x(`/itemName/${T}.${F}/version/${W}/statType/${G==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${T}/extensions/${F}/${W}/stats?statType=${G}`),ce=L.$o?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",$e={...await this.j,Accept:ce};try{await this.k.request({type:"POST",url:te,headers:$e},D.CancellationToken.None)}catch{}}async download(T,F,W){this.l.trace("ExtensionGalleryService#download",T.identifier.id);const G=(0,d.$lp)(T),te=new Date().getTime(),ce=me=>this.o.publicLog("galleryService:downloadVSIX",{...G,duration:me}),le=W===2?"install":W===3?"update":"",$e=le?{uri:`${T.assets.download.uri}${u.URI.parse(T.assets.download.uri).query?"&":"?"}${le}=true`,fallbackUri:`${T.assets.download.fallbackUri}${u.URI.parse(T.assets.download.fallbackUri).query?"&":"?"}${le}=true`}:T.assets.download,ye=T.queryContext?.[r]?{[r]:T.queryContext[r]}:void 0,he=await this.D($e,ye?{headers:ye}:void 0);await this.q.writeFile(F,he.stream),ce(new Date().getTime()-te)}async downloadSignatureArchive(T,F){if(!T.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",T.identifier.id);const W=await this.D(T.assets.signature);await this.q.writeFile(F,W.stream)}async getReadme(T,F){if(T.assets.readme){const W=await this.D(T.assets.readme,{},F);return await(0,c.$Bp)(W)||""}return""}async getManifest(T,F){if(T.assets.manifest){const W=await this.D(T.assets.manifest,{},F),G=await(0,c.$Bp)(W);return G?JSON.parse(G):null}return null}async C(T,F){const W=oe(T,o.Manifest);if(!W)throw new Error("Manifest was not found");const G={"Accept-Encoding":"gzip"},te=await this.D(W,{headers:G});return await(0,c.$Cp)(te)}async getCoreTranslation(T,F){const W=T.assets.coreTranslations.filter(G=>G[0]===F.toUpperCase())[0];if(W){const G=await this.D(W[1]),te=await(0,c.$Bp)(G);return te?JSON.parse(te):null}return null}async getChangelog(T,F){if(T.assets.changelog){const W=await this.D(T.assets.changelog,{},F);return await(0,c.$Bp)(W)||""}return""}async getAllCompatibleVersions(T,F,W){let G=new v().withFlags(t.IncludeVersions,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeVersionProperties).withPage(1,1);T.identifier.uuid?G=G.withFilter(s.ExtensionId,T.identifier.uuid):G=G.withFilter(s.ExtensionName,T.identifier.id);const{galleryExtensions:te}=await this.B(G,D.CancellationToken.None);if(!te.length)return[];const ce=H(te[0]);if((0,E.$Lo)(ce,W))return[];const le=[];await Promise.all(te[0].versions.map(async he=>{try{await this.y(he,F?"any":"release",!0,ce,W)&&le.push(he)}catch{}}));const $e=[],ye=new Set;for(const he of K(le,W))ye.has(he.version)||(ye.add(he.version),$e.push({version:he.version,date:he.lastUpdated,isPreReleaseVersion:fe(he)}));return $e}async D(T,F={},W=D.CancellationToken.None){const G=await this.j,te={type:"GET"},ce={...G,...F.headers||{}};F={...F,...te,headers:ce};const le=T.uri,$e=T.fallbackUri,ye={...F,url:le};try{const he=await this.k.request(ye,W);if(he.res.statusCode===200)return he;const me=await(0,c.$Bp)(he);throw new Error(`Expected 200, got back ${he.res.statusCode} instead.

${me}`)}catch(he){if((0,R.$4)(he))throw he;const me=(0,R.$0)(he);this.o.publicLog2("galleryService:cdnFallback",{url:le,message:me});const de={...F,url:$e};return this.k.request(de,W)}}async E(T){let F=ue(T);if(!F){const W=await this.C(T,D.CancellationToken.None);if(!W)throw new Error("Manifest was not found");F=W.engines.vscode}return F}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const T=await this.k.request({type:"GET",url:this.h},D.CancellationToken.None);if(T.res.statusCode!==200)throw new Error("Could not get extensions report.");const F=await(0,c.$Cp)(T),W=[],G={},te=[];if(F){for(const ce of F.malicious)W.push({id:ce});if(F.migrateToPreRelease)for(const[ce,le]of Object.entries(F.migrateToPreRelease))(!le.engine||(0,m.$vp)(le.engine,this.u.version,this.u.date))&&(G[ce.toLowerCase()]={disallowInstall:!0,extension:{id:le.id,displayName:le.displayName,autoMigrate:{storage:!!le.migrateStorage},preRelease:!0}});if(F.deprecated)for(const[ce,le]of Object.entries(F.deprecated))le&&(G[ce.toLowerCase()]=(0,P.$Zf)(le)?{}:le);if(F.search)for(const ce of F.search)te.push(ce)}return{malicious:W,deprecated:G,search:te}}};C=pe([se(1,c.$wp),se(2,k.$Aj),se(3,y.$ni),se(4,h.$Fl),se(5,w.$Gk),se(6,b.$Sj),se(7,a.$Mi)],C);let z=class extends C{constructor(T,F,W,G,te,ce,le,$e){super(T,F,W,G,te,ce,le,$e)}};e.$Sp=z,e.$Sp=z=pe([se(0,$.$Jp),se(1,c.$wp),se(2,k.$Aj),se(3,y.$ni),se(4,h.$Fl),se(5,w.$Gk),se(6,b.$Sj),se(7,a.$Mi)],z);let f=class extends C{constructor(T,F,W,G,te,ce,le){super(void 0,T,F,W,G,te,ce,le)}};e.$Tp=f,e.$Tp=f=pe([se(0,c.$wp),se(1,k.$Aj),se(2,y.$ni),se(3,h.$Fl),se(4,w.$Gk),se(5,b.$Sj),se(6,a.$Mi)],f)}),define(ie[164],ne([0,1,11,18,13,4,142,22,23,3,68]),function(J,e,N,D,R,L,A,P,u,a,y){"use strict";var E,d;Object.defineProperty(e,"__esModule",{value:!0}),e.$NP=e.$MP=e.$LP=void 0;let m=class extends u.$jl{static{E=this}static{this.a="profileAssociationsMigration"}constructor(c,p,$,h,g){super($,h,p,g),this.U=c,this.W=$}O(){return this.U.getItem(E.b,[]).map(p=>({...p,location:(0,a.$Tf)(p.location)?this.w.extUri.joinPath(this.profilesHome,p.location):N.URI.revive(p.location)}))}Q(){const c=this.U.getItem(E.c,{});return this.U.getItem(E.a,!1)?c:this.N(c)}S(){return this.w.extUri.joinPath(N.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$LP=m,e.$LP=m=E=pe([se(0,A.$GP),se(1,P.$el),se(2,D.$oi),se(3,R.$Gk),se(4,L.$Aj)],m);let w=d=class extends m{constructor(c,p,$,h,g){super(c,p,$,h,g),this.$=c}P(c){c.length?this.$.setItem(d.b,c.map(p=>({...p,location:this.w.extUri.basename(p.location)}))):this.$.removeItem(d.b)}O(){const c=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P(c),this.$.setItem("userDataProfilesMigration",!0)),c}R(c){c.emptyWindows||c.workspaces?this.$.setItem(d.c,c):this.$.removeItem(d.c)}Q(){const c="workspaceAndProfileInfo",p=this.$.getItem(c,void 0);if(p){this.$.removeItem(c);const h=p.reduce((g,{workspace:i,profile:r})=>(g[N.URI.revive(i).toString()]=N.URI.revive(r).toString(),g),{});this.$.setItem(d.c,{workspaces:h})}const $=super.Q();return this.$.getItem(d.a,!1)||(this.R($),this.$.setItem(d.a,!0)),$}};e.$MP=w,e.$MP=w=d=pe([se(0,A.$HP),se(1,P.$el),se(2,D.$oi),se(3,R.$Gk),se(4,L.$Aj)],w);let k=class extends w{constructor(c,p,$,h){super(new y.$KP(0,p,h,$),c,p,$,h)}async init(){return await this.$.init(),super.init()}};e.$NP=k,e.$NP=k=pe([se(0,P.$el),se(1,D.$oi),se(2,R.$Gk),se(3,L.$Aj)],k)}),define(ie[165],ne([0,1,140,9,14,7,3,29,18,141,4,45,139,177]),function(J,e,N,D,R,L,A,P,u,a,y,E,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dr=e.$Cr=void 0;let w=class extends E.$xp{constructor(p,$,h,g){super(g),this.m=p,this.n=$,this.r=h,this.s(),this.B(p.onDidChangeConfiguration(i=>{i.affectsConfiguration("http")&&this.s()}))}s(){const p=this.m.getValue("http");this.f=p?.proxy,this.g=!!p?.proxyStrictSSL,this.h=p?.proxyAuthorization}async request(p,$){const{f:h,g}=this;let i;try{i=await(0,a.$km)(this.m,this.r,this.n.args,process.env)}catch(n){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,L.$0)(n)))}const r={...process.env,...i},t=p.agent?p.agent:await(0,d.$Br)(p.url||"",r,{proxyUrl:h,strictSSL:g});return p.agent=t,p.strictSSL=g,this.h&&(p.headers={...p.headers||{},"Proxy-Authorization":this.h}),this.c(p.isChromiumNetwork?"electron":"node",p,()=>b(p,$))}async resolveProxy(p){}async loadCertificates(){return(await new Promise(($,h)=>{J(["@vscode/proxy-agent"],$,h)})).loadSystemCertificates({log:this.r})}};e.$Cr=w,e.$Cr=w=pe([se(0,P.$Mi),se(1,u.$oi),se(2,y.$Aj),se(3,y.$Bj)],w);async function k(c){return((0,N.parse)(c.url).protocol==="https:"?await new Promise((h,g)=>{J(["https"],h,g)}):await new Promise((h,g)=>{J(["http"],h,g)})).request}async function b(c,p){return D.Promises.withAsyncBody(async($,h)=>{const g=(0,N.parse)(c.url),i=c.getRawRequest?c.getRawRequest(c):await k(c),r={hostname:g.hostname,port:g.port?parseInt(g.port):g.protocol==="https:"?443:80,protocol:g.protocol,path:g.path,method:c.type||"GET",headers:c.headers,agent:c.agent,rejectUnauthorized:(0,A.$Zf)(c.strictSSL)?c.strictSSL:!0};c.user&&c.password&&(r.auth=c.user+":"+c.password);const t=i(r,n=>{const s=(0,A.$Xf)(c.followRedirects)?c.followRedirects:3;if(n.statusCode&&n.statusCode>=300&&n.statusCode<400&&s>0&&n.headers.location)b({...c,url:n.headers.location,followRedirects:s-1},p).then($,h);else{let o=n;!c.isChromiumNetwork&&n.headers["content-encoding"]==="gzip"&&(o=n.pipe((0,m.createGunzip)())),$({res:n,stream:(0,R.$Ie)(o)})}});t.on("error",h),c.timeout&&t.setTimeout(c.timeout),c.isChromiumNetwork&&t.removeHeader("Content-Length"),c.data&&typeof c.data=="string"&&t.write(c.data),t.end(),p.onCancellationRequested(()=>{t.abort(),h(new L.$5)})})}e.$Dr=b}),define(ie[178],ne([0,1,33,9,34,7,2,15,16,12,35,11,24,29,136,59,138,18,114,163,21,64,143,42,52,159,161,13,126,128,51,124,62,63,147,4,132,39,133,150,32,45,165,68,69,25,149,41,151,152,22,154,23,164,153,160,129,131,5,155,179]),function(J,e,N,D,R,L,A,P,u,a,y,E,d,m,w,k,b,c,p,$,h,g,i,r,t,n,s,o,l,O,I,v,j,q,Y,Z,oe,re,ue,fe,ae,B,X,U,M,H,K,Q,ee,C,z,f,S,T,F,W,G,te,ce,le,$e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class ye extends A.$Tc{constructor(de){super(),this.b=de,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const[de,we]=await this.f();return de.invokeFunction(async Ee=>{const ke=Ee.get(Z.$Aj),V=Ee.get(o.$Gk),x=Ee.get(c.$oi),_=Ee.get(S.$gl);ke.info("CLI main",this.b),this.h(ke),await this.j(x,V,_,de),await Promise.all(we.map(ge=>{(0,D.$0g)(ge.flush(),1e3)}))})}async f(){const de=new j.$ei,we={_serviceBrand:void 0,...fe.default};de.set(ae.$Sj,we);const Ee=new p.$Rm(this.b,we);de.set(c.$oi,Ee),await Promise.all([this.g(Ee.appSettingsHome.with({scheme:P.Schemas.file}).fsPath),this.g(Ee.extensionsPath)].map(be=>be?d.Promises.mkdir(be,{recursive:!0}):void 0));const ke=new te.$FP((0,Z.$Oj)(Ee),Ee.logsHome);de.set(Z.$Bj,ke);const V=this.B(ke.createLogger("cli",{name:(0,ce.localize)(0,null)})),x=[];ke.getLogLevel()===Z.LogLevel.Trace&&x.push(new Z.$Ij(ke.getLogLevel()));const _=this.B(new G.$PP(V,x));de.set(Z.$Aj,_);const ge=this.B(new l.$rq(_));de.set(o.$Gk,ge);const ve=this.B(new O.$Qq(_));ge.registerProvider(P.Schemas.file,ve);const De=new f.$es(ge);de.set(z.$el,De);const Se=new U.$JP(1,Ee,_,ge),Le=new T.$LP(Se,De,Ee,ge,_);de.set(S.$gl,Le),ge.registerProvider(P.Schemas.vscodeUserData,new le.$2ac(P.Schemas.file,ve,P.Schemas.vscodeUserData,Le,De,_));const Oe=a.$i&&we.win32RegValueName?this.B(new ue.$Zac(_,we.win32RegValueName)):Ee.policyFile?this.B(new oe.$1ac(Ee.policyFile,ge,_)):new re.$2n;de.set(re.$Zn,Oe);const Ae=this.B(new w.$po(Le.defaultProfile.settingsResource,ge,Oe,_));de.set(m.$Mi,Ae),await Promise.all([Se.init(),Ae.initialize()]);let Fe;try{Fe=await(0,F.$Dac)(Se,_)}catch(be){be.code!=="ENOENT"&&_.error(be)}const je=await(0,F.$Eac)(Se,_);Le.init(),de.set(z.$el,new f.$es(ge));const Ne=new X.$Cr(Ae,Ee,_,ke);de.set(B.$wp,Ne),de.set(k.$to,new I.$di(b.$5P,void 0,!0)),de.set(r.$$p,new I.$di(W.$OP,void 0,!0)),de.set(t.$cq,new I.$di(s.$Aac,void 0,!0)),de.set(g.$Up,new I.$di(g.$Vp,void 0,!0)),de.set(n.$mq,new I.$di(n.$nq,void 0,!0)),de.set(h.$Oo,new I.$di($.$Tp,void 0,!0)),de.set(q.$wr,new I.$di(Y.$yr,void 0,!1));const Te=[],Ce=(0,Q.$ap)(we,Ae);if((0,Q.$8o)(we,Ee)){we.aiConfig&&we.aiConfig.ariaKey&&Te.push(new ee.$DP(Ne,Ce,"monacoworkbench",null,we.aiConfig.ariaKey));const be={appenders:Te,sendErrorTelemetry:!1,commonProperties:(0,M.$Yo)((0,N.release)(),(0,N.hostname)(),process.arch,we.commit,we.version,Fe,je,Ce),piiPaths:(0,Q.$bp)(Ee)};de.set(H.$Fl,new I.$di(K.$Er,[be],!1))}else de.set(H.$Fl,Q.$3o);return[new v.$Tq(de),Te]}g(de){if(a.$i){const we=(0,$e.getUNCHost)(de);we&&(0,$e.addUNCHostToAllowlist)(we)}return de}h(de){(0,L.setUnexpectedErrorHandler)(we=>{const Ee=(0,R.$4i)(we,!0);Ee&&de.error(`[uncaught exception in CLI]: ${Ee}`)}),process.on("uncaughtException",we=>{(0,L.$Z)(we)||(0,L.$1)(we)}),process.on("unhandledRejection",we=>(0,L.$1)(we))}async j(de,we,Ee,ke){let V;if(de.args.profile&&(V=Ee.profiles.find(_=>_.name===de.args.profile),!V))throw new Error(`Profile '${de.args.profile}' not found.`);const x=(V??Ee.defaultProfile).extensionsResource;if(this.b["list-extensions"])return ke.createInstance(i.$Wp,new Z.$Ij(Z.LogLevel.Info,!1)).listExtensions(!!this.b["show-versions"],this.b.category,x);if(this.b["install-extension"]||this.b["install-builtin-extension"]){const _={isMachineScoped:!!this.b["do-not-sync"],installPreReleaseVersion:!!this.b["pre-release"],profileLocation:x};return ke.createInstance(i.$Wp,new Z.$Ij(Z.LogLevel.Info,!1)).installExtensions(this.m(this.b["install-extension"]||[]),this.m(this.b["install-builtin-extension"]||[]),_,!!this.b.force)}else{if(this.b["uninstall-extension"])return ke.createInstance(i.$Wp,new Z.$Ij(Z.LogLevel.Info,!1)).uninstallExtensions(this.m(this.b["uninstall-extension"]),!!this.b.force,x);if(this.b["update-extensions"])return ke.createInstance(i.$Wp,new Z.$Ij(Z.LogLevel.Info,!1)).updateExtensions(x);if(this.b["locate-extension"])return ke.createInstance(i.$Wp,new Z.$Ij(Z.LogLevel.Info,!1)).locateExtension(this.b["locate-extension"]);this.b.telemetry&&console.log(await(0,C.$nbc)(de.appRoot,de.extensionsPath))}}m(de){return de.map(we=>/\.vsix$/i.test(we)?E.URI.file((0,u.$ic)(we)?we:(0,u.$jc)((0,y.cwd)(),we)):we)}}async function he(me){const de=new ye(me);try{await de.run()}finally{de.dispose()}}e.main=he})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/d73fa8b14a6c873958d00a7d7ad13fcb540a052c/core/vs/code/node/cliProcessMain.js.map
