/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var le=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/platform","vs/base/common/async","vs/base/common/errors","vs/platform/log/common/log","vs/nls!vs/code/node/sharedProcess/sharedProcessMain","vs/base/common/uri","vs/platform/files/common/files","vs/base/common/types","vs/nls","vs/base/common/buffer","vs/base/common/path","vs/platform/environment/common/environment","vs/base/common/arrays","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/base/common/resources","vs/platform/configuration/common/configuration","vs/platform/telemetry/common/telemetry","vs/base/common/network","vs/platform/product/common/productService","vs/platform/userDataSync/common/userDataSync","vs/base/common/cancellation","vs/base/common/strings","vs/platform/uriIdentity/common/uriIdentity","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/objects","vs/base/node/pfs","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/json","vs/base/common/map","vs/base/common/process","os","vs/base/common/errorMessage","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/jsonFormatter","vs/platform/externalServices/common/serviceMachineId","vs/platform/configuration/common/configurationRegistry","vs/platform/extensions/common/extensions","vs/platform/telemetry/common/telemetryUtils","vs/base/common/stream","vs/base/common/ternarySearchTree","vs/base/common/extpath","fs","vs/platform/files/common/watcher","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/lazy","vs/base/common/hash","vs/base/common/semver/semver","vs/platform/ipc/common/mainProcessService","vs/platform/native/common/native","vs/platform/policy/common/policy","vs/platform/request/common/request","vs/platform/userDataProfile/common/userDataProfileStorageService","vs/base/common/iterator","vs/base/common/jsonEdit","vs/base/common/stopwatch","net","vs/base/common/date","vs/base/common/marshalling","child_process","vs/base/parts/ipc/common/ipc.net","vs/base/parts/storage/common/storage","vs/base/node/zip","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","crypto","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/platform/configuration/common/configurationModels","vs/platform/storage/common/storageIpc","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/content","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/common/decorators","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/severity","vs/base/common/processes","vs/base/common/glob","vs/base/common/uriIpc","vs/base/parts/ipc/node/ipc.cp","vs/platform/contextkey/common/contextkey","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionRecommendations/common/extensionRecommendations","vs/platform/files/common/io","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/base/common/performance","vs/platform/lifecycle/node/sharedProcessLifecycleService","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteHosts","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remoteTunnel/common/remoteTunnel","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataProfilesManifestSync","vs/platform/userDataSync/common/userDataSyncStoreService","vs/base/parts/ipc/node/ipc.net","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/assert","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/node/macAddress","vs/base/node/nodeStreams","vs/base/node/ports","vs/base/parts/sandbox/node/electronTypes","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/desktopEnvironmentInfo","vs/base/common/mime","vs/base/common/console","vs/amdX","vs/base/node/id","vs/base/node/osReleaseInfo","vs/base/node/extpath","vs/base/node/processes","vs/base/node/ps","vs/base/parts/ipc/node/ipc.mp","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/remoteTunnel/common/remoteTunnel","vs/nls!vs/platform/remoteTunnel/node/remoteTunnelService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryLogAppender","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncLog","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/nls!vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionRecommendations/common/extensionRecommendationsIpc","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/code/node/sharedProcess/contrib/localizationsUpdater","vs/code/node/sharedProcess/contrib/logsDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/native/common/nativeHostService","vs/platform/policy/common/policyIpc","vs/code/node/sharedProcess/contrib/codeCacheCleaner","vs/code/node/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/userDataProfilesManifestMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/windows/node/windowTracker","vs/code/node/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/code/node/sharedProcess/contrib/extensions","vs/platform/extensionManagement/node/extensionTipsService","vs/platform/remoteTunnel/node/remoteTunnelService","vs/platform/storage/common/storageService","vs/platform/userDataProfile/common/userDataProfileIpc","vs/platform/userDataProfile/node/userDataProfileStorageService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataSyncLocalStoreService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/node/userDataAutoSyncService","vs/platform/workspaces/node/workspaces","vs/code/node/sharedProcess/contrib/storageDataCleaner","vs/platform/remote/node/nodeSocketFactory","vs/platform/tunnel/node/tunnelService","stream","fs/promises","readline","util","path","graceful-fs","https","zlib","vs/code/node/sharedProcess/sharedProcessMain"],he=function(se){for(var e=[],I=0,L=se.length;I<L;I++)e[I]=le[se[I]];return e};define(le[124],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class I{static get(){const A=new Map,j=new Map,O=new Map,R=new Map;function k(h,f){h.has(f.detail)||h.set(f.detail,-f.timestamp)}function g(h,f){const m=h.get(f.detail);m&&(m>=0||h.set(f.detail,m+f.timestamp))}let C=[];typeof se=="function"&&typeof se.getStats=="function"&&(C=se.getStats().slice(0).sort((h,f)=>h.timestamp-f.timestamp));for(const h of C)switch(h.type){case 10:k(A,h);break;case 11:case 12:g(A,h);break;case 21:k(j,h);break;case 22:g(j,h);break;case 33:k(O,h);break;case 34:g(O,h);break;case 31:k(R,h);break;case 32:g(R,h);break}let S=0;O.forEach(h=>S+=h);function w(h){const f=[];return h.forEach((m,y)=>f.push([y,m])),f}return{amdLoad:w(A),amdInvoke:w(j),nodeRequire:w(O),nodeEval:w(R),nodeRequireTotal:S}}static toMarkdownTable(A,j){let O="";const R=[];return A.forEach((k,g)=>{R[g]=k.length}),j.forEach(k=>{k.forEach((g,C)=>{typeof g>"u"&&(g=k[C]="-");const S=g.toString().length;R[C]=Math.max(S,R[C])})}),A.forEach((k,g)=>{O+=`| ${k+" ".repeat(R[g]-k.toString().length)} `}),O+=`|
`,A.forEach((k,g)=>{O+=`| ${"-".repeat(R[g])} `}),O+=`|
`,j.forEach(k=>{k.forEach((g,C)=>{typeof g<"u"&&(O+=`| ${g+" ".repeat(R[C]-g.toString().length)} `)}),O+=`|
`}),O}}e.$U=I}),define(le[125],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rb=e.$qb=e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=void 0;function I(m,y,l){const d=L(m,y);if(d!==-1)return m[d]}e.$fb=I;function L(m,y,l=m.length-1){for(let d=l;d>=0;d--){const $=m[d];if(y($))return d}return-1}e.$gb=L;function A(m,y){const l=j(m,y);return l===-1?void 0:m[l]}e.$hb=A;function j(m,y,l=0,d=m.length){let $=l,c=d;for(;$<c;){const v=Math.floor(($+c)/2);y(m[v])?$=v+1:c=v}return $-1}e.$ib=j;function O(m,y){const l=R(m,y);return l===m.length?void 0:m[l]}e.$jb=O;function R(m,y,l=0,d=m.length){let $=l,c=d;for(;$<c;){const v=Math.floor(($+c)/2);y(m[v])?c=v:$=v+1}return $}e.$kb=R;function k(m,y,l=0,d=m.length){const $=R(m,y,l,d);return $===m.length?-1:$}e.$lb=k;class g{static{this.assertInvariants=!1}constructor(y){this.e=y,this.c=0}findLastMonotonous(y){if(g.assertInvariants){if(this.d){for(const d of this.e)if(this.d(d)&&!y(d))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=y}const l=j(this.e,y,this.c);return this.c=l+1,l===-1?void 0:this.e[l]}}e.$mb=g;function C(m,y){if(m.length===0)return;let l=m[0];for(let d=1;d<m.length;d++){const $=m[d];y($,l)>0&&(l=$)}return l}e.$nb=C;function S(m,y){if(m.length===0)return;let l=m[0];for(let d=1;d<m.length;d++){const $=m[d];y($,l)>=0&&(l=$)}return l}e.$ob=S;function w(m,y){return C(m,(l,d)=>-y(l,d))}e.$pb=w;function h(m,y){if(m.length===0)return-1;let l=0;for(let d=1;d<m.length;d++){const $=m[d];y($,m[l])>0&&(l=d)}return l}e.$qb=h;function f(m,y){for(const l of m){const d=y(l);if(d!==void 0)return d}}e.$rb=f}),define(le[126],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N=e.$M=e.$L=e.$K=void 0;function I(O,R){const k=Object.create(null);for(const g of O){const C=R(g);let S=k[C];S||(S=k[C]=[]),S.push(g)}return k}e.$K=I;function L(O,R){const k=[],g=[];for(const C of O)R.has(C)||k.push(C);for(const C of R)O.has(C)||g.push(C);return{removed:k,added:g}}e.$L=L;function A(O,R){const k=[],g=[];for(const[C,S]of O)R.has(C)||k.push(S);for(const[C,S]of R)O.has(C)||g.push(S);return{removed:k,added:g}}e.$M=A;function j(O,R){const k=new Set;for(const g of R)O.has(g)&&k.add(g);return k}e.$N=j}),define(le[84],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mh=e.$Lh=e.$Kh=void 0;function I(O){return(R,k,g)=>{let C=null,S=null;if(typeof g.value=="function"?(C="value",S=g.value):typeof g.get=="function"&&(C="get",S=g.get),!S)throw new Error("not supported");g[C]=O(S,k)}}function L(O,R,k){let g=null,C=null;if(typeof k.value=="function"?(g="value",C=k.value,C.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof k.get=="function"&&(g="get",C=k.get),!C)throw new Error("not supported");const S=`$memoize$${R}`;k[g]=function(...w){return this.hasOwnProperty(S)||Object.defineProperty(this,S,{configurable:!1,enumerable:!1,writable:!1,value:C.apply(this,w)}),this[S]}}e.$Kh=L;function A(O,R,k){return I((g,C)=>{const S=`$debounce$${C}`,w=`$debounce$result$${C}`;return function(...h){this[w]||(this[w]=k?k():void 0),clearTimeout(this[S]),R&&(this[w]=R(this[w],...h),h=[this[w]]),this[S]=setTimeout(()=>{g.apply(this,h),this[w]=k?k():void 0},O)}})}e.$Lh=A;function j(O,R,k){return I((g,C)=>{const S=`$throttle$timer$${C}`,w=`$throttle$result$${C}`,h=`$throttle$lastRun$${C}`,f=`$throttle$pending$${C}`;return function(...m){if(this[w]||(this[w]=k?k():void 0),(this[h]===null||this[h]===void 0)&&(this[h]=-Number.MAX_VALUE),R&&(this[w]=R(this[w],...m)),this[f])return;const y=this[h]+O;y<=Date.now()?(this[h]=Date.now(),g.apply(this,[this[w]]),this[w]=k?k():void 0):(this[f]=!0,this[S]=setTimeout(()=>{this[f]=!1,this[h]=Date.now(),g.apply(this,[this[w]]),this[w]=k?k():void 0},y-Date.now()))}})}e.$Mh=j}),define(le[7],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.setUnexpectedErrorHandler=e.$X=e.$W=void 0;class I{constructor(){this.b=[],this.a=function(i){setTimeout(()=>{throw i.stack?$.isErrorNoTelemetry(i)?new $(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.b.push(i),()=>{this.d(i)}}c(i){this.b.forEach(o=>{o(i)})}d(i){this.b.splice(this.b.indexOf(i),1)}setUnexpectedErrorHandler(i){this.a=i}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(i){this.a(i),this.c(i)}onUnexpectedExternalError(i){this.a(i)}}e.$W=I,e.$X=new I;function L(v){e.$X.setUnexpectedErrorHandler(v)}e.setUnexpectedErrorHandler=L;function A(v){if(!v||typeof v!="object")return!1;const i=v;return i.code==="EPIPE"&&i.syscall?.toUpperCase()==="WRITE"}e.$Z=A;function j(v){g(v)||e.$X.onUnexpectedError(v)}e.$1=j;function O(v){g(v)||e.$X.onUnexpectedExternalError(v)}e.$2=O;function R(v){if(v instanceof Error){const{name:i,message:o}=v,n=v.stacktrace||v.stack;return{$isError:!0,name:i,message:o,stack:n,noTelemetry:$.isErrorNoTelemetry(v)}}return v}e.$3=R;const k="Canceled";function g(v){return v instanceof C?!0:v instanceof Error&&v.name===k&&v.message===k}e.$4=g;class C extends Error{constructor(){super(k),this.name=this.message}}e.$5=C;function S(){const v=new Error(k);return v.name=v.message,v}e.$6=S;function w(v){return v?new Error(`Illegal argument: ${v}`):new Error("Illegal argument")}e.$7=w;function h(v){return v?new Error(`Illegal state: ${v}`):new Error("Illegal state")}e.$8=h;class f extends TypeError{constructor(i){super(i?`${i} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=f;function m(v){return v?v.message?v.message:v.stack?v.stack.split(`
`)[0]:String(v):"Error"}e.$0=m;class y extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}e.$$=y;class l extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}e.$_=l;class d extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=d;class $ extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof $)return i;const o=new $;return o.message=i.message,o.stack=i.stack,o}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}e.$bb=$;class c extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,c.prototype)}}e.$cb=c}),define(le[17],he([0,1,7,125]),function(se,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ac=e.$_b=e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=e.CompareResult=e.$6b=e.$5b=e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=e.$Gb=e.top=e.$Eb=e.$Db=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=e.$sb=void 0;function A(q,Y=0){return q[q.length-(1+Y)]}e.$sb=A;function j(q){if(q.length===0)throw new Error("Invalid tail call");return[q.slice(0,q.length-1),q[q.length-1]]}e.$tb=j;function O(q,Y,_=(ie,J)=>ie===J){if(q===Y)return!0;if(!q||!Y||q.length!==Y.length)return!1;for(let ie=0,J=q.length;ie<J;ie++)if(!_(q[ie],Y[ie]))return!1;return!0}e.$ub=O;function R(q,Y){const _=q.length-1;Y<_&&(q[Y]=q[_]),q.pop()}e.$vb=R;function k(q,Y,_){return g(q.length,ie=>_(q[ie],Y))}e.$wb=k;function g(q,Y){let _=0,ie=q-1;for(;_<=ie;){const J=(_+ie)/2|0,ne=Y(J);if(ne<0)_=J+1;else if(ne>0)ie=J-1;else return J}return-(_+1)}e.$xb=g;function C(q,Y,_){if(q=q|0,q>=Y.length)throw new TypeError("invalid index");const ie=Y[Math.floor(Y.length*Math.random())],J=[],ne=[],ce=[];for(const fe of Y){const de=_(fe,ie);de<0?J.push(fe):de>0?ne.push(fe):ce.push(fe)}return q<J.length?C(q,J,_):q<J.length+ce.length?ce[0]:C(q-(J.length+ce.length),ne,_)}e.$yb=C;function S(q,Y){const _=[];let ie;for(const J of q.slice(0).sort(Y))!ie||Y(ie[0],J)!==0?(ie=[J],_.push(ie)):ie.push(J);return _}e.$zb=S;function*w(q,Y){let _,ie;for(const J of q)ie!==void 0&&Y(ie,J)?_.push(J):(_&&(yield _),_=[J]),ie=J;_&&(yield _)}e.$Ab=w;function h(q,Y){for(let _=0;_<=q.length;_++)Y(_===0?void 0:q[_-1],_===q.length?void 0:q[_])}e.$Bb=h;function f(q,Y){for(let _=0;_<q.length;_++)Y(_===0?void 0:q[_-1],q[_],_+1===q.length?void 0:q[_+1])}e.$Cb=f;function m(q,Y,_){const ie=[];function J(fe,de,me){if(de===0&&me.length===0)return;const Ee=ie[ie.length-1];Ee&&Ee.start+Ee.deleteCount===fe?(Ee.deleteCount+=de,Ee.toInsert.push(...me)):ie.push({start:fe,deleteCount:de,toInsert:me})}let ne=0,ce=0;for(;;){if(ne===q.length){J(ne,0,Y.slice(ce));break}if(ce===Y.length){J(ne,q.length-ne,[]);break}const fe=q[ne],de=Y[ce],me=_(fe,de);me===0?(ne+=1,ce+=1):me<0?(J(ne,1,[]),ne+=1):me>0&&(J(ne,0,[de]),ce+=1)}return ie}e.$Db=m;function y(q,Y,_){const ie=m(q,Y,_),J=[],ne=[];for(const ce of ie)J.push(...q.slice(ce.start,ce.start+ce.deleteCount)),ne.push(...ce.toInsert);return{removed:J,added:ne}}e.$Eb=y;function l(q,Y,_){if(_===0)return[];const ie=q.slice(0,_).sort(Y);return $(q,Y,ie,_,q.length),ie}e.top=l;function d(q,Y,_,ie,J){return _===0?Promise.resolve([]):new Promise((ne,ce)=>{(async()=>{const fe=q.length,de=q.slice(0,_).sort(Y);for(let me=_,Ee=Math.min(_+ie,fe);me<fe;me=Ee,Ee=Math.min(Ee+ie,fe)){if(me>_&&await new Promise(Re=>setTimeout(Re)),J&&J.isCancellationRequested)throw new I.$5;$(q,Y,de,me,Ee)}return de})().then(ne,ce)})}e.$Gb=d;function $(q,Y,_,ie,J){for(const ne=_.length;ie<J;ie++){const ce=q[ie];if(Y(ce,_[ne-1])<0){_.pop();const fe=(0,L.$kb)(_,de=>Y(ce,de)<0);_.splice(fe,0,ce)}}}function c(q){return q.filter(Y=>!!Y)}e.$Hb=c;function v(q){let Y=0;for(let _=0;_<q.length;_++)q[_]&&(q[Y]=q[_],Y+=1);q.length=Y}e.$Ib=v;function i(q,Y,_){q.splice(_,0,q.splice(Y,1)[0])}e.$Jb=i;function o(q){return!Array.isArray(q)||q.length===0}e.$Kb=o;function n(q){return Array.isArray(q)&&q.length>0}e.$Lb=n;function s(q,Y=_=>_){const _=new Set;return q.filter(ie=>{const J=Y(ie);return _.has(J)?!1:(_.add(J),!0)})}e.$Mb=s;function t(q){const Y=new Set;return _=>{const ie=q(_);return Y.has(ie)?!1:(Y.add(ie),!0)}}e.$Nb=t;function r(q,Y){return q.length>0?q[0]:Y}e.$Ob=r;function a(q,Y){return q.length>0?q[q.length-1]:Y}e.$Pb=a;function E(q,Y,_=(ie,J)=>ie===J){let ie=0;for(let J=0,ne=Math.min(q.length,Y.length);J<ne&&_(q[J],Y[J]);J++)ie++;return ie}e.$Qb=E;function b(q){return[].concat(...q)}e.$Rb=b;function u(q,Y){let _=typeof Y=="number"?q:0;typeof Y=="number"?_=q:(_=0,Y=q);const ie=[];if(_<=Y)for(let J=_;J<Y;J++)ie.push(J);else for(let J=_;J>Y;J--)ie.push(J);return ie}e.$Sb=u;function p(q,Y,_){return q.reduce((ie,J)=>(ie[Y(J)]=_?_(J):J,ie),Object.create(null))}e.$Tb=p;function P(q,Y){return q.push(Y),()=>N(q,Y)}e.$Ub=P;function N(q,Y){const _=q.indexOf(Y);if(_>-1)return q.splice(_,1),Y}e.$Vb=N;function F(q,Y,_){const ie=q.slice(0,Y),J=q.slice(Y);return ie.concat(_,J)}e.$Wb=F;function M(q,Y){let _;if(typeof Y=="number"){let ie=Y;_=()=>{const J=Math.sin(ie++)*179426549;return J-Math.floor(J)}}else _=Math.random;for(let ie=q.length-1;ie>0;ie-=1){const J=Math.floor(_()*(ie+1)),ne=q[ie];q[ie]=q[J],q[J]=ne}}e.$Xb=M;function z(q,Y){const _=q.indexOf(Y);_>-1&&(q.splice(_,1),q.unshift(Y))}e.$Yb=z;function Z(q,Y){const _=q.indexOf(Y);_>-1&&(q.splice(_,1),q.push(Y))}e.$Zb=Z;function X(q,Y){for(const _ of Y)q.push(_)}e.$1b=X;function x(q,Y){return Array.isArray(q)?q.map(Y):Y(q)}e.$2b=x;function W(q){return Array.isArray(q)?q:[q]}e.$3b=W;function Q(q){return q[Math.floor(Math.random()*q.length)]}e.$4b=Q;function H(q,Y,_){const ie=te(q,Y),J=q.length,ne=_.length;q.length=J+ne;for(let ce=J-1;ce>=ie;ce--)q[ce+ne]=q[ce];for(let ce=0;ce<ne;ce++)q[ce+ie]=_[ce]}e.$5b=H;function V(q,Y,_,ie){const J=te(q,Y);let ne=q.splice(J,_);return ne===void 0&&(ne=[]),H(q,J,ie),ne}e.$6b=V;function te(q,Y){return Y<0?Math.max(Y+q.length,0):Math.min(Y,q.length)}var re;(function(q){function Y(ne){return ne<0}q.isLessThan=Y;function _(ne){return ne<=0}q.isLessThanOrEqual=_;function ie(ne){return ne>0}q.isGreaterThan=ie;function J(ne){return ne===0}q.isNeitherLessOrGreaterThan=J,q.greaterThan=1,q.lessThan=-1,q.neitherLessOrGreaterThan=0})(re||(e.CompareResult=re={}));function ee(q,Y){return(_,ie)=>Y(q(_),q(ie))}e.$7b=ee;function ae(...q){return(Y,_)=>{for(const ie of q){const J=ie(Y,_);if(!re.isNeitherLessOrGreaterThan(J))return J}return re.neitherLessOrGreaterThan}}e.$8b=ae;const G=(q,Y)=>q-Y;e.$9b=G;const U=(q,Y)=>(0,e.$9b)(q?1:0,Y?1:0);e.$0b=U;function D(q){return(Y,_)=>-q(Y,_)}e.$$b=D;class T{constructor(Y){this.g=Y,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(Y){let _=this.c;for(;_<this.g.length&&Y(this.g[_]);)_++;const ie=_===this.c?null:this.g.slice(this.c,_);return this.c=_,ie}takeFromEndWhile(Y){let _=this.d;for(;_>=0&&Y(this.g[_]);)_--;const ie=_===this.d?null:this.g.slice(_+1,this.d+1);return this.d=_,ie}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const Y=this.g[this.c];return this.c++,Y}removeLast(){const Y=this.g[this.d];return this.d--,Y}takeCount(Y){const _=this.g.slice(this.c,this.c+Y);return this.c+=Y,_}}e.$_b=T;class B{static{this.empty=new B(Y=>{})}constructor(Y){this.iterate=Y}forEach(Y){this.iterate(_=>(Y(_),!0))}toArray(){const Y=[];return this.iterate(_=>(Y.push(_),!0)),Y}filter(Y){return new B(_=>this.iterate(ie=>Y(ie)?_(ie):!0))}map(Y){return new B(_=>this.iterate(ie=>_(Y(ie))))}some(Y){let _=!1;return this.iterate(ie=>(_=Y(ie),!_)),_}findFirst(Y){let _;return this.iterate(ie=>Y(ie)?(_=ie,!1):!0),_}findLast(Y){let _;return this.iterate(ie=>(Y(ie)&&(_=ie),!0)),_}findLastMaxBy(Y){let _,ie=!0;return this.iterate(J=>((ie||re.isGreaterThan(Y(J,_)))&&(ie=!1,_=J),!0)),_}}e.$ac=B}),define(le[127],he([0,1,7]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ad=e.$_c=e.$$c=e.$0c=e.$9c=e.ok=void 0;function L(g,C){if(!g)throw new Error(C?`Assertion failed (${C})`:"Assertion Failed")}e.ok=L;function A(g,C="Unreachable"){throw new Error(C)}e.$9c=A;function j(g){if(!g)throw new I.$cb("Assertion Failed")}e.$0c=j;function O(g){g||(0,I.$1)(new I.$cb("Soft Assertion Failed"))}e.$$c=O;function R(g){if(!g()){debugger;g(),(0,I.$1)(new I.$cb("Assertion Failed"))}}e.$_c=R;function k(g,C){let S=0;for(;S<g.length-1;){const w=g[S],h=g[S+1];if(!C(w,h))return!1;S++}return!0}e.$ad=k}),define(le[85],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=void 0;function I(L,A){const j=this;let O=!1,R;return function(){if(O)return R;if(O=!0,A)try{R=L.apply(j,arguments)}finally{A()}else R=L.apply(j,arguments);return R}}e.$db=I}),define(le[61],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var I;(function(L){function A(i){return i&&typeof i=="object"&&typeof i[Symbol.iterator]=="function"}L.is=A;const j=Object.freeze([]);function O(){return j}L.empty=O;function*R(i){yield i}L.single=R;function k(i){return A(i)?i:R(i)}L.wrap=k;function g(i){return i||j}L.from=g;function*C(i){for(let o=i.length-1;o>=0;o--)yield i[o]}L.reverse=C;function S(i){return!i||i[Symbol.iterator]().next().done===!0}L.isEmpty=S;function w(i){return i[Symbol.iterator]().next().value}L.first=w;function h(i,o){for(const n of i)if(o(n))return!0;return!1}L.some=h;function f(i,o){for(const n of i)if(o(n))return n}L.find=f;function*m(i,o){for(const n of i)o(n)&&(yield n)}L.filter=m;function*y(i,o){let n=0;for(const s of i)yield o(s,n++)}L.map=y;function*l(...i){for(const o of i)yield*o}L.concat=l;function d(i,o,n){let s=n;for(const t of i)s=o(s,t);return s}L.reduce=d;function*$(i,o,n=i.length){for(o<0&&(o+=i.length),n<0?n+=i.length:n>i.length&&(n=i.length);o<n;o++)yield i[o]}L.slice=$;function c(i,o=Number.POSITIVE_INFINITY){const n=[];if(o===0)return[n,i];const s=i[Symbol.iterator]();for(let t=0;t<o;t++){const r=s.next();if(r.done)return[n,L.empty()];n.push(r.value)}return[n,{[Symbol.iterator](){return s}}]}L.consume=c;async function v(i){const o=[];for await(const n of i)o.push(n);return Promise.resolve(o)}L.asyncToArray=v})(I||(e.Iterable=I={}))}),define(le[34],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bn=e.$An=e.$zn=e.$yn=e.$xn=e.$wn=e.$vn=e.$un=e.$tn=e.$sn=e.$rn=e.$qn=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var I;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(I||(e.ScanError=I={}));var L;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(L||(e.SyntaxKind=L={}));var A;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(A||(e.ParseErrorCode=A={}));var j;(function(i){i.DEFAULT={allowTrailingComma:!0}})(j||(e.ParseOptions=j={}));function O(i,o=!1){let n=0;const s=i.length;let t="",r=0,a=16,E=0;function b(z){let Z=0,X=0;for(;Z<z;){const x=i.charCodeAt(n);if(x>=48&&x<=57)X=X*16+x-48;else if(x>=65&&x<=70)X=X*16+x-65+10;else if(x>=97&&x<=102)X=X*16+x-97+10;else break;n++,Z++}return Z<z&&(X=-1),X}function u(z){n=z,t="",r=0,a=16,E=0}function p(){const z=n;if(i.charCodeAt(n)===48)n++;else for(n++;n<i.length&&g(i.charCodeAt(n));)n++;if(n<i.length&&i.charCodeAt(n)===46)if(n++,n<i.length&&g(i.charCodeAt(n)))for(n++;n<i.length&&g(i.charCodeAt(n));)n++;else return E=3,i.substring(z,n);let Z=n;if(n<i.length&&(i.charCodeAt(n)===69||i.charCodeAt(n)===101))if(n++,(n<i.length&&i.charCodeAt(n)===43||i.charCodeAt(n)===45)&&n++,n<i.length&&g(i.charCodeAt(n))){for(n++;n<i.length&&g(i.charCodeAt(n));)n++;Z=n}else E=3;return i.substring(z,Z)}function P(){let z="",Z=n;for(;;){if(n>=s){z+=i.substring(Z,n),E=2;break}const X=i.charCodeAt(n);if(X===34){z+=i.substring(Z,n),n++;break}if(X===92){if(z+=i.substring(Z,n),n++,n>=s){E=2;break}switch(i.charCodeAt(n++)){case 34:z+='"';break;case 92:z+="\\";break;case 47:z+="/";break;case 98:z+="\b";break;case 102:z+="\f";break;case 110:z+=`
`;break;case 114:z+="\r";break;case 116:z+="	";break;case 117:{const W=b(4);W>=0?z+=String.fromCharCode(W):E=4;break}default:E=5}Z=n;continue}if(X>=0&&X<=31)if(k(X)){z+=i.substring(Z,n),E=2;break}else E=6;n++}return z}function N(){if(t="",E=0,r=n,n>=s)return r=s,a=17;let z=i.charCodeAt(n);if(R(z)){do n++,t+=String.fromCharCode(z),z=i.charCodeAt(n);while(R(z));return a=15}if(k(z))return n++,t+=String.fromCharCode(z),z===13&&i.charCodeAt(n)===10&&(n++,t+=`
`),a=14;switch(z){case 123:return n++,a=1;case 125:return n++,a=2;case 91:return n++,a=3;case 93:return n++,a=4;case 58:return n++,a=6;case 44:return n++,a=5;case 34:return n++,t=P(),a=10;case 47:{const Z=n-1;if(i.charCodeAt(n+1)===47){for(n+=2;n<s&&!k(i.charCodeAt(n));)n++;return t=i.substring(Z,n),a=12}if(i.charCodeAt(n+1)===42){n+=2;const X=s-1;let x=!1;for(;n<X;){if(i.charCodeAt(n)===42&&i.charCodeAt(n+1)===47){n+=2,x=!0;break}n++}return x||(n++,E=1),t=i.substring(Z,n),a=13}return t+=String.fromCharCode(z),n++,a=16}case 45:if(t+=String.fromCharCode(z),n++,n===s||!g(i.charCodeAt(n)))return a=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return t+=p(),a=11;default:for(;n<s&&F(z);)n++,z=i.charCodeAt(n);if(r!==n){switch(t=i.substring(r,n),t){case"true":return a=8;case"false":return a=9;case"null":return a=7}return a=16}return t+=String.fromCharCode(z),n++,a=16}}function F(z){if(R(z)||k(z))return!1;switch(z){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function M(){let z;do z=N();while(z>=12&&z<=15);return z}return{setPosition:u,getPosition:()=>n,scan:o?M:N,getToken:()=>a,getTokenValue:()=>t,getTokenOffset:()=>r,getTokenLength:()=>n-r,getTokenError:()=>E}}e.$qn=O;function R(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function k(i){return i===10||i===13||i===8232||i===8233}function g(i){return i>=48&&i<=57}var C;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(C||(C={}));function S(i,o){const n=[],s=new Object;let t;const r={value:{},offset:0,length:0,type:"object",parent:void 0};let a=!1;function E(b,u,p,P){r.value=b,r.offset=u,r.length=p,r.type=P,r.colonOffset=void 0,t=r}try{$(i,{onObjectBegin:(b,u)=>{if(o<=b)throw s;t=void 0,a=o>b,n.push("")},onObjectProperty:(b,u,p)=>{if(o<u||(E(b,u,p,"property"),n[n.length-1]=b,o<=u+p))throw s},onObjectEnd:(b,u)=>{if(o<=b)throw s;t=void 0,n.pop()},onArrayBegin:(b,u)=>{if(o<=b)throw s;t=void 0,n.push(0)},onArrayEnd:(b,u)=>{if(o<=b)throw s;t=void 0,n.pop()},onLiteralValue:(b,u,p)=>{if(o<u||(E(b,u,p,v(b)),o<=u+p))throw s},onSeparator:(b,u,p)=>{if(o<=u)throw s;if(b===":"&&t&&t.type==="property")t.colonOffset=u,a=!1,t=void 0;else if(b===","){const P=n[n.length-1];typeof P=="number"?n[n.length-1]=P+1:(a=!0,n[n.length-1]=""),t=void 0}}})}catch(b){if(b!==s)throw b}return{path:n,previousNode:t,isAtPropertyKey:a,matches:b=>{let u=0;for(let p=0;u<b.length&&p<n.length;p++)if(b[u]===n[p]||b[u]==="*")u++;else if(b[u]!=="**")return!1;return u===b.length}}}e.$rn=S;function w(i,o=[],n=j.DEFAULT){let s=null,t=[];const r=[];function a(b){Array.isArray(t)?t.push(b):s!==null&&(t[s]=b)}return $(i,{onObjectBegin:()=>{const b={};a(b),r.push(t),t=b,s=null},onObjectProperty:b=>{s=b},onObjectEnd:()=>{t=r.pop()},onArrayBegin:()=>{const b=[];a(b),r.push(t),t=b,s=null},onArrayEnd:()=>{t=r.pop()},onLiteralValue:a,onError:(b,u,p)=>{o.push({error:b,offset:u,length:p})}},n),t[0]}e.$sn=w;function h(i,o=[],n=j.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function t(b){s.type==="property"&&(s.length=b-s.offset,s=s.parent)}function r(b){return s.children.push(b),b}$(i,{onObjectBegin:b=>{s=r({type:"object",offset:b,length:-1,parent:s,children:[]})},onObjectProperty:(b,u,p)=>{s=r({type:"property",offset:u,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:b,offset:u,length:p,parent:s})},onObjectEnd:(b,u)=>{s.length=b+u-s.offset,s=s.parent,t(b+u)},onArrayBegin:(b,u)=>{s=r({type:"array",offset:b,length:-1,parent:s,children:[]})},onArrayEnd:(b,u)=>{s.length=b+u-s.offset,s=s.parent,t(b+u)},onLiteralValue:(b,u,p)=>{r({type:v(b),offset:u,length:p,parent:s,value:b}),t(u+p)},onSeparator:(b,u,p)=>{s.type==="property"&&(b===":"?s.colonOffset=u:b===","&&t(u))},onError:(b,u,p)=>{o.push({error:b,offset:u,length:p})}},n);const E=s.children[0];return E&&delete E.parent,E}e.$tn=h;function f(i,o){if(!i)return;let n=i;for(const s of o)if(typeof s=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let t=!1;for(const r of n.children)if(Array.isArray(r.children)&&r.children[0].value===s){n=r.children[1],t=!0;break}if(!t)return}else{const t=s;if(n.type!=="array"||t<0||!Array.isArray(n.children)||t>=n.children.length)return;n=n.children[t]}return n}e.$un=f;function m(i){if(!i.parent||!i.parent.children)return[];const o=m(i.parent);if(i.parent.type==="property"){const n=i.parent.children[0].value;o.push(n)}else if(i.parent.type==="array"){const n=i.parent.children.indexOf(i);n!==-1&&o.push(n)}return o}e.$vn=m;function y(i){switch(i.type){case"array":return i.children.map(y);case"object":{const o=Object.create(null);for(const n of i.children){const s=n.children[1];s&&(o[n.children[0].value]=y(s))}return o}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.$wn=y;function l(i,o,n=!1){return o>=i.offset&&o<i.offset+i.length||n&&o===i.offset+i.length}e.$xn=l;function d(i,o,n=!1){if(l(i,o,n)){const s=i.children;if(Array.isArray(s))for(let t=0;t<s.length&&s[t].offset<=o;t++){const r=d(s[t],o,n);if(r)return r}return i}}e.$yn=d;function $(i,o,n=j.DEFAULT){const s=O(i,!1);function t(ee){return ee?()=>ee(s.getTokenOffset(),s.getTokenLength()):()=>!0}function r(ee){return ee?ae=>ee(ae,s.getTokenOffset(),s.getTokenLength()):()=>!0}const a=t(o.onObjectBegin),E=r(o.onObjectProperty),b=t(o.onObjectEnd),u=t(o.onArrayBegin),p=t(o.onArrayEnd),P=r(o.onLiteralValue),N=r(o.onSeparator),F=t(o.onComment),M=r(o.onError),z=n&&n.disallowComments,Z=n&&n.allowTrailingComma;function X(){for(;;){const ee=s.scan();switch(s.getTokenError()){case 4:x(14);break;case 5:x(15);break;case 3:x(13);break;case 1:z||x(11);break;case 2:x(12);break;case 6:x(16);break}switch(ee){case 12:case 13:z?x(10):F();break;case 16:x(1);break;case 15:case 14:break;default:return ee}}}function x(ee,ae=[],G=[]){if(M(ee),ae.length+G.length>0){let U=s.getToken();for(;U!==17;){if(ae.indexOf(U)!==-1){X();break}else if(G.indexOf(U)!==-1)break;U=X()}}}function W(ee){const ae=s.getTokenValue();return ee?P(ae):E(ae),X(),!0}function Q(){switch(s.getToken()){case 11:{let ee=0;try{ee=JSON.parse(s.getTokenValue()),typeof ee!="number"&&(x(2),ee=0)}catch{x(2)}P(ee);break}case 7:P(null);break;case 8:P(!0);break;case 9:P(!1);break;default:return!1}return X(),!0}function H(){return s.getToken()!==10?(x(3,[],[2,5]),!1):(W(!1),s.getToken()===6?(N(":"),X(),re()||x(4,[],[2,5])):x(5,[],[2,5]),!0)}function V(){a(),X();let ee=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(ee||x(4,[],[]),N(","),X(),s.getToken()===2&&Z)break}else ee&&x(6,[],[]);H()||x(4,[],[2,5]),ee=!0}return b(),s.getToken()!==2?x(7,[2],[]):X(),!0}function te(){u(),X();let ee=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(ee||x(4,[],[]),N(","),X(),s.getToken()===4&&Z)break}else ee&&x(6,[],[]);re()||x(4,[],[4,5]),ee=!0}return p(),s.getToken()!==4?x(8,[4],[]):X(),!0}function re(){switch(s.getToken()){case 3:return te();case 1:return V();case 10:return W(!0);default:return Q()}}return X(),s.getToken()===17?n.allowEmptyContent?!0:(x(4,[],[]),!1):re()?(s.getToken()!==17&&x(9,[],[]),!0):(x(4,[],[]),!1)}e.$zn=$;function c(i,o){const n=O(i),s=[];let t,r=0,a;do switch(a=n.getPosition(),t=n.scan(),t){case 12:case 13:case 17:r!==a&&s.push(i.substring(r,a)),o!==void 0&&s.push(n.getTokenValue().replace(/[^\r\n]/g,o)),r=n.getPosition();break}while(t!==17);return s.join("")}e.$An=c;function v(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.$Bn=v}),define(le[42],he([0,1,34]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fn=e.$En=e.$Dn=e.$Cn=void 0;function L(g,C,S){let w,h,f,m,y;if(C){for(m=C.offset,y=m+C.length,f=m;f>0&&!k(g,f-1);)f--;let a=y;for(;a<g.length&&!k(g,a);)a++;h=g.substring(f,a),w=O(h,S)}else h=g,w=0,f=0,m=0,y=g.length;const l=R(S,g);let d=!1,$=0,c;S.insertSpaces?c=j(" ",S.tabSize||4):c="	";const v=(0,I.$qn)(h,!1);let i=!1;function o(){return l+j(c,w+$)}function n(){let a=v.scan();for(d=!1;a===15||a===14;)d=d||a===14,a=v.scan();return i=a===16||v.getTokenError()!==0,a}const s=[];function t(a,E,b){!i&&E<y&&b>m&&g.substring(E,b)!==a&&s.push({offset:E,length:b-E,content:a})}let r=n();if(r!==17){const a=v.getTokenOffset()+f,E=j(c,w);t(E,f,a)}for(;r!==17;){let a=v.getTokenOffset()+v.getTokenLength()+f,E=n(),b="";for(;!d&&(E===12||E===13);){const p=v.getTokenOffset()+f;t(" ",a,p),a=v.getTokenOffset()+v.getTokenLength()+f,b=E===12?o():"",E=n()}if(E===2)r!==1&&($--,b=o());else if(E===4)r!==3&&($--,b=o());else{switch(r){case 3:case 1:$++,b=o();break;case 5:case 12:b=o();break;case 13:d?b=o():b=" ";break;case 6:b=" ";break;case 10:if(E===6){b="";break}case 7:case 8:case 9:case 11:case 2:case 4:E===12||E===13?b=" ":E!==5&&E!==17&&(i=!0);break;case 16:i=!0;break}d&&(E===12||E===13)&&(b=o())}const u=v.getTokenOffset()+f;t(b,a,u),r=E}return s}e.$Cn=L;function A(g,C){const S=JSON.stringify(g,void 0,C.insertSpaces?C.tabSize||4:"	");return C.eol!==void 0?S.replace(/\r\n|\r|\n/g,C.eol):S}e.$Dn=A;function j(g,C){let S="";for(let w=0;w<C;w++)S+=g;return S}function O(g,C){let S=0,w=0;const h=C.tabSize||4;for(;S<g.length;){const f=g.charAt(S);if(f===" ")w++;else if(f==="	")w+=h;else break;S++}return Math.floor(w/h)}function R(g,C){for(let S=0;S<C.length;S++){const w=C.charAt(S);if(w==="\r")return S+1<C.length&&C.charAt(S+1)===`
`?`\r
`:"\r";if(w===`
`)return`
`}return g&&g.eol||`
`}e.$En=R;function k(g,C){return`\r
`.indexOf(g.charAt(C))!==-1}e.$Fn=k}),define(le[62],he([0,1,34,42]),function(se,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kn=e.$Jn=e.$In=e.$Hn=e.$Gn=void 0;function A(g,C,S){return j(g,C,void 0,S)}e.$Gn=A;function j(g,C,S,w,h){const f=C.slice(),m=[],y=(0,I.$tn)(g,m);let l,d;for(;f.length>0&&(d=f.pop(),l=(0,I.$un)(y,f),l===void 0&&S!==void 0);)typeof d=="string"?S={[d]:S}:S=[S];if(l)if(l.type==="object"&&typeof d=="string"&&Array.isArray(l.children)){const $=(0,I.$un)(l,[d]);if($!==void 0)if(S===void 0){if(!$.parent)throw new Error("Malformed AST");const c=l.children.indexOf($.parent);let v,i=$.parent.offset+$.parent.length;if(c>0){const o=l.children[c-1];v=o.offset+o.length}else v=l.offset+1,l.children.length>1&&(i=l.children[1].offset);return O(g,{offset:v,length:i-v,content:""},w)}else return O(g,{offset:$.offset,length:$.length,content:JSON.stringify(S)},w);else{if(S===void 0)return[];const c=`${JSON.stringify(d)}: ${JSON.stringify(S)}`,v=h?h(l.children.map(o=>o.children[0].value)):l.children.length;let i;if(v>0){const o=l.children[v-1];i={offset:o.offset+o.length,length:0,content:","+c}}else l.children.length===0?i={offset:l.offset+1,length:0,content:c}:i={offset:l.offset+1,length:0,content:c+","};return O(g,i,w)}}else if(l.type==="array"&&typeof d=="number"&&Array.isArray(l.children))if(S!==void 0){const $=`${JSON.stringify(S)}`;let c;if(l.children.length===0||d===0)c={offset:l.offset+1,length:0,content:l.children.length===0?$:$+","};else{const v=d===-1||d>l.children.length?l.children.length:d,i=l.children[v-1];c={offset:i.offset+i.length,length:0,content:","+$}}return O(g,c,w)}else{const $=d,c=l.children[$];let v;if(l.children.length===1)v={offset:l.offset+1,length:l.length-2,content:""};else if(l.children.length-1===$){const i=l.children[$-1],o=i.offset+i.length,n=l.offset+l.length;v={offset:o,length:n-2-o,content:""}}else v={offset:c.offset,length:l.children[$+1].offset-c.offset,content:""};return O(g,v,w)}else throw new Error(`Can not add ${typeof d!="number"?"index":"property"} to parent of type ${l.type}`);else{if(S===void 0)throw new Error("Can not delete in empty document");return O(g,{offset:y?y.offset:0,length:y?y.length:0,content:JSON.stringify(S)},w)}}e.$Hn=j;function O(g,C,S){let w=R(g,C),h=C.offset,f=C.offset+C.content.length;if(C.length===0||C.content.length===0){for(;h>0&&!(0,L.$Fn)(w,h-1);)h--;for(;f<w.length&&!(0,L.$Fn)(w,f);)f++}const m=(0,L.$Cn)(w,{offset:h,length:f-h},S);for(let l=m.length-1;l>=0;l--){const d=m[l];w=R(w,d),h=Math.min(h,d.offset),f=Math.max(f,d.offset+d.length),f+=d.content.length-d.length}const y=g.length-(w.length-f)-h;return[{offset:h,length:y,content:w.substring(h,f)}]}e.$In=O;function R(g,C){return g.substring(0,C.offset)+C.content+g.substring(C.offset+C.length)}e.$Jn=R;function k(g,C){const S=C.slice(0).sort((h,f)=>{const m=h.offset-f.offset;return m===0?h.length-f.length:m});let w=g.length;for(let h=S.length-1;h>=0;h--){const f=S[h];if(f.offset+f.length<=w)g=R(g,f);else throw new Error("Overlapping edit");w=f.offset}return g}e.$Kn=k}),define(le[53],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class I{constructor(A){this.d=A,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(A){this.c=A}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=I}),define(le[86],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=void 0;class I{static{this.Undefined=new I(void 0)}constructor(j){this.element=j,this.next=I.Undefined,this.prev=I.Undefined}}class L{constructor(){this.a=I.Undefined,this.b=I.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===I.Undefined}clear(){let j=this.a;for(;j!==I.Undefined;){const O=j.next;j.prev=I.Undefined,j.next=I.Undefined,j=O}this.a=I.Undefined,this.b=I.Undefined,this.c=0}unshift(j){return this.d(j,!1)}push(j){return this.d(j,!0)}d(j,O){const R=new I(j);if(this.a===I.Undefined)this.a=R,this.b=R;else if(O){const g=this.b;this.b=R,R.prev=g,g.next=R}else{const g=this.a;this.a=R,R.next=g,g.prev=R}this.c+=1;let k=!1;return()=>{k||(k=!0,this.e(R))}}shift(){if(this.a!==I.Undefined){const j=this.a.element;return this.e(this.a),j}}pop(){if(this.b!==I.Undefined){const j=this.b.element;return this.e(this.b),j}}e(j){if(j.prev!==I.Undefined&&j.next!==I.Undefined){const O=j.prev;O.next=j.next,j.next.prev=O}else j.prev===I.Undefined&&j.next===I.Undefined?(this.a=I.Undefined,this.b=I.Undefined):j.next===I.Undefined?(this.b=this.b.prev,this.b.next=I.Undefined):j.prev===I.Undefined&&(this.a=this.a.next,this.a.prev=I.Undefined);this.c-=1}*[Symbol.iterator](){let j=this.a;for(;j!==I.Undefined;)yield j.element,j=j.next}}e.$4c=L}),define(le[35],he([0,1]),function(se,e){"use strict";var I,L,A;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.Touch=e.$Bc=e.$Ac=e.$zc=e.$yc=e.$xc=void 0;function j($,c,v){let i=$.get(c);return i===void 0&&(i=v,$.set(c,i)),i}e.$xc=j;function O($){const c=[];return $.forEach((v,i)=>{c.push(`${i} => ${v}`)}),`Map(${$.size}) {${c.join(", ")}}`}e.$yc=O;function R($){const c=[];return $.forEach(v=>{c.push(v)}),`Set(${$.size}) {${c.join(", ")}}`}e.$zc=R;class k{constructor(c,v){this.uri=c,this.value=v}}function g($){return Array.isArray($)}class C{static{this.c=c=>c.toString()}constructor(c,v){if(this[I]="ResourceMap",c instanceof C)this.d=new Map(c.d),this.e=v??C.c;else if(g(c)){this.d=new Map,this.e=v??C.c;for(const[i,o]of c)this.set(i,o)}else this.d=new Map,this.e=c??C.c}set(c,v){return this.d.set(this.e(c),new k(c,v)),this}get(c){return this.d.get(this.e(c))?.value}has(c){return this.d.has(this.e(c))}get size(){return this.d.size}clear(){this.d.clear()}delete(c){return this.d.delete(this.e(c))}forEach(c,v){typeof v<"u"&&(c=c.bind(v));for(const[i,o]of this.d)c(o.value,o.uri,this)}*values(){for(const c of this.d.values())yield c.value}*keys(){for(const c of this.d.values())yield c.uri}*entries(){for(const c of this.d.values())yield[c.uri,c.value]}*[(I=Symbol.toStringTag,Symbol.iterator)](){for(const[,c]of this.d)yield[c.uri,c.value]}}e.$Ac=C;class S{constructor(c,v){this[L]="ResourceSet",!c||typeof c=="function"?this.c=new C(c):(this.c=new C(v),c.forEach(this.add,this))}get size(){return this.c.size}add(c){return this.c.set(c,c),this}clear(){this.c.clear()}delete(c){return this.c.delete(c)}forEach(c,v){this.c.forEach((i,o)=>c.call(v,o,o,this))}has(c){return this.c.has(c)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Bc=S;var w;(function($){$[$.None=0]="None",$[$.AsOld=1]="AsOld",$[$.AsNew=2]="AsNew"})(w||(e.Touch=w={}));class h{constructor(){this[A]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(c){return this.c.has(c)}get(c,v=0){const i=this.c.get(c);if(i)return v!==0&&this.l(i,v),i.value}set(c,v,i=0){let o=this.c.get(c);if(o)o.value=v,i!==0&&this.l(o,i);else{switch(o={key:c,value:v,next:void 0,previous:void 0},i){case 0:this.j(o);break;case 1:this.i(o);break;case 2:this.j(o);break;default:this.j(o);break}this.c.set(c,o),this.f++}return this}delete(c){return!!this.remove(c)}remove(c){const v=this.c.get(c);if(v)return this.c.delete(c),this.k(v),this.f--,v.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const c=this.d;return this.c.delete(c.key),this.k(c),this.f--,c.value}forEach(c,v){const i=this.g;let o=this.d;for(;o;){if(v?c.bind(v)(o.value,o.key,this):c(o.value,o.key,this),this.g!==i)throw new Error("LinkedMap got modified during iteration.");o=o.next}}keys(){const c=this,v=this.g;let i=this.d;const o={[Symbol.iterator](){return o},next(){if(c.g!==v)throw new Error("LinkedMap got modified during iteration.");if(i){const n={value:i.key,done:!1};return i=i.next,n}else return{value:void 0,done:!0}}};return o}values(){const c=this,v=this.g;let i=this.d;const o={[Symbol.iterator](){return o},next(){if(c.g!==v)throw new Error("LinkedMap got modified during iteration.");if(i){const n={value:i.value,done:!1};return i=i.next,n}else return{value:void 0,done:!0}}};return o}entries(){const c=this,v=this.g;let i=this.d;const o={[Symbol.iterator](){return o},next(){if(c.g!==v)throw new Error("LinkedMap got modified during iteration.");if(i){const n={value:[i.key,i.value],done:!1};return i=i.next,n}else return{value:void 0,done:!0}}};return o}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(c){if(c>=this.size)return;if(c===0){this.clear();return}let v=this.d,i=this.size;for(;v&&i>c;)this.c.delete(v.key),v=v.next,i--;this.d=v,this.f=i,v&&(v.previous=void 0),this.g++}i(c){if(!this.d&&!this.e)this.e=c;else if(this.d)c.next=this.d,this.d.previous=c;else throw new Error("Invalid list");this.d=c,this.g++}j(c){if(!this.d&&!this.e)this.d=c;else if(this.e)c.previous=this.e,this.e.next=c;else throw new Error("Invalid list");this.e=c,this.g++}k(c){if(c===this.d&&c===this.e)this.d=void 0,this.e=void 0;else if(c===this.d){if(!c.next)throw new Error("Invalid list");c.next.previous=void 0,this.d=c.next}else if(c===this.e){if(!c.previous)throw new Error("Invalid list");c.previous.next=void 0,this.e=c.previous}else{const v=c.next,i=c.previous;if(!v||!i)throw new Error("Invalid list");v.previous=i,i.next=v}c.next=void 0,c.previous=void 0,this.g++}l(c,v){if(!this.d||!this.e)throw new Error("Invalid list");if(!(v!==1&&v!==2)){if(v===1){if(c===this.d)return;const i=c.next,o=c.previous;c===this.e?(o.next=void 0,this.e=o):(i.previous=o,o.next=i),c.previous=void 0,c.next=this.d,this.d.previous=c,this.d=c,this.g++}else if(v===2){if(c===this.e)return;const i=c.next,o=c.previous;c===this.d?(i.previous=void 0,this.d=i):(i.previous=o,o.next=i),c.next=void 0,c.previous=this.e,this.e.next=c,this.e=c,this.g++}}}toJSON(){const c=[];return this.forEach((v,i)=>{c.push([i,v])}),c}fromJSON(c){this.clear();for(const[v,i]of c)this.set(v,i)}}e.$Cc=h;class f extends h{constructor(c,v=1){super(),this.m=c,this.n=Math.min(Math.max(0,v),1)}get limit(){return this.m}set limit(c){this.m=c,this.o()}get ratio(){return this.n}set ratio(c){this.n=Math.min(Math.max(0,c),1),this.o()}get(c,v=2){return super.get(c,v)}peek(c){return super.get(c,0)}set(c,v){return super.set(c,v,2),this.o(),this}o(){this.size>this.m&&this.h(Math.round(this.m*this.n))}}e.$Dc=f;class m{constructor(){this.c=new Map}add(c){return this.c.set(c,(this.c.get(c)||0)+1),this}delete(c){let v=this.c.get(c)||0;return v===0?!1:(v--,v===0?this.c.delete(c):this.c.set(c,v),!0)}has(c){return this.c.has(c)}}e.$Ec=m;class y{constructor(c){if(this.c=new Map,this.d=new Map,c)for(const[v,i]of c)this.set(v,i)}clear(){this.c.clear(),this.d.clear()}set(c,v){this.c.set(c,v),this.d.set(v,c)}get(c){return this.c.get(c)}getKey(c){return this.d.get(c)}delete(c){const v=this.c.get(c);return v===void 0?!1:(this.c.delete(c),this.d.delete(v),!0)}forEach(c,v){this.c.forEach((i,o)=>{c.call(v,i,o,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Fc=y;class l{constructor(){this.c=new Map}add(c,v){let i=this.c.get(c);i||(i=new Set,this.c.set(c,i)),i.add(v)}delete(c,v){const i=this.c.get(c);i&&(i.delete(v),i.size===0&&this.c.delete(c))}forEach(c,v){const i=this.c.get(c);i&&i.forEach(v)}get(c){const v=this.c.get(c);return v||new Set}}e.$Gc=l;function d($,c){if($===c)return!0;if($.size!==c.size)return!1;for(const[v,i]of $)if(!c.has(v)||c.get(v)!==i)return!1;for(const[v]of c)if(!$.has(v))return!1;return!0}e.$Hc=d}),define(le[2],he([0,1,17,126,35,85,61]),function(se,e,I,L,A,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=void 0;const R=!1;let k=null;class g{constructor(){this.b=new Map}static{this.a=0}c(P){let N=this.b.get(P);return N||(N={parent:null,source:null,isSingleton:!1,value:P,idx:g.a++},this.b.set(P,N)),N}trackDisposable(P){const N=this.c(P);N.source||(N.source=new Error().stack)}setParent(P,N){const F=this.c(P);F.parent=N}markAsDisposed(P){this.b.delete(P)}markAsSingleton(P){this.c(P).isSingleton=!0}f(P,N){const F=N.get(P);if(F)return F;const M=P.parent?this.f(this.c(P.parent),N):P;return N.set(P,M),M}getTrackedDisposables(){const P=new Map;return[...this.b.entries()].filter(([,F])=>F.source!==null&&!this.f(F,P).isSingleton).flatMap(([F])=>F)}computeLeakingDisposables(P=10,N){let F;if(N)F=N;else{const x=new Map,W=[...this.b.values()].filter(H=>H.source!==null&&!this.f(H,x).isSingleton);if(W.length===0)return;const Q=new Set(W.map(H=>H.value));if(F=W.filter(H=>!(H.parent&&Q.has(H.parent))),F.length===0)throw new Error("There are cyclic diposable chains!")}if(!F)return;function M(x){function W(H,V){for(;H.length>0&&V.some(te=>typeof te=="string"?te===H[0]:H[0].match(te));)H.shift()}const Q=x.source.split(`
`).map(H=>H.trim().replace("at ","")).filter(H=>H!=="");return W(Q,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),Q.reverse()}const z=new A.$Gc;for(const x of F){const W=M(x);for(let Q=0;Q<=W.length;Q++)z.add(W.slice(0,Q).join(`
`),x)}F.sort((0,I.$7b)(x=>x.idx,I.$9b));let Z="",X=0;for(const x of F.slice(0,P)){X++;const W=M(x),Q=[];for(let H=0;H<W.length;H++){let V=W[H];V=`(shared with ${z.get(W.slice(0,H+1).join(`
`)).size}/${F.length} leaks) at ${V}`;const re=z.get(W.slice(0,H).join(`
`)),ee=(0,L.$K)([...re].map(ae=>M(ae)[H]),ae=>ae);delete ee[W[H]];for(const[ae,G]of Object.entries(ee))Q.unshift(`    - stacktraces of ${G.length} other leaks continue with ${ae}`);Q.unshift(V)}Z+=`


==================== Leaking disposable ${X}/${F.length}: ${x.value.constructor.name} ====================
${Q.join(`
`)}
============================================================

`}return F.length>P&&(Z+=`


... and ${F.length-P} more leaking disposables

`),{leaks:F,details:Z}}}e.$Ic=g;function C(p){k=p}if(e.$Jc=C,R){const p="__is_disposable_tracked__";C(new class{trackDisposable(P){const N=new Error("Potentially leaked disposable").stack;setTimeout(()=>{P[p]||console.log(N)},3e3)}setParent(P,N){if(P&&P!==i.None)try{P[p]=!0}catch{}}markAsDisposed(P){if(P&&P!==i.None)try{P[p]=!0}catch{}}markAsSingleton(P){}})}function S(p){return k?.trackDisposable(p),p}e.$Kc=S;function w(p){k?.markAsDisposed(p)}e.$Lc=w;function h(p,P){k?.setParent(p,P)}function f(p,P){if(k)for(const N of p)k.setParent(N,P)}function m(p){return k?.markAsSingleton(p),p}e.$Mc=m;function y(p){return typeof p.dispose=="function"&&p.dispose.length===0}e.$Nc=y;function l(p){if(O.Iterable.is(p)){const P=[];for(const N of p)if(N)try{N.dispose()}catch(F){P.push(F)}if(P.length===1)throw P[0];if(P.length>1)throw new AggregateError(P,"Encountered errors while disposing of store");return Array.isArray(p)?[]:p}else if(p)return p.dispose(),p}e.$Oc=l;function d(p){for(const P of p)y(P)&&P.dispose();return[]}e.$Pc=d;function $(...p){const P=c(()=>l(p));return f(p,P),P}e.$Qc=$;function c(p){const P=S({dispose:(0,j.$db)(()=>{w(P),p()})});return P}e.$Rc=c;class v{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,S(this)}dispose(){this.g||(w(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{l(this.f)}finally{this.f.clear()}}add(P){if(!P)return P;if(P===this)throw new Error("Cannot register a disposable on itself!");return h(P,this),this.g?v.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(P),P}delete(P){if(P){if(P===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(P),P.dispose()}}deleteAndLeak(P){P&&this.f.has(P)&&(this.f.delete(P),h(P,null))}}e.$Sc=v;class i{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new v,S(this),h(this.q,this)}dispose(){w(this),this.q.dispose()}B(P){if(P===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(P)}}e.$Tc=i;class o{constructor(){this.b=!1,S(this)}get value(){return this.b?void 0:this.a}set value(P){this.b||P===this.a||(this.a?.dispose(),P&&h(P,this),this.a=P)}clear(){this.value=void 0}dispose(){this.b=!0,w(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const P=this.a;return this.a=void 0,P&&h(P,null),P}}e.$Uc=o;class n{constructor(P){this.a=new o,this.b=!1,this.a.value=P}get value(){return this.a.value}set value(P){this.b||P===this.a.value||(this.a.value=P)}dispose(){this.b=!0,this.a.dispose()}}e.$Vc=n;class s{constructor(P){this.b=P,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Wc=s;class t{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,S(this)}set(P){let N=P;return this.unset=()=>N=void 0,this.isset=()=>N!==void 0,this.dispose=()=>{N&&(N(),N=void 0,w(this))},this}}e.$Xc=t;class r{constructor(){this.a=new Map}acquire(P,...N){let F=this.a.get(P);F||(F={counter:0,object:this.b(P,...N)},this.a.set(P,F));const{object:M}=F,z=(0,j.$db)(()=>{--F.counter===0&&(this.c(P,F.object),this.a.delete(P))});return F.counter++,{object:M,dispose:z}}}e.$Yc=r;class a{constructor(P){this.a=P}async acquire(P,...N){const F=this.a.acquire(P,...N);try{return{object:await F.object,dispose:()=>F.dispose()}}catch(M){throw F.dispose(),M}}}e.$Zc=a;class E{constructor(P){this.object=P}dispose(){}}e.$1c=E;function b(p){const P=new v;try{p(P)}finally{P.dispose()}}e.$2c=b;class u{constructor(){this.a=new Map,this.b=!1,S(this)}dispose(){w(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{l(this.a.values())}finally{this.a.clear()}}has(P){return this.a.has(P)}get size(){return this.a.size}get(P){return this.a.get(P)}set(P,N,F=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),F||this.a.get(P)?.dispose(),this.a.set(P,N)}deleteAndDispose(P){this.a.get(P)?.dispose(),this.a.delete(P)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$3c=u}),define(le[87],he([0,1,35]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tl=e.$Sl=e.$Rl=void 0;const L=new I.$Dc(1e4);function A(g){return k(g,"NFC",L)}e.$Rl=A;const j=new I.$Dc(1e4);function O(g){return k(g,"NFD",j)}e.$Sl=O;const R=/[^\u0000-\u0080]/;function k(g,C,S){if(!g)return g;const w=S.get(g);if(w)return w;let h;return R.test(g)?h=g.normalize(C):h=g,S.set(g,h),h}e.$Tl=function(){const g=/[\u0300-\u036f]/g;return function(C){return O(C).replace(g,"")}}()}),function(){function se(A){const j=[];typeof A=="number"&&j.push("code/timeOrigin",A);function O(k){j.push(k,Date.now())}function R(){const k=[];for(let g=0;g<j.length;g+=2)k.push({name:j[g],startTime:j[g+1]});return k}return{mark:O,getMarks:R}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?se():{mark(A){performance.mark(A)},getMarks(){let A=performance.timeOrigin;typeof A!="number"&&(A=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const j=[{name:"code/timeOrigin",startTime:Math.round(A)}];for(const O of performance.getEntriesByType("mark"))j.push({name:O.name,startTime:Math.round(A+O.startTime)});return j}};if(typeof process=="object"){const A=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return se(A)}else return console.trace("perf-util loaded in UNKNOWN environment"),se()}function I(A){return A.MonacoPerformanceMarks||(A.MonacoPerformanceMarks=e()),A.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return I(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=I(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=I(L))}(),function(se,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var I=e();for(var L in I)(typeof exports=="object"?exports:se)[L]=I[L]}}(typeof self<"u"?self:this,function(){return function(se){var e={};function I(L){if(e[L])return e[L].exports;var A=e[L]={i:L,l:!1,exports:{}};return se[L].call(A.exports,A,A.exports,I),A.l=!0,A.exports}return I.m=se,I.c=e,I.d=function(L,A,j){I.o(L,A)||Object.defineProperty(L,A,{enumerable:!0,get:j})},I.r=function(L){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(L,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(L,"__esModule",{value:!0})},I.t=function(L,A){if(1&A&&(L=I(L)),8&A||4&A&&typeof L=="object"&&L&&L.__esModule)return L;var j=Object.create(null);if(I.r(j),Object.defineProperty(j,"default",{enumerable:!0,value:L}),2&A&&typeof L!="string")for(var O in L)I.d(j,O,function(R){return L[R]}.bind(null,O));return j},I.n=function(L){var A=L&&L.__esModule?function(){return L.default}:function(){return L};return I.d(A,"a",A),A},I.o=function(L,A){return Object.prototype.hasOwnProperty.call(L,A)},I.p="",I(I.s=0)}([function(se,e,I){(function(L){var A;e=se.exports=G,A=typeof L=="object"&&L.env&&L.env.NODE_DEBUG&&/\bsemver\b/i.test(L.env.NODE_DEBUG)?function(){var ue=Array.prototype.slice.call(arguments,0);ue.unshift("SEMVER"),console.log.apply(console,ue)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var j=256,O=Number.MAX_SAFE_INTEGER||9007199254740991,R=e.re=[],k=e.src=[],g=0,C=g++;k[C]="0|[1-9]\\d*";var S=g++;k[S]="[0-9]+";var w=g++;k[w]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var h=g++;k[h]="("+k[C]+")\\.("+k[C]+")\\.("+k[C]+")";var f=g++;k[f]="("+k[S]+")\\.("+k[S]+")\\.("+k[S]+")";var m=g++;k[m]="(?:"+k[C]+"|"+k[w]+")";var y=g++;k[y]="(?:"+k[S]+"|"+k[w]+")";var l=g++;k[l]="(?:-("+k[m]+"(?:\\."+k[m]+")*))";var d=g++;k[d]="(?:-?("+k[y]+"(?:\\."+k[y]+")*))";var $=g++;k[$]="[0-9A-Za-z-]+";var c=g++;k[c]="(?:\\+("+k[$]+"(?:\\."+k[$]+")*))";var v=g++,i="v?"+k[h]+k[l]+"?"+k[c]+"?";k[v]="^"+i+"$";var o="[v=\\s]*"+k[f]+k[d]+"?"+k[c]+"?",n=g++;k[n]="^"+o+"$";var s=g++;k[s]="((?:<|>)?=?)";var t=g++;k[t]=k[S]+"|x|X|\\*";var r=g++;k[r]=k[C]+"|x|X|\\*";var a=g++;k[a]="[v=\\s]*("+k[r]+")(?:\\.("+k[r]+")(?:\\.("+k[r]+")(?:"+k[l]+")?"+k[c]+"?)?)?";var E=g++;k[E]="[v=\\s]*("+k[t]+")(?:\\.("+k[t]+")(?:\\.("+k[t]+")(?:"+k[d]+")?"+k[c]+"?)?)?";var b=g++;k[b]="^"+k[s]+"\\s*"+k[a]+"$";var u=g++;k[u]="^"+k[s]+"\\s*"+k[E]+"$";var p=g++;k[p]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var P=g++;k[P]="(?:~>?)";var N=g++;k[N]="(\\s*)"+k[P]+"\\s+",R[N]=new RegExp(k[N],"g");var F=g++;k[F]="^"+k[P]+k[a]+"$";var M=g++;k[M]="^"+k[P]+k[E]+"$";var z=g++;k[z]="(?:\\^)";var Z=g++;k[Z]="(\\s*)"+k[z]+"\\s+",R[Z]=new RegExp(k[Z],"g");var X=g++;k[X]="^"+k[z]+k[a]+"$";var x=g++;k[x]="^"+k[z]+k[E]+"$";var W=g++;k[W]="^"+k[s]+"\\s*("+o+")$|^$";var Q=g++;k[Q]="^"+k[s]+"\\s*("+i+")$|^$";var H=g++;k[H]="(\\s*)"+k[s]+"\\s*("+o+"|"+k[a]+")",R[H]=new RegExp(k[H],"g");var V=g++;k[V]="^\\s*("+k[a]+")\\s+-\\s+("+k[a]+")\\s*$";var te=g++;k[te]="^\\s*("+k[E]+")\\s+-\\s+("+k[E]+")\\s*$";var re=g++;k[re]="(<|>)?=?\\s*\\*";for(var ee=0;ee<35;ee++)A(ee,k[ee]),R[ee]||(R[ee]=new RegExp(k[ee]));function ae(ue,ge){if(ue instanceof G)return ue;if(typeof ue!="string"||ue.length>j||!(ge?R[n]:R[v]).test(ue))return null;try{return new G(ue,ge)}catch{return null}}function G(ue,ge){if(ue instanceof G){if(ue.loose===ge)return ue;ue=ue.version}else if(typeof ue!="string")throw new TypeError("Invalid Version: "+ue);if(ue.length>j)throw new TypeError("version is longer than "+j+" characters");if(!(this instanceof G))return new G(ue,ge);A("SemVer",ue,ge),this.loose=ge;var be=ue.trim().match(ge?R[n]:R[v]);if(!be)throw new TypeError("Invalid Version: "+ue);if(this.raw=ue,this.major=+be[1],this.minor=+be[2],this.patch=+be[3],this.major>O||this.major<0)throw new TypeError("Invalid major version");if(this.minor>O||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>O||this.patch<0)throw new TypeError("Invalid patch version");be[4]?this.prerelease=be[4].split(".").map(function(Pe){if(/^[0-9]+$/.test(Pe)){var Ce=+Pe;if(Ce>=0&&Ce<O)return Ce}return Pe}):this.prerelease=[],this.build=be[5]?be[5].split("."):[],this.format()}e.parse=ae,e.valid=function(ue,ge){var be=ae(ue,ge);return be?be.version:null},e.clean=function(ue,ge){var be=ae(ue.trim().replace(/^[=v]+/,""),ge);return be?be.version:null},e.SemVer=G,G.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},G.prototype.toString=function(){return this.version},G.prototype.compare=function(ue){return A("SemVer.compare",this.version,this.loose,ue),ue instanceof G||(ue=new G(ue,this.loose)),this.compareMain(ue)||this.comparePre(ue)},G.prototype.compareMain=function(ue){return ue instanceof G||(ue=new G(ue,this.loose)),D(this.major,ue.major)||D(this.minor,ue.minor)||D(this.patch,ue.patch)},G.prototype.comparePre=function(ue){if(ue instanceof G||(ue=new G(ue,this.loose)),this.prerelease.length&&!ue.prerelease.length)return-1;if(!this.prerelease.length&&ue.prerelease.length)return 1;if(!this.prerelease.length&&!ue.prerelease.length)return 0;var ge=0;do{var be=this.prerelease[ge],Pe=ue.prerelease[ge];if(A("prerelease compare",ge,be,Pe),be===void 0&&Pe===void 0)return 0;if(Pe===void 0)return 1;if(be===void 0)return-1;if(be!==Pe)return D(be,Pe)}while(++ge)},G.prototype.inc=function(ue,ge){switch(ue){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ge);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ge);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ge),this.inc("pre",ge);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ge),this.inc("pre",ge);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var be=this.prerelease.length;--be>=0;)typeof this.prerelease[be]=="number"&&(this.prerelease[be]++,be=-2);be===-1&&this.prerelease.push(0)}ge&&(this.prerelease[0]===ge?isNaN(this.prerelease[1])&&(this.prerelease=[ge,0]):this.prerelease=[ge,0]);break;default:throw new Error("invalid increment argument: "+ue)}return this.format(),this.raw=this.version,this},e.inc=function(ue,ge,be,Pe){typeof be=="string"&&(Pe=be,be=void 0);try{return new G(ue,be).inc(ge,Pe).version}catch{return null}},e.diff=function(ue,ge){if(Y(ue,ge))return null;var be=ae(ue),Pe=ae(ge);if(be.prerelease.length||Pe.prerelease.length){for(var Ce in be)if((Ce==="major"||Ce==="minor"||Ce==="patch")&&be[Ce]!==Pe[Ce])return"pre"+Ce;return"prerelease"}for(var Ce in be)if((Ce==="major"||Ce==="minor"||Ce==="patch")&&be[Ce]!==Pe[Ce])return Ce},e.compareIdentifiers=D;var U=/^[0-9]+$/;function D(ue,ge){var be=U.test(ue),Pe=U.test(ge);return be&&Pe&&(ue=+ue,ge=+ge),be&&!Pe?-1:Pe&&!be?1:ue<ge?-1:ue>ge?1:0}function T(ue,ge,be){return new G(ue,be).compare(new G(ge,be))}function B(ue,ge,be){return T(ue,ge,be)>0}function q(ue,ge,be){return T(ue,ge,be)<0}function Y(ue,ge,be){return T(ue,ge,be)===0}function _(ue,ge,be){return T(ue,ge,be)!==0}function ie(ue,ge,be){return T(ue,ge,be)>=0}function J(ue,ge,be){return T(ue,ge,be)<=0}function ne(ue,ge,be,Pe){var Ce;switch(ge){case"===":typeof ue=="object"&&(ue=ue.version),typeof be=="object"&&(be=be.version),Ce=ue===be;break;case"!==":typeof ue=="object"&&(ue=ue.version),typeof be=="object"&&(be=be.version),Ce=ue!==be;break;case"":case"=":case"==":Ce=Y(ue,be,Pe);break;case"!=":Ce=_(ue,be,Pe);break;case">":Ce=B(ue,be,Pe);break;case">=":Ce=ie(ue,be,Pe);break;case"<":Ce=q(ue,be,Pe);break;case"<=":Ce=J(ue,be,Pe);break;default:throw new TypeError("Invalid operator: "+ge)}return Ce}function ce(ue,ge){if(ue instanceof ce){if(ue.loose===ge)return ue;ue=ue.value}if(!(this instanceof ce))return new ce(ue,ge);A("comparator",ue,ge),this.loose=ge,this.parse(ue),this.semver===fe?this.value="":this.value=this.operator+this.semver.version,A("comp",this)}e.rcompareIdentifiers=function(ue,ge){return D(ge,ue)},e.major=function(ue,ge){return new G(ue,ge).major},e.minor=function(ue,ge){return new G(ue,ge).minor},e.patch=function(ue,ge){return new G(ue,ge).patch},e.compare=T,e.compareLoose=function(ue,ge){return T(ue,ge,!0)},e.rcompare=function(ue,ge,be){return T(ge,ue,be)},e.sort=function(ue,ge){return ue.sort(function(be,Pe){return e.compare(be,Pe,ge)})},e.rsort=function(ue,ge){return ue.sort(function(be,Pe){return e.rcompare(be,Pe,ge)})},e.gt=B,e.lt=q,e.eq=Y,e.neq=_,e.gte=ie,e.lte=J,e.cmp=ne,e.Comparator=ce;var fe={};function de(ue,ge){if(ue instanceof de)return ue.loose===ge?ue:new de(ue.raw,ge);if(ue instanceof ce)return new de(ue.value,ge);if(!(this instanceof de))return new de(ue,ge);if(this.loose=ge,this.raw=ue,this.set=ue.split(/\s*\|\|\s*/).map(function(be){return this.parseRange(be.trim())},this).filter(function(be){return be.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ue);this.format()}function me(ue){return!ue||ue.toLowerCase()==="x"||ue==="*"}function Ee(ue,ge,be,Pe,Ce,Fe,De,ze,Te,qe,Ue,Ae,oe){return((ge=me(be)?"":me(Pe)?">="+be+".0.0":me(Ce)?">="+be+"."+Pe+".0":">="+ge)+" "+(ze=me(Te)?"":me(qe)?"<"+(+Te+1)+".0.0":me(Ue)?"<"+Te+"."+(+qe+1)+".0":Ae?"<="+Te+"."+qe+"."+Ue+"-"+Ae:"<="+ze)).trim()}function Re(ue,ge){for(var be=0;be<ue.length;be++)if(!ue[be].test(ge))return!1;if(ge.prerelease.length){for(be=0;be<ue.length;be++)if(A(ue[be].semver),ue[be].semver!==fe&&ue[be].semver.prerelease.length>0){var Pe=ue[be].semver;if(Pe.major===ge.major&&Pe.minor===ge.minor&&Pe.patch===ge.patch)return!0}return!1}return!0}function Oe(ue,ge,be){try{ge=new de(ge,be)}catch{return!1}return ge.test(ue)}function Ne(ue,ge,be,Pe){var Ce,Fe,De,ze,Te;switch(ue=new G(ue,Pe),ge=new de(ge,Pe),be){case">":Ce=B,Fe=J,De=q,ze=">",Te=">=";break;case"<":Ce=q,Fe=ie,De=B,ze="<",Te="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Oe(ue,ge,Pe))return!1;for(var qe=0;qe<ge.set.length;++qe){var Ue=ge.set[qe],Ae=null,oe=null;if(Ue.forEach(function($e){$e.semver===fe&&($e=new ce(">=0.0.0")),Ae=Ae||$e,oe=oe||$e,Ce($e.semver,Ae.semver,Pe)?Ae=$e:De($e.semver,oe.semver,Pe)&&(oe=$e)}),Ae.operator===ze||Ae.operator===Te||(!oe.operator||oe.operator===ze)&&Fe(ue,oe.semver)||oe.operator===Te&&De(ue,oe.semver))return!1}return!0}ce.prototype.parse=function(ue){var ge=this.loose?R[W]:R[Q],be=ue.match(ge);if(!be)throw new TypeError("Invalid comparator: "+ue);this.operator=be[1],this.operator==="="&&(this.operator=""),be[2]?this.semver=new G(be[2],this.loose):this.semver=fe},ce.prototype.toString=function(){return this.value},ce.prototype.test=function(ue){return A("Comparator.test",ue,this.loose),this.semver===fe||(typeof ue=="string"&&(ue=new G(ue,this.loose)),ne(ue,this.operator,this.semver,this.loose))},ce.prototype.intersects=function(ue,ge){if(!(ue instanceof ce))throw new TypeError("a Comparator is required");var be;if(this.operator==="")return be=new de(ue.value,ge),Oe(this.value,be,ge);if(ue.operator==="")return be=new de(this.value,ge),Oe(ue.semver,be,ge);var Pe=!(this.operator!==">="&&this.operator!==">"||ue.operator!==">="&&ue.operator!==">"),Ce=!(this.operator!=="<="&&this.operator!=="<"||ue.operator!=="<="&&ue.operator!=="<"),Fe=this.semver.version===ue.semver.version,De=!(this.operator!==">="&&this.operator!=="<="||ue.operator!==">="&&ue.operator!=="<="),ze=ne(this.semver,"<",ue.semver,ge)&&(this.operator===">="||this.operator===">")&&(ue.operator==="<="||ue.operator==="<"),Te=ne(this.semver,">",ue.semver,ge)&&(this.operator==="<="||this.operator==="<")&&(ue.operator===">="||ue.operator===">");return Pe||Ce||Fe&&De||ze||Te},e.Range=de,de.prototype.format=function(){return this.range=this.set.map(function(ue){return ue.join(" ").trim()}).join("||").trim(),this.range},de.prototype.toString=function(){return this.range},de.prototype.parseRange=function(ue){var ge=this.loose;ue=ue.trim(),A("range",ue,ge);var be=ge?R[te]:R[V];ue=ue.replace(be,Ee),A("hyphen replace",ue),ue=ue.replace(R[H],"$1$2$3"),A("comparator trim",ue,R[H]),ue=(ue=(ue=ue.replace(R[N],"$1~")).replace(R[Z],"$1^")).split(/\s+/).join(" ");var Pe=ge?R[W]:R[Q],Ce=ue.split(" ").map(function(Fe){return function(De,ze){return A("comp",De),De=function(Te,qe){return Te.trim().split(/\s+/).map(function(Ue){return function(Ae,oe){A("caret",Ae,oe);var $e=oe?R[x]:R[X];return Ae.replace($e,function(pe,we,ve,ke,Ie){var Le;return A("caret",Ae,pe,we,ve,ke,Ie),me(we)?Le="":me(ve)?Le=">="+we+".0.0 <"+(+we+1)+".0.0":me(ke)?Le=we==="0"?">="+we+"."+ve+".0 <"+we+"."+(+ve+1)+".0":">="+we+"."+ve+".0 <"+(+we+1)+".0.0":Ie?(A("replaceCaret pr",Ie),Ie.charAt(0)!=="-"&&(Ie="-"+Ie),Le=we==="0"?ve==="0"?">="+we+"."+ve+"."+ke+Ie+" <"+we+"."+ve+"."+(+ke+1):">="+we+"."+ve+"."+ke+Ie+" <"+we+"."+(+ve+1)+".0":">="+we+"."+ve+"."+ke+Ie+" <"+(+we+1)+".0.0"):(A("no pr"),Le=we==="0"?ve==="0"?">="+we+"."+ve+"."+ke+" <"+we+"."+ve+"."+(+ke+1):">="+we+"."+ve+"."+ke+" <"+we+"."+(+ve+1)+".0":">="+we+"."+ve+"."+ke+" <"+(+we+1)+".0.0"),A("caret return",Le),Le})}(Ue,qe)}).join(" ")}(De,ze),A("caret",De),De=function(Te,qe){return Te.trim().split(/\s+/).map(function(Ue){return function(Ae,oe){var $e=oe?R[M]:R[F];return Ae.replace($e,function(pe,we,ve,ke,Ie){var Le;return A("tilde",Ae,pe,we,ve,ke,Ie),me(we)?Le="":me(ve)?Le=">="+we+".0.0 <"+(+we+1)+".0.0":me(ke)?Le=">="+we+"."+ve+".0 <"+we+"."+(+ve+1)+".0":Ie?(A("replaceTilde pr",Ie),Ie.charAt(0)!=="-"&&(Ie="-"+Ie),Le=">="+we+"."+ve+"."+ke+Ie+" <"+we+"."+(+ve+1)+".0"):Le=">="+we+"."+ve+"."+ke+" <"+we+"."+(+ve+1)+".0",A("tilde return",Le),Le})}(Ue,qe)}).join(" ")}(De,ze),A("tildes",De),De=function(Te,qe){return A("replaceXRanges",Te,qe),Te.split(/\s+/).map(function(Ue){return function(Ae,oe){Ae=Ae.trim();var $e=oe?R[u]:R[b];return Ae.replace($e,function(pe,we,ve,ke,Ie,Le){A("xRange",Ae,pe,we,ve,ke,Ie,Le);var Ve=me(ve),Be=Ve||me(ke),Me=Be||me(Ie);return we==="="&&Me&&(we=""),Ve?pe=we===">"||we==="<"?"<0.0.0":"*":we&&Me?(Be&&(ke=0),Me&&(Ie=0),we===">"?(we=">=",Be?(ve=+ve+1,ke=0,Ie=0):Me&&(ke=+ke+1,Ie=0)):we==="<="&&(we="<",Be?ve=+ve+1:ke=+ke+1),pe=we+ve+"."+ke+"."+Ie):Be?pe=">="+ve+".0.0 <"+(+ve+1)+".0.0":Me&&(pe=">="+ve+"."+ke+".0 <"+ve+"."+(+ke+1)+".0"),A("xRange return",pe),pe})}(Ue,qe)}).join(" ")}(De,ze),A("xrange",De),De=function(Te,qe){return A("replaceStars",Te,qe),Te.trim().replace(R[re],"")}(De,ze),A("stars",De),De}(Fe,ge)}).join(" ").split(/\s+/);return this.loose&&(Ce=Ce.filter(function(Fe){return!!Fe.match(Pe)})),Ce=Ce.map(function(Fe){return new ce(Fe,ge)})},de.prototype.intersects=function(ue,ge){if(!(ue instanceof de))throw new TypeError("a Range is required");return this.set.some(function(be){return be.every(function(Pe){return ue.set.some(function(Ce){return Ce.every(function(Fe){return Pe.intersects(Fe,ge)})})})})},e.toComparators=function(ue,ge){return new de(ue,ge).set.map(function(be){return be.map(function(Pe){return Pe.value}).join(" ").trim().split(" ")})},de.prototype.test=function(ue){if(!ue)return!1;typeof ue=="string"&&(ue=new G(ue,this.loose));for(var ge=0;ge<this.set.length;ge++)if(Re(this.set[ge],ue))return!0;return!1},e.satisfies=Oe,e.maxSatisfying=function(ue,ge,be){var Pe=null,Ce=null;try{var Fe=new de(ge,be)}catch{return null}return ue.forEach(function(De){Fe.test(De)&&(Pe&&Ce.compare(De)!==-1||(Ce=new G(Pe=De,be)))}),Pe},e.minSatisfying=function(ue,ge,be){var Pe=null,Ce=null;try{var Fe=new de(ge,be)}catch{return null}return ue.forEach(function(De){Fe.test(De)&&(Pe&&Ce.compare(De)!==1||(Ce=new G(Pe=De,be)))}),Pe},e.validRange=function(ue,ge){try{return new de(ue,ge).range||"*"}catch{return null}},e.ltr=function(ue,ge,be){return Ne(ue,ge,"<",be)},e.gtr=function(ue,ge,be){return Ne(ue,ge,">",be)},e.outside=Ne,e.prerelease=function(ue,ge){var be=ae(ue,ge);return be&&be.prerelease.length?be.prerelease:null},e.intersects=function(ue,ge,be){return ue=new de(ue,be),ge=new de(ge,be),ue.intersects(ge)},e.coerce=function(ue){if(ue instanceof G)return ue;if(typeof ue!="string")return null;var ge=ue.match(R[p]);return ge==null?null:ae((ge[1]||"0")+"."+(ge[2]||"0")+"."+(ge[3]||"0"))}}).call(this,I(1))},function(se,e){var I,L,A=se.exports={};function j(){throw new Error("setTimeout has not been defined")}function O(){throw new Error("clearTimeout has not been defined")}function R(y){if(I===setTimeout)return setTimeout(y,0);if((I===j||!I)&&setTimeout)return I=setTimeout,setTimeout(y,0);try{return I(y,0)}catch{try{return I.call(null,y,0)}catch{return I.call(this,y,0)}}}(function(){try{I=typeof setTimeout=="function"?setTimeout:j}catch{I=j}try{L=typeof clearTimeout=="function"?clearTimeout:O}catch{L=O}})();var k,g=[],C=!1,S=-1;function w(){C&&k&&(C=!1,k.length?g=k.concat(g):S=-1,g.length&&h())}function h(){if(!C){var y=R(w);C=!0;for(var l=g.length;l;){for(k=g,g=[];++S<l;)k&&k[S].run();S=-1,l=g.length}k=null,C=!1,function(d){if(L===clearTimeout)return clearTimeout(d);if((L===O||!L)&&clearTimeout)return L=clearTimeout,clearTimeout(d);try{L(d)}catch{try{return L.call(null,d)}catch{return L.call(this,d)}}}(y)}}function f(y,l){this.fun=y,this.array=l}function m(){}A.nextTick=function(y){var l=new Array(arguments.length-1);if(arguments.length>1)for(var d=1;d<arguments.length;d++)l[d-1]=arguments[d];g.push(new f(y,l)),g.length!==1||C||R(h)},f.prototype.run=function(){this.fun.apply(null,this.array)},A.title="browser",A.browser=!0,A.env={},A.argv=[],A.version="",A.versions={},A.on=m,A.addListener=m,A.once=m,A.off=m,A.removeListener=m,A.removeAllListeners=m,A.emit=m,A.prependListener=m,A.prependOnceListener=m,A.listeners=function(y){return[]},A.binding=function(y){throw new Error("process.binding is not supported")},A.cwd=function(){return"/"},A.chdir=function(y){throw new Error("process.chdir is not supported")},A.umask=function(){return 0}}])}),define(le[128],he([0,1]),function(se,e){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.$ds=void 0;class L{constructor(R,k,g){this.level=R,this.key=k,this.value=g,this.forward=[]}}const A=void 0;class j{constructor(R,k=2**16){this.comparator=R,this[I]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(k)|0),this.e=new L(this.c,A,A)}get size(){return this.f}clear(){this.e=new L(this.c,A,A),this.f=0}has(R){return!!j.g(this,R,this.comparator)}get(R){return j.g(this,R,this.comparator)?.value}set(R,k){return j.h(this,R,k,this.comparator)&&(this.f+=1),this}delete(R){const k=j.k(this,R,this.comparator);return k&&(this.f-=1),k}forEach(R,k){let g=this.e.forward[0];for(;g;)R.call(k,g.value,g.key,this),g=g.forward[0]}[(I=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let R=this.e.forward[0];for(;R;)yield[R.key,R.value],R=R.forward[0]}*keys(){let R=this.e.forward[0];for(;R;)yield R.key,R=R.forward[0]}*values(){let R=this.e.forward[0];for(;R;)yield R.value,R=R.forward[0]}toString(){let R="[SkipList]:",k=this.e.forward[0];for(;k;)R+=`node(${k.key}, ${k.value}, lvl:${k.level})`,k=k.forward[0];return R}static g(R,k,g){let C=R.e;for(let S=R.d-1;S>=0;S--)for(;C.forward[S]&&g(C.forward[S].key,k)<0;)C=C.forward[S];if(C=C.forward[0],C&&g(C.key,k)===0)return C}static h(R,k,g,C){const S=[];let w=R.e;for(let h=R.d-1;h>=0;h--){for(;w.forward[h]&&C(w.forward[h].key,k)<0;)w=w.forward[h];S[h]=w}if(w=w.forward[0],w&&C(w.key,k)===0)return w.value=g,!1;{const h=j.j(R);if(h>R.d){for(let f=R.d;f<h;f++)S[f]=R.e;R.d=h}w=new L(h,k,g);for(let f=0;f<h;f++)w.forward[f]=S[f].forward[f],S[f].forward[f]=w;return!0}}static j(R,k=.5){let g=1;for(;Math.random()<k&&g<R.c;)g+=1;return g}static k(R,k,g){const C=[];let S=R.e;for(let w=R.d-1;w>=0;w--){for(;S.forward[w]&&g(S.forward[w].key,k)<0;)S=S.forward[w];C[w]=S}if(S=S.forward[0],!S||g(S.key,k)!==0)return!1;for(let w=0;w<R.d&&C[w].forward[w]===S;w++)C[w].forward[w]=S.forward[w];for(;R.d>0&&R.e.forward[R.d-1]===A;)R.d-=1;return!0}}e.$ds=j}),define(le[63],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2d=void 0;const I=globalThis.performance&&typeof globalThis.performance.now=="function";class L{static create(j){return new L(j)}constructor(j){this.c=I&&j===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$2d=L}),define(le[3],he([0,1,7,85,2,86,63]),function(se,e,I,L,A,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.Event=void 0;const R=!1,k=!1;var g;(function(b){b.None=()=>A.$Tc.None;function u(J){if(k){const{onDidAddListener:ne}=J,ce=f.create();let fe=0;J.onDidAddListener=()=>{++fe===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ce.print()),ne?.()}}}function p(J,ne){return Q(J,()=>{},0,void 0,!0,void 0,ne)}b.defer=p;function P(J){return(ne,ce=null,fe)=>{let de=!1,me;return me=J(Ee=>{if(!de)return me?me.dispose():de=!0,ne.call(ce,Ee)},null,fe),de&&me.dispose(),me}}b.once=P;function N(J,ne,ce){return x((fe,de=null,me)=>J(Ee=>fe.call(de,ne(Ee)),null,me),ce)}b.map=N;function F(J,ne,ce){return x((fe,de=null,me)=>J(Ee=>{ne(Ee),fe.call(de,Ee)},null,me),ce)}b.forEach=F;function M(J,ne,ce){return x((fe,de=null,me)=>J(Ee=>ne(Ee)&&fe.call(de,Ee),null,me),ce)}b.filter=M;function z(J){return J}b.signal=z;function Z(...J){return(ne,ce=null,fe)=>{const de=(0,A.$Qc)(...J.map(me=>me(Ee=>ne.call(ce,Ee))));return W(de,fe)}}b.any=Z;function X(J,ne,ce,fe){let de=ce;return N(J,me=>(de=ne(de,me),de),fe)}b.reduce=X;function x(J,ne){let ce;const fe={onWillAddFirstListener(){ce=J(de.fire,de)},onDidRemoveLastListener(){ce?.dispose()}};ne||u(fe);const de=new $(fe);return ne?.add(de),de.event}function W(J,ne){return ne instanceof Array?ne.push(J):ne&&ne.add(J),J}function Q(J,ne,ce=100,fe=!1,de=!1,me,Ee){let Re,Oe,Ne,ue=0,ge;const be={leakWarningThreshold:me,onWillAddFirstListener(){Re=J(Ce=>{ue++,Oe=ne(Oe,Ce),fe&&!Ne&&(Pe.fire(Oe),Oe=void 0),ge=()=>{const Fe=Oe;Oe=void 0,Ne=void 0,(!fe||ue>1)&&Pe.fire(Fe),ue=0},typeof ce=="number"?(clearTimeout(Ne),Ne=setTimeout(ge,ce)):Ne===void 0&&(Ne=0,queueMicrotask(ge))})},onWillRemoveListener(){de&&ue>0&&ge?.()},onDidRemoveLastListener(){ge=void 0,Re.dispose()}};Ee||u(be);const Pe=new $(be);return Ee?.add(Pe),Pe.event}b.debounce=Q;function H(J,ne=0,ce){return b.debounce(J,(fe,de)=>fe?(fe.push(de),fe):[de],ne,void 0,!0,void 0,ce)}b.accumulate=H;function V(J,ne=(fe,de)=>fe===de,ce){let fe=!0,de;return M(J,me=>{const Ee=fe||!ne(me,de);return fe=!1,de=me,Ee},ce)}b.latch=V;function te(J,ne,ce){return[b.filter(J,ne,ce),b.filter(J,fe=>!ne(fe),ce)]}b.split=te;function re(J,ne=!1,ce=[],fe){let de=ce.slice(),me=J(Oe=>{de?de.push(Oe):Re.fire(Oe)});fe&&fe.add(me);const Ee=()=>{de?.forEach(Oe=>Re.fire(Oe)),de=null},Re=new $({onWillAddFirstListener(){me||(me=J(Oe=>Re.fire(Oe)),fe&&fe.add(me))},onDidAddFirstListener(){de&&(ne?setTimeout(Ee):Ee())},onDidRemoveLastListener(){me&&me.dispose(),me=null}});return fe&&fe.add(Re),Re.event}b.buffer=re;function ee(J,ne){return(fe,de,me)=>{const Ee=ne(new G);return J(function(Re){const Oe=Ee.evaluate(Re);Oe!==ae&&fe.call(de,Oe)},void 0,me)}}b.chain=ee;const ae=Symbol("HaltChainable");class G{constructor(){this.f=[]}map(ne){return this.f.push(ne),this}forEach(ne){return this.f.push(ce=>(ne(ce),ce)),this}filter(ne){return this.f.push(ce=>ne(ce)?ce:ae),this}reduce(ne,ce){let fe=ce;return this.f.push(de=>(fe=ne(fe,de),fe)),this}latch(ne=(ce,fe)=>ce===fe){let ce=!0,fe;return this.f.push(de=>{const me=ce||!ne(de,fe);return ce=!1,fe=de,me?de:ae}),this}evaluate(ne){for(const ce of this.f)if(ne=ce(ne),ne===ae)break;return ne}}function U(J,ne,ce=fe=>fe){const fe=(...Re)=>Ee.fire(ce(...Re)),de=()=>J.on(ne,fe),me=()=>J.removeListener(ne,fe),Ee=new $({onWillAddFirstListener:de,onDidRemoveLastListener:me});return Ee.event}b.fromNodeEventEmitter=U;function D(J,ne,ce=fe=>fe){const fe=(...Re)=>Ee.fire(ce(...Re)),de=()=>J.addEventListener(ne,fe),me=()=>J.removeEventListener(ne,fe),Ee=new $({onWillAddFirstListener:de,onDidRemoveLastListener:me});return Ee.event}b.fromDOMEventEmitter=D;function T(J){return new Promise(ne=>P(J)(ne))}b.toPromise=T;function B(J){const ne=new $;return J.then(ce=>{ne.fire(ce)},()=>{ne.fire(void 0)}).finally(()=>{ne.dispose()}),ne.event}b.fromPromise=B;function q(J,ne,ce){return ne(ce),J(fe=>ne(fe))}b.runAndSubscribe=q;class Y{constructor(ne,ce){this._observable=ne,this.f=0,this.g=!1;const fe={onWillAddFirstListener:()=>{ne.addObserver(this)},onDidRemoveLastListener:()=>{ne.removeObserver(this)}};ce||u(fe),this.emitter=new $(fe),ce&&ce.add(this.emitter)}beginUpdate(ne){this.f++}handlePossibleChange(ne){}handleChange(ne,ce){this.g=!0}endUpdate(ne){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function _(J,ne){return new Y(J,ne).emitter.event}b.fromObservable=_;function ie(J){return(ne,ce,fe)=>{let de=0,me=!1;const Ee={beginUpdate(){de++},endUpdate(){de--,de===0&&(J.reportChanges(),me&&(me=!1,ne.call(ce)))},handlePossibleChange(){},handleChange(){me=!0}};J.addObserver(Ee),J.reportChanges();const Re={dispose(){J.removeObserver(Ee)}};return fe instanceof A.$Sc?fe.add(Re):Array.isArray(fe)&&fe.push(Re),Re}}b.fromObservableLight=ie})(g||(e.Event=g={}));class C{static{this.all=new Set}static{this.f=0}constructor(u){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${u}_${C.f++}`,C.all.add(this)}start(u){this.g=new O.$2d,this.listenerCount=u}stop(){if(this.g){const u=this.g.elapsed();this.durations.push(u),this.elapsedOverall+=u,this.invocationCount+=1,this.g=void 0}}}e.$4d=C;let S=-1;function w(b){const u=S;return S=b,{dispose(){S=u}}}e.$5d=w;class h{constructor(u,p=Math.random().toString(18).slice(2,5)){this.threshold=u,this.name=p,this.g=0}dispose(){this.f?.clear()}check(u,p){const P=this.threshold;if(P<=0||p<P)return;this.f||(this.f=new Map);const N=this.f.get(u.value)||0;if(this.f.set(u.value,N+1),this.g-=1,this.g<=0){this.g=P*.5;let F,M=0;for(const[z,Z]of this.f)(!F||M<Z)&&(F=z,M=Z);console.warn(`[${this.name}] potential listener LEAK detected, having ${p} listeners already. MOST frequent listener (${M}):`),console.warn(F)}return()=>{const F=this.f.get(u.value)||0;this.f.set(u.value,F-1)}}}class f{static create(){return new f(new Error().stack??"")}constructor(u){this.value=u}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let m=0;class y{constructor(u){this.value=u,this.id=m++}}const l=2,d=(b,u)=>{if(b instanceof y)u(b);else for(let p=0;p<b.length;p++){const P=b[p];P&&u(P)}};class ${constructor(u){this.w=0,this.f=u,this.g=S>0||this.f?.leakWarningThreshold?new h(this.f?.leakWarningThreshold??S):void 0,this.j=this.f?._profName?new C(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(R){const u=this.t;queueMicrotask(()=>{d(u,p=>p.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(u,p,P)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),A.$Tc.None;if(this.m)return A.$Tc.None;p&&(u=u.bind(p));const N=new y(u);let F,M;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(N.stack=f.create(),F=this.g.check(N.stack,this.w+1)),R&&(N.stack=M??f.create()),this.t?this.t instanceof y?(this.u??=new v,this.t=[this.t,N]):this.t.push(N):(this.f?.onWillAddFirstListener?.(this),this.t=N,this.f?.onDidAddFirstListener?.(this)),this.w++;const z=(0,A.$Rc)(()=>{F?.(),this.x(N)});return P instanceof A.$Sc?P.add(z):Array.isArray(P)&&P.push(z),z},this.q}x(u){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const p=this.t,P=p.indexOf(u);if(P===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,p[P]=void 0;const N=this.u.current===this;if(this.w*l<=p.length){let F=0;for(let M=0;M<p.length;M++)p[M]?p[F++]=p[M]:N&&(this.u.end--,F<this.u.i&&this.u.i--);p.length=F}}y(u,p){if(!u)return;const P=this.f?.onListenerError||I.$1;if(!P){u.value(p);return}try{u.value(p)}catch(N){P(N)}}z(u){const p=u.current.t;for(;u.i<u.end;)this.y(p[u.i++],u.value);u.reset()}fire(u){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof y)this.y(this.t,u);else{const p=this.u;p.enqueue(this,u,this.t.length),this.z(p)}this.j?.stop()}hasListeners(){return this.w>0}}e.$6d=$;const c=()=>new v;e.$7d=c;class v{constructor(){this.i=-1,this.end=0}enqueue(u,p,P){this.i=0,this.end=P,this.current=u,this.value=p}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class i extends ${async fireAsync(u,p,P){if(this.t)for(this.h||(this.h=new j.$4c),d(this.t,N=>this.h.push([N.value,u]));this.h.size>0&&!p.isCancellationRequested;){const[N,F]=this.h.shift(),M=[],z={...F,token:p,waitUntil:Z=>{if(Object.isFrozen(M))throw new Error("waitUntil can NOT be called asynchronous");P&&(Z=P(Z,N)),M.push(Z)}};try{N(z)}catch(Z){(0,I.$1)(Z);continue}Object.freeze(M),await Promise.allSettled(M).then(Z=>{for(const X of Z)X.status==="rejected"&&(0,I.$1)(X.reason)})}}}e.$8d=i;class o extends ${get isPaused(){return this.h!==0}constructor(u){super(u),this.h=0,this.s=new j.$4c,this.A=u?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const u=Array.from(this.s);this.s.clear(),super.fire(this.A(u))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(u){this.w&&(this.h!==0?this.s.push(u):super.fire(u))}}e.$9d=o;class n extends o{constructor(u){super(u),this.k=u.delay??100}fire(u){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(u)}}e.$0d=n;class s extends ${constructor(u){super(u),this.h=[],this.k=u?.merge}fire(u){this.hasListeners()&&(this.h.push(u),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(p=>super.fire(p)),this.h=[]}))}}e.$$d=s;class t{constructor(){this.g=!1,this.h=[],this.f=new $({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(u){const p={event:u,listener:null};this.h.push(p),this.g&&this.m(p);const P=()=>{this.g&&this.o(p);const N=this.h.indexOf(p);this.h.splice(N,1)};return(0,A.$Rc)((0,L.$db)(P))}j(){this.g=!0,this.h.forEach(u=>this.m(u))}k(){this.g=!1,this.h.forEach(u=>this.o(u))}m(u){u.listener=u.event(p=>this.f.fire(p))}o(u){u.listener?.dispose(),u.listener=null}dispose(){this.f.dispose();for(const u of this.h)u.listener?.dispose();this.h=[]}}e.$_d=t;class r{constructor(u,p,P,N){this.f=new A.$Sc;const F=this.f.add(new t),M=this.f.add(new A.$3c);function z(Z){M.set(Z,F.add(N(Z)))}for(const Z of u)z(Z);this.f.add(p(Z=>{z(Z)})),this.f.add(P(Z=>{M.deleteAndDispose(Z)})),this.event=F.event}dispose(){this.f.dispose()}}e.$ae=r;class a{constructor(){this.f=[]}wrapEvent(u){return(p,P,N)=>u(F=>{const M=this.f[this.f.length-1];M?M.push(()=>p.call(P,F)):p.call(P,F)},void 0,N)}bufferEvents(u){const p=[];this.f.push(p);const P=u();return this.f.pop(),p.forEach(N=>N()),P}}e.$be=a;class E{constructor(){this.f=!1,this.g=g.None,this.h=A.$Tc.None,this.j=new $({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(u){this.g=u,this.f&&(this.h.dispose(),this.h=u(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$ce=E}),define(le[26],he([0,1,3]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$de=e.CancellationToken=void 0;const L=Object.freeze(function(R,k){const g=setTimeout(R.bind(k),0);return{dispose(){clearTimeout(g)}}});var A;(function(R){function k(g){return g===R.None||g===R.Cancelled||g instanceof j?!0:!g||typeof g!="object"?!1:typeof g.isCancellationRequested=="boolean"&&typeof g.onCancellationRequested=="function"}R.isCancellationToken=k,R.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:I.Event.None}),R.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(A||(e.CancellationToken=A={}));class j{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?L:(this.b||(this.b=new I.$6d),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class O{constructor(k){this.f=void 0,this.g=void 0,this.g=k&&k.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new j),this.f}cancel(){this.f?this.f instanceof j&&this.f.cancel():this.f=A.Cancelled}dispose(k=!1){k&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof j&&this.f.dispose():this.f=A.None}}e.$de=O}),define(le[129],he([0,1,26]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qe=e.$Pe=e.$Oe=void 0;class L{constructor(R){this.b=R,this.a=null}get(){if(this.a)return this.a;const R=new I.$de,k=this.b(R.token);return this.a={promise:k,dispose:()=>{this.a=null,R.cancel(),R.dispose()}},this.a}}e.$Oe=L;class A{constructor(R){this.c=R,this.a=void 0,this.b=void 0}get(R){const k=JSON.stringify(R);return this.b!==k&&(this.b=k,this.a=this.c(R)),this.a}}e.$Pe=A;class j{get cachedValues(){return this.a}constructor(R){this.b=R,this.a=new Map}get(R){if(this.a.has(R))return this.a.get(R);const k=this.b(R);return this.a.set(R,k),k}}e.$Qe=j}),define(le[47],he([0,1,7,2]),function(se,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=void 0;function A(c){const v=c;return v?typeof v.read=="function":!1}e.$ee=A;function j(c){const v=c;return v?[v.on,v.pause,v.resume,v.destroy].every(i=>typeof i=="function"):!1}e.$fe=j;function O(c){const v=c;return v?j(v.stream)&&Array.isArray(v.buffer)&&typeof v.ended=="boolean":!1}e.$ge=O;function R(c,v){return new k(c,v)}e.$he=R;class k{constructor(v,i){this.e=v,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(v){if(!this.a.destroyed){if(this.a.flowing)this.g(v);else if(this.b.data.push(v),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(v){this.a.destroyed||(this.a.flowing?this.h(v):this.b.error.push(v))}end(v){this.a.destroyed||(typeof v<"u"&&this.write(v),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(v){this.c.data.slice(0).forEach(i=>i(v))}h(v){this.c.error.length===0?(0,I.$1)(v):this.c.error.slice(0).forEach(i=>i(v))}i(){this.c.end.slice(0).forEach(v=>v())}on(v,i){if(!this.a.destroyed)switch(v){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(v,i){if(this.a.destroyed)return;let o;switch(v){case"data":o=this.c.data;break;case"end":o=this.c.end;break;case"error":o=this.c.error;break}if(o){const n=o.indexOf(i);n>=0&&o.splice(n,1)}}j(){if(this.b.data.length>0){const v=this.e(this.b.data);this.g(v),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(o=>o())}}k(){if(this.c.error.length>0){for(const v of this.b.error)this.h(v);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function g(c,v){const i=[];let o;for(;(o=c.read())!==null;)i.push(o);return v(i)}e.$ie=g;function C(c,v,i){const o=[];let n;for(;(n=c.read())!==null&&o.length<i;)o.push(n);return n===null&&o.length>0?v(o):{read:()=>{if(o.length>0)return o.shift();if(typeof n<"u"){const s=n;return n=void 0,s}return c.read()}}}e.$je=C;function S(c,v){return new Promise((i,o)=>{const n=[];w(c,{onData:s=>{v&&n.push(s)},onError:s=>{v?o(s):i(void 0)},onEnd:()=>{i(v?v(n):void 0)}})})}e.$ke=S;function w(c,v,i){c.on("error",o=>{i?.isCancellationRequested||v.onError(o)}),c.on("end",()=>{i?.isCancellationRequested||v.onEnd()}),c.on("data",o=>{i?.isCancellationRequested||v.onData(o)})}e.$le=w;function h(c,v){return new Promise((i,o)=>{const n=new L.$Sc,s=[],t=E=>{if(s.push(E),s.length>v)return n.dispose(),c.pause(),i({stream:c,buffer:s,ended:!1})},r=E=>(n.dispose(),o(E)),a=()=>(n.dispose(),i({stream:c,buffer:s,ended:!0}));n.add((0,L.$Rc)(()=>c.removeListener("error",r))),c.on("error",r),n.add((0,L.$Rc)(()=>c.removeListener("end",a))),c.on("end",a),n.add((0,L.$Rc)(()=>c.removeListener("data",t))),c.on("data",t)})}e.$me=h;function f(c,v){const i=R(v);return i.end(c),i}e.$ne=f;function m(){const c=R(()=>{throw new Error("not supported")});return c.end(),c}e.$oe=m;function y(c){let v=!1;return{read:()=>v?null:(v=!0,c)}}e.$pe=y;function l(c,v,i){const o=R(i);return w(c,{onData:n=>o.write(v.data(n)),onError:n=>o.error(v.error?v.error(n):n),onEnd:()=>o.end()}),o}e.$qe=l;function d(c,v,i){let o=!1;return{read:()=>{const n=v.read();return o?n:(o=!0,n!==null?i([c,n]):c)}}}e.$re=d;function $(c,v,i){let o=!1;const n=R(i);return w(v,{onData:s=>o?n.write(s):(o=!0,n.write(i([c,s]))),onError:s=>n.error(s),onEnd:()=>{o||(o=!0,n.write(c)),n.end()}}),n}e.$se=$}),define(le[14],he([0,1,53,47]),function(se,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=e.$Ee=e.$De=e.$Ce=e.$Be=e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=void 0;const A=typeof Buffer<"u",j=new I.$V(()=>new Uint8Array(256));let O,R;class k{static alloc(p){return A?new k(Buffer.allocUnsafe(p)):new k(new Uint8Array(p))}static wrap(p){return A&&!Buffer.isBuffer(p)&&(p=Buffer.from(p.buffer,p.byteOffset,p.byteLength)),new k(p)}static fromString(p,P){return!(P?.dontUseNodeBuffer||!1)&&A?new k(Buffer.from(p)):(O||(O=new TextEncoder),new k(O.encode(p)))}static fromByteArray(p){const P=k.alloc(p.length);for(let N=0,F=p.length;N<F;N++)P.buffer[N]=p[N];return P}static concat(p,P){if(typeof P>"u"){P=0;for(let M=0,z=p.length;M<z;M++)P+=p[M].byteLength}const N=k.alloc(P);let F=0;for(let M=0,z=p.length;M<z;M++){const Z=p[M];N.set(Z,F),F+=Z.byteLength}return N}constructor(p){this.buffer=p,this.byteLength=this.buffer.byteLength}clone(){const p=k.alloc(this.byteLength);return p.set(this),p}toString(){return A?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(p,P){return new k(this.buffer.subarray(p,P))}set(p,P){if(p instanceof k)this.buffer.set(p.buffer,P);else if(p instanceof Uint8Array)this.buffer.set(p,P);else if(p instanceof ArrayBuffer)this.buffer.set(new Uint8Array(p),P);else if(ArrayBuffer.isView(p))this.buffer.set(new Uint8Array(p.buffer,p.byteOffset,p.byteLength),P);else throw new Error("Unknown argument 'array'")}readUInt32BE(p){return w(this.buffer,p)}writeUInt32BE(p,P){h(this.buffer,p,P)}readUInt32LE(p){return f(this.buffer,p)}writeUInt32LE(p,P){m(this.buffer,p,P)}readUInt8(p){return y(this.buffer,p)}writeUInt8(p,P){l(this.buffer,p,P)}indexOf(p,P=0){return g(this.buffer,p instanceof k?p.buffer:p,P)}}e.$te=k;function g(u,p,P=0){const N=p.byteLength,F=u.byteLength;if(N===0)return 0;if(N===1)return u.indexOf(p[0]);if(N>F-P)return-1;const M=j.value;M.fill(p.length);for(let x=0;x<p.length;x++)M[p[x]]=p.length-x-1;let z=P+p.length-1,Z=z,X=-1;for(;z<F;)if(u[z]===p[Z]){if(Z===0){X=z;break}z--,Z--}else z+=Math.max(p.length-Z,M[u[z]]),Z=p.length-1;return X}e.$ue=g;function C(u,p){return u[p+0]<<0>>>0|u[p+1]<<8>>>0}e.$ve=C;function S(u,p,P){u[P+0]=p&255,p=p>>>8,u[P+1]=p&255}e.$we=S;function w(u,p){return u[p]*2**24+u[p+1]*2**16+u[p+2]*2**8+u[p+3]}e.$xe=w;function h(u,p,P){u[P+3]=p,p=p>>>8,u[P+2]=p,p=p>>>8,u[P+1]=p,p=p>>>8,u[P]=p}e.$ye=h;function f(u,p){return u[p+0]<<0>>>0|u[p+1]<<8>>>0|u[p+2]<<16>>>0|u[p+3]<<24>>>0}e.$ze=f;function m(u,p,P){u[P+0]=p&255,p=p>>>8,u[P+1]=p&255,p=p>>>8,u[P+2]=p&255,p=p>>>8,u[P+3]=p&255}e.$Ae=m;function y(u,p){return u[p]}e.$Be=y;function l(u,p,P){u[P]=p}e.$Ce=l;function d(u){return L.$ie(u,p=>k.concat(p))}e.$De=d;function $(u){return L.$pe(u)}e.$Ee=$;function c(u){return L.$ke(u,p=>k.concat(p))}e.$Fe=c;async function v(u){return u.ended?k.concat(u.buffer):k.concat([...u.buffer,await c(u.stream)])}e.$Ge=v;function i(u){return L.$ne(u,p=>k.concat(p))}e.$He=i;function o(u){return L.$qe(u,{data:p=>typeof p=="string"?k.fromString(p):k.wrap(p)},p=>k.concat(p))}e.$Ie=o;function n(u){return L.$he(p=>k.concat(p),u)}e.$Je=n;function s(u,p){return L.$re(u,p,P=>k.concat(P))}e.$Ke=s;function t(u,p){return L.$se(u,p,P=>k.concat(P))}e.$Le=t;function r(u){let p=0,P=0,N=0;const F=new Uint8Array(Math.floor(u.length/4*3)),M=Z=>{switch(P){case 3:F[N++]=p|Z,P=0;break;case 2:F[N++]=p|Z>>>2,p=Z<<6,P=3;break;case 1:F[N++]=p|Z>>>4,p=Z<<4,P=2;break;default:p=Z<<2,P=1}};for(let Z=0;Z<u.length;Z++){const X=u.charCodeAt(Z);if(X>=65&&X<=90)M(X-65);else if(X>=97&&X<=122)M(X-97+26);else if(X>=48&&X<=57)M(X-48+52);else if(X===43||X===45)M(62);else if(X===47||X===95)M(63);else{if(X===61)break;throw new SyntaxError(`Unexpected base64 character ${u[Z]}`)}}const z=N;for(;P>0;)M(0);return k.wrap(F).slice(0,z)}e.$Me=r;const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",E="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function b({buffer:u},p=!0,P=!1){const N=P?E:a;let F="";const M=u.byteLength%3;let z=0;for(;z<u.byteLength-M;z+=3){const Z=u[z+0],X=u[z+1],x=u[z+2];F+=N[Z>>>2],F+=N[(Z<<4|X>>>4)&63],F+=N[(X<<2|x>>>6)&63],F+=N[x&63]}if(M===1){const Z=u[z+0];F+=N[Z>>>2],F+=N[Z<<4&63],p&&(F+="==")}else if(M===2){const Z=u[z+0],X=u[z+1];F+=N[Z>>>2],F+=N[(Z<<4|X>>>4)&63],F+=N[X<<2&63],p&&(F+="=")}return F}e.$Ne=b}),define(le[27],he([0,1,129,53]),function(se,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sf=e.$Rf=e.$Qf=e.$Pf=e.GraphemeBreakType=e.$Of=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.$Df=e.$Cf=e.$Bf=e.$Af=e.$zf=e.$yf=e.$xf=e.$wf=e.$vf=e.$uf=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=e.$hf=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=e.$8e=e.$7e=e.$6e=e.$5e=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=void 0;function A(oe){return!oe||typeof oe!="string"?!0:oe.trim().length===0}e.$Te=A;const j=/{(\d+)}/g;function O(oe,...$e){return $e.length===0?oe:oe.replace(j,function(pe,we){const ve=parseInt(we,10);return isNaN(ve)||ve<0||ve>=$e.length?pe:$e[ve]})}e.$Ue=O;const R=/{([^}]+)}/g;function k(oe,$e){return Object.keys($e).length===0?oe:oe.replace(R,(pe,we)=>$e[we]??pe)}e.$Ve=k;function g(oe){return oe.replace(/[<>"'&]/g,$e=>{switch($e){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return $e})}e.$We=g;function C(oe){return oe.replace(/[<>&]/g,function($e){switch($e){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return $e}})}e.$Xe=C;function S(oe){return oe.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$Ye=S;function w(oe,$e){let pe=0;const we=$e.charCodeAt(0);for(let ve=oe.length-1;ve>=0;ve--)oe.charCodeAt(ve)===we&&pe++;return pe}e.$Ze=w;function h(oe,$e,pe="\u2026"){return oe.length<=$e?oe:`${oe.substr(0,$e)}${pe}`}e.$1e=h;function f(oe,$e,pe="\u2026"){if(oe.length<=$e)return oe;const we=Math.ceil($e/2)-pe.length/2,ve=Math.floor($e/2)-pe.length/2;return`${oe.substr(0,we)}${pe}${oe.substr(oe.length-ve)}`}e.$2e=f;function m(oe,$e=" "){const pe=y(oe,$e);return l(pe,$e)}e.$3e=m;function y(oe,$e){if(!oe||!$e)return oe;const pe=$e.length;if(pe===0||oe.length===0)return oe;let we=0;for(;oe.indexOf($e,we)===we;)we=we+pe;return oe.substring(we)}e.$4e=y;function l(oe,$e){if(!oe||!$e)return oe;const pe=$e.length,we=oe.length;if(pe===0||we===0)return oe;let ve=we,ke=-1;for(;ke=oe.lastIndexOf($e,ve-1),!(ke===-1||ke+pe!==ve);){if(ke===0)return"";ve=ke}return oe.substring(0,ve)}e.$5e=l;function d(oe){return oe.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$6e=d;function $(oe){return oe.replace(/\*/g,"")}e.$7e=$;function c(oe,$e,pe={}){if(!oe)throw new Error("Cannot create regex from empty string");$e||(oe=S(oe)),pe.wholeWord&&(/\B/.test(oe.charAt(0))||(oe="\\b"+oe),/\B/.test(oe.charAt(oe.length-1))||(oe=oe+"\\b"));let we="";return pe.global&&(we+="g"),pe.matchCase||(we+="i"),pe.multiline&&(we+="m"),pe.unicode&&(we+="u"),new RegExp(oe,we)}e.$8e=c;function v(oe){return oe.source==="^"||oe.source==="^$"||oe.source==="$"||oe.source==="^\\s*$"?!1:!!(oe.exec("")&&oe.lastIndex===0)}e.$9e=v;function i(oe){return oe.split(/\r\n|\r|\n/)}e.$0e=i;function o(oe){const $e=[],pe=oe.split(/(\r\n|\r|\n)/);for(let we=0;we<Math.ceil(pe.length/2);we++)$e.push(pe[2*we]+(pe[2*we+1]??""));return $e}e.$$e=o;function n(oe){for(let $e=0,pe=oe.length;$e<pe;$e++){const we=oe.charCodeAt($e);if(we!==32&&we!==9)return $e}return-1}e.$_e=n;function s(oe,$e=0,pe=oe.length){for(let we=$e;we<pe;we++){const ve=oe.charCodeAt(we);if(ve!==32&&ve!==9)return oe.substring($e,we)}return oe.substring($e,pe)}e.$af=s;function t(oe,$e=oe.length-1){for(let pe=$e;pe>=0;pe--){const we=oe.charCodeAt(pe);if(we!==32&&we!==9)return pe}return-1}e.$bf=t;function r(oe,$e,pe){const we=[];let ve=0;for(const ke of oe.matchAll($e)){if(we.push(oe.slice(ve,ke.index)),ke.index===void 0)throw new Error("match.index should be defined");ve=ke.index+ke[0].length,we.push(pe(ke[0],...ke.slice(1),ke.index,oe,ke.groups))}return we.push(oe.slice(ve)),Promise.all(we).then(ke=>ke.join(""))}e.$cf=r;function a(oe,$e){return oe<$e?-1:oe>$e?1:0}e.$df=a;function E(oe,$e,pe=0,we=oe.length,ve=0,ke=$e.length){for(;pe<we&&ve<ke;pe++,ve++){const Ve=oe.charCodeAt(pe),Be=$e.charCodeAt(ve);if(Ve<Be)return-1;if(Ve>Be)return 1}const Ie=we-pe,Le=ke-ve;return Ie<Le?-1:Ie>Le?1:0}e.$ef=E;function b(oe,$e){return u(oe,$e,0,oe.length,0,$e.length)}e.$ff=b;function u(oe,$e,pe=0,we=oe.length,ve=0,ke=$e.length){for(;pe<we&&ve<ke;pe++,ve++){let Ve=oe.charCodeAt(pe),Be=$e.charCodeAt(ve);if(Ve===Be)continue;if(Ve>=128||Be>=128)return E(oe.toLowerCase(),$e.toLowerCase(),pe,we,ve,ke);P(Ve)&&(Ve-=32),P(Be)&&(Be-=32);const Me=Ve-Be;if(Me!==0)return Me}const Ie=we-pe,Le=ke-ve;return Ie<Le?-1:Ie>Le?1:0}e.$gf=u;function p(oe){return oe>=48&&oe<=57}e.$hf=p;function P(oe){return oe>=97&&oe<=122}e.$if=P;function N(oe){return oe>=65&&oe<=90}e.$jf=N;function F(oe,$e){return oe.length===$e.length&&u(oe,$e)===0}e.$kf=F;function M(oe,$e){const pe=$e.length;return $e.length>oe.length?!1:u(oe,$e,0,pe)===0}e.$lf=M;function z(oe,$e){const pe=Math.min(oe.length,$e.length);let we;for(we=0;we<pe;we++)if(oe.charCodeAt(we)!==$e.charCodeAt(we))return we;return pe}e.$mf=z;function Z(oe,$e){const pe=Math.min(oe.length,$e.length);let we;const ve=oe.length-1,ke=$e.length-1;for(we=0;we<pe;we++)if(oe.charCodeAt(ve-we)!==$e.charCodeAt(ke-we))return we;return pe}e.$nf=Z;function X(oe){return 55296<=oe&&oe<=56319}e.$of=X;function x(oe){return 56320<=oe&&oe<=57343}e.$pf=x;function W(oe,$e){return(oe-55296<<10)+($e-56320)+65536}e.$qf=W;function Q(oe,$e,pe){const we=oe.charCodeAt(pe);if(X(we)&&pe+1<$e){const ve=oe.charCodeAt(pe+1);if(x(ve))return W(we,ve)}return we}e.$rf=Q;function H(oe,$e){const pe=oe.charCodeAt($e-1);if(x(pe)&&$e>1){const we=oe.charCodeAt($e-2);if(X(we))return W(we,pe)}return pe}class V{get offset(){return this.e}constructor($e,pe=0){this.c=$e,this.d=$e.length,this.e=pe}setOffset($e){this.e=$e}prevCodePoint(){const $e=H(this.c,this.e);return this.e-=$e>=65536?2:1,$e}nextCodePoint(){const $e=Q(this.c,this.d,this.e);return this.e+=$e>=65536?2:1,$e}eol(){return this.e>=this.d}}e.$sf=V;class te{get offset(){return this.c.offset}constructor($e,pe=0){this.c=new V($e,pe)}nextGraphemeLength(){const $e=Ce.getInstance(),pe=this.c,we=pe.offset;let ve=$e.getGraphemeBreakType(pe.nextCodePoint());for(;!pe.eol();){const ke=pe.offset,Ie=$e.getGraphemeBreakType(pe.nextCodePoint());if(be(ve,Ie)){pe.setOffset(ke);break}ve=Ie}return pe.offset-we}prevGraphemeLength(){const $e=Ce.getInstance(),pe=this.c,we=pe.offset;let ve=$e.getGraphemeBreakType(pe.prevCodePoint());for(;pe.offset>0;){const ke=pe.offset,Ie=$e.getGraphemeBreakType(pe.prevCodePoint());if(be(Ie,ve)){pe.setOffset(ke);break}ve=Ie}return we-pe.offset}eol(){return this.c.eol()}}e.$tf=te;function re(oe,$e){return new te(oe,$e).nextGraphemeLength()}e.$uf=re;function ee(oe,$e){return new te(oe,$e).prevGraphemeLength()}e.$vf=ee;function ae(oe,$e){$e>0&&x(oe.charCodeAt($e))&&$e--;const pe=$e+re(oe,$e);return[pe-ee(oe,pe),pe]}e.$wf=ae;function G(oe){const $e=new te(oe);let pe=0;for(;!$e.eol();)pe++,$e.nextGraphemeLength();return pe}e.$xf=G;let U;function D(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function T(oe){return U||(U=D()),U.test(oe)}e.$yf=T;const B=/^[\t\n\r\x20-\x7E]*$/;function q(oe){return B.test(oe)}e.$zf=q,e.$Af=/[\u2028\u2029]/;function Y(oe){return e.$Af.test(oe)}e.$Bf=Y;function _(oe){return oe>=11904&&oe<=55215||oe>=63744&&oe<=64255||oe>=65281&&oe<=65374}e.$Cf=_;function ie(oe){return oe>=127462&&oe<=127487||oe===8986||oe===8987||oe===9200||oe===9203||oe>=9728&&oe<=10175||oe===11088||oe===11093||oe>=127744&&oe<=128591||oe>=128640&&oe<=128764||oe>=128992&&oe<=129008||oe>=129280&&oe<=129535||oe>=129648&&oe<=129782}e.$Df=ie;function J(oe,$e,pe=""){const we=oe.trimStart();if(we.length<$e)return we;const ve=/\b/g;let ke=0;for(;ve.test(we)&&!(we.length-ve.lastIndex<$e);)ke=ve.lastIndex,ve.lastIndex+=1;return ke===0?we:pe+we.substring(ke).trimStart()}e.$Ef=J;const ne=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,ce=/\x1b\].*?\x07/g;function fe(oe){return oe&&(oe=oe.replace(ne,"").replace(ce,"")),oe}e.$Ff=fe,e.$Gf="\uFEFF";function de(oe){return!!(oe&&oe.length>0&&oe.charCodeAt(0)===65279)}e.$Hf=de;function me(oe){return de(oe)?oe.substr(1):oe}e.$If=me;function Ee(oe,$e){if(!oe||!$e||oe.length<$e.length)return!1;const pe=$e.length,we=oe.toLowerCase();let ve=0,ke=-1;for(;ve<pe;){const Ie=we.indexOf($e[ve],ke+1);if(Ie<0)return!1;ke=Ie,ve++}return!0}e.$Jf=Ee;function Re(oe,$e=!1){return oe?($e&&(oe=oe.replace(/\\./g,"")),oe.toLowerCase()!==oe):!1}e.$Kf=Re;function Oe(oe){return oe.charAt(0).toUpperCase()+oe.slice(1)}e.$Lf=Oe;function Ne(oe,$e=1){if($e===0)return"";let pe=-1;do pe=oe.indexOf(`
`,pe+1),$e--;while($e>0&&pe>=0);return pe===-1?oe:(oe[pe-1]==="\r"&&pe--,oe.substr(0,pe))}e.$Mf=Ne;function ue(oe){return oe=oe%(2*26),oe<26?String.fromCharCode(97+oe):String.fromCharCode(65+oe-26)}e.$Nf=ue;function ge(oe){return Ce.getInstance().getGraphemeBreakType(oe)}e.$Of=ge;function be(oe,$e){return oe===0?$e!==5&&$e!==7:oe===2&&$e===3?!1:oe===4||oe===2||oe===3||$e===4||$e===2||$e===3?!0:!(oe===8&&($e===8||$e===9||$e===11||$e===12)||(oe===11||oe===9)&&($e===9||$e===10)||(oe===12||oe===10)&&$e===10||$e===5||$e===13||$e===7||oe===1||oe===13&&$e===14||oe===6&&$e===6)}var Pe;(function(oe){oe[oe.Other=0]="Other",oe[oe.Prepend=1]="Prepend",oe[oe.CR=2]="CR",oe[oe.LF=3]="LF",oe[oe.Control=4]="Control",oe[oe.Extend=5]="Extend",oe[oe.Regional_Indicator=6]="Regional_Indicator",oe[oe.SpacingMark=7]="SpacingMark",oe[oe.L=8]="L",oe[oe.V=9]="V",oe[oe.T=10]="T",oe[oe.LV=11]="LV",oe[oe.LVT=12]="LVT",oe[oe.ZWJ=13]="ZWJ",oe[oe.Extended_Pictographic=14]="Extended_Pictographic"})(Pe||(e.GraphemeBreakType=Pe={}));class Ce{static{this.c=null}static getInstance(){return Ce.c||(Ce.c=new Ce),Ce.c}constructor(){this.d=Fe()}getGraphemeBreakType($e){if($e<32)return $e===10?3:$e===13?2:4;if($e<127)return 0;const pe=this.d,we=pe.length/3;let ve=1;for(;ve<=we;)if($e<pe[3*ve])ve=2*ve;else if($e>pe[3*ve+1])ve=2*ve+1;else return pe[3*ve+2];return 0}}function Fe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function De(oe,$e){if(oe===0)return 0;const pe=ze(oe,$e);if(pe!==void 0)return pe;const we=new V($e,oe);return we.prevCodePoint(),we.offset}e.$Pf=De;function ze(oe,$e){const pe=new V($e,oe);let we=pe.prevCodePoint();for(;Te(we)||we===65039||we===8419;){if(pe.offset===0)return;we=pe.prevCodePoint()}if(!ie(we))return;let ve=pe.offset;return ve>0&&pe.prevCodePoint()===8205&&(ve=pe.offset),ve}function Te(oe){return 127995<=oe&&oe<=127999}var qe;(function(oe){oe[oe.zwj=8205]="zwj",oe[oe.emojiVariantSelector=65039]="emojiVariantSelector",oe[oe.enclosingKeyCap=8419]="enclosingKeyCap"})(qe||(qe={})),e.$Qf="\xA0";class Ue{static{this.c=new L.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new I.$Pe($e=>{function pe(Me){const Ke=new Map;for(let Ge=0;Ge<Me.length;Ge+=2)Ke.set(Me[Ge],Me[Ge+1]);return Ke}function we(Me,Ke){const Ge=new Map(Me);for(const[_e,tt]of Ke)Ge.set(_e,tt);return Ge}function ve(Me,Ke){if(!Me)return Ke;const Ge=new Map;for(const[_e,tt]of Me)Ke.has(_e)&&Ge.set(_e,tt);return Ge}const ke=this.c.value;let Ie=$e.filter(Me=>!Me.startsWith("_")&&Me in ke);Ie.length===0&&(Ie=["_default"]);let Le;for(const Me of Ie){const Ke=pe(ke[Me]);Le=ve(Le,Ke)}const Ve=pe(ke._common),Be=we(Ve,Le);return new Ue(Be)})}static getInstance($e){return Ue.d.get(Array.from($e))}static{this.e=new L.$V(()=>Object.keys(Ue.c.value).filter($e=>!$e.startsWith("_")))}static getLocales(){return Ue.e.value}constructor($e){this.f=$e}isAmbiguous($e){return this.f.has($e)}getPrimaryConfusable($e){return this.f.get($e)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$Rf=Ue;class Ae{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Ae.c())),this.d}static isInvisibleCharacter($e){return Ae.e().has($e)}static get codePoints(){return Ae.e()}}e.$Sf=Ae}),define(le[54],he([0,1,27]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=e.$7i=void 0;function L(l){return A(l,0)}e.$7i=L;function A(l,d){switch(typeof l){case"object":return l===null?j(349,d):Array.isArray(l)?k(l,d):g(l,d);case"string":return R(l,d);case"boolean":return O(l,d);case"number":return j(l,d);case"undefined":return j(937,d);default:return j(617,d)}}e.$8i=A;function j(l,d){return(d<<5)-d+l|0}e.$9i=j;function O(l,d){return j(l?433:863,d)}function R(l,d){d=j(149417,d);for(let $=0,c=l.length;$<c;$++)d=j(l.charCodeAt($),d);return d}e.$0i=R;function k(l,d){return d=j(104579,d),l.reduce(($,c)=>A(c,$),d)}function g(l,d){return d=j(181387,d),Object.keys(l).sort().reduce(($,c)=>($=R(c,$),A(l[c],$)),d)}class C{constructor(){this.g=0}get value(){return this.g}hash(d){return this.g=A(d,this.g),this.g}}e.$$i=C;var S;(function(l){l[l.BLOCK_SIZE=64]="BLOCK_SIZE",l[l.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(S||(S={}));function w(l,d,$=32){const c=$-d,v=~((1<<c)-1);return(l<<d|(v&l)>>>c)>>>0}function h(l,d=0,$=l.byteLength,c=0){for(let v=0;v<$;v++)l[d+v]=c}function f(l,d,$="0"){for(;l.length<d;)l=$+l;return l}function m(l,d=32){return l instanceof ArrayBuffer?Array.from(new Uint8Array(l)).map($=>$.toString(16).padStart(2,"0")).join(""):f((l>>>0).toString(16),d/4)}e.$_i=m;class y{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(d){const $=d.length;if($===0)return;const c=this.p;let v=this.r,i=this.u,o,n;for(i!==0?(o=i,n=-1,i=0):(o=d.charCodeAt(0),n=0);;){let s=o;if(I.$of(o))if(n+1<$){const t=d.charCodeAt(n+1);I.$pf(t)?(n++,s=I.$qf(o,t)):s=65533}else{i=o;break}else I.$pf(o)&&(s=65533);if(v=this.w(c,v,s),n++,n<$)o=d.charCodeAt(n);else break}this.r=v,this.u=i}w(d,$,c){return c<128?d[$++]=c:c<2048?(d[$++]=192|(c&1984)>>>6,d[$++]=128|(c&63)>>>0):c<65536?(d[$++]=224|(c&61440)>>>12,d[$++]=128|(c&4032)>>>6,d[$++]=128|(c&63)>>>0):(d[$++]=240|(c&1835008)>>>18,d[$++]=128|(c&258048)>>>12,d[$++]=128|(c&4032)>>>6,d[$++]=128|(c&63)>>>0),$>=64&&(this.y(),$-=64,this.t+=64,d[0]=d[64],d[1]=d[65],d[2]=d[66]),$}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),m(this.h)+m(this.l)+m(this.m)+m(this.n)+m(this.o)}x(){this.p[this.r++]=128,h(this.p,this.r),this.r>56&&(this.y(),h(this.p));const d=8*this.t;this.q.setUint32(56,Math.floor(d/4294967296),!1),this.q.setUint32(60,d%4294967296,!1),this.y()}y(){const d=y.g,$=this.q;for(let a=0;a<64;a+=4)d.setUint32(a,$.getUint32(a,!1),!1);for(let a=64;a<320;a+=4)d.setUint32(a,w(d.getUint32(a-12,!1)^d.getUint32(a-32,!1)^d.getUint32(a-56,!1)^d.getUint32(a-64,!1),1),!1);let c=this.h,v=this.l,i=this.m,o=this.n,n=this.o,s,t,r;for(let a=0;a<80;a++)a<20?(s=v&i|~v&o,t=1518500249):a<40?(s=v^i^o,t=1859775393):a<60?(s=v&i|v&o|i&o,t=2400959708):(s=v^i^o,t=3395469782),r=w(c,5)+s+n+t+d.getUint32(a*4,!1)&4294967295,n=o,o=i,i=w(v,30),v=c,c=r;this.h=this.h+c&4294967295,this.l=this.l+v&4294967295,this.m=this.m+i&4294967295,this.n=this.n+o&4294967295,this.o=this.o+n&4294967295}}e.$aj=y}),define(le[88],he([0,1,27]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var L;(function(A){A[A.Ignore=0]="Ignore",A[A.Info=1]="Info",A[A.Warning=2]="Warning",A[A.Error=3]="Error"})(L||(L={})),function(A){const j="error",O="warning",R="warn",k="info",g="ignore";function C(w){return w?I.$kf(j,w)?A.Error:I.$kf(O,w)||I.$kf(R,w)?A.Warning:I.$kf(k,w)?A.Info:A.Ignore:A.Ignore}A.fromValue=C;function S(w){switch(w){case A.Error:return j;case A.Warning:return O;case A.Info:return k;default:return g}}A.toString=S}(L||(L={})),e.default=L}),define(le[130],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3d=void 0,e.$3d=Symbol("MicrotaskDelay")}),define(le[48],he([0,1,17,27]),function(se,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mi=e.$li=e.$ki=e.$ji=e.$ii=void 0;class A{constructor(){this.b="",this.c=0}reset(h){return this.b=h,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(h){const f=h.charCodeAt(0),m=this.b.charCodeAt(this.c);return f-m}value(){return this.b[this.c]}}e.$ii=A;class j{constructor(h=!0){this.e=h}reset(h){return this.b=h,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let h=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(h)this.c++;else break;else h=!1;return this}cmp(h){return this.e?(0,L.$ef)(h,this.b,0,h.length,this.c,this.d):(0,L.$gf)(h,this.b,0,h.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$ji=j;class O{constructor(h=!0,f=!0){this.f=h,this.g=f}reset(h){this.d=0,this.e=0,this.b=h,this.c=h.length;for(let f=h.length-1;f>=0;f--,this.c--){const m=this.b.charCodeAt(f);if(!(m===47||this.f&&m===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let h=!0;for(;this.e<this.c;this.e++){const f=this.b.charCodeAt(this.e);if(f===47||this.f&&f===92)if(h)this.d++;else break;else h=!1}return this}cmp(h){return this.g?(0,L.$ef)(h,this.b,0,h.length,this.d,this.e):(0,L.$gf)(h,this.b,0,h.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$ki=O;var R;(function(w){w[w.Scheme=1]="Scheme",w[w.Authority=2]="Authority",w[w.Path=3]="Path",w[w.Query=4]="Query",w[w.Fragment=5]="Fragment"})(R||(R={}));class k{constructor(h,f){this.f=h,this.g=f,this.d=[],this.e=0}reset(h){return this.c=h,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new O(!1,!this.f(h)),this.b.reset(h.path),this.b.value()&&this.d.push(3)),this.g(h)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(h){if(this.d[this.e]===1)return(0,L.$ff)(h,this.c.scheme);if(this.d[this.e]===2)return(0,L.$ff)(h,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(h);if(this.d[this.e]===4)return(0,L.$df)(h,this.c.query);if(this.d[this.e]===5)return(0,L.$df)(h,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$li=k;class g{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const h=this.right;return this.right=h.left,h.left=this,this.updateHeight(),h.updateHeight(),h}rotateRight(){const h=this.left;return this.left=h.right,h.right=this,this.updateHeight(),h.updateHeight(),h}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var C;(function(w){w[w.Left=-1]="Left",w[w.Mid=0]="Mid",w[w.Right=1]="Right"})(C||(C={}));class S{static forUris(h=()=>!1,f=()=>!1){return new S(new k(h,f))}static forPaths(h=!1){return new S(new O(void 0,!h))}static forStrings(){return new S(new A)}static forConfigKeys(){return new S(new j)}constructor(h){this.b=h}clear(){this.c=void 0}fill(h,f){if(f){const m=f.slice(0);(0,I.$Xb)(m);for(const y of m)this.set(y,h)}else{const m=h.slice(0);(0,I.$Xb)(m);for(const y of m)this.set(y[0],y[1])}}set(h,f){const m=this.b.reset(h);let y;this.c||(this.c=new g,this.c.segment=m.value());const l=[];for(y=this.c;;){const $=m.cmp(y.segment);if($>0)y.left||(y.left=new g,y.left.segment=m.value()),l.push([-1,y]),y=y.left;else if($<0)y.right||(y.right=new g,y.right.segment=m.value()),l.push([1,y]),y=y.right;else if(m.hasNext())m.next(),y.mid||(y.mid=new g,y.mid.segment=m.value()),l.push([0,y]),y=y.mid;else break}const d=y.value;y.value=f,y.key=h;for(let $=l.length-1;$>=0;$--){const c=l[$][1];c.updateHeight();const v=c.balanceFactor();if(v<-1||v>1){const i=l[$][0],o=l[$+1][0];if(i===1&&o===1)l[$][1]=c.rotateLeft();else if(i===-1&&o===-1)l[$][1]=c.rotateRight();else if(i===1&&o===-1)c.right=l[$+1][1]=l[$+1][1].rotateRight(),l[$][1]=c.rotateLeft();else if(i===-1&&o===1)c.left=l[$+1][1]=l[$+1][1].rotateLeft(),l[$][1]=c.rotateRight();else throw new Error;if($>0)switch(l[$-1][0]){case-1:l[$-1][1].left=l[$][1];break;case 1:l[$-1][1].right=l[$][1];break;case 0:l[$-1][1].mid=l[$][1];break}else this.c=l[0][1]}}return d}get(h){return this.d(h)?.value}d(h){const f=this.b.reset(h);let m=this.c;for(;m;){const y=f.cmp(m.segment);if(y>0)m=m.left;else if(y<0)m=m.right;else if(f.hasNext())f.next(),m=m.mid;else break}return m}has(h){const f=this.d(h);return!(f?.value===void 0&&f?.mid===void 0)}delete(h){return this.e(h,!1)}deleteSuperstr(h){return this.e(h,!0)}e(h,f){const m=this.b.reset(h),y=[];let l=this.c;for(;l;){const d=m.cmp(l.segment);if(d>0)y.push([-1,l]),l=l.left;else if(d<0)y.push([1,l]),l=l.right;else if(m.hasNext())m.next(),y.push([0,l]),l=l.mid;else break}if(l){if(f?(l.left=void 0,l.mid=void 0,l.right=void 0,l.height=1):(l.key=void 0,l.value=void 0),!l.mid&&!l.value)if(l.left&&l.right){const d=this.f(l.right);if(d.key){const{key:$,value:c,segment:v}=d;this.e(d.key,!1),l.key=$,l.value=c,l.segment=v}}else{const d=l.left??l.right;if(y.length>0){const[$,c]=y[y.length-1];switch($){case-1:c.left=d;break;case 0:c.mid=d;break;case 1:c.right=d;break}}else this.c=d}for(let d=y.length-1;d>=0;d--){const $=y[d][1];$.updateHeight();const c=$.balanceFactor();if(c>1?($.right.balanceFactor()>=0||($.right=$.right.rotateRight()),y[d][1]=$.rotateLeft()):c<-1&&($.left.balanceFactor()<=0||($.left=$.left.rotateLeft()),y[d][1]=$.rotateRight()),d>0)switch(y[d-1][0]){case-1:y[d-1][1].left=y[d][1];break;case 1:y[d-1][1].right=y[d][1];break;case 0:y[d-1][1].mid=y[d][1];break}else this.c=y[0][1]}}}f(h){for(;h.left;)h=h.left;return h}findSubstr(h){const f=this.b.reset(h);let m=this.c,y;for(;m;){const l=f.cmp(m.segment);if(l>0)m=m.left;else if(l<0)m=m.right;else if(f.hasNext())f.next(),y=m.value||y,m=m.mid;else break}return m&&m.value||y}findSuperstr(h){return this.g(h,!1)}g(h,f){const m=this.b.reset(h);let y=this.c;for(;y;){const l=m.cmp(y.segment);if(l>0)y=y.left;else if(l<0)y=y.right;else if(m.hasNext())m.next(),y=y.mid;else return y.mid?this.h(y.mid):f?y.value:void 0}}hasElementOrSubtree(h){return this.g(h,!0)!==void 0}forEach(h){for(const[f,m]of this)h(m,f)}*[Symbol.iterator](){yield*this.h(this.c)}h(h){const f=[];return this.j(h,f),f[Symbol.iterator]()}j(h,f){h&&(h.left&&this.j(h.left,f),h.value&&f.push([h.key,h.value]),h.mid&&this.j(h.mid,f),h.right&&this.j(h.right,f))}_isBalanced(){const h=f=>{if(!f)return!0;const m=f.balanceFactor();return m<-1||m>1?!1:h(f.left)&&h(f.right)};return h(this.c)}}e.$mi=S}),define(le[12],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=void 0;function I(v){return typeof v=="string"}e.$Tf=I;function L(v){return Array.isArray(v)&&v.every(i=>I(i))}e.$Uf=L;function A(v){return typeof v=="object"&&v!==null&&!Array.isArray(v)&&!(v instanceof RegExp)&&!(v instanceof Date)}e.$Vf=A;function j(v){const i=Object.getPrototypeOf(Uint8Array);return typeof v=="object"&&v instanceof i}e.$Wf=j;function O(v){return typeof v=="number"&&!isNaN(v)}e.$Xf=O;function R(v){return!!v&&typeof v[Symbol.iterator]=="function"}e.$Yf=R;function k(v){return v===!0||v===!1}e.$Zf=k;function g(v){return typeof v>"u"}e.$1f=g;function C(v){return!S(v)}e.$2f=C;function S(v){return g(v)||v===null}e.$3f=S;function w(v,i){if(!v)throw new Error(i?`Unexpected type, expected '${i}'`:"Unexpected type")}e.$4f=w;function h(v){if(S(v))throw new Error("Assertion Failed: argument is undefined or null");return v}e.$5f=h;function f(...v){const i=[];for(let o=0;o<v.length;o++){const n=v[o];if(S(n))throw new Error(`Assertion Failed: argument at index ${o} is undefined or null`);i.push(n)}return i}e.$6f=f;const m=Object.prototype.hasOwnProperty;function y(v){if(!A(v))return!1;for(const i in v)if(m.call(v,i))return!1;return!0}e.$7f=y;function l(v){return typeof v=="function"}e.$8f=l;function d(...v){return v.length>0&&v.every(l)}e.$9f=d;function $(v,i){const o=Math.min(v.length,i.length);for(let n=0;n<o;n++)c(v[n],i[n])}e.$0f=$;function c(v,i){if(I(i)){if(typeof v!==i)throw new Error(`argument does not match constraint: typeof ${i}`)}else if(l(i)){try{if(v instanceof i)return}catch{}if(!S(v)&&v.constructor===i||i.length===1&&i.call(void 0,v)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$$f=c}),define(le[30],he([0,1,12]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wn=e.$Vn=e.$Un=e.$Tn=e.$Sn=e.$Rn=e.$Qn=e.$Pn=e.$On=e.$Nn=e.$Mn=e.$Ln=void 0;function L(l){if(!l||typeof l!="object"||l instanceof RegExp)return l;const d=Array.isArray(l)?[]:{};return Object.entries(l).forEach(([$,c])=>{d[$]=c&&typeof c=="object"?L(c):c}),d}e.$Ln=L;function A(l){if(!l||typeof l!="object")return l;const d=[l];for(;d.length>0;){const $=d.shift();Object.freeze($);for(const c in $)if(j.call($,c)){const v=$[c];typeof v=="object"&&!Object.isFrozen(v)&&!(0,I.$Wf)(v)&&d.push(v)}}return l}e.$Mn=A;const j=Object.prototype.hasOwnProperty;function O(l,d){return R(l,d,new Set)}e.$Nn=O;function R(l,d,$){if((0,I.$3f)(l))return l;const c=d(l);if(typeof c<"u")return c;if(Array.isArray(l)){const v=[];for(const i of l)v.push(R(i,d,$));return v}if((0,I.$Vf)(l)){if($.has(l))throw new Error("Cannot clone recursive data-structure");$.add(l);const v={};for(const i in l)j.call(l,i)&&(v[i]=R(l[i],d,$));return $.delete(l),v}return l}function k(l,d,$=!0){return(0,I.$Vf)(l)?((0,I.$Vf)(d)&&Object.keys(d).forEach(c=>{c in l?$&&((0,I.$Vf)(l[c])&&(0,I.$Vf)(d[c])?k(l[c],d[c],$):l[c]=d[c]):l[c]=d[c]}),l):d}e.$On=k;function g(l,d){if(l===d)return!0;if(l==null||d===null||d===void 0||typeof l!=typeof d||typeof l!="object"||Array.isArray(l)!==Array.isArray(d))return!1;let $,c;if(Array.isArray(l)){if(l.length!==d.length)return!1;for($=0;$<l.length;$++)if(!g(l[$],d[$]))return!1}else{const v=[];for(c in l)v.push(c);v.sort();const i=[];for(c in d)i.push(c);if(i.sort(),!g(v,i))return!1;for($=0;$<v.length;$++)if(!g(l[v[$]],d[v[$]]))return!1}return!0}e.$Pn=g;function C(l){const d=new Set;return JSON.stringify(l,($,c)=>{if((0,I.$Vf)(c)||Array.isArray(c)){if(d.has(c))return"[Circular]";d.add(c)}return c})}e.$Qn=C;function S(l,d){const $=Object.create(null);return!l||!d||Object.keys(d).forEach(v=>{const i=l[v],o=d[v];g(i,o)||($[v]=o)}),$}e.$Rn=S;function w(l,d){const $=d.toLowerCase(),c=Object.keys(l).find(v=>v.toLowerCase()===$);return c?l[c]:l[d]}e.$Sn=w;function h(l,d){const $=Object.create(null);for(const[c,v]of Object.entries(l))d(c,v)&&($[c]=v);return $}e.$Tn=h;function f(l){let d=[];for(;Object.prototype!==l;)d=d.concat(Object.getOwnPropertyNames(l)),l=Object.getPrototypeOf(l);return d}e.$Un=f;function m(l){const d=[];for(const $ of f(l))typeof l[$]=="function"&&d.push($);return d}e.$Vn=m;function y(l,d){const $=v=>function(){const i=Array.prototype.slice.call(arguments,0);return d(v,i)},c={};for(const v of l)c[v]=$(v);return c}e.$Wn=y}),define(le[32],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cg=e.$Bg=void 0;const I=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(A){return I.test(A)}e.$Bg=L,e.$Cg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let A;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?A=crypto.getRandomValues.bind(crypto):A=function(R){for(let k=0;k<R.length;k++)R[k]=Math.floor(Math.random()*256);return R};const j=new Uint8Array(16),O=[];for(let R=0;R<256;R++)O.push(R.toString(16).padStart(2,"0"));return function(){A(j),j[6]=j[6]&15|64,j[8]=j[8]&63|128;let k=0,g="";return g+=O[j[k++]],g+=O[j[k++]],g+=O[j[k++]],g+=O[j[k++]],g+="-",g+=O[j[k++]],g+=O[j[k++]],g+="-",g+=O[j[k++]],g+=O[j[k++]],g+="-",g+=O[j[k++]],g+=O[j[k++]],g+="-",g+=O[j[k++]],g+=O[j[k++]],g+=O[j[k++]],g+=O[j[k++]],g+=O[j[k++]],g+=O[j[k++]],g}}()}),define(le[131],he([0,1,37]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mn=void 0;const L=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function A(O){const R=O.replace(/\-/g,":").toLowerCase();return!L.has(R)}function j(){const O=(0,I.networkInterfaces)();for(const R in O){const k=O[R];if(k){for(const{mac:g}of k)if(A(g))return g}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.$mn=j}),define(le[132],he([0,1,269,14]),function(se,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NV=void 0;class A extends I.Transform{constructor(O){if(super(),typeof O=="number")this.b=O,this.c=1;else{const R=Buffer.isBuffer(O)?O:Buffer.from(O);this.b=R.length===1?R[0]:R,this.c=R.length}}_transform(O,R,k){this.a?this.a=Buffer.concat([this.a,O]):this.a=O;let g=0;for(;g<this.a.length;){const C=typeof this.b=="number"?this.a.indexOf(this.b,g):(0,L.$ue)(this.a,this.b,g);if(C===-1)break;this.push(this.a.slice(g,C+this.c)),g=C+this.c}this.a=g===this.a.length?void 0:this.a.slice(g),k()}_flush(O){this.a&&this.push(this.a),O()}}e.$NV=A}),define(le[133],he([0,1,64]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gg=e.$Fg=e.$Eg=void 0;function L(R,k,g,C=1){let S=!1;return new Promise(w=>{const h=setTimeout(()=>{if(!S)return S=!0,w(0)},g);A(R,k,C,f=>{if(!S)return S=!0,clearTimeout(h),w(f)})})}e.$Eg=L;function A(R,k,g,C){if(k===0)return C(0);const S=new I.Socket;S.once("connect",()=>(O(S),A(R+g,k-1,g,C))),S.once("data",()=>{}),S.once("error",w=>(O(S),w.code!=="ECONNREFUSED"?A(R+g,k-1,g,C):C(R))),S.connect(R,"127.0.0.1")}e.$Fg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function j(R,k,g,C="127.0.0.1"){let S=!1,w,h=1;const f=I.createServer({pauseOnConnect:!0});function m(y,l){S||(S=!0,f.removeAllListeners(),f.close(),w&&clearTimeout(w),l(y))}return new Promise(y=>{w=setTimeout(()=>{m(0,y)},g),f.on("listening",()=>{m(R,y)}),f.on("error",l=>{l&&(l.code==="EADDRINUSE"||l.code==="EACCES")&&h<k?(R++,h++,f.listen(R,C)):m(0,y)}),f.on("close",()=>{m(0,y)}),f.listen(R,C)})}e.$Gg=j;function O(R){try{R.removeAllListeners("connect"),R.removeAllListeners("error"),R.end(),R.destroy(),R.unref()}catch(k){console.error(k)}}}),define(le[134],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4V=void 0;function I(L){return!!L.parentPort}e.$4V=I}),define(le[135],he([13,9]),function(se,e){return se.create("vs/base/common/date",e)}),define(le[65],he([0,1,135]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mm=e.$Lm=e.$Km=void 0;const L=60,A=L*60,j=A*24,O=j*7,R=j*30,k=j*365;function g(w,h,f,m){typeof w!="number"&&(w=w.getTime());const y=Math.round((new Date().getTime()-w)/1e3);if(y<-30)return(0,I.localize)(0,null,g(new Date().getTime()+y*1e3,!1));if(!m&&y<30)return(0,I.localize)(1,null);let l;return y<L?(l=y,h?l===1?f?(0,I.localize)(2,null,l):(0,I.localize)(3,null,l):f?(0,I.localize)(4,null,l):(0,I.localize)(5,null,l):l===1?f?(0,I.localize)(6,null,l):(0,I.localize)(7,null,l):f?(0,I.localize)(8,null,l):(0,I.localize)(9,null,l)):y<A?(l=Math.floor(y/L),h?l===1?f?(0,I.localize)(10,null,l):(0,I.localize)(11,null,l):f?(0,I.localize)(12,null,l):(0,I.localize)(13,null,l):l===1?f?(0,I.localize)(14,null,l):(0,I.localize)(15,null,l):f?(0,I.localize)(16,null,l):(0,I.localize)(17,null,l)):y<j?(l=Math.floor(y/A),h?l===1?f?(0,I.localize)(18,null,l):(0,I.localize)(19,null,l):f?(0,I.localize)(20,null,l):(0,I.localize)(21,null,l):l===1?f?(0,I.localize)(22,null,l):(0,I.localize)(23,null,l):f?(0,I.localize)(24,null,l):(0,I.localize)(25,null,l)):y<O?(l=Math.floor(y/j),h?l===1?(0,I.localize)(26,null,l):(0,I.localize)(27,null,l):l===1?(0,I.localize)(28,null,l):(0,I.localize)(29,null,l)):y<R?(l=Math.floor(y/O),h?l===1?f?(0,I.localize)(30,null,l):(0,I.localize)(31,null,l):f?(0,I.localize)(32,null,l):(0,I.localize)(33,null,l):l===1?f?(0,I.localize)(34,null,l):(0,I.localize)(35,null,l):f?(0,I.localize)(36,null,l):(0,I.localize)(37,null,l)):y<k?(l=Math.floor(y/R),h?l===1?f?(0,I.localize)(38,null,l):(0,I.localize)(39,null,l):f?(0,I.localize)(40,null,l):(0,I.localize)(41,null,l):l===1?f?(0,I.localize)(42,null,l):(0,I.localize)(43,null,l):f?(0,I.localize)(44,null,l):(0,I.localize)(45,null,l)):(l=Math.floor(y/k),h?l===1?f?(0,I.localize)(46,null,l):(0,I.localize)(47,null,l):f?(0,I.localize)(48,null,l):(0,I.localize)(49,null,l):l===1?f?(0,I.localize)(50,null,l):(0,I.localize)(51,null,l):f?(0,I.localize)(52,null,l):(0,I.localize)(53,null,l))}e.$Km=g;function C(w,h){const f=Math.abs(w/1e3);return f<1?h?(0,I.localize)(54,null,w):(0,I.localize)(55,null,w):f<L?h?(0,I.localize)(56,null,Math.round(w)/1e3):(0,I.localize)(57,null,Math.round(w)/1e3):f<A?h?(0,I.localize)(58,null,Math.round(w/(1e3*L))):(0,I.localize)(59,null,Math.round(w/(1e3*L))):f<j?h?(0,I.localize)(60,null,Math.round(w/(1e3*A))):(0,I.localize)(61,null,Math.round(w/(1e3*A))):(0,I.localize)(62,null,Math.round(w/(1e3*j)))}e.$Lm=C;function S(w){return w.getFullYear()+"-"+String(w.getMonth()+1).padStart(2,"0")+"-"+String(w.getDate()).padStart(2,"0")+"T"+String(w.getHours()).padStart(2,"0")+":"+String(w.getMinutes()).padStart(2,"0")+":"+String(w.getSeconds()).padStart(2,"0")+"."+(w.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$Mm=S}),define(le[136],he([13,9]),function(se,e){return se.create("vs/base/common/errorMessage",e)}),define(le[38],he([0,1,17,12,136]),function(se,e,I,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6i=e.$5i=e.$4i=void 0;function j(S,w){return w&&(S.stack||S.stacktrace)?A.localize(0,null,R(S),O(S.stack)||O(S.stacktrace)):R(S)}function O(S){return Array.isArray(S)?S.join(`
`):S}function R(S){return S.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${S.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof S.code=="string"&&typeof S.errno=="number"&&typeof S.syscall=="string"?A.localize(1,null,S.message):S.message||A.localize(2,null)}function k(S=null,w=!1){if(!S)return A.localize(3,null);if(Array.isArray(S)){const h=I.$Hb(S),f=k(h[0],w);return h.length>1?A.localize(4,null,f,h.length):f}if(L.$Tf(S))return S;if(S.detail){const h=S.detail;if(h.error)return j(h.error,w);if(h.exception)return j(h.exception,w)}return S.stack?j(S,w):S.message?S.message:A.localize(5,null)}e.$4i=k;function g(S){const w=S;return w instanceof Error&&Array.isArray(w.actions)}e.$5i=g;function C(S,w){let h;return typeof S=="string"?h=new Error(S):h=S,h.actions=w,h}e.$6i=C}),define(le[137],he([13,9]),function(se,e){return se.create("vs/base/common/jsonErrorMessages",e)}),define(le[138],he([0,1,137]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aq=void 0;function L(A){switch(A){case 1:return(0,I.localize)(0,null);case 2:return(0,I.localize)(1,null);case 3:return(0,I.localize)(2,null);case 4:return(0,I.localize)(3,null);case 5:return(0,I.localize)(4,null);case 6:return(0,I.localize)(5,null);case 7:return(0,I.localize)(6,null);case 8:return(0,I.localize)(7,null);case 9:return(0,I.localize)(8,null);default:return""}}e.$aq=L}),define(le[139],he([13,9]),function(se,e){return se.create("vs/base/common/platform",e)}),define(le[5],he([0,1,139]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J=e.$I=e.$H=e.$G=e.$F=e.$E=e.$D=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.Platform=e.$g=void 0,e.$g="en";let L=!1,A=!1,j=!1,O=!1,R=!1,k=!1,g=!1,C=!1,S=!1,w=!1,h,f=e.$g,m=e.$g,y,l;const d=globalThis;let $;typeof d.vscode<"u"&&typeof d.vscode.process<"u"?$=d.vscode.process:typeof process<"u"&&($=process);const c=typeof $?.versions?.electron=="string",v=c&&$?.type==="renderer";if(typeof $=="object"){L=$.platform==="win32",A=$.platform==="darwin",j=$.platform==="linux",O=j&&!!$.env.SNAP&&!!$.env.SNAP_REVISION,g=c,S=!!$.env.CI||!!$.env.BUILD_ARTIFACTSTAGINGDIRECTORY,h=e.$g,f=e.$g;const u=$.env.VSCODE_NLS_CONFIG;if(u)try{const p=JSON.parse(u),P=p.availableLanguages["*"];h=p.locale,m=p.osLocale,f=P||e.$g,y=p._translationsConfigFile}catch{}R=!0}else typeof navigator=="object"&&!v?(l=navigator.userAgent,L=l.indexOf("Windows")>=0,A=l.indexOf("Macintosh")>=0,C=(l.indexOf("Macintosh")>=0||l.indexOf("iPad")>=0||l.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,j=l.indexOf("Linux")>=0,w=l?.indexOf("Mobi")>=0,k=!0,h=I.getConfiguredDefaultLocale(I.localize(0,null))||e.$g,f=h,m=navigator.language):console.error("Unable to resolve platform.");var i;(function(u){u[u.Web=0]="Web",u[u.Mac=1]="Mac",u[u.Linux=2]="Linux",u[u.Windows=3]="Windows"})(i||(e.Platform=i={}));function o(u){switch(u){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$h=o;let n=0;A?n=1:L?n=3:j&&(n=2),e.$i=L,e.$j=A,e.$k=j,e.$l=O,e.$m=R,e.$n=g,e.$o=k,e.$p=k&&typeof d.importScripts=="function",e.$q=e.$p?d.origin:void 0,e.$r=C,e.$s=w,e.$t=S,e.$u=n,e.$v=l,e.$w=f;var s;(function(u){function p(){return e.$w}u.value=p;function P(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}u.isDefaultVariant=P;function N(){return e.$w==="en"}u.isDefault=N})(s||(e.Language=s={})),e.$x=h,e.$y=m,e.$z=y,e.$A=typeof d.postMessage=="function"&&!d.importScripts,e.$B=(()=>{if(e.$A){const u=[];d.addEventListener("message",P=>{if(P.data&&P.data.vscodeScheduleAsyncWork)for(let N=0,F=u.length;N<F;N++){const M=u[N];if(M.id===P.data.vscodeScheduleAsyncWork){u.splice(N,1),M.callback();return}}});let p=0;return P=>{const N=++p;u.push({id:N,callback:P}),d.postMessage({vscodeScheduleAsyncWork:N},"*")}}return u=>setTimeout(u)})();var t;(function(u){u[u.Windows=1]="Windows",u[u.Macintosh=2]="Macintosh",u[u.Linux=3]="Linux"})(t||(e.OperatingSystem=t={})),e.OS=A||C?2:L?1:3;let r=!0,a=!1;function E(){if(!a){a=!0;const u=new Uint8Array(2);u[0]=1,u[1]=2,r=new Uint16Array(u.buffer)[0]===513}return r}e.$D=E,e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function b(u){return parseFloat(u)>=20}e.$J=b}),define(le[36],he([0,1,5]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=e.$dc=e.env=e.cwd=void 0;let L;const A=globalThis.vscode;if(typeof A<"u"&&typeof A.process<"u"){const j=A.process;L={get platform(){return j.platform},get arch(){return j.arch},get env(){return j.env},cwd(){return j.cwd()}}}else typeof process<"u"?L={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:L={get platform(){return I.$i?"win32":I.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.$dc=L.platform,e.$ec=L.arch}),define(le[140],he([0,1,36]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tV=void 0;var L;(function(R){R.UNKNOWN="UNKNOWN",R.CINNAMON="CINNAMON",R.DEEPIN="DEEPIN",R.GNOME="GNOME",R.KDE3="KDE3",R.KDE4="KDE4",R.KDE5="KDE5",R.KDE6="KDE6",R.PANTHEON="PANTHEON",R.UNITY="UNITY",R.XFCE="XFCE",R.UKUI="UKUI",R.LXQT="LXQT"})(L||(L={}));const A="XDG_CURRENT_DESKTOP",j="KDE_SESSION_VERSION";function O(){const R=I.env[A];if(R){const g=R.split(":").map(C=>C.trim()).filter(C=>C.length>0);for(const C of g)switch(C){case"Unity":{const S=I.env.DESKTOP_SESSION;return S&&S.includes("gnome-fallback")?L.GNOME:L.UNITY}case"Deepin":return L.DEEPIN;case"GNOME":return L.GNOME;case"X-Cinnamon":return L.CINNAMON;case"KDE":{const S=I.env[j];return S==="5"?L.KDE5:S==="6"?L.KDE6:L.KDE4}case"Pantheon":return L.PANTHEON;case"XFCE":return L.XFCE;case"UKUI":return L.UKUI;case"LXQt":return L.LXQT}}const k=I.env.DESKTOP_SESSION;if(k)switch(k){case"deepin":return L.DEEPIN;case"gnome":case"mate":return L.GNOME;case"kde4":case"kde-plasma":return L.KDE4;case"kde":return j in I.env?L.KDE4:L.KDE3;case"xfce":case"xubuntu":return L.XFCE;case"ukui":return L.UKUI}return"GNOME_DESKTOP_SESSION_ID"in I.env?L.GNOME:"KDE_FULL_SESSION"in I.env?j in I.env?L.KDE4:L.KDE3:L.UNKNOWN}e.$tV=O}),define(le[15],he([0,1,36]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tc=e.sep=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=void 0;const L=65,A=97,j=90,O=122,R=46,k=47,g=92,C=58,S=63;class w extends Error{constructor(o,n,s){let t;typeof n=="string"&&n.indexOf("not ")===0?(t="must not be",n=n.replace(/^not /,"")):t="must be";const r=o.indexOf(".")!==-1?"property":"argument";let a=`The "${o}" ${r} ${t} of type ${n}`;a+=`. Received type ${typeof s}`,super(a),this.code="ERR_INVALID_ARG_TYPE"}}function h(i,o){if(i===null||typeof i!="object")throw new w(o,"Object",i)}function f(i,o){if(typeof i!="string")throw new w(o,"string",i)}const m=I.$dc==="win32";function y(i){return i===k||i===g}function l(i){return i===k}function d(i){return i>=L&&i<=j||i>=A&&i<=O}function $(i,o,n,s){let t="",r=0,a=-1,E=0,b=0;for(let u=0;u<=i.length;++u){if(u<i.length)b=i.charCodeAt(u);else{if(s(b))break;b=k}if(s(b)){if(!(a===u-1||E===1))if(E===2){if(t.length<2||r!==2||t.charCodeAt(t.length-1)!==R||t.charCodeAt(t.length-2)!==R){if(t.length>2){const p=t.lastIndexOf(n);p===-1?(t="",r=0):(t=t.slice(0,p),r=t.length-1-t.lastIndexOf(n)),a=u,E=0;continue}else if(t.length!==0){t="",r=0,a=u,E=0;continue}}o&&(t+=t.length>0?`${n}..`:"..",r=2)}else t.length>0?t+=`${n}${i.slice(a+1,u)}`:t=i.slice(a+1,u),r=u-a-1;a=u,E=0}else b===R&&E!==-1?++E:E=-1}return t}function c(i,o){h(o,"pathObject");const n=o.dir||o.root,s=o.base||`${o.name||""}${o.ext||""}`;return n?n===o.root?`${n}${s}`:`${n}${i}${s}`:s}e.$fc={resolve(...i){let o="",n="",s=!1;for(let t=i.length-1;t>=-1;t--){let r;if(t>=0){if(r=i[t],f(r,"path"),r.length===0)continue}else o.length===0?r=I.cwd():(r=I.env[`=${o}`]||I.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==o.toLowerCase()&&r.charCodeAt(2)===g)&&(r=`${o}\\`));const a=r.length;let E=0,b="",u=!1;const p=r.charCodeAt(0);if(a===1)y(p)&&(E=1,u=!0);else if(y(p))if(u=!0,y(r.charCodeAt(1))){let P=2,N=P;for(;P<a&&!y(r.charCodeAt(P));)P++;if(P<a&&P!==N){const F=r.slice(N,P);for(N=P;P<a&&y(r.charCodeAt(P));)P++;if(P<a&&P!==N){for(N=P;P<a&&!y(r.charCodeAt(P));)P++;(P===a||P!==N)&&(b=`\\\\${F}\\${r.slice(N,P)}`,E=P)}}}else E=1;else d(p)&&r.charCodeAt(1)===C&&(b=r.slice(0,2),E=2,a>2&&y(r.charCodeAt(2))&&(u=!0,E=3));if(b.length>0)if(o.length>0){if(b.toLowerCase()!==o.toLowerCase())continue}else o=b;if(s){if(o.length>0)break}else if(n=`${r.slice(E)}\\${n}`,s=u,u&&o.length>0)break}return n=$(n,!s,"\\",y),s?`${o}\\${n}`:`${o}${n}`||"."},normalize(i){f(i,"path");const o=i.length;if(o===0)return".";let n=0,s,t=!1;const r=i.charCodeAt(0);if(o===1)return l(r)?"\\":i;if(y(r))if(t=!0,y(i.charCodeAt(1))){let E=2,b=E;for(;E<o&&!y(i.charCodeAt(E));)E++;if(E<o&&E!==b){const u=i.slice(b,E);for(b=E;E<o&&y(i.charCodeAt(E));)E++;if(E<o&&E!==b){for(b=E;E<o&&!y(i.charCodeAt(E));)E++;if(E===o)return`\\\\${u}\\${i.slice(b)}\\`;E!==b&&(s=`\\\\${u}\\${i.slice(b,E)}`,n=E)}}}else n=1;else d(r)&&i.charCodeAt(1)===C&&(s=i.slice(0,2),n=2,o>2&&y(i.charCodeAt(2))&&(t=!0,n=3));let a=n<o?$(i.slice(n),!t,"\\",y):"";return a.length===0&&!t&&(a="."),a.length>0&&y(i.charCodeAt(o-1))&&(a+="\\"),s===void 0?t?`\\${a}`:a:t?`${s}\\${a}`:`${s}${a}`},isAbsolute(i){f(i,"path");const o=i.length;if(o===0)return!1;const n=i.charCodeAt(0);return y(n)||o>2&&d(n)&&i.charCodeAt(1)===C&&y(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let o,n;for(let r=0;r<i.length;++r){const a=i[r];f(a,"path"),a.length>0&&(o===void 0?o=n=a:o+=`\\${a}`)}if(o===void 0)return".";let s=!0,t=0;if(typeof n=="string"&&y(n.charCodeAt(0))){++t;const r=n.length;r>1&&y(n.charCodeAt(1))&&(++t,r>2&&(y(n.charCodeAt(2))?++t:s=!1))}if(s){for(;t<o.length&&y(o.charCodeAt(t));)t++;t>=2&&(o=`\\${o.slice(t)}`)}return e.$fc.normalize(o)},relative(i,o){if(f(i,"from"),f(o,"to"),i===o)return"";const n=e.$fc.resolve(i),s=e.$fc.resolve(o);if(n===s||(i=n.toLowerCase(),o=s.toLowerCase(),i===o))return"";let t=0;for(;t<i.length&&i.charCodeAt(t)===g;)t++;let r=i.length;for(;r-1>t&&i.charCodeAt(r-1)===g;)r--;const a=r-t;let E=0;for(;E<o.length&&o.charCodeAt(E)===g;)E++;let b=o.length;for(;b-1>E&&o.charCodeAt(b-1)===g;)b--;const u=b-E,p=a<u?a:u;let P=-1,N=0;for(;N<p;N++){const M=i.charCodeAt(t+N);if(M!==o.charCodeAt(E+N))break;M===g&&(P=N)}if(N!==p){if(P===-1)return s}else{if(u>p){if(o.charCodeAt(E+N)===g)return s.slice(E+N+1);if(N===2)return s.slice(E+N)}a>p&&(i.charCodeAt(t+N)===g?P=N:N===2&&(P=3)),P===-1&&(P=0)}let F="";for(N=t+P+1;N<=r;++N)(N===r||i.charCodeAt(N)===g)&&(F+=F.length===0?"..":"\\..");return E+=P,F.length>0?`${F}${s.slice(E,b)}`:(s.charCodeAt(E)===g&&++E,s.slice(E,b))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const o=e.$fc.resolve(i);if(o.length<=2)return i;if(o.charCodeAt(0)===g){if(o.charCodeAt(1)===g){const n=o.charCodeAt(2);if(n!==S&&n!==R)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(d(o.charCodeAt(0))&&o.charCodeAt(1)===C&&o.charCodeAt(2)===g)return`\\\\?\\${o}`;return i},dirname(i){f(i,"path");const o=i.length;if(o===0)return".";let n=-1,s=0;const t=i.charCodeAt(0);if(o===1)return y(t)?i:".";if(y(t)){if(n=s=1,y(i.charCodeAt(1))){let E=2,b=E;for(;E<o&&!y(i.charCodeAt(E));)E++;if(E<o&&E!==b){for(b=E;E<o&&y(i.charCodeAt(E));)E++;if(E<o&&E!==b){for(b=E;E<o&&!y(i.charCodeAt(E));)E++;if(E===o)return i;E!==b&&(n=s=E+1)}}}}else d(t)&&i.charCodeAt(1)===C&&(n=o>2&&y(i.charCodeAt(2))?3:2,s=n);let r=-1,a=!0;for(let E=o-1;E>=s;--E)if(y(i.charCodeAt(E))){if(!a){r=E;break}}else a=!1;if(r===-1){if(n===-1)return".";r=n}return i.slice(0,r)},basename(i,o){o!==void 0&&f(o,"ext"),f(i,"path");let n=0,s=-1,t=!0,r;if(i.length>=2&&d(i.charCodeAt(0))&&i.charCodeAt(1)===C&&(n=2),o!==void 0&&o.length>0&&o.length<=i.length){if(o===i)return"";let a=o.length-1,E=-1;for(r=i.length-1;r>=n;--r){const b=i.charCodeAt(r);if(y(b)){if(!t){n=r+1;break}}else E===-1&&(t=!1,E=r+1),a>=0&&(b===o.charCodeAt(a)?--a===-1&&(s=r):(a=-1,s=E))}return n===s?s=E:s===-1&&(s=i.length),i.slice(n,s)}for(r=i.length-1;r>=n;--r)if(y(i.charCodeAt(r))){if(!t){n=r+1;break}}else s===-1&&(t=!1,s=r+1);return s===-1?"":i.slice(n,s)},extname(i){f(i,"path");let o=0,n=-1,s=0,t=-1,r=!0,a=0;i.length>=2&&i.charCodeAt(1)===C&&d(i.charCodeAt(0))&&(o=s=2);for(let E=i.length-1;E>=o;--E){const b=i.charCodeAt(E);if(y(b)){if(!r){s=E+1;break}continue}t===-1&&(r=!1,t=E+1),b===R?n===-1?n=E:a!==1&&(a=1):n!==-1&&(a=-1)}return n===-1||t===-1||a===0||a===1&&n===t-1&&n===s+1?"":i.slice(n,t)},format:c.bind(null,"\\"),parse(i){f(i,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return o;const n=i.length;let s=0,t=i.charCodeAt(0);if(n===1)return y(t)?(o.root=o.dir=i,o):(o.base=o.name=i,o);if(y(t)){if(s=1,y(i.charCodeAt(1))){let P=2,N=P;for(;P<n&&!y(i.charCodeAt(P));)P++;if(P<n&&P!==N){for(N=P;P<n&&y(i.charCodeAt(P));)P++;if(P<n&&P!==N){for(N=P;P<n&&!y(i.charCodeAt(P));)P++;P===n?s=P:P!==N&&(s=P+1)}}}}else if(d(t)&&i.charCodeAt(1)===C){if(n<=2)return o.root=o.dir=i,o;if(s=2,y(i.charCodeAt(2))){if(n===3)return o.root=o.dir=i,o;s=3}}s>0&&(o.root=i.slice(0,s));let r=-1,a=s,E=-1,b=!0,u=i.length-1,p=0;for(;u>=s;--u){if(t=i.charCodeAt(u),y(t)){if(!b){a=u+1;break}continue}E===-1&&(b=!1,E=u+1),t===R?r===-1?r=u:p!==1&&(p=1):r!==-1&&(p=-1)}return E!==-1&&(r===-1||p===0||p===1&&r===E-1&&r===a+1?o.base=o.name=i.slice(a,E):(o.name=i.slice(a,r),o.base=i.slice(a,E),o.ext=i.slice(r,E))),a>0&&a!==s?o.dir=i.slice(0,a-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null};const v=(()=>{if(m){const i=/\\/g;return()=>{const o=I.cwd().replace(i,"/");return o.slice(o.indexOf("/"))}}return()=>I.cwd()})();e.$gc={resolve(...i){let o="",n=!1;for(let s=i.length-1;s>=-1&&!n;s--){const t=s>=0?i[s]:v();f(t,"path"),t.length!==0&&(o=`${t}/${o}`,n=t.charCodeAt(0)===k)}return o=$(o,!n,"/",l),n?`/${o}`:o.length>0?o:"."},normalize(i){if(f(i,"path"),i.length===0)return".";const o=i.charCodeAt(0)===k,n=i.charCodeAt(i.length-1)===k;return i=$(i,!o,"/",l),i.length===0?o?"/":n?"./":".":(n&&(i+="/"),o?`/${i}`:i)},isAbsolute(i){return f(i,"path"),i.length>0&&i.charCodeAt(0)===k},join(...i){if(i.length===0)return".";let o;for(let n=0;n<i.length;++n){const s=i[n];f(s,"path"),s.length>0&&(o===void 0?o=s:o+=`/${s}`)}return o===void 0?".":e.$gc.normalize(o)},relative(i,o){if(f(i,"from"),f(o,"to"),i===o||(i=e.$gc.resolve(i),o=e.$gc.resolve(o),i===o))return"";const n=1,s=i.length,t=s-n,r=1,a=o.length-r,E=t<a?t:a;let b=-1,u=0;for(;u<E;u++){const P=i.charCodeAt(n+u);if(P!==o.charCodeAt(r+u))break;P===k&&(b=u)}if(u===E)if(a>E){if(o.charCodeAt(r+u)===k)return o.slice(r+u+1);if(u===0)return o.slice(r+u)}else t>E&&(i.charCodeAt(n+u)===k?b=u:u===0&&(b=0));let p="";for(u=n+b+1;u<=s;++u)(u===s||i.charCodeAt(u)===k)&&(p+=p.length===0?"..":"/..");return`${p}${o.slice(r+b)}`},toNamespacedPath(i){return i},dirname(i){if(f(i,"path"),i.length===0)return".";const o=i.charCodeAt(0)===k;let n=-1,s=!0;for(let t=i.length-1;t>=1;--t)if(i.charCodeAt(t)===k){if(!s){n=t;break}}else s=!1;return n===-1?o?"/":".":o&&n===1?"//":i.slice(0,n)},basename(i,o){o!==void 0&&f(o,"ext"),f(i,"path");let n=0,s=-1,t=!0,r;if(o!==void 0&&o.length>0&&o.length<=i.length){if(o===i)return"";let a=o.length-1,E=-1;for(r=i.length-1;r>=0;--r){const b=i.charCodeAt(r);if(b===k){if(!t){n=r+1;break}}else E===-1&&(t=!1,E=r+1),a>=0&&(b===o.charCodeAt(a)?--a===-1&&(s=r):(a=-1,s=E))}return n===s?s=E:s===-1&&(s=i.length),i.slice(n,s)}for(r=i.length-1;r>=0;--r)if(i.charCodeAt(r)===k){if(!t){n=r+1;break}}else s===-1&&(t=!1,s=r+1);return s===-1?"":i.slice(n,s)},extname(i){f(i,"path");let o=-1,n=0,s=-1,t=!0,r=0;for(let a=i.length-1;a>=0;--a){const E=i.charCodeAt(a);if(E===k){if(!t){n=a+1;break}continue}s===-1&&(t=!1,s=a+1),E===R?o===-1?o=a:r!==1&&(r=1):o!==-1&&(r=-1)}return o===-1||s===-1||r===0||r===1&&o===s-1&&o===n+1?"":i.slice(o,s)},format:c.bind(null,"/"),parse(i){f(i,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return o;const n=i.charCodeAt(0)===k;let s;n?(o.root="/",s=1):s=0;let t=-1,r=0,a=-1,E=!0,b=i.length-1,u=0;for(;b>=s;--b){const p=i.charCodeAt(b);if(p===k){if(!E){r=b+1;break}continue}a===-1&&(E=!1,a=b+1),p===R?t===-1?t=b:u!==1&&(u=1):t!==-1&&(u=-1)}if(a!==-1){const p=r===0&&n?1:r;t===-1||u===0||u===1&&t===a-1&&t===r+1?o.base=o.name=i.slice(p,a):(o.name=i.slice(p,t),o.base=i.slice(p,a),o.ext=i.slice(t,a))}return r>0?o.dir=i.slice(0,r-1):n&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.$gc.win32=e.$fc.win32=e.$fc,e.$gc.posix=e.$fc.posix=e.$gc,e.$hc=m?e.$fc.normalize:e.$gc.normalize,e.$ic=m?e.$fc.isAbsolute:e.$gc.isAbsolute,e.$jc=m?e.$fc.join:e.$gc.join,e.$kc=m?e.$fc.resolve:e.$gc.resolve,e.$lc=m?e.$fc.relative:e.$gc.relative,e.$mc=m?e.$fc.dirname:e.$gc.dirname,e.$nc=m?e.$fc.basename:e.$gc.basename,e.$oc=m?e.$fc.extname:e.$gc.extname,e.$pc=m?e.$fc.format:e.$gc.format,e.$qc=m?e.$fc.parse:e.$gc.parse,e.$rc=m?e.$fc.toNamespacedPath:e.$gc.toNamespacedPath,e.sep=m?e.$fc.sep:e.$gc.sep,e.$tc=m?e.$fc.delimiter:e.$gc.delimiter}),define(le[49],he([0,1,15,5,27,12]),function(se,e,I,L,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=e.$fg=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=void 0;function O(r){return r===47||r===92}e.$_f=O;function R(r){return r.replace(/[\\/]/g,I.$gc.sep)}e.$ag=R;function k(r){return r.indexOf("/")===-1&&(r=R(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.$bg=k;function g(r,a=I.$gc.sep){if(!r)return"";const E=r.length,b=r.charCodeAt(0);if(O(b)){if(O(r.charCodeAt(1))&&!O(r.charCodeAt(2))){let p=3;const P=p;for(;p<E&&!O(r.charCodeAt(p));p++);if(P!==p&&!O(r.charCodeAt(p+1))){for(p+=1;p<E;p++)if(O(r.charCodeAt(p)))return r.slice(0,p+1).replace(/[\\/]/g,a)}}return a}else if(l(b)&&r.charCodeAt(1)===58)return O(r.charCodeAt(2))?r.slice(0,2)+a:r.slice(0,2);let u=r.indexOf("://");if(u!==-1){for(u+=3;u<E;u++)if(O(r.charCodeAt(u)))return r.slice(0,u+1)}return""}e.$cg=g;function C(r){if(!L.$i||!r||r.length<5)return!1;let a=r.charCodeAt(0);if(a!==92||(a=r.charCodeAt(1),a!==92))return!1;let E=2;const b=E;for(;E<r.length&&(a=r.charCodeAt(E),a!==92);E++);return!(b===E||(a=r.charCodeAt(E+1),isNaN(a)||a===92))}e.$dg=C;const S=/[\\/:\*\?"<>\|]/g,w=/[\\/]/g,h=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function f(r,a=L.$i){const E=a?S:w;return!(!r||r.length===0||/^\s+$/.test(r)||(E.lastIndex=0,E.test(r))||a&&h.test(r)||r==="."||r===".."||a&&r[r.length-1]==="."||a&&r.length!==r.trim().length||r.length>255)}e.$eg=f;function m(r,a,E){const b=r===a;return!E||b?b:!r||!a?!1:(0,A.$kf)(r,a)}e.$fg=m;function y(r,a,E,b=I.sep){if(r===a)return!0;if(!r||!a||a.length>r.length)return!1;if(E){if(!(0,A.$lf)(r,a))return!1;if(a.length===r.length)return!0;let p=a.length;return a.charAt(a.length-1)===b&&p--,r.charAt(p)===b}return a.charAt(a.length-1)!==b&&(a+=b),r.indexOf(a)===0}e.$gg=y;function l(r){return r>=65&&r<=90||r>=97&&r<=122}e.$hg=l;function d(r,a){return L.$i&&r.endsWith(":")&&(r+=I.sep),(0,I.$ic)(r)||(r=(0,I.$jc)(a,r)),r=(0,I.$hc)(r),L.$i?(r=(0,A.$5e)(r,I.sep),r.endsWith(":")&&(r+=I.sep)):(r=(0,A.$5e)(r,I.sep),r||(r=I.sep)),r}e.$ig=d;function $(r){const a=(0,I.$hc)(r);return L.$i?r.length>3?!1:c(a)&&(r.length===2||a.charCodeAt(2)===92):a===I.$gc.sep}e.$jg=$;function c(r,a=L.$i){return a?l(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.$kg=c;function v(r,a=L.$i){return c(r,a)?r[0]:void 0}e.$lg=v;function i(r,a,E){return a.length>r.length?-1:r===a?0:(E&&(r=r.toLowerCase(),a=a.toLowerCase()),r.indexOf(a))}e.$mg=i;function o(r){const a=r.split(":");let E,b,u;for(const p of a){const P=Number(p);(0,j.$Xf)(P)?b===void 0?b=P:u===void 0&&(u=P):E=E?[E,p].join(":"):p}if(!E)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:E,line:b!==void 0?b:void 0,column:u!==void 0?u:b!==void 0?1:void 0}}e.$ng=o;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",s="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function t(r,a,E=8){let b="";for(let p=0;p<E;p++){let P;p===0&&L.$i&&!a&&(E===3||E===4)?P=s:P=n,b+=P.charAt(Math.floor(Math.random()*P.length))}let u;return a?u=`${a}-${b}`:u=b,r?(0,I.$jc)(r,u):u}e.$og=t}),define(le[141],he([0,1,15]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ys=e.$xs=e.$ws=e.$vs=e.$us=void 0,e.$us=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const L={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},A={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function j(C){const S=(0,I.$oc)(C),w=L[S.toLowerCase()];return w!==void 0?w:O(C)}e.$vs=j;function O(C){const S=(0,I.$oc)(C);return A[S.toLowerCase()]}e.$ws=O;function R(C){for(const S in A)if(A[S]===C)return S}e.$xs=R;const k=/^(.+)\/(.+?)(;.+)?$/;function g(C,S){const w=k.exec(C);return w?`${w[1].toLowerCase()}/${w[2].toLowerCase()}${w[3]??""}`:S?void 0:C}e.$ys=g}),define(le[89],he([0,1,5]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4l=e.$3l=e.TerminateResponseCode=e.Source=void 0;var L;(function(R){R[R.stdout=0]="stdout",R[R.stderr=1]="stderr"})(L||(e.Source=L={}));var A;(function(R){R[R.Success=0]="Success",R[R.Unknown=1]="Unknown",R[R.AccessDenied=2]="AccessDenied",R[R.ProcessNotFound=3]="ProcessNotFound"})(A||(e.TerminateResponseCode=A={}));function j(R,...k){const g=k.reduce((w,h)=>(w[h]=!0,w),{}),C=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(R).filter(w=>!g[w]).forEach(w=>{for(let h=0;h<C.length;h++)if(w.search(C[h])!==-1){delete R[w];break}})}e.$3l=j;function O(R){R&&(delete R.DEBUG,I.$j&&delete R.DYLD_LIBRARY_PATH,I.$k&&delete R.LD_PRELOAD)}e.$4l=O}),define(le[10],he([0,1,15,5]),function(se,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wc=e.$vc=e.URI=void 0;const A=/^\w[\w\d+.-]*$/,j=/^\//,O=/^\/\//;function R(s,t){if(!s.scheme&&t)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!A.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!j.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(O.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function k(s,t){return!s&&!t?"file":s}function g(s,t){switch(s){case"https":case"http":case"file":t?t[0]!==S&&(t=S+t):t=S;break}return t}const C="",S="/",w=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class h{static isUri(t){return t instanceof h?!0:t?typeof t.authority=="string"&&typeof t.fragment=="string"&&typeof t.path=="string"&&typeof t.query=="string"&&typeof t.scheme=="string"&&typeof t.fsPath=="string"&&typeof t.with=="function"&&typeof t.toString=="function":!1}constructor(t,r,a,E,b,u=!1){typeof t=="object"?(this.scheme=t.scheme||C,this.authority=t.authority||C,this.path=t.path||C,this.query=t.query||C,this.fragment=t.fragment||C):(this.scheme=k(t,u),this.authority=r||C,this.path=g(this.scheme,a||C),this.query=E||C,this.fragment=b||C,R(this,u))}get fsPath(){return c(this,!1)}with(t){if(!t)return this;let{scheme:r,authority:a,path:E,query:b,fragment:u}=t;return r===void 0?r=this.scheme:r===null&&(r=C),a===void 0?a=this.authority:a===null&&(a=C),E===void 0?E=this.path:E===null&&(E=C),b===void 0?b=this.query:b===null&&(b=C),u===void 0?u=this.fragment:u===null&&(u=C),r===this.scheme&&a===this.authority&&E===this.path&&b===this.query&&u===this.fragment?this:new y(r,a,E,b,u)}static parse(t,r=!1){const a=w.exec(t);return a?new y(a[2]||C,n(a[4]||C),n(a[5]||C),n(a[7]||C),n(a[9]||C),r):new y(C,C,C,C,C)}static file(t){let r=C;if(L.$i&&(t=t.replace(/\\/g,S)),t[0]===S&&t[1]===S){const a=t.indexOf(S,2);a===-1?(r=t.substring(2),t=S):(r=t.substring(2,a),t=t.substring(a)||S)}return new y("file",r,t,C,C)}static from(t,r){return new y(t.scheme,t.authority,t.path,t.query,t.fragment,r)}static joinPath(t,...r){if(!t.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let a;return L.$i&&t.scheme==="file"?a=h.file(I.$fc.join(c(t,!0),...r)).path:a=I.$gc.join(t.path,...r),t.with({path:a})}toString(t=!1){return v(this,t)}toJSON(){return this}static revive(t){if(t){if(t instanceof h)return t;{const r=new y(t);return r._formatted=t.external??null,r._fsPath=t._sep===m?t.fsPath??null:null,r}}else return t}}e.URI=h;function f(s){return!s||typeof s!="object"?!1:typeof s.scheme=="string"&&(typeof s.authority=="string"||typeof s.authority>"u")&&(typeof s.path=="string"||typeof s.path>"u")&&(typeof s.query=="string"||typeof s.query>"u")&&(typeof s.fragment=="string"||typeof s.fragment>"u")}e.$vc=f;const m=L.$i?1:void 0;class y extends h{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=c(this,!1)),this._fsPath}toString(t=!1){return t?v(this,!0):(this._formatted||(this._formatted=v(this,!1)),this._formatted)}toJSON(){const t={$mid:1};return this._fsPath&&(t.fsPath=this._fsPath,t._sep=m),this._formatted&&(t.external=this._formatted),this.path&&(t.path=this.path),this.scheme&&(t.scheme=this.scheme),this.authority&&(t.authority=this.authority),this.query&&(t.query=this.query),this.fragment&&(t.fragment=this.fragment),t}}const l={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function d(s,t,r){let a,E=-1;for(let b=0;b<s.length;b++){const u=s.charCodeAt(b);if(u>=97&&u<=122||u>=65&&u<=90||u>=48&&u<=57||u===45||u===46||u===95||u===126||t&&u===47||r&&u===91||r&&u===93||r&&u===58)E!==-1&&(a+=encodeURIComponent(s.substring(E,b)),E=-1),a!==void 0&&(a+=s.charAt(b));else{a===void 0&&(a=s.substr(0,b));const p=l[u];p!==void 0?(E!==-1&&(a+=encodeURIComponent(s.substring(E,b)),E=-1),a+=p):E===-1&&(E=b)}}return E!==-1&&(a+=encodeURIComponent(s.substring(E))),a!==void 0?a:s}function $(s){let t;for(let r=0;r<s.length;r++){const a=s.charCodeAt(r);a===35||a===63?(t===void 0&&(t=s.substr(0,r)),t+=l[a]):t!==void 0&&(t+=s[r])}return t!==void 0?t:s}function c(s,t){let r;return s.authority&&s.path.length>1&&s.scheme==="file"?r=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?t?r=s.path.substr(1):r=s.path[1].toLowerCase()+s.path.substr(2):r=s.path,L.$i&&(r=r.replace(/\//g,"\\")),r}e.$wc=c;function v(s,t){const r=t?$:d;let a="",{scheme:E,authority:b,path:u,query:p,fragment:P}=s;if(E&&(a+=E,a+=":"),(b||E==="file")&&(a+=S,a+=S),b){let N=b.indexOf("@");if(N!==-1){const F=b.substr(0,N);b=b.substr(N+1),N=F.lastIndexOf(":"),N===-1?a+=r(F,!1,!1):(a+=r(F.substr(0,N),!1,!1),a+=":",a+=r(F.substr(N+1),!1,!0)),a+="@"}b=b.toLowerCase(),N=b.lastIndexOf(":"),N===-1?a+=r(b,!1,!0):(a+=r(b.substr(0,N),!1,!0),a+=b.substr(N))}if(u){if(u.length>=3&&u.charCodeAt(0)===47&&u.charCodeAt(2)===58){const N=u.charCodeAt(1);N>=65&&N<=90&&(u=`/${String.fromCharCode(N+32)}:${u.substr(3)}`)}else if(u.length>=2&&u.charCodeAt(1)===58){const N=u.charCodeAt(0);N>=65&&N<=90&&(u=`${String.fromCharCode(N+32)}:${u.substr(2)}`)}a+=r(u,!0,!1)}return p&&(a+="?",a+=r(p,!1,!1)),P&&(a+="#",a+=t?P:d(P,!1,!1)),a}function i(s){try{return decodeURIComponent(s)}catch{return s.length>3?s.substr(0,3)+i(s.substr(3)):s}}const o=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function n(s){return s.match(o)?s.replace(o,t=>i(t)):s}}),define(le[142],he([0,1,10]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$Dq=e.$Cq=e.$Bq=void 0;function L(g){const C=g;return C&&typeof C.type=="string"&&typeof C.severity=="string"}e.$Bq=L;function A(g){const C=[];let S;try{const w=JSON.parse(g.arguments),h=w[w.length-1];h&&h.__$stack&&(w.pop(),S=h.__$stack),C.push(...w)}catch{C.push("Unable to log remote console arguments",g.arguments)}return{args:C,stack:S}}e.$Cq=A;function j(g){if(typeof g!="string")return j(A(g).stack);const C=g;if(C){const S=O(C),w=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(S||"");if(w&&w.length===4)return{uri:I.URI.file(w[1]),line:Number(w[2]),column:Number(w[3])}}}e.$Dq=j;function O(g){if(!g)return g;const C=g.indexOf(`
`);return C===-1?g:g.substring(0,C)}function R(g,C){const{args:S,stack:w}=A(g),h=typeof S[0]=="string"&&S.length===1;let f=O(w);f&&(f=`(${f.trim()})`);let m=[];if(typeof S[0]=="string"?f&&h?m=[`%c[${C}] %c${S[0]} %c${f}`,k("blue"),k(""),k("grey")]:m=[`%c[${C}] %c${S[0]}`,k("blue"),k(""),...S.slice(1)]:m=[`%c[${C}]%`,k("blue"),...S],f&&!h&&m.push(f),typeof console[g.severity]!="function")throw new Error("Unknown console method");console[g.severity].apply(console,m)}e.log=R;function k(g){return`color: ${g}`}}),define(le[66],he([0,1,14,10]),function(se,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ph=e.$Oh=e.$Nh=void 0;function A(k){return JSON.stringify(k,O)}e.$Nh=A;function j(k){let g=JSON.parse(k);return g=R(g),g}e.$Oh=j;function O(k,g){return g instanceof RegExp?{$mid:2,source:g.source,flags:g.flags}:g}function R(k,g=0){if(!k||g>200)return k;if(typeof k=="object"){switch(k.$mid){case 1:return L.URI.revive(k);case 2:return new RegExp(k.source,k.flags);case 17:return new Date(k.source)}if(k instanceof I.$te||k instanceof Uint8Array)return k;if(Array.isArray(k))for(let C=0;C<k.length;++C)k[C]=R(k[C],g+1);else for(const C in k)Object.hasOwnProperty.call(k,C)&&(k[C]=R(k[C],g+1))}return k}e.$Ph=R}),define(le[23],he([0,1,7,5,27,10,15]),function(se,e,I,L,A,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.Schemas=void 0;var R;(function(f){f.inMemory="inmemory",f.vscode="vscode",f.internal="private",f.walkThrough="walkThrough",f.walkThroughSnippet="walkThroughSnippet",f.http="http",f.https="https",f.file="file",f.mailto="mailto",f.untitled="untitled",f.data="data",f.command="command",f.vscodeRemote="vscode-remote",f.vscodeRemoteResource="vscode-remote-resource",f.vscodeManagedRemoteResource="vscode-managed-remote-resource",f.vscodeUserData="vscode-userdata",f.vscodeCustomEditor="vscode-custom-editor",f.vscodeNotebookCell="vscode-notebook-cell",f.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",f.vscodeNotebookCellOutput="vscode-notebook-cell-output",f.vscodeInteractiveInput="vscode-interactive-input",f.vscodeSettings="vscode-settings",f.vscodeWorkspaceTrust="vscode-workspace-trust",f.vscodeTerminal="vscode-terminal",f.vscodeChatCodeBlock="vscode-chat-code-block",f.vscodeChatSesssion="vscode-chat-editor",f.webviewPanel="webview-panel",f.vscodeWebview="vscode-webview",f.extension="extension",f.vscodeFileResource="vscode-file",f.tmp="tmp",f.vsls="vsls",f.vscodeSourceControl="vscode-scm",f.codeSetting="code-setting"})(R||(e.Schemas=R={}));function k(f,m){return j.URI.isUri(f)?(0,A.$kf)(f.scheme,m):(0,A.$lf)(f,m+":")}e.$pg=k;function g(f,...m){return m.some(y=>k(f,y))}e.$qg=g,e.$rg="vscode-tkn",e.$sg="tkn";class C{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(m){this.d=m}setDelegate(m){this.e=m}setServerRootPath(m,y){this.f=S(m,y)}getServerRootPath(){return this.f}get g(){return O.$gc.join(this.f,R.vscodeRemoteResource)}set(m,y,l){this.a[m]=y,this.b[m]=l}setConnectionToken(m,y){this.c[m]=y}getPreferredWebSchema(){return this.d}rewrite(m){if(this.e)try{return this.e(m)}catch(v){return I.$1(v),m}const y=m.authority;let l=this.a[y];l&&l.indexOf(":")!==-1&&l.indexOf("[")===-1&&(l=`[${l}]`);const d=this.b[y],$=this.c[y];let c=`path=${encodeURIComponent(m.path)}`;return typeof $=="string"&&(c+=`&${e.$sg}=${encodeURIComponent($)}`),j.URI.from({scheme:L.$o?this.d:R.vscodeRemoteResource,authority:`${l}:${d}`,path:this.g,query:c})}}e.$tg=new C;function S(f,m){return O.$gc.join(m??"/",`${f.quality??"oss"}-${f.commit??"dev"}`)}e.$ug=S,e.$vg="vs/../../extensions",e.$wg="vs/../../node_modules",e.$xg="vs/../../node_modules.asar",e.$yg="vs/../../node_modules.asar.unpacked",e.$zg="vscode-app";class w{static{this.a=e.$zg}asBrowserUri(m){const y=this.b(m,se);return this.uriToBrowserUri(y)}uriToBrowserUri(m){return m.scheme===R.vscodeRemote?e.$tg.rewrite(m):m.scheme===R.file&&(L.$m||L.$q===`${R.vscodeFileResource}://${w.a}`)?m.with({scheme:R.vscodeFileResource,authority:m.authority||w.a,query:null,fragment:null}):m}asFileUri(m){const y=this.b(m,se);return this.uriToFileUri(y)}uriToFileUri(m){return m.scheme===R.vscodeFileResource?m.with({scheme:R.file,authority:m.authority!==w.a?m.authority:null,query:null,fragment:null}):m}b(m,y){return j.URI.isUri(m)?m:j.URI.parse(y.toUrl(m))}}e.$Ag=new w;var h;(function(f){const m=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);f.CoopAndCoep=Object.freeze(m.get("3"));const y="vscode-coi";function l($){let c;typeof $=="string"?c=new URL($).searchParams:$ instanceof URL?c=$.searchParams:j.URI.isUri($)&&(c=new URL($.toString(!0)).searchParams);const v=c?.get(y);if(v)return m.get(v)}f.getHeadersFromQuery=l;function d($,c,v){if(!globalThis.crossOriginIsolated)return;const i=c&&v?"3":v?"2":"1";$ instanceof URLSearchParams?$.set(y,i):$[y]=i}f.addSearchParam=d})(h||(e.COI=h={}))}),define(le[143],he([0,1,124,23,5,10]),function(se,e,I,L,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xD=void 0;class O{constructor(w,h,f){this.id=w,this.dependencies=h,this.callback=f}}class R{static{this.INSTANCE=new R}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(w,h,f)=>{typeof w!="string"&&(f=h,h=w,w=null),(typeof h!="object"||!Array.isArray(h))&&(f=h,h=null),this.c.push(new O(w,h,f))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(w){if(w.startsWith(window.location.origin)||w.startsWith("vscode-file://vscode-app"))return w;throw new Error(`[trusted_script_src] Invalid script url: ${w}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(w){return w}})))}async load(w){this.g();const h=await(this.a?this.i(w):this.b?this.h(w):this.j(w));if(!h)throw new Error(`Did not receive a define call from script ${w}`);if(Array.isArray(h.dependencies)&&h.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${w}. The dependencies are: ${h.dependencies.join(", ")}`);return typeof h.callback=="function"?h.callback([]):h.callback}h(w){return new Promise((h,f)=>{const m=document.createElement("script");m.setAttribute("async","async"),m.setAttribute("type","text/javascript");const y=()=>{m.removeEventListener("load",l),m.removeEventListener("error",d)},l=$=>{y(),h(this.c.pop())},d=$=>{y(),f($)};m.addEventListener("load",l),m.addEventListener("error",d),this.f&&(w=this.f.createScriptURL(w)),m.setAttribute("src",w),window.document.getElementsByTagName("head")[0].appendChild(m)})}i(w){return new Promise((h,f)=>{try{this.f&&(w=this.f.createScriptURL(w)),importScripts(w),h(this.c.pop())}catch(m){f(m)}})}async j(w){try{const h=globalThis._VSCODE_NODE_MODULES.fs,f=globalThis._VSCODE_NODE_MODULES.vm,m=globalThis._VSCODE_NODE_MODULES.module,y=j.URI.parse(w).fsPath,l=h.readFileSync(y).toString(),d=m.wrap(l.replace(/^#!.*/,""));return new f.Script(d).runInThisContext().apply(),this.c.pop()}catch(h){throw h}}}const k=new Map;let g={};typeof globalThis.require=="object"&&(g=globalThis.require.paths??{});async function C(S,w,h){if(I.$T){h===void 0&&(h=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),g[S]&&(S=g[S]);const f=`${S}/${w}`;if(k.has(f))return k.get(f);let m;if(/^\w[\w\d+.-]*:\/\//.test(f))m=f;else{const $=`${h&&!A.$o?L.$xg:L.$wg}/${f}`;m=L.$Ag.asBrowserUri($).toString(!0)}const y=R.INSTANCE.load(m);return k.set(f,y),y}else return await new Promise((f,m)=>{se([S],f,m)})}e.$xD=C}),define(le[20],he([0,1,49,23,15,5,27,10]),function(se,e,I,L,A,j,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4g=e.DataUri=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=void 0;function k(h){return(0,R.$wc)(h,!0)}e.$Hg=k;class g{constructor(f){this.a=f}compare(f,m,y=!1){return f===m?0:(0,O.$df)(this.getComparisonKey(f,y),this.getComparisonKey(m,y))}isEqual(f,m,y=!1){return f===m?!0:!f||!m?!1:this.getComparisonKey(f,y)===this.getComparisonKey(m,y)}getComparisonKey(f,m=!1){return f.with({path:this.a(f)?f.path.toLowerCase():void 0,fragment:m?null:void 0}).toString()}ignorePathCasing(f){return this.a(f)}isEqualOrParent(f,m,y=!1){if(f.scheme===m.scheme){if(f.scheme===L.Schemas.file)return I.$gg(k(f),k(m),this.a(f))&&f.query===m.query&&(y||f.fragment===m.fragment);if((0,e.$Yg)(f.authority,m.authority))return I.$gg(f.path,m.path,this.a(f),"/")&&f.query===m.query&&(y||f.fragment===m.fragment)}return!1}joinPath(f,...m){return R.URI.joinPath(f,...m)}basenameOrAuthority(f){return(0,e.$Qg)(f)||f.authority}basename(f){return A.$gc.basename(f.path)}extname(f){return A.$gc.extname(f.path)}dirname(f){if(f.path.length===0)return f;let m;return f.scheme===L.Schemas.file?m=R.URI.file(A.$mc(k(f))).path:(m=A.$gc.dirname(f.path),f.authority&&m.length&&m.charCodeAt(0)!==47&&(console.error(`dirname("${f.toString})) resulted in a relative path`),m="/")),f.with({path:m})}normalizePath(f){if(!f.path.length)return f;let m;return f.scheme===L.Schemas.file?m=R.URI.file(A.$hc(k(f))).path:m=A.$gc.normalize(f.path),f.with({path:m})}relativePath(f,m){if(f.scheme!==m.scheme||!(0,e.$Yg)(f.authority,m.authority))return;if(f.scheme===L.Schemas.file){const d=A.$lc(k(f),k(m));return j.$i?I.$ag(d):d}let y=f.path||"/";const l=m.path||"/";if(this.a(f)){let d=0;for(const $=Math.min(y.length,l.length);d<$&&!(y.charCodeAt(d)!==l.charCodeAt(d)&&y.charAt(d).toLowerCase()!==l.charAt(d).toLowerCase());d++);y=l.substr(0,d)+y.substr(d)}return A.$gc.relative(y,l)}resolvePath(f,m){if(f.scheme===L.Schemas.file){const y=R.URI.file(A.$kc(k(f),m));return f.with({authority:y.authority,path:y.path})}return m=I.$bg(m),f.with({path:A.$gc.resolve(f.path,m)})}isAbsolutePath(f){return!!f.path&&f.path[0]==="/"}isEqualAuthority(f,m){return f===m||f!==void 0&&m!==void 0&&(0,O.$kf)(f,m)}hasTrailingPathSeparator(f,m=A.sep){if(f.scheme===L.Schemas.file){const y=k(f);return y.length>I.$cg(y).length&&y[y.length-1]===m}else{const y=f.path;return y.length>1&&y.charCodeAt(y.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(f.fsPath)}}removeTrailingPathSeparator(f,m=A.sep){return(0,e.$Zg)(f,m)?f.with({path:f.path.substr(0,f.path.length-1)}):f}addTrailingPathSeparator(f,m=A.sep){let y=!1;if(f.scheme===L.Schemas.file){const l=k(f);y=l!==void 0&&l.length===I.$cg(l).length&&l[l.length-1]===m}else{m="/";const l=f.path;y=l.length===1&&l.charCodeAt(l.length-1)===47}return!y&&!(0,e.$Zg)(f,m)?f.with({path:f.path+"/"}):f}}e.$Ig=g,e.$Jg=new g(()=>!1),e.$Kg=new g(h=>h.scheme===L.Schemas.file?!j.$k:!0),e.$Lg=new g(h=>!0),e.$Mg=e.$Jg.isEqual.bind(e.$Jg),e.$Ng=e.$Jg.isEqualOrParent.bind(e.$Jg),e.$Og=e.$Jg.getComparisonKey.bind(e.$Jg),e.$Pg=e.$Jg.basenameOrAuthority.bind(e.$Jg),e.$Qg=e.$Jg.basename.bind(e.$Jg),e.$Rg=e.$Jg.extname.bind(e.$Jg),e.$Sg=e.$Jg.dirname.bind(e.$Jg),e.$Tg=e.$Jg.joinPath.bind(e.$Jg),e.$Ug=e.$Jg.normalizePath.bind(e.$Jg),e.$Vg=e.$Jg.relativePath.bind(e.$Jg),e.$Wg=e.$Jg.resolvePath.bind(e.$Jg),e.$Xg=e.$Jg.isAbsolutePath.bind(e.$Jg),e.$Yg=e.$Jg.isEqualAuthority.bind(e.$Jg),e.$Zg=e.$Jg.hasTrailingPathSeparator.bind(e.$Jg),e.$1g=e.$Jg.removeTrailingPathSeparator.bind(e.$Jg),e.$2g=e.$Jg.addTrailingPathSeparator.bind(e.$Jg);function C(h,f){const m=[];for(let y=0;y<h.length;y++){const l=f(h[y]);h.some((d,$)=>$===y?!1:(0,e.$Ng)(l,f(d)))||m.push(h[y])}return m}e.$3g=C;var S;(function(h){h.META_DATA_LABEL="label",h.META_DATA_DESCRIPTION="description",h.META_DATA_SIZE="size",h.META_DATA_MIME="mime";function f(m){const y=new Map;m.path.substring(m.path.indexOf(";")+1,m.path.lastIndexOf(";")).split(";").forEach($=>{const[c,v]=$.split(":");c&&v&&y.set(c,v)});const d=m.path.substring(0,m.path.indexOf(";"));return d&&y.set(h.META_DATA_MIME,d),y}h.parseMetaData=f})(S||(e.DataUri=S={}));function w(h,f,m){if(f){let y=h.path;return y&&y[0]!==A.$gc.sep&&(y=A.$gc.sep+y),h.with({scheme:m,authority:f,path:y})}return h.with({scheme:m})}e.$4g=w}),define(le[6],he([0,1,26,7,3,2,20,5,130,53]),function(se,e,I,L,A,j,O,R,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.Promises=e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=void 0;function C(ie){return!!ie&&typeof ie.then=="function"}e.$5g=C;function S(ie){const J=new I.$de,ne=ie(J.token),ce=new Promise((fe,de)=>{const me=J.token.onCancellationRequested(()=>{me.dispose(),de(new L.$5)});Promise.resolve(ne).then(Ee=>{me.dispose(),J.dispose(),fe(Ee)},Ee=>{me.dispose(),J.dispose(),de(Ee)})});return new class{cancel(){J.cancel(),J.dispose()}then(fe,de){return ce.then(fe,de)}catch(fe){return this.then(void 0,fe)}finally(fe){return ce.finally(fe)}}}e.$6g=S;function w(ie,J,ne){return new Promise((ce,fe)=>{const de=J.onCancellationRequested(()=>{de.dispose(),ce(ne)});ie.then(ce,fe).finally(()=>de.dispose())})}e.$7g=w;function h(ie,J){return new Promise((ne,ce)=>{const fe=J.onCancellationRequested(()=>{fe.dispose(),ce(new L.$5)});ie.then(ne,ce).finally(()=>fe.dispose())})}e.$8g=h;async function f(ie){let J=-1;const ne=ie.map((ce,fe)=>ce.then(de=>(J=fe,de)));try{return await Promise.race(ne)}finally{ie.forEach((ce,fe)=>{fe!==J&&ce.cancel()})}}e.$9g=f;function m(ie,J,ne){let ce;const fe=setTimeout(()=>{ce?.(void 0),ne?.()},J);return Promise.race([ie.finally(()=>clearTimeout(fe)),new Promise(de=>ce=de)])}e.$0g=m;function y(ie){return new Promise((J,ne)=>{const ce=ie();C(ce)?ce.then(J,ne):J(ce)})}e.$$g=y;function l(){let ie,J;return{promise:new Promise((ce,fe)=>{ie=ce,J=fe}),resolve:ie,reject:J}}e.$_g=l;class d{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(J){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=J,!this.b){const ne=()=>{if(this.b=null,this.f)return;const ce=this.queue(this.d);return this.d=null,ce};this.b=new Promise(ce=>{this.a.then(ne,ne).then(ce)})}return new Promise((ne,ce)=>{this.b.then(ne,ce)})}return this.a=J(),new Promise((ne,ce)=>{this.a.then(fe=>{this.a=null,ne(fe)},fe=>{this.a=null,ce(fe)})})}dispose(){this.f=!0}}e.$ah=d;class ${constructor(){this.a=Promise.resolve(null)}queue(J){return this.a=this.a.then(()=>J(),()=>J())}}e.$bh=$;class c{constructor(){this.a=new Map}queue(J,ne){const fe=(this.a.get(J)??Promise.resolve()).catch(()=>{}).then(ne).finally(()=>{this.a.get(J)===fe&&this.a.delete(J)});return this.a.set(J,fe),fe}}e.$ch=c;const v=(ie,J)=>{let ne=!0;const ce=setTimeout(()=>{ne=!1,J()},ie);return{isTriggered:()=>ne,dispose:()=>{clearTimeout(ce),ne=!1}}},i=ie=>{let J=!0;return queueMicrotask(()=>{J&&(J=!1,ie())}),{isTriggered:()=>J,dispose:()=>{J=!1}}};class o{constructor(J){this.defaultDelay=J,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(J,ne=this.defaultDelay){this.g=J,this.h(),this.b||(this.b=new Promise((fe,de)=>{this.d=fe,this.f=de}).then(()=>{if(this.b=null,this.d=null,this.g){const fe=this.g;return this.g=null,fe()}}));const ce=()=>{this.a=null,this.d?.(null)};return this.a=ne===k.$3d?i(ce):v(ne,ce),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new L.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$dh=o;class n{constructor(J){this.a=new o(J),this.b=new d}trigger(J,ne){return this.a.trigger(()=>this.b.queue(J),ne)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$eh=n;class s{constructor(){this.a=!1,this.b=new Promise((J,ne)=>{this.d=J})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$fh=s;class t extends s{constructor(J){super(),this.f=setTimeout(()=>this.open(),J)}open(){clearTimeout(this.f),super.open()}}e.$gh=t;function r(ie,J){return J?new Promise((ne,ce)=>{const fe=setTimeout(()=>{de.dispose(),ne()},ie),de=J.onCancellationRequested(()=>{clearTimeout(fe),de.dispose(),ce(new L.$5)})}):S(ne=>r(ie,ne))}e.$hh=r;function a(ie,J=0,ne){const ce=setTimeout(()=>{ie(),ne&&fe.dispose()},J),fe=(0,j.$Rc)(()=>{clearTimeout(ce),ne?.deleteAndLeak(fe)});return ne?.add(fe),fe}e.$ih=a;function E(ie){const J=[];let ne=0;const ce=ie.length;function fe(){return ne<ce?ie[ne++]():null}function de(me){me!=null&&J.push(me);const Ee=fe();return Ee?Ee.then(de):Promise.resolve(J)}return Promise.resolve(null).then(de)}e.$jh=E;function b(ie,J=ce=>!!ce,ne=null){let ce=0;const fe=ie.length,de=()=>{if(ce>=fe)return Promise.resolve(ne);const me=ie[ce++];return Promise.resolve(me()).then(Re=>J(Re)?Promise.resolve(Re):de())};return de()}e.$kh=b;function u(ie,J=ce=>!!ce,ne=null){if(ie.length===0)return Promise.resolve(ne);let ce=ie.length;const fe=()=>{ce=-1;for(const de of ie)de.cancel?.()};return new Promise((de,me)=>{for(const Ee of ie)Ee.then(Re=>{--ce>=0&&J(Re)?(fe(),de(Re)):ce===0&&de(ne)}).catch(Re=>{--ce>=0&&(fe(),me(Re))})})}e.$lh=u;class p{constructor(J){this.a=0,this.b=!1,this.f=J,this.g=[],this.d=0,this.h=new A.$6d}whenIdle(){return this.size>0?A.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(J){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((ne,ce)=>{this.g.push({factory:J,c:ne,e:ce}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const J=this.g.shift();this.d++;const ne=J.factory();ne.then(J.c,J.e),ne.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$mh=p;class P extends p{constructor(){super(1)}}e.$nh=P;class N{constructor(){this.a=new te,this.b=0}queue(J){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,J())):this.a.run(this.b++,J())}}e.$oh=N;class F{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const J=new ae;return this.b.add(J),J.p}g(){for(const[,J]of this.a)if(J.size>0)return!1;return!0}queueSize(J,ne=O.$Jg){const ce=ne.getComparisonKey(J);return this.a.get(ce)?.size??0}queueFor(J,ne,ce=O.$Jg){const fe=ce.getComparisonKey(J);let de=this.a.get(fe);if(!de){de=new P;const me=this.f++,Ee=A.Event.once(de.onDrained)(()=>{de?.dispose(),this.a.delete(fe),this.h(),this.d?.deleteAndDispose(me),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new j.$3c),this.d.set(me,Ee),this.a.set(fe,de)}return de.queue(ne)}h(){this.g()&&this.j()}j(){for(const J of this.b)J.complete();this.b.clear()}dispose(){for(const[,J]of this.a)J.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$ph=F;class M{constructor(J,ne){this.a=-1,typeof J=="function"&&typeof ne=="number"&&this.setIfNotSet(J,ne)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(J,ne){this.cancel(),this.a=setTimeout(()=>{this.a=-1,J()},ne)}setIfNotSet(J,ne){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,J()},ne))}}e.$qh=M;class z{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(J,ne,ce=globalThis){this.cancel();const fe=ce.setInterval(()=>{J()},ne);this.d=(0,j.$Rc)(()=>{ce.clearInterval(fe),this.d=void 0})}dispose(){this.cancel()}}e.$rh=z;class Z{constructor(J,ne){this.b=-1,this.a=J,this.d=ne,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(J=this.d){this.cancel(),this.b=setTimeout(this.f,J)}get delay(){return this.d}set delay(J){this.d=J}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$sh=Z;class X{constructor(J,ne){ne%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ne}ms is not a multiple of 1000ms.`),this.a=J,this.b=ne,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(J=this.b){J%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${J}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(J/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$th=X;class x extends Z{constructor(J,ne){super(J,ne),this.j=[]}work(J){this.j.push(J),this.isScheduled()||this.schedule()}h(){const J=this.j;this.j=[],this.a?.(J)}dispose(){this.j=[],super.dispose()}}e.$uh=x;class W extends j.$Tc{constructor(J,ne){super(),this.g=J,this.h=ne,this.a=[],this.b=this.B(new j.$Uc),this.f=!1}get pending(){return this.a.length}work(J){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+J.length>this.g.maxBufferedWork)return!1}else if(this.pending+J.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const ne of J)this.a.push(ne);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new Z(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$vh=W,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$xh=(ie,J)=>{(0,R.$B)(()=>{if(ne)return;const ce=Date.now()+15;J(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ce-Date.now())}}))});let ne=!1;return{dispose(){ne||(ne=!0)}}}:e.$xh=(ie,J,ne)=>{const ce=ie.requestIdleCallback(J,typeof ne=="number"?{timeout:ne}:void 0);let fe=!1;return{dispose(){fe||(fe=!0,ie.cancelIdleCallback(ce))}}},e.$wh=ie=>(0,e.$xh)(globalThis,ie)}();class Q{constructor(J,ne){this.g=!1,this.d=()=>{try{this.j=ne()}catch(ce){this.l=ce}finally{this.g=!0}},this.f=(0,e.$xh)(J,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$yh=Q;class H extends Q{constructor(J){super(globalThis,J)}}e.$zh=H;async function V(ie,J,ne){let ce;for(let fe=0;fe<ne;fe++)try{return await ie()}catch(de){ce=de,await r(J)}throw ce}e.$Ah=V;class te{isRunning(J){return typeof J=="number"?this.a?.taskId===J:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(J,ne,ce){return this.a={taskId:J,cancel:()=>ce?.(),promise:ne},ne.then(()=>this.d(J),()=>this.d(J)),ne}d(J){this.a&&J===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const J=this.b;this.b=void 0,J.run().then(J.promiseResolve,J.promiseReject)}}queue(J){if(this.b)this.b.run=J;else{const{promise:ne,resolve:ce,reject:fe}=l();this.b={run:J,promise:ne,promiseResolve:ce,promiseReject:fe}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Bh=te;class re{constructor(J,ne=()=>Date.now()){this.d=J,this.f=ne,this.a=0,this.b=0}increment(){const J=this.f();return J-this.a>this.d&&(this.a=J,this.b=0),this.b++,this.b}}e.$Ch=re;var ee;(function(ie){ie[ie.Resolved=0]="Resolved",ie[ie.Rejected=1]="Rejected"})(ee||(ee={}));class ae{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((J,ne)=>{this.a=J,this.b=ne})}complete(J){return new Promise(ne=>{this.a(J),this.d={outcome:0,value:J},ne()})}error(J){return new Promise(ne=>{this.b(J),this.d={outcome:1,value:J},ne()})}cancel(){return this.error(new L.$5)}}e.$Dh=ae;var G;(function(ie){async function J(ce){let fe;const de=await Promise.all(ce.map(me=>me.then(Ee=>Ee,Ee=>{fe||(fe=Ee)})));if(typeof fe<"u")throw fe;return de}ie.settled=J;function ne(ce){return new Promise(async(fe,de)=>{try{await ce(fe,de)}catch(me){de(me)}})}ie.withAsyncBody=ne})(G||(e.Promises=G={}));class U{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(J){this.a=void 0,this.b=void 0,this.d=!1,this.promise=J.then(ne=>(this.a=ne,this.d=!0,ne),ne=>{throw this.b=ne,this.d=!0,ne})}requireValue(){if(!this.d)throw new L.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Eh=U;class D{constructor(J){this.b=J,this.a=new g.$V(()=>new U(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Fh=D;var T;(function(ie){ie[ie.Initial=0]="Initial",ie[ie.DoneOK=1]="DoneOK",ie[ie.DoneError=2]="DoneError"})(T||(T={}));class B{static fromArray(J){return new B(ne=>{ne.emitMany(J)})}static fromPromise(J){return new B(async ne=>{ne.emitMany(await J)})}static fromPromises(J){return new B(async ne=>{await Promise.all(J.map(async ce=>ne.emitOne(await ce)))})}static merge(J){return new B(async ne=>{await Promise.all(J.map(async ce=>{for await(const fe of ce)ne.emitOne(fe)}))})}static{this.EMPTY=B.fromArray([])}constructor(J){this.a=0,this.b=[],this.d=null,this.f=new A.$6d,queueMicrotask(async()=>{const ne={emitOne:ce=>this.g(ce),emitMany:ce=>this.h(ce),reject:ce=>this.k(ce)};try{await Promise.resolve(J(ne)),this.j()}catch(ce){this.k(ce)}finally{ne.emitOne=void 0,ne.emitMany=void 0,ne.reject=void 0}})}[Symbol.asyncIterator](){let J=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(J<this.b.length)return{done:!1,value:this.b[J++]};if(this.a===1)return{done:!0,value:void 0};await A.Event.toPromise(this.f.event)}while(!0)}}}static map(J,ne){return new B(async ce=>{for await(const fe of J)ce.emitOne(ne(fe))})}map(J){return B.map(this,J)}static filter(J,ne){return new B(async ce=>{for await(const fe of J)ne(fe)&&ce.emitOne(fe)})}filter(J){return B.filter(this,J)}static coalesce(J){return B.filter(J,ne=>!!ne)}coalesce(){return B.coalesce(this)}static async toPromise(J){const ne=[];for await(const ce of J)ne.push(ce);return ne}toPromise(){return B.toPromise(this)}g(J){this.a===0&&(this.b.push(J),this.f.fire())}h(J){this.a===0&&(this.b=this.b.concat(J),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(J){this.a===0&&(this.a=2,this.d=J,this.f.fire())}}e.$Gh=B;class q extends B{constructor(J,ne){super(ne),this.l=J}cancel(){this.l.cancel()}}e.$Hh=q;function Y(ie){const J=new I.$de,ne=ie(J.token);return new q(J,async ce=>{const fe=J.token.onCancellationRequested(()=>{fe.dispose(),J.dispose(),ce.reject(new L.$5)});try{for await(const de of ne){if(J.token.isCancellationRequested)return;ce.emitOne(de)}fe.dispose(),J.dispose()}catch(de){fe.dispose(),J.dispose(),ce.reject(de)}})}e.$Ih=Y;class _{constructor(){this.a=new ae,this.b=new B(ce=>{if(J){ce.reject(J);return}return ne&&ce.emitMany(ne),this.d=fe=>ce.reject(fe),this.f=fe=>ce.emitOne(fe),this.a.p});let J,ne;this.f=ce=>{ne||(ne=[]),ne.push(ce)},this.d=ce=>{J||(J=ce)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(J){this.d(J),this.a.complete()}emitOne(J){this.f(J)}}e.$Jh=_}),define(le[90],he([0,1,17,6,49,35,15,5,27]),function(se,e,I,L,A,j,O,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4j=e.$3j=e.$2j=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=void 0;function g(){return Object.create(null)}e.$Uj=g,e.$Vj="**",e.$Wj="/";const C="[/\\\\]",S="[^/\\\\]",w=/\//g;function h(Q,H){switch(Q){case 0:return"";case 1:return`${S}*?`;default:return`(?:${C}|${S}+${C}${H?`|${C}${S}+`:""})*?`}}function f(Q,H){if(!Q)return[];const V=[];let te=!1,re=!1,ee="";for(const ae of Q){switch(ae){case H:if(!te&&!re){V.push(ee),ee="";continue}break;case"{":te=!0;break;case"}":te=!1;break;case"[":re=!0;break;case"]":re=!1;break}ee+=ae}return ee&&V.push(ee),V}e.$Xj=f;function m(Q){if(!Q)return"";let H="";const V=f(Q,e.$Wj);if(V.every(te=>te===e.$Vj))H=".*";else{let te=!1;V.forEach((re,ee)=>{if(re===e.$Vj){if(te)return;H+=h(2,ee===V.length-1)}else{let ae=!1,G="",U=!1,D="";for(const T of re){if(T!=="}"&&ae){G+=T;continue}if(U&&(T!=="]"||!D)){let B;T==="-"?B=T:(T==="^"||T==="!")&&!D?B="^":T===e.$Wj?B="":B=(0,k.$Ye)(T),D+=B;continue}switch(T){case"{":ae=!0;continue;case"[":U=!0;continue;case"}":{const q=`(?:${f(G,",").map(Y=>m(Y)).join("|")})`;H+=q,ae=!1,G="";break}case"]":{H+="["+D+"]",U=!1,D="";break}case"?":H+=S;continue;case"*":H+=h(1);continue;default:H+=(0,k.$Ye)(T)}}ee<V.length-1&&(V[ee+1]!==e.$Vj||ee+2<V.length)&&(H+=C)}te=re===e.$Vj})}return H}const y=/^\*\*\/\*\.[\w\.-]+$/,l=/^\*\*\/([\w\.-]+)\/?$/,d=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,$=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,c=/^\*\*((\/[\w\.-]+)+)\/?$/,v=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new j.$Dc(1e4),o=function(){return!1},n=function(){return null};function s(Q,H){if(!Q)return n;let V;typeof Q!="string"?V=Q.pattern:V=Q,V=V.trim();const te=`${V}_${!!H.trimForExclusions}`;let re=i.get(te);if(re)return t(re,Q);let ee;return y.test(V)?re=a(V.substr(4),V):(ee=l.exec(r(V,H)))?re=E(ee[1],V):(H.trimForExclusions?$:d).test(V)?re=b(V,H):(ee=c.exec(r(V,H)))?re=u(ee[1].substr(1),V,!0):(ee=v.exec(r(V,H)))?re=u(ee[1],V,!1):re=p(V),i.set(te,re),t(re,Q)}function t(Q,H){if(typeof H=="string")return Q;const V=function(te,re){return(0,A.$gg)(te,H.base,!R.$k)?Q((0,k.$4e)(te.substr(H.base.length),O.sep),re):null};return V.allBasenames=Q.allBasenames,V.allPaths=Q.allPaths,V.basenames=Q.basenames,V.patterns=Q.patterns,V}function r(Q,H){return H.trimForExclusions&&Q.endsWith("/**")?Q.substr(0,Q.length-2):Q}function a(Q,H){return function(V,te){return typeof V=="string"&&V.endsWith(Q)?H:null}}function E(Q,H){const V=`/${Q}`,te=`\\${Q}`,re=function(ae,G){return typeof ae!="string"?null:G?G===Q?H:null:ae===Q||ae.endsWith(V)||ae.endsWith(te)?H:null},ee=[Q];return re.basenames=ee,re.patterns=[H],re.allBasenames=ee,re}function b(Q,H){const V=x(Q.slice(1,-1).split(",").map(G=>s(G,H)).filter(G=>G!==n),Q),te=V.length;if(!te)return n;if(te===1)return V[0];const re=function(G,U){for(let D=0,T=V.length;D<T;D++)if(V[D](G,U))return Q;return null},ee=V.find(G=>!!G.allBasenames);ee&&(re.allBasenames=ee.allBasenames);const ae=V.reduce((G,U)=>U.allPaths?G.concat(U.allPaths):G,[]);return ae.length&&(re.allPaths=ae),re}function u(Q,H,V){const te=O.sep===O.$gc.sep,re=te?Q:Q.replace(w,O.sep),ee=O.sep+re,ae=O.$gc.sep+Q;let G;return V?G=function(U,D){return typeof U=="string"&&(U===re||U.endsWith(ee)||!te&&(U===Q||U.endsWith(ae)))?H:null}:G=function(U,D){return typeof U=="string"&&(U===re||!te&&U===Q)?H:null},G.allPaths=[(V?"*/":"./")+Q],G}function p(Q){try{const H=new RegExp(`^${m(Q)}$`);return function(V){return H.lastIndex=0,typeof V=="string"&&H.test(V)?Q:null}}catch{return n}}function P(Q,H,V){return!Q||typeof H!="string"?!1:N(Q)(H,void 0,V)}e.$Yj=P;function N(Q,H={}){if(!Q)return o;if(typeof Q=="string"||F(Q)){const V=s(Q,H);if(V===n)return o;const te=function(re,ee){return!!V(re,ee)};return V.allBasenames&&(te.allBasenames=V.allBasenames),V.allPaths&&(te.allPaths=V.allPaths),te}return Z(Q,H)}e.$Zj=N;function F(Q){const H=Q;return H?typeof H.base=="string"&&typeof H.pattern=="string":!1}e.$1j=F;function M(Q){return Q.allBasenames||[]}e.$2j=M;function z(Q){return Q.allPaths||[]}e.$3j=z;function Z(Q,H){const V=x(Object.getOwnPropertyNames(Q).map(G=>X(G,Q[G],H)).filter(G=>G!==n)),te=V.length;if(!te)return n;if(!V.some(G=>!!G.requiresSiblings)){if(te===1)return V[0];const G=function(T,B){let q;for(let Y=0,_=V.length;Y<_;Y++){const ie=V[Y](T,B);if(typeof ie=="string")return ie;(0,L.$5g)(ie)&&(q||(q=[]),q.push(ie))}return q?(async()=>{for(const Y of q){const _=await Y;if(typeof _=="string")return _}return null})():null},U=V.find(T=>!!T.allBasenames);U&&(G.allBasenames=U.allBasenames);const D=V.reduce((T,B)=>B.allPaths?T.concat(B.allPaths):T,[]);return D.length&&(G.allPaths=D),G}const re=function(G,U,D){let T,B;for(let q=0,Y=V.length;q<Y;q++){const _=V[q];_.requiresSiblings&&D&&(U||(U=(0,O.$nc)(G)),T||(T=U.substr(0,U.length-(0,O.$oc)(G).length)));const ie=_(G,U,T,D);if(typeof ie=="string")return ie;(0,L.$5g)(ie)&&(B||(B=[]),B.push(ie))}return B?(async()=>{for(const q of B){const Y=await q;if(typeof Y=="string")return Y}return null})():null},ee=V.find(G=>!!G.allBasenames);ee&&(re.allBasenames=ee.allBasenames);const ae=V.reduce((G,U)=>U.allPaths?G.concat(U.allPaths):G,[]);return ae.length&&(re.allPaths=ae),re}function X(Q,H,V){if(H===!1)return n;const te=s(Q,V);if(te===n)return n;if(typeof H=="boolean")return te;if(H){const re=H.when;if(typeof re=="string"){const ee=(ae,G,U,D)=>{if(!D||!te(ae,G))return null;const T=re.replace("$(basename)",()=>U),B=D(T);return(0,L.$5g)(B)?B.then(q=>q?Q:null):B?Q:null};return ee.requiresSiblings=!0,ee}}return te}function x(Q,H){const V=Q.filter(G=>!!G.basenames);if(V.length<2)return Q;const te=V.reduce((G,U)=>{const D=U.basenames;return D?G.concat(D):G},[]);let re;if(H){re=[];for(let G=0,U=te.length;G<U;G++)re.push(H)}else re=V.reduce((G,U)=>{const D=U.patterns;return D?G.concat(D):G},[]);const ee=function(G,U){if(typeof G!="string")return null;if(!U){let T;for(T=G.length;T>0;T--){const B=G.charCodeAt(T-1);if(B===47||B===92)break}U=G.substr(T)}const D=te.indexOf(U);return D!==-1?re[D]:null};ee.basenames=te,ee.patterns=re,ee.allBasenames=te;const ae=Q.filter(G=>!G.basenames);return ae.push(ee),ae}function W(Q,H){return(0,I.$ub)(Q,H,(V,te)=>typeof V=="string"&&typeof te=="string"?V===te:typeof V!="string"&&typeof te!="string"?V.base===te.base&&V.pattern===te.pattern:!1)}e.$4j=W}),define(le[91],he([0,1,14,10]),function(se,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ln=e.$kn=e.$jn=e.$in=e.$hn=void 0;function A(S){return S.toJSON()}class j{constructor(w){this.a=w}transformIncoming(w){const h=this.a.transformIncoming(w);return h===w?w:A(L.URI.from(h))}transformOutgoing(w){const h=this.a.transformOutgoing(w);return h===w?w:A(L.URI.from(h))}transformOutgoingURI(w){const h=this.a.transformOutgoing(w);return h===w?w:L.URI.from(h)}transformOutgoingScheme(w){return this.a.transformOutgoingScheme(w)}}e.$hn=j,e.$in=new class{transformIncoming(S){return S}transformOutgoing(S){return S}transformOutgoingURI(S){return S}transformOutgoingScheme(S){return S}};function O(S,w,h){if(!S||h>200)return null;if(typeof S=="object"){if(S instanceof L.URI)return w.transformOutgoing(S);for(const f in S)if(Object.hasOwnProperty.call(S,f)){const m=O(S[f],w,h+1);m!==null&&(S[f]=m)}}return null}function R(S,w){const h=O(S,w,0);return h===null?S:h}e.$jn=R;function k(S,w,h,f){if(!S||f>200)return null;if(typeof S=="object"){if(S.$mid===1)return h?L.URI.revive(w.transformIncoming(S)):w.transformIncoming(S);if(S instanceof I.$te)return null;for(const m in S)if(Object.hasOwnProperty.call(S,m)){const y=k(S[m],w,h,f+1);y!==null&&(S[m]=y)}}return null}function g(S,w){const h=k(S,w,!1,0);return h===null?S:h}e.$kn=g;function C(S,w){const h=k(S,w,!0,0);return h===null?S:h}e.$ln=C}),define(le[144],he([0,1,37,48,32,131,5]),function(se,e,I,L,A,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pn=e.$on=e.$nn=void 0,e.$nn=new class{c(w){return this.a||(this.a=L.$mi.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(w)}value(){if(this.b===void 0){let w=0,h=0;const f=(0,I.networkInterfaces)();for(const m in f){const y=f[m];if(y)for(const{mac:l,internal:d}of y)d||(h+=1,this.c(l.toUpperCase())&&(w+=1))}this.b=h>0?w/h:0}return this.b}};let R;async function k(w){return R||(R=(async()=>await g(w)||A.$Cg())()),R}e.$on=k;async function g(w){try{const h=await new Promise((m,y)=>{se(["crypto"],m,y)}),f=(0,j.$mn)();return h.createHash("sha256").update(f,"utf8").digest("hex")}catch(h){w(h);return}}const C="Software\\Microsoft\\SQMClient";async function S(w){if(O.$i){const h=await new Promise((f,m)=>{se(["@vscode/windows-registry"],f,m)});try{return h.GetStringRegKey("HKEY_LOCAL_MACHINE",C,"MachineId")||""}catch(f){return w(f),""}}return""}e.$pn=S}),define(le[145],he([0,1,50,270,271,5]),function(se,e,I,L,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dg=void 0;async function O(R){if(j.$j||j.$i)return;let k;for(const g of["/etc/os-release","/usr/lib/os-release","/etc/lsb-release"])try{k=await(0,L.open)(g,I.constants.R_OK);break}catch{}if(!k){R("Unable to retrieve release information from known identifier paths.");return}try{const g=new Set(["ID","DISTRIB_ID","ID_LIKE","VERSION_ID","DISTRIB_RELEASE"]),C={id:"unknown"};for await(const S of(0,A.createInterface)({input:k.createReadStream(),crlfDelay:1/0})){if(!S.includes("="))continue;const w=S.split("=")[0].toUpperCase().trim();if(g.has(w)){const h=S.split("=")[1].replace(/"/g,"").toLowerCase().trim();w==="ID"||w==="DISTRIB_ID"?C.id=h:w==="ID_LIKE"?C.id_like=h:(w==="VERSION_ID"||w==="DISTRIB_RELEASE")&&(C.version_id=h)}}return C}catch(g){R(g)}}e.$Dg=O}),define(le[31],he([0,1,50,37,272,6,49,87,15,5,20,10]),function(se,e,I,L,A,j,O,R,k,g,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var w;(function(X){X[X.UNLINK=0]="UNLINK",X[X.MOVE=1]="MOVE"})(w||(e.RimRafMode=w={}));async function h(X,x=w.UNLINK,W){if((0,O.$jg)(X))throw new Error("rimraf - will refuse to recursively delete root");return x===w.UNLINK?m(X):f(X,W)}async function f(X,x=(0,O.$og)((0,L.tmpdir)())){try{try{await I.promises.rename(X,x)}catch(W){return W.code==="ENOENT"?void 0:m(X)}m(x).catch(W=>{})}catch(W){if(W.code!=="ENOENT")throw W}}async function m(X){return(0,A.promisify)(I.rm)(X,{recursive:!0,force:!0,maxRetries:3})}function y(X){if((0,O.$jg)(X))throw new Error("rimraf - will refuse to recursively delete root");I.rmSync(X,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=y;async function l(X,x){return c(await(x?d(X):(0,A.promisify)(I.readdir)(X)))}async function d(X){try{return await(0,A.promisify)(I.readdir)(X,{withFileTypes:!0})}catch(Q){console.warn("[node.js fs] readdir with filetypes failed with error: ",Q)}const x=[],W=await l(X);for(const Q of W){let H=!1,V=!1,te=!1;try{const re=await e.Promises.lstat((0,k.$jc)(X,Q));H=re.isFile(),V=re.isDirectory(),te=re.isSymbolicLink()}catch(re){console.warn("[node.js fs] unexpected error from lstat after readdir: ",re)}x.push({name:Q,isFile:()=>H,isDirectory:()=>V,isSymbolicLink:()=>te})}return x}function $(X){return c(I.readdirSync(X))}e.readdirSync=$;function c(X){return X.map(x=>typeof x=="string"?g.$j?(0,R.$Rl)(x):x:(x.name=g.$j?(0,R.$Rl)(x.name):x.name,x))}async function v(X){const x=await l(X),W=[];for(const Q of x)await o.existsDirectory((0,k.$jc)(X,Q))&&W.push(Q);return W}function i(X,x=1e3){return new Promise(W=>{let Q=!1;const H=setInterval(()=>{Q||(Q=!0,I.access(X,V=>{Q=!1,V&&(clearInterval(H),W(void 0))}))},x)})}e.whenDeleted=i;var o;(function(X){async function x(H){let V;try{if(V=await e.Promises.lstat(H),!V.isSymbolicLink())return{stat:V}}catch{}try{return{stat:await e.Promises.stat(H),symbolicLink:V?.isSymbolicLink()?{dangling:!1}:void 0}}catch(te){if(te.code==="ENOENT"&&V)return{stat:V,symbolicLink:{dangling:!0}};if(g.$i&&te.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(H)),symbolicLink:{dangling:!1}}}catch(re){if(re.code==="ENOENT"&&V)return{stat:V,symbolicLink:{dangling:!0}};throw re}throw te}}X.stat=x;async function W(H){try{const{stat:V,symbolicLink:te}=await X.stat(H);return V.isFile()&&te?.dangling!==!0}catch{}return!1}X.existsFile=W;async function Q(H){try{const{stat:V,symbolicLink:te}=await X.stat(H);return V.isDirectory()&&te?.dangling!==!0}catch{}return!1}X.existsDirectory=Q})(o||(e.SymlinkSupport=o={}));const n=new j.$ph;function s(X,x,W){return n.queueFor(S.URI.file(X),()=>{const Q=b(W);return new Promise((H,V)=>a(X,x,Q,te=>te?V(te):H()))},C.$Kg)}let t=!0;function r(X){t=X}e.configureFlushOnWrite=r;function a(X,x,W,Q){if(!t)return I.writeFile(X,x,{mode:W.mode,flag:W.flag},Q);I.open(X,W.flag,W.mode,(H,V)=>{if(H)return Q(H);I.writeFile(V,x,te=>{if(te)return I.close(V,()=>Q(te));I.fdatasync(V,re=>(re&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",re),r(!1)),I.close(V,ee=>Q(ee))))})})}function E(X,x,W){const Q=b(W);if(!t)return I.writeFileSync(X,x,{mode:Q.mode,flag:Q.flag});const H=I.openSync(X,Q.flag,Q.mode);try{I.writeFileSync(H,x);try{I.fdatasyncSync(H)}catch(V){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",V),r(!1)}}finally{I.closeSync(H)}}e.writeFileSync=E;function b(X){return X?{mode:typeof X.mode=="number"?X.mode:438,flag:typeof X.flag=="string"?X.flag:"w"}:{mode:438,flag:"w"}}async function u(X,x,W=6e4){if(X!==x)try{g.$i&&typeof W=="number"?await p(X,x,Date.now(),W):await(0,A.promisify)(I.rename)(X,x)}catch(Q){if(X.toLowerCase()!==x.toLowerCase()&&Q.code==="EXDEV"||X.endsWith("."))await P(X,x,{preserveSymlinks:!1}),await h(X,w.MOVE);else throw Q}}async function p(X,x,W,Q,H=0){try{return await(0,A.promisify)(I.rename)(X,x)}catch(V){if(V.code!=="EACCES"&&V.code!=="EPERM"&&V.code!=="EBUSY")throw V;if(Date.now()-W>=Q)throw console.error(`[node.js fs] rename failed after ${H} retries with error: ${V}`),V;if(H===0){let te=!1;try{const{stat:re}=await o.stat(x);re.isFile()||(te=!0)}catch{}if(te)throw V}return await(0,j.$hh)(Math.min(100,H*10)),p(X,x,W,Q,H+1)}}async function P(X,x,W){return F(X,x,{root:{source:X,target:x},options:W,handledSourcePaths:new Set})}const N=511;async function F(X,x,W){if(W.handledSourcePaths.has(X))return;W.handledSourcePaths.add(X);const{stat:Q,symbolicLink:H}=await o.stat(X);if(H){if(W.options.preserveSymlinks)try{return await Z(X,x,W)}catch{}if(H.dangling)return}return Q.isDirectory()?M(X,x,Q.mode&N,W):z(X,x,Q.mode&N)}async function M(X,x,W,Q){await e.Promises.mkdir(x,{recursive:!0,mode:W});const H=await l(X);for(const V of H)await F((0,k.$jc)(X,V),(0,k.$jc)(x,V),Q)}async function z(X,x,W){await e.Promises.copyFile(X,x),await e.Promises.chmod(x,W)}async function Z(X,x,W){let Q=await e.Promises.readlink(X);(0,O.$gg)(Q,W.root.source,!g.$k)&&(Q=(0,k.$jc)(W.root.target,Q.substr(W.root.source.length+1))),await e.Promises.symlink(Q,x)}e.Promises=new class{get access(){return(0,A.promisify)(I.access)}get stat(){return(0,A.promisify)(I.stat)}get lstat(){return(0,A.promisify)(I.lstat)}get utimes(){return(0,A.promisify)(I.utimes)}get read(){return(X,x,W,Q,H)=>new Promise((V,te)=>{I.read(X,x,W,Q,H,(re,ee,ae)=>re?te(re):V({bytesRead:ee,buffer:ae}))})}get readFile(){return(0,A.promisify)(I.readFile)}get write(){return(X,x,W,Q,H)=>new Promise((V,te)=>{I.write(X,x,W,Q,H,(re,ee,ae)=>re?te(re):V({bytesWritten:ee,buffer:ae}))})}get appendFile(){return(0,A.promisify)(I.appendFile)}get fdatasync(){return(0,A.promisify)(I.fdatasync)}get truncate(){return(0,A.promisify)(I.truncate)}get copyFile(){return(0,A.promisify)(I.copyFile)}get open(){return(0,A.promisify)(I.open)}get close(){return(0,A.promisify)(I.close)}get symlink(){return(0,A.promisify)(I.symlink)}get readlink(){return(0,A.promisify)(I.readlink)}get chmod(){return(0,A.promisify)(I.chmod)}get mkdir(){return(0,A.promisify)(I.mkdir)}get unlink(){return(0,A.promisify)(I.unlink)}get rmdir(){return(0,A.promisify)(I.rmdir)}get realpath(){return(0,A.promisify)(I.realpath)}async exists(X){try{return await e.Promises.access(X),!0}catch{return!1}}get readdir(){return l}get readDirsInDir(){return v}get writeFile(){return s}get rm(){return h}get rename(){return u}get copy(){return P}}}),define(le[146],he([0,1,50,15,5,27,31]),function(se,e,I,L,A,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lq=e.$Kq=e.$Jq=e.$Iq=void 0;function R(w){if(A.$k)return w;const h=(0,L.$mc)(w);if(w===h)return w;const f=((0,L.$nc)(w)||w).toLowerCase();try{const y=(0,O.readdirSync)(h).filter(l=>l.toLowerCase()===f);if(y.length===1){const l=R(h);if(l)return(0,L.$jc)(l,y[0])}else if(y.length>1){const l=y.indexOf(f);if(l>=0){const d=R(h);if(d)return(0,L.$jc)(d,y[l])}}}catch{}return null}e.$Iq=R;async function k(w){if(A.$k)return w;const h=(0,L.$mc)(w);if(w===h)return w;const f=((0,L.$nc)(w)||w).toLowerCase();try{const y=(await O.Promises.readdir(h)).filter(l=>l.toLowerCase()===f);if(y.length===1){const l=await k(h);if(l)return(0,L.$jc)(l,y[0])}else if(y.length>1){const l=y.indexOf(f);if(l>=0){const d=await k(h);if(d)return(0,L.$jc)(d,y[l])}}}catch{}return null}e.$Jq=k;async function g(w){try{return await O.Promises.realpath(w)}catch{const f=S(w);return await O.Promises.access(f,I.constants.R_OK),f}}e.$Kq=g;function C(w){try{return I.realpathSync(w)}catch{const f=S(w);return I.accessSync(f,I.constants.R_OK),f}}e.$Lq=C;function S(w){return(0,j.$5e)((0,L.$hc)(w),L.sep)}}),define(le[147],he([0,1,15,5,36,89,12,31]),function(se,e,I,L,A,j,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$6l=e.$5l=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return j.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return j.TerminateResponseCode}});function k(S=A.env){return S.comspec||"cmd.exe"}e.$5l=k;function g(S){let w=[],h=!1;const f=function(m){if(h){w.push(m);return}(!S.send(m,l=>{if(l&&console.error(l),h=!1,w.length>0){const d=w.slice(0);w=[],d.forEach($=>f($))}})||L.$i)&&(h=!0)};return{send:f}}e.$6l=g;var C;(function(S){async function w(h,f,m){if(I.$ic(h))return h;if(f===void 0&&(f=A.cwd()),I.$mc(h)!=="."||(m===void 0&&O.$Tf(A.env.PATH)&&(m=A.env.PATH.split(I.$tc)),m===void 0||m.length===0))return I.$jc(f,h);async function l(d){if(await R.Promises.exists(d)){let $;try{$=await R.Promises.stat(d)}catch(c){c.message.startsWith("EACCES")&&($=await R.Promises.lstat(d))}return $?!$.isDirectory():!1}return!1}for(const d of m){let $;if(I.$ic(d)?$=I.$jc(d,h):$=I.$jc(f,d,h),await l($))return $;let c=$+".com";if(await l(c)||(c=$+".exe",await l(c)))return c}return I.$jc(f,h)}S.findExecutable=w})(C||(e.win32=C={}))}),define(le[148],he([0,1,67,23]),function(se,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hs=void 0;function A(O){return new Promise((R,k)=>{let g;const C=new Map;function S(h,f,m,y,l){const d=C.get(f);if(h===O||d){const $={name:w(m),cmd:m,pid:h,ppid:f,load:y,mem:l};C.set(h,$),h===O&&(g=$),d&&(d.children||(d.children=[]),d.children.push($),d.children.length>1&&(d.children=d.children.sort((c,v)=>c.pid-v.pid)))}}function w(h){const f=/--utility-sub-type=network/i,m=/--crashes-directory/i,y=/\\pipe\\winpty-control/i,l=/conhost\.exe.+--headless/i,d=/--type=([a-zA-Z-]+)/;if(m.exec(h))return"electron-crash-reporter";if(y.exec(h))return"winpty-agent";if(l.exec(h))return"conpty-agent";let $=d.exec(h);if($&&$.length===2)return $[1]==="renderer"?"window":$[1]==="utility"?f.exec(h)?"utility-network-service":"utility-process":$[1]==="extensionHost"?"extension-host":$[1];const c=/[a-zA-Z-]+\.js/g;let v="";do $=c.exec(h),$&&(v+=$+" ");while($);return v&&h.indexOf("node ")<0&&h.indexOf("node.exe")<0?`electron-nodejs (${v})`:h}if(process.platform==="win32"){const h=f=>f.indexOf("\\\\?\\")===0||f.indexOf("\\??\\")===0?f.substring(4):f.indexOf('"\\\\?\\')===0||f.indexOf('"\\??\\')===0?'"'+f.substring(5):f;new Promise((f,m)=>{se(["@vscode/windows-process-tree"],f,m)}).then(f=>{f.getProcessList(O,m=>{if(!m){k(new Error(`Root process ${O} not found`));return}f.getProcessCpuUsage(m,y=>{const l=new Map;y.forEach(d=>{const $=h(d.commandLine||"");l.set(d.pid,{name:w($),cmd:$,pid:d.pid,ppid:d.ppid,load:d.cpu||0,mem:d.memory||0})}),g=l.get(O),g?(l.forEach(d=>{const $=l.get(d.ppid);$&&($.children||($.children=[]),$.children.push(d))}),l.forEach(d=>{d.children&&(d.children=d.children.sort(($,c)=>$.pid-c.pid))}),R(g)):k(new Error(`Root process ${O} not found`))})},f.ProcessDataFlag.CommandLine|f.ProcessDataFlag.Memory)})}else{let h=function(){let f=[g];const m=[];for(;f.length;){const l=f.shift();l&&(m.push(l.pid),l.children&&(f=f.concat(l.children)))}let y=JSON.stringify(L.$Ag.asFileUri("vs/base/node/cpuUsage.sh").fsPath);y+=" "+m.join(" "),(0,I.exec)(y,{},(l,d,$)=>{if(l||$)k(l||new Error($.toString()));else{const c=d.toString().split(`
`);for(let v=0;v<m.length;v++){const i=C.get(m[v]);i.load=parseFloat(c[v])}if(!g){k(new Error(`Root process ${O} not found`));return}R(g)}})};(0,I.exec)("which ps",{},(f,m,y)=>{if(f||y)if(process.platform!=="linux")k(f||new Error(y.toString()));else{const l=JSON.stringify(L.$Ag.asFileUri("vs/base/node/ps.sh").fsPath);(0,I.exec)(l,{},(d,$,c)=>{d||c?k(d||new Error(c.toString())):(j($,S),h())})}else{const l=m.toString().trim();(0,I.exec)(`${l} -ax -o pid=,ppid=,pcpu=,pmem=,command=`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},($,c,v)=>{$||v&&!v.includes("screen size is bogus")?k($||new Error(v.toString())):(j(c,S),process.platform==="linux"?h():g?R(g):k(new Error(`Root process ${O} not found`)))})}})}})}e.$hs=A;function j(O,R){const k=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,g=O.toString().split(`
`);for(const C of g){const S=k.exec(C.trim());S&&S.length===6&&R(parseInt(S[1]),parseInt(S[2]),S[5],parseFloat(S[3]),parseFloat(S[4]))}}});var ye=this&&this.__decorate||function(se,e,I,L){var A=arguments.length,j=A<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,I):L,O;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")j=Reflect.decorate(se,e,I,L);else for(var R=se.length-1;R>=0;R--)(O=se[R])&&(j=(A<3?O(j):A>3?O(e,I,j):O(e,I))||j);return A>3&&j&&Object.defineProperty(e,I,j),j};define(le[40],he([0,1,17,6,14,26,84,7,3,2,66,27,12]),function(se,e,I,L,A,j,O,R,k,g,C,S,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2h=e.ProxyChannel=e.$1h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.RequestInitiator=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=void 0;var h;(function(H){H[H.Promise=100]="Promise",H[H.PromiseCancel=101]="PromiseCancel",H[H.EventListen=102]="EventListen",H[H.EventDispose=103]="EventDispose"})(h||(h={}));function f(H){switch(H){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var m;(function(H){H[H.Initialize=200]="Initialize",H[H.PromiseSuccess=201]="PromiseSuccess",H[H.PromiseError=202]="PromiseError",H[H.PromiseErrorObj=203]="PromiseErrorObj",H[H.EventFire=204]="EventFire"})(m||(m={}));function y(H){switch(H){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var l;(function(H){H[H.Uninitialized=0]="Uninitialized",H[H.Idle=1]="Idle"})(l||(l={}));function d(H){let V=0;for(let te=0;;te+=7){const re=H.read(1);if(V|=(re.buffer[0]&127)<<te,!(re.buffer[0]&128))return V}}const $=n(0);function c(H,V){if(V===0){H.write($);return}let te=0;for(let ee=V;ee!==0;ee=ee>>>7)te++;const re=A.$te.alloc(te);for(let ee=0;V!==0;ee++)re.buffer[ee]=V&127,V=V>>>7,V>0&&(re.buffer[ee]|=128);H.write(re)}class v{constructor(V){this.b=V,this.a=0}read(V){const te=this.b.slice(this.a,this.a+V);return this.a+=te.byteLength,te}}e.$Qh=v;class i{constructor(){this.a=[]}get buffer(){return A.$te.concat(this.a)}write(V){this.a.push(V)}}e.$Rh=i;var o;(function(H){H[H.Undefined=0]="Undefined",H[H.String=1]="String",H[H.Buffer=2]="Buffer",H[H.VSBuffer=3]="VSBuffer",H[H.Array=4]="Array",H[H.Object=5]="Object",H[H.Int=6]="Int"})(o||(o={}));function n(H){const V=A.$te.alloc(1);return V.writeUInt8(H,0),V}const s={Undefined:n(o.Undefined),String:n(o.String),Buffer:n(o.Buffer),VSBuffer:n(o.VSBuffer),Array:n(o.Array),Object:n(o.Object),Uint:n(o.Int)},t=typeof Buffer<"u";function r(H,V){if(typeof V>"u")H.write(s.Undefined);else if(typeof V=="string"){const te=A.$te.fromString(V);H.write(s.String),c(H,te.byteLength),H.write(te)}else if(t&&Buffer.isBuffer(V)){const te=A.$te.wrap(V);H.write(s.Buffer),c(H,te.byteLength),H.write(te)}else if(V instanceof A.$te)H.write(s.VSBuffer),c(H,V.byteLength),H.write(V);else if(Array.isArray(V)){H.write(s.Array),c(H,V.length);for(const te of V)r(H,te)}else if(typeof V=="number"&&(V|0)===V)H.write(s.Uint),c(H,V);else{const te=A.$te.fromString(JSON.stringify(V));H.write(s.Object),c(H,te.byteLength),H.write(te)}}e.$Sh=r;function a(H){switch(H.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return H.read(d(H)).toString();case o.Buffer:return H.read(d(H)).buffer;case o.VSBuffer:return H.read(d(H));case o.Array:{const te=d(H),re=[];for(let ee=0;ee<te;ee++)re.push(a(H));return re}case o.Object:return JSON.parse(H.read(d(H)).toString());case o.Int:return d(H)}}e.$Th=a;class E{constructor(V,te,re=null,ee=1e3){this.h=V,this.j=te,this.k=re,this.l=ee,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ae=>this.q(ae)),this.m({type:200})}registerChannel(V,te){this.b.set(V,te),setTimeout(()=>this.w(V),0)}m(V){switch(V.type){case 200:{const te=this.o([V.type]);this.k?.logOutgoing(te,0,1,y(V.type));return}case 201:case 202:case 204:case 203:{const te=this.o([V.type,V.id],V.data);this.k?.logOutgoing(te,V.id,1,y(V.type),V.data);return}}}o(V,te=void 0){const re=new i;return r(re,V),r(re,te),this.p(re.buffer)}p(V){try{return this.h.send(V),V.byteLength}catch{return 0}}q(V){const te=new v(V),re=a(te),ee=a(te),ae=re[0];switch(ae){case 100:return this.k?.logIncoming(V.byteLength,re[1],1,`${f(ae)}: ${re[2]}.${re[3]}`,ee),this.s({type:ae,id:re[1],channelName:re[2],name:re[3],arg:ee});case 102:return this.k?.logIncoming(V.byteLength,re[1],1,`${f(ae)}: ${re[2]}.${re[3]}`,ee),this.t({type:ae,id:re[1],channelName:re[2],name:re[3],arg:ee});case 101:return this.k?.logIncoming(V.byteLength,re[1],1,`${f(ae)}`),this.u({type:ae,id:re[1]});case 103:return this.k?.logIncoming(V.byteLength,re[1],1,`${f(ae)}`),this.u({type:ae,id:re[1]})}}s(V){const te=this.b.get(V.channelName);if(!te){this.v(V);return}const re=new j.$de;let ee;try{ee=te.call(this.j,V.name,V.arg,re.token)}catch(U){ee=Promise.reject(U)}const ae=V.id;ee.then(U=>{this.m({id:ae,data:U,type:201})},U=>{U instanceof Error?this.m({id:ae,data:{message:U.message,name:U.name,stack:U.stack?U.stack.split?U.stack.split(`
`):U.stack:void 0},type:202}):this.m({id:ae,data:U,type:203})}).finally(()=>{G.dispose(),this.d.delete(V.id)});const G=(0,g.$Rc)(()=>re.cancel());this.d.set(V.id,G)}t(V){const te=this.b.get(V.channelName);if(!te){this.v(V);return}const re=V.id,ae=te.listen(this.j,V.name,V.arg)(G=>this.m({id:re,data:G,type:204}));this.d.set(V.id,ae)}u(V){const te=this.d.get(V.id);te&&(te.dispose(),this.d.delete(V.id))}v(V){let te=this.g.get(V.channelName);te||(te=[],this.g.set(V.channelName,te));const re=setTimeout(()=>{console.error(`Unknown channel: ${V.channelName}`),V.type===100&&this.m({id:V.id,data:{name:"Unknown channel",message:`Channel name '${V.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);te.push({request:V,timeoutTimer:re})}w(V){const te=this.g.get(V);if(te){for(const re of te)switch(clearTimeout(re.timeoutTimer),re.request.type){case 100:this.s(re.request);break;case 102:this.t(re.request);break}this.g.delete(V)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,g.$Oc)(this.d.values()),this.d.clear()}}e.$Uh=E;var b;(function(H){H[H.LocalSide=0]="LocalSide",H[H.OtherSide=1]="OtherSide"})(b||(e.RequestInitiator=b={}));class u{constructor(V,te=null){this.l=V,this.a=!1,this.b=l.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new k.$6d,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(re=>this.s(re)),this.j=te}getChannel(V){const te=this;return{call(re,ee,ae){return te.a?Promise.reject(new R.$5):te.m(V,re,ee,ae)},listen(re,ee){return te.a?k.Event.None:te.o(V,re,ee)}}}m(V,te,re,ee=j.CancellationToken.None){const ae=this.g++,U={id:ae,type:100,channelName:V,name:te,arg:re};if(ee.isCancellationRequested)return Promise.reject(new R.$5);let D;return new Promise((B,q)=>{if(ee.isCancellationRequested)return q(new R.$5);const Y=()=>{const ne=ce=>{switch(ce.type){case 201:this.f.delete(ae),B(ce.data);break;case 202:{this.f.delete(ae);const fe=new Error(ce.data.message);fe.stack=Array.isArray(ce.data.stack)?ce.data.stack.join(`
`):ce.data.stack,fe.name=ce.data.name,q(fe);break}case 203:this.f.delete(ae),q(ce.data);break}};this.f.set(ae,ne),this.p(U)};let _=null;this.b===l.Idle?Y():(_=(0,L.$6g)(ne=>this.u()),_.then(()=>{_=null,Y()}));const ie=()=>{_?(_.cancel(),_=null):this.p({id:ae,type:101}),q(new R.$5)},J=ee.onCancellationRequested(ie);D=(0,g.$Qc)((0,g.$Rc)(ie),J),this.d.add(D)}).finally(()=>{D.dispose(),this.d.delete(D)})}o(V,te,re){const ee=this.g++,G={id:ee,type:102,channelName:V,name:te,arg:re};let U=null;const D=new k.$6d({onWillAddFirstListener:()=>{U=(0,L.$6g)(B=>this.u()),U.then(()=>{U=null,this.d.add(D),this.p(G)})},onDidRemoveLastListener:()=>{U?(U.cancel(),U=null):(this.d.delete(D),this.p({id:ee,type:103}))}}),T=B=>D.fire(B.data);return this.f.set(ee,T),D.event}p(V){switch(V.type){case 100:case 102:{const te=this.q([V.type,V.id,V.channelName,V.name],V.arg);this.j?.logOutgoing(te,V.id,0,`${f(V.type)}: ${V.channelName}.${V.name}`,V.arg);return}case 101:case 103:{const te=this.q([V.type,V.id]);this.j?.logOutgoing(te,V.id,0,f(V.type));return}}}q(V,te=void 0){const re=new i;return r(re,V),r(re,te),this.r(re.buffer)}r(V){try{return this.l.send(V),V.byteLength}catch{return 0}}s(V){const te=new v(V),re=a(te),ee=a(te),ae=re[0];switch(ae){case 200:return this.j?.logIncoming(V.byteLength,0,0,y(ae)),this.t({type:re[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(V.byteLength,re[1],0,y(ae),ee),this.t({type:re[0],id:re[1],data:ee})}}t(V){if(V.type===200){this.b=l.Idle,this.k.fire();return}this.f.get(V.id)?.(V)}get onDidInitializePromise(){return k.Event.toPromise(this.onDidInitialize)}u(){return this.b===l.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,g.$Oc)(this.d.values()),this.d.clear()}}e.$Vh=u,ye([O.$Kh],u.prototype,"onDidInitializePromise",null);class p{get connections(){const V=[];return this.f.forEach(te=>V.push(te)),V}constructor(V){this.a=new Map,this.f=new Set,this.g=new k.$6d,this.onDidAddConnection=this.g.event,this.h=new k.$6d,this.onDidRemoveConnection=this.h.event,this.j=new g.$Sc,this.j.add(V(({protocol:te,onDidClientDisconnect:re})=>{const ee=k.Event.once(te.onMessage);this.j.add(ee(ae=>{const G=new v(ae),U=a(G),D=new E(te,U),T=new u(te);this.a.forEach((q,Y)=>D.registerChannel(Y,q));const B={channelServer:D,channelClient:T,ctx:U};this.f.add(B),this.g.fire(B),this.j.add(re(()=>{D.dispose(),T.dispose(),this.f.delete(B),this.h.fire(B)}))}))}))}getChannel(V,te){const re=this;return{call(ee,ae,G){let U;if((0,w.$8f)(te)){const T=(0,I.$4b)(re.connections.filter(te));U=T?Promise.resolve(T):k.Event.toPromise(k.Event.filter(re.onDidAddConnection,te))}else U=te.routeCall(re,ee,ae);const D=U.then(T=>T.channelClient.getChannel(V));return N(D).call(ee,ae,G)},listen(ee,ae){if((0,w.$8f)(te))return re.k(V,te,ee,ae);const G=te.routeEvent(re,ee,ae).then(U=>U.channelClient.getChannel(V));return N(G).listen(ee,ae)}}}k(V,te,re,ee){const ae=this;let G;const U=new k.$6d({onWillAddFirstListener:()=>{G=new g.$Sc;const D=new k.$_d,T=new Map,B=Y=>{const ie=Y.channelClient.getChannel(V).listen(re,ee),J=D.add(ie);T.set(Y,J)},q=Y=>{const _=T.get(Y);_&&(_.dispose(),T.delete(Y))};ae.connections.filter(te).forEach(B),k.Event.filter(ae.onDidAddConnection,te)(B,void 0,G),ae.onDidRemoveConnection(q,void 0,G),D.event(U.fire,U,G),G.add(D)},onDidRemoveLastListener:()=>{G?.dispose(),G=void 0}});return U.event}registerChannel(V,te){this.a.set(V,te);for(const re of this.f)re.channelServer.registerChannel(V,te)}dispose(){this.j.dispose();for(const V of this.f)V.channelClient.dispose(),V.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$Wh=p;class P{constructor(V,te,re=null){const ee=new i;r(ee,te),V.send(ee.buffer),this.a=new u(V,re),this.d=new E(V,te,re)}getChannel(V){return this.a.getChannel(V)}registerChannel(V,te){this.d.registerChannel(V,te)}dispose(){this.a.dispose(),this.d.dispose()}}e.$Xh=P;function N(H){return{call(V,te,re){return H.then(ee=>ee.call(V,te,re))},listen(V,te){const re=new k.$ce;return H.then(ee=>re.input=ee.listen(V,te)),re.event}}}e.$Yh=N;function F(H){let V=!1;return{call(te,re,ee){return V?H.call(te,re,ee):(0,L.$hh)(0).then(()=>V=!0).then(()=>H.call(te,re,ee))},listen(te,re){if(V)return H.listen(te,re);const ee=new k.$ce;return(0,L.$hh)(0).then(()=>V=!0).then(()=>ee.input=H.listen(te,re)),ee.event}}}e.$Zh=F;class M{constructor(V){this.a=V}routeCall(V){return this.b(V)}routeEvent(V){return this.b(V)}async b(V){for(const te of V.connections)if(await Promise.resolve(this.a(te.ctx)))return Promise.resolve(te);return await k.Event.toPromise(V.onDidAddConnection),await this.b(V)}}e.$1h=M;var z;(function(H){function V(ae,G,U){const D=ae,T=U&&U.disableMarshalling,B=new Map;for(const q in D)re(q)&&B.set(q,k.Event.buffer(D[q],!0,void 0,G));return new class{listen(q,Y,_){const ie=B.get(Y);if(ie)return ie;const J=D[Y];if(typeof J=="function"){if(ee(Y))return J.call(D,_);if(re(Y))return B.set(Y,k.Event.buffer(D[Y],!0,void 0,G)),B.get(Y)}throw new R.$bb(`Event not found: ${Y}`)}call(q,Y,_){const ie=D[Y];if(typeof ie=="function"){if(!T&&Array.isArray(_))for(let ne=0;ne<_.length;ne++)_[ne]=(0,C.$Ph)(_[ne]);let J=ie.apply(D,_);return J instanceof Promise||(J=Promise.resolve(J)),J}throw new R.$bb(`Method not found: ${Y}`)}}}H.fromService=V;function te(ae,G){const U=G&&G.disableMarshalling;return new Proxy({},{get(D,T){if(typeof T=="string")return G?.properties?.has(T)?G.properties.get(T):ee(T)?function(B){return ae.listen(T,B)}:re(T)?ae.listen(T):async function(...B){let q;G&&!(0,w.$3f)(G.context)?q=[G.context,...B]:q=B;const Y=await ae.call(T,q);return U?Y:(0,C.$Ph)(Y)};throw new R.$bb(`Property not found: ${String(T)}`)}})}H.toService=te;function re(ae){return ae[0]==="o"&&ae[1]==="n"&&S.$jf(ae.charCodeAt(2))}function ee(ae){return/^onDynamic/.test(ae)&&S.$jf(ae.charCodeAt(9))}})(z||(e.ProxyChannel=z={}));const Z=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function X(H){if(Array.isArray(H))return H;if(H&&typeof H=="object"&&typeof H.toString=="function"){const V=H.toString();if(V!=="[object Object]")return V}return H}function x(H){return Array.isArray(H)?H.map(X):X(H)}function W(H,V,te,re,ee,ae,G){G=x(G);const U=Z[ee],D=U[re%U.length];let T=[`%c[${H}]%c[${String(V).padStart(7," ")}]%c[len: ${String(te).padStart(5," ")}]%c${String(re).padStart(5," ")} - ${ae}`,"color: darkgreen","color: grey","color: grey",`color: ${D}`];/\($/.test(ae)?(T=T.concat(G),T.push(")")):T.push(G),console.log.apply(console,T)}class Q{constructor(V,te){this.d=V,this.f=te,this.a=0,this.b=0}logOutgoing(V,te,re,ee,ae){this.b+=V,W(this.d,this.b,V,te,re,ee,ae)}logIncoming(V,te,re,ee,ae){this.a+=V,W(this.f,this.a,V,te,re,ee,ae)}}e.$2h=Q}),define(le[68],he([0,1,14,3,2,40]),function(se,e,I,L,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7h=e.$6h=e.$5h=e.$4h=e.ProtocolConstants=e.$3h=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var O;(function(s){s.Created="created",s.Read="read",s.Write="write",s.Open="open",s.Error="error",s.Close="close",s.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",s.NodeEndReceived="nodeEndReceived",s.NodeEndSent="nodeEndSent",s.NodeDrainBegin="nodeDrainBegin",s.NodeDrainEnd="nodeDrainEnd",s.zlibInflateError="zlibInflateError",s.zlibInflateData="zlibInflateData",s.zlibInflateInitialWrite="zlibInflateInitialWrite",s.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",s.zlibInflateWrite="zlibInflateWrite",s.zlibInflateFlushFired="zlibInflateFlushFired",s.zlibDeflateError="zlibDeflateError",s.zlibDeflateData="zlibDeflateData",s.zlibDeflateWrite="zlibDeflateWrite",s.zlibDeflateFlushFired="zlibDeflateFlushFired",s.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",s.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",s.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",s.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",s.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",s.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",s.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",s.ProtocolHeaderRead="protocolHeaderRead",s.ProtocolMessageRead="protocolMessageRead",s.ProtocolHeaderWrite="protocolHeaderWrite",s.ProtocolMessageWrite="protocolMessageWrite",s.ProtocolWrite="protocolWrite"})(O||(e.SocketDiagnosticsEventType=O={}));var R;(function(s){s.enableDiagnostics=!1,s.records=[];const t=new WeakMap;let r=0;function a(b,u){if(!t.has(b)){const p=String(++r);t.set(b,p)}return t.get(b)}function E(b,u,p,P){if(!s.enableDiagnostics)return;const N=a(b,u);if(P instanceof I.$te||P instanceof Uint8Array||P instanceof ArrayBuffer||ArrayBuffer.isView(P)){const F=I.$te.alloc(P.byteLength);F.set(P),s.records.push({timestamp:Date.now(),id:N,label:u,type:p,buff:F})}else s.records.push({timestamp:Date.now(),id:N,label:u,type:p,data:P})}s.traceSocketEvent=E})(R||(e.SocketDiagnostics=R={}));var k;(function(s){s[s.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",s[s.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(k||(e.SocketCloseEventType=k={}));let g=null;function C(){return g||(g=I.$te.alloc(0)),g}class S{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(t){this.a.push(t),this.b+=t.byteLength}read(t){return this.c(t,!0)}peek(t){return this.c(t,!1)}c(t,r){if(t===0)return C();if(t>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===t){const u=this.a[0];return r&&(this.a.shift(),this.b-=t),u}if(this.a[0].byteLength>t){const u=this.a[0].slice(0,t);return r&&(this.a[0]=this.a[0].slice(t),this.b-=t),u}const a=I.$te.alloc(t);let E=0,b=0;for(;t>0;){const u=this.a[b];if(u.byteLength>t){const p=u.slice(0,t);a.set(p,E),E+=t,r&&(this.a[b]=u.slice(t),this.b-=t),t-=t}else a.set(u,E),E+=u.byteLength,r?(this.a.shift(),this.b-=u.byteLength):b++,t-=u.byteLength}return a}}e.$3h=S;var w;(function(s){s[s.None=0]="None",s[s.Regular=1]="Regular",s[s.Control=2]="Control",s[s.Ack=3]="Ack",s[s.Disconnect=5]="Disconnect",s[s.ReplayRequest=6]="ReplayRequest",s[s.Pause=7]="Pause",s[s.Resume=8]="Resume",s[s.KeepAlive=9]="KeepAlive"})(w||(w={}));function h(s){switch(s){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var f;(function(s){s[s.HeaderLength=13]="HeaderLength",s[s.AcknowledgeTime=2e3]="AcknowledgeTime",s[s.TimeoutTime=2e4]="TimeoutTime",s[s.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",s[s.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",s[s.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(f||(e.ProtocolConstants=f={}));class m{constructor(t,r,a,E){this.type=t,this.id=r,this.ack=a,this.data=E,this.writtenTime=0}get size(){return this.data.byteLength}}class y extends A.$Tc{constructor(t){super(),this.f=this.B(new L.$6d),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=t,this.b=!1,this.c=new S,this.B(this.a.onData(r=>this.acceptChunk(r))),this.lastReadTime=Date.now()}acceptChunk(t){if(!(!t||t.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(t);this.c.byteLength>=this.g.readLen;){const r=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=r.readUInt32BE(9),this.g.messageType=r.readUInt8(0),this.g.id=r.readUInt32BE(1),this.g.ack=r.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:h(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const a=this.g.messageType,E=this.g.id,b=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",r),this.f.fire(new m(a,E,b,r)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class l{constructor(t){this.k=null,this.a=!1,this.b=!1,this.c=t,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(t){if(this.a)return;t.writtenTime=Date.now(),this.lastWriteTime=Date.now();const r=I.$te.alloc(13);r.writeUInt8(t.type,0),r.writeUInt32BE(t.id,1),r.writeUInt32BE(t.ack,5),r.writeUInt32BE(t.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:h(t.type),id:t.id,ack:t.ack,messageSize:t.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",t.data),this.j(r,t.data)}g(t,r){const a=this.f===0;return this.d.push(t,r),this.f+=t.byteLength+r.byteLength,a}h(){const t=I.$te.concat(this.d,this.f);return this.d.length=0,this.f=0,t}j(t,r){this.g(t,r)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const t=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:t.byteLength}),this.c.write(t)}}class d extends A.$Tc{constructor(t){super(),this.f=new L.$6d,this.onMessage=this.f.event,this.g=new L.$6d,this.onDidDispose=this.g.event,this.a=t,this.b=this.B(new l(this.a)),this.c=this.B(new y(this.a)),this.B(this.c.onMessage(r=>{r.type===1&&this.f.fire(r.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(t){this.b.write(new m(1,0,0,t))}}e.$4h=d;class $ extends j.$Xh{static fromSocket(t,r){return new $(new d(t),r)}get onDidDispose(){return this.b.onDidDispose}constructor(t,r,a=null){super(t,r,a),this.b=t}dispose(){super.dispose();const t=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),t.end()}}e.$5h=$;class c{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new L.$6d({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(t){this.b?this.d.length>0?this.d.push(t):this.a.fire(t):this.d.push(t)}flushBuffer(){this.d=[]}}e.$6h=c;class v{constructor(t){this.data=t,this.next=null}}class i{constructor(){this.a=null,this.b=null}length(){let t=0,r=this.a;for(;r;)r=r.next,t++;return t}peek(){return this.a?this.a.data:null}toArray(){const t=[];let r=0,a=this.a;for(;a;)t[r++]=a.data,a=a.next;return t}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(t){const r=new v(t);if(!this.a){this.a=r,this.b=r;return}this.b.next=r,this.b=r}}class o{static{this.a=10}static{this.b=null}static getInstance(){return o.b||(o.b=new o),o.b}constructor(){this.c=[];const t=Date.now();for(let r=0;r<o.a;r++)this.c[r]=t-1e3*r;setInterval(()=>{for(let r=o.a;r>=1;r--)this.c[r]=this.c[r-1];this.c[0]=Date.now()},1e3)}d(){const t=Date.now(),r=(1+o.a)*1e3;let a=0;for(let E=0;E<o.a;E++)t-this.c[E]<=r&&a++;return 1-a/o.a}hasHighLoad(){return this.d()>=.5}}class n{get unacknowledgedCount(){return this.c-this.d}constructor(t){this.u=new c,this.onControlMessage=this.u.event,this.v=new c,this.onMessage=this.v.event,this.w=new c,this.onDidDispose=this.w.event,this.x=new c,this.onSocketClose=this.x.event,this.y=new c,this.onSocketTimeout=this.y.event,this.s=t.loadEstimator??o.getInstance(),this.t=t.sendKeepAlive??!0,this.a=!1,this.b=new i,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new A.$Sc,this.o=t.socket,this.p=this.r.add(new l(this.o)),this.q=this.r.add(new y(this.o)),this.r.add(this.q.onMessage(r=>this.z(r))),this.r.add(this.o.onClose(r=>this.x.fire(r))),t.initialChunk&&this.q.acceptChunk(t.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const t=new m(5,0,0,C());this.p.write(t),this.p.flush()}sendPause(){const t=new m(7,0,0,C());this.p.write(t)}sendResume(){const t=new m(8,0,0,C());this.p.write(t)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(t,r){this.a=!0,this.r.dispose(),this.r=new A.$Sc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=t,this.p=this.r.add(new l(this.o)),this.q=this.r.add(new y(this.o)),this.r.add(this.q.onMessage(a=>this.z(a))),this.r.add(this.o.onClose(a=>this.x.fire(a))),this.q.acceptChunk(r)}endAcceptReconnection(){this.a=!1,this.h=this.g;const t=new m(3,0,this.h,C());this.p.write(t);const r=this.b.toArray();for(let a=0,E=r.length;a<E;a++)this.p.write(r[a]);this.B()}acceptDisconnect(){this.w.fire()}z(t){if(t.ack>this.d){this.d=t.ack;do{const r=this.b.peek();if(r&&r.id<=t.ack)this.b.pop();else break}while(!0)}switch(t.type){case 0:break;case 1:{if(t.id>this.g)if(t.id!==this.g+1){const r=Date.now();r-this.m>1e4&&(this.m=r,this.p.write(new m(6,0,0,C())))}else this.g=t.id,this.j=Date.now(),this.A(),this.v.fire(t.data);break}case 2:{this.u.fire(t.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const r=this.b.toArray();for(let a=0,E=r.length;a<E;a++)this.p.write(r[a]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(t){const r=++this.c;this.h=this.g;const a=new m(1,r,this.h,t);this.b.push(a),this.a||(this.p.write(a),this.B())}sendControl(t){const r=new m(2,0,0,t);this.p.write(r)}A(){if(this.g<=this.h||this.k)return;const t=Date.now()-this.j;if(t>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-t+5)}B(){if(this.c<=this.d||this.f||this.a)return;const t=this.b.peek(),r=Date.now()-t.writtenTime,a=Date.now()-this.q.lastReadTime,E=Date.now()-this.n;if(r>=2e4&&a>=2e4&&E>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:r,timeSinceLastReceivedSomeData:a});return}const b=Math.max(2e4-r,2e4-a,2e4-E,500);this.f=setTimeout(()=>{this.f=null,this.B()},b)}C(){if(this.g<=this.h)return;this.h=this.g;const t=new m(3,0,this.h,C());this.p.write(t)}D(){this.h=this.g;const t=new m(9,0,this.h,C());this.p.write(t)}}e.$7h=n}),define(le[92],he([0,1,67,6,14,26,142,7,3,2,30,147,89,40]),function(se,e,I,L,A,j,O,R,k,g,C,S,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gq=e.$Fq=void 0;class f extends h.$Uh{constructor(l){super({send:d=>{try{process.send?.(d.buffer.toString("base64"))}catch{}},onMessage:k.Event.fromNodeEventEmitter(process,"message",d=>A.$te.wrap(Buffer.from(d,"base64")))},l),process.once("disconnect",()=>this.dispose())}}e.$Fq=f;class m{constructor(l,d){this.i=l,this.j=d,this.c=new Set,this.g=new Map,this.h=new k.$6d,this.onDidProcessExit=this.h.event;const $=d&&d.timeout?d.timeout:6e4;this.b=new L.$dh($),this.d=null,this.f=null}getChannel(l){const d=this;return{call($,c,v){return d.k(l,$,c,v)},listen($,c){return d.l(l,$,c)}}}k(l,d,$,c=j.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(c.isCancellationRequested)return Promise.reject(R.$6());this.b.cancel();const v=this.n(l),i=(0,L.$6g)(s=>v.call(d,$,s)),o=c.onCancellationRequested(()=>i.cancel()),n=(0,g.$Rc)(()=>i.cancel());return this.c.add(n),i.finally(()=>{o.dispose(),this.c.delete(n),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),i}l(l,d,$){if(!this.b)return k.Event.None;this.b.cancel();let c;const v=new k.$6d({onWillAddFirstListener:()=>{c=this.n(l).listen(d,$)(v.fire,v),this.c.add(c)},onDidRemoveLastListener:()=>{this.c.delete(c),c.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return v.event}get m(){if(!this.f){const l=this.j&&this.j.args?this.j.args:[],d=Object.create(null);d.env={...(0,C.$Ln)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(d.env={...d.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(d.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(d.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(d.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),d.execArgv===void 0&&(d.execArgv=process.execArgv.filter(t=>!/^--inspect(-brk)?=/.test(t)).filter(t=>!t.startsWith("--vscode-"))),(0,w.$4l)(d.env),this.d=(0,I.fork)(this.i,l,d);const $=new k.$6d;k.Event.fromNodeEventEmitter(this.d,"message",t=>t)(t=>{if((0,O.$Bq)(t)){(0,O.log)(t,`IPC Library: ${this.j.serverName}`);return}$.fire(A.$te.wrap(Buffer.from(t,"base64")))});const v=this.j.useQueue?(0,S.$6l)(this.d):this.d,i=t=>this.d&&this.d.connected&&v.send(t.buffer.toString("base64")),o=$.event,n={send:i,onMessage:o};this.f=new h.$Vh(n);const s=()=>this.o();process.once("exit",s),this.d.on("error",t=>console.warn('IPC "'+this.j.serverName+'" errored with '+t)),this.d.on("exit",(t,r)=>{process.removeListener("exit",s),this.c.forEach(a=>(0,g.$Oc)(a)),this.c.clear(),t!==0&&r!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+t+" and signal "+r),this.b?.cancel(),this.o(),this.h.fire({code:t,signal:r})})}return this.f}n(l){let d=this.g.get(l);return d||(d=this.m.getChannel(l),this.g.set(l,d)),d}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$Gq=m}),define(le[149],he([0,1,134,14,40,3,12,17]),function(se,e,I,L,A,j,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6V=e.$5V=void 0;class k{constructor(w){this.a=w,this.onMessage=j.Event.fromNodeEventEmitter(this.a,"message",h=>h.data?L.$te.wrap(h.data):L.$te.alloc(0)),w.start()}send(w){this.a.postMessage(w.buffer)}disconnect(){this.a.close()}}class g extends A.$Wh{static b(w){(0,O.$4f)((0,I.$4V)(process),"Electron Utility Process");const h=new j.$6d;return process.parentPort.on("message",f=>{if(w?.handledClientConnection(f))return;const m=(0,R.$Ob)(f.ports);m&&h.fire(m)}),j.Event.map(h.event,f=>({protocol:new k(f),onDidClientDisconnect:j.Event.fromNodeEventEmitter(f,"close")}))}constructor(w){super(g.b(w))}}e.$5V=g;function C(S,w,h){const f=m=>{m.data===w&&(S.removeListener("message",f),h())};S.on("message",f)}e.$6V=C}),define(le[69],he([0,1,6,3,2,66,12]),function(se,e,I,L,A,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gp=e.$Fp=e.StorageState=e.$Ep=e.StorageHint=void 0;var R;(function(w){w[w.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",w[w.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(R||(e.StorageHint=R={}));function k(w){const h=w;return h?.changed instanceof Map||h?.deleted instanceof Set}e.$Ep=k;var g;(function(w){w[w.None=0]="None",w[w.Initialized=1]="Initialized",w[w.Closed=2]="Closed"})(g||(e.StorageState=g={}));class C extends A.$Tc{static{this.a=100}constructor(h,f=Object.create(null)){super(),this.r=h,this.s=f,this.b=this.B(new L.$9d),this.onDidChangeStorage=this.b.event,this.c=g.None,this.f=new Map,this.g=this.B(new I.$eh(C.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(h=>this.u(h)))}u(h){this.b.pause();try{h.changed?.forEach((f,m)=>this.w(m,f)),h.deleted?.forEach(f=>this.w(f,void 0))}finally{this.b.resume()}}w(h,f){if(this.c===g.Closed)return;let m=!1;(0,O.$3f)(f)?m=this.f.delete(h):this.f.get(h)!==f&&(this.f.set(h,f),m=!0),m&&this.b.fire({key:h,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===g.None&&(this.c=g.Initialized,this.s.hint!==R.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(h,f){const m=this.f.get(h);return(0,O.$3f)(m)?f:m}getBoolean(h,f){const m=this.get(h);return(0,O.$3f)(m)?f:m==="true"}getNumber(h,f){const m=this.get(h);return(0,O.$3f)(m)?f:parseInt(m,10)}getObject(h,f){const m=this.get(h);return(0,O.$3f)(m)?f:(0,j.$Oh)(m)}async set(h,f,m=!1){if(this.c===g.Closed)return;if((0,O.$3f)(f))return this.delete(h,m);const y=(0,O.$Vf)(f)||Array.isArray(f)?(0,j.$Nh)(f):String(f);if(this.f.get(h)!==y)return this.f.set(h,y),this.j.set(h,y),this.h.delete(h),this.b.fire({key:h,external:m}),this.D()}async delete(h,f=!1){if(!(this.c===g.Closed||!this.f.delete(h)))return this.h.has(h)||this.h.add(h),this.j.delete(h),this.b.fire({key:h,external:f}),this.D()}async optimize(){if(this.c!==g.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=g.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const h={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(h).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(h){if(this.z)return this.D(h)}async D(h){return this.s.hint===R.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),h)}async whenFlushed(){if(this.z)return new Promise(h=>this.n.push(h))}isInMemory(){return this.s.hint===R.STORAGE_IN_MEMORY}}e.$Fp=C;class S{constructor(){this.onDidChangeItemsExternal=L.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(h){h.insert?.forEach((f,m)=>this.a.set(m,f)),h.delete?.forEach(f=>this.a.delete(f))}async optimize(){}async close(){}}e.$Gp=S}),define(le[150],he([13,9]),function(se,e){return se.create("vs/base/node/zip",e)}),define(le[70],he([0,1,50,6,15,12,31,150]),function(se,e,I,L,A,j,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5p=e.$4p=e.zip=e.$2p=e.$1p=void 0,e.$1p="end of central directory record signature not found";const k=new RegExp(e.$1p);class g extends Error{constructor(v,i){let o=i.message;switch(v){case"CorruptZip":o=`Corrupt ZIP: ${o}`;break}super(o),this.type=v,this.cause=i}}e.$2p=g;function C(c){const v=c.externalFileAttributes>>16||33188;return[448,56,7].map(i=>v&i).reduce((i,o)=>i+o,v&61440)}function S(c){if(c instanceof g)return c;let v;return k.test(c.message)&&(v="CorruptZip"),new g(v,c)}function w(c,v,i,o,n,s){const t=A.$mc(v),r=A.$jc(o,t);if(!r.startsWith(o))return Promise.reject(new Error(R.localize(0,null,v)));const a=A.$jc(o,v);let E;return s.onCancellationRequested(()=>{E?.destroy()}),Promise.resolve(O.Promises.mkdir(r,{recursive:!0})).then(()=>new Promise((b,u)=>{if(!s.isCancellationRequested)try{E=(0,I.createWriteStream)(a,{mode:i}),E.once("close",()=>b()),E.once("error",u),c.once("error",u),c.pipe(E)}catch(p){u(p)}}))}function h(c,v,i,o){let n=(0,L.$6g)(()=>Promise.resolve()),s=0;const t=o.onCancellationRequested(()=>{n.cancel(),c.close()});return new Promise((r,a)=>{const E=new L.$bh,b=u=>{u.isCancellationRequested||(s++,c.readEntry())};c.once("error",a),c.once("close",()=>n.then(()=>{o.isCancellationRequested||c.entryCount===s?r():a(new g("Incomplete",new Error(R.localize(1,null,s,c.entryCount))))},a)),c.readEntry(),c.on("entry",u=>{if(o.isCancellationRequested)return;if(!i.sourcePathRegex.test(u.fileName)){b(o);return}const p=u.fileName.replace(i.sourcePathRegex,"");if(/\/$/.test(p)){const F=A.$jc(v,p);n=(0,L.$6g)(M=>O.Promises.mkdir(F,{recursive:!0}).then(()=>b(M)).then(void 0,a));return}const P=m(c,u),N=C(u);n=(0,L.$6g)(F=>E.queue(()=>P.then(M=>w(M,p,N,v,i,F).then(()=>b(F)))).then(null,a))})}).finally(()=>t.dispose())}async function f(c,v=!1){const{open:i}=await new Promise((o,n)=>{se(["yauzl"],o,n)});return new Promise((o,n)=>{i(c,v?{lazyEntries:!0}:void 0,(s,t)=>{s?n(S(s)):o((0,j.$5f)(t))})})}function m(c,v){return new Promise((i,o)=>{c.openReadStream(v,(n,s)=>{n?o(S(n)):i((0,j.$5f)(s))})})}async function y(c,v){const{ZipFile:i}=await new Promise((o,n)=>{se(["yazl"],o,n)});return new Promise((o,n)=>{const s=new i;v.forEach(r=>{r.contents?s.addBuffer(typeof r.contents=="string"?Buffer.from(r.contents,"utf8"):r.contents,r.path):r.localPath&&s.addFile(r.localPath,r.path)}),s.end();const t=(0,I.createWriteStream)(c);s.outputStream.pipe(t),s.outputStream.once("error",n),t.once("error",n),t.once("finish",()=>o(c))})}e.zip=y;function l(c,v,i={},o){const n=new RegExp(i.sourcePath?`^${i.sourcePath}`:"");let s=f(c,!0);return i.overwrite&&(s=s.then(t=>O.Promises.rm(v).then(()=>t))),s.then(t=>h(t,v,{sourcePathRegex:n},o))}e.$4p=l;function d(c,v){return f(c).then(i=>new Promise((o,n)=>{i.on("entry",s=>{s.fileName===v&&m(i,s).then(t=>o(t),t=>n(t))}),i.once("close",()=>n(new Error(R.localize(2,null,v))))}))}function $(c,v){return d(c,v).then(i=>new Promise((o,n)=>{const s=[];i.once("error",n),i.on("data",t=>s.push(t)),i.on("end",()=>o(Buffer.concat(s)))}))}e.$5p=$}),define(le[151],he([13,9]),function(se,e){return se.create("vs/platform/configuration/common/configurationRegistry",e)}),define(le[152],he([13,9]),function(se,e){return se.create("vs/platform/contextkey/common/contextkey",e)}),define(le[153],he([13,9]),function(se,e){return se.create("vs/platform/contextkey/common/scanner",e)}),define(le[154],he([13,9]),function(se,e){return se.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(le[155],he([13,9]),function(se,e){return se.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(le[156],he([13,9]),function(se,e){return se.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(le[157],he([13,9]),function(se,e){return se.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(le[158],he([13,9]),function(se,e){return se.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(le[159],he([13,9]),function(se,e){return se.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(le[160],he([13,9]),function(se,e){return se.create("vs/platform/extensions/common/extensionValidator",e)}),define(le[161],he([13,9]),function(se,e){return se.create("vs/platform/files/common/fileService",e)}),define(le[162],he([13,9]),function(se,e){return se.create("vs/platform/files/common/files",e)}),define(le[163],he([13,9]),function(se,e){return se.create("vs/platform/files/common/io",e)}),define(le[164],he([13,9]),function(se,e){return se.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(le[165],he([13,9]),function(se,e){return se.create("vs/platform/languagePacks/common/languagePacks",e)}),define(le[166],he([13,9]),function(se,e){return se.create("vs/platform/remoteTunnel/common/remoteTunnel",e)}),define(le[167],he([13,9]),function(se,e){return se.create("vs/platform/remoteTunnel/node/remoteTunnelService",e)}),define(le[168],he([13,9]),function(se,e){return se.create("vs/platform/request/common/request",e)}),define(le[169],he([13,9]),function(se,e){return se.create("vs/platform/telemetry/common/telemetryLogAppender",e)}),define(le[170],he([13,9]),function(se,e){return se.create("vs/platform/telemetry/common/telemetryService",e)}),define(le[171],he([13,9]),function(se,e){return se.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(le[172],he([13,9]),function(se,e){return se.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(le[173],he([13,9]),function(se,e){return se.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(le[174],he([13,9]),function(se,e){return se.create("vs/platform/userDataSync/common/settingsSync",e)}),define(le[175],he([13,9]),function(se,e){return se.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(le[176],he([13,9]),function(se,e){return se.create("vs/platform/userDataSync/common/userDataSync",e)}),define(le[177],he([13,9]),function(se,e){return se.create("vs/platform/userDataSync/common/userDataSyncLog",e)}),define(le[178],he([13,9]),function(se,e){return se.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(le[179],he([13,9]),function(se,e){return se.create("vs/platform/userDataSync/common/userDataSyncResourceProvider",e)}),define(le[180],he([13,9]),function(se,e){return se.create("vs/platform/workspace/common/workspace",e)}),define(le[181],he([0,1,7,153]),function(se,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bj=e.TokenType=void 0;var A;(function(g){g[g.LParen=0]="LParen",g[g.RParen=1]="RParen",g[g.Neg=2]="Neg",g[g.Eq=3]="Eq",g[g.NotEq=4]="NotEq",g[g.Lt=5]="Lt",g[g.LtEq=6]="LtEq",g[g.Gt=7]="Gt",g[g.GtEq=8]="GtEq",g[g.RegexOp=9]="RegexOp",g[g.RegexStr=10]="RegexStr",g[g.True=11]="True",g[g.False=12]="False",g[g.In=13]="In",g[g.Not=14]="Not",g[g.And=15]="And",g[g.Or=16]="Or",g[g.Str=17]="Str",g[g.QuotedStr=18]="QuotedStr",g[g.Error=19]="Error",g[g.EOF=20]="EOF"})(A||(e.TokenType=A={}));function j(...g){switch(g.length){case 1:return(0,L.localize)(0,null,g[0]);case 2:return(0,L.localize)(1,null,g[0],g[1]);case 3:return(0,L.localize)(2,null,g[0],g[1],g[2]);default:return}}const O=(0,L.localize)(3,null),R=(0,L.localize)(4,null);class k{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(C){switch(C.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return C.isTripleEq?"===":"==";case 4:return C.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return C.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return C.lexeme;case 18:return C.lexeme;case 19:return C.lexeme;case 20:return"EOF";default:throw(0,I.$8)(`unhandled token type: ${JSON.stringify(C)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(C=>C.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(C){return this.c=C,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const S=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:S})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const S=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:S})}else this.h(126)?this.k(9):this.l(j("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(j("&&"));break;case 124:this.h(124)?this.k(16):this.l(j("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(C){return this.r()||this.c.charCodeAt(this.e)!==C?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(C){this.f.push({type:C,offset:this.d})}l(C){const S=this.d,w=this.c.substring(this.d,this.e),h={type:19,offset:this.d,lexeme:w};this.g.push({offset:S,lexeme:w,additionalInfo:C}),this.f.push(h)}n(){this.m.lastIndex=this.d;const C=this.m.exec(this.c);if(C){this.e=this.d+C[0].length;const S=this.c.substring(this.d,this.e),w=k.b.get(S);w?this.k(w):this.f.push({type:17,lexeme:S,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(O);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let C=this.e,S=!1,w=!1;for(;;){if(C>=this.c.length){this.e=C,this.l(R);return}const f=this.c.charCodeAt(C);if(S)S=!1;else if(f===47&&!w){C++;break}else f===91?w=!0:f===92?S=!0:f===93&&(w=!1);C++}for(;C<this.c.length&&k.a.has(this.c.charCodeAt(C));)C++;this.e=C;const h=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:h,offset:this.d})}r(){return this.e>=this.c.length}}e.$bj=k}),define(le[182],he([0,1,65,84,23,15,36,20,10]),function(se,e,I,L,A,j,O,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qm=e.$Pm=e.$Om=e.$Nm=void 0,e.$Nm=/^([^.]+\..+)[:=](.+)$/;class g{get appRoot(){return(0,j.$mc)(A.$Ag.asFileUri("").fsPath)}get userHome(){return k.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return k.URI.file((0,j.$jc)(this.userDataPath,"User"))}get tmpDir(){return k.URI.file(this.b.tmpDir)}get cacheHome(){return k.URI.file(this.userDataPath)}get stateResource(){return(0,R.$Tg)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:A.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,R.$Tg)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const h=(0,I.$Mm)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,j.$jc)(this.userDataPath,"logs",h)}return k.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,R.$Tg)(k.URI.file((0,j.$jc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,R.$Tg)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,R.$Tg)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,R.$Tg)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const h=O.env.VSCODE_PORTABLE;return h?k.URI.file((0,j.$jc)(h,"argv.json")):(0,R.$Tg)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return k.URI.file((0,j.$jc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const h=this.args["builtin-extensions-dir"];return h?(0,j.$kc)(h):(0,j.$hc)((0,j.$jc)(A.$Ag.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const h=this.args["extensions-download-dir"];return h?k.URI.file((0,j.$kc)(h)):k.URI.file((0,j.$jc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const h=this.args["extensions-dir"];if(h)return(0,j.$kc)(h);const f=O.env.VSCODE_EXTENSIONS;if(f)return f;const m=O.env.VSCODE_PORTABLE;return m?(0,j.$jc)(m,"extensions"):(0,R.$Tg)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const h=this.args.extensionDevelopmentPath;if(Array.isArray(h))return h.map(f=>/^[^:/?#]+?:\/\//.test(f)?k.URI.parse(f):k.URI.file((0,j.$hc)(f)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(h=>h==="ui"||h==="workspace"||h==="web"?h:"workspace")}get extensionTestsLocationURI(){const h=this.args.extensionTestsPath;if(h)return/^[^:/?#]+?:\/\//.test(h)?k.URI.parse(h):k.URI.file((0,j.$hc)(h))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const h=this.args["disable-extension"];if(h){if(typeof h=="string")return[h];if(Array.isArray(h)&&h.length>0)return h}return!1}get debugExtensionHost(){return C(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!O.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(h=>!e.$Nm.test(h))}get extensionLogLevel(){const h=[];for(const f of this.args.log||[]){const m=e.$Nm.exec(f);m&&m[1]&&m[2]&&h.push([m[1],m[2]])}return h.length?h:void 0}get serviceMachineIdResource(){return(0,R.$Tg)(k.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const h=O.env.VSCODE_PORTABLE;return h?k.URI.file((0,j.$jc)(h,"policy.json")):(0,R.$Tg)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(h){this.args.continueOn=h}get args(){return this.a}constructor(h,f,m){this.a=h,this.b=f,this.c=m,this.editSessionId=this.args.editSessionId}}e.$Om=g,ye([L.$Kh],g.prototype,"appRoot",null),ye([L.$Kh],g.prototype,"userHome",null),ye([L.$Kh],g.prototype,"userDataPath",null),ye([L.$Kh],g.prototype,"appSettingsHome",null),ye([L.$Kh],g.prototype,"tmpDir",null),ye([L.$Kh],g.prototype,"cacheHome",null),ye([L.$Kh],g.prototype,"stateResource",null),ye([L.$Kh],g.prototype,"userRoamingDataHome",null),ye([L.$Kh],g.prototype,"userDataSyncHome",null),ye([L.$Kh],g.prototype,"sync",null),ye([L.$Kh],g.prototype,"machineSettingsResource",null),ye([L.$Kh],g.prototype,"workspaceStorageHome",null),ye([L.$Kh],g.prototype,"localHistoryHome",null),ye([L.$Kh],g.prototype,"keyboardLayoutResource",null),ye([L.$Kh],g.prototype,"argvResource",null),ye([L.$Kh],g.prototype,"isExtensionDevelopment",null),ye([L.$Kh],g.prototype,"untitledWorkspacesHome",null),ye([L.$Kh],g.prototype,"builtinExtensionsPath",null),ye([L.$Kh],g.prototype,"extensionsPath",null),ye([L.$Kh],g.prototype,"extensionDevelopmentLocationURI",null),ye([L.$Kh],g.prototype,"extensionDevelopmentKind",null),ye([L.$Kh],g.prototype,"extensionTestsLocationURI",null),ye([L.$Kh],g.prototype,"debugExtensionHost",null),ye([L.$Kh],g.prototype,"logLevel",null),ye([L.$Kh],g.prototype,"extensionLogLevel",null),ye([L.$Kh],g.prototype,"serviceMachineIdResource",null),ye([L.$Kh],g.prototype,"disableTelemetry",null),ye([L.$Kh],g.prototype,"disableWorkspaceTrust",null),ye([L.$Kh],g.prototype,"useInMemorySecretStorage",null),ye([L.$Kh],g.prototype,"policyFile",null);function C(w,h){return S(w["inspect-extensions"],w["inspect-brk-extensions"],5870,h,w.debugId,w.extensionEnvironment)}e.$Pm=C;function S(w,h,f,m,y,l){const $=Number(h||w)||(m?null:f),c=$?!!h:!1;let v;if(l)try{v=JSON.parse(l)}catch{}return{port:$,break:c,debugId:y,env:v}}e.$Qm=S}),function(){"use strict";function se(e,I,L){function A(O,R){const k=j(O,R),g=[k];return e.isAbsolute(k)||g.unshift(L),e.resolve(...g)}function j(O,R){process.env.VSCODE_DEV&&(R="code-oss-dev");const k=process.env.VSCODE_PORTABLE;if(k)return e.join(k,"user-data");let g=process.env.VSCODE_APPDATA;if(g)return e.join(g,R);const C=O["user-data-dir"];if(C)return C;switch(process.platform){case"win32":if(g=process.env.APPDATA,!g){const S=process.env.USERPROFILE;if(typeof S!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");g=e.join(S,"AppData","Roaming")}break;case"darwin":g=e.join(I.homedir(),"Library","Application Support");break;case"linux":g=process.env.XDG_CONFIG_HOME||e.join(I.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(g,R)}return{getUserDataPath:A}}if(typeof define=="function")define(le[183],he([273,37,36]),function(e,I,L){return se(e,I,L.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),I=require("os");module.exports=se(e,I,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(le[184],he([0,1,37,182,183]),function(se,e,I,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tm=e.$Sm=e.$Rm=void 0;class j extends L.$Om{constructor(g,C){super(g,{homeDir:(0,I.homedir)(),tmpDir:(0,I.tmpdir)(),userDataDir:(0,A.getUserDataPath)(g,C.nameShort)},C)}}e.$Rm=j;function O(k,g){return(0,L.$Qm)(k["inspect-ptyhost"],k["inspect-brk-ptyhost"],5877,g,k.extensionEnvironment)}e.$Sm=O;function R(k,g){return(0,L.$Qm)(k["inspect-sharedprocess"],k["inspect-brk-sharedprocess"],5879,g,k.extensionEnvironment)}e.$Tm=R}),define(le[185],he([0,1,12,156]),function(se,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bq=void 0;function A(O,R,k,g){try{j(O,R,k,g)}catch(C){O.error(C?.message??C)}return R}e.$bq=A;function j(O,R,k,g){const C=(S,w,h)=>{const f=S[w];if((0,I.$Tf)(f)){const m=f,y=m.length;if(y>1&&m[0]==="%"&&m[y-1]==="%"){const l=m.substr(1,y-2);let d=k[l];d===void 0&&g&&(d=g[l]);const $=typeof d=="string"?d:d?.message,c=g?.[l],v=typeof c=="string"?c:c?.message;if(!$){v||O.warn(`[${R.name}]: ${(0,L.localize)(0,null,l)}`);return}if(h&&(w==="title"||w==="category")&&v&&v!==$){const i={value:$,original:v};S[w]=i}else S[w]=$}}else if((0,I.$Vf)(f))for(const m in f)f.hasOwnProperty(m)&&(m==="commands"?C(f,m,!0):C(f,m,h));else if(Array.isArray(f))for(let m=0;m<f.length;m++)C(f,m,h)};for(const S in R)R.hasOwnProperty(S)&&C(R,S)}}),define(le[186],he([0,1,70,159]),function(se,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jq=void 0;function A(j){return(0,I.$5p)(j,"extension/package.json").then(O=>{try{return JSON.parse(O.toString("utf8"))}catch{throw new Error((0,L.localize)(0,null))}})}e.$jq=A}),define(le[187],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vbc=e.$Ubc=void 0;class I{constructor(j){this.a=j}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(j){return this.a.call("promptImportantExtensionsInstallNotification",[j])}promptWorkspaceRecommendations(j){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.$Ubc=I;class L{constructor(j){this.a=j}listen(j,O){throw new Error(`Event not found: ${O}`)}call(j,O,R){switch(O){case"promptImportantExtensionsInstallNotification":return this.a.promptImportantExtensionsInstallNotification(R[0])}throw new Error(`Call not found: ${O}`)}}e.$Vbc=L}),define(le[71],he([0,1,20,88,160,55]),function(se,e,I,L,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vp=e.$up=e.$tp=e.$sp=e.$rp=e.$qp=e.$pp=void 0;const O=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,R=/^-(\d{4})(\d{2})(\d{2})$/;function k(l){return l=l.trim(),l==="*"||O.test(l)}e.$pp=k;function g(l){if(!k(l))return null;if(l=l.trim(),l==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const d=l.match(O);return d?{hasCaret:d[1]==="^",hasGreaterEquals:d[1]===">=",majorBase:d[2]==="x"?0:parseInt(d[2],10),majorMustEqual:d[2]!=="x",minorBase:d[4]==="x"?0:parseInt(d[4],10),minorMustEqual:d[4]!=="x",patchBase:d[6]==="x"?0:parseInt(d[6],10),patchMustEqual:d[6]!=="x",preRelease:d[8]||null}:null}e.$qp=g;function C(l){if(!l)return null;const d=l.majorBase,$=l.majorMustEqual,c=l.minorBase;let v=l.minorMustEqual;const i=l.patchBase;let o=l.patchMustEqual;l.hasCaret&&(d===0||(v=!1),o=!1);let n=0;if(l.preRelease){const s=R.exec(l.preRelease);if(s){const[,t,r,a]=s;n=Date.UTC(Number(t),Number(r)-1,Number(a))}}return{majorBase:d,majorMustEqual:$,minorBase:c,minorMustEqual:v,patchBase:i,patchMustEqual:o,isMinimum:l.hasGreaterEquals,notBefore:n}}e.$rp=C;function S(l,d,$){let c;typeof l=="string"?c=C(g(l)):c=l;let v;d instanceof Date?v=d.getTime():typeof d=="string"&&(v=new Date(d).getTime());let i;if(typeof $=="string"?i=C(g($)):i=$,!c||!i)return!1;const o=c.majorBase,n=c.minorBase,s=c.patchBase;let t=i.majorBase,r=i.minorBase,a=i.patchBase;const E=i.notBefore;let b=i.majorMustEqual,u=i.minorMustEqual,p=i.patchMustEqual;return i.isMinimum?o>t?!0:o<t?!1:n>r?!0:n<r||v&&v<E?!1:s>=a:(o===1&&t===0&&(!b||!u||!p)&&(t=1,r=0,a=0,b=!0,u=!1,p=!1),o<t?!1:o>t?!b:n<r?!1:n>r?!u:s<a?!1:s>a?!p:!(v&&v<E))}e.$sp=S;function w(l,d,$,c,v){const i=[];if(typeof c.publisher<"u"&&typeof c.publisher!="string")return i.push([L.default.Error,A.localize(0,null)]),i;if(typeof c.name!="string")return i.push([L.default.Error,A.localize(1,null,"name")]),i;if(typeof c.version!="string")return i.push([L.default.Error,A.localize(2,null,"version")]),i;if(!c.engines)return i.push([L.default.Error,A.localize(3,null,"engines")]),i;if(typeof c.engines.vscode!="string")return i.push([L.default.Error,A.localize(4,null,"engines.vscode")]),i;if(typeof c.extensionDependencies<"u"&&!y(c.extensionDependencies))return i.push([L.default.Error,A.localize(5,null,"extensionDependencies")]),i;if(typeof c.activationEvents<"u"){if(!y(c.activationEvents))return i.push([L.default.Error,A.localize(6,null,"activationEvents")]),i;if(typeof c.main>"u"&&typeof c.browser>"u")return i.push([L.default.Error,A.localize(7,null,"activationEvents","main","browser")]),i}if(typeof c.extensionKind<"u"&&typeof c.main>"u"&&i.push([L.default.Warning,A.localize(8,null,"extensionKind")]),typeof c.main<"u"){if(typeof c.main!="string")return i.push([L.default.Error,A.localize(9,null,"main")]),i;{const s=(0,I.$Tg)($,c.main);(0,I.$Ng)(s,$)||i.push([L.default.Warning,A.localize(10,null,s.path,$.path)])}}if(typeof c.browser<"u"){if(typeof c.browser!="string")return i.push([L.default.Error,A.localize(11,null,"browser")]),i;{const s=(0,I.$Tg)($,c.browser);(0,I.$Ng)(s,$)||i.push([L.default.Warning,A.localize(12,null,s.path,$.path)])}}if(!j.valid(c.version))return i.push([L.default.Error,A.localize(13,null)]),i;const o=[];if(!h(l,d,c,v,o))for(const s of o)i.push([L.default.Error,s]);return i}e.$tp=w;function h(l,d,$,c,v){return c||typeof $.main>"u"&&typeof $.browser>"u"?!0:m(l,d,$.engines.vscode,v)}e.$up=h;function f(l,d,$){return l==="*"||m(d,$,l)}e.$vp=f;function m(l,d,$,c=[]){const v=C(g($));if(!v)return c.push(A.localize(14,null,$)),!1;if(v.majorBase===0){if(!v.majorMustEqual||!v.minorMustEqual)return c.push(A.localize(15,null,$)),!1}else if(!v.majorMustEqual)return c.push(A.localize(16,null,$)),!1;return S(l,d,v)?!0:(c.push(A.localize(17,null,l,$)),!1)}function y(l){if(!Array.isArray(l))return!1;for(let d=0,$=l.length;d<$;d++)if(typeof l[d]!="string")return!1;return!0}}),define(le[43],he([0,1,14,32]),function(se,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pp=void 0;async function A(j,O,R){let k=R&&R.get("storage.serviceMachineId",-1)||null;if(k)return k;try{const C=(await O.readFile(j.serviceMachineIdResource)).value.toString();k=(0,L.$Bg)(C)?C:null}catch{k=null}if(!k){k=(0,L.$Cg)();try{await O.writeFile(j.serviceMachineIdResource,I.$te.fromString(k))}catch{}}return R?.store("storage.serviceMachineId",k,-1,1),k}e.$Pp=A}),define(le[72],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$di=void 0;class I{constructor(A,j=[],O=!1){this.ctor=A,this.staticArguments=j,this.supportsDelayedInstantiation=O}}e.$di=I}),define(le[188],he([0,1,72]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cs=e.$bs=e.InstantiationType=void 0;const L=[];var A;(function(R){R[R.Eager=0]="Eager",R[R.Delayed=1]="Delayed"})(A||(e.InstantiationType=A={}));function j(R,k,g){k instanceof I.$di||(k=new I.$di(k,[],!!g)),L.push([R,k])}e.$bs=j;function O(){return L}e.$cs=O}),define(le[189],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sq=e.$Rq=void 0;class I{constructor(j,O){this.key=j,this.data=O,this.incoming=new Map,this.outgoing=new Map}}e.$Rq=I;class L{constructor(j){this.b=j,this.a=new Map}roots(){const j=[];for(const O of this.a.values())O.outgoing.size===0&&j.push(O);return j}insertEdge(j,O){const R=this.lookupOrInsertNode(j),k=this.lookupOrInsertNode(O);R.outgoing.set(k.key,k),k.incoming.set(R.key,R)}removeNode(j){const O=this.b(j);this.a.delete(O);for(const R of this.a.values())R.outgoing.delete(O),R.incoming.delete(O)}lookupOrInsertNode(j){const O=this.b(j);let R=this.a.get(O);return R||(R=new I(O,j),this.a.set(O,R)),R}lookup(j){return this.a.get(this.b(j))}isEmpty(){return this.a.size===0}toString(){const j=[];for(const[O,R]of this.a)j.push(`${O}
	(-> incoming)[${[...R.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...R.outgoing.keys()].join(",")}]
`);return j.join(`
`)}findCycleSlow(){for(const[j,O]of this.a){const R=new Set([j]),k=this.c(O,R);if(k)return k}}c(j,O){for(const[R,k]of j.outgoing){if(O.has(R))return[...O,R].join(" -> ");O.add(R);const g=this.c(k,O);if(g)return g;O.delete(R)}}}e.$Sq=L}),define(le[4],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hi=e.$gi=e.$fi=e._util=void 0;var I;(function(O){O.serviceIds=new Map,O.DI_TARGET="$di$target",O.DI_DEPENDENCIES="$di$dependencies";function R(k){return k[O.DI_DEPENDENCIES]||[]}O.getServiceDependencies=R})(I||(e._util=I={})),e.$fi=A("instantiationService");function L(O,R,k){R[I.DI_TARGET]===R?R[I.DI_DEPENDENCIES].push({id:O,index:k}):(R[I.DI_DEPENDENCIES]=[{id:O,index:k}],R[I.DI_TARGET]=R)}function A(O){if(I.serviceIds.has(O))return I.serviceIds.get(O);const R=function(k,g,C){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(R,k,C)};return R.toString=()=>O,I.serviceIds.set(O,R),R}e.$gi=A;function j(O){return O}e.$hi=j}),define(le[190],he([0,1,4]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ubc=void 0,e.$ubc=(0,I.$gi)("checksumService")}),define(le[21],he([0,1,12,10,4]),function(se,e,I,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.ConfigurationTarget=e.$Oi=e.$Ni=e.$Mi=void 0,e.$Mi=(0,A.$gi)("configurationService");function j(l){return l&&typeof l=="object"&&(!l.overrideIdentifier||typeof l.overrideIdentifier=="string")&&(!l.resource||l.resource instanceof L.URI)}e.$Ni=j;function O(l){return l&&typeof l=="object"&&(!l.overrideIdentifiers||Array.isArray(l.overrideIdentifiers))&&!l.overrideIdentifier&&(!l.resource||l.resource instanceof L.URI)}e.$Oi=O;var R;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.USER=2]="USER",l[l.USER_LOCAL=3]="USER_LOCAL",l[l.USER_REMOTE=4]="USER_REMOTE",l[l.WORKSPACE=5]="WORKSPACE",l[l.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",l[l.DEFAULT=7]="DEFAULT",l[l.MEMORY=8]="MEMORY"})(R||(e.ConfigurationTarget=R={}));function k(l){switch(l){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$Pi=k;function g(l){return l.applicationValue!==void 0||l.userValue!==void 0||l.userLocalValue!==void 0||l.userRemoteValue!==void 0||l.workspaceValue!==void 0||l.workspaceFolderValue!==void 0}e.$Qi=g;function C(l,d){const $=Object.create(null);for(const c in l)S($,c,l[c],d);return $}e.$Ri=C;function S(l,d,$,c){const v=d.split("."),i=v.pop();let o=l;for(let n=0;n<v.length;n++){const s=v[n];let t=o[s];switch(typeof t){case"undefined":t=o[s]=Object.create(null);break;case"object":break;default:c(`Ignoring ${d} as ${v.slice(0,n+1).join(".")} is ${JSON.stringify(t)}`);return}o=t}if(typeof o=="object"&&o!==null)try{o[i]=$}catch{c(`Ignoring ${d} as ${v.join(".")} is ${JSON.stringify(o)}`)}else c(`Ignoring ${d} as ${v.join(".")} is ${JSON.stringify(o)}`)}e.$Si=S;function w(l,d){const $=d.split(".");h(l,$)}e.$Ti=w;function h(l,d){const $=d.shift();if(d.length===0){delete l[$];return}if(Object.keys(l).indexOf($)!==-1){const c=l[$];typeof c=="object"&&!Array.isArray(c)&&(h(c,d),Object.keys(c).length===0&&delete l[$])}}function f(l,d,$){function c(o,n){let s=o;for(const t of n){if(typeof s!="object"||s===null)return;s=s[t]}return s}const v=d.split("."),i=c(l,v);return typeof i>"u"?$:i}e.$Ui=f;function m(l,d,$){Object.keys(d).forEach(c=>{c!=="__proto__"&&(c in l?I.$Vf(l[c])&&I.$Vf(d[c])?m(l[c],d[c],$):$&&(l[c]=d[c]):l[c]=d[c])})}e.$Vi=m;function y(l){return l.replace(/[\[\]]/g,"")}e.$Wi=y}),define(le[93],he([0,1,5,27,181,4,152,7]),function(se,e,I,L,A,j,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.ContextKeyExprType=e.$cj=void 0;const k=new Map;k.set("false",!1),k.set("true",!0),k.set("isMac",I.$j),k.set("isLinux",I.$k),k.set("isWindows",I.$i),k.set("isWeb",I.$o),k.set("isMacNative",I.$j&&!I.$o),k.set("isEdge",I.$H),k.set("isFirefox",I.$F),k.set("isChrome",I.$E),k.set("isSafari",I.$G);function g(U,D){if(k.get(U)!==void 0)throw(0,R.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");k.set(U,D)}e.$cj=g;const C=Object.prototype.hasOwnProperty;var S;(function(U){U[U.False=0]="False",U[U.True=1]="True",U[U.Defined=2]="Defined",U[U.Not=3]="Not",U[U.Equals=4]="Equals",U[U.NotEquals=5]="NotEquals",U[U.And=6]="And",U[U.Regex=7]="Regex",U[U.NotRegex=8]="NotRegex",U[U.Or=9]="Or",U[U.In=10]="In",U[U.NotIn=11]="NotIn",U[U.Greater=12]="Greater",U[U.GreaterEquals=13]="GreaterEquals",U[U.Smaller=14]="Smaller",U[U.SmallerEquals=15]="SmallerEquals"})(S||(e.ContextKeyExprType=S={}));const w={regexParsingWithErrorRecovery:!0},h=(0,O.localize)(0,null),f=(0,O.localize)(1,null),m=(0,O.localize)(2,null),y=(0,O.localize)(3,null),l=(0,O.localize)(4,null),d=(0,O.localize)(5,null),$=(0,O.localize)(6,null),c=(0,O.localize)(7,null);class v{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(D=w){this.k=D,this.d=new A.$bj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(D){if(D===""){this.h.push({message:h,offset:0,lexeme:"",additionalInfo:f});return}this.f=this.d.reset(D).scan(),this.g=0,this.h=[];try{const T=this.l();if(!this.E()){const B=this.D(),q=B.type===17?d:void 0;throw this.h.push({message:l,offset:B.offset,lexeme:A.$bj.getLexeme(B),additionalInfo:q}),v.c}return T}catch(T){if(T!==v.c)throw T;return}}l(){return this.m()}m(){const D=[this.o()];for(;this.y(16);){const T=this.o();D.push(T)}return D.length===1?D[0]:i.or(...D)}o(){const D=[this.s()];for(;this.y(15);){const T=this.s();D.push(T)}return D.length===1?D[0]:i.and(...D)}s(){if(this.y(2)){const D=this.D();switch(D.type){case 11:return this.z(),t.INSTANCE;case 12:return this.z(),r.INSTANCE;case 0:{this.z();const T=this.l();return this.A(1,y),T?.negate()}case 17:return this.z(),P.create(D.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",D)}}return this.t()}t(){const D=this.D();switch(D.type){case 11:return this.z(),i.true();case 12:return this.z(),i.false();case 0:{this.z();const T=this.l();return this.A(1,y),T}case 17:{const T=D.lexeme;if(this.z(),this.y(9)){const q=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),q.type!==10)throw this.B("REGEX",q);const Y=q.lexeme,_=Y.lastIndexOf("/"),ie=_===Y.length-1?void 0:this.w(Y.substring(_+1));let J;try{J=new RegExp(Y.substring(1,_),ie)}catch{throw this.B("REGEX",q)}return X.create(T,J)}switch(q.type){case 10:case 19:{const Y=[q.lexeme];this.z();let _=this.D(),ie=0;for(let de=0;de<q.lexeme.length;de++)q.lexeme.charCodeAt(de)===40?ie++:q.lexeme.charCodeAt(de)===41&&ie--;for(;!this.E()&&_.type!==15&&_.type!==16;){switch(_.type){case 0:ie++;break;case 1:ie--;break;case 10:case 18:for(let de=0;de<_.lexeme.length;de++)_.lexeme.charCodeAt(de)===40?ie++:q.lexeme.charCodeAt(de)===41&&ie--}if(ie<0)break;Y.push(A.$bj.getLexeme(_)),this.z(),_=this.D()}const J=Y.join(""),ne=J.lastIndexOf("/"),ce=ne===J.length-1?void 0:this.w(J.substring(ne+1));let fe;try{fe=new RegExp(J.substring(1,ne),ce)}catch{throw this.B("REGEX",q)}return i.regex(T,fe)}case 18:{const Y=q.lexeme;this.z();let _=null;if(!(0,L.$Te)(Y)){const ie=Y.indexOf("/"),J=Y.lastIndexOf("/");if(ie!==J&&ie>=0){const ne=Y.slice(ie+1,J),ce=Y[J+1]==="i"?"i":"";try{_=new RegExp(ne,ce)}catch{throw this.B("REGEX",q)}}}if(_===null)throw this.B("REGEX",q);return X.create(T,_)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,m);const q=this.u();return i.notIn(T,q)}switch(this.D().type){case 3:{this.z();const q=this.u();if(this.x().type===18)return i.equals(T,q);switch(q){case"true":return i.has(T);case"false":return i.not(T);default:return i.equals(T,q)}}case 4:{this.z();const q=this.u();if(this.x().type===18)return i.notEquals(T,q);switch(q){case"true":return i.not(T);case"false":return i.has(T);default:return i.notEquals(T,q)}}case 5:return this.z(),z.create(T,this.u());case 6:return this.z(),Z.create(T,this.u());case 7:return this.z(),F.create(T,this.u());case 8:return this.z(),M.create(T,this.u());case 13:return this.z(),i.in(T,this.u());default:return i.has(T)}}case 20:throw this.h.push({message:$,offset:D.offset,lexeme:"",additionalInfo:c}),v.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const D=this.D();switch(D.type){case 17:case 18:return this.z(),D.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(D){return D.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(D){return this.C(D)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(D,T){if(this.C(D))return this.z();throw this.B(T,this.D())}B(D,T,B){const q=(0,O.localize)(8,null,D,A.$bj.getLexeme(T)),Y=T.offset,_=A.$bj.getLexeme(T);return this.h.push({message:q,offset:Y,lexeme:_,additionalInfo:B}),v.c}C(D){return this.D().type===D}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$dj=v;class i{static false(){return t.INSTANCE}static true(){return r.INSTANCE}static has(D){return a.create(D)}static equals(D,T){return E.create(D,T)}static notEquals(D,T){return p.create(D,T)}static regex(D,T){return X.create(D,T)}static in(D,T){return b.create(D,T)}static notIn(D,T){return u.create(D,T)}static not(D){return P.create(D)}static and(...D){return Q.create(D,null,!0)}static or(...D){return H.create(D,null,!0)}static greater(D,T){return F.create(D,T)}static greaterEquals(D,T){return M.create(D,T)}static smaller(D,T){return z.create(D,T)}static smallerEquals(D,T){return Z.create(D,T)}static{this.c=new v({regexParsingWithErrorRecovery:!1})}static deserialize(D){return D==null?void 0:this.c.parse(D)}}e.$ej=i;function o(U){const D=new v({regexParsingWithErrorRecovery:!1});return U.map(T=>(D.parse(T),D.lexingErrors.length>0?D.lexingErrors.map(B=>({errorMessage:B.additionalInfo?(0,O.localize)(9,null,B.additionalInfo):(0,O.localize)(10,null),offset:B.offset,length:B.lexeme.length})):D.parsingErrors.length>0?D.parsingErrors.map(B=>({errorMessage:B.additionalInfo?`${B.message}. ${B.additionalInfo}`:B.message,offset:B.offset,length:B.lexeme.length})):[]))}e.$fj=o;function n(U,D){const T=U?U.substituteConstants():void 0,B=D?D.substituteConstants():void 0;return!T&&!B?!0:!T||!B?!1:T.equals(B)}e.$gj=n;function s(U,D){return U.cmp(D)}class t{static{this.INSTANCE=new t}constructor(){this.type=0}cmp(D){return this.type-D.type}equals(D){return D.type===this.type}substituteConstants(){return this}evaluate(D){return!1}serialize(){return"false"}keys(){return[]}map(D){return this}negate(){return r.INSTANCE}}e.$hj=t;class r{static{this.INSTANCE=new r}constructor(){this.type=1}cmp(D){return this.type-D.type}equals(D){return D.type===this.type}substituteConstants(){return this}evaluate(D){return!0}serialize(){return"true"}keys(){return[]}map(D){return this}negate(){return t.INSTANCE}}e.$ij=r;class a{static create(D,T=null){const B=k.get(D);return typeof B=="boolean"?B?r.INSTANCE:t.INSTANCE:new a(D,T)}constructor(D,T){this.key=D,this.c=T,this.type=2}cmp(D){return D.type!==this.type?this.type-D.type:te(this.key,D.key)}equals(D){return D.type===this.type?this.key===D.key:!1}substituteConstants(){const D=k.get(this.key);return typeof D=="boolean"?D?r.INSTANCE:t.INSTANCE:this}evaluate(D){return!!D.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(D){return D.mapDefined(this.key)}negate(){return this.c||(this.c=P.create(this.key,this)),this.c}}e.$jj=a;class E{static create(D,T,B=null){if(typeof T=="boolean")return T?a.create(D,B):P.create(D,B);const q=k.get(D);return typeof q=="boolean"?T===(q?"true":"false")?r.INSTANCE:t.INSTANCE:new E(D,T,B)}constructor(D,T,B){this.c=D,this.d=T,this.f=B,this.type=4}cmp(D){return D.type!==this.type?this.type-D.type:re(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){const D=k.get(this.c);if(typeof D=="boolean"){const T=D?"true":"false";return this.d===T?r.INSTANCE:t.INSTANCE}return this}evaluate(D){return D.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(D){return D.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=p.create(this.c,this.d,this)),this.f}}e.$kj=E;class b{static create(D,T){return new b(D,T)}constructor(D,T){this.d=D,this.f=T,this.type=10,this.c=null}cmp(D){return D.type!==this.type?this.type-D.type:re(this.d,this.f,D.d,D.f)}equals(D){return D.type===this.type?this.d===D.d&&this.f===D.f:!1}substituteConstants(){return this}evaluate(D){const T=D.getValue(this.f),B=D.getValue(this.d);return Array.isArray(T)?T.includes(B):typeof B=="string"&&typeof T=="object"&&T!==null?C.call(T,B):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(D){return D.mapIn(this.d,this.f)}negate(){return this.c||(this.c=u.create(this.d,this.f)),this.c}}e.$lj=b;class u{static create(D,T){return new u(D,T)}constructor(D,T){this.d=D,this.f=T,this.type=11,this.c=b.create(D,T)}cmp(D){return D.type!==this.type?this.type-D.type:this.c.cmp(D.c)}equals(D){return D.type===this.type?this.c.equals(D.c):!1}substituteConstants(){return this}evaluate(D){return!this.c.evaluate(D)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(D){return D.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$mj=u;class p{static create(D,T,B=null){if(typeof T=="boolean")return T?P.create(D,B):a.create(D,B);const q=k.get(D);return typeof q=="boolean"?T===(q?"true":"false")?t.INSTANCE:r.INSTANCE:new p(D,T,B)}constructor(D,T,B){this.c=D,this.d=T,this.f=B,this.type=5}cmp(D){return D.type!==this.type?this.type-D.type:re(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){const D=k.get(this.c);if(typeof D=="boolean"){const T=D?"true":"false";return this.d===T?t.INSTANCE:r.INSTANCE}return this}evaluate(D){return D.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(D){return D.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=E.create(this.c,this.d,this)),this.f}}e.$nj=p;class P{static create(D,T=null){const B=k.get(D);return typeof B=="boolean"?B?t.INSTANCE:r.INSTANCE:new P(D,T)}constructor(D,T){this.c=D,this.d=T,this.type=3}cmp(D){return D.type!==this.type?this.type-D.type:te(this.c,D.c)}equals(D){return D.type===this.type?this.c===D.c:!1}substituteConstants(){const D=k.get(this.c);return typeof D=="boolean"?D?t.INSTANCE:r.INSTANCE:this}evaluate(D){return!D.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(D){return D.mapNot(this.c)}negate(){return this.d||(this.d=a.create(this.c,this)),this.d}}e.$oj=P;function N(U,D){if(typeof U=="string"){const T=parseFloat(U);isNaN(T)||(U=T)}return typeof U=="string"||typeof U=="number"?D(U):t.INSTANCE}class F{static create(D,T,B=null){return N(T,q=>new F(D,q,B))}constructor(D,T,B){this.c=D,this.d=T,this.f=B,this.type=12}cmp(D){return D.type!==this.type?this.type-D.type:re(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){return this}evaluate(D){return typeof this.d=="string"?!1:parseFloat(D.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(D){return D.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=Z.create(this.c,this.d,this)),this.f}}e.$pj=F;class M{static create(D,T,B=null){return N(T,q=>new M(D,q,B))}constructor(D,T,B){this.c=D,this.d=T,this.f=B,this.type=13}cmp(D){return D.type!==this.type?this.type-D.type:re(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){return this}evaluate(D){return typeof this.d=="string"?!1:parseFloat(D.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(D){return D.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$qj=M;class z{static create(D,T,B=null){return N(T,q=>new z(D,q,B))}constructor(D,T,B){this.c=D,this.d=T,this.f=B,this.type=14}cmp(D){return D.type!==this.type?this.type-D.type:re(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){return this}evaluate(D){return typeof this.d=="string"?!1:parseFloat(D.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(D){return D.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=M.create(this.c,this.d,this)),this.f}}e.$rj=z;class Z{static create(D,T,B=null){return N(T,q=>new Z(D,q,B))}constructor(D,T,B){this.c=D,this.d=T,this.f=B,this.type=15}cmp(D){return D.type!==this.type?this.type-D.type:re(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){return this}evaluate(D){return typeof this.d=="string"?!1:parseFloat(D.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(D){return D.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.$sj=Z;class X{static create(D,T){return new X(D,T)}constructor(D,T){this.d=D,this.f=T,this.type=7,this.c=null}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.d<D.d)return-1;if(this.d>D.d)return 1;const T=this.f?this.f.source:"",B=D.f?D.f.source:"";return T<B?-1:T>B?1:0}equals(D){if(D.type===this.type){const T=this.f?this.f.source:"",B=D.f?D.f.source:"";return this.d===D.d&&T===B}return!1}substituteConstants(){return this}evaluate(D){const T=D.getValue(this.d);return this.f?this.f.test(T):!1}serialize(){const D=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${D}`}keys(){return[this.d]}map(D){return D.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=x.create(this)),this.c}}e.$tj=X;class x{static create(D){return new x(D)}constructor(D){this.c=D,this.type=8}cmp(D){return D.type!==this.type?this.type-D.type:this.c.cmp(D.c)}equals(D){return D.type===this.type?this.c.equals(D.c):!1}substituteConstants(){return this}evaluate(D){return!this.c.evaluate(D)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(D){return new x(this.c.map(D))}negate(){return this.c}}e.$uj=x;function W(U){let D=null;for(let T=0,B=U.length;T<B;T++){const q=U[T].substituteConstants();if(U[T]!==q&&D===null){D=[];for(let Y=0;Y<T;Y++)D[Y]=U[Y]}D!==null&&(D[T]=q)}return D===null?U:D}class Q{static create(D,T,B){return Q.d(D,T,B)}constructor(D,T){this.expr=D,this.c=T,this.type=6}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.expr.length<D.expr.length)return-1;if(this.expr.length>D.expr.length)return 1;for(let T=0,B=this.expr.length;T<B;T++){const q=s(this.expr[T],D.expr[T]);if(q!==0)return q}return 0}equals(D){if(D.type===this.type){if(this.expr.length!==D.expr.length)return!1;for(let T=0,B=this.expr.length;T<B;T++)if(!this.expr[T].equals(D.expr[T]))return!1;return!0}return!1}substituteConstants(){const D=W(this.expr);return D===this.expr?this:Q.create(D,this.c,!1)}evaluate(D){for(let T=0,B=this.expr.length;T<B;T++)if(!this.expr[T].evaluate(D))return!1;return!0}static d(D,T,B){const q=[];let Y=!1;for(const _ of D)if(_){if(_.type===1){Y=!0;continue}if(_.type===0)return t.INSTANCE;if(_.type===6){q.push(..._.expr);continue}q.push(_)}if(q.length===0&&Y)return r.INSTANCE;if(q.length!==0){if(q.length===1)return q[0];q.sort(s);for(let _=1;_<q.length;_++)q[_-1].equals(q[_])&&(q.splice(_,1),_--);if(q.length===1)return q[0];for(;q.length>1;){const _=q[q.length-1];if(_.type!==9)break;q.pop();const ie=q.pop(),J=q.length===0,ne=H.create(_.expr.map(ce=>Q.create([ce,ie],null,B)),null,J);ne&&(q.push(ne),q.sort(s))}if(q.length===1)return q[0];if(B){for(let _=0;_<q.length;_++)for(let ie=_+1;ie<q.length;ie++)if(q[_].negate().equals(q[ie]))return t.INSTANCE;if(q.length===1)return q[0]}return new Q(q,T)}}serialize(){return this.expr.map(D=>D.serialize()).join(" && ")}keys(){const D=[];for(const T of this.expr)D.push(...T.keys());return D}map(D){return new Q(this.expr.map(T=>T.map(D)),null)}negate(){if(!this.c){const D=[];for(const T of this.expr)D.push(T.negate());this.c=H.create(D,this,!0)}return this.c}}e.$vj=Q;class H{static create(D,T,B){return H.d(D,T,B)}constructor(D,T){this.expr=D,this.c=T,this.type=9}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.expr.length<D.expr.length)return-1;if(this.expr.length>D.expr.length)return 1;for(let T=0,B=this.expr.length;T<B;T++){const q=s(this.expr[T],D.expr[T]);if(q!==0)return q}return 0}equals(D){if(D.type===this.type){if(this.expr.length!==D.expr.length)return!1;for(let T=0,B=this.expr.length;T<B;T++)if(!this.expr[T].equals(D.expr[T]))return!1;return!0}return!1}substituteConstants(){const D=W(this.expr);return D===this.expr?this:H.create(D,this.c,!1)}evaluate(D){for(let T=0,B=this.expr.length;T<B;T++)if(this.expr[T].evaluate(D))return!0;return!1}static d(D,T,B){let q=[],Y=!1;if(D){for(let _=0,ie=D.length;_<ie;_++){const J=D[_];if(J){if(J.type===0){Y=!0;continue}if(J.type===1)return r.INSTANCE;if(J.type===9){q=q.concat(J.expr);continue}q.push(J)}}if(q.length===0&&Y)return t.INSTANCE;q.sort(s)}if(q.length!==0){if(q.length===1)return q[0];for(let _=1;_<q.length;_++)q[_-1].equals(q[_])&&(q.splice(_,1),_--);if(q.length===1)return q[0];if(B){for(let _=0;_<q.length;_++)for(let ie=_+1;ie<q.length;ie++)if(q[_].negate().equals(q[ie]))return r.INSTANCE;if(q.length===1)return q[0]}return new H(q,T)}}serialize(){return this.expr.map(D=>D.serialize()).join(" || ")}keys(){const D=[];for(const T of this.expr)D.push(...T.keys());return D}map(D){return new H(this.expr.map(T=>T.map(D)),null)}negate(){if(!this.c){const D=[];for(const T of this.expr)D.push(T.negate());for(;D.length>1;){const T=D.shift(),B=D.shift(),q=[];for(const Y of G(T))for(const _ of G(B))q.push(Q.create([Y,_],null,!1));D.unshift(H.create(q,null,!1))}this.c=H.create(D,this,!0)}return this.c}}e.$wj=H;class V extends a{static{this.d=[]}static all(){return V.d.values()}constructor(D,T,B){super(D,null),this.f=T,typeof B=="object"?V.d.push({...B,key:D}):B!==!0&&V.d.push({key:D,description:B,type:T!=null?typeof T:void 0})}bindTo(D){return D.createKey(this.key,this.f)}getValue(D){return D.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(D){return E.create(this.key,D)}notEqualsTo(D){return p.create(this.key,D)}}e.$xj=V,e.$yj=(0,j.$gi)("contextKeyService");function te(U,D){return U<D?-1:U>D?1:0}function re(U,D,T,B){return U<T?-1:U>T?1:D<B?-1:D>B?1:0}function ee(U,D){if(U.type===0||D.type===1)return!0;if(U.type===9)return D.type===9?ae(U.expr,D.expr):!1;if(D.type===9){for(const T of D.expr)if(ee(U,T))return!0;return!1}if(U.type===6){if(D.type===6)return ae(D.expr,U.expr);for(const T of U.expr)if(ee(T,D))return!0;return!1}return U.equals(D)}e.$zj=ee;function ae(U,D){let T=0,B=0;for(;T<U.length&&B<D.length;){const q=U[T].cmp(D[B]);if(q<0)return!1;q===0&&T++,B++}return T===U.length}function G(U){return U.type===9?U.expr:[U]}}),define(le[94],he([0,1,4]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1m=e.$Zm=e.$Ym=e.ID=void 0,e.ID="diagnosticsService",e.$Ym=(0,I.$gi)(e.ID);function L(j){return!!j.hostName&&!!j.errorMessage}e.$Zm=L;class A{async getPerformanceInfo(O,R){return{}}async getSystemInfo(O,R){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(O,R){return""}async getWorkspaceFileExtensions(O){return{extensions:[]}}async reportWorkspaceStats(O){}}e.$1m=A}),define(le[95],he([0,1,4]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$to=void 0,e.$to=(0,I.$gi)("downloadService")}),define(le[16],he([0,1,4]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oi=e.$ni=void 0,e.$ni=(0,I.$gi)("environmentService"),e.$oi=(0,I.$hi)(e.$ni)}),define(le[29],he([0,1,155,4]),function(se,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=e.$So=e.$Ro=e.$Qo=e.ExtensionGalleryErrorCode=e.$Po=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Oo=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$No=e.$Mo=e.$Lo=e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=void 0,e.$Co="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Do=new RegExp(e.$Co),e.$Eo="__web_extension",e.$Fo="skipWalkthrough",e.$Go="extensionsSync",e.$Ho="dependecyOrPackExtensionInstall";function A($){switch($){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$Io=A;function j($){switch($){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$Jo=j;function O($,c){switch($){case 3:return c==="x64"?"win32-x64":c==="arm64"?"win32-arm64":"unknown";case 2:return c==="x64"?"linux-x64":c==="arm64"?"linux-arm64":c==="arm"?"linux-armhf":"unknown";case"alpine":return c==="x64"?"alpine-x64":c==="arm64"?"alpine-arm64":"unknown";case 1:return c==="x64"?"darwin-x64":c==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$Ko=O;function R($,c){return c==="web"&&!$.includes("web")}e.$Lo=R;function k($,c,v){return R(c,v)?!1:$==="undefined"||$==="universal"?!0:$==="unknown"?!1:$===v}e.$Mo=k;function g($){return $&&typeof $=="object"&&typeof $.id=="string"&&(!$.uuid||typeof $.uuid=="string")}e.$No=g;var C;(function($){$[$.NoneOrRelevance=0]="NoneOrRelevance",$[$.LastUpdatedDate=1]="LastUpdatedDate",$[$.Title=2]="Title",$[$.PublisherName=3]="PublisherName",$[$.InstallCount=4]="InstallCount",$[$.PublishedDate=10]="PublishedDate",$[$.AverageRating=6]="AverageRating",$[$.WeightedRating=12]="WeightedRating"})(C||(e.SortBy=C={}));var S;(function($){$[$.Default=0]="Default",$[$.Ascending=1]="Ascending",$[$.Descending=2]="Descending"})(S||(e.SortOrder=S={}));var w;(function($){$.Install="install",$.Uninstall="uninstall"})(w||(e.StatisticType=w={}));var h;(function($){$[$.None=1]="None",$[$.Install=2]="Install",$[$.Update=3]="Update",$[$.Migrate=4]="Migrate"})(h||(e.InstallOperation=h={})),e.$Oo=(0,L.$gi)("extensionGalleryService");var f;(function($){$.Unsupported="Unsupported",$.Deprecated="Deprecated",$.Malicious="Malicious",$.Incompatible="Incompatible",$.IncompatibleTargetPlatform="IncompatibleTargetPlatform",$.ReleaseVersionNotFound="ReleaseVersionNotFound",$.Invalid="Invalid",$.Download="Download",$.DownloadSignature="DownloadSignature",$.UpdateMetadata="UpdateMetadata",$.Extract="Extract",$.Scanning="Scanning",$.Delete="Delete",$.Rename="Rename",$.CorruptZip="CorruptZip",$.IncompleteZip="IncompleteZip",$.Signature="Signature",$.NotAllowed="NotAllowed",$.Gallery="Gallery",$.Unknown="Unknown",$.Internal="Internal"})(f||(e.ExtensionManagementErrorCode=f={}));var m;(function($){$.UnknownError="UnknownError",$.PackageIsInvalidZip="PackageIsInvalidZip",$.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(m||(e.ExtensionSignaturetErrorCode=m={}));class y extends Error{constructor(c,v){super(c),this.code=v,this.name=v}}e.$Po=y;var l;(function($){$.Timeout="Timeout",$.Cancelled="Cancelled",$.Failed="Failed"})(l||(e.ExtensionGalleryErrorCode=l={}));class d extends Error{constructor(c,v){super(c),this.code=v,this.name=v}}e.$Qo=d,e.$Ro=(0,L.$gi)("extensionManagementService"),e.$So="extensionsIdentifiers/disabled",e.$To="extensionsIdentifiers/enabled",e.$Uo=(0,L.$gi)("IGlobalExtensionEnablementService"),e.$Vo=(0,L.$gi)("IExtensionTipsService"),e.$Wo=(0,I.localize2)(0,"Extensions"),e.$Xo=(0,I.localize2)(1,"Preferences")}),define(le[191],he([0,1,3,2,30,10,91,29]),function(se,e,I,L,A,j,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zp=e.$Yp=e.$Xp=void 0;function k(y,l){return y?j.URI.revive(l?l.transformIncoming(y):y):void 0}function g(y,l){return l?l.transformOutgoingURI(y):y}function C(y,l){l=l||O.$in;const d=y.manifest;return{...(0,O.$ln)({...y,manifest:void 0},l),manifest:d}}function S(y,l){return y?.profileLocation?(0,O.$ln)(y,l??O.$in):y}function w(y,l){return l?(0,A.$Nn)(y,d=>d instanceof j.URI?l.transformOutgoingURI(d):void 0):y}class h{constructor(l,d){this.a=l,this.b=d,this.onInstallExtension=I.Event.buffer(l.onInstallExtension,!0),this.onDidInstallExtensions=I.Event.buffer(l.onDidInstallExtensions,!0),this.onUninstallExtension=I.Event.buffer(l.onUninstallExtension,!0),this.onDidUninstallExtension=I.Event.buffer(l.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=I.Event.buffer(l.onDidUpdateExtensionMetadata,!0)}listen(l,d){const $=this.b(l);switch(d){case"onInstallExtension":return I.Event.map(this.onInstallExtension,c=>({...c,profileLocation:c.profileLocation?g(c.profileLocation,$):c.profileLocation}));case"onDidInstallExtensions":return I.Event.map(this.onDidInstallExtensions,c=>c.map(v=>({...v,local:v.local?w(v.local,$):v.local,profileLocation:v.profileLocation?g(v.profileLocation,$):v.profileLocation})));case"onUninstallExtension":return I.Event.map(this.onUninstallExtension,c=>({...c,profileLocation:c.profileLocation?g(c.profileLocation,$):c.profileLocation}));case"onDidUninstallExtension":return I.Event.map(this.onDidUninstallExtension,c=>({...c,profileLocation:c.profileLocation?g(c.profileLocation,$):c.profileLocation}));case"onDidUpdateExtensionMetadata":return I.Event.map(this.onDidUpdateExtensionMetadata,c=>w(c,$))}throw new Error("Invalid listen")}async call(l,d,$){const c=this.b(l);switch(d){case"zip":{const v=C($[0],c),i=await this.a.zip(v);return g(i,c)}case"unzip":return this.a.unzip(k($[0],c));case"install":return this.a.install(k($[0],c),S($[1],c));case"installFromLocation":return this.a.installFromLocation(k($[0],c),k($[1],c));case"installExtensionsFromProfile":return this.a.installExtensionsFromProfile($[0],k($[1],c),k($[2],c));case"getManifest":return this.a.getManifest(k($[0],c));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall($[0]);case"installFromGallery":return this.a.installFromGallery($[0],S($[1],c));case"installGalleryExtensions":{const v=$[0];return this.a.installGalleryExtensions(v.map(({extension:i,options:o})=>({extension:i,options:S(o,c)??{}})))}case"uninstall":return this.a.uninstall(C($[0],c),S($[1],c));case"reinstallFromGallery":return this.a.reinstallFromGallery(C($[0],c));case"getInstalled":return(await this.a.getInstalled($[0],k($[1],c))).map(i=>w(i,c));case"toggleAppliationScope":{const v=await this.a.toggleAppliationScope(C($[0],c),k($[1],c));return w(v,c)}case"copyExtensions":return this.a.copyExtensions(k($[0],c),k($[1],c));case"updateMetadata":{const v=await this.a.updateMetadata(C($[0],c),$[1],k($[2],c));return w(v,c)}case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download($[0],$[1],$[2]);case"cleanUp":return this.a.cleanUp()}throw new Error("Invalid call")}}e.$Xp=h;class f extends L.$Tc{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}get onDidUpdateExtensionMetadata(){return this.j.event}constructor(l){super(),this.m=l,this.c=this.B(new I.$6d),this.f=this.B(new I.$6d),this.g=this.B(new I.$6d),this.h=this.B(new I.$6d),this.j=this.B(new I.$6d),this.B(this.m.listen("onInstallExtension")(d=>this.n(this.c,{...d,source:this.r(d.source)?j.URI.revive(d.source):d.source,profileLocation:j.URI.revive(d.profileLocation)}))),this.B(this.m.listen("onDidInstallExtensions")(d=>this.n(this.f,d.map($=>({...$,local:$.local?C($.local,null):$.local,source:this.r($.source)?j.URI.revive($.source):$.source,profileLocation:j.URI.revive($.profileLocation)}))))),this.B(this.m.listen("onUninstallExtension")(d=>this.n(this.g,{...d,profileLocation:j.URI.revive(d.profileLocation)}))),this.B(this.m.listen("onDidUninstallExtension")(d=>this.n(this.h,{...d,profileLocation:j.URI.revive(d.profileLocation)}))),this.B(this.m.listen("onDidUpdateExtensionMetadata")(d=>this.j.fire(C(d,null))))}n(l,d){l.fire(d)}r(l){return l?typeof l.path=="string"&&typeof l.scheme=="string":!1}getTargetPlatform(){return this.s||(this.s=this.m.call("getTargetPlatform")),this.s}async canInstall(l){const d=await this.getTargetPlatform();return l.allTargetPlatforms.some($=>(0,R.$Mo)($,l.allTargetPlatforms,d))}zip(l){return Promise.resolve(this.m.call("zip",[l]).then(d=>j.URI.revive(d)))}unzip(l){return Promise.resolve(this.m.call("unzip",[l]))}install(l,d){return Promise.resolve(this.m.call("install",[l,d])).then($=>C($,null))}installFromLocation(l,d){return Promise.resolve(this.m.call("installFromLocation",[l,d])).then($=>C($,null))}async installExtensionsFromProfile(l,d,$){return(await this.m.call("installExtensionsFromProfile",[l,d,$])).map(v=>C(v,null))}getManifest(l){return Promise.resolve(this.m.call("getManifest",[l]))}installFromGallery(l,d){return Promise.resolve(this.m.call("installFromGallery",[l,d])).then($=>C($,null))}async installGalleryExtensions(l){return(await this.m.call("installGalleryExtensions",[l])).map($=>({...$,local:$.local?C($.local,null):$.local,source:this.r($.source)?j.URI.revive($.source):$.source,profileLocation:j.URI.revive($.profileLocation)}))}uninstall(l,d){return Promise.resolve(this.m.call("uninstall",[l,d]))}reinstallFromGallery(l){return Promise.resolve(this.m.call("reinstallFromGallery",[l])).then(d=>C(d,null))}getInstalled(l=null,d){return Promise.resolve(this.m.call("getInstalled",[l,d])).then($=>$.map(c=>C(c,null)))}updateMetadata(l,d,$){return Promise.resolve(this.m.call("updateMetadata",[l,d,$])).then(c=>C(c,null))}toggleAppliationScope(l,d){return this.m.call("toggleAppliationScope",[l,d]).then($=>C($,null))}copyExtensions(l,d){return this.m.call("copyExtensions",[l,d])}getExtensionsControlManifest(){return Promise.resolve(this.m.call("getExtensionsControlManifest"))}async download(l,d,$){const c=await this.m.call("download",[l,d,$]);return j.URI.revive(c)}async cleanUp(){return this.m.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.$Yp=f;class m{constructor(l){this.a=l}listen(l,d){throw new Error("Invalid listen")}call(l,d,$){switch(d){case"getConfigBasedTips":return this.a.getConfigBasedTips(j.URI.revive($[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.$Zp=m}),define(le[96],he([0,1,4]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$61b=e.RecommendationsNotificationResult=e.$51b=e.RecommendationSource=void 0;var L;(function(O){O[O.FILE=1]="FILE",O[O.WORKSPACE=2]="WORKSPACE",O[O.EXE=3]="EXE"})(L||(e.RecommendationSource=L={}));function A(O){switch(O){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.$51b=A;var j;(function(O){O.Ignored="ignored",O.Cancelled="cancelled",O.TooMany="toomany",O.IncompatibleWindow="incompatibleWindow",O.Accepted="reacted"})(j||(e.RecommendationsNotificationResult=j={})),e.$61b=(0,I.$gi)("IExtensionRecommendationNotificationService")}),define(le[11],he([0,1,48,15,27,12,10,162,4,5,23,53]),function(se,e,I,L,A,j,O,R,k,g,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dl=e.$cl=e.$bl=e.$al=e.$_k=e.FileKind=e.$$k=e.$0k=e.$9k=e.$8k=e.$7k=e.$6k=e.$5k=e.FileOperationResult=e.$4k=e.$3k=e.$2k=e.$1k=e.$Zk=e.FileChangeType=e.$Yk=e.FileOperation=e.$Xk=e.$Wk=e.$Vk=e.$Uk=e.$Tk=e.$Sk=e.FileSystemProviderErrorCode=e.$Rk=e.$Qk=e.$Pk=e.$Ok=e.$Nk=e.$Mk=e.$Lk=e.$Kk=e.$Jk=e.FileSystemProviderCapabilities=e.$Ik=e.FilePermission=e.FileType=e.$Hk=e.$Gk=void 0,e.$Gk=(0,k.$gi)("fileService");function w(ee){return ee.create===!0}e.$Hk=w;var h;(function(ee){ee[ee.Unknown=0]="Unknown",ee[ee.File=1]="File",ee[ee.Directory=2]="Directory",ee[ee.SymbolicLink=64]="SymbolicLink"})(h||(e.FileType=h={}));var f;(function(ee){ee[ee.Readonly=1]="Readonly",ee[ee.Locked=2]="Locked"})(f||(e.FilePermission=f={}));function m(ee){const ae=ee;return!!ae&&typeof ae.onDidChange=="function"}e.$Ik=m;var y;(function(ee){ee[ee.None=0]="None",ee[ee.FileReadWrite=2]="FileReadWrite",ee[ee.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",ee[ee.FileReadStream=16]="FileReadStream",ee[ee.FileFolderCopy=8]="FileFolderCopy",ee[ee.PathCaseSensitive=1024]="PathCaseSensitive",ee[ee.Readonly=2048]="Readonly",ee[ee.Trash=4096]="Trash",ee[ee.FileWriteUnlock=8192]="FileWriteUnlock",ee[ee.FileAtomicRead=16384]="FileAtomicRead",ee[ee.FileAtomicWrite=32768]="FileAtomicWrite",ee[ee.FileAtomicDelete=65536]="FileAtomicDelete",ee[ee.FileClone=131072]="FileClone"})(y||(e.FileSystemProviderCapabilities=y={}));function l(ee){return!!(ee.capabilities&2)}e.$Jk=l;function d(ee){return!!(ee.capabilities&8)}e.$Kk=d;function $(ee){return!!(ee.capabilities&131072)}e.$Lk=$;function c(ee){return!!(ee.capabilities&4)}e.$Mk=c;function v(ee){return!!(ee.capabilities&16)}e.$Nk=v;function i(ee){return l(ee)?!!(ee.capabilities&16384):!1}e.$Ok=i;function o(ee){return l(ee)?!!(ee.capabilities&32768):!1}e.$Pk=o;function n(ee){return!!(ee.capabilities&65536)}e.$Qk=n;function s(ee){return!!(ee.capabilities&2048)}e.$Rk=s;var t;(function(ee){ee.FileExists="EntryExists",ee.FileNotFound="EntryNotFound",ee.FileNotADirectory="EntryNotADirectory",ee.FileIsADirectory="EntryIsADirectory",ee.FileExceedsStorageQuota="EntryExceedsStorageQuota",ee.FileTooLarge="EntryTooLarge",ee.FileWriteLocked="EntryWriteLocked",ee.NoPermissions="NoPermissions",ee.Unavailable="Unavailable",ee.Unknown="Unknown"})(t||(e.FileSystemProviderErrorCode=t={}));class r extends Error{static create(ae,G){const U=new r(ae.toString(),G);return b(U,G),U}constructor(ae,G){super(ae),this.code=G}}e.$Sk=r;function a(ee,ae){return r.create(ee,ae)}e.$Tk=a;function E(ee){return ee||a((0,R.localize)(0,null),t.Unknown)}e.$Uk=E;function b(ee,ae){return ee.name=ae?`${ae} (FileSystemError)`:"FileSystemError",ee}e.$Vk=b;function u(ee){if(!ee)return t.Unknown;if(ee instanceof r)return ee.code;const ae=/^(.+) \(FileSystemError\)$/.exec(ee.name);if(!ae)return t.Unknown;switch(ae[1]){case t.FileExists:return t.FileExists;case t.FileIsADirectory:return t.FileIsADirectory;case t.FileNotADirectory:return t.FileNotADirectory;case t.FileNotFound:return t.FileNotFound;case t.FileTooLarge:return t.FileTooLarge;case t.FileWriteLocked:return t.FileWriteLocked;case t.NoPermissions:return t.NoPermissions;case t.Unavailable:return t.Unavailable}return t.Unknown}e.$Wk=u;function p(ee){if(ee instanceof Z)return ee.fileOperationResult;switch(u(ee)){case t.FileNotFound:return 1;case t.FileIsADirectory:return 0;case t.FileNotADirectory:return 9;case t.FileWriteLocked:return 5;case t.NoPermissions:return 6;case t.FileExists:return 4;case t.FileTooLarge:return 7;default:return 10}}e.$Xk=p;var P;(function(ee){ee[ee.CREATE=0]="CREATE",ee[ee.DELETE=1]="DELETE",ee[ee.MOVE=2]="MOVE",ee[ee.COPY=3]="COPY",ee[ee.WRITE=4]="WRITE"})(P||(e.FileOperation=P={}));class N{constructor(ae,G,U){this.resource=ae,this.operation=G,this.target=U}isOperation(ae){return this.operation===ae}}e.$Yk=N;var F;(function(ee){ee[ee.UPDATED=0]="UPDATED",ee[ee.ADDED=1]="ADDED",ee[ee.DELETED=2]="DELETED"})(F||(e.FileChangeType=F={}));class M{static{this.a=null}constructor(ae,G){this.c=G,this.b=void 0,this.d=new S.$V(()=>{const U=I.$mi.forUris(()=>this.c);return U.fill(this.rawAdded.map(D=>[D,!0])),U}),this.f=new S.$V(()=>{const U=I.$mi.forUris(()=>this.c);return U.fill(this.rawUpdated.map(D=>[D,!0])),U}),this.g=new S.$V(()=>{const U=I.$mi.forUris(()=>this.c);return U.fill(this.rawDeleted.map(D=>[D,!0])),U}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const U of ae){switch(U.type){case 1:this.rawAdded.push(U.resource);break;case 0:this.rawUpdated.push(U.resource);break;case 2:this.rawDeleted.push(U.resource);break}this.b!==M.a&&(typeof U.cId=="number"?this.b===void 0?this.b=U.cId:this.b!==U.cId&&(this.b=M.a):this.b!==void 0&&(this.b=M.a))}}contains(ae,...G){return this.h(ae,{includeChildren:!1},...G)}affects(ae,...G){return this.h(ae,{includeChildren:!0},...G)}h(ae,G,...U){if(!ae)return!1;const D=U.length>0;return!!((!D||U.includes(1))&&(this.d.value.get(ae)||G.includeChildren&&this.d.value.findSuperstr(ae))||(!D||U.includes(0))&&(this.f.value.get(ae)||G.includeChildren&&this.f.value.findSuperstr(ae))||(!D||U.includes(2))&&(this.g.value.findSubstr(ae)||G.includeChildren&&this.g.value.findSuperstr(ae)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(ae){return this.b===ae}hasCorrelation(){return typeof this.b=="number"}}e.$Zk=M;function z(ee,ae,G){return!ee||!ae||ee===ae||ae.length>ee.length?!1:(ae.charAt(ae.length-1)!==L.sep&&(ae+=L.sep),G?(0,A.$lf)(ee,ae):ee.indexOf(ae)===0)}e.$1k=z;class Z extends Error{constructor(ae,G,U){super(ae),this.fileOperationResult=G,this.options=U}}e.$2k=Z;class X extends Z{constructor(ae,G,U,D){super(ae,G,D),this.fileOperationResult=G,this.size=U}}e.$3k=X;class x extends Z{constructor(ae,G,U){super(ae,2,U),this.stat=G}}e.$4k=x;var W;(function(ee){ee[ee.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",ee[ee.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",ee[ee.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",ee[ee.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",ee[ee.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",ee[ee.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",ee[ee.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",ee[ee.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",ee[ee.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",ee[ee.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",ee[ee.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(W||(e.FileOperationResult=W={})),e.$5k={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$6k={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$7k="files.associations",e.$8k="files.exclude",e.$9k="files.readonlyInclude",e.$0k="files.readonlyExclude",e.$$k="files.readonlyFromPermissions";var Q;(function(ee){ee[ee.FILE=0]="FILE",ee[ee.FOLDER=1]="FOLDER",ee[ee.ROOT_FOLDER=2]="ROOT_FOLDER"})(Q||(e.FileKind=Q={})),e.$_k="";function H(ee){if(!(typeof ee.size!="number"||typeof ee.mtime!="number"))return ee.mtime.toString(29)+ee.size.toString(31)}e.$al=H;async function V(ee,ae){if(!ae.hasProvider(O.URI.from({scheme:ee.scheme})))return new Promise(G=>{const U=ae.onDidChangeFileSystemProviderRegistrations(D=>{D.scheme===ee.scheme&&D.added&&(U.dispose(),G())})})}e.$bl=V;class te{static{this.KB=1024}static{this.MB=te.KB*te.KB}static{this.GB=te.MB*te.KB}static{this.TB=te.GB*te.KB}static formatSize(ae){return(0,j.$Xf)(ae)||(ae=0),ae<te.KB?(0,R.localize)(1,null,ae.toFixed(0)):ae<te.MB?(0,R.localize)(2,null,(ae/te.KB).toFixed(2)):ae<te.GB?(0,R.localize)(3,null,(ae/te.MB).toFixed(2)):ae<te.TB?(0,R.localize)(4,null,(ae/te.GB).toFixed(2)):(0,R.localize)(5,null,(ae/te.TB).toFixed(2))}}e.$cl=te;function re(ee){const ae=typeof ee=="string"||ee?.scheme===C.Schemas.vscodeRemote;return typeof ee!="string"&&ee?.scheme===C.Schemas.file?1024*te.MB:ae?10*te.MB:g.$o?50*te.MB:1024*te.MB}e.$dl=re});var K=this&&this.__param||function(se,e){return function(I,L){e(I,L,se)}};define(le[192],he([0,1,73,47,11]),function(se,e,I,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vbc=void 0;let j=class{constructor(R){this.a=R}async checksum(R){const k=(await this.a.readFileStream(R)).value;return new Promise((g,C)=>{const S=(0,I.createHash)("sha256");(0,L.$le)(k,{onData:w=>S.update(w.buffer),onError:w=>C(w),onEnd:()=>g(S.digest("base64").replace(/=+$/,""))})})}};e.$vbc=j,e.$vbc=j=ye([K(0,A.$Gk)],j)}),define(le[97],he([0,1,14,7,163,11]),function(se,e,I,L,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qq=void 0;async function O(C,S,w,h,f,m){let y;try{await R(C,S,w,h,f,m)}catch(l){y=l}finally{y&&f.errorTransformer&&(y=f.errorTransformer(y)),typeof y<"u"&&w.error(y),w.end()}}e.$qq=O;async function R(C,S,w,h,f,m){k(m);const y=await C.open(S,{create:!1});try{k(m);let l=0,d=0,$=f&&typeof f.length=="number"?f.length:void 0,c=I.$te.alloc(Math.min(f.bufferSize,typeof $=="number"?$:f.bufferSize)),v=f&&typeof f.position=="number"?f.position:0,i=0;do d=await C.read(y,v,c.buffer,i,c.byteLength-i),v+=d,i+=d,l+=d,typeof $=="number"&&($-=d),i===c.byteLength&&(await w.write(h(c)),c=I.$te.alloc(Math.min(f.bufferSize,typeof $=="number"?$:f.bufferSize)),i=0);while(d>0&&(typeof $!="number"||$>0)&&k(m)&&g(l,f));if(i>0){let o=i;typeof $=="number"&&(o=Math.min(i,$)),w.write(h(c.slice(0,o)))}}catch(l){throw(0,j.$Uk)(l)}finally{await C.close(y)}}function k(C){if(C.isCancellationRequested)throw(0,L.$6)();return!0}function g(C,S){if(typeof S?.limits?.size=="number"&&C>S.limits.size)throw(0,j.$Tk)((0,A.localize)(0,null),j.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(le[51],he([0,1,90,2,15,5,10,11]),function(se,e,I,L,A,j,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zq=e.$yq=e.$xq=e.$wq=e.$vq=e.$uq=e.$tq=e.$sq=void 0;function k(l){return l.recursive===!0}e.$sq=k;class g extends L.$Tc{static{this.a=5}constructor(d,$,c,v){super(),this.h=d,this.j=$,this.m=c,this.n=v,this.c=this.B(new L.$Uc),this.f=void 0,this.g=0}s(){const d=new L.$Sc;this.c.value=d,this.b=this.r(d),this.b.setVerboseLogging(this.m),d.add(this.b.onDidChangeFile($=>this.h($))),d.add(this.b.onDidLogMessage($=>this.j($))),d.add(this.b.onDidError($=>this.t($)))}t(d){this.n.restartOnError?this.g<g.a&&this.f?(this.w(`restarting watcher after error: ${d}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${d}`):this.w(d)}u(d){this.g++,this.s(),this.watch(d)}async watch(d){this.f=d,await this.b?.watch(d)}async setVerboseLogging(d){this.m=d,await this.b?.setVerboseLogging(d)}w(d){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${d}`})}y(d){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${d}`})}dispose(){return this.b=void 0,super.dispose()}}e.$tq=g;class C extends g{constructor(d,$,c){super(d,$,c,{type:"node.js",restartOnError:!1})}}e.$uq=C;class S extends g{constructor(d,$,c){super(d,$,c,{type:"universal",restartOnError:!0})}}e.$vq=S;function w(l){return l.map(d=>({type:d.type,resource:O.URI.revive(d.resource),cId:d.cId}))}e.$wq=w;function h(l){const d=new y;for(const $ of l)d.processEvent($);return d.coalesce()}e.$xq=h;function f(l,d){return typeof d=="string"&&!d.startsWith(I.$Vj)&&!(0,A.$ic)(d)?{base:l,pattern:d}:d}e.$yq=f;function m(l,d){const $=[];for(const c of d)$.push((0,I.$Zj)(f(l,c)));return $}e.$zq=m;class y{constructor(){this.a=new Set,this.b=new Map}c(d){return j.$k?d.resource.fsPath:d.resource.fsPath.toLowerCase()}processEvent(d){const $=this.b.get(this.c(d));let c=!1;if($){const v=$.type,i=d.type;$.resource.fsPath!==d.resource.fsPath&&(d.type===2||d.type===1)?c=!0:v===1&&i===2?(this.b.delete(this.c(d)),this.a.delete($)):v===2&&i===1?$.type=0:v===1&&i===0||($.type=i)}else c=!0;c&&(this.a.add(d),this.b.set(this.c(d),d))}coalesce(){const d=[],$=[];return Array.from(this.a).filter(c=>c.type!==2?(d.push(c),!1):!0).sort((c,v)=>c.resource.fsPath.length-v.resource.fsPath.length).filter(c=>$.some(v=>(0,R.$1k)(c.resource.fsPath,v,!j.$k))?!1:($.push(c.resource.fsPath),!0)).concat(d)}}}),define(le[193],he([0,1,14,38,7,3,2,47,32,11,51]),function(se,e,I,L,A,j,O,R,k,g,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yP=e.$xP=void 0,e.$xP="localFilesystem";class S extends O.$Tc{constructor(h,f){super(),this.a=h,this.b=f,this.onDidChangeCapabilities=j.Event.None,this.f=this.B(new j.$6d),this.onDidChangeFile=this.f.event,this.g=this.B(new j.$6d),this.onDidWatchError=this.g.event,this.h=(0,k.$Cg)(),this.j()}get capabilities(){return this.c||(this.c=253982,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(h){return this.a.call("stat",[h])}readdir(h){return this.a.call("readdir",[h])}async readFile(h,f){const{buffer:m}=await this.a.call("readFile",[h,f]);return m}readFileStream(h,f,m){const y=(0,R.$he)(d=>I.$te.concat(d.map($=>I.$te.wrap($))).buffer),l=new O.$Sc;return l.add(this.a.listen("readFileStream",[h,f])(d=>{if(d instanceof I.$te)y.write(d.buffer);else{if(d==="end")y.end();else{let $;if(d instanceof Error)$=d;else{const c=d;$=(0,g.$Tk)(c.message??(0,L.$4i)(c),c.code??g.FileSystemProviderErrorCode.Unknown)}y.error($),y.end()}l.dispose()}})),l.add(m.onCancellationRequested(()=>{y.error((0,A.$6)()),y.end(),l.dispose()})),y}writeFile(h,f,m){return this.a.call("writeFile",[h,I.$te.wrap(f),m])}open(h,f){return this.a.call("open",[h,f])}close(h){return this.a.call("close",[h])}async read(h,f,m,y,l){const[d,$]=await this.a.call("read",[h,f,l]);return m.set(d.buffer.slice(0,$),y),$}write(h,f,m,y,l){return this.a.call("write",[h,f,I.$te.wrap(m),y,l])}mkdir(h){return this.a.call("mkdir",[h])}delete(h,f){return this.a.call("delete",[h,f])}rename(h,f,m){return this.a.call("rename",[h,f,m])}copy(h,f,m){return this.a.call("copy",[h,f,m])}cloneFile(h,f){return this.a.call("cloneFile",[h,f])}j(){this.B(this.a.listen("fileChange",[this.h])(h=>{if(Array.isArray(h)){const f=h;this.f.fire((0,C.$wq)(f))}else{const f=h;this.g.fire(f)}}))}watch(h,f){const m=(0,k.$Cg)();return this.a.call("watch",[this.h,m,h,f]),(0,O.$Rc)(()=>this.a.call("unwatch",[this.h,m]))}}e.$yP=S}),define(le[194],he([0,1,50,6,26,49,2,87,15,5,20,10,146,31,51]),function(se,e,I,L,A,j,O,R,k,g,C,S,w,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nq=e.$Mq=void 0;class m extends O.$Tc{static{this.a=100}static{this.b=75}constructor(d,$,c,v){super(),this.m=d,this.n=$,this.r=c,this.s=v,this.c=this.B(new L.$vh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},i=>this.n(i))),this.f=this.B(new L.$uh(i=>this.z(i),m.b)),this.g=(0,f.$zq)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,f.$zq)(this.m.path,this.m.includes):void 0,this.j=new A.$de,this.ready=this.t()}async t(){try{const d=await this.u(this.m);if(this.j.token.isCancellationRequested)return;const $=await h.Promises.stat(d);this.B(await this.w(d,$.isDirectory()))}catch(d){d.code!=="ENOENT"?this.D(d):this.G(d)}}async u(d){let $=d.path;try{$=await h.Promises.realpath(d.path),d.path===$&&($=await(0,w.$Jq)(d.path)??d.path),d.path!==$&&this.G(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${d.path}, real: ${$})`)}catch{}return $}async w(d,$){if(g.$j&&(0,j.$gg)(d,"/Volumes/",!0))return this.D(`Refusing to watch ${d} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),O.$Tc.None;const c=new A.$de(this.j.token),v=new O.$Sc;try{const i=S.URI.file(this.m.path),o=(0,k.$nc)(d),n=(0,I.watch)(d);v.add((0,O.$Rc)(()=>{n.removeAllListeners(),n.close()})),this.G(`Started watching: '${d}'`);const s=new Set;if($)try{for(const r of await h.Promises.readdir(d))s.add(r)}catch(r){this.D(r)}const t=new Map;v.add((0,O.$Rc)(()=>{for(const[,r]of t)r.dispose();t.clear()})),n.on("error",(r,a)=>{this.D(`Failed to watch ${d} for changes using fs.watch() (${r}, ${a})`),this.dispose()}),n.on("change",(r,a)=>{if(c.token.isCancellationRequested)return;this.G(`[raw] ["${r}"] ${a}`);let E="";if(a&&(E=a.toString(),g.$j&&(E=(0,R.$Rl)(E))),!(!E||r!=="change"&&r!=="rename"))if($)if(r==="rename"){t.get(E)?.dispose();const b=setTimeout(async()=>{if(t.delete(E),E===o&&!await h.Promises.exists(d)){this.F("Watcher shutdown because watched path got deleted"),this.dispose();return}const u=await this.C((0,k.$jc)(d,E));if(c.token.isCancellationRequested)return;let p;u?s.has(E)?p=0:(p=1,s.add(E)):(s.delete(E),p=2),this.y({resource:(0,C.$Tg)(i,E),type:p,cId:this.m.correlationId})},m.a);t.set(E,(0,O.$Rc)(()=>clearTimeout(b)))}else{let b;s.has(E)?b=0:(b=1,s.add(E)),this.y({resource:(0,C.$Tg)(i,E),type:b,cId:this.m.correlationId})}else if(r==="rename"||E!==o){const b=setTimeout(async()=>{const u=await h.Promises.exists(d);c.token.isCancellationRequested||(u?(this.y({resource:i,type:0,cId:this.m.correlationId},!0),v.add(await this.w(d,!1))):(this.y({resource:i,type:2,cId:this.m.correlationId},!0),this.f.flush(),this.dispose()))},m.a);v.clear(),v.add((0,O.$Rc)(()=>clearTimeout(b)))}else this.y({resource:i,type:0,cId:this.m.correlationId},!0)})}catch(i){await h.Promises.exists(d)&&!c.token.isCancellationRequested&&this.D(`Failed to watch ${d} for changes using fs.watch() (${i.toString()})`)}return(0,O.$Rc)(()=>{c.dispose(!0),v.dispose()})}y(d,$=!1){this.j.token.isCancellationRequested||(this.s&&this.G(`${d.type===1?"[ADDED]":d.type===2?"[DELETED]":"[CHANGED]"} ${d.resource.fsPath}`),!$&&this.g.some(c=>c(d.resource.fsPath))?this.s&&this.G(` >> ignored (excluded) ${d.resource.fsPath}`):!$&&this.h&&this.h.length>0&&!this.h.some(c=>c(d.resource.fsPath))?this.s&&this.G(` >> ignored (not included) ${d.resource.fsPath}`):this.f.work(d))}z(d){const $=(0,f.$xq)(d);if($.length>0){if(this.s)for(const v of $)this.G(` >> normalized ${v.type===1?"[ADDED]":v.type===2?"[DELETED]":"[CHANGED]"} ${v.resource.fsPath}`);this.c.work($)?this.c.pending>0&&this.G(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${$[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.F(`started ignoring events due to too many file change events at once (incoming: ${$.length}, most recent change: ${$[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async C(d){if(g.$k)return h.Promises.exists(d);try{const $=(0,k.$nc)(d);return(await h.Promises.readdir((0,k.$mc)(d))).some(v=>v===$)}catch($){return this.G($),!1}}setVerboseLogging(d){this.s=d}D(d){this.j.token.isCancellationRequested||this.r?.({type:"error",message:`[File Watcher (node.js)] ${d}`})}F(d){this.j.token.isCancellationRequested||this.r?.({type:"warn",message:`[File Watcher (node.js)] ${d}`})}G(d){!this.j.token.isCancellationRequested&&this.s&&this.r?.({type:"trace",message:`[File Watcher (node.js)] ${d}`})}dispose(){this.G(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$Mq=m;async function y(l,d,$,c,v=512){const i=await h.Promises.open(l,"r"),o=Buffer.allocUnsafe(v),n=new A.$de(c);let s,t=!1;const r={path:l,excludes:[],recursive:!1},a=new m(r,E=>{(async()=>{for(const{type:b}of E)if(b===0){if(t)return;t=!0;try{for(;!n.token.isCancellationRequested;){const{bytesRead:u}=await h.Promises.read(i,o,0,v,null);if(!u||n.token.isCancellationRequested)break;d(o.slice(0,u))}}catch(u){s=new Error(u),n.dispose(!0)}finally{t=!1}}})()});return await a.ready,$(),new Promise((E,b)=>{n.token.onCancellationRequested(async()=>{a.dispose();try{await h.Promises.close(i)}catch(u){s=new Error(u)}s?b(s):E()})})}e.$Nq=y}),define(le[195],he([0,1,3,90,2,5,194]),function(se,e,I,L,A,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oq=void 0;class R extends A.$Tc{constructor(){super(...arguments),this.a=this.B(new I.$6d),this.onDidChangeFile=this.a.event,this.b=this.B(new I.$6d),this.onDidLogMessage=this.b.event,this.onDidError=I.Event.None,this.c=new Map,this.f=!1}async watch(g){const C=this.j(g),S=C.filter(h=>{const f=this.c.get(h.path);return f?!(0,L.$4j)(f.request.excludes,h.excludes)||!(0,L.$4j)(f.request.includes,h.includes):!0}),w=Array.from(this.c.values()).filter(({request:h})=>!C.find(f=>f.path===h.path&&(0,L.$4j)(f.excludes,h.excludes)&&(0,L.$4j)(f.includes,h.includes))).map(({request:h})=>h.path);S.length&&this.m(`Request to start watching: ${S.map(h=>`${h.path} (excludes: ${h.excludes.length>0?h.excludes:"<none>"}, includes: ${h.includes&&h.includes.length>0?JSON.stringify(h.includes):"<all>"}, correlationId: ${typeof h.correlationId=="number"?h.correlationId:"<none>"})`).join(",")}`),w.length&&this.m(`Request to stop watching: ${w.join(",")}`);for(const h of w)this.h(h);for(const h of S)this.g(h)}g(g){const C=new O.$Mq(g,w=>this.a.fire(w),w=>this.b.fire(w),this.f),S={request:g,instance:C};this.c.set(g.path,S)}async stop(){for(const[g]of this.c)this.h(g);this.c.clear()}h(g){const C=this.c.get(g);C&&(this.c.delete(g),C.instance.dispose())}j(g){const C=new Map;for(const S of g){const w=j.$k?S.path:S.path.toLowerCase();let h=C.get(S.correlationId);h||(h=new Map,C.set(S.correlationId,h)),h.set(w,S)}return Array.from(C.values()).map(S=>Array.from(S.values())).flat()}async setVerboseLogging(g){this.f=g;for(const[,C]of this.c)C.instance.setVerboseLogging(g)}m(g){this.f&&this.b.fire({type:"trace",message:this.n(g)})}n(g,C){return C?`[File Watcher (node.js)] ${g} (path: ${C.request.path})`:`[File Watcher (node.js)] ${g}`}}e.$Oq=R}),define(le[196],he([0,1,51,195]),function(se,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pq=void 0;class A extends I.$uq{constructor(O,R,k){super(O,R,k),this.s()}r(O){return O.add(new L.$Oq)}}e.$Pq=A}),define(le[197],he([0,1,23,40,92,51]),function(se,e,I,L,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hq=void 0;class O extends j.$vq{constructor(k,g,C){super(k,g,C),this.s()}r(k){const g=k.add(new A.$Gq(I.$Ag.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return k.add(g.onDidProcessExit(({code:C,signal:S})=>this.t(`terminated by itself with code ${C}, signal: ${S}`))),L.ProxyChannel.toService((0,L.$Zh)(g.getChannel("watcher")))}}e.$Hq=O}),define(le[74],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ei=void 0;class I{constructor(...A){this.a=new Map;for(const[j,O]of A)this.set(j,O)}set(A,j){const O=this.a.get(A);return this.a.set(A,j),O}has(A){return this.a.has(A)}get(A){return this.a.get(A)}}e.$ei=I}),define(le[198],he([0,1,6,7,2,72,189,4,74,86]),function(se,e,I,L,A,j,O,R,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uq=e.$Tq=void 0;const C=!1;class S extends Error{constructor(y){super("cyclic dependency between services"),this.message=y.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${y.toString()}`}}class w{constructor(y=new k.$ei,l=!1,d,$=C){this.f=y,this.g=l,this.h=d,this.i=$,this.o=new Set,this.f.set(R.$fi,this),this._globalGraph=$?d?._globalGraph??new O.$Sq(c=>c):void 0}createChild(y){return new w(y,this.g,this,this.i)}invokeFunction(y,...l){const d=f.traceInvocation(this.i,y);let $=!1;try{return y({get:v=>{if($)throw(0,L.$8)("service accessor is only valid during the invocation of its target method");const i=this.m(v,d);if(!i)throw new Error(`[invokeFunction] unknown service '${v}'`);return i}},...l)}finally{$=!0,d.stop()}}createInstance(y,...l){let d,$;return y instanceof j.$di?(d=f.traceCreation(this.i,y.ctor),$=this.j(y.ctor,y.staticArguments.concat(l),d)):(d=f.traceCreation(this.i,y),$=this.j(y,l,d)),d.stop(),$}j(y,l=[],d){const $=R._util.getServiceDependencies(y).sort((i,o)=>i.index-o.index),c=[];for(const i of $){const o=this.m(i.id,d);o||this.u(`[createInstance] ${y.name} depends on UNKNOWN service ${i.id}.`,!1),c.push(o)}const v=$.length>0?$[0].index:l.length;if(l.length!==v){console.trace(`[createInstance] First service dependency of ${y.name} at position ${v+1} conflicts with ${l.length} static arguments`);const i=v-l.length;i>0?l=l.concat(new Array(i)):l=l.slice(0,v)}return Reflect.construct(y,l.concat(c))}k(y,l){if(this.f.get(y)instanceof j.$di)this.f.set(y,l);else if(this.h)this.h.k(y,l);else throw new Error("illegalState - setting UNKNOWN service instance")}l(y){const l=this.f.get(y);return!l&&this.h?this.h.l(y):l}m(y,l){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(y));const d=this.l(y);return d instanceof j.$di?this.q(y,d,l.branch(y,!0)):(l.branch(y,!1),d)}q(y,l,d){if(this.o.has(y))throw new Error(`illegal state - RECURSIVELY instantiating service '${y}'`);this.o.add(y);try{return this.r(y,l,d)}finally{this.o.delete(y)}}r(y,l,d){const $=new O.$Sq(i=>i.id.toString());let c=0;const v=[{id:y,desc:l,_trace:d}];for(;v.length;){const i=v.pop();if($.lookupOrInsertNode(i),c++>1e3)throw new S($);for(const o of R._util.getServiceDependencies(i.desc.ctor)){const n=this.l(o.id);if(n||this.u(`[createInstance] ${y} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(o.id)),n instanceof j.$di){const s={id:o.id,desc:n,_trace:i._trace.branch(o.id,!0)};$.insertEdge(i,s),v.push(s)}}}for(;;){const i=$.roots();if(i.length===0){if(!$.isEmpty())throw new S($);break}for(const{data:o}of i){if(this.l(o.id)instanceof j.$di){const s=this.s(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this.k(o.id,s)}$.removeNode(o)}}return this.l(y)}s(y,l,d=[],$,c){if(this.f.get(y)instanceof j.$di)return this.t(y,l,d,$,c);if(this.h)return this.h.s(y,l,d,$,c);throw new Error(`illegalState - creating UNKNOWN service instance ${l.name}`)}t(y,l,d=[],$,c){if($){const v=new w(void 0,this.g,this,this.i);v.c=String(y);const i=new Map,o=new I.$zh(()=>{const n=v.j(l,d,c);for(const[s,t]of i){const r=n[s];if(typeof r=="function")for(const a of t)a.disposable=r.apply(n,a.listener)}return i.clear(),n});return new Proxy(Object.create(null),{get(n,s){if(!o.isInitialized&&typeof s=="string"&&(s.startsWith("onDid")||s.startsWith("onWill"))){let a=i.get(s);return a||(a=new g.$4c,i.set(s,a)),(b,u,p)=>{if(o.isInitialized)return o.value[s](b,u,p);{const P={listener:[b,u,p],disposable:void 0},N=a.push(P);return(0,A.$Rc)(()=>{N(),P.disposable?.dispose()})}}}if(s in n)return n[s];const t=o.value;let r=t[s];return typeof r!="function"||(r=r.bind(t),n[s]=r),r},set(n,s,t){return o.value[s]=t,!0},getPrototypeOf(n){return l.prototype}})}else return this.j(l,d,c)}u(y,l){if(l&&console.warn(y),this.g)throw new Error(y)}}e.$Tq=w;var h;(function(m){m[m.None=0]="None",m[m.Creation=1]="Creation",m[m.Invocation=2]="Invocation",m[m.Branch=3]="Branch"})(h||(h={}));class f{static{this.all=new Set}static{this.c=new class extends f{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(y,l){return y?new f(2,l.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):f.c}static traceCreation(y,l){return y?new f(1,l.name):f.c}static{this.f=0}constructor(y,l){this.type=y,this.name=l,this.g=Date.now(),this.h=[]}branch(y,l){const d=new f(3,y.toString());return this.h.push([y,l,d]),d}stop(){const y=Date.now()-this.g;f.f+=y;let l=!1;function d(c,v){const i=[],o=new Array(c+1).join("	");for(const[n,s,t]of v.h)if(s&&t){l=!0,i.push(`${o}CREATES -> ${n}`);const r=d(c+1,t);r&&i.push(r)}else i.push(`${o}uses -> ${n}`);return i.join(`
`)}const $=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${d(1,this)}`,`DONE, took ${y.toFixed(2)}ms (grand total ${f.f.toFixed(2)}ms)`];(y>2||l)&&f.all.add($.join(`
`))}}e.$Uq=f}),define(le[56],he([0,1,4]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4ac=e.$3ac=void 0,e.$3ac=(0,I.$gi)("mainProcessService");class L{constructor(j,O){this.a=j,this.b=O}getChannel(j){return this.a.getChannel(j,this.b)}registerChannel(j,O){this.a.registerChannel(j,O)}}e.$4ac=L}),define(le[75],he([0,1,26,2,5,165,29,4]),function(se,e,I,L,A,j,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xr=e.$wr=e.$vr=void 0;function k(C){return C.tags.find(S=>S.startsWith("lp-"))?.split("lp-")[1]}e.$vr=k,e.$wr=(0,R.$gi)("languagePackService");let g=class extends L.$Tc{constructor(S){super(),this.c=S}async getAvailableLanguages(){const S=new I.$de;setTimeout(()=>S.cancel(),1e3);let w;try{w=await this.c.query({text:'category:"language packs"',pageSize:20},S.token)}catch{return[]}const f=w.firstPage.filter(m=>m.properties.localizedLanguages?.length&&m.tags.some(y=>y.startsWith("lp-"))).map(m=>{const y=m.properties.localizedLanguages?.[0],l=k(m);return{...this.f(l,y,m),extensionId:m.identifier.id,galleryExtension:m}});return f.push(this.f("en","English")),f}f(S,w,h){const f=w??S;let m;if(f!==S&&(m=`(${S})`),S.toLowerCase()===A.$w.toLowerCase()&&(m??="",m+=(0,j.localize)(0,null)),h?.installCount){m??="";const y=h.installCount;let l;y>1e6?l=`${Math.floor(y/1e5)/10}M`:y>1e3?l=`${Math.floor(y/1e3)}K`:l=String(y),m+=` $(cloud-download) ${l}`}return{id:S,label:f,description:m}}};e.$xr=g,e.$xr=g=ye([K(0,O.$Oo)],g)}),define(le[199],he([0,1,2,75]),function(se,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rbc=void 0;let A=class extends I.$Tc{constructor(O){super(),this.a=O,this.b()}b(){this.a.update()}};e.$rbc=A,e.$rbc=A=ye([K(0,L.$wr)],A)}),define(le[8],he([0,1,38,3,54,2,35,5,20,12,10,93,4]),function(se,e,I,L,A,j,O,R,k,g,C,S,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.log=e.$Dj=e.LogLevel=e.$Cj=e.$Bj=e.$Aj=void 0,e.$Aj=(0,w.$gi)("logService"),e.$Bj=(0,w.$gi)("loggerService");function h(){return new Date().toISOString()}function f(b){return(0,g.$Xf)(b)}e.$Cj=f;var m;(function(b){b[b.Off=0]="Off",b[b.Trace=1]="Trace",b[b.Debug=2]="Debug",b[b.Info=3]="Info",b[b.Warning=4]="Warning",b[b.Error=5]="Error"})(m||(e.LogLevel=m={})),e.$Dj=m.Info;function y(b,u,p){switch(u){case m.Trace:b.trace(p);break;case m.Debug:b.debug(p);break;case m.Info:b.info(p);break;case m.Warning:b.warn(p);break;case m.Error:b.error(p);break;case m.Off:break;default:throw new Error(`Invalid log level ${u}`)}}e.log=y;function l(b,u=!1){let p="";for(let P=0;P<b.length;P++){let N=b[P];if(N instanceof Error&&(N=(0,I.$4i)(N,u)),typeof N=="object")try{N=JSON.stringify(N)}catch{}p+=(P>0?" ":"")+N}return p}class d extends j.$Tc{constructor(){super(...arguments),this.b=e.$Dj,this.c=this.B(new L.$6d),this.onDidChangeLogLevel=this.c.event}setLevel(u){this.b!==u&&(this.b=u,this.c.fire(this.b))}getLevel(){return this.b}f(u){return this.b!==m.Off&&this.b<=u}}e.$Fj=d;class $ extends d{constructor(u){super(),this.h=u}f(u){return this.h||super.f(u)}trace(u,...p){this.f(m.Trace)&&this.g(m.Trace,l([u,...p],!0))}debug(u,...p){this.f(m.Debug)&&this.g(m.Debug,l([u,...p]))}info(u,...p){this.f(m.Info)&&this.g(m.Info,l([u,...p]))}warn(u,...p){this.f(m.Warning)&&this.g(m.Warning,l([u,...p]))}error(u,...p){if(this.f(m.Error))if(u instanceof Error){const P=Array.prototype.slice.call(arguments);P[0]=u.stack,this.g(m.Error,l(P))}else this.g(m.Error,l([u,...p]))}flush(){}}e.$Gj=$;class c extends d{constructor(u=e.$Dj){super(),this.setLevel(u),this.g=!R.$i}trace(u,...p){this.f(m.Trace)&&(this.g?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,u,...p):console.log(`[main ${h()}]`,u,...p))}debug(u,...p){this.f(m.Debug)&&(this.g?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,u,...p):console.log(`[main ${h()}]`,u,...p))}info(u,...p){this.f(m.Info)&&(this.g?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,u,...p):console.log(`[main ${h()}]`,u,...p))}warn(u,...p){this.f(m.Warning)&&(this.g?console.warn(`\x1B[93m[main ${h()}]\x1B[0m`,u,...p):console.warn(`[main ${h()}]`,u,...p))}error(u,...p){this.f(m.Error)&&(this.g?console.error(`\x1B[91m[main ${h()}]\x1B[0m`,u,...p):console.error(`[main ${h()}]`,u,...p))}flush(){}}e.$Hj=c;class v extends d{constructor(u=e.$Dj,p=!0){super(),this.g=p,this.setLevel(u)}trace(u,...p){this.f(m.Trace)&&(this.g?console.log("%cTRACE","color: #888",u,...p):console.log(u,...p))}debug(u,...p){this.f(m.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",u,...p):console.log(u,...p))}info(u,...p){this.f(m.Info)&&(this.g?console.log("%c INFO","color: #33f",u,...p):console.log(u,...p))}warn(u,...p){this.f(m.Warning)&&(this.g?console.log("%c WARN","color: #993",u,...p):console.log(u,...p))}error(u,...p){this.f(m.Error)&&(this.g?console.log("%c  ERR","color: #f33",u,...p):console.error(u,...p))}flush(){}}e.$Ij=v;class i extends d{constructor(u,p=e.$Dj){super(),this.g=u,this.setLevel(p)}trace(u,...p){this.f(m.Trace)&&this.g.log(m.Trace,[this.h(u),...p])}debug(u,...p){this.f(m.Debug)&&this.g.log(m.Debug,[this.h(u),...p])}info(u,...p){this.f(m.Info)&&this.g.log(m.Info,[this.h(u),...p])}warn(u,...p){this.f(m.Warning)&&this.g.log(m.Warning,[this.h(u),...p])}error(u,...p){this.f(m.Error)&&this.g.log(m.Error,[this.h(u),...p])}h(u){return typeof u=="string"?u:(0,I.$4i)(u,this.f(m.Trace))}flush(){}}e.$Jj=i;class o extends d{constructor(u){super(),this.g=u,u.length&&this.setLevel(u[0].getLevel())}setLevel(u){for(const p of this.g)p.setLevel(u);super.setLevel(u)}trace(u,...p){for(const P of this.g)P.trace(u,...p)}debug(u,...p){for(const P of this.g)P.debug(u,...p)}info(u,...p){for(const P of this.g)P.info(u,...p)}warn(u,...p){for(const P of this.g)P.warn(u,...p)}error(u,...p){for(const P of this.g)P.error(u,...p)}flush(){for(const u of this.g)u.flush()}dispose(){for(const u of this.g)u.dispose();super.dispose()}}e.$Kj=o;class n extends j.$Tc{constructor(u,p,P){if(super(),this.h=u,this.j=p,this.b=new O.$Ac,this.c=this.B(new L.$6d),this.onDidChangeLoggers=this.c.event,this.f=this.B(new L.$6d),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new L.$6d),this.onDidChangeVisibility=this.g.event,P)for(const N of P)this.b.set(N.resource,{logger:void 0,info:N})}m(u){return(0,g.$Tf)(u)?[...this.b.values()].find(p=>p.info.id===u):this.b.get(u)}getLogger(u){return this.m(u)?.logger}createLogger(u,p){const P=this.n(u),N=(0,g.$Tf)(u)?u:p?.id??(0,A.$7i)(P.toString()).toString(16);let F=this.b.get(P)?.logger;const M=p?.logLevel==="always"?m.Trace:p?.logLevel;F||(F=this.s(P,M??this.getLogLevel(P)??this.h,{...p,id:N}));const z={logger:F,info:{resource:P,id:N,logLevel:M,name:p?.name,hidden:p?.hidden,extensionId:p?.extensionId,when:p?.when}};return this.registerLogger(z.info),this.b.set(P,z),F}n(u){return(0,g.$Tf)(u)?(0,k.$Tg)(this.j,`${u}.log`):u}setLogLevel(u,p){if(C.URI.isUri(u)){const P=u,N=p,F=this.b.get(P);F&&N!==F.info.logLevel&&(F.info.logLevel=N===this.h?void 0:N,F.logger?.setLevel(N),this.b.set(F.info.resource,F),this.f.fire([P,N]))}else{this.h=u;for(const[P,N]of this.b.entries())this.b.get(P)?.info.logLevel===void 0&&N.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(u,p){const P=this.m(u);P&&p!==!P.info.hidden&&(P.info.hidden=!p,this.b.set(P.info.resource,P),this.g.fire([P.info.resource,p]))}getLogLevel(u){let p;return u&&(p=this.b.get(u)?.info.logLevel),p??this.h}registerLogger(u){const p=this.b.get(u.resource);p?p.info.hidden!==u.hidden&&this.setVisibility(u.resource,!u.hidden):(this.b.set(u.resource,{info:u,logger:void 0}),this.c.fire({added:[u],removed:[]}))}deregisterLogger(u){const p=this.b.get(u);p&&(p.logger&&p.logger.dispose(),this.b.delete(u),this.c.fire({added:[],removed:[p.info]}))}*getRegisteredLoggers(){for(const u of this.b.values())yield u.info}getRegisteredLogger(u){return this.b.get(u)?.info}dispose(){this.b.forEach(u=>u.logger?.dispose()),this.b.clear(),super.dispose()}}e.$Lj=n;class s{constructor(){this.onDidChangeLogLevel=new L.$6d().event}setLevel(u){}getLevel(){return m.Info}trace(u,...p){}debug(u,...p){}info(u,...p){}warn(u,...p){}error(u,...p){}critical(u,...p){}dispose(){}flush(){}}e.$Mj=s;class t extends s{}e.$Nj=t;function r(b){if(b.verbose)return m.Trace;if(typeof b.logLevel=="string"){const u=E(b.logLevel.toLowerCase());if(u!==void 0)return u}return e.$Dj}e.$Oj=r;function a(b){switch(b){case m.Trace:return"trace";case m.Debug:return"debug";case m.Info:return"info";case m.Warning:return"warn";case m.Error:return"error";case m.Off:return"off"}}e.$Pj=a;function E(b){switch(b){case"trace":return m.Trace;case"debug":return m.Debug;case"info":return m.Info;case"warn":return m.Warning;case"error":return m.Error;case"critical":return m.Error;case"off":return m.Off}}e.$Qj=E,e.$Rj=new S.$xj("logLevel",a(m.Info))}),define(le[200],he([0,1,6,7,2,23,15,20,31,16,8]),function(se,e,I,L,A,j,O,R,k,g,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sbc=void 0;let S=class extends A.$Tc{constructor(h,f){super(),this.a=h,this.b=f,this.B(new I.$sh(()=>{this.c()},10*1e3)).schedule()}async c(){this.b.trace("[logs cleanup]: Starting to clean up old logs.");try{const h=(0,R.$Qg)(this.a.logsHome),f=(0,R.$Sg)(this.a.logsHome.with({scheme:j.Schemas.file})).fsPath,l=(await k.Promises.readdir(f)).filter($=>/^\d{8}T\d{6}$/.test($)).sort().filter($=>$!==h),d=l.slice(0,Math.max(0,l.length-9));d.length>0&&(this.b.trace(`[logs cleanup]: Removing log folders '${d.join(", ")}'`),await Promise.all(d.map($=>k.Promises.rm((0,O.$jc)(f,$)))))}catch(h){(0,L.$1)(h)}}};e.$sbc=S,e.$sbc=S=ye([K(0,g.$ni),K(1,C.$Aj)],S)}),define(le[98],he([0,1,7,4,8]),function(se,e,I,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vp=e.$Up=void 0,e.$Up=(0,L.$gi)("IExtensionSignatureVerificationService");let j=class{constructor(R){this.b=R}c(){return this.a||(this.a=new Promise((R,k)=>se(["@vscode/vsce-sign"],async g=>R(g),k))),this.a}async verify(R,k,g){let C;try{C=await this.c()}catch(S){return this.b.error("Could not load vsce-sign module",(0,I.$0)(S)),!1}return C.verify(R,k,g)}};e.$Vp=j,e.$Vp=j=ye([K(0,A.$Aj)],j)}),define(le[201],he([0,1,17,6,7,3,2,15,51,8]),function(se,e,I,L,A,j,O,R,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aq=void 0;class C extends O.$Tc{constructor(w,h){super(),this.a=w,this.b=h,this.c=this.B(new j.$6d),this.onDidChangeFile=this.c.event,this.g=this.B(new j.$6d),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new L.$eh(0)),this.w=[],this.y=this.B(new L.$eh(0))}watch(w,h){return h.recursive||this.b?.watcher?.forceUniversal?this.n(w,h):this.z(w,h)}n(w,h){const f={path:this.H(w),excludes:h.excludes,includes:h.includes,recursive:h.recursive,correlationId:h.correlationId},m=(0,I.$Ub)(this.j,f);return this.r(),(0,O.$Rc)(()=>{m(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(w=>(0,A.$1)(w))}s(){this.h||(this.h=this.B(this.t(h=>this.c.fire((0,k.$wq)(h)),h=>this.G(h),this.a.getLevel()===g.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===g.LogLevel.Trace)})));const w=this.b?.watcher?.recursive?.usePolling;if(w===!0)for(const h of this.j)(0,k.$sq)(h)&&(h.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(w))for(const h of this.j)(0,k.$sq)(h)&&w.includes(h.path)&&(h.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(w,h){const f={path:this.H(w),excludes:h.excludes,includes:h.includes,recursive:!1,correlationId:h.correlationId},m=(0,I.$Ub)(this.w,f);return this.C(),(0,O.$Rc)(()=>{m(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(w=>(0,A.$1)(w))}D(){return this.u||(this.u=this.B(this.F(w=>this.c.fire((0,k.$wq)(w)),w=>this.G(w),this.a.getLevel()===g.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===g.LogLevel.Trace)}))),this.u.watch(this.w)}G(w){w.type==="error"&&this.g.fire(w.message),this.a[w.type](w.message)}H(w){return(0,R.$hc)(w.fsPath)}}e.$Aq=C}),define(le[202],he([0,1,17,6,14,26,3,54,61,2,48,23,99,20,47,161,11,97,8,7]),function(se,e,I,L,A,j,O,R,k,g,C,S,w,h,f,m,y,l,d,$){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.$rq=void 0;let v=class extends g.$Tc{static{c=this}constructor(o){super(),this.b=o,this.a=256*1024,this.c=this.B(new O.$6d),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new O.$6d),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new O.$6d),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new O.$6d),this.onDidRunOperation=this.r.event,this.X=this.B(new O.$6d),this.Y=this.B(new O.$6d),this.onDidFilesChange=this.Y.event,this.Z=this.B(new O.$6d),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new L.$ph)}registerProvider(o,n){if(this.h.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,w.mark)(`code/registerFilesystem/${o}`);const s=new g.$Sc;return this.h.set(o,n),this.c.fire({added:!0,scheme:o,provider:n}),s.add(n.onDidChangeFile(t=>{const r=new y.$Zk(t,!this.S(n));this.X.fire(r),r.hasCorrelation()||this.Y.fire(r)})),typeof n.onDidWatchError=="function"&&s.add(n.onDidWatchError(t=>this.Z.fire(new Error(t)))),s.add(n.onDidChangeCapabilities(()=>this.g.fire({provider:n,scheme:o}))),(0,g.$Rc)(()=>{this.c.fire({added:!1,scheme:o,provider:n}),this.h.delete(o),(0,g.$Oc)(s)})}getProvider(o){return this.h.get(o)}async activateProvider(o){const n=[];this.f.fire({scheme:o,join(s){n.push(s)}}),!this.h.has(o)&&await L.Promises.settled(n)}async canHandleResource(o){return await this.activateProvider(o.scheme),this.hasProvider(o)}hasProvider(o){return this.h.has(o.scheme)}hasCapability(o,n){const s=this.h.get(o.scheme);return!!(s&&s.capabilities&n)}listCapabilities(){return k.Iterable.map(this.h,([o,n])=>({scheme:o,capabilities:n.capabilities}))}async j(o){if(!(0,h.$Xg)(o))throw new y.$2k((0,m.localize)(0,null,this.sb(o)),8);await this.activateProvider(o.scheme);const n=this.h.get(o.scheme);if(!n){const s=new $.$bb;throw s.message=(0,m.localize)(1,null,o.toString()),s}return n}async m(o){const n=await this.j(o);if((0,y.$Mk)(n)||(0,y.$Jk)(n)||(0,y.$Nk)(n))return n;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(o){const n=await this.j(o);if((0,y.$Mk)(n)||(0,y.$Jk)(n))return n;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,n){try{return await this.s(o,n)}catch(s){throw(0,y.$Wk)(s)===y.FileSystemProviderErrorCode.FileNotFound?new y.$2k((0,m.localize)(2,null,this.sb(o)),1):(0,y.$Uk)(s)}}async s(o,n){const s=await this.j(o),t=this.S(s),r=n?.resolveTo,a=n?.resolveSingleChildDescendants,E=n?.resolveMetadata,b=await s.stat(o);let u;return this.t(s,o,b,void 0,!!E,(p,P)=>(u||(u=C.$mi.forUris(()=>!t),u.set(o,!0),r&&u.fill(!0,r)),u.get(p.resource)||u.findSuperstr(p.resource.with({query:null,fragment:null}))?!0:p.isDirectory&&a?P===1:!1))}async t(o,n,s,t,r,a){const{providerExtUri:E}=this.R(o),b={resource:n,name:E.basename(n),isFile:(s.type&y.FileType.File)!==0,isDirectory:(s.type&y.FileType.Directory)!==0,isSymbolicLink:(s.type&y.FileType.SymbolicLink)!==0,mtime:s.mtime,ctime:s.ctime,size:s.size,readonly:!!((s.permissions??0)&y.FilePermission.Readonly)||!!(o.capabilities&2048),locked:!!((s.permissions??0)&y.FilePermission.Locked),etag:(0,y.$al)({mtime:s.mtime,size:s.size}),children:void 0};if(b.isDirectory&&a(b,t)){try{const u=await o.readdir(n),p=await L.Promises.settled(u.map(async([P,N])=>{try{const F=E.joinPath(n,P),M=r?await o.stat(F):{type:N};return await this.t(o,F,M,u.length,r,a)}catch(F){return this.b.trace(F),null}}));b.children=(0,I.$Hb)(p)}catch(u){this.b.trace(u),b.children=[]}return b}return b}async resolveAll(o){return L.Promises.settled(o.map(async n=>{try{return{stat:await this.s(n.resource,n.options),success:!0}}catch(s){return this.b.trace(s),{stat:void 0,success:!1}}}))}async stat(o){const n=await this.j(o),s=await n.stat(o);return this.t(n,o,s,void 0,!0,()=>!1)}async exists(o){const n=await this.j(o);try{return!!await n.stat(o)}catch{return!1}}async canCreateFile(o,n){try{await this.u(o,n)}catch(s){return s}return!0}async u(o,n){if(!n?.overwrite&&await this.exists(o))throw new y.$2k((0,m.localize)(3,null,this.sb(o)),3,n)}async createFile(o,n=A.$te.fromString(""),s){await this.u(o,s);const t=await this.writeFile(o,n);return this.r.fire(new y.$Yk(o,0,t)),t}async writeFile(o,n,s){const t=this.qb(await this.n(o),o),{providerExtUri:r}=this.R(t);let a=s;if((0,y.$Pk)(t)&&!a?.atomic){const E=t.enforceAtomicWriteFile?.(o);E&&(a={...s,atomic:E})}try{await this.w(t,o,a)||await this.U(t,r.dirname(o));let b;if((0,y.$Jk)(t)&&!(n instanceof A.$te))if((0,f.$fe)(n)){const u=await(0,f.$me)(n,3);u.ended?b=A.$te.concat(u.buffer):b=u}else b=(0,f.$je)(n,u=>A.$te.concat(u),3);else b=n;!(0,y.$Mk)(t)||(0,y.$Jk)(t)&&b instanceof A.$te||(0,y.$Jk)(t)&&(0,y.$Pk)(t)&&a?.atomic?await this.hb(t,o,a,b):await this.db(t,o,a,b instanceof A.$te?(0,A.$Ee)(b):b),this.r.fire(new y.$Yk(o,4))}catch(E){throw new y.$2k((0,m.localize)(4,null,this.sb(o),(0,y.$Uk)(E).toString()),(0,y.$Xk)(E),a)}return this.resolve(o,{resolveMetadata:!0})}async w(o,n,s){const t=!!s?.unlock;if(t&&!(o.capabilities&8192))throw new Error((0,m.localize)(5,null,this.sb(n)));if(!!s?.atomic){if(!(o.capabilities&32768))throw new Error((0,m.localize)(6,null,this.sb(n)));if(!(o.capabilities&2))throw new Error((0,m.localize)(7,null,this.sb(n)));if(t)throw new Error((0,m.localize)(8,null,this.sb(n)))}let a;try{a=await o.stat(n)}catch{return}if(a.type&y.FileType.Directory)throw new y.$2k((0,m.localize)(9,null,this.sb(n)),0,s);if(this.rb(n,a),typeof s?.mtime=="number"&&typeof s.etag=="string"&&s.etag!==y.$_k&&typeof a.mtime=="number"&&typeof a.size=="number"&&s.mtime<a.mtime&&s.etag!==(0,y.$al)({mtime:s.mtime,size:a.size}))throw new y.$2k((0,m.localize)(10,null),3,s);return a}async readFile(o,n,s){const t=await this.m(o);return n?.atomic?this.z(t,o,n,s):this.C(t,o,n,s)}async z(o,n,s,t){return new Promise((r,a)=>{this.cb.queueFor(n,async()=>{try{const E=await this.C(o,n,s,t);r(E)}catch(E){a(E)}},this.R(o).providerExtUri)})}async C(o,n,s,t){const r=await this.D(o,n,{...s,preferUnbuffered:!0},t);return{...r,value:await(0,A.$Fe)(r.value)}}async readFileStream(o,n,s){const t=await this.m(o);return this.D(t,o,n,s)}async D(o,n,s,t){const r=new j.$de(t);let a=s;(0,y.$Ok)(o)&&o.enforceAtomicReadFile?.(n)&&(a={...s,atomic:!0});const E=this.J(n,a).then(u=>u,u=>{throw r.dispose(!0),u});let b;try{return typeof a?.etag=="string"&&a.etag!==y.$_k&&await E,a?.atomic&&(0,y.$Ok)(o)||!((0,y.$Mk)(o)||(0,y.$Nk)(o))||(0,y.$Jk)(o)&&a?.preferUnbuffered?b=this.I(o,n,a):(0,y.$Nk)(o)?b=this.G(o,n,r.token,a):b=this.H(o,n,r.token,a),b.on("end",()=>r.dispose()),b.on("error",()=>r.dispose()),{...await E,value:b}}catch(u){throw b&&await(0,f.$ke)(b),this.F(u,n,a)}}F(o,n,s){const t=(0,m.localize)(11,null,this.sb(n),(0,y.$Uk)(o).toString());return o instanceof y.$4k?new y.$4k(t,o.stat,s):o instanceof y.$3k?new y.$3k(t,o.fileOperationResult,o.size,o.options):new y.$2k(t,(0,y.$Xk)(o),s)}G(o,n,s,t=Object.create(null)){const r=o.readFileStream(n,t,s);return(0,f.$qe)(r,{data:a=>a instanceof A.$te?a:A.$te.wrap(a),error:a=>this.F(a,n,t)},a=>A.$te.concat(a))}H(o,n,s,t=Object.create(null)){const r=(0,A.$Je)();return(0,l.$qq)(o,n,r,a=>a,{...t,bufferSize:this.a,errorTransformer:a=>this.F(a,n,t)},s),r}I(o,n,s){const t=(0,f.$he)(r=>A.$te.concat(r));return(async()=>{try{let r;s?.atomic&&(0,y.$Ok)(o)?r=await o.readFile(n,{atomic:!0}):r=await o.readFile(n),typeof s?.position=="number"&&(r=r.slice(s.position)),typeof s?.length=="number"&&(r=r.slice(0,s.length)),this.L(n,r.byteLength,s),t.end(A.$te.wrap(r))}catch(r){t.error(r),t.end()}})(),t}async J(o,n){const s=await this.resolve(o,{resolveMetadata:!0});if(s.isDirectory)throw new y.$2k((0,m.localize)(12,null,this.sb(o)),0,n);if(typeof n?.etag=="string"&&n.etag!==y.$_k&&n.etag===s.etag)throw new y.$4k((0,m.localize)(13,null),s,n);return this.L(o,s.size,n),s}L(o,n,s){if(typeof s?.limits?.size=="number"&&n>s.limits.size)throw new y.$3k((0,m.localize)(14,null,this.sb(o)),7,n,s)}async canMove(o,n,s){return this.M(o,n,"move",s)}async canCopy(o,n,s){return this.M(o,n,"copy",s)}async M(o,n,s,t){if(o.toString()!==n.toString())try{const r=s==="move"?this.qb(await this.n(o),o):await this.m(o),a=this.qb(await this.n(n),n);await this.Q(r,o,a,n,s,t)}catch(r){return r}return!0}async move(o,n,s){const t=this.qb(await this.n(o),o),r=this.qb(await this.n(n),n),a=await this.N(t,o,r,n,"move",!!s),E=await this.resolve(n,{resolveMetadata:!0});return this.r.fire(new y.$Yk(o,a==="move"?2:3,E)),E}async copy(o,n,s){const t=await this.m(o),r=this.qb(await this.n(n),n),a=await this.N(t,o,r,n,"copy",!!s),E=await this.resolve(n,{resolveMetadata:!0});return this.r.fire(new y.$Yk(o,a==="copy"?3:2,E)),E}async N(o,n,s,t,r,a){if(n.toString()===t.toString())return r;const{exists:E,isSameResourceWithDifferentPathCase:b}=await this.Q(o,n,s,t,r,a);if(E&&!b&&a&&await this.del(t,{recursive:!0}),await this.U(s,this.R(s).providerExtUri.dirname(t)),r==="copy"){if(o===s&&(0,y.$Kk)(o))await o.copy(n,t,{overwrite:a});else{const u=await this.resolve(n);u.isDirectory?await this.P(o,u,s,t):await this.O(o,n,s,t)}return r}else return o===s?(await o.rename(n,t,{overwrite:a}),r):(await this.N(o,n,s,t,"copy",a),await this.del(n,{recursive:!0}),"copy")}async O(o,n,s,t){if((0,y.$Mk)(o)&&(0,y.$Mk)(s))return this.jb(o,n,s,t);if((0,y.$Mk)(o)&&(0,y.$Jk)(s))return this.pb(o,n,s,t);if((0,y.$Jk)(o)&&(0,y.$Mk)(s))return this.nb(o,n,s,t);if((0,y.$Jk)(o)&&(0,y.$Jk)(s))return this.lb(o,n,s,t)}async P(o,n,s,t){await s.mkdir(t),Array.isArray(n.children)&&await L.Promises.settled(n.children.map(async r=>{const a=this.R(s).providerExtUri.joinPath(t,r.name);return r.isDirectory?this.P(o,await this.resolve(r.resource),s,a):this.O(o,r.resource,s,a)}))}async Q(o,n,s,t,r,a){let E=!1;if(o===s){const{providerExtUri:u,isPathCaseSensitive:p}=this.R(o);if(p||(E=u.isEqual(n,t)),E&&r==="copy")throw new Error((0,m.localize)(15,null,this.sb(n),this.sb(t)));if(!E&&u.isEqualOrParent(t,n))throw new Error((0,m.localize)(16,null,this.sb(n),this.sb(t)))}const b=await this.exists(t);if(b&&!E){if(!a)throw new y.$2k((0,m.localize)(17,null,this.sb(n),this.sb(t)),4);if(o===s){const{providerExtUri:u}=this.R(o);if(u.isEqualOrParent(n,t))throw new Error((0,m.localize)(18,null,this.sb(n),this.sb(t)))}}return{exists:b,isSameResourceWithDifferentPathCase:E}}R(o){const n=this.S(o);return{providerExtUri:n?h.$Jg:h.$Lg,isPathCaseSensitive:n}}S(o){return!!(o.capabilities&1024)}async createFolder(o){const n=this.qb(await this.j(o),o);await this.U(n,o);const s=await this.resolve(o,{resolveMetadata:!0});return this.r.fire(new y.$Yk(o,0,s)),s}async U(o,n){const s=[],{providerExtUri:t}=this.R(o);for(;!t.isEqual(n,t.dirname(n));)try{if(!((await o.stat(n)).type&y.FileType.Directory))throw new Error((0,m.localize)(19,null,this.sb(n)));break}catch(r){if((0,y.$Wk)(r)!==y.FileSystemProviderErrorCode.FileNotFound)throw r;s.push(t.basename(n)),n=t.dirname(n)}for(let r=s.length-1;r>=0;r--){n=t.joinPath(n,s[r]);try{await o.mkdir(n)}catch(a){if((0,y.$Wk)(a)!==y.FileSystemProviderErrorCode.FileExists)throw a}}}async canDelete(o,n){try{await this.W(o,n)}catch(s){return s}return!0}async W(o,n){const s=this.qb(await this.j(o),o),t=!!n?.useTrash;if(t&&!(s.capabilities&4096))throw new Error((0,m.localize)(20,null,this.sb(o)));const r=n?.atomic;if(r&&!(s.capabilities&65536))throw new Error((0,m.localize)(21,null,this.sb(o)));if(t&&r)throw new Error((0,m.localize)(22,null,this.sb(o)));let a;try{a=await s.stat(o)}catch{}if(a)this.rb(o,a);else throw new y.$2k((0,m.localize)(23,null,this.sb(o)),1);if(!!!n?.recursive){const b=await this.resolve(o);if(b.isDirectory&&Array.isArray(b.children)&&b.children.length>0)throw new Error((0,m.localize)(24,null,this.sb(o)))}return s}async del(o,n){const s=await this.W(o,n);let t=n;if((0,y.$Qk)(s)&&!t?.atomic){const b=s.enforceAtomicDelete?.(o);b&&(t={...n,atomic:b})}const r=!!t?.useTrash,a=!!t?.recursive,E=t?.atomic??!1;await s.delete(o,{recursive:a,useTrash:r,atomic:E}),this.r.fire(new y.$Yk(o,1))}async cloneFile(o,n){const s=await this.j(o),t=this.qb(await this.n(n),n);if(!(s===t&&this.R(s).providerExtUri.isEqual(o,n)))return s===t&&(0,y.$Lk)(s)?s.cloneFile(o,n):(await this.U(t,this.R(t).providerExtUri.dirname(n)),s===t&&(0,y.$Kk)(s)?this.cb.queueFor(o,()=>s.copy(o,n,{overwrite:!0}),this.R(s).providerExtUri):this.cb.queueFor(o,()=>this.O(s,o,t,n),this.R(s).providerExtUri))}static{this.ab=0}createWatcher(o,n){return this.watch(o,{...n,correlationId:c.ab++})}watch(o,n={recursive:!1,excludes:[]}){const s=new g.$Sc;let t=!1,r=()=>{t=!0};s.add((0,g.$Rc)(()=>r())),(async()=>{try{const E=await this.bb(o,n);t?(0,g.$Oc)(E):r=()=>(0,g.$Oc)(E)}catch(E){this.b.error(E)}})();const a=n.correlationId;if(typeof a=="number"){const E=s.add(new O.$6d);return s.add(this.X.event(u=>{u.correlates(a)&&E.fire(u)})),{onDidChange:E.event,dispose:()=>s.dispose()}}return s}async bb(o,n){const s=await this.j(o),t=(0,R.$7i)([this.R(s).providerExtUri.getComparisonKey(o),n]);let r=this.$.get(t);return r||(r={count:0,disposable:s.watch(o,n)},this.$.set(t,r)),r.count+=1,(0,g.$Rc)(()=>{r&&(r.count--,r.count===0&&((0,g.$Oc)(r.disposable),this.$.delete(t)))})}dispose(){super.dispose();for(const[,o]of this.$)(0,g.$Oc)(o.disposable);this.$.clear()}async db(o,n,s,t){return this.cb.queueFor(n,async()=>{const r=await o.open(n,{create:!0,unlock:s?.unlock??!1});try{(0,f.$fe)(t)||(0,f.$ge)(t)?await this.eb(o,r,t):await this.fb(o,r,t)}catch(a){throw(0,y.$Uk)(a)}finally{await o.close(r)}},this.R(o).providerExtUri)}async eb(o,n,s){let t=0,r;if((0,f.$ge)(s)){if(s.buffer.length>0){const a=A.$te.concat(s.buffer);await this.gb(o,n,a,a.byteLength,t,0),t+=a.byteLength}if(s.ended)return;r=s.stream}else r=s;return new Promise((a,E)=>{(0,f.$le)(r,{onData:async b=>{r.pause();try{await this.gb(o,n,b,b.byteLength,t,0)}catch(u){return E(u)}t+=b.byteLength,setTimeout(()=>r.resume())},onError:b=>E(b),onEnd:()=>a()})})}async fb(o,n,s){let t=0,r;for(;(r=s.read())!==null;)await this.gb(o,n,r,r.byteLength,t,0),t+=r.byteLength}async gb(o,n,s,t,r,a){let E=0;for(;E<t;){const b=await o.write(n,r+E,s.buffer,a+E,t-E);E+=b}}async hb(o,n,s,t){return this.cb.queueFor(n,()=>this.ib(o,n,s,t),this.R(o).providerExtUri)}async ib(o,n,s,t){let r;t instanceof A.$te?r=t:(0,f.$fe)(t)?r=await(0,A.$Fe)(t):(0,f.$ge)(t)?r=await(0,A.$Ge)(t):r=(0,A.$De)(t),await o.writeFile(n,r.buffer,{create:!0,overwrite:!0,unlock:s?.unlock??!1,atomic:s?.atomic??!1})}async jb(o,n,s,t){return this.cb.queueFor(t,()=>this.kb(o,n,s,t),this.R(s).providerExtUri)}async kb(o,n,s,t){let r,a;try{r=await o.open(n,{create:!1}),a=await s.open(t,{create:!0,unlock:!1});const E=A.$te.alloc(this.a);let b=0,u=0,p=0;do p=await o.read(r,b,E.buffer,u,E.byteLength-u),await this.gb(s,a,E,p,b,u),b+=p,u+=p,u===E.byteLength&&(u=0);while(p>0)}catch(E){throw(0,y.$Uk)(E)}finally{await L.Promises.settled([typeof r=="number"?o.close(r):Promise.resolve(),typeof a=="number"?s.close(a):Promise.resolve()])}}async lb(o,n,s,t){return this.cb.queueFor(t,()=>this.mb(o,n,s,t),this.R(s).providerExtUri)}async mb(o,n,s,t){return s.writeFile(t,await o.readFile(n),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(o,n,s,t){return this.cb.queueFor(t,()=>this.ob(o,n,s,t),this.R(s).providerExtUri)}async ob(o,n,s,t){const r=await s.open(t,{create:!0,unlock:!1});try{const a=await o.readFile(n);await this.gb(s,r,A.$te.wrap(a),a.byteLength,0,0)}catch(a){throw(0,y.$Uk)(a)}finally{await s.close(r)}}async pb(o,n,s,t){const r=await(0,A.$Fe)(this.H(o,n,j.CancellationToken.None));await this.hb(s,t,void 0,r)}qb(o,n){if(o.capabilities&2048)throw new y.$2k((0,m.localize)(25,null,this.sb(n)),6);return o}rb(o,n){if((n.permissions??0)&y.FilePermission.Readonly)throw new y.$2k((0,m.localize)(26,null,this.sb(o)),6)}sb(o){return o.scheme===S.Schemas.file?o.fsPath:o.toString(!0)}};e.$rq=v,e.$rq=v=c=ye([K(0,d.$Aj)],v)}),define(le[203],he([0,1,50,274,6,35,14,3,49,2,15,5,20,47,31,164,11,97,201,38,197,196]),function(se,e,I,L,A,j,O,R,k,g,C,S,w,h,f,m,y,l,d,$,c,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qq=void 0,(()=>{try{(0,L.gracefulify)(I)}catch(o){console.error(`Error enabling graceful-fs: ${(0,$.$4i)(o)}`)}})();class i extends d.$Aq{static{this.I=!1}constructor(n,s){super(n,s),this.onDidChangeCapabilities=R.Event.None,this.N=new j.$Ac(t=>w.$Kg.getComparisonKey(t)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,S.$k&&(this.J|=1024)),this.J}async stat(n){try{const{stat:s,symbolicLink:t}=await f.SymlinkSupport.stat(this.H(n));return{type:this.M(s,t),ctime:s.birthtime.getTime(),mtime:s.mtime.getTime(),size:s.size,permissions:s.mode&128?void 0:y.FilePermission.Locked}}catch(s){throw this.fb(s)}}async L(n){try{return await this.stat(n)}catch{return}}async readdir(n){try{const s=await f.Promises.readdir(this.H(n),{withFileTypes:!0}),t=[];return await Promise.all(s.map(async r=>{try{let a;r.isSymbolicLink()?a=(await this.stat((0,w.$Tg)(n,r.name))).type:a=this.M(r),t.push([r.name,a])}catch(a){this.a.trace(a)}})),t}catch(s){throw this.fb(s)}}M(n,s){let t;return s?.dangling?t=y.FileType.Unknown:n.isFile()?t=y.FileType.File:n.isDirectory()?t=y.FileType.Directory:t=y.FileType.Unknown,s&&(t|=y.FileType.SymbolicLink),t}async O(n){const s=this.H(n);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${s})`);let t;for(;t=this.N.get(n);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${s})`),await t.wait();const r=new A.$fh;return this.N.set(n,r),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${s})`),(0,g.$Rc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${s})`),this.N.get(n)===r&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${s})`),this.N.delete(n)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${s})`),r.open()})}async readFile(n,s){let t;try{s?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(n)})`),t=await this.O(n));const r=this.H(n);return await f.Promises.readFile(r)}catch(r){throw this.fb(r)}finally{t?.dispose()}}P(n){i.I&&this.a.trace(n)}readFileStream(n,s,t){const r=(0,h.$he)(a=>O.$te.concat(a.map(E=>O.$te.wrap(E))).buffer);return(0,l.$qq)(this,n,r,a=>a.buffer,{...s,bufferSize:256*1024},t),r}async writeFile(n,s,t){return t?.atomic!==!1&&t?.atomic?.postfix&&await this.Q(n)?this.R(n,(0,w.$Tg)((0,w.$Sg)(n),`${(0,w.$Qg)(n)}${t.atomic.postfix}`),s,t):this.S(n,s,t)}async Q(n){try{const s=this.H(n),{symbolicLink:t}=await f.SymlinkSupport.stat(s);if(t)return!1}catch{}return!0}async R(n,s,t,r){const a=new g.$Sc;try{a.add(await this.O(n)),a.add(await this.O(s)),await this.S(s,t,r,!0);try{await this.rename(s,n,{overwrite:!0})}catch(E){try{await this.delete(s,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw E}}finally{a.dispose()}}async S(n,s,t,r){let a;try{const E=this.H(n);if(!t.create||!t.overwrite){if(await f.Promises.exists(E)){if(!t.overwrite)throw(0,y.$Tk)((0,m.localize)(0,null),y.FileSystemProviderErrorCode.FileExists)}else if(!t.create)throw(0,y.$Tk)((0,m.localize)(1,null),y.FileSystemProviderErrorCode.FileNotFound)}a=await this.open(n,{create:!0,unlock:t.unlock},r),await this.write(a,0,s,0,s.byteLength)}catch(E){throw await this.gb(n,E)}finally{typeof a=="number"&&await this.close(a)}}static{this.Y=!0}static configureFlushOnWrite(n){i.Y=n}async open(n,s,t){const r=this.H(n);let a;(0,y.$Hk)(s)&&!t&&(a=await this.O(n));let E;try{if((0,y.$Hk)(s)&&s.unlock)try{const{stat:u}=await f.SymlinkSupport.stat(r);u.mode&128||await f.Promises.chmod(r,u.mode|128)}catch(u){u.code!=="ENOENT"&&this.a.trace(u)}let b;if((0,y.$Hk)(s)){if(S.$i)try{await f.Promises.truncate(r,0),b="r+"}catch(u){u.code!=="ENOENT"&&this.a.trace(u)}b||(b="w")}else b="r";E=await f.Promises.open(r,b)}catch(b){throw a?.dispose(),(0,y.$Hk)(s)?await this.gb(n,b):this.fb(b)}if(this.U.set(E,0),(0,y.$Hk)(s)&&this.X.set(E,n),a){const b=this.W.get(E);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${E} (${r})`),this.W.set(E,a),b&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${E} (${r})`),b.dispose())}return E}async close(n){const s=this.W.get(n);try{if(this.U.delete(n),this.X.delete(n)&&i.Y)try{await f.Promises.fdatasync(n)}catch(t){i.configureFlushOnWrite(!1),this.a.error(t)}return await f.Promises.close(n)}catch(t){throw this.fb(t)}finally{s&&(this.W.get(n)===s&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${n}`),this.W.delete(n)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${n}`),s.dispose())}}async read(n,s,t,r,a){const E=this.Z(n,s);let b=null;try{b=(await f.Promises.read(n,t,r,a,E)).bytesRead}catch(u){throw this.fb(u)}finally{this.$(n,E,b)}return b}Z(n,s){return s===this.U.get(n)?null:s}$(n,s,t){const r=this.U.get(n);typeof r=="number"&&(typeof s=="number"||(typeof t=="number"?this.U.set(n,r+t):this.U.delete(n)))}async write(n,s,t,r,a){return(0,A.$Ah)(()=>this.ab(n,s,t,r,a),100,3)}async ab(n,s,t,r,a){const E=this.Z(n,s);let b=null;try{b=(await f.Promises.write(n,t,r,a,E)).bytesWritten}catch(u){throw await this.gb(this.X.get(n),u)}finally{this.$(n,E,b)}return b}async mkdir(n){try{await f.Promises.mkdir(this.H(n))}catch(s){throw this.fb(s)}}async delete(n,s){try{const t=this.H(n);if(s.recursive){let r;s?.atomic!==!1&&s.atomic.postfix&&(r=(0,C.$jc)((0,C.$mc)(t),`${(0,C.$nc)(t)}${s.atomic.postfix}`)),await f.Promises.rm(t,f.RimRafMode.MOVE,r)}else try{await f.Promises.unlink(t)}catch(r){if(r.code==="EPERM"||r.code==="EISDIR"){let a=!1;try{const{stat:E,symbolicLink:b}=await f.SymlinkSupport.stat(t);a=E.isDirectory()&&!b}catch{}if(a)await f.Promises.rmdir(t);else throw r}else throw r}}catch(t){throw this.fb(t)}}async rename(n,s,t){const r=this.H(n),a=this.H(s);if(r!==a)try{await this.bb(n,s,"move",t.overwrite),await f.Promises.rename(r,a)}catch(E){throw(E.code==="EINVAL"||E.code==="EBUSY"||E.code==="ENAMETOOLONG")&&(E=new Error((0,m.localize)(2,null,(0,C.$nc)(r),(0,C.$nc)((0,C.$mc)(a)),E.toString()))),this.fb(E)}}async copy(n,s,t){const r=this.H(n),a=this.H(s);if(r!==a)try{await this.bb(n,s,"copy",t.overwrite),await f.Promises.copy(r,a,{preserveSymlinks:!0})}catch(E){throw(E.code==="EINVAL"||E.code==="EBUSY"||E.code==="ENAMETOOLONG")&&(E=new Error((0,m.localize)(3,null,(0,C.$nc)(r),(0,C.$nc)((0,C.$mc)(a)),E.toString()))),this.fb(E)}}async bb(n,s,t,r){const a=this.H(n),E=this.H(s);let b=!1;if(!!(this.capabilities&1024)||(b=(0,k.$fg)(a,E,!0)),b){if(t==="copy")throw(0,y.$Tk)((0,m.localize)(4,null),y.FileSystemProviderErrorCode.FileExists);if(t==="move")return}const p=await this.L(n);if(!p)throw(0,y.$Tk)((0,m.localize)(5,null),y.FileSystemProviderErrorCode.FileNotFound);const P=await this.L(s);if(P){if(!r)throw(0,y.$Tk)((0,m.localize)(6,null),y.FileSystemProviderErrorCode.FileExists);p.type&y.FileType.File&&P.type&y.FileType.File||await this.delete(s,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(n,s){return this.cb(n,s,!1)}async cb(n,s,t){const r=this.H(n),a=this.H(s),E=!!(this.capabilities&1024);if((0,k.$fg)(r,a,!E))return;const b=new g.$Sc;try{b.add(await this.O(n)),b.add(await this.O(s)),t&&await f.Promises.mkdir((0,C.$mc)(a),{recursive:!0}),await f.Promises.copyFile(r,a)}catch(u){if(u.code==="ENOENT"&&!t)return this.cb(n,s,!0);throw this.fb(u)}finally{b.dispose()}}t(n,s,t){return new c.$Hq(r=>n(r),r=>s(r),t)}F(n,s,t){return new v.$Pq(r=>n(r),r=>s(r),t)}fb(n){if(n instanceof y.$Sk)return n;let s=n,t;switch(n.code){case"ENOENT":t=y.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":t=y.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":t=y.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":t=y.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":t=y.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":s=`${n.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,t=y.FileSystemProviderErrorCode.Unknown;break;default:t=y.FileSystemProviderErrorCode.Unknown}return(0,y.$Tk)(s,t)}async gb(n,s){let t=this.fb(s);if(n&&t.code===y.FileSystemProviderErrorCode.NoPermissions)try{const{stat:r}=await f.SymlinkSupport.stat(this.H(n));r.mode&128||(t=(0,y.$Tk)(s,y.FileSystemProviderErrorCode.FileWriteLocked))}catch(r){this.a.trace(r)}return t}}e.$Qq=i}),define(le[100],he([0,1,3,2,4,8]),function(se,e,I,L,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sbc=e.$Rbc=void 0,e.$Rbc=(0,A.$gi)("sharedProcessLifecycleService");let O=class extends L.$Tc{constructor(k){super(),this.b=k,this.a=this.B(new I.$6d),this.onWillShutdown=this.a.event}fireOnWillShutdown(){this.b.trace("Lifecycle#onWillShutdown.fire()"),this.a.fire()}};e.$Sbc=O,e.$Sbc=O=ye([K(0,j.$Aj)],O)}),define(le[204],he([0,1,10,3,8,2]),function(se,e,I,L,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rr=e.$Qr=e.$Pr=void 0;class O extends A.$Lj{constructor(S,w,h,f,m){super(w,h,f),this.r=S,this.t=m,this.B(m.listen("onDidChangeLogLevel",S)(y=>{(0,A.$Cj)(y)?super.setLogLevel(y):super.setLogLevel(I.URI.revive(y[0]),y[1])})),this.B(m.listen("onDidChangeVisibility",S)(([y,l])=>super.setVisibility(I.URI.revive(y),l))),this.B(m.listen("onDidChangeLoggers",S)(({added:y,removed:l})=>{for(const d of y)super.registerLogger({...d,resource:I.URI.revive(d.resource)});for(const d of l)super.deregisterLogger(d.resource)}))}createConsoleMainLogger(){return new A.$Jj({log:(S,w)=>{this.t.call("consoleLog",[S,w])}})}registerLogger(S){super.registerLogger(S),this.t.call("registerLogger",[S,this.r])}deregisterLogger(S){super.deregisterLogger(S),this.t.call("deregisterLogger",[S,this.r])}setLogLevel(S,w){super.setLogLevel(S,w),this.t.call("setLogLevel",[S,w])}setVisibility(S,w){super.setVisibility(S,w),this.t.call("setVisibility",[this.n(S),w])}s(S,w,h){return new R(this.t,S,w,h,this.r)}static setLogLevel(S,w,h){return S.call("setLogLevel",[w,h])}}e.$Pr=O;class R extends A.$Gj{constructor(S,w,h,f,m){super(f?.logLevel==="always"),this.r=S,this.s=w,this.m=!1,this.n=[],this.setLevel(h),this.r.call("createLogger",[w,f,m]).then(()=>{this.u(this.n),this.m=!0})}g(S,w){const h=[[S,w]];this.m?this.u(h):this.n.push(...h)}u(S){this.r.call("log",[this.s,S])}}class k{constructor(S,w){this.a=S,this.b=w}listen(S,w){const h=this.b(S);switch(w){case"onDidChangeLoggers":return L.Event.map(this.a.onDidChangeLoggers,f=>({added:[...f.added].map(m=>this.c(m,h)),removed:[...f.removed].map(m=>this.c(m,h))}));case"onDidChangeVisibility":return L.Event.map(this.a.onDidChangeVisibility,f=>[h.transformOutgoingURI(f[0]),f[1]]);case"onDidChangeLogLevel":return L.Event.map(this.a.onDidChangeLogLevel,f=>(0,A.$Cj)(f)?f:[h.transformOutgoingURI(f[0]),f[1]])}throw new Error(`Event not found: ${w}`)}async call(S,w,h){const f=this.b(S);switch(w){case"setLogLevel":return(0,A.$Cj)(h[0])?this.a.setLogLevel(h[0]):this.a.setLogLevel(I.URI.revive(f.transformIncoming(h[0][0])),h[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(m=>this.c(m,f)))}throw new Error(`Call not found: ${w}`)}c(S,w){return{...S,resource:w.transformOutgoingURI(S.resource)}}}e.$Qr=k;class g extends j.$Tc{constructor(S,w){super(),w.call("setLogLevel",[S.getLogLevel()]),this.B(S.onDidChangeLogLevel(h=>w.call("setLogLevel",[h]))),w.call("getRegisteredLoggers").then(h=>{for(const f of h)S.registerLogger({...f,resource:I.URI.revive(f.resource)})}),this.B(w.listen("onDidChangeVisibility")(([h,f])=>S.setVisibility(I.URI.revive(h),f))),this.B(w.listen("onDidChangeLoggers")(({added:h,removed:f})=>{for(const m of h)S.registerLogger({...m,resource:I.URI.revive(m.resource)});for(const m of f)S.deregisterLogger(m.resource)}))}}e.$Rr=g}),define(le[205],he([0,1,2,8]),function(se,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PP=void 0;class A extends I.$Tc{constructor(O,R=[]){super(),this.a=new L.$Kj([O,...R]),this.B(O.onDidChangeLogLevel(k=>this.setLevel(k)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(O){this.a.setLevel(O)}getLevel(){return this.a.getLevel()}trace(O,...R){this.a.trace(O,...R)}debug(O,...R){this.a.debug(O,...R)}info(O,...R){this.a.info(O,...R)}warn(O,...R){this.a.warn(O,...R)}error(O,...R){this.a.error(O,...R)}flush(){this.a.flush()}}e.$PP=A}),define(le[57],he([0,1,4]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N_b=void 0,e.$N_b=(0,I.$gi)("nativeHostService")}),define(le[206],he([0,1,40,56]),function(se,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9ac=void 0;let A=class{constructor(O,R){return this.windowId=O,I.ProxyChannel.toService(R.getChannel("nativeHost"),{context:O,properties:(()=>{const k=new Map;return k.set("windowId",O),k})()})}};e.$9ac=A,e.$9ac=A=ye([K(1,L.$3ac)],A)}),define(le[58],he([0,1,3,61,2,4]),function(se,e,I,L,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2n=e.$1n=e.$Zn=void 0,e.$Zn=(0,j.$gi)("policy");class O extends A.$Tc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new I.$6d),this.onDidChange=this.h.event}async updatePolicyDefinitions(g){const C=Object.keys(this.f).length;return this.f={...g,...this.f},C!==Object.keys(this.f).length&&await this.j(g),L.Iterable.reduce(this.g.entries(),(S,[w,h])=>({...S,[w]:h}),{})}getPolicyValue(g){return this.g.get(g)}serialize(){return L.Iterable.reduce(Object.entries(this.f),(g,[C,S])=>({...g,[C]:{definition:S,value:this.g.get(C)}}),{})}}e.$1n=O;class R{constructor(){this.onDidChange=I.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$2n=R}),define(le[207],he([0,1,3,2,58]),function(se,e,I,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zac=e.$yac=void 0;class j{constructor(k){this.b=k,this.a=new L.$Sc}listen(k,g){switch(g){case"onDidChange":return I.Event.map(this.b.onDidChange,C=>C.reduce((S,w)=>({...S,[w]:this.b.getPolicyValue(w)??null}),{}),this.a)}throw new Error(`Event not found: ${g}`)}call(k,g,C){switch(g){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(C)}throw new Error(`Call not found: ${g}`)}dispose(){this.a.dispose()}}e.$yac=j;class O extends A.$1n{constructor(k,g){super(),this.a=g;for(const C in k){const{definition:S,value:w}=k[C];this.f[C]=S,w!==void 0&&this.g.set(C,w)}this.a.listen("onDidChange")(C=>{for(const S in C){const w=C[S];w===null?this.g.delete(S):this.g.set(S,w)}this.h.fire(Object.keys(C))})}async j(k){const g=await this.a.call("updatePolicyDefinitions",k);for(const C in g)this.g.set(C,g[C])}}e.$zac=O}),define(le[101],he([0,1,36]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let L;const A=globalThis.vscode;if(typeof A<"u"&&typeof A.context<"u"){const j=A.context.configuration();if(j)L=j.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(L=globalThis._VSCODE_PRODUCT_JSON,I.env.VSCODE_DEV&&Object.assign(L,{nameShort:`${L.nameShort} Dev`,nameLong:`${L.nameLong} Dev`,dataFolderName:`${L.dataFolderName}-dev`,serverDataFolderName:L.serverDataFolderName?`${L.serverDataFolderName}-dev`:void 0}),!L.version){const j=globalThis._VSCODE_PACKAGE_JSON;Object.assign(L,{version:j.version})}}else L={},Object.keys(L).length===0&&Object.assign(L,{version:"1.87.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=L}),define(le[24],he([0,1,4]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tj=e.$Sj=void 0,e.$Sj=(0,I.$gi)("productService"),e.$Tj="vscode://schemas/vscode-product"}),define(le[208],he([0,1,6,7,2,15,31,8,24]),function(se,e,I,L,A,j,O,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pbc=void 0;let g=class extends A.$Tc{constructor(S,w,h){super(),this.b=w,this.c=h,this.a=this.b.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,S&&this.B(new I.$sh(()=>{this.f(S)},3e4)).schedule()}async f(S){this.c.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const w=Date.now(),h=(0,j.$mc)(S),f=(0,j.$nc)(S),m=await O.Promises.readdir(h);await Promise.all(m.map(async y=>{if(y===f)return;const l=(0,j.$jc)(h,y),d=await O.Promises.stat(l);if(d.isDirectory()&&w-d.mtime.getTime()>this.a)return this.c.trace(`[code cache cleanup]: Removing code cache folder ${y}.`),O.Promises.rm(l)}))}catch(w){(0,L.$1)(w)}}};e.$pbc=g,e.$pbc=g=ye([K(1,k.$Sj),K(2,R.$Aj)],g)}),define(le[209],he([0,1,6,7,2,15,31,16,8,24]),function(se,e,I,L,A,j,O,R,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qbc=void 0;let C=class extends A.$Tc{constructor(w,h,f){super(),this.b=w,this.c=h,this.f=f,this.a=this.f.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.b.isBuilt&&this.B(new I.$sh(()=>{this.g()},4e4)).schedule()}async g(){this.c.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const w=Object.create(null),h=JSON.parse(await O.Promises.readFile((0,j.$jc)(this.b.userDataPath,"languagepacks.json"),"utf8"));for(const d of Object.keys(h)){const $=h[d];w[`${$.hash}.${d}`]=!0}const f=(0,j.$jc)(this.b.userDataPath,"clp");if(!await O.Promises.exists(f))return;const y=await O.Promises.readdir(f);for(const d of y){if(w[d]){this.c.trace(`[language pack cache cleanup]: Skipping folder ${d}. Language pack still in use.`);continue}this.c.trace(`[language pack cache cleanup]: Removing unused language pack: ${d}`),await O.Promises.rm((0,j.$jc)(f,d))}const l=Date.now();for(const d of Object.keys(w)){const $=(0,j.$jc)(f,d),c=await O.Promises.readdir($);for(const v of c){if(v==="tcf.json")continue;const i=(0,j.$jc)($,v),o=await O.Promises.stat(i);o.isDirectory()&&l-o.mtime.getTime()>this.a&&(this.c.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,j.$jc)(d,v)}`),await O.Promises.rm(i))}}}catch(w){(0,L.$1)(w)}}};e.$qbc=C,e.$qbc=C=ye([K(0,R.$oi),K(1,k.$Aj),K(2,g.$Sj)],C)}),define(le[210],he([0,1,15,4]),function(se,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.$GF=void 0,e.$GF=(0,L.$gi)("IV8InspectProfilingService");var A;(function(j){function O(k){return!!(k.samples&&k.timeDeltas)}j.isValidProfile=O;function R(k,g="noAbsolutePaths"){for(const C of k.nodes)C.callFrame&&C.callFrame.url&&((0,I.$ic)(C.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(C.callFrame.url))&&(C.callFrame.url=(0,I.$jc)(g,(0,I.$nc)(C.callFrame.url)));return k}j.rewriteAbsolutePaths=R})(A||(e.Utils=A={}))}),define(le[211],he([0,1,32]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hbc=void 0;class L{constructor(){this.a=new Map}async startProfiling(j){const R=await(await new Promise((g,C)=>{se(["v8-inspect-profiler"],g,C)})).startProfiling({port:j.port,checkForPaused:!0}),k=(0,I.$Cg)();return this.a.set(k,R),k}async stopProfiling(j){const O=this.a.get(j);if(!O)throw new Error(`UNKNOWN session '${j}'`);const R=await O.stop();return this.a.delete(j),R.profile}}e.$Hbc=L}),define(le[41],he([0,1,127,12]),function(se,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xn=void 0;class A{constructor(){this.a=new Map}add(O,R){I.ok(L.$Tf(O)),I.ok(L.$Vf(R)),I.ok(!this.a.has(O),"There is already an extension with this id"),this.a.set(O,R)}knows(O){return this.a.has(O)}as(O){return this.a.get(O)||null}}e.$Xn=new A}),define(le[102],he([0,1,3,41]),function(se,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yn=void 0,e.$Yn={JSONContribution:"base.contributions.json"};function A(R){return R.length>0&&R.charAt(R.length-1)==="#"?R.substring(0,R.length-1):R}class j{constructor(){this.b=new I.$6d,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(k,g){this.a[A(k)]=g,this.b.fire(k)}notifySchemaChanged(k){this.b.fire(k)}getSchemaContributions(){return{schemas:this.a}}}const O=new j;L.$Xn.add(e.$Yn.JSONContribution,O)}),define(le[44],he([0,1,17,3,12,151,21,102,41]),function(se,e,I,L,A,j,O,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fo=e.$eo=e.$do=e.$co=e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.ConfigurationScope=e.$3n=e.EditPresentationTypes=void 0;var g;(function(v){v.Multiline="multilineText",v.Singleline="singlelineText"})(g||(e.EditPresentationTypes=g={})),e.$3n={Configuration:"base.contributions.configuration"};var C;(function(v){v[v.APPLICATION=1]="APPLICATION",v[v.MACHINE=2]="MACHINE",v[v.WINDOW=3]="WINDOW",v[v.RESOURCE=4]="RESOURCE",v[v.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",v[v.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(C||(e.ConfigurationScope=C={})),e.$4n={properties:{},patternProperties:{}},e.$5n={properties:{},patternProperties:{}},e.$6n={properties:{},patternProperties:{}},e.$7n={properties:{},patternProperties:{}},e.$8n={properties:{},patternProperties:{}},e.$9n={properties:{},patternProperties:{}},e.$0n="vscode://schemas/settings/resourceLanguage",e.$$n="vscode://schemas/settings/configurationDefaults";const S=k.$Xn.as(R.$Yn.JSONContribution);class w{constructor(){this.h=new Set,this.i=new L.$6d,this.onDidSchemaChange=this.i.event,this.j=new L.$6d,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:j.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},S.registerSchema(e.$0n,this.g),this.v()}registerConfiguration(i,o=!0){this.registerConfigurations([i],o)}registerConfigurations(i,o=!0){const n=new Set;this.n(i,o,n),S.registerSchema(e.$0n,this.g),this.i.fire(),this.j.fire({properties:n})}deregisterConfigurations(i){const o=new Set;this.o(i,o),S.registerSchema(e.$0n,this.g),this.i.fire(),this.j.fire({properties:o})}updateConfigurations({add:i,remove:o}){const n=new Set;this.o(o,n),this.n(i,!1,n),S.registerSchema(e.$0n,this.g),this.i.fire(),this.j.fire({properties:n})}registerDefaultConfigurations(i){const o=new Set;this.k(i,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}k(i,o){const n=[];for(const{overrides:s,source:t}of i)for(const r in s)if(o.add(r),e.$ao.test(r)){const a=this.a.get(r),E=a?.valuesSources??new Map;if(t)for(const P of Object.keys(s[r]))E.set(P,t);const b={...a?.value||{},...s[r]};this.a.set(r,{source:t,value:b,valuesSources:E});const u=(0,O.$Wi)(r),p={type:"object",default:b,description:j.localize(1,null,u),$ref:e.$0n,defaultDefaultValue:b,source:A.$Tf(t)?void 0:t,defaultValueSource:t};n.push(...m(r)),this.d[r]=p,this.b.properties[r]=p}else{this.a.set(r,{value:s[r],source:t});const a=this.d[r];a&&(this.w(r,a),this.r(r,a))}this.m(n)}deregisterDefaultConfigurations(i){const o=new Set;this.l(i,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}l(i,o){for(const{overrides:n,source:s}of i)for(const t in n){const r=this.a.get(t),a=A.$Tf(s)?s:s?.id,E=A.$Tf(r?.source)?r?.source:r?.source?.id;if(a===E)if(o.add(t),this.a.delete(t),e.$ao.test(t))delete this.d[t],delete this.b.properties[t];else{const b=this.d[t];b&&(this.w(t,b),this.r(t,b))}}this.u()}deltaConfiguration(i){let o=!1;const n=new Set;i.removedDefaults&&(this.l(i.removedDefaults,n),o=!0),i.addedDefaults&&(this.k(i.addedDefaults,n),o=!0),i.removedConfigurations&&this.o(i.removedConfigurations,n),i.addedConfigurations&&this.n(i.addedConfigurations,!1,n),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:o})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){this.m(i),this.i.fire()}m(i){for(const o of i)this.h.add(o);this.u()}n(i,o,n){i.forEach(s=>{this.p(s,o,s.extensionInfo,s.restrictedProperties,void 0,n),this.c.push(s),this.q(s)})}o(i,o){const n=s=>{if(s.properties)for(const t in s.properties){o.add(t);const r=this.d[t];r?.policy?.name&&this.e.delete(r.policy.name),delete this.d[t],this.s(t,s.properties[t])}s.allOf?.forEach(t=>n(t))};for(const s of i){n(s);const t=this.c.indexOf(s);t!==-1&&this.c.splice(t,1)}}p(i,o=!0,n,s,t=3,r){t=A.$3f(i.scope)?t:i.scope;const a=i.properties;if(a)for(const b in a){const u=a[b];if(o&&$(b,u)){delete a[b];continue}if(u.source=n,u.defaultDefaultValue=a[b].default,this.w(b,u),e.$ao.test(b)?u.scope=void 0:(u.scope=A.$3f(u.scope)?t:u.scope,u.restricted=A.$3f(u.restricted)?!!s?.includes(b):u.restricted),a[b].hasOwnProperty("included")&&!a[b].included){this.f[b]=a[b],delete a[b];continue}else this.d[b]=a[b],a[b].policy?.name&&this.e.set(a[b].policy.name,b);!a[b].deprecationMessage&&a[b].markdownDeprecationMessage&&(a[b].deprecationMessage=a[b].markdownDeprecationMessage),r.add(b)}const E=i.allOf;if(E)for(const b of E)this.p(b,o,n,s,t,r)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(i){const o=n=>{const s=n.properties;if(s)for(const r in s)this.r(r,s[r]);n.allOf?.forEach(o)};o(i)}r(i,o){switch(e.$4n.properties[i]=o,o.scope){case 1:e.$5n.properties[i]=o;break;case 2:e.$6n.properties[i]=o;break;case 6:e.$7n.properties[i]=o;break;case 3:e.$8n.properties[i]=o;break;case 4:e.$9n.properties[i]=o;break;case 5:e.$9n.properties[i]=o,this.g.properties[i]=o;break}}s(i,o){switch(delete e.$4n.properties[i],o.scope){case 1:delete e.$5n.properties[i];break;case 2:delete e.$6n.properties[i];break;case 6:delete e.$7n.properties[i];break;case 3:delete e.$8n.properties[i];break;case 4:case 5:delete e.$9n.properties[i],delete this.g.properties[i];break}}u(){for(const i of this.h.values()){const o=`[${i}]`,n={type:"object",description:j.localize(2,null),errorMessage:j.localize(3,null),$ref:e.$0n};this.w(o,n),e.$4n.properties[o]=n,e.$5n.properties[o]=n,e.$6n.properties[o]=n,e.$7n.properties[o]=n,e.$8n.properties[o]=n,e.$9n.properties[o]=n}}v(){const i={type:"object",description:j.localize(4,null),errorMessage:j.localize(5,null),$ref:e.$0n};e.$4n.patternProperties[e.$_n]=i,e.$5n.patternProperties[e.$_n]=i,e.$6n.patternProperties[e.$_n]=i,e.$7n.patternProperties[e.$_n]=i,e.$8n.patternProperties[e.$_n]=i,e.$9n.patternProperties[e.$_n]=i,this.i.fire()}w(i,o){const n=this.a.get(i);let s=n?.value,t=n?.source;A.$1f(s)&&(s=o.defaultDefaultValue,t=void 0),A.$1f(s)&&(s=l(o.type)),o.default=s,o.defaultValueSource=t}}const h="\\[([^\\]]+)\\]",f=new RegExp(h,"g");e.$_n=`^(${h})+$`,e.$ao=new RegExp(e.$_n);function m(v){const i=[];if(e.$ao.test(v)){let o=f.exec(v);for(;o?.length;){const n=o[1].trim();n&&i.push(n),o=f.exec(v)}}return(0,I.$Mb)(i)}e.$bo=m;function y(v){return v.reduce((i,o)=>`${i}[${o}]`,"")}e.$co=y;function l(v){switch(Array.isArray(v)?v[0]:v){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$do=l;const d=new w;k.$Xn.add(e.$3n.Configuration,d);function $(v,i){return v.trim()?e.$ao.test(v)?j.localize(7,null,v):d.getConfigurationProperties()[v]!==void 0?j.localize(8,null,v):i.policy?.name&&d.getPolicyConfigurations().get(i.policy?.name)!==void 0?j.localize(9,null,v,i.policy?.name,d.getPolicyConfigurations().get(i.policy?.name)):null:j.localize(6,null)}e.$eo=$;function c(){const v=[],i=d.getConfigurationProperties();for(const o of Object.keys(i))v.push([o,i[o].scope]);return v.push(["launch",4]),v.push(["task",4]),v}e.$fo=c}),define(le[76],he([0,1,17,3,34,2,35,30,12,10,21,44,41]),function(se,e,I,L,A,j,O,R,k,g,C,S,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=void 0;function h(o){return Object.isFrozen(o)?o:R.$Mn(o)}class f{constructor(n={},s=[],t=[],r){this.b=n,this.c=s,this.d=t,this.raw=r,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const n=this.raw.map(s=>{if(s instanceof f)return s;const t=new m("");return t.parseRaw(s),t.configurationModel});this.f=n.reduce((s,t)=>t===s?t:s.merge(t),n[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(n){return n?(0,C.$Ui)(this.contents,n):this.contents}inspect(n,s){const t=this;return{get value(){return h(t.rawConfiguration.getValue(n))},get override(){return s?h(t.rawConfiguration.getOverrideValue(n,s)):void 0},get merged(){return h(s?t.rawConfiguration.override(s).getValue(n):t.rawConfiguration.getValue(n))},get overrides(){const r=[];for(const{contents:a,identifiers:E,keys:b}of t.rawConfiguration.overrides){const u=new f(a,b).getValue(n);u!==void 0&&r.push({identifiers:E,value:u})}return r.length?h(r):void 0}}}getOverrideValue(n,s){const t=this.i(s);return t?n?(0,C.$Ui)(t,n):t:void 0}getKeysForOverrideIdentifier(n){const s=[];for(const t of this.overrides)t.identifiers.includes(n)&&s.push(...t.keys);return I.$Mb(s)}getAllOverrideIdentifiers(){const n=[];for(const s of this.overrides)n.push(...s.identifiers);return I.$Mb(n)}override(n){let s=this.a.get(n);return s||(s=this.g(n),this.a.set(n,s)),s}merge(...n){const s=R.$Ln(this.contents),t=R.$Ln(this.overrides),r=[...this.keys],a=this.raw?.length?[...this.raw]:[this];for(const E of n)if(a.push(...E.raw?.length?E.raw:[E]),!E.isEmpty()){this.h(s,E.contents);for(const b of E.overrides){const[u]=t.filter(p=>I.$ub(p.identifiers,b.identifiers));u?(this.h(u.contents,b.contents),u.keys.push(...b.keys),u.keys=I.$Mb(u.keys)):t.push(R.$Ln(b))}for(const b of E.keys)r.indexOf(b)===-1&&r.push(b)}return new f(s,r,t,a.every(E=>E instanceof f)?void 0:a)}g(n){const s=this.i(n);if(!s||typeof s!="object"||!Object.keys(s).length)return this;const t={};for(const r of I.$Mb([...Object.keys(this.contents),...Object.keys(s)])){let a=this.contents[r];const E=s[r];E&&(typeof a=="object"&&typeof E=="object"?(a=R.$Ln(a),this.h(a,E)):a=E),t[r]=a}return new f(t,this.keys,this.overrides)}h(n,s){for(const t of Object.keys(s)){if(t in n&&k.$Vf(n[t])&&k.$Vf(s[t])){this.h(n[t],s[t]);continue}n[t]=R.$Ln(s[t])}}i(n){let s=null,t=null;const r=a=>{a&&(t?this.h(t,a):t=R.$Ln(a))};for(const a of this.overrides)a.identifiers.length===1&&a.identifiers[0]===n?s=a.contents:a.identifiers.includes(n)&&r(a.contents);return r(s),t}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(n,s){this.j(n,s,!0)}setValue(n,s){this.j(n,s,!1)}removeValue(n){const s=this.keys.indexOf(n);s!==-1&&(this.keys.splice(s,1),(0,C.$Ti)(this.contents,n),S.$ao.test(n)&&this.overrides.splice(this.overrides.findIndex(t=>I.$ub(t.identifiers,(0,S.$bo)(n))),1))}j(n,s,t){(0,C.$Si)(this.contents,n,s,r=>console.error(r)),t=t||this.keys.indexOf(n)===-1,t&&this.keys.push(n),S.$ao.test(n)&&this.overrides.push({identifiers:(0,S.$bo)(n),keys:Object.keys(this.contents[n]),contents:(0,C.$Ri)(this.contents[n],r=>console.error(r))})}}e.$go=f;class m{constructor(n){this.f=n,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new f}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(n,s){if(!k.$3f(n)){const t=this.g(n);this.parseRaw(t,s)}}reparse(n){this.a&&this.parseRaw(this.a,n)}parseRaw(n,s){this.a=n;const{contents:t,keys:r,overrides:a,restricted:E,hasExcludedProperties:b}=this.h(n,s);this.b=new f(t,r,a,b?[n]:void 0),this.c=E||[]}g(n){let s={},t=null,r=[];const a=[],E=[];function b(p){Array.isArray(r)?r.push(p):t!==null&&(r[t]=p)}const u={onObjectBegin:()=>{const p={};b(p),a.push(r),r=p,t=null},onObjectProperty:p=>{t=p},onObjectEnd:()=>{r=a.pop()},onArrayBegin:()=>{const p=[];b(p),a.push(r),r=p,t=null},onArrayEnd:()=>{r=a.pop()},onLiteralValue:b,onError:(p,P,N)=>{E.push({error:p,offset:P,length:N})}};if(n)try{A.$zn(n,u),s=r[0]||{}}catch(p){console.error(`Error while parsing settings file ${this.f}: ${p}`),this.d=[p]}return s}h(n,s){const t=w.$Xn.as(S.$3n.Configuration).getConfigurationProperties(),r=this.i(n,t,!0,s);n=r.raw;const a=(0,C.$Ri)(n,u=>console.error(`Conflict in settings file ${this.f}: ${u}`)),E=Object.keys(n),b=this.j(n,u=>console.error(`Conflict in settings file ${this.f}: ${u}`));return{contents:a,keys:E,overrides:b,restricted:r.restricted,hasExcludedProperties:r.hasExcludedProperties}}i(n,s,t,r){let a=!1;if(!r?.scopes&&!r?.skipRestricted&&!r?.exclude?.length)return{raw:n,restricted:[],hasExcludedProperties:a};const E={},b=[];for(const u in n)if(S.$ao.test(u)&&t){const p=this.i(n[u],s,!1,r);E[u]=p.raw,a=a||p.hasExcludedProperties,b.push(...p.restricted)}else{const p=s[u],P=p?typeof p.scope<"u"?p.scope:3:void 0;p?.restricted&&b.push(u),!r.exclude?.includes(u)&&(r.include?.includes(u)||(P===void 0||r.scopes===void 0||r.scopes.includes(P))&&!(r.skipRestricted&&p?.restricted))?E[u]=n[u]:a=!0}return{raw:E,restricted:b,hasExcludedProperties:a}}j(n,s){const t=[];for(const r of Object.keys(n))if(S.$ao.test(r)){const a={};for(const E in n[r])a[E]=n[r][E];t.push({identifiers:(0,S.$bo)(r),keys:Object.keys(a),contents:(0,C.$Ri)(a,s)})}return t}}e.$ho=m;class y extends j.$Tc{constructor(n,s,t,r){super(),this.c=n,this.f=s,this.g=r,this.b=this.B(new L.$6d),this.onDidChange=this.b.event,this.a=new m(this.c.toString()),this.B(this.g.watch(t.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(L.Event.any(L.Event.filter(this.g.onDidFilesChange,a=>a.contains(this.c)),L.Event.filter(this.g.onDidRunOperation,a=>(a.isOperation(0)||a.isOperation(3)||a.isOperation(1)||a.isOperation(4))&&t.isEqual(a.resource,n)))(()=>this.b.fire()))}async loadConfiguration(){try{const n=await this.g.readFile(this.c);return this.a.parse(n.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new f}}reparse(n){return n&&(this.f=n),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$io=y;class l{constructor(n,s,t,r,a,E,b,u,p,P,N,F,M){this.a=n,this.b=s,this.c=t,this.overrideIdentifiers=r,this.d=a,this.f=E,this.g=b,this.h=u,this.i=p,this.j=P,this.k=N,this.l=F,this.m=M}get value(){return h(this.c)}n(n){return n?.value!==void 0||n?.override!==void 0||n?.overrides!==void 0?n:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class d{constructor(n,s,t,r,a=new f,E=new f,b=new O.$Ac,u=new f,p=new O.$Ac){this.c=n,this.d=s,this.f=t,this.g=r,this.h=a,this.i=E,this.j=b,this.l=u,this.m=p,this.a=null,this.b=new O.$Ac,this.n=null}getValue(n,s,t){return this.p(n,s,t).getValue(n)}updateValue(n,s,t={}){let r;t.resource?(r=this.m.get(t.resource),r||(r=new f,this.m.set(t.resource,r))):r=this.l,s===void 0?r.removeValue(n):r.setValue(n,s),t.resource||(this.a=null)}inspect(n,s,t){const r=this.p(n,s,t),a=this.t(s.resource,t),E=s.resource?this.m.get(s.resource)||this.l:this.l,b=new Set;for(const u of r.overrides)for(const p of u.identifiers)r.getOverrideValue(n,p)!==void 0&&b.add(p);return new l(n,s,r.getValue(n),b.size?[...b]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,t?this.i:void 0,a||void 0,E)}keys(n){const s=this.t(void 0,n);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:s?s.keys.slice(0):[]}}updateDefaultConfiguration(n){this.c=n,this.a=null,this.b.clear()}updatePolicyConfiguration(n){this.d=n}updateApplicationConfiguration(n){this.f=n,this.a=null,this.b.clear()}updateLocalUserConfiguration(n){this.g=n,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(n){this.h=n,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(n){this.i=n,this.a=null,this.b.clear()}updateFolderConfiguration(n,s){this.j.set(n,s),this.b.delete(n)}deleteFolderConfiguration(n){this.folderConfigurations.delete(n),this.b.delete(n)}compareAndUpdateDefaultConfiguration(n,s){const t=[];if(!s){const{added:r,updated:a,removed:E}=v(this.c,n);s=[...r,...a,...E]}for(const r of s)for(const a of(0,S.$bo)(r)){const E=this.c.getKeysForOverrideIdentifier(a),b=n.getKeysForOverrideIdentifier(a),u=[...b.filter(p=>E.indexOf(p)===-1),...E.filter(p=>b.indexOf(p)===-1),...E.filter(p=>!R.$Pn(this.c.override(a).getValue(p),n.override(a).getValue(p)))];t.push([a,u])}return this.updateDefaultConfiguration(n),{keys:s,overrides:t}}compareAndUpdatePolicyConfiguration(n){const{added:s,updated:t,removed:r}=v(this.d,n),a=[...s,...t,...r];return a.length&&this.updatePolicyConfiguration(n),{keys:a,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:s,updated:t,removed:r,overrides:a}=v(this.applicationConfiguration,n),E=[...s,...t,...r];return E.length&&this.updateApplicationConfiguration(n),{keys:E,overrides:a}}compareAndUpdateLocalUserConfiguration(n){const{added:s,updated:t,removed:r,overrides:a}=v(this.localUserConfiguration,n),E=[...s,...t,...r];return E.length&&this.updateLocalUserConfiguration(n),{keys:E,overrides:a}}compareAndUpdateRemoteUserConfiguration(n){const{added:s,updated:t,removed:r,overrides:a}=v(this.remoteUserConfiguration,n),E=[...s,...t,...r];return E.length&&this.updateRemoteUserConfiguration(n),{keys:E,overrides:a}}compareAndUpdateWorkspaceConfiguration(n){const{added:s,updated:t,removed:r,overrides:a}=v(this.workspaceConfiguration,n),E=[...s,...t,...r];return E.length&&this.updateWorkspaceConfiguration(n),{keys:E,overrides:a}}compareAndUpdateFolderConfiguration(n,s){const t=this.folderConfigurations.get(n),{added:r,updated:a,removed:E,overrides:b}=v(t,s),u=[...r,...a,...E];return(u.length||!t)&&this.updateFolderConfiguration(n,s),{keys:u,overrides:b}}compareAndDeleteFolderConfiguration(n){const s=this.folderConfigurations.get(n);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:t,updated:r,removed:a,overrides:E}=v(s,void 0);return{keys:[...t,...r,...a],overrides:E}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(n,s,t){let r=this.q(s,t);return s.overrideIdentifier&&(r=r.override(s.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(n)!==void 0&&(r=r.merge(this.d)),r}q({resource:n},s){let t=this.r();if(s&&n){const r=s.getFolder(n);r&&(t=this.s(r.uri)||t);const a=this.m.get(n);a&&(t=t.merge(a))}return t}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(n){let s=this.b.get(n);if(!s){const t=this.r(),r=this.j.get(n);r?(s=t.merge(r),this.b.set(n,s)):s=t}return s}t(n,s){if(s&&n){const t=s.getFolder(n);if(t)return this.j.get(t.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((n,s)=>{const{contents:t,overrides:r,keys:a}=this.j.get(s);return n.push([s,{contents:t,overrides:r,keys:a}]),n},[])}}allKeys(){const n=new Set;return this.c.keys.forEach(s=>n.add(s)),this.userConfiguration.keys.forEach(s=>n.add(s)),this.i.keys.forEach(s=>n.add(s)),this.j.forEach(s=>s.keys.forEach(t=>n.add(t))),[...n.values()]}u(){const n=new Set;return this.c.getAllOverrideIdentifiers().forEach(s=>n.add(s)),this.userConfiguration.getAllOverrideIdentifiers().forEach(s=>n.add(s)),this.i.getAllOverrideIdentifiers().forEach(s=>n.add(s)),this.j.forEach(s=>s.getAllOverrideIdentifiers().forEach(t=>n.add(t))),[...n.values()]}v(n){const s=new Set;return this.c.getKeysForOverrideIdentifier(n).forEach(t=>s.add(t)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(t=>s.add(t)),this.i.getKeysForOverrideIdentifier(n).forEach(t=>s.add(t)),this.j.forEach(t=>t.getKeysForOverrideIdentifier(n).forEach(r=>s.add(r))),[...s.values()]}static parse(n){const s=this.w(n.defaults),t=this.w(n.policy),r=this.w(n.application),a=this.w(n.user),E=this.w(n.workspace),b=n.folders.reduce((u,p)=>(u.set(g.URI.revive(p[0]),this.w(p[1])),u),new O.$Ac);return new d(s,t,r,a,new f,E,b,new f,new O.$Ac)}static w(n){return new f(n.contents,n.keys,n.overrides)}}e.$jo=d;function $(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const n=new Set,s=new Map;for(const r of o)r.keys.forEach(a=>n.add(a)),r.overrides.forEach(([a,E])=>{const b=(0,O.$xc)(s,a,new Set);E.forEach(u=>b.add(u))});const t=[];return s.forEach((r,a)=>t.push([a,[...r.values()]])),{keys:[...n.values()],overrides:t}}e.$ko=$;class c{constructor(n,s,t,r){this.change=n,this.f=s,this.g=t,this.h=r,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.i=void 0;for(const a of n.keys)this.affectedKeys.add(a);for(const[,a]of n.overrides)for(const E of a)this.affectedKeys.add(E);this.d=this.a;for(const a of this.affectedKeys)this.d+=a+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=d.parse(this.f.data)),this.i}affectsConfiguration(n,s){const t=this.a+n,r=this.d.indexOf(t);if(r<0)return!1;const a=r+t.length;if(a>=this.d.length)return!1;const E=this.d.charCodeAt(a);if(E!==this.b&&E!==this.c)return!1;if(s){const b=this.previousConfiguration?this.previousConfiguration.getValue(n,s,this.f?.workspace):void 0,u=this.g.getValue(n,s,this.h);return!R.$Pn(b,u)}return!0}}e.$lo=c;function v(o,n){const{added:s,removed:t,updated:r}=i(n?.rawConfiguration,o?.rawConfiguration),a=[],E=o?.getAllOverrideIdentifiers()||[],b=n?.getAllOverrideIdentifiers()||[];if(n){const u=b.filter(p=>!E.includes(p));for(const p of u)a.push([p,n.getKeysForOverrideIdentifier(p)])}if(o){const u=E.filter(p=>!b.includes(p));for(const p of u)a.push([p,o.getKeysForOverrideIdentifier(p)])}if(n&&o){for(const u of E)if(b.includes(u)){const p=i({contents:o.getOverrideValue(void 0,u)||{},keys:o.getKeysForOverrideIdentifier(u)},{contents:n.getOverrideValue(void 0,u)||{},keys:n.getKeysForOverrideIdentifier(u)});a.push([u,[...p.added,...p.removed,...p.updated]])}}return{added:s,removed:t,updated:r,overrides:a}}function i(o,n){const s=o?n?o.keys.filter(a=>n.keys.indexOf(a)===-1):[...o.keys]:[],t=n?o?n.keys.filter(a=>o.keys.indexOf(a)===-1):[...n.keys]:[],r=[];if(o&&n){for(const a of n.keys)if(o.keys.indexOf(a)!==-1){const E=(0,C.$Ui)(n.contents,a),b=(0,C.$Ui)(o.contents,a);R.$Pn(E,b)||r.push(a)}}return{added:s,removed:t,updated:r}}}),define(le[212],he([0,1,17,3,2,30,12,76,44,8,58,41]),function(se,e,I,L,A,j,O,R,k,g,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oo=e.$no=e.$mo=void 0;class w extends A.$Tc{constructor(){super(...arguments),this.a=this.B(new L.$6d),this.onDidChangeConfiguration=this.a.event,this.b=new R.$go}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(S.$Xn.as(k.$3n.Configuration).onDidUpdateConfiguration(({properties:y,defaultsOverrides:l})=>this.c(Array.from(y),l))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(y,l){this.h(y,S.$Xn.as(k.$3n.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:y})}f(){return{}}g(){this.b=new R.$go;const y=S.$Xn.as(k.$3n.Configuration).getConfigurationProperties();this.h(Object.keys(y),y)}h(y,l){const d=this.f();for(const $ of y){const c=d[$],v=l[$];c!==void 0?this.b.addValue($,c):v?this.b.addValue($,v.default):this.b.removeValue($)}}}e.$mo=w;class h{constructor(){this.onDidChangeConfiguration=L.Event.None,this.configurationModel=new R.$go}async initialize(){return this.configurationModel}}e.$no=h;let f=class extends A.$Tc{get configurationModel(){return this.b}constructor(y,l,d){super(),this.c=y,this.f=l,this.g=d,this.a=this.B(new L.$6d),this.onDidChangeConfiguration=this.a.event,this.b=new R.$go}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(y=>this.j(y))),this.B(this.c.onDidChangeConfiguration(async({properties:y})=>this.m(await this.h(y),!0))),this.b}async h(y){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",y);const l={},d=[],$=S.$Xn.as(k.$3n.Configuration).getConfigurationProperties();for(const c of y){const v=$[c];if(!v){d.push(c);continue}if(v.policy){if(v.type!=="string"&&v.type!=="number"){this.g.warn(`Policy ${v.policy.name} has unsupported type ${v.type}`);continue}d.push(c),l[v.policy.name]={type:v.type}}}return(0,O.$7f)(l)||await this.f.updatePolicyDefinitions(l),d}j(y){this.g.trace("PolicyConfiguration#onDidChangePolicies",y);const l=S.$Xn.as(k.$3n.Configuration).getPolicyConfigurations(),d=(0,I.$Hb)(y.map($=>l.get($)));this.m(d,!0)}m(y,l){this.g.trace("PolicyConfiguration#update",y);const d=S.$Xn.as(k.$3n.Configuration).getConfigurationProperties(),$=[],c=this.b.isEmpty();for(const v of y){const i=d[v]?.policy?.name;if(i){const o=this.f.getPolicyValue(i);(c?o!==void 0:!(0,j.$Pn)(this.b.getValue(v),o))&&$.push([v,o])}else this.b.getValue(v)!==void 0&&$.push([v,void 0])}if($.length){this.g.trace("PolicyConfiguration#changed",$);const v=this.b;this.b=new R.$go;for(const i of v.keys)this.b.setValue(i,v.getValue(i));for(const[i,o]of $)o===void 0?this.b.removeValue(i):this.b.setValue(i,o);l&&this.a.fire(this.b)}}};e.$oo=f,e.$oo=f=ye([K(1,C.$Zn),K(2,g.$Aj)],f)}),define(le[213],he([0,1,17,6,14,3,34,62,2,30,5,20,21,76,44,212,58]),function(se,e,I,L,A,j,O,R,k,g,C,S,w,h,f,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$po=void 0;class l extends k.$Tc{constructor(c,v,i,o){super(),this.m=c,this.h=this.B(new j.$6d),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new m.$mo),this.c=i instanceof y.$2n?new m.$no:this.B(new m.$oo(this.b,i,o)),this.f=this.B(new h.$io(this.m,{},S.$Kg,v)),this.a=new h.$jo(this.b.configurationModel,this.c.configurationModel,new h.$go,new h.$go),this.j=new d(c,v,this),this.g=this.B(new L.$sh(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:n,properties:s})=>this.r(n,s))),this.B(this.c.onDidChangeConfiguration(n=>this.s(n))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[c,v,i]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new h.$jo(c,v,new h.$go,i)}getConfigurationData(){return this.a.toData()}getValue(c,v){const i=typeof c=="string"?c:void 0,o=(0,w.$Ni)(c)?c:(0,w.$Ni)(v)?v:{};return this.a.getValue(i,o,void 0)}async updateValue(c,v,i,o,n){const s=(0,w.$Oi)(i)?i:(0,w.$Ni)(i)?{resource:i.resource,overrideIdentifiers:i.overrideIdentifier?[i.overrideIdentifier]:void 0}:void 0,t=s?o:i;if(t!==void 0&&t!==3&&t!==2)throw new Error(`Unable to write ${c} to target ${t}.`);s?.overrideIdentifiers&&(s.overrideIdentifiers=(0,I.$Mb)(s.overrideIdentifiers),s.overrideIdentifiers=s.overrideIdentifiers.length?s.overrideIdentifiers:void 0);const r=this.inspect(c,{resource:s?.resource,overrideIdentifier:s?.overrideIdentifiers?s.overrideIdentifiers[0]:void 0});if(r.policyValue!==void 0)throw new Error(`Unable to write ${c} because it is configured in system policy.`);if((0,g.$Pn)(v,r.defaultValue)&&(v=void 0),s?.overrideIdentifiers?.length&&s.overrideIdentifiers.length>1){const E=s.overrideIdentifiers.sort(),b=this.a.localUserConfiguration.overrides.find(u=>(0,I.$ub)([...u.identifiers].sort(),E));b&&(s.overrideIdentifiers=b.identifiers)}const a=s?.overrideIdentifiers?.length?[(0,f.$co)(s.overrideIdentifiers),c]:[c];await this.j.write(a,v),await this.reloadConfiguration()}inspect(c,v={}){return this.a.inspect(c,v,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const c=await this.f.loadConfiguration();this.n(c)}n(c){const v=this.a.toData(),i=this.a.compareAndUpdateLocalUserConfiguration(c);this.t(i,v,2)}r(c,v){const i=this.a.toData(),o=this.a.compareAndUpdateDefaultConfiguration(c,v);this.t(o,i,7)}s(c){const v=this.a.toData(),i=this.a.compareAndUpdatePolicyConfiguration(c);this.t(i,v,7)}t(c,v,i){const o=new h.$lo(c,{data:v},this.a);o.source=i,this.h.fire(o)}}e.$po=l;class d{constructor(c,v,i){this.b=c,this.c=v,this.d=i,this.a=new L.$nh}write(c,v){return this.a.queue(()=>this.e(c,v))}async e(c,v){let i;try{i=(await this.c.readFile(this.b)).value.toString()}catch(s){if(s.fileOperationResult===1)i="{}";else throw s}const o=[];if((0,O.$sn)(i,o,{allowTrailingComma:!0,allowEmptyContent:!0}),o.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const n=this.f(i,c,v);i=(0,R.$Kn)(i,n),await this.c.writeFile(this.b,A.$te.fromString(i))}f(c,v,i){const{tabSize:o,insertSpaces:n,eol:s}=this.h;if(!v.length){const t=JSON.stringify(i,null,n?" ".repeat(o):"	");return[{content:t,length:t.length,offset:0}]}return(0,R.$Hn)(c,v,i,{tabSize:o,insertSpaces:n,eol:s})}get h(){if(!this.g){let c=C.OS===3||C.OS===2?`
`:`\r
`;const v=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});v&&typeof v=="string"&&v!=="auto"&&(c=v),this.g={eol:c,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(le[214],he([0,1,14,3,2,68]),function(se,e,I,L,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Btb=e.$Atb=e.$ztb=e.$ytb=void 0;const O=(g,C,S)=>{const w=new Uint8Array(16);for(let m=0;m<16;m++)w[m]=Math.round(Math.random()*256);const h=(0,I.$Ne)(I.$te.wrap(w));return[`GET ws://localhost${g}?${C}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${h}`].join(`\r
`)+`\r
\r
`};e.$ytb=O,e.$ztb=I.$te.fromString(`\r
\r
`);async function R(g,C,S,w,h){g.write(I.$te.fromString((0,e.$ytb)(C,S,w)));const f=new A.$Sc;try{return await new Promise((m,y)=>{let l;f.add(g.onData(d=>{l?l=I.$te.concat([l,d],l.byteLength+d.byteLength):l=d;const $=l.indexOf(e.$ztb);if($===-1)return;m(g),g.pauseData();const c=l.slice($+e.$ztb.byteLength);c.byteLength&&h.onData.fire(c)})),f.add(g.onClose(d=>y(d??new Error("socket closed")))),f.add(g.onEnd(()=>y(new Error("socket ended"))))})}catch(m){throw g.dispose(),m}finally{f.dispose()}}e.$Atb=R;class k extends A.$Tc{constructor(C,S){super(),this.g=C,this.a=this.B(new L.$9d),this.onData=(...w)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...w)),this.b=this.B(new L.$6d),this.onDidDispose=this.b.event,this.f=!1,this.B(S.onData),this.B(S.onData.event(w=>this.a.fire(w))),this.onClose=this.B(S.onClose).event,this.onEnd=this.B(S.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(C,S){j.SocketDiagnostics.traceSocketEvent(this,this.g,C,S)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$Btb=k}),define(le[215],he([0,1,7,4]),function(se,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pl=e.$ol=e.RemoteAuthorityResolverErrorCode=e.$nl=e.$ml=e.RemoteConnectionType=e.$ll=void 0,e.$ll=(0,L.$gi)("remoteAuthorityResolverService");var A;(function(C){C[C.WebSocket=0]="WebSocket",C[C.Managed=1]="Managed"})(A||(e.RemoteConnectionType=A={}));class j{constructor(S){this.id=S,this.type=1}toString(){return`Managed(${this.id})`}}e.$ml=j;class O{constructor(S,w){this.host=S,this.port=w,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$nl=O;var R;(function(C){C.Unknown="Unknown",C.NotAvailable="NotAvailable",C.TemporarilyNotAvailable="TemporarilyNotAvailable",C.NoResolverFound="NoResolverFound",C.InvalidAuthority="InvalidAuthority"})(R||(e.RemoteAuthorityResolverErrorCode=R={}));class k extends I.$bb{static isNotAvailable(S){return S instanceof k&&S._code===R.NotAvailable}static isTemporarilyNotAvailable(S){return S instanceof k&&S._code===R.TemporarilyNotAvailable}static isNoResolverFound(S){return S instanceof k&&S._code===R.NoResolverFound}static isInvalidAuthority(S){return S instanceof k&&S._code===R.InvalidAuthority}static isHandled(S){return S instanceof k&&S.isHandled}constructor(S,w=R.Unknown,h){super(S),this._message=S,this._code=w,this._detail=h,this.isHandled=w===R.NotAvailable&&h===!0,Object.setPrototypeOf(this,k.prototype)}}e.$ol=k;function g(C){const S=C.indexOf("+");return S===-1?C:C.substring(0,S)}e.$pl=g}),define(le[216],he([0,1,6,14,26,7,3,2,23,99,63,32,68,215]),function(se,e,I,L,A,j,O,R,k,g,C,S,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$El=e.$Dl=e.$Cl=e.$Bl=e.$Al=e.$zl=e.$yl=e.$xl=e.PersistentConnectionEventType=e.$wl=e.$vl=e.$ul=e.ConnectionType=void 0;const f=30*1e3;var m;(function(U){U[U.Management=1]="Management",U[U.ExtensionHost=2]="ExtensionHost",U[U.Tunnel=3]="Tunnel"})(m||(e.ConnectionType=m={}));function y(U){switch(U){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function l(U){const D=new A.$de;return setTimeout(()=>D.cancel(),U),D.token}function d(U,D){if(U.isCancellationRequested||D.isCancellationRequested)return A.CancellationToken.Cancelled;const T=new A.$de;return U.onCancellationRequested(()=>T.cancel()),D.onCancellationRequested(()=>T.cancel()),T.token}class ${get didTimeout(){return this.c==="timedout"}constructor(D){this.c="pending",this.d=new R.$Sc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,I.$_g)(),D.isCancellationRequested?this.h():this.d.add(D.onCancellationRequested(()=>this.h()))}registerDisposable(D){this.c==="pending"?this.d.add(D):D.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const D=new Error("Time limit reached");return D.code="ETIMEDOUT",D.syscall="connect",D}resolve(D){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(D))}reject(D){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(D))}}function c(U,D){const T=new $(D);return T.registerDisposable(U.onControlMessage(B=>{const q=JSON.parse(B.toString()),Y=V(q);Y?T.reject(Y):T.resolve(q)})),T.promise}function v(U,D,T,B,q,Y,_,ie){const J=new $(ie),ne=C.$2d.create(!1);return U.info(`Creating a socket (${_})...`),g.mark(`code/willCreateSocket/${Y}`),D.connect(T,B,q,_).then(ce=>{J.didTimeout?(g.mark(`code/didCreateSocketError/${Y}`),U.info(`Creating a socket (${_}) finished after ${ne.elapsed()} ms, but this is too late and has timed out already.`),ce?.dispose()):(g.mark(`code/didCreateSocketOK/${Y}`),U.info(`Creating a socket (${_}) was successful after ${ne.elapsed()} ms.`),J.resolve(ce))},ce=>{g.mark(`code/didCreateSocketError/${Y}`),U.info(`Creating a socket (${_}) returned an error after ${ne.elapsed()} ms.`),U.error(ce),J.reject(ce)}),J.promise}function i(U,D){const T=new $(D);return U.then(B=>{T.didTimeout||T.resolve(B)},B=>{T.didTimeout||T.reject(B)}),T.promise}async function o(U,D,T,B){const q=ae(U,D);U.logService.trace(`${q} 1/6. invoking socketFactory.connect().`);let Y;try{Y=await v(U.logService,U.remoteSocketFactoryService,U.connectTo,k.$tg.getServerRootPath(),`reconnectionToken=${U.reconnectionToken}&reconnection=${U.reconnectionProtocol?"true":"false"}`,y(D),`renderer-${y(D)}-${U.reconnectionToken}`,B)}catch(ce){throw U.logService.error(`${q} socketFactory.connect() failed or timed out. Error:`),U.logService.error(ce),ce}U.logService.trace(`${q} 2/6. socketFactory.connect() was successful.`);let _,ie;U.reconnectionProtocol?(U.reconnectionProtocol.beginAcceptReconnection(Y,null),_=U.reconnectionProtocol,ie=!1):(_=new w.$7h({socket:Y}),ie=!0),U.logService.trace(`${q} 3/6. sending AuthRequest control message.`);const J=await i(U.signService.createNewMessage((0,S.$Cg)()),B),ne={type:"auth",auth:U.connectionToken||"00000000000000000000",data:J.data};_.sendControl(L.$te.fromString(JSON.stringify(ne)));try{const ce=await c(_,d(B,l(1e4)));if(ce.type!=="sign"||typeof ce.data!="string"){const Ee=new Error("Unexpected handshake message");throw Ee.code="VSCODE_CONNECTION_ERROR",Ee}if(U.logService.trace(`${q} 4/6. received SignRequest control message.`),!await i(U.signService.validate(J,ce.signedData),B)){const Ee=new Error("Refused to connect to unsupported server");throw Ee.code="VSCODE_CONNECTION_ERROR",Ee}const de=await i(U.signService.sign(ce.data),B),me={type:"connectionType",commit:U.commit,signedData:de,desiredConnectionType:D};return T&&(me.args=T),U.logService.trace(`${q} 5/6. sending ConnectionTypeRequest control message.`),_.sendControl(L.$te.fromString(JSON.stringify(me))),{protocol:_,ownsProtocol:ie}}catch(ce){throw ce&&ce.code==="ETIMEDOUT"&&(U.logService.error(`${q} the handshake timed out. Error:`),U.logService.error(ce)),ce&&ce.code==="VSCODE_CONNECTION_ERROR"&&(U.logService.error(`${q} received error control message when negotiating connection. Error:`),U.logService.error(ce)),ie&&H(_),ce}}async function n(U,D,T,B){const q=Date.now(),Y=ae(U,D),{protocol:_,ownsProtocol:ie}=await o(U,D,T,B),J=new $(B);return J.registerDisposable(_.onControlMessage(ne=>{const ce=JSON.parse(ne.toString()),fe=V(ce);fe?(U.logService.error(`${Y} received error control message when negotiating connection. Error:`),U.logService.error(fe),ie&&H(_),J.reject(fe)):(U.reconnectionProtocol?.endAcceptReconnection(),U.logService.trace(`${Y} 6/6. handshake finished, connection is up and running after ${G(q)}!`),J.resolve({protocol:_,firstMessage:ce}))})),J.promise}async function s(U,D){const{protocol:T}=await n(U,1,void 0,D);return{protocol:T}}async function t(U,D,T){const{protocol:B,firstMessage:q}=await n(U,2,D,T),Y=q&&q.debugPort;return{protocol:B,debugPort:Y}}async function r(U,D,T){const B=Date.now(),q=ae(U,3),{protocol:Y}=await o(U,3,D,T);return U.logService.trace(`${q} 6/6. handshake finished, connection is up and running after ${G(B)}!`),Y}async function a(U,D,T){const{connectTo:B,connectionToken:q}=await U.addressProvider.getAddress();return{commit:U.commit,quality:U.quality,connectTo:B,connectionToken:q,reconnectionToken:D,reconnectionProtocol:T,remoteSocketFactoryService:U.remoteSocketFactoryService,signService:U.signService,logService:U.logService}}async function E(U,D,T){return u(U,async B=>{const{protocol:q}=await s(B,A.CancellationToken.None);return new W(U,D,T,B.reconnectionToken,q)})}e.$ul=E;async function b(U,D){return u(U,async T=>{const{protocol:B,debugPort:q}=await t(T,D,A.CancellationToken.None);return new Q(U,D,T.reconnectionToken,B,q)})}e.$vl=b;async function u(U,D){for(let B=1;;B++)try{const q=(0,S.$Cg)(),Y=await a(U,q,null);return await D(Y)}catch(q){if(B<5)U.logService.error(`[remote-connection][attempt ${B}] An error occurred in initial connection! Will retry... Error:`),U.logService.error(q);else throw U.logService.error(`[remote-connection][attempt ${B}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),U.logService.error(q),x.triggerPermanentFailure(0,0,h.$ol.isHandled(q)),q}}async function p(U,D,T){const B=await a(U,(0,S.$Cg)(),null);return await r(B,{host:D,port:T},A.CancellationToken.None)}e.$wl=p;function P(U){return(0,I.$6g)(D=>new Promise((T,B)=>{const q=setTimeout(T,U*1e3);D.onCancellationRequested(()=>{clearTimeout(q),T()})}))}var N;(function(U){U[U.ConnectionLost=0]="ConnectionLost",U[U.ReconnectionWait=1]="ReconnectionWait",U[U.ReconnectionRunning=2]="ReconnectionRunning",U[U.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",U[U.ConnectionGain=4]="ConnectionGain"})(N||(e.PersistentConnectionEventType=N={}));class F{constructor(D,T){this.reconnectionToken=D,this.millisSinceLastIncomingData=T,this.type=0}}e.$xl=F;class M{constructor(D,T,B,q){this.reconnectionToken=D,this.millisSinceLastIncomingData=T,this.durationSeconds=B,this.c=q,this.type=1}skipWait(){this.c.cancel()}}e.$yl=M;class z{constructor(D,T,B){this.reconnectionToken=D,this.millisSinceLastIncomingData=T,this.attempt=B,this.type=2}}e.$zl=z;class Z{constructor(D,T,B){this.reconnectionToken=D,this.millisSinceLastIncomingData=T,this.attempt=B,this.type=4}}e.$Al=Z;class X{constructor(D,T,B,q){this.reconnectionToken=D,this.millisSinceLastIncomingData=T,this.attempt=B,this.handled=q,this.type=3}}e.$Bl=X;class x extends R.$Tc{static triggerPermanentFailure(D,T,B){this._permanentFailure=!0,this.f=D,this.g=T,this.h=B,this.j.forEach(q=>q.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(D=>D.y())}static debugPauseSocketWriting(){this.j.forEach(D=>D.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||x._permanentFailure}constructor(D,T,B,q,Y){super(),this.t=D,this.u=T,this.reconnectionToken=B,this.protocol=q,this.w=Y,this.m=this.B(new O.$6d),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new Z(this.reconnectionToken,0,0)),this.B(q.onSocketClose(_=>{const ie=ee(this.t,this.reconnectionToken,!0);_?_.type===0?(this.u.logService.info(`${ie} received socket close event (hadError: ${_.hadError}).`),_.error&&this.u.logService.error(_.error)):(this.u.logService.info(`${ie} received socket close event (wasClean: ${_.wasClean}, code: ${_.code}, reason: ${_.reason}).`),_.event&&this.u.logService.error(_.event)):this.u.logService.info(`${ie} received socket close event.`),this.y()})),this.B(q.onSocketTimeout(_=>{const ie=ee(this.t,this.reconnectionToken,!0);this.u.logService.info(`${ie} received socket timeout event (unacknowledgedMsgCount: ${_.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${_.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${_.timeSinceLastReceivedSomeData}).`),this.y()})),x.j.push(this),this.B((0,R.$Rc)(()=>{const _=x.j.indexOf(this);_>=0&&x.j.splice(_,1)})),this.n&&this.D(x.f,x.g,x.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const D=ee(this.t,this.reconnectionToken,!0);this.u.logService.info(`${D} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const T=[0,5,5,10,10,10,10,10,30];let B=-1;do{B++;const q=B<T.length?T[B]:T[T.length-1];try{if(q>0){const _=P(q);this.m.fire(new M(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),q,_)),this.u.logService.info(`${D} waiting for ${q} seconds before reconnecting...`);try{await _}catch{}}if(this.n){this.u.logService.error(`${D} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),B+1)),this.u.logService.info(`${D} resolving connection...`);const Y=await a(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${D} connecting to ${Y.connectTo}...`),await this.G(Y,l(f)),this.u.logService.info(`${D} reconnected!`),this.m.fire(new Z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),B+1));break}catch(Y){if(Y.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${D} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(Y),this.C(this.protocol.getMillisSinceLastIncomingData(),B+1,!1);break}if(B>360){this.u.logService.error(`${D} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(Y),this.C(this.protocol.getMillisSinceLastIncomingData(),B+1,!1);break}if(h.$ol.isTemporarilyNotAvailable(Y)){this.u.logService.info(`${D} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(Y);continue}if((Y.code==="ETIMEDOUT"||Y.code==="ENETUNREACH"||Y.code==="ECONNREFUSED"||Y.code==="ECONNRESET")&&Y.syscall==="connect"){this.u.logService.info(`${D} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(Y);continue}if((0,j.$4)(Y)){this.u.logService.info(`${D} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(Y);continue}if(Y instanceof h.$ol){this.u.logService.error(`${D} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(Y),this.C(this.protocol.getMillisSinceLastIncomingData(),B+1,h.$ol.isHandled(Y));break}this.u.logService.error(`${D} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(Y),this.C(this.protocol.getMillisSinceLastIncomingData(),B+1,!1);break}}while(!this.n&&!this.s)}C(D,T,B){this.w?x.triggerPermanentFailure(D,T,B):this.D(D,T,B)}D(D,T,B){this.m.fire(new X(this.reconnectionToken,D,T,B)),H(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$Cl=x;class W extends x{constructor(D,T,B,q,Y){super(1,D,q,Y,!0),this.client=this.B(new w.$5h(Y,{remoteAuthority:T,clientId:B},D.ipcLogger))}async G(D,T){await s(D,T)}}e.$Dl=W;class Q extends x{constructor(D,T,B,q,Y){super(2,D,B,q,!1),this.H=T,this.debugPort=Y}async G(D,T){await t(D,this.H,T)}}e.$El=Q;function H(U){try{U.acceptDisconnect();const D=U.getSocket();U.dispose(),D.dispose()}catch(D){(0,j.$1)(D)}}function V(U){if(U&&U.type==="error"){const D=new Error(`Connection error: ${U.reason}`);return D.code="VSCODE_CONNECTION_ERROR",D}return null}function te(U,D){for(;U.length<D;)U+=" ";return U}function re(U,D){return`[remote-connection][${te(y(U),13)}][${D.substr(0,5)}\u2026]`}function ee(U,D,T){return`${re(U,D)}[${T?"reconnect":"initial"}]`}function ae(U,D){return`${ee(D,U.reconnectionToken,!!U.reconnectionProtocol)}[${U.connectTo}]`}function G(U){return`${Date.now()-U} ms`}}),define(le[103],he([0,1,23]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tm=e.$sm=e.$rm=e.$qm=void 0;function L(k){return k.scheme===I.Schemas.vscodeRemote?k.authority:void 0}e.$qm=L;function A(k){if(!k)return;const g=k.indexOf("+");return g<0?k:k.substr(0,g)}e.$rm=A;function j(k){const{host:g,port:C}=R(k);if(typeof C>"u")throw new Error(`Invalid remote authority: ${k}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:g,port:C}}e.$sm=j;function O(k,g){let{host:C,port:S}=R(k);return typeof S>"u"&&(S=g),{host:C,port:S}}e.$tm=O;function R(k){const g=k.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(g)return{host:g[1],port:parseInt(g[2],10)};const C=k.match(/^(\[[0-9a-z:]+\])$/);if(C)return{host:C[1],port:void 0};const S=k.match(/(.*):(\d+)$/);return S?{host:S[1],port:parseInt(S[2],10)}:{host:k,port:void 0}}}),define(le[45],he([0,1,27,4,103]),function(se,e,I,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hm=e.$Gm=e.$Fm=e.$Em=e.$Dm=e.$Cm=e.$Bm=e.$Am=e.TargetPlatform=e.ExtensionType=e.$zm=e.$ym=e.$xm=e.$wm=e.$vm=e.$um=void 0,e.$um="extensions.user.cache",e.$vm="extensions.builtin.cache",e.$wm="undefined_publisher",e.$xm=["ui","workspace","web"];function j(m){if(typeof m=="object"&&m!==null&&m.supported!==!0)return m.description}e.$ym=j,e.$zm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var O;(function(m){m[m.System=0]="System",m[m.User=1]="User"})(O||(e.ExtensionType=O={}));var R;(function(m){m.WIN32_X64="win32-x64",m.WIN32_ARM64="win32-arm64",m.LINUX_X64="linux-x64",m.LINUX_ARM64="linux-arm64",m.LINUX_ARMHF="linux-armhf",m.ALPINE_X64="alpine-x64",m.ALPINE_ARM64="alpine-arm64",m.DARWIN_X64="darwin-x64",m.DARWIN_ARM64="darwin-arm64",m.WEB="web",m.UNIVERSAL="universal",m.UNKNOWN="unknown",m.UNDEFINED="undefined"})(R||(e.TargetPlatform=R={}));class k{constructor(y){this.value=y,this._lower=y.toLowerCase()}static equals(y,l){if(typeof y>"u"||y===null)return typeof l>"u"||l===null;if(typeof l>"u"||l===null)return!1;if(typeof y=="string"||typeof l=="string"){const d=typeof y=="string"?y:y.value,$=typeof l=="string"?l:l.value;return I.$kf(d,$)}return y._lower===l._lower}static toKey(y){return typeof y=="string"?y.toLowerCase():y._lower}}e.$Am=k;class g{get size(){return this.c.size}constructor(y){if(this.c=new Set,y)for(const l of y)this.add(l)}add(y){this.c.add(k.toKey(y))}delete(y){return this.c.delete(k.toKey(y))}has(y){return this.c.has(k.toKey(y))}}e.$Bm=g;class C{constructor(){this.c=new Map}clear(){this.c.clear()}delete(y){this.c.delete(k.toKey(y))}get(y){return this.c.get(k.toKey(y))}has(y){return this.c.has(k.toKey(y))}set(y,l){this.c.set(k.toKey(y),l)}values(){return this.c.values()}forEach(y){this.c.forEach(y)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Cm=C;function S(m){return w(m)}e.$Dm=S;function w(m){return m.contributes&&m.contributes.localizations?m.contributes.localizations.length>0:!1}e.$Em=w;function h(m){return m.contributes&&m.contributes.authentication?m.contributes.authentication.length>0:!1}e.$Fm=h;function f(m,y){if(y){const l=`onResolveRemoteAuthority:${(0,A.$rm)(y)}`;return!!m.activationEvents?.includes(l)}return!1}e.$Gm=f,e.$Hm=(0,L.$gi)("IBuiltinExtensionsScannerService")}),define(le[217],he([0,1,2,45,11]),function(se,e,I,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kq=void 0;class j extends I.$Tc{constructor(R,k,g,C,S){super(),this.a=R,this.b=k,this.c=g,this.f=S,this.B(C.onDidInstallExtensions(w=>this.g(w))),this.B(C.onDidUninstallExtension(w=>this.h(w)))}g(R){for(const k of R)k.local&&this.invalidate(k.profileLocation)}h(R){R.error||this.invalidate(R.profileLocation)}async invalidate(R){if(R)for(const k of this.a.profiles)this.c.extUri.isEqual(k.extensionsResource,R)&&await this.j(k);else await this.j(this.a.defaultProfile)}async j(R){try{await this.b.del(this.c.extUri.joinPath(R.cacheHome,L.$um))}catch(k){(0,A.$Xk)(k)!==1&&this.f.error(k)}}}e.$kq=j}),define(le[104],he([0,1,2,4]),function(se,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rl=e.$ql=void 0,e.$ql=(0,L.$gi)("remoteSocketFactoryService");class A{constructor(){this.a={}}register(O,R){return this.a[O]??=[],this.a[O].push(R),(0,I.$Rc)(()=>{const k=this.a[O]?.indexOf(R);typeof k=="number"&&k>=0&&this.a[O]?.splice(k,1)})}b(O){return(this.a[O.type]||[]).find(k=>k.supports(O))}connect(O,R,k,g){const C=this.b(O);if(!C)throw new Error(`No socket factory found for ${O}`);return C.connect(O,R,k,g)}}e.$rl=A}),define(le[218],he([0,1,4]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fbc=e.$Ebc=void 0,e.$Ebc=(0,I.$gi)("sharedProcessTunnelService"),e.$Fbc="sharedProcessTunnel"}),define(le[105],he([0,1,4,166]),function(se,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pbc=e.$Obc=e.$Nbc=e.$Mbc=e.$Lbc=e.TunnelStates=e.$Kbc=e.$Jbc=void 0,e.$Jbc=(0,I.$gi)("IRemoteTunnelService"),e.$Kbc={active:!1};var A;(function(j){j.disconnected=O=>({type:"disconnected",onTokenFailed:O}),j.connected=(O,R)=>({type:"connected",info:O,serviceInstallFailed:R}),j.connecting=O=>({type:"connecting",progress:O}),j.uninitialized={type:"uninitialized"}})(A||(e.TunnelStates=A={})),e.$Lbc="remote.tunnels.access",e.$Mbc=e.$Lbc+".hostNameOverride",e.$Nbc=e.$Lbc+".preventSleep",e.$Obc="remoteTunnelService",e.$Pbc=(0,L.localize)(0,null)}),define(le[59],he([0,1,14,7,2,168,44,4,8,41]),function(se,e,I,L,A,j,O,R,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dp=e.$Cp=e.$Bp=e.$Ap=e.$zp=e.$yp=e.$xp=e.$wp=void 0,e.$wp=(0,R.$gi)("requestService");class C{constructor(v){this.b=v}toJSON(){if(!this.a){const v=Object.create(null);for(const i in this.b)i.toLowerCase()==="authorization"||i.toLowerCase()==="proxy-authorization"?v[i]="*****":v[i]=this.b[i];this.a=v}return this.a}}class S extends A.$Tc{constructor(v){super(),this.b=0,this.a=v.createLogger("network",{name:(0,j.localize)(0,null),when:k.$Rj.isEqualTo((0,k.$Pj)(k.LogLevel.Trace)).serialize()})}async c(v,i,o){const n=`${v} #${++this.b}: ${i.url}`;this.a.trace(`${n} - begin`,i.type,new C(i.headers??{}));try{const s=await o();return this.a.trace(`${n} - end`,i.type,s.res.statusCode,s.res.headers),s}catch(s){throw this.a.error(`${n} - error`,i.type,(0,L.$0)(s)),s}}}e.$xp=S;function w(c){return c.res.statusCode&&c.res.statusCode>=200&&c.res.statusCode<300||c.res.statusCode===1223}e.$yp=w;function h(c){return c.res.statusCode===204}e.$zp=h;async function f(c){return h(c)?null:(await(0,I.$Fe)(c.stream)).toString()}e.$Ap=f;async function m(c){if(!w(c))throw new Error("Server returned "+c.res.statusCode);return f(c)}e.$Bp=m;async function y(c){if(!w(c))throw new Error("Server returned "+c.res.statusCode);if(h(c))return null;const i=(await(0,I.$Fe)(c.stream)).toString();try{return JSON.parse(i)}catch(o){throw o.message+=`:
`+i,o}}e.$Cp=y;function l(c){$(c)}e.$Dp=l;let d;function $(c){const v=g.$Xn.as(O.$3n.Configuration),i=d;d={id:"http",order:15,title:(0,j.localize)(1,null),type:"object",scope:c,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,j.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,j.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,j.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,j.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,j.localize)(6,null),(0,j.localize)(7,null),(0,j.localize)(8,null),(0,j.localize)(9,null)],default:"override",description:(0,j.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,j.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,j.localize)(12,null),restricted:!0}}},v.updateConfigurations({add:[d],remove:i?[i]:[]})}$(1)}),define(le[219],he([0,1,26,23,11,59]),function(se,e,I,L,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5P=void 0;let O=class{constructor(k,g){this.a=k,this.b=g}async download(k,g,C=I.CancellationToken.None){if(k.scheme===L.Schemas.file||k.scheme===L.Schemas.vscodeRemote){await this.b.copy(k,g);return}const S={type:"GET",url:k.toString(!0)},w=await this.a.request(S,C);if(w.res.statusCode===200)await this.b.writeFile(g,w.stream);else{const h=await(0,j.$Bp)(w);throw new Error(`Expected 200, got back ${w.res.statusCode} instead.

${h}`)}}};e.$5P=O,e.$5P=O=ye([K(0,j.$wp),K(1,A.$Gk)],O)}),define(le[220],he([0,1,14,26]),function(se,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ar=e.$zr=void 0;class A{constructor(R){this.a=R}listen(R,k){throw new Error("Invalid listen")}call(R,k,g,C=L.CancellationToken.None){switch(k){case"request":return this.a.request(g[0],C).then(async({res:S,stream:w})=>{const h=await(0,I.$Fe)(w);return[{statusCode:S.statusCode,headers:S.headers},h]});case"resolveProxy":return this.a.resolveProxy(g[0]);case"loadCertificates":return this.a.loadCertificates()}throw new Error("Invalid call")}}e.$zr=A;class j{constructor(R){this.a=R}async request(R,k){const[g,C]=await this.a.call("request",[R],k);return{res:g,stream:(0,I.$He)(C)}}async resolveProxy(R){return this.a.call("resolveProxy",[R])}async loadCertificates(){return this.a.call("loadCertificates")}}e.$Ar=j}),define(le[221],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$_b=e.$0_b=e.$9_b=void 0,e.$9_b={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.$0_b={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.$$_b={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(le[222],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$58b=void 0;class I{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(A){try{const j=await this.c();if(j){const O=String(I.a++);return this.b.set(O,j),{id:O,data:j.createNewMessage(A)}}}catch{}return{id:"",data:A}}async validate(A,j){if(!A.id)return!0;const O=this.b.get(A.id);if(!O)return!1;this.b.delete(A.id);try{return O.validate(j)==="ok"}catch{return!1}finally{O.dispose?.()}}async sign(A){try{return await this.d(A)}catch{}return A}}e.$58b=I}),define(le[106],he([0,1,4]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tl=e.$sl=void 0,e.$sl="signService",e.$tl=(0,I.$gi)(e.$sl)}),define(le[223],he([0,1,222]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yac=void 0;class L extends I.$58b{c(){return this.h().then(j=>new j.validator)}d(j){return this.h().then(O=>new O.signer().sign(j))}h(){return new Promise((j,O)=>se(["vsda"],j,O))}}e.$Yac=L}),define(le[77],he([0,1,3,2]),function(se,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$THb=e.$SHb=e.$RHb=e.$QHb=void 0;class A extends L.$Tc{constructor(S,w,h){super(),this.a=S,this.b=w,this.c=h}async getItems(){const S={profile:this.b,workspace:this.c},w=await this.a.call("getItems",S);return new Map(w)}updateItems(S){const w={profile:this.b,workspace:this.c};return S.insert&&(w.insert=Array.from(S.insert.entries())),S.delete&&(w.delete=Array.from(S.delete.values())),this.a.call("updateItems",w)}optimize(){const S={profile:this.b,workspace:this.c};return this.a.call("optimize",S)}}class j extends A{constructor(S,w){super(S,w,void 0),this.f=this.B(new I.$6d),this.onDidChangeItemsExternal=this.f.event,this.g()}g(){this.B(this.a.listen("onDidChangeStorage",{profile:this.b})(S=>this.h(S)))}h(S){(Array.isArray(S.changed)||Array.isArray(S.deleted))&&this.f.fire({changed:S.changed?new Map(S.changed):void 0,deleted:S.deleted?new Set(S.deleted):void 0})}}class O extends j{constructor(S){super(S,void 0)}async close(){this.dispose()}}e.$QHb=O;class R extends j{constructor(S,w){super(S,w)}async close(){this.dispose()}}e.$RHb=R;class k extends A{constructor(S,w){super(S,void 0,w),this.onDidChangeItemsExternal=I.Event.None}async close(){this.dispose()}}e.$SHb=k;class g{constructor(S){this.a=S}isUsed(S){const w={payload:S,profile:void 0,workspace:void 0};return this.a.call("isUsed",w)}}e.$THb=g}),define(le[107],he([0,1,5,36,32]),function(se,e,I,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zo=e.$Yo=void 0;function j(k){if(I.$u===2&&/^penguin(\.|$)/i.test(k))return"chromebook"}function O(k,g,C,S,w,h,f,m,y){const l=Object.create(null);l["common.machineId"]=h,l["common.sqmId"]=f,l.sessionID=(0,A.$Cg)()+Date.now(),l.commitHash=S,l.version=w,l["common.platformVersion"]=(k||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),l["common.platform"]=(0,I.$h)(I.$u),l["common.nodePlatform"]=L.$dc,l["common.nodeArch"]=C,l["common.product"]=y||"desktop",m&&(l["common.msftInternal"]=m);let d=0;const $=Date.now();Object.defineProperties(l,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-$,enumerable:!0},"common.sequence":{get:()=>d++,enumerable:!0}}),I.$l&&(l["common.snap"]="true");const c=j(g);return c&&(l["common.platformDetail"]=c),l}e.$Yo=O;function R(k){const g=L.env.USERDNSDOMAIN;if(!g)return!1;const C=g.toLowerCase();return k.some(S=>C===S)}e.$Zo=R}),define(le[22],he([0,1,4]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$Pl=e.$Ol=e.$Nl=e.$Ml=e.$Ll=e.$Kl=e.$Jl=e.$Il=e.$Hl=e.$Gl=e.$Fl=void 0,e.$Fl=(0,I.$gi)("telemetryService"),e.$Gl=(0,I.$gi)("customEndpointTelemetryService"),e.$Hl="telemetry.currentSessionDate",e.$Il="telemetry.firstSessionDate",e.$Jl="telemetry.lastSessionDate",e.$Kl="telemetry.machineId",e.$Ll="telemetry.sqmId",e.$Ml="telemetry",e.$Nl="telemetry.telemetryLevel",e.$Ol="telemetry.enableCrashReporter",e.$Pl="telemetry.enableTelemetry";var L;(function(j){j[j.NONE=0]="NONE",j[j.CRASH=1]="CRASH",j[j.ERROR=2]="ERROR",j[j.USAGE=3]="USAGE"})(L||(e.TelemetryLevel=L={}));var A;(function(j){j.OFF="off",j.CRASH="crash",j.ERROR="error",j.ON="all"})(A||(e.TelemetryConfiguration=A={}))}),define(le[224],he([0,1,37,6,34,23,15,5,10,144,31,148,94,11,24,22]),function(se,e,I,L,A,j,O,R,k,g,C,S,w,h,f,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ls=e.$ks=e.$js=e.$is=void 0;const y=new Map;async function l(i,o){const n=`${i}::${o.join(":")}`,s=y.get(n);if(s)return s;const t=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],r=new Map,a=new Map,E=2e4;function b(p,P,N,F){const M=P.substring(p.length+1);return L.Promises.withAsyncBody(async z=>{let Z;try{Z=await C.Promises.readdir(P,{withFileTypes:!0})}catch{z();return}if(F.count>=E){F.count+=Z.length,F.maxReached=!0,z();return}let X=Z.length;if(X===0){z();return}let x=Z;F.count+Z.length>E&&(F.maxReached=!0,X=E-F.count,x=Z.slice(0,X)),F.count+=Z.length;for(const W of x)if(W.isDirectory()){if(N.includes(W.name)||await b(p,(0,O.$jc)(P,W.name),N,F),--X===0){z();return}}else{const Q=W.name.lastIndexOf(".");if(Q>=0){const H=W.name.substring(Q+1);H&&r.set(H,(r.get(H)??0)+1)}for(const H of t)H.relativePathPattern?.test(M)!==!1&&H.filePattern.test(W.name)&&a.set(H.tag,(a.get(H.tag)??0)+1);if(--X===0){z();return}}})}const u=L.Promises.withAsyncBody(async p=>{const P={count:0,maxReached:!1};await b(i,i,o,P);const N=await c(i);p({configFiles:d(a),fileTypes:d(r),fileCount:P.count,maxFilesReached:P.maxReached,launchConfigFiles:N})});return y.set(n,u),u}e.$is=l;function d(i){return Array.from(i.entries(),([o,n])=>({name:o,count:n})).sort((o,n)=>n.count-o.count)}function $(){const i={os:`${I.type()} ${I.arch()} ${I.release()}`,memory:`${(I.totalmem()/h.$cl.GB).toFixed(2)}GB (${(I.freemem()/h.$cl.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(g.$nn.value()*100)}%`},o=I.cpus();return o&&o.length>0&&(i.cpus=`${o[0].model} (${o.length} x ${o[0].speed})`),i}e.$js=$;async function c(i){try{const o=new Map,n=(0,O.$jc)(i,".vscode","launch.json"),s=await C.Promises.readFile(n),t=[],r=(0,A.$sn)(s.toString(),t);if(t.length)return console.log(`Unable to parse ${n}`),[];if((0,A.$Bn)(r)==="object"&&r.configurations)for(const a of r.configurations){const E=a.type;E&&(o.has(E)?o.set(E,o.get(E)+1):o.set(E,1))}return d(o)}catch{return[]}}e.$ks=c;let v=class{constructor(o,n){this.c=o,this.d=n}f(o){const n=[];return n.push(`OS Version:       ${o.os}`),n.push(`CPUs:             ${o.cpus}`),n.push(`Memory (System):  ${o.memory}`),n.push(`VM:               ${o.vmHint}`),n.join(`
`)}g(o){const n=[];n.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),n.push(`OS Version:       ${I.type()} ${I.arch()} ${I.release()}`);const s=I.cpus();return s&&s.length>0&&n.push(`CPUs:             ${s[0].model} (${s.length} x ${s[0].speed})`),n.push(`Memory (System):  ${(I.totalmem()/h.$cl.GB).toFixed(2)}GB (${(I.freemem()/h.$cl.GB).toFixed(2)}GB free)`),R.$i||n.push(`Load (avg):       ${I.loadavg().map(t=>Math.round(t)).join(", ")}`),n.push(`VM:               ${Math.round(g.$nn.value()*100)}%`),n.push(`Screen Reader:    ${o.screenReader?"yes":"no"}`),n.push(`Process Argv:     ${o.mainArguments.join(" ")}`),n.push(`GPU Status:       ${this.j(o.gpuFeatureStatus)}`),n.join(`
`)}async getPerformanceInfo(o,n){return Promise.all([(0,S.$hs)(o.mainPID),this.k(o)]).then(async s=>{let[t,r]=s,a=this.m(o,t);return n.forEach(E=>{if((0,w.$Zm)(E))a+=`
${E.errorMessage}`,r+=`
${E.errorMessage}`;else if(a+=`

Remote: ${E.hostName}`,E.processes&&(a+=`
${this.m(o,E.processes)}`),E.workspaceMetadata){r+=`
|  Remote: ${E.hostName}`;for(const b of Object.keys(E.workspaceMetadata)){const u=E.workspaceMetadata[b];let p=`${u.fileCount} files`;u.maxFilesReached&&(p=`more than ${p}`),r+=`|    Folder (${b}): ${p}`,r+=this.h(u)}}}),{processInfo:a,workspaceInfo:r}})}async getSystemInfo(o,n){const{memory:s,vmHint:t,os:r,cpus:a}=$(),E={os:r,memory:s,cpus:a,vmHint:t,processArgs:`${o.mainArguments.join(" ")}`,gpuStatus:o.gpuFeatureStatus,screenReader:`${o.screenReader?"yes":"no"}`,remoteData:n};return R.$i||(E.load=`${I.loadavg().map(b=>Math.round(b)).join(", ")}`),R.$k&&(E.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(E)}async getDiagnostics(o,n){const s=[];return(0,S.$hs)(o.mainPID).then(async t=>(s.push(""),s.push(this.g(o)),s.push(""),s.push(this.m(o,t)),o.windows.some(r=>r.folderURIs&&r.folderURIs.length>0&&!r.remoteAuthority)&&(s.push(""),s.push("Workspace Stats: "),s.push(await this.k(o))),n.forEach(r=>{if((0,w.$Zm)(r))s.push(`
${r.errorMessage}`);else if(s.push(`

`),s.push(`Remote:           ${r.hostName}`),s.push(this.f(r.machineInfo)),r.processes&&s.push(this.m(o,r.processes)),r.workspaceMetadata)for(const a of Object.keys(r.workspaceMetadata)){const E=r.workspaceMetadata[a];let b=`${E.fileCount} files`;E.maxFilesReached&&(b=`more than ${b}`),s.push(`Folder (${a}): ${b}`),s.push(this.h(E))}}),s.push(""),s.push(""),s.join(`
`)))}h(o){const n=[];let t=0;const r=(u,p)=>{const P=` ${u}(${p})`;t+P.length>60?(n.push(a),a="|                 ",t=a.length):t+=P.length,a+=P};let a="|      File types:";const E=10,b=o.fileTypes.length>E?E:o.fileTypes.length;for(let u=0;u<b;u++){const p=o.fileTypes[u];r(p.name,p.count)}if(n.push(a),o.configFiles.length>=0&&(a="|      Conf files:",t=0,o.configFiles.forEach(u=>{r(u.name,u.count)}),n.push(a)),o.launchConfigFiles.length>0){let u="|      Launch Configs:";o.launchConfigFiles.forEach(p=>{const P=p.count>1?` ${p.name}(${p.count})`:` ${p.name}`;u+=P}),n.push(u)}return n.join(`
`)}j(o){const n=Math.max(...Object.keys(o).map(s=>s.length));return Object.keys(o).map(s=>`${s}:  ${" ".repeat(n-s.length)}  ${o[s]}`).join(`
                  `)}k(o){const n=[],s=[];return o.windows.forEach(t=>{t.folderURIs.length===0||t.remoteAuthority||(n.push(`|  Window (${t.title})`),t.folderURIs.forEach(r=>{const a=k.URI.revive(r);if(a.scheme===j.Schemas.file){const E=a.fsPath;s.push(l(E,["node_modules",".git"]).then(b=>{let u=`${b.fileCount} files`;b.maxFilesReached&&(u=`more than ${u}`),n.push(`|    Folder (${(0,O.$nc)(E)}): ${u}`),n.push(this.h(b))}).catch(b=>{n.push(`|      Error: Unable to collect workspace stats for folder ${E} (${b.toString()})`)}))}else n.push(`|    Folder (${a.toString()}): Workspace stats not available.`)}))}),Promise.all(s).then(t=>n.join(`
`)).catch(t=>`Unable to collect workspace stats: ${t}`)}m(o,n){const s=new Map;o.windows.forEach(r=>s.set(r.pid,`window [${r.id}] (${r.title})`)),o.pidToNames.forEach(({pid:r,name:a})=>s.set(r,a));const t=[];return t.push("CPU %	Mem MB	   PID	Process"),n&&this.n(o.mainPID,s,t,n,0),t.join(`
`)}n(o,n,s,t,r){const a=r===0;let E;a?E=t.pid===o?`${this.d.applicationName} main`:"remote agent":n.has(t.pid)?E=n.get(t.pid):E=`${"  ".repeat(r)} ${t.name}`;const b=process.platform==="win32"?t.mem:I.totalmem()*(t.mem/100);s.push(`${t.load.toFixed(0).padStart(5," ")}	${(b/h.$cl.MB).toFixed(0).padStart(6," ")}	${t.pid.toFixed(0).padStart(6," ")}	${E}`),Array.isArray(t.children)&&t.children.forEach(u=>this.n(o,n,s,u,r+1))}async getWorkspaceFileExtensions(o){const n=new Set;for(const{uri:s}of o.folders){const t=k.URI.revive(s);if(t.scheme!==j.Schemas.file)continue;const r=t.fsPath;try{(await l(r,["node_modules",".git"])).fileTypes.forEach(E=>n.add(E.name))}catch{}}return{extensions:[...n]}}async reportWorkspaceStats(o){for(const{uri:n}of o.folders){const s=k.URI.revive(n);if(s.scheme!==j.Schemas.file)continue;const t=s.fsPath;try{const r=await l(t,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":o.telemetryId,rendererSessionId:o.rendererSessionId}),r.fileTypes.forEach(a=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:o.rendererSessionId,type:a.name,count:a.count})}),r.launchConfigFiles.forEach(a=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:o.rendererSessionId,type:a.name,count:a.count})}),r.configFiles.forEach(a=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:o.rendererSessionId,type:a.name,count:a.count})})}catch{}}}};e.$ls=v,e.$ls=v=ye([K(0,m.$Fl),K(1,f.$Sj)],v)}),define(le[108],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cac=e.$bac=void 0;class I{constructor(j){this.b=j}listen(j,O){throw new Error(`Event not found: ${O}`)}call(j,O,{eventName:R,data:k}){return this.b.forEach(g=>g.log(R,k)),Promise.resolve(null)}}e.$bac=I;class L{constructor(j){this.b=j}log(j,O){return this.b.call("log",{eventName:j,data:O}).then(void 0,R=>`Failed to log telemetry: ${console.warn(R)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$cac=L}),define(le[46],he([0,1,30,12,103,107,22]),function(se,e,I,L,A,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cp=e.$bp=e.$ap=e.$_o=e.$$o=e.$0o=e.$9o=e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=e.$3o=e.$2o=e.$1o=void 0;class R{constructor(o){this.value=o,this.isTrustedTelemetryValue=!0}}e.$1o=R;class k{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$2o=k,e.$3o=new k;class g{async publicLog(o,n,s){}async publicLogError(o,n,s){}}e.$4o=g,e.$5o="telemetry",e.$6o="extensionTelemetryLog",e.$7o={log:()=>null,flush:()=>Promise.resolve(null)};function C(i,o){return!o.isBuilt&&!o.disableTelemetry?!0:!(o.disableTelemetry||!i.enableTelemetry)}e.$8o=C;function S(i,o){return o.extensionTestsLocationURI?!0:!(o.isBuilt||o.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}e.$9o=S;function w(i){const o=i.getValue(O.$Nl),n=i.getValue(O.$Ol);if(i.getValue(O.$Pl)===!1||n===!1)return 0;switch(o??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$0o=w;function h(i){const o={},n={},s={};y(i,s);for(let t in s){t=t.length>150?t.substr(t.length-149):t;const r=s[t];typeof r=="number"?n[t]=r:typeof r=="boolean"?n[t]=r?1:0:typeof r=="string"?(r.length>8192&&console.warn(`Telemetry property: ${t} has been trimmed to 8192, the original length is ${r.length}`),o[t]=r.substring(0,8191)):typeof r<"u"&&r!==null&&(o[t]=r)}return{properties:o,measurements:n}}e.$$o=h;const f=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function m(i){if(!i)return"none";const o=(0,A.$rm)(i);return f.has(o)?o:"other"}e.$_o=m;function y(i,o,n=0,s){if(i)for(const t of Object.getOwnPropertyNames(i)){const r=i[t],a=s?s+t:t;Array.isArray(r)?o[a]=(0,I.$Qn)(r):r instanceof Date?o[a]=r.toISOString():(0,L.$Vf)(r)?n<2?y(r,o,n+1,a+"."):o[a]=(0,I.$Qn)(r):o[a]=r}}function l(i,o){const n=i.msftInternalDomains||[],s=o.getValue("telemetry.internalTesting");return(0,j.$Zo)(n)||s}e.$ap=l;function d(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.$bp=d;function $(i,o){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let n=i;const s=[];for(const E of o)for(;;){const b=E.exec(i);if(!b)break;s.push([b.index,E.lastIndex])}const t=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,r=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let a=0;for(n="";;){const E=r.exec(i);if(!E)break;const b=s.some(([u,p])=>E.index<p&&u<r.lastIndex);!t.test(E[0])&&!b&&(n+=i.substring(a,E.index)+"<REDACTED: user-file-path>",a=r.lastIndex)}return a<i.length&&(n+=i.substr(a)),n}function c(i){if(!i)return i;const o=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const n of o)if(n.regex.test(i))return`<REDACTED: ${n.label}>`;return i}function v(i,o){return(0,I.$Nn)(i,n=>{if(n instanceof R||Object.hasOwnProperty.call(n,"isTrustedTelemetryValue"))return n.value;if(typeof n=="string"){let s=n.replaceAll("%20"," ");s=$(s,o);for(const t of o)s=s.replace(t,"");return s=c(s),s}})}e.$cp=v}),define(le[33],he([0,1,27,29,45,5,10,7,36,46]),function(se,e,I,L,A,j,O,R,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$op=e.$np=e.$mp=e.$lp=e.$kp=e.$jp=e.$ip=e.$hp=e.$gp=e.$fp=e.$ep=e.$dp=void 0;function C(n,s){return n.uuid&&s.uuid?n.uuid===s.uuid:n.id===s.id?!0:(0,I.$ff)(n.id,s.id)===0}e.$dp=C;const S=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class w{static create(s){const t=s.manifest?s.manifest.version:s.version,r=s.manifest?s.targetPlatform:s.properties.targetPlatform;return new w(s.identifier,t,r)}static parse(s){const t=S.exec(s);return t&&t[1]&&t[2]?new w({id:t[1]},t[2],t[4]||void 0):null}constructor(s,t,r="undefined"){this.version=t,this.targetPlatform=r,this.id=s.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(s){return s instanceof w?C(this,s)&&this.version===s.version&&this.targetPlatform===s.targetPlatform:!1}}e.$ep=w;const h=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function f(n){const s=h.exec(n);return s&&s[1]?[y(s[1]),s[2]]:[y(n),void 0]}e.$fp=f;function m(n,s){return`${n}.${s}`}e.$gp=m;function y(n){return n.toLowerCase()}e.$hp=y;function l(n,s){return y(m(n??A.$wm,s))}e.$ip=l;function d(n,s){const t=[],r=a=>{for(const E of t)if(E.some(b=>C(s(b),s(a))))return E;return null};for(const a of n){const E=r(a);E?E.push(a):t.push([a])}return t}e.$jp=d;function $(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}e.$kp=$;function c(n){return{id:new g.$1o(n.identifier.id),name:new g.$1o(n.name),galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),isSigned:n.isSigned,...n.telemetryData}}e.$lp=c,e.$mp=new A.$Am("pprice.better-merge");function v(n,s){const t=[],r=s.manifest.extensionDependencies?.slice(0)??[];for(;r.length;){const a=r.shift();if(a&&t.every(E=>!C(E.identifier,{id:a}))){const E=n.filter(b=>C(b.identifier,{id:a}));E.length===1&&(t.push(E[0]),r.push(...E[0].manifest.extensionDependencies?.slice(0)??[]))}}return t}e.$np=v;async function i(n,s){if(!j.$k)return!1;let t;try{t=(await n.readFile(O.URI.file("/etc/os-release"))).value.toString()}catch{try{t=(await n.readFile(O.URI.file("/usr/lib/os-release"))).value.toString()}catch(a){s.debug("Error while getting the os-release file.",(0,R.$0)(a))}}return!!t&&(t.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function o(n,s){const t=await i(n,s),r=(0,L.$Ko)(t?"alpine":j.$u,k.$ec);return s.debug("ComputeTargetPlatform:",r),r}e.$op=o}),define(le[225],he([0,1,17,2,20,10,11,24,6,3,15,5,36,33]),function(se,e,I,L,A,j,O,R,k,g,C,S,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$a$b=e.$_0b=void 0;let f=class extends L.$Tc{constructor($,c){super(),this.b=$,this.c=c,this.a=new Map,this.c.configBasedExtensionTips&&Object.entries(this.c.configBasedExtensionTips).forEach(([,v])=>this.a.set(v.configPath,v))}getConfigBasedTips($){return this.f($)}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async f($){const c=[];for(const[v,i]of this.a)if(!(i.configScheme&&i.configScheme!==$.scheme))try{const o=(await this.b.readFile((0,A.$Tg)($,v))).value.toString();for(const[n,s]of Object.entries(i.recommendations))(!s.contentPattern||new RegExp(s.contentPattern,"mig").test(o))&&c.push({extensionId:n,extensionName:s.name,configName:i.configName,important:!!s.important,isExtensionPack:!!s.isExtensionPack,whenNotInstalled:s.whenNotInstalled})}catch{}return c}};e.$_0b=f,e.$_0b=f=ye([K(0,O.$Gk),K(1,R.$Sj)],f);const m="extensionTips/promptedExecutableTips",y="extensionTips/lastPromptedMediumImpExeTime";class l extends f{constructor($,c,v,i,o,n,s,t){super(s,t),this.r=$,this.s=c,this.t=v,this.u=i,this.w=o,this.z=n,this.g=new Map,this.h=new Map,this.j=new Map,this.m=new Map,this.n=new Map,t.exeBasedExtensionTips&&Object.entries(t.exeBasedExtensionTips).forEach(([r,a])=>{const E=[],b=[],u=[];Object.entries(a.recommendations).forEach(([p,P])=>{P.important?a.important?E.push({extensionId:p,extensionName:P.name,isExtensionPack:!!P.isExtensionPack}):b.push({extensionId:p,extensionName:P.name,isExtensionPack:!!P.isExtensionPack}):u.push({extensionId:p,extensionName:P.name,isExtensionPack:!!P.isExtensionPack})}),E.length&&this.g.set(r,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:E}),b.length&&this.h.set(r,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:b}),u.length&&this.j.set(r,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:u})}),(0,k.$ih)(async()=>{await this.C(),this.F(),this.G()},3e3,this.q)}async getImportantExecutableBasedTips(){const $=await this.O(this.g),c=await this.O(this.h);return[...$,...c]}getOtherExecutableBasedTips(){return this.O(this.j)}async C(){const $=await this.O(this.g),c=await this.O(this.h),v=await this.u.getInstalled();this.m=this.D($,v),this.n=this.D(c,v)}D($,c){const v=new Map;$.forEach(t=>v.set(t.extensionId.toLowerCase(),t));const{installed:i,uninstalled:o}=this.N([...v.keys()],c);for(const t of i){const r=v.get(t);r&&this.t.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:t,exeName:r.exeName})}for(const t of o){const r=v.get(t);r&&this.t.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:t,exeName:r.exeName})}const n=this.L(),s=new Map;for(const t of o){const r=v.get(t);if(r&&(!n[r.exeName]||!n[r.exeName].includes(r.extensionId))){let a=s.get(r.exeName);a||(a=[],s.set(r.exeName,a)),a.push(r)}}return s}F(){if(this.m.size===0)return;const[$,c]=[...this.m.entries()][0];this.H(c).then(v=>{switch(v){case"reacted":this.M(c[0].exeName,c);break;case"ignored":this.m.delete($);break;case"incompatibleWindow":{const i=g.Event.once(g.Event.latch(g.Event.any(this.s.onDidOpenMainWindow,this.s.onDidFocusMainWindow)));this.B(i(()=>this.F()));break}case"toomany":{const i=this.B(new L.$Uc);i.value=(0,k.$ih)(()=>{i.dispose(),this.F()},60*60*1e3);break}}})}G(){if(this.n.size===0)return;const $=this.I(),c=Date.now()-$,v=7*24*60*60*1e3;if(c<v){const n=this.B(new L.$Uc);n.value=(0,k.$ih)(()=>{n.dispose(),this.G()},v-c);return}const[i,o]=[...this.n.entries()][0];this.H(o).then(n=>{switch(n){case"reacted":{this.J(Date.now()),this.n.delete(i),this.M(o[0].exeName,o);const s=this.B(new L.$Uc);s.value=(0,k.$ih)(()=>{s.dispose(),this.G()},v);break}case"ignored":this.n.delete(i),this.G();break;case"incompatibleWindow":{const s=g.Event.once(g.Event.latch(g.Event.any(this.s.onDidOpenMainWindow,this.s.onDidFocusMainWindow)));this.B(s(()=>this.G()));break}case"toomany":{const s=this.B(new L.$Uc);s.value=(0,k.$ih)(()=>{s.dispose(),this.G()},60*60*1e3);break}}})}async H($){const c=await this.u.getInstalled(1),v=$.filter(i=>!i.whenNotInstalled||i.whenNotInstalled.every(o=>c.every(n=>!(0,h.$dp)(n.identifier,{id:o})))).map(({extensionId:i})=>i.toLowerCase());return this.z.promptImportantExtensionsInstallNotification({extensions:v,source:3,name:$[0].exeFriendlyName,searchValue:`@exe:"${$[0].exeName}"`})}I(){let $=this.w.getNumber(y,-1);return $||($=Date.now(),this.J($)),$}J($){this.w.store(y,$,-1,1)}L(){return JSON.parse(this.w.get(m,-1,"{}"))}M($,c){const v=this.L();v[$]=c.map(({extensionId:i})=>i.toLowerCase()),this.w.store(m,JSON.stringify(v),-1,0)}N($,c){const v=[],i=[],o=c.reduce((n,s)=>(n.add(s.identifier.id.toLowerCase()),n),new Set);return $.forEach(n=>{o.has(n.toLowerCase())?v.push(n):i.push(n)}),{installed:v,uninstalled:i}}async O($){const c=[],v=new Map;for(const i of $.keys()){const o=$.get(i);if(!o||!(0,I.$Lb)(o.recommendations))continue;const n=[];S.$i?o.windowsPath&&n.push(o.windowsPath.replace("%USERPROFILE%",()=>w.env.USERPROFILE).replace("%ProgramFiles(x86)%",()=>w.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",()=>w.env.ProgramFiles).replace("%APPDATA%",()=>w.env.APPDATA).replace("%WINDIR%",()=>w.env.WINDIR)):(n.push((0,C.$jc)("/usr/local/bin",i)),n.push((0,C.$jc)("/usr/bin",i)),n.push((0,C.$jc)(this.r.fsPath,i)));for(const s of n){let t=v.get(s);if(t===void 0&&(t=await this.b.exists(j.URI.file(s)),v.set(s,t)),t)for(const{extensionId:r,extensionName:a,isExtensionPack:E,whenNotInstalled:b}of o.recommendations)c.push({extensionId:r,extensionName:a,isExtensionPack:E,exeName:i,exeFriendlyName:o.exeFriendlyName,windowsPath:o.windowsPath,whenNotInstalled:b})}}return c}}e.$a$b=l}),define(le[226],he([0,1,26,33]),function(se,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$j2b=void 0;async function A(j,O,R,k,g){try{const C=await j.getExtensionsControlManifest();if(!C.deprecated)return;const S=await j.getInstalled(1);for(const[w,h]of Object.entries(C.deprecated)){if(!h?.extension)continue;const{id:f,autoMigrate:m,preRelease:y}=h.extension;if(!m)continue;const l=S.find($=>(0,L.$dp)($.identifier,{id:w}));if(!l)continue;const d=(await O.getExtensions([{id:f,preRelease:y}],{targetPlatform:await j.getTargetPlatform(),compatible:!0},I.CancellationToken.None))[0];if(!d){g.info(`Skipping migrating '${l.identifier.id}' extension because, the comaptible target '${f}' extension is not found`);continue}try{g.info(`Migrating '${l.identifier.id}' extension to '${f}' extension...`);const $=!k.getDisabledExtensions().some(v=>(0,L.$dp)(v,l.identifier));await j.uninstall(l),g.info(`Uninstalled the unsupported extension '${l.identifier.id}'`);let c=S.find(v=>(0,L.$dp)(v.identifier,{id:f}));(!c||!c.isPreReleaseVersion&&$)&&(c=await j.installFromGallery(d,{installPreReleaseVersion:!0,isMachineScoped:l.isMachineScoped,operation:4}),g.info(`Installed the pre-release extension '${c.identifier.id}'`),$||(await k.disableExtension(c.identifier),g.info(`Disabled the pre-release extension '${c.identifier.id}' because the unsupported extension '${l.identifier.id}' is disabled`)),m.storage&&(R.addToMigrationList((0,L.$gp)(l.manifest.publisher,l.manifest.name),(0,L.$gp)(c.manifest.publisher,c.manifest.name)),g.info("Added pre-release extension to the storage migration list"))),g.info(`Migrated '${l.identifier.id}' extension to '${f}' extension.`)}catch($){g.error($)}}}catch(C){g.error(C)}}e.$j2b=A}),define(le[227],he([0,1,6,7,2,23,20,55,12,32,31,70,21,16,29,33,98,11,8]),function(se,e,I,L,A,j,O,R,k,g,C,S,w,h,f,m,y,l,d){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$hq=void 0;let c=class extends A.$Tc{static{$=this}static{this.c=".sigzip"}constructor(i,o,n,s,t,r){super(),this.h=o,this.j=n,this.m=s,this.n=t,this.r=r,this.extensionsDownloadDir=i.extensionsDownloadLocation,this.f=20,this.g=this.y()}async download(i,o,n){await this.g;const s=(0,O.$Tg)(this.extensionsDownloadDir,this.z(i));try{await this.w(i,s,r=>this.j.download(i,r,o))}catch(r){throw new f.$Po(r.message,f.ExtensionManagementErrorCode.Download)}let t=!1;if(n&&this.t(i)){const r=await this.u(i);try{t=await this.n.verify(s.fsPath,r.fsPath,this.r.getLevel()===d.LogLevel.Trace)}catch(a){const E=a;if(t=E.code,E.output&&this.r.trace(`Extension signature verification details for ${i.identifier.id} ${i.version}:
${E.output}`),t===f.ExtensionSignaturetErrorCode.PackageIsInvalidZip||t===f.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip){try{await this.delete(s)}catch(b){this.r.error(b)}throw new f.$Po(S.$1p,f.ExtensionManagementErrorCode.CorruptZip)}}finally{try{await this.delete(r)}catch(a){this.r.error(a)}}}return t===!0?this.r.info(`Extension signature is verified: ${i.identifier.id}`):t===!1?this.r.info(`Extension signature verification is not done: ${i.identifier.id}`):this.r.warn(`Extension signature verification failed with error '${t}': ${i.identifier.id}`),{location:s,verificationStatus:t}}t(i){if(!i.isSigned)return this.r.info(`Extension is not signed: ${i.identifier.id}`),!1;const o=this.m.getValue("extensions.verifySignature");return(0,k.$Zf)(o)?o:!0}async u(i){await this.g;const o=(0,O.$Tg)(this.extensionsDownloadDir,`${this.z(i)}${$.c}`);try{await this.w(i,o,n=>this.j.downloadSignatureArchive(i,n))}catch(n){throw new f.$Po(n.message,f.ExtensionManagementErrorCode.DownloadSignature)}return o}async w(i,o,n){if(await this.h.exists(o))return;if(o.scheme!==j.Schemas.file){await n(o);return}const s=(0,O.$Tg)(this.extensionsDownloadDir,`.${(0,g.$Cg)()}`);await this.h.exists(s)||await n(s);try{await C.Promises.rename(s.fsPath,o.fsPath,2*60*1e3)}catch(t){try{await this.h.del(s)}catch{}if(t.code==="ENOTEMPTY")this.r.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",i.identifier.id,o.path);else throw this.r.info(`Rename failed because of ${(0,L.$0)(t)}. Deleted the file from downloaded location`,s.path),t}}async delete(i){await this.g,await this.h.del(i)}async y(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.r.trace("Extension VSIX downloads cache dir does not exist");return}const i=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(i.children){const o=[],n=[],s=[];for(const a of i.children)if(a.name.endsWith($.c))s.push(a.resource);else{const E=m.$ep.parse(a.name);E&&n.push([E,a])}const t=(0,m.$jp)(n,([a])=>a),r=[];for(const a of t)a.sort((E,b)=>R.rcompare(E[0].version,b[0].version)),o.push(...a.slice(1).map(E=>E[1].resource)),r.push(a[0][1]);r.sort((a,E)=>a.mtime-E.mtime),o.push(...r.slice(0,Math.max(0,r.length-this.f)).map(a=>a.resource)),o.push(...s),await I.Promises.settled(o.map(a=>(this.r.trace("Deleting from cache",a.path),this.h.del(a))))}}catch(i){this.r.error(i)}}z(i){return this.f?m.$ep.create(i).toString().toLowerCase():(0,g.$Cg)()}};e.$hq=c,e.$hq=c=$=ye([K(0,h.$oi),K(1,l.$Gk),K(2,f.$Oo),K(3,w.$Mi),K(4,y.$Up),K(5,d.$Aj)],c)}),define(le[228],he([0,1,3,2,35,33,45]),function(se,e,I,L,A,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lq=void 0;class R extends L.$Tc{constructor(g,C,S,w,h,f,m){super(),this.f=g,this.g=C,this.h=S,this.j=w,this.m=h,this.n=f,this.r=m,this.a=this.B(new I.$6d),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new L.$3c),this.s().then(null,y=>m.error(y))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(g=>this.u(g.added))),this.B(this.j.onAddExtensions(g=>this.w(g))),this.B(this.j.onDidAddExtensions(g=>this.y(g))),this.B(this.j.onRemoveExtensions(g=>this.z(g))),this.B(this.j.onDidRemoveExtensions(g=>this.C(g))),this.B(this.n.onDidFilesChange(g=>this.D(g)))}async u(g){try{g.length&&await Promise.all(g.map(C=>(this.c.set(C.id,(0,L.$Qc)(this.n.watch(this.m.extUri.dirname(C.extensionsResource)),this.n.watch(C.extensionsResource))),this.G(C.extensionsResource))))}catch(C){throw this.r.error(C),C}}async w(g){for(const C of g.extensions)this.I(this.L(C.identifier,C.version),g.profileLocation)}async y(g){for(const C of g.extensions){const S=this.L(C.identifier,C.version);g.error?this.J(S,g.profileLocation):this.I(S,g.profileLocation)}}async z(g){for(const C of g.extensions)this.J(this.L(C.identifier,C.version),g.profileLocation)}async C(g){const C=[],S=[];for(const w of g.extensions){const h=this.L(w.identifier,w.version);g.error?this.I(h,g.profileLocation):(this.J(h,g.profileLocation),this.b.has(h)||(this.r.debug("Extension is removed from all profiles",w.identifier.id,w.version),S.push(this.f.scanInstalledExtensionAtLocation(w.location).then(f=>{f?C.push(f):this.r.info("Extension not found at the location",w.location.toString())},f=>this.r.error(f)))))}try{await Promise.all(S),C.length&&await this.H(C)}catch(w){this.r.error(w)}}D(g){for(const C of this.h.profiles)g.contains(C.extensionsResource,0,1)&&this.F(C.extensionsResource)}async F(g){const C=[],S=[],w=await this.j.scanProfileExtensions(g),h=new Set,f=new Set;for(const[m,y]of this.b)y.has(g)&&f.add(m);for(const m of w){const y=this.L(m.identifier,m.version);h.add(y),f.has(y)||(C.push(m.identifier),this.I(y,g))}for(const m of f)if(!h.has(m)){const y=this.M(m);y&&(S.push(y.identifier),this.J(m,g))}(C.length||S.length)&&this.a.fire({added:C.length?{extensions:C,profileLocation:g}:void 0,removed:S.length?{extensions:S,profileLocation:g}:void 0})}async G(g){const C=await this.j.scanProfileExtensions(g);for(const S of C)this.I(this.L(S.identifier,S.version),g)}async H(g){g||(g=(await this.f.scanAllUserInstalledExtensions()).filter(S=>!this.b.has(this.L(S.identifier,S.manifest.version)))),g.length&&await this.f.markAsUninstalled(...g)}I(g,C){let S=this.b.get(g);S||this.b.set(g,S=new A.$Bc(w=>this.m.extUri.getComparisonKey(w))),S.add(C)}J(g,C){const S=this.b.get(g);S&&S.delete(C),S?.size||this.b.delete(g)}L(g,C){return`${O.$Am.toKey(g.id)}@${C}`}M(g){const[C,S]=(0,j.$fp)(g);return S?{identifier:{id:C},version:S}:void 0}}e.$lq=R}),define(le[229],he([0,1,43,46]),function(se,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qp=void 0;async function A(j,O,R,k,g,C,S){const w={"X-Market-Client-Id":`VSCode ${j}`,"User-Agent":`VSCode ${j} (${O.nameShort})`};if((0,L.$8o)(O,R)&&(0,L.$0o)(k)===3){const h=await(0,I.$Pp)(R,g,C);w["X-Market-User-Id"]=h,w["VSCode-SessionId"]=S.machineId||h}return w}e.$Qp=A}),define(le[230],he([0,1,73,17,6,2,23,15,31,16,29,33,8,75,10]),function(se,e,I,L,A,j,O,R,k,g,C,S,w,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yr=void 0;let m=class extends h.$xr{constructor($,c,v,i){super(v),this.h=$,this.j=i,this.g=this.B(new y(c,i)),this.h.registerParticipant({postInstall:async o=>this.m(o),postUninstall:async o=>this.n(o)})}async getBuiltInExtensionTranslationsUri($,c){const i=(await this.g.getLanguagePacks())[c];if(!i){this.j.warn(`No language pack found for ${c}`);return}const o=i.translations[$];return o?f.URI.file(o):void 0}async getInstalledLanguages(){const $=await this.g.getLanguagePacks(),c=Object.keys($).map(v=>{const i=$[v];return{...this.f(v,i.label),extensionId:i.extensions[0].extensionIdentifier.id}});return c.push(this.f("en","English")),c.sort((v,i)=>v.label.localeCompare(i.label)),c}async m($){$&&$.manifest&&$.manifest.contributes&&$.manifest.contributes.localizations&&$.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",$.identifier.id),await this.update())}async n($){const c=await this.g.getLanguagePacks();Object.keys(c).some(v=>c[v]&&c[v].extensions.some(i=>(0,S.$dp)(i.extensionIdentifier,$.identifier)))&&(this.j.info("Removing language packs from the extension",$.identifier.id),await this.update())}async update(){const[$,c]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),v=await this.g.update(c);return!(0,L.$ub)(Object.keys($),Object.keys(v))}};e.$yr=m,e.$yr=m=ye([K(0,C.$Ro),K(1,g.$oi),K(2,C.$Oo),K(3,w.$Aj)],m);let y=class extends j.$Tc{constructor($,c){super(),this.j=c,this.c={},this.f=(0,R.$jc)($.userDataPath,"languagepacks.json"),this.g=new A.$nh}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update($){return this.s(c=>{Object.keys(c).forEach(v=>delete c[v]),this.m(c,...$)}).then(()=>this.c)}m($,...c){for(const v of c)v&&v.manifest&&v.manifest.contributes&&v.manifest.contributes.localizations&&v.manifest.contributes.localizations.length&&this.n($,v);Object.keys($).forEach(v=>this.r($[v]))}n($,c){const v=c.identifier,i=c.manifest.contributes&&c.manifest.contributes.localizations?c.manifest.contributes.localizations:[];for(const o of i)if(c.location.scheme===O.Schemas.file&&l(o)){let n=$[o.languageId];n||(n={hash:"",extensions:[],translations:{},label:o.localizedLanguageName??o.languageName},$[o.languageId]=n);const s=n.extensions.filter(t=>(0,S.$dp)(t.extensionIdentifier,v))[0];s?s.version=c.manifest.version:n.extensions.push({extensionIdentifier:v,version:c.manifest.version});for(const t of o.translations)n.translations[t.id]=(0,R.$jc)(c.location.fsPath,t.path)}}r($){if($){const c=(0,I.createHash)("md5");for(const v of $.extensions)c.update(v.extensionIdentifier.uuid||v.extensionIdentifier.id).update(v.version);$.hash=c.digest("hex")}}s($=()=>null){return this.g.queue(()=>{let c=null;return k.Promises.readFile(this.f,"utf8").then(void 0,v=>v.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(v)).then(v=>{try{return JSON.parse(v)}catch{return{}}}).then(v=>(c=$(v),v)).then(v=>{for(const o of Object.keys(v))v[o]||delete v[o];this.c=v,this.h=!0;const i=JSON.stringify(this.c);return this.j.debug("Writing language packs",i),k.Promises.writeFile(this.f,i)}).then(()=>c,v=>this.j.error(v))})}};y=ye([K(0,g.$oi),K(1,w.$Aj)],y);function l(d){if(typeof d.languageId!="string"||!Array.isArray(d.translations)||d.translations.length===0)return!1;for(const $ of d.translations)if(typeof $.id!="string"||typeof $.path!="string")return!1;return!(d.languageName&&typeof d.languageName!="string"||d.localizedLanguageName&&typeof d.localizedLanguageName!="string")}}),define(le[231],he([0,1,143,7,30,46]),function(se,e,I,L,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CP=void 0;const O="https://mobile.events.data.microsoft.com/OneCollector/1.0",R="https://mobile.events.data.microsoft.com/ping";async function k(C,S,w){const h=await(0,I.$xD)("@microsoft/1ds-core-js","dist/ms.core.js"),f=await(0,I.$xD)("@microsoft/1ds-post-js","dist/ms.post.js"),m=new h.AppInsightsCore,y=new f.PostChannel,l={instrumentationKey:C,endpointUrl:O,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[y]]};if(w){l.extensionConfig={};const d={alwaysUseXhrOverride:!0,ignoreMc1Ms0CookieProcessing:!0,httpXHROverride:w};l.extensionConfig[y.identifier]=d}return m.initialize(l,[]),m.addTelemetryInitializer(d=>{d.ext=d.ext??{},d.ext.web=d.ext.web??{},d.ext.web.consentDetails='{"GPC_DataSharingOptIn":false}',S&&(d.ext.utc=d.ext.utc??{},d.ext.utc.flags=8462029)}),m}class g{constructor(S,w,h,f,m){this.e=S,this.f=w,this.g=h,this.h=m,this.c=O,this.d=R,this.g||(this.g={}),typeof f=="function"?this.a=f():this.a=f,this.b=null}i(S){if(this.a){if(typeof this.a!="string"){S(this.a);return}this.b||(this.b=k(this.a,this.e,this.h)),this.b.then(w=>{S(w)},w=>{(0,L.$1)(w),console.error(w)})}}log(S,w){if(!this.a)return;w=(0,A.$On)(w,this.g),w=(0,j.$$o)(w);const h=this.f+"/"+S;try{this.i(f=>{f.pluginVersionString=w?.properties.version??"Unknown",f.track({name:h,baseData:{name:h,properties:w?.properties,measurements:w?.measurements}})})}catch{}}flush(){return this.a?new Promise(S=>{this.i(w=>{w.unload(!0,()=>{this.a=void 0,S(void 0)})})}):Promise.resolve(void 0)}}e.$CP=g}),define(le[109],he([0,1,2,169,16,8,24,46]),function(se,e,I,L,A,j,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$z0b=void 0;let k=class extends I.$Tc{constructor(C,S,w,h,f=""){super(),this.b=f;const m=S.getLogger(R.$5o);if(m)this.a=this.B(m);else{const l=(0,R.$9o)(h,w)?" (Not Sent)":"",d=()=>(0,R.$8o)(h,w)&&C.getLevel()===j.LogLevel.Trace;this.a=this.B(S.createLogger(R.$5o,{name:(0,L.localize)(0,null,l),hidden:!d()})),this.B(C.onDidChangeLogLevel(()=>S.setVisibility(R.$5o,d()))),this.a.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.a.info("===========================================================")}}flush(){return Promise.resolve(void 0)}log(C,S){this.a.trace(`${this.b}telemetry/${C}`,(0,R.$$o)(S))}};e.$z0b=k,e.$z0b=k=ye([K(0,j.$Aj),K(1,j.$Bj),K(2,A.$ni),K(3,O.$Sj)],k)}),define(le[110],he([0,1,2,30,5,27,170,21,44,101,24,41,22,46]),function(se,e,I,L,A,j,O,R,k,g,C,S,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Er=void 0;let f=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(l,d,$){this.k=d,this.l=$,this.d={},this.i=new I.$Sc,this.j=[],this.b=l.appenders,this.c=l.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=l.piiPaths||[],this.g=3,this.h=!!l.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const c of this.f)this.j.push(new RegExp((0,j.$Ye)(c),"gi")),c.indexOf("\\")>=0&&this.j.push(new RegExp((0,j.$Ye)(c.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(c=>{(c.affectsConfiguration(w.$Nl)||c.affectsConfiguration(w.$Pl)||c.affectsConfiguration(w.$Ol))&&this.m()}))}setExperimentProperty(l,d){this.d[l]=d}m(){let l=(0,h.$0o)(this.k);const d=this.l.enabledTelemetryLevels;if(d){this.h=this.sendErrorTelemetry?d.error:!1;const $=d.usage?3:d.error?2:0;l=Math.min(l,$)}this.g=l}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(l,d,$){this.g<d||($=(0,L.$On)($,this.d),$=(0,h.$cp)($,this.j),$=(0,L.$On)($,this.c),this.b.forEach(c=>c.log(l,$)))}publicLog(l,d){this.n(l,3,d)}publicLog2(l,d){this.publicLog(l,d)}publicLogError(l,d){this.h&&this.n(l,2,d)}publicLogError2(l,d){this.publicLogError(l,d)}};e.$Er=f,e.$Er=f=ye([K(1,R.$Mi),K(2,C.$Sj)],f);function m(){const y=(0,O.localize)(0,null,g.default.nameLong),l=g.default.privacyStatementUrl?(0,O.localize)(2,null,"https://aka.ms/vscode-telemetry",g.default.privacyStatementUrl):(0,O.localize)(1,null,"https://aka.ms/vscode-telemetry"),d=A.$o?"":(0,O.localize)(3,null),$=(0,O.localize)(4,null),c=(0,O.localize)(5,null),v=(0,O.localize)(6,null),i=(0,O.localize)(7,null),o=`
|       | ${$} | ${c} | ${v} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,n=(0,O.localize)(8,null);return`
${y} ${l} ${d}

&nbsp;

${i}
${o}

&nbsp;

${n}
`}S.$Xn.as(k.$3n.Configuration).registerConfiguration({id:w.$Ml,order:1,type:"object",title:(0,O.localize)(9,null),properties:{[w.$Nl]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,O.localize)(10,null),(0,O.localize)(11,null),(0,O.localize)(12,null),(0,O.localize)(13,null)],markdownDescription:m(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),S.$Xn.as(k.$3n.Configuration).registerConfiguration({id:w.$Ml,order:110,type:"object",title:(0,O.localize)(14,null),properties:{[w.$Pl]:{type:"boolean",markdownDescription:g.default.privacyStatementUrl?(0,O.localize)(16,null,g.default.nameLong,g.default.privacyStatementUrl):(0,O.localize)(15,null,g.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,O.localize)(17,null,`\`#${w.$Nl}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(le[232],he([0,1,14,26,275,231]),function(se,e,I,L,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DP=void 0;async function O(C,S){const w=await S.request(C,L.CancellationToken.None),h=(await(0,I.$Fe)(w.stream)).toString(),f=w.res.statusCode??200;return{headers:w.res.headers,statusCode:f,responseData:h}}async function R(C){const S={method:C.type,headers:C.headers};return new Promise((h,f)=>{const m=A.request(C.url??"",S,y=>{y.on("data",function(l){h({headers:y.headers,statusCode:y.statusCode??200,responseData:l.toString()})}),y.on("error",function(l){f(l)})});m.write(C.data,y=>{y&&f(y)}),m.end()})}async function k(C,S,w){const h=typeof S.data=="string"?S.data:new TextDecoder().decode(S.data),f={type:"POST",headers:{...S.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(S.data).toString()},url:S.urlString,data:h};try{const m=C?await O(f,C):await R(f);w(m.statusCode,m.headers,m.responseData)}catch{w(0,{})}}class g extends j.$CP{constructor(S,w,h,f,m){const y={sendPOST:(l,d)=>{k(S,l,d)}};super(w,h,f,m,y)}}e.$DP=g}),define(le[233],he([0,1,23,92,21,16,8,24,22,108,109,110]),function(se,e,I,L,A,j,O,R,k,g,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wbc=void 0;let w=class{constructor(f,m,y,l,d,$){this.b=f,this.c=m,this.d=y,this.e=l,this.f=d,this.g=$,this.a=new Map}h(f){if(!this.a.has(f.id)){const m=Object.create(null);m["common.vscodemachineid"]=this.c.machineId,m["common.vscodesessionid"]=this.c.sessionId;const y=[f.id,JSON.stringify(m),f.aiKey],d=new L.$Gq(I.$Ag.asFileUri("bootstrap-fork").fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:y,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),$=[new g.$cac(d),new C.$z0b(this.d,this.e,this.f,this.g,`[${f.id}] `)];this.a.set(f.id,new S.$Er({appenders:$,sendErrorTelemetry:f.sendErrorTelemetry},this.b,this.g))}return this.a.get(f.id)}publicLog(f,m,y){this.h(f).publicLog(m,y)}publicLogError(f,m,y){this.h(f).publicLogError(m,y)}};e.$wbc=w,e.$wbc=w=ye([K(0,A.$Mi),K(1,k.$Fl),K(2,O.$Aj),K(3,O.$Bj),K(4,j.$ni),K(5,R.$Sj)],w)}),define(le[78],he([0,1,3,21,4,8]),function(se,e,I,L,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1v=e.$Zv=e.$Yv=e.$Xv=e.$Wv=e.$Vv=e.$Uv=e.$Tv=e.ProvidedOnAutoForward=e.$Sv=e.TunnelPrivacyId=e.TunnelProtocol=e.$Rv=e.$Qv=void 0,e.$Qv=(0,A.$gi)("tunnelService"),e.$Rv=(0,A.$gi)("sharedTunnelsService");var O;(function(y){y.Http="http",y.Https="https"})(O||(e.TunnelProtocol=O={}));var R;(function(y){y.ConstantPrivate="constantPrivate",y.Private="private",y.Public="public"})(R||(e.TunnelPrivacyId=R={}));function k(y){return!!y.forwardPort}e.$Sv=k;var g;(function(y){y[y.Notify=1]="Notify",y[y.OpenBrowser=2]="OpenBrowser",y[y.OpenPreview=3]="OpenPreview",y[y.Silent=4]="Silent",y[y.Ignore=5]="Ignore",y[y.OpenBrowserOnce=6]="OpenBrowserOnce"})(g||(e.ProvidedOnAutoForward=g={}));function C(y){if(y.scheme!=="http"&&y.scheme!=="https")return;const l=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(y.authority);if(l)return{address:l[1],port:+l[2]}}e.$Tv=C,e.$Uv=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function S(y){return e.$Uv.indexOf(y)>=0}e.$Vv=S,e.$Wv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function w(y){return e.$Wv.indexOf(y)>=0}e.$Xv=w;function h(y,l,d,$){if(d===1)return!1;if(d===2&&w(l)){const c=/(\d+)\.(\d+)\.(\d+)/g.exec($);if(c?.length===4&&parseInt(c[1])>=18)return!1}return y<1024}e.$Yv=h;class f{constructor(l,d,$){this.remoteAddress=l,this.localAddress=d,this.b=$,this.a=new I.$6d,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Zv=f;let m=class{constructor(l,d){this.k=l,this.l=d,this.a=new I.$6d,this.onTunnelOpened=this.a.event,this.b=new I.$6d,this.onTunnelClosed=this.b.event,this.c=new I.$6d,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const l=this.l.getValue("remote.localPortHost");return!l||l==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(l){return this.f=l,l?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(l){this.g=l.elevation,this.i=l.privacyOptions,this.h=l.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const l=[],d=Array.from(this.e.values());for(const $ of d){const c=Array.from($.values());for(const v of c){const i=await v.value;i&&typeof i!="string"&&l.push(i)}}return l}async dispose(){for(const l of this.e.values()){for(const{value:d}of l.values())await d.then($=>typeof $!="string"?$?.dispose():void 0);l.clear()}this.e.clear()}setEnvironmentTunnel(l,d,$,c,v){this.q(l,d,Promise.resolve({tunnelRemoteHost:l,tunnelRemotePort:d,localAddress:$,privacy:c,protocol:v,dispose:()=>Promise.resolve()}))}async getExistingTunnel(l,d){(w(l)||S(l))&&(l=e.$Uv[0]);const $=this.s(l,d);if($)return++$.refcount,$.value}openTunnel(l,d,$,c,v,i=!1,o,n){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${d}:${$} on local port ${v}.`);const s=this.f??l;if(!s)return;if(d||(d="localhost"),c||(c=this.m),this.f&&this.j.has($)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const t=this.t(s,d,$,c,v,i,o,n);return t?t.then(r=>{if(r){if(typeof r=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(d,$),r}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(d,$);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const a=this.o(r);return(r.tunnelRemoteHost!==d||r.tunnelRemotePort!==$)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),o&&r.privacy!==o&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(a),a}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),t)}o(l){return{tunnelRemotePort:l.tunnelRemotePort,tunnelRemoteHost:l.tunnelRemoteHost,tunnelLocalPort:l.tunnelLocalPort,localAddress:l.localAddress,privacy:l.privacy,protocol:l.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${l.tunnelRemoteHost}:${l.tunnelRemotePort} `);const d=this.e.get(l.tunnelRemoteHost);if(d){const $=d.get(l.tunnelRemotePort);$&&($.refcount--,await this.p(l.tunnelRemoteHost,l.tunnelRemotePort,$))}}}}async p(l,d,$){if($.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${l}:${d}.`);const c=$.value.then(async v=>{v&&typeof v!="string"&&(await v.dispose(!0),this.b.fire({host:v.tunnelRemoteHost,port:v.tunnelRemotePort}))});return this.e.has(l)&&this.e.get(l).delete(d),c}}async closeTunnel(l,d){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${l}:${d} `);const $=this.e.get(l);if($&&$.has(d)){const c=$.get(d);c.refcount=0,await this.p(l,d,c)}}q(l,d,$){this.e.has(l)||this.e.set(l,new Map),this.e.get(l).set(d,{refcount:1,value:$})}async r(l,d){const $=this.e.get(l);if($){const c=$.get(d),v=c?await c.value:void 0;(!v||typeof v=="string")&&$.delete(d),$.size===0&&this.e.delete(l)}}s(l,d){const $=[l];S(l)?($.push(...e.$Uv),$.push(...e.$Wv)):w(l)&&$.push(...e.$Wv);const c=$.map(v=>this.e.get(v));for(const v of c){const i=v?.get(d);if(i)return i}}canTunnel(l){return!!C(l)}u(l,d,$,c,v,i,o){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${d}:${$} on local port ${c}.`);const n=$;this.j.add(n);const s=c===void 0?$:c,t={elevationRequired:v?this.isPortPrivileged(s):!1},r={remoteAddress:{host:d,port:$},localAddressPort:c,privacy:i,public:i?i!==R.Private:void 0,protocol:o},a=l.forwardPort(r,t);return a?(this.q(d,$,a),a.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(n)})):this.j.delete(n),a}};e.$1v=m,e.$1v=m=ye([K(0,j.$Aj),K(1,L.$Mi)],m)}),define(le[234],he([0,1,8,78,2,7,6]),function(se,e,I,L,A,j,O){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.$Gbc=void 0;class k extends A.$Tc{constructor(){super(),this.a=null,this.b=null}async getAddress(){return this.a?this.a:(this.b||(this.b=new O.$Dh),this.b.p)}setAddress(S){this.a=S,this.b&&(this.b.complete(S),this.b=null)}setTunnel(S){this.B(S)}}let g=class extends A.$Tc{static{R=this}static{this.a=0}constructor(S,w){super(),this.f=S,this.g=w,this.b=new Map,this.c=new Set}dispose(){super.dispose(),this.b.forEach(S=>S.dispose())}async createTunnel(){return{id:String(++R.a)}}async startTunnel(S,w,h,f,m,y,l){const d=new k,$=await Promise.resolve(this.f.openTunnel(S,d,h,f,m,y,l));if(!$||typeof $=="string")throw this.g.info(`[SharedProcessTunnelService] Could not create a tunnel to ${h}:${f} (remote).`),d.dispose(),new Error("Could not create tunnel");if(this.c.has(w))throw this.c.delete(w),d.dispose(),await $.dispose(),(0,j.$6)();return d.setTunnel($),this.b.set(w,d),this.g.info(`[SharedProcessTunnelService] Created tunnel ${w}: ${$.localAddress} (local) to ${h}:${f} (remote).`),{tunnelLocalPort:$.tunnelLocalPort,localAddress:$.localAddress}}async setAddress(S,w){const h=this.b.get(S);h&&h.setAddress(w)}async destroyTunnel(S){const w=this.b.get(S);if(w){this.g.info(`[SharedProcessTunnelService] Disposing tunnel ${S}.`),this.b.delete(S),await w.dispose();return}this.c.add(S)}};e.$Gbc=g,e.$Gbc=g=R=ye([K(0,L.$Rv),K(1,I.$Aj)],g)}),define(le[28],he([0,1,4]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$el=void 0,e.$el=(0,I.$gi)("IUriIdentityService")}),define(le[235],he([0,1,28,188,11,20,128,3,2]),function(se,e,I,L,A,j,O,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$es=void 0;class g{static{this._clock=0}constructor(w){this.uri=w,this.time=g._clock++}touch(){return this.time=g._clock++,this}}let C=class{constructor(w){this.g=w,this.c=new k.$Sc,this.f=2**16;const h=new Map,f=m=>{let y=h.get(m.scheme);return y===void 0&&(y=w.hasProvider(m)&&!this.g.hasCapability(m,1024),h.set(m.scheme,y)),y};this.c.add(R.Event.any(w.onDidChangeFileSystemProviderRegistrations,w.onDidChangeFileSystemProviderCapabilities)(m=>{h.delete(m.scheme)})),this.extUri=new j.$Ig(f),this.d=new O.$ds((m,y)=>this.extUri.compare(m,y,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(w){this.g.hasProvider(w)&&(w=(0,j.$Ug)(w));const h=this.d.get(w);return h?h.touch().uri.with({fragment:w.fragment}):(this.d.set(w,new g(w)),this.h(),w)}h(){if(this.d.size<this.f)return;const w=[...this.d.entries()].sort((f,m)=>f[1].time<m[1].time?1:f[1].time>m[1].time?-1:0);g._clock=0,this.d.clear();const h=this.f*.5;for(let f=0;f<h;f++)this.d.set(w[f][0],w[f][1].touch())}};e.$es=C,e.$es=C=ye([K(0,A.$Gk)],C),(0,L.$bs)(I.$el,C,1)}),define(le[236],he([0,1,3,2,11,48,35]),function(se,e,I,L,A,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2ac=void 0;class R extends L.$Tc{constructor(g,C,S,w,h,f){super(),this.f=g,this.g=C,this.h=S,this.j=w,this.m=h,this.n=f,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new I.$6d),this.onDidChangeFile=this.a.event,this.b=j.$mi.forUris(()=>!(this.capabilities&1024)),this.c=new O.$Bc(m=>this.m.extUri.getComparisonKey(this.t(m))),this.r(),this.B(w.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(m=>this.s(m)))}r(){this.c.clear();for(const g of this.j.profiles)this.c.add(g.settingsResource),this.c.add(g.keybindingsResource),this.c.add(g.tasksResource),this.c.add(g.extensionsResource)}open(g,C){return this.g.open(this.t(g),C)}close(g){return this.g.close(g)}read(g,C,S,w,h){return this.g.read(g,C,S,w,h)}write(g,C,S,w,h){return this.g.write(g,C,S,w,h)}watch(g,C){this.b.set(g,g);const S=this.g.watch(this.t(g),C);return(0,L.$Rc)(()=>{this.b.delete(g),S.dispose()})}stat(g){return this.g.stat(this.t(g))}mkdir(g){return this.g.mkdir(this.t(g))}rename(g,C,S){return this.g.rename(this.t(g),this.t(C),S)}readFile(g,C){return this.g.readFile(this.t(g),C)}readFileStream(g,C,S){return this.g.readFileStream(this.t(g),C,S)}readdir(g){return this.g.readdir(this.t(g))}enforceAtomicReadFile(g){return this.c.has(g)}writeFile(g,C,S){return this.g.writeFile(this.t(g),C,S)}enforceAtomicWriteFile(g){return this.c.has(g)?{postfix:".vsctmp"}:!1}delete(g,C){return this.g.delete(this.t(g),C)}copy(g,C,S){if((0,A.$Kk)(this.g))return this.g.copy(this.t(g),this.t(C),S);throw new Error("copy not supported")}cloneFile(g,C){if((0,A.$Lk)(this.g))return this.g.cloneFile(this.t(g),this.t(C));throw new Error("clone not supported")}s(g){const C=[];for(const S of g){if(S.resource.scheme!==this.f)continue;const w=this.u(S.resource);this.b.findSubstr(w)&&C.push({resource:w,type:S.type,cId:S.cId})}C.length&&(this.n.debug("User data changed"),this.a.fire(C))}t(g){return g.with({scheme:this.f})}u(g){return g.with({scheme:this.h})}}e.$2ac=R}),define(le[79],he([0,1,62]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xHb=e.$wHb=e.edit=void 0;function L(O,R,k,g){const C=(0,I.$Hn)(O,R,k,g)[0];return C&&(O=O.substring(0,C.offset)+C.content+O.substring(C.offset+C.length)),O}e.edit=L;function A(O,R,k){let g=k;for(;g>=0;){if(O.charAt(g)===R.charAt(R.length-1)&&R.length===1)return g+1;if(g--,R.length===2&&g>=0&&O.charAt(g)===R.charAt(0))return g+2}return 0}e.$wHb=A;function j(O,R,k){let g=k;for(;g>=0;)if(O.charAt(g)===R.charAt(R.length-1)&&R.length===1||(g++,R.length===2&&g>=0&&O.charAt(g)===R.charAt(1)))return g;return O.length-1}e.$xHb=j}),define(le[237],he([0,1,30,55,12]),function(se,e,I,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$f9b=void 0;function j(h,f,m,y,l,d){const $=[],c=[],v=[];if(!f){const z=h.filter(({identifier:Z})=>l.every(X=>X.toLowerCase()!==Z.id.toLowerCase()));return{local:{added:$,removed:c,updated:v},remote:z.length>0?{added:z,updated:[],removed:[],all:z}:null}}h=h.map(S),f=f.map(S),m=m?m.map(S):null;const i=new Map,o=z=>{z.uuid&&i.set(z.id.toLowerCase(),z.uuid)};h.forEach(({identifier:z})=>o(z)),f.forEach(({identifier:z})=>o(z)),m?.forEach(({identifier:z})=>o(z)),y?.forEach(({identifier:z})=>o(z)),d?.forEach(z=>o(z));const n=z=>{const Z=z.identifier.uuid||i.get(z.identifier.id.toLowerCase());return Z?`uuid:${Z}`:`id:${z.identifier.id.toLowerCase()}`},s=(z,Z)=>(z.set(n(Z),Z),z),t=h.reduce(s,new Map),r=f.reduce(s,new Map),a=f.reduce((z,Z)=>s(z,(0,I.$Ln)(Z)),new Map),E=m?m.reduce(s,new Map):null,b=y.reduce(s,new Map),u=l.reduce((z,Z)=>{const X=i.get(Z.toLowerCase());return z.add(X?`uuid:${X}`:`id:${Z.toLowerCase()}`)},new Set),p=d?d.reduce((z,{id:Z,uuid:X})=>(X=X??i.get(Z.toLowerCase()),z.add(X?`uuid:${X}`:`id:${Z.toLowerCase()}`)),new Set):null,P=O(t,r,u,!1);if(P.added.size>0||P.removed.size>0||P.updated.size>0){const z=O(E,t,u,!1),Z=O(E,r,u,!0),X=(x,W,Q,H)=>{let V,te,re;return W.installed?(V=H.pinned,re=H.preRelease,V&&(te=H.version)):(V=Q.pinned,re=Q.preRelease,V&&(te=Q.version)),V===void 0&&(V=W.pinned,V&&(te=W.version)),re===void 0&&(re=W.preRelease),{...H,installed:W.installed||Q.installed,pinned:V,preRelease:re,version:te??(Q.version&&(!W.installed||L.gt(Q.version,W.version))?Q.version:W.version),state:k(W,Q,E?.get(x))}};for(const x of Z.removed.values()){const W=t.get(x);if(!W)continue;const Q=(0,A.$5f)(E?.get(x)),H=p&&!p.has(x)&&Q.installed;W.installed&&H?c.push(W.identifier):a.set(x,W)}for(const x of Z.added.values()){const W=(0,A.$5f)(r.get(x)),Q=t.get(x);if(Q){if(P.updated.has(x)){const H=X(x,Q,W,W);R(Q,W,!1,!1)||v.push(w(H,x)),a.set(x,H)}}else W.installed&&$.push(w(W,x))}for(const x of Z.updated.values()){const W=(0,A.$5f)(r.get(x)),Q=(0,A.$5f)(E?.get(x)),H=t.get(x);if(H)if(p&&!p.has(x)&&Q.installed&&H.installed&&!W.installed)c.push(H.identifier);else{const te=X(x,H,W,W);v.push(w(te,x)),a.set(x,te)}else W.installed&&$.push(w(W,x))}for(const x of z.added.values())Z.added.has(x)||a.set(x,(0,A.$5f)(t.get(x)));for(const x of z.updated.values()){if(Z.removed.has(x)||Z.updated.has(x))continue;const W=(0,A.$5f)(t.get(x)),Q=(0,A.$5f)(r.get(x));a.set(x,X(x,W,Q,W))}for(const x of z.removed.values())Z.updated.has(x)||Z.removed.has(x)||b.has(x)||(0,A.$5f)(r.get(x)).installed&&p&&(p.has(x)||!(0,A.$5f)(E?.get(x)).installed||a.delete(x))}const N=[],F=O(r,a,new Set,!0),M=F.added.size>0||F.updated.size>0||F.removed.size>0;return M&&a.forEach((z,Z)=>N.push(w(z,Z))),{local:{added:$,removed:c,updated:v},remote:M?{added:[...F.added].map(z=>a.get(z)),updated:[...F.updated].map(z=>a.get(z)),removed:[...F.removed].map(z=>r.get(z)),all:N}:null}}e.$f9b=j;function O(h,f,m,y){const l=h?[...h.keys()].filter(i=>!m.has(i)):[],d=[...f.keys()].filter(i=>!m.has(i)),$=d.filter(i=>!l.includes(i)).reduce((i,o)=>(i.add(o),i),new Set),c=l.filter(i=>!d.includes(i)).reduce((i,o)=>(i.add(o),i),new Set),v=new Set;for(const i of l){if(c.has(i))continue;const o=h.get(i),n=f.get(i);(!n||!R(o,n,y,!0))&&v.add(i)}return{added:$,removed:c,updated:v}}function R(h,f,m,y){return!(h.disabled!==f.disabled||!!h.isApplicationScoped!=!!f.isApplicationScoped||y&&h.installed!==f.installed||h.installed&&f.installed&&(h.preRelease!==f.preRelease||h.pinned!==f.pinned||f.pinned&&h.version!==f.version)||!C(h.state,f.state)||m&&h.version!==f.version)}function k(h,f,m){const y=h.state,l=f.state,d=m?.state;if(!f.version||y&&L.gt(h.version,f.version))return y;if(l&&L.gt(f.version,h.version)||!y)return l;if(!l)return y;const $=(0,I.$Ln)(y),c=d?g(d,l):{added:Object.keys(l).reduce((i,o)=>(i.add(o),i),new Set),removed:new Set,updated:new Set},v=d?g(d,y):{added:Object.keys(y).reduce((i,o)=>(i.add(o),i),new Set),removed:new Set,updated:new Set};for(const i of[...c.added.values(),...c.updated.values()])$[i]=l[i];for(const i of c.removed.values())v.updated.has(i)||delete $[i];return $}function g(h,f){const m=Object.keys(h),y=Object.keys(f),l=y.filter(c=>!m.includes(c)).reduce((c,v)=>(c.add(v),c),new Set),d=m.filter(c=>!y.includes(c)).reduce((c,v)=>(c.add(v),c),new Set),$=new Set;for(const c of m){if(d.has(c))continue;const v=h[c],i=f[c];(0,I.$Pn)(v,i)||$.add(c)}return{added:l,removed:d,updated:$}}function C(h={},f={}){const{added:m,removed:y,updated:l}=g(h,f);return m.size===0&&y.size===0&&l.size===0}function S(h){return{...h,disabled:!!h.disabled,installed:!!h.installed}}function w(h,f){const m={...h,identifier:{id:h.identifier.id,uuid:f.startsWith("uuid:")?f.substring(5):void 0},preRelease:!!h.preRelease,pinned:!!h.pinned};return h.disabled||delete m.disabled,h.installed||delete m.installed,h.state||delete m.state,h.isApplicationScoped||delete m.isApplicationScoped,m}}),define(le[111],he([0,1,17,21,4]),function(se,e,I,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EJb=e.$DJb=void 0,e.$DJb=(0,A.$gi)("IIgnoredExtensionsManagementService");let j=class{constructor(R){this.a=R}hasToNeverSyncExtension(R){return this.b().includes(R.toLowerCase())}hasToAlwaysSyncExtension(R){return this.b().includes(`-${R.toLowerCase()}`)}updateIgnoredExtensions(R,k){let g=[...this.a.getValue("settingsSync.ignoredExtensions")].map(C=>C.toLowerCase());return g=g.filter(C=>C!==R&&C!==`-${R}`),k&&g.push(R.toLowerCase()),this.a.updateValue("settingsSync.ignoredExtensions",g.length?g:void 0,2)}updateSynchronizedExtensions(R,k){let g=[...this.a.getValue("settingsSync.ignoredExtensions")].map(C=>C.toLowerCase());return g=g.filter(C=>C!==R&&C!==`-${R}`),k&&g.push(`-${R.toLowerCase()}`),this.a.updateValue("settingsSync.ignoredExtensions",g.length?g:void 0,2)}getIgnoredExtensions(R){const k=R.filter(w=>w.isMachineScoped).map(w=>w.identifier.id.toLowerCase()),g=this.b().map(w=>w.toLowerCase()),C=[],S=[];if(Array.isArray(g))for(const w of g)w.startsWith("-")?S.push(w.substring(1)):C.push(w);return(0,I.$Mb)([...k,...C].filter(w=>!S.includes(w)))}b(){let R=this.a.inspect("settingsSync.ignoredExtensions").userValue;return R!==void 0||(R=this.a.inspect("sync.ignoredExtensions").userValue,R!==void 0)?R:(this.a.getValue("settingsSync.ignoredExtensions")||[]).map(k=>k.toLowerCase())}};e.$EJb=j,e.$EJb=j=ye([K(0,L.$Mi)],j)}),define(le[238],he([0,1,17,34,30,93,79]),function(se,e,I,L,A,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$l9b=void 0;function R(c){return(0,L.$sn)(c)||[]}async function k(c,v,i,o,n){const s=R(c),t=R(v),r=i?R(i):null,a=[...s,...t,...r||[]].map(X=>X.key),E=await n.resolveUserBindings(a),b=C(s,t,r,E);if(!b.hasLocalForwarded&&!b.hasRemoteForwarded)return{mergeContent:c,hasChanges:!1,hasConflicts:!1};if(!b.hasLocalForwarded&&b.hasRemoteForwarded)return{mergeContent:v,hasChanges:!0,hasConflicts:!1};if(b.hasLocalForwarded&&!b.hasRemoteForwarded)return{mergeContent:c,hasChanges:!0,hasConflicts:!1};const u=w(s),p=w(t),P=r?w(r):null,N=f(u,p,E),F=P?f(P,u,E):{added:[...u.keys()].reduce((X,x)=>(X.add(x),X),new Set),removed:new Set,updated:new Set},M=P?f(P,p,E):{added:[...p.keys()].reduce((X,x)=>(X.add(x),X),new Set),removed:new Set,updated:new Set},z=g(N,F,M);let Z=c;for(const X of z.removed.values())z.conflicts.has(X)||(Z=d(Z,X,o));for(const X of z.added.values()){if(z.conflicts.has(X))continue;const x=p.get(X);if(x.some(W=>W.command!==`-${X}`&&b.conflicts.has(E[W.key]))){z.conflicts.add(X);continue}Z=l(Z,x,o)}for(const X of z.updated.values()){if(z.conflicts.has(X))continue;const x=p.get(X);if(x.some(W=>W.command!==`-${X}`&&b.conflicts.has(E[W.key]))){z.conflicts.add(X);continue}Z=$(Z,X,x,o)}return{mergeContent:Z,hasChanges:!0,hasConflicts:z.conflicts.size>0}}e.$l9b=k;function g(c,v,i){const o=new Set,n=new Set,s=new Set,t=new Set;for(const r of v.removed.values())i.updated.has(r)&&t.add(r);for(const r of i.removed.values())t.has(r)||(v.updated.has(r)?t.add(r):n.add(r));for(const r of v.added.values())t.has(r)||i.added.has(r)&&c.updated.has(r)&&t.add(r);for(const r of i.added.values())t.has(r)||(v.added.has(r)?c.updated.has(r)&&t.add(r):o.add(r));for(const r of v.updated.values())t.has(r)||i.updated.has(r)&&c.updated.has(r)&&t.add(r);for(const r of i.updated.values())t.has(r)||(v.updated.has(r)?c.updated.has(r)&&t.add(r):s.add(r));return{added:o,removed:n,updated:s,conflicts:t}}function C(c,v,i,o){const n=new Set,s=S(c,o),t=S(v,o),r=i?S(i,o):null,a=h(s,t);if(a.added.size===0&&a.removed.size===0&&a.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const E=r?h(r,s):{added:[...s.keys()].reduce((F,M)=>(F.add(M),F),new Set),removed:new Set,updated:new Set};if(E.added.size===0&&E.removed.size===0&&E.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:n,removed:n,updated:n,conflicts:n};const b=r?h(r,t):{added:[...t.keys()].reduce((F,M)=>(F.add(M),F),new Set),removed:new Set,updated:new Set};if(b.added.size===0&&b.removed.size===0&&b.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const{added:u,removed:p,updated:P,conflicts:N}=g(a,E,b);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:u,removed:p,updated:P,conflicts:N}}function S(c,v){const i=new Map;for(const o of c){const n=v[o.key];let s=i.get(n);s||(s=[],i.set(n,s)),s.push(o)}return i}function w(c){const v=new Map;for(const i of c){const o=i.command[0]==="-"?i.command.substring(1):i.command;let n=v.get(o);n||(n=[],v.set(o,n)),n.push(i)}return v}function h(c,v){const i=[...c.keys()],o=[...v.keys()],n=o.filter(r=>!i.includes(r)).reduce((r,a)=>(r.add(a),r),new Set),s=i.filter(r=>!o.includes(r)).reduce((r,a)=>(r.add(a),r),new Set),t=new Set;for(const r of i){if(s.has(r))continue;const a=c.get(r).map(b=>({...b,key:r})),E=v.get(r).map(b=>({...b,key:r}));(0,I.$ub)(a,E,(b,u)=>y(b,u))||t.add(r)}return{added:n,removed:s,updated:t}}function f(c,v,i){const o=[...c.keys()],n=[...v.keys()],s=n.filter(a=>!o.includes(a)).reduce((a,E)=>(a.add(E),a),new Set),t=o.filter(a=>!n.includes(a)).reduce((a,E)=>(a.add(E),a),new Set),r=new Set;for(const a of o){if(t.has(a))continue;const E=c.get(a).map(u=>({...u,key:i[u.key]})),b=v.get(a).map(u=>({...u,key:i[u.key]}));m(E,b)||r.add(a)}return{added:s,removed:t,updated:r}}function m(c,v){return!(!(0,I.$ub)(c.filter(({command:i})=>i[0]!=="-"),v.filter(({command:i})=>i[0]!=="-"),(i,o)=>y(i,o))||!(0,I.$ub)(c.filter(({command:i})=>i[0]==="-"),v.filter(({command:i})=>i[0]==="-"),(i,o)=>y(i,o)))}function y(c,v){if(c.command!==v.command||c.key!==v.key)return!1;const i=j.$ej.deserialize(c.when),o=j.$ej.deserialize(v.when);return!(i&&!o||!i&&o||i&&o&&!i.equals(o)||!A.$Pn(c.args,v.args))}function l(c,v,i){for(const o of v)c=O.edit(c,[-1],o,i);return c}function d(c,v,i){const o=R(c);for(let n=o.length-1;n>=0;n--)(o[n].command===v||o[n].command===`-${v}`)&&(c=O.edit(c,[n],void 0,i));return c}function $(c,v,i,o){const n=R(c),s=n.findIndex(t=>t.command===v||t.command===`-${v}`);for(let t=n.length-1;t>=0;t--)(n[t].command===v||n[t].command===`-${v}`)&&(c=O.edit(c,[t],void 0,o));for(let t=i.length-1;t>=0;t--)c=O.edit(c,[s],i[t],o);return c}}),define(le[239],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$t9b=e.$s9b=void 0;function I(j,O,R){const k={},g={},C=new Set;if(!O)return{local:{added:k,updated:g,removed:[...C.values()]},remote:{added:j,updated:{},removed:[]},conflicts:[]};const S=L(j,O);if(S.added.size===0&&S.removed.size===0&&S.updated.size===0)return{local:{added:k,updated:g,removed:[...C.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const w=L(R,j),h=L(R,O),f={},m={},y=new Set,l=new Set;for(const d of w.removed.values())h.updated.has(d)?k[d]=O[d]:y.add(d);for(const d of h.removed.values())l.has(d)||(w.updated.has(d)?l.add(d):C.add(d));for(const d of w.updated.values())l.has(d)||(h.updated.has(d)?S.updated.has(d)&&l.add(d):m[d]=j[d]);for(const d of h.updated.values())l.has(d)||(w.updated.has(d)?S.updated.has(d)&&l.add(d):j[d]!==void 0&&(g[d]=O[d]));for(const d of w.added.values())l.has(d)||(h.added.has(d)?S.updated.has(d)&&l.add(d):f[d]=j[d]);for(const d of h.added.values())l.has(d)||(w.added.has(d)?S.updated.has(d)&&l.add(d):k[d]=O[d]);return{local:{added:k,removed:[...C.values()],updated:g},remote:{added:f,removed:[...y.values()],updated:m},conflicts:[...l.values()]}}e.$s9b=I;function L(j,O){const R=j?Object.keys(j):[],k=O?Object.keys(O):[],g=k.filter(w=>!R.includes(w)).reduce((w,h)=>(w.add(h),w),new Set),C=R.filter(w=>!k.includes(w)).reduce((w,h)=>(w.add(h),w),new Set),S=new Set;for(const w of R){if(C.has(w))continue;const h=j[w],f=O[w];h!==f&&S.add(w)}return{added:g,removed:C,updated:S}}function A(j,O){const{added:R,removed:k,updated:g}=L(j,O);return R.size===0&&k.size===0&&g.size===0}e.$t9b=A}),define(le[240],he([0,1,30]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$d$b=void 0;function L(j,O,R,k){const g={added:[],removed:[],updated:[]};let C={added:[],removed:[],updated:[]};if(!O){const w=j.filter(({id:h})=>!k.includes(h));return w.length?C.added=w:C=null,{local:g,remote:C}}const S=A(j,O,k);if(S.added.length>0||S.removed.length>0||S.updated.length>0){const w=A(R,j,k),h=A(R,O,k);for(const f of h.removed){const m=j.find(y=>y.id===f);m&&g.removed.push(m)}for(const f of h.added){const m=O.find(y=>y.id===f);w.added.includes(f)?S.updated.includes(f)&&g.updated.push(m):g.added.push(m)}for(const f of h.updated)g.updated.push(O.find(m=>m.id===f));for(const f of w.added)h.added.includes(f)||C.added.push(j.find(m=>m.id===f));for(const f of w.updated)h.removed.includes(f)||h.updated.includes(f)||C.updated.push(j.find(m=>m.id===f));for(const f of w.removed){const m=O.find(y=>y.id===f);m&&C.removed.push(m)}}return C.added.length===0&&C.removed.length===0&&C.updated.length===0&&(C=null),{local:g,remote:C}}e.$d$b=L;function A(j,O,R){j=j?j.filter(({id:h})=>!R.includes(h)):[],O=O.filter(({id:h})=>!R.includes(h));const k=j.map(({id:h})=>h),g=O.map(({id:h})=>h),C=g.filter(h=>!k.includes(h)),S=k.filter(h=>!g.includes(h)),w=[];for(const{id:h,name:f,shortName:m,icon:y,useDefaultFlags:l}of j){if(S.includes(h))continue;const d=O.find($=>$.id===h);(!d||d.name!==f||d.shortName!==m||d.icon!==y||!(0,I.$Pn)(d.useDefaultFlags,l))&&w.push(h)}return{added:C,removed:S,updated:w}}}),define(le[25],he([0,1,17,12,176,44,29,4,102,41]),function(se,e,I,L,A,j,O,R,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xpb=e.$wpb=e.$vpb=e.$upb=e.$tpb=e.$spb=e.$rpb=e.$qpb=e.$ppb=e.$opb=e.$npb=e.MergeState=e.Change=e.SyncStatus=e.$mpb=e.$lpb=e.$kpb=e.UserDataSyncErrorCode=e.$jpb=e.$ipb=e.$hpb=e.$gpb=e.$fpb=e.$epb=e.$dpb=e.$cpb=e.$bpb=e.SyncResource=e.$apb=e.$_ob=e.$$ob=e.$0ob=e.$9ob=e.$8ob=void 0;function C(){const t=g.$Xn.as(j.$3n.Configuration).getConfigurationProperties();return Object.keys(t).filter(r=>!!t[r].disallowSyncIgnore)}e.$8ob=C;function S(){const t=g.$Xn.as(j.$3n.Configuration).getConfigurationProperties(),r=Object.keys(t).filter(b=>!!t[b].ignoreSync),a=Object.keys(t).filter(b=>t[b].scope===2||t[b].scope===6),E=C();return(0,I.$Mb)([...r,...a,...E])}e.$9ob=S,e.$0ob="settingsSync",e.$$ob="settingsSync.keybindingsPerPlatform";function w(){const t="vscode://schemas/ignoredSettings",r=g.$Xn.as(j.$3n.Configuration);r.registerConfiguration({id:"settingsSync",order:30,title:(0,A.localize)(0,null),type:"object",properties:{[e.$$ob]:{type:"boolean",description:(0,A.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,A.localize)(2,null),items:[{type:"string",pattern:O.$Co,errorMessage:(0,A.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,A.localize)(4,null),default:[],scope:1,$ref:t,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const a=g.$Xn.as(k.$Yn.JSONContribution),E=()=>{const b=C(),u=S(),p=Object.keys(j.$4n.properties).filter(F=>!u.includes(F)),P=u.filter(F=>!b.includes(F)),N={items:{type:"string",enum:[...p,...P.map(F=>`-${F}`)]}};a.registerSchema(t,N)};return r.onDidUpdateConfiguration(()=>E())}e.$_ob=w;function h(t){return t&&(0,L.$Vf)(t)&&(0,L.$Tf)(t.id)&&Array.isArray(t.scopes)}e.$apb=h;var f;(function(t){t.Settings="settings",t.Keybindings="keybindings",t.Snippets="snippets",t.Tasks="tasks",t.Extensions="extensions",t.GlobalState="globalState",t.Profiles="profiles",t.WorkspaceState="workspaceState"})(f||(e.SyncResource=f={})),e.$bpb=["settings","keybindings","snippets","tasks","extensions","globalState","profiles"];function m(t,...r){return t?[t,...r]:r}e.$cpb=m;function y(t,r,a,E){return E.joinPath(a.userDataSyncHome,...m(t,r,`lastSync${r}.json`))}e.$dpb=y,e.$epb=(0,R.$gi)("IUserDataSyncStoreManagementService"),e.$fpb=(0,R.$gi)("IUserDataSyncStoreService"),e.$gpb=(0,R.$gi)("IUserDataSyncLocalStoreService"),e.$hpb="x-operation-id",e.$ipb="X-Execution-Id";function l(t){const r={};return r[e.$ipb]=t,r}e.$jpb=l;var d;(function(t){t.Unauthorized="Unauthorized",t.Forbidden="Forbidden",t.NotFound="NotFound",t.MethodNotFound="MethodNotFound",t.Conflict="Conflict",t.Gone="Gone",t.PreconditionFailed="PreconditionFailed",t.TooLarge="TooLarge",t.UpgradeRequired="UpgradeRequired",t.PreconditionRequired="PreconditionRequired",t.TooManyRequests="RemoteTooManyRequests",t.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",t.RequestFailed="RequestFailed",t.RequestCanceled="RequestCanceled",t.RequestTimeout="RequestTimeout",t.RequestProtocolNotSupported="RequestProtocolNotSupported",t.RequestPathNotEscaped="RequestPathNotEscaped",t.RequestHeadersNotObject="RequestHeadersNotObject",t.NoCollection="NoCollection",t.NoRef="NoRef",t.EmptyResponse="EmptyResponse",t.TurnedOff="TurnedOff",t.SessionExpired="SessionExpired",t.ServiceChanged="ServiceChanged",t.DefaultServiceChanged="DefaultServiceChanged",t.LocalTooManyProfiles="LocalTooManyProfiles",t.LocalTooManyRequests="LocalTooManyRequests",t.LocalPreconditionFailed="LocalPreconditionFailed",t.LocalInvalidContent="LocalInvalidContent",t.LocalError="LocalError",t.IncompatibleLocalContent="IncompatibleLocalContent",t.IncompatibleRemoteContent="IncompatibleRemoteContent",t.Unknown="Unknown"})(d||(e.UserDataSyncErrorCode=d={}));class $ extends Error{constructor(r,a,E,b){super(r),this.code=a,this.resource=E,this.operationId=b,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.$kpb=$;class c extends ${constructor(r,a,E,b,u){super(r,E,void 0,u),this.url=a,this.serverCode=b}}e.$lpb=c;class v extends ${constructor(r,a){super(r,a)}}e.$mpb=v,function(t){function r(a){if(a instanceof t)return a;const E=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(a.name);if(E&&E[1]){const b=E[2]==="unknown"?void 0:E[2],u=E[3]==="unknown"?void 0:E[3];return new t(a.message,E[1],b,u)}return new t(a.message,"Unknown")}t.toUserDataSyncError=r}($||(e.$kpb=$={}));var i;(function(t){t.Uninitialized="uninitialized",t.Idle="idle",t.Syncing="syncing",t.HasConflicts="hasConflicts"})(i||(e.SyncStatus=i={}));var o;(function(t){t[t.None=0]="None",t[t.Added=1]="Added",t[t.Modified=2]="Modified",t[t.Deleted=3]="Deleted"})(o||(e.Change=o={}));var n;(function(t){t.Preview="preview",t.Conflict="conflict",t.Accepted="accepted"})(n||(e.MergeState=n={})),e.$npb="sync.store.url.type";function s(t){return`sync.enable.${t}`}e.$opb=s,e.$ppb=(0,R.$gi)("IUserDataSyncEnablementService"),e.$qpb=(0,R.$gi)("IUserDataSyncService"),e.$rpb=(0,R.$gi)("IUserDataSyncResourceProviderService"),e.$spb=(0,R.$gi)("IUserDataAutoSyncService"),e.$tpb=(0,R.$gi)("IUserDataSyncUtilService"),e.$upb=(0,R.$gi)("IUserDataSyncLogService"),e.$vpb="userDataSync",e.$wpb="vscode-userdata-sync",e.$xpb="preview"}),define(le[241],he([0,1,30,25]),function(se,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WIb=void 0;function A(O,R,k,g,C){if(!R)return{remote:{added:Object.keys(O),removed:[],updated:[],all:Object.keys(O).length>0?O:null},local:{added:{},removed:[],updated:{}}};const S=j(O,R);if(S.added.size===0&&S.removed.size===0&&S.updated.size===0)return{remote:{added:[],removed:[],updated:[],all:null},local:{added:{},removed:[],updated:{}}};const w=k?j(k,R):{added:Object.keys(R).reduce((d,$)=>(d.add($),d),new Set),removed:new Set,updated:new Set},h=k?j(k,O):{added:Object.keys(O).reduce((d,$)=>(d.add($),d),new Set),removed:new Set,updated:new Set},f={added:{},removed:[],updated:{}},m=I.$Ln(R),y=!k;for(const d of h.added.values())d!==L.$npb&&y&&w.added.has(d)||(m[d]=O[d]);for(const d of h.updated.values())m[d]=O[d];for(const d of h.removed.values())g.unregistered.includes(d)||delete m[d];for(const d of w.added.values()){const $=R[d];if(g.machine.includes(d)){C.info(`GlobalState: Skipped adding ${d} in local storage because it is declared as machine scoped.`);continue}if(k&&h.added.has(d))continue;const c=O[d];c&&c.value===$.value||d===L.$npb&&y&&h.added.has(d)||(c?f.updated[d]=$:f.added[d]=$)}for(const d of w.updated.values()){const $=R[d];if(g.machine.includes(d)){C.info(`GlobalState: Skipped updating ${d} in local storage because it is declared as machine scoped.`);continue}if(h.updated.has(d)||h.removed.has(d))continue;const c=O[d];c&&c.value===$.value||(f.updated[d]=$)}for(const d of w.removed.values()){if(g.machine.includes(d)){C.trace(`GlobalState: Skipped removing ${d} in local storage because it is declared as machine scoped.`);continue}h.updated.has(d)||h.removed.has(d)||f.removed.push(d)}const l=j(R,m);return{local:f,remote:{added:[...l.added],updated:[...l.updated],removed:[...l.removed],all:l.added.size===0&&l.removed.size===0&&l.updated.size===0?null:m}}}e.$WIb=A;function j(O,R){const k=Object.keys(O),g=Object.keys(R),C=g.filter(h=>!k.includes(h)).reduce((h,f)=>(h.add(f),h),new Set),S=k.filter(h=>!g.includes(h)).reduce((h,f)=>(h.add(f),h),new Set),w=new Set;for(const h of k){if(S.has(h))continue;const f=O[h],m=R[h];I.$Pn(f,m)||w.add(h)}return{added:C,removed:S,updated:w}}}),define(le[242],he([0,1,17,34,62,42,30,79,25]),function(se,e,I,L,A,j,O,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DHb=e.$CHb=e.$BHb=e.$AHb=e.$zHb=e.$yHb=void 0;function g(a,E,b){let u=[];b?u=S(b):u=C(E);const p=[],P=[...(0,k.$8ob)()];if(Array.isArray(u))for(const N of u)N.startsWith("-")?P.push(N.substring(1)):p.push(N);return(0,I.$Mb)([...a,...p].filter(N=>!P.includes(N)))}e.$yHb=g;function C(a){let E=a.inspect("settingsSync.ignoredSettings").userValue;return E!==void 0||(E=a.inspect("sync.ignoredSettings").userValue,E!==void 0)?E:a.getValue("settingsSync.ignoredSettings")||[]}function S(a){const E=(0,L.$sn)(a);return E?E["settingsSync.ignoredSettings"]||E["sync.ignoredSettings"]||[]:[]}function w(a,E){const b=(0,L.$sn)(a)||{};let u="{}";for(const p of Object.keys(b)){const P=(0,A.$Hn)(u,[p],b[p],E);u=(0,A.$Kn)(u,P)}return u}e.$zHb=w;function h(a,E,b,u){if(b.length){const p=r(E),P=(0,L.$sn)(E)||{},N=(0,L.$sn)(a);if(!N)return a;const F=[];for(const M of b){const z=P[M],Z=N[M];z===void 0?a=R.edit(a,[M],void 0,u):Z!==void 0?a=R.edit(a,[M],z,u):F.push(i(M,p))}F.sort((M,z)=>M.startOffset-z.startOffset),F.forEach(M=>a=d(M.setting.key,E,a,u))}return a}e.$AHb=h;function f(a,E,b,u,p,P){const N=h(a,E,u,P),F=b!==N,M=b!==E;if(!F&&!M)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(F&&!M)return{conflictsSettings:[],localContent:null,remoteContent:N,hasConflicts:!1};if(M&&!F)return{conflictsSettings:[],localContent:h(E,a,u,P),remoteContent:null,hasConflicts:!1};if(b===null&&y(a)){const T=m(a,E,u)?null:h(E,a,u,P);return{conflictsSettings:[],localContent:T,remoteContent:null,hasConflicts:!1}}let z=a,Z=E;const X=(0,L.$sn)(a),x=(0,L.$sn)(E),W=b?(0,L.$sn)(b):null,Q=u.reduce((T,B)=>(T.add(B),T),new Set),H=l(X,x,Q),V=l(W,X,Q),te=l(W,x,Q),re=new Map,ee=new Set,ae=T=>{ee.add(T);const B=p.filter(({key:q})=>q===T)[0];B?(z=R.edit(z,[T],B.value,P),Z=R.edit(Z,[T],B.value,P)):re.set(T,{key:T,localValue:X[T],remoteValue:x[T]})};for(const T of V.removed.values())te.updated.has(T)?ae(T):Z=R.edit(Z,[T],void 0,P);for(const T of te.removed.values())ee.has(T)||(V.updated.has(T)?ae(T):z=R.edit(z,[T],void 0,P));for(const T of V.updated.values())ee.has(T)||(te.updated.has(T)?H.updated.has(T)&&ae(T):Z=R.edit(Z,[T],X[T],P));for(const T of te.updated.values())ee.has(T)||(V.updated.has(T)?H.updated.has(T)&&ae(T):z=R.edit(z,[T],x[T],P));for(const T of V.added.values())ee.has(T)||(te.added.has(T)?H.updated.has(T)&&ae(T):Z=d(T,z,Z,P));for(const T of te.added.values())ee.has(T)||(V.added.has(T)?H.updated.has(T)&&ae(T):z=d(T,Z,z,P));const G=re.size>0||!m(z,Z,u),U=G||!m(z,a,[]),D=G||!m(Z,E,[]);return{localContent:U?z:null,remoteContent:D?Z:null,conflictsSettings:[...re.values()],hasConflicts:G}}e.$BHb=f;function m(a,E,b){if(a===E)return!0;const u=(0,L.$sn)(a),p=(0,L.$sn)(E),P=b.reduce((M,z)=>(M.add(z),M),new Set),N=r(a).filter(M=>!(M.setting&&P.has(M.setting.key))),F=r(E).filter(M=>!(M.setting&&P.has(M.setting.key)));if(N.length!==F.length)return!1;for(let M=0;M<N.length;M++){const z=N[M],Z=F[M];if(z.setting&&Z.setting){if(z.setting.key!==Z.setting.key||!O.$Pn(u[z.setting.key],p[z.setting.key]))return!1}else if(!z.setting&&!Z.setting){if(z.value!==Z.value)return!1}else return!1}return!0}function y(a){return a?r(a).length===0:!0}e.$CHb=y;function l(a,E,b){const u=a?Object.keys(a).filter(M=>!b.has(M)):[],p=Object.keys(E).filter(M=>!b.has(M)),P=p.filter(M=>!u.includes(M)).reduce((M,z)=>(M.add(z),M),new Set),N=u.filter(M=>!p.includes(M)).reduce((M,z)=>(M.add(z),M),new Set),F=new Set;if(a)for(const M of u){if(N.has(M))continue;const z=a[M],Z=E[M];O.$Pn(z,Z)||F.add(M)}return{added:P,removed:N,updated:F}}function d(a,E,b,u){const p=(0,L.$sn)(E),P=r(E),N=r(b),F=$(a,P,N);return c(b,a,p[a],F,N,u)}e.$DHb=d;function $(a,E,b){const u=E.findIndex(P=>P.setting?.key===a),p=E[u-1];if(p){if(p.setting){const N=i(p.setting.key,b);if(N)return{index:b.indexOf(N),insertAfter:!0}}else{const N=o(u,E);if(N){const F=i(N.setting.key,b);if(F){const M=n(b.indexOf(F),b),z=s(E,N,E[u]);if(M){const Z=s(b,F,M),X=t(z,Z);return X?{index:b.indexOf(X),insertAfter:!0}:{index:b.indexOf(M),insertAfter:!1}}else{const Z=s(b,F,b[b.length-1]),X=t(z,Z);return X?{index:b.indexOf(X),insertAfter:!0}:{index:b.length-1,insertAfter:!0}}}}}const P=E[u+1];if(P)if(P.setting){const N=i(P.setting.key,b);if(N)return{index:b.indexOf(N),insertAfter:!1}}else{const N=n(u,E);if(N){const F=i(N.setting.key,b);if(F){const M=o(b.indexOf(F),b),z=s(E,E[u],N);if(M){const Z=s(b,M,F),X=t(z.reverse(),Z.reverse());return X?{index:b.indexOf(X),insertAfter:!1}:{index:b.indexOf(M),insertAfter:!0}}else{const Z=s(b,b[0],F),X=t(z.reverse(),Z.reverse());return X?{index:b.indexOf(X),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:b.length-1,insertAfter:!0}}function c(a,E,b,u,p,P){let N;return u.index===-1?N=(0,A.$Hn)(a,[E],b,P):N=v(a,E,b,u,p,P).map(F=>(0,A.$In)(a,F,P)[0]),(0,A.$Kn)(a,N)}function v(a,E,b,u,p,P){const N=`${JSON.stringify(E)}: ${JSON.stringify(b)}`,F=(0,j.$En)(P,a),M=p[u.index];if(u.insertAfter){const z=[];if(M.setting)z.push({offset:M.endOffset,length:0,content:","+N});else{const Z=n(u.index,p),X=o(u.index,p),x=X?.setting?.commaOffset;X&&x===void 0&&z.push({offset:X.endOffset,length:0,content:","});const W=x!==void 0&&x>M.endOffset;z.push({offset:W?x+1:M.endOffset,length:0,content:Z?F+N+",":F+N})}return z}else{if(M.setting)return[{offset:M.startOffset,length:0,content:N+","}];const z=(p[u.index-1]&&!p[u.index-1].setting?F:"")+N+(n(u.index,p)?",":"")+F;return[{offset:M.startOffset,length:0,content:z}]}}function i(a,E){return E.filter(b=>b.setting?.key===a)[0]}function o(a,E){for(let b=a-1;b>=0;b--)if(E[b].setting)return E[b]}function n(a,E){for(let b=a+1;b<E.length;b++)if(E[b].setting)return E[b]}function s(a,E,b){const u=a.indexOf(E),p=a.indexOf(b);return a.filter((P,N)=>u<N&&N<p)}function t(a,E){if(a.length&&E.length){let b=0;for(;b<E.length&&b<a.length;b++)if(a[b].value!==E[b].value)return E[b-1];return E[b-1]}}function r(a){const E=[];let b=-1,u,p;const P={onObjectBegin:N=>{b++},onObjectProperty:(N,F,M)=>{b===0&&(u=F,p=N)},onObjectEnd:(N,F)=>{b--,b===0&&E.push({startOffset:u,endOffset:N+F,value:a.substring(u,N+F),setting:{key:p,commaOffset:void 0}})},onArrayBegin:(N,F)=>{b++},onArrayEnd:(N,F)=>{b--,b===0&&E.push({startOffset:u,endOffset:N+F,value:a.substring(u,N+F),setting:{key:p,commaOffset:void 0}})},onLiteralValue:(N,F,M)=>{b===0&&E.push({startOffset:u,endOffset:F+M,value:a.substring(u,F+M),setting:{key:p,commaOffset:void 0}})},onSeparator:(N,F,M)=>{if(b===0&&N===","){let z=E.length-1;for(;z>=0&&!E[z].setting;z--);const Z=E[z];Z&&E.splice(z,1,{startOffset:Z.startOffset,endOffset:Z.endOffset,value:Z.value,setting:{key:Z.setting.key,commaOffset:F}})}},onComment:(N,F)=>{b===0&&E.push({startOffset:N,endOffset:N+F,value:a.substring(N,N+F)})}};return(0,L.$zn)(a,P),E}}),define(le[80],he([0,1,3,2,4,25]),function(se,e,I,L,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jHb=e.$iHb=void 0,e.$iHb=(0,A.$gi)("IUserDataSyncAccountService");let O=class extends L.$Tc{get account(){return this.a}constructor(k,g){super(),this.g=k,this.h=g,this.b=this.B(new I.$6d),this.onDidChangeAccount=this.b.event,this.c=this.B(new I.$6d),this.onTokenFailed=this.c.event,this.f=!1,this.B(k.onTokenFailed(C=>{this.h.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.f,C),this.updateAccount(void 0),C==="Forbidden"?this.c.fire(!0):this.c.fire(this.f),this.f=!0})),this.B(k.onTokenSucceed(()=>this.f=!1))}async updateAccount(k){(k&&this.a?k.token!==this.a.token||k.authenticationProviderId!==this.a.authenticationProviderId:k!==this.a)&&(this.a=k,this.a&&this.g.setAuthToken(this.a.token,this.a.authenticationProviderId),this.b.fire(k))}};e.$jHb=O,e.$jHb=O=ye([K(0,j.$fpb),K(1,j.$upb)],O)}),define(le[243],he([0,1,20,177,16,8,25]),function(se,e,I,L,A,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FJb=void 0;let R=class extends j.$Fj{constructor(g,C){super(),this.g=this.B(g.createLogger((0,I.$Tg)(C.logsHome,`${O.$vpb}.log`),{id:O.$vpb,name:(0,L.localize)(0,null)}))}trace(g,...C){this.g.trace(g,...C)}debug(g,...C){this.g.debug(g,...C)}info(g,...C){this.g.info(g,...C)}warn(g,...C){this.g.warn(g,...C)}error(g,...C){this.g.error(g,...C)}flush(){this.g.flush()}};e.$FJb=R,e.$FJb=R=ye([K(0,j.$Bj),K(1,A.$ni)],R)}),define(le[244],he([0,1,6,3,2]),function(se,e,I,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wac=void 0;class j extends A.$Tc{constructor({onDidOpenMainWindow:R,onDidFocusMainWindow:k,getActiveWindowId:g}){super(),this.a=this.B(new A.$Sc),L.Event.latch(L.Event.any(R,k))(this.f,this,this.a),this.b=(0,I.$6g)(()=>g()),(async()=>{try{const S=await this.b;this.c=typeof this.c=="number"?this.c:S}catch{}finally{this.b=void 0}})()}f(R){this.b&&(this.b.cancel(),this.b=void 0),this.c=R}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$wac=j}),define(le[112],he([0,1,180,15,48,20,10,4,23]),function(se,e,I,L,A,j,O,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Li=e.$Ki=e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.$Di=e.$Ci=e.$Bi=e.$Ai=e.$zi=e.$yi=e.$xi=e.WorkbenchState=e.$wi=e.$vi=e.$ui=e.$ti=e.$si=e.$ri=e.$qi=e.$pi=void 0,e.$pi=(0,R.$gi)("contextService");function g(s){const t=s;return typeof t?.id=="string"&&O.URI.isUri(t.uri)}e.$qi=g;function C(s){return typeof s?.id=="string"&&!g(s)&&!w(s)}e.$ri=C,e.$si={id:"ext-dev"},e.$ti={id:"empty-window"};function S(s,t){if(typeof s=="string"||typeof s>"u")return typeof s=="string"?{id:(0,L.$nc)(s)}:t?e.$si:e.$ti;const r=s;return r.configuration?{id:r.id,configPath:r.configuration}:r.folders.length===1?{id:r.id,uri:r.folders[0].uri}:{id:r.id}}e.$ui=S;function w(s){const t=s;return typeof t?.id=="string"&&O.URI.isUri(t.configPath)}e.$vi=w;function h(s){const t=s;if(t?.uri)return{id:t.id,uri:O.URI.revive(t.uri)};const r=s;if(r?.configPath)return{id:r.id,configPath:O.URI.revive(r.configPath)};if(s?.id)return{id:s.id}}e.$wi=h;var f;(function(s){s[s.EMPTY=1]="EMPTY",s[s.FOLDER=2]="FOLDER",s[s.WORKSPACE=3]="WORKSPACE"})(f||(e.WorkbenchState=f={}));function m(s){const t=s;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&Array.isArray(t.folders))}e.$xi=m;function y(s){const t=s;return!!(t&&typeof t=="object"&&O.URI.isUri(t.uri)&&typeof t.name=="string"&&typeof t.toResource=="function")}e.$yi=y;class l{constructor(t,r,a,E,b){this.h=t,this.j=a,this.k=E,this.l=b,this.c=A.$mi.forUris(this.l,()=>!0),this.folders=r}update(t){this.h=t.id,this.k=t.configuration,this.j=t.transient,this.l=t.l,this.folders=t.folders}get folders(){return this.g}set folders(t){this.g=t,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(t){this.k=t}getFolder(t){return t&&this.c.findSubstr(t)||null}n(){this.c=A.$mi.forUris(this.l,()=>!0);for(const t of this.folders)this.c.set(t.uri,t)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$zi=l;class d{constructor(t,r){this.raw=r,this.uri=t.uri,this.index=t.index,this.name=t.name}toResource(t){return(0,j.$Tg)(this.uri,t)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Ai=d;function $(s){return new d({uri:s,index:0,name:(0,j.$Pg)(s)},{uri:s.toString()})}e.$Bi=$,e.$Ci="code-workspace",e.$Di=`.${e.$Ci}`,e.$Ei=[{name:(0,I.localize)(0,null),extensions:[e.$Ci]}],e.$Fi="workspace.json";function c(s,t){return j.$Kg.isEqualOrParent(s,t.untitledWorkspacesHome)}e.$Gi=c;function v(s){let t;return O.URI.isUri(s)?t=s:t=s.configuration,t?.scheme===k.Schemas.tmp}e.$Hi=v,e.$Ii="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function i(s){return s.id===e.$Ii}e.$Ji=i;function o(s,t){return!c(s,t)&&!v(s)}e.$Ki=o;function n(s){return(typeof s=="string"?(0,L.$oc)(s):(0,j.$Rg)(s))===e.$Di}e.$Li=n}),define(le[18],he([0,1,54,3,2,20,10,171,16,11,4,8,112,35,28,6,32,27,12]),function(se,e,I,L,A,j,O,R,k,g,C,S,w,h,f,m,y,l,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kl=e.$jl=e.$il=e.$hl=e.$gl=e.$fl=e.ProfileResourceType=void 0;var $;(function(s){s.Settings="settings",s.Keybindings="keybindings",s.Snippets="snippets",s.Tasks="tasks",s.Extensions="extensions",s.GlobalState="globalState"})($||(e.ProfileResourceType=$={}));function c(s){const t=s;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&typeof t.isDefault=="boolean"&&typeof t.name=="string"&&O.URI.isUri(t.location)&&O.URI.isUri(t.globalStorageHome)&&O.URI.isUri(t.settingsResource)&&O.URI.isUri(t.keybindingsResource)&&O.URI.isUri(t.tasksResource)&&O.URI.isUri(t.snippetsHome)&&O.URI.isUri(t.extensionsResource))}e.$fl=c,e.$gl=(0,C.$gi)("IUserDataProfilesService");function v(s,t){return{id:s.id,isDefault:s.isDefault,name:s.name,shortName:s.shortName,icon:s.icon,location:O.URI.revive(s.location).with({scheme:t}),globalStorageHome:O.URI.revive(s.globalStorageHome).with({scheme:t}),settingsResource:O.URI.revive(s.settingsResource).with({scheme:t}),keybindingsResource:O.URI.revive(s.keybindingsResource).with({scheme:t}),tasksResource:O.URI.revive(s.tasksResource).with({scheme:t}),snippetsHome:O.URI.revive(s.snippetsHome).with({scheme:t}),extensionsResource:O.URI.revive(s.extensionsResource).with({scheme:t}),cacheHome:O.URI.revive(s.cacheHome).with({scheme:t}),useDefaultFlags:s.useDefaultFlags,isTransient:s.isTransient}}e.$hl=v;function i(s,t,r,a,E,b){return{id:s,name:t,location:r,isDefault:!1,shortName:E?.shortName,icon:E?.icon,globalStorageHome:b&&E?.useDefaultFlags?.globalState?b.globalStorageHome:(0,j.$Tg)(r,"globalStorage"),settingsResource:b&&E?.useDefaultFlags?.settings?b.settingsResource:(0,j.$Tg)(r,"settings.json"),keybindingsResource:b&&E?.useDefaultFlags?.keybindings?b.keybindingsResource:(0,j.$Tg)(r,"keybindings.json"),tasksResource:b&&E?.useDefaultFlags?.tasks?b.tasksResource:(0,j.$Tg)(r,"tasks.json"),snippetsHome:b&&E?.useDefaultFlags?.snippets?b.snippetsHome:(0,j.$Tg)(r,"snippets"),extensionsResource:b&&E?.useDefaultFlags?.extensions?b.extensionsResource:(0,j.$Tg)(r,"extensions.json"),cacheHome:(0,j.$Tg)(a,s),useDefaultFlags:E?.useDefaultFlags,isTransient:E?.transient}}e.$il=i;let o=class extends A.$Tc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(t,r,a,E){super(),this.t=t,this.u=r,this.w=a,this.y=E,this.f=!0,this.h=this.B(new L.$6d),this.onDidChangeProfiles=this.h.event,this.j=this.B(new L.$6d),this.onWillCreateProfile=this.j.event,this.m=this.B(new L.$6d),this.onWillRemoveProfile=this.m.event,this.n=this.B(new L.$6d),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new h.$Ac,emptyWindows:new Map},this.profilesHome=(0,j.$Tg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,j.$Tg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(t){this.f!==t&&(this.z=void 0,this.f=t)}isEnabled(){return this.f}get C(){if(!this.z){const t=this.D(),r=[t];if(this.f)try{for(const b of this.O()){if(!b.name||!(0,d.$Tf)(b.name)||!b.location){this.y.warn("Skipping the invalid stored profile",b.location||b.name);continue}r.push(i((0,j.$Qg)(b.location),b.name,b.location,this.g,{shortName:b.shortName,icon:b.icon,useDefaultFlags:b.useDefaultFlags},t))}}catch(b){this.y.error(b)}const a=new h.$Ac,E=new Map;if(r.length)try{const b=this.Q();if(b.workspaces)for(const[u,p]of Object.entries(b.workspaces)){const P=O.URI.parse(u),N=r.find(F=>F.id===p);N&&a.set(P,N)}if(b.emptyWindows)for(const[u,p]of Object.entries(b.emptyWindows)){const P=r.find(N=>N.id===p);P&&E.set(u,P)}}catch(b){this.y.error(b)}this.z={profiles:r,workspaces:a,emptyWindows:E}}return this.z}D(){const t=i("__default__profile__",(0,R.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...t,extensionsResource:this.S()??t.extensionsResource,isDefault:!0}}async createTransientProfile(t){const r="Temp",a=new RegExp(`${(0,l.$Ye)(r)}\\s(\\d+)`);let E=0;for(const u of this.profiles){const p=a.exec(u.name),P=p?parseInt(p[1]):0;E=P>E?P:E}const b=`${r} ${E+1}`;return this.createProfile((0,I.$7i)((0,y.$Cg)()).toString(16),b,{transient:!0},t)}async createNamedProfile(t,r,a){return this.createProfile((0,I.$7i)((0,y.$Cg)()).toString(16),t,r,a)}async createProfile(t,r,a,E){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const b=await this.F(t,r,a);return E&&await this.setProfileForWorkspace(E,b),b}async F(t,r,a){if(!(0,d.$Tf)(r)||!r)throw new Error("Name of the profile is mandatory and must be of type `string`");let E=this.r.get(r);return E||(E=(async()=>{try{const b=this.profiles.find(P=>P.name===r||P.id===t);if(b)return b;const u=i(t,r,(0,j.$Tg)(this.profilesHome,t),this.g,a,this.defaultProfile);await this.u.createFolder(u.location);const p=[];return this.j.fire({profile:u,join(P){p.push(P)}}),await m.Promises.settled(p),this.I([u],[],[]),u}finally{this.r.delete(r)}})(),this.r.set(r,E)),E}async updateProfile(t,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let a=this.profiles.find(E=>E.id===t.id);if(!a)throw new Error(`Profile '${t.name}' does not exist`);return a=i(a.id,r.name??a.name,a.location,this.g,{shortName:r.shortName??a.shortName,icon:r.icon===null?void 0:r.icon??a.icon,transient:r.transient??a.isTransient,useDefaultFlags:r.useDefaultFlags??a.useDefaultFlags},this.defaultProfile),this.I([],[],[a]),a}async removeProfile(t){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(t.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(E=>E.id===t.id);if(!r)throw new Error(`Profile '${t.name}' does not exist`);const a=[];this.m.fire({profile:r,join(E){a.push(E)}});try{await Promise.allSettled(a)}catch(E){this.y.error(E)}for(const E of[...this.C.emptyWindows.keys()])r.id===this.C.emptyWindows.get(E)?.id&&this.C.emptyWindows.delete(E);for(const E of[...this.C.workspaces.keys()])r.id===this.C.workspaces.get(E)?.id&&this.C.workspaces.delete(E);this.M(),this.I([],[r],[]);try{await this.u.del(r.cacheHome,{recursive:!0})}catch(E){(0,g.$Xk)(E)!==1&&this.y.error(E)}}async setProfileForWorkspace(t,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const a=this.profiles.find(E=>E.id===r.id);if(!a)throw new Error(`Profile '${r.name}' does not exist`);this.L(t,a)}unsetWorkspace(t,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(t,void 0,r)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const t=await this.u.resolve(this.profilesHome);await Promise.all((t.children||[]).filter(r=>r.isDirectory&&this.profiles.every(a=>!this.w.extUri.isEqual(a.location,r.resource))).map(r=>this.u.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const t=this.s.profiles.filter(r=>!this.H(r));await Promise.allSettled(t.map(r=>this.removeProfile(r)))}getProfileForWorkspace(t){const r=this.G(t);return O.URI.isUri(r)?this.s.workspaces.get(r)??this.C.workspaces.get(r):this.s.emptyWindows.get(r)??this.C.emptyWindows.get(r)}G(t){return(0,w.$qi)(t)?t.uri:(0,w.$vi)(t)?t.configPath:t.id}H(t){return!!([...this.s.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,t.location))||[...this.s.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,t.location))||[...this.C.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,t.location))||[...this.C.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,t.location)))}I(t,r,a){const E=[...this.profiles,...t],b=[];this.s.profiles=[];for(let u of E)u.isDefault||r.some(p=>u.id===p.id)||(u=a.find(p=>u.id===p.id)??u,u.isTransient?this.s.profiles.push(u):b.push({location:u.location,name:u.name,shortName:u.shortName,icon:u.icon,useDefaultFlags:u.useDefaultFlags}));this.P(b),this.z=void 0,this.J(t,r,a)}J(t,r,a){this.h.fire({added:t,removed:r,updated:a,all:this.profiles})}L(t,r,a){a=r?.isTransient?!0:a,a||this.L(t,void 0,!0);const E=this.G(t),b=a?this.s:this.C;O.URI.isUri(E)?(b.workspaces.delete(E),r&&b.workspaces.set(E,r)):(b.emptyWindows.delete(E),r&&b.emptyWindows.set(E,r)),a||this.M()}M(){const t={};for(const[a,E]of this.C.workspaces.entries())t[a.toString()]=E.id;const r={};for(const[a,E]of this.C.emptyWindows.entries())r[a.toString()]=E.id;this.R({workspaces:t,emptyWindows:r}),this.z=void 0}N(t){const r={},a=this.D();if(t.workspaces)for(const[b,u]of Object.entries(t.workspaces)){const p=O.URI.parse(u);r[b]=this.w.extUri.isEqual(p,a.location)?a.id:this.w.extUri.basename(p)}const E={};if(t.emptyWindows)for(const[b,u]of Object.entries(t.emptyWindows)){const p=O.URI.parse(u);E[b]=this.w.extUri.isEqual(p,a.location)?a.id:this.w.extUri.basename(p)}return{workspaces:r,emptyWindows:E}}O(){return[]}P(t){throw new Error("not implemented")}Q(){return{}}R(t){throw new Error("not implemented")}S(){}};e.$jl=o,e.$jl=o=ye([K(0,k.$ni),K(1,g.$Gk),K(2,f.$el),K(3,S.$Aj)],o);class n extends o{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(t){this.a=t}Q(){return this.X}R(t){this.X=t}}e.$kl=n}),define(le[245],he([0,1,6,2,18]),function(se,e,I,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ibc=void 0;let j=class extends L.$Tc{constructor(R){super(),this.B(new I.$sh(()=>{R.cleanUp()},10*1e3)).schedule()}};e.$Ibc=j,e.$Ibc=j=ye([K(0,A.$gl)],j)}),define(le[246],he([0,1,17,6,26,7,3,2,5,12,10,154,29,33,45,8,24,22,28,18]),function(se,e,I,L,A,j,O,R,k,g,C,S,w,h,f,m,y,l,d,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9p=e.$8p=e.$7p=e.$6p=void 0;let c=class extends R.$Tc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(t,r,a,E,b,u){super(),this.z=t,this.C=r,this.D=a,this.F=E,this.G=b,this.H=u,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new O.$6d),this.s=this.B(new O.$6d),this.t=this.B(new O.$6d),this.u=this.B(new O.$6d),this.w=this.B(new O.$6d),this.y=[],this.B((0,R.$Rc)(()=>{this.j.forEach(({task:p})=>p.cancel()),this.m.forEach(p=>p.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(t){const r=await this.getTargetPlatform();return t.allTargetPlatforms.some(a=>(0,w.$Mo)(a,t.allTargetPlatforms,r))}async installFromGallery(t,r={}){try{const E=(await this.installGalleryExtensions([{extension:t,options:r}])).find(({identifier:b})=>(0,h.$dp)(b,t.identifier));if(E?.local)return E?.local;throw E?.error?E.error:new w.$Po(`Unknown error while installing extension ${t.identifier.id}`,w.ExtensionManagementErrorCode.Unknown)}catch(a){throw i(a)}}async installGalleryExtensions(t){if(!this.z.isEnabled())throw new w.$Po(S.localize(0,null),w.ExtensionManagementErrorCode.NotAllowed);const r=[],a=[];await Promise.allSettled(t.map(async({extension:E,options:b})=>{try{const u=await this.N(E,!!b?.installGivenVersion,!!b?.installPreReleaseVersion);a.push({...u,options:b})}catch(u){r.push({identifier:E.identifier,operation:2,source:E,error:u})}})),a.length&&r.push(...await this.I(a));for(const E of r)E.error&&(this.F.error("Failed to install extension.",E.identifier.id),this.F.error(E.error),E.source&&!C.URI.isUri(E.source)&&o(this.C,"extensionGallery:install",{extensionData:(0,h.$lp)(E.source),error:E.error}));return r}async uninstall(t,r={}){return this.F.trace("ExtensionManagementService#uninstall",t.identifier.id),this.P(t,r)}async toggleAppliationScope(t,r){if((0,f.$Dm)(t.manifest)||t.isBuiltin)return t;if(t.isApplicationScoped){let a=await this.updateMetadata(t,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(r,this.H.defaultProfile.extensionsResource)||(a=await this.$(t,this.H.defaultProfile.extensionsResource,r));for(const E of this.H.profiles){const b=(await this.getInstalled(1,E.extensionsResource)).find(u=>(0,h.$dp)(u.identifier,t.identifier));b?this.w.fire(b):this.u.fire({identifier:t.identifier,profileLocation:E.extensionsResource})}return a}else{const a=this.D.extUri.isEqual(r,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(t,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.$(t,r,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:a.identifier,operation:2,local:a,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),a}}getExtensionsControlManifest(){const t=new Date().getTime();return(!this.g||t-this.h>1e3*60*5)&&(this.g=this.W(),this.h=t),this.g}registerParticipant(t){this.y.push(t)}async I(t){const r=[],a=new Map,E=[],b=[],u=(P,N)=>`${h.$ep.create(P).toString()}-${N.toString()}`,p=(P,N,F)=>{const M=this.Y(P,N,F),z=C.URI.isUri(N)?N.path:`${N.identifier.id.toLowerCase()}-${F.profileLocation.toString()}`;a.set(z,{task:M,manifest:P}),this.n.fire({identifier:M.identifier,source:N,profileLocation:F.profileLocation}),this.F.info("Installing extension:",M.identifier.id),C.URI.isUri(N)||this.j.set(u(N,F.profileLocation),{task:M,waitingTasks:[]})};try{for(const{manifest:P,extension:N,options:F}of t){const M=F.isApplicationScoped||F.isBuiltin||(0,f.$Dm)(P),z={...F,installOnlyNewlyAddedFromExtensionPack:F.installOnlyNewlyAddedFromExtensionPack??!C.URI.isUri(N),isApplicationScoped:M,profileLocation:M?this.H.defaultProfile.extensionsResource:F.profileLocation??this.X()},Z=C.URI.isUri(N)?void 0:this.j.get(u(N,z.profileLocation));Z?(this.F.info("Extension is already requested to install",Z.task.identifier.id),E.push(Z.task.waitUntilTaskIsFinished())):p(P,N,z)}await Promise.all([...a.values()].map(async({task:P,manifest:N})=>{if(P.options.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",P.identifier.id);else try{const F=await this.M(P.identifier,N,!!P.options.installOnlyNewlyAddedFromExtensionPack,!!P.options.installPreReleaseVersion,P.options.profileLocation),M=await this.getInstalled(void 0,P.options.profileLocation),z={...P.options,donotIncludePackAndDependencies:!0,context:{...P.options.context,[w.$Ho]:!0}};for(const{gallery:Z,manifest:X}of(0,I.$Mb)(F,({gallery:x})=>x.identifier.id)){if(a.has(`${Z.identifier.id.toLowerCase()}-${z.profileLocation.toString()}`))continue;const x=this.j.get(u(Z,z.profileLocation));if(x){if(this.J(P,x.task)){const W=x.task.identifier;this.F.info("Waiting for already requested installing extension",W.id,P.identifier.id),x.waitingTasks.push(P),E.push(O.Event.toPromise(O.Event.filter(this.onDidInstallExtensions,Q=>Q.some(H=>(0,h.$dp)(H.identifier,W)))).then(Q=>{if(this.F.info("Finished waiting for already requested installing extension",W.id,P.identifier.id),!Q.find(V=>(0,h.$dp)(V.identifier,W))?.local)throw new Error(`Extension ${W.id} is not installed`)}))}}else M.some(({identifier:W})=>(0,h.$dp)(W,Z.identifier))||p(X,Z,z)}}catch(F){if(C.URI.isUri(P.source))(0,I.$Lb)(N.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",P.identifier.id,F.message),(0,I.$Lb)(N.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",P.identifier.id,F.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",P.identifier.id),F}})),await this.L([...a.values()].map(async({task:P})=>{const N=new Date().getTime();try{const F=await P.run();if(await this.L(this.y.map(M=>M.postInstall(F,P.source,P.options,A.CancellationToken.None))),!C.URI.isUri(P.source)){const M=P.operation===3,z=M?void 0:(new Date().getTime()-P.source.lastUpdated)/1e3;if(o(this.C,M?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,h.$lp)(P.source),verificationStatus:P.verificationStatus,duration:new Date().getTime()-N,durationSinceUpdate:z}),k.$o&&P.operation!==3)try{await this.z.reportStatistic(F.manifest.publisher,F.manifest.name,F.manifest.version,"install")}catch{}}b.push({local:F,identifier:P.identifier,operation:P.operation,source:P.source,context:P.options.context,profileLocation:P.profileLocation,applicationScoped:F.isApplicationScoped})}catch(F){throw this.F.error("Error while installing the extension",P.identifier.id,(0,j.$0)(F)),F}})),E.length&&await this.L(E);for(const P of b)this.F.info("Extension installed successfully:",P.identifier.id),r.push(P);return r}catch(P){b.length&&await Promise.allSettled(b.map(async({local:N,profileLocation:F})=>{try{await this.Z(N,{versionOnly:!0,profileLocation:F}).run(),this.F.info("Rollback: Uninstalled extension",N.identifier.id)}catch(M){this.F.warn("Rollback: Error while uninstalling extension",N.identifier.id,(0,j.$0)(M))}}));for(const{task:N}of a.values())N.cancel(),r.push({identifier:N.identifier,operation:2,source:N.source,context:N.options.context,profileLocation:N.profileLocation,error:P});throw P}finally{for(const{task:P}of a.values())P.source&&!C.URI.isUri(P.source)&&this.j.delete(u(P.source,P.profileLocation));r.length&&this.s.fire(r)}}J(t,r){for(const[,{task:a,waitingTasks:E}]of this.j.entries())if(a===t&&(E.includes(r)||E.some(b=>this.J(b,r)))||a===r&&E[0]&&!this.J(t,E[0]))return!1;return!0}async L(t){const r=[],a=[],E=await Promise.allSettled(t);for(const b of E)b.status==="fulfilled"?r.push(b.value):a.push(b.reason);if(a.length)throw v(a);return r}async M(t,r,a,E,b){if(!this.z.isEnabled())return[];const u=await this.getInstalled(void 0,b),p=[],P=[],N=async(F,M)=>{p.push(F);const z=M.extensionDependencies||[],Z=[...z];if(M.extensionPack){const X=a?u.find(x=>(0,h.$dp)(x.identifier,F)):void 0;for(const x of M.extensionPack)X&&X.manifest.extensionPack&&X.manifest.extensionPack.some(W=>(0,h.$dp)({id:W},{id:x}))||Z.every(W=>!(0,h.$dp)({id:W},{id:x}))&&Z.push(x)}if(Z.length){const X=Z.filter(x=>p.every(W=>!(0,h.$dp)(W,{id:x})));if(X.length){const x=await this.z.getExtensions(X.map(W=>({id:W,preRelease:E})),A.CancellationToken.None);for(const W of x){if(p.find(V=>(0,h.$dp)(V,W.identifier)))continue;const Q=z.some(V=>(0,h.$dp)({id:V},W.identifier));let H;try{H=await this.N(W,!1,E)}catch(V){if(Q)throw V;this.F.info("Skipping the packed extension as it cannot be installed",W.identifier.id,(0,j.$0)(V));continue}P.push({gallery:H.extension,manifest:H.manifest}),await N(H.extension.identifier,H.manifest)}}}};return await N(t,r),P}async N(t,r,a){let E;const b=await this.getExtensionsControlManifest();if(b.malicious.some(P=>(0,h.$dp)(t.identifier,P)))throw new w.$Po(S.localize(1,null,t.identifier.id),w.ExtensionManagementErrorCode.Malicious);const u=b.deprecated[t.identifier.id.toLowerCase()];if(u?.extension?.autoMigrate){if(this.F.info(`The '${t.identifier.id}' extension is deprecated, fetching the compatible '${u.extension.id}' extension instead.`),E=(await this.z.getExtensions([{id:u.extension.id,preRelease:u.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0},A.CancellationToken.None))[0],!E)throw new w.$Po(S.localize(2,null,t.identifier.id,u.extension.id),w.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(t)){const P=await this.getTargetPlatform();throw new w.$Po(S.localize(3,null,t.identifier.id,this.G.nameLong,(0,w.$Io)(P)),w.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(E=await this.O(t,r,a),!E)throw!a&&t.properties.isPreReleaseVersion&&(await this.z.getExtensions([t.identifier],A.CancellationToken.None))[0]?new w.$Po(S.localize(4,null,t.displayName??t.identifier.id),w.ExtensionManagementErrorCode.ReleaseVersionNotFound):new w.$Po(S.localize(5,null,t.identifier.id,this.G.nameLong,this.G.version),w.ExtensionManagementErrorCode.Incompatible)}this.F.info("Getting Manifest...",E.identifier.id);const p=await this.z.getManifest(E,A.CancellationToken.None);if(p===null)throw new w.$Po(`Missing manifest for extension ${E.identifier.id}`,w.ExtensionManagementErrorCode.Invalid);if(p.version!==E.version)throw new w.$Po(`Cannot install '${E.identifier.id}' extension because of version mismatch in Marketplace`,w.ExtensionManagementErrorCode.Invalid);return{extension:E,manifest:p}}async O(t,r,a){const E=await this.getTargetPlatform();let b=null;return!r&&t.hasPreReleaseVersion&&t.properties.isPreReleaseVersion!==a&&(b=(await this.z.getExtensions([{...t.identifier,preRelease:a}],{targetPlatform:E,compatible:!0},A.CancellationToken.None))[0]||null),!b&&await this.z.isExtensionCompatible(t,a,E)&&(b=t),b||(r?b=(await this.z.getExtensions([{...t.identifier,version:t.version}],{targetPlatform:E,compatible:!0},A.CancellationToken.None))[0]||null:b=await this.z.getCompatibleExtension(t,a,E)),b}async P(t,r){const a={...r,profileLocation:t.isApplicationScoped?this.H.defaultProfile.extensionsResource:r.profileLocation??this.X()},E=F=>`${F.id.toLowerCase()}${a.versionOnly?`-${t.manifest.version}`:""}${a.profileLocation?`@${a.profileLocation.toString()}`:""}`,b=this.m.get(E(t.identifier));if(b)return this.F.info("Extensions is already requested to uninstall",t.identifier.id),b.waitUntilTaskIsFinished();const u=F=>{const M=this.Z(F,a);return this.m.set(E(M.extension.identifier),M),a.profileLocation?this.F.info("Uninstalling extension from the profile:",`${F.identifier.id}@${F.manifest.version}`,a.profileLocation.toString()):this.F.info("Uninstalling extension:",`${F.identifier.id}@${F.manifest.version}`),this.t.fire({identifier:F.identifier,profileLocation:a.profileLocation,applicationScoped:F.isApplicationScoped}),M},p=(F,M)=>{M?a.profileLocation?this.F.error("Failed to uninstall extension from the profile:",`${F.identifier.id}@${F.manifest.version}`,a.profileLocation.toString(),M.message):this.F.error("Failed to uninstall extension:",`${F.identifier.id}@${F.manifest.version}`,M.message):a.profileLocation?this.F.info("Successfully uninstalled extension from the profile",`${F.identifier.id}@${F.manifest.version}`,a.profileLocation.toString()):this.F.info("Successfully uninstalled extension:",`${F.identifier.id}@${F.manifest.version}`),o(this.C,"extensionGallery:uninstall",{extensionData:(0,h.$kp)(F),error:M}),this.u.fire({identifier:F.identifier,error:M?.code,profileLocation:a.profileLocation,applicationScoped:F.isApplicationScoped})},P=[],N=[];try{P.push(u(t));const F=await this.getInstalled(1,a.profileLocation);if(a.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${t.identifier.id}@${t.manifest.version}`);else{const M=this.S(t,F);for(const z of M)this.m.has(E(z.identifier))?this.F.info("Extensions is already requested to uninstall",z.identifier.id):P.push(u(z))}a.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${t.identifier.id}@${t.manifest.version}`):this.Q(P.map(M=>M.extension),F,t),await this.L(P.map(async M=>{try{if(await M.run(),await this.L(this.y.map(z=>z.postUninstall(M.extension,a,A.CancellationToken.None))),M.extension.identifier.uuid)try{await this.z.reportStatistic(M.extension.manifest.publisher,M.extension.manifest.name,M.extension.manifest.version,"uninstall")}catch{}p(M.extension)}catch(z){const Z=z instanceof w.$Po?z:new w.$Po((0,j.$0)(z),w.ExtensionManagementErrorCode.Internal);throw p(M.extension,Z),Z}finally{N.push(M)}}))}catch(F){const M=F instanceof w.$Po?F:new w.$Po((0,j.$0)(F),w.ExtensionManagementErrorCode.Internal);for(const z of P){try{z.cancel()}catch{}N.includes(z)||p(z.extension,M)}throw M}finally{for(const F of P)this.m.delete(E(F.extension.identifier))||this.F.warn("Uninstallation task is not found in the cache",F.extension.identifier.id)}}Q(t,r,a){for(const E of t){const b=this.U(E,r);if(b.length){const u=b.filter(p=>!t.some(P=>(0,h.$dp)(P.identifier,p.identifier)));if(u.length)throw new Error(this.R(E,u,a))}}}R(t,r,a){return a===t?r.length===1?S.localize(6,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?S.localize(7,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):S.localize(8,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?S.localize(9,null,a.manifest.displayName||a.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?S.localize(10,null,a.manifest.displayName||a.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):S.localize(11,null,a.manifest.displayName||a.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}S(t,r,a=[]){if(a.indexOf(t)!==-1)return[];a.push(t);const E=t.manifest.extensionPack?t.manifest.extensionPack:[];if(E.length){const b=r.filter(p=>!p.isBuiltin&&E.some(P=>(0,h.$dp)({id:P},p.identifier))),u=[];for(const p of b)u.push(...this.S(p,r,a));return[...b,...u]}return[]}U(t,r){return r.filter(a=>a.manifest.extensionDependencies&&a.manifest.extensionDependencies.some(E=>(0,h.$dp)({id:E},t.identifier)))}async W(){try{return this.F.trace("ExtensionManagementService.updateControlCache"),await this.z.getExtensionsControlManifest()}catch(t){return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest",(0,j.$0)(t)),{malicious:[],deprecated:{},search:[]}}}};e.$6p=c,e.$6p=c=ye([K(0,w.$Oo),K(1,l.$Fl),K(2,d.$el),K(3,m.$Aj),K(4,y.$Sj),K(5,$.$gl)],c);function v(s){const t=Array.isArray(s)?s:[s];return t.length===1?t[0]instanceof Error?t[0]:new Error(t[0]):t.reduce((r,a)=>new Error(`${r.message}${r.message?",":""}${a instanceof Error?a.message:a}`),new Error(""))}e.$7p=v;function i(s){if(s instanceof w.$Po)return s;if(s instanceof w.$Qo){const r=new w.$Po(s.message,w.ExtensionManagementErrorCode.Gallery);return r.stack=s.stack,r}const t=new w.$Po(s.message,w.ExtensionManagementErrorCode.Internal);return t.stack=s.stack,t}e.$8p=i;function o(s,t,{extensionData:r,verificationStatus:a,duration:E,error:b,durationSinceUpdate:u}){let p,P;(0,g.$2f)(a)&&(a===!0?a="Verified":(a===!1||(p=w.ExtensionManagementErrorCode.Signature,P=a),a="Unverified")),b&&(b instanceof w.$Po||b instanceof w.$Qo?(p=b.code,b.code===w.ExtensionManagementErrorCode.Signature&&(P=b.message)):p=w.ExtensionManagementErrorCode.Internal),s.publicLog(t,{...r,verificationStatus:a,success:!b,duration:E,errorcode:p,errorcodeDetail:P,durationSinceUpdate:u})}class n{constructor(){this.d=new L.$fh}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,L.$6g)(t=>this.h(t))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,L.$6g)(t=>new Promise((r,a)=>{const E=t.onCancellationRequested(()=>{E.dispose(),a(new j.$5)})})),this.d.open()),this.g.cancel()}}e.$9p=n}),define(le[52],he([0,1,6,14,2,3,35,10,29,33,11,4,8,18,28,12,7,22]),function(se,e,I,L,A,j,O,R,k,g,C,S,w,h,f,m,y,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_p=e.$$p=e.$0p=e.ExtensionsProfileScanningErrorCode=void 0;var d;(function(o){o.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",o.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(d||(e.ExtensionsProfileScanningErrorCode=d={}));class $ extends Error{constructor(n,s){super(n),this.code=s}}e.$0p=$,e.$$p=(0,S.$gi)("IExtensionsProfileScannerService");let c=class extends A.$Tc{constructor(n,s,t,r,a,E){super(),this.j=n,this.m=s,this.n=t,this.r=r,this.s=a,this.t=E,this.b=this.B(new j.$6d),this.onAddExtensions=this.b.event,this.c=this.B(new j.$6d),this.onDidAddExtensions=this.c.event,this.f=this.B(new j.$6d),this.onRemoveExtensions=this.f.event,this.g=this.B(new j.$6d),this.onDidRemoveExtensions=this.g.event,this.h=new O.$Ac}scanProfileExtensions(n,s){return this.u(n,void 0,s)}async addExtensionsToProfile(n,s){const t=[],r=[];try{return await this.u(s,a=>{const E=[];for(const b of a)n.some(([u])=>(0,g.$dp)(u.identifier,b.identifier)&&u.manifest.version!==b.version)?t.push(b):E.push(b);for(const[b,u]of n){const p=E.findIndex(N=>(0,g.$dp)(N.identifier,b.identifier)&&N.version===b.manifest.version),P={identifier:b.identifier,version:b.manifest.version,location:b.location,metadata:u};p===-1?(r.push(P),E.push(P)):E.splice(p,1,P)}return r.length&&this.b.fire({extensions:r,profileLocation:s}),t.length&&this.f.fire({extensions:t,profileLocation:s}),E}),r.length&&this.c.fire({extensions:r,profileLocation:s}),t.length&&this.g.fire({extensions:t,profileLocation:s}),r}catch(a){throw r.length&&this.c.fire({extensions:r,error:a,profileLocation:s}),t.length&&this.g.fire({extensions:t,error:a,profileLocation:s}),a}}async updateMetadata(n,s){const t=[];return await this.u(s,r=>{const a=[];for(const E of r){const b=n.find(([u])=>(0,g.$dp)(u.identifier,E.identifier)&&u.manifest.version===E.version);b&&(E.metadata={...E.metadata,...b[1]},t.push(E)),a.push(E)}return a}),t}async removeExtensionFromProfile(n,s){const t=[];try{await this.u(s,r=>{const a=[];for(const E of r)(0,g.$dp)(E.identifier,n.identifier)?t.push(E):a.push(E);return t.length&&this.f.fire({extensions:t,profileLocation:s}),a}),t.length&&this.g.fire({extensions:t,profileLocation:s})}catch(r){throw t.length&&this.g.fire({extensions:t,error:r,profileLocation:s}),r}}async u(n,s,t){return this.F(n).queue(async()=>{let r=[],a;try{const E=await this.m.readFile(n);a=JSON.parse(E.value.toString().trim()||"[]")}catch(E){if((0,C.$Xk)(E)!==1)throw E;if(this.r.extUri.isEqual(n,this.n.defaultProfile.extensionsResource)&&(a=await this.D()),!a&&t?.bailOutWhenFileNotFound)throw new $((0,y.$0)(E),"ERROR_PROFILE_NOT_FOUND")}if(a){Array.isArray(a)||this.w(n);let E=!1;for(const b of a){v(b)||this.w(n);let u;if((0,m.$Tf)(b.relativeLocation)&&b.relativeLocation)u=this.z(b.relativeLocation);else if((0,m.$Tf)(b.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${b.location}`);continue}else{u=R.URI.revive(b.location);const p=this.y(u);p&&(E=!0,b.relativeLocation=p)}(0,m.$1f)(b.metadata?.hasPreReleaseVersion)&&b.metadata?.preRelease&&(E=!0,b.metadata.hasPreReleaseVersion=!0),r.push({identifier:b.identifier,location:u,version:b.version,metadata:b.metadata})}E&&await this.m.writeFile(n,L.$te.fromString(JSON.stringify(a)))}if(s){r=s(r);const E=r.map(b=>({identifier:b.identifier,version:b.version,location:b.location.toJSON(),relativeLocation:this.y(b.location),metadata:b.metadata}));await this.m.writeFile(n,L.$te.fromString(JSON.stringify(E)))}return r})}w(n){const s=new $(`Invalid extensions content in ${n.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:s.code}),s}y(n){return this.r.extUri.isEqual(this.r.extUri.dirname(n),this.j)?this.r.extUri.basename(n):void 0}z(n){return this.r.extUri.joinPath(this.j,n)}async D(){return this.C||(this.C=(async()=>{const n=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),s=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let t;try{t=(await this.m.readFile(n)).value.toString()}catch(a){if((0,C.$Xk)(a)===1)return;throw a}this.t.info("Migrating extensions from old default profile location",n.toString());let r;try{const a=JSON.parse(t);Array.isArray(a)&&a.every(E=>v(E))?r=a:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",a)}catch(a){this.t.error(a)}if(r)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,L.$te.fromString(JSON.stringify(r)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",n.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(a){if((0,C.$Xk)(a)===3)this.t.info("Migration from old default profile location to new location is done by another window",n.toString(),this.n.defaultProfile.extensionsResource.toString());else throw a}try{await this.m.del(n)}catch(a){(0,C.$Xk)(a)!==1&&this.t.error(a)}try{await this.m.del(s)}catch(a){(0,C.$Xk)(a)!==1&&this.t.error(a)}return r})()),this.C}F(n){let s=this.h.get(n);return s||(s=new I.$nh,this.h.set(n,s)),s}};e.$_p=c,e.$_p=c=ye([K(1,C.$Gk),K(2,h.$gl),K(3,f.$el),K(4,l.$Fl),K(5,w.$Aj)],c);function v(o){return(0,m.$Vf)(o)&&(0,k.$No)(o.identifier)&&(i(o.location)||(0,m.$Tf)(o.location)&&o.location)&&((0,m.$1f)(o.relativeLocation)||(0,m.$Tf)(o.relativeLocation))&&o.version&&(0,m.$Tf)(o.version)}function i(o){return o?(0,m.$Tf)(o.path)&&(0,m.$Tf)(o.scheme):!1}}),define(le[81],he([0,1,17,6,30,14,7,34,138,2,23,15,5,20,55,88,12,10,157,16,33,45,71,11,4,8,24,3,66,52,18,28,185]),function(se,e,I,L,A,j,O,R,k,g,C,S,w,h,f,m,y,l,d,$,c,v,i,o,n,s,t,r,a,E,b,u,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gq=e.$fq=e.$eq=e.$dq=e.$cq=e.Translations=void 0;var P;(function(x){function W(Q,H){if(Q===H)return!0;const V=Object.keys(Q),te=new Set;for(const re of Object.keys(H))te.add(re);if(V.length!==te.size)return!1;for(const re of V){if(Q[re]!==H[re])return!1;te.delete(re)}return te.size===0}x.equals=W})(P||(e.Translations=P={})),e.$cq=(0,n.$gi)("IExtensionsScannerService");let N=class extends g.$Tc{constructor(W,Q,H,V,te,re,ee,ae,G,U,D,T){super(),this.systemExtensionsLocation=W,this.userExtensionsLocation=Q,this.r=H,this.s=V,this.t=te,this.u=re,this.w=ee,this.y=ae,this.z=G,this.C=U,this.D=D,this.F=T,this.g=this.B(new r.$6d),this.onDidChangeCache=this.g.event,this.h=(0,h.$Tg)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(z,this.s,this.h)),this.m=this.B(this.F.createInstance(z,this.s,this.h)),this.n=this.B(this.F.createInstance(M,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,c.$op)(this.w,this.y)),this.G}async scanAllExtensions(W,Q,H){const[V,te]=await Promise.all([this.scanSystemExtensions(W),this.scanUserExtensions(Q)]),re=H?await this.scanExtensionsUnderDevelopment(W,[...V,...te]):[];return this.L(V,te,re,await this.getTargetPlatform(),!0)}async scanSystemExtensions(W){const Q=[];Q.push(this.M(!!W.useCache,W.language)),Q.push(this.N(W.language,!!W.checkControlFile));const[H,V]=await Promise.all(Q);return this.J([...H,...V],0,W,!1)}async scanUserExtensions(W){const Q=W.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",Q);const H=this.D.extUri.isEqual(W.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,V=await this.P(Q,!!W.profileLocation,1,!W.includeUninstalled,W.language,!0,H),te=W.useCache&&!V.devMode&&V.excludeObsolete?this.m:this.n;let re;try{re=await te.scanExtensions(V)}catch(ee){if(ee instanceof E.$0p&&ee.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),re=await te.scanExtensions(V);else throw ee}return re=await this.J(re,1,W,!0),this.y.trace("Scanned user extensions:",re.length),re}async scanExtensionsUnderDevelopment(W,Q){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const H=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(V=>V.scheme===C.Schemas.file).map(async V=>{const te=await this.P(V,!1,1,!0,W.language,!1,void 0);return(await this.n.scanOneOrMultipleExtensions(te)).map(ee=>(ee.type=Q.find(ae=>(0,c.$dp)(ae.identifier,ee.identifier))?.type??ee.type,this.n.validate(ee,te)))}))).flat();return this.J(H,"development",W,!0)}return[]}async scanExistingExtension(W,Q,H){const V=await this.P(W,!1,Q,!0,H.language,!0,void 0),te=await this.n.scanExtension(V);return!te||!H.includeInvalid&&!te.isValid?null:te}async scanOneOrMultipleExtensions(W,Q,H){const V=await this.P(W,!1,Q,!0,H.language,!0,void 0),te=await this.n.scanOneOrMultipleExtensions(V);return this.J(te,Q,H,!0)}async scanMetadata(W){const Q=(0,h.$Tg)(W,"package.json"),H=(await this.w.readFile(Q)).value.toString();return JSON.parse(H).__metadata}async updateMetadata(W,Q){const H=(0,h.$Tg)(W,"package.json"),V=(await this.w.readFile(H)).value.toString(),te=JSON.parse(V);Q.isMachineScoped===!1&&delete Q.isMachineScoped,Q.isBuiltin===!1&&delete Q.isBuiltin,te.__metadata={...te.__metadata,...Q},await this.w.writeFile((0,h.$Tg)(W,"package.json"),j.$te.fromString(JSON.stringify(te,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(W){if(W instanceof E.$0p&&W.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw W}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const W=await this.scanUserExtensions({includeInvalid:!0});if(W.length)await this.u.addExtensionsToProfile(W.map(Q=>[Q,Q.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,j.$te.fromString(JSON.stringify([])))}catch(Q){(0,o.$Xk)(Q)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,O.$0)(Q))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(W){this.y.error(W)}finally{this.H=void 0}})()),this.H}async J(W,Q,H,V){return H.includeAllVersions||(W=this.L(Q===0?W:void 0,Q===1?W:void 0,Q==="development"?W:void 0,await this.getTargetPlatform(),V)),H.includeInvalid||(W=W.filter(te=>te.isValid)),W.sort((te,re)=>{const ee=S.$nc(te.location.fsPath),ae=S.$nc(re.location.fsPath);return ee<ae?-1:ee>ae?1:0})}L(W,Q,H,V,te){const re=(ae,G,U)=>{if(ae.isValid&&!G.isValid)return!1;if(ae.isValid===G.isValid){if(te&&f.gt(ae.manifest.version,G.manifest.version))return this.y.debug(`Skipping extension ${G.location.path} with lower version ${G.manifest.version} in favour of ${ae.location.path} with version ${ae.manifest.version}`),!1;if(f.eq(ae.manifest.version,G.manifest.version)){if(ae.type===0)return this.y.debug(`Skipping extension ${G.location.path} in favour of system extension ${ae.location.path} with same version`),!1;if(ae.targetPlatform===V)return this.y.debug(`Skipping extension ${G.location.path} from different target platform ${G.targetPlatform}`),!1}}return U?this.y.warn(`Overwriting user extension ${ae.location.path} with ${G.location.path}.`):this.y.debug(`Overwriting user extension ${ae.location.path} with ${G.location.path}.`),!0},ee=new v.$Cm;return W?.forEach(ae=>{const G=ee.get(ae.identifier.id);(!G||re(G,ae,!1))&&ee.set(ae.identifier.id,ae)}),Q?.forEach(ae=>{const G=ee.get(ae.identifier.id);if(!G&&W&&ae.type===0){this.y.debug(`Skipping obsolete system extension ${ae.location.path}.`);return}(!G||re(G,ae,!1))&&ee.set(ae.identifier.id,ae)}),H?.forEach(ae=>{const G=ee.get(ae.identifier.id);(!G||re(G,ae,!0))&&ee.set(ae.identifier.id,ae),ee.set(ae.identifier.id,ae)}),[...ee.values()]}async M(W,Q){this.y.trace("Started scanning system extensions");const H=await this.P(this.systemExtensionsLocation,!1,0,!0,Q,!0,void 0),te=await(W&&!H.devMode?this.j:this.n).scanExtensions(H);return this.y.trace("Scanned system extensions:",te.length),te}async N(W,Q){const H=this.z.isBuilt?[]:this.C.builtInExtensions;if(!H?.length)return[];this.y.trace("Started scanning dev system extensions");const V=Q?await this.O():{},te=[],re=l.URI.file(S.$hc(S.$jc(C.$Ag.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const ae of H){const G=V[ae.name]||"marketplace";switch(G){case"disabled":break;case"marketplace":te.push((0,h.$Tg)(re,ae.name));break;default:te.push(l.URI.file(G));break}}const ee=await Promise.all(te.map(async ae=>this.n.scanExtension(await this.P(ae,!1,0,!0,W,!0,void 0))));return this.y.trace("Scanned dev system extensions:",ee.length),(0,I.$Hb)(ee)}async O(){try{const W=await this.w.readFile(this.r);return JSON.parse(W.value.toString())}catch{return{}}}async P(W,Q,H,V,te,re,ee){const ae=await this.f(te??w.$w),G=await this.Q(W),U=Q&&!this.D.extUri.isEqual(W,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,D=U?await this.Q(U):void 0;return new F(W,G,U,D,Q,ee,H,V,re,this.C.version,this.C.date,this.C.commit,!this.z.isBuilt,te,ae)}async Q(W){try{const Q=await this.w.stat(W);if(typeof Q.mtime=="number")return Q.mtime}catch{}}};e.$dq=N,e.$dq=N=ye([K(4,b.$gl),K(5,E.$$p),K(6,o.$Gk),K(7,s.$Aj),K(8,$.$ni),K(9,t.$Sj),K(10,u.$el),K(11,n.$fi)],N);class F{constructor(W,Q,H,V,te,re,ee,ae,G,U,D,T,B,q,Y){this.location=W,this.mtime=Q,this.applicationExtensionslocation=H,this.applicationExtensionslocationMtime=V,this.profile=te,this.profileScanOptions=re,this.type=ee,this.excludeObsolete=ae,this.validate=G,this.productVersion=U,this.productDate=D,this.productCommit=T,this.devMode=B,this.language=q,this.translations=Y}static createNlsConfiguration(W){return{language:W.language,pseudo:W.language==="pseudo",devMode:W.devMode,translations:W.translations}}static equals(W,Q){return(0,h.$Mg)(W.location,Q.location)&&W.mtime===Q.mtime&&(0,h.$Mg)(W.applicationExtensionslocation,Q.applicationExtensionslocation)&&W.applicationExtensionslocationMtime===Q.applicationExtensionslocationMtime&&W.profile===Q.profile&&A.$Pn(W.profileScanOptions,Q.profileScanOptions)&&W.type===Q.type&&W.excludeObsolete===Q.excludeObsolete&&W.validate===Q.validate&&W.productVersion===Q.productVersion&&W.productDate===Q.productDate&&W.productCommit===Q.productCommit&&W.devMode===Q.devMode&&W.language===Q.language&&P.equals(W.translations,Q.translations)}}e.$eq=F;let M=class extends g.$Tc{constructor(W,Q,H,V,te){super(),this.f=W,this.g=Q,this.h=H,this.j=V,this.m=te}async scanExtensions(W){const Q=W.profile?await this.r(W):await this.n(W);let H={};if(W.excludeObsolete&&W.type===1)try{const V=(await this.j.readFile(this.f)).value.toString();H=JSON.parse(V)}catch{}return(0,y.$7f)(H)?Q:Q.filter(V=>!H[c.$ep.create(V).toString()])}async n(W){const Q=await this.j.resolve(W.location);if(!Q.children?.length)return[];const H=await Promise.all(Q.children.map(async V=>{if(!V.isDirectory||W.type===1&&(0,h.$Qg)(V.resource).indexOf(".")===0)return null;const te=new F(V.resource,W.mtime,W.applicationExtensionslocation,W.applicationExtensionslocationMtime,W.profile,W.profileScanOptions,W.type,W.excludeObsolete,W.validate,W.productVersion,W.productDate,W.productCommit,W.devMode,W.language,W.translations);return this.scanExtension(te)}));return(0,I.$Hb)(H).sort((V,te)=>V.location.path<te.location.path?-1:1)}async r(W){let Q=await this.s(W.location,()=>!0,W);if(W.applicationExtensionslocation&&!this.h.extUri.isEqual(W.location,W.applicationExtensionslocation)){Q=Q.filter(V=>!V.metadata?.isApplicationScoped);const H=await this.s(W.applicationExtensionslocation,V=>!!V.metadata?.isBuiltin||!!V.metadata?.isApplicationScoped,W);Q.push(...H)}return Q}async s(W,Q,H){const V=await this.g.scanProfileExtensions(W,H.profileScanOptions);if(!V.length)return[];const te=await Promise.all(V.map(async re=>{if(Q(re)){const ee=new F(re.location,H.mtime,H.applicationExtensionslocation,H.applicationExtensionslocationMtime,H.profile,H.profileScanOptions,H.type,H.excludeObsolete,H.validate,H.productVersion,H.productDate,H.productCommit,H.devMode,H.language,H.translations);return this.scanExtension(ee,re.metadata)}return null}));return(0,I.$Hb)(te)}async scanOneOrMultipleExtensions(W){try{if(await this.j.exists((0,h.$Tg)(W.location,"package.json"))){const Q=await this.scanExtension(W);return Q?[Q]:[]}else return await this.scanExtensions(W)}catch(Q){return this.m.error(`Error scanning extensions at ${W.location.path}:`,(0,O.$0)(Q)),[]}}async scanExtension(W,Q){try{let H=await this.scanExtensionManifest(W.location);if(H){H.publisher||(H.publisher=v.$wm),Q=Q??H.__metadata,delete H.__metadata;const V=(0,c.$ip)(H.publisher,H.name),te=Q?.id?{id:V,uuid:Q.id}:{id:V},re=Q?.isSystem?0:W.type,ee=re===0||!!Q?.isBuiltin;H=await this.t(W.location,H,F.createNlsConfiguration(W));const ae={type:re,identifier:te,manifest:H,location:W.location,isBuiltin:ee,targetPlatform:Q?.targetPlatform??"undefined",metadata:Q,isValid:!0,validations:[]};return W.validate?this.validate(ae,W):ae}}catch(H){W.type!==0&&this.m.error(H)}return null}validate(W,Q){let H=!0;const V=(0,i.$tp)(Q.productVersion,Q.productDate,Q.location,W.manifest,W.isBuiltin);for(const[te,re]of V)te===m.default.Error&&(H=!1,this.m.error(this.z(Q.location,re)));return W.isValid=H,W.validations=V,W}async scanExtensionManifest(W){const Q=(0,h.$Tg)(W,"package.json");let H;try{H=(await this.j.readFile(Q)).value.toString()}catch(te){return(0,o.$Xk)(te)!==1&&this.m.error(this.z(W,(0,d.localize)(0,null,Q.path,te.message))),null}let V;try{V=JSON.parse(H)}catch{const re=[];(0,R.$sn)(H,re);for(const ee of re)this.m.error(this.z(W,(0,d.localize)(1,null,Q.path,ee.offset,ee.length,(0,k.$aq)(ee.error))));return null}return(0,R.$Bn)(V)!=="object"?(this.m.error(this.z(W,(0,d.localize)(2,null,Q.path))),null):V}async t(W,Q,H){const V=await this.u(W,Q,H);if(V)try{const te=[],re=await this.w(V.default,te);if(te.length>0)return te.forEach(ae=>{this.m.error(this.z(W,(0,d.localize)(3,null,V.default?.path,(0,k.$aq)(ae.error))))}),Q;if((0,R.$Bn)(V)!=="object")return this.m.error(this.z(W,(0,d.localize)(4,null,V.default?.path))),Q;const ee=V.values||Object.create(null);return(0,p.$bq)(this.m,Q,ee,re)}catch{}return Q}async u(W,Q,H){const V=(0,h.$Tg)(W,"package.nls.json"),te=(G,U)=>{U.forEach(D=>{this.m.error(this.z(W,(0,d.localize)(5,null,G?.path,(0,k.$aq)(D.error))))})},re=G=>{this.m.error(this.z(W,(0,d.localize)(6,null,G?.path)))},ee=`${Q.publisher}.${Q.name}`,ae=H.translations[ee];if(ae)try{const G=l.URI.file(ae),U=(await this.j.readFile(G)).value.toString(),D=[],T=(0,R.$sn)(U,D);return D.length>0?(te(G,D),{values:void 0,default:V}):(0,R.$Bn)(T)!=="object"?(re(G),{values:void 0,default:V}):{values:T.contents?T.contents.package:void 0,default:V}}catch{return{values:void 0,default:V}}else{if(!await this.j.exists(V))return;let U;try{U=await this.y(W,H)}catch{return}if(!U.localized)return{values:void 0,default:U.original};try{const D=(await this.j.readFile(U.localized)).value.toString(),T=[],B=(0,R.$sn)(D,T);return T.length>0?(te(U.localized,T),{values:void 0,default:U.original}):(0,R.$Bn)(B)!=="object"?(re(U.localized),{values:void 0,default:U.original}):{values:B,default:U.original}}catch{return{values:void 0,default:U.original}}}}async w(W,Q){if(W)try{const H=(await this.j.readFile(W)).value.toString();return(0,R.$sn)(H,Q)}catch{}}y(W,Q){return new Promise((H,V)=>{const te=re=>{const ee=(0,h.$Tg)(W,`package.nls.${re}.json`);this.j.exists(ee).then(ae=>{ae&&H({localized:ee,original:(0,h.$Tg)(W,"package.nls.json")});const G=re.lastIndexOf("-");G===-1?H({localized:(0,h.$Tg)(W,"package.nls.json"),original:null}):(re=re.substring(0,G),te(re))})};if(Q.devMode||Q.pseudo||!Q.language)return H({localized:(0,h.$Tg)(W,"package.nls.json"),original:null});te(Q.language)})}z(W,Q){return`[${W.path}]: ${Q}`}};M=ye([K(1,E.$$p),K(2,u.$el),K(3,o.$Gk),K(4,s.$Aj)],M);let z=class extends M{constructor(W,Q,H,V,te,re,ee){super(Q,V,te,re,ee),this.G=W,this.H=H,this.D=this.B(new L.$eh(3e3)),this.F=this.B(new r.$6d),this.onDidChangeCache=this.F.event}async scanExtensions(W){const Q=this.M(W),H=await this.I(Q);if(this.C=W,H&&H.input&&F.equals(H.input,this.C))return this.m.debug("Using cached extensions scan result",W.location.toString()),this.D.trigger(()=>this.L()),H.result.map(te=>(te.location=l.URI.revive(te.location),te));const V=await super.scanExtensions(W);return await this.J(Q,{input:W,result:V}),V}async I(W){try{const Q=await this.j.readFile(W),H=JSON.parse(Q.value.toString());return{result:H.result,input:(0,a.$Ph)(H.input)}}catch(Q){this.m.debug("Error while reading the extension cache file:",W.path,(0,O.$0)(Q))}return null}async J(W,Q){try{await this.j.writeFile(W,j.$te.fromString(JSON.stringify(Q)))}catch(H){this.m.debug("Error while writing the extension cache file:",W.path,(0,O.$0)(H))}}async L(){if(!this.C)return;const W=this.M(this.C),Q=await this.I(W);if(!Q)return;const H=Q.result,V=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!A.$Pn(V,H))try{this.m.info("Invalidating Cache",H,V),await this.j.del(W),this.F.fire()}catch(te){this.m.error(te)}}M(W){const Q=this.N(W);return this.h.extUri.joinPath(Q.cacheHome,W.type===0?v.$vm:v.$um)}N(W){return W.type===0?this.H.defaultProfile:W.profile?this.h.extUri.isEqual(W.location,this.G.extensionsResource)?this.G:this.H.profiles.find(Q=>this.h.extUri.isEqual(W.location,Q.extensionsResource))??this.G:this.H.defaultProfile}};z=ye([K(2,b.$gl),K(3,E.$$p),K(4,u.$el),K(5,o.$Gk),K(6,s.$Aj)],z);function Z(x,W){const Q=(0,c.$gp)(x.manifest.publisher,x.manifest.name);return{id:Q,identifier:new v.$Am(Q),isBuiltin:x.type===0,isUserBuiltin:x.type===1&&x.isBuiltin,isUnderDevelopment:W,extensionLocation:x.location,uuid:x.identifier.uuid,targetPlatform:x.targetPlatform,...x.manifest}}e.$fq=Z;class X extends N{constructor(W,Q,H,V,te,re,ee,ae,G,U,D,T){super(W,Q,(0,h.$Tg)(H,".vscode-oss-dev","extensions","control.json"),V,te,re,ee,ae,G,U,D,T),this.R=(async()=>{if(w.$z)try{const B=await this.w.readFile(l.URI.file(w.$z));return JSON.parse(B.value.toString())}catch{}return Object.create(null)})()}f(W){return this.R}}e.$gq=X}),define(le[247],he([0,1,67,6,38,3,2,23,15,31,8,18]),function(se,e,I,L,A,j,O,R,k,g,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iq=void 0;let w=class extends O.$Tc{constructor(f,m){super(),this.b=f,this.f=m,this.a=new L.$mh(5)}async postUninstall(f){const m=this.g(f,"uninstall");m&&(this.f.info(f.identifier.id,f.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(m.script,"uninstall",m.args,!0,f),this.f.info("Finished running post uninstall script",f.identifier.id,f.manifest.version)}catch(y){this.f.error("Failed to run post uninstall script",f.identifier.id,f.manifest.version),this.f.error(y)}}));try{await g.Promises.rm(this.m(f))}catch(y){this.f.error("Error while removing extension storage path",f.identifier.id),this.f.error(y)}}g(f,m){const y=`vscode:${m}`;if(f.location.scheme===R.Schemas.file&&f.manifest&&f.manifest.scripts&&typeof f.manifest.scripts[y]=="string"){const l=f.manifest.scripts[y].split(" ");return l.length<2||l[0]!=="node"||!l[1]?(this.f.warn(f.identifier.id,f.manifest.version,`${y} should be a node script`),null):{script:(0,k.$jc)(f.location.fsPath,l[1]),args:l.slice(2)||[]}}return null}h(f,m,y,l,d){return new Promise(($,c)=>{const v=this.j(f,m,y,d);let i;const o=n=>{i&&(clearTimeout(i),i=null),n?c(n):$(void 0)};v.on("error",n=>{o((0,A.$4i)(n)||"Unknown")}),v.on("exit",(n,s)=>{o(n?`post-${m} process exited with code ${n}`:void 0)}),l&&(i=setTimeout(()=>{i=null,v.kill(),c("timed out")},5e3))})}j(f,m,y,l){const d={silent:!0,execArgv:void 0},$=(0,I.fork)(f,[`--type=extension-post-${m}`,...y],d);$.stdout.setEncoding("utf8"),$.stderr.setEncoding("utf8");const c=j.Event.fromNodeEventEmitter($.stdout,"data"),v=j.Event.fromNodeEventEmitter($.stderr,"data");c(n=>this.f.info(l.identifier.id,l.manifest.version,`post-${m}`,n)),v(n=>this.f.error(l.identifier.id,l.manifest.version,`post-${m}`,n));const i=j.Event.any(j.Event.map(c,n=>({data:`%c${n}`,format:[""]})),j.Event.map(v,n=>({data:`%c${n}`,format:["color: red"]})));return j.Event.debounce(i,(n,s)=>n?{data:n.data+s.data,format:[...n.format,...s.format]}:{data:s.data,format:s.format},100)(n=>{console.group(l.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),$}m(f){return(0,k.$jc)(this.b.defaultProfile.globalStorageHome.fsPath,f.identifier.id.toLowerCase())}};e.$iq=w,e.$iq=w=ye([K(0,S.$gl),K(1,C.$Aj)],w)}),define(le[113],he([0,1,6,14,26,38,7,3,54,2,35,23,15,20,55,12,10,32,31,70,158,95,16,246,29,33,52,81,227,247,186,217,228,71,11,4,8,24,22,28,18]),function(se,e,I,L,A,j,O,R,k,g,C,S,w,h,f,m,y,l,d,$,c,v,i,o,n,s,t,r,a,E,b,u,p,P,N,F,M,z,Z,X,x){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pq=e.$oq=e.$nq=e.$mq=void 0,e.$mq=(0,F.$hi)(n.$Ro);const W=".vsctmp";let Q=class extends o.$6p{constructor(G,U,D,T,B,q,Y,_,ie,J,ne,ce){super(G,U,ne,D,J,ce),this.eb=B,this.fb=q,this.gb=Y,this.hb=ie,this.db=new Map,this.qb=new C.$Bc;const fe=this.B(_.createInstance(E.$iq));this.ab=this.B(_.createInstance(H,me=>fe.postUninstall(me))),this.bb=this.B(new u.$kq(ce,ie,ne,this,this.F)),this.cb=this.B(_.createInstance(a.$hq));const de=this.B(new p.$lq(this,this.eb,ce,q,ne,ie,D));this.B(de.onDidChangeExtensionsByAnotherSource(me=>this.pb(me))),this.rb()}getTargetPlatform(){return this.ib||(this.ib=(0,s.$op)(this.hb,this.F)),this.ib}async zip(G){this.F.trace("ExtensionManagementService#zip",G.identifier.id);const U=await this.ob(G),D=await(0,$.zip)((0,h.$Tg)(this.cb.extensionsDownloadDir,(0,l.$Cg)()).fsPath,U);return y.URI.file(D)}async unzip(G){return this.F.trace("ExtensionManagementService#unzip",G.toString()),(await this.install(G)).identifier}async getManifest(G){const{location:U,cleanup:D}=await this.kb(G),T=w.$kc(U.fsPath);try{return await(0,b.$jq)(T)}finally{await D()}}getInstalled(G,U=this.H.defaultProfile.extensionsResource){return this.ab.scanExtensions(G??null,U)}scanAllUserInstalledExtensions(){return this.ab.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(G){return this.ab.scanUserExtensionAtLocation(G)}async install(G,U={}){this.F.trace("ExtensionManagementService#install",G.toString());const{location:D,cleanup:T}=await this.kb(G);try{const B=await(0,b.$jq)(w.$kc(D.fsPath)),q=(0,s.$ip)(B.publisher,B.name);if(B.engines&&B.engines.vscode&&!(0,P.$vp)(B.engines.vscode,this.G.version,this.G.date))throw new Error(c.localize(0,null,q,this.G.version));const _=(await this.I([{manifest:B,extension:D,options:U}])).find(({identifier:ie})=>(0,s.$dp)(ie,{id:q}));if(_?.local)return _.local;throw _?.error?_.error:(0,o.$8p)(new Error(`Unknown error while installing extension ${q}`))}finally{await T()}}async installFromLocation(G,U){this.F.trace("ExtensionManagementService#installFromLocation",G.toString());const D=await this.ab.scanUserExtensionAtLocation(G);if(!D||!D.manifest.name||!D.manifest.version)throw new Error(`Cannot find a valid extension from the location ${G.toString()}`);return await this.tb([[D,void 0]],U),this.F.info("Successfully installed extension",D.identifier.id,U.toString()),D}async installExtensionsFromProfile(G,U,D){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",G,U.toString(),D.toString());const T=(await this.ab.scanExtensions(1,U)).filter(B=>G.some(q=>(0,s.$dp)(q,B.identifier)));if(T.length){const B=await Promise.all(T.map(q=>this.ab.scanMetadata(q,U)));await this.tb(T.map((q,Y)=>[q,B[Y]]),D),this.F.info("Successfully installed extensions",T.map(q=>q.identifier.id),D.toString())}return T}async updateMetadata(G,U,D=this.H.defaultProfile.extensionsResource){return this.F.trace("ExtensionManagementService#updateMetadata",G.identifier.id),U.isPreReleaseVersion&&(U.preRelease=!0,U.hasPreReleaseVersion=!0),U.isMachineScoped===!1&&(U.isMachineScoped=void 0),U.isBuiltin===!1&&(U.isBuiltin=void 0),U.pinned===!1&&(U.pinned=void 0),G=await this.ab.updateMetadata(G,U,D),this.bb.invalidate(D),this.w.fire(G),G}async reinstallFromGallery(G){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",G.identifier.id),!this.z.isEnabled())throw new Error(c.localize(1,null));const U=await this.getTargetPlatform(),[D]=await this.z.getExtensions([{...G.identifier,preRelease:G.preRelease}],{targetPlatform:U,compatible:!0},A.CancellationToken.None);if(!D)throw new Error(c.localize(2,null));await this.ab.setUninstalled(G);try{await this.ab.removeUninstalledExtension(G)}catch(T){throw new Error(c.localize(3,null,(0,j.$4i)(T)))}return this.installFromGallery(D)}$(G,U,D,T){return this.ab.copyExtension(G,U,D,T)}copyExtensions(G,U){return this.ab.copyExtensions(G,U)}markAsUninstalled(...G){return this.ab.setUninstalled(...G)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.ab.cleanUp()}catch(G){this.F.error(G)}}async download(G,U,D){const{location:T}=await this.cb.download(G,U,!D);return T}async kb(G){if(G.scheme===S.Schemas.file)return{location:G,async cleanup(){}};this.F.trace("Downloading extension from",G.toString());const U=(0,h.$Tg)(this.cb.extensionsDownloadDir,(0,l.$Cg)());return await this.gb.download(G,U),this.F.info("Downloaded extension to",U.toString()),{location:U,cleanup:async()=>{try{await this.hb.del(U)}catch(T){this.F.error(T)}}}}X(){return this.H.defaultProfile.extensionsResource}Y(G,U,D){if(y.URI.isUri(U))return new re(G,U,D,this.z,this.ab,this.D,this.H,this.eb,this.fb,this.F);const T=s.$ep.create(U).toString();let B=this.db.get(T);return B||(this.db.set(T,B=new te(G,U,D,this.cb,this.ab,this.D,this.H,this.eb,this.fb,this.F)),B.waitUntilTaskIsFinished().finally(()=>this.db.delete(T))),B}Z(G,U){return new ee(G,U.profileLocation,this.fb)}async ob(G){const U=async T=>{let B=await d.Promises.readdir(T);B=B.map(_=>w.$jc(T,_));const q=await Promise.all(B.map(_=>d.Promises.stat(_)));let Y=Promise.resolve([]);return q.forEach((_,ie)=>{const J=B[ie];_.isFile()&&(Y=Y.then(ne=>[...ne,J])),_.isDirectory()&&(Y=Y.then(ne=>U(J).then(ce=>[...ne,...ce])))}),Y};return(await U(G.location.fsPath)).map(T=>({path:`extension/${w.$lc(G.location.fsPath,T)}`,localPath:T}))}async pb({added:G,removed:U}){if(U){const D=G&&this.D.extUri.isEqual(U.profileLocation,G.profileLocation)?U.extensions.filter(T=>G.extensions.every(B=>!(0,s.$dp)(B,T))):U.extensions;for(const T of D)this.F.info("Extensions removed from another source",T.id,U.profileLocation.toString()),this.u.fire({identifier:T,profileLocation:U.profileLocation})}if(G){const T=(await this.ab.scanExtensions(1,G.profileLocation)).filter(B=>G.extensions.some(q=>(0,s.$dp)(q,B.identifier)));this.s.fire(T.map(B=>(this.F.info("Extensions added from another source",B.identifier.id,G.profileLocation.toString()),{identifier:B.identifier,local:B,profileLocation:G.profileLocation,operation:1})))}}async rb(){this.B(this.ab.onExtract(U=>this.qb.add(U)));const G=await this.hb.resolve(this.eb.userExtensionsLocation);for(const U of G.children??[])U.isDirectory&&this.qb.add(U.resource);this.B(this.hb.watch(this.eb.userExtensionsLocation)),this.B(this.hb.onDidFilesChange(U=>this.sb(U)))}async sb(G){if(!G.affects(this.eb.userExtensionsLocation,1))return;const U=[];for(const D of G.rawAdded){if(this.qb.has(D)||!this.D.extUri.isEqual(this.D.extUri.dirname(D),this.eb.userExtensionsLocation)||this.D.extUri.isEqual(D,this.D.extUri.joinPath(this.eb.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(D).startsWith(".")||!(await this.hb.stat(D)).isDirectory)continue;const T=await this.ab.scanUserExtensionAtLocation(D);T&&T.installedTimestamp===void 0&&(this.qb.add(D),U.push(T))}U.length&&(await this.tb(U.map(D=>[D,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",U.map(D=>D.identifier.id)))}async tb(G,U){const D=G.map(T=>T[0]);await this.ub(D),await this.fb.addExtensionsToProfile(G,U),this.s.fire(D.map(T=>({local:T,identifier:T.identifier,operation:1,profileLocation:U})))}async ub(G){const U=await this.ab.getUninstalledExtensions();for(const D of G){const T=s.$ep.create(D);U[T.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",T.id),await this.ab.setInstalled(T),this.F.info("Removed the extension from uninstalled list:",T.id))}}};e.$nq=Q,e.$nq=Q=ye([K(0,n.$Oo),K(1,Z.$Fl),K(2,M.$Aj),K(3,i.$oi),K(4,r.$cq),K(5,t.$$p),K(6,v.$to),K(7,F.$fi),K(8,N.$Gk),K(9,z.$Sj),K(10,X.$el),K(11,x.$gl)],Q);let H=class extends g.$Tc{constructor(G,U,D,T,B,q){super(),this.j=G,this.m=U,this.n=D,this.s=T,this.t=B,this.u=q,this.h=this.B(new R.$6d),this.onExtract=this.h.event,this.c=(0,h.$Tg)(this.n.userExtensionsLocation,".obsolete"),this.g=new I.$nh}async cleanUp(){await this.H(),await this.G()}async scanExtensions(G,U){const D={includeInvalid:!0,profileLocation:U};let T=[];return G===null||G===0?T.push(...await this.n.scanAllExtensions({includeInvalid:!0},D,!1)):G===1&&T.push(...await this.n.scanUserExtensions(D)),T=G!==null?T.filter(B=>B.type===G):T,Promise.all(T.map(B=>this.F(B)))}async scanAllUserExtensions(G){const U=await this.n.scanUserExtensions({includeAllVersions:!G,includeInvalid:!0});return Promise.all(U.map(D=>this.F(D)))}async scanUserExtensionAtLocation(G){try{const U=await this.n.scanExistingExtension(G,1,{includeInvalid:!0});if(U)return await this.F(U)}catch(U){this.u.error(U)}return null}async extractUserExtension(G,U,D,T,B){const q=G.toString(),Y=y.URI.file(w.$jc(this.n.userExtensionsLocation.fsPath,`.${(0,l.$Cg)()}`)),_=y.URI.file(w.$jc(this.n.userExtensionsLocation.fsPath,q));let ie=await this.m.exists(_);if(ie&&T){try{await this.y(G.id,_,"removeExisting")}catch{throw new n.$Po(c.localize(4,null,_.fsPath,G.id),n.ExtensionManagementErrorCode.Delete)}ie=!1}if(ie)await this.n.updateMetadata(_,D);else try{try{this.u.trace(`Started extracting the extension from ${U} to ${_.fsPath}`),await(0,$.$4p)(U,Y.fsPath,{sourcePath:"extension",overwrite:!0},B),this.u.info(`Extracted extension to ${_}:`,G.id)}catch(J){let ne=n.ExtensionManagementErrorCode.Extract;throw J instanceof $.$2p&&(J.type==="CorruptZip"?ne=n.ExtensionManagementErrorCode.CorruptZip:J.type==="Incomplete"&&(ne=n.ExtensionManagementErrorCode.IncompleteZip)),new n.$Po(J.message,ne)}await this.n.updateMetadata(Y,D);try{this.u.trace(`Started renaming the extension from ${Y.fsPath} to ${_.fsPath}`),await this.C(Y.fsPath,_.fsPath),this.u.info("Renamed to",_.fsPath)}catch(J){if(J.code==="ENOTEMPTY")this.u.info("Rename failed because extension was installed by another source. So ignoring renaming.",G.id);else throw this.u.info(`Rename failed because of ${(0,O.$0)(J)}. Deleted from extracted location`,Y),J}this.h.fire(_)}catch(J){try{await this.m.del(Y,{recursive:!0})}catch{}throw J}return this.D(_,1)}async scanMetadata(G,U){return U?(await this.w(G,U))?.metadata:this.n.scanMetadata(G.location)}async w(G,U){return(await this.s.scanProfileExtensions(U)).find(T=>(0,s.$dp)(T.identifier,G.identifier))}async updateMetadata(G,U,D){return D?await this.s.updateMetadata([[G,U]],D):await this.n.updateMetadata(G.location,U),this.D(G.location,G.type,D)}getUninstalledExtensions(){return this.z()}async setUninstalled(...G){const U=G.map(D=>s.$ep.create(D));await this.z(D=>U.forEach(T=>{D[T.toString()]=!0,this.u.info("Marked extension as uninstalled",T.toString())}))}async setInstalled(G){await this.z(U=>delete U[G.toString()])}async removeExtension(G,U){if(this.t.extUri.isEqualOrParent(G.location,this.n.userExtensionsLocation))return this.y(G.identifier.id,G.location,U)}async removeUninstalledExtension(G){await this.removeExtension(G,"uninstalled"),await this.z(U=>delete U[s.$ep.create(G).toString()])}async copyExtension(G,U,D,T){const B=await this.w(G,U),q=await this.w(G,D);if(T={...B?.metadata,...T},q)if(this.t.extUri.isEqual(q.location,G.location))await this.s.updateMetadata([[G,{...q.metadata,...T}]],D);else{const Y=await this.D(q.location,G.type,D);await this.s.removeExtensionFromProfile(Y,D),await this.s.addExtensionsToProfile([[G,{...q.metadata,...T}]],D)}else await this.s.addExtensionsToProfile([[G,T]],D);return this.D(G.location,G.type,D)}async copyExtensions(G,U){const D=await this.scanExtensions(1,G),T=await Promise.all(D.filter(B=>!B.isApplicationScoped).map(async B=>[B,await this.scanMetadata(B,G)]));await this.s.addExtensionsToProfile(T,U)}async y(G,U,D){this.u.trace(`Deleting ${D} extension from disk`,G,U.fsPath);const T=this.t.extUri.joinPath(this.t.extUri.dirname(U),`${this.t.extUri.basename(U)}.${(0,k.$7i)((0,l.$Cg)()).toString(16)}${W}`);await this.C(U.fsPath,T.fsPath),await this.m.del(T,{recursive:!0}),this.u.info(`Deleted ${D} extension from disk`,G,U.fsPath)}async z(G){return this.g.queue(async()=>{let U;try{U=(await this.m.readFile(this.c,"utf8")).value.toString()}catch(T){if((0,N.$Xk)(T)!==1)throw T}let D={};if(U)try{D=JSON.parse(U)}catch{}return G&&(G(D),Object.keys(D).length?await this.m.writeFile(this.c,L.$te.fromString(JSON.stringify(D))):await this.m.del(this.c)),D})}async C(G,U){try{await d.Promises.rename(G,U,2*60*1e3)}catch(D){throw new n.$Po(D.message||c.localize(5,null,G,U),D.code||n.ExtensionManagementErrorCode.Rename)}}async D(G,U,D){if(D){const B=(await this.n.scanUserExtensions({profileLocation:D})).find(q=>this.t.extUri.isEqual(q.location,G));if(B)return this.F(B)}else{const T=await this.n.scanExistingExtension(G,U,{includeInvalid:!0});if(T)return this.F(T)}throw new Error(c.localize(6,null,G.path))}async F(G){const U=await this.m.resolve(G.location);let D,T;return U.children&&(D=U.children.find(({name:B})=>/^readme(\.txt|\.md|)$/i.test(B))?.resource,T=U.children.find(({name:B})=>/^changelog(\.txt|\.md|)$/i.test(B))?.resource),{identifier:G.identifier,type:G.type,isBuiltin:G.isBuiltin||!!G.metadata?.isBuiltin,location:G.location,manifest:G.manifest,targetPlatform:G.targetPlatform,validations:G.validations,isValid:G.isValid,readmeUrl:D,changelogUrl:T,publisherDisplayName:G.metadata?.publisherDisplayName||null,publisherId:G.metadata?.publisherId||null,isApplicationScoped:!!G.metadata?.isApplicationScoped,isMachineScoped:!!G.metadata?.isMachineScoped,isPreReleaseVersion:!!G.metadata?.isPreReleaseVersion,hasPreReleaseVersion:!!G.metadata?.hasPreReleaseVersion,preRelease:!!G.metadata?.preRelease,installedTimestamp:G.metadata?.installedTimestamp,updated:!!G.metadata?.updated,pinned:!!G.metadata?.pinned}}async G(){const G=await this.getUninstalledExtensions();if(Object.keys(G).length===0){this.u.debug("No uninstalled extensions found.");return}this.u.debug("Removing uninstalled extensions:",Object.keys(G));const U=await this.n.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),D=new Set;for(const B of U)G[s.$ep.create(B).toString()]||D.add(B.identifier.id.toLowerCase());try{const B=(0,s.$jp)(U,q=>q.identifier);await I.Promises.settled(B.map(async q=>{const Y=q.sort((_,ie)=>f.rcompare(_.manifest.version,ie.manifest.version))[0];D.has(Y.identifier.id.toLowerCase())||await this.j(await this.F(Y))}))}catch(B){this.u.error(B)}const T=U.filter(B=>B.metadata&&G[s.$ep.create(B).toString()]);await Promise.allSettled(T.map(B=>this.removeUninstalledExtension(B)))}async H(){this.u.trace("ExtensionManagementService#removeTempDeleteFolders");let G;try{G=await this.m.resolve(this.n.userExtensionsLocation)}catch(U){(0,N.$Xk)(U)!==1&&this.u.error(U);return}if(G?.children)try{await Promise.allSettled(G.children.map(async U=>{if(!(!U.isDirectory||!U.name.endsWith(W))){this.u.trace("Deleting the temporarily deleted folder",U.resource.toString());try{await this.m.del(U.resource,{recursive:!0}),this.u.trace("Deleted the temporarily deleted folder",U.resource.toString())}catch(D){(0,N.$Xk)(D)!==1&&this.u.error(D)}}}))}catch{}}};e.$oq=H,e.$oq=H=ye([K(1,N.$Gk),K(2,r.$cq),K(3,t.$$p),K(4,X.$el),K(5,M.$Aj)],H);class V extends o.$9p{get profileLocation(){return this.j}get verificationStatus(){return this.k}get operation(){return(0,m.$1f)(this.options.operation)?this.l:this.options.operation}constructor(G,U,D,T,B,q,Y,_,ie){super(),this.identifier=G,this.source=U,this.options=D,this.m=T,this.n=B,this.o=q,this.p=Y,this.q=_,this.s=ie,this.j=this.options.profileLocation,this.k=!1,this.l=2}async h(G){const[U,D]=await this.x(G);return this.j=U.isBuiltin||U.isApplicationScoped?this.o.defaultProfile.extensionsResource:this.options.profileLocation,this.n.extUri.isEqual(this.o.defaultProfile.extensionsResource,this.j)&&await this.p.initializeDefaultProfileExtensions(),await this.q.addExtensionsToProfile([[U,D]],this.j),U}async u({zipPath:G,key:U,metadata:D},T,B){let q=await this.v(U);return q?q=await this.m.updateMetadata(q,D):(this.s.trace("Extracting extension...",U.id),q=await this.m.extractUserExtension(U,G,D,T,B),this.s.info("Extracting extension completed.",U.id)),q}async v(G){return await this.w(G)?(this.s.trace("Removing the extension from uninstalled list:",G.id),await this.m.setInstalled(G),this.s.info("Removed the extension from uninstalled list:",G.id),(await this.m.scanAllUserExtensions(!0)).find(T=>s.$ep.create(T).equals(G))):void 0}async w(G){return!!(await this.m.getUninstalledExtensions())[G.toString()]}}class te extends V{constructor(G,U,D,T,B,q,Y,_,ie,J){super(U.identifier,U,D,B,q,Y,_,ie,J),this.y=U,this.z=T}async x(G){let U;try{U=await this.m.scanExtensions(null,this.options.profileLocation)}catch(Y){throw new n.$Po(Y,n.ExtensionManagementErrorCode.Scanning)}const D=U.find(Y=>(0,s.$dp)(Y.identifier,this.y.identifier));D&&(this.l=3);const T={id:this.y.identifier.uuid,publisherId:this.y.publisherId,publisherDisplayName:this.y.publisherDisplayName,targetPlatform:this.y.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||D?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||D?.isMachineScoped,isBuiltin:this.options.isBuiltin||D?.isBuiltin,isSystem:D?.type===0?!0:void 0,updated:!!D,isPreReleaseVersion:this.y.properties.isPreReleaseVersion,hasPreReleaseVersion:D?.hasPreReleaseVersion||this.y.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??D?.pinned,preRelease:(0,m.$Zf)(this.options.preRelease)?this.options.preRelease:this.options.installPreReleaseVersion||this.y.properties.isPreReleaseVersion||D?.preRelease};if(D?.manifest.version===this.y.version)try{return[await this.m.updateMetadata(D,T),T]}catch(Y){throw new n.$Po((0,O.$0)(Y),n.ExtensionManagementErrorCode.UpdateMetadata)}const{location:B,verificationStatus:q}=await this.z.download(this.y,this.l,!this.options.donotVerifySignature);try{return this.k=q,this.B(B.fsPath),[await this.u({zipPath:B.fsPath,key:s.$ep.create(this.y),metadata:T},!1,G),T]}catch(Y){try{await this.z.delete(B)}catch(_){this.s.warn("Error while deleting the downloaded file",B.toString(),(0,O.$0)(_))}throw Y}}async B(G){try{await(0,b.$jq)(G)}catch(U){throw new n.$Po((0,o.$7p)(U).message,n.ExtensionManagementErrorCode.Invalid)}}}e.$pq=te;class re extends V{constructor(G,U,D,T,B,q,Y,_,ie,J){super({id:(0,s.$ip)(G.publisher,G.name)},U,D,B,q,Y,_,ie,J),this.y=G,this.z=U,this.A=T}async h(G){const U=await super.h(G);return this.D(U,G),U}async x(G){const U=new s.$ep(this.identifier,this.y.version),T=(await this.m.scanExtensions(1,this.options.profileLocation)).find(Y=>(0,s.$dp)(this.identifier,Y.identifier)),B={isApplicationScoped:this.options.isApplicationScoped||T?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||T?.isMachineScoped,isBuiltin:this.options.isBuiltin||T?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??T?.pinned};if(T)if(this.l=3,U.equals(new s.$ep(T.identifier,T.manifest.version)))try{await this.m.removeExtension(T,"existing")}catch{throw new Error(c.localize(7,null,this.y.displayName||this.y.name))}else!this.options.profileLocation&&f.gt(T.manifest.version,this.y.version)&&await this.m.setUninstalled(T);else{const Y=await this.v(U);if(Y)try{await this.m.removeExtension(Y,"existing")}catch{throw new Error(c.localize(8,null,this.y.displayName||this.y.name))}}return[await this.u({zipPath:w.$kc(this.z.fsPath),key:U,metadata:B},!0,G),B]}async D(G,U){try{let[D]=await this.A.getExtensions([{id:G.identifier.id,version:G.manifest.version}],U);if(D||([D]=await this.A.getExtensions([{id:G.identifier.id}],U)),D){const T={id:D.identifier.uuid,publisherDisplayName:D.publisherDisplayName,publisherId:D.publisherId,isPreReleaseVersion:D.properties.isPreReleaseVersion,hasPreReleaseVersion:G.hasPreReleaseVersion||D.properties.isPreReleaseVersion,preRelease:D.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.m.updateMetadata(G,T,this.options.profileLocation)}}catch{}}}class ee extends o.$9p{constructor(G,U,D){super(),this.extension=G,this.j=U,this.k=D}async h(G){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(le[248],he([0,1,8,18,28,22,52,11,16,10]),function(se,e,I,L,A,j,O,R,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OP=void 0;let C=class extends O.$_p{constructor(w,h,f,m,y,l){super(g.URI.file(w.extensionsPath),h,f,m,y,l)}};e.$OP=C,e.$OP=C=ye([K(0,k.$oi),K(1,R.$Gk),K(2,L.$gl),K(3,A.$el),K(4,j.$Fl),K(5,I.$Aj)],C)}),define(le[249],he([0,1,10,16,52,81,11,4,8,24,28,18]),function(se,e,I,L,A,j,O,R,k,g,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aac=void 0;let w=class extends j.$gq{constructor(f,m,y,l,d,$,c,v){super(I.URI.file(d.builtinExtensionsPath),I.URI.file(d.extensionsPath),d.userHome,f.defaultProfile,f,m,y,l,d,$,c,v)}};e.$Aac=w,e.$Aac=w=ye([K(0,S.$gl),K(1,A.$$p),K(2,O.$Gk),K(3,k.$Aj),K(4,L.$oi),K(5,g.$Sj),K(6,C.$el),K(7,R.$fi)],w)}),define(le[19],he([0,1,6,3,2,99,12,69,4,18]),function(se,e,I,L,A,j,O,R,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Op=e.$Np=e.$Mp=e.$Lp=e.$Kp=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$Jp=e.$Ip=e.$Hp=void 0,e.$Hp="__$__isNewStorageMarker",e.$Ip="__$__targetStorageMarker",e.$Jp=(0,k.$gi)("storageService");var C;(function(d){d[d.NONE=0]="NONE",d[d.SHUTDOWN=1]="SHUTDOWN"})(C||(e.WillSaveStateReason=C={}));var S;(function(d){d[d.APPLICATION=-1]="APPLICATION",d[d.PROFILE=0]="PROFILE",d[d.WORKSPACE=1]="WORKSPACE"})(S||(e.StorageScope=S={}));var w;(function(d){d[d.USER=0]="USER",d[d.MACHINE=1]="MACHINE"})(w||(e.StorageTarget=w={}));function h(d){const $=d.get(e.$Ip);if($)try{return JSON.parse($)}catch{}return Object.create(null)}e.$Kp=h;class f extends A.$Tc{static{this.a=60*1e3}constructor($={flushInterval:f.a}){super(),this.m=$,this.b=this.B(new L.$9d),this.c=this.B(new L.$9d),this.onDidChangeTarget=this.c.event,this.f=this.B(new L.$6d),this.onWillSaveState=this.f.event,this.h=this.B(new I.$sh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new A.$Uc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue($,c,v){return L.Event.filter(this.b.event,i=>i.scope===$&&(c===void 0||i.key===c),v)}n(){this.j.value=(0,I.$wh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,A.$Oc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,j.mark)("code/willInitStorage");try{await this.O()}finally{(0,j.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u($,c){const{key:v,external:i}=c;if(v===e.$Ip){switch($){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:$})}else this.b.fire({scope:$,key:v,target:this.J($)[v],external:i})}w($){this.f.fire({reason:$})}get($,c,v){return this.P(c)?.get($,v)}getBoolean($,c,v){return this.P(c)?.getBoolean($,v)}getNumber($,c,v){return this.P(c)?.getNumber($,v)}getObject($,c,v){return this.P(c)?.getObject($,v)}storeAll($,c){this.y(()=>{for(const v of $)this.store(v.key,v.value,v.scope,v.target,c)})}store($,c,v,i,o=!1){if((0,O.$3f)(c)){this.remove($,v,o);return}this.y(()=>{this.z($,v,i),this.P(v)?.set($,c,o)})}remove($,c,v=!1){this.y(()=>{this.z($,c,void 0),this.P(c)?.delete($,v)})}y($){this.b.pause(),this.c.pause();try{$()}finally{this.b.resume(),this.c.resume()}}keys($,c){const v=[],i=this.J($);for(const o of Object.keys(i))i[o]===c&&v.push(o);return v}z($,c,v,i=!1){const o=this.J(c);typeof v=="number"?o[$]!==v&&(o[$]=v,this.P(c)?.set(e.$Ip,JSON.stringify(o),i)):typeof o[$]=="number"&&(delete o[$],this.P(c)?.set(e.$Ip,JSON.stringify(o),i))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J($){switch($){case-1:return this.I;case 0:return this.G;default:return this.D}}L($){const c=this.P($);return c?h(c):Object.create(null)}isNew($){return this.getBoolean(e.$Hp,$)===!0}async flush($=C.NONE){this.f.fire({reason:$});const c=this.P(-1),v=this.P(0),i=this.P(1);switch($){case C.NONE:await I.Promises.settled([c?.whenFlushed()??Promise.resolve(),v?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve()]);break;case C.SHUTDOWN:await I.Promises.settled([c?.flush(0)??Promise.resolve(),v?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve()]);break}}async log(){const $=this.P(-1)?.items??new Map,c=this.P(0)?.items??new Map,v=this.P(1)?.items??new Map;return l($,c,v,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize($){return await this.flush(),this.P($)?.optimize()}async switch($,c){return this.w(C.NONE),(0,g.$fl)($)?this.R($,c):this.S($,c)}M($,c){return!($.id===c.id||m(c)&&m($))}N($,c,v){this.y(()=>{const i=new Set;for(const[o,n]of $)i.add(o),c.get(o)!==n&&this.u(v,{key:o,external:!0});for(const[o]of c.items)i.has(o)||this.u(v,{key:o,external:!0})})}}e.$Lp=f;function m(d){return d.isDefault||!!d.useDefaultFlags?.globalState}e.$Mp=m;class y extends f{constructor(){super(),this.U=this.B(new R.$Fp(new R.$Gp,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new R.$Fp(new R.$Gp,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new R.$Fp(new R.$Gp,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage($=>this.u(1,$))),this.B(this.W.onDidChangeStorage($=>this.u(0,$))),this.B(this.U.onDidChangeStorage($=>this.u(-1,$)))}P($){switch($){case-1:return this.U;case 0:return this.W;default:return this.X}}Q($){switch($){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope($){return!1}}e.$Np=y;async function l(d,$,c,v,i,o){const n=P=>{try{return JSON.parse(P)}catch{return P}},s=new Map,t=new Map;d.forEach((P,N)=>{s.set(N,P),t.set(N,n(P))});const r=new Map,a=new Map;$.forEach((P,N)=>{r.set(N,P),a.set(N,n(P))});const E=new Map,b=new Map;c.forEach((P,N)=>{E.set(N,P),b.set(N,n(P))}),console.group(v!==i?`Storage: Application (path: ${v})`:`Storage: Application & Profile (path: ${v}, default profile)`);const u=[];if(s.forEach((P,N)=>{u.push({key:N,value:P})}),console.table(u),console.groupEnd(),console.log(t),v!==i){console.group(`Storage: Profile (path: ${i}, profile specific)`);const P=[];r.forEach((N,F)=>{P.push({key:F,value:N})}),console.table(P),console.groupEnd(),console.log(a)}console.group(`Storage: Workspace (path: ${o})`);const p=[];E.forEach((P,N)=>{p.push({key:N,value:P})}),console.table(p),console.groupEnd(),console.log(b)}e.$Op=l}),define(le[114],he([0,1,3,2,12,29,33,19]),function(se,e,I,L,A,j,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hHb=e.$gHb=void 0;let k=class extends L.$Tc{constructor(S,w){super(),this.a=new I.$6d,this.onDidChangeEnablement=this.a.event,this.b=this.B(new g(S)),this.B(this.b.onDidChange(h=>this.a.fire({extensions:h,source:"storage"}))),this.B(w.onDidInstallExtensions(h=>h.forEach(({local:f,operation:m})=>{f&&m===4&&this.f(f.identifier)})))}async enableExtension(S,w){return this.f(S)?(this.a.fire({extensions:[S],source:w}),!0):!1}async disableExtension(S,w){return this.c(S)?(this.a.fire({extensions:[S],source:w}),!0):!1}getDisabledExtensions(){return this.h(j.$So)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}c(S){const w=this.getDisabledExtensions();return w.every(h=>!(0,O.$dp)(h,S))?(w.push(S),this.g(w),!0):!1}f(S){const w=this.getDisabledExtensions();for(let h=0;h<w.length;h++){const f=w[h];if((0,O.$dp)(f,S))return w.splice(h,1),this.g(w),!0}return!1}g(S){this.j(j.$So,S)}h(S){return this.b.get(S,0)}j(S,w){this.b.set(S,w,0)}};e.$gHb=k,e.$gHb=k=ye([K(0,R.$Jp),K(1,j.$Ro)],k);class g extends L.$Tc{constructor(S){super(),this.c=S,this.a=Object.create(null),this.b=this.B(new I.$6d),this.onDidChange=this.b.event,this.B(S.onDidChangeValue(0,void 0,this.B(new L.$Sc))(w=>this.f(w)))}get(S,w){let h;return w===0?((0,A.$3f)(this.a[S])&&(this.a[S]=this.g(S,w)),h=this.a[S]):h=this.g(S,w),JSON.parse(h)}set(S,w,h){const f=JSON.stringify(w.map(({id:y,uuid:l})=>({id:y,uuid:l})));this.g(S,h)!==f&&(h===0&&(w.length?this.a[S]=f:delete this.a[S]),this.h(S,w.length?f:void 0,h))}f(S){if(!(0,A.$3f)(this.a[S.key])&&this.g(S.key,S.scope)!==this.a[S.key]){const h=this.get(S.key,S.scope);delete this.a[S.key];const f=this.get(S.key,S.scope),m=h.filter(l=>!f.some(d=>(0,O.$dp)(l,d))),y=f.filter(l=>!h.some(d=>(0,O.$dp)(d,l)));(m.length||y.length)&&this.b.fire([...m,...y])}}g(S,w){return this.c.get(S,w,"[]")}h(S,w,h){w?this.c.store(S,w,h,1):this.c.remove(S,h)}}e.$hHb=g}),define(le[250],he([0,1,17,26,7,5,36,12,10,21,16,29,33,71,11,8,24,59,229,19,22,63]),function(se,e,I,L,A,j,O,R,k,g,C,S,w,h,f,m,y,l,d,$,c,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tp=e.$Sp=e.$Rp=void 0;const i=j.$o?"web":(0,S.$Ko)(j.$u,O.$ec),o="X-Market-Search-Activity-Id";var n;(function(T){T[T.None=0]="None",T[T.IncludeVersions=1]="IncludeVersions",T[T.IncludeFiles=2]="IncludeFiles",T[T.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",T[T.IncludeSharedAccounts=8]="IncludeSharedAccounts",T[T.IncludeVersionProperties=16]="IncludeVersionProperties",T[T.ExcludeNonValidated=32]="ExcludeNonValidated",T[T.IncludeInstallationTargets=64]="IncludeInstallationTargets",T[T.IncludeAssetUri=128]="IncludeAssetUri",T[T.IncludeStatistics=256]="IncludeStatistics",T[T.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",T[T.Unpublished=4096]="Unpublished",T[T.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(n||(n={}));function s(...T){return String(T.reduce((B,q)=>B|q,0))}var t;(function(T){T[T.Tag=1]="Tag",T[T.ExtensionId=4]="ExtensionId",T[T.Category=5]="Category",T[T.ExtensionName=7]="ExtensionName",T[T.Target=8]="Target",T[T.Featured=9]="Featured",T[T.SearchText=10]="SearchText",T[T.ExcludeWithFlags=12]="ExcludeWithFlags"})(t||(t={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},a={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink",SupportLink:"Microsoft.VisualStudio.Services.Links.Support"},b={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:n.None,criteria:[],assetTypes:[]};class u{constructor(B=b){this.d=B}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(B,q=this.d.pageSize){return new u({...this.d,pageNumber:B,pageSize:q})}withFilter(B,...q){const Y=[...this.d.criteria,...q.length?q.map(_=>({filterType:B,value:_})):[{filterType:B}]];return new u({...this.d,criteria:Y})}withSortBy(B){return new u({...this.d,sortBy:B})}withSortOrder(B){return new u({...this.d,sortOrder:B})}withFlags(...B){return new u({...this.d,flags:B.reduce((q,Y)=>q|Y,0)})}withAssetTypes(...B){return new u({...this.d,assetTypes:B})}withSource(B){return new u({...this.d,source:B})}get raw(){const{criteria:B,pageNumber:q,pageSize:Y,sortBy:_,sortOrder:ie,flags:J,assetTypes:ne}=this.d;return{filters:[{criteria:B,pageNumber:q,pageSize:Y,sortBy:_,sortOrder:ie}],assetTypes:ne,flags:J}}get searchText(){const B=this.d.criteria.filter(q=>q.filterType===t.SearchText)[0];return B&&B.value?B.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(B=>String(B.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function p(T,B){const q=(T||[]).filter(Y=>Y.statisticName===B)[0];return q?q.value:0}function P(T){const B="Microsoft.VisualStudio.Code.Translation.";return T.files.filter(Y=>Y.assetType.indexOf(B)===0).reduce((Y,_)=>{const ie=M(T,_.assetType);return ie&&Y.push([_.assetType.substring(B.length),ie]),Y},[])}function N(T){if(T.properties){const B=T.properties.filter(_=>_.key===r.Repository),q=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),Y=B.filter(_=>q.test(_.value))[0];return Y?{uri:Y.value,fallbackUri:Y.value}:null}return M(T,r.Repository)}function F(T){return{uri:`${T.fallbackAssetUri}/${r.VSIX}?redirect=true${T.targetPlatform?`&targetPlatform=${T.targetPlatform}`:""}`,fallbackUri:`${T.fallbackAssetUri}/${r.VSIX}${T.targetPlatform?`?targetPlatform=${T.targetPlatform}`:""}`}}function M(T,B){return T.files.filter(Y=>Y.assetType===B)[0]?{uri:`${T.assetUri}/${B}${T.targetPlatform?`?targetPlatform=${T.targetPlatform}`:""}`,fallbackUri:`${T.fallbackAssetUri}/${B}${T.targetPlatform?`?targetPlatform=${T.targetPlatform}`:""}`}:null}function z(T,B){const q=T.properties?T.properties.filter(_=>_.key===B):[],Y=q.length>0&&q[0].value;return Y?Y.split(",").map(_=>(0,w.$hp)(_)):[]}function Z(T){const B=T.properties?T.properties.filter(q=>q.key===a.Engine):[];return B.length>0&&B[0].value||""}function X(T){const B=T.properties?T.properties.filter(q=>q.key===a.PreRelease):[];return B.length>0&&B[0].value==="true"}function x(T){const B=T.properties?T.properties.filter(Y=>Y.key===a.LocalizedLanguages):[],q=B.length>0&&B[0].value||"";return q?q.split(","):[]}function W(T){return T.properties?.find(B=>B.key===a.SponsorLink)?.value}function Q(T){return T.properties?.find(B=>B.key===a.SupportLink)?.value}function H(T){return T.indexOf("preview")!==-1}function V(T){return T.targetPlatform?(0,S.$Jo)(T.targetPlatform):"undefined"}function te(T){const B=(0,I.$Mb)(T.versions.map(V)),q=!!T.tags?.includes(S.$Eo),Y=B.indexOf("web");return q?Y===-1&&B.push("web"):Y!==-1&&B.splice(Y,1),B}function re(T,B){for(let q=0;q<T.length;q++){const Y=T[q];if(Y.version===T[q-1]?.version){let _=q;if(V(Y)===B)for(;_>0&&T[_-1].version===Y.version;)_--;_!==q&&(T.splice(q,1),T.splice(_,0,Y))}}return T}e.$Rp=re;function ee(T,B,q){T.telemetryData={index:B,querySource:q,queryActivityId:T.queryContext?.[o]}}function ae(T,B,q,Y){const _=T.versions[0],ie={manifest:M(B,r.Manifest),readme:M(B,r.Details),changelog:M(B,r.Changelog),license:M(B,r.License),repository:N(B),download:F(B),icon:M(B,r.Icon),signature:M(B,r.Signature),coreTranslations:P(B)};return{identifier:{id:(0,w.$ip)(T.publisher.publisherName,T.extensionName),uuid:T.extensionId},name:T.extensionName,version:B.version,displayName:T.displayName,publisherId:T.publisher.publisherId,publisher:T.publisher.publisherName,publisherDisplayName:T.publisher.displayName,publisherDomain:T.publisher.domain?{link:T.publisher.domain,verified:!!T.publisher.isDomainVerified}:void 0,publisherSponsorLink:W(_),description:T.shortDescription??"",installCount:p(T.statistics,"install"),rating:p(T.statistics,"averagerating"),ratingCount:p(T.statistics,"ratingcount"),categories:T.categories||[],tags:T.tags||[],releaseDate:Date.parse(T.releaseDate),lastUpdated:Date.parse(T.lastUpdated),allTargetPlatforms:q,assets:ie,properties:{dependencies:z(B,a.Dependency),extensionPack:z(B,a.ExtensionPack),engine:Z(B),localizedLanguages:x(B),targetPlatform:V(B),isPreReleaseVersion:X(B)},hasPreReleaseVersion:X(_),hasReleaseVersion:!0,preview:H(T.flags),isSigned:!!ie.signature,queryContext:Y,supportLink:Q(_)}}let G=class{constructor(B,q,Y,_,ie,J,ne,ce){this.k=q,this.l=Y,this.n=_,this.o=ie,this.q=J,this.u=ne,this.w=ce;const fe=ne.extensionsGallery,de=fe?.servicePPEUrl&&ce.getValue("_extensionsGallery.enablePPE");this.d=de?fe.servicePPEUrl:fe?.serviceUrl,this.g=de?void 0:fe?.searchUrl,this.h=fe?.controlUrl,this.j=(0,d.$Qp)(ne.version,ne,this.n,this.w,this.q,B,this.o)}x(B=""){return`${this.d}${B}`}isEnabled(){return!!this.d}async getExtensions(B,q,Y){const _=L.CancellationToken.isCancellationToken(q)?{}:q,ie=L.CancellationToken.isCancellationToken(q)?q:Y,J=[],ne=[],ce=[],fe=[];let de=!0;for(const Re of B){Re.uuid?ne.push(Re.uuid):J.push(Re.id);const Oe=!!(Re.version||Re.preRelease);ce.push({id:Re.id,uuid:Re.uuid,includePreRelease:Oe}),Re.version&&fe.push({id:Re.id,uuid:Re.uuid,version:Re.version}),de=de&&!!Re.hasPreRelease&&!Oe}if(!ne.length&&!J.length)return[];let me=new u().withPage(1,B.length);ne.length&&(me=me.withFilter(t.ExtensionId,...ne)),J.length&&(me=me.withFilter(t.ExtensionName,...J)),(_.queryAllVersions||de)&&(me=me.withFlags(me.flags,n.IncludeVersions)),_.source&&(me=me.withSource(_.source));const{extensions:Ee}=await this.z(me,{targetPlatform:_.targetPlatform??i,includePreRelease:ce,versions:fe,compatible:!!_.compatible},ie);return _.source&&Ee.forEach((Re,Oe)=>ee(Re,Oe,_.source)),Ee}async getCompatibleExtension(B,q,Y){if((0,S.$Lo)(B.allTargetPlatforms,Y))return null;if(await this.isExtensionCompatible(B,q,Y))return B;const _=new u().withFlags(n.IncludeVersions).withPage(1,1).withFilter(t.ExtensionId,B.identifier.uuid),{extensions:ie}=await this.z(_,{targetPlatform:Y,compatible:!0,includePreRelease:q},L.CancellationToken.None);return ie[0]||null}async isExtensionCompatible(B,q,Y){if(!(0,S.$Mo)(B.properties.targetPlatform,B.allTargetPlatforms,Y)||!q&&B.properties.isPreReleaseVersion)return!1;let _=B.properties.engine;if(!_){const ie=await this.getManifest(B,L.CancellationToken.None);if(!ie)throw new Error("Manifest was not found");_=ie.engines.vscode}return(0,h.$vp)(_,this.u.version,this.u.date)}async y(B,q,Y,_,ie){if(!(0,S.$Mo)(V(B),_,ie)||q!=="any"&&X(B)!==(q==="prerelease"))return!1;if(Y)try{const J=await this.E(B);if(!(0,h.$vp)(J,this.u.version,this.u.date))return!1}catch(J){return this.l.error(`Error while getting the engine for the version ${B.version}.`,(0,A.$0)(J)),!1}return!0}async query(B,q){let Y=B.text||"";const _=B.pageSize??50;let ie=new u().withPage(1,_);Y?(Y=Y.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(de,me,Ee)=>(ie=ie.withFilter(t.Category,Ee||me),"")),Y=Y.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(de,me,Ee)=>(ie=ie.withFilter(t.Tag,Ee||me),"")),Y=Y.replace(/\bfeatured(\s+|\b|$)/g,()=>(ie=ie.withFilter(t.Featured),"")),Y=Y.trim(),Y&&(Y=Y.length<200?Y:Y.substring(0,200),ie=ie.withFilter(t.SearchText,Y)),ie=ie.withSortBy(0)):B.ids?ie=ie.withFilter(t.ExtensionId,...B.ids):B.names?ie=ie.withFilter(t.ExtensionName,...B.names):ie=ie.withSortBy(4),typeof B.sortBy=="number"&&(ie=ie.withSortBy(B.sortBy)),typeof B.sortOrder=="number"&&(ie=ie.withSortOrder(B.sortOrder)),B.source&&(ie=ie.withSource(B.source));const J=async(de,me)=>{const{extensions:Ee,total:Re}=await this.z(de,{targetPlatform:i,compatible:!1,includePreRelease:!!B.includePreRelease},me);return Ee.forEach((Oe,Ne)=>ee(Oe,(de.pageNumber-1)*de.pageSize+Ne,B.source)),{extensions:Ee,total:Re}},{extensions:ne,total:ce}=await J(ie,q),fe=async(de,me)=>{if(me.isCancellationRequested)throw new A.$5;const{extensions:Ee}=await J(ie.withPage(de+1),me);return Ee};return{firstPage:ne,total:ce,pageSize:ie.pageSize,getPage:fe}}async z(B,q,Y){const _=B.flags;B.flags&n.IncludeLatestVersionOnly&&B.flags&n.IncludeVersions&&(B=B.withFlags(B.flags&~n.IncludeVersions,n.IncludeLatestVersionOnly)),!(B.flags&n.IncludeLatestVersionOnly)&&!(B.flags&n.IncludeVersions)&&(B=B.withFlags(B.flags,n.IncludeLatestVersionOnly)),q.versions?.length&&(B=B.withFlags(B.flags&~n.IncludeLatestVersionOnly,n.IncludeVersions)),B=B.withFlags(B.flags,n.IncludeAssetUri,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeStatistics,n.IncludeVersionProperties);const{galleryExtensions:ie,total:J,context:ne}=await this.B(B,Y);if(!(B.flags&n.IncludeLatestVersionOnly)){const me=[];for(const Ee of ie){const Re=await this.A(Ee,q,ne);Re&&me.push(Re)}return{extensions:me,total:J}}const fe=[],de=new Map;for(let me=0;me<ie.length;me++){const Ee=ie[me],Re={id:(0,w.$ip)(Ee.publisher.publisherName,Ee.extensionName),uuid:Ee.extensionId},Oe=(0,R.$Zf)(q.includePreRelease)?q.includePreRelease:!!q.includePreRelease.find(ue=>(0,w.$dp)(ue,Re))?.includePreRelease;if(q.compatible&&(0,S.$Lo)(te(Ee),q.targetPlatform))continue;const Ne=await this.A(Ee,q,ne);!Ne||Ne.properties.isPreReleaseVersion&&(!Oe||!Ne.hasReleaseVersion)||!Ne.properties.isPreReleaseVersion&&Ne.properties.targetPlatform!==q.targetPlatform&&Ne.hasPreReleaseVersion?de.set(Ee.extensionId,me):fe.push([me,Ne])}if(de.size){const me=new v.$2d,Ee=new u().withFlags(_&~n.IncludeLatestVersionOnly,n.IncludeVersions).withPage(1,de.size).withFilter(t.ExtensionId,...de.keys()),{extensions:Re}=await this.z(Ee,q,Y);this.o.publicLog2("galleryService:additionalQuery",{duration:me.elapsed(),count:de.size});for(const Oe of Re){const Ne=de.get(Oe.identifier.uuid);fe.push([Ne,Oe])}}return{extensions:fe.sort((me,Ee)=>me[0]-Ee[0]).map(([,me])=>me),total:J}}async A(B,q,Y){const _={id:(0,w.$ip)(B.publisher.publisherName,B.extensionName),uuid:B.extensionId},ie=q.versions?.find(fe=>(0,w.$dp)(fe,_))?.version,J=(0,R.$Zf)(q.includePreRelease)?q.includePreRelease:!!q.includePreRelease.find(fe=>(0,w.$dp)(fe,_))?.includePreRelease,ne=te(B),ce=re(B.versions,q.targetPlatform);if(q.compatible&&(0,S.$Lo)(ne,q.targetPlatform))return null;for(let fe=0;fe<ce.length;fe++){const de=ce[fe];if(!(ie&&de.version!==ie)){if(await this.y(de,J?"any":"release",q.compatible,ne,q.targetPlatform))return ae(B,de,ne,Y);if(ie&&de.version===ie)return null}}return ie||q.compatible?null:ae(B,B.versions[0],ne)}async B(B,q){if(!this.isEnabled())throw new Error("No extension gallery service configured.");B=B.withFlags(B.flags,n.ExcludeNonValidated).withFilter(t.Target,"Microsoft.VisualStudio.Code").withFilter(t.ExcludeWithFlags,s(n.Unpublished));const Y=await this.j,_=JSON.stringify(B.raw),ie={...Y,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(_.length)},J=new v.$2d;let ne,ce,fe=0;try{if(ne=await this.k.request({type:"POST",url:this.g&&B.criteria.some(me=>me.filterType===t.SearchText)?this.g:this.x("/extensionquery"),data:_,headers:ie},q),ne.res.statusCode&&ne.res.statusCode>=400&&ne.res.statusCode<500)return{galleryExtensions:[],total:fe};const de=await(0,l.$Cp)(ne);if(de){const me=de.results[0],Ee=me.extensions,Re=me.resultMetadata&&me.resultMetadata.filter(Oe=>Oe.metadataType==="ResultCount")[0];return fe=Re&&Re.metadataItems.filter(Oe=>Oe.name==="TotalCount")[0].count||0,{galleryExtensions:Ee,total:fe,context:{[o]:ne.res.headers.activityid}}}return{galleryExtensions:[],total:fe}}catch(de){const me=(0,A.$4)(de)?S.ExtensionGalleryErrorCode.Cancelled:(0,A.$0)(de).startsWith("XHR timeout")?S.ExtensionGalleryErrorCode.Timeout:S.ExtensionGalleryErrorCode.Failed;throw ce=new S.$Qo((0,A.$0)(de),me),ce}finally{this.o.publicLog2("galleryService:query",{...B.telemetryData,requestBodySize:String(_.length),duration:J.elapsed(),success:!!ne&&(0,l.$yp)(ne),responseBodySize:ne?.res.headers["Content-Length"],statusCode:ne?String(ne.res.statusCode):void 0,errorCode:ce?.code,count:String(fe)})}}async reportStatistic(B,q,Y,_){if(!this.isEnabled())return;const ie=j.$o?this.x(`/itemName/${B}.${q}/version/${Y}/statType/${_==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${B}/extensions/${q}/${Y}/stats?statType=${_}`),J=j.$o?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ce={...await this.j,Accept:J};try{await this.k.request({type:"POST",url:ie,headers:ce},L.CancellationToken.None)}catch{}}async download(B,q,Y){this.l.trace("ExtensionGalleryService#download",B.identifier.id);const _=(0,w.$lp)(B),ie=new Date().getTime(),J=me=>this.o.publicLog("galleryService:downloadVSIX",{..._,duration:me}),ne=Y===2?"install":Y===3?"update":"",ce=ne?{uri:`${B.assets.download.uri}${k.URI.parse(B.assets.download.uri).query?"&":"?"}${ne}=true`,fallbackUri:`${B.assets.download.fallbackUri}${k.URI.parse(B.assets.download.fallbackUri).query?"&":"?"}${ne}=true`}:B.assets.download,fe=B.queryContext?.[o]?{[o]:B.queryContext[o]}:void 0,de=await this.D(ce,fe?{headers:fe}:void 0);await this.q.writeFile(q,de.stream),J(new Date().getTime()-ie)}async downloadSignatureArchive(B,q){if(!B.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",B.identifier.id);const Y=await this.D(B.assets.signature);await this.q.writeFile(q,Y.stream)}async getReadme(B,q){if(B.assets.readme){const Y=await this.D(B.assets.readme,{},q);return await(0,l.$Bp)(Y)||""}return""}async getManifest(B,q){if(B.assets.manifest){const Y=await this.D(B.assets.manifest,{},q),_=await(0,l.$Bp)(Y);return _?JSON.parse(_):null}return null}async C(B,q){const Y=M(B,r.Manifest);if(!Y)throw new Error("Manifest was not found");const _={"Accept-Encoding":"gzip"},ie=await this.D(Y,{headers:_});return await(0,l.$Cp)(ie)}async getCoreTranslation(B,q){const Y=B.assets.coreTranslations.filter(_=>_[0]===q.toUpperCase())[0];if(Y){const _=await this.D(Y[1]),ie=await(0,l.$Bp)(_);return ie?JSON.parse(ie):null}return null}async getChangelog(B,q){if(B.assets.changelog){const Y=await this.D(B.assets.changelog,{},q);return await(0,l.$Bp)(Y)||""}return""}async getAllCompatibleVersions(B,q,Y){let _=new u().withFlags(n.IncludeVersions,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties).withPage(1,1);B.identifier.uuid?_=_.withFilter(t.ExtensionId,B.identifier.uuid):_=_.withFilter(t.ExtensionName,B.identifier.id);const{galleryExtensions:ie}=await this.B(_,L.CancellationToken.None);if(!ie.length)return[];const J=te(ie[0]);if((0,S.$Lo)(J,Y))return[];const ne=[];await Promise.all(ie[0].versions.map(async de=>{try{await this.y(de,q?"any":"release",!0,J,Y)&&ne.push(de)}catch{}}));const ce=[],fe=new Set;for(const de of re(ne,Y))fe.has(de.version)||(fe.add(de.version),ce.push({version:de.version,date:de.lastUpdated,isPreReleaseVersion:X(de)}));return ce}async D(B,q={},Y=L.CancellationToken.None){const _=await this.j,ie={type:"GET"},J={..._,...q.headers||{}};q={...q,...ie,headers:J};const ne=B.uri,ce=B.fallbackUri,fe={...q,url:ne};try{const de=await this.k.request(fe,Y);if(de.res.statusCode===200)return de;const me=await(0,l.$Bp)(de);throw new Error(`Expected 200, got back ${de.res.statusCode} instead.

${me}`)}catch(de){if((0,A.$4)(de))throw de;const me=(0,A.$0)(de);this.o.publicLog2("galleryService:cdnFallback",{url:ne,message:me});const Ee={...q,url:ce};return this.k.request(Ee,Y)}}async E(B){let q=Z(B);if(!q){const Y=await this.C(B,L.CancellationToken.None);if(!Y)throw new Error("Manifest was not found");q=Y.engines.vscode}return q}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const B=await this.k.request({type:"GET",url:this.h},L.CancellationToken.None);if(B.res.statusCode!==200)throw new Error("Could not get extensions report.");const q=await(0,l.$Cp)(B),Y=[],_={},ie=[];if(q){for(const J of q.malicious)Y.push({id:J});if(q.migrateToPreRelease)for(const[J,ne]of Object.entries(q.migrateToPreRelease))(!ne.engine||(0,h.$vp)(ne.engine,this.u.version,this.u.date))&&(_[J.toLowerCase()]={disallowInstall:!0,extension:{id:ne.id,displayName:ne.displayName,autoMigrate:{storage:!!ne.migrateStorage},preRelease:!0}});if(q.deprecated)for(const[J,ne]of Object.entries(q.deprecated))ne&&(_[J.toLowerCase()]=(0,R.$Zf)(ne)?{}:ne);if(q.search)for(const J of q.search)ie.push(J)}return{malicious:Y,deprecated:_,search:ie}}};G=ye([K(1,l.$wp),K(2,m.$Aj),K(3,C.$ni),K(4,c.$Fl),K(5,f.$Gk),K(6,y.$Sj),K(7,g.$Mi)],G);let U=class extends G{constructor(B,q,Y,_,ie,J,ne,ce){super(B,q,Y,_,ie,J,ne,ce)}};e.$Sp=U,e.$Sp=U=ye([K(0,$.$Jp),K(1,l.$wp),K(2,m.$Aj),K(3,C.$ni),K(4,c.$Fl),K(5,f.$Gk),K(6,y.$Sj),K(7,g.$Mi)],U);let D=class extends G{constructor(B,q,Y,_,ie,J,ne){super(void 0,B,q,Y,_,ie,J,ne)}};e.$Tp=D,e.$Tp=D=ye([K(0,l.$wp),K(1,m.$Aj),K(2,C.$ni),K(3,c.$Fl),K(4,f.$Gk),K(5,y.$Sj),K(6,g.$Mi)],D)}),define(le[82],he([0,1,4,3,2,19,33,24,17,8,12]),function(se,e,I,L,A,j,O,R,k,g,C){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$Dv=e.$Cv=void 0,e.$Cv=(0,I.$gi)("IExtensionStorageService");const w=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let h=class extends A.$Tc{static{S=this}static{this.a=512*1024}static b(m){return`extensionKeys/${(0,O.$hp)(m.id)}@${m.version}`}static c(m){const y=w.exec(m);if(y&&y[1])return{id:y[1],version:y[2]}}static async removeOutdatedExtensionVersions(m,y){const l=await m.getInstalled(),d=[];for(const[$,c]of S.f(y)){const v=l.find(i=>(0,O.$dp)(i.identifier,{id:$}))?.manifest.version;for(const i of c)v!==i&&d.push(S.b({id:$,version:i}))}for(const $ of d)y.remove($,0)}static f(m){const y=new Map,l=m.keys(0,1);for(const d of l){const $=S.c(d);if($){let c=y.get($.id.toLowerCase());c||y.set($.id.toLowerCase(),c=[]),c.push($.version)}}return y}constructor(m,y,l){super(),this.j=m,this.m=y,this.n=l,this.g=this.B(new L.$6d),this.onDidChangeExtensionStorageToSync=this.g.event,this.h=S.f(m),this.B(this.j.onDidChangeValue(0,void 0,this.B(new A.$Sc))(d=>this.r(d)))}r(m){if(this.h.has(m.key.toLowerCase())){this.g.fire();return}const y=S.c(m.key);if(y){if(this.j.get(m.key,0)===void 0)this.h.delete(y.id.toLowerCase());else{let l=this.h.get(y.id.toLowerCase());l||this.h.set(y.id.toLowerCase(),l=[]),l.push(y.version),this.g.fire()}return}}s(m){if((0,C.$Tf)(m))return m;const y=m.manifest?m.manifest.publisher:m.publisher,l=m.manifest?m.manifest.name:m.name;return(0,O.$gp)(y,l)}getExtensionState(m,y){const l=this.s(m),d=this.getExtensionStateRaw(m,y);if(d)try{return JSON.parse(d)}catch($){this.n.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${l}, global: ${y}): ${$}`)}}getExtensionStateRaw(m,y){const l=this.s(m),d=this.j.get(l,y?0:1);return d&&d?.length>S.a&&this.n.warn(`[mainThreadStorage] large extension state detected (extensionId: ${l}, global: ${y}): ${d.length/1024}kb. Consider to use 'storageUri' or 'globalStorageUri' to store this data on disk instead.`),d}setExtensionState(m,y,l){const d=this.s(m);y===void 0?this.j.remove(d,l?0:1):this.j.store(d,JSON.stringify(y),l?0:1,1)}setKeysForSync(m,y){this.j.store(S.b(m),JSON.stringify(y),0,1)}getKeysForSync(m){const y=this.m.extensionSyncedKeys?.[m.id.toLowerCase()],l=this.j.get(S.b(m),0),d=l?JSON.parse(l):void 0;return d&&y?(0,k.$Mb)([...d,...y]):d||y}addToMigrationList(m,y){if(m!==y){const l=this.t.filter(d=>!d.includes(m)&&!d.includes(y));l.push([m,y]),this.t=l}}getSourceExtensionToMigrate(m){const y=this.t.find(([,l])=>m===l);return y?y[0]:void 0}get t(){const m=this.j.get("extensionStorage.migrationList",-1,"[]");try{const y=JSON.parse(m);if(Array.isArray(y))return y}catch{}return[]}set t(m){m.length?this.j.store("extensionStorage.migrationList",JSON.stringify(m),-1,1):this.j.remove("extensionStorage.migrationList",-1)}};e.$Dv=h,e.$Dv=h=S=ye([K(0,j.$Jp),K(1,R.$Sj),K(2,g.$Aj)],h)}),define(le[251],he([0,1,2,29,82,226,113,8,19]),function(se,e,I,L,A,j,O,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qbc=void 0;let g=class extends I.$Tc{constructor(S,w,h,f,m,y){super(),S.cleanUp(),(0,j.$j2b)(S,w,h,f,y),A.$Dv.removeOutdatedExtensionVersions(S,m)}};e.$Qbc=g,e.$Qbc=g=ye([K(0,O.$mq),K(1,L.$Oo),K(2,A.$Cv),K(3,L.$Uo),K(4,k.$Jp),K(5,R.$Aj)],g)}),define(le[252],he([0,1,29,11,24,16,96,57,19,22,225]),function(se,e,I,L,A,j,O,R,k,g,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xbc=void 0;let S=class extends C.$a$b{constructor(h,f,m,y,l,d,$,c){super(h.userHome,l,f,m,y,d,$,c)}};e.$Xbc=S,e.$Xbc=S=ye([K(0,j.$oi),K(1,g.$Fl),K(2,I.$Ro),K(3,k.$Jp),K(4,R.$N_b),K(5,O.$61b),K(6,L.$Gk),K(7,A.$Sj)],S)}),define(le[253],he([0,1,105,3,22,16,2,8,15,67,24,5,6,100,21,167,37,19,12,132,20]),function(se,e,I,L,A,j,O,R,k,g,C,S,w,h,f,m,y,l,d,$,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tbc=void 0;const v=[I.$Mbc,I.$Nbc],i="remoteTunnelSession",o="remoteTunnelIsService";let n=class extends O.$Tc{constructor(a,E,b,u,p,P,N){super(),this.y=a,this.z=E,this.C=b,this.D=P,this.F=N,this.f=new L.$6d,this.onDidTokenFailed=this.f.event,this.g=new L.$6d,this.onDidChangeTunnelStatus=this.g.event,this.h=new L.$6d,this.onDidChangeMode=this.h.event,this.n=I.$Kbc,this.w=!1,this.I=(F,M)=>{M?this.j.error(F):this.j.info(F)},this.j=this.B(u.createLogger((0,c.$Tg)(b.logsHome,`${I.$Obc}.log`),{id:I.$Obc,name:I.$Pbc})),this.t=new w.$dh(100),this.B(this.j.onDidChangeLogLevel(F=>this.j.info("Log level changed to "+(0,R.$Pj)(F)))),this.B(p.onWillShutdown(()=>{this.r?.cancel(),this.r=void 0,this.dispose()})),this.B(P.onDidChangeConfiguration(F=>{v.some(M=>F.affectsConfiguration(M))&&this.t.trigger(()=>this.L())})),this.n=this.R(),this.s=I.TunnelStates.uninitialized}async getTunnelStatus(){return this.s}G(a){this.s=a,this.g.fire(a)}H(a){t(this.n,a)||(this.n=a,this.S(a),this.h.fire(this.n),a.active?(this.j.info(`Session updated: ${a.session.accountLabel} (${a.session.providerId}) (service=${a.asService})`),a.session.token&&this.j.info(`Session token updated: ${a.session.accountLabel} (${a.session.providerId})`)):this.j.info("Session reset"))}getMode(){return Promise.resolve(this.n)}async initialize(a){if(this.w)return this.s;this.w=!0,this.H(a);try{await this.t.trigger(()=>this.L())}catch(E){this.j.error(E)}return this.s}J(){if(!this.u){let a;S.$j?a=this.C.appRoot:a=(0,k.$mc)((0,k.$mc)(this.C.appRoot)),this.u=(0,k.$jc)(a,"bin",`${this.z.tunnelApplicationName}${S.$i?".exe":""}`)}return this.u}async startTunnel(a){if(t(this.n,a)&&this.s.type!=="disconnected")return this.s;this.H(a);try{await this.t.trigger(()=>this.L())}catch(E){this.j.error(E)}return this.s}async stopTunnel(){if(this.r&&(this.r.cancel(),this.r=void 0),this.n.active){const a=this.n.asService;this.H(I.$Kbc);try{a&&this.O("uninstallService",["service","uninstall"])}catch(E){this.j.error(E)}}try{await this.O("stop",["kill"])}catch(a){this.j.error(a)}this.G(I.TunnelStates.disconnected())}async L(){this.y.publicLog2("remoteTunnel.enablement",{enabled:this.n.active,service:this.n.active&&this.n.asService}),this.r&&(this.r.cancel(),this.r=void 0);let a="",E=!1;const b=(M,z)=>{z?this.j.error(M):a+=M,!this.C.isBuilt&&M.startsWith("   Compiling")&&this.G(I.TunnelStates.connecting((0,m.localize)(0,null)))},u=this.O("status",["status"],b);this.r=u;try{if(await u,this.r!==u)return;let M;try{M=JSON.parse(a.trim().split(`
`).find(z=>z.startsWith("{")))}catch{this.j.error(`Could not parse status output: ${JSON.stringify(a.trim())}`),this.G(I.TunnelStates.disconnected());return}if(E=M.service_installed,this.j.info(M.tunnel?"Other tunnel running, attaching...":"No other tunnel running"),!M.tunnel&&!this.n.active){this.G(I.TunnelStates.disconnected());return}}catch(M){this.j.error(M),this.G(I.TunnelStates.disconnected());return}finally{this.r===u&&(this.r=void 0)}const p=this.n.active?this.n.session:void 0;if(p&&p.token){const M=p.token;this.G(I.TunnelStates.connecting((0,m.localize)(1,null,p.accountLabel,p.providerId)));const z=(X,x)=>{X=X.replaceAll(M,"*".repeat(4)),b(X,x)},Z=this.O("login",["user","login","--provider",p.providerId,"--access-token",M,"--log",(0,R.$Pj)(this.j.getLevel())],z);this.r=Z;try{if(await Z,this.r!==Z)return}catch(X){this.j.error(X),this.r=void 0,this.f.fire(p),this.G(I.TunnelStates.disconnected(p));return}}const P=this.Q();P?this.G(I.TunnelStates.connecting((0,m.localize)(2,null,P))):this.G(I.TunnelStates.connecting((0,m.localize)(3,null)));const N=["--accept-server-license-terms","--log",(0,R.$Pj)(this.j.getLevel())];P?N.push("--name",P):N.push("--random-name");let F=!1;return this.n.active&&this.n.asService&&!E&&(F=await this.M(N)===!1),this.N(p,N,F)}async M(a){let E;try{E=await this.O("serviceInstall",["service","install",...a])}catch(b){this.j.error(b),E=1}if(E!==0){const b=(0,m.localize)(4,null);return this.j.warn(b),this.G(I.TunnelStates.connecting(b)),!1}return!0}async N(a,E,b){E.push("--parent-process-id",String(process.pid)),this.P()&&E.push("--no-sleep");let u=!1;const p=this.O("tunnel",E,(P,N)=>{N?this.j.error(P):this.j.info(P),P.includes("Connected to an existing tunnel process")&&(u=!0);const F=P.match(/Open this link in your browser (https:\/\/([^\/\s]+)\/([^\/\s]+)\/([^\/\s]+))/);if(F){const M={link:F[1],domain:F[2],tunnelName:F[4],isAttached:u};this.G(I.TunnelStates.connected(M,b))}else P.match(/error refreshing token/)&&(p.cancel(),this.f.fire(a),this.G(I.TunnelStates.disconnected(a)))});this.r=p,p.finally(()=>{p===this.r&&(this.j.info("tunnel process terminated"),this.r=void 0,this.n=I.$Kbc,this.G(I.TunnelStates.disconnected()))})}O(a,E,b=this.I){return(0,w.$6g)(u=>new Promise((p,P)=>{u.isCancellationRequested&&p(-1);let N;const F=["ignore","pipe","pipe"];if(u.onCancellationRequested(()=>{N&&(this.j.info(`${a} terminating(${N.pid})`),N.kill())}),!this.C.isBuilt)b(`Building tunnel CLI from sources and run
`,!1),b(`${a} Spawning: cargo run -- tunnel ${E.join(" ")}
`,!1),N=(0,g.spawn)("cargo",["run","--","tunnel",...E],{cwd:(0,k.$jc)(this.C.appRoot,"cli"),stdio:F});else{b(`Running tunnel CLI
`,!1);const M=this.J();b(`${a} Spawning: ${M} tunnel ${E.join(" ")}
`,!1),N=(0,g.spawn)(M,["tunnel",...E],{cwd:(0,y.homedir)(),stdio:F})}N.stdout.pipe(new $.$NV(`
`)).on("data",M=>{if(N){const z=M.toString();b(z,!1)}}),N.stderr.pipe(new $.$NV(`
`)).on("data",M=>{if(N){const z=M.toString();b(z,!0)}}),N.on("exit",M=>{N&&(b(`${a} exit(${N.pid}): + ${M} `,!1),N=void 0,p(M||0))}),N.on("error",M=>{N&&(b(`${a} error(${N.pid}): + ${M} `,!0),N=void 0,P())})}))}async getTunnelName(){return this.Q()}P(){return!!this.D.getValue(I.$Nbc)}Q(){let a=this.D.getValue(I.$Mbc)||(0,y.hostname)();return a=a.replace(/^-+/g,"").replace(/[^\w-]/g,"").substring(0,20),a||void 0}R(){try{const a=this.F.get(i,-1),E=this.F.getBoolean(o,-1,!1);if(a){const b=JSON.parse(a);if(b&&(0,d.$Tf)(b.accountLabel)&&(0,d.$Tf)(b.sessionId)&&(0,d.$Tf)(b.providerId))return{active:!0,session:b,asService:E};this.j.error("Problems restoring session from storage, invalid format",b)}}catch(a){this.j.error("Problems restoring session from storage",a)}return I.$Kbc}S(a){if(a.active){const E={providerId:a.session.providerId,sessionId:a.session.sessionId,accountLabel:a.session.accountLabel};this.F.store(i,JSON.stringify(E),-1,1),this.F.store(o,a.asService,-1,1)}else this.F.remove(i,-1),this.F.remove(o,-1)}};e.$Tbc=n,e.$Tbc=n=ye([K(0,A.$Fl),K(1,C.$Sj),K(2,j.$oi),K(3,R.$Bj),K(4,h.$Rbc),K(5,f.$Mi),K(6,l.$Jp)],n);function s(r,a){return r&&a?r.sessionId===a.sessionId&&r.providerId===a.providerId&&r.token===a.token:r===a}const t=(r,a)=>r.active!==a.active?!1:r.active&&a.active?r.asService===a.asService&&s(r.session,a.session):!0}),define(le[254],he([0,1,6,2,23,20,69,19,77,18]),function(se,e,I,L,A,j,O,R,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ybc=void 0;class C extends R.$Lp{constructor(w,h,f,m){super(),this.bb=w,this.cb=h,this.db=f,this.eb=m,this.s=this.cb.defaultProfile,this.U=this.fb(),this.W=this.cb.currentProfile,this.X=this.B(new L.$Sc),this.Y=this.gb(this.W),this.Z=this.bb?.id,this.$=this.B(new L.$Sc),this.ab=this.hb(this.bb)}fb(){const w=this.B(new k.$QHb(this.db.getChannel("storage"))),h=this.B(new O.$Fp(w));return this.B(h.onDidChangeStorage(f=>this.u(-1,f))),h}gb(w){this.X.clear(),this.W=w;let h;if((0,R.$Mp)(w))h=this.U;else{const f=this.X.add(new k.$RHb(this.db.getChannel("storage"),w));h=this.X.add(new O.$Fp(f))}return this.X.add(h.onDidChangeStorage(f=>this.u(0,f))),h}hb(w){this.$.clear(),this.Z=w?.id;let h;if(w){const f=this.$.add(new k.$SHb(this.db.getChannel("storage"),w));h=this.$.add(new O.$Fp(f)),this.$.add(h.onDidChangeStorage(m=>this.u(1,m)))}return h}async O(){await I.Promises.settled([this.U.init(),this.Y.init(),this.ab?.init()??Promise.resolve()])}P(w){switch(w){case-1:return this.U;case 0:return this.Y;default:return this.ab}}Q(w){switch(w){case-1:return this.s.globalStorageHome.with({scheme:A.Schemas.file}).fsPath;case 0:return this.W?.globalStorageHome.with({scheme:A.Schemas.file}).fsPath;default:return this.Z?`${(0,j.$Tg)(this.eb.workspaceStorageHome,this.Z,"state.vscdb").with({scheme:A.Schemas.file}).fsPath}`:void 0}}async close(){this.t(),this.w(R.WillSaveStateReason.SHUTDOWN),await I.Promises.settled([this.U.close(),this.Y.close(),this.ab?.close()??Promise.resolve()])}async R(w){if(!this.M(this.W,w))return;const h=this.Y,f=h.items;h!==this.U&&await h.close(),this.Y=this.gb(w),await this.Y.init(),this.N(f,this.Y,0)}async S(w,h){const f=this.ab,m=f?.items??new Map;await f?.close(),this.ab=this.hb(w),await this.ab.init(),this.N(m,this.ab,1)}hasScope(w){return(0,g.$fl)(w)?this.W.id===w.id:this.Z===w.id}}e.$Ybc=C}),define(le[255],he([0,1,3,2,18,91]),function(se,e,I,L,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WP=e.$VP=void 0;class O{constructor(g,C){this.a=g,this.b=C}listen(g,C){const S=this.b(g);switch(C){case"onDidChangeProfiles":return I.Event.map(this.a.onDidChangeProfiles,w=>({all:w.all.map(h=>(0,j.$jn)({...h},S)),added:w.added.map(h=>(0,j.$jn)({...h},S)),removed:w.removed.map(h=>(0,j.$jn)({...h},S)),updated:w.updated.map(h=>(0,j.$jn)({...h},S))}))}throw new Error(`Invalid listen ${C}`)}async call(g,C,S){const w=this.b(g);switch(C){case"createProfile":{const h=await this.a.createProfile(S[0],S[1],S[2]);return(0,j.$jn)({...h},w)}case"updateProfile":{let h=(0,A.$hl)((0,j.$kn)(S[0],w),this.a.profilesHome.scheme);return h=await this.a.updateProfile(h,S[1]),(0,j.$jn)({...h},w)}case"removeProfile":{const h=(0,A.$hl)((0,j.$kn)(S[0],w),this.a.profilesHome.scheme);return this.a.removeProfile(h)}}throw new Error(`Invalid call ${C}`)}}e.$VP=O;class R extends L.$Tc{get defaultProfile(){return this.profiles[0]}get profiles(){return this.a}constructor(g,C,S){super(),this.profilesHome=C,this.f=S,this.a=[],this.b=this.B(new I.$6d),this.onDidChangeProfiles=this.b.event,this.c=!0,this.a=g.map(w=>(0,A.$hl)(w,this.profilesHome.scheme)),this.B(this.f.listen("onDidChangeProfiles")(w=>{const h=w.added.map(y=>(0,A.$hl)(y,this.profilesHome.scheme)),f=w.removed.map(y=>(0,A.$hl)(y,this.profilesHome.scheme)),m=w.updated.map(y=>(0,A.$hl)(y,this.profilesHome.scheme));this.a=w.all.map(y=>(0,A.$hl)(y,this.profilesHome.scheme)),this.b.fire({added:h,removed:f,updated:m,all:this.profiles})})),this.onDidResetWorkspaces=this.f.listen("onDidResetWorkspaces")}setEnablement(g){this.c=g}isEnabled(){return this.c}async createNamedProfile(g,C,S){const w=await this.f.call("createNamedProfile",[g,C,S]);return(0,A.$hl)(w,this.profilesHome.scheme)}async createProfile(g,C,S,w){const h=await this.f.call("createProfile",[g,C,S,w]);return(0,A.$hl)(h,this.profilesHome.scheme)}async createTransientProfile(g){const C=await this.f.call("createTransientProfile",[g]);return(0,A.$hl)(C,this.profilesHome.scheme)}async setProfileForWorkspace(g,C){await this.f.call("setProfileForWorkspace",[g,C])}removeProfile(g){return this.f.call("removeProfile",[g])}async updateProfile(g,C){const S=await this.f.call("updateProfile",[g,C]);return(0,A.$hl)(S,this.profilesHome.scheme)}resetWorkspaces(){return this.f.call("resetWorkspaces")}cleanUp(){return this.f.call("cleanUp")}cleanUpTransientProfiles(){return this.f.call("cleanUpTransientProfiles")}}e.$WP=R}),define(le[60],he([0,1,2,69,4,19,3,77,18]),function(se,e,I,L,A,j,O,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WHb=e.$VHb=e.$UHb=void 0,e.$UHb=(0,A.$gi)("IUserDataProfileStorageService");let g=class extends I.$Tc{constructor(h){super(),this.a=h}async readStorageData(h){return this.withProfileScopedStorageService(h,async f=>this.b(f))}async updateStorageData(h,f,m){return this.withProfileScopedStorageService(h,async y=>this.c(y,f,m))}async withProfileScopedStorageService(h,f){if(this.a.hasScope(h))return f(this.a);const m=await this.g(h),y=new S(m);try{await y.initialize();const l=await f(y);return await y.flush(),l}finally{y.dispose(),await this.f(m)}}b(h){const f=new Map,m=y=>{for(const l of h.keys(0,y))f.set(l,{value:h.get(l,0),target:y})};return m(0),m(1),f}c(h,f,m){h.storeAll(Array.from(f.entries()).map(([y,l])=>({key:y,value:l,scope:0,target:m})),!0)}async f(h){try{await h.close()}finally{(0,I.$Nc)(h)&&h.dispose()}}};e.$VHb=g,e.$VHb=g=ye([K(0,j.$Jp)],g);class C extends g{constructor(h,f,m,y){super(m),this.j=h;const l=h.getChannel("profileStorageListener"),d=this.B(new I.$Uc);this.h=this.B(new O.$6d({onWillAddFirstListener:()=>{d.value=l.listen("onDidChange")($=>{y.trace("profile storage changes",$),this.h.fire({targetChanges:$.targetChanges.map(c=>(0,k.$hl)(c,f.profilesHome.scheme)),valueChanges:$.valueChanges.map(c=>({...c,profile:(0,k.$hl)(c.profile,f.profilesHome.scheme)}))})})},onDidRemoveLastListener:()=>d.value=void 0})),this.onDidChange=this.h.event}async g(h){const f=this.j.getChannel("storage");return(0,j.$Mp)(h)?new R.$QHb(f):new R.$RHb(f,h)}}e.$WHb=C;class S extends j.$Lp{constructor(h){super({flushInterval:100}),this.s=this.B(new L.$Fp(h))}O(){return this.s.init()}P(h){return h===0?this.s:void 0}Q(){}async R(){}async S(){}hasScope(){return!1}}}),define(le[256],he([0,1,19,8,18,56,60]),function(se,e,I,L,A,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dbc=void 0;let R=class extends O.$WHb{constructor(g,C,S,w){super(g,C,S,w)}};e.$Dbc=R,e.$Dbc=R=ye([K(0,j.$3ac),K(1,A.$gl),K(2,I.$Jp),K(3,L.$Aj)],R)}),define(le[39],he([0,1,17,6,14,26,3,34,2,27,12,172,21,16,11,8,43,19,22,28,25,18]),function(se,e,I,L,A,j,O,R,k,g,C,S,w,h,f,m,y,l,d,$,c,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VIb=e.$UIb=e.$TIb=e.$SIb=e.$RIb=e.$QIb=e.$PIb=void 0;function i(E){return!!(E&&E.ref!==void 0&&typeof E.ref=="string"&&E.ref!==""&&E.syncData!==void 0&&(E.syncData===null||o(E.syncData)))}e.$PIb=i;function o(E){return!!(E&&E.version!==void 0&&typeof E.version=="number"&&E.content!==void 0&&typeof E.content=="string"&&(Object.keys(E).length===2||Object.keys(E).length===3&&E.machineId!==void 0&&typeof E.machineId=="string"))}e.$QIb=o;function n(E,b){return`${(0,g.$Lf)(E)}${b.isDefault?"":` (${b.name})`}`}e.$RIb=n;let s=class extends k.$Tc{get status(){return this.m}get conflicts(){return{...this.syncResource,conflicts:this.s}}constructor(b,u,p,P,N,F,M,z,Z,X,x,W){super(),this.syncResource=b,this.collection=u,this.G=p,this.H=P,this.I=N,this.J=F,this.L=M,this.M=z,this.N=Z,this.O=X,this.P=x,this.c=null,this.m="idle",this.n=this.B(new O.$6d),this.onDidChangeStatus=this.n.event,this.s=[],this.t=this.B(new O.$6d),this.onDidChangeConflicts=this.t.event,this.u=this.B(new L.$eh(50)),this.w=this.B(new O.$6d),this.onDidChangeLocal=this.w.event,this.z=`${this.collection?`${this.collection}.`:""}${this.syncResource.syncResource}.lastSyncUserData`,this.C=!1,this.F={},this.resource=this.syncResource.syncResource,this.D=n(b.syncResource,b.profile),this.h=W.extUri,this.f=this.h.joinPath(P.userDataSyncHome,...(0,c.$cpb)(b.profile.isDefault?void 0:b.profile.id,b.syncResource)),this.g=this.h.joinPath(this.f,c.$xpb),this.y=(0,c.$dpb)(b.profile.isDefault?void 0:b.profile.id,b.syncResource,P,this.h),this.j=(0,y.$Pp)(P,p,N)}Q(){this.u.trigger(()=>this.R())}async R(){if(this.status==="hasConflicts"){this.O.info(`${this.D}: In conflicts state and local change detected. Syncing again...`);const b=await this.c;this.c=null;const u=await this.Y(b.remoteUserData,b.lastSyncUserData,!0,this.ob());this.S(u)}else{this.O.trace(`${this.D}: Checking for local changes...`);const b=await this.getLastSyncUserData();(b?await this.ub(b):!0)&&this.w.fire()}}S(b){this.m!==b&&(this.m=b,this.n.fire(b))}async sync(b,u={}){await this.U(b,!0,this.ob(),u)}async preview(b,u,p={}){return this.U(b,!1,u,p)}async apply(b,u={}){try{this.F={...u};const p=await this.ab(b);return this.S(p),this.c}finally{this.F={}}}async U(b,u,p,P){try{if(this.F={...P},this.status==="hasConflicts")return this.O.info(`${this.D}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.c;if(this.status==="syncing")return this.O.info(`${this.D}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.c;this.O.trace(`${this.D}: Started synchronizing ${this.resource.toLowerCase()}...`),this.S("syncing");let N="idle";try{const F=await this.getLastSyncUserData(),M=await this.X(b,F);return N=await this.Y(M,F,u,p),N==="hasConflicts"?this.O.info(`${this.D}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):N==="idle"&&this.O.trace(`${this.D}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.c||null}finally{this.S(N)}}finally{this.F={}}}async replace(b){const u=this.kb(b);if(!u)return!1;await this.stop();try{this.O.trace(`${this.D}: Started resetting ${this.resource.toLowerCase()}...`),this.S("syncing");const p=await this.getLastSyncUserData(),P=await this.X(null,p),N=await this.W(P),F=await this.qb({ref:P.ref,syncData:u},p,N,this.ob(),j.CancellationToken.None),M=[];for(const z of F){const Z=await this.sb(z,z.remoteResource,void 0,j.CancellationToken.None),{remoteChange:X}=await this.sb(z,z.previewResource,z.remoteContent,j.CancellationToken.None);M.push([z,{...Z,remoteChange:X!==0?X:2}])}await this.tb(P,p,M,!1),this.O.info(`${this.D}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.S("idle")}return!0}async W(b){const u=await this.j;return!!b.syncData?.machineId&&b.syncData.machineId===u}async X(b,u){if(u){const p=b?b[this.resource]:void 0;if(u.ref===p||p===void 0&&u.syncData===null)return u}return this.getRemoteUserData(u)}async Y(b,u,p,P){if(b.syncData&&b.syncData.version>this.pb)throw this.N.publicLog2("sync/incompatible",{source:this.resource}),new c.$kpb((0,S.localize)(0,null,this.resource,this.pb,b.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.Z(b,u,p,P)}catch(N){if(N instanceof c.$kpb)switch(N.code){case"LocalPreconditionFailed":return this.O.info(`${this.D}: Failed to synchronize ${this.D} as there is a new local version available. Synchronizing again...`),this.Y(b,u,p,P);case"Conflict":case"PreconditionFailed":return this.O.info(`${this.D}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),b=await this.getRemoteUserData(null),u=await this.getLastSyncUserData(),this.Y(b,u,p,P)}throw N}}async Z(b,u,p,P){try{const N=await this.W(b),F=!N&&u===null&&this.gb()!==void 0,M=p&&!F;this.c||(this.c=(0,L.$6g)(Z=>this.eb(b,u,N,M,P,Z)));let z=await this.c;if(p&&F){this.O.info(`${this.D}: Accepting remote because it was synced before and the last sync data is not available.`);for(const Z of z.resourcePreviews)z=await this.accept(Z.remoteResource)||z}return this.cb(z.resourcePreviews),z.resourcePreviews.some(({mergeState:Z})=>Z==="conflict")?"hasConflicts":p?await this.ab(!1):"syncing"}catch(N){throw this.c=null,N}}async merge(b){return await this.$(b,async u=>{const p=await this.rb(u,j.CancellationToken.None);await this.G.writeFile(u.previewResource,A.$te.fromString(p?.content||""));const P=p&&!p.hasConflicts?await this.sb(u,u.previewResource,void 0,j.CancellationToken.None):void 0;return u.acceptResult=P,u.mergeState=p.hasConflicts?"conflict":P?"accepted":"preview",u.localChange=P?P.localChange:p.localChange,u.remoteChange=P?P.remoteChange:p.remoteChange,u}),this.c}async accept(b,u){return await this.$(b,async p=>{const P=await this.sb(p,b,u,j.CancellationToken.None);return p.acceptResult=P,p.mergeState="accepted",p.localChange=P.localChange,p.remoteChange=P.remoteChange,p}),this.c}async discard(b){return await this.$(b,async u=>{const p=await this.rb(u,j.CancellationToken.None);return await this.G.writeFile(u.previewResource,A.$te.fromString(p.content||"")),u.acceptResult=void 0,u.mergeState="preview",u.localChange=p.localChange,u.remoteChange=p.remoteChange,u}),this.c}async $(b,u){if(!this.c)return;let p=await this.c;const P=p.resourcePreviews.findIndex(({localResource:N,remoteResource:F,previewResource:M})=>this.h.isEqual(N,b)||this.h.isEqual(F,b)||this.h.isEqual(M,b));P!==-1&&(this.c=(0,L.$6g)(async N=>{const F=[...p.resourcePreviews];return F[P]=await u(F[P]),{...p,resourcePreviews:F}}),p=await this.c,this.cb(p.resourcePreviews),p.resourcePreviews.some(({mergeState:N})=>N==="conflict")?this.S("hasConflicts"):this.S("syncing"))}async ab(b){if(!this.c)return"idle";const u=await this.c;return u.resourcePreviews.some(({mergeState:p})=>p==="conflict")?"hasConflicts":u.resourcePreviews.some(({mergeState:p})=>p!=="accepted")?"syncing":(await this.tb(u.remoteUserData,u.lastSyncUserData,u.resourcePreviews.map(p=>[p,p.acceptResult]),b),this.c=null,await this.bb(),"idle")}async bb(){try{await this.G.del(this.g,{recursive:!0})}catch{}}cb(b){const u=b.filter(({mergeState:p})=>p==="conflict");(0,I.$ub)(this.s,u,(p,P)=>this.h.isEqual(p.previewResource,P.previewResource))||(this.s=u,this.t.fire(this.conflicts))}async hasPreviouslySynced(){const b=await this.getLastSyncUserData();return!!b&&b.syncData!==null}async db(b){const u=this.c?await this.c:null;if(u)for(const p of u.resourcePreviews){if(this.h.isEqual(p.acceptedResource,b))return p.acceptResult?p.acceptResult.content:null;if(this.h.isEqual(p.remoteResource,b))return p.remoteContent;if(this.h.isEqual(p.localResource,b))return p.localContent;if(this.h.isEqual(p.baseResource,b))return p.baseContent}return null}async resetLocal(){this.I.remove(this.z,-1);try{await this.G.del(this.y)}catch(b){(0,f.$Xk)(b)!==1&&this.O.error(b)}}async eb(b,u,p,P,N,F){const M=await this.qb(b,u,p,N,F),z=[];for(const Z of M){const X=Z.previewResource.with({scheme:c.$wpb,authority:"accepted"});if(Z.localChange===0&&Z.remoteChange===0)z.push({...Z,acceptedResource:X,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const x=P?await this.rb(Z,F):void 0;if(F.isCancellationRequested)break;await this.G.writeFile(Z.previewResource,A.$te.fromString(x?.content||""));const W=x&&!x.hasConflicts?await this.sb(Z,Z.previewResource,void 0,F):void 0;z.push({...Z,acceptResult:W,mergeState:x?.hasConflicts?"conflict":W?"accepted":"preview",localChange:W?W.localChange:x?x.localChange:Z.localChange,remoteChange:W?W.remoteChange:x?x.remoteChange:Z.remoteChange})}}return{syncResource:this.resource,profile:this.syncResource.profile,remoteUserData:b,lastSyncUserData:u,resourcePreviews:z,isLastSyncFromCurrentMachine:p}}async getLastSyncUserData(){let b=this.gb();if(b||(b=await this.jb()),!b)return this.O.info(`${this.D}: Last sync data state does not exist.`),null;const u=JSON.parse(b),p=this.M.getResourceSyncStateVersion(this.resource);if(this.C=!!u.version&&!!p&&u.version!==p,this.C)return this.O.info(`${this.D}: Reset last sync state because last sync state version ${u.version} is not compatible with current sync state version ${p}.`),await this.resetLocal(),null;let P,N=1;for(;P===void 0&&N++<6;)try{const F=await this.hb();F&&(F.ref===u.ref?P=F.syncData:this.O.info(`${this.D}: Last sync data stored locally is not same as the last sync state.`));break}catch(F){if(F instanceof f.$2k&&F.fileOperationResult===1){this.O.info(`${this.D}: Last sync resource does not exist locally.`);break}else{if(F instanceof c.$kpb)throw F;this.O.error(F,N)}}if(P===void 0)try{const F=await this.J.resolveResourceContent(this.resource,u.ref,this.collection,this.F);P=F===null?null:this.kb(F),await this.ib({ref:u.ref,syncData:P})}catch(F){if(F instanceof c.$kpb&&F.code==="NotFound")this.O.info(`${this.D}: Last sync resource does not exist remotely.`);else throw F}return P===void 0?null:{...u,syncData:P}}async fb(b,u={}){if(u.ref||u.version)throw new Error("Cannot have core properties as additional");const p=this.M.getResourceSyncStateVersion(this.resource),P={ref:b.ref,version:p,...u};this.I.store(this.z,JSON.stringify(P),-1,1),await this.ib(b)}gb(){return this.I.get(this.z,-1)}async hb(){const b=(await this.G.readFile(this.y)).value.toString();try{const u=b?JSON.parse(b):void 0;if(i(u))return u}catch(u){this.O.error(u)}}async ib(b){await this.G.writeFile(this.y,A.$te.fromString(JSON.stringify(b)))}async jb(){try{const b=await this.G.readFile(this.y),u=JSON.parse(b.value.toString());await this.G.del(this.y),u.ref&&u.content!==void 0?(this.I.store(this.z,JSON.stringify({...u,content:void 0}),-1,1),await this.ib({ref:u.ref,syncData:u.content===null?null:JSON.parse(u.content)})):this.O.info(`${this.D}: Migrating last sync user data. Invalid data.`,u)}catch(b){b instanceof f.$2k&&b.fileOperationResult===1?this.O.info(`${this.D}: Migrating last sync user data. Resource does not exist.`):this.O.error(b)}return this.I.get(this.z,-1)}async getRemoteUserData(b){const{ref:u,content:p}=await this.lb(b);let P=null;return p!==null&&(P=this.kb(p)),{ref:u,syncData:P}}kb(b){try{const u=JSON.parse(b);if(o(u))return u}catch(u){this.O.error(u)}throw new c.$kpb((0,S.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async lb(b){const u=b?{ref:b.ref,content:b.syncData?JSON.stringify(b.syncData):null}:null;return this.J.readResource(this.resource,u,this.collection,this.F)}async mb(b,u){const p=await this.j,P={version:this.pb,machineId:p,content:b};try{return u=await this.J.writeResource(this.resource,JSON.stringify(P),u,this.collection,this.F),{ref:u,syncData:P}}catch(N){throw N instanceof c.$kpb&&N.code==="TooLarge"&&(N=new c.$kpb(N.message,N.code,this.resource)),N}}async nb(b){const u={version:this.pb,content:b};return this.L.writeResource(this.resource,JSON.stringify(u),new Date,this.syncResource.profile.isDefault?void 0:this.syncResource.profile.id)}async stop(){this.status!=="idle"&&(this.O.trace(`${this.D}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.c&&(this.c.cancel(),this.c=null),this.cb([]),await this.bb(),this.S("idle"),this.O.info(`${this.D}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}ob(){return this.P.getValue(c.$0ob)}};e.$SIb=s,e.$SIb=s=ye([K(2,f.$Gk),K(3,h.$ni),K(4,l.$Jp),K(5,c.$fpb),K(6,c.$gpb),K(7,c.$ppb),K(8,d.$Fl),K(9,c.$upb),K(10,w.$Mi),K(11,$.$el)],s);let t=class extends s{constructor(b,u,p,P,N,F,M,z,Z,X,x,W,Q){super(u,p,P,N,F,M,z,Z,X,x,W,Q),this.r=b,this.B(this.G.watch(this.h.dirname(b))),this.B(this.G.onDidFilesChange(H=>this.yb(H)))}async vb(){try{return await this.G.readFile(this.r)}catch{return null}}async wb(b,u,p){try{u?await this.G.writeFile(this.r,A.$te.fromString(b),p?void 0:u):await this.G.createFile(this.r,A.$te.fromString(b),{overwrite:p})}catch(P){throw P instanceof f.$2k&&P.fileOperationResult===1||P instanceof f.$2k&&P.fileOperationResult===3?new c.$kpb(P.message,"LocalPreconditionFailed"):P}}async xb(){try{await this.G.del(this.r)}catch(b){if(!(b instanceof f.$2k&&b.fileOperationResult===1))throw b}}yb(b){b.contains(this.r)&&this.Q()}};e.$TIb=t,e.$TIb=t=ye([K(3,f.$Gk),K(4,h.$ni),K(5,l.$Jp),K(6,c.$fpb),K(7,c.$gpb),K(8,c.$ppb),K(9,d.$Fl),K(10,c.$upb),K(11,w.$Mi),K(12,$.$el)],t);let r=class extends t{constructor(b,u,p,P,N,F,M,z,Z,X,x,W,Q,H){super(b,u,p,P,N,F,M,z,Z,X,x,Q,H),this.zb=W,this.Bb=void 0}Ab(b,u){const p=[],P=(0,R.$sn)(b,p,{allowEmptyContent:!0,allowTrailingComma:!0});return p.length>0||!(0,C.$1f)(P)&&u!==Array.isArray(P)}Cb(){return this.Bb||(this.Bb=this.zb.resolveFormattingOptions(this.r)),this.Bb}};e.$UIb=r,e.$UIb=r=ye([K(3,f.$Gk),K(4,h.$ni),K(5,l.$Jp),K(6,c.$fpb),K(7,c.$gpb),K(8,c.$ppb),K(9,d.$Fl),K(10,c.$upb),K(11,c.$tpb),K(12,w.$Mi),K(13,$.$el)],r);let a=class{constructor(b,u,p,P,N,F,M){this.resource=b,this.g=u,this.h=p,this.j=P,this.k=N,this.l=F,this.d=M.extUri,this.f=(0,c.$dpb)(void 0,this.resource,p,this.d)}async initialize({ref:b,content:u}){if(!u){this.j.info("Remote content does not exist.",this.resource);return}const p=this.m(u);if(p)try{await this.o({ref:b,syncData:p})}catch(P){this.j.error(P)}}m(b){try{const u=JSON.parse(b);if(o(u))return u}catch(u){this.j.error(u)}this.j.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async n(b,u={}){if(u.ref||u.version)throw new Error("Cannot have core properties as additional");const p={ref:b.ref,version:void 0,...u};this.l.store(`${this.resource}.lastSyncUserData`,JSON.stringify(p),-1,1),await this.k.writeFile(this.f,A.$te.fromString(JSON.stringify(b)))}};e.$VIb=a,e.$VIb=a=ye([K(1,v.$gl),K(2,h.$ni),K(3,m.$Aj),K(4,f.$Gk),K(5,l.$Jp),K(6,$.$el)],a)}),define(le[115],he([0,1,6,26,7,3,42,2,27,21,16,114,29,33,82,45,11,4,74,8,19,22,28,18,39,237,111,25,60]),function(se,e,I,L,A,j,O,R,k,g,C,S,w,h,f,m,y,l,d,$,c,v,i,o,n,s,t,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$k9b=e.$j9b=e.$i9b=e.$h9b=e.$g9b=void 0;async function E(F,M){const z=JSON.parse(F.content);if(F.version===1||F.version===2){const Z=(await M.getInstalled(0)).filter(X=>X.isBuiltin);for(const X of z)F.version===1&&(X.enabled===!1&&(X.disabled=!0),delete X.enabled),F.version===2&&Z.every(x=>!(0,h.$dp)(x.identifier,X.identifier))&&(X.installed=!0)}return z}function b(F){return JSON.parse(F.content)}e.$g9b=b;function u(F,M){return F.sort((z,Z)=>!z.identifier.uuid&&Z.identifier.uuid?-1:z.identifier.uuid&&!Z.identifier.uuid?1:(0,k.$df)(z.identifier.id,Z.identifier.id)),M?(0,O.$Dn)(F,{}):JSON.stringify(F)}e.$h9b=u;let p=class extends n.$SIb{constructor(M,z,Z,X,x,W,Q,H,V,te,re,ee,ae,G,U,D,T){super({syncResource:"extensions",profile:M},z,X,Z,x,W,Q,ee,ae,te,re,U),this.Cb=H,this.Db=V,this.Eb=T,this.pb=6,this.wb=this.h.joinPath(this.g,"extensions.json"),this.xb=this.wb.with({scheme:r.$wpb,authority:"base"}),this.yb=this.wb.with({scheme:r.$wpb,authority:"local"}),this.zb=this.wb.with({scheme:r.$wpb,authority:"remote"}),this.Ab=this.wb.with({scheme:r.$wpb,authority:"accepted"}),this.Bb=this.Eb.createInstance(P),this.B(j.Event.any(j.Event.filter(this.Cb.onDidInstallExtensions,B=>B.some(({local:q})=>!!q)),j.Event.filter(this.Cb.onDidUninstallExtension,B=>!B.error),j.Event.filter(D.onDidChange,B=>B.valueChanges.some(({profile:q,changes:Y})=>this.syncResource.profile.id===q.id&&Y.some(_=>_.key===w.$So))),G.onDidChangeExtensionStorageToSync)(()=>this.Q()))}async qb(M,z){const Z=M.syncData?await E(M.syncData,this.Cb):null,X=z?.skippedExtensions??[],x=z?.builtinExtensions??null,W=z?.syncData?await E(z.syncData,this.Cb):null,{localExtensions:Q,ignoredExtensions:H}=await this.Bb.getLocalExtensions(this.syncResource.profile);Z?this.O.trace(`${this.D}: Merging remote extensions with local extensions...`):this.O.trace(`${this.D}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:V,remote:te}=(0,s.$f9b)(Q,Z,W,X,H,x),re={local:V,remote:te,content:this.Hb(Q,V.added,V.updated,V.removed),localChange:V.added.length>0||V.removed.length>0||V.updated.length>0?2:0,remoteChange:te!==null?2:0},ee=this.Ob(Q,!1);return[{skippedExtensions:X,builtinExtensions:x,baseResource:this.xb,baseContent:W?this.Ob(W,!1):ee,localResource:this.yb,localContent:ee,localExtensions:Q,remoteResource:this.zb,remoteExtensions:Z,remoteContent:Z?this.Ob(Z,!1):null,previewResource:this.wb,previewResult:re,localChange:re.localChange,remoteChange:re.remoteChange,acceptedResource:this.Ab}]}async ub(M){const z=M.syncData?await E(M.syncData,this.Cb):null,{localExtensions:Z,ignoredExtensions:X}=await this.Bb.getLocalExtensions(this.syncResource.profile),{remote:x}=(0,s.$f9b)(Z,z,z,M.skippedExtensions||[],X,M.builtinExtensions||[]);return x!==null}Hb(M,z,Z,X){const x=[...z,...Z],W=new Set,Q=H=>{W.add(H.id.toLowerCase()),H.uuid&&W.add(H.uuid)};x.forEach(({identifier:H})=>Q(H)),X.forEach(Q);for(const H of M)W.has(H.identifier.id.toLowerCase())||H.identifier.uuid&&W.has(H.identifier.uuid)||x.push(H);return this.Ob(x,!1)}async rb(M,z){return{...M.previewResult,hasConflicts:!1}}async sb(M,z,Z,X){if(this.h.isEqual(z,this.yb))return this.Kb(M);if(this.h.isEqual(z,this.zb))return this.Lb(M);if(this.h.isEqual(z,this.wb))return M.previewResult;throw new Error(`Invalid Resource: ${z.toString()}`)}async Kb(M){const z=await this.Cb.getInstalled(void 0,this.syncResource.profile.extensionsResource),Z=this.Db.getIgnoredExtensions(z),X=(0,s.$f9b)(M.localExtensions,null,null,M.skippedExtensions,Z,M.builtinExtensions),{local:x,remote:W}=X;return{content:M.localContent,local:x,remote:W,localChange:x.added.length>0||x.removed.length>0||x.updated.length>0?2:0,remoteChange:W!==null?2:0}}async Lb(M){const z=await this.Cb.getInstalled(void 0,this.syncResource.profile.extensionsResource),Z=this.Db.getIgnoredExtensions(z),X=M.remoteContent?JSON.parse(M.remoteContent):null;if(X!==null){const x=(0,s.$f9b)(M.localExtensions,X,M.localExtensions,[],Z,M.builtinExtensions),{local:W,remote:Q}=x;return{content:M.remoteContent,local:W,remote:Q,localChange:W.added.length>0||W.removed.length>0||W.updated.length>0?2:0,remoteChange:Q!==null?2:0}}else return{content:M.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async tb(M,z,Z,X){let{skippedExtensions:x,builtinExtensions:W,localExtensions:Q}=Z[0][0];const{local:H,remote:V,localChange:te,remoteChange:re}=Z[0][1];if(te===0&&re===0&&this.O.info(`${this.D}: No changes found during synchronizing extensions.`),te!==0&&(await this.nb(JSON.stringify(Q)),x=await this.Bb.updateLocalExtensions(H.added,H.removed,H.updated,x,this.syncResource.profile)),V){this.O.trace(`${this.D}: Updating remote extensions...`);const ee=JSON.stringify(V.all);M=await this.mb(ee,X?null:M.ref),this.O.info(`${this.D}: Updated remote extensions.${V.added.length?` Added: ${JSON.stringify(V.added.map(ae=>ae.identifier.id))}.`:""}${V.updated.length?` Updated: ${JSON.stringify(V.updated.map(ae=>ae.identifier.id))}.`:""}${V.removed.length?` Removed: ${JSON.stringify(V.removed.map(ae=>ae.identifier.id))}.`:""}`)}z?.ref!==M.ref&&(this.O.trace(`${this.D}: Updating last synchronized extensions...`),W=this.Nb(Q,W),await this.fb(M,{skippedExtensions:x,builtinExtensions:W}),this.O.info(`${this.D}: Updated last synchronized extensions.${x.length?` Skipped: ${JSON.stringify(x.map(ee=>ee.identifier.id))}.`:""}`))}Nb(M,z){const Z=new Set,X=[];for(const x of M)Z.add(x.identifier.id.toLowerCase()),x.installed||X.push(x.identifier);if(z)for(const x of z)Z.has(x.id.toLowerCase())||X.push(x);return X}async resolveContent(M){if(this.h.isEqual(this.zb,M)||this.h.isEqual(this.xb,M)||this.h.isEqual(this.yb,M)||this.h.isEqual(this.Ab,M)){const z=await this.db(M);return z&&this.Ob(JSON.parse(z),!0)}return null}Ob(M,z){return u(M,z)}async hasLocalData(){try{const{localExtensions:M}=await this.Bb.getLocalExtensions(this.syncResource.profile);if(M.some(z=>z.installed||z.disabled))return!0}catch{}return!1}};e.$i9b=p,e.$i9b=p=ye([K(2,C.$ni),K(3,y.$Gk),K(4,c.$Jp),K(5,r.$fpb),K(6,r.$gpb),K(7,w.$Ro),K(8,t.$DJb),K(9,r.$upb),K(10,g.$Mi),K(11,r.$ppb),K(12,v.$Fl),K(13,f.$Cv),K(14,i.$el),K(15,a.$UHb),K(16,l.$fi)],p);let P=class{constructor(M,z,Z,X,x,W){this.a=M,this.b=z,this.c=Z,this.d=X,this.f=x,this.g=W}async getLocalExtensions(M){const z=await this.a.getInstalled(void 0,M.extensionsResource),Z=this.d.getIgnoredExtensions(z);return{localExtensions:await this.j(M,async(x,W)=>{const Q=x.getDisabledExtensions();return z.map(H=>{const{identifier:V,isBuiltin:te,manifest:re,preRelease:ee,pinned:ae,isApplicationScoped:G}=H,U={identifier:V,preRelease:ee,version:re.version,pinned:!!ae};G&&!(0,m.$Dm)(re)&&(U.isApplicationScoped=G),Q.some(D=>(0,h.$dp)(D,V))&&(U.disabled=!0),te||(U.installed=!0);try{const D=W.getKeysForSync({id:V.id,version:re.version});if(D){const T=W.getExtensionState(H,!0)||{};U.state=Object.keys(T).reduce((B,q)=>(D.includes(q)&&(B[q]=T[q]),B),{})}}catch(D){this.g.info(`${(0,n.$RIb)("extensions",M)}: Error while parsing extension state`,(0,A.$0)(D))}return U})}),ignoredExtensions:Z}}async updateLocalExtensions(M,z,Z,X,x){const W=(0,n.$RIb)("extensions",x),Q=[],H=new Map,V=[],te=[],re=await this.a.getInstalled(void 0,x.extensionsResource);if((M.length||Z.length)&&await this.j(x,async(G,U)=>{await I.Promises.settled([...M,...Z].map(async D=>{const T=re.find(Y=>(0,h.$dp)(Y.identifier,D.identifier));if(T&&T.isBuiltin){D.state&&T.manifest.version===D.version&&this.h(D.state,T,T.manifest.version,U),G.getDisabledExtensions().some(_=>(0,h.$dp)(_,D.identifier))!==!!D.disabled&&(D.disabled?(this.g.trace(`${W}: Disabling extension...`,D.identifier.id),await G.disableExtension(D.identifier),this.g.info(`${W}: Disabled extension`,D.identifier.id)):(this.g.trace(`${W}: Enabling extension...`,D.identifier.id),await G.enableExtension(D.identifier),this.g.info(`${W}: Enabled extension`,D.identifier.id))),V.push(D.identifier);return}const B=D.pinned?D.version:void 0,q=(await this.c.getExtensions([{...D.identifier,version:B,preRelease:B?void 0:D.preRelease}],L.CancellationToken.None))[0];if(D.state&&(T?T.manifest.version===D.version:q)&&this.h(D.state,T||q,T?.manifest.version,U),q)try{G.getDisabledExtensions().some(_=>(0,h.$dp)(_,D.identifier))!==!!D.disabled&&(D.disabled?(this.g.trace(`${W}: Disabling extension...`,D.identifier.id,q.version),await G.disableExtension(q.identifier),this.g.info(`${W}: Disabled extension`,D.identifier.id,q.version)):(this.g.trace(`${W}: Enabling extension...`,D.identifier.id,q.version),await G.enableExtension(q.identifier),this.g.info(`${W}: Enabled extension`,D.identifier.id,q.version))),(!T||T.preRelease!==D.preRelease||T.pinned!==D.pinned||B&&T.manifest.version!==B)&&(await this.a.canInstall(q)?(Q.push({extension:q,options:{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installGivenVersion:D.pinned&&!!D.version,installPreReleaseVersion:D.preRelease,profileLocation:x.extensionsResource,isApplicationScoped:D.isApplicationScoped,context:{[w.$Fo]:!0,[w.$Go]:!0}}}),H.set(q.identifier.id.toLowerCase(),D)):(this.g.info(`${W}: Skipped synchronizing extension because it cannot be installed.`,q.displayName||q.identifier.id),te.push(D)))}catch(Y){te.push(D),this.g.error(Y),this.g.info(`${W}: Skipped synchronizing extension`,q.displayName||q.identifier.id)}else te.push(D),this.g.info(`${W}: Skipped synchronizing extension because the extension is not found.`,D.identifier.id)}))}),z.length){const G=re.filter(({identifier:U,isBuiltin:D})=>!D&&z.some(T=>(0,h.$dp)(U,T)));await I.Promises.settled(G.map(async U=>{this.g.trace(`${W}: Uninstalling local extension...`,U.identifier.id),await this.a.uninstall(U,{donotIncludePack:!0,donotCheckDependents:!0,profileLocation:x.extensionsResource}),this.g.info(`${W}: Uninstalled local extension.`,U.identifier.id),V.push(U.identifier)}))}const ee=await this.a.installGalleryExtensions(Q);for(const{identifier:G,local:U,error:D,source:T}of ee){const B=T;if(U)this.g.info(`${W}: Installed extension.`,G.id,B.version),V.push(G);else{const q=H.get(G.id.toLowerCase());q&&(te.push(q),this.g.info(`${W}: Skipped synchronizing extension`,B.displayName||B.identifier.id)),D instanceof w.$Po&&[w.ExtensionManagementErrorCode.Incompatible,w.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(D.code)?this.g.info(`${W}: Skipped synchronizing extension because the compatible extension is not found.`,B.displayName||B.identifier.id):D&&this.g.error(D)}}const ae=[];for(const G of X)V.some(U=>(0,h.$dp)(U,G.identifier))||ae.push(G);for(const G of te)ae.some(U=>(0,h.$dp)(U.identifier,G.identifier))||ae.push(G);return ae}h(M,z,Z,X){const x=X.getExtensionState(z,!0)||{},W=Z?X.getKeysForSync({id:z.identifier.id,version:Z}):void 0;W?W.forEach(Q=>{x[Q]=M[Q]}):Object.keys(M).forEach(Q=>x[Q]=M[Q]),X.setExtensionState(z,x,!0)}async j(M,z){return this.b.withProfileScopedStorageService(M,async Z=>{const X=new R.$Sc,x=this.f.createChild(new d.$ei([c.$Jp,Z])),W=X.add(x.createInstance(S.$gHb)),Q=X.add(x.createInstance(f.$Dv));try{return await z(W,Q)}finally{X.dispose()}})}};e.$j9b=P,e.$j9b=P=ye([K(0,w.$Ro),K(1,a.$UHb),K(2,w.$Oo),K(3,t.$DJb),K(4,l.$fi),K(5,r.$upb)],P);let N=class extends n.$VIb{constructor(M,z,Z,X,x,W,Q,H){super("extensions",X,x,W,Z,Q,H),this.p=M,this.q=z}async t(M){return M.syncData?await E(M.syncData,this.p):null}u(M,z){const Z=[],X=[],x=[];for(const W of M){if(this.q.hasToNeverSyncExtension(W.identifier.id))continue;const Q=z.find(H=>(0,h.$dp)(H.identifier,W.identifier));Q?(Z.push(Q),W.disabled&&x.push(W.identifier)):W.installed&&(X.push({...W.identifier,preRelease:!!W.preRelease}),W.disabled&&x.push(W.identifier))}return{installedExtensions:Z,newExtensions:X,disabledExtensions:x,remoteExtensions:M}}};e.$k9b=N,e.$k9b=N=ye([K(0,w.$Ro),K(1,t.$DJb),K(2,y.$Gk),K(3,o.$gl),K(4,C.$ni),K(5,$.$Aj),K(6,c.$Jp),K(7,i.$el)],N)}),define(le[116],he([0,1,14,7,3,34,42,5,32,21,16,11,8,43,19,22,28,39,79,241,25,18,60,4]),function(se,e,I,L,A,j,O,R,k,g,C,S,w,h,f,m,y,l,d,$,c,v,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2Ib=e.$1Ib=e.$ZIb=e.$YIb=e.$XIb=void 0;const n="globalState.argv.",s=["locale"];function t(p,P){const N=p.storage?Object.keys(p.storage).sort():[],F={};return N.forEach(M=>F[M]=p.storage[M]),p.storage=F,P?(0,O.$Dn)(p,{}):JSON.stringify(p)}e.$XIb=t;const r=1;let a=class extends l.$SIb{constructor(P,N,F,M,z,Z,X,x,W,Q,H,V,te,re){super({syncResource:"globalState",profile:P},N,M,x,V,z,Z,W,Q,X,H,te),this.Bb=F,this.pb=r,this.vb=this.h.joinPath(this.g,"globalState.json"),this.wb=this.vb.with({scheme:c.$wpb,authority:"base"}),this.xb=this.vb.with({scheme:c.$wpb,authority:"local"}),this.yb=this.vb.with({scheme:c.$wpb,authority:"remote"}),this.zb=this.vb.with({scheme:c.$wpb,authority:"accepted"}),this.Ab=re.createInstance(E),this.B(M.watch(this.h.dirname(this.H.argvResource))),this.B(A.Event.any(A.Event.filter(M.onDidFilesChange,ee=>ee.contains(this.H.argvResource)),A.Event.filter(F.onDidChange,ee=>!!(ee.targetChanges.some(ae=>this.syncResource.profile.id===ae.id)||ee.valueChanges.some(({profile:ae,changes:G})=>this.syncResource.profile.id===ae.id&&G.some(U=>U.target===0)))))(()=>this.Q()))}async qb(P,N,F){const M=P.syncData?JSON.parse(P.syncData.content):null;N=N===null&&F?P:N;const z=N&&N.syncData?JSON.parse(N.syncData.content):null,Z=await this.Ab.getLocalGlobalState(this.syncResource.profile);M?this.O.trace(`${this.D}: Merging remote ui state with local ui state...`):this.O.trace(`${this.D}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const X=await this.Jb(z),{local:x,remote:W}=(0,$.$WIb)(Z.storage,M?M.storage:null,z?z.storage:null,X,this.O),Q={content:null,local:x,remote:W,localChange:Object.keys(x.added).length>0||Object.keys(x.updated).length>0||x.removed.length>0?2:0,remoteChange:W.all!==null?2:0},H=t(Z,!1);return[{baseResource:this.wb,baseContent:z?t(z,!1):H,localResource:this.xb,localContent:H,localUserData:Z,remoteResource:this.yb,remoteContent:M?t(M,!1):null,previewResource:this.vb,previewResult:Q,localChange:Q.localChange,remoteChange:Q.remoteChange,acceptedResource:this.zb,storageKeys:X}]}async ub(P){const N=P.syncData?JSON.parse(P.syncData.content):null;if(N===null)return!0;const F=await this.Ab.getLocalGlobalState(this.syncResource.profile),M=await this.Jb(N),{remote:z}=(0,$.$WIb)(F.storage,N.storage,N.storage,M,this.O);return z.all!==null}async rb(P,N){return{...P.previewResult,hasConflicts:!1}}async sb(P,N,F,M){if(this.h.isEqual(N,this.xb))return this.Gb(P);if(this.h.isEqual(N,this.yb))return this.Hb(P);if(this.h.isEqual(N,this.vb))return P.previewResult;throw new Error(`Invalid Resource: ${N.toString()}`)}async Gb(P){return{content:P.localContent,local:{added:{},removed:[],updated:{}},remote:{added:Object.keys(P.localUserData.storage),removed:[],updated:[],all:P.localUserData.storage},localChange:0,remoteChange:2}}async Hb(P){if(P.remoteContent!==null){const N=JSON.parse(P.remoteContent),{local:F,remote:M}=(0,$.$WIb)(P.localUserData.storage,N.storage,null,P.storageKeys,this.O);return{content:P.remoteContent,local:F,remote:M,localChange:Object.keys(F.added).length>0||Object.keys(F.updated).length>0||F.removed.length>0?2:0,remoteChange:M!==null?2:0}}else return{content:P.remoteContent,local:{added:{},removed:[],updated:{}},remote:{added:[],removed:[],updated:[],all:null},localChange:0,remoteChange:0}}async tb(P,N,F,M){const{localUserData:z}=F[0][0],{local:Z,remote:X,localChange:x,remoteChange:W}=F[0][1];if(x===0&&W===0&&this.O.info(`${this.D}: No changes found during synchronizing ui state.`),x!==0&&(this.O.trace(`${this.D}: Updating local ui state...`),await this.nb(JSON.stringify(z)),await this.Ab.writeLocalGlobalState(Z,this.syncResource.profile),this.O.info(`${this.D}: Updated local ui state`)),W!==0){this.O.trace(`${this.D}: Updating remote ui state...`);const Q=JSON.stringify({storage:X.all});P=await this.mb(Q,M?null:P.ref),this.O.info(`${this.D}: Updated remote ui state.${X.added.length?` Added: ${X.added}.`:""}${X.updated.length?` Updated: ${X.updated}.`:""}${X.removed.length?` Removed: ${X.removed}.`:""}`)}N?.ref!==P.ref&&(this.O.trace(`${this.D}: Updating last synchronized ui state...`),await this.fb(P),this.O.info(`${this.D}: Updated last synchronized ui state`))}async resolveContent(P){if(this.h.isEqual(this.yb,P)||this.h.isEqual(this.wb,P)||this.h.isEqual(this.xb,P)||this.h.isEqual(this.zb,P)){const N=await this.db(P);return N&&t(JSON.parse(N),!0)}return null}async hasLocalData(){try{const{storage:P}=await this.Ab.getLocalGlobalState(this.syncResource.profile);if(Object.keys(P).length>1||P[`${n}.locale`]?.value!=="en")return!0}catch{}return!1}async Jb(P){const N=await this.Bb.readStorageData(this.syncResource.profile),F=[],M=[];for(const[X,x]of N)x.target===0?F.push(X):x.target===1&&M.push(X);const z=[...F,...M],Z=P?.storage?Object.keys(P.storage).filter(X=>!X.startsWith(n)&&!z.includes(X)&&N.get(X)!==void 0):[];if(!R.$o){const X=[...c.$bpb.map(x=>(0,c.$opb)(x)),c.$npb];Z.push(...X),M.push(...X)}return{user:F,machine:M,unregistered:Z}}};e.$YIb=a,e.$YIb=a=ye([K(2,i.$UHb),K(3,S.$Gk),K(4,c.$fpb),K(5,c.$gpb),K(6,c.$upb),K(7,C.$ni),K(8,c.$ppb),K(9,m.$Fl),K(10,g.$Mi),K(11,f.$Jp),K(12,y.$el),K(13,o.$fi)],a);let E=class{constructor(P,N,F,M){this.a=P,this.b=N,this.c=F,this.d=M}async getLocalGlobalState(P){const N={};if(P.isDefault){const M=await this.f(),z=(0,j.$sn)(M);for(const Z of s)z[Z]!==void 0&&(N[`${n}${Z}`]={version:1,value:z[Z]})}const F=await this.c.readStorageData(P);for(const[M,z]of F)z.value&&z.target===0&&(N[M]={version:1,value:z.value});return{storage:N}}async f(){try{this.d.debug("GlobalStateSync#getLocalArgvContent",this.b.argvResource);const P=await this.a.readFile(this.b.argvResource);return this.d.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.b.argvResource),P.value.toString()}catch(P){this.d.debug((0,L.$0)(P))}return"{}"}async writeLocalGlobalState({added:P,removed:N,updated:F},M){const z=(0,l.$RIb)("globalState",M),Z={},X=new Map,x=await this.c.readStorageData(M),W=(Q,H)=>{for(const V of Q){if(V.startsWith(n)){Z[V.substring(n.length)]=H?H[V].value:void 0;continue}if(H){const te=H[V];te.value!==x.get(V)?.value&&X.set(V,te.value)}else x.get(V)!==void 0&&X.set(V,void 0)}};if(W(Object.keys(P),P),W(Object.keys(F),F),W(N),Object.keys(Z).length){this.d.trace(`${z}: Updating locale...`);const Q=await this.f();let H=Q;for(const V of Object.keys(Z))H=(0,d.edit)(H,[V],Z[V],{});Q!==H&&(this.d.trace(`${z}: Updating locale...`),await this.a.writeFile(this.b.argvResource,I.$te.fromString(H)),this.d.info(`${z}: Updated locale.`)),this.d.info(`${z}: Updated locale`)}X.size&&(this.d.trace(`${z}: Updating global state...`),await this.c.updateStorageData(M,X,0),this.d.info(`${z}: Updated global state`,[...X.keys()]))}};e.$ZIb=E,e.$ZIb=E=ye([K(0,S.$Gk),K(1,C.$ni),K(2,i.$UHb),K(3,c.$upb)],E);let b=class extends l.$VIb{constructor(P,N,F,M,z,Z){super("globalState",F,M,z,N,P,Z)}async o(P){const N=P.syncData?JSON.parse(P.syncData.content):null;if(!N){this.j.info("Skipping initializing global state because remote global state does not exist.");return}const F={},M={};for(const z of Object.keys(N.storage))z.startsWith(n)?F[z.substring(n.length)]=N.storage[z].value:this.l.get(z,0)===void 0&&(M[z]=N.storage[z].value);if(Object.keys(F).length){let z="{}";try{z=(await this.k.readFile(this.h.argvResource)).value.toString()}catch{}for(const Z of Object.keys(F))z=(0,d.edit)(z,[Z],F[Z],{});await this.k.writeFile(this.h.argvResource,I.$te.fromString(z))}if(Object.keys(M).length){const z=[];for(const Z of Object.keys(M))z.push({key:Z,value:M[Z],scope:0,target:0});this.l.storeAll(z,!0)}}};e.$1Ib=b,e.$1Ib=b=ye([K(0,f.$Jp),K(1,S.$Gk),K(2,v.$gl),K(3,C.$ni),K(4,c.$upb),K(5,y.$el)],b);let u=class{constructor(P,N,F,M,z){this.a=P,this.b=N,this.c=F,this.d=M,this.f=z}getSyncStoreType(P){return this.h(P)?.storage[c.$npb]?.value}async sync(P){const N=(0,c.$jpb)((0,k.$Cg)());try{return await this.g(P,N)}catch(F){if(F instanceof c.$kpb)switch(F.code){case"PreconditionFailed":return this.f.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.g(P,N)}throw F}}async g(P,N){const F=await this.a.readResource("globalState",null,void 0,N),M=this.h(F)||{storage:{}};M.storage[c.$npb]={value:P,version:r};const z=await(0,h.$Pp)(this.c,this.d,this.b),Z={version:r,machineId:z,content:t(M,!1)};await this.a.writeResource("globalState",JSON.stringify(Z),F.ref,void 0,N)}h({content:P}){if(!P)return null;const N=JSON.parse(P);if((0,l.$QIb)(N))return N?JSON.parse(N.content):null;throw new Error("Invalid remote data")}};e.$2Ib=u,e.$2Ib=u=ye([K(1,f.$Jp),K(2,C.$ni),K(3,S.$Gk),K(4,w.$Aj)],u)}),define(le[117],he([0,1,17,14,3,34,5,12,173,21,16,11,19,22,28,18,39,238,25]),function(se,e,I,L,A,j,O,R,k,g,C,S,w,h,f,m,y,l,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$o9b=e.$n9b=e.$m9b=void 0;function $(i,o,n){try{const s=JSON.parse(i);if(!o)return(0,R.$1f)(s.all)?null:s.all;switch(O.OS){case 2:return(0,R.$1f)(s.mac)?null:s.mac;case 3:return(0,R.$1f)(s.linux)?null:s.linux;case 1:return(0,R.$1f)(s.windows)?null:s.windows}}catch(s){return n.error(s),null}}e.$m9b=$;let c=class extends y.$UIb{constructor(o,n,s,t,r,a,E,b,u,p,P,N,F){super(o.keybindingsResource,{syncResource:"keybindings",profile:o},n,b,u,p,s,t,E,N,r,P,a,F),this.pb=2,this.Eb=this.h.joinPath(this.g,"keybindings.json"),this.Fb=this.Eb.with({scheme:d.$wpb,authority:"base"}),this.Gb=this.Eb.with({scheme:d.$wpb,authority:"local"}),this.Hb=this.Eb.with({scheme:d.$wpb,authority:"remote"}),this.Ib=this.Eb.with({scheme:d.$wpb,authority:"accepted"}),this.B(A.Event.filter(a.onDidChangeConfiguration,M=>M.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.Q()))}async qb(o,n,s,t){const r=o.syncData?$(o.syncData.content,t.keybindingsPerPlatform??this.Qb(),this.O):null;n=n===null&&s?o:n;const a=n?this.Ob(n):null,E=await this.vb(),b=await this.Cb();let u=null,p=!1,P=!1,N=!1;if(r){let z=E?E.value.toString():"[]";if(z=z||"[]",this.Ab(z,!0))throw new d.$kpb((0,k.localize)(0,null),"LocalInvalidContent",this.resource);if(!a||a!==z||a!==r){this.O.trace(`${this.D}: Merging remote keybindings with local keybindings...`);const Z=await(0,l.$l9b)(z,r,a,b,this.zb);Z.hasChanges&&(u=Z.mergeContent,N=Z.hasConflicts,p=N||Z.mergeContent!==z,P=N||Z.mergeContent!==r)}}else E&&(this.O.trace(`${this.D}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),u=E.value.toString(),P=!0);const F={content:N?a:u,localChange:p?E?2:1:0,remoteChange:P?2:0,hasConflicts:N},M=E?E.value.toString():null;return[{fileContent:E,baseResource:this.Fb,baseContent:a,localResource:this.Gb,localContent:M,localChange:F.localChange,remoteResource:this.Hb,remoteContent:r,remoteChange:F.remoteChange,previewResource:this.Eb,previewResult:F,acceptedResource:this.Ib}]}async ub(o){const n=this.Ob(o);if(n===null)return!0;const s=await this.vb(),t=s?s.value.toString():"",r=await this.Cb(),a=await(0,l.$l9b)(t||"[]",n,n,r,this.zb);return a.hasConflicts||a.mergeContent!==n}async rb(o,n){return o.previewResult}async sb(o,n,s,t){if(this.h.isEqual(n,this.Gb))return{content:o.fileContent?o.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(n,this.Hb))return{content:o.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(n,this.Eb))return s===void 0?{content:o.previewResult.content,localChange:o.previewResult.localChange,remoteChange:o.previewResult.remoteChange}:{content:s,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${n.toString()}`)}async tb(o,n,s,t){const{fileContent:r}=s[0][0];let{content:a,localChange:E,remoteChange:b}=s[0][1];if(E===0&&b===0&&this.O.info(`${this.D}: No changes found during synchronizing keybindings.`),a!==null&&(a=a.trim(),a=a||"[]",this.Ab(a,!0)))throw new d.$kpb((0,k.localize)(1,null),"LocalInvalidContent",this.resource);if(E!==0&&(this.O.trace(`${this.D}: Updating local keybindings...`),r&&await this.nb(this.Pb(r.value.toString())),await this.wb(a||"[]",r,t),this.O.info(`${this.D}: Updated local keybindings`)),b!==0){this.O.trace(`${this.D}: Updating remote keybindings...`);const u=this.Pb(a||"[]",o.syncData?.content);o=await this.mb(u,t?null:o.ref),this.O.info(`${this.D}: Updated remote keybindings`)}try{await this.G.del(this.Eb)}catch{}n?.ref!==o.ref&&(this.O.trace(`${this.D}: Updating last synchronized keybindings...`),await this.fb(o,{platformSpecific:this.Qb()}),this.O.info(`${this.D}: Updated last synchronized keybindings`))}async hasLocalData(){try{const o=await this.vb();if(o){const n=(0,j.$sn)(o.value.toString());if((0,I.$Lb)(n))return!0}}catch(o){if(o.fileOperationResult!==1)return!0}return!1}async resolveContent(o){return this.h.isEqual(this.Hb,o)||this.h.isEqual(this.Fb,o)||this.h.isEqual(this.Gb,o)||this.h.isEqual(this.Ib,o)?this.db(o):null}Ob(o){return!o.syncData||o.platformSpecific!==void 0&&o.platformSpecific!==this.Qb()?null:$(o.syncData.content,this.Qb(),this.O)}Pb(o,n){let s={};try{s=JSON.parse(n||"{}")}catch(t){this.O.error(t)}switch(this.Qb()?delete s.all:s.all=o,O.OS){case 2:s.mac=o;break;case 3:s.linux=o;break;case 1:s.windows=o;break}return JSON.stringify(s)}Qb(){return!!this.P.getValue(d.$$ob)}};e.$n9b=c,e.$n9b=c=ye([K(2,d.$fpb),K(3,d.$gpb),K(4,d.$upb),K(5,g.$Mi),K(6,d.$ppb),K(7,S.$Gk),K(8,C.$ni),K(9,w.$Jp),K(10,d.$tpb),K(11,h.$Fl),K(12,f.$el)],c);let v=class extends y.$VIb{constructor(o,n,s,t,r,a){super("keybindings",n,s,t,o,r,a)}async o(o){const n=o.syncData?this.p(o.syncData.content):null;if(!n){this.j.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing keybindings because local keybindings exist.");return}await this.k.writeFile(this.g.defaultProfile.keybindingsResource,L.$te.fromString(n)),await this.n(o)}async i(){try{const o=await this.k.readFile(this.g.defaultProfile.settingsResource),n=(0,j.$sn)(o.value.toString());return!(0,I.$Lb)(n)}catch(o){return o.fileOperationResult===1}}p(o){try{return $(o,!0,this.j)}catch(n){return this.j.error(n),null}}};e.$o9b=v,e.$o9b=v=ye([K(0,S.$Gk),K(1,m.$gl),K(2,C.$ni),K(3,d.$upb),K(4,w.$Jp),K(5,f.$el)],v)}),define(le[118],he([0,1,14,3,174,21,76,16,29,11,19,22,28,18,39,242,25]),function(se,e,I,L,A,j,O,R,k,g,C,S,w,h,f,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$r9b=e.$q9b=e.$p9b=void 0;function l(v){return v&&v.settings&&typeof v.settings=="string"&&Object.keys(v).length===1}function d(v){const i=JSON.parse(v);return l(i)?i:{settings:v}}e.$p9b=d;let $=class extends f.$UIb{constructor(i,o,n,s,t,r,a,E,b,u,p,P,N,F){super(i.settingsResource,{syncResource:"settings",profile:i},o,n,s,t,r,a,p,P,E,b,u,F),this.Eb=N,this.pb=2,this.previewResource=this.h.joinPath(this.g,"settings.json"),this.baseResource=this.previewResource.with({scheme:y.$wpb,authority:"base"}),this.localResource=this.previewResource.with({scheme:y.$wpb,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:y.$wpb,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:y.$wpb,authority:"accepted"}),this.Ob=void 0}async getRemoteUserDataSyncConfiguration(i){const o=await this.getLastSyncUserData(),n=await this.X(i,o),s=this.Lb(n),t=new O.$ho(y.$0ob);return s?.settings&&t.parse(s.settings),t.configurationModel.getValue(y.$0ob)||{}}async qb(i,o,n){const s=await this.vb(),t=await this.Cb(),r=this.Lb(i);o=o===null&&n?i:o;const a=o?this.Lb(o):null,E=await this.Pb();let b=null,u=!1,p=!1,P=!1;if(r){let z=s?s.value.toString().trim():"{}";z=z||"{}",this.Qb(z),this.O.trace(`${this.D}: Merging remote settings with local settings...`);const Z=(0,m.$BHb)(z,r.settings,a?a.settings:null,E,[],t);b=Z.localContent||Z.remoteContent,u=Z.localContent!==null,p=Z.remoteContent!==null,P=Z.hasConflicts}else s&&(this.O.trace(`${this.D}: Remote settings does not exist. Synchronizing settings for the first time.`),b=s.value.toString().trim()||"{}",this.Qb(b),p=!0);const N=s?s.value.toString():null,F=a?.settings??null,M={content:P?F:b,localChange:u?2:0,remoteChange:p?2:0,hasConflicts:P};return[{fileContent:s,baseResource:this.baseResource,baseContent:F,localResource:this.localResource,localContent:N,localChange:M.localChange,remoteResource:this.remoteResource,remoteContent:r?r.settings:null,remoteChange:M.remoteChange,previewResource:this.previewResource,previewResult:M,acceptedResource:this.acceptedResource}]}async ub(i){const o=this.Lb(i);if(o===null)return!0;const n=await this.vb(),s=n?n.value.toString().trim():"",t=await this.Pb(),r=await this.Cb();return(0,m.$BHb)(s||"{}",o.settings,o.settings,t,[],r).remoteContent!==null}async rb(i,o){const n=await this.Cb(),s=await this.Pb();return{...i.previewResult,content:i.previewResult.content?(0,m.$AHb)(i.previewResult.content,"{}",s,n):null}}async sb(i,o,n,s){const t=await this.Cb(),r=await this.Pb();if(this.h.isEqual(o,this.localResource))return{content:i.fileContent?(0,m.$AHb)(i.fileContent.value.toString(),"{}",r,t):null,localChange:0,remoteChange:2};if(this.h.isEqual(o,this.remoteResource))return{content:i.remoteContent!==null?(0,m.$AHb)(i.remoteContent,i.fileContent?i.fileContent.value.toString():"{}",r,t):null,localChange:2,remoteChange:0};if(this.h.isEqual(o,this.previewResource))return n===void 0?{content:i.previewResult.content,localChange:i.previewResult.localChange,remoteChange:i.previewResult.remoteChange}:{content:n!==null?(0,m.$AHb)(n,i.fileContent?i.fileContent.value.toString():"{}",r,t):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${o.toString()}`)}async tb(i,o,n,s){const{fileContent:t}=n[0][0];let{content:r,localChange:a,remoteChange:E}=n[0][1];if(a===0&&E===0&&this.O.info(`${this.D}: No changes found during synchronizing settings.`),r=r?r.trim():"{}",r=r||"{}",this.Qb(r),a!==0&&(this.O.trace(`${this.D}: Updating local settings...`),t&&await this.nb(JSON.stringify(this.Nb(t.value.toString()))),await this.wb(r,t,s),await this.P.reloadConfiguration(3),this.O.info(`${this.D}: Updated local settings`)),E!==0){const b=await this.Cb(),u=this.Lb(i),p=await this.Pb(r);r=(0,m.$AHb)(r,u?u.settings:"{}",p,b),this.O.trace(`${this.D}: Updating remote settings...`),i=await this.mb(JSON.stringify(this.Nb(r)),s?null:i.ref),this.O.info(`${this.D}: Updated remote settings`)}try{await this.G.del(this.previewResource)}catch{}o?.ref!==i.ref&&(this.O.trace(`${this.D}: Updating last synchronized settings...`),await this.fb(i),this.O.info(`${this.D}: Updated last synchronized settings`))}async hasLocalData(){try{const i=await this.vb();if(i)return!(0,m.$CHb)(i.value.toString())}catch(i){if(i.fileOperationResult!==1)return!0}return!1}async resolveContent(i){return this.h.isEqual(this.remoteResource,i)||this.h.isEqual(this.localResource,i)||this.h.isEqual(this.acceptedResource,i)||this.h.isEqual(this.baseResource,i)?this.db(i):null}async db(i){let o=await super.db(i);if(o){const n=await this.Cb(),s=await this.Pb();o=(0,m.$AHb)(o,"{}",s,n)}return o}Lb(i){return i.syncData?this.Mb(i.syncData.content):null}Mb(i){try{return d(i)}catch(o){this.O.error(o)}return null}Nb(i){return{settings:i}}async Pb(i){if(!this.Ob){this.Ob=this.zb.resolveDefaultIgnoredSettings();const n=this.B(L.Event.any(L.Event.filter(this.Eb.onDidInstallExtensions,s=>s.some(({local:t})=>!!t)),L.Event.filter(this.Eb.onDidUninstallExtension,s=>!s.error))(()=>{n.dispose(),this.Ob=void 0}))}const o=await this.Ob;return(0,m.$yHb)(o,this.P,i)}Qb(i){if(this.Ab(i,!1))throw new y.$kpb((0,A.localize)(0,null),"LocalInvalidContent",this.resource)}};e.$q9b=$,e.$q9b=$=ye([K(2,g.$Gk),K(3,R.$ni),K(4,C.$Jp),K(5,y.$fpb),K(6,y.$gpb),K(7,y.$upb),K(8,y.$tpb),K(9,j.$Mi),K(10,y.$ppb),K(11,S.$Fl),K(12,k.$Ro),K(13,w.$el)],$);let c=class extends f.$VIb{constructor(i,o,n,s,t,r){super("settings",o,n,s,i,t,r)}async o(i){const o=i.syncData?this.p(i.syncData.content):null;if(!o){this.j.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing settings because local settings exist.");return}await this.k.writeFile(this.g.defaultProfile.settingsResource,I.$te.fromString(o.settings)),await this.n(i)}async i(){try{const i=await this.k.readFile(this.g.defaultProfile.settingsResource);return(0,m.$CHb)(i.value.toString().trim())}catch(i){return i.fileOperationResult===1}}p(i){try{return d(i)}catch(o){this.j.error(o)}return null}};e.$r9b=c,e.$r9b=c=ye([K(0,g.$Gk),K(1,h.$gl),K(2,R.$ni),K(3,y.$upb),K(4,C.$Jp),K(5,w.$el)],c)}),define(le[119],he([0,1,14,3,30,21,16,11,19,22,28,18,39,239,25]),function(se,e,I,L,A,j,O,R,k,g,C,S,w,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$w9b=e.$v9b=e.$u9b=void 0;function m(d){return JSON.parse(d.content)}e.$u9b=m;let y=class extends w.$SIb{constructor($,c,v,i,o,n,s,t,r,a,E,b){super({syncResource:"snippets",profile:$},c,i,v,o,n,s,a,E,t,r,b),this.pb=1,this.vb=$.snippetsHome,this.B(this.G.watch(v.userRoamingDataHome)),this.B(this.G.watch(this.vb)),this.B(L.Event.filter(this.G.onDidFilesChange,u=>u.affects(this.vb))(()=>this.Q()))}async qb($,c,v){const i=await this.Hb(),o=this.Gb(i),n=$.syncData?this.Fb($.syncData):null;c=c===null&&v?$:c;const s=c&&c.syncData?this.Fb(c.syncData):null;n?this.O.trace(`${this.D}: Merging remote snippets with local snippets...`):this.O.trace(`${this.D}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const t=(0,h.$s9b)(o,n,s);return this.Bb(t,i,n||{},s||{})}async ub($){const c=$.syncData?this.Fb($.syncData):null;if(c===null)return!0;const v=await this.Hb(),i=this.Gb(v),o=(0,h.$s9b)(i,c,c);return Object.keys(o.remote.added).length>0||Object.keys(o.remote.updated).length>0||o.remote.removed.length>0||o.conflicts.length>0}async rb($,c){return $.previewResult}async sb($,c,v,i){if(this.h.isEqualOrParent(c,this.g.with({scheme:f.$wpb,authority:"local"})))return{content:$.fileContent?$.fileContent.value.toString():null,localChange:0,remoteChange:$.fileContent?$.remoteContent!==null?2:1:3};if(this.h.isEqualOrParent(c,this.g.with({scheme:f.$wpb,authority:"remote"})))return{content:$.remoteContent,localChange:$.remoteContent!==null?$.fileContent?2:1:3,remoteChange:0};if(this.h.isEqualOrParent(c,this.g))return v===void 0?{content:$.previewResult.content,localChange:$.previewResult.localChange,remoteChange:$.previewResult.remoteChange}:{content:v,localChange:v===null?$.fileContent!==null?3:0:2,remoteChange:v===null?$.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${c.toString()}`)}async tb($,c,v,i){const o=v.map(([n,s])=>({...n,acceptResult:s}));o.every(({localChange:n,remoteChange:s})=>n===0&&s===0)&&this.O.info(`${this.D}: No changes found during synchronizing snippets.`),o.some(({localChange:n})=>n!==0)&&(await this.Cb(o),await this.Db(o,i)),o.some(({remoteChange:n})=>n!==0)&&($=await this.Eb(o,$,i)),c?.ref!==$.ref&&(this.O.trace(`${this.D}: Updating last synchronized snippets...`),await this.fb($),this.O.info(`${this.D}: Updated last synchronized snippets`));for(const{previewResource:n}of o)try{await this.G.del(n)}catch{}}Bb($,c,v,i){const o=new Map;for(const n of Object.keys($.local.added)){const s={content:$.local.added[n],hasConflicts:!1,localChange:1,remoteChange:0};o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:f.$wpb,authority:"base"}),baseContent:null,fileContent:null,localResource:this.h.joinPath(this.g,n).with({scheme:f.$wpb,authority:"local"}),localContent:null,remoteResource:this.h.joinPath(this.g,n).with({scheme:f.$wpb,authority:"remote"}),remoteContent:v[n],previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:f.$wpb,authority:"accepted"})})}for(const n of Object.keys($.local.updated)){const s={content:$.local.updated[n],hasConflicts:!1,localChange:2,remoteChange:0},t=c[n]?c[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:f.$wpb,authority:"base"}),baseContent:i[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:f.$wpb,authority:"local"}),fileContent:c[n],localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:f.$wpb,authority:"remote"}),remoteContent:v[n],previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:f.$wpb,authority:"accepted"})})}for(const n of $.local.removed){const s={content:null,hasConflicts:!1,localChange:3,remoteChange:0},t=c[n]?c[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:f.$wpb,authority:"base"}),baseContent:i[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:f.$wpb,authority:"local"}),fileContent:c[n],localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:f.$wpb,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:f.$wpb,authority:"accepted"})})}for(const n of Object.keys($.remote.added)){const s={content:$.remote.added[n],hasConflicts:!1,localChange:0,remoteChange:1},t=c[n]?c[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:f.$wpb,authority:"base"}),baseContent:i[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:f.$wpb,authority:"local"}),fileContent:c[n],localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:f.$wpb,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:f.$wpb,authority:"accepted"})})}for(const n of Object.keys($.remote.updated)){const s={content:$.remote.updated[n],hasConflicts:!1,localChange:0,remoteChange:2},t=c[n]?c[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:f.$wpb,authority:"base"}),baseContent:i[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:f.$wpb,authority:"local"}),fileContent:c[n],localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:f.$wpb,authority:"remote"}),remoteContent:v[n],previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:f.$wpb,authority:"accepted"})})}for(const n of $.remote.removed){const s={content:null,hasConflicts:!1,localChange:0,remoteChange:3};o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:f.$wpb,authority:"base"}),baseContent:i[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:f.$wpb,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.h.joinPath(this.g,n).with({scheme:f.$wpb,authority:"remote"}),remoteContent:v[n],previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:f.$wpb,authority:"accepted"})})}for(const n of $.conflicts){const s={content:i[n]??null,hasConflicts:!0,localChange:c[n]?2:1,remoteChange:v[n]?2:1},t=c[n]?c[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:f.$wpb,authority:"base"}),baseContent:i[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:f.$wpb,authority:"local"}),fileContent:c[n]||null,localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:f.$wpb,authority:"remote"}),remoteContent:v[n]||null,previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:f.$wpb,authority:"accepted"})})}for(const n of Object.keys(c))if(!o.has(n)){const s={content:c[n]?c[n].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0},t=c[n]?c[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:f.$wpb,authority:"base"}),baseContent:i[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:f.$wpb,authority:"local"}),fileContent:c[n]||null,localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:f.$wpb,authority:"remote"}),remoteContent:v[n]||null,previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:f.$wpb,authority:"accepted"})})}return[...o.values()]}async resolveContent($){return this.h.isEqualOrParent($,this.g.with({scheme:f.$wpb,authority:"remote"}))||this.h.isEqualOrParent($,this.g.with({scheme:f.$wpb,authority:"local"}))||this.h.isEqualOrParent($,this.g.with({scheme:f.$wpb,authority:"base"}))||this.h.isEqualOrParent($,this.g.with({scheme:f.$wpb,authority:"accepted"}))?this.db($):null}async hasLocalData(){try{const $=await this.Hb();if(Object.keys($).length)return!0}catch{}return!1}async Cb($){const c={};for(const v of $)v.fileContent&&(c[this.h.basename(v.localResource)]=v.fileContent);await this.nb(JSON.stringify(this.Gb(c)))}async Db($,c){for(const{fileContent:v,acceptResult:i,localResource:o,remoteResource:n,localChange:s}of $)if(s!==0){const t=n?this.h.basename(n):this.h.basename(o),r=this.h.joinPath(this.vb,t);s===3?(this.O.trace(`${this.D}: Deleting snippet...`,this.h.basename(r)),await this.G.del(r),this.O.info(`${this.D}: Deleted snippet`,this.h.basename(r))):s===1?(this.O.trace(`${this.D}: Creating snippet...`,this.h.basename(r)),await this.G.createFile(r,I.$te.fromString(i.content),{overwrite:c}),this.O.info(`${this.D}: Created snippet`,this.h.basename(r))):(this.O.trace(`${this.D}: Updating snippet...`,this.h.basename(r)),await this.G.writeFile(r,I.$te.fromString(i.content),c?void 0:v),this.O.info(`${this.D}: Updated snippet`,this.h.basename(r)))}}async Eb($,c,v){const i=c.syncData?this.Fb(c.syncData):{},o=(0,A.$Ln)(i);for(const{acceptResult:n,localResource:s,remoteResource:t,remoteChange:r}of $)if(r!==0){const a=s?this.h.basename(s):this.h.basename(t);r===3?delete o[a]:o[a]=n.content}return(0,h.$t9b)(i,o)||(this.O.trace(`${this.D}: Updating remote snippets...`),c=await this.mb(JSON.stringify(o),v?null:c.ref),this.O.info(`${this.D}: Updated remote snippets`)),c}Fb($){return m($)}Gb($){const c={};for(const v of Object.keys($))c[v]=$[v].value.toString();return c}async Hb(){const $={};let c;try{c=await this.G.resolve(this.vb)}catch(v){if(v instanceof R.$2k&&v.fileOperationResult===1)return $;throw v}for(const v of c.children||[]){const i=v.resource,o=this.h.extname(i);if(o===".json"||o===".code-snippets"){const n=this.h.relativePath(this.vb,i),s=await this.G.readFile(i);$[n]=s}}return $}};e.$v9b=y,e.$v9b=y=ye([K(2,O.$ni),K(3,R.$Gk),K(4,k.$Jp),K(5,f.$fpb),K(6,f.$gpb),K(7,f.$upb),K(8,j.$Mi),K(9,f.$ppb),K(10,g.$Fl),K(11,C.$el)],y);let l=class extends w.$VIb{constructor($,c,v,i,o,n){super("snippets",c,v,i,$,o,n)}async o($){const c=$.syncData?JSON.parse($.syncData.content):null;if(!c){this.j.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing snippets because local snippets exist.");return}for(const i of Object.keys(c)){const o=c[i];if(o){const n=this.d.joinPath(this.g.defaultProfile.snippetsHome,i);await this.k.createFile(n,I.$te.fromString(o)),this.j.info("Created snippet",this.d.basename(n))}}await this.n($)}async i(){try{return!(await this.k.resolve(this.g.defaultProfile.snippetsHome)).children?.length}catch($){return $.fileOperationResult===1}}};e.$w9b=l,e.$w9b=l=ye([K(0,R.$Gk),K(1,S.$gl),K(2,O.$ni),K(3,f.$upb),K(4,k.$Jp),K(5,C.$el)],l)}),define(le[120],he([0,1,14,21,16,11,19,22,28,18,39,25]),function(se,e,I,L,A,j,O,R,k,g,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$z9b=e.$y9b=e.$x9b=void 0;function w(y,l){try{return JSON.parse(y).tasks??null}catch(d){return l.error(d),null}}e.$x9b=w;let h=class extends C.$TIb{constructor(l,d,$,c,v,i,o,n,s,t,r,a){super(l.tasksResource,{syncResource:"tasks",profile:l},d,n,s,t,$,c,o,r,v,i,a),this.pb=1,this.Ab=this.h.joinPath(this.g,"tasks.json"),this.Bb=this.Ab.with({scheme:S.$wpb,authority:"base"}),this.Cb=this.Ab.with({scheme:S.$wpb,authority:"local"}),this.Db=this.Ab.with({scheme:S.$wpb,authority:"remote"}),this.Eb=this.Ab.with({scheme:S.$wpb,authority:"accepted"})}async qb(l,d,$,c){const v=l.syncData?w(l.syncData.content,this.O):null;d=d===null&&$?l:d;const i=d?.syncData?w(d.syncData.content,this.O):null,o=await this.vb();let n=null,s=!1,t=!1,r=!1;if(l.syncData){const b=o?o.value.toString():null;if(!i||i!==b||i!==v){this.O.trace(`${this.D}: Merging remote tasks with local tasks...`);const u=m(b,v,i);n=u.content,r=u.hasConflicts,s=u.hasLocalChanged,t=u.hasRemoteChanged}}else o&&(this.O.trace(`${this.D}: Remote tasks does not exist. Synchronizing tasks for the first time.`),n=o.value.toString(),t=!0);const a={content:r?i:n,localChange:s?o?2:1:0,remoteChange:t?2:0,hasConflicts:r},E=o?o.value.toString():null;return[{fileContent:o,baseResource:this.Bb,baseContent:i,localResource:this.Cb,localContent:E,localChange:a.localChange,remoteResource:this.Db,remoteContent:v,remoteChange:a.remoteChange,previewResource:this.Ab,previewResult:a,acceptedResource:this.Eb}]}async ub(l){const d=l?.syncData?w(l.syncData.content,this.O):null;if(d===null)return!0;const $=await this.vb(),c=$?$.value.toString():null,v=m(c,d,d);return v.hasLocalChanged||v.hasRemoteChanged}async rb(l,d){return l.previewResult}async sb(l,d,$,c){if(this.h.isEqual(d,this.Cb))return{content:l.fileContent?l.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(d,this.Db))return{content:l.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(d,this.Ab))return $===void 0?{content:l.previewResult.content,localChange:l.previewResult.localChange,remoteChange:l.previewResult.remoteChange}:{content:$,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${d.toString()}`)}async tb(l,d,$,c){const{fileContent:v}=$[0][0],{content:i,localChange:o,remoteChange:n}=$[0][1];if(o===0&&n===0&&this.O.info(`${this.D}: No changes found during synchronizing tasks.`),o!==0&&(this.O.trace(`${this.D}: Updating local tasks...`),v&&await this.nb(JSON.stringify(this.Kb(v.value.toString()))),i?await this.wb(i,v,c):await this.xb(),this.O.info(`${this.D}: Updated local tasks`)),n!==0){this.O.trace(`${this.D}: Updating remote tasks...`);const s=JSON.stringify(this.Kb(i));l=await this.mb(s,c?null:l.ref),this.O.info(`${this.D}: Updated remote tasks`)}try{await this.G.del(this.Ab)}catch{}d?.ref!==l.ref&&(this.O.trace(`${this.D}: Updating last synchronized tasks...`),await this.fb(l),this.O.info(`${this.D}: Updated last synchronized tasks`))}async hasLocalData(){return this.G.exists(this.r)}async resolveContent(l){return this.h.isEqual(this.Db,l)||this.h.isEqual(this.Bb,l)||this.h.isEqual(this.Cb,l)||this.h.isEqual(this.Eb,l)?this.db(l):null}Kb(l){return l?{tasks:l}:{}}};e.$y9b=h,e.$y9b=h=ye([K(2,S.$fpb),K(3,S.$gpb),K(4,S.$upb),K(5,L.$Mi),K(6,S.$ppb),K(7,j.$Gk),K(8,A.$ni),K(9,O.$Jp),K(10,R.$Fl),K(11,k.$el)],h);let f=class extends C.$VIb{constructor(l,d,$,c,v,i){super("tasks",d,$,c,l,v,i),this.c=this.g.defaultProfile.tasksResource}async o(l){const d=l.syncData?w(l.syncData.content,this.j):null;if(!d){this.j.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.p()){this.j.info("Skipping initializing tasks because local tasks exist.");return}await this.k.writeFile(this.c,I.$te.fromString(d)),await this.n(l)}async p(){return this.k.exists(this.c)}};e.$z9b=f,e.$z9b=f=ye([K(0,j.$Gk),K(1,g.$gl),K(2,A.$ni),K(3,S.$upb),K(4,O.$Jp),K(5,k.$el)],f);function m(y,l,d){if(y===null&&l===null&&d===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(y===l)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const $=d!==y,c=d!==l;return!$&&!c?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:$&&!c?{content:y,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:c&&!$?{content:l,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:y,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(le[121],he([0,1,42,21,16,11,19,22,28,18,39,240,25]),function(se,e,I,L,A,j,O,R,k,g,C,S,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$g$b=e.$f$b=e.$e$b=void 0;let h=class extends C.$SIb{constructor(l,d,$,c,v,i,o,n,s,t,r,a,E){super({syncResource:"profiles",profile:l},d,c,v,i,o,n,r,a,s,t,E),this.vb=$,this.pb=2,this.previewResource=this.h.joinPath(this.g,"profiles.json"),this.baseResource=this.previewResource.with({scheme:w.$wpb,authority:"base"}),this.localResource=this.previewResource.with({scheme:w.$wpb,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:w.$wpb,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:w.$wpb,authority:"accepted"}),this.B($.onDidChangeProfiles(()=>this.Q()))}async getLastSyncedProfiles(){const l=await this.getLastSyncUserData();return l?.syncData?m(l.syncData):null}async getRemoteSyncedProfiles(l){const d=await this.getLastSyncUserData(),$=await this.X(l,d);return $?.syncData?m($.syncData):null}async qb(l,d,$){if(!this.vb.isEnabled())throw new w.$kpb("Cannot sync profiles because they are disabled","LocalError");const c=l.syncData?m(l.syncData):null,v=d?.syncData?m(d.syncData):null,i=this.Db(),{local:o,remote:n}=(0,S.$d$b)(i,c,v,[]),s={local:o,remote:n,content:v?this.Eb(v):null,localChange:o.added.length>0||o.removed.length>0||o.updated.length>0?2:0,remoteChange:n!==null?2:0},t=f(i,!1);return[{baseResource:this.baseResource,baseContent:v?this.Eb(v):null,localResource:this.localResource,localContent:t,remoteResource:this.remoteResource,remoteContent:c?this.Eb(c):null,remoteProfiles:c,previewResource:this.previewResource,previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.acceptedResource}]}async ub(l){const d=l?.syncData?m(l.syncData):null,$=this.Db(),{remote:c}=(0,S.$d$b)($,d,d,[]);return!!c?.added.length||!!c?.removed.length||!!c?.updated.length}async rb(l,d){return{...l.previewResult,hasConflicts:!1}}async sb(l,d,$,c){if(this.h.isEqual(d,this.localResource))return this.Ab(l);if(this.h.isEqual(d,this.remoteResource))return this.Bb(l);if(this.h.isEqual(d,this.previewResource))return l.previewResult;throw new Error(`Invalid Resource: ${d.toString()}`)}async Ab(l){const d=this.Db(),$=(0,S.$d$b)(d,null,null,[]),{local:c,remote:v}=$;return{content:l.localContent,local:c,remote:v,localChange:c.added.length>0||c.removed.length>0||c.updated.length>0?2:0,remoteChange:v!==null?2:0}}async Bb(l){const d=l.remoteContent?JSON.parse(l.remoteContent):null,$=[],c=[];for(const v of this.Db()){const i=d?.find(o=>o.id===v.id);i&&($.push({id:v.id,name:v.name,collection:i.collection}),c.push(v))}if(d!==null){const v=(0,S.$d$b)(c,d,$,[]),{local:i,remote:o}=v;return{content:l.remoteContent,local:i,remote:o,localChange:i.added.length>0||i.removed.length>0||i.updated.length>0?2:0,remoteChange:o!==null?2:0}}else return{content:l.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async tb(l,d,$,c){const{local:v,remote:i,localChange:o,remoteChange:n}=$[0][1];o===0&&n===0&&this.O.info(`${this.D}: No changes found during synchronizing profiles.`);const s=$[0][0].remoteProfiles||[];if(s.length+(i?.added.length??0)-(i?.removed.length??0)>20)throw new w.$kpb("Too many profiles to sync. Please remove some profiles and try again.","LocalTooManyProfiles");if(o!==0){await this.nb(f(this.Db(),!1));const t=[];for(const r of v.added)t.push((async()=>{this.O.trace(`${this.D}: Creating '${r.name}' profile...`),await this.vb.createProfile(r.id,r.name,{shortName:r.shortName,icon:r.icon,useDefaultFlags:r.useDefaultFlags}),this.O.info(`${this.D}: Created profile '${r.name}'.`)})());for(const r of v.removed)t.push((async()=>{this.O.trace(`${this.D}: Removing '${r.name}' profile...`),await this.vb.removeProfile(r),this.O.info(`${this.D}: Removed profile '${r.name}'.`)})());for(const r of v.updated){const a=this.vb.profiles.find(E=>E.id===r.id);a?t.push((async()=>{this.O.trace(`${this.D}: Updating '${r.name}' profile...`),await this.vb.updateProfile(a,{name:r.name,shortName:r.shortName,icon:r.icon,useDefaultFlags:r.useDefaultFlags}),this.O.info(`${this.D}: Updated profile '${r.name}'.`)})()):this.O.info(`${this.D}: Could not find profile with id '${r.id}' to update.`)}await Promise.all(t)}if(n!==0){this.O.trace(`${this.D}: Updating remote profiles...`);const t=[],r=s.length+(i?.added.length??0)<=20;if(r)for(const a of i?.added||[]){const E=await this.J.createCollection(this.F);t.push(E),s.push({id:a.id,name:a.name,collection:E,shortName:a.shortName,icon:a.icon,useDefaultFlags:a.useDefaultFlags})}else this.O.info(`${this.D}: Could not create remote profiles as there are too many profiles.`);for(const a of i?.removed||[])s.splice(s.findIndex(({id:E})=>a.id===E),1);for(const a of i?.updated||[]){const E=s.find(({id:b})=>a.id===b);E&&s.splice(s.indexOf(E),1,{...E,id:a.id,name:a.name,shortName:a.shortName,icon:a.icon,useDefaultFlags:a.useDefaultFlags})}try{l=await this.updateRemoteProfiles(s,c?null:l.ref),this.O.info(`${this.D}: Updated remote profiles.${r&&i?.added.length?` Added: ${JSON.stringify(i.added.map(a=>a.name))}.`:""}${i?.updated.length?` Updated: ${JSON.stringify(i.updated.map(a=>a.name))}.`:""}${i?.removed.length?` Removed: ${JSON.stringify(i.removed.map(a=>a.name))}.`:""}`)}catch(a){if(t.length){this.O.info(`${this.D}: Failed to update remote profiles. Cleaning up added collections...`);for(const E of t)await this.J.deleteCollection(E,this.F)}throw a}for(const a of i?.removed||[])await this.J.deleteCollection(a.collection,this.F)}d?.ref!==l.ref&&(this.O.trace(`${this.D}: Updating last synchronized profiles...`),await this.fb(l),this.O.info(`${this.D}: Updated last synchronized profiles.`))}async updateRemoteProfiles(l,d){return this.mb(this.Eb(l),d)}async hasLocalData(){return this.Db().length>0}async resolveContent(l){if(this.h.isEqual(this.remoteResource,l)||this.h.isEqual(this.baseResource,l)||this.h.isEqual(this.localResource,l)||this.h.isEqual(this.acceptedResource,l)){const d=await this.db(l);return d&&(0,I.$Dn)(JSON.parse(d),{})}return null}Db(){return this.vb.profiles.filter(l=>!l.isDefault&&!l.isTransient)}Eb(l){return JSON.stringify([...l].sort((d,$)=>d.name.localeCompare($.name)))}};e.$e$b=h,e.$e$b=h=ye([K(2,g.$gl),K(3,j.$Gk),K(4,A.$ni),K(5,O.$Jp),K(6,w.$fpb),K(7,w.$gpb),K(8,w.$upb),K(9,L.$Mi),K(10,w.$ppb),K(11,R.$Fl),K(12,k.$el)],h);function f(y,l){const d=[...y].sort(($,c)=>$.name.localeCompare(c.name)).map($=>({id:$.id,name:$.name}));return l?(0,I.$Dn)(d,{}):JSON.stringify(d)}e.$f$b=f;function m(y){return JSON.parse(y.content)}e.$g$b=m}),define(le[257],he([0,1,3,2,5,16,19,22,25]),function(se,e,I,L,A,j,O,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$40b=void 0;const g="sync.enable";let C=class extends L.$Tc{constructor(w,h,f,m){super(),this.c=w,this.f=h,this.g=f,this.h=m,this.a=new I.$6d,this.onDidChangeEnablement=this.a.event,this.b=new I.$6d,this.onDidChangeResourceEnablement=this.b.event,this.B(w.onDidChangeValue(-1,void 0,this.B(new L.$Sc))(y=>this.m(y)))}isEnabled(){switch(this.g.sync){case"on":return!0;case"off":return!1}return this.c.getBoolean(g,-1,!1)}canToggleEnablement(){return this.h.userDataSyncStore!==void 0&&this.g.sync===void 0}setEnablement(w){w&&!this.canToggleEnablement()||(this.f.publicLog2(g,{enabled:w}),this.c.store(g,w,-1,1))}isResourceEnabled(w){return this.c.getBoolean((0,k.$opb)(w),-1,!0)}setResourceEnablement(w,h){if(this.isResourceEnabled(w)!==h){const f=(0,k.$opb)(w);this.j(f,h)}}getResourceSyncStateVersion(w){}j(w,h){this.c.store(w,h,-1,A.$o?0:1)}m(w){if(g===w.key){this.a.fire(this.isEnabled());return}const h=k.$bpb.filter(f=>(0,k.$opb)(f)===w.key)[0];if(h){this.b.fire([h,this.isResourceEnabled(h)]);return}}};e.$40b=C,e.$40b=C=ye([K(0,O.$Jp),K(1,R.$Fl),K(2,j.$ni),K(3,k.$epb)],C)}),define(le[258],he([0,1,6,14,65,2,20,21,16,11,18,25]),function(se,e,I,L,A,j,O,R,k,g,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$c$b=void 0;let w=class extends j.$Tc{constructor(f,m,y,l,d){super(),this.a=f,this.b=m,this.c=y,this.f=l,this.g=d,this.h()}async h(){for(const m of this.g.profiles)for(const y of S.$bpb)try{await this.m(this.j(y,m.isDefault?void 0:m.id))}catch(l){this.f.error(l)}let f;try{f=await this.b.resolve(this.a.userDataSyncHome)}catch(m){(0,g.$Xk)(m)!==1&&this.f.error(m);return}if(f.children){for(const m of f.children)if(m.isDirectory&&!this.g.profiles.some(y=>y.id===m.name))try{this.f.info("Deleting non existing profile from backup",m.resource.path),await this.b.del(m.resource,{recursive:!0})}catch(y){this.f.error(y)}}}async getAllResourceRefs(f,m,y){const l=this.j(f,m,y);try{const d=await this.b.resolve(l);if(d.children)return d.children.filter(c=>c.isFile&&!c.name.startsWith("lastSync")).sort().reverse().map(c=>({ref:c.name,created:this.n(c)}))}catch(d){if((0,g.$Xk)(d)!==1)throw d}return[]}async resolveResourceContent(f,m,y,l){const d=this.j(f,y,l),$=(0,O.$Tg)(d,m);try{return(await this.b.readFile($)).value.toString()}catch(c){return this.f.error(c),null}}async writeResource(f,m,y,l,d){const $=this.j(f,l,d),c=(0,O.$Tg)($,`${(0,A.$Mm)(y).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.b.writeFile(c,L.$te.fromString(m))}catch(v){this.f.error(v)}}j(f,m,y=this.a.userDataSyncHome){return(0,O.$Tg)(y,...m?[m,f]:[f])}async m(f){try{try{if(!await this.b.exists(f))return}catch{return}const m=await this.b.resolve(f);if(m.children){const y=m.children.filter(c=>c.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(c.name)).sort(),l=1e3*60*60*24*(this.c.getValue("sync.localBackupDuration")||30);let d=y.filter(c=>Date.now()-this.n(c)>l);const $=y.length-d.length;$<10&&(d=d.slice(10-$)),await I.Promises.settled(d.map(async c=>{this.f.info("Deleting from backup",c.resource.path),await this.b.del(c.resource)}))}}catch(m){this.f.error(m)}}n(f){return new Date(parseInt(f.name.substring(0,4)),parseInt(f.name.substring(4,6))-1,parseInt(f.name.substring(6,8)),parseInt(f.name.substring(9,11)),parseInt(f.name.substring(11,13)),parseInt(f.name.substring(13,15))).getTime()}};e.$c$b=w,e.$c$b=w=ye([K(0,k.$ni),K(1,g.$Gk),K(2,R.$Mi),K(3,S.$upb),K(4,C.$gl)],w)}),define(le[83],he([0,1,3,2,5,27,178,16,11,4,24,43,19,25]),function(se,e,I,L,A,j,O,R,k,g,C,S,w,h){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.$7ob=e.$6ob=e.$5ob=void 0,e.$5ob=(0,g.$gi)("IUserDataSyncMachinesService");const m="sync.currentMachineName",y="Safari",l="Chrome",d="Edge",$="Firefox",c="Android";function v(n){switch(n){case y:case l:case d:case $:case c:case(0,A.$h)(0):return!0}return!1}e.$6ob=v;function i(){return A.$G?y:A.$E?l:A.$H?d:A.$F?$:A.$I?c:(0,A.$h)(A.$o?0:A.$u)}let o=class extends L.$Tc{static{f=this}static{this.a=1}static{this.b="machines"}constructor(s,t,r,a,E,b){super(),this.h=r,this.j=a,this.m=E,this.n=b,this.c=this.B(new I.$6d),this.onDidChange=this.c.event,this.g=null,this.f=(0,S.$Pp)(s,t,r)}async getMachines(s){const t=await this.f;return(await this.s(s)).machines.map(a=>({...a,isCurrent:a.id===t}))}async addCurrentMachine(s){const t=await this.f,r=await this.s(s);r.machines.some(({id:a})=>a===t)||(r.machines.push({id:t,name:this.r(r.machines),platform:i()}),await this.t(r))}async removeCurrentMachine(s){const t=await this.f,r=await this.s(s),a=r.machines.filter(({id:E})=>E!==t);a.length!==r.machines.length&&(r.machines=a,await this.t(r))}async renameMachine(s,t,r){const a=await this.s(r),E=a.machines.find(({id:b})=>b===s);if(E){E.name=t,await this.t(a);const b=await this.f;s===b&&this.h.store(m,t,-1,1)}}async setEnablements(s){const t=await this.s();for(const[r,a]of s){const E=t.machines.find(b=>b.id===r);E&&(E.disabled=a?void 0:!0)}await this.t(t)}r(s){const t=this.h.get(m,-1);if(t)return t;const r=`${this.n.embedderIdentifier?`${this.n.embedderIdentifier} - `:""}${i()} (${this.n.nameShort})`,a=new RegExp(`${(0,j.$Ye)(r)}\\s#(\\d+)`);let E=0;for(const b of s){const u=a.exec(b.name),p=u?parseInt(u[1]):0;E=p>E?p:E}return`${r} #${E+1}`}async s(s){this.g=await this.u(s);const t=this.w(this.g);if(t.version!==f.a)throw new Error((0,O.localize)(0,null,this.n.nameLong));return t}async t(s){const t=JSON.stringify(s),r=await this.j.writeResource(f.b,t,this.g?.ref||null);this.g={ref:r,content:t},this.c.fire()}async u(s){if(this.g){const t=s&&s.latest?s.latest[f.b]:void 0;if(this.g.ref===t)return this.g;if(t===void 0&&this.g.content===null)return this.g}return this.j.readResource(f.b,this.g)}w(s){if(s.content!==null)try{return JSON.parse(s.content)}catch(t){this.m.error(t)}return{version:f.a,machines:[]}}};e.$7ob=o,e.$7ob=o=f=ye([K(0,R.$ni),K(1,k.$Gk),K(2,w.$Jp),K(3,h.$fpb),K(4,h.$upb),K(5,C.$Sj)],o)}),define(le[259],he([0,1,6,65,38,7,3,2,5,20,10,175,24,19,22,25,80,83]),function(se,e,I,L,A,j,O,R,k,g,C,S,w,h,f,m,y,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$i$b=void 0;const d="sync.disableMachineEventually",$="sync.sessionId",c="sync.storeUrl",v="sync.productQuality";let i=class extends R.$Tc{get n(){const s=this.H.get(c,-1);return s?C.URI.parse(s):void 0}set n(s){s?this.H.store(c,s.toString(),-1,1):this.H.remove(c,-1)}get s(){return this.H.get(v,-1)}set s(s){s?this.H.store(v,s,-1,1):this.H.remove(v,-1)}constructor(s,t,r,a,E,b,u,p,P,N){super(),this.u=t,this.w=r,this.y=a,this.z=E,this.C=b,this.D=u,this.F=p,this.G=P,this.H=N,this.a=this.B(new R.$Uc),this.b=0,this.c=void 0,this.g=!1,this.h=this.B(new O.$6d),this.onError=this.h.event,this.S=[],this.f=this.B(new I.$eh(this.U())),this.j=this.n,this.n=t.userDataSyncStore?.url,this.r=this.s,this.s=s.quality,this.n&&(this.C.info("Using settings sync service",this.n.toString()),this.B(t.onDidChangeUserDataSyncStore(()=>{(0,g.$Mg)(this.n,t.userDataSyncStore?.url)||(this.j=this.n,this.n=t.userDataSyncStore?.url,this.n&&this.C.info("Using settings sync service",this.n.toString()))})),this.y.isEnabled()?this.C.info("Auto Sync is enabled."):this.C.info("Auto Sync is disabled."),this.I(),this.Q()&&this.P(),this.B(u.onDidChangeAccount(()=>this.I())),this.B(r.onDidChangeDonotMakeRequestsUntil(()=>this.I())),this.B(E.onDidChangeLocal(F=>this.triggerSync([F],!1,!1))),this.B(O.Event.filter(this.y.onDidChangeResourceEnablement,([,F])=>F)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this.B(this.u.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}I(){const{enabled:s,message:t}=this.L();s?this.a.value===void 0&&(this.a.value=new o(this.j,1e3*60*5,this.u,this.w,this.z,this.G,this.C,this.F,this.H),this.a.value.register(this.a.value.onDidStartSync(()=>this.c=new Date().getTime())),this.a.value.register(this.a.value.onDidFinishSync(r=>this.O(r))),this.J()&&this.a.value.start()):(this.f.cancel(),this.a.value!==void 0?(t&&this.C.info(t),this.a.clear()):t&&this.y.isEnabled()&&this.C.info(t))}J(){return!0}L(){return this.y.isEnabled()?this.D.account?this.w.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,L.$Mm)(this.w.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.g?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.R(),this.j=this.n,this.M(!0)}async turnOff(s,t,r){try{this.D.account&&!r&&await this.G.removeCurrentMachine(),this.M(!1),this.H.remove($,-1),s?(this.F.publicLog2("sync/turnOffEveryWhere"),await this.z.reset()):await this.z.resetLocal()}catch(a){if(this.C.error(a),t)this.M(!1);else throw a}}M(s){this.y.isEnabled()!==s&&(this.y.setEnablement(s),this.I())}N(){return!!this.r&&!!this.s&&this.r!==this.s}async O(s){if(!s){this.b=0;return}const t=m.$kpb.toUserDataSyncError(s);t instanceof m.$mpb&&this.F.publicLog2("autosync/error",{code:t.code,service:this.u.userDataSyncStore.url.toString()}),t.code==="SessionExpired"?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because current session is expired")):t.code==="TurnedOff"?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):t.code==="LocalTooManyRequests"?(this.g=!0,this.C.info("Auto Sync: Suspended sync because of making too many requests to server"),this.I()):t.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.P(),this.C.info("Auto Sync: Turned off sync because of making too many requests to server")):t.code==="MethodNotFound"?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because current client is making requests to server that are not supported")):t.code==="UpgradeRequired"||t.code==="Gone"?(await this.turnOff(!1,!0,!0),this.P(),this.C.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):t.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.C.info(`Auto Sync: Turned off sync because server has ${t.resource} content with newer version than of client. Requires client upgrade.`)):t.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.C.info(`Auto Sync: Turned off sync because server has ${t.resource} content with older version than of client. Requires server reset.`)):t.code==="ServiceChanged"||t.code==="DefaultServiceChanged"?k.$o&&t.code==="DefaultServiceChanged"&&!this.N()?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.C.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.C.error(t),this.b++),this.h.fire(t)}async P(){this.H.store(d,!0,-1,1),await(0,I.$hh)(1e3*60*10),this.Q()&&(this.R(),!this.y.isEnabled()&&this.D.account&&await this.G.removeCurrentMachine())}Q(){return this.H.getBoolean(d,-1,!1)}R(){this.H.remove(d,-1)}async triggerSync(s,t,r){if(this.a.value===void 0)return this.f.cancel();if(t&&this.c&&Math.round((new Date().getTime()-this.c)/1e3)<10){this.C.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.S.push(...s),this.f.trigger(async()=>{this.C.trace("activity sources",...this.S);const a=this.D.account?.authenticationProviderId||"";this.F.publicLog2("sync/triggered",{sources:this.S,providerId:a}),this.S=[],this.a.value&&await this.a.value.sync("Activity",r)},this.b?this.U()*1*Math.min(Math.pow(2,this.b),60):this.U())}U(){return 2e3}};e.$i$b=i,e.$i$b=i=ye([K(0,w.$Sj),K(1,m.$epb),K(2,m.$fpb),K(3,m.$ppb),K(4,m.$qpb),K(5,m.$upb),K(6,y.$iHb),K(7,f.$Fl),K(8,l.$5ob),K(9,h.$Jp)],i);class o extends R.$Tc{static{this.a="Interval"}constructor(s,t,r,a,E,b,u,p,P){super(),this.m=s,this.n=t,this.r=r,this.s=a,this.u=E,this.w=b,this.y=u,this.z=p,this.C=P,this.b=this.B(new R.$Uc),this.c=this.B(new O.$6d),this.onDidStartSync=this.c.event,this.f=this.B(new O.$6d),this.onDidFinishSync=this.f.event,this.g=null}start(){this.B(this.onDidFinishSync(()=>this.D())),this.B((0,R.$Rc)(()=>{this.j&&(this.j.cancel(),this.y.info("Auto sync: Cancelled sync that is in progress"),this.j=void 0),this.h?.stop(),this.y.info("Auto Sync: Stopped")})),this.sync(o.a,!1)}D(){this.b.value=(0,I.$ih)(()=>{this.sync(o.a,!1),this.b.value=void 0},this.n)}sync(s,t){const r=(0,I.$6g)(async a=>{if(this.j)try{this.y.debug("Auto Sync: Waiting until sync is finished."),await this.j}catch(E){if((0,j.$4)(E))return}return this.H(s,t,a)});return this.j=r,this.j.finally(()=>this.j=void 0),this.j}F(){return this.m!==void 0&&!(0,g.$Mg)(this.m,this.r.userDataSyncStore?.url)}async G(){const s=await this.r.getPreviousUserDataSyncStore(),t=this.r.userDataSyncStore;return!!t&&!!s&&(!(0,g.$Mg)(t.defaultUrl,s.defaultUrl)||!(0,g.$Mg)(t.insidersUrl,s.insidersUrl)||!(0,g.$Mg)(t.stableUrl,s.stableUrl))}async H(s,t,r){this.y.info(`Auto Sync: Triggered by ${s}`),this.c.fire();let a;try{await this.I(t,r)}catch(E){if(this.y.error(E),a=E,m.$kpb.toUserDataSyncError(E).code==="MethodNotFound")try{this.y.info("Auto Sync: Client is making invalid requests. Cleaning up data..."),await this.u.cleanUpRemoteData(),this.y.info("Auto Sync: Retrying sync..."),await this.I(t,r),a=void 0}catch(b){this.y.error(b),a=b}}this.f.fire(a)}async I(s,t){if(this.h=await this.u.createSyncTask(this.g,s),t.isCancellationRequested)return;if(this.g=this.h.manifest,this.g===null&&await this.u.hasPreviouslySynced())throw this.F()?await this.G()?new m.$mpb((0,S.localize)(0,null),"DefaultServiceChanged"):new m.$mpb((0,S.localize)(1,null),"ServiceChanged"):new m.$mpb((0,S.localize)(2,null),"TurnedOff");const r=this.C.get($,-1);if(r&&this.g&&r!==this.g.session)throw this.F()?await this.G()?new m.$mpb((0,S.localize)(3,null),"DefaultServiceChanged"):new m.$mpb((0,S.localize)(4,null),"ServiceChanged"):new m.$mpb((0,S.localize)(5,null),"SessionExpired");const a=await this.w.getMachines(this.g||void 0);if(t.isCancellationRequested)return;const E=a.find(u=>u.isCurrent);if(E?.disabled)throw new m.$mpb((0,S.localize)(6,null),"TurnedOff");const b=new Date().getTime();if(await this.h.run(),this.z.publicLog2("settingsSync:sync",{duration:new Date().getTime()-b}),this.g===null)try{this.g=await this.s.manifest(null)}catch(u){throw new m.$mpb((0,A.$4i)(u),u instanceof m.$kpb?u.code:"Unknown")}this.g&&this.g.session!==r&&this.C.store($,this.g.session,-1,1),!t.isCancellationRequested&&(E||await this.w.addCurrentMachine(this.g||void 0))}register(s){return super.B(s)}}}),define(le[260],he([0,1,10,179,16,11,43,19,28,25,18,39,119,118,117,21,120,115,116,4,121,42,27]),function(se,e,I,L,A,j,O,R,k,g,C,S,w,h,f,m,y,l,d,$,c,v,i){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$Q$b=void 0;let n=class{static{o=this}static{this.a="not-existing-resource"}static{this.b="remote-backup"}static{this.c="local-backup"}constructor(t,r,a,E,b,u,p,P,N,F){this.e=t,this.f=r,this.g=a,this.h=b,this.i=u,this.j=p,this.k=P,this.l=N,this.n=F,this.d=E.extUri}async getRemoteSyncedProfiles(){const t=await this.e.readResource("profiles",null,void 0);if(t.content){const r=this.L(t.content,"profiles");return(0,c.$g$b)(r)}return[]}async getLocalSyncedProfiles(t){const r=await this.f.getAllResourceRefs("profiles",void 0,t);if(r.length){const a=await this.f.resolveResourceContent("profiles",r[0].ref,void 0,t);if(a){const E=this.L(a,"profiles");return(0,c.$g$b)(E)}}return[]}async getLocalSyncedMachines(t){const r=await this.f.getAllResourceRefs("machines",void 0,t);if(r.length){const a=await this.f.resolveResourceContent("machines",r[0].ref,void 0,t);if(a)return JSON.parse(a).machines.map(b=>({...b,isCurrent:!1}))}return[]}async getRemoteSyncResourceHandles(t,r){return(await this.e.getAllResourceRefs(t,r?.collection)).map(({created:E,ref:b})=>({created:E,uri:this.J({remote:!0,syncResource:t,profile:r?.id??this.k.defaultProfile.id,location:void 0,collection:r?.collection,ref:b,node:void 0})}))}async getLocalSyncResourceHandles(t,r,a){return(await this.f.getAllResourceRefs(t,r?.collection,a)).map(({created:b,ref:u})=>({created:b,uri:this.J({remote:!1,syncResource:t,profile:r?.id??this.k.defaultProfile.id,collection:r?.collection,ref:u,node:void 0,location:a})}))}resolveUserDataSyncResource({uri:t}){const r=this.K(t),a=r?this.k.profiles.find(E=>E.id===r.profile):void 0;return r&&a?{profile:a,syncResource:r?.syncResource}:void 0}async getAssociatedResources({uri:t}){const r=this.K(t);if(!r)return[];const a=this.k.profiles.find(E=>E.id===r.profile);switch(r.syncResource){case"settings":return this.s(t,a);case"keybindings":return this.u(t,a);case"tasks":return this.w(t,a);case"snippets":return this.y(t,a);case"globalState":return this.D(t,a);case"extensions":return this.A(t,a);case"profiles":return this.G(t,a);case"workspaceState":return[]}}async getMachineId({uri:t}){const r=this.K(t);if(r){if(r.remote){if(r.ref){const{content:a}=await this.M(r.syncResource,r.ref,r.collection);if(a)return this.L(a,r.syncResource)?.machineId}return}if(r.location){if(r.ref){const a=await this.f.resolveResourceContent(r.syncResource,r.ref,r.collection,r.location);if(a)return this.L(a,r.syncResource)?.machineId}return}return(0,O.$Pp)(this.h,this.j,this.i)}}async resolveContent(t){const r=this.K(t);if(!r||r.node===o.a)return null;if(r.ref){const a=await this.o(r.remote,r.syncResource,r.collection,r.ref,r.location);return r.node&&a?this.q(r.syncResource,a,r.node):a}return!r.remote&&!r.node?this.r(r.syncResource,r.profile):null}async o(t,r,a,E,b){if(t){const{content:u}=await this.M(r,E,a);return u}return this.f.resolveResourceContent(r,E,a,b)}q(t,r,a){const E=this.L(r,t);switch(t){case"settings":return this.t(E,a);case"keybindings":return this.v(E,a);case"tasks":return this.x(E,a);case"snippets":return this.z(E,a);case"globalState":return this.E(E,a);case"extensions":return this.B(E,a);case"profiles":return this.H(E,a);case"workspaceState":return null}}async r(t,r){const a=this.k.profiles.find(E=>E.id===r);if(!a)return null;switch(t){case"globalState":return this.F(a);case"extensions":return this.C(a);case"profiles":return this.I(a);case"settings":return null;case"keybindings":return null;case"tasks":return null;case"snippets":return null;case"workspaceState":return null}}s(t,r){const a=this.d.joinPath(t,"settings.json"),E=r?r.settingsResource:this.d.joinPath(t,o.a);return[{resource:a,comparableResource:E}]}t(t,r){switch(r){case"settings.json":return(0,h.$p9b)(t.content).settings}return null}u(t,r){const a=this.d.joinPath(t,"keybindings.json"),E=r?r.keybindingsResource:this.d.joinPath(t,o.a);return[{resource:a,comparableResource:E}]}v(t,r){switch(r){case"keybindings.json":return(0,f.$m9b)(t.content,!!this.l.getValue(g.$$ob),this.g)}return null}w(t,r){const a=this.d.joinPath(t,"tasks.json"),E=r?r.tasksResource:this.d.joinPath(t,o.a);return[{resource:a,comparableResource:E}]}x(t,r){switch(r){case"tasks.json":return(0,y.$x9b)(t.content,this.g)}return null}async y(t,r){const a=await this.resolveContent(t);if(a){const E=this.L(a,"snippets");if(E){const b=(0,w.$u9b)(E),u=[];for(const p of Object.keys(b)){const P=this.d.joinPath(t,p),N=r?this.d.joinPath(r.snippetsHome,p):this.d.joinPath(t,o.a);u.push({resource:P,comparableResource:N})}return u}}return[]}z(t,r){return(0,w.$u9b)(t)[r]||null}A(t,r){const a=this.d.joinPath(t,"extensions.json"),E=r?this.J({remote:!1,syncResource:"extensions",profile:r.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(t,o.a);return[{resource:a,comparableResource:E}]}B(t,r){switch(r){case"extensions.json":return(0,l.$h9b)((0,l.$g9b)(t),!0)}return null}async C(t){const{localExtensions:r}=await this.n.createInstance(l.$j9b).getLocalExtensions(t);return(0,l.$h9b)(r,!0)}D(t,r){const a=this.d.joinPath(t,"globalState.json"),E=r?this.J({remote:!1,syncResource:"globalState",profile:r.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(t,o.a);return[{resource:a,comparableResource:E}]}E(t,r){switch(r){case"globalState.json":return(0,d.$XIb)(JSON.parse(t.content),!0)}return null}async F(t){const r=await this.n.createInstance(d.$ZIb).getLocalGlobalState(t);return(0,d.$XIb)(r,!0)}G(t,r){const a=this.d.joinPath(t,"profiles.json"),E=this.J({remote:!1,syncResource:"profiles",profile:this.k.defaultProfile.id,location:void 0,collection:void 0,ref:void 0,node:void 0});return[{resource:a,comparableResource:E}]}H(t,r){switch(r){case"profiles.json":return(0,v.$Dn)(JSON.parse(t.content),{})}return null}async I(t){return(0,c.$f$b)(this.k.profiles.filter(r=>!r.isDefault&&!r.isTransient),!0)}J(t){const r=t.remote?o.b:o.c,a=[];return t.location&&(a.push(`scheme:${t.location.scheme}`),a.push(`authority:${t.location.authority}`),a.push((0,i.$3e)(t.location.path,"/"))),a.push(`syncResource:${t.syncResource}`),a.push(`profile:${t.profile}`),t.collection&&a.push(`collection:${t.collection}`),t.ref&&a.push(`ref:${t.ref}`),t.node&&a.push(t.node),this.d.joinPath(I.URI.from({scheme:g.$wpb,authority:r,path:"/",query:t.location?.query,fragment:t.location?.fragment}),...a)}K(t){if(t.scheme!==g.$wpb)return;const r=[];for(;t.path!=="/";)r.unshift(this.d.basename(t)),t=this.d.dirname(t);if(r.length<2)return;const a=t.authority===o.b;let E,b;const u=[];let p,P,N,F,M;for(;r.length;){const z=r.shift();z.startsWith("scheme:")?E=z.substring(7):z.startsWith("authority:")?b=z.substring(10):z.startsWith("syncResource:")?p=z.substring(13):z.startsWith("profile:")?P=z.substring(8):z.startsWith("collection:")?N=z.substring(11):z.startsWith("ref:")?F=z.substring(4):p?M=z:u.push(z)}return{remote:a,syncResource:p,profile:P,collection:N,ref:F,node:M,location:E&&b!==void 0?this.d.joinPath(I.URI.from({scheme:E,authority:b,query:t.query,fragment:t.fragment,path:"/"}),...u):void 0}}L(t,r){try{const a=JSON.parse(t);if((0,S.$QIb)(a))return a}catch(a){this.g.error(a)}throw new g.$kpb((0,L.localize)(0,null),"IncompatibleRemoteContent",r)}async M(t,r,a){const E=await this.e.resolveResourceContent(t,r,a);return{ref:r,content:E}}};e.$Q$b=n,e.$Q$b=n=o=ye([K(0,g.$fpb),K(1,g.$gpb),K(2,g.$upb),K(3,k.$el),K(4,A.$ni),K(5,R.$Jp),K(6,j.$Gk),K(7,C.$gl),K(8,m.$Mi),K(9,$.$fi)],n)}),define(le[261],he([0,1,17,6,26,38,3,2,20,12,32,21,29,11,4,19,22,18,115,116,117,118,119,120,121,25]),function(se,e,I,L,A,j,O,R,k,g,C,S,w,h,f,m,y,l,d,$,c,v,i,o,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$h$b=void 0;const t="sync.lastSyncTime";let r=class extends R.$Tc{get status(){return this.f}get conflicts(){return this.j}get lastSyncTime(){return this.t}constructor(p,P,N,F,M,z,Z,X,x,W,Q){super(),this.C=p,this.D=P,this.F=N,this.G=F,this.H=M,this.I=z,this.J=Z,this.L=X,this.M=x,this.N=W,this.O=Q,this.f="uninitialized",this.g=this.B(new O.$6d),this.onDidChangeStatus=this.g.event,this.h=this.B(new O.$6d),this.onDidChangeLocal=this.h.event,this.j=[],this.m=this.B(new O.$6d),this.onDidChangeConflicts=this.m.event,this.n=[],this.r=this.B(new O.$6d),this.onSyncErrors=this.r.event,this.t=void 0,this.u=this.B(new O.$6d),this.onDidChangeLastSyncTime=this.u.event,this.w=this.B(new O.$6d),this.onDidResetLocal=this.w.event,this.y=this.B(new O.$6d),this.onDidResetRemote=this.y.event,this.z=new Map,this.f=N.userDataSyncStore?"idle":"uninitialized",this.t=this.J.getNumber(t,-1,void 0),this.B((0,R.$Rc)(()=>this.bb()))}async createSyncTask(p,P){this.cb(),this.H.info("Sync started.");const N=new Date().getTime(),F=(0,C.$Cg)();try{const X=(0,s.$jpb)(F);P&&(X["Cache-Control"]="no-cache"),p=await this.D.manifest(p,X)}catch(X){const x=s.$kpb.toUserDataSyncError(X);throw b(x,F,this.F,this.I),x}const M=!1,z=this;let Z;return{manifest:p,async run(){if(M)throw new Error("Can run a task only once");Z=(0,L.$6g)(X=>z.P(p,!1,F,X)),await Z.finally(()=>Z=void 0),z.H.info(`Sync done. Took ${new Date().getTime()-N}ms`),z.$()},stop(){return Z?.cancel(),z.U()}}}async createManualSyncTask(){if(this.cb(),this.L.isEnabled())throw new s.$kpb("Cannot start manual sync when sync is enabled","LocalError");this.H.info("Sync started.");const p=new Date().getTime(),P=(0,C.$Cg)(),N=(0,s.$jpb)(P);let F;try{F=await this.D.manifest(null,N)}catch(Z){const X=s.$kpb.toUserDataSyncError(Z);throw b(X,P,this.F,this.I),X}await this.resetLocal();const M=this,z=new A.$de;return{id:P,async merge(){return M.P(F,!0,P,z.token)},async apply(){try{try{await M.R(F,P,z.token)}catch(Z){if(s.$kpb.toUserDataSyncError(Z).code==="MethodNotFound")M.H.info("Client is making invalid requests. Cleaning up data..."),await M.cleanUpRemoteData(),M.H.info("Applying manual sync again..."),await M.R(F,P,z.token);else throw Z}}catch(Z){throw M.H.error(Z),Z}M.H.info(`Sync done. Took ${new Date().getTime()-p}ms`),M.$()},async stop(){z.cancel(),await M.U(),await M.resetLocal()}}}async P(p,P,N,F){this.n=[];try{this.status!=="hasConflicts"&&this.Y("syncing");const M=this.getOrCreateActiveProfileSynchronizer(this.M.defaultProfile,void 0);this.n.push(...await this.S(M,p,P,N,F));const z=M.enabled.find(Z=>Z.resource==="profiles");if(z){const Z=await z.getLastSyncedProfiles()||[];if(F.isCancellationRequested)return;await this.Q(Z,p,P,N,F)}}finally{this.status!=="hasConflicts"&&this.Y("idle"),this.r.fire(this.n)}}async Q(p,P,N,F,M){for(const z of p){if(M.isCancellationRequested)return;const Z=this.M.profiles.find(x=>x.id===z.id);if(!Z){this.H.error(`Profile with id:${z.id} and name: ${z.name} does not exist locally to sync.`);continue}this.H.info("Syncing profile.",z.name);const X=this.getOrCreateActiveProfileSynchronizer(Z,z);this.n.push(...await this.S(X,P,N,F,M))}for(const[z,Z]of this.z.entries())this.M.profiles.some(X=>X.id===Z[0].profile.id)||(Z[1].dispose(),this.z.delete(z))}async R(p,P,N){const F=this.ab();for(const x of F){if(N.isCancellationRequested)return;await x.apply(P,N)}const M=F.find(x=>x.profile.isDefault);if(!M)return;const z=M.enabled.find(x=>x.resource==="profiles");if(!z)return;const X=(await z.getRemoteSyncedProfiles(p?.latest??null)||[]).filter(x=>F.every(W=>W.profile.id!==x.id));X.length&&await this.Q(X,p,!1,P,N)}async S(p,P,N,F,M){return(await p.sync(P,N,F,M)).map(([Z,X])=>({profile:p.profile,syncResource:Z,error:X}))}async U(){this.status!=="idle"&&await Promise.allSettled(this.ab().map(p=>p.stop()))}async resolveContent(p){const P=await this.N.resolveContent(p);if(P)return P;for(const N of this.ab())for(const F of N.enabled){const M=await F.resolveContent(p);if(M)return M}return null}async replace(p){this.cb();const P=this.N.resolveUserDataSyncResource(p);if(!P)return;const N=await this.resolveContent(p.uri);N&&await this.W(P.profile,async F=>{if(P.syncResource===F.resource)return await F.replace(N),!0})}async accept(p,P,N,F){this.cb(),await this.W(p.profile,async M=>{if(p.syncResource===M.resource)return await M.accept(P,N),F&&await M.apply((0,g.$Zf)(F)?!1:F.force,(0,s.$jpb)((0,C.$Cg)())),!0})}async hasLocalData(){return!!await this.W(this.M.defaultProfile,async P=>{if(P.resource!=="globalState"&&await P.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.W(this.M.defaultProfile,async P=>{if(await P.hasPreviouslySynced())return!0})}async reset(){this.cb(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.cb();try{await this.D.clear(),this.H.info("Cleared data on server")}catch(p){this.H.error(p)}this.y.fire()}async resetLocal(){this.cb(),this.t=void 0,this.J.remove(t,-1);for(const[p]of this.z.values())try{await p.resetLocal()}catch(P){this.H.error(P)}this.bb(),this.w.fire(),this.H.info("Did reset the local sync state.")}async cleanUpRemoteData(){const p=await this.N.getRemoteSyncedProfiles(),P=p.map(z=>z.collection),N=await this.D.getAllCollections(),F=N.filter(z=>!P.includes(z));F.length&&(this.H.info(`Deleting ${F.length} redundant collections on server`),await Promise.allSettled(F.map(z=>this.D.deleteCollection(z))),this.H.info("Deleted redundant collections on server"));const M=p.filter(z=>N.includes(z.collection));if(M.length!==p.length){const z=this.G.createInstance(n.$e$b,this.M.defaultProfile,void 0);try{this.H.info("Resetting the last synced state of profiles"),await z.resetLocal(),this.H.info("Did reset the last synced state of profiles"),this.H.info("Updating remote profiles with invalid collections on server"),await z.updateRemoteProfiles(M,null),this.H.info("Updated remote profiles on server")}finally{z.dispose()}}}async saveRemoteActivityData(p){this.cb();const P=await this.D.getActivityData();await this.C.writeFile(p,P)}async extractActivityData(p,P){const N=(await this.C.readFile(p)).value.toString(),F=JSON.parse(N);if(F.resources)for(const M in F.resources)for(const z of F.resources[M])await this.O.writeResource(M,z.content,new Date(z.created*1e3),void 0,P);if(F.collections)for(const M in F.collections)for(const z in F.collections[M].resources)for(const Z of F.collections[M].resources?.[z]??[])await this.O.writeResource(z,Z.content,new Date(Z.created*1e3),M,P)}async W(p,P){const N=new R.$Sc;try{const F=this.z.get(p.id);if(F){const x=await this.X(F[0],P,N);return(0,g.$1f)(x)?null:x}if(p.isDefault){const x=N.add(this.G.createInstance(a,p,void 0)),W=await this.X(x,P,N);return(0,g.$1f)(W)?null:W}if(this.M.isEnabled())return null;const M=N.add(this.G.createInstance(n.$e$b,p,void 0)),z=await this.D.manifest(null),X=(await M.getRemoteSyncedProfiles(z?.latest??null)||[]).find(x=>x.id===p.id);if(X){const x=N.add(this.G.createInstance(a,p,X.collection)),W=await this.X(x,P,N);return(0,g.$1f)(W)?null:W}return null}finally{N.dispose()}}async X(p,P,N){const F=[...p.enabled,...p.disabled.reduce((M,z)=>(z!=="workspaceState"&&M.push(N.add(p.createSynchronizer(z))),M),[])];for(const M of F){const z=await P(M);if(!(0,g.$1f)(z))return z}}Y(p){const P=this.f;this.f!==p&&(this.f=p,this.g.fire(p),P==="hasConflicts"&&this.$())}Z(){const p=this.ab().map(P=>P.conflicts).flat();(0,I.$ub)(this.j,p,(P,N)=>P.profile.id===N.profile.id&&P.syncResource===N.syncResource&&(0,I.$ub)(P.conflicts,N.conflicts,(F,M)=>(0,k.$Mg)(F.previewResource,M.previewResource)))||(this.j=p,this.m.fire(p))}$(){this.status==="idle"&&(this.t=new Date().getTime(),this.J.store(t,this.t,-1,1),this.u.fire(this.t))}getOrCreateActiveProfileSynchronizer(p,P){let N=this.z.get(p.id);if(N&&N[0].collection!==P?.collection&&(this.H.error("Profile synchronizer collection does not match with the remote sync profile collection"),N[1].dispose(),N=void 0,this.z.delete(p.id)),!N){const F=new R.$Sc,M=F.add(this.G.createInstance(a,p,P?.collection));F.add(M.onDidChangeStatus(z=>this.Y(z))),F.add(M.onDidChangeConflicts(z=>this.Z())),F.add(M.onDidChangeLocal(z=>this.h.fire(z))),this.z.set(p.id,N=[M,F])}return N[0]}ab(){const p=[];for(const[P]of this.z.values())p.push(P);return p}bb(){this.z.forEach(([,p])=>p.dispose()),this.z.clear()}cb(){if(!this.F.userDataSyncStore)throw new Error("Not enabled")}};e.$h$b=r,e.$h$b=r=ye([K(0,h.$Gk),K(1,s.$fpb),K(2,s.$epb),K(3,f.$fi),K(4,s.$upb),K(5,y.$Fl),K(6,m.$Jp),K(7,s.$ppb),K(8,l.$gl),K(9,s.$rpb),K(10,s.$gpb)],r);let a=class extends R.$Tc{get enabled(){return this.f.sort((p,P)=>p[1]-P[1]).map(([p])=>p)}get disabled(){return s.$bpb.filter(p=>!this.r.isResourceEnabled(p))}get status(){return this.g}get conflicts(){return this.m}constructor(p,P,N,F,M,z,Z,X,x,W){super(),this.profile=p,this.collection=P,this.r=N,this.t=F,this.u=M,this.w=z,this.y=Z,this.z=X,this.C=x,this.D=W,this.f=[],this.g="idle",this.h=this.B(new O.$6d),this.onDidChangeStatus=this.h.event,this.j=this.B(new O.$6d),this.onDidChangeLocal=this.j.event,this.m=[],this.n=this.B(new O.$6d),this.onDidChangeConflicts=this.n.event,this.B(N.onDidChangeResourceEnablement(([Q,H])=>this.F(Q,H))),this.B((0,R.$Rc)(()=>this.f.splice(0,this.f.length).forEach(([,,Q])=>Q.dispose())));for(const Q of s.$bpb)N.isResourceEnabled(Q)&&this.G(Q)}F(p,P){P?this.G(p):this.H(p)}G(p){if(this.f.some(([M])=>M.resource===p))return;if(p==="extensions"&&!this.u.isEnabled()){this.z.info("Skipping extensions sync because gallery is not configured");return}if(p==="profiles"&&(!this.profile.isDefault||!this.C.isEnabled())||p==="workspaceState")return;if(p!=="profiles"&&this.profile.useDefaultFlags?.[p]){this.z.debug(`Skipping syncing ${p} in ${this.profile.name} because it is already synced by default profile`);return}const P=new R.$Sc,N=P.add(this.createSynchronizer(p));P.add(N.onDidChangeStatus(()=>this.L())),P.add(N.onDidChangeConflicts(()=>this.M())),P.add(N.onDidChangeLocal(()=>this.j.fire(p)));const F=this.N(p);this.f.push([N,F,P])}H(p){const P=this.f.findIndex(([N])=>N.resource===p);if(P!==-1){const[[N,,F]]=this.f.splice(P,1);F.dispose(),this.L(),Promise.allSettled([N.stop(),N.resetLocal()]).then(null,M=>this.z.error(M))}}createSynchronizer(p){switch(p){case"settings":return this.t.createInstance(v.$q9b,this.profile,this.collection);case"keybindings":return this.t.createInstance(c.$n9b,this.profile,this.collection);case"snippets":return this.t.createInstance(i.$v9b,this.profile,this.collection);case"tasks":return this.t.createInstance(o.$y9b,this.profile,this.collection);case"globalState":return this.t.createInstance($.$YIb,this.profile,this.collection);case"extensions":return this.t.createInstance(d.$i9b,this.profile,this.collection);case"profiles":return this.t.createInstance(n.$e$b,this.profile,this.collection)}}async sync(p,P,N,F){if(F.isCancellationRequested)return[];const M=this.enabled;if(!M.length)return[];try{const z=[],Z=(0,s.$jpb)(N),X=(this.collection?p?.collections?.[this.collection]?.latest:p?.latest)??null,x=P?await this.I(X):{};for(const W of M){if(F.isCancellationRequested)return[];if(!this.r.isResourceEnabled(W.resource))return[];try{if(P){const Q=await W.preview(X,x,Z);if(Q)for(const H of Q.resourcePreviews)(H.localChange!==0||H.remoteChange!==0)&&H.mergeState==="preview"&&await W.merge(H.previewResource)}else await W.sync(X,Z)}catch(Q){const H=s.$kpb.toUserDataSyncError(Q);if(b(H,N,this.w,this.y),E(Q))throw H;this.z.error(Q),this.z.error(`${W.resource}: ${(0,j.$4i)(Q)}`),z.push([W.resource,H])}}return z}finally{this.L()}}async apply(p,P){const N=(0,s.$jpb)(p);for(const F of this.enabled){if(P.isCancellationRequested)return;try{await F.apply(!1,N)}catch(M){const z=s.$kpb.toUserDataSyncError(M);if(b(z,p,this.w,this.y),E(M))throw z;this.z.error(M),this.z.error(`${F.resource}: ${(0,j.$4i)(M)}`)}}}async stop(){for(const p of this.enabled)try{p.status!=="idle"&&await p.stop()}catch(P){this.z.error(P)}}async resetLocal(){for(const p of this.enabled)try{await p.resetLocal()}catch(P){this.z.error(`${p.resource}: ${(0,j.$4i)(P)}`),this.z.error(P)}}async I(p){if(!this.profile.isDefault)return{};const P=this.D.getValue(s.$0ob),N=this.enabled.find(F=>F instanceof v.$q9b);if(N){const F=await N.getRemoteUserDataSyncConfiguration(p);return{...P,...F}}return P}J(p){this.g!==p&&(this.g=p,this.h.fire(p))}L(){return this.M(),this.enabled.some(p=>p.status==="hasConflicts")?this.J("hasConflicts"):this.enabled.some(p=>p.status==="syncing")?this.J("syncing"):this.J("idle")}M(){const p=this.enabled.filter(P=>P.status==="hasConflicts").filter(P=>P.conflicts.conflicts.length>0).map(P=>P.conflicts);(0,I.$ub)(this.m,p,(P,N)=>P.syncResource===N.syncResource&&(0,I.$ub)(P.conflicts,N.conflicts,(F,M)=>(0,k.$Mg)(F.previewResource,M.previewResource)))||(this.m=p,this.n.fire(p))}N(p){switch(p){case"settings":return 0;case"keybindings":return 1;case"snippets":return 2;case"tasks":return 3;case"globalState":return 4;case"extensions":return 5;case"profiles":return 6;case"workspaceState":return 7}}};a=ye([K(2,s.$ppb),K(3,f.$fi),K(4,w.$Oo),K(5,s.$epb),K(6,y.$Fl),K(7,s.$upb),K(8,l.$gl),K(9,S.$Mi)],a);function E(u){if(u instanceof s.$kpb)switch(u.code){case"MethodNotFound":case"TooLarge":case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"LocalTooManyProfiles":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":return!0}return!1}function b(u,p,P,N){N.publicLog2("sync/error",{code:u.code,serverCode:u instanceof s.$lpb?String(u.serverCode):void 0,url:u instanceof s.$lpb?u.url:void 0,resource:u.resource,executionId:p,service:P.userDataSyncStore.url.toString()})}}),define(le[262],he([0,1,3,2,10,18,25]),function(se,e,I,L,A,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cbc=e.$Bbc=void 0;function R(w,h){return{...w,profile:(0,j.$hl)(w.profile,h.profilesHome.scheme)}}function k(w){return{created:w.created,uri:A.URI.revive(w.uri)}}class g{constructor(h,f,m){this.c=h,this.d=f,this.f=m,this.a=new Map,this.b=new I.$6d}listen(h,f){switch(f){case"onDidChangeStatus":return this.c.onDidChangeStatus;case"onDidChangeConflicts":return this.c.onDidChangeConflicts;case"onDidChangeLocal":return this.c.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.c.onDidChangeLastSyncTime;case"onSyncErrors":return this.c.onSyncErrors;case"onDidResetLocal":return this.c.onDidResetLocal;case"onDidResetRemote":return this.c.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.b.event}throw new Error(`[UserDataSyncServiceChannel] Event not found: ${f}`)}async call(h,f,m){try{return await this.g(h,f,m)}catch(y){throw this.f.error(y),y}}async g(h,f,m){switch(f){case"_getInitialData":return Promise.resolve([this.c.status,this.c.conflicts,this.c.lastSyncTime]);case"reset":return this.c.reset();case"resetRemote":return this.c.resetRemote();case"resetLocal":return this.c.resetLocal();case"hasPreviouslySynced":return this.c.hasPreviouslySynced();case"hasLocalData":return this.c.hasLocalData();case"resolveContent":return this.c.resolveContent(A.URI.revive(m[0]));case"accept":return this.c.accept(R(m[0],this.d),A.URI.revive(m[1]),m[2],m[3]);case"replace":return this.c.replace(k(m[0]));case"cleanUpRemoteData":return this.c.cleanUpRemoteData();case"getRemoteActivityData":return this.c.saveRemoteActivityData(A.URI.revive(m[0]));case"extractActivityData":return this.c.extractActivityData(A.URI.revive(m[0]),A.URI.revive(m[1]));case"createManualSyncTask":return this.i()}if(f.startsWith("manualSync/")){const y=f.substring(11),l=m[0],d=this.h(l);switch(m=m.slice(1),y){case"merge":return d.merge();case"apply":return d.apply().then(()=>this.a.delete(this.j(d.id)));case"stop":return d.stop().finally(()=>this.a.delete(this.j(d.id)))}}throw new Error("Invalid call")}h(h){const f=this.a.get(this.j(h));if(!f)throw new Error(`Manual sync taks not found: ${h}`);return f}async i(){const h=await this.c.createManualSyncTask();return this.a.set(this.j(h.id),h),h.id}j(h){return`manualSyncTask-${h}`}}e.$Bbc=g;let C=class extends L.$Tc{get status(){return this.b}get onDidChangeLocal(){return this.a.listen("onDidChangeLocal")}get conflicts(){return this.f}get lastSyncTime(){return this.h}get onDidResetLocal(){return this.a.listen("onDidResetLocal")}get onDidResetRemote(){return this.a.listen("onDidResetRemote")}constructor(h,f){super(),this.n=f,this.b="uninitialized",this.c=this.B(new I.$6d),this.onDidChangeStatus=this.c.event,this.f=[],this.g=this.B(new I.$6d),this.onDidChangeConflicts=this.g.event,this.h=void 0,this.j=this.B(new I.$6d),this.onDidChangeLastSyncTime=this.j.event,this.m=this.B(new I.$6d),this.onSyncErrors=this.m.event,this.a={call(m,y,l){return h.call(m,y,l).then(null,d=>{throw O.$kpb.toUserDataSyncError(d)})},listen(m,y){return h.listen(m,y)}},this.a.call("_getInitialData").then(([m,y,l])=>{this.s(m),this.t(y),l&&this.u(l),this.B(this.a.listen("onDidChangeStatus")(d=>this.s(d))),this.B(this.a.listen("onDidChangeLastSyncTime")(d=>this.u(d)))}),this.B(this.a.listen("onDidChangeConflicts")(m=>this.t(m))),this.B(this.a.listen("onSyncErrors")(m=>this.m.fire(m.map(y=>({...y,error:O.$kpb.toUserDataSyncError(y.error)})))))}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const h=await this.a.call("createManualSyncTask"),f=this;return new S(h,{async call(y,l,d){return f.a.call(`manualSync/${y}`,[h,...Array.isArray(l)?l:[l]],d)},listen(){throw new Error("not supported")}})}reset(){return this.a.call("reset")}resetRemote(){return this.a.call("resetRemote")}resetLocal(){return this.a.call("resetLocal")}hasPreviouslySynced(){return this.a.call("hasPreviouslySynced")}hasLocalData(){return this.a.call("hasLocalData")}accept(h,f,m,y){return this.a.call("accept",[h,f,m,y])}resolveContent(h){return this.a.call("resolveContent",[h])}cleanUpRemoteData(){return this.a.call("cleanUpRemoteData")}replace(h){return this.a.call("replace",[h])}saveRemoteActivityData(h){return this.a.call("getRemoteActivityData",[h])}extractActivityData(h,f){return this.a.call("extractActivityData",[h,f])}async s(h){this.b=h,this.c.fire(h)}async t(h){this.f=h.map(f=>({syncResource:f.syncResource,profile:(0,j.$hl)(f.profile,this.n.profilesHome.scheme),conflicts:f.conflicts.map(m=>({...m,baseResource:A.URI.revive(m.baseResource),localResource:A.URI.revive(m.localResource),remoteResource:A.URI.revive(m.remoteResource),previewResource:A.URI.revive(m.previewResource)}))})),this.g.fire(this.f)}u(h){this.h!==h&&(this.h=h,this.j.fire(h))}};e.$Cbc=C,e.$Cbc=C=ye([K(1,j.$gl)],C);class S extends L.$Tc{constructor(h,f){super(),this.id=h,this.a=f}async merge(){return this.a.call("merge")}async apply(){return this.a.call("apply")}stop(){return this.a.call("stop")}dispose(){this.a.call("dispose"),super.dispose()}}}),define(le[122],he([0,1,6,26,7,3,2,141,5,20,12,10,32,21,16,11,24,59,43,19,25]),function(se,e,I,L,A,j,O,R,k,g,C,S,w,h,f,m,y,l,d,$,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OIb=e.$NIb=e.$MIb=e.$LIb=e.$KIb=void 0;const v="configurationSync.store",i="sync.previous.store",o="sync.donot-make-requests-until",n="sync.user-session-id",s="sync.machine-session-id",t=100,r=1e3*60*5;let a=class extends O.$Tc{get userDataSyncStore(){return this.b}get c(){return this.h.get(c.$npb,-1)}set c(N){this.h.store(c.$npb,N,-1,k.$o?0:1)}constructor(N,F,M){super(),this.f=N,this.g=F,this.h=M,this.a=this.B(new j.$6d),this.onDidChangeUserDataSyncStore=this.a.event,this.j();const z=this.B(new O.$Sc);this.B(j.Event.filter(M.onDidChangeValue(-1,c.$npb,z),()=>this.c!==this.userDataSyncStore?.type,z)(()=>this.j()))}j(){this.b=this.m(this.f[v]),this.a.fire()}m(N){if(N&&(N=k.$o&&N.web?{...N,...N.web}:N,(0,C.$Tf)(N.url)&&(0,C.$Vf)(N.authenticationProviders)&&Object.keys(N.authenticationProviders).every(F=>Array.isArray(N.authenticationProviders[F].scopes)))){const F=N,M=!!F.canSwitch,z=F.url===F.insidersUrl?"insiders":"stable",Z=(M?this.c:void 0)||z,X=Z==="insiders"?F.insidersUrl:Z==="stable"?F.stableUrl:F.url;return{url:S.URI.parse(X),type:Z,defaultType:z,defaultUrl:S.URI.parse(F.url),stableUrl:S.URI.parse(F.stableUrl),insidersUrl:S.URI.parse(F.insidersUrl),canSwitch:M,authenticationProviders:Object.keys(F.authenticationProviders).reduce((x,W)=>(x.push({id:W,scopes:F.authenticationProviders[W].scopes}),x),[])}}}};e.$KIb=a,e.$KIb=a=ye([K(0,y.$Sj),K(1,h.$Mi),K(2,$.$Jp)],a);let E=class extends a{constructor(N,F,M){super(N,F,M);const z=this.h.get(i,-1);z&&(this.n=JSON.parse(z));const Z=this.f[v];Z?this.h.store(i,JSON.stringify(Z),-1,1):this.h.remove(i,-1)}async switch(N){N!==this.c&&(this.c=N,this.j())}async getPreviousUserDataSyncStore(){return this.m(this.n)}};e.$LIb=E,e.$LIb=E=ye([K(0,y.$Sj),K(1,h.$Mi),K(2,$.$Jp)],E);let b=class extends O.$Tc{get donotMakeRequestsUntil(){return this.j}constructor(N,F,M,z,Z,X,x){super(),this.n=M,this.r=z,this.s=x,this.g=this.B(new j.$6d),this.onTokenFailed=this.g.event,this.h=this.B(new j.$6d),this.onTokenSucceed=this.h.event,this.j=void 0,this.m=this.B(new j.$6d),this.onDidChangeDonotMakeRequestsUntil=this.m.event,this.w=void 0,this.t(N),this.c=(0,d.$Pp)(Z,X,x).then(W=>{const Q={"X-Client-Name":`${F.applicationName}${k.$o?"-web":""}`,"X-Client-Version":F.version};return F.commit&&(Q["X-Client-Commit"]=F.commit),Q}),this.f=new p(t,r,this.n,this.r),this.u(),this.B((0,O.$Rc)(()=>{this.w&&(this.w.cancel(),this.w=void 0)}))}setAuthToken(N,F){this.b={token:N,type:F}}t(N){this.a=N?(0,g.$Tg)(N,"v1"):void 0}u(){const N=this.s.getNumber(o,-1);N&&Date.now()<N&&this.y(new Date(N))}y(N){this.j?.getTime()!==N?.getTime()&&(this.j=N,this.w&&(this.w.cancel(),this.w=void 0),this.j?(this.s.store(o,this.j.getTime(),-1,1),this.w=(0,I.$6g)(F=>(0,I.$hh)(this.j.getTime()-Date.now(),F).then(()=>this.y(void 0))),this.w.then(null,F=>null)):this.s.remove(o,-1),this.m.fire())}async getAllCollections(N={}){if(!this.a)throw new Error("No settings sync store url configured.");const F=(0,g.$Tg)(this.a,"collection").toString();N={...N},N["Content-Type"]="application/json";const M=await this.D(F,{type:"GET",headers:N},[],L.CancellationToken.None);return(await(0,l.$Cp)(M))?.map(({id:z})=>z)||[]}async createCollection(N={}){if(!this.a)throw new Error("No settings sync store url configured.");const F=(0,g.$Tg)(this.a,"collection").toString();N={...N},N["Content-Type"]=R.$us.text;const M=await this.D(F,{type:"POST",headers:N},[],L.CancellationToken.None),z=await(0,l.$Bp)(M);if(!z)throw new c.$lpb("Server did not return the collection id",F,"NoCollection",M.res.statusCode,M.res.headers[c.$hpb]);return z}async deleteCollection(N,F={}){if(!this.a)throw new Error("No settings sync store url configured.");const M=N?(0,g.$Tg)(this.a,"collection",N).toString():(0,g.$Tg)(this.a,"collection").toString();F={...F},await this.D(M,{type:"DELETE",headers:F},[],L.CancellationToken.None)}async getAllResourceRefs(N,F){if(!this.a)throw new Error("No settings sync store url configured.");const M=this.z(this.a,F,N),z={},Z=await this.D(M.toString(),{type:"GET",headers:z},[],L.CancellationToken.None);return(await(0,l.$Cp)(Z)||[]).map(({url:x,created:W})=>({ref:(0,g.$Vg)(M,M.with({path:x})),created:W*1e3}))}async resolveResourceContent(N,F,M,z={}){if(!this.a)throw new Error("No settings sync store url configured.");const Z=(0,g.$Tg)(this.z(this.a,M,N),F).toString();z={...z},z["Cache-Control"]="no-cache";const X=await this.D(Z,{type:"GET",headers:z},[],L.CancellationToken.None);return await(0,l.$Bp)(X)}async deleteResource(N,F,M){if(!this.a)throw new Error("No settings sync store url configured.");const z=F!==null?(0,g.$Tg)(this.z(this.a,M,N),F).toString():this.z(this.a,M,N).toString(),Z={};await this.D(z,{type:"DELETE",headers:Z},[],L.CancellationToken.None)}async deleteResources(){if(!this.a)throw new Error("No settings sync store url configured.");const N=(0,g.$Tg)(this.a,"resource").toString(),F={"Content-Type":R.$us.text};await this.D(N,{type:"DELETE",headers:F},[],L.CancellationToken.None)}async readResource(N,F,M,z={}){if(!this.a)throw new Error("No settings sync store url configured.");const Z=(0,g.$Tg)(this.z(this.a,M,N),"latest").toString();z={...z},z["Cache-Control"]="no-cache",F&&(z["If-None-Match"]=F.ref);const X=await this.D(Z,{type:"GET",headers:z},[304],L.CancellationToken.None);let x=null;if(X.res.statusCode===304&&(x=F),x===null){const W=X.res.headers.etag;if(!W)throw new c.$lpb("Server did not return the ref",Z,"NoRef",X.res.statusCode,X.res.headers[c.$hpb]);const Q=await(0,l.$Bp)(X);if(!Q&&X.res.statusCode===304)throw new c.$lpb("Empty response",Z,"EmptyResponse",X.res.statusCode,X.res.headers[c.$hpb]);x={ref:W,content:Q}}return x}async writeResource(N,F,M,z,Z={}){if(!this.a)throw new Error("No settings sync store url configured.");const X=this.z(this.a,z,N).toString();Z={...Z},Z["Content-Type"]=R.$us.text,M&&(Z["If-Match"]=M);const x=await this.D(X,{type:"POST",data:F,headers:Z},[],L.CancellationToken.None),W=x.res.headers.etag;if(!W)throw new c.$lpb("Server did not return the ref",X,"NoRef",x.res.statusCode,x.res.headers[c.$hpb]);return W}async manifest(N,F={}){if(!this.a)throw new Error("No settings sync store url configured.");const M=(0,g.$Tg)(this.a,"manifest").toString();F={...F},F["Content-Type"]="application/json",N&&(F["If-None-Match"]=N.ref);const z=await this.D(M,{type:"GET",headers:F},[304],L.CancellationToken.None);let Z=null;if(z.res.statusCode===304&&(Z=N),!Z){const x=z.res.headers.etag;if(!x)throw new c.$lpb("Server did not return the ref",M,"NoRef",z.res.statusCode,z.res.headers[c.$hpb]);const W=await(0,l.$Bp)(z);if(!W&&z.res.statusCode===304)throw new c.$lpb("Empty response",M,"EmptyResponse",z.res.statusCode,z.res.headers[c.$hpb]);W&&(Z={...JSON.parse(W),ref:x})}const X=this.s.get(n,-1);return X&&Z&&X!==Z.session&&this.C(),Z===null&&X&&this.C(),Z&&this.s.store(n,Z.session,-1,1),Z}async clear(){if(!this.a)throw new Error("No settings sync store url configured.");await this.deleteCollection(),await this.deleteResources(),this.C()}async getActivityData(){if(!this.a)throw new Error("No settings sync store url configured.");const N=(0,g.$Tg)(this.a,"download").toString(),F={},M=await this.D(N,{type:"GET",headers:F},[],L.CancellationToken.None);if(!(0,l.$yp)(M))throw new c.$lpb("Server returned "+M.res.statusCode,N,"EmptyResponse",M.res.statusCode,M.res.headers[c.$hpb]);if((0,l.$zp)(M))throw new c.$lpb("Empty response",N,"EmptyResponse",M.res.statusCode,M.res.headers[c.$hpb]);return M.stream}z(N,F,M){return F?(0,g.$Tg)(N,"collection",F,"resource",M):(0,g.$Tg)(N,"resource",M)}C(){this.s.remove(n,-1),this.s.remove(s,-1)}async D(N,F,M,z){if(!this.b)throw new c.$lpb("No Auth Token Available",N,"Unauthorized",void 0,void 0);if(this.j&&Date.now()<this.j.getTime())throw new c.$lpb(`${F.type} request '${N}' failed because of too many requests (429).`,N,"TooManyRequestsAndRetryAfter",void 0,void 0);this.y(void 0);const Z=await this.c;F.headers={...F.headers||{},...Z,"X-Account-Type":this.b.type,authorization:`Bearer ${this.b.token}`},this.F(F.headers),this.r.trace("Sending request to server",{url:N,type:F.type,headers:{...F.headers,authorization:void 0}});let X;try{X=await this.f.request(N,F,z)}catch(V){if(!(V instanceof c.$lpb)){let te="RequestFailed";const re=(0,A.$0)(V).toLowerCase();re.includes("xhr timeout")?te="RequestTimeout":re.includes("protocol")&&re.includes("not supported")?te="RequestProtocolNotSupported":re.includes("request path contains unescaped characters")?te="RequestPathNotEscaped":re.includes("headers must be an object")?te="RequestHeadersNotObject":(0,A.$4)(V)&&(te="RequestCanceled"),V=new c.$lpb(`Connection refused for the request '${N}'.`,N,te,void 0,void 0)}throw this.r.info("Request failed",N),V}const x=X.res.headers[c.$hpb],W={url:N,status:X.res.statusCode,"execution-id":F.headers[c.$ipb],"operation-id":x},Q=(0,l.$yp)(X)||X.res.statusCode&&M.includes(X.res.statusCode);let H="";if(Q?this.r.trace("Request succeeded",W):(H=await(0,l.$Ap)(X)||"",this.r.info("Request failed",W,H)),X.res.statusCode===401||X.res.statusCode===403){if(this.b=void 0,X.res.statusCode===401)throw this.g.fire("Unauthorized"),new c.$lpb(`${F.type} request '${N}' failed because of Unauthorized (401).`,N,"Unauthorized",X.res.statusCode,x);if(X.res.statusCode===403)throw this.g.fire("Forbidden"),new c.$lpb(`${F.type} request '${N}' failed because the access is forbidden (403).`,N,"Forbidden",X.res.statusCode,x)}if(this.h.fire(),X.res.statusCode===404)throw new c.$lpb(`${F.type} request '${N}' failed because the requested resource is not found (404).`,N,"NotFound",X.res.statusCode,x);if(X.res.statusCode===405)throw new c.$lpb(`${F.type} request '${N}' failed because the requested endpoint is not found (405). ${H}`,N,"MethodNotFound",X.res.statusCode,x);if(X.res.statusCode===409)throw new c.$lpb(`${F.type} request '${N}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,N,"Conflict",X.res.statusCode,x);if(X.res.statusCode===410)throw new c.$lpb(`${F.type} request '${N}' failed because the requested resource is not longer available (410).`,N,"Gone",X.res.statusCode,x);if(X.res.statusCode===412)throw new c.$lpb(`${F.type} request '${N}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,N,"PreconditionFailed",X.res.statusCode,x);if(X.res.statusCode===413)throw new c.$lpb(`${F.type} request '${N}' failed because of too large payload (413).`,N,"TooLarge",X.res.statusCode,x);if(X.res.statusCode===426)throw new c.$lpb(`${F.type} request '${N}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,N,"UpgradeRequired",X.res.statusCode,x);if(X.res.statusCode===429){const V=X.res.headers["retry-after"];throw V?(this.y(new Date(Date.now()+parseInt(V)*1e3)),new c.$lpb(`${F.type} request '${N}' failed because of too many requests (429).`,N,"TooManyRequestsAndRetryAfter",X.res.statusCode,x)):new c.$lpb(`${F.type} request '${N}' failed because of too many requests (429).`,N,"RemoteTooManyRequests",X.res.statusCode,x)}if(!Q)throw new c.$lpb("Server returned "+X.res.statusCode,N,"Unknown",X.res.statusCode,x);return X}F(N){let F=this.s.get(s,-1);F===void 0&&(F=(0,w.$Cg)(),this.s.store(s,F,-1,1)),N["X-Machine-Session-Id"]=F;const M=this.s.get(n,-1);M!==void 0&&(N["X-User-Session-Id"]=M)}};e.$MIb=b,e.$MIb=b=ye([K(1,y.$Sj),K(2,l.$wp),K(3,c.$upb),K(4,f.$ni),K(5,m.$Gk),K(6,$.$Jp)],b);let u=class extends b{constructor(N,F,M,z,Z,X,x){super(N.userDataSyncStore?.url,F,M,z,Z,X,x),this.B(N.onDidChangeUserDataSyncStore(()=>this.t(N.userDataSyncStore?.url)))}};e.$NIb=u,e.$NIb=u=ye([K(0,c.$epb),K(1,y.$Sj),K(2,l.$wp),K(3,c.$upb),K(4,f.$ni),K(5,m.$Gk),K(6,$.$Jp)],u);class p{constructor(N,F,M,z){this.c=N,this.d=F,this.f=M,this.g=z,this.a=[],this.b=void 0}request(N,F,M){if(this.h()&&this.i(),F.url=N,this.a.length>=this.c)throw this.g.info("Too many requests",...this.a),new c.$lpb(`Too many requests. Only ${this.c} requests allowed in ${this.d/(1e3*60)} minutes.`,N,"LocalTooManyRequests",void 0,void 0);return this.b=this.b||new Date,this.a.push(N),this.f.request(F,M)}h(){return this.b!==void 0&&new Date().getTime()-this.b.getTime()>this.d}i(){this.a=[],this.b=void 0}}e.$OIb=p}),define(le[263],he([0,1,3,2,10,21,24,19,122]),function(se,e,I,L,A,j,O,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Abc=e.$zbc=e.$ybc=e.$xbc=void 0;class g{constructor(f){this.a=f}listen(f,m){switch(m){case"onDidChangeAccount":return this.a.onDidChangeAccount;case"onTokenFailed":return this.a.onTokenFailed}throw new Error(`[UserDataSyncAccountServiceChannel] Event not found: ${m}`)}call(f,m,y){switch(m){case"_getInitialData":return Promise.resolve(this.a.account);case"updateAccount":return this.a.updateAccount(y)}throw new Error("Invalid call")}}e.$xbc=g;class C extends L.$Tc{get account(){return this.a}get onTokenFailed(){return this.c.listen("onTokenFailed")}constructor(f){super(),this.c=f,this.b=this.B(new I.$6d),this.onDidChangeAccount=this.b.event,this.c.call("_getInitialData").then(m=>{this.a=m,this.B(this.c.listen("onDidChangeAccount")(y=>{this.a=y,this.b.fire(y)}))})}updateAccount(f){return this.c.call("updateAccount",f)}}e.$ybc=C;class S{constructor(f){this.a=f}listen(f,m){switch(m){case"onDidChangeUserDataSyncStore":return this.a.onDidChangeUserDataSyncStore}throw new Error(`[UserDataSyncStoreManagementServiceChannel] Event not found: ${m}`)}call(f,m,y){switch(m){case"switch":return this.a.switch(y[0]);case"getPreviousUserDataSyncStore":return this.a.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.$zbc=S;let w=class extends k.$KIb{constructor(f,m,y,l){super(m,y,l),this.n=f,this.B(this.n.listen("onDidChangeUserDataSyncStore")(()=>this.j()))}async switch(f){return this.n.call("switch",[f])}async getPreviousUserDataSyncStore(){const f=await this.n.call("getPreviousUserDataSyncStore");return this.r(f)}r(f){return{url:A.URI.revive(f.url),type:f.type,defaultUrl:A.URI.revive(f.defaultUrl),insidersUrl:A.URI.revive(f.insidersUrl),stableUrl:A.URI.revive(f.stableUrl),canSwitch:f.canSwitch,authenticationProviders:f.authenticationProviders}}};e.$Abc=w,e.$Abc=w=ye([K(1,O.$Sj),K(2,j.$Mi),K(3,R.$Jp)],w)}),define(le[264],he([0,1,3,57,24,19,22,259,25,80,83]),function(se,e,I,L,A,j,O,R,k,g,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wbc=void 0;let S=class extends R.$i$b{constructor(h,f,m,y,l,d,$,c,v,i,o){super(h,f,m,y,l,$,c,v,i,o),this.B(I.Event.debounce(I.Event.any(I.Event.map(d.onDidFocusMainWindow,()=>"windowFocus"),I.Event.map(d.onDidOpenMainWindow,()=>"windowOpen")),(n,s)=>n?[...n,s]:[s],1e3)(n=>this.triggerSync(n,!0,!1)))}};e.$Wbc=S,e.$Wbc=S=ye([K(0,A.$Sj),K(1,k.$epb),K(2,k.$fpb),K(3,k.$ppb),K(4,k.$qpb),K(5,L.$N_b),K(6,k.$upb),K(7,g.$iHb),K(8,O.$Fl),K(9,C.$5ob),K(10,j.$Jp)],S)}),define(le[265],he([0,1,73,23,5,20]),function(se,e,I,L,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$e_b=e.$d_b=e.$c_b=e.$b_b=void 0,e.$b_b=128/4;function O(g){function C(){let S=g.scheme===L.Schemas.file?(0,j.$Hg)(g):g.toString();return A.$k||(S=S.toLowerCase()),(0,I.createHash)("md5").update(S).digest("hex")}return{id:C(),configPath:g}}e.$c_b=O;function R(g,C){function S(){if(g.scheme!==L.Schemas.file)return(0,I.createHash)("md5").update(g.toString()).digest("hex");if(!C)return;let h;return A.$k?h=C.ino:A.$j?h=C.birthtime.getTime():A.$i&&(typeof C.birthtimeMs=="number"?h=Math.floor(C.birthtimeMs):h=C.birthtime.getTime()),(0,I.createHash)("md5").update(g.fsPath).update(h?String(h):"").digest("hex")}const w=S();if(typeof w=="string")return{id:w,uri:g}}e.$d_b=R;function k(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.$e_b=k}),define(le[266],he([0,1,6,7,2,15,31,16,8,77,112,265,57,56,23]),function(se,e,I,L,A,j,O,R,k,g,C,S,w,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tbc=void 0;let m=class extends A.$Tc{constructor(l,d,$,c){super(),this.a=l,this.b=d,this.c=$,this.f=c,this.B(new I.$sh(()=>{this.g()},30*1e3)).schedule()}async g(){this.b.trace("[storage cleanup]: Starting to clean up workspace storage folders for unused empty workspaces.");try{const l=this.a.workspaceStorageHome.with({scheme:f.Schemas.file}).fsPath,d=await O.Promises.readdir(l),$=new g.$THb(this.f.getChannel("storage"));await Promise.all(d.map(async c=>{const v=(0,j.$jc)(l,c);c.length===S.$b_b||c===C.$si.id||(await this.c.getWindows({includeAuxiliaryWindows:!1})).some(n=>n.workspace?.id===c)||await $.isUsed(v)||(this.b.trace(`[storage cleanup]: Deleting workspace storage folder ${c} as it seems to be an unused empty workspace.`),await O.Promises.rm(v))}))}catch(l){(0,L.$1)(l)}}};e.$tbc=m,e.$tbc=m=ye([K(0,R.$oi),K(1,k.$Aj),K(2,w.$N_b),K(3,h.$3ac)],m)}),define(le[123],he([0,1,73,64,37,276,14,7,3,2,15,5,32,40,68]),function(se,e,I,L,A,j,O,R,k,g,C,S,w,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=e.$0h=e.$9h=e.$8h=void 0;class m{traceSocketEvent(u,p){f.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,u,p)}constructor(u,p=""){this.f=!0,this.debugLabel=p,this.socket=u,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=P=>{if(this.traceSocketEvent("error",{code:P?.code,message:P?.message}),P){if(P.code==="EPIPE")return;(0,R.$1)(P)}},this.socket.on("error",this.a),this.b=P=>{this.traceSocketEvent("close",{hadError:P}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(u){const p=P=>{this.traceSocketEvent("read",P),u(O.$te.wrap(P))};return this.socket.on("data",p),{dispose:()=>this.socket.off("data",p)}}onClose(u){const p=P=>{u({type:0,hadError:P,error:void 0})};return this.socket.on("close",p),{dispose:()=>this.socket.off("close",p)}}onEnd(u){const p=()=>{u()};return this.socket.on("end",p),{dispose:()=>this.socket.off("end",p)}}write(u){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",u),this.socket.write(u.buffer,p=>{if(p){if(p.code==="EPIPE")return;(0,R.$1)(p)}})}catch(p){if(p.code==="EPIPE")return;(0,R.$1)(p)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((u,p)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),u();return}const P=()=>{this.socket.off("close",P),this.socket.off("end",P),this.socket.off("error",P),this.socket.off("timeout",P),this.socket.off("drain",P),this.traceSocketEvent("nodeDrainEnd"),u()};this.socket.on("close",P),this.socket.on("end",P),this.socket.on("error",P),this.socket.on("timeout",P),this.socket.on("drain",P)})}}e.$8h=m;var y;(function(b){b[b.MinHeaderByteSize=2]="MinHeaderByteSize",b[b.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(y||(y={}));var l;(function(b){b[b.PeekHeader=1]="PeekHeader",b[b.ReadHeader=2]="ReadHeader",b[b.ReadBody=3]="ReadBody",b[b.Fin=4]="Fin"})(l||(l={}));class d extends g.$Tc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(u,p){this.socket.traceSocketEvent(u,p)}constructor(u,p,P,N){super(),this.f=this.B(new k.$6d),this.g=this.B(new k.$6d),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=u,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:p,inflateBytesLength:P?.byteLength||0,recordInflateBytes:N}),this.a=this.B(new $(this,p,P,N,this.f,(F,M)=>this.m(F,M))),this.B(this.a.onError(F=>{console.error(F),(0,R.$1)(F),this.g.fire({type:0,hadError:!0,error:F})})),this.b=new f.$3h,this.B(this.socket.onData(F=>this.n(F))),this.B(this.socket.onClose(async F=>{this.a.isProcessingReadQueue()&&await k.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(F)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(u){return this.f.event(u)}onClose(u){return this.g.event(u)}onEnd(u){return this.socket.onEnd(u)}write(u){let p=0;for(;p<u.byteLength;)this.a.writeMessage(u.slice(p,Math.min(p+262144,u.byteLength)),{compressed:!0,opcode:2}),p+=262144}m(u,{compressed:p,opcode:P}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",u);let N=2;u.byteLength<126?N+=0:u.byteLength<2**16?N+=2:N+=8;const F=O.$te.alloc(N),M=p?64:0,z=P&15;if(F.writeUInt8(128|M|z,0),u.byteLength<126)F.writeUInt8(u.byteLength,1);else if(u.byteLength<2**16){F.writeUInt8(126,1);let Z=1;F.writeUInt8(u.byteLength>>>8&255,++Z),F.writeUInt8(u.byteLength>>>0&255,++Z)}else{F.writeUInt8(127,1);let Z=1;F.writeUInt8(0,++Z),F.writeUInt8(0,++Z),F.writeUInt8(0,++Z),F.writeUInt8(0,++Z),F.writeUInt8(u.byteLength>>>24&255,++Z),F.writeUInt8(u.byteLength>>>16&255,++Z),F.writeUInt8(u.byteLength>>>8&255,++Z),F.writeUInt8(u.byteLength>>>0&255,++Z)}this.socket.write(O.$te.concat([F,u]))}end(){this.h=!0,this.socket.end()}n(u){if(u.byteLength!==0){for(this.b.acceptChunk(u);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const p=this.b.peek(this.j.readLen),P=p.readUInt8(0),N=(P&128)>>>7,F=(P&64)>>>6,M=P&15,z=p.readUInt8(1),Z=(z&128)>>>7,X=z&127;this.j.state=2,this.j.readLen=2+(Z?4:0)+(X===126?2:0)+(X===127?8:0),this.j.fin=N,this.j.firstFrameOfMessage&&(this.j.compressed=!!F),this.j.firstFrameOfMessage=!!N,this.j.mask=0,this.j.opcode=M,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const p=this.b.read(this.j.readLen),P=p.readUInt8(1),N=(P&128)>>>7;let F=P&127,M=1;F===126?F=p.readUInt8(++M)*2**8+p.readUInt8(++M):F===127&&(F=p.readUInt8(++M)*0+p.readUInt8(++M)*0+p.readUInt8(++M)*0+p.readUInt8(++M)*0+p.readUInt8(++M)*2**24+p.readUInt8(++M)*2**16+p.readUInt8(++M)*2**8+p.readUInt8(++M));let z=0;N&&(z=p.readUInt8(++M)*2**24+p.readUInt8(++M)*2**16+p.readUInt8(++M)*2**8+p.readUInt8(++M)),this.j.state=3,this.j.readLen=F,this.j.mask=z,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const p=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",p),i(p,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",p),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(p,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(p,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await k.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$9h=d;class $ extends g.$Tc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:O.$te.alloc(0)}constructor(u,p,P,N,F,M){super(),this.n=u,this.r=F,this.s=M,this.a=this.B(new k.$6d),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new k.$6d),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new k.$6d),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,p?(this.b=this.B(new c(this.n,N,P,{windowBits:15})),this.f=this.B(new v(this.n,{windowBits:15})),this.B(this.b.onError(z=>this.a.fire(z))),this.B(this.f.onError(z=>this.a.fire(z)))):(this.b=null,this.f=null)}writeMessage(u,p){this.g.push({data:u,options:p}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:u,options:p}=this.g.shift();if(this.f&&p.compressed){const P=await this.w(this.f,u);this.s(P,p)}else this.s(u,{...p,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(u,p){return new Promise((P,N)=>{u.write(p),u.flush(F=>P(F))})}acceptFrame(u,p,P){this.h.push({data:u,isCompressed:p,isLastFrameOfMessage:P}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const u=this.h.shift();if(this.b&&u.isCompressed){const p=await this.C(this.b,u.data,u.isLastFrameOfMessage);this.r.fire(p)}else this.r.fire(u.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(u,p,P){return new Promise((N,F)=>{u.write(p),P&&u.write(O.$te.fromByteArray([0,0,255,255])),u.flush(M=>N(M))})}}class c extends g.$Tc{get recordedInflateBytes(){return this.j?O.$te.concat(this.f):O.$te.alloc(0)}constructor(u,p,P,N){super(),this.h=u,this.j=p,this.a=this.B(new k.$6d),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,j.createInflateRaw)(N),this.b.on("error",F=>{this.h.traceSocketEvent("zlibInflateError",{message:F?.message,code:F?.code}),this.a.fire(F)}),this.b.on("data",F=>{this.h.traceSocketEvent("zlibInflateData",F),this.g.push(O.$te.wrap(F))}),P&&(this.h.traceSocketEvent("zlibInflateInitialWrite",P.buffer),this.b.write(P.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(u){this.j&&this.f.push(u.clone()),this.h.traceSocketEvent("zlibInflateWrite",u),this.b.write(u.buffer)}flush(u){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const p=O.$te.concat(this.g);this.g.length=0,u(p)})}}class v extends g.$Tc{constructor(u,p){super(),this.g=u,this.a=this.B(new k.$6d),this.onError=this.a.event,this.f=[],this.b=(0,j.createDeflateRaw)({windowBits:15}),this.b.on("error",P=>{this.g.traceSocketEvent("zlibDeflateError",{message:P?.message,code:P?.code}),this.a.fire(P)}),this.b.on("data",P=>{this.g.traceSocketEvent("zlibDeflateData",P),this.f.push(O.$te.wrap(P))})}write(u){this.g.traceSocketEvent("zlibDeflateWrite",u.buffer),this.b.write(u.buffer)}flush(u){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let p=O.$te.concat(this.f);this.f.length=0,p=p.slice(0,p.byteLength-4),u(p)})}}function i(b,u){if(u===0)return;const p=b.byteLength>>>2;for(let Z=0;Z<p;Z++){const X=b.readUInt32BE(Z*4);b.writeUInt32BE(X^u,Z*4)}const P=p*4,N=b.byteLength-P,F=u>>>24&255,M=u>>>16&255,z=u>>>8&255;N>=1&&b.writeUInt8(b.readUInt8(P)^F,P),N>=2&&b.writeUInt8(b.readUInt8(P+1)^M,P+1),N>=3&&b.writeUInt8(b.readUInt8(P+2)^z,P+2)}e.$0h=process.env.XDG_RUNTIME_DIR;const o={2:107,1:103};function n(){const b=(0,w.$Cg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${b}-sock`;const u=process.platform!=="darwin"&&e.$0h?e.$0h:(0,A.tmpdir)(),p=(0,C.$jc)(u,`vscode-ipc-${b}.sock`);return t(p),p}e.$$h=n;function s(b,u,p){const N=(0,I.createHash)("sha256").update(b).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${N}-${p}-${u}-sock`;const F=p.substr(0,4),M=u.substr(0,6);let z;return process.platform!=="darwin"&&e.$0h&&!process.env.VSCODE_PORTABLE?z=(0,C.$jc)(e.$0h,`vscode-${N}-${F}-${M}.sock`):z=(0,C.$jc)(b,`${F}-${M}.sock`),t(z),z}e.$_h=s;function t(b){const u=o[S.$u];typeof u=="number"&&b.length>=u&&console.warn(`WARNING: IPC handle "${b}" is longer than ${u} chars, try a shorter --user-data-dir`)}class r extends h.$Wh{static b(u){const p=k.Event.fromNodeEventEmitter(u,"connection");return k.Event.map(p,P=>({protocol:new f.$4h(new m(P,"ipc-server-connection")),onDidClientDisconnect:k.Event.once(k.Event.fromNodeEventEmitter(P,"close"))}))}constructor(u){super(r.b(u)),this.d=u}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$ai=r;function a(b){return new Promise((u,p)=>{const P=(0,L.createServer)();P.on("error",p),P.listen(b,()=>{P.removeListener("error",p),u(new r(P))})})}e.$bi=a;function E(b,u){return new Promise((p,P)=>{const N=(0,L.createConnection)(b,()=>{N.removeListener("error",P),p(f.$5h.fromSocket(new m(N,`ipc-client${u}`),u))});N.once("error",P)})}e.$ci=E}),define(le[267],he([0,1,64,123,214]),function(se,e,I,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zbc=void 0,e.$Zbc=new class{supports(j){return!0}connect({host:j,port:O},R,k,g){return new Promise((C,S)=>{const w=I.createConnection({host:j,port:O},()=>{w.removeListener("error",S),w.write((0,A.$ytb)(R,k,g));const h=f=>{f.toString().indexOf(`\r
\r
`)>=0&&(w.off("data",h),C(new L.$8h(w,g)))};w.on("data",h)});w.setNoDelay(!0),w.once("error",S)})}}}),define(le[268],he([0,1,64,37,133,123,6,2,5,21,8,24,216,104,106,78,14]),function(se,e,I,L,A,j,O,R,k,g,C,S,w,h,f,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wac=e.$Vac=e.$Uac=e.$Tac=void 0;async function l(i,o,n,s,t){let r;for(let a=3;a&&(r?.dispose(),r=await new d(i,o,n,s,t).waitForReady(),!(t&&A.$Fg[t]||!A.$Fg[r.tunnelLocalPort]));a--);return r}class d extends R.$Tc{constructor(o,n,s,t,r){super(),this.m=n,this.n=r,this.privacy=m.TunnelPrivacyId.Private,this.j=new Map,this.a=o,this.b=I.createServer(),this.c=new O.$fh,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=a=>this.r(a),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=t,this.tunnelRemoteHost=s}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(n=>{n()})}async waitForReady(){const o=this.n??this.tunnelRemotePort,n=(0,m.$Xv)(this.m)?"0.0.0.0":"127.0.0.1";let s=await(0,A.$Gg)(o,2,1e3,n),t=null;return this.b.listen(s,this.m),await this.c.wait(),t=this.b.address(),t||(s=0,this.b.listen(s,this.m),await this.c.wait(),t=this.b.address()),this.tunnelLocalPort=t.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${t.port}`,this}async r(o){o.pause();const n=(0,m.$Vv)(this.tunnelRemoteHost)||(0,m.$Xv)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,s=await(0,w.$wl)(this.a,n,this.tunnelRemotePort),t=s.getSocket(),r=s.readEntireBuffer();s.dispose(),r.byteLength>0&&o.write(r.buffer),o.on("end",()=>{o.localAddress&&this.j.delete(o.localAddress),t.end()}),o.on("close",()=>t.end()),o.on("error",()=>{o.localAddress&&this.j.delete(o.localAddress),t instanceof j.$8h?t.socket.destroy():t.end()}),t instanceof j.$8h?this.t(o,t):this.s(o,t),o.localAddress&&this.j.set(o.localAddress,()=>{o.end(),t.end()})}s(o,n){n.onClose(()=>o.destroy()),n.onEnd(()=>o.end()),n.onData(s=>o.write(s.buffer)),o.on("data",s=>n.write(y.$te.wrap(s))),o.resume()}t(o,n){const s=n.socket;s.on("end",()=>o.end()),s.on("close",()=>o.end()),s.on("error",()=>{o.destroy()}),s.pipe(o),o.pipe(s)}}e.$Tac=d;let $=class extends m.$1v{constructor(o,n,s,t,r){super(n,r),this.v=o,this.w=s,this.y=t}isPortPrivileged(o){return(0,m.$Yv)(o,this.m,k.OS,L.release())}t(o,n,s,t,r,a,E,b){const u=this.s(n,s);if(u)return++u.refcount,u.value;if((0,m.$Sv)(o))return this.u(o,n,s,r,a,E,b);{this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${n}:${s} on local port ${r}.`);const p={commit:this.y.commit,quality:this.y.quality,addressProvider:o,remoteSocketFactoryService:this.v,signService:this.w,logService:this.k,ipcLogger:null},P=l(p,t,n,s,r);return this.k.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.q(n,s,P),P}}};e.$Uac=$,e.$Uac=$=ye([K(0,h.$ql),K(1,C.$Aj),K(2,f.$tl),K(3,S.$Sj),K(4,g.$Mi)],$);let c=class extends ${constructor(o,n,s,t,r){super(o,n,s,t,r)}};e.$Vac=c,e.$Vac=c=ye([K(0,h.$ql),K(1,C.$Aj),K(2,f.$tl),K(3,S.$Sj),K(4,g.$Mi)],c);let v=class extends R.$Tc{constructor(o,n,s,t,r){super(),this.b=o,this.c=n,this.f=s,this.g=t,this.h=r,this.a=new Map}async openTunnel(o,n,s,t,r,a,E,b,u){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${s}:${t} on local port ${a}.`),!this.a.has(o)){const p=new c(this.b,this.c,this.g,this.f,this.h);this.B(p),this.a.set(o,p),p.onTunnelClosed(async()=>{(await p.tunnels).length===0&&(p.dispose(),this.a.delete(o))})}return this.a.get(o).openTunnel(n,s,t,r,a,E,b,u)}};e.$Wac=v,e.$Wac=v=ye([K(0,h.$ql),K(1,C.$Aj),K(2,S.$Sj),K(3,f.$tl),K(4,g.$Mi)],v)}),define(le[277],he([0,1,37,38,7,2,23,10,17,3,40,149,208,209,199,200,266,190,192,21,213,94,224,95,219,16,114,250,29,98,191,113,96,11,202,203,72,4,198,74,75,230,8,204,101,24,59,19,107,22,108,109,110,46,233,82,111,25,80,258,263,243,83,257,261,262,122,60,256,244,106,223,78,268,218,234,28,235,5,236,193,211,210,81,249,18,52,207,58,255,232,245,105,260,251,9,205,100,253,248,220,187,57,206,264,252,56,254,104,267,184,221,145,140]),function(se,e,I,L,A,j,O,R,k,g,C,S,w,h,f,m,y,l,d,$,c,v,i,o,n,s,t,r,a,E,b,u,p,P,N,F,M,z,Z,X,x,W,Q,H,V,te,re,ee,ae,G,U,D,T,B,q,Y,_,ie,J,ne,ce,fe,de,me,Ee,Re,Oe,Ne,ue,ge,be,Pe,Ce,Fe,De,ze,Te,qe,Ue,Ae,oe,$e,pe,we,ve,ke,Ie,Le,Ve,Be,Me,Ke,Ge,_e,tt,Et,St,$t,kt,Pt,Ct,Rt,It,Ot,Dt,jt,gt,At,mt,Lt,Nt,st,Tt,Ft){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class Mt extends j.$Tc{constructor(Se){super(),this.f=Se,this.a=this.B(new S.$5V(this)),this.b=void 0,this.c=this.B(new g.$6d),this.g()}g(){let Se=!1;const je=()=>{Se||(Se=!0,this.b?.fireOnWillShutdown(),this.dispose())};process.once("exit",je),(0,S.$6V)(process.parentPort,st.$9_b.exit,je)}async init(){const Se=await this.h();(0,ie.$_ob)(),Se.invokeFunction(je=>{const We=je.get(Q.$Aj),He=je.get(G.$Fl),Ye=je.get(ke.$gl);We.trace("sharedProcess configuration",JSON.stringify(this.f)),this.j(je),this.m(We),this.n(He,Ye),this.B(Ye.onDidChangeProfiles(()=>this.n(He,Ye))),this.r(He,We)}),this.B((0,j.$Qc)(Se.createInstance(w.$pbc,this.f.codeCachePath),Se.createInstance(h.$qbc),Se.createInstance(y.$tbc),Se.createInstance(m.$sbc),Se.createInstance(f.$rbc),Se.createInstance(tt.$Qbc),Se.createInstance(Ke.$Ibc)))}async h(){const Se=new X.$ei,je={_serviceBrand:void 0,...V.default};Se.set(te.$Sj,je);const We=new C.$1h(Je=>Je==="main"),He=new gt.$4ac(this.a,We);Se.set(gt.$3ac,He);const Ye=this.f.policiesData?new Le.$zac(this.f.policiesData,He.getChannel("policy")):new Ve.$2n;Se.set(Ve.$Zn,Ye);const Xe=new Nt.$Rm(this.f.args,je);Se.set(s.$oi,Xe);const et=new H.$Pr(void 0,this.f.logLevel,Xe.logsHome,this.f.loggers.map(Je=>({...Je,resource:R.URI.revive(Je.resource)})),He.getChannel("logger"));Se.set(Q.$Bj,et);const ot=this.B(et.createLogger("sharedprocess",{name:(0,Et.localize)(0,null)})),ht=this.B(new Q.$Ij(ot.getLevel())),Qe=this.B(new St.$PP(ot,[ht]));Se.set(Q.$Aj,Qe),this.b=this.B(new $t.$Sbc(Qe)),Se.set($t.$Rbc,this.b);const Ze=this.B(new N.$rq(Qe));Se.set(P.$Gk,Ze);const ut=this.B(new F.$Qq(Qe));Ze.registerProvider(O.Schemas.file,ut);const at=new qe.$es(Ze);Se.set(Te.$el,at);const xe=this.B(new Be.$WP(this.f.profiles.all,R.URI.revive(this.f.profiles.home).with({scheme:Xe.userRoamingDataHome.scheme}),He.getChannel("userDataProfiles")));Se.set(ke.$gl,xe);const ft=this.B(new Ae.$2ac(O.Schemas.file,this.B(new oe.$yP(He.getChannel(oe.$xP),{pathCaseSensitive:Ue.$k})),O.Schemas.vscodeUserData,xe,at,Qe));Ze.registerProvider(O.Schemas.vscodeUserData,ft);const it=this.B(new c.$po(xe.defaultProfile.settingsResource,Ze,Ye,Qe));Se.set($.$Mi,it);const dt=new At.$Ybc(void 0,{defaultProfile:xe.defaultProfile,currentProfile:xe.defaultProfile},He,Xe);Se.set(ee.$Jp,dt),this.B((0,j.$Rc)(()=>dt.flush())),await Promise.all([it.initialize(),dt.initialize()]);const bt=new Ct.$Ar(He.getChannel("request"));Se.set(re.$wp,bt),Se.set(l.$ubc,new M.$di(d.$vbc,void 0,!1)),Se.set(pe.$GF,new M.$di($e.$Hbc,void 0,!1));const pt=new Ot.$9ac(-1,He);Se.set(It.$N_b,pt),Se.set(o.$to,new M.$di(n.$5P,void 0,!0));const Ut=this.B(new ge.$wac(pt)),zt=new C.$1h(Je=>Ut.getActiveClientId().then(lt=>Je===lt));Se.set(p.$61b,new Rt.$Ubc(this.a.getChannel("extensionRecommendationNotification",zt)));let ct;const nt=[],yt=(0,B.$ap)(je,it);if((0,B.$8o)(je,Xe)){const Je=new D.$z0b(Qe,et,Xe,je);if(nt.push(Je),!(0,B.$9o)(je,Xe)&&je.aiConfig?.ariaKey){const lt=new Me.$DP(bt,yt,"monacoworkbench",null,je.aiConfig.ariaKey);this.B((0,j.$Rc)(()=>lt.flush())),nt.push(lt)}ct=new T.$Er({appenders:nt,commonProperties:(0,ae.$Yo)((0,I.release)(),(0,I.hostname)(),process.arch,je.commit,je.version,this.f.machineId,this.f.sqmId,yt),sendErrorTelemetry:!0,piiPaths:(0,B.$bp)(Xe)},it,je)}else{ct=B.$3o;const Je=B.$7o;nt.push(Je)}this.a.registerChannel("telemetryAppender",new U.$bac(nt)),Se.set(G.$Fl,ct);const Bt=new q.$wbc(it,ct,Qe,et,Xe,je);Se.set(G.$Gl,Bt),Se.set(Ie.$$p,new M.$di(Pt.$OP,void 0,!0)),Se.set(we.$cq,new M.$di(ve.$Aac,void 0,!0)),Se.set(E.$Up,new M.$di(E.$Vp,void 0,!0)),Se.set(u.$mq,new M.$di(u.$nq,void 0,!0)),Se.set(a.$Oo,new M.$di(r.$Sp,void 0,!0)),Se.set(a.$Vo,new M.$di(jt.$Xbc,void 0,!1)),Se.set(x.$wr,new M.$di(W.$yr,void 0,!1)),Se.set(v.$Ym,new M.$di(i.$ls,void 0,!1)),Se.set(J.$iHb,new M.$di(J.$jHb,void 0,!0)),Se.set(ie.$upb,new M.$di(fe.$FJb,void 0,!0)),Se.set(ie.$tpb,C.ProxyChannel.toService(this.a.getChannel("userDataSyncUtil",Je=>Je.ctx!=="main"))),Se.set(a.$Uo,new M.$di(t.$gHb,void 0,!1)),Se.set(_.$DJb,new M.$di(_.$EJb,void 0,!0)),Se.set(Y.$Cv,new M.$di(Y.$Dv)),Se.set(ie.$epb,new M.$di(Oe.$LIb,void 0,!0)),Se.set(ie.$fpb,new M.$di(Oe.$NIb,void 0,!0)),Se.set(de.$5ob,new M.$di(de.$7ob,void 0,!0)),Se.set(ie.$gpb,new M.$di(ne.$c$b,void 0,!1)),Se.set(ie.$ppb,new M.$di(me.$40b,void 0,!0)),Se.set(ie.$qpb,new M.$di(Ee.$h$b,void 0,!1)),Se.set(Ne.$UHb,new M.$di(ue.$Dbc,void 0,!0)),Se.set(ie.$rpb,new M.$di(_e.$Q$b,void 0,!0)),Se.set(be.$tl,new M.$di(Pe.$Yac,void 0,!1));const vt=new mt.$rl;return Se.set(mt.$ql,vt),vt.register(0,Lt.$Zbc),Se.set(Ce.$Rv,new M.$di(Fe.$Wac)),Se.set(De.$Ebc,new M.$di(ze.$Gbc)),Se.set(Ge.$Jbc,new M.$di(kt.$Tbc)),new Z.$Tq(Se)}j(Se){const je=new b.$Xp(Se.get(a.$Ro),()=>null);this.a.registerChannel("extensions",je);const We=C.ProxyChannel.fromService(Se.get(x.$wr),this.q);this.a.registerChannel("languagePacks",We);const He=C.ProxyChannel.fromService(Se.get(v.$Ym),this.q);this.a.registerChannel("diagnostics",He);const Ye=new b.$Zp(Se.get(a.$Vo));this.a.registerChannel("extensionTipsService",Ye);const Xe=C.ProxyChannel.fromService(Se.get(l.$ubc),this.q);this.a.registerChannel("checksum",Xe);const et=C.ProxyChannel.fromService(Se.get(pe.$GF),this.q);this.a.registerChannel("v8InspectProfiling",et);const ot=C.ProxyChannel.fromService(Se.get(de.$5ob),this.q);this.a.registerChannel("userDataSyncMachines",ot);const ht=C.ProxyChannel.fromService(Se.get(G.$Gl),this.q);this.a.registerChannel("customEndpointTelemetry",ht);const Qe=new ce.$xbc(Se.get(J.$iHb));this.a.registerChannel("userDataSyncAccount",Qe);const Ze=new ce.$zbc(Se.get(ie.$epb));this.a.registerChannel("userDataSyncStoreManagement",Ze);const ut=new Re.$Bbc(Se.get(ie.$qpb),Se.get(ke.$gl),Se.get(Q.$Aj));this.a.registerChannel("userDataSync",ut);const at=this.B(Se.get(z.$fi).createInstance(Dt.$Wbc));this.a.registerChannel("userDataAutoSync",C.ProxyChannel.fromService(at,this.q)),this.a.registerChannel("IUserDataSyncResourceProviderService",C.ProxyChannel.fromService(Se.get(ie.$rpb),this.q));const xe=C.ProxyChannel.fromService(Se.get(De.$Ebc),this.q);this.a.registerChannel(De.$Fbc,xe);const ft=C.ProxyChannel.fromService(Se.get(Ge.$Jbc),this.q);this.a.registerChannel("remoteTunnel",ft)}m(Se){process.on("uncaughtException",je=>(0,A.$1)(je)),process.on("unhandledRejection",je=>(0,A.$1)(je)),(0,A.setUnexpectedErrorHandler)(je=>{const We=(0,L.$4i)(je,!0);We&&Se.error(`[uncaught exception in sharedProcess]: ${We}`)})}n(Se,je){Se.publicLog2("profilesInfo",{count:je.profiles.length})}async r(Se,je){if(Ue.$k){const We=await(0,Tt.$Dg)(je.error.bind(je)),He=(0,Ft.$tV)();We&&Se.publicLog2("clientPlatformInfo",{platformId:We.id,platformVersionId:We.version_id,platformIdLike:We.id_like,desktopEnvironment:He})}}handledClientConnection(Se){if(Se.data!==st.$$_b.response)return!1;const je=(0,k.$Ob)(Se.ports);return je?(this.c.fire(je),!0):!1}}async function wt(rt){try{const Se=new Mt(rt);process.parentPort.postMessage(st.$9_b.ipcReady),await Se.init(),process.parentPort.postMessage(st.$9_b.initDone)}catch(Se){process.parentPort.postMessage({error:Se.toString()})}}e.main=wt;const qt=setTimeout(()=>{process.parentPort.postMessage({warning:"[SharedProcess] did not receive configuration within 30s..."})},3e4);process.parentPort.once("message",rt=>{clearTimeout(qt),wt(rt.data)})})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/d73fa8b14a6c873958d00a7d7ad13fcb540a052c/core/vs/code/node/sharedProcess/sharedProcessMain.js.map
