/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var K=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/observableInternal/autorun","vs/base/common/observableInternal/derived","vs/base/common/errors","vs/editor/common/tokens/lineTokens","vs/base/common/uri","vs/base/common/observable","vs/base/common/buffer","vs/editor/common/core/eolCounter","vs/editor/common/encodedTokenAttributes","vs/editor/common/core/lineRange","vs/editor/common/tokens/contiguousMultilineTokensBuilder","vs/base/common/path","vs/base/common/strings","vs/base/common/network","vs/base/common/resources","vs/base/common/async","vs/editor/common/languages/nullTokenize","vs/base/common/amd","vs/base/common/assert","vs/base/common/observableInternal/utils","vs/base/common/observableInternal/promise","vs/base/common/cancellation","vs/base/common/stream","vs/base/common/lazy","vs/base/common/symbols","vs/editor/common/model/fixedArray","vs/base/common/arrays","vs/editor/common/tokens/contiguousTokensEditing","vs/editor/common/tokens/contiguousMultilineTokens","vs/base/common/extpath","vs/amdX","vs/base/common/event","vs/editor/common/languages","vs/editor/common/model/textModelTokens","vs/base/common/stopwatch","vs/workbench/services/textMate/browser/tokenizationSupport/textMateTokenizationSupport","vs/workbench/services/textMate/browser/tokenizationSupport/tokenizationSupportWithLineLimit","vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateWorkerTokenizer","vs/workbench/services/textMate/common/TMScopeRegistry","vs/workbench/services/textMate/common/TMGrammarFactory","vs/editor/common/core/position","vs/base/common/types","vs/editor/common/core/offsetRange","vs/editor/common/model/mirrorTextModel","vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateTokenizationWorker.worker"],V=function(z){for(var e=[],P=0,S=z.length;P<S;P++)e[P]=K[z[P]];return e};define(K[24],V([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class P{static get(){const k=new Map,C=new Map,r=new Map,c=new Map;function i(u,n){u.has(n.detail)||u.set(n.detail,-n.timestamp)}function o(u,n){const t=u.get(n.detail);t&&(t>=0||u.set(n.detail,t+n.timestamp))}let m=[];typeof z=="function"&&typeof z.getStats=="function"&&(m=z.getStats().slice(0).sort((u,n)=>u.timestamp-n.timestamp));for(const u of m)switch(u.type){case 10:i(k,u);break;case 11:case 12:o(k,u);break;case 21:i(C,u);break;case 22:o(C,u);break;case 33:i(r,u);break;case 34:o(r,u);break;case 31:i(c,u);break;case 32:o(c,u);break}let l=0;r.forEach(u=>l+=u);function b(u){const n=[];return u.forEach((t,s)=>n.push([s,t])),n}return{amdLoad:b(k),amdInvoke:b(C),nodeRequire:b(r),nodeEval:b(c),nodeRequireTotal:l}}static toMarkdownTable(k,C){let r="";const c=[];return k.forEach((i,o)=>{c[o]=i.length}),C.forEach(i=>{i.forEach((o,m)=>{typeof o>"u"&&(o=i[m]="-");const l=o.toString().length;c[m]=Math.max(l,c[m])})}),k.forEach((i,o)=>{r+=`| ${i+" ".repeat(c[o]-i.toString().length)} `}),r+=`|
`,k.forEach((i,o)=>{r+=`| ${"-".repeat(c[o])} `}),r+=`|
`,C.forEach(i=>{i.forEach((o,m)=>{typeof o<"u"&&(r+=`| ${o+" ".repeat(c[m]-o.toString().length)} `)}),r+=`|
`}),r}}e.$U=P}),define(K[4],V([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7c=e.$6c=e.$5c=void 0;class P{constructor(n,t,s){this.owner=n,this.debugNameSource=t,this.referenceFn=s}getDebugName(n){return C(n,this)}}e.$5c=P;const S=new Map,k=new WeakMap;function C(u,n){const t=k.get(u);if(t)return t;const s=r(u,n);if(s){let d=S.get(s)??0;d++,S.set(s,d);const T=d===1?s:`${s}#${d}`;return k.set(u,T),T}}e.$6c=C;function r(u,n){const t=k.get(u);if(t)return t;const s=n.owner?m(n.owner)+".":"";let d;const T=n.debugNameSource;if(T!==void 0)if(typeof T=="function"){if(d=T(),d!==void 0)return s+d}else return s+T;const L=n.referenceFn;if(L!==void 0&&(d=b(L),d!==void 0))return s+d;if(n.owner!==void 0){const I=c(n.owner,u);if(I!==void 0)return s+I}}function c(u,n){for(const t in u)if(u[t]===n)return t}const i=new Map,o=new WeakMap;function m(u){const n=o.get(u);if(n)return n;const t=l(u);let s=i.get(t)??0;s++,i.set(t,s);const d=s===1?t:`${t}#${s}`;return o.set(u,d),d}function l(u){const n=u.constructor;return n?n.name:"Object"}function b(u){const n=u.toString(),s=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(n);return(s?s[1]:void 0)?.trim()}e.$7c=b}),define(K[5],V([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zd=e.$yd=e.$xd=void 0;let P;function S(t){P=t}e.$xd=S;function k(){return P}e.$yd=k;class C{constructor(){this.a=0,this.d=new WeakMap}b(s){return r([c(u("|  ",this.a)),s])}c(s){return s.hadValue?s.didChange?[c(" "),o(m(s.oldValue,70),{color:"red",strikeThrough:!0}),c(" "),o(m(s.newValue,60),{color:"green"})]:[c(" (unchanged)")]:[c(" "),o(m(s.newValue,60),{color:"green"}),c(" (initial)")]}handleObservableChanged(s,d){console.log(...this.b([i("observable value changed"),o(s.debugName,{color:"BlueViolet"}),...this.c(d)]))}formatChanges(s){if(s.size!==0)return o(" (changed deps: "+[...s].map(d=>d.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(s){const d=s.handleChange;this.d.set(s,new Set),s.handleChange=(T,L)=>(this.d.get(s).add(T),d.apply(s,[T,L]))}handleDerivedRecomputed(s,d){const T=this.d.get(s);console.log(...this.b([i("derived recomputed"),o(s.debugName,{color:"BlueViolet"}),...this.c(d),this.formatChanges(T),{data:[{fn:s._computeFn}]}])),T.clear()}handleFromEventObservableTriggered(s,d){console.log(...this.b([i("observable from event triggered"),o(s.debugName,{color:"BlueViolet"}),...this.c(d),{data:[{fn:s._getValue}]}]))}handleAutorunCreated(s){const d=s.handleChange;this.d.set(s,new Set),s.handleChange=(T,L)=>(this.d.get(s).add(T),d.apply(s,[T,L]))}handleAutorunTriggered(s){const d=this.d.get(s);console.log(...this.b([i("autorun"),o(s.debugName,{color:"BlueViolet"}),this.formatChanges(d),{data:[{fn:s._runFn}]}])),d.clear(),this.a++}handleAutorunFinished(s){this.a--}handleBeginTransaction(s){let d=s.getDebugName();d===void 0&&(d=""),console.log(...this.b([i("transaction"),o(d,{color:"BlueViolet"}),{data:[{fn:s._fn}]}])),this.a++}handleEndTransaction(){this.a--}}e.$zd=C;function r(t){const s=new Array,d=[];let T="";function L(E){if("length"in E)for(const a of E)a&&L(a);else"text"in E?(T+=`%c${E.text}`,s.push(E.style),E.data&&d.push(...E.data)):"data"in E&&d.push(...E.data)}L(t);const I=[T,...s];return I.push(...d),I}function c(t){return o(t,{color:"black"})}function i(t){return o(n(`${t}: `,10),{color:"black",bold:!0})}function o(t,s={color:"black"}){function d(L){return Object.entries(L).reduce((I,[E,a])=>`${I}${E}:${a};`,"")}const T={color:s.color};return s.strikeThrough&&(T["text-decoration"]="line-through"),s.bold&&(T["font-weight"]="bold"),{text:t,style:d(T)}}function m(t,s){switch(typeof t){case"number":return""+t;case"string":return t.length+2<=s?`"${t}"`:`"${t.substr(0,s-7)}"+...`;case"boolean":return t?"true":"false";case"undefined":return"undefined";case"object":return t===null?"null":Array.isArray(t)?l(t,s):b(t,s);case"symbol":return t.toString();case"function":return`[[Function${t.name?" "+t.name:""}]]`;default:return""+t}}function l(t,s){let d="[ ",T=!0;for(const L of t){if(T||(d+=", "),d.length-5>s){d+="...";break}T=!1,d+=`${m(L,s-d.length)}`}return d+=" ]",d}function b(t,s){let d="{ ",T=!0;for(const[L,I]of Object.entries(t)){if(T||(d+=", "),d.length-5>s){d+="...";break}T=!1,d+=`${L}: ${m(I,s-d.length)}`}return d+=" }",d}function u(t,s){let d="";for(let T=1;T<=s;T++)d+=t;return d}function n(t,s){for(;t.length<s;)t+=" ";return t}}),define(K[7],V([0,1,25,2,4,5]),function(z,e,P,S,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hd=e.$gd=e.$fd=e.$ed=e.$dd=e.$cd=e.$bd=void 0;function r(n){return new u(new k.$5c(void 0,void 0,n),n,void 0,void 0)}e.$bd=r;function c(n,t){return new u(new k.$5c(n.owner,n.debugName,n.debugReferenceFn??t),t,void 0,void 0)}e.$cd=c;function i(n,t){return new u(new k.$5c(n.owner,n.debugName,n.debugReferenceFn??t),t,n.createEmptyChangeSummary,n.handleChange)}e.$dd=i;function o(n,t){const s=new S.$Sc,d=i({owner:n.owner,debugName:n.debugName,debugReferenceFn:n.debugReferenceFn,createEmptyChangeSummary:n.createEmptyChangeSummary,handleChange:n.handleChange},(T,L)=>{s.clear(),t(T,L,s)});return(0,S.$Rc)(()=>{d.dispose(),s.dispose()})}e.$ed=o;function m(n){const t=new S.$Sc,s=c({owner:void 0,debugName:void 0,debugReferenceFn:n},d=>{t.clear(),n(d,t)});return(0,S.$Rc)(()=>{s.dispose(),t.dispose()})}e.$fd=m;function l(n,t){let s;return c({debugReferenceFn:t},d=>{const T=n.read(d),L=s;s=T,t({lastValue:L,newValue:T})})}e.$gd=l;var b;(function(n){n[n.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",n[n.stale=2]="stale",n[n.upToDate=3]="upToDate"})(b||(b={}));class u{get debugName(){return this.h.getDebugName(this)??"(anonymous)"}constructor(t,s,d,T){this.h=t,this._runFn=s,this.i=d,this.j=T,this.a=2,this.b=0,this.c=!1,this.e=new Set,this.f=new Set,this.g=this.i?.(),(0,C.$yd)()?.handleAutorunCreated(this),this.k(),(0,S.$Kc)(this)}dispose(){this.c=!0;for(const t of this.e)t.removeObserver(this);this.e.clear(),(0,S.$Lc)(this)}k(){if(this.a===3)return;const t=this.f;this.f=this.e,this.e=t,this.a=3;const s=this.c;try{if(!s){(0,C.$yd)()?.handleAutorunTriggered(this);const d=this.g;this.g=this.i?.(),this._runFn(this,d)}}finally{s||(0,C.$yd)()?.handleAutorunFinished(this);for(const d of this.f)d.removeObserver(this);this.f.clear()}}toString(){return`Autorun<${this.debugName}>`}beginUpdate(){this.a===3&&(this.a=1),this.b++}endUpdate(){if(this.b===1)do{if(this.a===1){this.a=3;for(const t of this.e)if(t.reportChanges(),this.a===2)break}this.k()}while(this.a!==3);this.b--,(0,P.$_c)(()=>this.b>=0)}handlePossibleChange(t){this.a===3&&this.e.has(t)&&!this.f.has(t)&&(this.a=1)}handleChange(t,s){this.e.has(t)&&!this.f.has(t)&&(!this.j||this.j({changedObservable:t,change:s,didChange:T=>T===t},this.g))&&(this.a=2)}readObservable(t){if(this.c)return t.get();t.addObserver(this);const s=t.get();return this.e.add(t),this.f.delete(t),s}}e.$hd=u,function(n){n.Observer=u}(r||(e.$bd=r={}))}),define(K[6],V([0,1,4,5]),function(z,e,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ud=e.$Td=e.$Sd=e.$Rd=e.$Qd=e.$Pd=e.$Od=e.$Nd=e.$Md=e.$Ld=e.$Kd=e.$Jd=e.$Id=e.$Hd=void 0;let k;function C(a){k=a}e.$Hd=C;let r;function c(a){r=a}e.$Id=c;let i;function o(a){i=a}e.$Jd=o;class m{get TChange(){return null}reportChanges(){this.get()}read($){return $?$.readObservable(this):this.get()}map($,w){const D=w===void 0?void 0:$,q=w===void 0?$:w;return i({owner:D,debugName:()=>{const f=(0,P.$7c)(q);if(f!==void 0)return f;const N=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(q.toString());if(N)return`${this.debugName}.${N[2]}`;if(!D)return`${this.debugName} (mapped)`}},f=>q(this.read(f),f))}recomputeInitiallyAndOnChange($,w){return $.add(k(this,w)),this}keepObserved($){return $.add(r(this)),this}}e.$Kd=m;class l extends m{constructor(){super(...arguments),this.c=new Set}addObserver($){const w=this.c.size;this.c.add($),w===0&&this.f()}removeObserver($){this.c.delete($)&&this.c.size===0&&this.g()}f(){}g(){}}e.$Ld=l;function b(a,$){const w=new d(a,$);try{a(w)}finally{w.finish()}}e.$Md=b;let u;function n(a){if(u)a(u);else{const $=new d(a,void 0);u=$;try{a($)}finally{$.finish(),u=void 0}}}e.$Nd=n;async function t(a,$){const w=new d(a,$);try{await a(w)}finally{w.finish()}}e.$Od=t;function s(a,$,w){a?$(a):b($,w)}e.$Pd=s;class d{constructor($,w){this._fn=$,this.b=w,this.a=[],(0,S.$yd)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():(0,P.$7c)(this._fn)}updateObserver($,w){this.a.push({observer:$,observable:w}),$.beginUpdate(w)}finish(){const $=this.a;for(let w=0;w<$.length;w++){const{observer:D,observable:q}=$[w];D.endUpdate(q)}this.a=null,(0,S.$yd)()?.handleEndTransaction()}}e.$Qd=d;function T(a,$){return typeof a=="string"?new L(void 0,a,$):new L(a,void 0,$)}e.$Rd=T;class L extends l{get debugName(){return new P.$5c(this.b,this.d,void 0).getDebugName(this)??"ObservableValue"}constructor($,w,D){super(),this.b=$,this.d=w,this.a=D}get(){return this.a}set($,w,D){if(this.a===$)return;let q;w||(w=q=new d(()=>{},()=>`Setting ${this.debugName}`));try{const f=this.a;this.e($),(0,S.$yd)()?.handleObservableChanged(this,{oldValue:f,newValue:$,change:D,didChange:!0,hadValue:!0});for(const v of this.c)w.updateObserver(v,this),v.handleChange(this,D)}finally{q&&q.finish()}}toString(){return`${this.debugName}: ${this.a}`}e($){this.a=$}}e.$Sd=L;function I(a,$){return typeof a=="string"?new E(void 0,a,$):new E(a,void 0,$)}e.$Td=I;class E extends L{e($){this.a!==$&&(this.a&&this.a.dispose(),this.a=$)}dispose(){this.a?.dispose()}}e.$Ud=E}),define(K[8],V([0,1,25,2,6,4,5]),function(z,e,P,S,k,C,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gd=e.$Fd=e.$Ed=e.$Dd=e.$Cd=e.$Bd=e.$Ad=void 0;const c=(t,s)=>t===s;e.$Ad=c;function i(t,s){return s!==void 0?new n(new C.$5c(t,void 0,s),s,void 0,void 0,void 0,e.$Ad):new n(new C.$5c(void 0,void 0,t),t,void 0,void 0,void 0,e.$Ad)}e.$Bd=i;function o(t,s){return new n(new C.$5c(t.owner,t.debugName,t.debugReferenceFn),s,void 0,void 0,t.onLastObserverRemoved,t.equalityComparer??e.$Ad)}e.$Cd=o,(0,k.$Jd)(o);function m(t,s){return new n(new C.$5c(t.owner,t.debugName,void 0),s,t.createEmptyChangeSummary,t.handleChange,void 0,t.equalityComparer??e.$Ad)}e.$Dd=m;function l(t,s){let d,T;s===void 0?(d=t,T=void 0):(T=t,d=s);const L=new S.$Sc;return new n(new C.$5c(T,void 0,d),I=>(L.clear(),d(I,L)),void 0,void 0,()=>L.dispose(),e.$Ad)}e.$Ed=l;function b(t,s){let d,T;s===void 0?(d=t,T=void 0):(T=t,d=s);const L=new S.$Sc;return new n(new C.$5c(T,void 0,d),I=>{L.clear();const E=d(I);return E&&L.add(E),E},void 0,void 0,()=>L.dispose(),e.$Ad)}e.$Fd=b;var u;(function(t){t[t.initial=0]="initial",t[t.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",t[t.stale=2]="stale",t[t.upToDate=3]="upToDate"})(u||(u={}));class n extends k.$Ld{get debugName(){return this.n.getDebugName(this)??"(anonymous)"}constructor(s,d,T,L,I=void 0,E){super(),this.n=s,this._computeFn=d,this.p=T,this.q=L,this.s=I,this.t=E,this.e=0,this.h=void 0,this.j=0,this.k=new Set,this.l=new Set,this.m=void 0,this.m=this.p?.(),(0,r.$yd)()?.handleDerivedCreated(this)}g(){this.e=0,this.h=void 0;for(const s of this.k)s.removeObserver(this);this.k.clear(),this.s?.()}get(){if(this.c.size===0){const s=this._computeFn(this,this.p?.());return this.g(),s}else{do{if(this.e===1){for(const s of this.k)if(s.reportChanges(),this.e===2)break}this.e===1&&(this.e=3),this.v()}while(this.e!==3);return this.h}}v(){if(this.e===3)return;const s=this.l;this.l=this.k,this.k=s;const d=this.e!==0,T=this.h;this.e=3;const L=this.m;this.m=this.p?.();try{this.h=this._computeFn(this,L)}finally{for(const E of this.l)E.removeObserver(this);this.l.clear()}const I=d&&!this.t(T,this.h);if((0,r.$yd)()?.handleDerivedRecomputed(this,{oldValue:T,newValue:this.h,change:void 0,didChange:I,hadValue:d}),I)for(const E of this.c)E.handleChange(this,void 0)}toString(){return`LazyDerived<${this.debugName}>`}beginUpdate(s){this.j++;const d=this.j===1;if(this.e===3&&(this.e=1,!d))for(const T of this.c)T.handlePossibleChange(this);if(d)for(const T of this.c)T.beginUpdate(this)}endUpdate(s){if(this.j--,this.j===0){const d=[...this.c];for(const T of d)T.endUpdate(this)}(0,P.$_c)(()=>this.j>=0)}handlePossibleChange(s){if(this.e===3&&this.k.has(s)&&!this.l.has(s)){this.e=1;for(const d of this.c)d.handlePossibleChange(this)}}handleChange(s,d){if(this.k.has(s)&&!this.l.has(s)){const T=this.q?this.q({changedObservable:s,change:d,didChange:I=>I===s},this.m):!0,L=this.e===3;if(T&&(this.e===1||L)&&(this.e=2,L))for(const I of this.c)I.handlePossibleChange(this)}}readObservable(s){s.addObserver(this);const d=s.get();return this.k.add(s),this.l.delete(s),d}addObserver(s){const d=!this.c.has(s)&&this.j>0;super.addObserver(s),d&&s.beginUpdate(this)}removeObserver(s){const d=this.c.has(s)&&this.j>0;super.removeObserver(s),d&&s.endUpdate(this)}}e.$Gd=n}),define(K[26],V([0,1,2,7,6,4,8,5]),function(z,e,P,S,k,C,r,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wd=e.$vd=e.$ud=e.$td=e.$sd=e.$rd=e.$qd=e.$pd=e.$od=e.$nd=e.$md=e.$ld=e.$kd=e.$jd=e.$id=void 0;function i(f){return new o(f)}e.$id=i;class o extends k.$Kd{constructor(v){super(),this.a=v}get debugName(){return this.toString()}get(){return this.a}addObserver(v){}removeObserver(v){}toString(){return`Const: ${this.a}`}}function m(f){const v=(0,k.$Rd)("promiseValue",{});return f.then(N=>{v.set({value:N},void 0)}),v}e.$jd=m;function l(f,v){return new b(f,v)}e.$kd=l;class b extends k.$Ld{constructor(v,N){super(),this.h=v,this._getValue=N,this.b=!1,this.l=U=>{const O=this._getValue(U),g=this.a,j=!this.b||g!==O;let B=!1;j&&(this.a=O,this.b&&(B=!0,(0,k.$Pd)(b.globalTransaction,J=>{(0,c.$yd)()?.handleFromEventObservableTriggered(this,{oldValue:g,newValue:O,change:void 0,didChange:j,hadValue:this.b});for(const H of this.c)J.updateObserver(H,this),H.handleChange(this,void 0)},()=>{const J=this.j();return"Event fired"+(J?`: ${J}`:"")})),this.b=!0),B||(0,c.$yd)()?.handleFromEventObservableTriggered(this,{oldValue:g,newValue:O,change:void 0,didChange:j,hadValue:this.b})}}j(){return(0,C.$7c)(this._getValue)}get debugName(){const v=this.j();return"From Event"+(v?`: ${v}`:"")}f(){this.e=this.h(this.l)}g(){this.e.dispose(),this.e=void 0,this.b=!1,this.a=void 0}get(){return this.e?(this.b||this.l(void 0),this.a):this._getValue(void 0)}}e.$ld=b,function(f){f.Observer=b;function v(N,U){let O=!1;b.globalTransaction===void 0&&(b.globalTransaction=N,O=!0);try{U()}finally{O&&(b.globalTransaction=void 0)}}f.batchEventsGlobally=v}(l||(e.$kd=l={}));function u(f,v){return new n(f,v)}e.$md=u;class n extends k.$Ld{constructor(v,N){super(),this.debugName=v,this.b=N,this.h=()=>{(0,k.$Md)(U=>{for(const O of this.c)U.updateObserver(O,this),O.handleChange(this,void 0)},()=>this.debugName)}}f(){this.a=this.b(this.h)}g(){this.a.dispose(),this.a=void 0}get(){}}function t(f){return typeof f=="string"?new s(f):new s(void 0,f)}e.$nd=t;class s extends k.$Ld{get debugName(){return new C.$5c(this.b,this.a,void 0).getDebugName(this)??"Observable Signal"}constructor(v,N){super(),this.a=v,this.b=N}trigger(v,N){if(!v){(0,k.$Md)(U=>{this.trigger(U,N)},()=>`Trigger signal ${this.debugName}`);return}for(const U of this.c)v.updateObserver(U,this),U.handleChange(this,N)}get(){}}function d(f,v,N){const U=(0,k.$Rd)("debounced",void 0);let O;return N.add((0,S.$bd)(g=>{const j=f.read(g);O&&clearTimeout(O),O=setTimeout(()=>{(0,k.$Md)(B=>{U.set(j,B)})},v)})),U}e.$od=d;function T(f,v){let N=!1,U,O;return l(g=>{const j=(0,S.$bd)(B=>{const J=f.read(B);N?(O&&clearTimeout(O),O=setTimeout(()=>{U=J,g()},v)):(N=!0,U=J)});return{dispose(){j.dispose(),N=!1,U=void 0}}},()=>N?U:f.get())}e.$pd=T;function L(f,v,N){const U=(0,k.$Rd)("triggeredRecently",!1);let O;return N.add(f(()=>{U.set(!0,void 0),O&&clearTimeout(O),O=setTimeout(()=>{U.set(!1,void 0)},v)})),U}e.$qd=L;function I(f){const v=new a(!1,void 0);return f.addObserver(v),(0,P.$Rc)(()=>{f.removeObserver(v)})}e.$rd=I,(0,k.$Id)(I);function E(f,v){const N=new a(!0,v);return f.addObserver(N),v?v(f.get()):f.reportChanges(),(0,P.$Rc)(()=>{f.removeObserver(N)})}e.$sd=E,(0,k.$Hd)(E);class a{constructor(v,N){this.b=v,this.c=N,this.a=0}beginUpdate(v){this.a++}endUpdate(v){this.a--,this.a===0&&this.b&&(this.c?this.c(v.get()):v.reportChanges())}handlePossibleChange(v){}handleChange(v,N){}}e.$td=a;function $(f){let v;return(0,r.$Bd)(U=>(v=f(U,v),v))}e.$ud=$;function w(f,v){let N;const U=(0,k.$Rd)("derivedObservableWithWritableCache.counter",0),O=(0,r.$Bd)(f,g=>(U.read(g),N=v(g,N),N));return Object.assign(O,{clearCache:g=>{N=void 0,U.set(U.get()+1,g)}})}e.$vd=w;function D(f,v,N,U){let O=new q(N,U);return(0,r.$Cd)({debugReferenceFn:N,owner:f,onLastObserverRemoved:()=>{O.dispose(),O=new q(N)}},j=>(O.setItems(v.read(j)),O.getItems()))}e.$wd=D;class q{constructor(v,N){this.c=v,this.e=N,this.a=new Map,this.b=[]}dispose(){this.a.forEach(v=>v.store.dispose()),this.a.clear()}setItems(v){const N=[],U=new Set(this.a.keys());for(const O of v){const g=this.e?this.e(O):O;let j=this.a.get(g);if(j)U.delete(g);else{const B=new P.$Sc;j={out:this.c(O,B),store:B},this.a.set(g,j)}N.push(j.out)}for(const O of U)this.a.get(O).store.dispose(),this.a.delete(O);this.b=N}getItems(){return this.b}}}),define(K[27],V([0,1,7,6,8,28,4]),function(z,e,P,S,k,C,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1d=e.$Zd=e.$Yd=e.$Xd=e.$Wd=e.$Vd=void 0;class c{get cachedValue(){return this.a}constructor(n){this.b=n,this.a=(0,S.$Rd)(this,void 0)}getValue(){let n=this.a.get();return n||(n=this.b(),this.a.set(n,void 0)),n}}e.$Vd=c;class i{constructor(n){this.a=(0,S.$Rd)(this,void 0),this.promiseResult=this.a,this.promise=n.then(t=>((0,S.$Md)(s=>{this.a.set(new o(t,void 0),s)}),t),t=>{throw(0,S.$Md)(s=>{this.a.set(new o(void 0,t),s)}),t})}}e.$Wd=i;class o{constructor(n,t){this.data=n,this.error=t}getDataOrThrow(){if(this.error)throw this.error;return this.data}}e.$Xd=o;class m{constructor(n){this.b=n,this.a=new c(()=>new i(this.b())),this.cachedPromiseResult=(0,k.$Bd)(this,t=>this.a.cachedValue.read(t)?.promiseResult.read(t))}getPromise(){return this.a.getValue().promise}}e.$Yd=m;function l(u,n,t){return new Promise((s,d)=>{let T=!0,L=!1;const I=u.map(a=>({isFinished:n(a),error:t?t(a):!1,state:a})),E=(0,P.$bd)(a=>{const{isFinished:$,error:w,state:D}=I.read(a);($||w)&&(T?L=!0:E.dispose(),w?d(w===!0?D:w):s(D))});T=!1,L&&E.dispose()})}e.$Zd=l;function b(u,n){let t,s;n===void 0?(t=u,s=void 0):(s=u,t=n);let d;return new k.$Gd(new r.$5c(s,void 0,t),T=>(d&&d.dispose(!0),d=new C.$de,t(T,d.token)),void 0,void 0,()=>d?.dispose(),k.$Ad)}e.$1d=b}),define(K[12],V([0,1,6,8,7,26,27,5]),function(z,e,P,S,k,C,r,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.derivedWithCancellationToken=e.waitForState=e.PromiseResult=e.ObservablePromise=e.ObservableLazyPromise=e.ObservableLazy=e.wasEventTriggeredRecently=e.observableSignalFromEvent=e.observableSignal=e.observableFromPromise=e.observableFromEvent=e.recomputeInitiallyAndOnChange=e.keepObserved=e.derivedObservableWithWritableCache=e.derivedObservableWithCache=e.debouncedObservable=e.constObservable=e.autorunWithStoreHandleChanges=e.autorunOpts=e.autorunWithStore=e.autorunHandleChanges=e.autorunDelta=e.autorun=e.derivedWithStore=e.derivedHandleChanges=e.derivedOpts=e.derived=e.subtransaction=e.transaction=e.disposableObservableValue=e.observableValue=void 0,Object.defineProperty(e,"observableValue",{enumerable:!0,get:function(){return P.$Rd}}),Object.defineProperty(e,"disposableObservableValue",{enumerable:!0,get:function(){return P.$Td}}),Object.defineProperty(e,"transaction",{enumerable:!0,get:function(){return P.$Md}}),Object.defineProperty(e,"subtransaction",{enumerable:!0,get:function(){return P.$Pd}}),Object.defineProperty(e,"derived",{enumerable:!0,get:function(){return S.$Bd}}),Object.defineProperty(e,"derivedOpts",{enumerable:!0,get:function(){return S.$Cd}}),Object.defineProperty(e,"derivedHandleChanges",{enumerable:!0,get:function(){return S.$Dd}}),Object.defineProperty(e,"derivedWithStore",{enumerable:!0,get:function(){return S.$Ed}}),Object.defineProperty(e,"autorun",{enumerable:!0,get:function(){return k.$bd}}),Object.defineProperty(e,"autorunDelta",{enumerable:!0,get:function(){return k.$gd}}),Object.defineProperty(e,"autorunHandleChanges",{enumerable:!0,get:function(){return k.$dd}}),Object.defineProperty(e,"autorunWithStore",{enumerable:!0,get:function(){return k.$fd}}),Object.defineProperty(e,"autorunOpts",{enumerable:!0,get:function(){return k.$cd}}),Object.defineProperty(e,"autorunWithStoreHandleChanges",{enumerable:!0,get:function(){return k.$ed}}),Object.defineProperty(e,"constObservable",{enumerable:!0,get:function(){return C.$id}}),Object.defineProperty(e,"debouncedObservable",{enumerable:!0,get:function(){return C.$od}}),Object.defineProperty(e,"derivedObservableWithCache",{enumerable:!0,get:function(){return C.$ud}}),Object.defineProperty(e,"derivedObservableWithWritableCache",{enumerable:!0,get:function(){return C.$vd}}),Object.defineProperty(e,"keepObserved",{enumerable:!0,get:function(){return C.$rd}}),Object.defineProperty(e,"recomputeInitiallyAndOnChange",{enumerable:!0,get:function(){return C.$sd}}),Object.defineProperty(e,"observableFromEvent",{enumerable:!0,get:function(){return C.$kd}}),Object.defineProperty(e,"observableFromPromise",{enumerable:!0,get:function(){return C.$jd}}),Object.defineProperty(e,"observableSignal",{enumerable:!0,get:function(){return C.$nd}}),Object.defineProperty(e,"observableSignalFromEvent",{enumerable:!0,get:function(){return C.$md}}),Object.defineProperty(e,"wasEventTriggeredRecently",{enumerable:!0,get:function(){return C.$qd}}),Object.defineProperty(e,"ObservableLazy",{enumerable:!0,get:function(){return r.$Vd}}),Object.defineProperty(e,"ObservableLazyPromise",{enumerable:!0,get:function(){return r.$Yd}}),Object.defineProperty(e,"ObservablePromise",{enumerable:!0,get:function(){return r.$Wd}}),Object.defineProperty(e,"PromiseResult",{enumerable:!0,get:function(){return r.$Xd}}),Object.defineProperty(e,"waitForState",{enumerable:!0,get:function(){return r.$Zd}}),Object.defineProperty(e,"derivedWithCancellationToken",{enumerable:!0,get:function(){return r.$1d}}),!1&&(0,c.$xd)(new c.$zd)}),define(K[29],V([0,1,9,2]),function(z,e,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=void 0;function k(I){const E=I;return E?typeof E.read=="function":!1}e.$ee=k;function C(I){const E=I;return E?[E.on,E.pause,E.resume,E.destroy].every(a=>typeof a=="function"):!1}e.$fe=C;function r(I){const E=I;return E?C(E.stream)&&Array.isArray(E.buffer)&&typeof E.ended=="boolean":!1}e.$ge=r;function c(I,E){return new i(I,E)}e.$he=c;class i{constructor(E,a){this.e=E,this.f=a,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(E){if(!this.a.destroyed){if(this.a.flowing)this.g(E);else if(this.b.data.push(E),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(a=>this.d.push(a))}}error(E){this.a.destroyed||(this.a.flowing?this.h(E):this.b.error.push(E))}end(E){this.a.destroyed||(typeof E<"u"&&this.write(E),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(E){this.c.data.slice(0).forEach(a=>a(E))}h(E){this.c.error.length===0?(0,P.$1)(E):this.c.error.slice(0).forEach(a=>a(E))}i(){this.c.end.slice(0).forEach(E=>E())}on(E,a){if(!this.a.destroyed)switch(E){case"data":this.c.data.push(a),this.resume();break;case"end":this.c.end.push(a),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(a),this.a.flowing&&this.k();break}}removeListener(E,a){if(this.a.destroyed)return;let $;switch(E){case"data":$=this.c.data;break;case"end":$=this.c.end;break;case"error":$=this.c.error;break}if($){const w=$.indexOf(a);w>=0&&$.splice(w,1)}}j(){if(this.b.data.length>0){const E=this.e(this.b.data);this.g(E),this.b.data.length=0;const a=[...this.d];this.d.length=0,a.forEach($=>$())}}k(){if(this.c.error.length>0){for(const E of this.b.error)this.h(E);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function o(I,E){const a=[];let $;for(;($=I.read())!==null;)a.push($);return E(a)}e.$ie=o;function m(I,E,a){const $=[];let w;for(;(w=I.read())!==null&&$.length<a;)$.push(w);return w===null&&$.length>0?E($):{read:()=>{if($.length>0)return $.shift();if(typeof w<"u"){const D=w;return w=void 0,D}return I.read()}}}e.$je=m;function l(I,E){return new Promise((a,$)=>{const w=[];b(I,{onData:D=>{E&&w.push(D)},onError:D=>{E?$(D):a(void 0)},onEnd:()=>{a(E?E(w):void 0)}})})}e.$ke=l;function b(I,E,a){I.on("error",$=>{a?.isCancellationRequested||E.onError($)}),I.on("end",()=>{a?.isCancellationRequested||E.onEnd()}),I.on("data",$=>{a?.isCancellationRequested||E.onData($)})}e.$le=b;function u(I,E){return new Promise((a,$)=>{const w=new S.$Sc,D=[],q=N=>{if(D.push(N),D.length>E)return w.dispose(),I.pause(),a({stream:I,buffer:D,ended:!1})},f=N=>(w.dispose(),$(N)),v=()=>(w.dispose(),a({stream:I,buffer:D,ended:!0}));w.add((0,S.$Rc)(()=>I.removeListener("error",f))),I.on("error",f),w.add((0,S.$Rc)(()=>I.removeListener("end",v))),I.on("end",v),w.add((0,S.$Rc)(()=>I.removeListener("data",q))),I.on("data",q)})}e.$me=u;function n(I,E){const a=c(E);return a.end(I),a}e.$ne=n;function t(){const I=c(()=>{throw new Error("not supported")});return I.end(),I}e.$oe=t;function s(I){let E=!1;return{read:()=>E?null:(E=!0,I)}}e.$pe=s;function d(I,E,a){const $=c(a);return b(I,{onData:w=>$.write(E.data(w)),onError:w=>$.error(E.error?E.error(w):w),onEnd:()=>$.end()}),$}e.$qe=d;function T(I,E,a){let $=!1;return{read:()=>{const w=E.read();return $?w:($=!0,w!==null?a([I,w]):I)}}}e.$re=T;function L(I,E,a){let $=!1;const w=c(a);return b(E,{onData:D=>$?w.write(D):($=!0,w.write(a([I,D]))),onError:D=>w.error(D),onEnd:()=>{$||($=!0,w.write(I)),w.end()}}),w}e.$se=L}),define(K[13],V([0,1,30,29]),function(z,e,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=e.$Ee=e.$De=e.$Ce=e.$Be=e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=void 0;const k=typeof Buffer<"u",C=new P.$V(()=>new Uint8Array(256));let r,c;class i{static alloc(g){return k?new i(Buffer.allocUnsafe(g)):new i(new Uint8Array(g))}static wrap(g){return k&&!Buffer.isBuffer(g)&&(g=Buffer.from(g.buffer,g.byteOffset,g.byteLength)),new i(g)}static fromString(g,j){return!(j?.dontUseNodeBuffer||!1)&&k?new i(Buffer.from(g)):(r||(r=new TextEncoder),new i(r.encode(g)))}static fromByteArray(g){const j=i.alloc(g.length);for(let B=0,J=g.length;B<J;B++)j.buffer[B]=g[B];return j}static concat(g,j){if(typeof j>"u"){j=0;for(let H=0,_=g.length;H<_;H++)j+=g[H].byteLength}const B=i.alloc(j);let J=0;for(let H=0,_=g.length;H<_;H++){const W=g[H];B.set(W,J),J+=W.byteLength}return B}constructor(g){this.buffer=g,this.byteLength=this.buffer.byteLength}clone(){const g=i.alloc(this.byteLength);return g.set(this),g}toString(){return k?this.buffer.toString():(c||(c=new TextDecoder),c.decode(this.buffer))}slice(g,j){return new i(this.buffer.subarray(g,j))}set(g,j){if(g instanceof i)this.buffer.set(g.buffer,j);else if(g instanceof Uint8Array)this.buffer.set(g,j);else if(g instanceof ArrayBuffer)this.buffer.set(new Uint8Array(g),j);else if(ArrayBuffer.isView(g))this.buffer.set(new Uint8Array(g.buffer,g.byteOffset,g.byteLength),j);else throw new Error("Unknown argument 'array'")}readUInt32BE(g){return b(this.buffer,g)}writeUInt32BE(g,j){u(this.buffer,g,j)}readUInt32LE(g){return n(this.buffer,g)}writeUInt32LE(g,j){t(this.buffer,g,j)}readUInt8(g){return s(this.buffer,g)}writeUInt8(g,j){d(this.buffer,g,j)}indexOf(g,j=0){return o(this.buffer,g instanceof i?g.buffer:g,j)}}e.$te=i;function o(O,g,j=0){const B=g.byteLength,J=O.byteLength;if(B===0)return 0;if(B===1)return O.indexOf(g[0]);if(B>J-j)return-1;const H=C.value;H.fill(g.length);for(let X=0;X<g.length;X++)H[g[X]]=g.length-X-1;let _=j+g.length-1,W=_,G=-1;for(;_<J;)if(O[_]===g[W]){if(W===0){G=_;break}_--,W--}else _+=Math.max(g.length-W,H[O[_]]),W=g.length-1;return G}e.$ue=o;function m(O,g){return O[g+0]<<0>>>0|O[g+1]<<8>>>0}e.$ve=m;function l(O,g,j){O[j+0]=g&255,g=g>>>8,O[j+1]=g&255}e.$we=l;function b(O,g){return O[g]*2**24+O[g+1]*2**16+O[g+2]*2**8+O[g+3]}e.$xe=b;function u(O,g,j){O[j+3]=g,g=g>>>8,O[j+2]=g,g=g>>>8,O[j+1]=g,g=g>>>8,O[j]=g}e.$ye=u;function n(O,g){return O[g+0]<<0>>>0|O[g+1]<<8>>>0|O[g+2]<<16>>>0|O[g+3]<<24>>>0}e.$ze=n;function t(O,g,j){O[j+0]=g&255,g=g>>>8,O[j+1]=g&255,g=g>>>8,O[j+2]=g&255,g=g>>>8,O[j+3]=g&255}e.$Ae=t;function s(O,g){return O[g]}e.$Be=s;function d(O,g,j){O[j]=g}e.$Ce=d;function T(O){return S.$ie(O,g=>i.concat(g))}e.$De=T;function L(O){return S.$pe(O)}e.$Ee=L;function I(O){return S.$ke(O,g=>i.concat(g))}e.$Fe=I;async function E(O){return O.ended?i.concat(O.buffer):i.concat([...O.buffer,await I(O.stream)])}e.$Ge=E;function a(O){return S.$ne(O,g=>i.concat(g))}e.$He=a;function $(O){return S.$qe(O,{data:g=>typeof g=="string"?i.fromString(g):i.wrap(g)},g=>i.concat(g))}e.$Ie=$;function w(O){return S.$he(g=>i.concat(g),O)}e.$Je=w;function D(O,g){return S.$re(O,g,j=>i.concat(j))}e.$Ke=D;function q(O,g){return S.$se(O,g,j=>i.concat(j))}e.$Le=q;function f(O){let g=0,j=0,B=0;const J=new Uint8Array(Math.floor(O.length/4*3)),H=W=>{switch(j){case 3:J[B++]=g|W,j=0;break;case 2:J[B++]=g|W>>>2,g=W<<6,j=3;break;case 1:J[B++]=g|W>>>4,g=W<<4,j=2;break;default:g=W<<2,j=1}};for(let W=0;W<O.length;W++){const G=O.charCodeAt(W);if(G>=65&&G<=90)H(G-65);else if(G>=97&&G<=122)H(G-97+26);else if(G>=48&&G<=57)H(G-48+52);else if(G===43||G===45)H(62);else if(G===47||G===95)H(63);else{if(G===61)break;throw new SyntaxError(`Unexpected base64 character ${O[W]}`)}}const _=B;for(;j>0;)H(0);return i.wrap(J).slice(0,_)}e.$Me=f;const v="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",N="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function U({buffer:O},g=!0,j=!1){const B=j?N:v;let J="";const H=O.byteLength%3;let _=0;for(;_<O.byteLength-H;_+=3){const W=O[_+0],G=O[_+1],X=O[_+2];J+=B[W>>>2],J+=B[(W<<4|G>>>4)&63],J+=B[(G<<2|X>>>6)&63],J+=B[X&63]}if(H===1){const W=O[_+0];J+=B[W>>>2],J+=B[W<<4&63],g&&(J+="==")}else if(H===2){const W=O[_+0],G=O[_+1];J+=B[W>>>2],J+=B[(W<<4|G>>>4)&63],J+=B[G<<2&63],g&&(J+="=")}return J}e.$Ne=U}),define(K[31],V([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3d=void 0,e.$3d=Symbol("MicrotaskDelay")}),define(K[14],V([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jt=e.StringEOL=void 0;var P;(function(k){k[k.Unknown=0]="Unknown",k[k.Invalid=3]="Invalid",k[k.LF=1]="LF",k[k.CRLF=2]="CRLF"})(P||(e.StringEOL=P={}));function S(k){let C=0,r=0,c=0,i=0;for(let o=0,m=k.length;o<m;o++){const l=k.charCodeAt(o);l===13?(C===0&&(r=o),C++,o+1<m&&k.charCodeAt(o+1)===10?(i|=2,o++):i|=3,c=o+1):l===10&&(i|=1,C===0&&(r=o),C++,c=o+1)}return C===0&&(r=k.length),[C,r,k.length-c,i]}e.$Jt=S}),define(K[15],V([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ht=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var P;(function(i){i[i.Null=0]="Null",i[i.PlainText=1]="PlainText"})(P||(e.LanguageId=P={}));var S;(function(i){i[i.NotSet=-1]="NotSet",i[i.None=0]="None",i[i.Italic=1]="Italic",i[i.Bold=2]="Bold",i[i.Underline=4]="Underline",i[i.Strikethrough=8]="Strikethrough"})(S||(e.FontStyle=S={}));var k;(function(i){i[i.None=0]="None",i[i.DefaultForeground=1]="DefaultForeground",i[i.DefaultBackground=2]="DefaultBackground"})(k||(e.ColorId=k={}));var C;(function(i){i[i.Other=0]="Other",i[i.Comment=1]="Comment",i[i.String=2]="String",i[i.RegEx=3]="RegEx"})(C||(e.StandardTokenType=C={}));var r;(function(i){i[i.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",i[i.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",i[i.BALANCED_BRACKETS_MASK=1024]="BALANCED_BRACKETS_MASK",i[i.FONT_STYLE_MASK=30720]="FONT_STYLE_MASK",i[i.FOREGROUND_MASK=16744448]="FOREGROUND_MASK",i[i.BACKGROUND_MASK=4278190080]="BACKGROUND_MASK",i[i.ITALIC_MASK=2048]="ITALIC_MASK",i[i.BOLD_MASK=4096]="BOLD_MASK",i[i.UNDERLINE_MASK=8192]="UNDERLINE_MASK",i[i.STRIKETHROUGH_MASK=16384]="STRIKETHROUGH_MASK",i[i.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",i[i.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",i[i.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",i[i.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",i[i.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",i[i.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",i[i.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",i[i.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",i[i.BALANCED_BRACKETS_OFFSET=10]="BALANCED_BRACKETS_OFFSET",i[i.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",i[i.FOREGROUND_OFFSET=15]="FOREGROUND_OFFSET",i[i.BACKGROUND_OFFSET=24]="BACKGROUND_OFFSET"})(r||(e.MetadataConsts=r={}));class c{static getLanguageId(o){return(o&255)>>>0}static getTokenType(o){return(o&768)>>>8}static containsBalancedBrackets(o){return(o&1024)!==0}static getFontStyle(o){return(o&30720)>>>11}static getForeground(o){return(o&16744448)>>>15}static getBackground(o){return(o&4278190080)>>>24}static getClassNameFromMetadata(o){let l="mtk"+this.getForeground(o);const b=this.getFontStyle(o);return b&1&&(l+=" mtki"),b&2&&(l+=" mtkb"),b&4&&(l+=" mtku"),b&8&&(l+=" mtks"),l}static getInlineStyleFromMetadata(o,m){const l=this.getForeground(o),b=this.getFontStyle(o);let u=`color: ${m[l]};`;b&1&&(u+="font-style: italic;"),b&2&&(u+="font-weight: bold;");let n="";return b&4&&(n+=" underline"),b&8&&(n+=" line-through"),n&&(u+=`text-decoration:${n};`),u}static getPresentationFromMetadata(o){const m=this.getForeground(o),l=this.getFontStyle(o);return{foreground:m,italic:!!(l&1),bold:!!(l&2),underline:!!(l&4),strikethrough:!!(l&8)}}}e.$Ht=c}),define(K[32],V([0,1,33]),function(z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wC=void 0;class S{constructor(r){this.b=r,this.a=[]}get(r){return r<this.a.length?this.a[r]:this.b}set(r,c){for(;r>=this.a.length;)this.a[this.a.length]=this.b;this.a[r]=c}replace(r,c,i){if(r>=this.a.length)return;if(c===0){this.insert(r,i);return}else if(i===0){this.delete(r,c);return}const o=this.a.slice(0,r),m=this.a.slice(r+c),l=k(i,this.b);this.a=o.concat(l,m)}delete(r,c){c===0||r>=this.a.length||this.a.splice(r,c)}insert(r,c){if(c===0||r>=this.a.length)return;const i=[];for(let o=0;o<c;o++)i[o]=this.b;this.a=(0,P.$Wb)(this.a,r,i)}}e.$wC=S;function k(C,r){const c=[];for(let i=0;i<C;i++)c[i]=r;return c}}),define(K[10],V([0,1,15]),function(z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kt=void 0;class S{static{this.defaultTokenMetadata=(32768|2<<24)>>>0}static createEmpty(r,c){const i=S.defaultTokenMetadata,o=new Uint32Array(2);return o[0]=r.length,o[1]=i,new S(o,r,c)}constructor(r,c,i){this._lineTokensBrand=void 0,this.a=r,this.b=this.a.length>>>1,this.c=c,this.d=i}equals(r){return r instanceof S?this.slicedEquals(r,0,this.b):!1}slicedEquals(r,c,i){if(this.c!==r.c||this.b!==r.b)return!1;const o=c<<1,m=o+(i<<1);for(let l=o;l<m;l++)if(this.a[l]!==r.a[l])return!1;return!0}getLineContent(){return this.c}getCount(){return this.b}getStartOffset(r){return r>0?this.a[r-1<<1]:0}getMetadata(r){return this.a[(r<<1)+1]}getLanguageId(r){const c=this.a[(r<<1)+1],i=P.$Ht.getLanguageId(c);return this.d.decodeLanguageId(i)}getStandardTokenType(r){const c=this.a[(r<<1)+1];return P.$Ht.getTokenType(c)}getForeground(r){const c=this.a[(r<<1)+1];return P.$Ht.getForeground(c)}getClassName(r){const c=this.a[(r<<1)+1];return P.$Ht.getClassNameFromMetadata(c)}getInlineStyle(r,c){const i=this.a[(r<<1)+1];return P.$Ht.getInlineStyleFromMetadata(i,c)}getPresentation(r){const c=this.a[(r<<1)+1];return P.$Ht.getPresentationFromMetadata(c)}getEndOffset(r){return this.a[r<<1]}findTokenIndexAtOffset(r){return S.findIndexInTokensArray(this.a,r)}inflate(){return this}sliceAndInflate(r,c,i){return new k(this,r,c,i)}static convertToEndOffset(r,c){const o=(r.length>>>1)-1;for(let m=0;m<o;m++)r[m<<1]=r[m+1<<1];r[o<<1]=c}static findIndexInTokensArray(r,c){if(r.length<=2)return 0;let i=0,o=(r.length>>>1)-1;for(;i<o;){const m=i+Math.floor((o-i)/2),l=r[m<<1];if(l===c)return m+1;l<c?i=m+1:l>c&&(o=m)}return i}withInserted(r){if(r.length===0)return this;let c=0,i=0,o="";const m=new Array;let l=0;for(;;){const b=c<this.b?this.a[c<<1]:-1,u=i<r.length?r[i]:null;if(b!==-1&&(u===null||b<=u.offset)){o+=this.c.substring(l,b);const n=this.a[(c<<1)+1];m.push(o.length,n),c++,l=b}else if(u){if(u.offset>l){o+=this.c.substring(l,u.offset);const n=this.a[(c<<1)+1];m.push(o.length,n),l=u.offset}o+=u.text,m.push(o.length,u.tokenMetadata),i++}else break}return new S(new Uint32Array(m),o,this.d)}}e.$Kt=S;class k{constructor(r,c,i,o){this.a=r,this.b=c,this.c=i,this.d=o,this.e=r.findTokenIndexAtOffset(c),this.f=0;for(let m=this.e,l=r.getCount();m<l&&!(r.getStartOffset(m)>=i);m++)this.f++}getMetadata(r){return this.a.getMetadata(this.e+r)}getLanguageId(r){return this.a.getLanguageId(this.e+r)}getLineContent(){return this.a.getLineContent().substring(this.b,this.c)}equals(r){return r instanceof k?this.b===r.b&&this.c===r.c&&this.d===r.d&&this.a.slicedEquals(r.a,this.e,this.f):!1}getCount(){return this.f}getForeground(r){return this.a.getForeground(this.e+r)}getEndOffset(r){const c=this.a.getEndOffset(this.e+r);return Math.min(this.c,c)-this.b+this.d}getClassName(r){return this.a.getClassName(this.e+r)}getInlineStyle(r,c){return this.a.getInlineStyle(this.e+r,c)}getPresentation(r){return this.a.getPresentation(this.e+r)}findTokenIndexAtOffset(r){return this.a.findTokenIndexAtOffset(r+this.b-this.d)-this.e}}}),define(K[34],V([0,1,10]),function(z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nt=e.$Mt=e.$Lt=void 0,e.$Lt=new Uint32Array(0).buffer;class S{static deleteBeginning(r,c){return r===null||r===e.$Lt?r:S.delete(r,0,c)}static deleteEnding(r,c){if(r===null||r===e.$Lt)return r;const i=k(r),o=i[i.length-2];return S.delete(r,c,o)}static delete(r,c,i){if(r===null||r===e.$Lt||c===i)return r;const o=k(r),m=o.length>>>1;if(c===0&&o[o.length-2]===i)return e.$Lt;const l=P.$Kt.findIndexInTokensArray(o,c),b=l>0?o[l-1<<1]:0,u=o[l<<1];if(i<u){const T=i-c;for(let L=l;L<m;L++)o[L<<1]-=T;return r}let n,t;b!==c?(o[l<<1]=c,n=l+1<<1,t=c):(n=l<<1,t=b);const s=i-c;for(let T=l+1;T<m;T++){const L=o[T<<1]-s;L>t&&(o[n++]=L,o[n++]=o[(T<<1)+1],t=L)}if(n===o.length)return r;const d=new Uint32Array(n);return d.set(o.subarray(0,n),0),d.buffer}static append(r,c){if(c===e.$Lt)return r;if(r===e.$Lt)return c;if(r===null)return r;if(c===null)return null;const i=k(r),o=k(c),m=o.length>>>1,l=new Uint32Array(i.length+o.length);l.set(i,0);let b=i.length;const u=i[i.length-2];for(let n=0;n<m;n++)l[b++]=o[n<<1]+u,l[b++]=o[(n<<1)+1];return l.buffer}static insert(r,c,i){if(r===null||r===e.$Lt)return r;const o=k(r),m=o.length>>>1;let l=P.$Kt.findIndexInTokensArray(o,c);l>0&&o[l-1<<1]===c&&l--;for(let b=l;b<m;b++)o[b<<1]+=i;return r}}e.$Mt=S;function k(C){return C instanceof Uint32Array?C:new Uint32Array(C)}e.$Nt=k}),define(K[35],V([0,1,33,13,47,14,34,16]),function(z,e,P,S,k,C,r,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ot=void 0;class i{static deserialize(m,l,b){const u=new Uint32Array(m.buffer),n=(0,S.$xe)(m,l);l+=4;const t=(0,S.$xe)(m,l);l+=4;const s=[];for(let d=0;d<t;d++){const T=(0,S.$xe)(m,l);l+=4,s.push(u.subarray(l/4,l/4+T/4)),l+=T}return b.push(new i(n,s)),l}get startLineNumber(){return this.a}get endLineNumber(){return this.a+this.b.length-1}constructor(m,l){this.a=m,this.b=l}getLineRange(){return new c.$gt(this.a,this.a+this.b.length)}getLineTokens(m){return this.b[m-this.a]}appendLineTokens(m){this.b.push(m)}serializeSize(){let m=0;m+=4,m+=4;for(let l=0;l<this.b.length;l++){const b=this.b[l];if(!(b instanceof Uint32Array))throw new Error("Not supported!");m+=4,m+=b.byteLength}return m}serialize(m,l){(0,S.$ye)(m,this.a,l),l+=4,(0,S.$ye)(m,this.b.length,l),l+=4;for(let b=0;b<this.b.length;b++){const u=this.b[b];if(!(u instanceof Uint32Array))throw new Error("Not supported!");(0,S.$ye)(m,u.byteLength,l),l+=4,m.set(new Uint8Array(u.buffer),l),l+=u.byteLength}return l}applyEdit(m,l){const[b,u]=(0,C.$Jt)(l);this.c(m),this.d(new k.$9s(m.startLineNumber,m.startColumn),b,u)}c(m){if(m.startLineNumber===m.endLineNumber&&m.startColumn===m.endColumn)return;const l=m.startLineNumber-this.a,b=m.endLineNumber-this.a;if(b<0){const u=b-l;this.a-=u;return}if(!(l>=this.b.length)){if(l<0&&b>=this.b.length){this.a=0,this.b=[];return}if(l===b){this.b[l]=r.$Mt.delete(this.b[l],m.startColumn-1,m.endColumn-1);return}if(l>=0)if(this.b[l]=r.$Mt.deleteEnding(this.b[l],m.startColumn-1),b<this.b.length){const u=r.$Mt.deleteBeginning(this.b[b],m.endColumn-1);this.b[l]=r.$Mt.append(this.b[l],u),this.b.splice(l+1,b-l)}else this.b[l]=r.$Mt.append(this.b[l],null),this.b=this.b.slice(0,l+1);else{const u=-l;this.a-=u,this.b[b]=r.$Mt.deleteBeginning(this.b[b],m.endColumn-1),this.b=this.b.slice(b)}}}d(m,l,b){if(l===0&&b===0)return;const u=m.lineNumber-this.a;if(u<0){this.a+=l;return}if(!(u>=this.b.length)){if(l===0){this.b[u]=r.$Mt.insert(this.b[u],m.column-1,b);return}this.b[u]=r.$Mt.deleteEnding(this.b[u],m.column-1),this.b[u]=r.$Mt.insert(this.b[u],m.column-1,b),this.e(m.lineNumber,l)}}e(m,l){if(l===0)return;const b=[];for(let u=0;u<l;u++)b[u]=null;this.b=P.$Wb(this.b,m,b)}}e.$Ot=i}),define(K[17],V([0,1,13,35]),function(z,e,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xC=void 0;class k{static deserialize(r){let c=0;const i=(0,P.$xe)(r,c);c+=4;const o=[];for(let m=0;m<i;m++)c=S.$Ot.deserialize(r,c,o);return o}constructor(){this.a=[]}add(r,c){if(this.a.length>0){const i=this.a[this.a.length-1];if(i.endLineNumber+1===r){i.appendLineTokens(c);return}}this.a.push(new S.$Ot(r,[c]))}finalize(){return this.a}serialize(){const r=this.b(),c=new Uint8Array(r);return this.c(c),c}b(){let r=0;r+=4;for(let c=0;c<this.a.length;c++)r+=this.a[c].serializeSize();return r}c(r){let c=0;(0,P.$ye)(r,this.a.length,c),c+=4;for(let i=0;i<this.a.length;i++)c=this.a[i].serialize(r,c)}}e.$xC=k}),define(K[36],V([0,1,18,3,19,48]),function(z,e,P,S,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=e.$fg=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=void 0;function r(f){return f===47||f===92}e.$_f=r;function c(f){return f.replace(/[\\/]/g,P.$gc.sep)}e.$ag=c;function i(f){return f.indexOf("/")===-1&&(f=c(f)),/^[a-zA-Z]:(\/|$)/.test(f)&&(f="/"+f),f}e.$bg=i;function o(f,v=P.$gc.sep){if(!f)return"";const N=f.length,U=f.charCodeAt(0);if(r(U)){if(r(f.charCodeAt(1))&&!r(f.charCodeAt(2))){let g=3;const j=g;for(;g<N&&!r(f.charCodeAt(g));g++);if(j!==g&&!r(f.charCodeAt(g+1))){for(g+=1;g<N;g++)if(r(f.charCodeAt(g)))return f.slice(0,g+1).replace(/[\\/]/g,v)}}return v}else if(d(U)&&f.charCodeAt(1)===58)return r(f.charCodeAt(2))?f.slice(0,2)+v:f.slice(0,2);let O=f.indexOf("://");if(O!==-1){for(O+=3;O<N;O++)if(r(f.charCodeAt(O)))return f.slice(0,O+1)}return""}e.$cg=o;function m(f){if(!S.$i||!f||f.length<5)return!1;let v=f.charCodeAt(0);if(v!==92||(v=f.charCodeAt(1),v!==92))return!1;let N=2;const U=N;for(;N<f.length&&(v=f.charCodeAt(N),v!==92);N++);return!(U===N||(v=f.charCodeAt(N+1),isNaN(v)||v===92))}e.$dg=m;const l=/[\\/:\*\?"<>\|]/g,b=/[\\/]/g,u=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function n(f,v=S.$i){const N=v?l:b;return!(!f||f.length===0||/^\s+$/.test(f)||(N.lastIndex=0,N.test(f))||v&&u.test(f)||f==="."||f===".."||v&&f[f.length-1]==="."||v&&f.length!==f.trim().length||f.length>255)}e.$eg=n;function t(f,v,N){const U=f===v;return!N||U?U:!f||!v?!1:(0,k.$kf)(f,v)}e.$fg=t;function s(f,v,N,U=P.sep){if(f===v)return!0;if(!f||!v||v.length>f.length)return!1;if(N){if(!(0,k.$lf)(f,v))return!1;if(v.length===f.length)return!0;let g=v.length;return v.charAt(v.length-1)===U&&g--,f.charAt(g)===U}return v.charAt(v.length-1)!==U&&(v+=U),f.indexOf(v)===0}e.$gg=s;function d(f){return f>=65&&f<=90||f>=97&&f<=122}e.$hg=d;function T(f,v){return S.$i&&f.endsWith(":")&&(f+=P.sep),(0,P.$ic)(f)||(f=(0,P.$jc)(v,f)),f=(0,P.$hc)(f),S.$i?(f=(0,k.$5e)(f,P.sep),f.endsWith(":")&&(f+=P.sep)):(f=(0,k.$5e)(f,P.sep),f||(f=P.sep)),f}e.$ig=T;function L(f){const v=(0,P.$hc)(f);return S.$i?f.length>3?!1:I(v)&&(f.length===2||v.charCodeAt(2)===92):v===P.$gc.sep}e.$jg=L;function I(f,v=S.$i){return v?d(f.charCodeAt(0))&&f.charCodeAt(1)===58:!1}e.$kg=I;function E(f,v=S.$i){return I(f,v)?f[0]:void 0}e.$lg=E;function a(f,v,N){return v.length>f.length?-1:f===v?0:(N&&(f=f.toLowerCase(),v=v.toLowerCase()),f.indexOf(v))}e.$mg=a;function $(f){const v=f.split(":");let N,U,O;for(const g of v){const j=Number(g);(0,C.$Xf)(j)?U===void 0?U=j:O===void 0&&(O=j):N=N?[N,g].join(":"):g}if(!N)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:N,line:U!==void 0?U:void 0,column:O!==void 0?O:U!==void 0?1:void 0}}e.$ng=$;const w="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",D="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function q(f,v,N=8){let U="";for(let g=0;g<N;g++){let j;g===0&&S.$i&&!v&&(N===3||N===4)?j=D:j=w,U+=j.charAt(Math.floor(Math.random()*j.length))}let O;return v?O=`${v}-${U}`:O=U,f?(0,P.$jc)(f,O):O}e.$og=q}),define(K[20],V([0,1,9,3,19,11,18]),function(z,e,P,S,k,C,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.Schemas=void 0;var c;(function(n){n.inMemory="inmemory",n.vscode="vscode",n.internal="private",n.walkThrough="walkThrough",n.walkThroughSnippet="walkThroughSnippet",n.http="http",n.https="https",n.file="file",n.mailto="mailto",n.untitled="untitled",n.data="data",n.command="command",n.vscodeRemote="vscode-remote",n.vscodeRemoteResource="vscode-remote-resource",n.vscodeManagedRemoteResource="vscode-managed-remote-resource",n.vscodeUserData="vscode-userdata",n.vscodeCustomEditor="vscode-custom-editor",n.vscodeNotebookCell="vscode-notebook-cell",n.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",n.vscodeNotebookCellOutput="vscode-notebook-cell-output",n.vscodeInteractiveInput="vscode-interactive-input",n.vscodeSettings="vscode-settings",n.vscodeWorkspaceTrust="vscode-workspace-trust",n.vscodeTerminal="vscode-terminal",n.vscodeChatCodeBlock="vscode-chat-code-block",n.vscodeChatSesssion="vscode-chat-editor",n.webviewPanel="webview-panel",n.vscodeWebview="vscode-webview",n.extension="extension",n.vscodeFileResource="vscode-file",n.tmp="tmp",n.vsls="vsls",n.vscodeSourceControl="vscode-scm",n.codeSetting="code-setting"})(c||(e.Schemas=c={}));function i(n,t){return C.URI.isUri(n)?(0,k.$kf)(n.scheme,t):(0,k.$lf)(n,t+":")}e.$pg=i;function o(n,...t){return t.some(s=>i(n,s))}e.$qg=o,e.$rg="vscode-tkn",e.$sg="tkn";class m{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(t){this.d=t}setDelegate(t){this.e=t}setServerRootPath(t,s){this.f=l(t,s)}getServerRootPath(){return this.f}get g(){return r.$gc.join(this.f,c.vscodeRemoteResource)}set(t,s,d){this.a[t]=s,this.b[t]=d}setConnectionToken(t,s){this.c[t]=s}getPreferredWebSchema(){return this.d}rewrite(t){if(this.e)try{return this.e(t)}catch(E){return P.$1(E),t}const s=t.authority;let d=this.a[s];d&&d.indexOf(":")!==-1&&d.indexOf("[")===-1&&(d=`[${d}]`);const T=this.b[s],L=this.c[s];let I=`path=${encodeURIComponent(t.path)}`;return typeof L=="string"&&(I+=`&${e.$sg}=${encodeURIComponent(L)}`),C.URI.from({scheme:S.$o?this.d:c.vscodeRemoteResource,authority:`${d}:${T}`,path:this.g,query:I})}}e.$tg=new m;function l(n,t){return r.$gc.join(t??"/",`${n.quality??"oss"}-${n.commit??"dev"}`)}e.$ug=l,e.$vg="vs/../../extensions",e.$wg="vs/../../node_modules",e.$xg="vs/../../node_modules.asar",e.$yg="vs/../../node_modules.asar.unpacked",e.$zg="vscode-app";class b{static{this.a=e.$zg}asBrowserUri(t){const s=this.b(t,z);return this.uriToBrowserUri(s)}uriToBrowserUri(t){return t.scheme===c.vscodeRemote?e.$tg.rewrite(t):t.scheme===c.file&&(S.$m||S.$q===`${c.vscodeFileResource}://${b.a}`)?t.with({scheme:c.vscodeFileResource,authority:t.authority||b.a,query:null,fragment:null}):t}asFileUri(t){const s=this.b(t,z);return this.uriToFileUri(s)}uriToFileUri(t){return t.scheme===c.vscodeFileResource?t.with({scheme:c.file,authority:t.authority!==b.a?t.authority:null,query:null,fragment:null}):t}b(t,s){return C.URI.isUri(t)?t:C.URI.parse(s.toUrl(t))}}e.$Ag=new b;var u;(function(n){const t=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);n.CoopAndCoep=Object.freeze(t.get("3"));const s="vscode-coi";function d(L){let I;typeof L=="string"?I=new URL(L).searchParams:L instanceof URL?I=L.searchParams:C.URI.isUri(L)&&(I=new URL(L.toString(!0)).searchParams);const E=I?.get(s);if(E)return t.get(E)}n.getHeadersFromQuery=d;function T(L,I,E){if(!globalThis.crossOriginIsolated)return;const a=I&&E?"3":E?"2":"1";L instanceof URLSearchParams?L.set(s,a):L[s]=a}n.addSearchParam=T})(u||(e.COI=u={}))}),define(K[37],V([0,1,24,20,3,11]),function(z,e,P,S,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xD=void 0;class r{constructor(b,u,n){this.id=b,this.dependencies=u,this.callback=n}}class c{static{this.INSTANCE=new c}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(b,u,n)=>{typeof b!="string"&&(n=u,u=b,b=null),(typeof u!="object"||!Array.isArray(u))&&(n=u,u=null),this.c.push(new r(b,u,n))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(b){if(b.startsWith(window.location.origin)||b.startsWith("vscode-file://vscode-app"))return b;throw new Error(`[trusted_script_src] Invalid script url: ${b}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(b){return b}})))}async load(b){this.g();const u=await(this.a?this.i(b):this.b?this.h(b):this.j(b));if(!u)throw new Error(`Did not receive a define call from script ${b}`);if(Array.isArray(u.dependencies)&&u.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${b}. The dependencies are: ${u.dependencies.join(", ")}`);return typeof u.callback=="function"?u.callback([]):u.callback}h(b){return new Promise((u,n)=>{const t=document.createElement("script");t.setAttribute("async","async"),t.setAttribute("type","text/javascript");const s=()=>{t.removeEventListener("load",d),t.removeEventListener("error",T)},d=L=>{s(),u(this.c.pop())},T=L=>{s(),n(L)};t.addEventListener("load",d),t.addEventListener("error",T),this.f&&(b=this.f.createScriptURL(b)),t.setAttribute("src",b),window.document.getElementsByTagName("head")[0].appendChild(t)})}i(b){return new Promise((u,n)=>{try{this.f&&(b=this.f.createScriptURL(b)),importScripts(b),u(this.c.pop())}catch(t){n(t)}})}async j(b){try{const u=globalThis._VSCODE_NODE_MODULES.fs,n=globalThis._VSCODE_NODE_MODULES.vm,t=globalThis._VSCODE_NODE_MODULES.module,s=C.URI.parse(b).fsPath,d=u.readFileSync(s).toString(),T=t.wrap(d.replace(/^#!.*/,""));return new n.Script(T).runInThisContext().apply(),this.c.pop()}catch(u){throw u}}}const i=new Map;let o={};typeof globalThis.require=="object"&&(o=globalThis.require.paths??{});async function m(l,b,u){if(P.$T){u===void 0&&(u=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),o[l]&&(l=o[l]);const n=`${l}/${b}`;if(i.has(n))return i.get(n);let t;if(/^\w[\w\d+.-]*:\/\//.test(n))t=n;else{const L=`${u&&!k.$o?S.$xg:S.$wg}/${n}`;t=S.$Ag.asBrowserUri(L).toString(!0)}const s=c.INSTANCE.load(t);return i.set(n,s),s}else return await new Promise((n,t)=>{z([l],n,t)})}e.$xD=m}),define(K[21],V([0,1,36,20,18,3,19,11]),function(z,e,P,S,k,C,r,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4g=e.DataUri=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=void 0;function i(u){return(0,c.$wc)(u,!0)}e.$Hg=i;class o{constructor(n){this.a=n}compare(n,t,s=!1){return n===t?0:(0,r.$df)(this.getComparisonKey(n,s),this.getComparisonKey(t,s))}isEqual(n,t,s=!1){return n===t?!0:!n||!t?!1:this.getComparisonKey(n,s)===this.getComparisonKey(t,s)}getComparisonKey(n,t=!1){return n.with({path:this.a(n)?n.path.toLowerCase():void 0,fragment:t?null:void 0}).toString()}ignorePathCasing(n){return this.a(n)}isEqualOrParent(n,t,s=!1){if(n.scheme===t.scheme){if(n.scheme===S.Schemas.file)return P.$gg(i(n),i(t),this.a(n))&&n.query===t.query&&(s||n.fragment===t.fragment);if((0,e.$Yg)(n.authority,t.authority))return P.$gg(n.path,t.path,this.a(n),"/")&&n.query===t.query&&(s||n.fragment===t.fragment)}return!1}joinPath(n,...t){return c.URI.joinPath(n,...t)}basenameOrAuthority(n){return(0,e.$Qg)(n)||n.authority}basename(n){return k.$gc.basename(n.path)}extname(n){return k.$gc.extname(n.path)}dirname(n){if(n.path.length===0)return n;let t;return n.scheme===S.Schemas.file?t=c.URI.file(k.$mc(i(n))).path:(t=k.$gc.dirname(n.path),n.authority&&t.length&&t.charCodeAt(0)!==47&&(console.error(`dirname("${n.toString})) resulted in a relative path`),t="/")),n.with({path:t})}normalizePath(n){if(!n.path.length)return n;let t;return n.scheme===S.Schemas.file?t=c.URI.file(k.$hc(i(n))).path:t=k.$gc.normalize(n.path),n.with({path:t})}relativePath(n,t){if(n.scheme!==t.scheme||!(0,e.$Yg)(n.authority,t.authority))return;if(n.scheme===S.Schemas.file){const T=k.$lc(i(n),i(t));return C.$i?P.$ag(T):T}let s=n.path||"/";const d=t.path||"/";if(this.a(n)){let T=0;for(const L=Math.min(s.length,d.length);T<L&&!(s.charCodeAt(T)!==d.charCodeAt(T)&&s.charAt(T).toLowerCase()!==d.charAt(T).toLowerCase());T++);s=d.substr(0,T)+s.substr(T)}return k.$gc.relative(s,d)}resolvePath(n,t){if(n.scheme===S.Schemas.file){const s=c.URI.file(k.$kc(i(n),t));return n.with({authority:s.authority,path:s.path})}return t=P.$bg(t),n.with({path:k.$gc.resolve(n.path,t)})}isAbsolutePath(n){return!!n.path&&n.path[0]==="/"}isEqualAuthority(n,t){return n===t||n!==void 0&&t!==void 0&&(0,r.$kf)(n,t)}hasTrailingPathSeparator(n,t=k.sep){if(n.scheme===S.Schemas.file){const s=i(n);return s.length>P.$cg(s).length&&s[s.length-1]===t}else{const s=n.path;return s.length>1&&s.charCodeAt(s.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(n.fsPath)}}removeTrailingPathSeparator(n,t=k.sep){return(0,e.$Zg)(n,t)?n.with({path:n.path.substr(0,n.path.length-1)}):n}addTrailingPathSeparator(n,t=k.sep){let s=!1;if(n.scheme===S.Schemas.file){const d=i(n);s=d!==void 0&&d.length===P.$cg(d).length&&d[d.length-1]===t}else{t="/";const d=n.path;s=d.length===1&&d.charCodeAt(d.length-1)===47}return!s&&!(0,e.$Zg)(n,t)?n.with({path:n.path+"/"}):n}}e.$Ig=o,e.$Jg=new o(()=>!1),e.$Kg=new o(u=>u.scheme===S.Schemas.file?!C.$k:!0),e.$Lg=new o(u=>!0),e.$Mg=e.$Jg.isEqual.bind(e.$Jg),e.$Ng=e.$Jg.isEqualOrParent.bind(e.$Jg),e.$Og=e.$Jg.getComparisonKey.bind(e.$Jg),e.$Pg=e.$Jg.basenameOrAuthority.bind(e.$Jg),e.$Qg=e.$Jg.basename.bind(e.$Jg),e.$Rg=e.$Jg.extname.bind(e.$Jg),e.$Sg=e.$Jg.dirname.bind(e.$Jg),e.$Tg=e.$Jg.joinPath.bind(e.$Jg),e.$Ug=e.$Jg.normalizePath.bind(e.$Jg),e.$Vg=e.$Jg.relativePath.bind(e.$Jg),e.$Wg=e.$Jg.resolvePath.bind(e.$Jg),e.$Xg=e.$Jg.isAbsolutePath.bind(e.$Jg),e.$Yg=e.$Jg.isEqualAuthority.bind(e.$Jg),e.$Zg=e.$Jg.hasTrailingPathSeparator.bind(e.$Jg),e.$1g=e.$Jg.removeTrailingPathSeparator.bind(e.$Jg),e.$2g=e.$Jg.addTrailingPathSeparator.bind(e.$Jg);function m(u,n){const t=[];for(let s=0;s<u.length;s++){const d=n(u[s]);u.some((T,L)=>L===s?!1:(0,e.$Ng)(d,n(T)))||t.push(u[s])}return t}e.$3g=m;var l;(function(u){u.META_DATA_LABEL="label",u.META_DATA_DESCRIPTION="description",u.META_DATA_SIZE="size",u.META_DATA_MIME="mime";function n(t){const s=new Map;t.path.substring(t.path.indexOf(";")+1,t.path.lastIndexOf(";")).split(";").forEach(L=>{const[I,E]=L.split(":");I&&E&&s.set(I,E)});const T=t.path.substring(0,t.path.indexOf(";"));return T&&s.set(u.META_DATA_MIME,T),s}u.parseMetaData=n})(l||(e.DataUri=l={}));function b(u,n,t){if(n){let s=u.path;return s&&s[0]!==k.$gc.sep&&(s=k.$gc.sep+s),u.with({scheme:t,authority:n,path:s})}return u.with({scheme:t})}e.$4g=b}),define(K[22],V([0,1,28,9,38,2,21,3,31,30]),function(z,e,P,S,k,C,r,c,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.Promises=e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=void 0;function m(M){return!!M&&typeof M.then=="function"}e.$5g=m;function l(M){const h=new P.$de,y=M(h.token),A=new Promise((R,F)=>{const Y=h.token.onCancellationRequested(()=>{Y.dispose(),F(new S.$5)});Promise.resolve(y).then(p=>{Y.dispose(),h.dispose(),R(p)},p=>{Y.dispose(),h.dispose(),F(p)})});return new class{cancel(){h.cancel(),h.dispose()}then(R,F){return A.then(R,F)}catch(R){return this.then(void 0,R)}finally(R){return A.finally(R)}}}e.$6g=l;function b(M,h,y){return new Promise((A,R)=>{const F=h.onCancellationRequested(()=>{F.dispose(),A(y)});M.then(A,R).finally(()=>F.dispose())})}e.$7g=b;function u(M,h){return new Promise((y,A)=>{const R=h.onCancellationRequested(()=>{R.dispose(),A(new S.$5)});M.then(y,A).finally(()=>R.dispose())})}e.$8g=u;async function n(M){let h=-1;const y=M.map((A,R)=>A.then(F=>(h=R,F)));try{return await Promise.race(y)}finally{M.forEach((A,R)=>{R!==h&&A.cancel()})}}e.$9g=n;function t(M,h,y){let A;const R=setTimeout(()=>{A?.(void 0),y?.()},h);return Promise.race([M.finally(()=>clearTimeout(R)),new Promise(F=>A=F)])}e.$0g=t;function s(M){return new Promise((h,y)=>{const A=M();m(A)?A.then(h,y):h(A)})}e.$$g=s;function d(){let M,h;return{promise:new Promise((A,R)=>{M=A,h=R}),resolve:M,reject:h}}e.$_g=d;class T{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(h){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=h,!this.b){const y=()=>{if(this.b=null,this.f)return;const A=this.queue(this.d);return this.d=null,A};this.b=new Promise(A=>{this.a.then(y,y).then(A)})}return new Promise((y,A)=>{this.b.then(y,A)})}return this.a=h(),new Promise((y,A)=>{this.a.then(R=>{this.a=null,y(R)},R=>{this.a=null,A(R)})})}dispose(){this.f=!0}}e.$ah=T;class L{constructor(){this.a=Promise.resolve(null)}queue(h){return this.a=this.a.then(()=>h(),()=>h())}}e.$bh=L;class I{constructor(){this.a=new Map}queue(h,y){const R=(this.a.get(h)??Promise.resolve()).catch(()=>{}).then(y).finally(()=>{this.a.get(h)===R&&this.a.delete(h)});return this.a.set(h,R),R}}e.$ch=I;const E=(M,h)=>{let y=!0;const A=setTimeout(()=>{y=!1,h()},M);return{isTriggered:()=>y,dispose:()=>{clearTimeout(A),y=!1}}},a=M=>{let h=!0;return queueMicrotask(()=>{h&&(h=!1,M())}),{isTriggered:()=>h,dispose:()=>{h=!1}}};class ${constructor(h){this.defaultDelay=h,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(h,y=this.defaultDelay){this.g=h,this.h(),this.b||(this.b=new Promise((R,F)=>{this.d=R,this.f=F}).then(()=>{if(this.b=null,this.d=null,this.g){const R=this.g;return this.g=null,R()}}));const A=()=>{this.a=null,this.d?.(null)};return this.a=y===i.$3d?a(A):E(y,A),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new S.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$dh=$;class w{constructor(h){this.a=new $(h),this.b=new T}trigger(h,y){return this.a.trigger(()=>this.b.queue(h),y)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$eh=w;class D{constructor(){this.a=!1,this.b=new Promise((h,y)=>{this.d=h})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$fh=D;class q extends D{constructor(h){super(),this.f=setTimeout(()=>this.open(),h)}open(){clearTimeout(this.f),super.open()}}e.$gh=q;function f(M,h){return h?new Promise((y,A)=>{const R=setTimeout(()=>{F.dispose(),y()},M),F=h.onCancellationRequested(()=>{clearTimeout(R),F.dispose(),A(new S.$5)})}):l(y=>f(M,y))}e.$hh=f;function v(M,h=0,y){const A=setTimeout(()=>{M(),y&&R.dispose()},h),R=(0,C.$Rc)(()=>{clearTimeout(A),y?.deleteAndLeak(R)});return y?.add(R),R}e.$ih=v;function N(M){const h=[];let y=0;const A=M.length;function R(){return y<A?M[y++]():null}function F(Y){Y!=null&&h.push(Y);const p=R();return p?p.then(F):Promise.resolve(h)}return Promise.resolve(null).then(F)}e.$jh=N;function U(M,h=A=>!!A,y=null){let A=0;const R=M.length,F=()=>{if(A>=R)return Promise.resolve(y);const Y=M[A++];return Promise.resolve(Y()).then(Q=>h(Q)?Promise.resolve(Q):F())};return F()}e.$kh=U;function O(M,h=A=>!!A,y=null){if(M.length===0)return Promise.resolve(y);let A=M.length;const R=()=>{A=-1;for(const F of M)F.cancel?.()};return new Promise((F,Y)=>{for(const p of M)p.then(Q=>{--A>=0&&h(Q)?(R(),F(Q)):A===0&&F(y)}).catch(Q=>{--A>=0&&(R(),Y(Q))})})}e.$lh=O;class g{constructor(h){this.a=0,this.b=!1,this.f=h,this.g=[],this.d=0,this.h=new k.$6d}whenIdle(){return this.size>0?k.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(h){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((y,A)=>{this.g.push({factory:h,c:y,e:A}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const h=this.g.shift();this.d++;const y=h.factory();y.then(h.c,h.e),y.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$mh=g;class j extends g{constructor(){super(1)}}e.$nh=j;class B{constructor(){this.a=new te,this.b=0}queue(h){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,h())):this.a.run(this.b++,h())}}e.$oh=B;class J{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const h=new x;return this.b.add(h),h.p}g(){for(const[,h]of this.a)if(h.size>0)return!1;return!0}queueSize(h,y=r.$Jg){const A=y.getComparisonKey(h);return this.a.get(A)?.size??0}queueFor(h,y,A=r.$Jg){const R=A.getComparisonKey(h);let F=this.a.get(R);if(!F){F=new j;const Y=this.f++,p=k.Event.once(F.onDrained)(()=>{F?.dispose(),this.a.delete(R),this.h(),this.d?.deleteAndDispose(Y),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new C.$3c),this.d.set(Y,p),this.a.set(R,F)}return F.queue(y)}h(){this.g()&&this.j()}j(){for(const h of this.b)h.complete();this.b.clear()}dispose(){for(const[,h]of this.a)h.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$ph=J;class H{constructor(h,y){this.a=-1,typeof h=="function"&&typeof y=="number"&&this.setIfNotSet(h,y)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(h,y){this.cancel(),this.a=setTimeout(()=>{this.a=-1,h()},y)}setIfNotSet(h,y){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,h()},y))}}e.$qh=H;class _{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(h,y,A=globalThis){this.cancel();const R=A.setInterval(()=>{h()},y);this.d=(0,C.$Rc)(()=>{A.clearInterval(R),this.d=void 0})}dispose(){this.cancel()}}e.$rh=_;class W{constructor(h,y){this.b=-1,this.a=h,this.d=y,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(h=this.d){this.cancel(),this.b=setTimeout(this.f,h)}get delay(){return this.d}set delay(h){this.d=h}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$sh=W;class G{constructor(h,y){y%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${y}ms is not a multiple of 1000ms.`),this.a=h,this.b=y,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(h=this.b){h%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${h}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(h/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$th=G;class X extends W{constructor(h,y){super(h,y),this.j=[]}work(h){this.j.push(h),this.isScheduled()||this.schedule()}h(){const h=this.j;this.j=[],this.a?.(h)}dispose(){this.j=[],super.dispose()}}e.$uh=X;class he extends C.$Tc{constructor(h,y){super(),this.g=h,this.h=y,this.a=[],this.b=this.B(new C.$Uc),this.f=!1}get pending(){return this.a.length}work(h){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+h.length>this.g.maxBufferedWork)return!1}else if(this.pending+h.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const y of h)this.a.push(y);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new W(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$vh=he,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$xh=(M,h)=>{(0,c.$B)(()=>{if(y)return;const A=Date.now()+15;h(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,A-Date.now())}}))});let y=!1;return{dispose(){y||(y=!0)}}}:e.$xh=(M,h,y)=>{const A=M.requestIdleCallback(h,typeof y=="number"?{timeout:y}:void 0);let R=!1;return{dispose(){R||(R=!0,M.cancelIdleCallback(A))}}},e.$wh=M=>(0,e.$xh)(globalThis,M)}();class ee{constructor(h,y){this.g=!1,this.d=()=>{try{this.j=y()}catch(A){this.l=A}finally{this.g=!0}},this.f=(0,e.$xh)(h,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$yh=ee;class ue extends ee{constructor(h){super(globalThis,h)}}e.$zh=ue;async function oe(M,h,y){let A;for(let R=0;R<y;R++)try{return await M()}catch(F){A=F,await f(h)}throw A}e.$Ah=oe;class te{isRunning(h){return typeof h=="number"?this.a?.taskId===h:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(h,y,A){return this.a={taskId:h,cancel:()=>A?.(),promise:y},y.then(()=>this.d(h),()=>this.d(h)),y}d(h){this.a&&h===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const h=this.b;this.b=void 0,h.run().then(h.promiseResolve,h.promiseReject)}}queue(h){if(this.b)this.b.run=h;else{const{promise:y,resolve:A,reject:R}=d();this.b={run:h,promise:y,promiseResolve:A,promiseReject:R}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Bh=te;class ce{constructor(h,y=()=>Date.now()){this.d=h,this.f=y,this.a=0,this.b=0}increment(){const h=this.f();return h-this.a>this.d&&(this.a=h,this.b=0),this.b++,this.b}}e.$Ch=ce;var ne;(function(M){M[M.Resolved=0]="Resolved",M[M.Rejected=1]="Rejected"})(ne||(ne={}));class x{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((h,y)=>{this.a=h,this.b=y})}complete(h){return new Promise(y=>{this.a(h),this.d={outcome:0,value:h},y()})}error(h){return new Promise(y=>{this.b(h),this.d={outcome:1,value:h},y()})}cancel(){return this.error(new S.$5)}}e.$Dh=x;var ie;(function(M){async function h(A){let R;const F=await Promise.all(A.map(Y=>Y.then(p=>p,p=>{R||(R=p)})));if(typeof R<"u")throw R;return F}M.settled=h;function y(A){return new Promise(async(R,F)=>{try{await A(R,F)}catch(Y){F(Y)}})}M.withAsyncBody=y})(ie||(e.Promises=ie={}));class se{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(h){this.a=void 0,this.b=void 0,this.d=!1,this.promise=h.then(y=>(this.a=y,this.d=!0,y),y=>{throw this.b=y,this.d=!0,y})}requireValue(){if(!this.d)throw new S.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Eh=se;class de{constructor(h){this.b=h,this.a=new o.$V(()=>new se(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Fh=de;var re;(function(M){M[M.Initial=0]="Initial",M[M.DoneOK=1]="DoneOK",M[M.DoneError=2]="DoneError"})(re||(re={}));class Z{static fromArray(h){return new Z(y=>{y.emitMany(h)})}static fromPromise(h){return new Z(async y=>{y.emitMany(await h)})}static fromPromises(h){return new Z(async y=>{await Promise.all(h.map(async A=>y.emitOne(await A)))})}static merge(h){return new Z(async y=>{await Promise.all(h.map(async A=>{for await(const R of A)y.emitOne(R)}))})}static{this.EMPTY=Z.fromArray([])}constructor(h){this.a=0,this.b=[],this.d=null,this.f=new k.$6d,queueMicrotask(async()=>{const y={emitOne:A=>this.g(A),emitMany:A=>this.h(A),reject:A=>this.k(A)};try{await Promise.resolve(h(y)),this.j()}catch(A){this.k(A)}finally{y.emitOne=void 0,y.emitMany=void 0,y.reject=void 0}})}[Symbol.asyncIterator](){let h=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(h<this.b.length)return{done:!1,value:this.b[h++]};if(this.a===1)return{done:!0,value:void 0};await k.Event.toPromise(this.f.event)}while(!0)}}}static map(h,y){return new Z(async A=>{for await(const R of h)A.emitOne(y(R))})}map(h){return Z.map(this,h)}static filter(h,y){return new Z(async A=>{for await(const R of h)y(R)&&A.emitOne(R)})}filter(h){return Z.filter(this,h)}static coalesce(h){return Z.filter(h,y=>!!y)}coalesce(){return Z.coalesce(this)}static async toPromise(h){const y=[];for await(const A of h)y.push(A);return y}toPromise(){return Z.toPromise(this)}g(h){this.a===0&&(this.b.push(h),this.f.fire())}h(h){this.a===0&&(this.b=this.b.concat(h),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(h){this.a===0&&(this.a=2,this.d=h,this.f.fire())}}e.$Gh=Z;class ae extends Z{constructor(h,y){super(y),this.l=h}cancel(){this.l.cancel()}}e.$Hh=ae;function le(M){const h=new P.$de,y=M(h.token);return new ae(h,async A=>{const R=h.token.onCancellationRequested(()=>{R.dispose(),h.dispose(),A.reject(new S.$5)});try{for await(const F of y){if(h.token.isCancellationRequested)return;A.emitOne(F)}R.dispose(),h.dispose()}catch(F){R.dispose(),h.dispose(),A.reject(F)}})}e.$Ih=le;class fe{constructor(){this.a=new x,this.b=new Z(A=>{if(h){A.reject(h);return}return y&&A.emitMany(y),this.d=R=>A.reject(R),this.f=R=>A.emitOne(R),this.a.p});let h,y;this.f=A=>{y||(y=[]),y.push(A)},this.d=A=>{h||(h=A)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(h){this.d(h),this.a.complete()}emitOne(h){this.f(h)}}e.$Jh=fe}),define(K[23],V([0,1,39]),function(z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vC=e.$uC=e.$tC=void 0,e.$tC=new class{clone(){return this}equals(C){return this===C}};function S(C,r){return new P.$Tt([new P.$St(0,"",C)],r)}e.$uC=S;function k(C,r){const c=new Uint32Array(2);return c[0]=0,c[1]=(C<<0|0|0|32768|2<<24)>>>0,new P.$Ut(c,r===null?e.$tC:r)}e.$vC=k}),define(K[40],V([0,1,22,9,3,41,14,16,49,23,32,17,10]),function(z,e,P,S,k,C,r,c,i,o,m,l,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DC=e.$CC=e.$BC=e.$AC=e.$zC=e.$yC=void 0;var u;(function(E){E[E.CHEAP_TOKENIZATION_LENGTH_LIMIT=2048]="CHEAP_TOKENIZATION_LENGTH_LIMIT"})(u||(u={}));class n{constructor(a,$){this.tokenizationSupport=$,this.a=this.tokenizationSupport.getInitialState(),this.store=new s(a)}getStartState(a){return this.store.getStartState(a,this.a)}getFirstInvalidLine(){return this.store.getFirstInvalidLine(this.a)}}e.$yC=n;class t extends n{constructor(a,$,w,D){super(a,$),this._textModel=w,this._languageIdCodec=D}updateTokensUntilLine(a,$){const w=this._textModel.getLanguageId();for(;;){const D=this.getFirstInvalidLine();if(!D||D.lineNumber>$)break;const q=this._textModel.getLineContent(D.lineNumber),f=L(this._languageIdCodec,w,this.tokenizationSupport,q,!0,D.startState);a.add(D.lineNumber,f.tokens),this.store.setEndState(D.lineNumber,f.endState)}}getTokenTypeIfInsertingCharacter(a,$){const w=this.getStartState(a.lineNumber);if(!w)return 0;const D=this._textModel.getLanguageId(),q=this._textModel.getLineContent(a.lineNumber),f=q.substring(0,a.column-1)+$+q.substring(a.column-1),v=L(this._languageIdCodec,D,this.tokenizationSupport,f,!0,w),N=new b.$Kt(v.tokens,f,this._languageIdCodec);if(N.getCount()===0)return 0;const U=N.findTokenIndexAtOffset(a.column-1);return N.getStandardTokenType(U)}tokenizeLineWithEdit(a,$,w){const D=a.lineNumber,q=a.column,f=this.getStartState(D);if(!f)return null;const v=this._textModel.getLineContent(D),N=v.substring(0,q-1)+w+v.substring(q-1+$),U=this._textModel.getLanguageIdAtPosition(D,0),O=L(this._languageIdCodec,U,this.tokenizationSupport,N,!0,f);return new b.$Kt(O.tokens,N,this._languageIdCodec)}isCheapToTokenize(a){const $=this.store.getFirstInvalidEndStateLineNumberOrMax();return a<$||a===$&&this._textModel.getLineLength(a)<2048}tokenizeHeuristically(a,$,w){if(w<=this.store.getFirstInvalidEndStateLineNumberOrMax())return{heuristicTokens:!1};if($<=this.store.getFirstInvalidEndStateLineNumberOrMax())return this.updateTokensUntilLine(a,w),{heuristicTokens:!1};let D=this.b($);const q=this._textModel.getLanguageId();for(let f=$;f<=w;f++){const v=this._textModel.getLineContent(f),N=L(this._languageIdCodec,q,this.tokenizationSupport,v,!0,D);a.add(f,N.tokens),D=N.endState}return{heuristicTokens:!0}}b(a){let $=this._textModel.getLineFirstNonWhitespaceColumn(a);const w=[];let D=null;for(let v=a-1;$>1&&v>=1;v--){const N=this._textModel.getLineFirstNonWhitespaceColumn(v);if(N!==0&&N<$&&(w.push(this._textModel.getLineContent(v)),$=N,D=this.getStartState(v),D))break}D||(D=this.tokenizationSupport.getInitialState()),w.reverse();const q=this._textModel.getLanguageId();let f=D;for(const v of w)f=L(this._languageIdCodec,q,this.tokenizationSupport,v,!1,f).endState;return f}}e.$zC=t;class s{constructor(a){this.d=a,this.a=new d,this.b=new T,this.b.addRange(new i.$et(1,a+1))}getEndState(a){return this.a.getEndState(a)}setEndState(a,$){if(!$)throw new S.$cb("Cannot set null/undefined state");this.b.delete(a);const w=this.a.setEndState(a,$);return w&&a<this.d&&this.b.addRange(new i.$et(a+1,a+2)),w}acceptChange(a,$){this.d+=$-a.length,this.a.acceptChange(a,$),this.b.addRangeAndResize(new i.$et(a.startLineNumber,a.endLineNumberExclusive),$)}acceptChanges(a){for(const $ of a){const[w]=(0,r.$Jt)($.text);this.acceptChange(new c.$gt($.range.startLineNumber,$.range.endLineNumber+1),w+1)}}invalidateEndStateRange(a){this.b.addRange(new i.$et(a.startLineNumber,a.endLineNumberExclusive))}getFirstInvalidEndStateLineNumber(){return this.b.min}getFirstInvalidEndStateLineNumberOrMax(){return this.getFirstInvalidEndStateLineNumber()||Number.MAX_SAFE_INTEGER}allStatesValid(){return this.b.min===null}getStartState(a,$){return a===1?$:this.getEndState(a-1)}getFirstInvalidLine(a){const $=this.getFirstInvalidEndStateLineNumber();if($===null)return null;const w=this.getStartState($,a);if(!w)throw new S.$cb("Start state must be defined");return{lineNumber:$,startState:w}}}e.$AC=s;class d{constructor(){this.a=new m.$wC(null)}getEndState(a){return this.a.get(a)}setEndState(a,$){const w=this.a.get(a);return w&&w.equals($)?!1:(this.a.set(a,$),!0)}acceptChange(a,$){let w=a.length;$>0&&w>0&&(w--,$--),this.a.replace(a.startLineNumber,w,$)}acceptChanges(a){for(const $ of a){const[w]=(0,r.$Jt)($.text);this.acceptChange(new c.$gt($.range.startLineNumber,$.range.endLineNumber+1),w+1)}}}e.$BC=d;class T{constructor(){this.a=[]}getRanges(){return this.a}get min(){return this.a.length===0?null:this.a[0].start}removeMin(){if(this.a.length===0)return null;const a=this.a[0];return a.start+1===a.endExclusive?this.a.shift():this.a[0]=new i.$et(a.start+1,a.endExclusive),a.start}delete(a){const $=this.a.findIndex(w=>w.contains(a));if($!==-1){const w=this.a[$];w.start===a?w.endExclusive===a+1?this.a.splice($,1):this.a[$]=new i.$et(a+1,w.endExclusive):w.endExclusive===a+1?this.a[$]=new i.$et(w.start,a):this.a.splice($,1,new i.$et(w.start,a),new i.$et(a+1,w.endExclusive))}}addRange(a){i.$et.addRange(a,this.a)}addRangeAndResize(a,$){let w=0;for(;!(w>=this.a.length||a.start<=this.a[w].endExclusive);)w++;let D=w;for(;!(D>=this.a.length||a.endExclusive<this.a[D].start);)D++;const q=$-a.length;for(let f=D;f<this.a.length;f++)this.a[f]=this.a[f].delta(q);if(w===D){const f=new i.$et(a.start,a.start+$);f.isEmpty||this.a.splice(w,0,f)}else{const f=Math.min(a.start,this.a[w].start),v=Math.max(a.endExclusive,this.a[D-1].endExclusive),N=new i.$et(f,v+q);N.isEmpty?this.a.splice(w,D-w):this.a.splice(w,D-w,N)}}toString(){return this.a.map(a=>a.toString()).join(" + ")}}e.$CC=T;function L(E,a,$,w,D,q){let f=null;if($)try{f=$.tokenizeEncoded(w,D,q.clone())}catch(v){(0,S.$1)(v)}return f||(f=(0,o.$vC)(E.encodeLanguageId(a),q)),b.$Kt.convertToEndOffset(f.tokens,w.length),f}class I{constructor(a,$){this.b=a,this.d=$,this.a=!1,this.f=!1}dispose(){this.a=!0}handleChanges(){this.g()}g(){this.f||!this.b._textModel.isAttachedToEditor()||!this.k()||(this.f=!0,(0,P.$wh)(a=>{this.f=!1,this.h(a)}))}h(a){const $=Date.now()+a.timeRemaining(),w=()=>{this.a||!this.b._textModel.isAttachedToEditor()||!this.k()||(this.j(),Date.now()<$?(0,k.$B)(w):this.g())};w()}j(){const a=this.b._textModel.getLineCount(),$=new l.$xC,w=C.$2d.create(!1);do if(w.elapsed()>1||this.l($)>=a)break;while(this.k());this.d.setTokens($.finalize()),this.checkFinished()}k(){return this.b?!this.b.store.allStatesValid():!1}l(a){const $=this.b?.getFirstInvalidLine();return $?(this.b.updateTokensUntilLine(a,$.lineNumber),$.lineNumber):this.b._textModel.getLineCount()+1}checkFinished(){this.a||this.b.store.allStatesValid()&&this.d.backgroundTokenizationFinished()}requestTokens(a,$){this.b.store.invalidateEndStateRange(new c.$gt(a,$))}}e.$DC=I}),define(K[42],V([0,1,38,2,41,15,39]),function(z,e,P,S,k,C,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fJb=void 0;class c extends S.$Tc{constructor(o,m,l,b,u,n,t){super(),this.c=o,this.f=m,this.g=l,this.h=b,this.j=u,this.m=n,this.n=t,this.a=[],this.b=this.B(new P.$6d),this.onDidEncounterLanguage=this.b.event}get backgroundTokenizerShouldOnlyVerifyTokens(){return this.j()}getInitialState(){return this.f}tokenize(o,m,l){throw new Error("Not supported!")}createBackgroundTokenizer(o,m){if(this.h)return this.h(o,m)}tokenizeEncoded(o,m,l){const b=Math.random()*1e4<1,u=this.n||b,n=u?new k.$2d(!0):void 0,t=this.c.tokenizeLine2(o,l,500);if(u){const d=n.elapsed();(b||d>32)&&this.m(d,o.length,b)}if(t.stoppedEarly)return console.warn(`Time limit reached when tokenizing line: ${o.substring(0,100)}`),new r.$Ut(t.tokens,l);if(this.g){const d=this.a,T=t.tokens;for(let L=0,I=T.length>>>1;L<I;L++){const E=T[(L<<1)+1],a=C.$Ht.getLanguageId(E);d[a]||(d[a]=!0,this.b.fire(a))}}let s;return l.equals(t.ruleStack)?s=l:s=t.ruleStack,new r.$Ut(t.tokens,s)}}e.$fJb=c}),define(K[43],V([0,1,23,2,12]),function(z,e,P,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gJb=void 0;class C extends S.$Tc{get backgroundTokenizerShouldOnlyVerifyTokens(){return this.b.backgroundTokenizerShouldOnlyVerifyTokens}constructor(c,i,o){super(),this.a=c,this.b=i,this.c=o,this.B((0,k.keepObserved)(this.c))}getInitialState(){return this.b.getInitialState()}tokenize(c,i,o){throw new Error("Not supported!")}tokenizeEncoded(c,i,o){return c.length>=this.c.get()?(0,P.$vC)(this.a,o):this.b.tokenizeEncoded(c,i,o)}createBackgroundTokenizer(c,i){if(this.b.createBackgroundTokenizer)return this.b.createBackgroundTokenizer(c,i)}}e.$gJb=C}),define(K[44],V([0,1,37,22,12,3,16,50,40,17,10,42,43]),function(z,e,P,S,k,C,r,c,i,o,m,l,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lJb=void 0;class u extends c.$Bv{constructor(s,d,T,L,I,E,a,$){super(s,d,T,L),this.s=I,this.t=E,this.u=a,this.a=null,this.b=!1,this.c=(0,k.observableValue)(this,-1),this.q=new S.$sh(()=>this.w(),10),this.c.set($,void 0),this.v()}dispose(){this.b=!0,super.dispose()}onLanguageId(s,d){this.t=s,this.u=d,this.v()}onEvents(s){super.onEvents(s),this.a?.store.acceptChanges(s.changes),this.q.schedule()}acceptMaxTokenizationLineLength(s){this.c.set(s,void 0)}retokenize(s,d){this.a&&(this.a.store.invalidateEndStateRange(new r.$gt(s,d)),this.q.schedule())}async v(){this.a=null;const s=this.t,d=this.u,T=await this.s.getOrCreateGrammar(s,d);if(!(this.b||s!==this.t||d!==this.u||!T)){if(T.grammar){const L=new b.$gJb(this.u,new l.$fJb(T.grammar,T.initialState,!1,void 0,()=>!1,(I,E,a)=>{this.s.reportTokenizationTime(I,s,T.sourceExtensionId,E,a)},!1),this.c);this.a=new i.$yC(this.f.length,L)}else this.a=null;this.w()}}async w(){if(this.b||!this.a)return;if(!this.m){const{diffStateStacksRefEq:d}=await(0,P.$xD)("vscode-textmate","release/main.js");this.m=d}const s=new Date().getTime();for(;;){let d=0;const T=new o.$xC,L=new n;for(;;){const a=this.a.getFirstInvalidLine();if(a===null||d>200)break;d++;const $=this.f[a.lineNumber-1],w=this.a.tokenizationSupport.tokenizeEncoded($,!0,a.startState);if(this.a.store.setEndState(a.lineNumber,w.endState)){const q=this.m(a.startState,w.endState);L.setState(a.lineNumber,q)}else L.setState(a.lineNumber,null);if(m.$Kt.convertToEndOffset(w.tokens,$.length),T.add(a.lineNumber,w.tokens),new Date().getTime()-s>20)break}if(d===0)break;const I=L.getStateDeltas();if(this.s.setTokensAndStates(this.h,T.serialize(),I),new Date().getTime()-s>20){(0,C.$B)(()=>this.w());return}}}}e.$lJb=u;class n{constructor(){this.a=-1,this.b=[]}setState(s,d){s===this.a+1?this.b[this.b.length-1].stateDeltas.push(d):this.b.push({startLineNumber:s,stateDeltas:[d]}),this.a=s}getStateDeltas(){return this.b}}}),define(K[45],V([0,1,21]),function(z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iJb=void 0;class S{constructor(){this.a=Object.create(null)}reset(){this.a=Object.create(null)}register(C){if(this.a[C.scopeName]){const r=this.a[C.scopeName];P.$Mg(r.location,C.location)||console.warn(`Overwriting grammar scope name to file mapping for scope ${C.scopeName}.
Old grammar file: ${r.location.toString()}.
New grammar file: ${C.location.toString()}`)}this.a[C.scopeName]=C}getGrammarDefinition(C){return this.a[C]||null}}e.$iJb=S}),define(K[46],V([0,1,2,45]),function(z,e,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kJb=e.$jJb=void 0,e.$jJb="No TM Grammar registered for this language.";class k extends P.$Tc{constructor(r,c,i,o){super(),this.a=r,this.b=i.INITIAL,this.c=new S.$iJb,this.f={},this.g={},this.h=new Map,this.j=this.B(new i.Registry({onigLib:o,loadGrammar:async m=>{const l=this.c.getGrammarDefinition(m);if(!l)return this.a.logTrace(`No grammar found for scope ${m}`),null;const b=l.location;try{const u=await this.a.readFile(b);return i.parseRawGrammar(u,b.path)}catch(u){return this.a.logError(`Unable to load and parse grammar for scope ${m} from ${b}`,u),null}},getInjections:m=>{const l=m.split(".");let b=[];for(let u=1;u<=l.length;u++){const n=l.slice(0,u).join(".");b=[...b,...this.f[n]||[]]}return b}}));for(const m of c){if(this.c.register(m),m.injectTo){for(const l of m.injectTo){let b=this.f[l];b||(this.f[l]=b=[]),b.push(m.scopeName)}if(m.embeddedLanguages)for(const l of m.injectTo){let b=this.g[l];b||(this.g[l]=b=[]),b.push(m.embeddedLanguages)}}m.language&&this.h.set(m.language,m.scopeName)}}has(r){return this.h.has(r)}setTheme(r,c){this.j.setTheme(r,c)}getColorMap(){return this.j.getColorMap()}async createGrammar(r,c){const i=this.h.get(r);if(typeof i!="string")throw new Error(e.$jJb);const o=this.c.getGrammarDefinition(i);if(!o)throw new Error(e.$jJb);const m=o.embeddedLanguages;if(this.g[i]){const u=this.g[i];for(const n of u)for(const t of Object.keys(n))m[t]=n[t]}const l=Object.keys(m).length>0;let b;try{b=await this.j.loadGrammarWithConfiguration(i,c,{embeddedLanguages:m,tokenTypes:o.tokenTypes,balancedBracketSelectors:o.balancedBracketSelectors,unbalancedBracketSelectors:o.unbalancedBracketSelectors})}catch(u){throw u.message&&u.message.startsWith("No grammar provided for")?new Error(e.$jJb):u}return{languageId:r,grammar:b,initialState:this.b,containsEmbeddedLanguages:l,sourceExtensionId:o.sourceExtensionId}}}e.$kJb=k}),define(K[51],V([0,1,11,46,44]),function(z,e,P,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextMateTokenizationWorker=e.create=void 0;function C(c,i){return new r(c,i)}e.create=C;class r{constructor(i,o){this.f=o,this.b=new Map,this.c=[],this.a=i.host;const m=o.grammarDefinitions.map(l=>({location:P.URI.revive(l.location),language:l.language,scopeName:l.scopeName,embeddedLanguages:l.embeddedLanguages,tokenTypes:l.tokenTypes,injectTo:l.injectTo,balancedBracketSelectors:l.balancedBracketSelectors,unbalancedBracketSelectors:l.unbalancedBracketSelectors,sourceExtensionId:l.sourceExtensionId}));this.d=this.g(m)}async g(i){const o=this.f.textmateMainUri,m=await new Promise((t,s)=>{z([o],t,s)}),l=await new Promise((t,s)=>{z([this.f.onigurumaMainUri],t,s)}),u=await(await fetch(this.f.onigurumaWASMUri)).arrayBuffer();await l.loadWASM(u);const n=Promise.resolve({createOnigScanner:t=>l.createOnigScanner(t),createOnigString:t=>l.createOnigString(t)});return new S.$kJb({logTrace:t=>{},logError:(t,s)=>console.error(t,s),readFile:t=>this.a.readFile(t)},i,m,n)}acceptNewModel(i){const o=P.URI.revive(i.uri),m=this;this.b.set(i.controllerId,new k.$lJb(o,i.lines,i.EOL,i.versionId,{async getOrCreateGrammar(l,b){const u=await m.d;return u?(m.c[b]||(m.c[b]=u.createGrammar(l,b)),m.c[b]):Promise.resolve(null)},setTokensAndStates(l,b,u){m.a.setTokensAndStates(i.controllerId,l,b,u)},reportTokenizationTime(l,b,u,n,t){m.a.reportTokenizationTime(l,b,u,n,t)}},i.languageId,i.encodedLanguageId,i.maxTokenizationLineLength))}acceptModelChanged(i,o){this.b.get(i).onEvents(o)}retokenize(i,o,m){this.b.get(i).retokenize(o,m)}acceptModelLanguageChanged(i,o,m){this.b.get(i).onLanguageId(o,m)}acceptRemovedModel(i){const o=this.b.get(i);o&&(o.dispose(),this.b.delete(i))}async acceptTheme(i,o){(await this.d)?.setTheme(i,o)}acceptMaxTokenizationLineLength(i,o){this.b.get(i).acceptMaxTokenizationLineLength(o)}}e.TextMateTokenizationWorker=r})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/d73fa8b14a6c873958d00a7d7ad13fcb540a052c/core/vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateTokenizationWorker.worker.js.map
